/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/buffer","vs/base/common/objects","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/color","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],me=function(Q){for(var t=[],E=0,P=Q.length;E<P;E++)t[E]=ge[Q[E]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function _t(Q){if(Array.isArray(Q)){for(var t=0,E=Array(Q.length);t<Q.length;t++)E[t]=Q[t];return E}else return Array.from(Q)}var xt=Object.hasOwnProperty,Nt=Object.setPrototypeOf,jt=Object.isFrozen,qt=Object.getPrototypeOf,Vt=Object.getOwnPropertyDescriptor,et=Object.freeze,ot=Object.seal,Kt=Object.create,It=typeof Reflect<"u"&&Reflect,wt=It.apply,At=It.construct;wt||(wt=function(t,E,P){return t.apply(E,P)}),et||(et=function(t){return t}),ot||(ot=function(t){return t}),At||(At=function(t,E){return new(Function.prototype.bind.apply(t,[null].concat(_t(E))))});var Gt=nt(Array.prototype.forEach),Mt=nt(Array.prototype.pop),mt=nt(Array.prototype.push),ht=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),lt=nt(String.prototype.replace),Yt=nt(String.prototype.indexOf),Xt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Zt(TypeError);function nt(Q){return function(t){for(var E=arguments.length,P=Array(E>1?E-1:0),U=1;U<E;U++)P[U-1]=arguments[U];return wt(Q,t,P)}}function Zt(Q){return function(){for(var t=arguments.length,E=Array(t),P=0;P<t;P++)E[P]=arguments[P];return At(Q,E)}}function He(Q,t){Nt&&Nt(Q,null);for(var E=t.length;E--;){var P=t[E];if(typeof P=="string"){var U=ht(P);U!==P&&(jt(t)||(t[E]=U),P=U)}Q[P]=!0}return Q}function ct(Q){var t=Kt(null),E=void 0;for(E in Q)wt(xt,Q,[E])&&(t[E]=Q[E]);return t}function Dt(Q,t){for(;Q!==null;){var E=Vt(Q,t);if(E){if(E.get)return nt(E.get);if(typeof E.value=="function")return nt(E.value)}Q=qt(Q)}function P(U){return console.warn("fallback value for",U),null}return P}var Ot=et(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),St=et(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=et(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Qt=et(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),kt=et(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),Jt=et(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=et(["#text"]),Ht=et(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ft=et(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),zt=et(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=et(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ei=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ti=ot(/<%[\s\S]*|[\s\S]*%>/gm),ii=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ni=ot(/^aria-[\-\w]+$/),si=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ri=ot(/^(?:\w+script|data):/i),oi=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),bt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Q){return typeof Q}:function(Q){return Q&&typeof Symbol=="function"&&Q.constructor===Symbol&&Q!==Symbol.prototype?"symbol":typeof Q};function rt(Q){if(Array.isArray(Q)){for(var t=0,E=Array(Q.length);t<Q.length;t++)E[t]=Q[t];return E}else return Array.from(Q)}var ai=function(){return typeof window>"u"?null:window},li=function(t,E){if((typeof t>"u"?"undefined":bt(t))!=="object"||typeof t.createPolicy!="function")return null;var P=null,U="data-tt-policy-suffix";E.currentScript&&E.currentScript.hasAttribute(U)&&(P=E.currentScript.getAttribute(U));var i="dompurify"+(P?"#"+P:"");try{return t.createPolicy(i,{createHTML:function(w){return w}})}catch{return console.warn("TrustedTypes policy "+i+" could not be created."),null}};function Ut(){var Q=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(oe){return Ut(oe)};if(t.version="2.3.1",t.removed=[],!Q||!Q.document||Q.document.nodeType!==9)return t.isSupported=!1,t;var E=Q.document,P=Q.document,U=Q.DocumentFragment,i=Q.HTMLTemplateElement,D=Q.Node,w=Q.Element,f=Q.NodeFilter,u=Q.NamedNodeMap,c=u===void 0?Q.NamedNodeMap||Q.MozNamedAttrMap:u,M=Q.Text,o=Q.Comment,n=Q.DOMParser,e=Q.trustedTypes,s=w.prototype,r=Dt(s,"cloneNode"),a=Dt(s,"nextSibling"),h=Dt(s,"childNodes"),p=Dt(s,"parentNode");if(typeof i=="function"){var T=P.createElement("template");T.content&&T.content.ownerDocument&&(P=T.content.ownerDocument)}var A=li(e,E),m=A&&j?A.createHTML(""):"",C=P,N=C.implementation,L=C.createNodeIterator,d=C.createDocumentFragment,v=C.getElementsByTagName,b=E.importNode,y={};try{y=ct(P).documentMode?P.documentMode:{}}catch{}var R={};t.isSupported=typeof p=="function"&&N&&typeof N.createHTMLDocument<"u"&&y!==9;var V=ei,ee=ti,Z=ii,J=ni,re=ri,he=oi,de=si,ce=null,pe=He({},[].concat(rt(Ot),rt(St),rt(Ct),rt(kt),rt(Bt))),Te=null,Pe=He({},[].concat(rt(Ht),rt(Ft),rt(zt),rt(yt))),Oe=null,x=null,G=!0,ie=!0,se=!1,ae=!1,te=!1,$=!1,g=!1,l=!1,k=!1,W=!0,j=!1,F=!0,I=!0,O=!1,S={},B=null,H=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),z=null,_=He({},["audio","video","img","source","image","track"]),Y=null,ne=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ue="http://www.w3.org/1998/Math/MathML",we="http://www.w3.org/2000/svg",De="http://www.w3.org/1999/xhtml",Le=De,Ae=!1,ve=null,Me=P.createElement("form"),Ie=function(oe){ve&&ve===oe||((!oe||(typeof oe>"u"?"undefined":bt(oe))!=="object")&&(oe={}),oe=ct(oe),ce="ALLOWED_TAGS"in oe?He({},oe.ALLOWED_TAGS):pe,Te="ALLOWED_ATTR"in oe?He({},oe.ALLOWED_ATTR):Pe,Y="ADD_URI_SAFE_ATTR"in oe?He(ct(ne),oe.ADD_URI_SAFE_ATTR):ne,z="ADD_DATA_URI_TAGS"in oe?He(ct(_),oe.ADD_DATA_URI_TAGS):_,B="FORBID_CONTENTS"in oe?He({},oe.FORBID_CONTENTS):H,Oe="FORBID_TAGS"in oe?He({},oe.FORBID_TAGS):{},x="FORBID_ATTR"in oe?He({},oe.FORBID_ATTR):{},S="USE_PROFILES"in oe?oe.USE_PROFILES:!1,G=oe.ALLOW_ARIA_ATTR!==!1,ie=oe.ALLOW_DATA_ATTR!==!1,se=oe.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=oe.SAFE_FOR_TEMPLATES||!1,te=oe.WHOLE_DOCUMENT||!1,l=oe.RETURN_DOM||!1,k=oe.RETURN_DOM_FRAGMENT||!1,W=oe.RETURN_DOM_IMPORT!==!1,j=oe.RETURN_TRUSTED_TYPE||!1,g=oe.FORCE_BODY||!1,F=oe.SANITIZE_DOM!==!1,I=oe.KEEP_CONTENT!==!1,O=oe.IN_PLACE||!1,de=oe.ALLOWED_URI_REGEXP||de,Le=oe.NAMESPACE||De,ae&&(ie=!1),k&&(l=!0),S&&(ce=He({},[].concat(rt(Bt))),Te=[],S.html===!0&&(He(ce,Ot),He(Te,Ht)),S.svg===!0&&(He(ce,St),He(Te,Ft),He(Te,yt)),S.svgFilters===!0&&(He(ce,Ct),He(Te,Ft),He(Te,yt)),S.mathMl===!0&&(He(ce,kt),He(Te,zt),He(Te,yt))),oe.ADD_TAGS&&(ce===pe&&(ce=ct(ce)),He(ce,oe.ADD_TAGS)),oe.ADD_ATTR&&(Te===Pe&&(Te=ct(Te)),He(Te,oe.ADD_ATTR)),oe.ADD_URI_SAFE_ATTR&&He(Y,oe.ADD_URI_SAFE_ATTR),oe.FORBID_CONTENTS&&(B===H&&(B=ct(B)),He(B,oe.FORBID_CONTENTS)),I&&(ce["#text"]=!0),te&&He(ce,["html","head","body"]),ce.table&&(He(ce,["tbody"]),delete Oe.tbody),et&&et(oe),ve=oe)},$e=He({},["mi","mo","mn","ms","mtext"]),ze=He({},["foreignobject","desc","title","annotation-xml"]),We=He({},St);He(We,Ct),He(We,Qt);var Je=He({},kt);He(Je,Jt);var it=function(oe){var Ee=p(oe);(!Ee||!Ee.tagName)&&(Ee={namespaceURI:De,tagName:"template"});var Fe=ht(oe.tagName),Ue=ht(Ee.tagName);if(oe.namespaceURI===we)return Ee.namespaceURI===De?Fe==="svg":Ee.namespaceURI===ue?Fe==="svg"&&(Ue==="annotation-xml"||$e[Ue]):Boolean(We[Fe]);if(oe.namespaceURI===ue)return Ee.namespaceURI===De?Fe==="math":Ee.namespaceURI===we?Fe==="math"&&ze[Ue]:Boolean(Je[Fe]);if(oe.namespaceURI===De){if(Ee.namespaceURI===we&&!ze[Ue]||Ee.namespaceURI===ue&&!$e[Ue])return!1;var Ke=He({},["title","style","font","a","script"]);return!Je[Fe]&&(Ke[Fe]||!We[Fe])}return!1},Be=function(oe){mt(t.removed,{element:oe});try{oe.parentNode.removeChild(oe)}catch{try{oe.outerHTML=m}catch{oe.remove()}}},je=function(oe,Ee){try{mt(t.removed,{attribute:Ee.getAttributeNode(oe),from:Ee})}catch{mt(t.removed,{attribute:null,from:Ee})}if(Ee.removeAttribute(oe),oe==="is"&&!Te[oe])if(l||k)try{Be(Ee)}catch{}else try{Ee.setAttribute(oe,"")}catch{}},Ge=function(oe){var Ee=void 0,Fe=void 0;if(g)oe="<remove></remove>"+oe;else{var Ue=Pt(oe,/^[\r\n\t ]+/);Fe=Ue&&Ue[0]}var Ke=A?A.createHTML(oe):oe;if(Le===De)try{Ee=new n().parseFromString(Ke,"text/html")}catch{}if(!Ee||!Ee.documentElement){Ee=N.createDocument(Le,"template",null);try{Ee.documentElement.innerHTML=Ae?"":Ke}catch{}}var Xe=Ee.body||Ee.documentElement;return oe&&Fe&&Xe.insertBefore(P.createTextNode(Fe),Xe.childNodes[0]||null),Le===De?v.call(Ee,te?"html":"body")[0]:te?Ee.documentElement:Xe},q=function(oe){return L.call(oe.ownerDocument||oe,oe,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},le=function(oe){return oe instanceof M||oe instanceof o?!1:typeof oe.nodeName!="string"||typeof oe.textContent!="string"||typeof oe.removeChild!="function"||!(oe.attributes instanceof c)||typeof oe.removeAttribute!="function"||typeof oe.setAttribute!="function"||typeof oe.namespaceURI!="string"||typeof oe.insertBefore!="function"},be=function(oe){return(typeof D>"u"?"undefined":bt(D))==="object"?oe instanceof D:oe&&(typeof oe>"u"?"undefined":bt(oe))==="object"&&typeof oe.nodeType=="number"&&typeof oe.nodeName=="string"},ye=function(oe,Ee,Fe){!R[oe]||Gt(R[oe],function(Ue){Ue.call(t,Ee,Fe,ve)})},Ce=function(oe){var Ee=void 0;if(ye("beforeSanitizeElements",oe,null),le(oe)||Pt(oe.nodeName,/[\u0080-\uFFFF]/))return Be(oe),!0;var Fe=ht(oe.nodeName);if(ye("uponSanitizeElement",oe,{tagName:Fe,allowedTags:ce}),!be(oe.firstElementChild)&&(!be(oe.content)||!be(oe.content.firstElementChild))&&at(/<[/\w]/g,oe.innerHTML)&&at(/<[/\w]/g,oe.textContent)||Fe==="select"&&at(/<template/i,oe.innerHTML))return Be(oe),!0;if(!ce[Fe]||Oe[Fe]){if(I&&!B[Fe]){var Ue=p(oe)||oe.parentNode,Ke=h(oe)||oe.childNodes;if(Ke&&Ue)for(var Xe=Ke.length,Ze=Xe-1;Ze>=0;--Ze)Ue.insertBefore(r(Ke[Ze],!0),a(oe))}return Be(oe),!0}return oe instanceof w&&!it(oe)||(Fe==="noscript"||Fe==="noembed")&&at(/<\/no(script|embed)/i,oe.innerHTML)?(Be(oe),!0):(ae&&oe.nodeType===3&&(Ee=oe.textContent,Ee=lt(Ee,V," "),Ee=lt(Ee,ee," "),oe.textContent!==Ee&&(mt(t.removed,{element:oe.cloneNode()}),oe.textContent=Ee)),ye("afterSanitizeElements",oe,null),!1)},Re=function(oe,Ee,Fe){if(F&&(Ee==="id"||Ee==="name")&&(Fe in P||Fe in Me))return!1;if(!(ie&&!x[Ee]&&at(Z,Ee))){if(!(G&&at(J,Ee))){if(!Te[Ee]||x[Ee])return!1;if(!Y[Ee]){if(!at(de,lt(Fe,he,""))){if(!((Ee==="src"||Ee==="xlink:href"||Ee==="href")&&oe!=="script"&&Yt(Fe,"data:")===0&&z[oe])){if(!(se&&!at(re,lt(Fe,he,"")))){if(Fe)return!1}}}}}}return!0},xe=function(oe){var Ee=void 0,Fe=void 0,Ue=void 0,Ke=void 0;ye("beforeSanitizeAttributes",oe,null);var Xe=oe.attributes;if(!!Xe){var Ze={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:Te};for(Ke=Xe.length;Ke--;){Ee=Xe[Ke];var st=Ee,ut=st.name,Et=st.namespaceURI;if(Fe=Xt(Ee.value),Ue=ht(ut),Ze.attrName=Ue,Ze.attrValue=Fe,Ze.keepAttr=!0,Ze.forceKeepAttr=void 0,ye("uponSanitizeAttribute",oe,Ze),Fe=Ze.attrValue,!Ze.forceKeepAttr&&(je(ut,oe),!!Ze.keepAttr)){if(at(/\/>/i,Fe)){je(ut,oe);continue}ae&&(Fe=lt(Fe,V," "),Fe=lt(Fe,ee," "));var Tt=oe.nodeName.toLowerCase();if(!!Re(Tt,Ue,Fe))try{Et?oe.setAttributeNS(Et,ut,Fe):oe.setAttribute(ut,Fe),Mt(t.removed)}catch{}}}ye("afterSanitizeAttributes",oe,null)}},tt=function Ne(oe){var Ee=void 0,Fe=q(oe);for(ye("beforeSanitizeShadowDOM",oe,null);Ee=Fe.nextNode();)ye("uponSanitizeShadowNode",Ee,null),!Ce(Ee)&&(Ee.content instanceof U&&Ne(Ee.content),xe(Ee));ye("afterSanitizeShadowDOM",oe,null)};return t.sanitize=function(Ne,oe){var Ee=void 0,Fe=void 0,Ue=void 0,Ke=void 0,Xe=void 0;if(Ae=!Ne,Ae&&(Ne="<!-->"),typeof Ne!="string"&&!be(Ne)){if(typeof Ne.toString!="function")throw Rt("toString is not a function");if(Ne=Ne.toString(),typeof Ne!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(bt(Q.toStaticHTML)==="object"||typeof Q.toStaticHTML=="function"){if(typeof Ne=="string")return Q.toStaticHTML(Ne);if(be(Ne))return Q.toStaticHTML(Ne.outerHTML)}return Ne}if($||Ie(oe),t.removed=[],typeof Ne=="string"&&(O=!1),!O)if(Ne instanceof D)Ee=Ge("<!---->"),Fe=Ee.ownerDocument.importNode(Ne,!0),Fe.nodeType===1&&Fe.nodeName==="BODY"||Fe.nodeName==="HTML"?Ee=Fe:Ee.appendChild(Fe);else{if(!l&&!ae&&!te&&Ne.indexOf("<")===-1)return A&&j?A.createHTML(Ne):Ne;if(Ee=Ge(Ne),!Ee)return l?null:m}Ee&&g&&Be(Ee.firstChild);for(var Ze=q(O?Ne:Ee);Ue=Ze.nextNode();)Ue.nodeType===3&&Ue===Ke||Ce(Ue)||(Ue.content instanceof U&&tt(Ue.content),xe(Ue),Ke=Ue);if(Ke=null,O)return Ne;if(l){if(k)for(Xe=d.call(Ee.ownerDocument);Ee.firstChild;)Xe.appendChild(Ee.firstChild);else Xe=Ee;return W&&(Xe=b.call(E,Xe,!0)),Xe}var st=te?Ee.outerHTML:Ee.innerHTML;return ae&&(st=lt(st,V," "),st=lt(st,ee," ")),A&&j?A.createHTML(st):st},t.setConfig=function(Ne){Ie(Ne),$=!0},t.clearConfig=function(){ve=null,$=!1},t.isValidAttribute=function(Ne,oe,Ee){ve||Ie({});var Fe=ht(Ne),Ue=ht(oe);return Re(Fe,Ue,Ee)},t.addHook=function(Ne,oe){typeof oe=="function"&&(R[Ne]=R[Ne]||[],mt(R[Ne],oe))},t.removeHook=function(Ne){R[Ne]&&Mt(R[Ne])},t.removeHooks=function(Ne){R[Ne]&&(R[Ne]=[])},t.removeAllHooks=function(){R={}},t}var ui=Ut();define("vs/base/browser/dompurify/dompurify",function(){return ui}),define(ge[39],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class E{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const w=P(D);this.a!==w&&(this.a=w,this.domNode.style.maxWidth=this.a)}setWidth(D){const w=P(D);this.b!==w&&(this.b=w,this.domNode.style.width=this.b)}setHeight(D){const w=P(D);this.c!==w&&(this.c=w,this.domNode.style.height=this.c)}setTop(D){const w=P(D);this.d!==w&&(this.d=w,this.domNode.style.top=this.d)}setLeft(D){const w=P(D);this.e!==w&&(this.e=w,this.domNode.style.left=this.e)}setBottom(D){const w=P(D);this.f!==w&&(this.f=w,this.domNode.style.bottom=this.f)}setRight(D){const w=P(D);this.g!==w&&(this.g=w,this.domNode.style.right=this.g)}setPaddingTop(D){const w=P(D);this.h!==w&&(this.h=w,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const w=P(D);this.i!==w&&(this.i=w,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const w=P(D);this.j!==w&&(this.j=w,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const w=P(D);this.k!==w&&(this.k=w,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const w=P(D);this.n!==w&&(this.n=w,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const w=P(D);this.s!==w&&(this.s=w,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const w=P(D);this.t!==w&&(this.t=w,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,w){this.domNode.classList.toggle(D,w),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,w){this.domNode.setAttribute(D,w)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}t.FastDomNode=E;function P(i){return typeof i=="number"?`${i}px`:i}function U(i){return new E(i)}t.createFastDomNode=U}),define(ge[67],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let E=!1,P=null;function U(D){if(!D.parent||D.parent===D)return null;try{const w=D.location,f=D.parent.location;if(w.origin!=="null"&&f.origin!=="null"&&w.origin!==f.origin)return E=!0,null}catch{return E=!0,null}return D.parent}class i{static getSameOriginWindowChain(){if(!P){P=[];let w=window,f;do f=U(w),f?P.push({window:w,iframeElement:w.frameElement||null}):P.push({window:w,iframeElement:null}),w=f;while(w)}return P.slice(0)}static hasDifferentOriginAncestor(){return P||this.getSameOriginWindowChain(),E}static getPositionOfChildWindowRelativeToAncestorWindow(w,f){if(!f||w===f)return{top:0,left:0};let u=0,c=0;const M=this.getSameOriginWindowChain();for(const o of M){if(u+=o.window.scrollY,c+=o.window.scrollX,o.window===f||!o.iframeElement)break;const n=o.iframeElement.getBoundingClientRect();u+=n.top,c+=n.left}return{top:u,left:c}}}t.IframeUtils=i}),define(ge[68],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var E;(function(i){i[i.Copy=0]="Copy",i[i.Move=1]="Move"})(E=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class P extends Error{constructor(D,w){super(`ListError [${D}] ${w}`)}}t.ListError=P;class U{constructor(){this.c=new WeakMap}getHeight(D){return this.c.get(D)??this.d(D)}setDynamicHeight(D,w){w>0&&this.c.set(D,w)}}t.CachedListVirtualDelegate=U}),define(ge[69],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class E{constructor(U){this.a=U}splice(U,i,D){this.a.forEach(w=>w.splice(U,i,D))}}t.CombinedSpliceable=E}),define(ge[40],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const E=20;class P{constructor(i,D,w,f,u,c){this.a=Math.round(D),this.b=Math.round(w),this.c=Math.round(i),this.d=f,this.e=u,this.f=c,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new P(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(i){const D=Math.round(i);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(i){const D=Math.round(i);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(i){const D=Math.round(i);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(i){this.a=Math.round(i)}setOppositeScrollbarSize(i){this.b=Math.round(i)}static l(i,D,w,f,u){const c=Math.max(0,w-i),M=Math.max(0,c-2*D),o=f>0&&f>w;if(!o)return{computedAvailableSize:Math.round(c),computedIsNeeded:o,computedSliderSize:Math.round(M),computedSliderRatio:0,computedSliderPosition:0};const n=Math.round(Math.max(E,Math.floor(w*M/f))),e=(M-n)/(f-w),s=u*e;return{computedAvailableSize:Math.round(c),computedIsNeeded:o,computedSliderSize:Math.round(n),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const i=P.l(this.b,this.c,this.d,this.e,this.f);this.g=i.computedAvailableSize,this.h=i.computedIsNeeded,this.i=i.computedSliderSize,this.j=i.computedSliderRatio,this.k=i.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(i){if(!this.h)return 0;const D=i-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(i){if(!this.h)return 0;const D=i-this.c;let w=this.f;return D<this.k?w-=this.d:w+=this.d,w}getDesiredScrollPositionFromDelta(i){if(!this.h)return 0;const D=this.k+i;return Math.round(D/this.j)}}t.ScrollbarState=P}),define(ge[24],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var E;(function(w){w[w.Hidden=0]="Hidden",w[w.Visible=1]="Visible",w[w.Recurse=2]="Recurse"})(E=t.TreeVisibility||(t.TreeVisibility={}));var P;(function(w){w[w.Unknown=0]="Unknown",w[w.Twistie=1]="Twistie",w[w.Element=2]="Element",w[w.Filter=3]="Filter"})(P=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var U;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(U=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(w=!1){return{accept:!0,bubble:0,autoExpand:w}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(w=!1){return{accept:!0,bubble:0,effect:0,autoExpand:w}}};class i extends Error{constructor(f,u){super(`TreeError [${f}] ${u}`)}}t.TreeError=i;class D{constructor(f){this.a=f,this.b=new WeakMap}map(f){let u=this.b.get(f);return u||(u=this.a(f),this.b.set(f,u)),u}}t.WeakMapper=D}),define(ge[70],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function E(D,w){const f=Object.create(null);for(const u of D){const c=w(u);let M=f[c];M||(M=f[c]=[]),M.push(u)}return f}t.groupBy=E;function P(D,w){const f=[],u=[];for(const c of D)w.has(c)||f.push(c);for(const c of w)D.has(c)||u.push(c);return{removed:f,added:u}}t.diffSets=P;function U(D,w){const f=[],u=[];for(const[c,M]of D)w.has(c)||f.push(M);for(const[c,M]of w)D.has(c)||u.push(M);return{removed:f,added:u}}t.diffMaps=U;class i{constructor(){this.a=new Map}add(w,f){let u=this.a.get(w);u||(u=new Set,this.a.set(w,u)),u.add(f)}delete(w,f){const u=this.a.get(w);!u||(u.delete(f),u.size===0&&this.a.delete(w))}forEach(w,f){const u=this.a.get(w);!u||u.forEach(f)}}t.SetMap=i}),define(ge[41],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function E(w,f){const u=Math.pow(10,f);return Math.round(w*u)/u}class P{constructor(f,u,c,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=E(Math.max(Math.min(1,M),0),3)}static equals(f,u){return f.r===u.r&&f.g===u.g&&f.b===u.b&&f.a===u.a}}t.RGBA=P;class U{constructor(f,u,c,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,u),0),3),this.l=E(Math.max(Math.min(1,c),0),3),this.a=E(Math.max(Math.min(1,M),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.l===u.l&&f.a===u.a}static fromRGBA(f){const u=f.r/255,c=f.g/255,M=f.b/255,o=f.a,n=Math.max(u,c,M),e=Math.min(u,c,M);let s=0,r=0;const a=(e+n)/2,h=n-e;if(h>0){switch(r=Math.min(a<=.5?h/(2*a):h/(2-2*a),1),n){case u:s=(c-M)/h+(c<M?6:0);break;case c:s=(M-u)/h+2;break;case M:s=(u-c)/h+4;break}s*=60,s=Math.round(s)}return new U(s,r,a,o)}static i(f,u,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?f+(u-f)*6*c:c<1/2?u:c<2/3?f+(u-f)*(2/3-c)*6:f}static toRGBA(f){const u=f.h/360,{s:c,l:M,a:o}=f;let n,e,s;if(c===0)n=e=s=M;else{const r=M<.5?M*(1+c):M+c-M*c,a=2*M-r;n=U.i(a,r,u+1/3),e=U.i(a,r,u),s=U.i(a,r,u-1/3)}return new P(Math.round(n*255),Math.round(e*255),Math.round(s*255),o)}}t.HSLA=U;class i{constructor(f,u,c,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,u),0),3),this.v=E(Math.max(Math.min(1,c),0),3),this.a=E(Math.max(Math.min(1,M),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.v===u.v&&f.a===u.a}static fromRGBA(f){const u=f.r/255,c=f.g/255,M=f.b/255,o=Math.max(u,c,M),n=Math.min(u,c,M),e=o-n,s=o===0?0:e/o;let r;return e===0?r=0:o===u?r=((c-M)/e%6+6)%6:o===c?r=(M-u)/e+2:r=(u-c)/e+4,new i(Math.round(r*60),s,o,f.a)}static toRGBA(f){const{h:u,s:c,v:M,a:o}=f,n=M*c,e=n*(1-Math.abs(u/60%2-1)),s=M-n;let[r,a,h]=[0,0,0];return u<60?(r=n,a=e):u<120?(r=e,a=n):u<180?(a=n,h=e):u<240?(a=e,h=n):u<300?(r=e,h=n):u<=360&&(r=n,h=e),r=Math.round((r+s)*255),a=Math.round((a+s)*255),h=Math.round((h+s)*255),new P(r,a,h,o)}}t.HSVA=i;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,u){return!f&&!u?!0:!f||!u?!1:f.equals(u)}get hsla(){return this.i?this.i:U.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:i.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof P)this.rgba=f;else if(f instanceof U)this.i=f,this.rgba=U.toRGBA(f);else if(f instanceof i)this.j=f,this.rgba=i.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&P.equals(this.rgba,f.rgba)&&U.equals(this.hsla,f.hsla)&&i.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),u=D.k(this.rgba.g),c=D.k(this.rgba.b),M=.2126*f+.7152*u+.0722*c;return E(M,4)}static k(f){const u=f/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(f){const u=this.getRelativeLuminance(),c=f.getRelativeLuminance();return u>c?(u+.05)/(c+.05):(c+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const u=this.getRelativeLuminance(),c=f.getRelativeLuminance();return u>c}isDarkerThan(f){const u=this.getRelativeLuminance(),c=f.getRelativeLuminance();return u<c}lighten(f){return new D(new U(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new U(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:u,g:c,b:M,a:o}=this.rgba;return new D(new P(u,c,M,o*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const u=f.rgba,c=this.rgba.a,M=u.a,o=c+M*(1-c);if(o<1e-6)return D.transparent;const n=this.rgba.r*c/o+u.r*M*(1-c)/o,e=this.rgba.g*c/o+u.g*M*(1-c)/o,s=this.rgba.b*c/o+u.b*M*(1-c)/o;return new D(new P(n,e,s,o))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:u,g:c,b:M,a:o}=this.rgba;return new D(new P(f.rgba.r-o*(f.rgba.r-u),f.rgba.g-o*(f.rgba.g-c),f.rgba.b-o*(f.rgba.b-M),1))}flatten(...f){const u=f.reduceRight((c,M)=>D.o(M,c));return D.o(this,u)}static o(f,u){const c=1-f.rgba.a;return new D(new P(c*u.rgba.r+f.rgba.a*f.rgba.r,c*u.rgba.g+f.rgba.a*f.rgba.g,c*u.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,u,c){if(f.isLighterThan(u))return f;c=c||.5;const M=f.getRelativeLuminance(),o=u.getRelativeLuminance();return c=c*(o-M)/o,f.lighten(c)}static getDarkerColor(f,u,c){if(f.isDarkerThan(u))return f;c=c||.5;const M=f.getRelativeLuminance(),o=u.getRelativeLuminance();return c=c*(M-o)/M,f.darken(c)}}t.Color=D,D.white=new D(new P(255,255,255,1)),D.black=new D(new P(0,0,0,1)),D.red=new D(new P(255,0,0,1)),D.blue=new D(new P(0,0,255,1)),D.green=new D(new P(0,255,0,1)),D.cyan=new D(new P(0,255,255,1)),D.lightgrey=new D(new P(211,211,211,1)),D.transparent=new D(new P(0,0,0,0)),function(w){let f;(function(u){let c;(function(M){function o(m){return m.rgba.a===1?`rgb(${m.rgba.r}, ${m.rgba.g}, ${m.rgba.b})`:w.Format.CSS.formatRGBA(m)}M.formatRGB=o;function n(m){return`rgba(${m.rgba.r}, ${m.rgba.g}, ${m.rgba.b}, ${+m.rgba.a.toFixed(2)})`}M.formatRGBA=n;function e(m){return m.hsla.a===1?`hsl(${m.hsla.h}, ${(m.hsla.s*100).toFixed(2)}%, ${(m.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(m)}M.formatHSL=e;function s(m){return`hsla(${m.hsla.h}, ${(m.hsla.s*100).toFixed(2)}%, ${(m.hsla.l*100).toFixed(2)}%, ${m.hsla.a.toFixed(2)})`}M.formatHSLA=s;function r(m){const C=m.toString(16);return C.length!==2?"0"+C:C}function a(m){return`#${r(m.rgba.r)}${r(m.rgba.g)}${r(m.rgba.b)}`}M.formatHex=a;function h(m,C=!1){return C&&m.rgba.a===1?w.Format.CSS.formatHex(m):`#${r(m.rgba.r)}${r(m.rgba.g)}${r(m.rgba.b)}${r(Math.round(m.rgba.a*255))}`}M.formatHexA=h;function p(m){return m.isOpaque()?w.Format.CSS.formatHex(m):w.Format.CSS.formatRGBA(m)}M.format=p;function T(m){const C=m.length;if(C===0||m.charCodeAt(0)!==35)return null;if(C===7){const N=16*A(m.charCodeAt(1))+A(m.charCodeAt(2)),L=16*A(m.charCodeAt(3))+A(m.charCodeAt(4)),d=16*A(m.charCodeAt(5))+A(m.charCodeAt(6));return new w(new P(N,L,d,1))}if(C===9){const N=16*A(m.charCodeAt(1))+A(m.charCodeAt(2)),L=16*A(m.charCodeAt(3))+A(m.charCodeAt(4)),d=16*A(m.charCodeAt(5))+A(m.charCodeAt(6)),v=16*A(m.charCodeAt(7))+A(m.charCodeAt(8));return new w(new P(N,L,d,v/255))}if(C===4){const N=A(m.charCodeAt(1)),L=A(m.charCodeAt(2)),d=A(m.charCodeAt(3));return new w(new P(16*N+N,16*L+L,16*d+d))}if(C===5){const N=A(m.charCodeAt(1)),L=A(m.charCodeAt(2)),d=A(m.charCodeAt(3)),v=A(m.charCodeAt(4));return new w(new P(16*N+N,16*L+L,16*d+d,(16*v+v)/255))}return null}M.parseHex=T;function A(m){switch(m){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=u.CSS||(u.CSS={}))})(f=w.Format||(w.Format={}))}(D=t.Color||(t.Color={}))}),define(ge[25],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function E(D){return(w,f,u)=>{let c=null,M=null;if(typeof u.value=="function"?(c="value",M=u.value):typeof u.get=="function"&&(c="get",M=u.get),!M)throw new Error("not supported");u[c]=D(M,f)}}function P(D,w,f){let u=null,c=null;if(typeof f.value=="function"?(u="value",c=f.value,c.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(u="get",c=f.get),!c)throw new Error("not supported");const M=`$memoize$${w}`;f[u]=function(...o){return this.hasOwnProperty(M)||Object.defineProperty(this,M,{configurable:!1,enumerable:!1,writable:!1,value:c.apply(this,o)}),this[M]}}t.memoize=P;function U(D,w,f){return E((u,c)=>{const M=`$debounce$${c}`,o=`$debounce$result$${c}`;return function(...n){this[o]||(this[o]=f?f():void 0),clearTimeout(this[M]),w&&(this[o]=w(this[o],...n),n=[this[o]]),this[M]=setTimeout(()=>{u.apply(this,n),this[o]=f?f():void 0},D)}})}t.debounce=U;function i(D,w,f){return E((u,c)=>{const M=`$throttle$timer$${c}`,o=`$throttle$result$${c}`,n=`$throttle$lastRun$${c}`,e=`$throttle$pending$${c}`;return function(...s){if(this[o]||(this[o]=f?f():void 0),(this[n]===null||this[n]===void 0)&&(this[n]=-Number.MAX_VALUE),w&&(this[o]=w(this[o],...s)),this[e])return;const r=this[n]+D;r<=Date.now()?(this[n]=Date.now(),u.apply(this,[this[o]]),this[o]=f?f():void 0):(this[e]=!0,this[M]=setTimeout(()=>{this[e]=!1,this[n]=Date.now(),u.apply(this,[this[o]]),this[o]=f?f():void 0},r-Date.now()))}})}t.throttle=i}),define(ge[71],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(U,i,D,w){this.originalStart=U,this.originalLength=i,this.modifiedStart=D,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),define(ge[7],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(m){setTimeout(()=>{throw m.stack?p.isErrorNoTelemetry(m)?new p(m.message+`

`+m.stack):new Error(m.message+`

`+m.stack):m},0)}}addListener(m){return this.b.push(m),()=>{this.d(m)}}c(m){this.b.forEach(C=>{C(m)})}d(m){this.b.splice(this.b.indexOf(m),1)}setUnexpectedErrorHandler(m){this.a=m}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(m){this.a(m),this.c(m)}onUnexpectedExternalError(m){this.a(m)}}t.ErrorHandler=E,t.errorHandler=new E;function P(A){t.errorHandler.setUnexpectedErrorHandler(A)}t.setUnexpectedErrorHandler=P;function U(A){f(A)||t.errorHandler.onUnexpectedError(A)}t.onUnexpectedError=U;function i(A){f(A)||t.errorHandler.onUnexpectedExternalError(A)}t.onUnexpectedExternalError=i;function D(A){if(A instanceof Error){const{name:m,message:C}=A,N=A.stacktrace||A.stack;return{$isError:!0,name:m,message:C,stack:N,noTelemetry:p.isErrorNoTelemetry(A)}}return A}t.transformErrorForSerialization=D;const w="Canceled";function f(A){return A instanceof u?!0:A instanceof Error&&A.name===w&&A.message===w}t.isCancellationError=f;class u extends Error{constructor(){super(w),this.name=this.message}}t.CancellationError=u;function c(){const A=new Error(w);return A.name=A.message,A}t.canceled=c;function M(A){return A?new Error(`Illegal argument: ${A}`):new Error("Illegal argument")}t.illegalArgument=M;function o(A){return A?new Error(`Illegal state: ${A}`):new Error("Illegal state")}t.illegalState=o;function n(A){return A?new Error(`readonly property '${A} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=n;function e(A){const m=new Error(`${A} has been disposed`);return m.name="DISPOSED",m}t.disposed=e;function s(A){return A?A.message?A.message:A.stack?A.stack.split(`
`)[0]:String(A):"Error"}t.getErrorMessage=s;class r extends Error{constructor(m){super("NotImplemented"),m&&(this.message=m)}}t.NotImplementedError=r;class a extends Error{constructor(m){super("NotSupported"),m&&(this.message=m)}}t.NotSupportedError=a;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=h;class p extends Error{constructor(m){super(m),this.name="CodeExpectedError"}static fromError(m){if(m instanceof p)return m;const C=new p;return C.message=m.message,C.stack=m.stack,C}static isErrorNoTelemetry(m){return m.name==="CodeExpectedError"}}t.ErrorNoTelemetry=p;class T extends Error{constructor(m){super(m||"An unexpected bug occurred."),Object.setPrototypeOf(this,T.prototype);debugger}}t.BugIndicatingError=T}),define(ge[13],me([1,0,7]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function P(F,I=0){return F[F.length-(1+I)]}t.tail=P;function U(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}t.tail2=U;function i(F,I,O=(S,B)=>S===B){if(F===I)return!0;if(!F||!I||F.length!==I.length)return!1;for(let S=0,B=F.length;S<B;S++)if(!O(F[S],I[S]))return!1;return!0}t.equals=i;function D(F,I){const O=F.length-1;I<O&&(F[I]=F[O]),F.pop()}t.removeFastWithoutKeepingOrder=D;function w(F,I,O){return f(F.length,S=>O(F[S],I))}t.binarySearch=w;function f(F,I){let O=0,S=F-1;for(;O<=S;){const B=(O+S)/2|0,H=I(B);if(H<0)O=B+1;else if(H>0)S=B-1;else return B}return-(O+1)}t.binarySearch2=f;function u(F,I){let O=0,S=F.length;if(S===0)return 0;for(;O<S;){const B=Math.floor((O+S)/2);I(F[B])?S=B:O=B+1}return O}t.findFirstInSorted=u;function c(F,I,O){if(F=F|0,F>=I.length)throw new TypeError("invalid index");const S=I[Math.floor(I.length*Math.random())],B=[],H=[],z=[];for(const _ of I){const Y=O(_,S);Y<0?B.push(_):Y>0?H.push(_):z.push(_)}return F<B.length?c(F,B,O):F<B.length+z.length?z[0]:c(F-(B.length+z.length),H,O)}t.quickSelect=c;function M(F,I){const O=[];let S;for(const B of F.slice(0).sort(I))!S||I(S[0],B)!==0?(S=[B],O.push(S)):S.push(B);return O}t.groupBy=M;function o(F,I,O){const S=[];function B(_,Y,ne){if(Y===0&&ne.length===0)return;const ue=S[S.length-1];ue&&ue.start+ue.deleteCount===_?(ue.deleteCount+=Y,ue.toInsert.push(...ne)):S.push({start:_,deleteCount:Y,toInsert:ne})}let H=0,z=0;for(;;){if(H===F.length){B(H,0,I.slice(z));break}if(z===I.length){B(H,F.length-H,[]);break}const _=F[H],Y=I[z],ne=O(_,Y);ne===0?(H+=1,z+=1):ne<0?(B(H,1,[]),H+=1):ne>0&&(B(H,0,[Y]),z+=1)}return S}t.sortedDiff=o;function n(F,I,O){const S=o(F,I,O),B=[],H=[];for(const z of S)B.push(...F.slice(z.start,z.start+z.deleteCount)),H.push(...z.toInsert);return{removed:B,added:H}}t.delta=n;function e(F,I,O){if(O===0)return[];const S=F.slice(0,O).sort(I);return r(F,I,S,O,F.length),S}t.top=e;function s(F,I,O,S,B){return O===0?Promise.resolve([]):new Promise((H,z)=>{(async()=>{const _=F.length,Y=F.slice(0,O).sort(I);for(let ne=O,ue=Math.min(O+S,_);ne<_;ne=ue,ue=Math.min(ue+S,_)){if(ne>O&&await new Promise(we=>setTimeout(we)),B&&B.isCancellationRequested)throw new E.CancellationError;r(F,I,Y,ne,ue)}return Y})().then(H,z)})}t.topAsync=s;function r(F,I,O,S,B){for(const H=O.length;S<B;S++){const z=F[S];if(I(z,O[H-1])<0){O.pop();const _=u(O,Y=>I(z,Y)<0);O.splice(_,0,z)}}}function a(F){return F.filter(I=>!!I)}t.coalesce=a;function h(F){let I=0;for(let O=0;O<F.length;O++)F[O]&&(F[I]=F[O],I+=1);F.length=I}t.coalesceInPlace=h;function p(F,I,O){F.splice(O,0,F.splice(I,1)[0])}t.move=p;function T(F){return!Array.isArray(F)||F.length===0}t.isFalsyOrEmpty=T;function A(F){return Array.isArray(F)&&F.length>0}t.isNonEmptyArray=A;function m(F,I=O=>O){const O=new Set;return F.filter(S=>{const B=I(S);return O.has(B)?!1:(O.add(B),!0)})}t.distinct=m;function C(F){const I=new Set;return O=>{const S=F(O);return I.has(S)?!1:(I.add(S),!0)}}t.uniqueFilter=C;function N(F,I){const O=L(F,I);if(O!==-1)return F[O]}t.findLast=N;function L(F,I){for(let O=F.length-1;O>=0;O--){const S=F[O];if(I(S))return O}return-1}t.lastIndex=L;function d(F,I){return F.length>0?F[0]:I}t.firstOrDefault=d;function v(F,I){return F.length>0?F[F.length-1]:I}t.lastOrDefault=v;function b(F,I,O=(S,B)=>S===B){let S=0;for(let B=0,H=Math.min(F.length,I.length);B<H&&O(F[B],I[B]);B++)S++;return S}t.commonPrefixLength=b;function y(F){return[].concat(...F)}t.flatten=y;function R(F,I){let O=typeof I=="number"?F:0;typeof I=="number"?O=F:(O=0,I=F);const S=[];if(O<=I)for(let B=O;B<I;B++)S.push(B);else for(let B=O;B>I;B--)S.push(B);return S}t.range=R;function V(F,I,O){return F.reduce((S,B)=>(S[I(B)]=O?O(B):B,S),Object.create(null))}t.index=V;function ee(F,I){return F.push(I),()=>Z(F,I)}t.insert=ee;function Z(F,I){const O=F.indexOf(I);if(O>-1)return F.splice(O,1),I}t.remove=Z;function J(F,I,O){const S=F.slice(0,I),B=F.slice(I);return S.concat(O,B)}t.arrayInsert=J;function re(F,I){let O;if(typeof I=="number"){let S=I;O=()=>{const B=Math.sin(S++)*179426549;return B-Math.floor(B)}}else O=Math.random;for(let S=F.length-1;S>0;S-=1){const B=Math.floor(O()*(S+1)),H=F[S];F[S]=F[B],F[B]=H}}t.shuffle=re;function he(F,I){const O=F.indexOf(I);O>-1&&(F.splice(O,1),F.unshift(I))}t.pushToStart=he;function de(F,I){const O=F.indexOf(I);O>-1&&(F.splice(O,1),F.push(I))}t.pushToEnd=de;function ce(F,I){for(const O of I)F.push(O)}t.pushMany=ce;function pe(F,I){return Array.isArray(F)?F.map(I):I(F)}t.mapArrayOrNot=pe;function Te(F){return Array.isArray(F)?F:[F]}t.asArray=Te;function Pe(F){return F[Math.floor(Math.random()*F.length)]}t.getRandomElement=Pe;function Oe(F,I){for(const O of F){const S=I(O);if(S!==void 0)return S}}t.mapFind=Oe;function x(F,I,O){const S=ie(F,I),B=F.length,H=O.length;F.length=B+H;for(let z=B-1;z>=S;z--)F[z+H]=F[z];for(let z=0;z<H;z++)F[z+S]=O[z]}t.insertInto=x;function G(F,I,O,S){const B=ie(F,I),H=F.splice(B,O);return x(F,B,S),H}t.splice=G;function ie(F,I){return I<0?Math.max(I+F.length,0):Math.min(I,F.length)}var se;(function(F){function I(B){return B<0}F.isLessThan=I;function O(B){return B>0}F.isGreaterThan=O;function S(B){return B===0}F.isNeitherLessOrGreaterThan=S,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(se=t.CompareResult||(t.CompareResult={}));function ae(F,I){return(O,S)=>I(F(O),F(S))}t.compareBy=ae;function te(...F){return(I,O)=>{for(const S of F){const B=S(I,O);if(!se.isNeitherLessOrGreaterThan(B))return B}return se.neitherLessOrGreaterThan}}t.tieBreakComparators=te;const $=(F,I)=>F-I;t.numberComparator=$;function g(F,I){if(F.length===0)return;let O=F[0];for(let S=1;S<F.length;S++){const B=F[S];I(B,O)>0&&(O=B)}return O}t.findMaxBy=g;function l(F,I){if(F.length===0)return;let O=F[0];for(let S=1;S<F.length;S++){const B=F[S];I(B,O)>=0&&(O=B)}return O}t.findLastMaxBy=l;function k(F,I){return g(F,(O,S)=>-I(O,S))}t.findMinBy=k;class W{constructor(I){this.f=I,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(I){let O=this.c;for(;O<this.f.length&&I(this.f[O]);)O++;const S=O===this.c?null:this.f.slice(this.c,O);return this.c=O,S}takeFromEndWhile(I){let O=this.d;for(;O>=0&&I(this.f[O]);)O--;const S=O===this.d?null:this.f.slice(O+1,this.d+1);return this.d=O,S}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const I=this.f[this.c];return this.c++,I}removeLast(){const I=this.f[this.d];return this.d--,I}takeCount(I){const O=this.f.slice(this.c,this.c+I);return this.c+=I,O}}t.ArrayQueue=W;class j{constructor(I){this.iterate=I}forEach(I){this.iterate(O=>(I(O),!0))}toArray(){const I=[];return this.iterate(O=>(I.push(O),!0)),I}filter(I){return new j(O=>this.iterate(S=>I(S)?O(S):!0))}map(I){return new j(O=>this.iterate(S=>O(I(S))))}some(I){let O=!1;return this.iterate(S=>(O=I(S),!O)),O}findFirst(I){let O;return this.iterate(S=>I(S)?(O=S,!1):!0),O}findLast(I){let O;return this.iterate(S=>(I(S)&&(O=S),!0)),O}findLastMaxBy(I){let O,S=!0;return this.iterate(B=>((S||se.isGreaterThan(I(B,O)))&&(S=!1,O=B),!0)),O}}t.CallbackIterable=j,j.empty=new j(F=>{})}),define(ge[72],me([1,0,7]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function P(f,u){if(!f)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}t.ok=P;function U(f,u="Unreachable"){throw new Error(u)}t.assertNever=U;function i(f){if(!f)throw new E.BugIndicatingError("Assertion Failed")}t.assert=i;function D(f){if(!f()){debugger;f(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}t.assertFn=D;function w(f,u){let c=0;for(;c<f.length-1;){const M=f[c],o=f[c+1];if(!u(M,o))return!1;c++}return!0}t.checkAdjacentItems=w}),define(ge[42],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(P){const U=this;let i=!1,D;return function(){return i||(i=!0,D=P.apply(U,arguments)),D}}t.once=E}),define(ge[73],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class E{constructor(U){this.a=U,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=E,t.defaultGenerator=new E("id#")}),define(ge[26],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(P){function U(T){return T&&typeof T=="object"&&typeof T[Symbol.iterator]=="function"}P.is=U;const i=Object.freeze([]);function D(){return i}P.empty=D;function*w(T){yield T}P.single=w;function f(T){return U(T)?T:w(T)}P.wrap=f;function u(T){return T||i}P.from=u;function c(T){return!T||T[Symbol.iterator]().next().done===!0}P.isEmpty=c;function M(T){return T[Symbol.iterator]().next().value}P.first=M;function o(T,A){for(const m of T)if(A(m))return!0;return!1}P.some=o;function n(T,A){for(const m of T)if(A(m))return m}P.find=n;function*e(T,A){for(const m of T)A(m)&&(yield m)}P.filter=e;function*s(T,A){let m=0;for(const C of T)yield A(C,m++)}P.map=s;function*r(...T){for(const A of T)for(const m of A)yield m}P.concat=r;function a(T,A,m){let C=m;for(const N of T)C=A(C,N);return C}P.reduce=a;function*h(T,A,m=T.length){for(A<0&&(A+=T.length),m<0?m+=T.length:m>T.length&&(m=T.length);A<m;A++)yield T[A]}P.slice=h;function p(T,A=Number.POSITIVE_INFINITY){const m=[];if(A===0)return[m,T];const C=T[Symbol.iterator]();for(let N=0;N<A;N++){const L=C.next();if(L.done)return[m,P.empty()];m.push(L.value)}return[m,{[Symbol.iterator](){return C}}]}P.consume=p})(E=t.Iterable||(t.Iterable={}))}),define(ge[43],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(E=t.KeyCode||(t.KeyCode={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P=t.ScanCode||(t.ScanCode={}));class U{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,r){this._keyCodeToStr[s]=r,this._strToKeyCode[r.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const i=new U,D=new U,w=new U;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],u=Object.create(null),c=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>u[e]||0,toString:e=>f[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",s=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],r=[],a=[];for(const h of s){const[p,T,A,m,C,N,L,d,v,b]=h;if(a[A]||(a[A]=!0,f[A]=m,u[m]=A,c[m.toLowerCase()]=A,T&&(t.IMMUTABLE_CODE_TO_KEY_CODE[A]=C,C!==0&&C!==3&&C!==5&&C!==4&&C!==6&&C!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[C]=A))),!r[C]){if(r[C]=!0,!N)throw new Error(`String representation missing for key code ${C} around scan code ${m}`);i.define(C,N),D.define(C,v||N),w.define(C,b||v||N)}L&&(t.EVENT_KEY_CODE_MAP[L]=C),d&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[d]=C)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(e){function s(A){return i.keyCodeToStr(A)}e.toString=s;function r(A){return i.strToKeyCode(A)}e.fromString=r;function a(A){return D.keyCodeToStr(A)}e.toUserSettingsUS=a;function h(A){return w.keyCodeToStr(A)}e.toUserSettingsGeneral=h;function p(A){return D.strToKeyCode(A)||w.strToKeyCode(A)}e.fromUserSettings=p;function T(A){if(A>=93&&A<=108)return null;switch(A){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return i.keyCodeToStr(A)}e.toElectronAccelerator=T})(M=t.KeyCodeUtils||(t.KeyCodeUtils={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o=t.KeyMod||(t.KeyMod={}));function n(e,s){const r=(s&65535)<<16>>>0;return(e|r)>>>0}t.KeyChord=n}),define(ge[74],me([1,0,7]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=t.createSimpleKeybinding=t.decodeKeybinding=void 0;var P;(function(M){M[M.CtrlCmd=2048]="CtrlCmd",M[M.Shift=1024]="Shift",M[M.Alt=512]="Alt",M[M.WinCtrl=256]="WinCtrl",M[M.KeyCode=255]="KeyCode"})(P||(P={}));function U(M,o){if(M===0)return null;const n=(M&65535)>>>0,e=(M&4294901760)>>>16;return e!==0?new f([i(n,o),i(e,o)]):new f([i(n,o)])}t.decodeKeybinding=U;function i(M,o){const n=!!(M&2048),e=!!(M&256),s=o===2?e:n,r=!!(M&1024),a=!!(M&512),h=o===2?n:e,p=M&255;return new D(s,r,a,h,p)}t.createSimpleKeybinding=i;class D{constructor(o,n,e,s,r){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyCode=r}equals(o){return o instanceof D&&this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",n=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`${o}${n}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new f([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=D;class w{constructor(o,n,e,s,r){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.scanCode=r}equals(o){return o instanceof w&&this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}getHashCode(){const o=this.ctrlKey?"1":"0",n=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`${o}${n}${e}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=w;class f{constructor(o){if(o.length===0)throw(0,E.illegalArgument)("chords");this.chords=o}getHashCode(){let o="";for(let n=0,e=this.chords.length;n<e;n++)n!==0&&(o+=";"),o+=this.chords[n].getHashCode();return o}equals(o){if(o===null||this.chords.length!==o.chords.length)return!1;for(let n=0;n<this.chords.length;n++)if(!this.chords[n].equals(o.chords[n]))return!1;return!0}}t.Keybinding=f;class u{constructor(o,n,e,s,r,a){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyLabel=r,this.keyAriaLabel=a}}t.ResolvedChord=u;class c{}t.ResolvedKeybinding=c}),define(ge[44],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class E{constructor(U){this.d=U,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(U){this.c=U}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=E}),define(ge[2],me([1,0,42,26]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const U=!1;let i=null;function D(v){i=v}if(t.setDisposableTracker=D,U){const v="__is_disposable_tracked__";D(new class{trackDisposable(b){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[v]||console.log(y)},3e3)}setParent(b,y){if(b&&b!==h.None)try{b[v]=!0}catch{}}markAsDisposed(b){if(b&&b!==h.None)try{b[v]=!0}catch{}}markAsSingleton(b){}})}function w(v){return i?.trackDisposable(v),v}function f(v){i?.markAsDisposed(v)}function u(v,b){i?.setParent(v,b)}function c(v,b){if(!!i)for(const y of v)i.setParent(y,b)}function M(v){return i?.markAsSingleton(v),v}t.markAsSingleton=M;function o(v){return typeof v.dispose=="function"&&v.dispose.length===0}t.isDisposable=o;function n(v){if(P.Iterable.is(v)){const b=[];for(const y of v)if(y)try{y.dispose()}catch(R){b.push(R)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}t.dispose=n;function e(v){for(const b of v)o(b)&&b.dispose();return[]}t.disposeIfDisposable=e;function s(...v){const b=r(()=>n(v));return c(v,b),b}t.combinedDisposable=s;function r(v){const b=w({dispose:(0,E.once)(()=>{f(b),v()})});return b}t.toDisposable=r;class a{constructor(){this.c=new Set,this.f=!1,w(this)}dispose(){this.f||(f(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{n(this.c)}finally{this.c.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return u(b,this),this.f?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(b),b}}t.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this.q=new a,w(this),u(this.q,this)}dispose(){f(this),this.q.dispose()}B(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(b)}}t.Disposable=h,h.None=Object.freeze({dispose(){}});class p{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(b){this.b||b===this.a||(this.a?.dispose(),b&&u(b,this),this.a=b)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const b=this.a;return this.a=void 0,b&&u(b,null),b}}t.MutableDisposable=p;class T{constructor(b){this.b=b,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=T;class A{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(b){let y=b;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,f(this))},this}}t.SafeDisposable=A;class m{constructor(){this.a=new Map}acquire(b,...y){let R=this.a.get(b);R||(R={counter:0,object:this.b(b,...y)},this.a.set(b,R));const{object:V}=R,ee=(0,E.once)(()=>{--R.counter===0&&(this.c(b,R.object),this.a.delete(b))});return R.counter++,{object:V,dispose:ee}}}t.ReferenceCollection=m;class C{constructor(b){this.a=b}async acquire(b,...y){const R=this.a.acquire(b,...y);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(V){throw R.dispose(),V}}}t.AsyncReferenceCollection=C;class N{constructor(b){this.object=b}dispose(){}}t.ImmortalReference=N;function L(v){const b=new a;try{v(b)}finally{b.dispose()}}t.disposeOnReturn=L;class d{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{n(this.a.values())}finally{this.a.clear()}}has(b){return this.a.has(b)}get(b){return this.a.get(b)}set(b,y,R=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this.a.get(b)?.dispose(),this.a.set(b,y)}deleteAndDispose(b){this.a.get(b)?.dispose(),this.a.delete(b)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=d}),define(ge[45],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(i){this.element=i,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class P{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let i=this.a;for(;i!==E.Undefined;){const D=i.next;i.prev=E.Undefined,i.next=E.Undefined,i=D}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(i){return this.d(i,!1)}push(i){return this.d(i,!0)}d(i,D){const w=new E(i);if(this.a===E.Undefined)this.a=w,this.b=w;else if(D){const u=this.b;this.b=w,w.prev=u,u.next=w}else{const u=this.a;this.a=w,w.next=u,u.prev=w}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(w))}}shift(){if(this.a!==E.Undefined){const i=this.a.element;return this.e(this.a),i}}pop(){if(this.b!==E.Undefined){const i=this.b.element;return this.e(this.b),i}}e(i){if(i.prev!==E.Undefined&&i.next!==E.Undefined){const D=i.prev;D.next=i.next,i.next.prev=D}else i.prev===E.Undefined&&i.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):i.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):i.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let i=this.a;for(;i!==E.Undefined;)yield i.element,i=i.next}}t.LinkedList=P}),define(ge[75],me([1,0]),function(Q,t){"use strict";var E,P,U;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function i(e,s,r){let a=e.get(s);return a===void 0&&(a=r,e.set(s,a)),a}t.getOrSet=i;function D(e){const s=[];return e.forEach((r,a)=>{s.push(`${a} => ${r}`)}),`Map(${e.size}) {${s.join(", ")}}`}t.mapToString=D;function w(e){const s=[];return e.forEach(r=>{s.push(r)}),`Set(${e.size}) {${s.join(", ")}}`}t.setToString=w;class f{constructor(s,r){this.uri=s,this.value=r}}class u{constructor(s,r){this[E]="ResourceMap",s instanceof u?(this.b=new Map(s.b),this.c=r??u.a):(this.b=new Map,this.c=s??u.a)}set(s,r){return this.b.set(this.c(s),new f(s,r)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,r){typeof r<"u"&&(s=s.bind(r));for(const[a,h]of this.b)s(h.value,h.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}t.ResourceMap=u,u.a=e=>e.toString();class c{constructor(s,r){this[P]="ResourceSet",!s||typeof s=="function"?this.a=new u(s):(this.a=new u(r),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,r){this.a.forEach((a,h)=>s.call(r,h,h,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=c;var M;(function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"})(M=t.Touch||(t.Touch={}));class o{constructor(){this[U]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,r=0){const a=this.a.get(s);if(!!a)return r!==0&&this.j(a,r),a.value}set(s,r,a=0){let h=this.a.get(s);if(h)h.value=r,a!==0&&this.j(h,a);else{switch(h={key:s,value:r,next:void 0,previous:void 0},a){case 0:this.h(h);break;case 1:this.g(h);break;case 2:this.h(h);break;default:this.h(h);break}this.a.set(s,h),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this.a.get(s);if(!!r)return this.a.delete(s),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,r){const a=this.e;let h=this.b;for(;h;){if(r?s.bind(r)(h.value,h.key,this):s(h.value,h.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const s=this,r=this.e;let a=this.b;const h={[Symbol.iterator](){return h},next(){if(s.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:a.key,done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return h}values(){const s=this,r=this.e;let a=this.b;const h={[Symbol.iterator](){return h},next(){if(s.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:a.value,done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return h}entries(){const s=this,r=this.e;let a=this.b;const h={[Symbol.iterator](){return h},next(){if(s.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:[a.key,a.value],done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return h}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this.b,a=this.size;for(;r&&a>s;)this.a.delete(r.key),r=r.next,a--;this.b=r,this.d=a,r&&(r.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const r=s.next,a=s.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}s.next=void 0,s.previous=void 0,this.e++}j(s,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this.b)return;const a=s.next,h=s.previous;s===this.c?(h.next=void 0,this.c=h):(a.previous=h,h.next=a),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(r===2){if(s===this.c)return;const a=s.next,h=s.previous;s===this.b?(a.previous=void 0,this.b=a):(a.previous=h,h.next=a),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((r,a)=>{s.push([a,r])}),s}fromJSON(s){this.clear();for(const[r,a]of s)this.set(r,a)}}t.LinkedMap=o;class n extends o{constructor(s,r=1){super(),this.k=s,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=n}),function(Q,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(ge[76],me([0]),t):(Q=typeof globalThis<"u"?globalThis:Q||self,t(Q.marked={}))}(this,function(Q){"use strict";function t(F,I){for(var O=0;O<I.length;O++){var S=I[O];S.enumerable=S.enumerable||!1,S.configurable=!0,"value"in S&&(S.writable=!0),Object.defineProperty(F,S.key,S)}}function E(F,I,O){return I&&t(F.prototype,I),O&&t(F,O),Object.defineProperty(F,"prototype",{writable:!1}),F}function P(F,I){if(!!F){if(typeof F=="string")return U(F,I);var O=Object.prototype.toString.call(F).slice(8,-1);if(O==="Object"&&F.constructor&&(O=F.constructor.name),O==="Map"||O==="Set")return Array.from(F);if(O==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(O))return U(F,I)}}function U(F,I){(I==null||I>F.length)&&(I=F.length);for(var O=0,S=new Array(I);O<I;O++)S[O]=F[O];return S}function i(F,I){var O=typeof Symbol<"u"&&F[Symbol.iterator]||F["@@iterator"];if(O)return(O=O.call(F)).next.bind(O);if(Array.isArray(F)||(O=P(F))||I&&F&&typeof F.length=="number"){O&&(F=O);var S=0;return function(){return S>=F.length?{done:!0}:{done:!1,value:F[S++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Q.defaults=D();function w(F){Q.defaults=F}var f=/[&<>"']/,u=/[&<>"']/g,c=/[<>"']|&(?!#?\w+;)/,M=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},n=function(I){return o[I]};function e(F,I){if(I){if(f.test(F))return F.replace(u,n)}else if(c.test(F))return F.replace(M,n);return F}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(F){return F.replace(s,function(I,O){return O=O.toLowerCase(),O==="colon"?":":O.charAt(0)==="#"?O.charAt(1)==="x"?String.fromCharCode(parseInt(O.substring(2),16)):String.fromCharCode(+O.substring(1)):""})}var a=/(^|[^\[])\^/g;function h(F,I){F=typeof F=="string"?F:F.source,I=I||"";var O={replace:function(B,H){return H=H.source||H,H=H.replace(a,"$1"),F=F.replace(B,H),O},getRegex:function(){return new RegExp(F,I)}};return O}var p=/[^\w:]/g,T=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function A(F,I,O){if(F){var S;try{S=decodeURIComponent(r(O)).replace(p,"").toLowerCase()}catch{return null}if(S.indexOf("javascript:")===0||S.indexOf("vbscript:")===0||S.indexOf("data:")===0)return null}I&&!T.test(O)&&(O=d(I,O));try{O=encodeURI(O).replace(/%25/g,"%")}catch{return null}return O}var m={},C=/^[^:]+:\/*[^/]*$/,N=/^([^:]+:)[\s\S]*$/,L=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(F,I){m[" "+F]||(C.test(F)?m[" "+F]=F+"/":m[" "+F]=R(F,"/",!0)),F=m[" "+F];var O=F.indexOf(":")===-1;return I.substring(0,2)==="//"?O?I:F.replace(N,"$1")+I:I.charAt(0)==="/"?O?I:F.replace(L,"$1")+I:F+I}var v={exec:function(){}};function b(F){for(var I=1,O,S;I<arguments.length;I++){O=arguments[I];for(S in O)Object.prototype.hasOwnProperty.call(O,S)&&(F[S]=O[S])}return F}function y(F,I){var O=F.replace(/\|/g,function(H,z,_){for(var Y=!1,ne=z;--ne>=0&&_[ne]==="\\";)Y=!Y;return Y?"|":" |"}),S=O.split(/ \|/),B=0;if(S[0].trim()||S.shift(),S.length>0&&!S[S.length-1].trim()&&S.pop(),S.length>I)S.splice(I);else for(;S.length<I;)S.push("");for(;B<S.length;B++)S[B]=S[B].trim().replace(/\\\|/g,"|");return S}function R(F,I,O){var S=F.length;if(S===0)return"";for(var B=0;B<S;){var H=F.charAt(S-B-1);if(H===I&&!O)B++;else if(H!==I&&O)B++;else break}return F.slice(0,S-B)}function V(F,I){if(F.indexOf(I[1])===-1)return-1;for(var O=F.length,S=0,B=0;B<O;B++)if(F[B]==="\\")B++;else if(F[B]===I[0])S++;else if(F[B]===I[1]&&(S--,S<0))return B;return-1}function ee(F){F&&F.sanitize&&!F.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Z(F,I){if(I<1)return"";for(var O="";I>1;)I&1&&(O+=F),I>>=1,F+=F;return O+F}function J(F,I,O,S){var B=I.href,H=I.title?e(I.title):null,z=F[1].replace(/\\([\[\]])/g,"$1");if(F[0].charAt(0)!=="!"){S.state.inLink=!0;var _={type:"link",raw:O,href:B,title:H,text:z,tokens:S.inlineTokens(z)};return S.state.inLink=!1,_}return{type:"image",raw:O,href:B,title:H,text:e(z)}}function re(F,I){var O=F.match(/^(\s+)(?:```)/);if(O===null)return I;var S=O[1];return I.split(`
`).map(function(B){var H=B.match(/^\s+/);if(H===null)return B;var z=H[0];return z.length>=S.length?B.slice(S.length):B}).join(`
`)}var he=function(){function F(O){this.options=O||Q.defaults}var I=F.prototype;return I.space=function(S){var B=this.rules.block.newline.exec(S);if(B&&B[0].length>0)return{type:"space",raw:B[0]}},I.code=function(S){var B=this.rules.block.code.exec(S);if(B){var H=B[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:B[0],codeBlockStyle:"indented",text:this.options.pedantic?H:R(H,`
`)}}},I.fences=function(S){var B=this.rules.block.fences.exec(S);if(B){var H=B[0],z=re(H,B[3]||"");return{type:"code",raw:H,lang:B[2]?B[2].trim():B[2],text:z}}},I.heading=function(S){var B=this.rules.block.heading.exec(S);if(B){var H=B[2].trim();if(/#$/.test(H)){var z=R(H,"#");(this.options.pedantic||!z||/ $/.test(z))&&(H=z.trim())}return{type:"heading",raw:B[0],depth:B[1].length,text:H,tokens:this.lexer.inline(H)}}},I.hr=function(S){var B=this.rules.block.hr.exec(S);if(B)return{type:"hr",raw:B[0]}},I.blockquote=function(S){var B=this.rules.block.blockquote.exec(S);if(B){var H=B[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:B[0],tokens:this.lexer.blockTokens(H,[]),text:H}}},I.list=function(S){var B=this.rules.block.list.exec(S);if(B){var H,z,_,Y,ne,ue,we,De,Le,Ae,ve,Me,Ie=B[1].trim(),$e=Ie.length>1,ze={type:"list",raw:"",ordered:$e,start:$e?+Ie.slice(0,-1):"",loose:!1,items:[]};Ie=$e?"\\d{1,9}\\"+Ie.slice(-1):"\\"+Ie,this.options.pedantic&&(Ie=$e?Ie:"[*+-]");for(var We=new RegExp("^( {0,3}"+Ie+")((?:[	 ][^\\n]*)?(?:\\n|$))");S&&(Me=!1,!(!(B=We.exec(S))||this.rules.block.hr.test(S)));){if(H=B[0],S=S.substring(H.length),De=B[2].split(`
`,1)[0],Le=S.split(`
`,1)[0],this.options.pedantic?(Y=2,ve=De.trimLeft()):(Y=B[2].search(/[^ ]/),Y=Y>4?1:Y,ve=De.slice(Y),Y+=B[1].length),ue=!1,!De&&/^ *$/.test(Le)&&(H+=Le+`
`,S=S.substring(Le.length+1),Me=!0),!Me)for(var Je=new RegExp("^ {0,"+Math.min(3,Y-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Y-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Be=new RegExp("^ {0,"+Math.min(3,Y-1)+"}(?:```|~~~)"),je=new RegExp("^ {0,"+Math.min(3,Y-1)+"}#");S&&(Ae=S.split(`
`,1)[0],De=Ae,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Be.test(De)||je.test(De)||Je.test(De)||it.test(S)));){if(De.search(/[^ ]/)>=Y||!De.trim())ve+=`
`+De.slice(Y);else if(!ue)ve+=`
`+De;else break;!ue&&!De.trim()&&(ue=!0),H+=Ae+`
`,S=S.substring(Ae.length+1)}ze.loose||(we?ze.loose=!0:/\n *\n *$/.test(H)&&(we=!0)),this.options.gfm&&(z=/^\[[ xX]\] /.exec(ve),z&&(_=z[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:H,task:!!z,checked:_,loose:!1,text:ve}),ze.raw+=H}ze.items[ze.items.length-1].raw=H.trimRight(),ze.items[ze.items.length-1].text=ve.trimRight(),ze.raw=ze.raw.trimRight();var Ge=ze.items.length;for(ne=0;ne<Ge;ne++){this.lexer.state.top=!1,ze.items[ne].tokens=this.lexer.blockTokens(ze.items[ne].text,[]);var q=ze.items[ne].tokens.filter(function(be){return be.type==="space"}),le=q.every(function(be){for(var ye=be.raw.split(""),Ce=0,Re=i(ye),xe;!(xe=Re()).done;){var tt=xe.value;if(tt===`
`&&(Ce+=1),Ce>1)return!0}return!1});!ze.loose&&q.length&&le&&(ze.loose=!0,ze.items[ne].loose=!0)}return ze}},I.html=function(S){var B=this.rules.block.html.exec(S);if(B){var H={type:"html",raw:B[0],pre:!this.options.sanitizer&&(B[1]==="pre"||B[1]==="script"||B[1]==="style"),text:B[0]};if(this.options.sanitize){var z=this.options.sanitizer?this.options.sanitizer(B[0]):e(B[0]);H.type="paragraph",H.text=z,H.tokens=this.lexer.inline(z)}return H}},I.def=function(S){var B=this.rules.block.def.exec(S);if(B){B[3]&&(B[3]=B[3].substring(1,B[3].length-1));var H=B[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:H,raw:B[0],href:B[2],title:B[3]}}},I.table=function(S){var B=this.rules.block.table.exec(S);if(B){var H={type:"table",header:y(B[1]).map(function(we){return{text:we}}),align:B[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:B[3]&&B[3].trim()?B[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=B[0];var z=H.align.length,_,Y,ne,ue;for(_=0;_<z;_++)/^ *-+: *$/.test(H.align[_])?H.align[_]="right":/^ *:-+: *$/.test(H.align[_])?H.align[_]="center":/^ *:-+ *$/.test(H.align[_])?H.align[_]="left":H.align[_]=null;for(z=H.rows.length,_=0;_<z;_++)H.rows[_]=y(H.rows[_],H.header.length).map(function(we){return{text:we}});for(z=H.header.length,Y=0;Y<z;Y++)H.header[Y].tokens=this.lexer.inline(H.header[Y].text);for(z=H.rows.length,Y=0;Y<z;Y++)for(ue=H.rows[Y],ne=0;ne<ue.length;ne++)ue[ne].tokens=this.lexer.inline(ue[ne].text);return H}}},I.lheading=function(S){var B=this.rules.block.lheading.exec(S);if(B)return{type:"heading",raw:B[0],depth:B[2].charAt(0)==="="?1:2,text:B[1],tokens:this.lexer.inline(B[1])}},I.paragraph=function(S){var B=this.rules.block.paragraph.exec(S);if(B){var H=B[1].charAt(B[1].length-1)===`
`?B[1].slice(0,-1):B[1];return{type:"paragraph",raw:B[0],text:H,tokens:this.lexer.inline(H)}}},I.text=function(S){var B=this.rules.block.text.exec(S);if(B)return{type:"text",raw:B[0],text:B[0],tokens:this.lexer.inline(B[0])}},I.escape=function(S){var B=this.rules.inline.escape.exec(S);if(B)return{type:"escape",raw:B[0],text:e(B[1])}},I.tag=function(S){var B=this.rules.inline.tag.exec(S);if(B)return!this.lexer.state.inLink&&/^<a /i.test(B[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(B[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(B[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(B[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:B[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):e(B[0]):B[0]}},I.link=function(S){var B=this.rules.inline.link.exec(S);if(B){var H=B[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var z=R(H.slice(0,-1),"\\");if((H.length-z.length)%2===0)return}else{var _=V(B[2],"()");if(_>-1){var Y=B[0].indexOf("!")===0?5:4,ne=Y+B[1].length+_;B[2]=B[2].substring(0,_),B[0]=B[0].substring(0,ne).trim(),B[3]=""}}var ue=B[2],we="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ue);De&&(ue=De[1],we=De[3])}else we=B[3]?B[3].slice(1,-1):"";return ue=ue.trim(),/^</.test(ue)&&(this.options.pedantic&&!/>$/.test(H)?ue=ue.slice(1):ue=ue.slice(1,-1)),J(B,{href:ue&&ue.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},B[0],this.lexer)}},I.reflink=function(S,B){var H;if((H=this.rules.inline.reflink.exec(S))||(H=this.rules.inline.nolink.exec(S))){var z=(H[2]||H[1]).replace(/\s+/g," ");if(z=B[z.toLowerCase()],!z||!z.href){var _=H[0].charAt(0);return{type:"text",raw:_,text:_}}return J(H,z,H[0],this.lexer)}},I.emStrong=function(S,B,H){H===void 0&&(H="");var z=this.rules.inline.emStrong.lDelim.exec(S);if(!!z&&!(z[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var _=z[1]||z[2]||"";if(!_||_&&(H===""||this.rules.inline.punctuation.exec(H))){var Y=z[0].length-1,ne,ue,we=Y,De=0,Le=z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Le.lastIndex=0,B=B.slice(-1*S.length+Y);(z=Le.exec(B))!=null;)if(ne=z[1]||z[2]||z[3]||z[4]||z[5]||z[6],!!ne){if(ue=ne.length,z[3]||z[4]){we+=ue;continue}else if((z[5]||z[6])&&Y%3&&!((Y+ue)%3)){De+=ue;continue}if(we-=ue,!(we>0)){if(ue=Math.min(ue,ue+we+De),Math.min(Y,ue)%2){var Ae=S.slice(1,Y+z.index+ue);return{type:"em",raw:S.slice(0,Y+z.index+ue+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var ve=S.slice(2,Y+z.index+ue-1);return{type:"strong",raw:S.slice(0,Y+z.index+ue+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},I.codespan=function(S){var B=this.rules.inline.code.exec(S);if(B){var H=B[2].replace(/\n/g," "),z=/[^ ]/.test(H),_=/^ /.test(H)&&/ $/.test(H);return z&&_&&(H=H.substring(1,H.length-1)),H=e(H,!0),{type:"codespan",raw:B[0],text:H}}},I.br=function(S){var B=this.rules.inline.br.exec(S);if(B)return{type:"br",raw:B[0]}},I.del=function(S){var B=this.rules.inline.del.exec(S);if(B)return{type:"del",raw:B[0],text:B[2],tokens:this.lexer.inlineTokens(B[2])}},I.autolink=function(S,B){var H=this.rules.inline.autolink.exec(S);if(H){var z,_;return H[2]==="@"?(z=e(this.options.mangle?B(H[1]):H[1]),_="mailto:"+z):(z=e(H[1]),_=z),{type:"link",raw:H[0],text:z,href:_,tokens:[{type:"text",raw:z,text:z}]}}},I.url=function(S,B){var H;if(H=this.rules.inline.url.exec(S)){var z,_;if(H[2]==="@")z=e(this.options.mangle?B(H[0]):H[0]),_="mailto:"+z;else{var Y;do Y=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Y!==H[0]);z=e(H[0]),H[1]==="www."?_="http://"+z:_=z}return{type:"link",raw:H[0],text:z,href:_,tokens:[{type:"text",raw:z,text:z}]}}},I.inlineText=function(S,B){var H=this.rules.inline.text.exec(S);if(H){var z;return this.lexer.state.inRawBlock?z=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):e(H[0]):H[0]:z=e(this.options.smartypants?B(H[0]):H[0]),{type:"text",raw:H[0],text:z}}},F}(),de={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};de._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,de._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,de.def=h(de.def).replace("label",de._label).replace("title",de._title).getRegex(),de.bullet=/(?:[*+-]|\d{1,9}[.)])/,de.listItemStart=h(/^( *)(bull) */).replace("bull",de.bullet).getRegex(),de.list=h(de.list).replace(/bull/g,de.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+de.def.source+")").getRegex(),de._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",de._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,de.html=h(de.html,"i").replace("comment",de._comment).replace("tag",de._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),de.paragraph=h(de._paragraph).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.blockquote=h(de.blockquote).replace("paragraph",de.paragraph).getRegex(),de.normal=b({},de),de.gfm=b({},de.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),de.gfm.table=h(de.gfm.table).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.gfm.paragraph=h(de._paragraph).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",de.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.pedantic=b({},de.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",de._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:h(de.normal._paragraph).replace("hr",de.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",de.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ce={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ce._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ce.punctuation=h(ce.punctuation).replace(/punctuation/g,ce._punctuation).getRegex(),ce.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ce.escapedEmSt=/\\\*|\\_/g,ce._comment=h(de._comment).replace("(?:-->|$)","-->").getRegex(),ce.emStrong.lDelim=h(ce.emStrong.lDelim).replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimAst=h(ce.emStrong.rDelimAst,"g").replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimUnd=h(ce.emStrong.rDelimUnd,"g").replace(/punct/g,ce._punctuation).getRegex(),ce._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ce._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ce._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ce.autolink=h(ce.autolink).replace("scheme",ce._scheme).replace("email",ce._email).getRegex(),ce._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ce.tag=h(ce.tag).replace("comment",ce._comment).replace("attribute",ce._attribute).getRegex(),ce._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ce._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ce._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ce.link=h(ce.link).replace("label",ce._label).replace("href",ce._href).replace("title",ce._title).getRegex(),ce.reflink=h(ce.reflink).replace("label",ce._label).replace("ref",de._label).getRegex(),ce.nolink=h(ce.nolink).replace("ref",de._label).getRegex(),ce.reflinkSearch=h(ce.reflinkSearch,"g").replace("reflink",ce.reflink).replace("nolink",ce.nolink).getRegex(),ce.normal=b({},ce),ce.pedantic=b({},ce.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",ce._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ce._label).getRegex()}),ce.gfm=b({},ce.normal,{escape:h(ce.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ce.gfm.url=h(ce.gfm.url,"i").replace("email",ce.gfm._extended_email).getRegex(),ce.breaks=b({},ce.gfm,{br:h(ce.br).replace("{2,}","*").getRegex(),text:h(ce.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function pe(F){return F.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Te(F){var I="",O,S,B=F.length;for(O=0;O<B;O++)S=F.charCodeAt(O),Math.random()>.5&&(S="x"+S.toString(16)),I+="&#"+S+";";return I}var Pe=function(){function F(O){this.tokens=[],this.tokens.links=Object.create(null),this.options=O||Q.defaults,this.options.tokenizer=this.options.tokenizer||new he,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var S={block:de.normal,inline:ce.normal};this.options.pedantic?(S.block=de.pedantic,S.inline=ce.pedantic):this.options.gfm&&(S.block=de.gfm,this.options.breaks?S.inline=ce.breaks:S.inline=ce.gfm),this.tokenizer.rules=S}F.lex=function(S,B){var H=new F(B);return H.lex(S)},F.lexInline=function(S,B){var H=new F(B);return H.inlineTokens(S)};var I=F.prototype;return I.lex=function(S){S=S.replace(/\r\n|\r/g,`
`),this.blockTokens(S,this.tokens);for(var B;B=this.inlineQueue.shift();)this.inlineTokens(B.src,B.tokens);return this.tokens},I.blockTokens=function(S,B){var H=this;B===void 0&&(B=[]),this.options.pedantic?S=S.replace(/\t/g,"    ").replace(/^ +$/gm,""):S=S.replace(/^( *)(\t+)/gm,function(we,De,Le){return De+"    ".repeat(Le.length)});for(var z,_,Y,ne;S;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(z=we.call({lexer:H},S,B))?(S=S.substring(z.raw.length),B.push(z),!0):!1}))){if(z=this.tokenizer.space(S)){S=S.substring(z.raw.length),z.raw.length===1&&B.length>0?B[B.length-1].raw+=`
`:B.push(z);continue}if(z=this.tokenizer.code(S)){S=S.substring(z.raw.length),_=B[B.length-1],_&&(_.type==="paragraph"||_.type==="text")?(_.raw+=`
`+z.raw,_.text+=`
`+z.text,this.inlineQueue[this.inlineQueue.length-1].src=_.text):B.push(z);continue}if(z=this.tokenizer.fences(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.heading(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.hr(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.blockquote(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.list(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.html(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.def(S)){S=S.substring(z.raw.length),_=B[B.length-1],_&&(_.type==="paragraph"||_.type==="text")?(_.raw+=`
`+z.raw,_.text+=`
`+z.raw,this.inlineQueue[this.inlineQueue.length-1].src=_.text):this.tokens.links[z.tag]||(this.tokens.links[z.tag]={href:z.href,title:z.title});continue}if(z=this.tokenizer.table(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.lheading(S)){S=S.substring(z.raw.length),B.push(z);continue}if(Y=S,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,De=S.slice(1),Le=void 0;H.options.extensions.startBlock.forEach(function(Ae){Le=Ae.call({lexer:this},De),typeof Le=="number"&&Le>=0&&(we=Math.min(we,Le))}),we<1/0&&we>=0&&(Y=S.substring(0,we+1))}(),this.state.top&&(z=this.tokenizer.paragraph(Y))){_=B[B.length-1],ne&&_.type==="paragraph"?(_.raw+=`
`+z.raw,_.text+=`
`+z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=_.text):B.push(z),ne=Y.length!==S.length,S=S.substring(z.raw.length);continue}if(z=this.tokenizer.text(S)){S=S.substring(z.raw.length),_=B[B.length-1],_&&_.type==="text"?(_.raw+=`
`+z.raw,_.text+=`
`+z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=_.text):B.push(z);continue}if(S){var ue="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return this.state.top=!0,B},I.inline=function(S,B){return B===void 0&&(B=[]),this.inlineQueue.push({src:S,tokens:B}),B},I.inlineTokens=function(S,B){var H=this;B===void 0&&(B=[]);var z,_,Y,ne=S,ue,we,De;if(this.tokens.links){var Le=Object.keys(this.tokens.links);if(Le.length>0)for(;(ue=this.tokenizer.rules.inline.reflinkSearch.exec(ne))!=null;)Le.includes(ue[0].slice(ue[0].lastIndexOf("[")+1,-1))&&(ne=ne.slice(0,ue.index)+"["+Z("a",ue[0].length-2)+"]"+ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ue=this.tokenizer.rules.inline.blockSkip.exec(ne))!=null;)ne=ne.slice(0,ue.index)+"["+Z("a",ue[0].length-2)+"]"+ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ue=this.tokenizer.rules.inline.escapedEmSt.exec(ne))!=null;)ne=ne.slice(0,ue.index)+"++"+ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;S;)if(we||(De=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(z=ve.call({lexer:H},S,B))?(S=S.substring(z.raw.length),B.push(z),!0):!1}))){if(z=this.tokenizer.escape(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.tag(S)){S=S.substring(z.raw.length),_=B[B.length-1],_&&z.type==="text"&&_.type==="text"?(_.raw+=z.raw,_.text+=z.text):B.push(z);continue}if(z=this.tokenizer.link(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.reflink(S,this.tokens.links)){S=S.substring(z.raw.length),_=B[B.length-1],_&&z.type==="text"&&_.type==="text"?(_.raw+=z.raw,_.text+=z.text):B.push(z);continue}if(z=this.tokenizer.emStrong(S,ne,De)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.codespan(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.br(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.del(S)){S=S.substring(z.raw.length),B.push(z);continue}if(z=this.tokenizer.autolink(S,Te)){S=S.substring(z.raw.length),B.push(z);continue}if(!this.state.inLink&&(z=this.tokenizer.url(S,Te))){S=S.substring(z.raw.length),B.push(z);continue}if(Y=S,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Me=S.slice(1),Ie=void 0;H.options.extensions.startInline.forEach(function($e){Ie=$e.call({lexer:this},Me),typeof Ie=="number"&&Ie>=0&&(ve=Math.min(ve,Ie))}),ve<1/0&&ve>=0&&(Y=S.substring(0,ve+1))}(),z=this.tokenizer.inlineText(Y,pe)){S=S.substring(z.raw.length),z.raw.slice(-1)!=="_"&&(De=z.raw.slice(-1)),we=!0,_=B[B.length-1],_&&_.type==="text"?(_.raw+=z.raw,_.text+=z.text):B.push(z);continue}if(S){var Ae="Infinite loop on byte: "+S.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return B},E(F,null,[{key:"rules",get:function(){return{block:de,inline:ce}}}]),F}(),Oe=function(){function F(O){this.options=O||Q.defaults}var I=F.prototype;return I.code=function(S,B,H){var z=(B||"").match(/\S*/)[0];if(this.options.highlight){var _=this.options.highlight(S,z);_!=null&&_!==S&&(H=!0,S=_)}return S=S.replace(/\n$/,"")+`
`,z?'<pre><code class="'+this.options.langPrefix+e(z,!0)+'">'+(H?S:e(S,!0))+`</code></pre>
`:"<pre><code>"+(H?S:e(S,!0))+`</code></pre>
`},I.blockquote=function(S){return`<blockquote>
`+S+`</blockquote>
`},I.html=function(S){return S},I.heading=function(S,B,H,z){if(this.options.headerIds){var _=this.options.headerPrefix+z.slug(H);return"<h"+B+' id="'+_+'">'+S+"</h"+B+`>
`}return"<h"+B+">"+S+"</h"+B+`>
`},I.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},I.list=function(S,B,H){var z=B?"ol":"ul",_=B&&H!==1?' start="'+H+'"':"";return"<"+z+_+`>
`+S+"</"+z+`>
`},I.listitem=function(S){return"<li>"+S+`</li>
`},I.checkbox=function(S){return"<input "+(S?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},I.paragraph=function(S){return"<p>"+S+`</p>
`},I.table=function(S,B){return B&&(B="<tbody>"+B+"</tbody>"),`<table>
<thead>
`+S+`</thead>
`+B+`</table>
`},I.tablerow=function(S){return`<tr>
`+S+`</tr>
`},I.tablecell=function(S,B){var H=B.header?"th":"td",z=B.align?"<"+H+' align="'+B.align+'">':"<"+H+">";return z+S+("</"+H+`>
`)},I.strong=function(S){return"<strong>"+S+"</strong>"},I.em=function(S){return"<em>"+S+"</em>"},I.codespan=function(S){return"<code>"+S+"</code>"},I.br=function(){return this.options.xhtml?"<br/>":"<br>"},I.del=function(S){return"<del>"+S+"</del>"},I.link=function(S,B,H){if(S=A(this.options.sanitize,this.options.baseUrl,S),S===null)return H;var z='<a href="'+e(S)+'"';return B&&(z+=' title="'+B+'"'),z+=">"+H+"</a>",z},I.image=function(S,B,H){if(S=A(this.options.sanitize,this.options.baseUrl,S),S===null)return H;var z='<img src="'+S+'" alt="'+H+'"';return B&&(z+=' title="'+B+'"'),z+=this.options.xhtml?"/>":">",z},I.text=function(S){return S},F}(),x=function(){function F(){}var I=F.prototype;return I.strong=function(S){return S},I.em=function(S){return S},I.codespan=function(S){return S},I.del=function(S){return S},I.html=function(S){return S},I.text=function(S){return S},I.link=function(S,B,H){return""+H},I.image=function(S,B,H){return""+H},I.br=function(){return""},F}(),G=function(){function F(){this.seen={}}var I=F.prototype;return I.serialize=function(S){return S.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},I.getNextSafeSlug=function(S,B){var H=S,z=0;if(this.seen.hasOwnProperty(H)){z=this.seen[S];do z++,H=S+"-"+z;while(this.seen.hasOwnProperty(H))}return B||(this.seen[S]=z,this.seen[H]=0),H},I.slug=function(S,B){B===void 0&&(B={});var H=this.serialize(S);return this.getNextSafeSlug(H,B.dryrun)},F}(),ie=function(){function F(O){this.options=O||Q.defaults,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new G}F.parse=function(S,B){var H=new F(B);return H.parse(S)},F.parseInline=function(S,B){var H=new F(B);return H.parseInline(S)};var I=F.prototype;return I.parse=function(S,B){B===void 0&&(B=!0);var H="",z,_,Y,ne,ue,we,De,Le,Ae,ve,Me,Ie,$e,ze,We,Je,it,Be,je,Ge=S.length;for(z=0;z<Ge;z++){if(ve=S[z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(je=this.options.extensions.renderers[ve.type].call({parser:this},ve),je!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){H+=je||"";continue}switch(ve.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,r(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Le="",De="",ne=ve.header.length,_=0;_<ne;_++)De+=this.renderer.tablecell(this.parseInline(ve.header[_].tokens),{header:!0,align:ve.align[_]});for(Le+=this.renderer.tablerow(De),Ae="",ne=ve.rows.length,_=0;_<ne;_++){for(we=ve.rows[_],De="",ue=we.length,Y=0;Y<ue;Y++)De+=this.renderer.tablecell(this.parseInline(we[Y].tokens),{header:!1,align:ve.align[Y]});Ae+=this.renderer.tablerow(De)}H+=this.renderer.table(Le,Ae);continue}case"blockquote":{Ae=this.parse(ve.tokens),H+=this.renderer.blockquote(Ae);continue}case"list":{for(Me=ve.ordered,Ie=ve.start,$e=ve.loose,ne=ve.items.length,Ae="",_=0;_<ne;_++)We=ve.items[_],Je=We.checked,it=We.task,ze="",We.task&&(Be=this.renderer.checkbox(Je),$e?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Be+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Be+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Be}):ze+=Be),ze+=this.parse(We.tokens,$e),Ae+=this.renderer.listitem(ze,it,Je);H+=this.renderer.list(Ae,Me,Ie);continue}case"html":{H+=this.renderer.html(ve.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ae=ve.tokens?this.parseInline(ve.tokens):ve.text;z+1<Ge&&S[z+1].type==="text";)ve=S[++z],Ae+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);H+=B?this.renderer.paragraph(Ae):Ae;continue}default:{var q='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return H},I.parseInline=function(S,B){B=B||this.renderer;var H="",z,_,Y,ne=S.length;for(z=0;z<ne;z++){if(_=S[z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(Y=this.options.extensions.renderers[_.type].call({parser:this},_),Y!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(_.type))){H+=Y||"";continue}switch(_.type){case"escape":{H+=B.text(_.text);break}case"html":{H+=B.html(_.text);break}case"link":{H+=B.link(_.href,_.title,this.parseInline(_.tokens,B));break}case"image":{H+=B.image(_.href,_.title,_.text);break}case"strong":{H+=B.strong(this.parseInline(_.tokens,B));break}case"em":{H+=B.em(this.parseInline(_.tokens,B));break}case"codespan":{H+=B.codespan(_.text);break}case"br":{H+=B.br();break}case"del":{H+=B.del(this.parseInline(_.tokens,B));break}case"text":{H+=B.text(_.text);break}default:{var ue='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(ue);return}else throw new Error(ue)}}}return H},F}();function se(F,I,O){if(typeof F>"u"||F===null)throw new Error("marked(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");if(typeof I=="function"&&(O=I,I=null),I=b({},se.defaults,I||{}),ee(I),O){var S=I.highlight,B;try{B=Pe.lex(F,I)}catch(ne){return O(ne)}var H=function(ue){var we;if(!ue)try{I.walkTokens&&se.walkTokens(B,I.walkTokens),we=ie.parse(B,I)}catch(De){ue=De}return I.highlight=S,ue?O(ue):O(null,we)};if(!S||S.length<3||(delete I.highlight,!B.length))return H();var z=0;se.walkTokens(B,function(ne){ne.type==="code"&&(z++,setTimeout(function(){S(ne.text,ne.lang,function(ue,we){if(ue)return H(ue);we!=null&&we!==ne.text&&(ne.text=we,ne.escaped=!0),z--,z===0&&H()})},0))}),z===0&&H();return}function _(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,I.silent)return"<p>An error occurred:</p><pre>"+e(ne.message+"",!0)+"</pre>";throw ne}try{var Y=Pe.lex(F,I);if(I.walkTokens){if(I.async)return Promise.all(se.walkTokens(Y,I.walkTokens)).then(function(){return ie.parse(Y,I)}).catch(_);se.walkTokens(Y,I.walkTokens)}return ie.parse(Y,I)}catch(ne){_(ne)}}se.options=se.setOptions=function(F){return b(se.defaults,F),w(se.defaults),se},se.getDefaults=D,se.defaults=Q.defaults,se.use=function(){for(var F=arguments.length,I=new Array(F),O=0;O<F;O++)I[O]=arguments[O];var S=b.apply(void 0,[{}].concat(I)),B=se.defaults.extensions||{renderers:{},childTokens:{}},H;I.forEach(function(z){if(z.extensions&&(H=!0,z.extensions.forEach(function(Y){if(!Y.name)throw new Error("extension name required");if(Y.renderer){var ne=B.renderers?B.renderers[Y.name]:null;ne?B.renderers[Y.name]=function(){for(var ue=arguments.length,we=new Array(ue),De=0;De<ue;De++)we[De]=arguments[De];var Le=Y.renderer.apply(this,we);return Le===!1&&(Le=ne.apply(this,we)),Le}:B.renderers[Y.name]=Y.renderer}if(Y.tokenizer){if(!Y.level||Y.level!=="block"&&Y.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");B[Y.level]?B[Y.level].unshift(Y.tokenizer):B[Y.level]=[Y.tokenizer],Y.start&&(Y.level==="block"?B.startBlock?B.startBlock.push(Y.start):B.startBlock=[Y.start]:Y.level==="inline"&&(B.startInline?B.startInline.push(Y.start):B.startInline=[Y.start]))}Y.childTokens&&(B.childTokens[Y.name]=Y.childTokens)})),z.renderer&&function(){var Y=se.defaults.renderer||new Oe,ne=function(De){var Le=Y[De];Y[De]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Me=0;Me<Ae;Me++)ve[Me]=arguments[Me];var Ie=z.renderer[De].apply(Y,ve);return Ie===!1&&(Ie=Le.apply(Y,ve)),Ie}};for(var ue in z.renderer)ne(ue);S.renderer=Y}(),z.tokenizer&&function(){var Y=se.defaults.tokenizer||new he,ne=function(De){var Le=Y[De];Y[De]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Me=0;Me<Ae;Me++)ve[Me]=arguments[Me];var Ie=z.tokenizer[De].apply(Y,ve);return Ie===!1&&(Ie=Le.apply(Y,ve)),Ie}};for(var ue in z.tokenizer)ne(ue);S.tokenizer=Y}(),z.walkTokens){var _=se.defaults.walkTokens;S.walkTokens=function(Y){var ne=[];return ne.push(z.walkTokens.call(this,Y)),_&&(ne=ne.concat(_.call(this,Y))),ne}}H&&(S.extensions=B),se.setOptions(S)})},se.walkTokens=function(F,I){for(var O=[],S=function(){var _=H.value;switch(O=O.concat(I.call(se,_)),_.type){case"table":{for(var Y=i(_.header),ne;!(ne=Y()).done;){var ue=ne.value;O=O.concat(se.walkTokens(ue.tokens,I))}for(var we=i(_.rows),De;!(De=we()).done;)for(var Le=De.value,Ae=i(Le),ve;!(ve=Ae()).done;){var Me=ve.value;O=O.concat(se.walkTokens(Me.tokens,I))}break}case"list":{O=O.concat(se.walkTokens(_.items,I));break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[_.type]?se.defaults.extensions.childTokens[_.type].forEach(function(Ie){O=O.concat(se.walkTokens(_[Ie],I))}):_.tokens&&(O=O.concat(se.walkTokens(_.tokens,I)))}},B=i(F),H;!(H=B()).done;)S();return O},se.parseInline=function(F,I){if(typeof F>"u"||F===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");I=b({},se.defaults,I||{}),ee(I);try{var O=Pe.lexInline(F,I);return I.walkTokens&&se.walkTokens(O,I.walkTokens),ie.parseInline(O,I)}catch(S){if(S.message+=`
Please report this to https://github.com/markedjs/marked.`,I.silent)return"<p>An error occurred:</p><pre>"+e(S.message+"",!0)+"</pre>";throw S}},se.Parser=ie,se.parser=ie.parse,se.Renderer=Oe,se.TextRenderer=x,se.Lexer=Pe,se.lexer=Pe.lex,se.Tokenizer=he,se.Slugger=G,se.parse=se;var ae=se.options,te=se.setOptions,$=se.use,g=se.walkTokens,l=se.parseInline,k=se,W=ie.parse,j=Pe.lex;Q.Lexer=Pe,Q.Parser=ie,Q.Renderer=Oe,Q.Slugger=G,Q.TextRenderer=x,Q.Tokenizer=he,Q.getDefaults=D,Q.lexer=j,Q.marked=se,Q.options=ae,Q.parse=k,Q.parseInline=l,Q.parser=W,Q.setOptions=te,Q.use=$,Q.walkTokens=g,Object.defineProperty(Q,"__esModule",{value:!0})}),define(ge[77],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class E{constructor(U,i=0,D=U.length,w=i-1){this.a=U,this.b=i,this.c=D,this.d=w}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=E}),define(ge[78],me([1,0,77]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class P{constructor(D=[],w=10){this.h(D),this.b=w,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.g()!==this.j.length-1?this.c.next():null}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()===this.j.length-1}isNowhere(){return this.c.current()===null}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new E.ArrayNavigator(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const w of D)this.a.add(w)}get j(){const D=[];return this.a.forEach(w=>D.push(w)),D}}t.HistoryNavigator=P;class U{constructor(D,w=10){if(this.f=w,D.length<1)throw new Error("not supported");this.d=1,this.a=this.b=this.c={value:D[0],previous:void 0,next:void 0};for(let f=1;f<D.length;f++)this.add(D[f])}add(D){const w={value:D,previous:this.b,next:void 0};for(this.b.next=w,this.b=w,this.c=this.b,this.d++;this.d>this.f;)this.a=this.a.next,this.a.previous=void 0,this.d--}replaceLast(D){const w=this.b.value;return this.b.value=D,w}isAtEnd(){return this.c===this.b}current(){return this.c.value}previous(){return this.c.previous&&(this.c=this.c.previous),this.c.value}next(){return this.c.next&&(this.c=this.c.next),this.c.value}has(D){let w=this.a;for(;w;){if(w.value===D)return!0;w=w.next}return!1}resetCursor(){return this.c=this.b,this.c.value}*[Symbol.iterator](){let D=this.a;for(;D;)yield D.value,D=D.next}}t.HistoryNavigator2=U}),define(ge[46],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function E(w,f,u){return Math.min(Math.max(w,f),u)}t.clamp=E;function P(w,f){return(f+w%f)%f}t.rot=P;class U{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=U;class i{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=i;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const u=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=D}),define(ge[47],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(P){function U(f,u){if(f.start>=u.end||u.start>=f.end)return{start:0,end:0};const c=Math.max(f.start,u.start),M=Math.min(f.end,u.end);return M-c<=0?{start:0,end:0}:{start:c,end:M}}P.intersect=U;function i(f){return f.end-f.start<=0}P.isEmpty=i;function D(f,u){return!i(U(f,u))}P.intersects=D;function w(f,u){const c=[],M={start:f.start,end:Math.min(u.start,f.end)},o={start:Math.max(u.end,f.start),end:f.end};return i(M)||c.push(M),i(o)||c.push(o),c}P.relativeComplement=w})(E=t.Range||(t.Range={}))}),define(ge[79],me([1,0,47]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function P(f,u){const c=[];for(const M of u){if(f.start>=M.range.end)continue;if(f.end<M.range.start)break;const o=E.Range.intersect(f,M.range);E.Range.isEmpty(o)||c.push({range:o,size:M.size})}return c}t.groupIntersect=P;function U({start:f,end:u},c){return{start:f+c,end:u+c}}t.shift=U;function i(f){const u=[];let c=null;for(const M of f){const o=M.range.start,n=M.range.end,e=M.size;if(c&&e===c.size){c.range.end=n;continue}c={range:{start:o,end:n},size:e},u.push(c)}return u}t.consolidate=i;function D(...f){return i(f.reduce((u,c)=>u.concat(c),[]))}class w{constructor(){this.a=[],this.b=0}splice(u,c,M=[]){const o=M.length-c,n=P({start:0,end:u},this.a),e=P({start:u+c,end:Number.POSITIVE_INFINITY},this.a).map(r=>({range:U(r.range,o),size:r.size})),s=M.map((r,a)=>({range:{start:u+a,end:u+a+1},size:r.size}));this.a=D(n,s,e),this.b=this.a.reduce((r,a)=>r+a.size*(a.range.end-a.range.start),0)}get count(){const u=this.a.length;return u?this.a[u-1].range.end:0}get size(){return this.b}indexAt(u){if(u<0)return-1;let c=0,M=0;for(const o of this.a){const n=o.range.end-o.range.start,e=M+n*o.size;if(u<e)return c+Math.floor((u-M)/o.size);c+=n,M=e}return c}indexAfter(u){return Math.min(this.indexAt(u)+1,this.count)}positionAt(u){if(u<0)return-1;let c=0,M=0;for(const o of this.a){const n=o.range.end-o.range.start,e=M+n;if(u<e)return c+(u-M)*o.size;c+=n*o.size,M=e}return-1}}t.RangeMap=w}),define(ge[80],me([1,0,7,2]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function U(T){const A=T;return A?typeof A.read=="function":!1}t.isReadable=U;function i(T){const A=T;return A?[A.on,A.pause,A.resume,A.destroy].every(m=>typeof m=="function"):!1}t.isReadableStream=i;function D(T){const A=T;return A?i(A.stream)&&Array.isArray(A.buffer)&&typeof A.ended=="boolean":!1}t.isReadableBufferedStream=D;function w(T,A){return new f(T,A)}t.newWriteableStream=w;class f{constructor(A,m){this.e=A,this.f=m,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(A){if(!this.a.destroyed){if(this.a.flowing)this.g(A);else if(this.b.data.push(A),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(m=>this.d.push(m))}}error(A){this.a.destroyed||(this.a.flowing?this.h(A):this.b.error.push(A))}end(A){this.a.destroyed||(typeof A<"u"&&this.write(A),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(A){this.c.data.slice(0).forEach(m=>m(A))}h(A){this.c.error.length===0?(0,E.onUnexpectedError)(A):this.c.error.slice(0).forEach(m=>m(A))}i(){this.c.end.slice(0).forEach(A=>A())}on(A,m){if(!this.a.destroyed)switch(A){case"data":this.c.data.push(m),this.resume();break;case"end":this.c.end.push(m),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(m),this.a.flowing&&this.k();break}}removeListener(A,m){if(this.a.destroyed)return;let C;switch(A){case"data":C=this.c.data;break;case"end":C=this.c.end;break;case"error":C=this.c.error;break}if(C){const N=C.indexOf(m);N>=0&&C.splice(N,1)}}j(){if(this.b.data.length>0){const A=this.e(this.b.data);this.g(A),this.b.data.length=0;const m=[...this.d];this.d.length=0,m.forEach(C=>C())}}k(){if(this.c.error.length>0){for(const A of this.b.error)this.h(A);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(T,A){const m=[];let C;for(;(C=T.read())!==null;)m.push(C);return A(m)}t.consumeReadable=u;function c(T,A,m){const C=[];let N;for(;(N=T.read())!==null&&C.length<m;)C.push(N);return N===null&&C.length>0?A(C):{read:()=>{if(C.length>0)return C.shift();if(typeof N<"u"){const L=N;return N=void 0,L}return T.read()}}}t.peekReadable=c;function M(T,A){return new Promise((m,C)=>{const N=[];o(T,{onData:L=>{A&&N.push(L)},onError:L=>{A?C(L):m(void 0)},onEnd:()=>{m(A?A(N):void 0)}})})}t.consumeStream=M;function o(T,A){let m=!1;return T.on("error",C=>{m||A.onError(C)}),T.on("end",()=>{m||A.onEnd()}),T.on("data",C=>{m||A.onData(C)}),(0,P.toDisposable)(()=>m=!0)}t.listenStream=o;function n(T,A){return new Promise((m,C)=>{const N=new P.DisposableStore,L=[],d=y=>{if(L.push(y),L.length>A)return N.dispose(),T.pause(),m({stream:T,buffer:L,ended:!1})},v=y=>C(y),b=()=>m({stream:T,buffer:L,ended:!0});N.add((0,P.toDisposable)(()=>T.removeListener("error",v))),T.on("error",v),N.add((0,P.toDisposable)(()=>T.removeListener("end",b))),T.on("end",b),N.add((0,P.toDisposable)(()=>T.removeListener("data",d))),T.on("data",d)})}t.peekStream=n;function e(T,A){const m=w(A);return m.end(T),m}t.toStream=e;function s(){const T=w(()=>{throw new Error("not supported")});return T.end(),T}t.emptyStream=s;function r(T){let A=!1;return{read:()=>A?null:(A=!0,T)}}t.toReadable=r;function a(T,A,m){const C=w(m);return o(T,{onData:N=>C.write(A.data(N)),onError:N=>C.error(A.error?A.error(N):N),onEnd:()=>C.end()}),C}t.transform=a;function h(T,A,m){let C=!1;return{read:()=>{const N=A.read();return C?N:(C=!0,N!==null?m([T,N]):T)}}}t.prefixedReadable=h;function p(T,A,m){let C=!1;const N=w(m);return o(A,{onData:L=>C?N.write(L):(C=!0,N.write(m([T,L]))),onError:L=>N.error(L),onEnd:()=>{C||(C=!0,N.write(T)),N.end()}}),N}t.prefixedStream=p}),define(ge[29],me([1,0,80]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const P=typeof Buffer<"u";let U,i;class D{static alloc(y){return P?new D(Buffer.allocUnsafe(y)):new D(new Uint8Array(y))}static wrap(y){return P&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new D(y)}static fromString(y,R){return!(R?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(y)):(U||(U=new TextEncoder),new D(U.encode(y)))}static fromByteArray(y){const R=D.alloc(y.length);for(let V=0,ee=y.length;V<ee;V++)R.buffer[V]=y[V];return R}static concat(y,R){if(typeof R>"u"){R=0;for(let Z=0,J=y.length;Z<J;Z++)R+=y[Z].byteLength}const V=D.alloc(R);let ee=0;for(let Z=0,J=y.length;Z<J;Z++){const re=y[Z];V.set(re,ee),ee+=re.byteLength}return V}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=D.alloc(this.byteLength);return y.set(this),y}toString(){return P?this.buffer.toString():(i||(i=new TextDecoder),i.decode(this.buffer))}slice(y,R){return new D(this.buffer.subarray(y,R))}set(y,R){if(y instanceof D)this.buffer.set(y.buffer,R);else if(y instanceof Uint8Array)this.buffer.set(y,R);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),R);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,R){c(this.buffer,y,R)}readUInt32LE(y){return M(this.buffer,y)}writeUInt32LE(y,R){o(this.buffer,y,R)}readUInt8(y){return n(this.buffer,y)}writeUInt8(y,R){e(this.buffer,y,R)}}t.VSBuffer=D;function w(b,y){return b[y+0]<<0>>>0|b[y+1]<<8>>>0}t.readUInt16LE=w;function f(b,y,R){b[R+0]=y&255,y=y>>>8,b[R+1]=y&255}t.writeUInt16LE=f;function u(b,y){return b[y]*2**24+b[y+1]*2**16+b[y+2]*2**8+b[y+3]}t.readUInt32BE=u;function c(b,y,R){b[R+3]=y,y=y>>>8,b[R+2]=y,y=y>>>8,b[R+1]=y,y=y>>>8,b[R]=y}t.writeUInt32BE=c;function M(b,y){return b[y+0]<<0>>>0|b[y+1]<<8>>>0|b[y+2]<<16>>>0|b[y+3]<<24>>>0}t.readUInt32LE=M;function o(b,y,R){b[R+0]=y&255,y=y>>>8,b[R+1]=y&255,y=y>>>8,b[R+2]=y&255,y=y>>>8,b[R+3]=y&255}t.writeUInt32LE=o;function n(b,y){return b[y]}t.readUInt8=n;function e(b,y,R){b[R]=y}t.writeUInt8=e;function s(b){return E.consumeReadable(b,y=>D.concat(y))}t.readableToBuffer=s;function r(b){return E.toReadable(b)}t.bufferToReadable=r;function a(b){return E.consumeStream(b,y=>D.concat(y))}t.streamToBuffer=a;async function h(b){return b.ended?D.concat(b.buffer):D.concat([...b.buffer,await a(b.stream)])}t.bufferedStreamToBuffer=h;function p(b){return E.toStream(b,y=>D.concat(y))}t.bufferToStream=p;function T(b){return E.transform(b,{data:y=>typeof y=="string"?D.fromString(y):D.wrap(y)},y=>D.concat(y))}t.streamToBufferReadableStream=T;function A(b){return E.newWriteableStream(y=>D.concat(y),b)}t.newWriteableBufferStream=A;function m(b,y){return E.prefixedReadable(b,y,R=>D.concat(R))}t.prefixedBufferReadable=m;function C(b,y){return E.prefixedStream(b,y,R=>D.concat(R))}t.prefixedBufferStream=C;function N(b){let y=0,R=0,V=0;const ee=new Uint8Array(Math.floor(b.length/4*3)),Z=re=>{switch(R){case 3:ee[V++]=y|re,R=0;break;case 2:ee[V++]=y|re>>>2,y=re<<6,R=3;break;case 1:ee[V++]=y|re>>>4,y=re<<4,R=2;break;default:y=re<<2,R=1}};for(let re=0;re<b.length;re++){const he=b.charCodeAt(re);if(he>=65&&he<=90)Z(he-65);else if(he>=97&&he<=122)Z(he-97+26);else if(he>=48&&he<=57)Z(he-48+52);else if(he===43||he===45)Z(62);else if(he===47||he===95)Z(63);else{if(he===61)break;throw new SyntaxError(`Unexpected base64 character ${b[re]}`)}}const J=V;for(;R>0;)Z(0);return D.wrap(ee).slice(0,J)}t.decodeBase64=N;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:b},y=!0,R=!1){const V=R?d:L;let ee="";const Z=b.byteLength%3;let J=0;for(;J<b.byteLength-Z;J+=3){const re=b[J+0],he=b[J+1],de=b[J+2];ee+=V[re>>>2],ee+=V[(re<<4|he>>>4)&63],ee+=V[(he<<2|de>>>6)&63],ee+=V[de&63]}if(Z===1){const re=b[J+0];ee+=V[re>>>2],ee+=V[re<<4&63],y&&(ee+="==")}else if(Z===2){const re=b[J+0],he=b[J+1];ee+=V[re>>>2],ee+=V[(re<<4|he>>>4)&63],ee+=V[he<<2&63],y&&(ee+="=")}return ee}t.encodeBase64=v}),define(ge[6],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function E(C){return typeof C=="string"}t.isString=E;function P(C){return Array.isArray(C)&&C.every(N=>E(N))}t.isStringArray=P;function U(C){return typeof C=="object"&&C!==null&&!Array.isArray(C)&&!(C instanceof RegExp)&&!(C instanceof Date)}t.isObject=U;function i(C){const N=Object.getPrototypeOf(Uint8Array);return typeof C=="object"&&C instanceof N}t.isTypedArray=i;function D(C){return typeof C=="number"&&!isNaN(C)}t.isNumber=D;function w(C){return!!C&&typeof C[Symbol.iterator]=="function"}t.isIterable=w;function f(C){return C===!0||C===!1}t.isBoolean=f;function u(C){return typeof C>"u"}t.isUndefined=u;function c(C){return!M(C)}t.isDefined=c;function M(C){return u(C)||C===null}t.isUndefinedOrNull=M;function o(C,N){if(!C)throw new Error(N?`Unexpected type, expected '${N}'`:"Unexpected type")}t.assertType=o;function n(C){if(M(C))throw new Error("Assertion Failed: argument is undefined or null");return C}t.assertIsDefined=n;function e(...C){const N=[];for(let L=0;L<C.length;L++){const d=C[L];if(M(d))throw new Error(`Assertion Failed: argument at index ${L} is undefined or null`);N.push(d)}return N}t.assertAllDefined=e;const s=Object.prototype.hasOwnProperty;function r(C){if(!U(C))return!1;for(const N in C)if(s.call(C,N))return!1;return!0}t.isEmptyObject=r;function a(C){return typeof C=="function"}t.isFunction=a;function h(...C){return C.length>0&&C.every(a)}t.areFunctions=h;function p(C,N){const L=Math.min(C.length,N.length);for(let d=0;d<L;d++)T(C[d],N[d])}t.validateConstraints=p;function T(C,N){if(E(N)){if(typeof C!==N)throw new Error(`argument does not match constraint: typeof ${N}`)}else if(a(N)){try{if(C instanceof N)return}catch{}if(!M(C)&&C.constructor===N||N.length===1&&N.call(void 0,C)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=T;function A(C){return C===null?void 0:C}t.withNullAsUndefined=A;function m(C){return typeof C>"u"?null:C}t.withUndefinedAsNull=m}),define(ge[16],me([1,0,6]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=t.getCodiconAriaLabel=void 0;function P(f){return f?f.replace(/\$\((.*?)\)/g,(u,c)=>` ${c} `).trim():""}t.getCodiconAriaLabel=P;const U=Object.create(null);function i(f,u){if((0,E.isString)(u)){const c=U[u];if(c===void 0)throw new Error(`${f} references an unknown codicon: ${u}`);u=c}return U[f]=u,{id:f}}function D(){return U}t.getCodiconFontCharacters=D;function w(){return Object.values(t.Codicon)}t.getAllCodicons=w,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracket:i("bracket",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(ge[30],me([1,0,6]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function P(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const h=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([p,T])=>{h[p]=T&&typeof T=="object"?P(T):T}),h}t.deepClone=P;function U(a){if(!a||typeof a!="object")return a;const h=[a];for(;h.length>0;){const p=h.shift();Object.freeze(p);for(const T in p)if(i.call(p,T)){const A=p[T];typeof A=="object"&&!Object.isFrozen(A)&&!(0,E.isTypedArray)(A)&&h.push(A)}}return a}t.deepFreeze=U;const i=Object.prototype.hasOwnProperty;function D(a,h){return w(a,h,new Set)}t.cloneAndChange=D;function w(a,h,p){if((0,E.isUndefinedOrNull)(a))return a;const T=h(a);if(typeof T<"u")return T;if(Array.isArray(a)){const A=[];for(const m of a)A.push(w(m,h,p));return A}if((0,E.isObject)(a)){if(p.has(a))throw new Error("Cannot clone recursive data-structure");p.add(a);const A={};for(const m in a)i.call(a,m)&&(A[m]=w(a[m],h,p));return p.delete(a),A}return a}function f(a,h,p=!0){return(0,E.isObject)(a)?((0,E.isObject)(h)&&Object.keys(h).forEach(T=>{T in a?p&&((0,E.isObject)(a[T])&&(0,E.isObject)(h[T])?f(a[T],h[T],p):a[T]=h[T]):a[T]=h[T]}),a):h}t.mixin=f;function u(a,h){if(a===h)return!0;if(a==null||h===null||h===void 0||typeof a!=typeof h||typeof a!="object"||Array.isArray(a)!==Array.isArray(h))return!1;let p,T;if(Array.isArray(a)){if(a.length!==h.length)return!1;for(p=0;p<a.length;p++)if(!u(a[p],h[p]))return!1}else{const A=[];for(T in a)A.push(T);A.sort();const m=[];for(T in h)m.push(T);if(m.sort(),!u(A,m))return!1;for(p=0;p<A.length;p++)if(!u(a[A[p]],h[A[p]]))return!1}return!0}t.equals=u;function c(a){const h=new Set;return JSON.stringify(a,(p,T)=>{if((0,E.isObject)(T)||Array.isArray(T)){if(h.has(T))return"[Circular]";h.add(T)}return T})}t.safeStringify=c;function M(a,h){const p=Object.create(null);return!a||!h||Object.keys(h).forEach(A=>{const m=a[A],C=h[A];u(m,C)||(p[A]=C)}),p}t.distinct=M;function o(a,h){const p=h.toLowerCase(),T=Object.keys(a).find(A=>A.toLowerCase()===p);return T?a[T]:a[h]}t.getCaseInsensitive=o;function n(a,h){const p=Object.create(null);for(const[T,A]of Object.entries(a))h(T,A)&&(p[T]=A);return p}t.filter=n;function e(a){let h=[],p=Object.getPrototypeOf(a);for(;Object.prototype!==p;)h=h.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return h}t.getAllPropertyNames=e;function s(a){const h=[];for(const p of e(a))typeof a[p]=="function"&&h.push(p);return h}t.getAllMethodNames=s;function r(a,h){const p=A=>function(){const m=Array.prototype.slice.call(arguments,0);return h(A,m)},T={};for(const A of a)T[A]=p(A);return T}t.createProxyObject=r}),define(ge[17],me([1,0,16]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.themeColorFromId=t.ThemeColor=void 0;var P;(function(D){function w(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=w})(P=t.ThemeColor||(t.ThemeColor={}));function U(D){return{id:D}}t.themeColorFromId=U;var i;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(h){const p=w.exec(h.id);if(!p)return f(E.Codicon.error);const[,T,A]=p,m=["codicon","codicon-"+T];return A&&m.push("codicon-modifier-"+A.substring(1)),m}D.asClassNameArray=f;function u(h){return f(h).join(" ")}D.asClassName=u;function c(h){return"."+f(h).join(".")}D.asCSSSelector=c;function M(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||P.isThemeColor(h.color))}D.isThemeIcon=M;const o=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function n(h){const p=o.exec(h);if(!p)return;const[,T]=p;return{id:T}}D.fromString=n;function e(h){return{id:h}}D.fromId=e;function s(h,p){let T=h.id;const A=T.lastIndexOf("~");return A!==-1&&(T=T.substring(0,A)),p&&(T=`${T}~${p}`),{id:T}}D.modify=s;function r(h){const p=h.id.lastIndexOf("~");if(p!==-1)return h.id.substring(p+1)}D.getModifier=r;function a(h,p){return h.id===p.id&&h.color?.id===p.color?.id}D.isEqual=a})(i=t.ThemeIcon||(t.ThemeIcon={}))}),define(ge[81],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ge[82],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class E{constructor(U,i){this.a=U,this.onMessage=i}send(U){try{this.a.send("vscode:message",U.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=E}),define(ge[48],me([8]),{}),define(ge[83],me([8]),{}),define(ge[84],me([8]),{}),define(ge[85],me([8]),{}),define(ge[86],me([1,0,84,85]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[87],me([8]),{}),define(ge[88],me([8]),{}),define(ge[89],me([8]),{}),define(ge[90],me([8]),{}),define(ge[91],me([8]),{}),define(ge[92],me([8]),{}),define(ge[93],me([8]),{}),define(ge[94],me([8]),{}),define(ge[95],me([8]),{}),define(ge[96],me([12,10]),function(Q,t){return Q.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[97],me([12,10]),function(Q,t){return Q.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[98],me([12,10]),function(Q,t){return Q.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[99],me([12,10]),function(Q,t){return Q.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(ge[100],me([12,10]),function(Q,t){return Q.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[101],me([12,10]),function(Q,t){return Q.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[102],me([12,10]),function(Q,t){return Q.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[103],me([12,10]),function(Q,t){return Q.create("vs/base/common/actions",t)}),define(ge[104],me([12,10]),function(Q,t){return Q.create("vs/base/common/platform",t)}),define(ge[5],me([1,0,104]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let P=!1,U=!1,i=!1,D=!1,w=!1,f=!1,u=!1,c=!1,M=!1,o=!1,n,e=t.LANGUAGE_DEFAULT,s,r;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?a=t.globals.vscode.process:typeof process<"u"&&(a=process);const h=typeof a?.versions?.electron=="string",p=h&&a?.type==="renderer";if(typeof navigator=="object"&&!p)r=navigator.userAgent,P=r.indexOf("Windows")>=0,U=r.indexOf("Macintosh")>=0,c=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,i=r.indexOf("Linux")>=0,o=r?.indexOf("Mobi")>=0,f=!0,n=E.getConfiguredDefaultLocale(E.localize(0,null))||t.LANGUAGE_DEFAULT,e=n;else if(typeof a=="object"){P=a.platform==="win32",U=a.platform==="darwin",i=a.platform==="linux",D=i&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,u=h,M=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,n=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const b=a.env.VSCODE_NLS_CONFIG;if(b)try{const y=JSON.parse(b),R=y.availableLanguages["*"];n=y.locale,e=R||t.LANGUAGE_DEFAULT,s=y._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var T;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(T=t.Platform||(t.Platform={}));function A(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=A;let m=0;U?m=1:P?m=3:i&&(m=2),t.isWindows=P,t.isMacintosh=U,t.isLinux=i,t.isLinuxSnap=D,t.isNative=w,t.isElectron=u,t.isWeb=f,t.isWebWorker=f&&typeof t.globals.importScripts=="function",t.isIOS=c,t.isMobile=o,t.isCI=M,t.platform=m,t.userAgent=r,t.language=e;var C;(function(b){function y(){return t.language}b.value=y;function R(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}b.isDefaultVariant=R;function V(){return t.language==="en"}b.isDefault=V})(C=t.Language||(t.Language={})),t.locale=n,t.translationsConfigFile=s,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const b=[];t.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let V=0,ee=b.length;V<ee;V++){const Z=b[V];if(Z.id===R.data.vscodeScheduleAsyncWork){b.splice(V,1),Z.callback();return}}});let y=0;return R=>{const V=++y;b.push({id:V,callback:R}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return b=>setTimeout(b)})();var N;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(N=t.OperatingSystem||(t.OperatingSystem={})),t.OS=U||c?2:P?1:3;let L=!0,d=!1;function v(){if(!d){d=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,L=new Uint16Array(b.buffer)[0]===(2<<8)+1}return L}t.isLittleEndian=v,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(ge[105],me([1,0,5]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let P;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const U=E.globals.vscode.process;P={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.platform=P.platform,t.arch=P.arch}),define(ge[22],me([1,0,105]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const P=65,U=97,i=90,D=122,w=46,f=47,u=92,c=58,M=63;class o extends Error{constructor(C,N,L){let d;typeof N=="string"&&N.indexOf("not ")===0?(d="must not be",N=N.replace(/^not /,"")):d="must be";const v=C.indexOf(".")!==-1?"property":"argument";let b=`The "${C}" ${v} ${d} of type ${N}`;b+=`. Received type ${typeof L}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function n(m,C){if(m===null||typeof m!="object")throw new o(C,"Object",m)}function e(m,C){if(typeof m!="string")throw new o(C,"string",m)}const s=E.platform==="win32";function r(m){return m===f||m===u}function a(m){return m===f}function h(m){return m>=P&&m<=i||m>=U&&m<=D}function p(m,C,N,L){let d="",v=0,b=-1,y=0,R=0;for(let V=0;V<=m.length;++V){if(V<m.length)R=m.charCodeAt(V);else{if(L(R))break;R=f}if(L(R)){if(!(b===V-1||y===1))if(y===2){if(d.length<2||v!==2||d.charCodeAt(d.length-1)!==w||d.charCodeAt(d.length-2)!==w){if(d.length>2){const ee=d.lastIndexOf(N);ee===-1?(d="",v=0):(d=d.slice(0,ee),v=d.length-1-d.lastIndexOf(N)),b=V,y=0;continue}else if(d.length!==0){d="",v=0,b=V,y=0;continue}}C&&(d+=d.length>0?`${N}..`:"..",v=2)}else d.length>0?d+=`${N}${m.slice(b+1,V)}`:d=m.slice(b+1,V),v=V-b-1;b=V,y=0}else R===w&&y!==-1?++y:y=-1}return d}function T(m,C){n(C,"pathObject");const N=C.dir||C.root,L=C.base||`${C.name||""}${C.ext||""}`;return N?N===C.root?`${N}${L}`:`${N}${m}${L}`:L}t.win32={resolve(...m){let C="",N="",L=!1;for(let d=m.length-1;d>=-1;d--){let v;if(d>=0){if(v=m[d],e(v,"path"),v.length===0)continue}else C.length===0?v=E.cwd():(v=E.env[`=${C}`]||E.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==C.toLowerCase()&&v.charCodeAt(2)===u)&&(v=`${C}\\`));const b=v.length;let y=0,R="",V=!1;const ee=v.charCodeAt(0);if(b===1)r(ee)&&(y=1,V=!0);else if(r(ee))if(V=!0,r(v.charCodeAt(1))){let Z=2,J=Z;for(;Z<b&&!r(v.charCodeAt(Z));)Z++;if(Z<b&&Z!==J){const re=v.slice(J,Z);for(J=Z;Z<b&&r(v.charCodeAt(Z));)Z++;if(Z<b&&Z!==J){for(J=Z;Z<b&&!r(v.charCodeAt(Z));)Z++;(Z===b||Z!==J)&&(R=`\\\\${re}\\${v.slice(J,Z)}`,y=Z)}}}else y=1;else h(ee)&&v.charCodeAt(1)===c&&(R=v.slice(0,2),y=2,b>2&&r(v.charCodeAt(2))&&(V=!0,y=3));if(R.length>0)if(C.length>0){if(R.toLowerCase()!==C.toLowerCase())continue}else C=R;if(L){if(C.length>0)break}else if(N=`${v.slice(y)}\\${N}`,L=V,V&&C.length>0)break}return N=p(N,!L,"\\",r),L?`${C}\\${N}`:`${C}${N}`||"."},normalize(m){e(m,"path");const C=m.length;if(C===0)return".";let N=0,L,d=!1;const v=m.charCodeAt(0);if(C===1)return a(v)?"\\":m;if(r(v))if(d=!0,r(m.charCodeAt(1))){let y=2,R=y;for(;y<C&&!r(m.charCodeAt(y));)y++;if(y<C&&y!==R){const V=m.slice(R,y);for(R=y;y<C&&r(m.charCodeAt(y));)y++;if(y<C&&y!==R){for(R=y;y<C&&!r(m.charCodeAt(y));)y++;if(y===C)return`\\\\${V}\\${m.slice(R)}\\`;y!==R&&(L=`\\\\${V}\\${m.slice(R,y)}`,N=y)}}}else N=1;else h(v)&&m.charCodeAt(1)===c&&(L=m.slice(0,2),N=2,C>2&&r(m.charCodeAt(2))&&(d=!0,N=3));let b=N<C?p(m.slice(N),!d,"\\",r):"";return b.length===0&&!d&&(b="."),b.length>0&&r(m.charCodeAt(C-1))&&(b+="\\"),L===void 0?d?`\\${b}`:b:d?`${L}\\${b}`:`${L}${b}`},isAbsolute(m){e(m,"path");const C=m.length;if(C===0)return!1;const N=m.charCodeAt(0);return r(N)||C>2&&h(N)&&m.charCodeAt(1)===c&&r(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let C,N;for(let v=0;v<m.length;++v){const b=m[v];e(b,"path"),b.length>0&&(C===void 0?C=N=b:C+=`\\${b}`)}if(C===void 0)return".";let L=!0,d=0;if(typeof N=="string"&&r(N.charCodeAt(0))){++d;const v=N.length;v>1&&r(N.charCodeAt(1))&&(++d,v>2&&(r(N.charCodeAt(2))?++d:L=!1))}if(L){for(;d<C.length&&r(C.charCodeAt(d));)d++;d>=2&&(C=`\\${C.slice(d)}`)}return t.win32.normalize(C)},relative(m,C){if(e(m,"from"),e(C,"to"),m===C)return"";const N=t.win32.resolve(m),L=t.win32.resolve(C);if(N===L||(m=N.toLowerCase(),C=L.toLowerCase(),m===C))return"";let d=0;for(;d<m.length&&m.charCodeAt(d)===u;)d++;let v=m.length;for(;v-1>d&&m.charCodeAt(v-1)===u;)v--;const b=v-d;let y=0;for(;y<C.length&&C.charCodeAt(y)===u;)y++;let R=C.length;for(;R-1>y&&C.charCodeAt(R-1)===u;)R--;const V=R-y,ee=b<V?b:V;let Z=-1,J=0;for(;J<ee;J++){const he=m.charCodeAt(d+J);if(he!==C.charCodeAt(y+J))break;he===u&&(Z=J)}if(J!==ee){if(Z===-1)return L}else{if(V>ee){if(C.charCodeAt(y+J)===u)return L.slice(y+J+1);if(J===2)return L.slice(y+J)}b>ee&&(m.charCodeAt(d+J)===u?Z=J:J===2&&(Z=3)),Z===-1&&(Z=0)}let re="";for(J=d+Z+1;J<=v;++J)(J===v||m.charCodeAt(J)===u)&&(re+=re.length===0?"..":"\\..");return y+=Z,re.length>0?`${re}${L.slice(y,R)}`:(L.charCodeAt(y)===u&&++y,L.slice(y,R))},toNamespacedPath(m){if(typeof m!="string"||m.length===0)return m;const C=t.win32.resolve(m);if(C.length<=2)return m;if(C.charCodeAt(0)===u){if(C.charCodeAt(1)===u){const N=C.charCodeAt(2);if(N!==M&&N!==w)return`\\\\?\\UNC\\${C.slice(2)}`}}else if(h(C.charCodeAt(0))&&C.charCodeAt(1)===c&&C.charCodeAt(2)===u)return`\\\\?\\${C}`;return m},dirname(m){e(m,"path");const C=m.length;if(C===0)return".";let N=-1,L=0;const d=m.charCodeAt(0);if(C===1)return r(d)?m:".";if(r(d)){if(N=L=1,r(m.charCodeAt(1))){let y=2,R=y;for(;y<C&&!r(m.charCodeAt(y));)y++;if(y<C&&y!==R){for(R=y;y<C&&r(m.charCodeAt(y));)y++;if(y<C&&y!==R){for(R=y;y<C&&!r(m.charCodeAt(y));)y++;if(y===C)return m;y!==R&&(N=L=y+1)}}}}else h(d)&&m.charCodeAt(1)===c&&(N=C>2&&r(m.charCodeAt(2))?3:2,L=N);let v=-1,b=!0;for(let y=C-1;y>=L;--y)if(r(m.charCodeAt(y))){if(!b){v=y;break}}else b=!1;if(v===-1){if(N===-1)return".";v=N}return m.slice(0,v)},basename(m,C){C!==void 0&&e(C,"ext"),e(m,"path");let N=0,L=-1,d=!0,v;if(m.length>=2&&h(m.charCodeAt(0))&&m.charCodeAt(1)===c&&(N=2),C!==void 0&&C.length>0&&C.length<=m.length){if(C===m)return"";let b=C.length-1,y=-1;for(v=m.length-1;v>=N;--v){const R=m.charCodeAt(v);if(r(R)){if(!d){N=v+1;break}}else y===-1&&(d=!1,y=v+1),b>=0&&(R===C.charCodeAt(b)?--b===-1&&(L=v):(b=-1,L=y))}return N===L?L=y:L===-1&&(L=m.length),m.slice(N,L)}for(v=m.length-1;v>=N;--v)if(r(m.charCodeAt(v))){if(!d){N=v+1;break}}else L===-1&&(d=!1,L=v+1);return L===-1?"":m.slice(N,L)},extname(m){e(m,"path");let C=0,N=-1,L=0,d=-1,v=!0,b=0;m.length>=2&&m.charCodeAt(1)===c&&h(m.charCodeAt(0))&&(C=L=2);for(let y=m.length-1;y>=C;--y){const R=m.charCodeAt(y);if(r(R)){if(!v){L=y+1;break}continue}d===-1&&(v=!1,d=y+1),R===w?N===-1?N=y:b!==1&&(b=1):N!==-1&&(b=-1)}return N===-1||d===-1||b===0||b===1&&N===d-1&&N===L+1?"":m.slice(N,d)},format:T.bind(null,"\\"),parse(m){e(m,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return C;const N=m.length;let L=0,d=m.charCodeAt(0);if(N===1)return r(d)?(C.root=C.dir=m,C):(C.base=C.name=m,C);if(r(d)){if(L=1,r(m.charCodeAt(1))){let Z=2,J=Z;for(;Z<N&&!r(m.charCodeAt(Z));)Z++;if(Z<N&&Z!==J){for(J=Z;Z<N&&r(m.charCodeAt(Z));)Z++;if(Z<N&&Z!==J){for(J=Z;Z<N&&!r(m.charCodeAt(Z));)Z++;Z===N?L=Z:Z!==J&&(L=Z+1)}}}}else if(h(d)&&m.charCodeAt(1)===c){if(N<=2)return C.root=C.dir=m,C;if(L=2,r(m.charCodeAt(2))){if(N===3)return C.root=C.dir=m,C;L=3}}L>0&&(C.root=m.slice(0,L));let v=-1,b=L,y=-1,R=!0,V=m.length-1,ee=0;for(;V>=L;--V){if(d=m.charCodeAt(V),r(d)){if(!R){b=V+1;break}continue}y===-1&&(R=!1,y=V+1),d===w?v===-1?v=V:ee!==1&&(ee=1):v!==-1&&(ee=-1)}return y!==-1&&(v===-1||ee===0||ee===1&&v===y-1&&v===b+1?C.base=C.name=m.slice(b,y):(C.name=m.slice(b,v),C.base=m.slice(b,y),C.ext=m.slice(v,y))),b>0&&b!==L?C.dir=m.slice(0,b-1):C.dir=C.root,C},sep:"\\",delimiter:";",win32:null,posix:null};const A=(()=>{if(s){const m=/\\/g;return()=>{const C=E.cwd().replace(m,"/");return C.slice(C.indexOf("/"))}}return()=>E.cwd()})();t.posix={resolve(...m){let C="",N=!1;for(let L=m.length-1;L>=-1&&!N;L--){const d=L>=0?m[L]:A();e(d,"path"),d.length!==0&&(C=`${d}/${C}`,N=d.charCodeAt(0)===f)}return C=p(C,!N,"/",a),N?`/${C}`:C.length>0?C:"."},normalize(m){if(e(m,"path"),m.length===0)return".";const C=m.charCodeAt(0)===f,N=m.charCodeAt(m.length-1)===f;return m=p(m,!C,"/",a),m.length===0?C?"/":N?"./":".":(N&&(m+="/"),C?`/${m}`:m)},isAbsolute(m){return e(m,"path"),m.length>0&&m.charCodeAt(0)===f},join(...m){if(m.length===0)return".";let C;for(let N=0;N<m.length;++N){const L=m[N];e(L,"path"),L.length>0&&(C===void 0?C=L:C+=`/${L}`)}return C===void 0?".":t.posix.normalize(C)},relative(m,C){if(e(m,"from"),e(C,"to"),m===C||(m=t.posix.resolve(m),C=t.posix.resolve(C),m===C))return"";const N=1,L=m.length,d=L-N,v=1,b=C.length-v,y=d<b?d:b;let R=-1,V=0;for(;V<y;V++){const Z=m.charCodeAt(N+V);if(Z!==C.charCodeAt(v+V))break;Z===f&&(R=V)}if(V===y)if(b>y){if(C.charCodeAt(v+V)===f)return C.slice(v+V+1);if(V===0)return C.slice(v+V)}else d>y&&(m.charCodeAt(N+V)===f?R=V:V===0&&(R=0));let ee="";for(V=N+R+1;V<=L;++V)(V===L||m.charCodeAt(V)===f)&&(ee+=ee.length===0?"..":"/..");return`${ee}${C.slice(v+R)}`},toNamespacedPath(m){return m},dirname(m){if(e(m,"path"),m.length===0)return".";const C=m.charCodeAt(0)===f;let N=-1,L=!0;for(let d=m.length-1;d>=1;--d)if(m.charCodeAt(d)===f){if(!L){N=d;break}}else L=!1;return N===-1?C?"/":".":C&&N===1?"//":m.slice(0,N)},basename(m,C){C!==void 0&&e(C,"ext"),e(m,"path");let N=0,L=-1,d=!0,v;if(C!==void 0&&C.length>0&&C.length<=m.length){if(C===m)return"";let b=C.length-1,y=-1;for(v=m.length-1;v>=0;--v){const R=m.charCodeAt(v);if(R===f){if(!d){N=v+1;break}}else y===-1&&(d=!1,y=v+1),b>=0&&(R===C.charCodeAt(b)?--b===-1&&(L=v):(b=-1,L=y))}return N===L?L=y:L===-1&&(L=m.length),m.slice(N,L)}for(v=m.length-1;v>=0;--v)if(m.charCodeAt(v)===f){if(!d){N=v+1;break}}else L===-1&&(d=!1,L=v+1);return L===-1?"":m.slice(N,L)},extname(m){e(m,"path");let C=-1,N=0,L=-1,d=!0,v=0;for(let b=m.length-1;b>=0;--b){const y=m.charCodeAt(b);if(y===f){if(!d){N=b+1;break}continue}L===-1&&(d=!1,L=b+1),y===w?C===-1?C=b:v!==1&&(v=1):C!==-1&&(v=-1)}return C===-1||L===-1||v===0||v===1&&C===L-1&&C===N+1?"":m.slice(C,L)},format:T.bind(null,"/"),parse(m){e(m,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return C;const N=m.charCodeAt(0)===f;let L;N?(C.root="/",L=1):L=0;let d=-1,v=0,b=-1,y=!0,R=m.length-1,V=0;for(;R>=L;--R){const ee=m.charCodeAt(R);if(ee===f){if(!y){v=R+1;break}continue}b===-1&&(y=!1,b=R+1),ee===w?d===-1?d=R:V!==1&&(V=1):d!==-1&&(V=-1)}if(b!==-1){const ee=v===0&&N?1:v;d===-1||V===0||V===1&&d===b-1&&d===v+1?C.base=C.name=m.slice(ee,b):(C.name=m.slice(ee,d),C.base=m.slice(ee,b),C.ext=m.slice(d,b))}return v>0?C.dir=m.slice(0,v-1):N&&(C.dir="/"),C},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=s?t.win32.normalize:t.posix.normalize,t.isAbsolute=s?t.win32.isAbsolute:t.posix.isAbsolute,t.join=s?t.win32.join:t.posix.join,t.resolve=s?t.win32.resolve:t.posix.resolve,t.relative=s?t.win32.relative:t.posix.relative,t.dirname=s?t.win32.dirname:t.posix.dirname,t.basename=s?t.win32.basename:t.posix.basename,t.extname=s?t.win32.extname:t.posix.extname,t.format=s?t.win32.format:t.posix.format,t.parse=s?t.win32.parse:t.posix.parse,t.toNamespacedPath=s?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=s?t.win32.sep:t.posix.sep,t.delimiter=s?t.win32.delimiter:t.posix.delimiter}),define(ge[106],me([1,0,22]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},U={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function i(c){const M=(0,E.extname)(c),o=P[M.toLowerCase()];return o!==void 0?o:D(c)}t.getMediaOrTextMime=i;function D(c){const M=(0,E.extname)(c);return U[M.toLowerCase()]}t.getMediaMime=D;function w(c){for(const M in U)if(U[M]===c)return M}t.getExtensionForMimeType=w;const f=/^(.+)\/(.+?)(;.+)?$/;function u(c,M){const o=f.exec(c);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:M?void 0:c}t.normalizeMimeType=u}),define(ge[107],me([1,0,5]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const P=E.globals.performance&&typeof E.globals.performance.now=="function";class U{static create(D=!0){return new U(D)}constructor(D){this.a=P&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}t.StopWatch=U}),define(ge[3],me([1,0,7,42,2,45,107]),function(Q,t,E,P,U,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const w=!1,f=!1;var u;(function(v){v.None=()=>U.Disposable.None;function b(k){if(f){const{onDidAddListener:W}=k,j=e.create();let F=0;k.onDidAddListener=()=>{++F===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),W?.()}}}function y(k,W){return ce(k,()=>{},0,void 0,void 0,W)}v.defer=y;function R(k){return(W,j=null,F)=>{let I=!1,O;return O=k(S=>{if(!I)return O?O.dispose():I=!0,W.call(j,S)},null,F),I&&O.dispose(),O}}v.once=R;function V(k,W,j){return de((F,I=null,O)=>k(S=>F.call(I,W(S)),null,O),j)}v.map=V;function ee(k,W,j){return de((F,I=null,O)=>k(S=>{W(S),F.call(I,S)},null,O),j)}v.forEach=ee;function Z(k,W,j){return de((F,I=null,O)=>k(S=>W(S)&&F.call(I,S),null,O),j)}v.filter=Z;function J(k){return k}v.signal=J;function re(...k){return(W,j=null,F)=>(0,U.combinedDisposable)(...k.map(I=>I(O=>W.call(j,O),null,F)))}v.any=re;function he(k,W,j,F){let I=j;return V(k,O=>(I=W(I,O),I),F)}v.reduce=he;function de(k,W){let j;const F={onWillAddFirstListener(){j=k(I.fire,I)},onDidRemoveLastListener(){j?.dispose()}};W||b(F);const I=new r(F);return W?.add(I),I.event}function ce(k,W,j=100,F=!1,I,O){let S,B,H,z=0;const _={leakWarningThreshold:I,onWillAddFirstListener(){S=k(ne=>{z++,B=W(B,ne),F&&!H&&(Y.fire(B),B=void 0),clearTimeout(H),H=setTimeout(()=>{const ue=B;B=void 0,H=void 0,(!F||z>1)&&Y.fire(ue),z=0},j)})},onDidRemoveLastListener(){S.dispose()}};O||b(_);const Y=new r(_);return O?.add(Y),Y.event}v.debounce=ce;function pe(k,W=0,j){return v.debounce(k,(F,I)=>F?(F.push(I),F):[I],W,void 0,void 0,j)}v.accumulate=pe;function Te(k,W=(F,I)=>F===I,j){let F=!0,I;return Z(k,O=>{const S=F||!W(O,I);return F=!1,I=O,S},j)}v.latch=Te;function Pe(k,W,j){return[v.filter(k,W,j),v.filter(k,F=>!W(F),j)]}v.split=Pe;function Oe(k,W=!1,j=[]){let F=j.slice(),I=k(B=>{F?F.push(B):S.fire(B)});const O=()=>{F?.forEach(B=>S.fire(B)),F=null},S=new r({onWillAddFirstListener(){I||(I=k(B=>S.fire(B)))},onDidAddFirstListener(){F&&(W?setTimeout(O):O())},onDidRemoveLastListener(){I&&I.dispose(),I=null}});return S.event}v.buffer=Oe;class x{constructor(W){this.event=W,this.c=new U.DisposableStore}map(W){return new x(V(this.event,W,this.c))}forEach(W){return new x(ee(this.event,W,this.c))}filter(W){return new x(Z(this.event,W,this.c))}reduce(W,j){return new x(he(this.event,W,j,this.c))}latch(){return new x(Te(this.event,void 0,this.c))}debounce(W,j=100,F=!1,I){return new x(ce(this.event,W,j,F,I,this.c))}on(W,j,F){return this.event(W,j,F)}once(W,j,F){return R(this.event)(W,j,F)}dispose(){this.c.dispose()}}function G(k){return new x(k)}v.chain=G;function ie(k,W,j=F=>F){const F=(...B)=>S.fire(j(...B)),I=()=>k.on(W,F),O=()=>k.removeListener(W,F),S=new r({onWillAddFirstListener:I,onDidRemoveLastListener:O});return S.event}v.fromNodeEventEmitter=ie;function se(k,W,j=F=>F){const F=(...B)=>S.fire(j(...B)),I=()=>k.addEventListener(W,F),O=()=>k.removeEventListener(W,F),S=new r({onWillAddFirstListener:I,onDidRemoveLastListener:O});return S.event}v.fromDOMEventEmitter=se;function ae(k){return new Promise(W=>R(k)(W))}v.toPromise=ae;function te(k,W){return W(void 0),k(j=>W(j))}v.runAndSubscribe=te;function $(k,W){let j=null;function F(O){j?.dispose(),j=new U.DisposableStore,W(O,j)}F(void 0);const I=k(O=>F(O));return(0,U.toDisposable)(()=>{I.dispose(),j?.dispose()})}v.runAndSubscribeWithStore=$;class g{constructor(W,j){this.obs=W,this.c=0,this.d=!1;const F={onWillAddFirstListener:()=>{W.addObserver(this)},onDidRemoveLastListener:()=>{W.removeObserver(this)}};j||b(F),this.emitter=new r(F),j&&j.add(this.emitter)}beginUpdate(W){this.c++}handleChange(W,j){this.d=!0}endUpdate(W){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function l(k,W){return new g(k,W).emitter.event}v.fromObservable=l})(u=t.Event||(t.Event={}));class c{constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${c.c++}`,c.all.add(this)}start(b){this.d=new D.StopWatch(!0),this.listenerCount=b}stop(){if(this.d){const b=this.d.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=c,c.all=new Set,c.c=0;let M=-1;function o(v){const b=M;return M=v,{dispose(){M=b}}}t.setGlobalLeakWarningThreshold=o;class n{constructor(b,y=Math.random().toString(18).slice(2,5)){this.threshold=b,this.name=y,this.d=0}dispose(){this.c?.clear()}check(b,y){const R=this.threshold;if(R<=0||y<R)return;this.c||(this.c=new Map);const V=this.c.get(b.value)||0;if(this.c.set(b.value,V+1),this.d-=1,this.d<=0){this.d=R*.5;let ee,Z=0;for(const[J,re]of this.c)(!ee||Z<re)&&(ee=J,Z=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${Z}):`),console.warn(ee)}return()=>{const ee=this.c.get(b.value)||0;this.c.set(b.value,ee-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class s{constructor(b,y,R){this.callback=b,this.callbackThis=y,this.stack=R,this.subscription=new U.SafeDisposable}invoke(b){this.callback.call(this.callbackThis,b)}}class r{constructor(b){this.j=!1,this.d=b,this.f=M>0||this.d?.leakWarningThreshold?new n(this.d?.leakWarningThreshold??M):void 0,this.g=this.d?._profName?new c(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(w){const b=Array.from(this.q);queueMicrotask(()=>{for(const y of b)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(b,y,R)=>{if(this.q||(this.q=new i.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),U.Disposable.None;const V=this.q.isEmpty();V&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let ee,Z;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(Z=e.create(),ee=this.f.check(Z,this.q.size+1)),w&&(Z=Z??e.create());const J=new s(b,y,Z),re=this.q.push(J);V&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,b,y);const he=J.subscription.set(()=>{ee?.(),this.j||(re(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return R instanceof U.DisposableStore?R.add(he):Array.isArray(R)&&R.push(he),he}),this.l}fire(b){if(this.q){this.m||(this.m=new h);for(const y of this.q)this.m.push(this,y,b);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=r;class a{constructor(){this.c=new i.LinkedList}get size(){return this.c.size}push(b,y,R){this.c.push(new p(b,y,R))}clear(b){const y=new i.LinkedList;for(const R of this.c)R.emitter!==b&&y.push(R);this.c=y}deliver(){for(;this.c.size>0;){const b=this.c.shift();try{b.listener.invoke(b.event)}catch(y){(0,E.onUnexpectedError)(y)}}}}t.EventDeliveryQueue=a;class h extends a{clear(b){this.c.clear()}}class p{constructor(b,y,R){this.emitter=b,this.listener=y,this.event=R}}class T extends r{async fireAsync(b,y,R){if(!!this.q){this.c||(this.c=new i.LinkedList);for(const V of this.q)this.c.push([V,b]);for(;this.c.size>0&&!y.isCancellationRequested;){const[V,ee]=this.c.shift(),Z=[],J={...ee,token:y,waitUntil:re=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");R&&(re=R(re,V.callback)),Z.push(re)}};try{V.invoke(J)}catch(re){(0,E.onUnexpectedError)(re);continue}Object.freeze(Z),await Promise.allSettled(Z).then(re=>{for(const he of re)he.status==="rejected"&&(0,E.onUnexpectedError)(he.reason)})}}}}t.AsyncEmitter=T;class A extends r{constructor(b){super(b),this.h=0,this.s=new i.LinkedList,this.t=b?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const b=Array.from(this.s);this.s.clear(),super.fire(this.t(b))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(b){this.q&&(this.h!==0?this.s.push(b):super.fire(b))}}t.PauseableEmitter=A;class m extends A{constructor(b){super(b),this.c=b.delay??100}fire(b){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(b)}}t.DebounceEmitter=m;class C extends r{constructor(b){super(b),this.c=[],this.h=b?.merge}fire(b){!this.hasListeners()||(this.c.push(b),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(y=>super.fire(y)),this.c=[]}))}}t.MicrotaskEmitter=C;class N{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(b){const y={event:b,listener:null};this.f.push(y),this.d&&this.j(y);const R=()=>{this.d&&this.k(y);const V=this.f.indexOf(y);this.f.splice(V,1)};return(0,U.toDisposable)((0,P.once)(R))}g(){this.d=!0,this.f.forEach(b=>this.j(b))}h(){this.d=!1,this.f.forEach(b=>this.k(b))}j(b){b.listener=b.event(y=>this.c.fire(y))}k(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=N;class L{constructor(){this.c=[]}wrapEvent(b){return(y,R,V)=>b(ee=>{const Z=this.c[this.c.length-1];Z?Z.push(()=>y.call(R,ee)):y.call(R,ee)},void 0,V)}bufferEvents(b){const y=[];this.c.push(y);const R=b();return this.c.pop(),y.forEach(V=>V()),R}}t.EventBufferer=L;class d{constructor(){this.c=!1,this.d=u.None,this.f=U.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(b){this.d=b,this.c&&(this.f.dispose(),this.f=b(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=d}),define(ge[18],me([1,0,3,2]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class U{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new E.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(T,A){this.a!==T&&(this.a=T)}getZoomFactor(){return this.b}setZoomFactor(T){this.b=T}setFullscreen(T){this.c!==T&&(this.c=T,this.d.fire())}isFullscreen(){return this.c}}U.INSTANCE=new U;class i extends P.Disposable{constructor(){super(),this.a=this.B(new E.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(T){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),T&&this.a.fire()}}class D extends P.Disposable{get value(){return this.b}constructor(){super(),this.a=this.B(new E.Emitter),this.onDidChange=this.a.event,this.b=this.c();const T=this.B(new i);this.B(T.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const T=document.createElement("canvas").getContext("2d"),A=window.devicePixelRatio||1,m=T.webkitBackingStorePixelRatio||T.mozBackingStorePixelRatio||T.msBackingStorePixelRatio||T.oBackingStorePixelRatio||T.backingStorePixelRatio||1;return A/m}}class w{constructor(){this.a=null}b(){return this.a||(this.a=(0,P.markAsSingleton)(new D)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function f(p,T){typeof p=="string"&&(p=window.matchMedia(p)),p.addEventListener("change",T)}t.addMatchMediaChangeListener=f,t.PixelRatio=new w;function u(p,T){U.INSTANCE.setZoomLevel(p,T)}t.setZoomLevel=u;function c(){return U.INSTANCE.getZoomLevel()}t.getZoomLevel=c;function M(){return U.INSTANCE.getZoomFactor()}t.getZoomFactor=M;function o(p){U.INSTANCE.setZoomFactor(p)}t.setZoomFactor=o;function n(p){U.INSTANCE.setFullscreen(p)}t.setFullscreen=n;function e(){return U.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=U.INSTANCE.onDidChangeFullscreen;const s=navigator.userAgent;t.isFirefox=s.indexOf("Firefox")>=0,t.isWebKit=s.indexOf("AppleWebKit")>=0,t.isChrome=s.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&s.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=s.indexOf("Electron/")>=0,t.isAndroid=s.indexOf("Android")>=0;let r=!1;if(window.matchMedia){const p=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),T=window.matchMedia("(display-mode: fullscreen)");r=p.matches,f(p,({matches:A})=>{r&&T.matches||(r=A)})}function a(){return r}t.isStandalone=a;function h(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=h}),define(ge[108],me([1,0,18,5]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var U;(function(i){i[i.Always=0]="Always",i[i.FullScreen=1]="FullScreen",i[i.None=2]="None"})(U=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:P.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:P.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>P.isNative||E.isStandalone()?0:navigator.keyboard||E.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(ge[20],me([1,0,3]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class P{get event(){return this.a.event}constructor(i,D,w){const f=u=>this.a.fire(u);this.a=new E.Emitter({onWillAddFirstListener:()=>i.addEventListener(D,f,w),onDidRemoveLastListener:()=>i.removeEventListener(D,f,w)})}dispose(){this.a.dispose()}}t.DomEmitter=P}),define(ge[14],me([1,0,18,43,74,5]),function(Q,t,E,P,U,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function D(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return P.KeyCodeUtils.fromString(r)}const s=e.keyCode;if(s===3)return 7;if(E.isFirefox){if(s===59)return 80;if(s===107)return 81;if(s===109)return 83;if(i.isMacintosh&&s===224)return 57}else if(E.isWebKit){if(s===91)return 57;if(i.isMacintosh&&s===93)return 57;if(!i.isMacintosh&&s===92)return 57}return P.EVENT_KEY_CODE_MAP[s]||0}const w=i.isMacintosh?256:2048,f=512,u=1024,c=i.isMacintosh?2048:256;function M(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=M;function o(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${P.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=o;class n{constructor(s){this._standardKeyboardEventBrand=!0;const r=s;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState("AltGraph"),this.keyCode=D(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let r=0;return this.ctrlKey&&(r|=w),this.altKey&&(r|=f),this.shiftKey&&(r|=u),this.metaKey&&(r|=c),r|=s,r}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new U.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=n}),define(ge[21],me([1,0,18,67,5]),function(Q,t,E,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class i{constructor(u){this.timestamp=Date.now(),this.browserEvent=u,this.leftButton=u.button===0,this.middleButton=u.button===1,this.rightButton=u.button===2,this.buttons=u.buttons,this.target=u.target,this.detail=u.detail||1,u.type==="dblclick"&&(this.detail=2),this.ctrlKey=u.ctrlKey,this.shiftKey=u.shiftKey,this.altKey=u.altKey,this.metaKey=u.metaKey,typeof u.pageX=="number"?(this.posx=u.pageX,this.posy=u.pageY):(this.posx=u.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=u.clientY+document.body.scrollTop+document.documentElement.scrollTop);const c=P.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,u.view);this.posx-=c.left,this.posy-=c.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=i;class D extends i{constructor(u){super(u),this.dataTransfer=u.dataTransfer}}t.DragMouseEvent=D;class w{constructor(u,c=0,M=0){if(this.browserEvent=u||null,this.target=u?u.target||u.targetNode||u.srcElement:null,this.deltaY=M,this.deltaX=c,u){const o=u,n=u;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof n.VERTICAL_AXIS<"u"&&n.axis===n.VERTICAL_AXIS)this.deltaY=-n.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!U.isMacintosh?this.deltaY=-u.deltaY/3:this.deltaY=-u.deltaY:this.deltaY=-u.deltaY/40}if(typeof o.wheelDeltaX<"u")E.isSafari&&U.isWindows?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof n.HORIZONTAL_AXIS<"u"&&n.axis===n.HORIZONTAL_AXIS)this.deltaX=-u.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!U.isMacintosh?this.deltaX=-u.deltaX/3:this.deltaX=-u.deltaX:this.deltaX=-u.deltaX/40}this.deltaY===0&&this.deltaX===0&&u.wheelDelta&&(this.deltaY=u.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=w}),define(ge[31],me([1,0,3,2,103]),function(Q,t,E,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class i extends P.Disposable{constructor(o,n="",e="",s=!0,r){super(),this.h=this.B(new E.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=n,this.u=e,this.w=s,this.C=r}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,n){this.C&&await this.C(o)}}t.Action=i;class D extends P.Disposable{constructor(){super(...arguments),this.f=this.B(new E.Emitter),this.onWillRun=this.f.event,this.h=this.B(new E.Emitter),this.onDidRun=this.h.event}async run(o,n){if(!o.enabled)return;this.f.fire({action:o});let e;try{await this.runAction(o,n)}catch(s){e=s}this.h.fire({action:o,error:e})}async runAction(o,n){await o.run(n)}}t.ActionRunner=D;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let n=[];for(const e of o)e.length&&(n.length?n=[...n,new w,...e]:n=e);return n}async run(){}}t.Separator=w,w.ID="vs.actions.separator";class f{get actions(){return this.a}constructor(o,n,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=n,this.class=s,this.a=e}async run(){}}t.SubmenuAction=f;class u extends i{constructor(){super(u.ID,U.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=u,u.ID="vs.actions.empty";function c(M){return{id:M.id,label:M.label,class:void 0,enabled:M.enabled??!0,checked:M.checked??!1,run:async()=>M.run(),tooltip:M.label}}t.toAction=c}),define(ge[27],me([1,0,3]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const P=Object.freeze(function(w,f){const u=setTimeout(w.bind(f),0);return{dispose(){clearTimeout(u)}}});var U;(function(w){function f(u){return u===w.None||u===w.Cancelled||u instanceof i?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}w.isCancellationToken=f,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(U=t.CancellationToken||(t.CancellationToken={}));class i{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?P:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new i),this.a}cancel(){this.a?this.a instanceof i&&this.a.cancel():this.a=U.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof i&&this.a.dispose():this.a=U.None}}t.CancellationTokenSource=D}),define(ge[109],me([1,0,27]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class P{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new E.CancellationTokenSource,f=this.b(w.token);return this.a={promise:f,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}t.Cache=P;class U{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const f=JSON.stringify(w);return this.b!==f&&(this.b=f,this.a=this.c(w)),this.a}}t.LRUCachedFunction=U;class i{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const f=this.b(w);return this.a.set(w,f),f}}t.CachedFunction=i}),define(ge[49],me([1,0,3,2]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var U;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(U=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class i{constructor(e,s,r,a,h,p,T){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,r=r|0,a=a|0,h=h|0,p=p|0,T=T|0),this.rawScrollLeft=a,this.rawScrollTop=T,s<0&&(s=0),a+s>r&&(a=r-s),a<0&&(a=0),h<0&&(h=0),T+h>p&&(T=p-h),T<0&&(T=0),this.width=s,this.scrollWidth=r,this.scrollLeft=a,this.height=h,this.scrollHeight=p,this.scrollTop=T}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new i(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new i(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const r=this.width!==e.width,a=this.scrollWidth!==e.scrollWidth,h=this.scrollLeft!==e.scrollLeft,p=this.height!==e.height,T=this.scrollHeight!==e.scrollHeight,A=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:a,scrollLeftChanged:h,heightChanged:p,scrollHeightChanged:T,scrollTopChanged:A}}}t.ScrollState=i;class D extends P.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new E.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new i(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const r=this.g.withScrollDimensions(e,s);this.k(r,Boolean(this.h)),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const r=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===r.scrollLeft&&this.h.to.scrollTop===r.scrollTop)return;let a;s?a=new c(this.h.from,r,this.h.startTime,this.h.duration):a=this.h.combine(this.g,r,this.c),this.h.dispose(),this.h=a}else{const r=this.g.withScrollPosition(e);this.h=c.start(this.g,r,this.c)}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}j(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.k(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}}k(e,s){const r=this.g;r.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(r,s)))}}t.Scrollable=D;class w{constructor(e,s,r){this.scrollLeft=e,this.scrollTop=s,this.isDone=r}}t.SmoothScrollingUpdate=w;function f(n,e){const s=e-n;return function(r){return n+s*o(r)}}function u(n,e,s){return function(r){return r<s?n(r/s):e((r-s)/(1-s))}}class c{constructor(e,s,r,a){this.from=e,this.to=s,this.duration=a,this.startTime=r,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,r){if(Math.abs(e-s)>2.5*r){let h,p;return e<s?(h=e+.75*r,p=s-.75*r):(h=e-.75*r,p=s+.75*r),u(f(e,h),f(p,s),.33)}return f(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const r=this.c(s),a=this.d(s);return new w(r,a,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,r){return c.start(e,s,r)}static start(e,s,r){r=r+10;const a=Date.now()-10;return new c(e,s,a,r)}}t.SmoothScrollingOperation=c;function M(n){return Math.pow(n,3)}function o(n){return 1-M(1-n)}}),define(ge[11],me([1,0,109,44]),function(Q,t,E,P){"use strict";var U;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function i(q){return!q||typeof q!="string"?!0:q.trim().length===0}t.isFalsyOrWhitespace=i;const D=/{(\d+)}/g;function w(q,...le){return le.length===0?q:q.replace(D,function(be,ye){const Ce=parseInt(ye,10);return isNaN(Ce)||Ce<0||Ce>=le.length?be:le[Ce]})}t.format=w;const f=/{([^}]+)}/g;function u(q,le){return q.replace(f,(be,ye)=>le[ye]??be)}t.format2=u;function c(q){return q.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.escape=c;function M(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=M;function o(q,le){let be=0;const ye=le.charCodeAt(0);for(let Ce=q.length-1;Ce>=0;Ce--)q.charCodeAt(Ce)===ye&&be++;return be}t.count=o;function n(q,le,be="\u2026"){return q.length<=le?q:`${q.substr(0,le)}${be}`}t.truncate=n;function e(q,le=" "){const be=s(q,le);return r(be,le)}t.trim=e;function s(q,le){if(!q||!le)return q;const be=le.length;if(be===0||q.length===0)return q;let ye=0;for(;q.indexOf(le,ye)===ye;)ye=ye+be;return q.substring(ye)}t.ltrim=s;function r(q,le){if(!q||!le)return q;const be=le.length,ye=q.length;if(be===0||ye===0)return q;let Ce=ye,Re=-1;for(;Re=q.lastIndexOf(le,Ce-1),!(Re===-1||Re+be!==Ce);){if(Re===0)return"";Ce=Re}return q.substring(0,Ce)}t.rtrim=r;function a(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=a;function h(q){return q.replace(/\*/g,"")}t.stripWildcards=h;function p(q,le,be={}){if(!q)throw new Error("Cannot create regex from empty string");le||(q=M(q)),be.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ye="";return be.global&&(ye+="g"),be.matchCase||(ye+="i"),be.multiline&&(ye+="m"),be.unicode&&(ye+="u"),new RegExp(q,ye)}t.createRegExp=p;function T(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}t.regExpLeadsToEndlessLoop=T;function A(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=A;function m(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}t.regExpFlags=m;function C(q){return q.split(/\r\n|\r|\n/)}t.splitLines=C;function N(q){for(let le=0,be=q.length;le<be;le++){const ye=q.charCodeAt(le);if(ye!==32&&ye!==9)return le}return-1}t.firstNonWhitespaceIndex=N;function L(q,le=0,be=q.length){for(let ye=le;ye<be;ye++){const Ce=q.charCodeAt(ye);if(Ce!==32&&Ce!==9)return q.substring(le,ye)}return q.substring(le,be)}t.getLeadingWhitespace=L;function d(q,le=q.length-1){for(let be=le;be>=0;be--){const ye=q.charCodeAt(be);if(ye!==32&&ye!==9)return be}return-1}t.lastNonWhitespaceIndex=d;function v(q,le,be){const ye=[];let Ce=0;for(const Re of q.matchAll(le)){if(ye.push(q.slice(Ce,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ce=Re.index+Re[0].length,ye.push(be(Re[0],...Re.slice(1),Re.index,q,Re.groups))}return ye.push(q.slice(Ce)),Promise.all(ye).then(Re=>Re.join(""))}t.replaceAsync=v;function b(q,le){return q<le?-1:q>le?1:0}t.compare=b;function y(q,le,be=0,ye=q.length,Ce=0,Re=le.length){for(;be<ye&&Ce<Re;be++,Ce++){const Ne=q.charCodeAt(be),oe=le.charCodeAt(Ce);if(Ne<oe)return-1;if(Ne>oe)return 1}const xe=ye-be,tt=Re-Ce;return xe<tt?-1:xe>tt?1:0}t.compareSubstring=y;function R(q,le){return V(q,le,0,q.length,0,le.length)}t.compareIgnoreCase=R;function V(q,le,be=0,ye=q.length,Ce=0,Re=le.length){for(;be<ye&&Ce<Re;be++,Ce++){let Ne=q.charCodeAt(be),oe=le.charCodeAt(Ce);if(Ne===oe)continue;if(Ne>=128||oe>=128)return y(q.toLowerCase(),le.toLowerCase(),be,ye,Ce,Re);Z(Ne)&&(Ne-=32),Z(oe)&&(oe-=32);const Ee=Ne-oe;if(Ee!==0)return Ee}const xe=ye-be,tt=Re-Ce;return xe<tt?-1:xe>tt?1:0}t.compareSubstringIgnoreCase=V;function ee(q){return q>=48&&q<=57}t.isAsciiDigit=ee;function Z(q){return q>=97&&q<=122}t.isLowerAsciiLetter=Z;function J(q){return q>=65&&q<=90}t.isUpperAsciiLetter=J;function re(q,le){return q.length===le.length&&V(q,le)===0}t.equalsIgnoreCase=re;function he(q,le){const be=le.length;return le.length>q.length?!1:V(q,le,0,be)===0}t.startsWithIgnoreCase=he;function de(q,le){const be=Math.min(q.length,le.length);let ye;for(ye=0;ye<be;ye++)if(q.charCodeAt(ye)!==le.charCodeAt(ye))return ye;return be}t.commonPrefixLength=de;function ce(q,le){const be=Math.min(q.length,le.length);let ye;const Ce=q.length-1,Re=le.length-1;for(ye=0;ye<be;ye++)if(q.charCodeAt(Ce-ye)!==le.charCodeAt(Re-ye))return ye;return be}t.commonSuffixLength=ce;function pe(q){return 55296<=q&&q<=56319}t.isHighSurrogate=pe;function Te(q){return 56320<=q&&q<=57343}t.isLowSurrogate=Te;function Pe(q,le){return(q-55296<<10)+(le-56320)+65536}t.computeCodePoint=Pe;function Oe(q,le,be){const ye=q.charCodeAt(be);if(pe(ye)&&be+1<le){const Ce=q.charCodeAt(be+1);if(Te(Ce))return Pe(ye,Ce)}return ye}t.getNextCodePoint=Oe;function x(q,le){const be=q.charCodeAt(le-1);if(Te(be)&&le>1){const ye=q.charCodeAt(le-2);if(pe(ye))return Pe(ye,be)}return be}class G{get offset(){return this.e}constructor(le,be=0){this.c=le,this.d=le.length,this.e=be}setOffset(le){this.e=le}prevCodePoint(){const le=x(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=Oe(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}t.CodePointIterator=G;class ie{get offset(){return this.c.offset}constructor(le,be=0){this.c=new G(le,be)}nextGraphemeLength(){const le=$e.getInstance(),be=this.c,ye=be.offset;let Ce=le.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Re=be.offset,xe=le.getGraphemeBreakType(be.nextCodePoint());if(Me(Ce,xe)){be.setOffset(Re);break}Ce=xe}return be.offset-ye}prevGraphemeLength(){const le=$e.getInstance(),be=this.c,ye=be.offset;let Ce=le.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Re=be.offset,xe=le.getGraphemeBreakType(be.prevCodePoint());if(Me(xe,Ce)){be.setOffset(Re);break}Ce=xe}return ye-be.offset}eol(){return this.c.eol()}}t.GraphemeIterator=ie;function se(q,le){return new ie(q,le).nextGraphemeLength()}t.nextCharLength=se;function ae(q,le){return new ie(q,le).prevGraphemeLength()}t.prevCharLength=ae;function te(q,le){le>0&&Te(q.charCodeAt(le))&&le--;const be=le+se(q,le);return[be-ae(q,be),be]}t.getCharContainingOffset=te;function $(q){const le=new ie(q);let be=0;for(;!le.eol();)be++,le.nextGraphemeLength();return be}t.charCount=$;let g;function l(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function k(q){return g||(g=l()),g.test(q)}t.containsRTL=k;const W=/^[\t\n\r\x20-\x7E]*$/;function j(q){return W.test(q)}t.isBasicASCII=j,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function F(q){return t.UNUSUAL_LINE_TERMINATORS.test(q)}t.containsUnusualLineTerminators=F;function I(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}t.isFullWidthCharacter=I;function O(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}t.isEmojiImprecise=O;function S(q,le){if(q.length<le)return q;const be=/\b/g;let ye=0;for(;be.test(q)&&!(q.length-be.lastIndex<le);)ye=be.lastIndex,be.lastIndex+=1;return q.substring(ye).replace(/^\s/,"")}t.lcut=S;const B=/\x1B\x5B[12]?K/g,H=/\x1b\[\d+m/g,z=/\x1b\[0?m/g;function _(q){return q&&(q=q.replace(B,""),q=q.replace(H,""),q=q.replace(z,"")),q}t.removeAnsiEscapeCodes=_,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Y(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}t.startsWithUTF8BOM=Y;function ne(q){return Y(q)?q.substr(1):q}t.stripUTF8BOM=ne;function ue(q,le){if(!q||!le||q.length<le.length)return!1;const be=le.length,ye=q.toLowerCase();let Ce=0,Re=-1;for(;Ce<be;){const xe=ye.indexOf(le[Ce],Re+1);if(xe<0)return!1;Re=xe,Ce++}return!0}t.fuzzyContains=ue;function we(q,le=!1){return q?(le&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}t.containsUppercaseCharacter=we;function De(q){return q.charAt(0).toUpperCase()+q.slice(1)}t.uppercaseFirstLetter=De;function Le(q,le=1){if(le===0)return"";let be=-1;do be=q.indexOf(`
`,be+1),le--;while(le>0&&be>=0);return be===-1?q:(q[be-1]==="\r"&&be--,q.substr(0,be))}t.getNLines=Le;function Ae(q){return q=q%(2*26),q<26?String.fromCharCode(97+q):String.fromCharCode(65+q-26)}t.singleLetterHash=Ae;function ve(q){return $e.getInstance().getGraphemeBreakType(q)}t.getGraphemeBreakType=ve;function Me(q,le){return q===0?le!==5&&le!==7:q===2&&le===3?!1:q===4||q===2||q===3||le===4||le===2||le===3?!0:!(q===8&&(le===8||le===9||le===11||le===12)||(q===11||q===9)&&(le===9||le===10)||(q===12||q===10)&&le===10||le===5||le===13||le===7||q===1||q===13&&le===14||q===6&&le===6)}var Ie;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=t.GraphemeBreakType||(t.GraphemeBreakType={}));class $e{static getInstance(){return $e.c||($e.c=new $e),$e.c}constructor(){this.d=ze()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const be=this.d,ye=be.length/3;let Ce=1;for(;Ce<=ye;)if(le<be[3*Ce])Ce=2*Ce;else if(le>be[3*Ce+1])Ce=2*Ce+1;else return be[3*Ce+2];return 0}}$e.c=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(q,le){if(q===0)return 0;const be=Je(q,le);if(be!==void 0)return be;const ye=new G(le,q);return ye.prevCodePoint(),ye.offset}t.getLeftDeleteOffset=We;function Je(q,le){const be=new G(le,q);let ye=be.prevCodePoint();for(;it(ye)||ye===65039||ye===8419;){if(be.offset===0)return;ye=be.prevCodePoint()}if(!O(ye))return;let Ce=be.offset;return Ce>0&&be.prevCodePoint()===8205&&(Ce=be.offset),Ce}function it(q){return 127995<=q&&q<=127999}var Be;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.noBreakWhitespace="\xA0";class je{static getInstance(le){return je.d.get(Array.from(le))}static getLocales(){return je.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=je,U=je,je.c=new P.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.d=new E.LRUCachedFunction(q=>{function le(oe){const Ee=new Map;for(let Fe=0;Fe<oe.length;Fe+=2)Ee.set(oe[Fe],oe[Fe+1]);return Ee}function be(oe,Ee){const Fe=new Map(oe);for(const[Ue,Ke]of Ee)Fe.set(Ue,Ke);return Fe}function ye(oe,Ee){if(!oe)return Ee;const Fe=new Map;for(const[Ue,Ke]of oe)Ee.has(Ue)&&Fe.set(Ue,Ke);return Fe}const Ce=U.c.value;let Re=q.filter(oe=>!oe.startsWith("_")&&oe in Ce);Re.length===0&&(Re=["_default"]);let xe;for(const oe of Re){const Ee=le(Ce[oe]);xe=ye(xe,Ee)}const tt=le(Ce._common),Ne=be(tt,xe);return new je(Ne)}),je.e=new P.Lazy(()=>Object.keys(je.c.value).filter(q=>!q.startsWith("_")));class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(le){return Ge.e().has(le)}static get codePoints(){return Ge.e()}}t.InvisibleCharacters=Ge,Ge.d=void 0}),define(ge[110],me([1,0,22,5,11,6]),function(Q,t,E,P,U,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function D(d){return d===47||d===92}t.isPathSeparator=D;function w(d){return d.replace(/[\\/]/g,E.posix.sep)}t.toSlashes=w;function f(d){return d.indexOf("/")===-1&&(d=w(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}t.toPosixPath=f;function u(d,v=E.posix.sep){if(!d)return"";const b=d.length,y=d.charCodeAt(0);if(D(y)){if(D(d.charCodeAt(1))&&!D(d.charCodeAt(2))){let V=3;const ee=V;for(;V<b&&!D(d.charCodeAt(V));V++);if(ee!==V&&!D(d.charCodeAt(V+1))){for(V+=1;V<b;V++)if(D(d.charCodeAt(V)))return d.slice(0,V+1).replace(/[\\/]/g,v)}}return v}else if(a(y)&&d.charCodeAt(1)===58)return D(d.charCodeAt(2))?d.slice(0,2)+v:d.slice(0,2);let R=d.indexOf("://");if(R!==-1){for(R+=3;R<b;R++)if(D(d.charCodeAt(R)))return d.slice(0,R+1)}return""}t.getRoot=u;function c(d){if(!P.isWindows||!d||d.length<5)return!1;let v=d.charCodeAt(0);if(v!==92||(v=d.charCodeAt(1),v!==92))return!1;let b=2;const y=b;for(;b<d.length&&(v=d.charCodeAt(b),v!==92);b++);return!(y===b||(v=d.charCodeAt(b+1),isNaN(v)||v===92))}t.isUNC=c;const M=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,n=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(d,v=P.isWindows){const b=v?M:o;return!(!d||d.length===0||/^\s+$/.test(d)||(b.lastIndex=0,b.test(d))||v&&n.test(d)||d==="."||d===".."||v&&d[d.length-1]==="."||v&&d.length!==d.trim().length||d.length>255)}t.isValidBasename=e;function s(d,v,b){const y=d===v;return!b||y?y:!d||!v?!1:(0,U.equalsIgnoreCase)(d,v)}t.isEqual=s;function r(d,v,b,y=E.sep){if(d===v)return!0;if(!d||!v||v.length>d.length)return!1;if(b){if(!(0,U.startsWithIgnoreCase)(d,v))return!1;if(v.length===d.length)return!0;let V=v.length;return v.charAt(v.length-1)===y&&V--,d.charAt(V)===y}return v.charAt(v.length-1)!==y&&(v+=y),d.indexOf(v)===0}t.isEqualOrParent=r;function a(d){return d>=65&&d<=90||d>=97&&d<=122}t.isWindowsDriveLetter=a;function h(d,v){return P.isWindows&&d.endsWith(":")&&(d+=E.sep),(0,E.isAbsolute)(d)||(d=(0,E.join)(v,d)),d=(0,E.normalize)(d),P.isWindows?(d=(0,U.rtrim)(d,E.sep),d.endsWith(":")&&(d+=E.sep)):(d=(0,U.rtrim)(d,E.sep),d||(d=E.sep)),d}t.sanitizeFilePath=h;function p(d){const v=(0,E.normalize)(d);return P.isWindows?d.length>3?!1:T(v)&&(d.length===2||v.charCodeAt(2)===92):v===E.posix.sep}t.isRootOrDriveLetter=p;function T(d,v=P.isWindows){return v?a(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}t.hasDriveLetter=T;function A(d){return T(d)?d[0]:void 0}t.getDriveLetter=A;function m(d,v,b){return v.length>d.length?-1:d===v?0:(b&&(d=d.toLowerCase(),v=v.toLowerCase()),d.indexOf(v))}t.indexOfPath=m;function C(d){const v=d.split(":");let b,y,R;for(const V of v){const ee=Number(V);(0,i.isNumber)(ee)?y===void 0?y=ee:R===void 0&&(R=ee):b=b?[b,V].join(":"):V}if(!b)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:b,line:y!==void 0?y:void 0,column:R!==void 0?R:y!==void 0?1:void 0}}t.parseLineAndColumnAware=C;const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function L(d,v,b=8){let y="";for(let V=0;V<b;V++)y+=N.charAt(Math.floor(Math.random()*N.length));let R;return v?R=`${v}-${y}`:R=y,d?(0,E.join)(d,R):R}t.randomPath=L}),define(ge[32],me([1,0,75,11]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function U(...H){return function(z,_){for(let Y=0,ne=H.length;Y<ne;Y++){const ue=H[Y](z,_);if(ue)return ue}return null}}t.or=U,t.matchesStrictPrefix=i.bind(void 0,!1),t.matchesPrefix=i.bind(void 0,!0);function i(H,z,_){if(!_||_.length<z.length)return null;let Y;return H?Y=P.startsWithIgnoreCase(_,z):Y=_.indexOf(z)===0,Y?z.length>0?[{start:0,end:z.length}]:[]:null}function D(H,z){const _=z.toLowerCase().indexOf(H.toLowerCase());return _===-1?null:[{start:_,end:_+H.length}]}t.matchesContiguousSubString=D;function w(H,z){return f(H.toLowerCase(),z.toLowerCase(),0,0)}t.matchesSubString=w;function f(H,z,_,Y){if(_===H.length)return[];if(Y===z.length)return null;if(H[_]===z[Y]){let ne=null;return(ne=f(H,z,_+1,Y+1))?a({start:Y,end:Y+1},ne):null}return f(H,z,_,Y+1)}function u(H){return 97<=H&&H<=122}function c(H){return 65<=H&&H<=90}t.isUpper=c;function M(H){return 48<=H&&H<=57}function o(H){return H===32||H===9||H===10||H===13}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(H=>n.add(H.charCodeAt(0)));function e(H){return o(H)||n.has(H)}function s(H,z){return H===z||e(H)&&e(z)}function r(H){return u(H)||c(H)||M(H)}function a(H,z){return z.length===0?z=[H]:H.end===z[0].start?z[0].start=H.start:z.unshift(H),z}function h(H,z){for(let _=z;_<H.length;_++){const Y=H.charCodeAt(_);if(c(Y)||M(Y)||_>0&&!r(H.charCodeAt(_-1)))return _}return H.length}function p(H,z,_,Y){if(_===H.length)return[];if(Y===z.length)return null;if(H[_]!==z[Y].toLowerCase())return null;{let ne=null,ue=Y+1;for(ne=p(H,z,_+1,Y+1);!ne&&(ue=h(z,ue))<z.length;)ne=p(H,z,_+1,ue),ue++;return ne===null?null:a({start:Y,end:Y+1},ne)}}function T(H){let z=0,_=0,Y=0,ne=0,ue=0;for(let ve=0;ve<H.length;ve++)ue=H.charCodeAt(ve),c(ue)&&z++,u(ue)&&_++,r(ue)&&Y++,M(ue)&&ne++;const we=z/H.length,De=_/H.length,Le=Y/H.length,Ae=ne/H.length;return{upperPercent:we,lowerPercent:De,alphaPercent:Le,numericPercent:Ae}}function A(H){const{upperPercent:z,lowerPercent:_}=H;return _===0&&z>.6}function m(H){const{upperPercent:z,lowerPercent:_,alphaPercent:Y,numericPercent:ne}=H;return _>.2&&z<.8&&Y>.6&&ne<.2}function C(H){let z=0,_=0,Y=0,ne=0;for(let ue=0;ue<H.length;ue++)Y=H.charCodeAt(ue),c(Y)&&z++,u(Y)&&_++,o(Y)&&ne++;return(z===0||_===0)&&ne===0?H.length<=30:z<=5}function N(H,z){if(!z||(z=z.trim(),z.length===0)||!C(H)||z.length>60)return null;const _=T(z);if(!m(_)){if(!A(_))return null;z=z.toLowerCase()}let Y=null,ne=0;for(H=H.toLowerCase();ne<z.length&&(Y=p(H,z,0,ne))===null;)ne=h(z,ne+1);return Y}t.matchesCamelCase=N;function L(H,z,_=!1){if(!z||z.length===0)return null;let Y=null,ne=0;for(H=H.toLowerCase(),z=z.toLowerCase();ne<z.length&&(Y=d(H,z,0,ne,_))===null;)ne=v(z,ne+1);return Y}t.matchesWords=L;function d(H,z,_,Y,ne){if(_===H.length)return[];if(Y===z.length)return null;if(s(H.charCodeAt(_),z.charCodeAt(Y))){let ue=null,we=Y+1;if(ue=d(H,z,_+1,Y+1,ne),!ne)for(;!ue&&(we=v(z,we))<z.length;)ue=d(H,z,_+1,we,ne),we++;return ue?H.charCodeAt(_)!==z.charCodeAt(Y)?ue:a({start:Y,end:Y+1},ue):null}else return null}function v(H,z){for(let _=z;_<H.length;_++)if(e(H.charCodeAt(_))||_>0&&e(H.charCodeAt(_-1)))return _;return H.length}const b=U(t.matchesPrefix,N,D),y=U(t.matchesPrefix,N,w),R=new E.LRUCache(1e4);function V(H,z,_=!1){if(typeof H!="string"||typeof z!="string")return null;let Y=R.get(H);Y||(Y=new RegExp(P.convertSimple2RegExpPattern(H),"i"),R.set(H,Y));const ne=Y.exec(z);return ne?[{start:ne.index,end:ne.index+ne[0].length}]:_?y(H,z):b(H,z)}t.matchesFuzzy=V;function ee(H,z){const _=W(H,H.toLowerCase(),0,z,z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?J(_):null}t.matchesFuzzy2=ee;function Z(H,z,_,Y,ne,ue){const we=Math.min(13,H.length);for(;_<we;_++){const De=W(H,z,_,Y,ne,ue,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,ue]}t.anyScore=Z;function J(H){if(typeof H>"u")return[];const z=[],_=H[1];for(let Y=H.length-1;Y>1;Y--){const ne=H[Y]+_,ue=z[z.length-1];ue&&ue.end===ne?ue.end=ne+1:z.push({start:ne,end:ne+1})}return z}t.createMatches=J;const re=128;function he(){const H=[],z=[];for(let _=0;_<=re;_++)z[_]=0;for(let _=0;_<=re;_++)H.push(z.slice(0));return H}function de(H){const z=[];for(let _=0;_<=H;_++)z[_]=0;return z}const ce=de(2*re),pe=de(2*re),Te=he(),Pe=he(),Oe=he(),x=!1;function G(H,z,_,Y,ne){function ue(De,Le,Ae=" "){for(;De.length<Le;)De=Ae+De;return De}let we=` |   |${Y.split("").map(De=>ue(De,3)).join("|")}
`;for(let De=0;De<=_;De++)De===0?we+=" |":we+=`${z[De-1]}|`,we+=H[De].slice(0,ne+1).map(Le=>ue(Le.toString(),3)).join("|")+`
`;return we}function ie(H,z,_,Y){H=H.substr(z),_=_.substr(Y),console.log(G(Pe,H,H.length,_,_.length)),console.log(G(Oe,H,H.length,_,_.length)),console.log(G(Te,H,H.length,_,_.length))}function se(H,z){if(z<0||z>=H.length)return!1;const _=H.codePointAt(z);switch(_){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(_)}}function ae(H,z){if(z<0||z>=H.length)return!1;switch(H.charCodeAt(z)){case 32:case 9:return!0;default:return!1}}function te(H,z,_){return z[H]!==_[H]}function $(H,z,_,Y,ne,ue,we=!1){for(;z<_&&ne<ue;)H[z]===Y[ne]&&(we&&(ce[z]=ne),z+=1),ne+=1;return z===_}t.isPatternInWord=$;var g;(function(H){H[H.Diag=1]="Diag",H[H.Left=2]="Left",H[H.LeftLeft=3]="LeftLeft"})(g||(g={}));var l;(function(H){H.Default=[-100,0];function z(_){return!_||_.length===2&&_[0]===-100&&_[1]===0}H.isDefault=z})(l=t.FuzzyScore||(t.FuzzyScore={}));class k{constructor(z,_){this.firstMatchCanBeWeak=z,this.boostFullMatch=_}}t.FuzzyScoreOptions=k,k.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function W(H,z,_,Y,ne,ue,we=k.default){const De=H.length>re?re:H.length,Le=Y.length>re?re:Y.length;if(_>=De||ue>=Le||De-_>Le-ue||!$(z,_,De,ne,ue,Le,!0))return;j(De,Le,_,ue,z,ne);let Ae=1,ve=1,Me=_,Ie=ue;const $e=[!1];for(Ae=1,Me=_;Me<De;Ae++,Me++){const Be=ce[Me],je=pe[Me],Ge=Me+1<De?pe[Me+1]:Le;for(ve=Be-ue+1,Ie=Be;Ie<Ge;ve++,Ie++){let q=Number.MIN_SAFE_INTEGER,le=!1;Ie<=je&&(q=F(H,z,Me,_,Y,ne,Ie,Le,ue,Te[Ae-1][ve-1]===0,$e));let be=0;q!==Number.MAX_SAFE_INTEGER&&(le=!0,be=q+Pe[Ae-1][ve-1]);const ye=Ie>Be,Ce=ye?Pe[Ae][ve-1]+(Te[Ae][ve-1]>0?-5:0):0,Re=Ie>Be+1&&Te[Ae][ve-1]>0,xe=Re?Pe[Ae][ve-2]+(Te[Ae][ve-2]>0?-5:0):0;if(Re&&(!ye||xe>=Ce)&&(!le||xe>=be))Pe[Ae][ve]=xe,Oe[Ae][ve]=3,Te[Ae][ve]=0;else if(ye&&(!le||Ce>=be))Pe[Ae][ve]=Ce,Oe[Ae][ve]=2,Te[Ae][ve]=0;else if(le)Pe[Ae][ve]=be,Oe[Ae][ve]=1,Te[Ae][ve]=Te[Ae-1][ve-1]+1;else throw new Error("not possible")}}if(x&&ie(H,_,Y,ue),!$e[0]&&!we.firstMatchCanBeWeak)return;Ae--,ve--;const ze=[Pe[Ae][ve],ue];let We=0,Je=0;for(;Ae>=1;){let Be=ve;do{const je=Oe[Ae][Be];if(je===3)Be=Be-2;else if(je===2)Be=Be-1;else break}while(Be>=1);We>1&&z[_+Ae-1]===ne[ue+ve-1]&&!te(Be+ue-1,Y,ne)&&We+1>Te[Ae][Be]&&(Be=ve),Be===ve?We++:We=1,Je||(Je=Be),Ae--,ve=Be-1,ze.push(ve)}Le===De&&we.boostFullMatch&&(ze[0]+=2);const it=Je-De;return ze[0]-=it,ze}t.fuzzyScore=W;function j(H,z,_,Y,ne,ue){let we=H-1,De=z-1;for(;we>=_&&De>=Y;)ne[we]===ue[De]&&(pe[we]=De,we--),De--}function F(H,z,_,Y,ne,ue,we,De,Le,Ae,ve){if(z[_]!==ue[we])return Number.MIN_SAFE_INTEGER;let Me=1,Ie=!1;return we===_-Y?Me=H[_]===ne[we]?7:5:te(we,ne,ue)&&(we===0||!te(we-1,ne,ue))?(Me=H[_]===ne[we]?7:5,Ie=!0):se(ue,we)&&(we===0||!se(ue,we-1))?Me=5:(se(ue,we-1)||ae(ue,we-1))&&(Me=5,Ie=!0),Me>1&&_===Y&&(ve[0]=!0),Ie||(Ie=te(we,ne,ue)||se(ue,we-1)||ae(ue,we-1)),_===Y?we>Le&&(Me-=Ie?3:5):Ae?Me+=Ie?2:0:Me+=Ie?0:1,we+1===De&&(Me-=Ie?3:5),Me}function I(H,z,_,Y,ne,ue,we){return S(H,z,_,Y,ne,ue,!0,we)}t.fuzzyScoreGracefulAggressive=I;function O(H,z,_,Y,ne,ue,we){return S(H,z,_,Y,ne,ue,!1,we)}t.fuzzyScoreGraceful=O;function S(H,z,_,Y,ne,ue,we,De){let Le=W(H,z,_,Y,ne,ue,De);if(Le&&!we)return Le;if(H.length>=3){const Ae=Math.min(7,H.length-1);for(let ve=_+1;ve<Ae;ve++){const Me=B(H,ve);if(Me){const Ie=W(Me,Me.toLowerCase(),_,Y,ne,ue,De);Ie&&(Ie[0]-=3,(!Le||Ie[0]>Le[0])&&(Le=Ie))}}}return Le}function B(H,z){if(z+1>=H.length)return;const _=H[z],Y=H[z+1];if(_!==Y)return H.slice(0,z)+Y+_+H.slice(z+2)}}),define(ge[111],me([1,0,11]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function P(a){return U(a,0)}t.hash=P;function U(a,h){switch(typeof a){case"object":return a===null?i(349,h):Array.isArray(a)?f(a,h):u(a,h);case"string":return w(a,h);case"boolean":return D(a,h);case"number":return i(a,h);case"undefined":return i(937,h);default:return i(617,h)}}t.doHash=U;function i(a,h){return(h<<5)-h+a|0}t.numberHash=i;function D(a,h){return i(a?433:863,h)}function w(a,h){h=i(149417,h);for(let p=0,T=a.length;p<T;p++)h=i(a.charCodeAt(p),h);return h}t.stringHash=w;function f(a,h){return h=i(104579,h),a.reduce((p,T)=>U(T,p),h)}function u(a,h){return h=i(181387,h),Object.keys(a).sort().reduce((p,T)=>(p=w(T,p),U(a[T],p)),h)}class c{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=U(h,this.g),this.g}}t.Hasher=c;var M;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function o(a,h,p=32){const T=p-h,A=~((1<<T)-1);return(a<<h|(A&a)>>>T)>>>0}function n(a,h=0,p=a.byteLength,T=0){for(let A=0;A<p;A++)a[h+A]=T}function e(a,h,p="0"){for(;a.length<h;)a=p+a;return a}function s(a,h=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(p=>p.toString(16).padStart(2,"0")).join(""):e((a>>>0).toString(16),h/4)}t.toHexString=s;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const p=h.length;if(p===0)return;const T=this.p;let A=this.r,m=this.u,C,N;for(m!==0?(C=m,N=-1,m=0):(C=h.charCodeAt(0),N=0);;){let L=C;if(E.isHighSurrogate(C))if(N+1<p){const d=h.charCodeAt(N+1);E.isLowSurrogate(d)?(N++,L=E.computeCodePoint(C,d)):L=65533}else{m=C;break}else E.isLowSurrogate(C)&&(L=65533);if(A=this.w(T,A,L),N++,N<p)C=h.charCodeAt(N);else break}this.r=A,this.u=m}w(h,p,T){return T<128?h[p++]=T:T<2048?(h[p++]=192|(T&1984)>>>6,h[p++]=128|(T&63)>>>0):T<65536?(h[p++]=224|(T&61440)>>>12,h[p++]=128|(T&4032)>>>6,h[p++]=128|(T&63)>>>0):(h[p++]=240|(T&1835008)>>>18,h[p++]=128|(T&258048)>>>12,h[p++]=128|(T&4032)>>>6,h[p++]=128|(T&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,n(this.p,this.r),this.r>56&&(this.y(),n(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=r.g,p=this.q;for(let b=0;b<64;b+=4)h.setUint32(b,p.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)h.setUint32(b,o(h.getUint32(b-12,!1)^h.getUint32(b-32,!1)^h.getUint32(b-56,!1)^h.getUint32(b-64,!1),1),!1);let T=this.h,A=this.l,m=this.m,C=this.n,N=this.o,L,d,v;for(let b=0;b<80;b++)b<20?(L=A&m|~A&C,d=1518500249):b<40?(L=A^m^C,d=1859775393):b<60?(L=A&m|A&C|m&C,d=2400959708):(L=A^m^C,d=3395469782),v=o(T,5)+L+N+d+h.getUint32(b*4,!1)&4294967295,N=C,C=m,m=o(A,30),A=T,T=v;this.h=this.h+T&4294967295,this.l=this.l+A&4294967295,this.m=this.m+m&4294967295,this.n=this.n+C&4294967295,this.o=this.o+N&4294967295}}t.StringSHA1=r,r.g=new DataView(new ArrayBuffer(320))}),define(ge[112],me([1,0,71,111]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class U{constructor(o){this.a=o}getElements(){const o=this.a,n=new Int32Array(o.length);for(let e=0,s=o.length;e<s;e++)n[e]=o.charCodeAt(e);return n}}t.StringDiffSequence=U;function i(M,o,n){return new c(new U(M),new U(o)).ComputeDiff(n).changes}t.stringDiff=i;class D{static Assert(o,n){if(!o)throw new Error(n)}}class w{static Copy(o,n,e,s,r){for(let a=0;a<r;a++)e[s+a]=o[n+a]}static Copy2(o,n,e,s,r){for(let a=0;a<r;a++)e[s+a]=o[n+a]}}var f;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(f||(f={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new E.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(o,n){this.b=Math.min(this.b,o),this.c=Math.min(this.c,n),this.d++}AddModifiedElement(o,n){this.b=Math.min(this.b,o),this.c=Math.min(this.c,n),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(o,n,e=null){this.a=e,this.b=o,this.c=n;const[s,r,a]=c.o(o),[h,p,T]=c.o(n);this.d=a&&T,this.e=s,this.f=r,this.g=h,this.h=p,this.k=[],this.m=[]}static n(o){return o.length>0&&typeof o[0]=="string"}static o(o){const n=o.getElements();if(c.n(n)){const e=new Int32Array(n.length);for(let s=0,r=n.length;s<r;s++)e[s]=(0,P.stringHash)(n[s],0);return[n,e,!0]}return n instanceof Int32Array?[[],n,!1]:[[],new Int32Array(n),!1]}p(o,n){return this.f[o]!==this.h[n]?!1:this.d?this.e[o]===this.g[n]:!0}q(o,n){if(!this.p(o,n))return!1;const e=c.r(this.b,o),s=c.r(this.c,n);return e===s}static r(o,n){return typeof o.getStrictElement=="function"?o.getStrictElement(n):null}s(o,n){return this.f[o]!==this.f[n]?!1:this.d?this.e[o]===this.e[n]:!0}u(o,n){return this.h[o]!==this.h[n]?!1:this.d?this.g[o]===this.g[n]:!0}ComputeDiff(o){return this.v(0,this.f.length-1,0,this.h.length-1,o)}v(o,n,e,s,r){const a=[!1];let h=this.w(o,n,e,s,a);return r&&(h=this.z(h)),{quitEarly:a[0],changes:h}}w(o,n,e,s,r){for(r[0]=!1;o<=n&&e<=s&&this.p(o,e);)o++,e++;for(;n>=o&&s>=e&&this.p(n,s);)n--,s--;if(o>n||e>s){let m;return e<=s?(D.Assert(o===n+1,"originalStart should only be one more than originalEnd"),m=[new E.DiffChange(o,0,e,s-e+1)]):o<=n?(D.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),m=[new E.DiffChange(o,n-o+1,e,0)]):(D.Assert(o===n+1,"originalStart should only be one more than originalEnd"),D.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),m=[]),m}const a=[0],h=[0],p=this.y(o,n,e,s,a,h,r),T=a[0],A=h[0];if(p!==null)return p;if(!r[0]){const m=this.w(o,T,e,A,r);let C=[];return r[0]?C=[new E.DiffChange(T+1,n-(T+1)+1,A+1,s-(A+1)+1)]:C=this.w(T+1,n,A+1,s,r),this.H(m,C)}return[new E.DiffChange(o,n-o+1,e,s-e+1)]}x(o,n,e,s,r,a,h,p,T,A,m,C,N,L,d,v,b,y){let R=null,V=null,ee=new u,Z=n,J=e,re=N[0]-v[0]-s,he=-1073741824,de=this.k.length-1;do{const ce=re+o;ce===Z||ce<J&&T[ce-1]<T[ce+1]?(m=T[ce+1],L=m-re-s,m<he&&ee.MarkNextChange(),he=m,ee.AddModifiedElement(m+1,L),re=ce+1-o):(m=T[ce-1]+1,L=m-re-s,m<he&&ee.MarkNextChange(),he=m-1,ee.AddOriginalElement(m,L+1),re=ce-1-o),de>=0&&(T=this.k[de],o=T[0],Z=1,J=T.length-1)}while(--de>=-1);if(R=ee.getReverseChanges(),y[0]){let ce=N[0]+1,pe=v[0]+1;if(R!==null&&R.length>0){const Te=R[R.length-1];ce=Math.max(ce,Te.getOriginalEnd()),pe=Math.max(pe,Te.getModifiedEnd())}V=[new E.DiffChange(ce,C-ce+1,pe,d-pe+1)]}else{ee=new u,Z=a,J=h,re=N[0]-v[0]-p,he=1073741824,de=b?this.m.length-1:this.m.length-2;do{const ce=re+r;ce===Z||ce<J&&A[ce-1]>=A[ce+1]?(m=A[ce+1]-1,L=m-re-p,m>he&&ee.MarkNextChange(),he=m+1,ee.AddOriginalElement(m+1,L+1),re=ce+1-r):(m=A[ce-1],L=m-re-p,m>he&&ee.MarkNextChange(),he=m,ee.AddModifiedElement(m+1,L+1),re=ce-1-r),de>=0&&(A=this.m[de],r=A[0],Z=1,J=A.length-1)}while(--de>=-1);V=ee.getChanges()}return this.H(R,V)}y(o,n,e,s,r,a,h){let p=0,T=0,A=0,m=0,C=0,N=0;o--,e--,r[0]=0,a[0]=0,this.k=[],this.m=[];const L=n-o+(s-e),d=L+1,v=new Int32Array(d),b=new Int32Array(d),y=s-e,R=n-o,V=o-e,ee=n-s,J=(R-y)%2===0;v[y]=o,b[R]=n,h[0]=!1;for(let re=1;re<=L/2+1;re++){let he=0,de=0;A=this.J(y-re,re,y,d),m=this.J(y+re,re,y,d);for(let pe=A;pe<=m;pe+=2){pe===A||pe<m&&v[pe-1]<v[pe+1]?p=v[pe+1]:p=v[pe-1]+1,T=p-(pe-y)-V;const Te=p;for(;p<n&&T<s&&this.p(p+1,T+1);)p++,T++;if(v[pe]=p,p+T>he+de&&(he=p,de=T),!J&&Math.abs(pe-R)<=re-1&&p>=b[pe])return r[0]=p,a[0]=T,Te<=b[pe]&&1447>0&&re<=1447+1?this.x(y,A,m,V,R,C,N,ee,v,b,p,n,r,T,s,a,J,h):null}const ce=(he-o+(de-e)-re)/2;if(this.a!==null&&!this.a(he,ce))return h[0]=!0,r[0]=he,a[0]=de,ce>0&&1447>0&&re<=1447+1?this.x(y,A,m,V,R,C,N,ee,v,b,p,n,r,T,s,a,J,h):(o++,e++,[new E.DiffChange(o,n-o+1,e,s-e+1)]);C=this.J(R-re,re,R,d),N=this.J(R+re,re,R,d);for(let pe=C;pe<=N;pe+=2){pe===C||pe<N&&b[pe-1]>=b[pe+1]?p=b[pe+1]-1:p=b[pe-1],T=p-(pe-R)-ee;const Te=p;for(;p>o&&T>e&&this.p(p,T);)p--,T--;if(b[pe]=p,J&&Math.abs(pe-y)<=re&&p<=v[pe])return r[0]=p,a[0]=T,Te>=v[pe]&&1447>0&&re<=1447+1?this.x(y,A,m,V,R,C,N,ee,v,b,p,n,r,T,s,a,J,h):null}if(re<=1447){let pe=new Int32Array(m-A+2);pe[0]=y-A+1,w.Copy2(v,A,pe,1,m-A+1),this.k.push(pe),pe=new Int32Array(N-C+2),pe[0]=R-C+1,w.Copy2(b,C,pe,1,N-C+1),this.m.push(pe)}}return this.x(y,A,m,V,R,C,N,ee,v,b,p,n,r,T,s,a,J,h)}z(o){for(let n=0;n<o.length;n++){const e=o[n],s=n<o.length-1?o[n+1].originalStart:this.f.length,r=n<o.length-1?o[n+1].modifiedStart:this.h.length,a=e.originalLength>0,h=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<r&&(!a||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!h||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const T=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!T)break;e.originalStart++,e.modifiedStart++}const p=[null];if(n<o.length-1&&this.I(o[n],o[n+1],p)){o[n]=p[0],o.splice(n+1,1),n--;continue}}for(let n=o.length-1;n>=0;n--){const e=o[n];let s=0,r=0;if(n>0){const m=o[n-1];s=m.originalStart+m.originalLength,r=m.modifiedStart+m.modifiedLength}const a=e.originalLength>0,h=e.modifiedLength>0;let p=0,T=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let m=1;;m++){const C=e.originalStart-m,N=e.modifiedStart-m;if(C<s||N<r||a&&!this.s(C,C+e.originalLength)||h&&!this.u(N,N+e.modifiedLength))break;const d=(C===s&&N===r?5:0)+this.G(C,e.originalLength,N,e.modifiedLength);d>T&&(T=d,p=m)}e.originalStart-=p,e.modifiedStart-=p;const A=[null];if(n>0&&this.I(o[n-1],o[n],A)){o[n-1]=A[0],o.splice(n,1),n++;continue}}if(this.d)for(let n=1,e=o.length;n<e;n++){const s=o[n-1],r=o[n],a=r.originalStart-s.originalStart-s.originalLength,h=s.originalStart,p=r.originalStart+r.originalLength,T=p-h,A=s.modifiedStart,m=r.modifiedStart+r.modifiedLength,C=m-A;if(a<5&&T<20&&C<20){const N=this.A(h,T,A,C,a);if(N){const[L,d]=N;(L!==s.originalStart+s.originalLength||d!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=L-s.originalStart,s.modifiedLength=d-s.modifiedStart,r.originalStart=L+a,r.modifiedStart=d+a,r.originalLength=p-r.originalStart,r.modifiedLength=m-r.modifiedStart)}}}return o}A(o,n,e,s,r){if(n<r||s<r)return null;const a=o+n-r+1,h=e+s-r+1;let p=0,T=0,A=0;for(let m=o;m<a;m++)for(let C=e;C<h;C++){const N=this.B(m,C,r);N>0&&N>p&&(p=N,T=m,A=C)}return p>0?[T,A]:null}B(o,n,e){let s=0;for(let r=0;r<e;r++){if(!this.p(o+r,n+r))return 0;s+=this.e[o+r].length}return s}C(o){return o<=0||o>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[o])}D(o,n){if(this.C(o)||this.C(o-1))return!0;if(n>0){const e=o+n;if(this.C(e-1)||this.C(e))return!0}return!1}E(o){return o<=0||o>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[o])}F(o,n){if(this.E(o)||this.E(o-1))return!0;if(n>0){const e=o+n;if(this.E(e-1)||this.E(e))return!0}return!1}G(o,n,e,s){const r=this.D(o,n)?1:0,a=this.F(e,s)?1:0;return r+a}H(o,n){const e=[];if(o.length===0||n.length===0)return n.length>0?n:o;if(this.I(o[o.length-1],n[0],e)){const s=new Array(o.length+n.length-1);return w.Copy(o,0,s,0,o.length-1),s[o.length-1]=e[0],w.Copy(n,1,s,o.length,n.length-1),s}else{const s=new Array(o.length+n.length);return w.Copy(o,0,s,0,o.length),w.Copy(n,0,s,o.length,n.length),s}}I(o,n,e){if(D.Assert(o.originalStart<=n.originalStart,"Left change is not less than or equal to right change"),D.Assert(o.modifiedStart<=n.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=n.originalStart||o.modifiedStart+o.modifiedLength>=n.modifiedStart){const s=o.originalStart;let r=o.originalLength;const a=o.modifiedStart;let h=o.modifiedLength;return o.originalStart+o.originalLength>=n.originalStart&&(r=n.originalStart+n.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=n.modifiedStart&&(h=n.modifiedStart+n.modifiedLength-o.modifiedStart),e[0]=new E.DiffChange(s,r,a,h),!0}else return e[0]=null,!1}J(o,n,e,s){if(o>=0&&o<s)return o;const r=e,a=s-e-1,h=n%2===0;if(o<0){const p=r%2===0;return h===p?0:1}else{const p=a%2===0;return h===p?s-1:s-2}}}t.LcsDiff=c}),define(ge[33],me([1,0,32,11,17]),function(Q,t,E,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const i="$(",D=new RegExp(`\\$\\(${U.ThemeIcon.iconNameExpression}(?:${U.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${D.source}`,"g");function f(r){return r.replace(w,(a,h)=>h?a:`\\${a}`)}t.escapeIcons=f;const u=new RegExp(`\\\\${D.source}`,"g");function c(r){return r.replace(u,a=>`\\${a}`)}t.markdownEscapeEscapedIcons=c;const M=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function o(r){return r.indexOf(i)===-1?r:r.replace(M,(a,h,p,T)=>p?a:h||T||"")}t.stripIcons=o;const n=new RegExp(`\\$\\(${U.ThemeIcon.iconNameCharacter}+\\)`,"g");function e(r){n.lastIndex=0;let a="";const h=[];let p=0;for(;;){const T=n.lastIndex,A=n.exec(r),m=r.substring(T,A?.index);if(m.length>0){a+=m;for(let C=0;C<m.length;C++)h.push(p)}if(!A)break;p+=A[0].length}return{text:a,iconOffsets:h}}t.parseLabelWithIcons=e;function s(r,a,h=!1){const{text:p,iconOffsets:T}=a;if(!T||T.length===0)return(0,E.matchesFuzzy)(r,p,h);const A=(0,P.ltrim)(p," "),m=p.length-A.length,C=(0,E.matchesFuzzy)(r,A,h);if(C)for(const N of C){const L=T[N.start+m]+m;N.start+=L,N.end+=L}return C}t.matchesFuzzyIconAware=s}),define(ge[113],me([1,0,13,11]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class U{constructor(){this.b="",this.c=0}reset(n){return this.b=n,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(n){const e=n.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.StringIterator=U;class i{constructor(n=!0){this.e=n}reset(n){return this.b=n,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let n=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(n)this.c++;else break;else n=!1;return this}cmp(n){return this.e?(0,P.compareSubstring)(n,this.b,0,n.length,this.c,this.d):(0,P.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=i;class D{constructor(n=!0,e=!0){this.f=n,this.g=e}reset(n){this.d=0,this.e=0,this.b=n,this.c=n.length;for(let e=n.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let n=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(n)this.d++;else break;else n=!1}return this}cmp(n){return this.g?(0,P.compareSubstring)(n,this.b,0,n.length,this.d,this.e):(0,P.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=D;var w;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(w||(w={}));class f{constructor(n,e){this.f=n,this.g=e,this.d=[],this.e=0}reset(n){return this.c=n,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(n)),this.b.reset(n.path),this.b.value()&&this.d.push(3)),this.g(n)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(n){if(this.d[this.e]===1)return(0,P.compareIgnoreCase)(n,this.c.scheme);if(this.d[this.e]===2)return(0,P.compareIgnoreCase)(n,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(n);if(this.d[this.e]===4)return(0,P.compare)(n,this.c.query);if(this.d[this.e]===5)return(0,P.compare)(n,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=f;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(c||(c={}));class M{static forUris(n=()=>!1,e=()=>!1){return new M(new f(n,e))}static forPaths(n=!1){return new M(new D(void 0,!n))}static forStrings(){return new M(new U)}static forConfigKeys(){return new M(new i)}constructor(n){this.b=n}clear(){this.c=void 0}fill(n,e){if(e){const s=e.slice(0);(0,E.shuffle)(s);for(const r of s)this.set(r,n)}else{const s=n.slice(0);(0,E.shuffle)(s);for(const r of s)this.set(r[0],r[1])}}set(n,e){const s=this.b.reset(n);let r;this.c||(this.c=new u,this.c.segment=s.value());const a=[];for(r=this.c;;){const p=s.cmp(r.segment);if(p>0)r.left||(r.left=new u,r.left.segment=s.value()),a.push([-1,r]),r=r.left;else if(p<0)r.right||(r.right=new u,r.right.segment=s.value()),a.push([1,r]),r=r.right;else if(s.hasNext())s.next(),r.mid||(r.mid=new u,r.mid.segment=s.value()),a.push([0,r]),r=r.mid;else break}const h=r.value;r.value=e,r.key=n;for(let p=a.length-1;p>=0;p--){const T=a[p][1];T.updateHeight();const A=T.balanceFactor();if(A<-1||A>1){const m=a[p][0],C=a[p+1][0];if(m===1&&C===1)a[p][1]=T.rotateLeft();else if(m===-1&&C===-1)a[p][1]=T.rotateRight();else if(m===1&&C===-1)T.right=a[p+1][1]=a[p+1][1].rotateRight(),a[p][1]=T.rotateLeft();else if(m===-1&&C===1)T.left=a[p+1][1]=a[p+1][1].rotateLeft(),a[p][1]=T.rotateRight();else throw new Error;if(p>0)switch(a[p-1][0]){case-1:a[p-1][1].left=a[p][1];break;case 1:a[p-1][1].right=a[p][1];break;case 0:a[p-1][1].mid=a[p][1];break}else this.c=a[0][1]}}return h}get(n){return this.d(n)?.value}d(n){const e=this.b.reset(n);let s=this.c;for(;s;){const r=e.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(n){const e=this.d(n);return!(e?.value===void 0&&e?.mid===void 0)}delete(n){return this.e(n,!1)}deleteSuperstr(n){return this.e(n,!0)}e(n,e){const s=this.b.reset(n),r=[];let a=this.c;for(;a;){const h=s.cmp(a.segment);if(h>0)r.push([-1,a]),a=a.left;else if(h<0)r.push([1,a]),a=a.right;else if(s.hasNext())s.next(),r.push([0,a]),a=a.mid;else break}if(!!a){if(e?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const h=this.f(a.right);if(h.key){const{key:p,value:T,segment:A}=h;this.e(h.key,!1),a.key=p,a.value=T,a.segment=A}}else{const h=a.left??a.right;if(r.length>0){const[p,T]=r[r.length-1];switch(p){case-1:T.left=h;break;case 0:T.mid=h;break;case 1:T.right=h;break}}else this.c=h}for(let h=r.length-1;h>=0;h--){const p=r[h][1];p.updateHeight();const T=p.balanceFactor();if(T>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),r[h][1]=p.rotateLeft()):T<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),r[h][1]=p.rotateRight()),h>0)switch(r[h-1][0]){case-1:r[h-1][1].left=r[h][1];break;case 1:r[h-1][1].right=r[h][1];break;case 0:r[h-1][1].mid=r[h][1];break}else this.c=r[0][1]}}}f(n){for(;n.left;)n=n.left;return n}findSubstr(n){const e=this.b.reset(n);let s=this.c,r;for(;s;){const a=e.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(e.hasNext())e.next(),r=s.value||r,s=s.mid;else break}return s&&s.value||r}findSuperstr(n){return this.g(n,!1)}g(n,e){const s=this.b.reset(n);let r=this.c;for(;r;){const a=s.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this.h(r.mid):e?r.value:void 0}}hasElementOrSubtree(n){return this.g(n,!0)!==void 0}forEach(n){for(const[e,s]of this)n(s,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(n){const e=[];return this.j(n,e),e[Symbol.iterator]()}j(n,e){!n||(n.left&&this.j(n.left,e),n.value&&e.push([n.key,n.value]),n.mid&&this.j(n.mid,e),n.right&&this.j(n.right,e))}_isBalanced(){const n=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:n(e.left)&&n(e.right)};return n(this.c)}}t.TernarySearchTree=M}),define(ge[15],me([1,0,22,5]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const U=/^\w[\w\d+.-]*$/,i=/^\//,D=/^\/\//;function w(N,L){if(!N.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${N.authority}", path: "${N.path}", query: "${N.query}", fragment: "${N.fragment}"}`);if(N.scheme&&!U.test(N.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(N.path){if(N.authority){if(!i.test(N.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(N.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(N,L){return!N&&!L?"file":N}function u(N,L){switch(N){case"https":case"http":case"file":L?L[0]!==M&&(L=M+L):L=M;break}return L}const c="",M="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class n{static isUri(L){return L instanceof n?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,d,v,b,y,R=!1){typeof L=="object"?(this.scheme=L.scheme||c,this.authority=L.authority||c,this.path=L.path||c,this.query=L.query||c,this.fragment=L.fragment||c):(this.scheme=f(L,R),this.authority=d||c,this.path=u(this.scheme,v||c),this.query=b||c,this.fragment=y||c,w(this,R))}get fsPath(){return p(this,!1)}with(L){if(!L)return this;let{scheme:d,authority:v,path:b,query:y,fragment:R}=L;return d===void 0?d=this.scheme:d===null&&(d=c),v===void 0?v=this.authority:v===null&&(v=c),b===void 0?b=this.path:b===null&&(b=c),y===void 0?y=this.query:y===null&&(y=c),R===void 0?R=this.fragment:R===null&&(R=c),d===this.scheme&&v===this.authority&&b===this.path&&y===this.query&&R===this.fragment?this:new s(d,v,b,y,R)}static parse(L,d=!1){const v=o.exec(L);return v?new s(v[2]||c,C(v[4]||c),C(v[5]||c),C(v[7]||c),C(v[9]||c),d):new s(c,c,c,c,c)}static file(L){let d=c;if(P.isWindows&&(L=L.replace(/\\/g,M)),L[0]===M&&L[1]===M){const v=L.indexOf(M,2);v===-1?(d=L.substring(2),L=M):(d=L.substring(2,v),L=L.substring(v)||M)}return new s("file",d,L,c,c)}static from(L){const d=new s(L.scheme,L.authority,L.path,L.query,L.fragment);return w(d,!0),d}static joinPath(L,...d){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return P.isWindows&&L.scheme==="file"?v=n.file(E.win32.join(p(L,!0),...d)).path:v=E.posix.join(L.path,...d),L.with({path:v})}toString(L=!1){return T(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof n)return L;{const d=new s(L);return d._formatted=L.external,d._fsPath=L._sep===e?L.fsPath:null,d}}else return L}}t.URI=n;const e=P.isWindows?1:void 0;class s extends n{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(L=!1){return L?T(this,!0):(this._formatted||(this._formatted=T(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=e),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(N,L,d){let v,b=-1;for(let y=0;y<N.length;y++){const R=N.charCodeAt(y);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||L&&R===47||d&&R===91||d&&R===93||d&&R===58)b!==-1&&(v+=encodeURIComponent(N.substring(b,y)),b=-1),v!==void 0&&(v+=N.charAt(y));else{v===void 0&&(v=N.substr(0,y));const V=r[R];V!==void 0?(b!==-1&&(v+=encodeURIComponent(N.substring(b,y)),b=-1),v+=V):b===-1&&(b=y)}}return b!==-1&&(v+=encodeURIComponent(N.substring(b))),v!==void 0?v:N}function h(N){let L;for(let d=0;d<N.length;d++){const v=N.charCodeAt(d);v===35||v===63?(L===void 0&&(L=N.substr(0,d)),L+=r[v]):L!==void 0&&(L+=N[d])}return L!==void 0?L:N}function p(N,L){let d;return N.authority&&N.path.length>1&&N.scheme==="file"?d=`//${N.authority}${N.path}`:N.path.charCodeAt(0)===47&&(N.path.charCodeAt(1)>=65&&N.path.charCodeAt(1)<=90||N.path.charCodeAt(1)>=97&&N.path.charCodeAt(1)<=122)&&N.path.charCodeAt(2)===58?L?d=N.path.substr(1):d=N.path[1].toLowerCase()+N.path.substr(2):d=N.path,P.isWindows&&(d=d.replace(/\//g,"\\")),d}t.uriToFsPath=p;function T(N,L){const d=L?h:a;let v="",{scheme:b,authority:y,path:R,query:V,fragment:ee}=N;if(b&&(v+=b,v+=":"),(y||b==="file")&&(v+=M,v+=M),y){let Z=y.indexOf("@");if(Z!==-1){const J=y.substr(0,Z);y=y.substr(Z+1),Z=J.lastIndexOf(":"),Z===-1?v+=d(J,!1,!1):(v+=d(J.substr(0,Z),!1,!1),v+=":",v+=d(J.substr(Z+1),!1,!0)),v+="@"}y=y.toLowerCase(),Z=y.lastIndexOf(":"),Z===-1?v+=d(y,!1,!0):(v+=d(y.substr(0,Z),!1,!0),v+=y.substr(Z))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const Z=R.charCodeAt(1);Z>=65&&Z<=90&&(R=`/${String.fromCharCode(Z+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const Z=R.charCodeAt(0);Z>=65&&Z<=90&&(R=`${String.fromCharCode(Z+32)}:${R.substr(2)}`)}v+=d(R,!0,!1)}return V&&(v+="?",v+=d(V,!1,!1)),ee&&(v+="#",v+=L?ee:a(ee,!1,!1)),v}function A(N){try{return decodeURIComponent(N)}catch{return N.length>3?N.substr(0,3)+A(N.substr(3)):N}}const m=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function C(N){return N.match(m)?N.replace(m,L=>A(L)):N}}),define(ge[50],me([1,0,29,11,15]),function(Q,t,E,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function i(u){return JSON.stringify(u,w)}t.stringify=i;function D(u){let c=JSON.parse(u);return c=f(c),c}t.parse=D;function w(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:(0,P.regExpFlags)(c)}:c}function f(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return U.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof E.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let M=0;M<u.length;++M)u[M]=f(u[M],c+1);else for(const M in u)Object.hasOwnProperty.call(u,M)&&(u[M]=f(u[M],c+1))}return u}t.revive=f}),define(ge[34],me([1,0,7,5,15]),function(Q,t,E,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var i;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebook="vscode-notebook",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractive="vscode-interactive",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(i=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${i.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${i.vscodeRemoteResource}`}set(c,M,o){this.a[c]=M,this.b[c]=o}setConnectionToken(c,M){this.c[c]=M}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(r){return E.onUnexpectedError(r),c}const M=c.authority;let o=this.a[M];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[M],e=this.c[M];let s=`path=${encodeURIComponent(c.path)}`;return typeof e=="string"&&(s+=`&${t.connectionTokenQueryName}=${encodeURIComponent(e)}`),U.URI.from({scheme:P.isWeb?this.d:i.vscodeRemoteResource,authority:`${o}:${n}`,path:this.f,query:s})}}t.RemoteAuthorities=new D,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class w{asBrowserUri(c){const M=this.b(c,Q);return this.uriToBrowserUri(M)}uriToBrowserUri(c){return c.scheme===i.vscodeRemote?t.RemoteAuthorities.rewrite(c):c.scheme===i.file&&(P.isNative||P.isWebWorker&&P.globals.origin===`${i.vscodeFileResource}://${w.a}`)?c.with({scheme:i.vscodeFileResource,authority:c.authority||w.a,query:null,fragment:null}):c}asFileUri(c){const M=this.b(c,Q);return this.uriToFileUri(M)}uriToFileUri(c){return c.scheme===i.vscodeFileResource?c.with({scheme:i.file,authority:c.authority!==w.a?c.authority:null,query:null,fragment:null}):c}b(c,M){return U.URI.isUri(c)?c:U.URI.parse(M.toUrl(c))}}w.a="vscode-app",t.FileAccess=new w;var f;(function(u){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(c.get("3"));const M="vscode-coi";function o(e){let s;typeof e=="string"?s=new URL(e).searchParams:e instanceof URL?s=e.searchParams:U.URI.isUri(e)&&(s=new URL(e.toString(!0)).searchParams);const r=s?.get(M);if(!!r)return c.get(r)}u.getHeadersFromQuery=o;function n(e,s,r){if(!globalThis.crossOriginIsolated)return;const a=s&&r?"3":r?"2":"1";e instanceof URLSearchParams?e.set(M,a):e[M]=a}u.addSearchParam=n})(f=t.COI||(t.COI={}))}),define(ge[35],me([1,0,110,34,22,5,11,15]),function(Q,t,E,P,U,i,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function f(n){return(0,w.uriToFsPath)(n,!0)}t.originalFSPath=f;class u{constructor(e){this.a=e}compare(e,s,r=!1){return e===s?0:(0,D.compare)(this.getComparisonKey(e,r),this.getComparisonKey(s,r))}isEqual(e,s,r=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,r)===this.getComparisonKey(s,r)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,r=!1){if(e.scheme===s.scheme){if(e.scheme===P.Schemas.file)return E.isEqualOrParent(f(e),f(s),this.a(e))&&e.query===s.query&&(r||e.fragment===s.fragment);if((0,t.isEqualAuthority)(e.authority,s.authority))return E.isEqualOrParent(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(r||e.fragment===s.fragment)}return!1}joinPath(e,...s){return w.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return U.posix.basename(e.path)}extname(e){return U.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===P.Schemas.file?s=w.URI.file(U.dirname(f(e))).path:(s=U.posix.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===P.Schemas.file?s=w.URI.file(U.normalize(f(e))).path:s=U.posix.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.isEqualAuthority)(e.authority,s.authority))return;if(e.scheme===P.Schemas.file){const h=U.relative(f(e),f(s));return i.isWindows?E.toSlashes(h):h}let r=e.path||"/";const a=s.path||"/";if(this.a(e)){let h=0;for(const p=Math.min(r.length,a.length);h<p&&!(r.charCodeAt(h)!==a.charCodeAt(h)&&r.charAt(h).toLowerCase()!==a.charAt(h).toLowerCase());h++);r=a.substr(0,h)+r.substr(h)}return U.posix.relative(r,a)}resolvePath(e,s){if(e.scheme===P.Schemas.file){const r=w.URI.file(U.resolve(f(e),s));return e.with({authority:r.authority,path:r.path})}return s=E.toPosixPath(s),e.with({path:U.posix.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,D.equalsIgnoreCase)(e,s)}hasTrailingPathSeparator(e,s=U.sep){if(e.scheme===P.Schemas.file){const r=f(e);return r.length>E.getRoot(r).length&&r[r.length-1]===s}else{const r=e.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=U.sep){return(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=U.sep){let r=!1;if(e.scheme===P.Schemas.file){const a=f(e);r=a!==void 0&&a.length===E.getRoot(a).length&&a[a.length-1]===s}else{s="/";const a=e.path;r=a.length===1&&a.charCodeAt(a.length-1)===47}return!r&&!(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path+"/"}):e}}t.ExtUri=u,t.extUri=new u(()=>!1),t.extUriBiasedIgnorePathCase=new u(n=>n.scheme===P.Schemas.file?!i.isLinux:!0),t.extUriIgnorePathCase=new u(n=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function c(n,e){const s=[];for(let r=0;r<n.length;r++){const a=e(n[r]);n.some((h,p)=>p===r?!1:(0,t.isEqualOrParent)(a,e(h)))||s.push(n[r])}return s}t.distinctParents=c;var M;(function(n){n.META_DATA_LABEL="label",n.META_DATA_DESCRIPTION="description",n.META_DATA_SIZE="size",n.META_DATA_MIME="mime";function e(s){const r=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(p=>{const[T,A]=p.split(":");T&&A&&r.set(T,A)});const h=s.path.substring(0,s.path.indexOf(";"));return h&&r.set(n.META_DATA_MIME,h),r}n.parseMetaData=e})(M=t.DataUri||(t.DataUri={}));function o(n,e,s){if(e){let r=n.path;return r&&r[0]!==U.posix.sep&&(r=U.posix.sep+r),n.with({scheme:s,authority:e,path:r})}return n.with({scheme:s})}t.toLocalResource=o}),define(ge[9],me([1,0,27,7,3,2,35,5]),function(Q,t,E,P,U,i,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function f(te){return!!te&&typeof te.then=="function"}t.isThenable=f;function u(te){const $=new E.CancellationTokenSource,g=te($.token),l=new Promise((k,W)=>{const j=$.token.onCancellationRequested(()=>{j.dispose(),$.dispose(),W(new P.CancellationError)});Promise.resolve(g).then(F=>{j.dispose(),$.dispose(),k(F)},F=>{j.dispose(),$.dispose(),W(F)})});return new class{cancel(){$.cancel()}then(k,W){return l.then(k,W)}catch(k){return this.then(void 0,k)}finally(k){return l.finally(k)}}}t.createCancelablePromise=u;function c(te,$,g){return new Promise((l,k)=>{const W=$.onCancellationRequested(()=>{W.dispose(),l(g)});te.then(l,k).finally(()=>W.dispose())})}t.raceCancellation=c;function M(te,$){return new Promise((g,l)=>{const k=$.onCancellationRequested(()=>{k.dispose(),l(new P.CancellationError)});te.then(g,l).finally(()=>k.dispose())})}t.raceCancellationError=M;async function o(te){let $=-1;const g=te.map((k,W)=>k.then(j=>($=W,j))),l=await Promise.race(g);return te.forEach((k,W)=>{W!==$&&k.cancel()}),l}t.raceCancellablePromises=o;function n(te,$,g){let l;const k=setTimeout(()=>{l?.(void 0),g?.()},$);return Promise.race([te.finally(()=>clearTimeout(k)),new Promise(W=>l=W)])}t.raceTimeout=n;function e(te){return new Promise(($,g)=>{const l=te();f(l)?l.then($,g):$(l)})}t.asPromise=e;class s{constructor(){this.a=null,this.b=null,this.d=null}queue($){if(this.a){if(this.d=$,!this.b){const g=()=>{this.b=null;const l=this.queue(this.d);return this.d=null,l};this.b=new Promise(l=>{this.a.then(g,g).then(l)})}return new Promise((g,l)=>{this.b.then(g,l)})}return this.a=$(),new Promise((g,l)=>{this.a.then(k=>{this.a=null,g(k)},k=>{this.a=null,l(k)})})}}t.Throttler=s;class r{constructor(){this.a=Promise.resolve(null)}queue($){return this.a=this.a.then(()=>$(),()=>$())}}t.Sequencer=r;class a{constructor(){this.a=new Map}queue($,g){const k=(this.a.get($)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.a.get($)===k&&this.a.delete($)});return this.a.set($,k),k}}t.SequencerByKey=a;const h=(te,$)=>{let g=!0;const l=setTimeout(()=>{g=!1,$()},te);return{isTriggered:()=>g,dispose:()=>{clearTimeout(l),g=!1}}},p=te=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,te())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class T{constructor($){this.defaultDelay=$,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger($,g=this.defaultDelay){this.g=$,this.h(),this.b||(this.b=new Promise((k,W)=>{this.d=k,this.f=W}).then(()=>{if(this.b=null,this.d=null,this.g){const k=this.g;return this.g=null,k()}}));const l=()=>{this.a=null,this.d?.(null)};return this.a=g===t.MicrotaskDelay?p(l):h(g,l),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=T;class A{constructor($){this.a=new T($),this.b=new s}trigger($,g){return this.a.trigger(()=>this.b.queue($),g)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=A;class m{constructor(){this.a=!1,this.b=new Promise(($,g)=>{this.d=$})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=m;class C extends m{constructor($){super(),this.f=setTimeout(()=>this.open(),$)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=C;function N(te,$){return $?new Promise((g,l)=>{const k=setTimeout(()=>{W.dispose(),g()},te),W=$.onCancellationRequested(()=>{clearTimeout(k),W.dispose(),l(new P.CancellationError)})}):u(g=>N(te,g))}t.timeout=N;function L(te,$=0){const g=setTimeout(te,$);return(0,i.toDisposable)(()=>clearTimeout(g))}t.disposableTimeout=L;function d(te){const $=[];let g=0;const l=te.length;function k(){return g<l?te[g++]():null}function W(j){j!=null&&$.push(j);const F=k();return F?F.then(W):Promise.resolve($)}return Promise.resolve(null).then(W)}t.sequence=d;function v(te,$=l=>!!l,g=null){let l=0;const k=te.length,W=()=>{if(l>=k)return Promise.resolve(g);const j=te[l++];return Promise.resolve(j()).then(I=>$(I)?Promise.resolve(I):W())};return W()}t.first=v;function b(te,$=l=>!!l,g=null){if(te.length===0)return Promise.resolve(g);let l=te.length;const k=()=>{l=-1;for(const W of te)W.cancel?.()};return new Promise((W,j)=>{for(const F of te)F.then(I=>{--l>=0&&$(I)?(k(),W(I)):l===0&&W(g)}).catch(I=>{--l>=0&&(k(),j(I))})})}t.firstParallel=b;class y{constructor($){this.a=0,this.d=$,this.f=[],this.b=0,this.g=new U.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue($){return this.a++,new Promise((g,l)=>{this.f.push({factory:$,c:g,e:l}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const $=this.f.shift();this.b++;const g=$.factory();g.then($.c,$.e),g.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=y;class R extends y{constructor(){super(1)}}t.Queue=R;class V{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const $=new Oe;return this.b.add($),$.p}d(){for(const[,$]of this.a)if($.size>0)return!1;return!0}queueFor($,g=D.extUri){const l=g.getComparisonKey($);let k=this.a.get(l);return k||(k=new R,U.Event.once(k.onDrained)(()=>{k?.dispose(),this.a.delete(l),this.f()}),this.a.set(l,k)),k}f(){!this.d()||this.g()}g(){for(const $ of this.b)$.complete();this.b.clear()}dispose(){for(const[,$]of this.a)$.dispose();this.a.clear(),this.g()}}t.ResourceQueue=V;class ee{constructor($,g){this.a=-1,typeof $=="function"&&typeof g=="number"&&this.setIfNotSet($,g)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet($,g){this.cancel(),this.a=setTimeout(()=>{this.a=-1,$()},g)}setIfNotSet($,g){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,$()},g))}}t.TimeoutTimer=ee;class Z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet($,g){this.cancel(),this.a=setInterval(()=>{$()},g)}}t.IntervalTimer=Z;class J{constructor($,g){this.b=-1,this.a=$,this.d=g,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule($=this.d){this.cancel(),this.b=setTimeout(this.f,$)}get delay(){return this.d}set delay($){this.d=$}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=J;class re{constructor($,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.a=$,this.b=g,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule($=this.b){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil($/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=re;class he extends J{constructor($,g){super($,g),this.j=[]}work($){this.j.push($),this.isScheduled()||this.schedule()}h(){const $=this.j;this.j=[],this.a?.($)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=he;class de extends i.Disposable{constructor($,g){super(),this.g=$,this.h=g,this.a=[],this.b=this.B(new i.MutableDisposable),this.f=!1}get pending(){return this.a.length}work($){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+$.length>this.g.maxBufferedWork)return!1}else if(this.pending+$.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const g of $)this.a.push(g);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=de,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=te=>{(0,w.setTimeout0)(()=>{if($)return;const g=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,g-Date.now())}}))});let $=!1;return{dispose(){$||($=!0)}}}:t.runWhenIdle=(te,$)=>{const g=requestIdleCallback(te,typeof $=="number"?{timeout:$}:void 0);let l=!1;return{dispose(){l||(l=!0,cancelIdleCallback(g))}}}}();class ce{constructor($){this.d=!1,this.a=()=>{try{this.f=$()}catch(g){this.g=g}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=ce;async function pe(te,$,g){let l;for(let k=0;k<g;k++)try{return await te()}catch(W){l=W,await N($)}throw l}t.retry=pe;class Te{hasPending($){return this.a?typeof $=="number"?this.a.taskId===$:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending($,g,l){return this.a={taskId:$,cancel:()=>l?.(),promise:g},g.then(()=>this.d($),()=>this.d($)),g}d($){this.a&&$===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const $=this.b;this.b=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this.b)this.b.run=$;else{let g,l;const k=new Promise((W,j)=>{g=W,l=j});this.b={run:$,promise:k,promiseResolve:g,promiseReject:l}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=Te;class Pe{constructor($,g=()=>Date.now()){this.d=$,this.f=g,this.a=0,this.b=0}increment(){const $=this.f();return $-this.a>this.d&&(this.a=$,this.b=0),this.b++,this.b}}t.IntervalCounter=Pe;class Oe{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise(($,g)=>{this.a=$,this.b=g})}complete($){return new Promise(g=>{this.a($),this.f=!0,g()})}error($){return new Promise(g=>{this.b($),this.d=!0,g()})}cancel(){new Promise($=>{this.b(new P.CancellationError),this.d=!0,$()})}}t.DeferredPromise=Oe;var x;(function(te){async function $(l){let k;const W=await Promise.all(l.map(j=>j.then(F=>F,F=>{k||(k=F)})));if(typeof k<"u")throw k;return W}te.settled=$;function g(l){return new Promise(async(k,W)=>{try{await l(k,W)}catch(j){W(j)}})}te.withAsyncBody=g})(x=t.Promises||(t.Promises={}));var G;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(G||(G={}));class ie{static fromArray($){return new ie(g=>{g.emitMany($)})}static fromPromise($){return new ie(async g=>{g.emitMany(await $)})}static fromPromises($){return new ie(async g=>{await Promise.all($.map(async l=>g.emitOne(await l)))})}static merge($){return new ie(async g=>{await Promise.all($.map(async l=>{for await(const k of l)g.emitOne(k)}))})}constructor($){this.a=0,this.b=[],this.d=null,this.f=new U.Emitter,queueMicrotask(async()=>{const g={emitOne:l=>this.g(l),emitMany:l=>this.h(l),reject:l=>this.k(l)};try{await Promise.resolve($(g)),this.j()}catch(l){this.k(l)}finally{g.emitOne=void 0,g.emitMany=void 0,g.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this.a===2)throw this.d;if($<this.b.length)return{done:!1,value:this.b[$++]};if(this.a===1)return{done:!0,value:void 0};await U.Event.toPromise(this.f.event)}while(!0)}}}static map($,g){return new ie(async l=>{for await(const k of $)l.emitOne(g(k))})}map($){return ie.map(this,$)}static filter($,g){return new ie(async l=>{for await(const k of $)g(k)&&l.emitOne(k)})}filter($){return ie.filter(this,$)}static coalesce($){return ie.filter($,g=>!!g)}coalesce(){return ie.coalesce(this)}static async toPromise($){const g=[];for await(const l of $)g.push(l);return g}toPromise(){return ie.toPromise(this)}g($){this.a===0&&(this.b.push($),this.f.fire())}h($){this.a===0&&(this.b=this.b.concat($),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k($){this.a===0&&(this.a=2,this.d=$,this.f.fire())}}t.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class se extends ie{constructor($,g){super(g),this.l=$}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=se;function ae(te){const $=new E.CancellationTokenSource,g=te($.token);return new se($,async l=>{const k=$.token.onCancellationRequested(()=>{k.dispose(),$.dispose(),l.reject(new P.CancellationError)});try{for await(const W of g){if($.token.isCancellationRequested)return;l.emitOne(W)}k.dispose(),$.dispose()}catch(W){k.dispose(),$.dispose(),l.reject(W)}})}t.createCancelableAsyncIterable=ae}),define(ge[4],me([1,0,18,108,14,21,9,7,3,114,2,34,5,6,15]),function(Q,t,E,P,U,i,D,w,f,u,c,M,o,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function s(X){for(;X.firstChild;)X.firstChild.remove()}t.clearNode=s;function r(X){return X?.isConnected??!1}t.isInDOM=r;class a{constructor(K,fe,Se,ke){this.f=K,this.g=fe,this.d=Se,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){!this.d||(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function h(X,K,fe,Se){return new a(X,K,fe,Se)}t.addDisposableListener=h;function p(X){return function(K){return X(new i.StandardMouseEvent(K))}}function T(X){return function(K){return X(new U.StandardKeyboardEvent(K))}}const A=function(K,fe,Se,ke){let qe=Se;return fe==="click"||fe==="mousedown"?qe=p(Se):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&(qe=T(Se)),h(K,fe,qe,ke)};t.addStandardDisposableListener=A;const m=function(K,fe,Se){const ke=p(fe);return N(K,ke,Se)};t.addStandardDisposableGenericMouseDownListener=m;const C=function(K,fe,Se){const ke=p(fe);return d(K,ke,Se)};t.addStandardDisposableGenericMouseUpListener=C;function N(X,K,fe){return h(X,o.isIOS&&P.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,K,fe)}t.addDisposableGenericMouseDownListener=N;function L(X,K,fe){return h(X,o.isIOS&&P.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,K,fe)}t.addDisposableGenericMouseMoveListener=L;function d(X,K,fe){return h(X,o.isIOS&&P.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,K,fe)}t.addDisposableGenericMouseUpListener=d;class v{constructor(K,fe=0){this.d=K,this.priority=fe,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(K){(0,w.onUnexpectedError)(K)}}static sort(K,fe){return fe.priority-K.priority}}(function(){let X=[],K=null,fe=!1,Se=!1;const ke=()=>{for(fe=!1,K=X,X=[],Se=!0;K.length>0;)K.sort(v.sort),K.shift().execute();Se=!1};t.scheduleAtNextAnimationFrame=(qe,_e=0)=>{const Ye=new v(qe,_e);return X.push(Ye),fe||(fe=!0,requestAnimationFrame(ke)),Ye},t.runAtThisOrScheduleAtNextAnimationFrame=(qe,_e)=>{if(Se){const Ye=new v(qe,_e);return K.push(Ye),Ye}else return(0,t.scheduleAtNextAnimationFrame)(qe,_e)}})();function b(X){return(0,t.scheduleAtNextAnimationFrame)(X,1e4)}t.measure=b;function y(X){return(0,t.scheduleAtNextAnimationFrame)(X,-1e4)}t.modify=y;const R=8,V=function(X,K){return K};class ee extends c.Disposable{constructor(K,fe,Se,ke=V,qe=R){super();let _e=null,Ye=0;const Qe=this.B(new D.TimeoutTimer),ft=()=>{Ye=new Date().getTime(),Se(_e),_e=null};this.B(h(K,fe,Lt=>{_e=ke(_e,Lt);const gt=new Date().getTime()-Ye;gt>=qe?(Qe.cancel(),ft()):Qe.setIfNotSet(ft,qe-gt)}))}}function Z(X,K,fe,Se,ke){return new ee(X,K,fe,Se,ke)}t.addDisposableThrottledListener=Z;function J(X){return document.defaultView.getComputedStyle(X,null)}t.getComputedStyle=J;function re(X){if(X!==document.body)return new de(X.clientWidth,X.clientHeight);if(o.isIOS&&window.visualViewport)return new de(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new de(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new de(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new de(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=re;class he{static d(K,fe){return parseFloat(fe)||0}static f(K,fe,Se){const ke=J(K),qe=ke?ke.getPropertyValue(fe):"0";return he.d(K,qe)}static getBorderLeftWidth(K){return he.f(K,"border-left-width","borderLeftWidth")}static getBorderRightWidth(K){return he.f(K,"border-right-width","borderRightWidth")}static getBorderTopWidth(K){return he.f(K,"border-top-width","borderTopWidth")}static getBorderBottomWidth(K){return he.f(K,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(K){return he.f(K,"padding-left","paddingLeft")}static getPaddingRight(K){return he.f(K,"padding-right","paddingRight")}static getPaddingTop(K){return he.f(K,"padding-top","paddingTop")}static getPaddingBottom(K){return he.f(K,"padding-bottom","paddingBottom")}static getMarginLeft(K){return he.f(K,"margin-left","marginLeft")}static getMarginTop(K){return he.f(K,"margin-top","marginTop")}static getMarginRight(K){return he.f(K,"margin-right","marginRight")}static getMarginBottom(K){return he.f(K,"margin-bottom","marginBottom")}}class de{constructor(K,fe){this.width=K,this.height=fe}with(K=this.width,fe=this.height){return K!==this.width||fe!==this.height?new de(K,fe):this}static is(K){return typeof K=="object"&&typeof K.height=="number"&&typeof K.width=="number"}static lift(K){return K instanceof de?K:new de(K.width,K.height)}static equals(K,fe){return K===fe?!0:!K||!fe?!1:K.width===fe.width&&K.height===fe.height}}t.Dimension=de,de.None=new de(0,0);function ce(X){let K=X.offsetParent,fe=X.offsetTop,Se=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==document.body&&X!==document.documentElement;){fe-=X.scrollTop;const ke=O(X)?null:J(X);ke&&(Se-=ke.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===K&&(Se+=he.getBorderLeftWidth(X),fe+=he.getBorderTopWidth(X),fe+=X.offsetTop,Se+=X.offsetLeft,K=X.offsetParent)}return{left:Se,top:fe}}t.getTopLeftOffset=ce;function pe(X,K,fe){typeof K=="number"&&(X.style.width=`${K}px`),typeof fe=="number"&&(X.style.height=`${fe}px`)}t.size=pe;function Te(X,K,fe,Se,ke,qe="absolute"){typeof K=="number"&&(X.style.top=`${K}px`),typeof fe=="number"&&(X.style.right=`${fe}px`),typeof Se=="number"&&(X.style.bottom=`${Se}px`),typeof ke=="number"&&(X.style.left=`${ke}px`),X.style.position=qe}t.position=Te;function Pe(X){const K=X.getBoundingClientRect();return{left:K.left+window.scrollX,top:K.top+window.scrollY,width:K.width,height:K.height}}t.getDomNodePagePosition=Pe;function Oe(X){let K=X,fe=1;do{const Se=J(K).zoom;Se!=null&&Se!=="1"&&(fe*=Se),K=K.parentElement}while(K!==null&&K!==document.documentElement);return fe}t.getDomNodeZoomLevel=Oe;function x(X){const K=he.getMarginLeft(X)+he.getMarginRight(X);return X.offsetWidth+K}t.getTotalWidth=x;function G(X){const K=he.getBorderLeftWidth(X)+he.getBorderRightWidth(X),fe=he.getPaddingLeft(X)+he.getPaddingRight(X);return X.offsetWidth-K-fe}t.getContentWidth=G;function ie(X){const K=he.getMarginLeft(X)+he.getMarginRight(X);return X.scrollWidth+K}t.getTotalScrollWidth=ie;function se(X){const K=he.getBorderTopWidth(X)+he.getBorderBottomWidth(X),fe=he.getPaddingTop(X)+he.getPaddingBottom(X);return X.offsetHeight-K-fe}t.getContentHeight=se;function ae(X){const K=he.getMarginTop(X)+he.getMarginBottom(X);return X.offsetHeight+K}t.getTotalHeight=ae;function te(X,K){if(X===null)return 0;const fe=ce(X),Se=ce(K);return fe.left-Se.left}function $(X,K){const fe=K.map(ke=>Math.max(ie(ke),x(ke))+te(ke,X)||0);return Math.max(...fe)}t.getLargestChildWidth=$;function g(X,K){for(;X;){if(X===K)return!0;X=X.parentNode}return!1}t.isAncestor=g;const l="parentFlowToElementId";function k(X,K){X.dataset[l]=K.id}t.setParentFlowTo=k;function W(X){const K=X.dataset[l];return typeof K=="string"?document.getElementById(K):null}function j(X,K){let fe=X;for(;fe;){if(fe===K)return!0;if(fe instanceof HTMLElement){const Se=W(fe);if(Se){fe=Se;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=j;function F(X,K,fe){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(K))return X;if(fe){if(typeof fe=="string"){if(X.classList.contains(fe))return null}else if(X===fe)return null}X=X.parentNode}return null}t.findParentWithClass=F;function I(X,K,fe){return!!F(X,K,fe)}t.hasParentWithClass=I;function O(X){return X&&!!X.host&&!!X.mode}t.isShadowRoot=O;function S(X){return!!B(X)}t.isInShadowDOM=S;function B(X){for(;X.parentNode;){if(X===document.body)return null;X=X.parentNode}return O(X)?X:null}t.getShadowRoot=B;function H(){let X=document.activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.getActiveElement=H;function z(X=document.getElementsByTagName("head")[0]){const K=document.createElement("style");return K.type="text/css",K.media="screen",X.appendChild(K),K}t.createStyleSheet=z;function _(X=document.getElementsByTagName("head")[0]){const K=document.createElement("meta");return X.appendChild(K),K}t.createMetaElement=_;let Y=null;function ne(){return Y||(Y=z()),Y}function ue(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function we(X,K,fe=ne()){!fe||!K||fe.sheet.insertRule(X+"{"+K+"}",0)}t.createCSSRule=we;function De(X,K=ne()){if(!K)return;const fe=ue(K),Se=[];for(let ke=0;ke<fe.length;ke++)fe[ke].selectorText.indexOf(X)!==-1&&Se.push(ke);for(let ke=Se.length-1;ke>=0;ke--)K.sheet.deleteRule(Se[ke])}t.removeCSSRulesContainingSelector=De;function Le(X){return typeof HTMLElement=="object"?X instanceof HTMLElement:X&&typeof X=="object"&&X.nodeType===1&&typeof X.nodeName=="string"}t.isHTMLElement=Le,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:E.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.isWebKit?"webkitAnimationIteration":"animationiteration"};function Ae(X){const K=X;return!!(K&&typeof K.preventDefault=="function"&&typeof K.stopPropagation=="function")}t.isEventLike=Ae,t.EventHelper={stop:(X,K)=>(X.preventDefault(),K&&X.stopPropagation(),X)};function ve(X){const K=[];for(let fe=0;X&&X.nodeType===X.ELEMENT_NODE;fe++)K[fe]=X.scrollTop,X=X.parentNode;return K}t.saveParentsScrollTop=ve;function Me(X,K){for(let fe=0;X&&X.nodeType===X.ELEMENT_NODE;fe++)X.scrollTop!==K[fe]&&(X.scrollTop=K[fe]),X=X.parentNode}t.restoreParentsScrollTop=Me;class Ie extends c.Disposable{static l(K){const fe=B(K),Se=fe?fe.activeElement:document.activeElement;return g(Se,K)}constructor(K){super(),this.f=this.B(new f.Emitter),this.onDidFocus=this.f.event,this.g=this.B(new f.Emitter),this.onDidBlur=this.g.event;let fe=Ie.l(K),Se=!1;const ke=()=>{Se=!1,fe||(fe=!0,this.f.fire())},qe=()=>{fe&&(Se=!0,window.setTimeout(()=>{Se&&(Se=!1,fe=!1,this.g.fire())},0))};this.j=()=>{Ie.l(K)!==fe&&(fe?qe():ke())},this.B(h(K,t.EventType.FOCUS,ke,!0)),this.B(h(K,t.EventType.BLUR,qe,!0)),this.B(h(K,t.EventType.FOCUS_IN,()=>this.j())),this.B(h(K,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function $e(X){return new Ie(X)}t.trackFocus=$e;function ze(X,K){return X.after(K),K}t.after=ze;function We(X,...K){if(X.append(...K),K.length===1&&typeof K[0]!="string")return K[0]}t.append=We;function Je(X,K){return X.insertBefore(K,X.firstChild),K}t.prepend=Je;function it(X,...K){X.innerText="",We(X,...K)}t.reset=it;const Be=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var je;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(je=t.Namespace||(t.Namespace={}));function Ge(X,K,fe,...Se){const ke=Be.exec(K);if(!ke)throw new Error("Bad use of emmet");const qe=ke[1]||"div";let _e;return X!==je.HTML?_e=document.createElementNS(X,qe):_e=document.createElement(qe),ke[3]&&(_e.id=ke[3]),ke[4]&&(_e.className=ke[4].replace(/\./g," ").trim()),fe&&Object.entries(fe).forEach(([Ye,Qe])=>{typeof Qe>"u"||(/^on\w+$/.test(Ye)?_e[Ye]=Qe:Ye==="selected"?Qe&&_e.setAttribute(Ye,"true"):_e.setAttribute(Ye,Qe))}),_e.append(...Se),_e}function q(X,K,...fe){return Ge(je.HTML,X,K,...fe)}t.$=q,q.SVG=function(X,K,...fe){return Ge(je.SVG,X,K,...fe)};function le(X,K){const fe=[];return X.forEach((Se,ke)=>{ke>0&&(K instanceof Node?fe.push(K.cloneNode()):fe.push(document.createTextNode(K))),fe.push(Se)}),fe}t.join=le;function be(...X){for(const K of X)K.style.display="",K.removeAttribute("aria-hidden")}t.show=be;function ye(...X){for(const K of X)K.style.display="none",K.setAttribute("aria-hidden","true")}t.hide=ye;function Ce(X,K){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(K))return X;X=X.parentNode}return null}function Re(X){!X||!X.hasAttribute("tabIndex")||(document.activeElement===X&&Ce(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Re;function xe(X){return K=>{K.preventDefault(),K.stopPropagation(),X(K)}}t.finalHandler=xe;function tt(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.domContentLoaded=tt;function Ne(X){const K=window.devicePixelRatio*X;return Math.max(1,Math.floor(K))/window.devicePixelRatio}t.computeScreenAwareSize=Ne;function oe(X){window.open(X,"_blank","noopener")}t.windowOpenNoOpener=oe;const Ee=780,Fe=640;function Ue(X){const K=Math.floor(window.screenLeft+window.innerWidth/2-Ee/2),fe=Math.floor(window.screenTop+window.innerHeight/2-Fe/2);window.open(X,"_blank",`width=${Ee},height=${Fe},top=${fe},left=${K}`)}t.windowOpenPopup=Ue;function Ke(X,K=!0){const fe=window.open();return fe?(K&&(fe.opener=null),fe.location.href=X,!0):!1}t.windowOpenWithSuccess=Ke;function Xe(X){const K=()=>{X(),fe=(0,t.scheduleAtNextAnimationFrame)(K)};let fe=(0,t.scheduleAtNextAnimationFrame)(K);return(0,c.toDisposable)(()=>fe.dispose())}t.animate=Xe,M.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Ze(X){return X?`url('${M.FileAccess.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Ze;function st(X){return`'${X.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=st;function ut(X,K){if(X!==void 0){const fe=X.match(/^\s*var\((.+)\)$/);if(fe){const Se=fe[1].split(",",2);return Se.length===2&&(K=ut(Se[1].trim(),K)),`var(${Se[0]}, ${K})`}return X}return K}t.asCssValueWithDefault=ut;function Et(X,K){let fe;if(e.URI.isUri(X))fe=X.toString(!0);else{const ke=new Blob([X]);fe=URL.createObjectURL(ke),setTimeout(()=>URL.revokeObjectURL(fe))}const Se=document.createElement("a");document.body.appendChild(Se),Se.download=K,Se.href=fe,Se.click(),setTimeout(()=>document.body.removeChild(Se))}t.triggerDownload=Et;function Tt(){return new Promise(X=>{const K=document.createElement("input");document.body.appendChild(K),K.type="file",K.multiple=!0,f.Event.once(f.Event.fromDOMEventEmitter(K,"input"))(()=>{X((0,n.withNullAsUndefined)(K.files))}),K.click(),setTimeout(()=>document.body.removeChild(K))})}t.triggerUpload=Tt;var vt;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(vt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function hi(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:vt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:vt.BROWSER,guess:!1}:(o.isMacintosh||o.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:vt.BROWSER,guess:!0}:null}t.detectFullscreen=hi;function Wt(X,K=!1){const fe=document.createElement("a");return u.addHook("afterSanitizeAttributes",Se=>{for(const ke of["href","src"])if(Se.hasAttribute(ke)){const qe=Se.getAttribute(ke);if(ke==="href"&&qe.startsWith("#"))continue;if(fe.href=qe,!X.includes(fe.protocol.replace(/:$/,""))){if(K&&ke==="src"&&fe.href.startsWith("data:"))continue;Se.removeAttribute(ke)}}}),(0,c.toDisposable)(()=>{u.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Wt;const ci=[M.Schemas.http,M.Schemas.https,M.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const di=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function fi(X,K){const fe=Wt(ci);try{const Se=u.sanitize(K,di);X.innerHTML=Se}finally{fe.dispose()}}t.safeInnerHtml=fi;function gi(X){const K=new Uint16Array(X.length);for(let ke=0;ke<K.length;ke++)K[ke]=X.charCodeAt(ke);let fe="";const Se=new Uint8Array(K.buffer);for(let ke=0;ke<Se.length;ke++)fe+=String.fromCharCode(Se[ke]);return fe}function mi(X){return btoa(gi(X))}t.multibyteAwareBtoa=mi;class dt extends f.Emitter{constructor(){super(),this.s=new c.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(h(window,"keydown",K=>{if(K.defaultPrevented)return;const fe=new U.StandardKeyboardEvent(K);if(!(fe.keyCode===6&&K.repeat)){if(K.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(K.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(K.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(K.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(fe.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=K.altKey,this.t.ctrlKey=K.ctrlKey,this.t.metaKey=K.metaKey,this.t.shiftKey=K.shiftKey,this.t.lastKeyPressed&&(this.t.event=K,this.fire(this.t))}},!0)),this.s.add(h(window,"keyup",K=>{K.defaultPrevented||(!K.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!K.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!K.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!K.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=K.altKey,this.t.ctrlKey=K.ctrlKey,this.t.metaKey=K.metaKey,this.t.shiftKey=K.shiftKey,this.t.lastKeyReleased&&(this.t.event=K,this.fire(this.t)))},!0)),this.s.add(h(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(h(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(h(document.body,"mousemove",K=>{K.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(h(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return dt.u||(dt.u=new dt),dt.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=dt;function bi(X){const K=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return K?K.pop():void 0}t.getCookieValue=bi;class pi extends c.Disposable{constructor(K,fe){super(),this.j=K,this.l=fe,this.f=0,this.g=0,this.m()}m(){this.B(h(this.j,t.EventType.DRAG_ENTER,K=>{this.f++,this.g=K.timeStamp,this.l.onDragEnter(K)})),this.B(h(this.j,t.EventType.DRAG_OVER,K=>{K.preventDefault(),this.l.onDragOver?.(K,K.timeStamp-this.g)})),this.B(h(this.j,t.EventType.DRAG_LEAVE,K=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(K))})),this.B(h(this.j,t.EventType.DRAG_END,K=>{this.f=0,this.g=0,this.l.onDragEnd(K)})),this.B(h(this.j,t.EventType.DROP,K=>{this.f=0,this.g=0,this.l.onDrop(K)}))}}t.DragAndDropObserver=pi;const vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function wi(X,...K){let fe,Se;Array.isArray(K[0])?(fe={},Se=K[0]):(fe=K[0]||{},Se=K[1]);const ke=vi.exec(X);if(!ke||!ke.groups)throw new Error("Bad use of h");const qe=ke.groups.tag||"div",_e=document.createElement(qe);ke.groups.id&&(_e.id=ke.groups.id),ke.groups.class&&(_e.className=ke.groups.class.replace(/\./g," ").trim());const Ye={};if(ke.groups.name&&(Ye[ke.groups.name]=_e),Se)for(const Qe of Se)Qe instanceof HTMLElement?_e.appendChild(Qe):typeof Qe=="string"?_e.append(Qe):(Object.assign(Ye,Qe),_e.appendChild(Qe.root));for(const[Qe,ft]of Object.entries(fe))if(Qe==="style")for(const[Lt,gt]of Object.entries(ft))_e.style.setProperty($t(Lt),typeof gt=="number"?gt+"px":""+gt);else Qe==="tabIndex"?_e.tabIndex=ft:_e.setAttribute($t(Qe),ft.toString());return Ye.root=_e,Ye}t.h=wi;function $t(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(ge[51],me([1,0,4,2,106]),function(Q,t,E,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class i extends P.Disposable{constructor(f,u){super(),this.B((0,E.addDisposableListener)(f,"dragover",c=>{c.preventDefault(),this.a||(this.a=setTimeout(()=>{u(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(c=>{this.B((0,E.addDisposableListener)(f,c,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=i,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:U.Mimes.text};function D(w,f,u,c,M){const o=document.createElement("div");o.className=u,o.textContent=f,M&&(o.style.color=M),c&&(o.style.background=c),w.dataTransfer&&(document.body.appendChild(o),w.dataTransfer.setDragImage(o,-10,-10),setTimeout(()=>document.body.removeChild(o),0))}t.applyDragImage=D}),define(ge[52],me([1,0,4]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function P(o,n={}){const e=i(n);return e.textContent=o,e}t.renderText=P;function U(o,n={}){const e=i(n);return f(e,u(o,!!n.renderCodeSegments),n.actionHandler,n.renderCodeSegments),e}t.renderFormattedText=U;function i(o){const n=o.inline?"span":"div",e=document.createElement(n);return o.className&&(e.className=o.className),e}t.createElement=i;class D{constructor(n){this.b=n,this.c=0}eos(){return this.c>=this.b.length}next(){const n=this.peek();return this.advance(),n}peek(){return this.b[this.c]}advance(){this.c++}}var w;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(w||(w={}));function f(o,n,e,s){let r;if(n.type===2)r=document.createTextNode(n.content||"");else if(n.type===3)r=document.createElement("b");else if(n.type===4)r=document.createElement("i");else if(n.type===7&&s)r=document.createElement("code");else if(n.type===5&&e){const a=document.createElement("a");e.disposables.add(E.addStandardDisposableListener(a,"click",h=>{e.callback(String(n.index),h)})),r=a}else n.type===8?r=document.createElement("br"):n.type===1&&(r=o);r&&o!==r&&o.appendChild(r),r&&Array.isArray(n.children)&&n.children.forEach(a=>{f(r,a,e,s)})}function u(o,n){const e={type:1,children:[]};let s=0,r=e;const a=[],h=new D(o);for(;!h.eos();){let p=h.next();const T=p==="\\"&&M(h.peek(),n)!==0;if(T&&(p=h.next()),!T&&c(p,n)&&p===h.peek()){h.advance(),r.type===2&&(r=a.pop());const A=M(p,n);if(r.type===A||r.type===5&&A===6)r=a.pop();else{const m={type:A,children:[]};A===5&&(m.index=s,s++),r.children.push(m),a.push(r),r=m}}else if(p===`
`)r.type===2&&(r=a.pop()),r.children.push({type:8});else if(r.type!==2){const A={type:2,content:p};r.children.push(A),a.push(r),r=A}else r.content+=p}return r.type===2&&(r=a.pop()),a.length,e}function c(o,n){return M(o,n)!==0}function M(o,n){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return n?7:0;default:return 0}}}),define(ge[53],me([1,0,4,2]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class U{constructor(){this.a=new P.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,w){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const f=this.c;this.c=null,D&&f&&f(w)}isMonitoring(){return!!this.b}startMonitoring(D,w,f,u,c){this.isMonitoring()&&this.stopMonitoring(!1),this.b=u,this.c=c;let M=D;try{D.setPointerCapture(w),this.a.add((0,P.toDisposable)(()=>{try{D.releasePointerCapture(w)}catch{}}))}catch{M=window}this.a.add(E.addDisposableListener(M,E.EventType.POINTER_MOVE,o=>{if(o.buttons!==f){this.stopMonitoring(!0);return}o.preventDefault(),this.b(o)})),this.a.add(E.addDisposableListener(M,E.EventType.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=U});var Ve=this&&this.__decorate||function(Q,t,E,P){var U=arguments.length,i=U<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,E):P,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")i=Reflect.decorate(Q,t,E,P);else for(var w=Q.length-1;w>=0;w--)(D=Q[w])&&(i=(U<3?D(i):U>3?D(t,E,i):D(t,E))||i);return U>3&&i&&Object.defineProperty(t,E,i),i};define(ge[23],me([1,0,4,13,25,2,45]),function(Q,t,E,P,U,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var w;(function(u){u.Tap="-monaco-gesturetap",u.Change="-monaco-gesturechange",u.Start="-monaco-gesturestart",u.End="-monaco-gesturesend",u.Contextmenu="-monaco-gesturecontextmenu"})(w=t.EventType||(t.EventType={}));class f extends i.Disposable{constructor(){super(),this.f=!1,this.g=new D.LinkedList,this.h=new D.LinkedList,this.k={},this.j=null,this.l=0,this.B(E.addDisposableListener(document,"touchstart",c=>this.n(c),{passive:!1})),this.B(E.addDisposableListener(document,"touchend",c=>this.p(c))),this.B(E.addDisposableListener(document,"touchmove",c=>this.v(c),{passive:!1}))}static addTarget(c){if(!f.isTouchDevice())return i.Disposable.None;f.b||(f.b=new f);const M=f.b.g.push(c);return(0,i.toDisposable)(M)}static ignoreTarget(c){if(!f.isTouchDevice())return i.Disposable.None;f.b||(f.b=new f);const M=f.b.h.push(c);return(0,i.toDisposable)(M)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(c){const M=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let o=0,n=c.targetTouches.length;o<n;o++){const e=c.targetTouches.item(o);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:M,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[M],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const s=this.r(w.Start,e.target);s.pageX=e.pageX,s.pageY=e.pageY,this.s(s)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}p(c){const M=Date.now(),o=Object.keys(this.k).length;for(let n=0,e=c.changedTouches.length;n<e;n++){const s=c.changedTouches.item(n);if(!this.k.hasOwnProperty(String(s.identifier))){console.warn("move of an UNKNOWN touch",s);continue}const r=this.k[s.identifier],a=Date.now()-r.initialTimeStamp;if(a<f.c&&Math.abs(r.initialPageX-P.tail(r.rollingPageX))<30&&Math.abs(r.initialPageY-P.tail(r.rollingPageY))<30){const h=this.r(w.Tap,r.initialTarget);h.pageX=P.tail(r.rollingPageX),h.pageY=P.tail(r.rollingPageY),this.s(h)}else if(a>=f.c&&Math.abs(r.initialPageX-P.tail(r.rollingPageX))<30&&Math.abs(r.initialPageY-P.tail(r.rollingPageY))<30){const h=this.r(w.Contextmenu,r.initialTarget);h.pageX=P.tail(r.rollingPageX),h.pageY=P.tail(r.rollingPageY),this.s(h)}else if(o===1){const h=P.tail(r.rollingPageX),p=P.tail(r.rollingPageY),T=P.tail(r.rollingTimestamps)-r.rollingTimestamps[0],A=h-r.rollingPageX[0],m=p-r.rollingPageY[0],C=[...this.g].filter(N=>r.initialTarget instanceof Node&&N.contains(r.initialTarget));this.u(C,M,Math.abs(A)/T,A>0?1:-1,h,Math.abs(m)/T,m>0?1:-1,p)}this.s(this.r(w.End,r.initialTarget)),delete this.k[s.identifier]}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}r(c,M){const o=document.createEvent("CustomEvent");return o.initEvent(c,!1,!0),o.initialTarget=M,o.tapCount=0,o}s(c){if(c.type===w.Tap){const M=new Date().getTime();let o=0;M-this.l>f.m?o=1:o=2,this.l=M,c.tapCount=o}else(c.type===w.Change||c.type===w.Contextmenu)&&(this.l=0);if(c.initialTarget instanceof Node){for(const M of this.h)if(M.contains(c.initialTarget))return;for(const M of this.g)M.contains(c.initialTarget)&&(M.dispatchEvent(c),this.f=!0)}}u(c,M,o,n,e,s,r,a){this.j=E.scheduleAtNextAnimationFrame(()=>{const h=Date.now(),p=h-M;let T=0,A=0,m=!0;o+=f.a*p,s+=f.a*p,o>0&&(m=!1,T=n*o*p),s>0&&(m=!1,A=r*s*p);const C=this.r(w.Change);C.translationX=T,C.translationY=A,c.forEach(N=>N.dispatchEvent(C)),m||this.u(c,h,o,n,e+T,s,r,a+A)})}v(c){const M=Date.now();for(let o=0,n=c.changedTouches.length;o<n;o++){const e=c.changedTouches.item(o);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const s=this.k[e.identifier],r=this.r(w.Change,s.initialTarget);r.translationX=e.pageX-P.tail(s.rollingPageX),r.translationY=e.pageY-P.tail(s.rollingPageY),r.pageX=e.pageX,r.pageY=e.pageY,this.s(r),s.rollingPageX.length>3&&(s.rollingPageX.shift(),s.rollingPageY.shift(),s.rollingTimestamps.shift()),s.rollingPageX.push(e.pageX),s.rollingPageY.push(e.pageY),s.rollingTimestamps.push(M)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}}f.a=-.005,f.c=700,f.m=400,Ve([U.memoize],f,"isTouchDevice",null),t.Gesture=f}),define(ge[54],me([1,0,4,5,83]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const U=2e4;let i,D,w,f,u;function c(e){i=document.createElement("div"),i.className="monaco-aria-container";const s=()=>{const a=document.createElement("div");return a.className="monaco-alert",a.setAttribute("role","alert"),a.setAttribute("aria-atomic","true"),i.appendChild(a),a};D=s(),w=s();const r=()=>{const a=document.createElement("div");return a.className="monaco-status",a.setAttribute("role","complementary"),a.setAttribute("aria-live","polite"),a.setAttribute("aria-atomic","true"),i.appendChild(a),a};f=r(),u=r(),e.appendChild(i)}t.setARIAContainer=c;function M(e){!i||(D.textContent!==e?(E.clearNode(w),n(D,e)):(E.clearNode(D),n(w,e)))}t.alert=M;function o(e){!i||(P.isMacintosh?M(e):f.textContent!==e?(E.clearNode(u),n(f,e)):(E.clearNode(f),n(u,e)))}t.status=o;function n(e,s){E.clearNode(e),s.length>U&&(s=s.substr(0,U)),e.textContent=s,e.style.visibility="hidden",e.style.visibility="visible"}}),define(ge[115],me([1,0,4,17]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const U=new RegExp(`(\\\\)?\\$\\((${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?)\\)`,"g");function i(w){const f=new Array;let u,c=0,M=0;for(;(u=U.exec(w))!==null;){M=u.index||0,c<M&&f.push(w.substring(c,M)),c=(u.index||0)+u[0].length;const[,o,n]=u;f.push(o?`$(${n})`:D({id:n}))}return c<w.length&&f.push(w.substring(c)),f}t.renderLabelWithIcons=i;function D(w){const f=E.$("span");return f.classList.add(...P.ThemeIcon.asClassNameArray(w)),f}t.renderIcon=D}),define(ge[116],me([1,0,4]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function P(i){try{i.parentElement?.removeChild(i)}catch{}}class U{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let w=this.h(D).pop(),f=!1;if(w)f=this.b.has(w.domNode),f&&this.b.delete(w.domNode);else{const u=(0,E.$)(".monaco-list-row"),M=this.i(D).renderTemplate(u);w={domNode:u,templateId:D,templateData:M}}return{row:w,isReusingConnectedDomNode:f}}release(D){!D||this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const w of this.b)this.g(w);this.b.clear(),this.c=!1}}f(D){const{domNode:w,templateId:f}=D;w&&(this.c?this.b.add(w):this.g(w)),this.h(f).push(D)}g(D){D.classList.remove("scrolling"),P(D)}h(D){let w=this.a.get(D);return w||(w=[],this.a.set(D,w)),w}dispose(){this.a.forEach((D,w)=>{for(const f of D)this.i(w).disposeTemplate(f.templateData),f.templateData=null}),this.a.clear(),this.b.clear()}i(D){const w=this.d.get(D);if(!w)throw new Error(`No renderer found for ${D}`);return w}}t.RowCache=U}),define(ge[117],me([1,0,9,2]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class U extends P.Disposable{constructor(D,w,f){super(),this.a=D,this.b=w,this.c=f,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new E.TimeoutTimer)}setVisibility(D){this.a!==D&&(this.a=D,this.m())}setShouldBeVisible(D){this.g=D,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const D=this.l();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.i!==D&&(this.i=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(D){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}t.ScrollbarVisibilityController=U}),define(ge[118],me([1,0,4,23,13,3,2,5]),function(Q,t,E,P,U,i,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class f extends D.Disposable{constructor(c,M,o,n){super(),this.f=0,this.b=n||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new i.Emitter),this.h=o,this.i(),this.setOptions(c,M)}i(){this.B(P.Gesture.addTarget(this.a)),[P.EventType.Tap].forEach(c=>{this.B(E.addDisposableListener(this.a,c,M=>{this.a.focus()}))}),this.B(E.addStandardDisposableListener(this.a,"click",c=>{E.EventHelper.stop(c,!0)})),this.B(E.addStandardDisposableListener(this.a,"change",c=>{this.a.title=c.target.value,this.g.fire({index:c.target.selectedIndex,selected:c.target.value})})),this.B(E.addStandardDisposableListener(this.a,"keydown",c=>{let M=!1;w.isMacintosh?(c.keyCode===18||c.keyCode===16||c.keyCode===10)&&(M=!0):(c.keyCode===18&&c.altKey||c.keyCode===10||c.keyCode===3)&&(M=!0),M&&c.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(c,M){(!this.c||!U.equals(this.c,c))&&(this.c=c,this.a.options.length=0,this.c.forEach((o,n)=>{this.a.add(this.j(o.text,n,o.isDisabled))})),M!==void 0&&this.select(M)}select(c){this.c.length===0?this.f=0:c>=0&&c<this.c.length?this.f=c:c>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(c){this.b.ariaLabel=c,this.a.setAttribute("aria-label",c)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(c){this.a.tabIndex=c?0:-1}render(c){c.classList.add("select-container"),c.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(c){this.h=c,this.applyStyles()}applyStyles(){if(this.a){const c=this.h.selectBackground?this.h.selectBackground.toString():"",M=this.h.selectForeground?this.h.selectForeground.toString():"",o=this.h.selectBorder?this.h.selectBorder.toString():"";this.a.style.backgroundColor=c,this.a.style.color=M,this.a.style.borderColor=o}}j(c,M,o){const n=document.createElement("option");return n.value=c,n.text=c,n.disabled=!!o,n}}t.SelectBoxNative=f}),define(ge[55],me([1,0,24,13,9,112,3,26]),function(Q,t,E,P,U,i,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function f(o){return typeof o=="object"&&"visibility"in o&&"data"in o}t.isFilterResult=f;function u(o){switch(o){case!0:return 1;case!1:return 0;default:return o}}t.getVisibleState=u;function c(o){return typeof o.collapsible=="boolean"}class M{constructor(n,e,s,r={}){this.o=n,this.p=e,this.rootRef=[],this.d=new D.EventBufferer,this.f=new D.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new D.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new D.Emitter,this.onDidSplice=this.l.event,this.m=new U.Delayer(U.MicrotaskDelay),this.h=typeof r.collapseByDefault>"u"?!1:r.collapseByDefault,this.j=r.filter,this.k=typeof r.autoExpandSingleChildren>"u"?!1:r.autoExpandSingleChildren,this.c={parent:void 0,element:s,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(n,e,s=w.Iterable.empty(),r={}){if(n.length===0)throw new E.TreeError(this.o,"Invalid tree location");r.diffIdentityProvider?this.q(r.diffIdentityProvider,n,e,s,r):this.s(n,e,s,r)}q(n,e,s,r=w.Iterable.empty(),a,h=a.diffDepth??0){const{parentNode:p}=this.G(e);if(!p.lastDiffIds)return this.s(e,s,r,a);const T=[...r],A=e[e.length-1],m=new i.LcsDiff({getElements:()=>p.lastDiffIds},{getElements:()=>[...p.children.slice(0,A),...T,...p.children.slice(A+s)].map(v=>n.getId(v.element).toString())}).ComputeDiff(!1);if(m.quitEarly)return p.lastDiffIds=void 0,this.s(e,s,T,a);const C=e.slice(0,-1),N=(v,b,y)=>{if(h>0)for(let R=0;R<y;R++)v--,b--,this.q(n,[...C,v,0],Number.MAX_SAFE_INTEGER,T[b].children,a,h-1)};let L=Math.min(p.children.length,A+s),d=T.length;for(const v of m.changes.sort((b,y)=>y.originalStart-b.originalStart))N(L,d,L-(v.originalStart+v.originalLength)),L=v.originalStart,d=v.modifiedStart-A,this.s([...C,L],v.originalLength,w.Iterable.slice(T,d,d+v.modifiedLength),a);N(L,d,L)}s(n,e,s=w.Iterable.empty(),{onDidCreateNode:r,onDidDeleteNode:a,diffIdentityProvider:h}){const{parentNode:p,listIndex:T,revealed:A,visible:m}=this.G(n),C=[],N=w.Iterable.map(s,re=>this.w(re,p,p.visible?1:0,A,C,r)),L=n[n.length-1],d=p.children.length>0;let v=0;for(let re=L;re>=0&&re<p.children.length;re--){const he=p.children[re];if(he.visible){v=he.visibleChildIndex;break}}const b=[];let y=0,R=0;for(const re of N)b.push(re),R+=re.renderNodeCount,re.visible&&(re.visibleChildIndex=v+y++);const V=(0,P.splice)(p.children,L,e,b);h?p.lastDiffIds?(0,P.splice)(p.lastDiffIds,L,e,b.map(re=>h.getId(re.element).toString())):p.lastDiffIds=p.children.map(re=>h.getId(re.element).toString()):p.lastDiffIds=void 0;let ee=0;for(const re of V)re.visible&&ee++;if(ee!==0)for(let re=L+b.length;re<p.children.length;re++){const he=p.children[re];he.visible&&(he.visibleChildIndex-=ee)}if(p.visibleChildrenCount+=y-ee,A&&m){const re=V.reduce((he,de)=>he+(de.visible?de.renderNodeCount:0),0);this.B(p,R-re),this.p.splice(T,re,C)}if(V.length>0&&a){const re=he=>{a(he),he.children.forEach(re)};V.forEach(re)}this.l.fire({insertedNodes:b,deletedNodes:V});const Z=p.children.length>0;d!==Z&&this.setCollapsible(n.slice(0,-1),Z);let J=p;for(;J;){if(J.visibility===2){this.m.trigger(()=>this.refilter());break}J=J.parent}}rerender(n){if(n.length===0)throw new E.TreeError(this.o,"Invalid tree location");const{node:e,listIndex:s,revealed:r}=this.F(n);e.visible&&r&&this.p.splice(s,1,[e])}updateElementHeight(n,e){if(n.length===0)throw new E.TreeError(this.o,"Invalid tree location");const{listIndex:s}=this.F(n);this.p.updateElementHeight(s,e)}has(n){return this.D(n)}getListIndex(n){const{listIndex:e,visible:s,revealed:r}=this.F(n);return s&&r?e:-1}getListRenderCount(n){return this.E(n).renderNodeCount}isCollapsible(n){return this.E(n).collapsible}setCollapsible(n,e){const s=this.E(n);typeof e>"u"&&(e=!s.collapsible);const r={collapsible:e};return this.d.bufferEvents(()=>this.t(n,r))}isCollapsed(n){return this.E(n).collapsed}setCollapsed(n,e,s){const r=this.E(n);typeof e>"u"&&(e=!r.collapsed);const a={collapsed:e,recursive:s||!1};return this.d.bufferEvents(()=>this.t(n,a))}t(n,e){const{node:s,listIndex:r,revealed:a}=this.F(n),h=this.u(s,r,a,e);if(s!==this.c&&this.k&&h&&!c(e)&&s.collapsible&&!s.collapsed&&!e.recursive){let p=-1;for(let T=0;T<s.children.length;T++)if(s.children[T].visible)if(p>-1){p=-1;break}else p=T;p>-1&&this.t([...n,p],e)}return h}u(n,e,s,r){const a=this.v(n,r,!1);if(!s||!n.visible||!a)return a;const h=n.renderNodeCount,p=this.x(n),T=h-(e===-1?0:1);return this.p.splice(e+1,T,p.slice(1)),a}v(n,e,s){let r;if(n===this.c?r=!1:(c(e)?(r=n.collapsible!==e.collapsible,n.collapsible=e.collapsible):n.collapsible?(r=n.collapsed!==e.collapsed,n.collapsed=e.collapsed):r=!1,r&&this.f.fire({node:n,deep:s})),!c(e)&&e.recursive)for(const a of n.children)r=this.v(a,e,!0)||r;return r}expandTo(n){this.d.bufferEvents(()=>{let e=this.E(n);for(;e.parent;)e=e.parent,n=n.slice(0,n.length-1),e.collapsed&&this.t(n,{collapsed:!1,recursive:!1})})}refilter(){const n=this.c.renderNodeCount,e=this.z(this.c);this.p.splice(0,n,e),this.m.cancel()}w(n,e,s,r,a,h){const p={parent:e,element:n.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof n.collapsible=="boolean"?n.collapsible:typeof n.collapsed<"u",collapsed:typeof n.collapsed>"u"?this.h:n.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},T=this.C(p,s);p.visibility=T,r&&a.push(p);const A=n.children||w.Iterable.empty(),m=r&&T!==0&&!p.collapsed;let C=0,N=1;for(const L of A){const d=this.w(L,p,T,m,a,h);p.children.push(d),N+=d.renderNodeCount,d.visible&&(d.visibleChildIndex=C++)}return p.collapsible=p.collapsible||p.children.length>0,p.visibleChildrenCount=C,p.visible=T===2?C>0:T===1,p.visible?p.collapsed||(p.renderNodeCount=N):(p.renderNodeCount=0,r&&a.pop()),h?.(p),p}x(n){const e=n.renderNodeCount,s=[];return this.y(n,s),this.B(n.parent,s.length-e),s}y(n,e){if(n.visible===!1)return 0;if(e.push(n),n.renderNodeCount=1,!n.collapsed)for(const s of n.children)n.renderNodeCount+=this.y(s,e);return this.g.fire(n),n.renderNodeCount}z(n){const e=n.renderNodeCount,s=[];return this.A(n,n.visible?1:0,s),this.B(n.parent,s.length-e),s}A(n,e,s,r=!0){let a;if(n!==this.c){if(a=this.C(n,e),a===0)return n.visible=!1,n.renderNodeCount=0,!1;r&&s.push(n)}const h=s.length;n.renderNodeCount=n===this.c?0:1;let p=!1;if(!n.collapsed||a!==0){let T=0;for(const A of n.children)p=this.A(A,a,s,r&&!n.collapsed)||p,A.visible&&(A.visibleChildIndex=T++);n.visibleChildrenCount=T}else n.visibleChildrenCount=0;return n!==this.c&&(n.visible=a===2?p:a===1,n.visibility=a),n.visible?n.collapsed||(n.renderNodeCount+=s.length-h):(n.renderNodeCount=0,r&&s.pop()),this.g.fire(n),n.visible}B(n,e){if(e!==0)for(;n;)n.renderNodeCount+=e,this.g.fire(n),n=n.parent}C(n,e){const s=this.j?this.j.filter(n.element,e):1;return typeof s=="boolean"?(n.filterData=void 0,s?1:0):f(s)?(n.filterData=s.data,u(s.visibility)):(n.filterData=void 0,u(s))}D(n,e=this.c){if(!n||n.length===0)return!0;const[s,...r]=n;return s<0||s>e.children.length?!1:this.D(r,e.children[s])}E(n,e=this.c){if(!n||n.length===0)return e;const[s,...r]=n;if(s<0||s>e.children.length)throw new E.TreeError(this.o,"Invalid tree location");return this.E(r,e.children[s])}F(n){if(n.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:s,revealed:r,visible:a}=this.G(n),h=n[n.length-1];if(h<0||h>e.children.length)throw new E.TreeError(this.o,"Invalid tree location");const p=e.children[h];return{node:p,listIndex:s,revealed:r,visible:a&&p.visible}}G(n,e=this.c,s=0,r=!0,a=!0){const[h,...p]=n;if(h<0||h>e.children.length)throw new E.TreeError(this.o,"Invalid tree location");for(let T=0;T<h;T++)s+=e.children[T].renderNodeCount;return r=r&&!e.collapsed,a=a&&e.visible,p.length===0?{parentNode:e,listIndex:s,revealed:r,visible:a}:this.G(p,e.children[h],s+1,r,a)}getNode(n=[]){return this.E(n)}getNodeLocation(n){const e=[];let s=n;for(;s.parent;)e.push(s.parent.children.indexOf(s)),s=s.parent;return e.reverse()}getParentNodeLocation(n){if(n.length!==0)return n.length===1?[]:(0,P.tail2)(n)[0]}getFirstElementChild(n){const e=this.E(n);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(n=[]){const e=this.E(n);if(e.children.length!==0)return this.H(e)}H(n){return n.children.length===0?n.element:this.H(n.children[n.children.length-1])}}t.IndexTreeModel=M}),define(ge[119],me([1,0,55,24,26]),function(Q,t,E,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class i{get size(){return this.d.size}constructor(w,f,u={}){this.k=w,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new E.IndexTreeModel(w,f,null,u),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,u.sorter&&(this.j={compare(c,M){return u.sorter.compare(c.element,M.element)}}),this.h=u.identityProvider}setChildren(w,f=U.Iterable.empty(),u={}){const c=this.o(w);this.l(c,this.m(f),u)}l(w,f=U.Iterable.empty(),u){const c=new Set,M=new Set,o=e=>{if(e.element===null)return;const s=e;if(c.add(s.element),this.d.set(s.element,s),this.h){const r=this.h.getId(s.element).toString();M.add(r),this.f.set(r,s)}u.onDidCreateNode?.(s)},n=e=>{if(e.element===null)return;const s=e;if(c.has(s.element)||this.d.delete(s.element),this.h){const r=this.h.getId(s.element).toString();M.has(r)||this.f.delete(r)}u.onDidDeleteNode?.(s)};this.c.splice([...w,0],Number.MAX_VALUE,f,{...u,onDidCreateNode:o,onDidDeleteNode:n})}m(w=U.Iterable.empty()){return this.j&&(w=[...w].sort(this.j.compare.bind(this.j))),U.Iterable.map(w,f=>{let u=this.d.get(f.element);if(!u&&this.h){const o=this.h.getId(f.element).toString();u=this.f.get(o)}if(!u)return{...f,children:this.m(f.children)};const c=typeof f.collapsible=="boolean"?f.collapsible:u.collapsible,M=typeof f.collapsed<"u"?f.collapsed:u.collapsed;return{...f,collapsible:c,collapsed:M,children:this.m(f.children)}})}rerender(w){const f=this.o(w);this.c.rerender(f)}updateElementHeight(w,f){const u=this.o(w);this.c.updateElementHeight(u,f)}resort(w=null,f=!0){if(!this.j)return;const u=this.o(w),c=this.c.getNode(u);this.l(u,this.n(c,f),{})}n(w,f,u=!0){let c=[...w.children];return(f||u)&&(c=c.sort(this.j.compare.bind(this.j))),U.Iterable.map(c,M=>({element:M.element,collapsible:M.collapsible,collapsed:M.collapsed,children:this.n(M,f,!1)}))}getFirstElementChild(w=null){const f=this.o(w);return this.c.getFirstElementChild(f)}getLastElementAncestor(w=null){const f=this.o(w);return this.c.getLastElementAncestor(f)}has(w){return this.d.has(w)}getListIndex(w){const f=this.o(w);return this.c.getListIndex(f)}getListRenderCount(w){const f=this.o(w);return this.c.getListRenderCount(f)}isCollapsible(w){const f=this.o(w);return this.c.isCollapsible(f)}setCollapsible(w,f){const u=this.o(w);return this.c.setCollapsible(u,f)}isCollapsed(w){const f=this.o(w);return this.c.isCollapsed(f)}setCollapsed(w,f,u){const c=this.o(w);return this.c.setCollapsed(c,f,u)}expandTo(w){const f=this.o(w);this.c.expandTo(f)}refilter(){this.c.refilter()}getNode(w=null){if(w===null)return this.c.getNode(this.c.rootRef);const f=this.d.get(w);if(!f)throw new P.TreeError(this.k,`Tree element not found: ${w}`);return f}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new P.TreeError(this.k,"Invalid getParentNodeLocation call");const f=this.d.get(w);if(!f)throw new P.TreeError(this.k,`Tree element not found: ${w}`);const u=this.c.getNodeLocation(f),c=this.c.getParentNodeLocation(u);return this.c.getNode(c).element}o(w){if(w===null)return[];const f=this.d.get(w);if(!f)throw new P.TreeError(this.k,`Tree element not found: ${w}`);return this.c.getNodeLocation(f)}}t.ObjectTreeModel=i}),define(ge[19],me([1,0,4,14,21,23,2]),function(Q,t,E,P,U,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends D.Disposable{f(u,c){this.B(E.addDisposableListener(u,E.EventType.CLICK,M=>c(new U.StandardMouseEvent(M))))}j(u,c){this.B(E.addDisposableListener(u,E.EventType.MOUSE_DOWN,M=>c(new U.StandardMouseEvent(M))))}k(u,c){this.B(E.addDisposableListener(u,E.EventType.MOUSE_OVER,M=>c(new U.StandardMouseEvent(M))))}m(u,c){this.B(E.addDisposableListener(u,E.EventType.MOUSE_LEAVE,M=>c(new U.StandardMouseEvent(M))))}p(u,c){this.B(E.addDisposableListener(u,E.EventType.KEY_DOWN,M=>c(new P.StandardKeyboardEvent(M))))}u(u,c){this.B(E.addDisposableListener(u,E.EventType.KEY_UP,M=>c(new P.StandardKeyboardEvent(M))))}z(u,c){this.B(E.addDisposableListener(u,E.EventType.INPUT,c))}C(u,c){this.B(E.addDisposableListener(u,E.EventType.BLUR,c))}D(u,c){this.B(E.addDisposableListener(u,E.EventType.FOCUS,c))}F(u,c){this.B(E.addDisposableListener(u,E.EventType.CHANGE,c))}G(u){return i.Gesture.ignoreTarget(u)}}t.Widget=w}),define(ge[36],me([1,0,53,19,9,17,4]),function(Q,t,E,P,U,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class w extends P.Widget{constructor(u){super(),this.a=u.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=u.bgWidth+"px",this.bgDomNode.style.height=u.bgHeight+"px",typeof u.top<"u"&&(this.bgDomNode.style.top="0px"),typeof u.left<"u"&&(this.bgDomNode.style.left="0px"),typeof u.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof u.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=u.className,this.domNode.classList.add(...i.ThemeIcon.asClassNameArray(u.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof u.top<"u"&&(this.domNode.style.top=u.top+"px"),typeof u.left<"u"&&(this.domNode.style.left=u.left+"px"),typeof u.bottom<"u"&&(this.domNode.style.bottom=u.bottom+"px"),typeof u.right<"u"&&(this.domNode.style.right=u.right+"px"),this.g=this.B(new E.GlobalPointerMoveMonitor),this.B(D.addStandardDisposableListener(this.bgDomNode,D.EventType.POINTER_DOWN,c=>this.h(c))),this.B(D.addStandardDisposableListener(this.domNode,D.EventType.POINTER_DOWN,c=>this.h(c))),this.b=this.B(new U.IntervalTimer),this.c=this.B(new U.TimeoutTimer)}h(u){if(!u.target||!(u.target instanceof Element))return;const c=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(c,200),this.g.startMonitoring(u.target,u.pointerId,u.buttons,M=>{},()=>{this.b.cancel(),this.c.cancel()}),u.preventDefault()}}t.ScrollbarArrow=w}),define(ge[56],me([1,0,4,39,53,36,117,19,5]),function(Q,t,E,P,U,i,D,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const u=140;class c extends w.Widget{constructor(o){super(),this.g=o.lazyRender,this.a=o.host,this.b=o.scrollable,this.c=o.scrollByPage,this.h=o.scrollbarState,this.i=this.B(new D.ScrollbarVisibilityController(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new U.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,P.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(E.addDisposableListener(this.domNode.domNode,E.EventType.POINTER_DOWN,n=>this.y(n)))}r(o){const n=this.B(new i.ScrollbarArrow(o));this.domNode.domNode.appendChild(n.bgDomNode),this.domNode.domNode.appendChild(n.domNode)}s(o,n,e,s){this.slider=(0,P.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(n),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(E.addDisposableListener(this.slider.domNode,E.EventType.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this.I(r))})),this.f(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}t(o){return this.h.setVisibleSize(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(o){return this.h.setScrollSize(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(o){return this.h.setScrollPosition(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){!this.n||(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(o){o.target===this.domNode.domNode&&this.H(o)}delegatePointerDown(o){const n=this.domNode.domNode.getClientRects()[0].top,e=n+this.h.getSliderPosition(),s=n+this.h.getSliderPosition()+this.h.getSliderSize(),r=this.O(o);e<=r&&r<=s?o.button===0&&(o.preventDefault(),this.I(o)):this.H(o)}H(o){let n,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")n=o.offsetX,e=o.offsetY;else{const r=E.getDomNodePagePosition(this.domNode.domNode);n=o.pageX-r.left,e=o.pageY-r.top}const s=this.N(n,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),o.button===0&&(o.preventDefault(),this.I(o))}I(o){if(!o.target||!(o.target instanceof Element))return;const n=this.O(o),e=this.P(o),s=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(o.target,o.pointerId,o.buttons,r=>{const a=this.P(r),h=Math.abs(a-e);if(f.isWindows&&h>u){this.J(s.getScrollPosition());return}const T=this.O(r)-n;this.J(s.getDesiredScrollPositionFromDelta(T))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(o){const n={};this.writeScrollPosition(n,o),this.b.setScrollPositionNow(n)}updateScrollbarSize(o){this.Q(o),this.h.setScrollbarSize(o),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=c}),define(ge[120],me([1,0,21,56,36,40,16]),function(Q,t,E,P,U,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends P.AbstractScrollbar{constructor(u,c,M){const o=u.getScrollDimensions(),n=u.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:M,scrollbarState:new i.ScrollbarState(c.horizontalHasArrows?c.arrowSize:0,c.horizontal===2?0:c.horizontalScrollbarSize,c.vertical===2?0:c.verticalScrollbarSize,o.width,o.scrollWidth,n.scrollLeft),visibility:c.horizontal,extraScrollbarClassName:"horizontal",scrollable:u,scrollByPage:c.scrollByPage}),c.horizontalHasArrows){const e=(c.arrowSize-U.ARROW_IMG_SIZE)/2,s=(c.horizontalScrollbarSize-U.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:D.Codicon.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:D.Codicon.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((c.horizontalScrollbarSize-c.horizontalSliderSize)/2),0,void 0,c.horizontalSliderSize)}M(u,c){this.slider.setWidth(u),this.slider.setLeft(c)}L(u,c){this.domNode.setWidth(u),this.domNode.setHeight(c),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(u){return this.n=this.v(u.scrollWidth)||this.n,this.n=this.w(u.scrollLeft)||this.n,this.n=this.t(u.width)||this.n,this.n}N(u,c){return u}O(u){return u.pageX}P(u){return u.pageY}Q(u){this.slider.setHeight(u)}writeScrollPosition(u,c){u.scrollLeft=c}updateOptions(u){this.updateScrollbarSize(u.horizontal===2?0:u.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this.i.setVisibility(u.horizontal),this.c=u.scrollByPage}}t.HorizontalScrollbar=w}),define(ge[121],me([1,0,21,56,36,40,16]),function(Q,t,E,P,U,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends P.AbstractScrollbar{constructor(u,c,M){const o=u.getScrollDimensions(),n=u.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:M,scrollbarState:new i.ScrollbarState(c.verticalHasArrows?c.arrowSize:0,c.vertical===2?0:c.verticalScrollbarSize,0,o.height,o.scrollHeight,n.scrollTop),visibility:c.vertical,extraScrollbarClassName:"vertical",scrollable:u,scrollByPage:c.scrollByPage}),c.verticalHasArrows){const e=(c.arrowSize-U.ARROW_IMG_SIZE)/2,s=(c.verticalScrollbarSize-U.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:D.Codicon.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:D.Codicon.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((c.verticalScrollbarSize-c.verticalSliderSize)/2),c.verticalSliderSize,void 0)}M(u,c){this.slider.setHeight(u),this.slider.setTop(c)}L(u,c){this.domNode.setWidth(c),this.domNode.setHeight(u),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(u){return this.n=this.v(u.scrollHeight)||this.n,this.n=this.w(u.scrollTop)||this.n,this.n=this.t(u.height)||this.n,this.n}N(u,c){return c}O(u){return u.pageY}P(u){return u.pageX}Q(u){this.slider.setWidth(u)}writeScrollPosition(u,c){u.scrollTop=c}updateOptions(u){this.updateScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(u.vertical),this.c=u.scrollByPage}}t.VerticalScrollbar=w}),define(ge[57],me([1,0,18,4,39,21,120,121,19,9,3,2,5,49,90]),function(Q,t,E,P,U,i,D,w,f,u,c,M,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,s=50,r=!0;class a{constructor(L,d,v){this.timestamp=L,this.deltaX=d,this.deltaY=v,this.score=0}}class h{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let L=1,d=0,v=1,b=this.d;do{const y=b===this.c?L:Math.pow(2,-v);if(L-=y,d+=this.b[b].score*y,b===this.c)break;b=(this.a+b-1)%this.a,v++}while(!0);return d<=.5}acceptStandardWheelEvent(L){const d=window.devicePixelRatio/(0,E.getZoomFactor)();o.isWindows||o.isLinux?this.accept(Date.now(),L.deltaX/d,L.deltaY/d):this.accept(Date.now(),L.deltaX,L.deltaY)}accept(L,d,v){const b=new a(L,d,v);b.score=this.f(b),this.c===-1&&this.d===-1?(this.b[0]=b,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=b)}f(L){if(Math.abs(L.deltaX)>0&&Math.abs(L.deltaY)>0)return 1;let d=.5;const v=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(L.deltaX)||!this.g(L.deltaY))&&(d+=.25),Math.min(Math.max(d,0),1)}g(L){return Math.abs(Math.round(L)-L)<.01}}t.MouseWheelClassifier=h,h.INSTANCE=new h;class p extends f.Widget{get options(){return this.a}constructor(L,d,v){super(),this.I=this.B(new c.Emitter),this.onScroll=this.I.event,this.J=this.B(new c.Emitter),this.onWillScroll=this.J.event,L.style.overflow="hidden",this.a=C(d),this.b=v,this.B(this.b.onScroll(y=>{this.J.fire(y),this.N(y),this.I.fire(y)}));const b={onMouseWheel:y=>this.M(y),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.B(new w.VerticalScrollbar(this.b,this.a,b)),this.g=this.B(new D.HorizontalScrollbar(this.b,this.a,b)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(L),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,U.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,U.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,U.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,y=>this.S(y)),this.m(this.r,y=>this.R(y)),this.w=this.B(new u.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,M.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(L){this.c.delegatePointerDown(L)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(L){this.b.setScrollDimensions(L,!1)}updateClassName(L){this.a.className=L,o.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(L){typeof L.handleMouseWheel<"u"&&(this.a.handleMouseWheel=L.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof L.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=L.mouseWheelScrollSensitivity),typeof L.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=L.fastScrollSensitivity),typeof L.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=L.scrollPredominantAxis),typeof L.horizontal<"u"&&(this.a.horizontal=L.horizontal),typeof L.vertical<"u"&&(this.a.vertical=L.vertical),typeof L.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=L.horizontalScrollbarSize),typeof L.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=L.verticalScrollbarSize),typeof L.scrollByPage<"u"&&(this.a.scrollByPage=L.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(L){this.H=L}delegateScrollFromMouseWheelEvent(L){this.M(new i.StandardWheelEvent(L))}L(L){if(this.s.length>0!==L&&(this.s=(0,M.dispose)(this.s),L)){const v=b=>{this.M(new i.StandardWheelEvent(b))};this.s.push(P.addDisposableListener(this.r,P.EventType.MOUSE_WHEEL,v,{passive:!1}))}}M(L){const d=h.INSTANCE;r&&d.acceptStandardWheelEvent(L);let v=!1;if(L.deltaY||L.deltaX){let y=L.deltaY*this.a.mouseWheelScrollSensitivity,R=L.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(y)>=Math.abs(R)?R=0:y=0),this.a.flipAxes&&([y,R]=[R,y]);const V=!o.isMacintosh&&L.browserEvent&&L.browserEvent.shiftKey;(this.a.scrollYToX||V)&&!R&&(R=y,y=0),L.browserEvent&&L.browserEvent.altKey&&(R=R*this.a.fastScrollSensitivity,y=y*this.a.fastScrollSensitivity);const ee=this.b.getFutureScrollPosition();let Z={};if(y){const J=s*y,re=ee.scrollTop-(J<0?Math.floor(J):Math.ceil(J));this.c.writeScrollPosition(Z,re)}if(R){const J=s*R,re=ee.scrollLeft-(J<0?Math.floor(J):Math.ceil(J));this.g.writeScrollPosition(Z,re)}Z=this.b.validateScrollPosition(Z),(ee.scrollLeft!==Z.scrollLeft||ee.scrollTop!==Z.scrollTop)&&(r&&this.a.mouseWheelSmoothScroll&&d.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(Z):this.b.setScrollPositionNow(Z),v=!0)}let b=v;!b&&this.a.alwaysConsumeMouseWheel&&(b=!0),!b&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(b=!0),b&&(L.preventDefault(),L.stopPropagation())}N(L){this.y=this.g.onDidScroll(L)||this.y,this.y=this.c.onDidScroll(L)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(!!this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const L=this.b.getCurrentScrollPosition(),d=L.scrollTop>0,v=L.scrollLeft>0,b=v?" left":"",y=d?" top":"",R=v||d?" top-left-corner":"";this.i.setClassName(`shadow${b}`),this.l.setClassName(`shadow${y}`),this.n.setClassName(`shadow${R}${y}${b}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(L){this.v=!1,this.W()}S(L){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.AbstractScrollableElement=p;class T extends p{constructor(L,d){d=d||{},d.mouseWheelSmoothScroll=!1;const v=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:b=>P.scheduleAtNextAnimationFrame(b)});super(L,d,v),this.B(v)}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=T;class A extends p{constructor(L,d,v){super(L,d,v)}setScrollPosition(L){L.reuseAnimation?this.b.setScrollPositionSmooth(L,L.reuseAnimation):this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=A;class m extends p{constructor(L,d){d=d||{},d.mouseWheelSmoothScroll=!1;const v=new n.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:b=>P.scheduleAtNextAnimationFrame(b)});super(L,d,v),this.B(v),this.Y=L,this.onScroll(b=>{b.scrollTopChanged&&(this.Y.scrollTop=b.scrollTop),b.scrollLeftChanged&&(this.Y.scrollLeft=b.scrollLeft)}),this.scanDomNode()}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.DomScrollableElement=m;function C(N){const L={lazyRender:typeof N.lazyRender<"u"?N.lazyRender:!1,className:typeof N.className<"u"?N.className:"",useShadows:typeof N.useShadows<"u"?N.useShadows:!0,handleMouseWheel:typeof N.handleMouseWheel<"u"?N.handleMouseWheel:!0,flipAxes:typeof N.flipAxes<"u"?N.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof N.consumeMouseWheelIfScrollbarIsNeeded<"u"?N.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof N.alwaysConsumeMouseWheel<"u"?N.alwaysConsumeMouseWheel:!1,scrollYToX:typeof N.scrollYToX<"u"?N.scrollYToX:!1,mouseWheelScrollSensitivity:typeof N.mouseWheelScrollSensitivity<"u"?N.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof N.fastScrollSensitivity<"u"?N.fastScrollSensitivity:5,scrollPredominantAxis:typeof N.scrollPredominantAxis<"u"?N.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof N.mouseWheelSmoothScroll<"u"?N.mouseWheelSmoothScroll:!0,arrowSize:typeof N.arrowSize<"u"?N.arrowSize:11,listenOnDomNode:typeof N.listenOnDomNode<"u"?N.listenOnDomNode:null,horizontal:typeof N.horizontal<"u"?N.horizontal:1,horizontalScrollbarSize:typeof N.horizontalScrollbarSize<"u"?N.horizontalScrollbarSize:10,horizontalSliderSize:typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:0,horizontalHasArrows:typeof N.horizontalHasArrows<"u"?N.horizontalHasArrows:!1,vertical:typeof N.vertical<"u"?N.vertical:1,verticalScrollbarSize:typeof N.verticalScrollbarSize<"u"?N.verticalScrollbarSize:10,verticalHasArrows:typeof N.verticalHasArrows<"u"?N.verticalHasArrows:!1,verticalSliderSize:typeof N.verticalSliderSize<"u"?N.verticalSliderSize:0,scrollByPage:typeof N.scrollByPage<"u"?N.scrollByPage:!1};return L.horizontalSliderSize=typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:L.horizontalScrollbarSize,L.verticalSliderSize=typeof N.verticalSliderSize<"u"?N.verticalSliderSize:L.verticalScrollbarSize,o.isMacintosh&&(L.className+=" mac"),L}}),define(ge[58],me([1,0,51,4,20,23,57,13,9,25,3,2,47,49,79,116,7]),function(Q,t,E,P,U,i,D,w,f,u,c,M,o,n,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const a={CurrentDragAndDropData:void 0},h={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(L){return[L]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class p{get context(){return this.d}set context(d){this.d=d}constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=p;class T{constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=T;class A{constructor(){this.types=[],this.files=[]}update(d){if(d.types&&this.types.splice(0,this.types.length,...d.types),d.files){this.files.splice(0,this.files.length);for(let v=0;v<d.files.length;v++){const b=d.files.item(v);b&&(b.size||b.type)&&this.files.push(b)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=A;function m(L,d){return Array.isArray(L)&&Array.isArray(d)?(0,w.equals)(L,d):L===d}class C{constructor(d){d?.getSetSize?this.getSetSize=d.getSetSize.bind(d):this.getSetSize=(v,b,y)=>y,d?.getPosInSet?this.getPosInSet=d.getPosInSet.bind(d):this.getPosInSet=(v,b)=>b+1,d?.getRole?this.getRole=d.getRole.bind(d):this.getRole=v=>"listitem",d?.isChecked?this.isChecked=d.isChecked.bind(d):this.isChecked=v=>{}}}class N{get contentHeight(){return this.g.size}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get O(){return this.N}set O(d){if(d!==this.N){if(d&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.N=d,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.N){for(const v of this.d)this.X(v);this.U(),this.q.setScrollDimensions({width:(0,P.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(d,v,b,y=h){if(this.P=v,this.domId=`list_id_${++N.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new f.Delayer(50),this.v=!1,this.x=M.Disposable.None,this.y=0,this.G=!1,this.J=M.Disposable.None,this.K=M.Disposable.None,this.L=new M.DisposableStore,this.M=new c.Emitter,this.onDidChangeContentHeight=c.Event.latch(this.M.event,void 0,this.L),this.N=!1,y.horizontalScrolling&&y.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const V of b)this.j.set(V.templateId,V);this.h=this.L.add(new s.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof y.mouseSupport=="boolean"?y.mouseSupport:!0),this.N=y.horizontalScrolling??h.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.C=typeof y.additionalScrollHeight>"u"?0:y.additionalScrollHeight,this.D=new C(y.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(y.transformOptimization??h.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(i.Gesture.addTarget(this.o)),this.p=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:y.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,P.scheduleAtNextAnimationFrame)(V)}),this.q=this.L.add(new D.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:y.alwaysConsumeMouseWheel??h.alwaysConsumeMouseWheel,horizontal:1,vertical:y.verticalScrollMode??h.verticalScrollMode,useShadows:y.useShadows??h.useShadows,mouseWheelScrollSensitivity:y.mouseWheelScrollSensitivity,fastScrollSensitivity:y.fastScrollSensitivity,scrollByPage:y.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),d.appendChild(this.domNode),this.q.onScroll(this.fb,this,this.L),this.L.add((0,P.addDisposableListener)(this.o,i.EventType.Change,V=>this.gb(V))),this.L.add((0,P.addDisposableListener)(this.q.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.L.add((0,P.addDisposableListener)(this.domNode,"dragover",V=>this.ib(this.eb(V)))),this.L.add((0,P.addDisposableListener)(this.domNode,"drop",V=>this.kb(this.eb(V)))),this.L.add((0,P.addDisposableListener)(this.domNode,"dragleave",V=>this.jb(this.eb(V)))),this.L.add((0,P.addDisposableListener)(this.domNode,"dragend",V=>this.lb(V))),this.z=y.setRowLineHeight??h.setRowLineHeight,this.A=y.setRowHeight??h.setRowHeight,this.B=y.supportDynamicHeights??h.supportDynamicHeights,this.F=y.dnd??h.dnd,this.layout(y.initialSize?.height,y.initialSize?.width)}updateOptions(d){d.additionalScrollHeight!==void 0&&(this.C=d.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),d.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(d.smoothScrolling?125:0),d.horizontalScrolling!==void 0&&(this.O=d.horizontalScrolling);let v;d.scrollByPage!==void 0&&(v={...v??{},scrollByPage:d.scrollByPage}),d.mouseWheelScrollSensitivity!==void 0&&(v={...v??{},mouseWheelScrollSensitivity:d.mouseWheelScrollSensitivity}),d.fastScrollSensitivity!==void 0&&(v={...v??{},fastScrollSensitivity:d.fastScrollSensitivity}),v&&this.q.updateOptions(v)}delegateScrollFromMouseWheelEvent(d){this.q.delegateScrollFromMouseWheelEvent(d)}delegateVerticalScrollbarPointerDown(d){this.q.delegateVerticalScrollbarPointerDown(d)}updateElementHeight(d,v,b){if(d<0||d>=this.d.length)return;const y=this.d[d].size;if(typeof v>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[d].lastDynamicHeightWidth=void 0,v=y+this.tb(d)}if(y===v)return;const R=this.rb(this.k,this.m);let V=0;d<R.start||b!==null&&b>d&&b<=R.end?V=v-y:V=0,this.g.splice(d,1,[{size:v}]),this.d[d].size=v,this.V(R,Math.max(0,this.k+V),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.R(),this.B&&this.sb(this.k,this.m)}splice(d,v,b=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.Q(d,v,b)}finally{this.v=!1,this.M.fire(this.contentHeight)}}Q(d,v,b=[]){const y=this.rb(this.k,this.m),R={start:d,end:d+v},V=o.Range.intersect(y,R),ee=new Map;for(let ae=V.end-1;ae>=V.start;ae--){const te=this.d[ae];if(te.dragStartDisposable.dispose(),te.checkedDisposable.dispose(),te.row){let $=ee.get(te.templateId);$||($=[],ee.set(te.templateId,$));const g=this.j.get(te.templateId);g&&g.disposeElement&&g.disposeElement(te.element,ae,te.row.templateData,te.size),$.push(te.row)}te.row=null}const Z={start:d+v,end:this.d.length},J=o.Range.intersect(Z,y),re=o.Range.relativeComplement(Z,y),he=b.map(ae=>({id:String(this.f++),element:ae,templateId:this.P.getTemplateId(ae),size:this.P.getHeight(ae),width:void 0,hasDynamicHeight:!!this.P.hasDynamicHeight&&this.P.hasDynamicHeight(ae),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:M.Disposable.None,checkedDisposable:M.Disposable.None}));let de;d===0&&v>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,he),de=this.d,this.d=he):(this.g.splice(d,v,he),de=this.d.splice(d,v,...he));const ce=b.length-v,pe=this.rb(this.k,this.m),Te=(0,e.shift)(J,ce),Pe=o.Range.intersect(pe,Te);for(let ae=Pe.start;ae<Pe.end;ae++)this.Y(this.d[ae],ae);const Oe=o.Range.relativeComplement(Te,pe);for(const ae of Oe)for(let te=ae.start;te<ae.end;te++)this.Z(te);const x=re.map(ae=>(0,e.shift)(ae,ce)),ie=[{start:d,end:d+b.length},...x].map(ae=>o.Range.intersect(pe,ae)),se=this.ub(ie);for(const ae of ie)for(let te=ae.start;te<ae.end;te++){const $=this.d[te],l=ee.get($.templateId)?.pop();this.W(te,se,l)}for(const ae of ee.values())for(const te of ae)this.h.release(te);return this.R(),this.B&&this.sb(this.scrollTop,this.renderHeight),de.map(ae=>ae.element)}R(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,P.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.U(),this.t=null}))}S(){if(!this.O){this.u.cancel();return}this.u.trigger(()=>this.U())}U(){if(!this.O)return;let d=0;for(const v of this.d)typeof v.width<"u"&&(d=Math.max(d,v.width));this.E=d,this.q.setScrollDimensions({scrollWidth:d===0?0:d+10})}updateWidth(d){if(!this.O||typeof this.E>"u")return;const v=this.d[d];this.X(v),typeof v.width<"u"&&v.width>this.E&&(this.E=v.width,this.q.setScrollDimensions({scrollWidth:this.E+10}))}rerender(){if(!!this.B){for(const d of this.d)d.lastDynamicHeightWidth=void 0;this.sb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const d=this.rb(this.k,this.m),v=this.g.positionAt(d.start),b=this.g.positionAt(d.start+1);return b!==-1&&(b-v)/2+v<this.scrollTop?d.start+1:d.start}get lastVisibleIndex(){return this.rb(this.k,this.m).end-1}element(d){return this.d[d].element}indexOf(d){return this.d.findIndex(v=>v.element===d)}domElement(d){const v=this.d[d].row;return v&&v.domNode}elementHeight(d){return this.d[d].size}elementTop(d){return this.g.positionAt(d)}indexAt(d){return this.g.indexAt(d)}indexAfter(d){return this.g.indexAfter(d)}layout(d,v){const b={height:typeof d=="number"?d:(0,P.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,b.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(b),typeof v<"u"&&(this.n=v,this.B&&this.sb(this.scrollTop,this.renderHeight)),this.O&&this.q.setScrollDimensions({width:typeof v=="number"?v:(0,P.getContentWidth)(this.domNode)})}V(d,v,b,y,R,V=!1){const ee=this.rb(v,b),Z=o.Range.relativeComplement(ee,d),J=o.Range.relativeComplement(d,ee),re=this.ub(Z);if(V){const he=o.Range.intersect(d,ee);for(let de=he.start;de<he.end;de++)this.Y(this.d[de],de)}this.h.transact(()=>{for(const he of J)for(let de=he.start;de<he.end;de++)this.Z(de);for(const he of Z)for(let de=he.start;de<he.end;de++)this.W(de,re)}),y!==void 0&&(this.o.style.left=`-${y}px`),this.o.style.top=`-${v}px`,this.O&&R!==void 0&&(this.o.style.width=`${Math.max(R,this.n)}px`),this.k=v,this.m=b}W(d,v,b){const y=this.d[d];let R=!1;if(!y.row)if(b)y.row=b;else{const re=this.h.alloc(y.templateId);y.row=re.row,R=re.isReusingConnectedDomNode}const V=this.D.getRole(y.element)||"listitem";y.row.domNode.setAttribute("role",V);const ee=this.D.isChecked(y.element);if(typeof ee=="boolean")y.row.domNode.setAttribute("aria-checked",String(!!ee));else if(ee){const re=he=>y.row.domNode.setAttribute("aria-checked",String(!!he));re(ee.value),y.checkedDisposable=ee.onDidChange(re)}(R||!y.row.domNode.parentElement)&&(v?this.o.insertBefore(y.row.domNode,v):this.o.appendChild(y.row.domNode)),this.Y(y,d);const Z=this.j.get(y.templateId);if(!Z)throw new Error(`No renderer found for template id ${y.templateId}`);Z?.renderElement(y.element,d,y.row.templateData,y.size);const J=this.F.getDragURI(y.element);y.dragStartDisposable.dispose(),y.row.domNode.draggable=!!J,J&&(y.dragStartDisposable=(0,P.addDisposableListener)(y.row.domNode,"dragstart",re=>this.hb(y.element,J,re))),this.O&&(this.X(y),this.S())}X(d){if(!d.row||!d.row.domNode)return;d.row.domNode.style.width="fit-content",d.width=(0,P.getContentWidth)(d.row.domNode);const v=window.getComputedStyle(d.row.domNode);v.paddingLeft&&(d.width+=parseFloat(v.paddingLeft)),v.paddingRight&&(d.width+=parseFloat(v.paddingRight)),d.row.domNode.style.width=""}Y(d,v){d.row.domNode.style.top=`${this.elementTop(v)}px`,this.A&&(d.row.domNode.style.height=`${d.size}px`),this.z&&(d.row.domNode.style.lineHeight=`${d.size}px`),d.row.domNode.setAttribute("data-index",`${v}`),d.row.domNode.setAttribute("data-last-element",v===this.length-1?"true":"false"),d.row.domNode.setAttribute("data-parity",v%2===0?"even":"odd"),d.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(d.element,v,this.length))),d.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(d.element,v))),d.row.domNode.setAttribute("id",this.getElementDomId(v)),d.row.domNode.classList.toggle("drop-target",d.dropTarget)}Z(d){const v=this.d[d];if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const b=this.j.get(v.templateId);b&&b.disposeElement&&b.disposeElement(v.element,d,v.row.templateData,v.size),this.h.release(v.row),v.row=null}this.O&&this.S()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(d,v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:d,reuseAnimation:v})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(d){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:d})}get scrollTop(){return this.getScrollTop()}set scrollTop(d){this.setScrollTop(d)}get scrollHeight(){return this.s+(this.O?10:0)+this.C}get onMouseClick(){return c.Event.map(this.L.add(new U.DomEmitter(this.domNode,"click")).event,d=>this.ab(d),this.L)}get onMouseDblClick(){return c.Event.map(this.L.add(new U.DomEmitter(this.domNode,"dblclick")).event,d=>this.ab(d),this.L)}get onMouseMiddleClick(){return c.Event.filter(c.Event.map(this.L.add(new U.DomEmitter(this.domNode,"auxclick")).event,d=>this.ab(d),this.L),d=>d.browserEvent.button===1,this.L)}get onMouseUp(){return c.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mouseup")).event,d=>this.ab(d),this.L)}get onMouseDown(){return c.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mousedown")).event,d=>this.ab(d),this.L)}get onMouseOver(){return c.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mouseover")).event,d=>this.ab(d),this.L)}get onMouseMove(){return c.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mousemove")).event,d=>this.ab(d),this.L)}get onMouseOut(){return c.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mouseout")).event,d=>this.ab(d),this.L)}get onContextMenu(){return c.Event.any(c.Event.map(this.L.add(new U.DomEmitter(this.domNode,"contextmenu")).event,d=>this.ab(d),this.L),c.Event.map(this.L.add(new U.DomEmitter(this.domNode,i.EventType.Contextmenu)).event,d=>this.db(d),this.L))}get onTouchStart(){return c.Event.map(this.L.add(new U.DomEmitter(this.domNode,"touchstart")).event,d=>this.bb(d),this.L)}get onTap(){return c.Event.map(this.L.add(new U.DomEmitter(this.o,i.EventType.Tap)).event,d=>this.db(d),this.L)}ab(d){const v=this.qb(d.target||null),b=typeof v>"u"?void 0:this.d[v],y=b&&b.element;return{browserEvent:d,index:v,element:y}}bb(d){const v=this.qb(d.target||null),b=typeof v>"u"?void 0:this.d[v],y=b&&b.element;return{browserEvent:d,index:v,element:y}}db(d){const v=this.qb(d.initialTarget||null),b=typeof v>"u"?void 0:this.d[v],y=b&&b.element;return{browserEvent:d,index:v,element:y}}eb(d){const v=this.qb(d.target||null),b=typeof v>"u"?void 0:this.d[v],y=b&&b.element;return{browserEvent:d,index:v,element:y}}fb(d){try{const v=this.rb(this.k,this.m);this.V(v,d.scrollTop,d.height,d.scrollLeft,d.scrollWidth),this.B&&this.sb(d.scrollTop,d.height,d.inSmoothScrolling)}catch(v){throw console.error("Got bad scroll event:",d),v}}gb(d){d.preventDefault(),d.stopPropagation(),this.scrollTop-=d.translationY}hb(d,v,b){if(!b.dataTransfer)return;const y=this.F.getDragElements(d);if(b.dataTransfer.effectAllowed="copyMove",b.dataTransfer.setData(E.DataTransfers.TEXT,v),b.dataTransfer.setDragImage){let R;this.F.getDragLabel&&(R=this.F.getDragLabel(y,b)),typeof R>"u"&&(R=String(y.length));const V=(0,P.$)(".monaco-drag-image");V.textContent=R,document.body.appendChild(V),b.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>document.body.removeChild(V),0)}this.domNode.classList.add("dragging"),this.H=new p(y),a.CurrentDragAndDropData=new T(y),this.F.onDragStart?.(this.H,b)}ib(d){if(d.browserEvent.preventDefault(),this.K.dispose(),a.CurrentDragAndDropData&&a.CurrentDragAndDropData.getData()==="vscode-ui"||(this.nb(d.browserEvent),!d.browserEvent.dataTransfer))return!1;if(!this.H)if(a.CurrentDragAndDropData)this.H=a.CurrentDragAndDropData;else{if(!d.browserEvent.dataTransfer.types)return!1;this.H=new A}const v=this.F.onDragOver(this.H,d.element,d.index,d.browserEvent);if(this.G=typeof v=="boolean"?v:v.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;d.browserEvent.dataTransfer.dropEffect=typeof v!="boolean"&&v.effect===0?"copy":"move";let b;if(typeof v!="boolean"&&v.feedback?b=v.feedback:typeof d.index>"u"?b=[-1]:b=[d.index],b=(0,w.distinct)(b).filter(y=>y>=-1&&y<this.length).sort((y,R)=>y-R),b=b[0]===-1?[-1]:b,m(this.I,b))return!0;if(this.I=b,this.J.dispose(),b[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,M.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const y of b){const R=this.d[y];R.dropTarget=!0,R.row?.domNode.classList.add("drop-target")}this.J=(0,M.toDisposable)(()=>{for(const y of b){const R=this.d[y];R.dropTarget=!1,R.row?.domNode.classList.remove("drop-target")}})}return!0}jb(d){this.K.dispose(),this.K=(0,f.disposableTimeout)(()=>this.mb(),100),this.H&&this.F.onDragLeave?.(this.H,d.element,d.index,d.browserEvent)}kb(d){if(!this.G)return;const v=this.H;this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,a.CurrentDragAndDropData=void 0,!(!v||!d.browserEvent.dataTransfer)&&(d.browserEvent.preventDefault(),v.update(d.browserEvent.dataTransfer),this.F.drop(v,d.element,d.index,d.browserEvent))}lb(d){this.G=!1,this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,a.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(d)}mb(){this.I=void 0,this.J.dispose(),this.J=M.Disposable.None}nb(d){if(!this.w){const v=(0,P.getTopLeftOffset)(this.domNode).top;this.w=(0,P.animate)(this.ob.bind(this,v))}this.x.dispose(),this.x=(0,f.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=d.pageY}ob(d){if(this.y===void 0)return;const v=this.y-d,b=this.renderHeight-35;v<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(v-35))):v>b&&(this.scrollTop+=Math.min(14,Math.floor(.3*(v-b))))}pb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}qb(d){const v=this.q.getDomNode();let b=d;for(;b instanceof HTMLElement&&b!==this.o&&v.contains(b);){const y=b.getAttribute("data-index");if(y){const R=Number(y);if(!isNaN(R))return R}b=b.parentElement}}rb(d,v){return{start:this.g.indexAt(d),end:this.g.indexAfter(d+v-1)}}sb(d,v,b){const y=this.rb(d,v);let R,V;d===this.elementTop(y.start)?(R=y.start,V=0):y.end-y.start>1&&(R=y.start+1,V=this.elementTop(R)-d);let ee=0;for(;;){const Z=this.rb(d,v);let J=!1;for(let re=Z.start;re<Z.end;re++){const he=this.tb(re);he!==0&&this.g.splice(re,1,[this.d[re]]),ee+=he,J=J||he!==0}if(!J){ee!==0&&this.R();const re=o.Range.relativeComplement(y,Z);for(const de of re)for(let ce=de.start;ce<de.end;ce++)this.d[ce].row&&this.Z(ce);const he=o.Range.relativeComplement(Z,y);for(const de of he)for(let ce=de.start;ce<de.end;ce++){const pe=ce+1,Te=pe<this.d.length?this.d[pe].row:null,Pe=Te?Te.domNode:null;this.W(ce,Pe)}for(let de=Z.start;de<Z.end;de++)this.d[de].row&&this.Y(this.d[de],de);if(typeof R=="number"){const de=this.p.getFutureScrollPosition().scrollTop-d,ce=this.elementTop(R)-V+de;this.setScrollTop(ce,b)}this.M.fire(this.contentHeight);return}}}tb(d){const v=this.d[d];if(this.P.getDynamicHeight){const V=this.P.getDynamicHeight(v.element);if(V!==null){const ee=v.size;return v.size=V,v.lastDynamicHeightWidth=this.n,V-ee}}if(!v.hasDynamicHeight||v.lastDynamicHeightWidth===this.n||!!this.P.hasDynamicHeight&&!this.P.hasDynamicHeight(v.element))return 0;const b=v.size;if(v.row)return v.row.domNode.style.height="",v.size=v.row.domNode.offsetHeight,v.lastDynamicHeightWidth=this.n,v.size-b;const{row:y}=this.h.alloc(v.templateId);y.domNode.style.height="",this.o.appendChild(y.domNode);const R=this.j.get(v.templateId);if(!R)throw new r.BugIndicatingError("Missing renderer for templateId: "+v.templateId);return R.renderElement(v.element,d,y.templateData,void 0),v.size=y.domNode.offsetHeight,R.disposeElement?.(v.element,d,y.templateData,void 0),this.P.setDynamicHeight?.(v.element,v.size),v.lastDynamicHeightWidth=this.n,this.o.removeChild(y.domNode),this.h.release(y),v.size-b}ub(d){const v=d[d.length-1];if(!v)return null;const b=this.d[v.end];return!b||!b.row?null:b.row.domNode}getElementDomId(d){return`${this.domId}_${d}`}dispose(){if(this.d){for(const d of this.d)if(d.row){const v=this.j.get(d.row.templateId);v&&(v.disposeElement?.(d.element,-1,d.row.templateData,void 0),v.disposeTemplate(d.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,M.dispose)(this.L)}}N.c=0,Ve([u.memoize],N.prototype,"onMouseClick",null),Ve([u.memoize],N.prototype,"onMouseDblClick",null),Ve([u.memoize],N.prototype,"onMouseMiddleClick",null),Ve([u.memoize],N.prototype,"onMouseUp",null),Ve([u.memoize],N.prototype,"onMouseDown",null),Ve([u.memoize],N.prototype,"onMouseOver",null),Ve([u.memoize],N.prototype,"onMouseMove",null),Ve([u.memoize],N.prototype,"onMouseOut",null),Ve([u.memoize],N.prototype,"onContextMenu",null),Ve([u.memoize],N.prototype,"onTouchStart",null),Ve([u.memoize],N.prototype,"onTap",null),t.ListView=N}),define(ge[59],me([1,0,4,20,14,23,54,69,13,9,41,25,3,32,2,46,30,5,6,68,58,89]),function(Q,t,E,P,U,i,D,w,f,u,c,M,o,n,e,s,r,a,h,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class A{constructor(g){this.d=g,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(g){return g}renderElement(g,l,k){const W=this.c.findIndex(j=>j.templateData===k);if(W>=0){const j=this.c[W];this.d.unrender(k),j.index=l}else{const j={index:l,templateData:k};this.c.push(j)}this.d.renderIndex(l,k)}splice(g,l,k){const W=[];for(const j of this.c)j.index<g?W.push(j):j.index>=g+l&&W.push({index:j.index+k-l,templateData:j.templateData});this.c=W}renderIndexes(g){for(const{index:l,templateData:k}of this.c)g.indexOf(l)>-1&&this.d.renderIndex(l,k)}disposeTemplate(g){const l=this.c.findIndex(k=>k.templateData===g);l<0||this.c.splice(l,1)}}class m{get name(){return this.h}get renderer(){return new A(this)}constructor(g){this.h=g,this.c=0,this.d=[],this.f=[],this.g=new o.Emitter,this.onChange=this.g.event}splice(g,l,k){l=Math.max(0,Math.min(l,this.c-g));const W=k.length-l,j=g+l,F=[...this.f.filter(O=>O<g),...k.map((O,S)=>O?S+g:-1).filter(O=>O!==-1),...this.f.filter(O=>O>=j).map(O=>O+W)],I=this.c+W;if(this.f.length>0&&F.length===0&&I>0){const O=this.f.find(S=>S>=g)??I-1;F.push(Math.min(O,I-1))}this.renderer.splice(g,l,k.length),this.k(F,F),this.c=I}renderIndex(g,l){l.classList.toggle(this.h,this.contains(g))}unrender(g){g.classList.remove(this.h)}set(g,l){return this.k(g,[...g].sort(G),l)}k(g,l,k){const W=this.d,j=this.f;this.d=g,this.f=l;const F=Oe(j,g);return this.renderer.renderIndexes(F),this.g.fire({indexes:g,browserEvent:k}),W}get(){return this.d}contains(g){return(0,f.binarySearch)(this.f,g,G)>=0}dispose(){(0,e.dispose)(this.g)}}Ve([M.memoize],m.prototype,"renderer",null);class C extends m{constructor(g){super("selected"),this.l=g}renderIndex(g,l){super.renderIndex(g,l),this.l&&(this.contains(g)?l.setAttribute("aria-selected","true"):l.setAttribute("aria-selected","false"))}}class N{constructor(g,l,k){this.c=g,this.d=l,this.f=k}splice(g,l,k){if(!this.f)return this.c.splice(g,l,k.map(()=>!1));const W=this.c.get().map(F=>this.f.getId(this.d.element(F)).toString()),j=k.map(F=>W.indexOf(this.f.getId(F).toString())>-1);this.c.splice(g,l,j)}}function L($){return $.tagName==="INPUT"||$.tagName==="TEXTAREA"}t.isInputElement=L;function d($){return $.classList.contains("monaco-editor")?!0:$.classList.contains("monaco-list")||!$.parentElement?!1:d($.parentElement)}t.isMonacoEditor=d;function v($){return $.tagName==="A"&&$.classList.contains("monaco-button")||$.tagName==="DIV"&&$.classList.contains("monaco-button-dropdown")?!0:$.classList.contains("monaco-list")||!$.parentElement?!1:v($.parentElement)}t.isButton=v;class b{get f(){return this.c.add(o.Event.chain(this.c.add(new P.DomEmitter(this.h.domNode,"keydown")).event).filter(g=>!L(g.target)).map(g=>new U.StandardKeyboardEvent(g)))}constructor(g,l,k){this.g=g,this.h=l,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter(W=>W.keyCode===3).on(this.k,this,this.c),this.f.filter(W=>W.keyCode===16).on(this.l,this,this.c),this.f.filter(W=>W.keyCode===18).on(this.o,this,this.c),this.f.filter(W=>W.keyCode===11).on(this.p,this,this.c),this.f.filter(W=>W.keyCode===12).on(this.q,this,this.c),this.f.filter(W=>W.keyCode===9).on(this.t,this,this.c),k.multipleSelectionSupport!==!1&&this.f.filter(W=>(a.isMacintosh?W.metaKey:W.ctrlKey)&&W.keyCode===31).on(this.s,this,this.d)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.d.clear(),g.multipleSelectionSupport&&this.f.filter(l=>(a.isMacintosh?l.metaKey:l.ctrlKey)&&l.keyCode===31).on(this.s,this,this.d))}k(g){g.preventDefault(),g.stopPropagation(),this.g.setSelection(this.g.getFocus(),g.browserEvent)}l(g){g.preventDefault(),g.stopPropagation(),this.g.focusPrevious(1,!1,g.browserEvent);const l=this.g.getFocus()[0];this.g.setAnchor(l),this.g.reveal(l),this.h.domNode.focus()}o(g){g.preventDefault(),g.stopPropagation(),this.g.focusNext(1,!1,g.browserEvent);const l=this.g.getFocus()[0];this.g.setAnchor(l),this.g.reveal(l),this.h.domNode.focus()}p(g){g.preventDefault(),g.stopPropagation(),this.g.focusPreviousPage(g.browserEvent);const l=this.g.getFocus()[0];this.g.setAnchor(l),this.g.reveal(l),this.h.domNode.focus()}q(g){g.preventDefault(),g.stopPropagation(),this.g.focusNextPage(g.browserEvent);const l=this.g.getFocus()[0];this.g.setAnchor(l),this.g.reveal(l),this.h.domNode.focus()}s(g){g.preventDefault(),g.stopPropagation(),this.g.setSelection((0,f.range)(this.g.length),g.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(g){this.g.getSelection().length&&(g.preventDefault(),g.stopPropagation(),this.g.setSelection([],g.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ve([M.memoize],b.prototype,"f",null);var y;(function($){$[$.Automatic=0]="Automatic",$[$.Trigger=1]="Trigger"})(y=t.TypeNavigationMode||(t.TypeNavigationMode={}));var R;(function($){$[$.Idle=0]="Idle",$[$.Typing=1]="Typing"})(R||(R={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter($){return $.ctrlKey||$.metaKey||$.altKey?!1:$.keyCode>=31&&$.keyCode<=56||$.keyCode>=21&&$.keyCode<=30||$.keyCode>=93&&$.keyCode<=102||$.keyCode>=80&&$.keyCode<=90}};class V{constructor(g,l,k,W,j){this.o=g,this.p=l,this.q=k,this.s=W,this.t=j,this.c=!1,this.d=R.Idle,this.f=y.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(g.options)}updateOptions(g){g.typeNavigationEnabled??!0?this.u():this.v(),this.f=g.typeNavigationMode??y.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let g=!1;const l=this.k.add(o.Event.chain(this.k.add(new P.DomEmitter(this.p.domNode,"keydown")).event)).filter(j=>!L(j.target)).filter(()=>this.f===y.Automatic||this.g).map(j=>new U.StandardKeyboardEvent(j)).filter(j=>g||this.s(j)).filter(j=>this.t.mightProducePrintableCharacter(j)).forEach(j=>E.EventHelper.stop(j,!0)).map(j=>j.browserEvent.key).event,k=o.Event.debounce(l,()=>null,800,void 0,void 0,this.k);o.Event.reduce(o.Event.any(l,k),(j,F)=>F===null?null:(j||"")+F,void 0,this.k)(this.z,this,this.k),k(this.w,this,this.k),l(()=>g=!0,void 0,this.k),k(()=>g=!1,void 0,this.k),this.c=!0,this.g=!1}v(){!this.c||(this.k.clear(),this.c=!1,this.g=!1)}w(){const g=this.o.getFocus();if(g.length>0&&g[0]===this.h){const l=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(g[0]));l&&(0,D.alert)(l)}this.h=-1}z(g){if(!g){this.d=R.Idle,this.g=!1;return}const l=this.o.getFocus(),k=l.length>0?l[0]:0,W=this.d===R.Idle?1:0;this.d=R.Typing;for(let j=0;j<this.o.length;j++){const F=(k+j+W)%this.o.length,I=this.q.getKeyboardNavigationLabel(this.p.element(F)),O=I&&I.toString();if(typeof O>"u"||(0,n.matchesPrefix)(g,O)){this.h=k,this.o.setFocus([F]),this.o.reveal(F);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ee{constructor(g,l){this.d=g,this.f=l,this.c=new e.DisposableStore,this.c.add(o.Event.chain(this.c.add(new P.DomEmitter(l.domNode,"keydown")).event)).filter(W=>!L(W.target)).map(W=>new U.StandardKeyboardEvent(W)).filter(W=>W.keyCode===2&&!W.ctrlKey&&!W.metaKey&&!W.shiftKey&&!W.altKey).on(this.g,this,this.c)}g(g){if(g.target!==this.f.domNode)return;const l=this.d.getFocus();if(l.length===0)return;const k=this.f.domElement(l[0]);if(!k)return;const W=k.querySelector("[tabIndex]");if(!W||!(W instanceof HTMLElement)||W.tabIndex===-1)return;const j=window.getComputedStyle(W);j.visibility==="hidden"||j.display==="none"||(g.preventDefault(),g.stopPropagation(),W.focus())}dispose(){this.c.dispose()}}function Z($){return a.isMacintosh?$.browserEvent.metaKey:$.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Z;function J($){return $.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=J;function re($){return $ instanceof MouseEvent&&$.button===2}const he={isSelectionSingleChangeEvent:Z,isSelectionRangeChangeEvent:J};class de{constructor(g){this.k=g,this.f=new e.DisposableStore,this.g=new o.Emitter,this.onPointer=this.g.event,g.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||he),this.d=typeof g.options.mouseSupport>"u"||!!g.options.mouseSupport,this.d&&(g.onMouseDown(this.s,this,this.f),g.onContextMenu(this.t,this,this.f),g.onMouseDblClick(this.v,this,this.f),g.onTouchStart(this.s,this,this.f),this.f.add(i.Gesture.addTarget(g.getHTMLElement()))),o.Event.any(g.onMouseClick,g.onMouseMiddleClick,g.onTap)(this.u,this,this.f)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.c=void 0,g.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||he))}o(g){return this.c?this.c.isSelectionSingleChangeEvent(g):!1}p(g){return this.c?this.c.isSelectionRangeChangeEvent(g):!1}q(g){return this.o(g)||this.p(g)}s(g){d(g.browserEvent.target)||document.activeElement!==g.browserEvent.target&&this.k.domFocus()}t(g){if(L(g.browserEvent.target)||d(g.browserEvent.target))return;const l=typeof g.index>"u"?[]:[g.index];this.k.setFocus(l,g.browserEvent)}u(g){if(!this.d||L(g.browserEvent.target)||d(g.browserEvent.target))return;const l=g.index;if(typeof l>"u"){this.k.setFocus([],g.browserEvent),this.k.setSelection([],g.browserEvent),this.k.setAnchor(void 0);return}if(this.p(g))return this.w(g);if(this.q(g))return this.w(g);this.k.setFocus([l],g.browserEvent),this.k.setAnchor(l),re(g.browserEvent)||this.k.setSelection([l],g.browserEvent),this.g.fire(g)}v(g){if(L(g.browserEvent.target)||d(g.browserEvent.target)||this.q(g))return;const l=this.k.getFocus();this.k.setSelection(l,g.browserEvent)}w(g){const l=g.index;let k=this.k.getAnchor();if(this.p(g)){typeof k>"u"&&(k=this.k.getFocus()[0]??l,this.k.setAnchor(k));const W=Math.min(k,l),j=Math.max(k,l),F=(0,f.range)(W,j+1),I=this.k.getSelection(),O=Pe(Oe(I,[k]),k);if(O.length===0)return;const S=Oe(F,x(I,O));this.k.setSelection(S,g.browserEvent),this.k.setFocus([l],g.browserEvent)}else if(this.o(g)){const W=this.k.getSelection(),j=W.filter(F=>F!==l);this.k.setFocus([l]),this.k.setAnchor(l),W.length===j.length?this.k.setSelection([...j,l],g.browserEvent):this.k.setSelection(j,g.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=de;class ce{constructor(g,l){this.c=g,this.d=l}style(g){const l=this.d&&`.${this.d}`,k=[];g.listBackground&&(g.listBackground.isOpaque()?k.push(`.monaco-list${l} .monaco-list-rows { background: ${g.listBackground}; }`):a.isMacintosh||console.warn(`List with id '${this.d}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),g.listFocusBackground&&(k.push(`.monaco-list${l}:focus .monaco-list-row.focused { background-color: ${g.listFocusBackground}; }`),k.push(`.monaco-list${l}:focus .monaco-list-row.focused:hover { background-color: ${g.listFocusBackground}; }`)),g.listFocusForeground&&k.push(`.monaco-list${l}:focus .monaco-list-row.focused { color: ${g.listFocusForeground}; }`),g.listActiveSelectionBackground&&(k.push(`.monaco-list${l}:focus .monaco-list-row.selected { background-color: ${g.listActiveSelectionBackground}; }`),k.push(`.monaco-list${l}:focus .monaco-list-row.selected:hover { background-color: ${g.listActiveSelectionBackground}; }`)),g.listActiveSelectionForeground&&k.push(`.monaco-list${l}:focus .monaco-list-row.selected { color: ${g.listActiveSelectionForeground}; }`),g.listActiveSelectionIconForeground&&k.push(`.monaco-list${l}:focus .monaco-list-row.selected .codicon { color: ${g.listActiveSelectionIconForeground}; }`),g.listFocusAndSelectionOutline&&k.push(`.monaco-list${l}:focus .monaco-list-row.selected { outline-color: ${g.listFocusAndSelectionOutline} !important; }`),g.listFocusAndSelectionBackground&&k.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.selected.focused { background-color: ${g.listFocusAndSelectionBackground}; }
			`),g.listFocusAndSelectionForeground&&k.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.selected.focused { color: ${g.listFocusAndSelectionForeground}; }
			`),g.listInactiveFocusForeground&&(k.push(`.monaco-list${l} .monaco-list-row.focused { color:  ${g.listInactiveFocusForeground}; }`),k.push(`.monaco-list${l} .monaco-list-row.focused:hover { color:  ${g.listInactiveFocusForeground}; }`)),g.listInactiveSelectionIconForeground&&k.push(`.monaco-list${l} .monaco-list-row.focused .codicon { color:  ${g.listInactiveSelectionIconForeground}; }`),g.listInactiveFocusBackground&&(k.push(`.monaco-list${l} .monaco-list-row.focused { background-color:  ${g.listInactiveFocusBackground}; }`),k.push(`.monaco-list${l} .monaco-list-row.focused:hover { background-color:  ${g.listInactiveFocusBackground}; }`)),g.listInactiveSelectionBackground&&(k.push(`.monaco-list${l} .monaco-list-row.selected { background-color:  ${g.listInactiveSelectionBackground}; }`),k.push(`.monaco-list${l} .monaco-list-row.selected:hover { background-color:  ${g.listInactiveSelectionBackground}; }`)),g.listInactiveSelectionForeground&&k.push(`.monaco-list${l} .monaco-list-row.selected { color: ${g.listInactiveSelectionForeground}; }`),g.listHoverBackground&&k.push(`.monaco-list${l}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${g.listHoverBackground}; }`),g.listHoverForeground&&k.push(`.monaco-list${l}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${g.listHoverForeground}; }`),g.listSelectionOutline&&k.push(`.monaco-list${l} .monaco-list-row.selected { outline: 1px dotted ${g.listSelectionOutline}; outline-offset: -1px; }`),g.listFocusOutline&&k.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${l}.last-focused .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
			`),g.listInactiveFocusOutline&&k.push(`.monaco-list${l} .monaco-list-row.focused { outline: 1px dotted ${g.listInactiveFocusOutline}; outline-offset: -1px; }`),g.listHoverOutline&&k.push(`.monaco-list${l} .monaco-list-row:hover { outline: 1px dashed ${g.listHoverOutline}; outline-offset: -1px; }`),g.listDropBackground&&k.push(`
				.monaco-list${l}.drop-target,
				.monaco-list${l} .monaco-list-rows.drop-target,
				.monaco-list${l} .monaco-list-row.drop-target { background-color: ${g.listDropBackground} !important; color: inherit !important; }
			`),g.tableColumnsBorder&&k.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${g.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),g.tableOddRowsBackgroundColor&&k.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${g.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=k.join(`
`)}}t.DefaultStyleController=ce;const pe={listFocusBackground:c.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:c.Color.fromHex("#0E639C"),listActiveSelectionForeground:c.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:c.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:c.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:c.Color.fromHex("#094771"),listFocusAndSelectionForeground:c.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:c.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:c.Color.fromHex("#FFFFFF"),listHoverBackground:c.Color.fromHex("#2A2D2E"),listDropBackground:c.Color.fromHex("#383B3D"),treeIndentGuidesStroke:c.Color.fromHex("#a9a9a9"),tableColumnsBorder:c.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:c.Color.fromHex("#cccccc").transparent(.04)},Te={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function Pe($,g){const l=$.indexOf(g);if(l===-1)return[];const k=[];let W=l-1;for(;W>=0&&$[W]===g-(l-W);)k.push($[W--]);for(k.reverse(),W=l;W<$.length&&$[W]===g+(W-l);)k.push($[W++]);return k}function Oe($,g){const l=[];let k=0,W=0;for(;k<$.length||W<g.length;)if(k>=$.length)l.push(g[W++]);else if(W>=g.length)l.push($[k++]);else if($[k]===g[W]){l.push($[k]),k++,W++;continue}else $[k]<g[W]?l.push($[k++]):l.push(g[W++]);return l}function x($,g){const l=[];let k=0,W=0;for(;k<$.length||W<g.length;)if(k>=$.length)l.push(g[W++]);else if(W>=g.length)l.push($[k++]);else if($[k]===g[W]){k++,W++;continue}else $[k]<g[W]?l.push($[k++]):W++;return l}const G=($,g)=>$-g;class ie{constructor(g,l){this.c=g,this.d=l}get templateId(){return this.c}renderTemplate(g){return this.d.map(l=>l.renderTemplate(g))}renderElement(g,l,k,W){let j=0;for(const F of this.d)F.renderElement(g,l,k[j++],W)}disposeElement(g,l,k,W){let j=0;for(const F of this.d)F.disposeElement?.(g,l,k[j],W),j+=1}disposeTemplate(g){let l=0;for(const k of this.d)k.disposeTemplate(g[l++])}}class se{constructor(g){this.c=g,this.templateId="a18n"}renderTemplate(g){return g}renderElement(g,l,k){const W=this.c.getAriaLabel(g);W?k.setAttribute("aria-label",W):k.removeAttribute("aria-label");const j=this.c.getAriaLevel&&this.c.getAriaLevel(g);typeof j=="number"?k.setAttribute("aria-level",`${j}`):k.removeAttribute("aria-level")}disposeTemplate(g){}}class ae{constructor(g,l){this.c=g,this.d=l}getDragElements(g){const l=this.c.getSelectedElements();return l.indexOf(g)>-1?l:[g]}getDragURI(g){return this.d.getDragURI(g)}getDragLabel(g,l){if(this.d.getDragLabel)return this.d.getDragLabel(g,l)}onDragStart(g,l){this.d.onDragStart?.(g,l)}onDragOver(g,l,k,W){return this.d.onDragOver(g,l,k,W)}onDragLeave(g,l,k,W){this.d.onDragLeave?.(g,l,k,W)}onDragEnd(g){this.d.onDragEnd?.(g)}drop(g,l,k,W){this.d.drop(g,l,k,W)}}class te{get onDidChangeFocus(){return o.Event.map(this.g.wrapEvent(this.c.onChange),g=>this.H(g),this.A)}get onDidChangeSelection(){return o.Event.map(this.g.wrapEvent(this.d.onChange),g=>this.H(g),this.A)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let g=!1;const l=this.A.add(o.Event.chain(this.A.add(new P.DomEmitter(this.k.domNode,"keydown")).event)).map(j=>new U.StandardKeyboardEvent(j)).filter(j=>g=j.keyCode===58||j.shiftKey&&j.keyCode===68).map(j=>E.EventHelper.stop(j,!0)).filter(()=>!1).event,k=this.A.add(o.Event.chain(this.A.add(new P.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>g=!1).map(j=>new U.StandardKeyboardEvent(j)).filter(j=>j.keyCode===58||j.shiftKey&&j.keyCode===68).map(j=>E.EventHelper.stop(j,!0)).map(({browserEvent:j})=>{const F=this.getFocus(),I=F.length?F[0]:void 0,O=typeof I<"u"?this.k.element(I):void 0,S=typeof I<"u"?this.k.domElement(I):this.k.domNode;return{index:I,element:O,anchor:S,browserEvent:j}}).event,W=this.A.add(o.Event.chain(this.k.onContextMenu)).filter(j=>!g).map(({element:j,index:F,browserEvent:I})=>({element:j,index:F,anchor:{x:I.pageX+1,y:I.pageY},browserEvent:I})).event;return o.Event.any(l,k,W)}get onKeyDown(){return this.A.add(new P.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.A.add(new P.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.A.add(new P.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.A.add(new P.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.A.add(new P.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(g,l,k,W,j=Te){this.C=g,this.D=j,this.c=new m("focused"),this.f=new m("anchor"),this.g=new o.EventBufferer,this.z="",this.A=new e.DisposableStore,this.B=new o.Emitter,this.onDidDispose=this.B.event;const F=this.D.accessibilityProvider&&this.D.accessibilityProvider.getWidgetRole?this.D.accessibilityProvider?.getWidgetRole():"list";this.d=new C(F!=="listbox"),(0,r.mixin)(j,pe,!1);const I=[this.c.renderer,this.d.renderer];this.u=j.accessibilityProvider,this.u&&(I.push(new se(this.u)),this.u.onDidChangeActiveDescendant?.(this.J,this,this.A)),W=W.map(S=>new ie(S.templateId,[...I,S]));const O={...j,dnd:j.dnd&&new ae(this,j.dnd)};if(this.k=new T.ListView(l,k,W,O),this.k.domNode.setAttribute("role",F),j.styleController)this.q=j.styleController(this.k.domId);else{const S=(0,E.createStyleSheet)(this.k.domNode);this.q=new ce(S,this.k.domId)}if(this.o=new w.CombinedSpliceable([new N(this.c,this.k,j.identityProvider),new N(this.d,this.k,j.identityProvider),new N(this.f,this.k,j.identityProvider),this.k]),this.A.add(this.c),this.A.add(this.d),this.A.add(this.f),this.A.add(this.k),this.A.add(this.B),this.A.add(new ee(this,this.k)),(typeof j.keyboardSupport!="boolean"||j.keyboardSupport)&&(this.v=new b(this,this.k,j),this.A.add(this.v)),j.keyboardNavigationLabelProvider){const S=j.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new V(this,this.k,j.keyboardNavigationLabelProvider,j.keyboardNavigationEventFilter??(()=>!0),S),this.A.add(this.t)}this.w=this.E(j),this.A.add(this.w),this.onDidChangeFocus(this.I,this,this.A),this.onDidChangeSelection(this.K,this,this.A),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.D.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}E(g){return new de(this)}updateOptions(g={}){this.D={...this.D,...g},this.t?.updateOptions(this.D),this.D.multipleSelectionController!==void 0&&(this.D.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(g),this.v?.updateOptions(g),this.k.updateOptions(g)}get options(){return this.D}splice(g,l,k=[]){if(g<0||g>this.k.length)throw new p.ListError(this.C,`Invalid start index: ${g}`);if(l<0)throw new p.ListError(this.C,`Invalid delete count: ${l}`);l===0&&k.length===0||this.g.bufferEvents(()=>this.o.splice(g,l,k))}updateWidth(g){this.k.updateWidth(g)}updateElementHeight(g,l){this.k.updateElementHeight(g,l,null)}rerender(){this.k.rerender()}element(g){return this.k.element(g)}indexOf(g){return this.k.indexOf(g)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get scrollTop(){return this.k.getScrollTop()}set scrollTop(g){this.k.setScrollTop(g)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(g){this.k.setScrollLeft(g)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.z}set ariaLabel(g){this.z=g,this.k.domNode.setAttribute("aria-label",g)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(g,l){this.k.layout(g,l)}triggerTypeNavigation(){this.t?.trigger()}setSelection(g,l){for(const k of g)if(k<0||k>=this.length)throw new p.ListError(this.C,`Invalid index ${k}`);this.d.set(g,l)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(g=>this.k.element(g))}setAnchor(g){if(typeof g>"u"){this.f.set([]);return}if(g<0||g>=this.length)throw new p.ListError(this.C,`Invalid index ${g}`);this.f.set([g])}getAnchor(){return(0,f.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const g=this.getAnchor();return typeof g>"u"?void 0:this.element(g)}setFocus(g,l){for(const k of g)if(k<0||k>=this.length)throw new p.ListError(this.C,`Invalid index ${k}`);this.c.set(g,l)}focusNext(g=1,l=!1,k,W){if(this.length===0)return;const j=this.c.get(),F=this.F(j.length>0?j[0]+g:0,l,W);F>-1&&this.setFocus([F],k)}focusPrevious(g=1,l=!1,k,W){if(this.length===0)return;const j=this.c.get(),F=this.G(j.length>0?j[0]-g:0,l,W);F>-1&&this.setFocus([F],k)}async focusNextPage(g,l){let k=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);k=k===0?0:k-1;const W=this.getFocus()[0];if(W!==k&&(W===void 0||k>W)){const j=this.G(k,!1,l);j>-1&&W!==j?this.setFocus([j],g):this.setFocus([k],g)}else{const j=this.k.getScrollTop();let F=j+this.k.renderHeight;k>W&&(F-=this.k.elementHeight(k)),this.k.setScrollTop(F),this.k.getScrollTop()!==j&&(this.setFocus([]),await(0,u.timeout)(0),await this.focusNextPage(g,l))}}async focusPreviousPage(g,l){let k;const W=this.k.getScrollTop();W===0?k=this.k.indexAt(W):k=this.k.indexAfter(W-1);const j=this.getFocus()[0];if(j!==k&&(j===void 0||j>=k)){const F=this.F(k,!1,l);F>-1&&j!==F?this.setFocus([F],g):this.setFocus([k],g)}else{const F=W;this.k.setScrollTop(W-this.k.renderHeight),this.k.getScrollTop()!==F&&(this.setFocus([]),await(0,u.timeout)(0),await this.focusPreviousPage(g,l))}}focusLast(g,l){if(this.length===0)return;const k=this.G(this.length-1,!1,l);k>-1&&this.setFocus([k],g)}focusFirst(g,l){this.focusNth(0,g,l)}focusNth(g,l,k){if(this.length===0)return;const W=this.F(g,!1,k);W>-1&&this.setFocus([W],l)}F(g,l=!1,k){for(let W=0;W<this.length;W++){if(g>=this.length&&!l)return-1;if(g=g%this.length,!k||k(this.element(g)))return g;g++}return-1}G(g,l=!1,k){for(let W=0;W<this.length;W++){if(g<0&&!l)return-1;if(g=(this.length+g%this.length)%this.length,!k||k(this.element(g)))return g;g--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(g=>this.k.element(g))}reveal(g,l){if(g<0||g>=this.length)throw new p.ListError(this.C,`Invalid index ${g}`);const k=this.k.getScrollTop(),W=this.k.elementTop(g),j=this.k.elementHeight(g);if((0,h.isNumber)(l)){const F=j-this.k.renderHeight;this.k.setScrollTop(F*(0,s.clamp)(l,0,1)+W)}else{const F=W+j,I=k+this.k.renderHeight;W<k&&F>=I||(W<k||F>=I&&j>=this.k.renderHeight?this.k.setScrollTop(W):F>=I&&this.k.setScrollTop(F-this.k.renderHeight))}}getRelativeTop(g){if(g<0||g>=this.length)throw new p.ListError(this.C,`Invalid index ${g}`);const l=this.k.getScrollTop(),k=this.k.elementTop(g),W=this.k.elementHeight(g);if(k<l||k+W>l+this.k.renderHeight)return null;const j=W-this.k.renderHeight;return Math.abs((l-k)/j)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(g){return this.k.getElementDomId(g)}style(g){this.q.style(g)}H({indexes:g,browserEvent:l}){return{indexes:g,elements:g.map(k=>this.k.element(k)),browserEvent:l}}I(){const g=this.c.get();this.k.domNode.classList.toggle("element-focused",g.length>0),this.J()}J(){const g=this.c.get();if(g.length>0){let l;this.u?.getActiveDescendantId&&(l=this.u.getActiveDescendantId(this.k.element(g[0]))),this.k.domNode.setAttribute("aria-activedescendant",l||this.k.getElementDomId(g[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}K(){const g=this.d.get();this.k.domNode.classList.toggle("selection-none",g.length===0),this.k.domNode.classList.toggle("selection-single",g.length===1),this.k.domNode.classList.toggle("selection-multiple",g.length>1)}dispose(){this.B.fire(),this.A.dispose(),this.B.dispose()}}Ve([M.memoize],te.prototype,"onDidChangeFocus",null),Ve([M.memoize],te.prototype,"onDidChangeSelection",null),Ve([M.memoize],te.prototype,"onContextMenu",null),Ve([M.memoize],te.prototype,"onKeyDown",null),Ve([M.memoize],te.prototype,"onKeyUp",null),Ve([M.memoize],te.prototype,"onKeyPress",null),Ve([M.memoize],te.prototype,"onDidFocus",null),Ve([M.memoize],te.prototype,"onDidBlur",null),t.List=te}),define(ge[60],me([1,0,7,33,35,11,15]),function(Q,t,E,P,U,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(w=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class f{constructor(a="",h=!1){if(this.value=a,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(a,h=0){return this.value+=o(this.supportThemeIcons?(0,P.escapeIcons)(a):a).replace(/([ \t]+)/g,(p,T)=>"&nbsp;".repeat(T.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,h){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(a,h,p){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(a),")"),p&&(this.value+=` "${this.c(this.c(p,'"'),")")}"`),this.value+=")",this}c(a,h){const p=new RegExp((0,i.escapeRegExpCharacters)(h),"g");return a.replace(p,(T,A)=>a.charAt(A-1)!=="\\"?`\\${T}`:T)}}t.MarkdownString=f;function u(r){return c(r)?!r.value:Array.isArray(r)?r.every(u):!0}t.isEmptyMarkdownString=u;function c(r){return r instanceof f?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}t.isMarkdownString=c;function M(r,a){return r===a?!0:!r||!a?!1:r.value===a.value&&r.isTrusted===a.isTrusted&&r.supportThemeIcons===a.supportThemeIcons&&r.supportHtml===a.supportHtml&&(r.baseUri===a.baseUri||!!r.baseUri&&!!a.baseUri&&(0,U.isEqual)(D.URI.from(r.baseUri),D.URI.from(a.baseUri)))}t.markdownStringEqual=M;function o(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=o;function n(r){return r.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=n;function e(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function s(r){const a=[],h=r.split("|").map(T=>T.trim());r=h[0];const p=h[1];if(p){const T=/height=(\d+)/.exec(p),A=/width=(\d+)/.exec(p),m=T?T[1]:"",C=A?A[1]:"",N=isFinite(parseInt(C)),L=isFinite(parseInt(m));N&&a.push(`width="${C}"`),L&&a.push(`height="${m}"`)}return{href:r,dimensions:a}}t.parseHrefAndDimensions=s}),define(ge[122],me([1,0,4,114,20,52,14,21,115,7,3,60,33,73,44,2,76,50,34,30,35,11,15]),function(Q,t,E,P,U,i,D,w,f,u,c,M,o,n,e,s,r,a,h,p,T,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const C=Object.freeze({image:(Z,J,re)=>{let he=[],de=[];return Z&&({href:Z,dimensions:he}=(0,M.parseHrefAndDimensions)(Z),de.push(`src="${(0,M.escapeDoubleQuotes)(Z)}"`)),re&&de.push(`alt="${(0,M.escapeDoubleQuotes)(re)}"`),J&&de.push(`title="${(0,M.escapeDoubleQuotes)(J)}"`),he.length&&(de=de.concat(he)),"<img "+de.join(" ")+">"},paragraph:Z=>`<p>${Z}</p>`,link:(Z,J,re)=>typeof Z!="string"?"":(Z===re&&(re=(0,M.removeMarkdownEscapes)(re)),J=typeof J=="string"?(0,M.escapeDoubleQuotes)((0,M.removeMarkdownEscapes)(J)):"",Z=(0,M.removeMarkdownEscapes)(Z),Z=Z.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Z}" title="${J||Z}">${re}</a>`)});function N(Z,J={},re={}){const he=new s.DisposableStore;let de=!1;const ce=(0,i.createElement)(J),pe=function(ae){let te;try{te=(0,a.parse)(decodeURIComponent(ae))}catch{}return te?(te=(0,p.cloneAndChange)(te,$=>{if(Z.uris&&Z.uris[$])return m.URI.revive(Z.uris[$])}),encodeURIComponent(JSON.stringify(te))):ae},Te=function(ae,te){const $=Z.uris&&Z.uris[ae];let g=m.URI.revive($);return te?ae.startsWith(h.Schemas.data+":")?ae:(g||(g=m.URI.parse(ae)),h.FileAccess.uriToBrowserUri(g).toString(!0)):!g||m.URI.parse(ae).toString()===g.toString()?ae:(g.query&&(g=g.with({query:pe(g.query)})),g.toString())},Pe=new r.marked.Renderer;Pe.image=C.image,Pe.link=C.link,Pe.paragraph=C.paragraph;const Oe=[];if(J.codeBlockRenderer&&(Pe.code=(ae,te)=>{const $=n.defaultGenerator.nextId(),g=J.codeBlockRenderer(L(te),ae);return Oe.push(g.then(l=>[$,l])),`<div class="code" data-code="${$}">${(0,A.escape)(ae)}</div>`}),J.actionHandler){const ae=function(g){let l=g.target;if(!(l.tagName!=="A"&&(l=l.parentElement,!l||l.tagName!=="A")))try{let k=l.dataset.href;k&&(Z.baseUri&&(k=d(m.URI.from(Z.baseUri),k)),J.actionHandler.callback(k,g))}catch(k){(0,u.onUnexpectedError)(k)}finally{g.preventDefault()}},te=J.actionHandler.disposables.add(new U.DomEmitter(ce,"click")),$=J.actionHandler.disposables.add(new U.DomEmitter(ce,"auxclick"));J.actionHandler.disposables.add(c.Event.any(te.event,$.event)(g=>{const l=new w.StandardMouseEvent(g);!l.leftButton&&!l.middleButton||ae(l)})),J.actionHandler.disposables.add(E.addDisposableListener(ce,"keydown",g=>{const l=new D.StandardKeyboardEvent(g);!l.equals(10)&&!l.equals(3)||ae(l)}))}Z.supportHtml||(re.sanitizer=ae=>(Z.isTrusted?ae.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?ae:"",re.sanitize=!0,re.silent=!0),re.renderer=Pe;let x=Z.value??"";x.length>1e5&&(x=`${x.substr(0,1e5)}\u2026`),Z.supportThemeIcons&&(x=(0,o.markdownEscapeEscapedIcons)(x));let G=r.marked.parse(x,re);Z.supportThemeIcons&&(G=(0,f.renderLabelWithIcons)(G).map(te=>typeof te=="string"?te:te.outerHTML).join(""));const se=new DOMParser().parseFromString(v(Z,G),"text/html");if(se.body.querySelectorAll("img").forEach(ae=>{const te=ae.getAttribute("src");if(te){let $=te;try{Z.baseUri&&($=d(m.URI.from(Z.baseUri),$))}catch{}ae.src=Te($,!0)}}),se.body.querySelectorAll("a").forEach(ae=>{const te=ae.getAttribute("href");if(ae.removeAttribute("href"),!te||/^data:|javascript:/i.test(te)||/^command:/i.test(te)&&!Z.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(te))ae.replaceWith(...ae.childNodes);else{let $=Te(te,!1);Z.baseUri&&($=d(m.URI.from(Z.baseUri),te)),ae.dataset.href=$}}),ce.innerHTML=v(Z,se.body.innerHTML),Oe.length>0&&Promise.all(Oe).then(ae=>{if(de)return;const te=new Map(ae),$=ce.querySelectorAll("div[data-code]");for(const g of $){const l=te.get(g.dataset.code??"");l&&E.reset(g,l)}J.asyncRenderCallback?.()}),J.asyncRenderCallback)for(const ae of ce.getElementsByTagName("img")){const te=he.add(E.addDisposableListener(ae,"load",()=>{te.dispose(),J.asyncRenderCallback()}))}return{element:ce,dispose:()=>{de=!0,he.dispose()}}}t.renderMarkdown=N;function L(Z){if(!Z)return"";const J=Z.split(/[\s+|:|,|\{|\?]/,1);return J.length?J[0]:Z}function d(Z,J){return/^\w[\w\d+.-]*:/.test(J)?J:Z.path.endsWith("/")?(0,T.resolvePath)(Z,J).toString():(0,T.resolvePath)((0,T.dirname)(Z),J).toString()}function v(Z,J){const{config:re,allowedSchemes:he}=b(Z);P.addHook("uponSanitizeAttribute",(ce,pe)=>{if(pe.attrName==="style"||pe.attrName==="class"){if(ce.tagName==="SPAN"){if(pe.attrName==="style"){pe.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(pe.attrValue);return}else if(pe.attrName==="class"){pe.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(pe.attrValue);return}}pe.keepAttr=!1;return}});const de=E.hookDomPurifyHrefAndSrcSanitizer(he);try{return P.sanitize(J,{...re,RETURN_TRUSTED_TYPE:!0})}finally{P.removeHook("uponSanitizeAttribute"),de.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width"];function b(Z){const J=[h.Schemas.http,h.Schemas.https,h.Schemas.mailto,h.Schemas.data,h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemote,h.Schemas.vscodeRemoteResource];return Z.isTrusted&&J.push(h.Schemas.command),{config:{ALLOWED_TAGS:[...E.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:J}}function y(Z){return typeof Z=="string"?Z:R(Z)}t.renderStringAsPlaintext=y;function R(Z){let J=Z.value??"";J.length>1e5&&(J=`${J.substr(0,1e5)}\u2026`);const re=r.marked.parse(J,{renderer:ee.value}).replace(/&(#\d+|[a-zA-Z]+);/g,he=>V.get(he)??he);return v({isTrusted:!1},re).toString()}t.renderMarkdownAsPlaintext=R;const V=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),ee=new e.Lazy(()=>{const Z=new r.marked.Renderer;return Z.code=J=>J,Z.blockquote=J=>J,Z.html=J=>"",Z.heading=(J,re,he)=>J+`
`,Z.hr=()=>"",Z.list=(J,re)=>J,Z.listitem=J=>J+`
`,Z.paragraph=J=>J+`
`,Z.table=(J,re)=>J+re+`
`,Z.tablerow=J=>J,Z.tablecell=(J,re)=>J+" ",Z.strong=J=>J,Z.em=J=>J,Z.codespan=J=>J,Z.br=()=>`
`,Z.del=J=>J,Z.image=(J,re,he)=>"",Z.text=J=>J,Z.link=(J,re,he)=>he,Z})}),define(ge[123],me([1,0,4,9,27,60,33,2,6,99]),function(Q,t,E,P,U,i,D,w,f,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function c(n,e){(0,f.isString)(e)?n.title=(0,D.stripIcons)(e):e?.markdownNotSupportedFallback?n.title=e.markdownNotSupportedFallback:n.removeAttribute("title")}t.setupNativeHover=c;class M{constructor(e,s,r){this.c=e,this.d=s,this.f=r}async update(e,s,r){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let a;if(e===void 0||(0,f.isString)(e)||e instanceof HTMLElement)a=e;else if(!(0,f.isFunction)(e.markdown))a=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,u.localize)(0,null),s),this.b=new U.CancellationTokenSource;const h=this.b.token;if(a=await e.markdown(h),a===void 0&&(a=e.markdownNotSupportedFallback),this.isDisposed||h.isCancellationRequested)return}this.g(a,s,r)}g(e,s,r){const a=this.a;if(this.h(e)){const h={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!a,...r};this.a=this.c.showHover(h,s)}a?.dispose()}h(e){return e?(0,i.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function o(n,e,s,r){let a,h;const p=(N,L)=>{N&&(h?.dispose(),h=void 0),L&&(a?.dispose(),a=void 0),n.onDidHideHover?.()},T=(N,L,d)=>new P.TimeoutTimer(async()=>{(!h||h.isDisposed)&&(h=new M(n,d||e,N>0),await h.update(s,L,r))},N),A=()=>{if(a)return;const N=new w.DisposableStore,L=b=>p(!1,b.fromElement===e);N.add(E.addDisposableListener(e,E.EventType.MOUSE_LEAVE,L,!0));const d=()=>p(!0,!0);N.add(E.addDisposableListener(e,E.EventType.MOUSE_DOWN,d,!0));const v={targetElements:[e],dispose:()=>{}};if(n.placement===void 0||n.placement==="mouse"){const b=y=>{v.x=y.x+10,y.target instanceof HTMLElement&&y.target.classList.contains("action-label")&&p(!0,!0)};N.add(E.addDisposableListener(e,E.EventType.MOUSE_MOVE,b,!0))}N.add(T(n.delay,!1,v)),a=N},m=E.addDisposableListener(e,E.EventType.MOUSE_OVER,A,!0);return{show:N=>{p(!1,!0),T(0,N)},hide:()=>{p(!0,!0)},update:async(N,L)=>{s=N,await h?.update(s,void 0,L)},dispose:()=>{m.dispose(),p(!0,!0)}}}t.setupCustomHover=o}),define(ge[124],me([1,0,4,20,14,122,59,13,3,43,2,5,101,92]),function(Q,t,E,P,U,i,D,w,f,u,c,M,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const n=E.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(h){const p=Object.create(null);return p.root=h,p.text=E.append(h,n(".option-text")),p.detail=E.append(h,n(".option-detail")),p.decoratorRight=E.append(h,n(".option-decorator-right")),p}renderElement(h,p,T){const A=T,m=h.text,C=h.detail,N=h.decoratorRight,L=h.isDisabled;A.text.textContent=m,A.detail.textContent=C||"",A.decoratorRight.innerText=N||"",L?A.root.classList.add("option-disabled"):A.root.classList.remove("option-disabled")}disposeTemplate(h){}}class r extends c.Disposable{constructor(h,p,T,A,m){super(),this.k=[],this.y=0,this.C=!1,this.F=!1,this.G=!1,this.f=!1,this.g=m||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=r.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new f.Emitter,this.B(this.m),this.n=A,this.I(),this.H(T),this.l=p||0,h&&this.setOptions(h,p)}getHeight(){return 22}getTemplateId(){return e}H(h){this.r=h,this.s=E.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.D=E.append(this.s,n(".select-box-details-pane"));const p=E.append(this.s,n(".select-box-dropdown-container-width-control")),T=E.append(p,n(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",E.append(T,this.w),this.z=0,this.t=E.createStyleSheet(this.s),this.s.setAttribute("draggable","true"),this.B(E.addDisposableListener(this.s,E.EventType.DRAG_START,A=>{E.EventHelper.stop(A,!0)}))}I(){this.B(E.addStandardDisposableListener(this.h,"change",p=>{this.l=p.target.selectedIndex,this.m.fire({index:p.target.selectedIndex,selected:p.target.value}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(E.addDisposableListener(this.h,E.EventType.CLICK,p=>{E.EventHelper.stop(p),this.f?this.O(!0):this.N()})),this.B(E.addDisposableListener(this.h,E.EventType.MOUSE_DOWN,p=>{E.EventHelper.stop(p)}));let h;this.B(E.addDisposableListener(this.h,"touchstart",p=>{h=this.f})),this.B(E.addDisposableListener(this.h,"touchend",p=>{E.EventHelper.stop(p),h?this.O(!0):this.N()})),this.B(E.addDisposableListener(this.h,E.EventType.KEY_DOWN,p=>{const T=new U.StandardKeyboardEvent(p);let A=!1;M.isMacintosh?(T.keyCode===18||T.keyCode===16||T.keyCode===10||T.keyCode===3)&&(A=!0):(T.keyCode===18&&T.altKey||T.keyCode===16&&T.altKey||T.keyCode===10||T.keyCode===3)&&(A=!0),A&&(this.N(),E.EventHelper.stop(p,!0))}))}get onDidSelect(){return this.m.event}setOptions(h,p){w.equals(this.k,h)||(this.k=h,this.h.options.length=0,this.C=!1,this.k.forEach((T,A)=>{this.h.add(this.M(T.text,A,T.isDisabled)),typeof T.description=="string"&&(this.C=!0)})),p!==void 0&&(this.select(p),this.y=this.l)}J(){this.u?.splice(0,this.u.length,this.k)}select(h){h>=0&&h<this.k.length?this.l=h:h>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(h){this.g.ariaLabel=h,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(h){this.h.tabIndex=h?0:-1}render(h){this.j=h,h.classList.add("select-container"),h.appendChild(this.h),this.applyStyles()}style(h){const p=[];this.n=h,this.n.listFocusBackground&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&!this.n.selectBorder.equals(this.n.selectBackground)?(p.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),p.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),p.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(p.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),p.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),p.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),p.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=p.join(`
`),this.applyStyles()}applyStyles(){if(this.h){const h=this.n.selectBackground?this.n.selectBackground.toString():"",p=this.n.selectForeground?this.n.selectForeground.toString():"",T=this.n.selectBorder?this.n.selectBorder.toString():"";this.h.style.backgroundColor=h,this.h.style.color=p,this.h.style.borderColor=T}this.u&&this.L()}L(){if(this.u){const h=this.n.selectBackground?this.n.selectBackground.toString():"";this.u.style({});const p=this.n.selectListBackground?this.n.selectListBackground.toString():h;this.v.style.backgroundColor=p,this.D.style.backgroundColor=p;const T=this.n.focusBorder?this.n.focusBorder.toString():"";this.s.style.outlineColor=T,this.s.style.outlineOffset="-1px"}}M(h,p,T){const A=document.createElement("option");return A.value=h,A.text=h,A.disabled=!!T,A}N(){this.D.innerText="",!(!this.r||this.f)&&(this.U(this.s),this.J(),this.r.showContextView({getAnchor:()=>this.h,render:h=>this.P(h,!0),layout:()=>{this.R()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.O(!1),this.r.showContextView({getAnchor:()=>this.h,render:h=>this.P(h),layout:()=>this.R(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}O(h){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),h&&this.h.focus(),this.r.hideContextView())}P(h,p){return h.appendChild(this.s),this.R(p),{dispose:()=>{try{h.removeChild(this.s)}catch{}}}}Q(){let h=0;return this.k.forEach((p,T)=>{this.ab(T),this.D.offsetHeight>h&&(h=this.D.offsetHeight)}),h}R(h){if(this.F)return!1;if(this.u){this.s.classList.add("visible");const p=E.getDomNodePagePosition(this.h),T=getComputedStyle(this.h),A=parseFloat(T.getPropertyValue("--dropdown-padding-top"))+parseFloat(T.getPropertyValue("--dropdown-padding-bottom")),m=window.innerHeight-p.top-p.height-(this.g.minBottomMargin||0),C=p.top-r.b,N=this.h.offsetWidth,L=this.S(this.w),d=Math.max(L,Math.round(N)).toString()+"px";this.s.style.width=d,this.u.getHTMLElement().style.height="",this.u.layout();let v=this.u.contentHeight;const b=this.C?this.Q():0,y=v+A+b,R=Math.floor((m-A-b)/this.getHeight()),V=Math.floor((C-A-b)/this.getHeight());if(h)return p.top+p.height>window.innerHeight-22||p.top<r.b||R<1&&V<1?!1:(R<r.c&&V>R&&this.k.length>R?(this.z=1,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.D),this.s.appendChild(this.v),this.D.classList.remove("border-top"),this.D.classList.add("border-bottom")):(this.z=0,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.v),this.s.appendChild(this.D),this.D.classList.remove("border-bottom"),this.D.classList.add("border-top")),!0);if(p.top+p.height>window.innerHeight-22||p.top<r.b||this.z===0&&R<1||this.z===1&&V<1)return this.O(!0),!1;if(this.z===0){if(this.f&&R+V<1)return this.O(!0),!1;y>m&&(v=R*this.getHeight())}else y>C&&(v=V*this.getHeight());return this.u.layout(v),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.C?(this.u.getHTMLElement().style.height=v+A+"px",this.s.style.height=""):this.s.style.height=v+A+"px",this.ab(this.l),this.s.style.width=d,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}S(h){let p=0;if(h){let T=0,A=0;this.k.forEach((m,C)=>{const N=m.detail?m.detail.length:0,L=m.decoratorRight?m.decoratorRight.length:0,d=m.text.length+N+L;d>A&&(T=C,A=d)}),h.textContent=this.k[T].text+(this.k[T].decoratorRight?this.k[T].decoratorRight+" ":""),p=E.getTotalWidth(h)}return p}U(h){if(this.u)return;this.v=E.append(h,n(".select-box-dropdown-list-container")),this.p=new s,this.u=new D.List("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:A=>{let m=A.text;return A.detail&&(m+=`. ${A.detail}`),A.decoratorRight&&(m+=`. ${A.decoratorRight}`),A.description&&(m+=`. ${A.description}`),m},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const p=this.B(new P.DomEmitter(this.v,"keydown")),T=f.Event.chain(p.event).filter(()=>this.u.length>0).map(A=>new U.StandardKeyboardEvent(A));this.B(T.filter(A=>A.keyCode===3).on(A=>this.cb(A),this)),this.B(T.filter(A=>A.keyCode===2).on(A=>this.cb(A),this)),this.B(T.filter(A=>A.keyCode===9).on(A=>this.bb(A),this)),this.B(T.filter(A=>A.keyCode===16).on(A=>this.eb(A),this)),this.B(T.filter(A=>A.keyCode===18).on(A=>this.db(A),this)),this.B(T.filter(A=>A.keyCode===12).on(this.gb,this)),this.B(T.filter(A=>A.keyCode===11).on(this.fb,this)),this.B(T.filter(A=>A.keyCode===14).on(this.hb,this)),this.B(T.filter(A=>A.keyCode===13).on(this.ib,this)),this.B(T.filter(A=>A.keyCode>=21&&A.keyCode<=56||A.keyCode>=80&&A.keyCode<=108).on(this.jb,this)),this.B(E.addDisposableListener(this.u.getHTMLElement(),E.EventType.POINTER_UP,A=>this.W(A))),this.B(this.u.onMouseOver(A=>typeof A.index<"u"&&this.u.setFocus([A.index]))),this.B(this.u.onDidChangeFocus(A=>this.Z(A))),this.B(E.addDisposableListener(this.s,E.EventType.FOCUS_OUT,A=>{!this.f||E.isAncestor(A.relatedTarget,this.s)||this.X()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.L()}W(h){if(!this.u.length)return;E.EventHelper.stop(h);const p=h.target;if(!p||p.classList.contains("slider"))return;const T=p.closest(".monaco-list-row");if(!T)return;const A=Number(T.getAttribute("data-index")),m=T.classList.contains("option-disabled");A>=0&&A<this.k.length&&!m&&(this.l=A,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.O(!0))}X(){this.G||(this.l!==this.y&&this.select(this.y),this.O(!1))}Y(h,p){const T=m=>{for(let C=0;C<m.childNodes.length;C++){const N=m.childNodes.item(C);(N.tagName&&N.tagName.toLowerCase())==="img"?m.removeChild(N):T(N)}},A=(0,i.renderMarkdown)({value:h,supportThemeIcons:!0},{actionHandler:p});return A.element.classList.add("select-box-description-markdown"),T(A.element),A.element}Z(h){!this.f||!this.C||this.ab(h.indexes[0])}ab(h){this.D.innerText="";const p=this.k[h],T=p?.description??"",A=p?.descriptionIsMarkdown??!1;if(T){if(A){const m=p.descriptionMarkdownActionHandler;this.D.appendChild(this.Y(T,m))}else this.D.innerText=T;this.D.style.display="block"}else this.D.style.display="none";this.F=!0,this.r.layout(),this.F=!1}bb(h){E.EventHelper.stop(h),this.select(this.y),this.O(!0)}cb(h){E.EventHelper.stop(h),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.O(!0)}db(h){if(this.l<this.k.length-1){E.EventHelper.stop(h,!0);const p=this.k[this.l+1].isDisabled;if(p&&this.k.length>this.l+2)this.l+=2;else{if(p)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}eb(h){this.l>0&&(E.EventHelper.stop(h,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}fb(h){E.EventHelper.stop(h),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}gb(h){E.EventHelper.stop(h),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}hb(h){E.EventHelper.stop(h),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}ib(h){E.EventHelper.stop(h),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}jb(h){const p=u.KeyCodeUtils.toString(h.keyCode);let T=-1;for(let A=0;A<this.k.length-1;A++)if(T=(A+this.l+1)%this.k.length,this.k[T].text.charAt(0).toUpperCase()===p&&!this.k[T].isDisabled){this.select(T),this.u.setFocus([T]),this.u.reveal(this.u.getFocus()[0]),E.EventHelper.stop(h);break}}dispose(){this.O(!1),super.dispose()}}t.SelectBoxList=r,r.a=32,r.b=2,r.c=3}),define(ge[125],me([1,0,124,118,19,41,30,5,91]),function(Q,t,E,P,U,i,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:i.Color.fromHex("#3C3C3C"),selectForeground:i.Color.fromHex("#F0F0F0"),selectBorder:i.Color.fromHex("#3C3C3C")};class f extends U.Widget{constructor(c,M,o,n=(0,D.deepClone)(t.defaultStyles),e){super(),w.isMacintosh&&!e?.useCustomDrawn?this.a=new P.SelectBoxNative(c,M,n,e):this.a=new E.SelectBoxList(c,M,o,n,e),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(c,M){this.a.setOptions(c,M)}select(c){this.a.select(c)}setAriaLabel(c){this.a.setAriaLabel(c)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(c){this.a.setFocusable(c)}render(c){this.a.render(c)}style(c){this.a.style(c)}applyStyles(){this.a.applyStyles()}}t.SelectBox=f}),define(ge[61],me([1,0,18,51,4,23,123,125,31,2,5,6,96,48]),function(Q,t,E,P,U,i,D,w,f,u,c,M,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class n extends u.Disposable{get action(){return this._action}constructor(a,h,p={}){super(),this.k=p,this._context=a||this,this._action=h,h instanceof f.Action&&this.B(h.onDidChange(T=>{!this.element||this.m(T)}))}m(a){a.enabled!==void 0&&this.t(),a.checked!==void 0&&this.C(),a.class!==void 0&&this.updateClass(),a.label!==void 0&&(this.updateLabel(),this.w()),a.tooltip!==void 0&&this.w()}get actionRunner(){return this.j||(this.j=this.B(new f.ActionRunner)),this.j}set actionRunner(a){this.j=a}isEnabled(){return this._action.enabled}setActionContext(a){this._context=a}render(a){const h=this.element=a;this.B(i.Gesture.addTarget(a));const p=this.k&&this.k.draggable;p&&(a.draggable=!0,E.isFirefox&&this.B((0,U.addDisposableListener)(a,U.EventType.DRAG_START,T=>T.dataTransfer?.setData(P.DataTransfers.TEXT,this._action.label)))),this.B((0,U.addDisposableListener)(h,i.EventType.Tap,T=>this.onClick(T,!0))),this.B((0,U.addDisposableListener)(h,U.EventType.MOUSE_DOWN,T=>{p||U.EventHelper.stop(T,!0),this._action.enabled&&T.button===0&&h.classList.add("active")})),c.isMacintosh&&this.B((0,U.addDisposableListener)(h,U.EventType.CONTEXT_MENU,T=>{T.button===0&&T.ctrlKey===!0&&this.onClick(T)})),this.B((0,U.addDisposableListener)(h,U.EventType.CLICK,T=>{U.EventHelper.stop(T,!0),this.k&&this.k.isMenu||this.onClick(T)})),this.B((0,U.addDisposableListener)(h,U.EventType.DBLCLICK,T=>{U.EventHelper.stop(T,!0)})),[U.EventType.MOUSE_UP,U.EventType.MOUSE_OUT].forEach(T=>{this.B((0,U.addDisposableListener)(h,T,A=>{U.EventHelper.stop(A),h.classList.remove("active")}))})}onClick(a,h=!1){U.EventHelper.stop(a,!0);const p=M.isUndefinedOrNull(this._context)?this.k?.useEventAsContext?a:{preserveFocus:h}:this._context;this.actionRunner.run(this._action,p)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(a){this.element&&(this.element.tabIndex=a?0:-1)}get trapsArrowNavigation(){return!1}t(){}updateLabel(){}u(){return this.action.tooltip}w(){if(!this.element)return;const a=this.u()??"";this.z(),this.k.hoverDelegate?(this.element.title="",this.f?this.f.update(a):(this.f=(0,D.setupCustomHover)(this.k.hoverDelegate,this.element,a),this.q.add(this.f))):this.element.title=a}z(){if(this.element){const a=this.u()??"";this.element.setAttribute("aria-label",a)}}updateClass(){}C(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=n;class e extends n{constructor(a,h,p){super(a,h,p),this.k=p,this.k.icon=p.icon!==void 0?p.icon:!1,this.k.label=p.label!==void 0?p.label:!0,this.D=""}render(a){super.render(a),this.element&&(this.g=(0,U.append)(this.element,(0,U.$)("a.action-label"))),this.g&&(this._action.id===f.Separator.ID?this.g.setAttribute("role","presentation"):this.k.isMenu?this.g.setAttribute("role","menuitem"):this.g.setAttribute("role","button")),this.k.label&&this.k.keybinding&&this.element&&((0,U.append)(this.element,(0,U.$)("span.keybinding")).textContent=this.k.keybinding),this.updateClass(),this.updateLabel(),this.w(),this.t(),this.C()}focus(){this.g&&(this.g.tabIndex=0,this.g.focus())}isFocused(){return!!this.g&&this.g?.tabIndex===0}blur(){this.g&&(this.g.tabIndex=-1)}setFocusable(a){this.g&&(this.g.tabIndex=a?0:-1)}updateLabel(){this.k.label&&this.g&&(this.g.textContent=this.action.label)}u(){let a=null;return this.action.tooltip?a=this.action.tooltip:!this.k.label&&this.action.label&&this.k.icon&&(a=this.action.label,this.k.keybinding&&(a=o.localize(0,null,a,this.k.keybinding))),a??void 0}updateClass(){this.D&&this.g&&this.g.classList.remove(...this.D.split(" ")),this.k.icon?(this.D=this.action.class,this.g&&(this.g.classList.add("codicon"),this.D&&this.g.classList.add(...this.D.split(" "))),this.t()):this.g?.classList.remove("codicon")}t(){this.action.enabled?(this.g&&(this.g.removeAttribute("aria-disabled"),this.g.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.g&&(this.g.setAttribute("aria-disabled","true"),this.g.classList.add("disabled")),this.element?.classList.add("disabled"))}z(){if(this.g){const a=this.u()??"";this.g.setAttribute("aria-label",a)}}C(){this.g&&(this.action.checked?this.g.classList.add("checked"):this.g.classList.remove("checked"))}}t.ActionViewItem=e;class s extends n{constructor(a,h,p,T,A,m){super(a,h),this.b=new w.SelectBox(p,T,A,void 0,m),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(a,h){this.b.setOptions(a,h)}select(a){this.b.select(a)}g(){this.B(this.b.onDidSelect(a=>this.n(a.selected,a.index)))}n(a,h){this.actionRunner.run(this._action,this.r(a,h))}r(a,h){return a}setFocusable(a){this.b.setFocusable(a)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(a){this.b.render(a)}}t.SelectActionViewItem=s}),define(ge[62],me([1,0,4,14,61,31,3,2,6,48]),function(Q,t,E,P,U,i,D,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var u;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(u=t.ActionsOrientation||(t.ActionsOrientation={}));class c extends w.Disposable{constructor(n,e={}){super(),this.g=this.B(new w.DisposableStore),this.n=this.B(new w.DisposableMap),this.t=!1,this.u=!0,this.w=this.B(new D.Emitter),this.onDidBlur=this.w.event,this.y=this.B(new D.Emitter({onWillAddFirstListener:()=>this.z=!0})),this.onDidCancel=this.y.event,this.z=!1,this.C=this.B(new D.Emitter),this.onDidRun=this.C.event,this.D=this.B(new D.Emitter),this.onWillRun=this.D.event,this.b=e,this.j=e.context??null,this.l=this.b.orientation??0,this.m={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new i.ActionRunner,this.g.add(this.f)),this.g.add(this.f.onDidRun(a=>this.C.fire(a))),this.g.add(this.f.onWillRun(a=>this.D.fire(a))),this.viewItems=[],this.r=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,r;switch(this.l){case 0:s=[15],r=[17];break;case 1:s=[16],r=[18],this.domNode.className+=" vertical";break}this.B(E.addDisposableListener(this.domNode,E.EventType.KEY_DOWN,a=>{const h=new P.StandardKeyboardEvent(a);let p=!0;const T=typeof this.r=="number"?this.viewItems[this.r]:void 0;s&&(h.equals(s[0])||h.equals(s[1]))?p=this.M():r&&(h.equals(r[0])||h.equals(r[1]))?p=this.L():h.equals(9)&&this.z?this.y.fire():h.equals(14)?p=this.I():h.equals(13)?p=this.J():h.equals(2)&&T instanceof U.BaseActionViewItem&&T.trapsArrowNavigation?p=this.L():this.G(h)?this.m.keyDown?this.O(h):this.t=!0:p=!1,p&&(h.preventDefault(),h.stopPropagation())})),this.B(E.addDisposableListener(this.domNode,E.EventType.KEY_UP,a=>{const h=new P.StandardKeyboardEvent(a);this.G(h)?(!this.m.keyDown&&this.t&&(this.t=!1,this.O(h)),h.preventDefault(),h.stopPropagation()):(h.equals(2)||h.equals(1026))&&this.H()})),this.s=this.B(E.trackFocus(this.domNode)),this.B(this.s.onDidBlur(()=>{(E.getActiveElement()===this.domNode||!E.isAncestor(E.getActiveElement(),this.domNode))&&(this.w.fire(),this.r=void 0,this.p=void 0,this.t=!1)})),this.B(this.s.onDidFocus(()=>this.H())),this.v=document.createElement("ul"),this.v.className="actions-container",this.v.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.v.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.v),n.appendChild(this.domNode)}F(){this.length()>=2?this.v.setAttribute("role",this.b.ariaRole||"toolbar"):this.v.setAttribute("role","presentation")}setAriaLabel(n){n?this.v.setAttribute("aria-label",n):this.v.removeAttribute("aria-label")}setFocusable(n){if(this.u=n,this.u){const e=this.viewItems.find(s=>s instanceof U.BaseActionViewItem&&s.isEnabled());e instanceof U.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof U.BaseActionViewItem&&e.setFocusable(!1)})}G(n){let e=!1;return this.m.keys.forEach(s=>{e=e||n.equals(s)}),e}H(){for(let n=0;n<this.v.children.length;n++){const e=this.v.children[n];if(E.isAncestor(E.getActiveElement(),e)){this.r=n;break}}}get context(){return this.j}set context(n){this.j=n,this.viewItems.forEach(e=>e.setActionContext(n))}get actionRunner(){return this.f}set actionRunner(n){this.f=n,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.C.fire(e))),this.g.add(this.f.onWillRun(e=>this.D.fire(e))),this.viewItems.forEach(e=>e.actionRunner=n)}getContainer(){return this.domNode}hasAction(n){return this.viewItems.findIndex(e=>e.action.id===n.id)!==-1}getAction(n){if(typeof n=="number")return this.viewItems[n]?.action;if(n instanceof HTMLElement){for(;n.parentElement!==this.v;){if(!n.parentElement)return;n=n.parentElement}for(let e=0;e<this.v.childNodes.length;e++)if(this.v.childNodes[e]===n)return this.viewItems[e].action}}push(n,e={}){const s=Array.isArray(n)?n:[n];let r=f.isNumber(e.index)?e.index:null;s.forEach(a=>{const h=document.createElement("li");h.className="action-item",h.setAttribute("role","presentation");let p;this.b.actionViewItemProvider&&(p=this.b.actionViewItemProvider(a)),p||(p=new U.ActionViewItem(this.context,a,{hoverDelegate:this.b.hoverDelegate,...e})),this.b.allowContextMenu||this.n.set(p,E.addDisposableListener(h,E.EventType.CONTEXT_MENU,T=>{E.EventHelper.stop(T,!0)})),p.actionRunner=this.f,p.setActionContext(this.context),p.render(h),this.u&&p instanceof U.BaseActionViewItem&&this.viewItems.length===0&&p.setFocusable(!0),r===null||r<0||r>=this.v.children.length?(this.v.appendChild(h),this.viewItems.push(p)):(this.v.insertBefore(h,this.v.children[r]),this.viewItems.splice(r,0,p),r++)}),typeof this.r=="number"&&this.focus(this.r),this.F()}getWidth(n){if(n>=0&&n<this.v.children.length){const e=this.v.children.item(n);if(e)return e.clientWidth}return 0}getHeight(n){if(n>=0&&n<this.v.children.length){const e=this.v.children.item(n);if(e)return e.clientHeight}return 0}pull(n){n>=0&&n<this.viewItems.length&&(this.v.removeChild(this.v.childNodes[n]),this.n.deleteAndDispose(this.viewItems[n]),(0,w.dispose)(this.viewItems.splice(n,1)),this.F())}clear(){this.isEmpty()||(this.viewItems=(0,w.dispose)(this.viewItems),this.n.clearAndDisposeAll(),E.clearNode(this.v),this.F())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(n){let e=!1,s;if(n===void 0?e=!0:typeof n=="number"?s=n:typeof n=="boolean"&&(e=n),e&&typeof this.r>"u"){const r=this.viewItems.findIndex(a=>a.isEnabled());this.r=r===-1?void 0:r,this.N(void 0,void 0,!0)}else s!==void 0&&(this.r=s),this.N(void 0,void 0,!0)}I(){return this.r=this.length()-1,this.L(!0)}J(){return this.r=0,this.M(!0)}L(n){if(typeof this.r>"u")this.r=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.r;let s;do{if(!n&&this.b.preventLoopNavigation&&this.r+1>=this.viewItems.length)return this.r=e,!1;this.r=(this.r+1)%this.viewItems.length,s=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===i.Separator.ID));return this.N(),!0}M(n){if(typeof this.r>"u")this.r=0;else if(this.viewItems.length<=1)return!1;const e=this.r;let s;do{if(this.r=this.r-1,this.r<0){if(!n&&this.b.preventLoopNavigation)return this.r=e,!1;this.r=this.viewItems.length-1}s=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===i.Separator.ID));return this.N(!0),!0}N(n,e,s=!1){typeof this.r>"u"&&this.v.focus({preventScroll:e}),this.p!==void 0&&this.p!==this.r&&this.viewItems[this.p]?.blur();const r=this.r!==void 0&&this.viewItems[this.r];if(r){let a=!0;f.isFunction(r.focus)||(a=!1),this.b.focusOnlyEnabledItems&&f.isFunction(r.isEnabled)&&!r.isEnabled()&&(a=!1),r.action.id===i.Separator.ID&&(a=!1),a?(s||this.p!==this.r)&&(r.focus(n),this.p=this.r):(this.v.focus({preventScroll:e}),this.p=void 0)}}O(n){if(typeof this.r>"u")return;const e=this.viewItems[this.r];if(e instanceof U.BaseActionViewItem){const s=e._context===null||e._context===void 0?n:e._context;this.run(e._action,s)}}async run(n,e){await this.f.run(n,e)}dispose(){this.j=void 0,this.viewItems=(0,w.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=c;function M(o){if(!o.length)return o;let n=-1;for(let s=0;s<o.length;s++)if(o[s].id!==i.Separator.ID){n=s;break}if(n===-1)return[];o=o.slice(n);for(let s=o.length-1;s>=0&&o[s].id===i.Separator.ID;s--)o.splice(s,1);let e=!1;for(let s=o.length-1;s>=0;s--){const r=o[s].id===i.Separator.ID;r&&!e?o.splice(s,1):r?r&&(e=!1):e=!0}return o}t.prepareActions=M}),define(ge[63],me([1,0,4,20,52,62,54,57,19,3,78,100,88]),function(Q,t,E,P,U,i,D,w,f,u,c,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const o=E.$;var n;(function(r){r[r.INFO=1]="INFO",r[r.WARNING=2]="WARNING",r[r.ERROR=3]="ERROR"})(n=t.MessageType||(t.MessageType={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class e extends f.Widget{constructor(a,h,p){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.B(new u.Emitter),this.onDidChange=this.I.event,this.J=this.B(new u.Emitter),this.onDidHeightChange=this.J.event,this.a=h,this.g=p,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=E.append(a,o(".monaco-inputbox.idle"));const T=this.g.flexibleHeight?"textarea":"input",A=E.append(this.element,o(".ibwrapper"));if(this.b=E.append(A,o(T+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.D(this.b,()=>this.element.classList.add("synthetic-focus")),this.C(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=E.append(A,o("div.mirror")),this.t.innerText="\xA0",this.H=new w.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),E.append(a,this.H.getDomNode()),this.B(this.H),this.B(this.H.onScroll(N=>this.b.scrollTop=N.scrollTop));const m=this.B(new P.DomEmitter(document,"selectionchange")),C=u.Event.filter(m.event,()=>document.getSelection()?.anchorNode===A);this.B(C(this.N,this)),this.B(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.z(this.b,()=>this.R()),this.C(this.b,()=>this.L()),this.D(this.b,()=>this.M()),this.B(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.B(new i.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(a){this.i=a,this.b.setAttribute("placeholder",a)}setTooltip(a){this.l=a,this.b.title=a}setAriaLabel(a){this.n=a,a?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(a){this.b.value!==a&&(this.b.value=a,this.R())}get step(){return this.b.step}set step(a){this.b.step=a}get height(){return typeof this.v=="number"?this.v:E.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(a=null){this.b.select(),a&&(this.b.setSelectionRange(a.start,a.end),a.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(a){a?this.enable():this.disable()}get width(){return E.getTotalWidth(this.b)}set width(a){if(this.g.flexibleHeight&&this.g.flexibleWidth){let h=0;if(this.t){const p=parseFloat(this.t.style.paddingLeft||"")||0,T=parseFloat(this.t.style.paddingRight||"")||0;h=p+T}this.b.style.width=a-h+"px"}else this.b.style.width=a+"px";this.t&&(this.t.style.width=a+"px")}set paddingRight(a){this.b.style.width=`calc(100% - ${a}px)`,this.t&&(this.t.style.paddingRight=a+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const a=this.w,h=this.v,p=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:a,height:h}),this.H.setScrollPosition({scrollTop:p})}showMessage(a,h){this.h=a,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(a.type));const p=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${E.asCssValueWithDefault(p.border,"transparent")}`,this.h.content&&(this.hasFocus()||h)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let a=null;return this.r&&(a=this.r(this.value),a?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(a)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),a?.type}stylesForType(a){const h=this.g.inputBoxStyles;switch(a){case 1:return{border:h.inputValidationInfoBorder,background:h.inputValidationInfoBackground,foreground:h.inputValidationInfoForeground};case 2:return{border:h.inputValidationWarningBorder,background:h.inputValidationWarningBackground,foreground:h.inputValidationWarningForeground};default:return{border:h.inputValidationErrorBorder,background:h.inputValidationErrorBackground,foreground:h.inputValidationErrorForeground}}}O(a){switch(a){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let a;const h=()=>a.style.width=E.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:T=>{if(!this.h)return null;a=E.append(T,o(".monaco-inputbox-container")),h();const A={inline:!0,className:"monaco-inputbox-message"},m=this.h.formatContent?(0,U.renderFormattedText)(this.h.content,A):(0,U.renderText)(this.h.content,A);m.classList.add(this.O(this.h.type));const C=this.stylesForType(this.h.type);return m.style.backgroundColor=C.background?C.background.toString():"",m.style.color=C.foreground?C.foreground.toString():"",m.style.border=C.border?`1px solid ${C.border}`:"",E.append(a,m),null},onHide:()=>{this.s="closed"},layout:h});let p;this.h.type===3?p=M.localize(0,null,this.h.content):this.h.type===2?p=M.localize(1,null,this.h.content):p=M.localize(2,null,this.h.content),D.alert(p),this.s="open"}Q(){!this.a||(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const a=this.value,p=a.charCodeAt(a.length-1)===10?" ":"";(a+p).replace(/\u000c/g,"")?this.t.textContent=a+p:this.t.innerText="\xA0",this.layout()}U(){const a=this.g.inputBoxStyles,h=a.inputBackground??"",p=a.inputForeground??"",T=a.inputBorder??"";this.element.style.backgroundColor=h,this.element.style.color=p,this.b.style.backgroundColor="inherit",this.b.style.color=p,this.element.style.border=`1px solid ${E.asCssValueWithDefault(T,"transparent")}`}layout(){if(!this.t)return;const a=this.w;this.w=E.getTotalHeight(this.t),a!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(a){const h=this.inputElement,p=h.selectionStart,T=h.selectionEnd,A=h.value;p!==null&&T!==null&&(this.value=A.substr(0,p)+a+A.substr(T),h.setSelectionRange(p+1,p+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=e;class s extends e{constructor(a,h,p){const T=M.localize(3,null),A=` or \u21C5 ${T}`,m=` (\u21C5 ${T})`;super(a,h,p),this.Y=this.B(new u.Emitter),this.onDidFocus=this.Y.event,this.Z=this.B(new u.Emitter),this.onDidBlur=this.Z.event,this.W=new c.HistoryNavigator(p.history,100);const C=()=>{if(p.showHistoryHint&&p.showHistoryHint()&&!this.i.endsWith(A)&&!this.i.endsWith(m)&&this.W.getHistory().length){const N=this.i.endsWith(")")?A:m,L=this.i+N;p.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=L:this.setPlaceHolder(L)}};this.X=new MutationObserver((N,L)=>{N.forEach(d=>{d.target.textContent||C()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.D(this.b,()=>C()),this.C(this.b,()=>{const N=L=>{if(this.i.endsWith(L)){const d=this.i.slice(0,this.i.length-L.length);return p.showPlaceholderOnFocus?this.i=d:this.setPlaceHolder(d),!0}else return!1};N(m)||N(A)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(a){this.value&&(a||this.value!==this.cb())&&this.W.add(this.value)}getHistory(){return this.W.getHistory()}isAtFirstInHistory(){return this.W.isFirst()}isAtLastInHistory(){return this.W.isLast()}isNowhereInHistory(){return this.W.isNowhere()}showNextValue(){this.W.has(this.value)||this.addToHistory();let a=this.eb();a&&(a=a===this.value?this.eb():a),a&&(this.value=a,D.status(this.value))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let a=this.db();a&&(a=a===this.value?this.db():a),a&&(this.value=a,D.status(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let a=this.W.current();return a||(a=this.W.last(),this.W.next()),a}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()||this.W.last()}}t.HistoryInputBox=s}),define(ge[64],me([1,0,61,19,16,17,3,93]),function(Q,t,E,P,U,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends E.BaseActionViewItem{constructor(M,o,n){super(M,o,n),this.a=this.B(new f({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.k.keybinding?`${this._action.label} (${this.k.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:n.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:n.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:n.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(M){this.element=M,this.element.appendChild(this.a.domNode)}t(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}C(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(M){this.a.domNode.tabIndex=M?0:-1}}t.ToggleActionViewItem=w;class f extends P.Widget{constructor(M){super(),this.a=this.B(new D.Emitter),this.onChange=this.a.event,this.b=this.B(new D.Emitter),this.onKeyDown=this.b.event,this.c=M,this.s=this.c.isChecked;const o=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,o.push(...i.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&o.push(...this.c.actionClassName.split(" ")),this.s&&o.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...o),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,n=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),n.preventDefault())}),this.B(this.G(this.domNode)),this.p(this.domNode,n=>{if(n.keyCode===10||n.keyCode===3){this.checked=!this.s,this.a.fire(!0),n.preventDefault(),n.stopPropagation();return}this.b.fire(n)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(M){this.s=M,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(M){this.g&&this.domNode.classList.remove(...i.ThemeIcon.asClassNameArray(this.g)),this.g=M,this.g&&this.domNode.classList.add(...i.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(M){this.domNode.title=M,this.domNode.setAttribute("aria-label",M)}}t.Toggle=f;class u extends P.Widget{constructor(M,o,n){super(),this.c=M,this.g=o,this.a=new f({title:this.c,isChecked:this.g,icon:U.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.a.domNode,this.b=n,this.h()}get checked(){return this.a.checked}set checked(M){this.a.checked=M}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.Checkbox=u}),define(ge[126],me([1,0,64,16,98]),function(Q,t,E,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const i=U.localize(0,null),D=U.localize(1,null),w=U.localize(2,null);class f extends E.Toggle{constructor(o){super({icon:P.Codicon.caseSensitive,title:i+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.CaseSensitiveToggle=f;class u extends E.Toggle{constructor(o){super({icon:P.Codicon.wholeWord,title:D+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.WholeWordsToggle=u;class c extends E.Toggle{constructor(o){super({icon:P.Codicon.regex,title:w+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.RegexToggle=c}),define(ge[127],me([1,0,4,126,63,19,3,97,2,87]),function(Q,t,E,P,U,i,D,w,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const u=w.localize(0,null);class c extends i.Widget{constructor(o,n,e){super(),this.i=!0,this.l=!1,this.n=new f.DisposableStore,this.H=[],this.I=this.B(new D.Emitter),this.onDidOptionChange=this.I.event,this.J=this.B(new D.Emitter),this.onKeyDown=this.J.event,this.L=this.B(new D.Emitter),this.onMouseDown=this.L.event,this.M=this.B(new D.Emitter),this.onInput=this.M.event,this.N=this.B(new D.Emitter),this.onKeyUp=this.N.event,this.O=this.B(new D.Emitter),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.B(new D.Emitter),this.onRegexKeyDown=this.P.event,this.Q=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||u,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",r=e.appendWholeWordsLabel||"",a=e.appendRegexLabel||"",h=e.history||[],p=!!e.flexibleHeight,T=!!e.flexibleWidth,A=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new U.HistoryInputBox(this.domNode,n,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:h,showHistoryHint:e.showHistoryHint,flexibleHeight:p,flexibleWidth:T,flexibleMaxHeight:A,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new P.RegexToggle({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(C=>{this.I.fire(C),!C&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(C=>{this.P.fire(C)})),this.w=this.B(new P.WholeWordsToggle({appendTitle:r,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(C=>{this.I.fire(C),!C&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new P.CaseSensitiveToggle({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(C=>{this.I.fire(C),!C&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(C=>{this.O.fire(C)}));const m=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,C=>{if(C.equals(15)||C.equals(17)||C.equals(9)){const N=m.indexOf(document.activeElement);if(N>=0){let L=-1;C.equals(17)?L=(N+1)%m.length:C.equals(15)&&(N===0?L=m.length-1:L=N-1),C.equals(9)?(m[N].blur(),this.inputBox.focus()):L>=0&&m[L].focus(),E.EventHelper.stop(C,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"block":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),o?.appendChild(this.domNode),this.B(E.addDisposableListener(this.inputBox.inputElement,"compositionstart",m=>{this.l=!0})),this.B(E.addDisposableListener(this.inputBox.inputElement,"compositionend",m=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,m=>this.J.fire(m)),this.u(this.inputBox.inputElement,m=>this.N.fire(m)),this.z(this.inputBox.inputElement,m=>this.M.fire()),this.j(this.inputBox.inputElement,m=>this.L.fire(m))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const o of this.H)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const o of this.H)o.disable()}setFocusInputOnOptionClick(o){this.i=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const n of this.H)n.domNode.remove();this.H=[],this.n.dispose(),this.n=new f.DisposableStore;for(const n of o??[])this.n.add(n),this.s.appendChild(n.domNode),this.n.add(n.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(n);this.H.length>0&&(this.s.style.display="block"),this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((n,e)=>n+e.width(),0)}clear(){this.R(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(o){this.y&&(this.y.checked=o)}getWholeWords(){return this.w?.checked??!1}setWholeWords(o){this.w&&(this.w.checked=o)}getRegex(){return this.v?.checked??!1}setRegex(o){this.v&&(this.v.checked=o,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Q),this.Q=1-this.Q,this.domNode.classList.add("highlight-"+this.Q)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}R(){this.inputBox.hideMessage()}}t.FindInput=c,c.OPTION_CHANGE="optionChange"}),define(ge[128],me([1,0,4,20,14,62,127,63,58,59,64,55,24,31,13,9,16,17,70,3,32,2,46,6,102,94]),function(Q,t,E,P,U,i,D,w,f,u,c,M,o,n,e,s,r,a,h,p,T,A,m,C,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class L extends f.ElementsDragAndDropData{set context(l){this.c.context=l}get context(){return this.c.context}constructor(l){super(l.elements.map(k=>k.element)),this.c=l}}function d(g){return g instanceof f.ElementsDragAndDropData?new L(g):g}class v{constructor(l,k){this.c=l,this.d=k,this.b=A.Disposable.None}getDragURI(l){return this.d.getDragURI(l.element)}getDragLabel(l,k){if(this.d.getDragLabel)return this.d.getDragLabel(l.map(W=>W.element),k)}onDragStart(l,k){this.d.onDragStart?.(d(l),k)}onDragOver(l,k,W,j,F=!0){const I=this.d.onDragOver(d(l),k&&k.element,W,j),O=this.a!==k;if(O&&(this.b.dispose(),this.a=k),typeof k>"u")return I;if(O&&typeof I!="boolean"&&I.autoExpand&&(this.b=(0,s.disposableTimeout)(()=>{const _=this.c(),Y=_.getNodeLocation(k);_.isCollapsed(Y)&&_.setCollapsed(Y,!1),this.a=void 0},500)),typeof I=="boolean"||!I.accept||typeof I.bubble>"u"||I.feedback){if(!F){const _=typeof I=="boolean"?I:I.accept,Y=typeof I=="boolean"?void 0:I.effect;return{accept:_,effect:Y,feedback:[W]}}return I}if(I.bubble===1){const _=this.c(),Y=_.getNodeLocation(k),ne=_.getParentNodeLocation(Y),ue=_.getNode(ne),we=ne&&_.getListIndex(ne);return this.onDragOver(l,ue,we,j,!1)}const S=this.c(),B=S.getNodeLocation(k),H=S.getListIndex(B),z=S.getListRenderCount(B);return{...I,feedback:(0,e.range)(H,H+z)}}drop(l,k,W,j){this.b.dispose(),this.a=void 0,this.d.drop(d(l),k&&k.element,W,j)}onDragEnd(l){this.d.onDragEnd?.(l)}}function b(g,l){return l&&{...l,identityProvider:l.identityProvider&&{getId(k){return l.identityProvider.getId(k.element)}},dnd:l.dnd&&new v(g,l.dnd),multipleSelectionController:l.multipleSelectionController&&{isSelectionSingleChangeEvent(k){return l.multipleSelectionController.isSelectionSingleChangeEvent({...k,element:k.element})},isSelectionRangeChangeEvent(k){return l.multipleSelectionController.isSelectionRangeChangeEvent({...k,element:k.element})}},accessibilityProvider:l.accessibilityProvider&&{...l.accessibilityProvider,getSetSize(k){const W=g(),j=W.getNodeLocation(k),F=W.getParentNodeLocation(j);return W.getNode(F).visibleChildrenCount},getPosInSet(k){return k.visibleChildIndex+1},isChecked:l.accessibilityProvider&&l.accessibilityProvider.isChecked?k=>l.accessibilityProvider.isChecked(k.element):void 0,getRole:l.accessibilityProvider&&l.accessibilityProvider.getRole?k=>l.accessibilityProvider.getRole(k.element):()=>"treeitem",getAriaLabel(k){return l.accessibilityProvider.getAriaLabel(k.element)},getWidgetAriaLabel(){return l.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:l.accessibilityProvider&&l.accessibilityProvider.getWidgetRole?()=>l.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:l.accessibilityProvider&&l.accessibilityProvider.getAriaLevel?k=>l.accessibilityProvider.getAriaLevel(k.element):k=>k.depth,getActiveDescendantId:l.accessibilityProvider.getActiveDescendantId&&(k=>l.accessibilityProvider.getActiveDescendantId(k.element))},keyboardNavigationLabelProvider:l.keyboardNavigationLabelProvider&&{...l.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(k){return l.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(k.element)}}}}class y{constructor(l){this.a=l}getHeight(l){return this.a.getHeight(l.element)}getTemplateId(l){return this.a.getTemplateId(l.element)}hasDynamicHeight(l){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(l.element)}setDynamicHeight(l,k){this.a.setDynamicHeight?.(l.element,k)}}t.ComposedTreeDelegate=y;class R{static lift(l){return l instanceof R?l:new R(l)}static empty(l=0){return new R({focus:[],selection:[],expanded:Object.create(null),scrollTop:l})}constructor(l){if(this.focus=new Set(l.focus),this.selection=new Set(l.selection),l.expanded instanceof Array){this.expanded=Object.create(null);for(const k of l.expanded)this.expanded[k]=1}else this.expanded=l.expanded;this.expanded=l.expanded,this.scrollTop=l.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=R;var V;(function(g){g.None="none",g.OnHover="onHover",g.Always="always"})(V=t.RenderIndentGuides||(t.RenderIndentGuides={}));class ee{get elements(){return this.b}constructor(l,k=[]){this.b=k,this.a=new A.DisposableStore,this.onDidChange=p.Event.forEach(l,W=>this.b=W,this.a)}dispose(){this.a.dispose()}}class Z{constructor(l,k,W,j,F,I={}){this.o=l,this.p=k,this.q=j,this.s=F,this.b=new Map,this.c=new Map,this.d=Z.a,this.f=!1,this.g=!1,this.j=new Set,this.k=A.Disposable.None,this.m=new A.DisposableStore,this.templateId=l.templateId,this.updateOptions(I),p.Event.map(W,O=>O.node)(this.u,this,this.m),l.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(l={}){if(typeof l.indent<"u"){const k=(0,m.clamp)(l.indent,0,40);if(k!==this.d){this.d=k;for(const[W,j]of this.c)this.v(W,j)}}if(typeof l.renderIndentGuides<"u"){const k=l.renderIndentGuides!==V.None;if(k!==this.g){this.g=k;for(const[W,j]of this.c)this.w(W,j);if(this.k.dispose(),k){const W=new A.DisposableStore;this.q.onDidChange(this.x,this,W),this.k=W,this.x(this.q.elements)}}}typeof l.hideTwistiesOfChildlessElements<"u"&&(this.f=l.hideTwistiesOfChildlessElements)}renderTemplate(l){const k=(0,E.append)(l,(0,E.$)(".monaco-tl-row")),W=(0,E.append)(k,(0,E.$)(".monaco-tl-indent")),j=(0,E.append)(k,(0,E.$)(".monaco-tl-twistie")),F=(0,E.append)(k,(0,E.$)(".monaco-tl-contents")),I=this.o.renderTemplate(F);return{container:l,indent:W,twistie:j,indentGuidesDisposable:A.Disposable.None,templateData:I}}renderElement(l,k,W,j){this.c.set(l,W),this.b.set(l.element,l),this.v(l,W),this.o.renderElement(l,k,W.templateData,j)}disposeElement(l,k,W,j){W.indentGuidesDisposable.dispose(),this.o.disposeElement?.(l,k,W.templateData,j),typeof j=="number"&&(this.c.delete(l),this.b.delete(l.element))}disposeTemplate(l){this.o.disposeTemplate(l.templateData)}t(l){const k=this.b.get(l);!k||this.u(k)}u(l){const k=this.c.get(l);!k||(this.x(this.q.elements),this.v(l,k))}v(l,k){const W=Z.a+(l.depth-1)*this.d;k.twistie.style.paddingLeft=`${W}px`,k.indent.style.width=`${W+this.d-16}px`,l.collapsible?k.container.setAttribute("aria-expanded",String(!l.collapsed)):k.container.removeAttribute("aria-expanded"),k.twistie.classList.remove(...a.ThemeIcon.asClassNameArray(r.Codicon.treeItemExpanded));let j=!1;this.o.renderTwistie&&(j=this.o.renderTwistie(l.element,k.twistie)),l.collapsible&&(!this.f||l.visibleChildrenCount>0)?(j||k.twistie.classList.add(...a.ThemeIcon.asClassNameArray(r.Codicon.treeItemExpanded)),k.twistie.classList.add("collapsible"),k.twistie.classList.toggle("collapsed",l.collapsed)):k.twistie.classList.remove("collapsible","collapsed"),this.w(l,k)}w(l,k){if((0,E.clearNode)(k.indent),k.indentGuidesDisposable.dispose(),!this.g)return;const W=new A.DisposableStore,j=this.p();for(;;){const F=j.getNodeLocation(l),I=j.getParentNodeLocation(F);if(!I)break;const O=j.getNode(I),S=(0,E.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(O)&&S.classList.add("active"),k.indent.childElementCount===0?k.indent.appendChild(S):k.indent.insertBefore(S,k.indent.firstElementChild),this.s.add(O,S),W.add((0,A.toDisposable)(()=>this.s.delete(O,S))),l=O}k.indentGuidesDisposable=W}x(l){if(!this.g)return;const k=new Set,W=this.p();l.forEach(j=>{const F=W.getNodeLocation(j);try{const I=W.getParentNodeLocation(F);j.collapsible&&j.children.length>0&&!j.collapsed?k.add(j):I&&k.add(W.getNode(I))}catch{}}),this.j.forEach(j=>{k.has(j)||this.s.forEach(j,F=>F.classList.remove("active"))}),k.forEach(j=>{this.j.has(j)||this.s.forEach(j,F=>F.classList.add("active"))}),this.j=k}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,A.dispose)(this.m)}}Z.a=8;class J{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(l){this.c=l,this.d=l.toLowerCase()}constructor(l,k,W){this.g=l,this.j=k,this.k=W,this.a=0,this.b=0,this.c="",this.d="",this.f=new A.DisposableStore,l.onWillRefilter(this.m,this,this.f)}filter(l,k){let W=1;if(this.k){const I=this.k.filter(l,k);if(typeof I=="boolean"?W=I?1:0:(0,M.isFilterResult)(I)?W=(0,M.getVisibleState)(I.visibility):W=I,W===0)return!1}if(this.a++,!this.c)return this.b++,{data:T.FuzzyScore.Default,visibility:W};const j=this.j.getKeyboardNavigationLabel(l),F=Array.isArray(j)?j:[j];for(const I of F){const O=I&&I.toString();if(typeof O>"u")return{data:T.FuzzyScore.Default,visibility:W};let S;if(this.g.findMatchType===pe.Contiguous){const B=O.toLowerCase().indexOf(this.d);if(B>-1){S=[Number.MAX_SAFE_INTEGER,0];for(let H=this.d.length;H>0;H--)S.push(B+H-1)}}else S=(0,T.fuzzyScore)(this.c,this.d,0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(S)return this.b++,F.length===1?{data:S,visibility:W}:{data:{label:O,score:S},visibility:W}}return this.g.findMode===ce.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(l):2:{data:T.FuzzyScore.Default,visibility:W}}m(){this.a=0,this.b=0}dispose(){(0,A.dispose)(this.f)}}class re extends c.Toggle{constructor(l){super({icon:r.Codicon.listFilter,title:(0,N.localize)(0,null),isChecked:l.isChecked??!1,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.ModeToggle=re;class he extends c.Toggle{constructor(l){super({icon:r.Codicon.searchFuzzy,title:(0,N.localize)(1,null),isChecked:l.isChecked??!1,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.FuzzyToggle=he;const de={inputBoxStyles:w.unthemedInboxStyles,toggleStyles:c.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ce;(function(g){g[g.Highlight=0]="Highlight",g[g.Filter=1]="Filter"})(ce=t.TreeFindMode||(t.TreeFindMode={}));var pe;(function(g){g[g.Fuzzy=0]="Fuzzy",g[g.Contiguous=1]="Contiguous"})(pe=t.TreeFindMatchType||(t.TreeFindMatchType={}));class Te extends A.Disposable{set mode(l){this.b.checked=l===ce.Filter,this.f.inputBox.setPlaceHolder(l===ce.Filter?(0,N.localize)(2,null):(0,N.localize)(3,null))}set matchType(l){this.c.checked=l===pe.Fuzzy}get value(){return this.f.inputBox.value}set value(l){this.f.inputBox.value=l}constructor(l,k,W,j,F,I){super(),this.p=k,this.a=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.k=0,this.m=0,this._onDidDisable=new p.Emitter,this.onDidDisable=this._onDidDisable.event,l.appendChild(this.a.root),this.B((0,A.toDisposable)(()=>l.removeChild(this.a.root)));const O=I?.styles??de;O.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=O.listFilterWidgetBackground),O.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${O.listFilterWidgetShadow}`),this.b=this.B(new re({...O.toggleStyles,isChecked:j===ce.Filter})),this.c=this.B(new he({...O.toggleStyles,isChecked:F===pe.Fuzzy})),this.onDidChangeMode=p.Event.map(this.b.onChange,()=>this.b.checked?ce.Filter:ce.Highlight,this.q),this.onDidChangeMatchType=p.Event.map(this.c.onChange,()=>this.c.checked?pe.Fuzzy:pe.Contiguous,this.q),this.f=this.B(new D.FindInput(this.a.findInput,W,{label:(0,N.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:O.inputBoxStyles,toggleStyles:O.toggleStyles,history:I?.history})),this.g=this.B(new i.ActionBar(this.a.actionbar)),this.mode=j;const S=this.B(new P.DomEmitter(this.f.inputBox.inputElement,"keydown")),B=this.B(p.Event.chain(S.event)).map(Y=>new U.StandardKeyboardEvent(Y)).event;this.B(B(Y=>{if(Y.equals(3)){Y.preventDefault(),Y.stopPropagation(),this.f.inputBox.addToHistory(),this.p.domFocus();return}if(Y.equals(18)){Y.preventDefault(),Y.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.p.domFocus()):this.f.inputBox.showNextValue();return}if(Y.equals(16)){Y.preventDefault(),Y.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const H=this.B(new n.Action("close",(0,N.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(H,{icon:!0,label:!1});const z=this.B(new P.DomEmitter(this.a.grab,"mousedown"));this.B(z.event(Y=>{const ne=new A.DisposableStore,ue=ne.add(new P.DomEmitter(window,"mousemove")),we=ne.add(new P.DomEmitter(window,"mouseup")),De=this.k,Le=Y.pageX,Ae=this.m,ve=Y.pageY;this.a.grab.classList.add("grabbing");const Me=this.a.root.style.transition;this.a.root.style.transition="unset";const Ie=$e=>{const ze=$e.pageX-Le;this.k=De-ze;const We=$e.pageY-ve;this.m=Ae+We,this.layout()};ne.add(ue.event(Ie)),ne.add(we.event($e=>{Ie($e),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Me,ne.dispose()}))}));const _=this.B(p.Event.chain(this.B(new P.DomEmitter(this.a.grab,"keydown")).event)).map(Y=>new U.StandardKeyboardEvent(Y)).event;this.B(_(Y=>{let ne,ue;if(Y.keyCode===15?ne=Number.POSITIVE_INFINITY:Y.keyCode===17?ne=0:Y.keyCode===10&&(ne=this.k===0?Number.POSITIVE_INFINITY:0),Y.keyCode===16?ue=0:Y.keyCode===18&&(ue=Number.POSITIVE_INFINITY),ne!==void 0&&(Y.preventDefault(),Y.stopPropagation(),this.k=ne,this.layout()),ue!==void 0){Y.preventDefault(),Y.stopPropagation(),this.m=ue;const we=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=we},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(l=this.j){this.j=l,this.k=(0,m.clamp)(this.k,0,Math.max(0,l-212)),this.a.root.style.right=`${this.k}px`,this.m=(0,m.clamp)(this.m,0,24),this.a.root.style.top=`${this.m}px`}showMessage(l){this.f.showMessage(l)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class Pe{get pattern(){return this.b}get mode(){return this.d}set mode(l){l!==this.d&&(this.d=l,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(l))}get matchType(){return this.f}set matchType(l){l!==this.f&&(this.f=l,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(l))}constructor(l,k,W,j,F,I={}){this.t=l,this.u=W,this.v=j,this.w=F,this.x=I,this.b="",this.c="",this.j=0,this.k=new p.Emitter,this.onDidChangeMode=this.k.event,this.m=new p.Emitter,this.onDidChangeMatchType=this.m.event,this.o=new p.Emitter,this.onDidChangePattern=this.o.event,this.p=new p.Emitter,this.onDidChangeOpenState=this.p.event,this.q=new A.DisposableStore,this.s=new A.DisposableStore,this.d=l.options.defaultFindMode??ce.Highlight,this.f=l.options.defaultFindMatchType??pe.Fuzzy,k.onDidSplice(this.z,this,this.s)}updateOptions(l={}){l.defaultFindMode!==void 0&&(this.mode=l.defaultFindMode),l.defaultFindMatchType!==void 0&&(this.matchType=l.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Te(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(l=>this.mode=l,void 0,this.q),this.g.onDidChangeMatchType(l=>this.matchType=l,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){!this.g||(this.a=this.g.getHistory(),this.g=void 0,this.q.dispose(),this.q=new A.DisposableStore,this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(l){this.b=l,this.o.fire(l),this.v.pattern=l,this.t.refilter(),l&&this.t.focusNext(0,!0,void 0,W=>!T.FuzzyScore.isDefault(W.filterData));const k=this.t.getFocus();if(k.length>0){const W=k[0];this.t.getRelativeTop(W)===null&&this.t.reveal(W,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const l=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&l?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,N.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(l){return!this.g||!this.pattern||this.d===ce.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!T.FuzzyScore.isDefault(l.filterData)}layout(l){this.j=l,this.g?.layout(l)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Oe(g){let l=o.TreeMouseEventTarget.Unknown;return(0,E.hasParentWithClass)(g.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?l=o.TreeMouseEventTarget.Twistie:(0,E.hasParentWithClass)(g.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?l=o.TreeMouseEventTarget.Element:(0,E.hasParentWithClass)(g.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(l=o.TreeMouseEventTarget.Filter),{browserEvent:g.browserEvent,element:g.element?g.element.element:null,target:l}}function x(g){return{element:g.element?g.element.element:null,browserEvent:g.browserEvent,anchor:g.anchor}}function G(g,l){l(g),g.children.forEach(k=>G(k,l))}class ie{get f(){return this.d||(this.d=this.m()),this.d}constructor(l,k){this.g=l,this.j=k,this.a=[],this.c=new p.Emitter,this.onDidChange=this.c.event}set(l,k){!k?.__forceEvent&&(0,e.equals)(this.a,l)||this.k(l,!1,k)}k(l,k,W){if(this.a=[...l],this.b=void 0,this.d=void 0,!k){const j=this;this.c.fire({get elements(){return j.get()},browserEvent:W})}}get(){return this.b||(this.b=this.a.map(l=>l.element)),[...this.b]}getNodes(){return this.a}has(l){return this.f.has(l)}onDidModelSplice({insertedNodes:l,deletedNodes:k}){if(!this.j){const S=this.m(),B=H=>S.delete(H);k.forEach(H=>G(H,B)),this.set([...S.values()]);return}const W=new Set,j=S=>W.add(this.j.getId(S.element).toString());k.forEach(S=>G(S,j));const F=new Map,I=S=>F.set(this.j.getId(S.element).toString(),S);l.forEach(S=>G(S,I));const O=[];for(const S of this.a){const B=this.j.getId(S.element).toString();if(!W.has(B))O.push(S);else{const z=F.get(B);z&&O.push(z)}}if(this.a.length>0&&O.length===0){const S=this.g();S&&O.push(S)}this.k(O,!0)}m(){const l=new Set;for(const k of this.a)l.add(k);return l}}class se extends u.MouseController{constructor(l,k){super(l),this.z=k}u(l){if((0,u.isButton)(l.browserEvent.target)||(0,u.isInputElement)(l.browserEvent.target)||(0,u.isMonacoEditor)(l.browserEvent.target))return;const k=l.element;if(!k)return super.u(l);if(this.p(l)||this.o(l))return super.u(l);const W=l.browserEvent.target,j=W.classList.contains("monaco-tl-twistie")||W.classList.contains("monaco-icon-label")&&W.classList.contains("folder-icon")&&l.browserEvent.offsetX<16;let F=!1;if(typeof this.z.expandOnlyOnTwistieClick=="function"?F=this.z.expandOnlyOnTwistieClick(k.element):F=!!this.z.expandOnlyOnTwistieClick,F&&!j&&l.browserEvent.detail!==2)return super.u(l);if(!this.z.expandOnDoubleClick&&l.browserEvent.detail===2)return super.u(l);if(k.collapsible){const I=this.z.getNodeLocation(k),O=l.browserEvent.altKey;if(this.z.setFocus([I]),this.z.toggleCollapsed(I,O),F&&j)return}super.u(l)}v(l){l.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.z.expandOnDoubleClick||super.v(l)}}class ae extends u.List{constructor(l,k,W,j,F,I,O,S){super(l,k,W,j,S),this.p=F,this.s=I,this.L=O}E(l){return new se(this,l.tree)}splice(l,k,W=[]){if(super.splice(l,k,W),W.length===0)return;const j=[],F=[];let I;W.forEach((O,S)=>{this.p.has(O)&&j.push(l+S),this.s.has(O)&&F.push(l+S),this.L.has(O)&&(I=l+S)}),j.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...j])),F.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...F])),typeof I=="number"&&super.setAnchor(I)}setFocus(l,k,W=!1){super.setFocus(l,k),W||this.p.set(l.map(j=>this.element(j)),k)}setSelection(l,k,W=!1){super.setSelection(l,k),W||this.s.set(l.map(j=>this.element(j)),k)}setAnchor(l,k=!1){super.setAnchor(l),k||(typeof l>"u"?this.L.set([]):this.L.set([this.element(l)]))}}class te{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return p.Event.map(this.j.onMouseClick,Oe)}get onMouseDblClick(){return p.Event.filter(p.Event.map(this.j.onMouseDblClick,Oe),l=>l.target!==o.TreeMouseEventTarget.Filter)}get onContextMenu(){return p.Event.map(this.j.onContextMenu,x)}get onTap(){return p.Event.map(this.j.onTap,Oe)}get onPointer(){return p.Event.map(this.j.onPointer,Oe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return p.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??ce.Highlight}set findMode(l){this.x&&(this.x.mode=l)}get findMatchType(){return this.x?.matchType??pe.Fuzzy}set findMatchType(l){this.x&&(this.x.matchType=l)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:p.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(l,k,W,j,F={}){this.D=l,this.E=F,this.w=new p.EventBufferer,this.onDidChangeFindOpenState=p.Event.None,this.A=new A.DisposableStore,this.B=new p.Emitter,this.onWillRefilter=this.B.event,this.C=new p.Emitter,this.onDidUpdateOptions=this.C.event;const I=new y(W),O=new p.Relay,S=new p.Relay,B=this.A.add(new ee(S.event)),H=new h.SetMap;this.k=j.map(Y=>new Z(Y,()=>this.o,O.event,B,H,F));for(const Y of this.k)this.A.add(Y);let z;F.keyboardNavigationLabelProvider&&(z=new J(this,F.keyboardNavigationLabelProvider,F.filter),F={...F,filter:z},this.A.add(z)),this.p=new ie(()=>this.j.getFocusedElements()[0],F.identityProvider),this.q=new ie(()=>this.j.getSelectedElements()[0],F.identityProvider),this.u=new ie(()=>this.j.getAnchorElement(),F.identityProvider),this.j=new ae(l,k,I,this.k,this.p,this.q,this.u,{...b(()=>this.o,F),tree:this}),this.o=this.I(l,this.j,F),O.input=this.o.onDidChangeCollapseState;const _=p.Event.forEach(this.o.onDidSplice,Y=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(Y),this.q.onDidModelSplice(Y)})},this.A);if(_(()=>null,null,this.A),S.input=p.Event.chain(p.Event.any(_,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const Y=new Set;for(const ne of this.p.getNodes())Y.add(ne);for(const ne of this.q.getNodes())Y.add(ne);return[...Y.values()]}).event,F.keyboardSupport!==!1){const Y=p.Event.chain(this.j.onKeyDown).filter(ne=>!(0,u.isInputElement)(ne.target)).map(ne=>new U.StandardKeyboardEvent(ne));Y.filter(ne=>ne.keyCode===15).on(this.F,this,this.A),Y.filter(ne=>ne.keyCode===17).on(this.G,this,this.A),Y.filter(ne=>ne.keyCode===10).on(this.H,this,this.A)}if((F.findWidgetEnabled??!0)&&F.keyboardNavigationLabelProvider&&F.contextViewProvider){const Y=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Pe(this,this.o,this.j,z,F.contextViewProvider,Y),this.y=ne=>this.x.shouldAllowFocus(ne),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=p.Event.None,this.onDidChangeFindMatchType=p.Event.None;this.z=(0,E.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===V.Always)}updateOptions(l={}){this.E={...this.E,...l};for(const k of this.k)k.updateOptions(l);this.j.updateOptions(this.E),this.x?.updateOptions(l),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===V.Always)}get options(){return this.E}updateWidth(l){const k=this.o.getListIndex(l);k!==-1&&this.j.updateWidth(k)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get scrollTop(){return this.j.scrollTop}set scrollTop(l){this.j.scrollTop=l}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(l){this.j.scrollLeft=l}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const l=this.j.firstVisibleIndex;return l<0||l>=this.j.length?void 0:this.j.element(l).element}get lastVisibleElement(){const l=this.j.lastVisibleIndex;return this.j.element(l).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(l){this.j.ariaLabel=l}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(l,k){this.j.layout(l,k),(0,C.isNumber)(k)&&this.x?.layout(k)}style(l){const k=`.${this.j.domId}`,W=[];l.treeIndentGuidesStroke&&(W.push(`.monaco-list${k}:hover .monaco-tl-indent > .indent-guide, .monaco-list${k}.always .monaco-tl-indent > .indent-guide  { border-color: ${l.treeIndentGuidesStroke.transparent(.4)}; }`),W.push(`.monaco-list${k} .monaco-tl-indent > .indent-guide.active { border-color: ${l.treeIndentGuidesStroke}; }`)),this.z.textContent=W.join(`
`),this.j.style(l)}getParentElement(l){const k=this.o.getParentNodeLocation(l);return this.o.getNode(k).element}getFirstElementChild(l){return this.o.getFirstElementChild(l)}getNode(l){return this.o.getNode(l)}getNodeLocation(l){return this.o.getNodeLocation(l)}collapse(l,k=!1){return this.o.setCollapsed(l,!0,k)}expand(l,k=!1){return this.o.setCollapsed(l,!1,k)}toggleCollapsed(l,k=!1){return this.o.setCollapsed(l,void 0,k)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(l){return this.o.isCollapsible(l)}setCollapsible(l,k){return this.o.setCollapsible(l,k)}isCollapsed(l){return this.o.isCollapsed(l)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(l){if(typeof l>"u")return this.j.setAnchor(void 0);const k=this.o.getNode(l);this.u.set([k]);const W=this.o.getListIndex(l);W>-1&&this.j.setAnchor(W,!0)}getAnchor(){return(0,e.firstOrDefault)(this.u.get(),void 0)}setSelection(l,k){const W=l.map(F=>this.o.getNode(F));this.q.set(W,k);const j=l.map(F=>this.o.getListIndex(F)).filter(F=>F>-1);this.j.setSelection(j,k,!0)}getSelection(){return this.q.get()}setFocus(l,k){const W=l.map(F=>this.o.getNode(F));this.p.set(W,k);const j=l.map(F=>this.o.getListIndex(F)).filter(F=>F>-1);this.j.setFocus(j,k,!0)}focusNext(l=1,k=!1,W,j=this.y){this.j.focusNext(l,k,W,j)}focusPrevious(l=1,k=!1,W,j=this.y){this.j.focusPrevious(l,k,W,j)}focusNextPage(l,k=this.y){return this.j.focusNextPage(l,k)}focusPreviousPage(l,k=this.y){return this.j.focusPreviousPage(l,k)}focusLast(l,k=this.y){this.j.focusLast(l,k)}focusFirst(l,k=this.y){this.j.focusFirst(l,k)}getFocus(){return this.p.get()}reveal(l,k){this.o.expandTo(l);const W=this.o.getListIndex(l);W!==-1&&this.j.reveal(W,k)}getRelativeTop(l){const k=this.o.getListIndex(l);return k===-1?null:this.j.getRelativeTop(k)}getViewState(l=this.options.identityProvider){if(!l)throw new o.TreeError(this.D,"Can't get tree view state without an identity provider");const k=I=>l.getId(I).toString(),W=R.empty(this.scrollTop);for(const I of this.getFocus())W.focus.add(k(I));for(const I of this.getSelection())W.selection.add(k(I));const j=this.o.getNode(),F=[j];for(;F.length>0;){const I=F.shift();I!==j&&I.collapsible&&(W.expanded[k(I.element)]=I.collapsed?0:1),F.push(...I.children)}return W}F(l){l.preventDefault(),l.stopPropagation();const k=this.j.getFocusedElements();if(k.length===0)return;const W=k[0],j=this.o.getNodeLocation(W);if(!this.o.setCollapsed(j,!0)){const I=this.o.getParentNodeLocation(j);if(!I)return;const O=this.o.getListIndex(I);this.j.reveal(O),this.j.setFocus([O])}}G(l){l.preventDefault(),l.stopPropagation();const k=this.j.getFocusedElements();if(k.length===0)return;const W=k[0],j=this.o.getNodeLocation(W);if(!this.o.setCollapsed(j,!1)){if(!W.children.some(S=>S.visible))return;const[I]=this.j.getFocus(),O=I+1;this.j.reveal(O),this.j.setFocus([O])}}H(l){l.preventDefault(),l.stopPropagation();const k=this.j.getFocusedElements();if(k.length===0)return;const W=k[0],j=this.o.getNodeLocation(W),F=l.browserEvent.altKey;this.o.setCollapsed(j,void 0,F)}navigate(l){return new $(this.j,this.o,l)}dispose(){(0,A.dispose)(this.A),this.j.dispose()}}t.AbstractTree=te;class ${constructor(l,k,W){this.b=l,this.c=k,W?this.a=this.c.getListIndex(W):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(ge[129],me([1,0,128,119,24,26]),function(Q,t,E,P,U,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class D extends E.AbstractTree{constructor(f,u,c,M,o,n={}){super(f,u,c,M,n),this.f=f,this.g=o,this.d=new Map,this.c=n.identityProvider}getInput(){return this.b}setInput(f,u){if(u&&!this.c)throw new U.TreeError(this.f,"Can't restore tree view state without an identity provider");if(this.b=f,!f){this.d.clear(),this.o.setChildren(null,i.Iterable.empty());return}if(!u){this.m(f);return}const c=[],M=[],o=e=>{const s=this.c.getId(e).toString();return!u.expanded[s]},n=e=>{const s=this.c.getId(e.element).toString();u.focus.has(s)&&c.push(e.element),u.selection.has(s)&&M.push(e.element)};this.m(f,o,n),this.setFocus(c),this.setSelection(M),u&&typeof u.scrollTop=="number"&&(this.scrollTop=u.scrollTop)}updateChildren(f=this.b){if(typeof this.b>"u")throw new U.TreeError(this.f,"Tree input not set");let u;this.c&&(u=c=>{const M=this.c.getId(c).toString(),o=this.d.get(M);if(!!o)return o.collapsed}),this.m(f,u)}resort(f=this.b,u=!0){this.o.resort(f===this.b?null:f,u)}refresh(f){if(f===void 0){this.j.rerender();return}this.o.rerender(f)}m(f,u,c){let M;if(this.c){const o=new Set,n=c;c=e=>{const s=this.c.getId(e.element).toString();o.add(s),this.d.set(s,e),n?.(e)},M=e=>{const s=this.c.getId(e.element).toString();o.has(s)||this.d.delete(s)}}this.o.setChildren(f===this.b?null:f,this.s(f,u).elements,{onDidCreateNode:c,onDidDeleteNode:M})}s(f,u){const c=[...this.g.getChildren(f)];return{elements:i.Iterable.map(c,o=>{const{elements:n,size:e}=this.s(o,u),s=this.g.hasChildren?this.g.hasChildren(o):void 0,r=e===0?void 0:u&&u(o);return{element:o,children:n,collapsible:s,collapsed:r}}),size:c.length}}I(f,u,c){return new P.ObjectTreeModel(f,u,c)}}t.DataTree=D}),define(ge[37],me([1,0,13,9,29,27,25,7,3,2,50,11,6]),function(Q,t,E,P,U,i,D,w,f,u,c,M,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var n;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(n||(n={}));function e(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(s||(s={}));function r(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(a||(a={}));function h(x){let G=0;for(let ie=0;;ie+=7){const se=x.read(1);if(G|=(se.buffer[0]&127)<<ie,!(se.buffer[0]&128))return G}}const p=N(0);function T(x,G){if(G===0){x.write(p);return}let ie=0;for(let ae=G;ae!==0;ae=ae>>>7)ie++;const se=U.VSBuffer.alloc(ie);for(let ae=0;G!==0;ae++)se.buffer[ae]=G&127,G=G>>>7,G>0&&(se.buffer[ae]|=128);x.write(se)}class A{constructor(G){this.b=G,this.a=0}read(G){const ie=this.b.slice(this.a,this.a+G);return this.a+=ie.byteLength,ie}}t.BufferReader=A;class m{constructor(){this.a=[]}get buffer(){return U.VSBuffer.concat(this.a)}write(G){this.a.push(G)}}t.BufferWriter=m;var C;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(C||(C={}));function N(x){const G=U.VSBuffer.alloc(1);return G.writeUInt8(x,0),G}const L={Undefined:N(C.Undefined),String:N(C.String),Buffer:N(C.Buffer),VSBuffer:N(C.VSBuffer),Array:N(C.Array),Object:N(C.Object),Uint:N(C.Int)},d=typeof Buffer<"u";function v(x,G){if(typeof G>"u")x.write(L.Undefined);else if(typeof G=="string"){const ie=U.VSBuffer.fromString(G);x.write(L.String),T(x,ie.byteLength),x.write(ie)}else if(d&&Buffer.isBuffer(G)){const ie=U.VSBuffer.wrap(G);x.write(L.Buffer),T(x,ie.byteLength),x.write(ie)}else if(G instanceof U.VSBuffer)x.write(L.VSBuffer),T(x,G.byteLength),x.write(G);else if(Array.isArray(G)){x.write(L.Array),T(x,G.length);for(const ie of G)v(x,ie)}else if(typeof G=="number"&&(G|0)===G)x.write(L.Uint),T(x,G);else{const ie=U.VSBuffer.fromString(JSON.stringify(G));x.write(L.Object),T(x,ie.byteLength),x.write(ie)}}t.serialize=v;function b(x){switch(x.read(1).readUInt8(0)){case C.Undefined:return;case C.String:return x.read(h(x)).toString();case C.Buffer:return x.read(h(x)).buffer;case C.VSBuffer:return x.read(h(x));case C.Array:{const ie=h(x),se=[];for(let ae=0;ae<ie;ae++)se.push(b(x));return se}case C.Object:return JSON.parse(x.read(h(x)).toString());case C.Int:return h(x)}}t.deserialize=b;class y{constructor(G,ie,se=null,ae=1e3){this.h=G,this.j=ie,this.k=se,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(G,ie){this.b.set(G,ie),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const ie=this.o([G.type]);this.k?.logOutgoing(ie,0,1,r(G.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([G.type,G.id],G.data);this.k?.logOutgoing(ie,G.id,1,r(G.type),G.data);return}}}o(G,ie=void 0){const se=new m;return v(se,G),v(se,ie),this.p(se.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const ie=new A(G),se=b(ie),ae=b(ie),te=se[0];switch(te){case 100:return this.k?.logIncoming(G.byteLength,se[1],1,`${e(te)}: ${se[2]}.${se[3]}`,ae),this.s({type:te,id:se[1],channelName:se[2],name:se[3],arg:ae});case 102:return this.k?.logIncoming(G.byteLength,se[1],1,`${e(te)}: ${se[2]}.${se[3]}`,ae),this.t({type:te,id:se[1],channelName:se[2],name:se[3],arg:ae});case 101:return this.k?.logIncoming(G.byteLength,se[1],1,`${e(te)}`),this.u({type:te,id:se[1]});case 103:return this.k?.logIncoming(G.byteLength,se[1],1,`${e(te)}`),this.u({type:te,id:se[1]})}}s(G){const ie=this.b.get(G.channelName);if(!ie){this.v(G);return}const se=new i.CancellationTokenSource;let ae;try{ae=ie.call(this.j,G.name,G.arg,se.token)}catch(g){ae=Promise.reject(g)}const te=G.id;ae.then(g=>{this.m({id:te,data:g,type:201}),this.d.delete(G.id)},g=>{g instanceof Error?this.m({id:te,data:{message:g.message,name:g.name,stack:g.stack?g.stack.split?g.stack.split(`
`):g.stack:void 0},type:202}):this.m({id:te,data:g,type:203}),this.d.delete(G.id)});const $=(0,u.toDisposable)(()=>se.cancel());this.d.set(G.id,$)}t(G){const ie=this.b.get(G.channelName);if(!ie){this.v(G);return}const se=G.id,te=ie.listen(this.j,G.name,G.arg)($=>this.m({id:se,data:$,type:204}));this.d.set(G.id,te)}u(G){const ie=this.d.get(G.id);ie&&(ie.dispose(),this.d.delete(G.id))}v(G){let ie=this.g.get(G.channelName);ie||(ie=[],this.g.set(G.channelName,ie));const se=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:G,timeoutTimer:se})}w(G){const ie=this.g.get(G);if(ie){for(const se of ie)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=y;var R;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(R=t.RequestInitiator||(t.RequestInitiator={}));class V{constructor(G,ie=null){this.l=G,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=ie}getChannel(G){const ie=this;return{call(se,ae,te){return ie.a?Promise.reject(new w.CancellationError):ie.m(G,se,ae,te)},listen(se,ae){return ie.a?f.Event.None:ie.o(G,se,ae)}}}m(G,ie,se,ae=i.CancellationToken.None){const te=this.g++,g={id:te,type:100,channelName:G,name:ie,arg:se};if(ae.isCancellationRequested)return Promise.reject(new w.CancellationError);let l;return new Promise((W,j)=>{if(ae.isCancellationRequested)return j(new w.CancellationError);const F=()=>{const B=H=>{switch(H.type){case 201:this.f.delete(te),W(H.data);break;case 202:{this.f.delete(te);const z=new Error(H.data.message);z.stack=Array.isArray(H.data.stack)?H.data.stack.join(`
`):H.data.stack,z.name=H.data.name,j(z);break}case 203:this.f.delete(te),j(H.data);break}};this.f.set(te,B),this.p(g)};let I=null;this.b===a.Idle?F():(I=(0,P.createCancelablePromise)(B=>this.u()),I.then(()=>{I=null,F()}));const O=()=>{I?(I.cancel(),I=null):this.p({id:te,type:101}),j(new w.CancellationError)},S=ae.onCancellationRequested(O);l=(0,u.combinedDisposable)((0,u.toDisposable)(O),S),this.d.add(l)}).finally(()=>{this.d.delete(l)})}o(G,ie,se){const ae=this.g++,$={id:ae,type:102,channelName:G,name:ie,arg:se};let g=null;const l=new f.Emitter({onWillAddFirstListener:()=>{g=(0,P.createCancelablePromise)(W=>this.u()),g.then(()=>{g=null,this.d.add(l),this.p($)})},onDidRemoveLastListener:()=>{g?(g.cancel(),g=null):(this.d.delete(l),this.p({id:ae,type:103}))}}),k=W=>l.fire(W.data);return this.f.set(ae,k),l.event}p(G){switch(G.type){case 100:case 102:{const ie=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(ie,G.id,0,`${e(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const ie=this.q([G.type,G.id]);this.j?.logOutgoing(ie,G.id,0,e(G.type));return}}}q(G,ie=void 0){const se=new m;return v(se,G),v(se,ie),this.r(se.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const ie=new A(G),se=b(ie),ae=b(ie),te=se[0];switch(te){case 200:return this.j?.logIncoming(G.byteLength,0,0,r(te)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,se[1],0,r(te),ae),this.t({type:se[0],id:se[1],data:ae})}}t(G){if(G.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.dispose)(this.d.values()),this.d.clear()}}Ve([D.memoize],V.prototype,"onDidInitializePromise",null),t.ChannelClient=V;class ee{get connections(){const G=[];return this.f.forEach(ie=>G.push(ie)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,G(({protocol:ie,onDidClientDisconnect:se})=>{f.Event.once(ie.onMessage)(te=>{const $=new A(te),g=b($),l=new y(ie,g),k=new V(ie);this.a.forEach((j,F)=>l.registerChannel(F,j));const W={channelServer:l,channelClient:k,ctx:g};this.f.add(W),this.g.fire(W),se(()=>{l.dispose(),k.dispose(),this.f.delete(W),this.h.fire(W)})})})}getChannel(G,ie){const se=this;return{call(ae,te,$){let g;if((0,o.isFunction)(ie)){const k=(0,E.getRandomElement)(se.connections.filter(ie));g=k?Promise.resolve(k):f.Event.toPromise(f.Event.filter(se.onDidAddConnection,ie))}else g=ie.routeCall(se,ae,te);const l=g.then(k=>k.channelClient.getChannel(G));return J(l).call(ae,te,$)},listen(ae,te){if((0,o.isFunction)(ie))return se.j(G,ie,ae,te);const $=ie.routeEvent(se,ae,te).then(g=>g.channelClient.getChannel(G));return J($).listen(ae,te)}}}j(G,ie,se,ae){const te=this;let $=new u.DisposableStore;const g=new f.Emitter({onWillAddFirstListener:()=>{$=new u.DisposableStore;const l=new f.EventMultiplexer,k=new Map,W=F=>{const O=F.channelClient.getChannel(G).listen(se,ae),S=l.add(O);k.set(F,S)},j=F=>{const I=k.get(F);!I||(I.dispose(),k.delete(F))};te.connections.filter(ie).forEach(W),f.Event.filter(te.onDidAddConnection,ie)(W,void 0,$),te.onDidRemoveConnection(j,void 0,$),l.event(g.fire,g,$),$.add(l)},onDidRemoveLastListener:()=>{$.dispose()}});return g.event}registerChannel(G,ie){this.a.set(G,ie),this.f.forEach(se=>{se.channelServer.registerChannel(G,ie)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=ee;class Z{constructor(G,ie,se=null){const ae=new m;v(ae,ie),G.send(ae.buffer),this.a=new V(G,se),this.d=new y(G,ie,se)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,ie){this.d.registerChannel(G,ie)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=Z;function J(x){return{call(G,ie,se){return x.then(ae=>ae.call(G,ie,se))},listen(G,ie){const se=new f.Relay;return x.then(ae=>se.input=ae.listen(G,ie)),se.event}}}t.getDelayedChannel=J;function re(x){let G=!1;return{call(ie,se,ae){return G?x.call(ie,se,ae):(0,P.timeout)(0).then(()=>G=!0).then(()=>x.call(ie,se,ae))},listen(ie,se){if(G)return x.listen(ie,se);const ae=new f.Relay;return(0,P.timeout)(0).then(()=>G=!0).then(()=>ae.input=x.listen(ie,se)),ae.event}}}t.getNextTickChannel=re;class he{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const ie of G.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await f.Event.toPromise(G.onDidAddConnection),await this.b(G)}}t.StaticRouter=he;var de;(function(x){function G(te,$){const g=te,l=$&&$.disableMarshalling,k=new Map;for(const W in g)se(W)&&k.set(W,f.Event.buffer(g[W],!0));return new class{listen(W,j,F){const I=k.get(j);if(I)return I;if(ae(j)){const O=g[j];if(typeof O=="function")return O.call(g,F)}throw new Error(`Event not found: ${j}`)}call(W,j,F){const I=g[j];if(typeof I=="function"){if(!l&&Array.isArray(F))for(let O=0;O<F.length;O++)F[O]=(0,c.revive)(F[O]);return I.apply(g,F)}throw new Error(`Method not found: ${j}`)}}}x.fromService=G;function ie(te,$){const g=$&&$.disableMarshalling;return new Proxy({},{get(l,k){if(typeof k=="string")return $?.properties?.has(k)?$.properties.get(k):ae(k)?function(W){return te.listen(k,W)}:se(k)?te.listen(k):async function(...W){let j;$&&!(0,o.isUndefinedOrNull)($.context)?j=[$.context,...W]:j=W;const F=await te.call(k,j);return g?F:(0,c.revive)(F)};throw new Error(`Property not found: ${String(k)}`)}})}x.toService=ie;function se(te){return te[0]==="o"&&te[1]==="n"&&M.isUpperAsciiLetter(te.charCodeAt(2))}function ae(te){return/^onDynamic/.test(te)&&M.isUpperAsciiLetter(te.charCodeAt(9))}})(de=t.ProxyChannel||(t.ProxyChannel={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function pe(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const G=x.toString();if(G!=="[object Object]")return G}return x}function Te(x){return Array.isArray(x)?x.map(pe):pe(x)}function Pe(x,G,ie,se,ae,te,$){$=Te($);const g=ce[ae],l=g[se%g.length];let k=[`%c[${x}]%c[${String(G).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${l}`];/\($/.test(te)?(k=k.concat($),k.push(")")):k.push($),console.log.apply(console,k)}class Oe{constructor(G,ie){this.d=G,this.f=ie,this.a=0,this.b=0}logOutgoing(G,ie,se,ae,te){this.b+=G,Pe(this.d,this.b,G,ie,se,ae,te)}logIncoming(G,ie,se,ae,te){this.a+=G,Pe(this.f,this.a,G,ie,se,ae,te)}}t.IPCLogger=Oe}),define(ge[28],me([1,0,5]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=E.globals.vscode.ipcRenderer,t.ipcMessagePort=E.globals.vscode.ipcMessagePort,t.webFrame=E.globals.vscode.webFrame,t.process=E.globals.vscode.process,t.context=E.globals.vscode.context}),define(ge[130],me([1,0,81,28]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let U=0;function i(w,f,u){const c=[],M=U++,o=`vscode:onContextMenu${M}`,n=(e,s,r)=>{c[s].click?.(r)};P.ipcRenderer.once(o,n),P.ipcRenderer.once(E.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===M&&(P.ipcRenderer.removeListener(o,n),u?.())}),P.ipcRenderer.send(E.CONTEXT_MENU_CHANNEL,M,w.map(e=>D(e,c)),o,f)}t.popup=i;function D(w,f){const u={id:f.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return f.push(w),Array.isArray(w.submenu)&&(u.submenu=w.submenu.map(c=>D(c,f))),u}}),define(ge[131],me([1,0,29,3,37,82,28]),function(Q,t,E,P,U,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends U.IPCClient{static f(){const u=P.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:message",(c,M)=>E.VSBuffer.wrap(M));return D.ipcRenderer.send("vscode:hello"),new i.Protocol(D.ipcRenderer,u)}constructor(u){const c=w.f();super(c,u),this.b=c}dispose(){this.b.disconnect()}}t.Client=w}),define(ge[132],me([12,10]),function(Q,t){return Q.create("vs/platform/files/common/files",t)}),define(ge[133],me([12,10]),function(Q,t){return Q.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[65],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class E{constructor(U,i=[],D=!1){this.ctor=U,this.staticArguments=i,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=E}),define(ge[134],me([1,0,65]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const P=[];var U;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(U=t.InstantiationType||(t.InstantiationType={}));function i(w,f,u){f instanceof E.SyncDescriptor||(f=new E.SyncDescriptor(f,[],Boolean(u))),P.push([w,f])}t.registerSingleton=i;function D(){return P}t.getSingletonServiceDescriptors=D}),define(ge[38],me([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function w(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=w})(E=t._util||(t._util={})),t.IInstantiationService=U("instantiationService");function P(D,w,f){w[E.DI_TARGET]===w?w[E.DI_DEPENDENCIES].push({id:D,index:f}):(w[E.DI_DEPENDENCIES]=[{id:D,index:f}],w[E.DI_TARGET]=w)}function U(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const w=function(f,u,c){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(w,f,c)};return w.toString=()=>D,E.serviceIds.set(D,w),w}t.createDecorator=U;function i(D){return D}t.refineServiceDecorator=i}),define(ge[135],me([1,0,38]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,E.createDecorator)(t.ID);function P(i){return!!i.hostName&&!!i.errorMessage}t.isRemoteDiagnosticError=P;class U{async getPerformanceInfo(D,w){return{}}async getSystemInfo(D,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,w){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}t.NullDiagnosticsService=U}),define(ge[136],me([1,0,113,22,11,6,15,132,38,5]),function(Q,t,E,P,U,i,D,w,f,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLargeFileConfirmationLimit=t.getPlatformFileLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,f.createDecorator)("fileService");function c(x){return x.create===!0}t.isFileOpenForWriteOptions=c;var M;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(M=t.FileType||(t.FileType={}));var o;(function(x){x[x.Readonly=1]="Readonly"})(o=t.FilePermission||(t.FilePermission={}));var n;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileClone=32768]="FileClone"})(n=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function e(x){return!!(x.capabilities&2)}t.hasReadWriteCapability=e;function s(x){return!!(x.capabilities&8)}t.hasFileFolderCopyCapability=s;function r(x){return!!(x.capabilities&32768)}t.hasFileCloneCapability=r;function a(x){return!!(x.capabilities&4)}t.hasOpenReadWriteCloseCapability=a;function h(x){return!!(x.capabilities&16)}t.hasFileReadStreamCapability=h;function p(x){return e(x)?!!(x.capabilities&16384):!1}t.hasFileAtomicReadCapability=p;var T;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(T=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class A extends Error{constructor(G,ie){super(G),this.code=ie}}t.FileSystemProviderError=A;function m(x,G){const ie=new A(x.toString(),G);return N(ie,G),ie}t.createFileSystemProviderError=m;function C(x){return x||m((0,w.localize)(0,null),T.Unknown)}t.ensureFileSystemProviderError=C;function N(x,G){return x.name=G?`${G} (FileSystemError)`:"FileSystemError",x}t.markAsFileSystemProviderError=N;function L(x){if(!x)return T.Unknown;if(x instanceof A)return x.code;const G=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!G)return T.Unknown;switch(G[1]){case T.FileExists:return T.FileExists;case T.FileIsADirectory:return T.FileIsADirectory;case T.FileNotADirectory:return T.FileNotADirectory;case T.FileNotFound:return T.FileNotFound;case T.FileExceedsMemoryLimit:return T.FileExceedsMemoryLimit;case T.FileTooLarge:return T.FileTooLarge;case T.FileWriteLocked:return T.FileWriteLocked;case T.NoPermissions:return T.NoPermissions;case T.Unavailable:return T.Unavailable}return T.Unknown}t.toFileSystemProviderErrorCode=L;function d(x){if(x instanceof ee)return x.fileOperationResult;switch(L(x)){case T.FileNotFound:return 1;case T.FileIsADirectory:return 0;case T.FileNotADirectory:return 10;case T.FileWriteLocked:return 5;case T.NoPermissions:return 6;case T.FileExists:return 4;case T.FileExceedsMemoryLimit:return 9;case T.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=d;var v;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(v=t.FileOperation||(t.FileOperation={}));class b{constructor(G,ie,se){this.resource=G,this.operation=ie,this.target=se}isOperation(G){return this.operation===G}}t.FileOperationEvent=b;var y;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(y=t.FileChangeType||(t.FileChangeType={}));class R{constructor(G,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const ae of G){const te=se.get(ae.type);switch(te?te.push([ae.resource,ae]):se.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,te]of se)switch(ae){case 1:this.a=E.TernarySearchTree.forUris(()=>ie),this.a.fill(te);break;case 0:this.b=E.TernarySearchTree.forUris(()=>ie),this.b.fill(te);break;case 2:this.c=E.TernarySearchTree.forUris(()=>ie),this.c.fill(te);break}}contains(G,...ie){return this.d(G,{includeChildren:!1},...ie)}affects(G,...ie){return this.d(G,{includeChildren:!0},...ie)}d(G,ie,...se){if(!G)return!1;const ae=se.length>0;return!!((!ae||se.includes(1))&&(this.a?.get(G)||ie.includeChildren&&this.a?.findSuperstr(G))||(!ae||se.includes(0))&&(this.b?.get(G)||ie.includeChildren&&this.b?.findSuperstr(G))||(!ae||se.includes(2))&&(this.c?.findSubstr(G)||ie.includeChildren&&this.c?.findSuperstr(G)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=R;function V(x,G,ie){return!x||!G||x===G||G.length>x.length?!1:(G.charAt(G.length-1)!==P.sep&&(G+=P.sep),ie?(0,U.startsWithIgnoreCase)(x,G):x.indexOf(G)===0)}t.isParent=V;class ee extends Error{constructor(G,ie,se){super(G),this.fileOperationResult=ie,this.options=se}}t.FileOperationError=ee;class Z extends ee{constructor(G,ie,se,ae){super(G,ie,ae),this.fileOperationResult=ie,this.size=se}}t.TooLargeFileOperationError=Z;class J extends ee{constructor(G,ie,se){super(G,2,se),this.stat=ie}}t.NotModifiedSinceFileOperationError=J;var re;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(re=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var he;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(he=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function de(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}t.etag=de;async function ce(x,G){if(!G.hasProvider(D.URI.from({scheme:x.scheme})))return new Promise(ie=>{const se=G.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===x.scheme&&ae.added&&(se.dispose(),ie())})})}t.whenProviderRegistered=ce,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class pe{static formatSize(G){return(0,i.isNumber)(G)||(G=0),G<pe.KB?(0,w.localize)(1,null,G.toFixed(0)):G<pe.MB?(0,w.localize)(2,null,(G/pe.KB).toFixed(2)):G<pe.GB?(0,w.localize)(3,null,(G/pe.MB).toFixed(2)):G<pe.TB?(0,w.localize)(4,null,(G/pe.GB).toFixed(2)):(0,w.localize)(5,null,(G/pe.TB).toFixed(2))}}t.ByteSize=pe,pe.KB=1024,pe.MB=pe.KB*pe.KB,pe.GB=pe.MB*pe.KB,pe.TB=pe.GB*pe.KB;var Te;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(Te=t.Arch||(t.Arch={}));function Pe(x){return{maxFileSize:x===0?300*pe.MB:16*pe.GB,maxHeapSize:x===0?700*pe.MB:2*700*pe.MB}}t.getPlatformFileLimits=Pe;function Oe(x){return u.isWeb?x?10*pe.MB:50*pe.MB:x?100*pe.MB:1024*pe.MB}t.getLargeFileConfirmationLimit=Oe}),define(ge[137],me([1,0,2,131]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class U extends E.Disposable{constructor(D){super(),this.a=this.B(new P.Client(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,w){this.a.registerChannel(D,w)}}t.ElectronIPCMainProcessService=U});var pt=this&&this.__param||function(Q,t){return function(E,P){t(E,P,Q)}};define(ge[138],me([1,0,37,65,134,38]),function(Q,t,E,P,U,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class D{constructor(n,e,s,r){const a=s.getChannel(n);return w(e)?r.createInstance(new P.SyncDescriptor(e.channelClientCtor,[a])):E.ProxyChannel.toService(a,e?.proxyOptions)}}function w(o){return!!o?.channelClientCtor}t.IMainProcessService=(0,i.createDecorator)("mainProcessService");let f=class extends D{constructor(n,e,s,r){super(n,e,s,r)}};f=Ve([pt(2,t.IMainProcessService),pt(3,i.IInstantiationService)],f);function u(o,n,e){(0,U.registerSingleton)(o,new P.SyncDescriptor(f,[n,e],!0))}t.registerMainProcessRemoteService=u,t.ISharedProcessService=(0,i.createDecorator)("sharedProcessService");let c=class extends D{constructor(n,e,s,r){super(n,e,s,r)}};c=Ve([pt(2,t.ISharedProcessService),pt(3,i.IInstantiationService)],c);function M(o,n,e){(0,U.registerSingleton)(o,new P.SyncDescriptor(c,[n,e],!0))}t.registerSharedProcessRemoteService=M}),define(ge[139],me([1,0,37,138]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let U=class{constructor(D,w){return this.windowId=D,E.ProxyChannel.toService(w.getChannel("nativeHost"),{context:D,properties:(()=>{const f=new Map;return f.set("windowId",D),f})()})}};U=Ve([pt(1,P.IMainProcessService)],U),t.NativeHostService=U}),define(ge[66],me([1,0,72,6]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class U{constructor(){this.a=new Map}add(D,w){E.ok(P.isString(D)),E.ok(P.isObject(w)),E.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,w)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}t.Registry=new U}),define(ge[140],me([1,0,3,66]),function(Q,t,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function U(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class i{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,u){this.a[U(f)]=u,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new i;P.Registry.add(t.Extensions.JSONContribution,D)}),define(ge[141],me([1,0,9,16,17,3,6,15,133,140,66]),function(Q,t,E,P,U,i,D,w,f,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var M;(function(T){function A(m,C){let N=m.defaults;for(;U.ThemeIcon.isThemeIcon(N);){const L=e.getIcon(N.id);if(!L)return;N=L.defaults}return N}T.getDefinition=A})(M=t.IconContribution||(t.IconContribution={}));var o;(function(T){function A(C){return{weight:C.weight,style:C.style,src:C.src.map(N=>({format:N.format,location:N.location.toString()}))}}T.toJSONObject=A;function m(C){const N=L=>(0,D.isString)(L)?L:void 0;if(C&&Array.isArray(C.src)&&C.src.every(L=>(0,D.isString)(L.format)&&(0,D.isString)(L.location)))return{weight:N(C.weight),style:N(C.style),src:C.src.map(L=>({format:L.format,location:w.URI.parse(L.location)}))}}T.fromJSONObject=m})(o=t.IconFontDefinition||(t.IconFontDefinition={}));class n{constructor(){this.a=new i.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${U.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(A,m,C,N){const L=this.b[A];if(L){if(C&&!L.description){L.description=C,this.d.properties[A].markdownDescription=`${C} $(${A})`;const b=this.e.enum.indexOf(A);b!==-1&&(this.e.enumDescriptions[b]=C),this.a.fire()}return L}const d={id:A,description:C,defaults:m,deprecationMessage:N};this.b[A]=d;const v={$ref:"#/definitions/icons"};return N&&(v.deprecationMessage=N),C&&(v.markdownDescription=`${C}: $(${A})`),this.d.properties[A]=v,this.e.enum.push(A),this.e.enumDescriptions.push(C||""),this.a.fire(),{id:A}}deregisterIcon(A){delete this.b[A],delete this.d.properties[A];const m=this.e.enum.indexOf(A);m!==-1&&(this.e.enum.splice(m,1),this.e.enumDescriptions.splice(m,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(A=>this.b[A])}getIcon(A){return this.b[A]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(A,m){const C=this.f[A];return C||(this.f[A]=m,this.a.fire(),m)}deregisterIconFont(A){delete this.f[A]}getIconFont(A){return this.f[A]}toString(){const A=(L,d)=>L.id.localeCompare(d.id),m=L=>{for(;U.ThemeIcon.isThemeIcon(L.defaults);)L=this.b[L.defaults.id];return`codicon codicon-${L?L.id:""}`},C=[];C.push("| preview     | identifier                        | default codicon ID                | description"),C.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const N=Object.keys(this.b).map(L=>this.b[L]);for(const L of N.filter(d=>!!d.description).sort(A))C.push(`|<i class="${m(L)}"></i>|${L.id}|${U.ThemeIcon.isThemeIcon(L.defaults)?L.defaults.id:L.id}|${L.description||""}|`);C.push("| preview     | identifier                        "),C.push("| ----------- | --------------------------------- |");for(const L of N.filter(d=>!U.ThemeIcon.isThemeIcon(d.defaults)).sort(A))C.push(`|<i class="${m(L)}"></i>|${L.id}|`);return C.join(`
`)}}const e=new n;c.Registry.add(t.Extensions.IconContribution,e);function s(T,A,m,C){return e.registerIcon(T,A,m,C)}t.registerIcon=s;function r(){return e}t.getIconRegistry=r;function a(){const T=(0,P.getCodiconFontCharacters)();for(const A in T){const m="\\"+T[A].toString(16);e.registerIcon(A,{fontCharacter:m})}}a(),t.iconsSchemaId="vscode://schemas/icons";const h=c.Registry.as(u.Extensions.JSONContribution);h.registerSchema(t.iconsSchemaId,e.getIconSchema());const p=new E.RunOnceScheduler(()=>h.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{p.isScheduled()||p.schedule()}),t.widgetClose=s("widget-close",P.Codicon.close,(0,f.localize)(2,null)),t.gotoPreviousLocation=s("goto-previous-location",P.Codicon.arrowUp,(0,f.localize)(3,null)),t.gotoNextLocation=s("goto-next-location",P.Codicon.arrowDown,(0,f.localize)(4,null)),t.syncing=U.ThemeIcon.modify(P.Codicon.sync,"spin"),t.spinningLoading=U.ThemeIcon.modify(P.Codicon.loading,"spin")}),define(ge[142],me([1,0,4,3,17,141]),function(Q,t,E,P,U,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function D(f){const u=new P.Emitter,c=(0,i.getIconRegistry)();return c.onDidChange(()=>u.fire()),f?.onDidProductIconThemeChange(()=>u.fire()),{onDidChange:u.event,getCSS(){const M=f?f.getProductIconTheme():new w,o={},n=s=>{const r=M.getIcon(s);if(!r)return;const a=r.font;return a?(o[a.id]=a.definition,`.codicon-${s.id}:before { content: '${r.fontCharacter}'; font-family: ${(0,E.asCSSPropertyValue)(a.id)}; }`):`.codicon-${s.id}:before { content: '${r.fontCharacter}'; }`},e=[];for(const s of c.getIcons()){const r=n(s);r&&e.push(r)}for(const s in o){const r=o[s],a=r.weight?`font-weight: ${r.weight};`:"",h=r.style?`font-style: ${r.style};`:"",p=r.src.map(T=>`${(0,E.asCSSUrl)(T.location)} format('${T.format}')`).join(", ");e.push(`@font-face { src: ${p}; font-family: ${(0,E.asCSSPropertyValue)(s)};${a}${h} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=D;class w{getIcon(u){const c=(0,i.getIconRegistry)();let M=u.defaults;for(;U.ThemeIcon.isThemeIcon(M);){const o=c.getIcon(M.id);if(!o)return;M=o.defaults}return M}}t.UnthemedProductIconTheme=w}),define(ge[143],me([1,0,5]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function P(c){return!!c.workspaceUri}t.isWorkspaceToOpen=P;function U(c){return!!c.folderUri}t.isFolderToOpen=U;function i(c){return!!c.fileUri}t.isFileToOpen=i;function D(c){const M=w(c),o=c.getValue("window.menuBarVisibility");return o==="default"||M==="native"&&o==="compact"||E.isMacintosh&&E.isNative?"classic":o}t.getMenuBarVisibility=D;function w(c){if(E.isWeb)return"custom";const M=c.getValue("window");if(M){if(E.isMacintosh&&M.nativeTabs===!0||E.isMacintosh&&M.nativeFullScreen===!1)return"native";const e=M.titleBarStyle;if(e==="native"||e==="custom")return e}return E.isLinux?"native":"custom"}t.getTitleBarStyle=w;function f(c){if(!E.isWindows||E.isWeb||w(c)==="native")return!1;const M=c.getValue("window.experimental.windowControlsOverlay.enabled");return typeof M=="boolean"?M:!0}t.useWindowControlsOverlay=f;function u(c=0){return Math.pow(1.2,c)}t.zoomLevelToZoomFactor=u}),define(ge[144],me([1,0,18,28,143]),function(Q,t,E,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function i(f){P.webFrame.setZoomLevel(f),(0,E.setZoomFactor)((0,U.zoomLevelToZoomFactor)(f)),(0,E.setZoomLevel)(f,!1)}t.applyZoom=i;function D(){i((0,E.getZoomLevel)()+1)}t.zoomIn=D;function w(){i((0,E.getZoomLevel)()-1)}t.zoomOut=w}),define(ge[145],me([1,0,10,4,129,9,130,28,135,136,137,139,142,144,14,95,86]),function(Q,t,E,P,U,i,D,w,f,u,c,M,o,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const s=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,r=/\s--inspect-port=(?<port>\d+)/;class a{getHeight(R){return 22}getTemplateId(R){return L(R)?"process":C(R)?"machine":(0,f.isRemoteDiagnosticError)(R)?"error":N(R)?"header":""}}class h{hasChildren(R){return(0,f.isRemoteDiagnosticError)(R)?!1:L(R)?!!R.children?.length:!0}getChildren(R){return L(R)?R.children?R.children:[]:(0,f.isRemoteDiagnosticError)(R)?[]:N(R)?R.processRoots.length>1?R.processRoots:[R.processRoots[0].rootProcess]:C(R)?[R.rootProcess]:[R.processes]}}class p{constructor(){this.templateId="header"}renderTemplate(R){const V=Object.create(null),ee=(0,P.append)(R,(0,P.$)(".row"));return V.name=(0,P.append)(ee,(0,P.$)(".nameLabel")),V.CPU=(0,P.append)(ee,(0,P.$)(".cpu")),V.memory=(0,P.append)(ee,(0,P.$)(".memory")),V.PID=(0,P.append)(ee,(0,P.$)(".pid")),V}renderElement(R,V,ee,Z){ee.name.textContent=(0,E.localize)(0,null),ee.CPU.textContent=(0,E.localize)(1,null),ee.PID.textContent=(0,E.localize)(2,null),ee.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(R){}}class T{constructor(){this.templateId="machine"}renderTemplate(R){const V=Object.create(null),ee=(0,P.append)(R,(0,P.$)(".row"));return V.name=(0,P.append)(ee,(0,P.$)(".nameLabel")),V}renderElement(R,V,ee,Z){ee.name.textContent=R.element.name}disposeTemplate(R){}}class A{constructor(){this.templateId="error"}renderTemplate(R){const V=Object.create(null),ee=(0,P.append)(R,(0,P.$)(".row"));return V.name=(0,P.append)(ee,(0,P.$)(".nameLabel")),V}renderElement(R,V,ee,Z){ee.name.textContent=R.element.errorMessage}disposeTemplate(R){}}class m{constructor(R,V,ee){this.a=R,this.b=V,this.c=ee,this.templateId="process"}renderTemplate(R){const V=Object.create(null),ee=(0,P.append)(R,(0,P.$)(".row"));return V.name=(0,P.append)(ee,(0,P.$)(".nameLabel")),V.CPU=(0,P.append)(ee,(0,P.$)(".cpu")),V.memory=(0,P.append)(ee,(0,P.$)(".memory")),V.PID=(0,P.append)(ee,(0,P.$)(".pid")),V}renderElement(R,V,ee,Z){const{element:J}=R;let re=J.name;re==="window"&&(re=this.c.get(J.pid)!==void 0?`${re} (${this.c.get(J.pid)})`:re);const he=J.pid.toFixed(0);ee.name.textContent=re,ee.name.title=J.cmd,ee.CPU.textContent=J.load.toFixed(0),ee.PID.textContent=he,ee.PID.parentElement.id=`pid-${he}`;const de=this.a==="win32"?J.mem:this.b*(J.mem/100);ee.memory.textContent=(de/u.ByteSize.MB).toFixed(0)}disposeTemplate(R){}}function C(y){return!!y.name&&!!y.rootProcess}function N(y){return!!y.processRoots}function L(y){return!!y.pid}class d{constructor(R,V){this.f=V,this.b=new Map;const ee=new c.ElectronIPCMainProcessService(R);this.c=new M.NativeHostService(R,ee),this.k(V.styles),this.g(V),w.ipcRenderer.on("vscode:windowsInfoResponse",(Z,J)=>{this.b=new Map,J.forEach(re=>this.b.set(re.pid,re.title))}),w.ipcRenderer.on("vscode:listProcessesResponse",async(Z,J)=>{J.forEach((re,he)=>{L(re.rootProcess)&&(re.rootProcess.name=he===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:J}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(J),this.m(0)}),this.a=Date.now(),w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")}g(R){document.onkeydown=V=>{const ee=R.platform==="darwin"?V.metaKey:V.ctrlKey;ee&&V.keyCode===87&&(V.stopPropagation(),V.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),ee&&V.keyCode===187&&(0,n.zoomIn)(),ee&&V.keyCode===189&&(0,n.zoomOut)()}}async h(R){const V=document.getElementById("process-list");if(!V)return;const{totalmem:ee}=await this.c.getOSStatistics(),Z=[new m(this.f.platform,ee,this.b),new p,new T,new A];this.d=new U.DataTree("processExplorer",V,new a,Z,new h,{identityProvider:{getId:J=>L(J)?J.pid.toString():(0,f.isRemoteDiagnosticError)(J)?J.hostName:N(J)?"processes":C(J)?J.name:"header"}}),this.d.setInput({processes:{processRoots:R}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(J=>{const re=new e.StandardKeyboardEvent(J);if(re.keyCode===35&&re.altKey){const he=this.n();Promise.all(he.map(de=>this.c.killProcess(de,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(J=>{L(J.element)&&this.l(J.element,!0)}),V.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{V.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(R){const V=s.exec(R);return V&&V.groups.port!=="0"||R.indexOf("node ")>=0||R.indexOf("node.exe")>=0}j(R){const V={type:"node",request:"attach",name:`process ${R.pid}`};let ee=s.exec(R.cmd);ee?V.port=Number(ee.groups.port):V.processId=String(R.pid),ee=r.exec(R.cmd),ee&&(V.port=Number(ee.groups.port)),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[V]})}k(R){const V=(0,P.createStyleSheet)(),ee=[];R.listFocusBackground&&(ee.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${R.listFocusBackground}; }`),ee.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${R.listFocusBackground}; }`)),R.listFocusForeground&&ee.push(`.monaco-list:focus .monaco-list-row.focused { color: ${R.listFocusForeground}; }`),R.listActiveSelectionBackground&&(ee.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${R.listActiveSelectionBackground}; }`),ee.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${R.listActiveSelectionBackground}; }`)),R.listActiveSelectionForeground&&ee.push(`.monaco-list:focus .monaco-list-row.selected { color: ${R.listActiveSelectionForeground}; }`),R.listHoverBackground&&ee.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${R.listHoverBackground}; }`),R.listHoverForeground&&ee.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${R.listHoverForeground}; }`),R.listFocusOutline&&ee.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${R.listFocusOutline}; outline-offset: -1px; }`),R.listHoverOutline&&ee.push(`.monaco-list-row:hover { outline: 1px dashed ${R.listHoverOutline}; outline-offset: -1px; }`),R.scrollbarShadowColor&&ee.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${R.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),R.scrollbarSliderBackgroundColor&&ee.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${R.scrollbarSliderBackgroundColor};
				}
			`),R.scrollbarSliderHoverBackgroundColor&&ee.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${R.scrollbarSliderHoverBackgroundColor};
				}
			`),R.scrollbarSliderActiveBackgroundColor&&ee.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${R.scrollbarSliderActiveBackgroundColor};
				}
			`),V.textContent=ee.join(`
`),R.color&&(document.body.style.color=R.color)}l(R,V){const ee=[],Z=Number(R.pid);V&&(ee.push({label:(0,E.localize)(4,null),click:()=>{this.c.killProcess(Z,"SIGTERM")}}),ee.push({label:(0,E.localize)(5,null),click:()=>{this.c.killProcess(Z,"SIGKILL")}}),ee.push({type:"separator"})),ee.push({label:(0,E.localize)(6,null),click:()=>{const J=this.n();J?.includes(Z)||(J.length=0,J.push(Z));const re=J?.map(he=>document.getElementById(`pid-${he}`)).filter(he=>!!he);if(re){const he=re.map(de=>de.innerText).filter(de=>!!de);this.c.writeClipboardText(he.join(`
`))}}}),ee.push({label:(0,E.localize)(7,null),click:()=>{const J=document.getElementById("process-list");J&&this.c.writeClipboardText(J.innerText)}}),R&&V&&this.i(R.cmd)&&(ee.push({type:"separator"}),ee.push({label:(0,E.localize)(8,null),click:()=>{this.j(R)}})),(0,D.popup)(ee)}m(R){setTimeout(()=>{const V=Date.now(),ee=R+V-this.a;this.a=V,ee>1e3?(w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.m(ee)},200)}n(){return this.d?.getSelection()?.map(R=>{if(!(!R||!("pid"in R)))return R.pid}).filter(R=>!!R)}}function v(){const y=(0,P.createStyleSheet)();y.id="codiconStyles";const R=(0,o.getIconsStyleSheet)(void 0);function V(){y.textContent=R.getCSS()}const ee=new i.RunOnceScheduler(V,0);R.onDidChange(()=>ee.schedule()),ee.schedule()}function b(y){const R=y.data.platform==="win32"?"windows":y.data.platform==="linux"?"linux":"mac";document.body.classList.add(R),v(),(0,n.applyZoom)(y.data.zoomLevel),new d(y.windowId,y.data)}t.startup=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0e76dfa9095a62efe572ae1d215be7ce2a7f1f8e/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
