/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var e=[],N=0,D=x.length;N<D;N++)e[N]=Z[x[N]];return e};define(Z[49],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function N(O){return(w,g,c)=>{let S=null,p=null;if(typeof c.value=="function"?(S="value",p=c.value):typeof c.get=="function"&&(S="get",p=c.get),!p)throw new Error("not supported");c[S]=O(p,g)}}function D(O,w,g){let c=null,S=null;if(typeof g.value=="function"?(c="value",S=g.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(c="get",S=g.get),!S)throw new Error("not supported");const p=`$memoize$${w}`;g[c]=function(...h){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,h)}),this[p]}}e.memoize=D;function R(O,w,g){return N((c,S)=>{const p=`$debounce$${S}`,h=`$debounce$result$${S}`;return function(...k){this[h]||(this[h]=g?g():void 0),clearTimeout(this[p]),w&&(this[h]=w(this[h],...k),k=[this[h]]),this[p]=setTimeout(()=>{c.apply(this,k),this[h]=g?g():void 0},O)}})}e.debounce=R;function T(O,w,g){return N((c,S)=>{const p=`$throttle$timer$${S}`,h=`$throttle$result$${S}`,k=`$throttle$lastRun$${S}`,E=`$throttle$pending$${S}`;return function(...A){if(this[h]||(this[h]=g?g():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),w&&(this[h]=w(this[h],...A)),this[E])return;const d=this[k]+O;d<=Date.now()?(this[k]=Date.now(),c.apply(this,[this[h]]),this[h]=g?g():void 0):(this[E]=!0,this[p]=setTimeout(()=>{this[E]=!1,this[k]=Date.now(),c.apply(this,[this[h]]),this[h]=g?g():void 0},d-Date.now()))}})}e.throttle=T}),define(Z[70],Q([0,1,7]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function D(g,c){if(!g)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function R(g,c="Unreachable"){throw new Error(c)}e.assertNever=R;function T(g){if(!g)throw new N.BugIndicatingError("Assertion Failed")}e.assert=T;function O(g){if(!g()){debugger;g(),(0,N.onUnexpectedError)(new N.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function w(g,c){let S=0;for(;S<g.length-1;){const p=g[S],h=g[S+1];if(!c(p,h))return!1;S++}return!0}e.checkAdjacentItems=w}),define(Z[50],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(N=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function O(t,s=!1){let i=0;const n=t.length;let r="",o=0,a=16,u=0;function f(ne){let ae=0,ue=0;for(;ae<ne;){const re=t.charCodeAt(i);if(re>=48&&re<=57)ue=ue*16+re-48;else if(re>=65&&re<=70)ue=ue*16+re-65+10;else if(re>=97&&re<=102)ue=ue*16+re-97+10;else break;i++,ae++}return ae<ne&&(ue=-1),ue}function L(ne){i=ne,r="",o=0,a=16,u=0}function F(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return u=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else u=3;return t.substring(ne,ae)}function Y(){let ne="",ae=i;for(;;){if(i>=n){ne+=t.substring(ae,i),u=2;break}const ue=t.charCodeAt(i);if(ue===34){ne+=t.substring(ae,i),i++;break}if(ue===92){if(ne+=t.substring(ae,i),i++,i>=n){u=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const ge=f(4);ge>=0?ne+=String.fromCharCode(ge):u=4;break}default:u=5}ae=i;continue}if(ue>=0&&ue<=31)if(g(ue)){ne+=t.substring(ae,i),u=2;break}else u=6;i++}return ne}function J(){if(r="",u=0,o=i,i>=n)return o=n,a=17;let ne=t.charCodeAt(i);if(w(ne)){do i++,r+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(w(ne));return a=15}if(g(ne))return i++,r+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),a=14;switch(ne){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,r=Y(),a=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(t.charCodeAt(i));)i++;return r=t.substring(ae,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=n-1;let re=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,re=!0;break}i++}return re||(i++,u=1),r=t.substring(ae,i),a=13}return r+=String.fromCharCode(ne),i++,a=16}case 45:if(r+=String.fromCharCode(ne),i++,i===n||!c(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),a=11;default:for(;i<n&&ee(ne);)i++,ne=t.charCodeAt(i);if(o!==i){switch(r=t.substring(o,i),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(ne),i++,a=16}}function ee(ne){if(w(ne)||g(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=J();while(ne>=12&&ne<=15);return ne}return{setPosition:L,getPosition:()=>i,scan:s?ie:J,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>u}}e.createScanner=O;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var S;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(S||(S={}));function p(t,s){const i=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(f,L,F,Y){o.value=f,o.offset=L,o.length=F,o.type=Y,o.colonOffset=void 0,r=o}try{b(t,{onObjectBegin:(f,L)=>{if(s<=f)throw n;r=void 0,a=s>f,i.push("")},onObjectProperty:(f,L,F)=>{if(s<L||(u(f,L,F,"property"),i[i.length-1]=f,s<=L+F))throw n},onObjectEnd:(f,L)=>{if(s<=f)throw n;r=void 0,i.pop()},onArrayBegin:(f,L)=>{if(s<=f)throw n;r=void 0,i.push(0)},onArrayEnd:(f,L)=>{if(s<=f)throw n;r=void 0,i.pop()},onLiteralValue:(f,L,F)=>{if(s<L||(u(f,L,F,y(f)),s<=L+F))throw n},onSeparator:(f,L,F)=>{if(s<=L)throw n;if(f===":"&&r&&r.type==="property")r.colonOffset=L,a=!1,r=void 0;else if(f===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(a=!0,i[i.length-1]=""),r=void 0}}})}catch(f){if(f!==n)throw f}return{path:i,previousNode:r,isAtPropertyKey:a,matches:f=>{let L=0;for(let F=0;L<f.length&&F<i.length;F++)if(f[L]===i[F]||f[L]==="*")L++;else if(f[L]!=="**")return!1;return L===f.length}}}e.getLocation=p;function h(t,s=[],i=T.DEFAULT){let n=null,r=[];const o=[];function a(f){Array.isArray(r)?r.push(f):n!==null&&(r[n]=f)}return b(t,{onObjectBegin:()=>{const f={};a(f),o.push(r),r=f,n=null},onObjectProperty:f=>{n=f},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const f=[];a(f),o.push(r),r=f,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:a,onError:(f,L,F)=>{s.push({error:f,offset:L,length:F})}},i),r[0]}e.parse=h;function k(t,s=[],i=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(f){n.type==="property"&&(n.length=f-n.offset,n=n.parent)}function o(f){return n.children.push(f),f}b(t,{onObjectBegin:f=>{n=o({type:"object",offset:f,length:-1,parent:n,children:[]})},onObjectProperty:(f,L,F)=>{n=o({type:"property",offset:L,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:f,offset:L,length:F,parent:n})},onObjectEnd:(f,L)=>{n.length=f+L-n.offset,n=n.parent,r(f+L)},onArrayBegin:(f,L)=>{n=o({type:"array",offset:f,length:-1,parent:n,children:[]})},onArrayEnd:(f,L)=>{n.length=f+L-n.offset,n=n.parent,r(f+L)},onLiteralValue:(f,L,F)=>{o({type:y(f),offset:L,length:F,parent:n,value:f}),r(L+F)},onSeparator:(f,L,F)=>{n.type==="property"&&(f===":"?n.colonOffset=L:f===","&&r(L))},onError:(f,L,F)=>{s.push({error:f,offset:L,length:F})}},i);const u=n.children[0];return u&&delete u.parent,u}e.parseTree=k;function E(t,s){if(!t)return;let i=t;for(const n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=E;function A(t){if(!t.parent||!t.parent.children)return[];const s=A(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=A;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const s=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(s[i.children[0].value]=d(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=d;function l(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=l;function v(t,s,i=!1){if(l(t,s,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const o=v(n[r],s,i);if(o)return o}return t}}e.findNodeAtOffset=v;function b(t,s,i=T.DEFAULT){const n=O(t,!1);function r(q){return q?()=>q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(q){return q?X=>q(X,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=r(s.onObjectBegin),u=o(s.onObjectProperty),f=r(s.onObjectEnd),L=r(s.onArrayBegin),F=r(s.onArrayEnd),Y=o(s.onLiteralValue),J=o(s.onSeparator),ee=r(s.onComment),ie=o(s.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function ue(){for(;;){const q=n.scan();switch(n.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:ne||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(q){case 12:case 13:ne?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return q}}}function re(q,X=[],P=[]){if(ie(q),X.length+P.length>0){let I=n.getToken();for(;I!==17;){if(X.indexOf(I)!==-1){ue();break}else if(P.indexOf(I)!==-1)break;I=ue()}}}function ge(q){const X=n.getTokenValue();return q?Y(X):u(X),ue(),!0}function B(){switch(n.getToken()){case 11:{let q=0;try{q=JSON.parse(n.getTokenValue()),typeof q!="number"&&(re(2),q=0)}catch{re(2)}Y(q);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return ue(),!0}function j(){return n.getToken()!==10?(re(3,[],[2,5]),!1):(ge(!1),n.getToken()===6?(J(":"),ue(),W()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function M(){a(),ue();let q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(q||re(4,[],[]),J(","),ue(),n.getToken()===2&&ae)break}else q&&re(6,[],[]);j()||re(4,[],[2,5]),q=!0}return f(),n.getToken()!==2?re(7,[2],[]):ue(),!0}function V(){L(),ue();let q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(q||re(4,[],[]),J(","),ue(),n.getToken()===4&&ae)break}else q&&re(6,[],[]);W()||re(4,[],[4,5]),q=!0}return F(),n.getToken()!==4?re(8,[4],[]):ue(),!0}function W(){switch(n.getToken()){case 3:return V();case 1:return M();case 10:return ge(!0);default:return B()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(re(4,[],[]),!1):W()?(n.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.visit=b;function m(t,s){const i=O(t),n=[];let r,o=0,a;do switch(a=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==a&&n.push(t.substring(o,a)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),o=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=m;function y(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(Z[71],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function N(w,g,c){return Math.min(Math.max(w,g),c)}e.clamp=N;function D(w,g){return(g+w%g)%g}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=R;class T{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=T;class O{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const c=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=O}),function(){function x(R){const T=[];typeof R=="number"&&T.push("code/timeOrigin",R);function O(g){T.push(g,Date.now())}function w(){const g=[];for(let c=0;c<T.length;c+=2)g.push({name:T[c],startTime:T[c+1]});return g}return{mark:O,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const O of performance.getEntriesByType("mark"))T.push({name:O.name,startTime:Math.round(R+O.startTime)});return T}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function N(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=N(D))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var D in N)(typeof exports=="object"?exports:x)[D]=N[D]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function N(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return x[D].call(R.exports,R,R.exports,N),R.l=!0,R.exports}return N.m=x,N.c=e,N.d=function(D,R,T){N.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:T})},N.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},N.t=function(D,R){if(1&R&&(D=N(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var T=Object.create(null);if(N.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var O in D)N.d(T,O,function(w){return D[w]}.bind(null,O));return T},N.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return N.d(R,"a",R),R},N.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},N.p="",N(N.s=0)}([function(x,e,N){(function(D){var R;e=x.exports=P,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],g=e.src=[],c=0,S=c++;g[S]="0|[1-9]\\d*";var p=c++;g[p]="[0-9]+";var h=c++;g[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=c++;g[k]="("+g[S]+")\\.("+g[S]+")\\.("+g[S]+")";var E=c++;g[E]="("+g[p]+")\\.("+g[p]+")\\.("+g[p]+")";var A=c++;g[A]="(?:"+g[S]+"|"+g[h]+")";var d=c++;g[d]="(?:"+g[p]+"|"+g[h]+")";var l=c++;g[l]="(?:-("+g[A]+"(?:\\."+g[A]+")*))";var v=c++;g[v]="(?:-?("+g[d]+"(?:\\."+g[d]+")*))";var b=c++;g[b]="[0-9A-Za-z-]+";var m=c++;g[m]="(?:\\+("+g[b]+"(?:\\."+g[b]+")*))";var y=c++,t="v?"+g[k]+g[l]+"?"+g[m]+"?";g[y]="^"+t+"$";var s="[v=\\s]*"+g[E]+g[v]+"?"+g[m]+"?",i=c++;g[i]="^"+s+"$";var n=c++;g[n]="((?:<|>)?=?)";var r=c++;g[r]=g[p]+"|x|X|\\*";var o=c++;g[o]=g[S]+"|x|X|\\*";var a=c++;g[a]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[l]+")?"+g[m]+"?)?)?";var u=c++;g[u]="[v=\\s]*("+g[r]+")(?:\\.("+g[r]+")(?:\\.("+g[r]+")(?:"+g[v]+")?"+g[m]+"?)?)?";var f=c++;g[f]="^"+g[n]+"\\s*"+g[a]+"$";var L=c++;g[L]="^"+g[n]+"\\s*"+g[u]+"$";var F=c++;g[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=c++;g[Y]="(?:~>?)";var J=c++;g[J]="(\\s*)"+g[Y]+"\\s+",w[J]=new RegExp(g[J],"g");var ee=c++;g[ee]="^"+g[Y]+g[a]+"$";var ie=c++;g[ie]="^"+g[Y]+g[u]+"$";var ne=c++;g[ne]="(?:\\^)";var ae=c++;g[ae]="(\\s*)"+g[ne]+"\\s+",w[ae]=new RegExp(g[ae],"g");var ue=c++;g[ue]="^"+g[ne]+g[a]+"$";var re=c++;g[re]="^"+g[ne]+g[u]+"$";var ge=c++;g[ge]="^"+g[n]+"\\s*("+s+")$|^$";var B=c++;g[B]="^"+g[n]+"\\s*("+t+")$|^$";var j=c++;g[j]="(\\s*)"+g[n]+"\\s*("+s+"|"+g[a]+")",w[j]=new RegExp(g[j],"g");var M=c++;g[M]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var V=c++;g[V]="^\\s*("+g[u]+")\\s+-\\s+("+g[u]+")\\s*$";var W=c++;g[W]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)R(q,g[q]),w[q]||(w[q]=new RegExp(g[q]));function X(z,H){if(z instanceof P)return z;if(typeof z!="string"||z.length>T||!(H?w[i]:w[y]).test(z))return null;try{return new P(z,H)}catch{return null}}function P(z,H){if(z instanceof P){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof P))return new P(z,H);R("SemVer",z,H),this.loose=H;var K=z.trim().match(H?w[i]:w[y]);if(!K)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var me=+de;if(me>=0&&me<O)return me}return de}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=X,e.valid=function(z,H){var K=X(z,H);return K?K.version:null},e.clean=function(z,H){var K=X(z.trim().replace(/^[=v]+/,""),H);return K?K.version:null},e.SemVer=P,P.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},P.prototype.toString=function(){return this.version},P.prototype.compare=function(z){return R("SemVer.compare",this.version,this.loose,z),z instanceof P||(z=new P(z,this.loose)),this.compareMain(z)||this.comparePre(z)},P.prototype.compareMain=function(z){return z instanceof P||(z=new P(z,this.loose)),C(this.major,z.major)||C(this.minor,z.minor)||C(this.patch,z.patch)},P.prototype.comparePre=function(z){if(z instanceof P||(z=new P(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],de=z.prerelease[H];if(R("prerelease compare",H,K,de),K===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(K===void 0)return-1;if(K!==de)return C(K,de)}while(++H)},P.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,K,de){typeof K=="string"&&(de=K,K=void 0);try{return new P(z,K).inc(H,de).version}catch{return null}},e.diff=function(z,H){if(te(z,H))return null;var K=X(z),de=X(H);if(K.prerelease.length||de.prerelease.length){for(var me in K)if((me==="major"||me==="minor"||me==="patch")&&K[me]!==de[me])return"pre"+me;return"prerelease"}for(var me in K)if((me==="major"||me==="minor"||me==="patch")&&K[me]!==de[me])return me},e.compareIdentifiers=C;var I=/^[0-9]+$/;function C(z,H){var K=I.test(z),de=I.test(H);return K&&de&&(z=+z,H=+H),K&&!de?-1:de&&!K?1:z<H?-1:z>H?1:0}function U(z,H,K){return new P(z,K).compare(new P(H,K))}function $(z,H,K){return U(z,H,K)>0}function G(z,H,K){return U(z,H,K)<0}function te(z,H,K){return U(z,H,K)===0}function se(z,H,K){return U(z,H,K)!==0}function he(z,H,K){return U(z,H,K)>=0}function ve(z,H,K){return U(z,H,K)<=0}function le(z,H,K,de){var me;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),me=z===K;break;case"!==":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),me=z!==K;break;case"":case"=":case"==":me=te(z,K,de);break;case"!=":me=se(z,K,de);break;case">":me=$(z,K,de);break;case">=":me=he(z,K,de);break;case"<":me=G(z,K,de);break;case"<=":me=ve(z,K,de);break;default:throw new TypeError("Invalid operator: "+H)}return me}function ce(z,H){if(z instanceof ce){if(z.loose===H)return z;z=z.value}if(!(this instanceof ce))return new ce(z,H);R("comparator",z,H),this.loose=H,this.parse(z),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(z,H){return C(H,z)},e.major=function(z,H){return new P(z,H).major},e.minor=function(z,H){return new P(z,H).minor},e.patch=function(z,H){return new P(z,H).patch},e.compare=U,e.compareLoose=function(z,H){return U(z,H,!0)},e.rcompare=function(z,H,K){return U(H,z,K)},e.sort=function(z,H){return z.sort(function(K,de){return e.compare(K,de,H)})},e.rsort=function(z,H){return z.sort(function(K,de){return e.rcompare(K,de,H)})},e.gt=$,e.lt=G,e.eq=te,e.neq=se,e.gte=he,e.lte=ve,e.cmp=le,e.Comparator=ce;var we={};function pe(z,H){if(z instanceof pe)return z.loose===H?z:new pe(z.raw,H);if(z instanceof ce)return new pe(z.value,H);if(!(this instanceof pe))return new pe(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function oe(z){return!z||z.toLowerCase()==="x"||z==="*"}function Se(z,H,K,de,me,Oe,be,Ne,Re,Te,Fe,ke,Le){return((H=oe(K)?"":oe(de)?">="+K+".0.0":oe(me)?">="+K+"."+de+".0":">="+H)+" "+(Ne=oe(Re)?"":oe(Te)?"<"+(+Re+1)+".0.0":oe(Fe)?"<"+Re+"."+(+Te+1)+".0":ke?"<="+Re+"."+Te+"."+Fe+"-"+ke:"<="+Ne)).trim()}function Ie(z,H){for(var K=0;K<z.length;K++)if(!z[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<z.length;K++)if(R(z[K].semver),z[K].semver!==we&&z[K].semver.prerelease.length>0){var de=z[K].semver;if(de.major===H.major&&de.minor===H.minor&&de.patch===H.patch)return!0}return!1}return!0}function Me(z,H,K){try{H=new pe(H,K)}catch{return!1}return H.test(z)}function Ue(z,H,K,de){var me,Oe,be,Ne,Re;switch(z=new P(z,de),H=new pe(H,de),K){case">":me=$,Oe=ve,be=G,Ne=">",Re=">=";break;case"<":me=G,Oe=he,be=$,Ne="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(z,H,de))return!1;for(var Te=0;Te<H.set.length;++Te){var Fe=H.set[Te],ke=null,Le=null;if(Fe.forEach(function(Ae){Ae.semver===we&&(Ae=new ce(">=0.0.0")),ke=ke||Ae,Le=Le||Ae,me(Ae.semver,ke.semver,de)?ke=Ae:be(Ae.semver,Le.semver,de)&&(Le=Ae)}),ke.operator===Ne||ke.operator===Re||(!Le.operator||Le.operator===Ne)&&Oe(z,Le.semver)||Le.operator===Re&&be(z,Le.semver))return!1}return!0}ce.prototype.parse=function(z){var H=this.loose?w[ge]:w[B],K=z.match(H);if(!K)throw new TypeError("Invalid comparator: "+z);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new P(K[2],this.loose):this.semver=we},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(z){return R("Comparator.test",z,this.loose),this.semver===we||(typeof z=="string"&&(z=new P(z,this.loose)),le(z,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(z,H){if(!(z instanceof ce))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new pe(z.value,H),Me(this.value,K,H);if(z.operator==="")return K=new pe(this.value,H),Me(z.semver,K,H);var de=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ne=le(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Re=le(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return de||me||Oe&&be||Ne||Re},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),R("range",z,H);var K=H?w[V]:w[M];z=z.replace(K,Se),R("hyphen replace",z),z=z.replace(w[j],"$1$2$3"),R("comparator trim",z,w[j]),z=(z=(z=z.replace(w[J],"$1~")).replace(w[ae],"$1^")).split(/\s+/).join(" ");var de=H?w[ge]:w[B],me=z.split(" ").map(function(Oe){return function(be,Ne){return R("comp",be),be=function(Re,Te){return Re.trim().split(/\s+/).map(function(Fe){return function(ke,Le){R("caret",ke,Le);var Ae=Le?w[re]:w[ue];return ke.replace(Ae,function(je,Ee,ye,Pe,De){var Ce;return R("caret",ke,je,Ee,ye,Pe,De),oe(Ee)?Ce="":oe(ye)?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":oe(Pe)?Ce=Ee==="0"?">="+Ee+"."+ye+".0 <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+".0 <"+(+Ee+1)+".0.0":De?(R("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ce=Ee==="0"?ye==="0"?">="+Ee+"."+ye+"."+Pe+De+" <"+Ee+"."+ye+"."+(+Pe+1):">="+Ee+"."+ye+"."+Pe+De+" <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+"."+Pe+De+" <"+(+Ee+1)+".0.0"):(R("no pr"),Ce=Ee==="0"?ye==="0"?">="+Ee+"."+ye+"."+Pe+" <"+Ee+"."+ye+"."+(+Pe+1):">="+Ee+"."+ye+"."+Pe+" <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+"."+Pe+" <"+(+Ee+1)+".0.0"),R("caret return",Ce),Ce})}(Fe,Te)}).join(" ")}(be,Ne),R("caret",be),be=function(Re,Te){return Re.trim().split(/\s+/).map(function(Fe){return function(ke,Le){var Ae=Le?w[ie]:w[ee];return ke.replace(Ae,function(je,Ee,ye,Pe,De){var Ce;return R("tilde",ke,je,Ee,ye,Pe,De),oe(Ee)?Ce="":oe(ye)?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":oe(Pe)?Ce=">="+Ee+"."+ye+".0 <"+Ee+"."+(+ye+1)+".0":De?(R("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ce=">="+Ee+"."+ye+"."+Pe+De+" <"+Ee+"."+(+ye+1)+".0"):Ce=">="+Ee+"."+ye+"."+Pe+" <"+Ee+"."+(+ye+1)+".0",R("tilde return",Ce),Ce})}(Fe,Te)}).join(" ")}(be,Ne),R("tildes",be),be=function(Re,Te){return R("replaceXRanges",Re,Te),Re.split(/\s+/).map(function(Fe){return function(ke,Le){ke=ke.trim();var Ae=Le?w[L]:w[f];return ke.replace(Ae,function(je,Ee,ye,Pe,De,Ce){R("xRange",ke,je,Ee,ye,Pe,De,Ce);var We=oe(ye),ze=We||oe(Pe),Be=ze||oe(De);return Ee==="="&&Be&&(Ee=""),We?je=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Be?(ze&&(Pe=0),Be&&(De=0),Ee===">"?(Ee=">=",ze?(ye=+ye+1,Pe=0,De=0):Be&&(Pe=+Pe+1,De=0)):Ee==="<="&&(Ee="<",ze?ye=+ye+1:Pe=+Pe+1),je=Ee+ye+"."+Pe+"."+De):ze?je=">="+ye+".0.0 <"+(+ye+1)+".0.0":Be&&(je=">="+ye+"."+Pe+".0 <"+ye+"."+(+Pe+1)+".0"),R("xRange return",je),je})}(Fe,Te)}).join(" ")}(be,Ne),R("xrange",be),be=function(Re,Te){return R("replaceStars",Re,Te),Re.trim().replace(w[W],"")}(be,Ne),R("stars",be),be}(Oe,H)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Oe){return!!Oe.match(de)})),me=me.map(function(Oe){return new ce(Oe,H)})},pe.prototype.intersects=function(z,H){if(!(z instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(de){return z.set.some(function(me){return me.every(function(Oe){return de.intersects(Oe,H)})})})})},e.toComparators=function(z,H){return new pe(z,H).set.map(function(K){return K.map(function(de){return de.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new P(z,this.loose));for(var H=0;H<this.set.length;H++)if(Ie(this.set[H],z))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(z,H,K){var de=null,me=null;try{var Oe=new pe(H,K)}catch{return null}return z.forEach(function(be){Oe.test(be)&&(de&&me.compare(be)!==-1||(me=new P(de=be,K)))}),de},e.minSatisfying=function(z,H,K){var de=null,me=null;try{var Oe=new pe(H,K)}catch{return null}return z.forEach(function(be){Oe.test(be)&&(de&&me.compare(be)!==1||(me=new P(de=be,K)))}),de},e.validRange=function(z,H){try{return new pe(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,K){return Ue(z,H,"<",K)},e.gtr=function(z,H,K){return Ue(z,H,">",K)},e.outside=Ue,e.prerelease=function(z,H){var K=X(z,H);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(z,H,K){return z=new pe(z,K),H=new pe(H,K),z.intersects(H)},e.coerce=function(z){if(z instanceof P)return z;if(typeof z!="string")return null;var H=z.match(w[F]);return H==null?null:X((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,N(1))},function(x,e){var N,D,R=x.exports={};function T(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function w(d){if(N===setTimeout)return setTimeout(d,0);if((N===T||!N)&&setTimeout)return N=setTimeout,setTimeout(d,0);try{return N(d,0)}catch{try{return N.call(null,d,0)}catch{return N.call(this,d,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:T}catch{N=T}try{D=typeof clearTimeout=="function"?clearTimeout:O}catch{D=O}})();var g,c=[],S=!1,p=-1;function h(){S&&g&&(S=!1,g.length?c=g.concat(c):p=-1,c.length&&k())}function k(){if(!S){var d=w(h);S=!0;for(var l=c.length;l;){for(g=c,c=[];++p<l;)g&&g[p].run();p=-1,l=c.length}g=null,S=!1,function(v){if(D===clearTimeout)return clearTimeout(v);if((D===O||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(v);try{D(v)}catch{try{return D.call(null,v)}catch{return D.call(this,v)}}}(d)}}function E(d,l){this.fun=d,this.array=l}function A(){}R.nextTick=function(d){var l=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)l[v-1]=arguments[v];c.push(new E(d,l)),c.length!==1||S||w(k)},E.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=A,R.addListener=A,R.once=A,R.off=A,R.removeListener=A,R.removeAllListeners=A,R.emit=A,R.prependListener=A,R.prependOnceListener=A,R.listeners=function(d){return[]},R.binding=function(d){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(d){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Z[72],Q([0,1]),function(x,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class D{constructor(w,g,c){this.level=w,this.key=g,this.value=c,this.forward=[]}}const R=void 0;class T{constructor(w,g=2**16){this.comparator=w,this[N]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R)}has(w){return Boolean(T.g(this,w,this.comparator))}get(w){return T.g(this,w,this.comparator)?.value}set(w,g){return T.h(this,w,g,this.comparator)&&(this.f+=1),this}delete(w){const g=T.k(this,w,this.comparator);return g&&(this.f-=1),g}forEach(w,g){let c=this.e.forward[0];for(;c;)w.call(g,c.value,c.key,this),c=c.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this.e.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this.e.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this.e.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",g=this.e.forward[0];for(;g;)w+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return w}static g(w,g,c){let S=w.e;for(let p=w.d-1;p>=0;p--)for(;S.forward[p]&&c(S.forward[p].key,g)<0;)S=S.forward[p];if(S=S.forward[0],S&&c(S.key,g)===0)return S}static h(w,g,c,S){const p=[];let h=w.e;for(let k=w.d-1;k>=0;k--){for(;h.forward[k]&&S(h.forward[k].key,g)<0;)h=h.forward[k];p[k]=h}if(h=h.forward[0],h&&S(h.key,g)===0)return h.value=c,!1;{const k=T.j(w);if(k>w.d){for(let E=w.d;E<k;E++)p[E]=w.e;w.d=k}h=new D(k,g,c);for(let E=0;E<k;E++)h.forward[E]=p[E].forward[E],p[E].forward[E]=h;return!0}}static j(w,g=.5){let c=1;for(;Math.random()<g&&c<w.c;)c+=1;return c}static k(w,g,c){const S=[];let p=w.e;for(let h=w.d-1;h>=0;h--){for(;p.forward[h]&&c(p.forward[h].key,g)<0;)p=p.forward[h];S[h]=p}if(p=p.forward[0],!p||c(p.key,g)!==0)return!1;for(let h=0;h<w.d&&S[h].forward[h]===p;h++)S[h].forward[h]=p.forward[h];for(;w.d>0&&w.e.forward[w.d-1]===R;)w.d-=1;return!0}}e.SkipList=T}),define(Z[43],Q([0,1,7,2]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(m){const y=m;return y?typeof y.read=="function":!1}e.isReadable=R;function T(m){const y=m;return y?[y.on,y.pause,y.resume,y.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=T;function O(m){const y=m;return y?T(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.isReadableBufferedStream=O;function w(m,y){return new g(m,y)}e.newWriteableStream=w;class g{constructor(y,t){this.e=y,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(t=>t(y))}h(y){this.c.error.length===0?(0,N.onUnexpectedError)(y):this.c.error.slice(0).forEach(t=>t(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,t){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(y,t){if(this.a.destroyed)return;let s;switch(y){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(t);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(m,y){const t=[];let s;for(;(s=m.read())!==null;)t.push(s);return y(t)}e.consumeReadable=c;function S(m,y,t){const s=[];let i;for(;(i=m.read())!==null&&s.length<t;)s.push(i);return i===null&&s.length>0?y(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return m.read()}}}e.peekReadable=S;function p(m,y){return new Promise((t,s)=>{const i=[];h(m,{onData:n=>{y&&i.push(n)},onError:n=>{y?s(n):t(void 0)},onEnd:()=>{t(y?y(i):void 0)}})})}e.consumeStream=p;function h(m,y){let t=!1;return m.on("error",s=>{t||y.onError(s)}),m.on("end",()=>{t||y.onEnd()}),m.on("data",s=>{t||y.onData(s)}),(0,D.toDisposable)(()=>t=!0)}e.listenStream=h;function k(m,y){return new Promise((t,s)=>{const i=new D.DisposableStore,n=[],r=u=>{if(n.push(u),n.length>y)return i.dispose(),m.pause(),t({stream:m,buffer:n,ended:!1})},o=u=>s(u),a=()=>t({stream:m,buffer:n,ended:!0});i.add((0,D.toDisposable)(()=>m.removeListener("error",o))),m.on("error",o),i.add((0,D.toDisposable)(()=>m.removeListener("end",a))),m.on("end",a),i.add((0,D.toDisposable)(()=>m.removeListener("data",r))),m.on("data",r)})}e.peekStream=k;function E(m,y){const t=w(y);return t.end(m),t}e.toStream=E;function A(){const m=w(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=A;function d(m){let y=!1;return{read:()=>y?null:(y=!0,m)}}e.toReadable=d;function l(m,y,t){const s=w(t);return h(m,{onData:i=>s.write(y.data(i)),onError:i=>s.error(y.error?y.error(i):i),onEnd:()=>s.end()}),s}e.transform=l;function v(m,y,t){let s=!1;return{read:()=>{const i=y.read();return s?i:(s=!0,i!==null?t([m,i]):m)}}}e.prefixedReadable=v;function b(m,y,t){let s=!1;const i=w(t);return h(y,{onData:n=>s?i.write(n):(s=!0,i.write(t([m,n]))),onError:n=>i.error(n),onEnd:()=>{s||(s=!0,i.write(m)),i.end()}}),i}e.prefixedStream=b}),define(Z[15],Q([0,1,43]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u";let R,T;class O{static alloc(u){return D?new O(Buffer.allocUnsafe(u)):new O(new Uint8Array(u))}static wrap(u){return D&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new O(u)}static fromString(u,f){return!(f?.dontUseNodeBuffer||!1)&&D?new O(Buffer.from(u)):(R||(R=new TextEncoder),new O(R.encode(u)))}static fromByteArray(u){const f=O.alloc(u.length);for(let L=0,F=u.length;L<F;L++)f.buffer[L]=u[L];return f}static concat(u,f){if(typeof f>"u"){f=0;for(let Y=0,J=u.length;Y<J;Y++)f+=u[Y].byteLength}const L=O.alloc(f);let F=0;for(let Y=0,J=u.length;Y<J;Y++){const ee=u[Y];L.set(ee,F),F+=ee.byteLength}return L}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=O.alloc(this.byteLength);return u.set(this),u}toString(){return D?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(u,f){return new O(this.buffer.subarray(u,f))}set(u,f){if(u instanceof O)this.buffer.set(u.buffer,f);else if(u instanceof Uint8Array)this.buffer.set(u,f);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),f);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return c(this.buffer,u)}writeUInt32BE(u,f){S(this.buffer,u,f)}readUInt32LE(u){return p(this.buffer,u)}writeUInt32LE(u,f){h(this.buffer,u,f)}readUInt8(u){return k(this.buffer,u)}writeUInt8(u,f){E(this.buffer,u,f)}}e.VSBuffer=O;function w(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=w;function g(a,u,f){a[f+0]=u&255,u=u>>>8,a[f+1]=u&255}e.writeUInt16LE=g;function c(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=c;function S(a,u,f){a[f+3]=u,u=u>>>8,a[f+2]=u,u=u>>>8,a[f+1]=u,u=u>>>8,a[f]=u}e.writeUInt32BE=S;function p(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=p;function h(a,u,f){a[f+0]=u&255,u=u>>>8,a[f+1]=u&255,u=u>>>8,a[f+2]=u&255,u=u>>>8,a[f+3]=u&255}e.writeUInt32LE=h;function k(a,u){return a[u]}e.readUInt8=k;function E(a,u,f){a[f]=u}e.writeUInt8=E;function A(a){return N.consumeReadable(a,u=>O.concat(u))}e.readableToBuffer=A;function d(a){return N.toReadable(a)}e.bufferToReadable=d;function l(a){return N.consumeStream(a,u=>O.concat(u))}e.streamToBuffer=l;async function v(a){return a.ended?O.concat(a.buffer):O.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=v;function b(a){return N.toStream(a,u=>O.concat(u))}e.bufferToStream=b;function m(a){return N.transform(a,{data:u=>typeof u=="string"?O.fromString(u):O.wrap(u)},u=>O.concat(u))}e.streamToBufferReadableStream=m;function y(a){return N.newWriteableStream(u=>O.concat(u),a)}e.newWriteableBufferStream=y;function t(a,u){return N.prefixedReadable(a,u,f=>O.concat(f))}e.prefixedBufferReadable=t;function s(a,u){return N.prefixedStream(a,u,f=>O.concat(f))}e.prefixedBufferStream=s;function i(a){let u=0,f=0,L=0;const F=new Uint8Array(Math.floor(a.length/4*3)),Y=ee=>{switch(f){case 3:F[L++]=u|ee,f=0;break;case 2:F[L++]=u|ee>>>2,u=ee<<6,f=3;break;case 1:F[L++]=u|ee>>>4,u=ee<<4,f=2;break;default:u=ee<<2,f=1}};for(let ee=0;ee<a.length;ee++){const ie=a.charCodeAt(ee);if(ie>=65&&ie<=90)Y(ie-65);else if(ie>=97&&ie<=122)Y(ie-97+26);else if(ie>=48&&ie<=57)Y(ie-48+52);else if(ie===43||ie===45)Y(62);else if(ie===47||ie===95)Y(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ee]}`)}}const J=L;for(;f>0;)Y(0);return O.wrap(F).slice(0,J)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:a},u=!0,f=!1){const L=f?r:n;let F="";const Y=a.byteLength%3;let J=0;for(;J<a.byteLength-Y;J+=3){const ee=a[J+0],ie=a[J+1],ne=a[J+2];F+=L[ee>>>2],F+=L[(ee<<4|ie>>>4)&63],F+=L[(ie<<2|ne>>>6)&63],F+=L[ne&63]}if(Y===1){const ee=a[J+0];F+=L[ee>>>2],F+=L[ee<<4&63],u&&(F+="==")}else if(Y===2){const ee=a[J+0],ie=a[J+1];F+=L[ee>>>2],F+=L[(ee<<4|ie>>>4)&63],F+=L[ie<<2&63],u&&(F+="=")}return F}e.encodeBase64=o}),define(Z[30],Q([0,1,3]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const v=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([b,m])=>{v[b]=m&&typeof m=="object"?D(m):m}),v}e.deepClone=D;function R(l){if(!l||typeof l!="object")return l;const v=[l];for(;v.length>0;){const b=v.shift();Object.freeze(b);for(const m in b)if(T.call(b,m)){const y=b[m];typeof y=="object"&&!Object.isFrozen(y)&&!(0,N.isTypedArray)(y)&&v.push(y)}}return l}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function O(l,v){return w(l,v,new Set)}e.cloneAndChange=O;function w(l,v,b){if((0,N.isUndefinedOrNull)(l))return l;const m=v(l);if(typeof m<"u")return m;if(Array.isArray(l)){const y=[];for(const t of l)y.push(w(t,v,b));return y}if((0,N.isObject)(l)){if(b.has(l))throw new Error("Cannot clone recursive data-structure");b.add(l);const y={};for(const t in l)T.call(l,t)&&(y[t]=w(l[t],v,b));return b.delete(l),y}return l}function g(l,v,b=!0){return(0,N.isObject)(l)?((0,N.isObject)(v)&&Object.keys(v).forEach(m=>{m in l?b&&((0,N.isObject)(l[m])&&(0,N.isObject)(v[m])?g(l[m],v[m],b):l[m]=v[m]):l[m]=v[m]}),l):v}e.mixin=g;function c(l,v){if(l===v)return!0;if(l==null||v===null||v===void 0||typeof l!=typeof v||typeof l!="object"||Array.isArray(l)!==Array.isArray(v))return!1;let b,m;if(Array.isArray(l)){if(l.length!==v.length)return!1;for(b=0;b<l.length;b++)if(!c(l[b],v[b]))return!1}else{const y=[];for(m in l)y.push(m);y.sort();const t=[];for(m in v)t.push(m);if(t.sort(),!c(y,t))return!1;for(b=0;b<y.length;b++)if(!c(l[y[b]],v[y[b]]))return!1}return!0}e.equals=c;function S(l){const v=new Set;return JSON.stringify(l,(b,m)=>{if((0,N.isObject)(m)||Array.isArray(m)){if(v.has(m))return"[Circular]";v.add(m)}return m})}e.safeStringify=S;function p(l,v){const b=Object.create(null);return!l||!v||Object.keys(v).forEach(y=>{const t=l[y],s=v[y];c(t,s)||(b[y]=s)}),b}e.distinct=p;function h(l,v){const b=v.toLowerCase(),m=Object.keys(l).find(y=>y.toLowerCase()===b);return m?l[m]:l[v]}e.getCaseInsensitive=h;function k(l,v){const b=Object.create(null);for(const[m,y]of Object.entries(l))v(m,y)&&(b[m]=y);return b}e.filter=k;function E(l){let v=[],b=Object.getPrototypeOf(l);for(;Object.prototype!==b;)v=v.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return v}e.getAllPropertyNames=E;function A(l){const v=[];for(const b of E(l))typeof l[b]=="function"&&v.push(b);return v}e.getAllMethodNames=A;function d(l,v){const b=y=>function(){const t=Array.prototype.slice.call(arguments,0);return v(y,t)},m={};for(const y of l)m[y]=b(y);return m}e.createProxyObject=d}),define(Z[31],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return N.test(R)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(w){for(let g=0;g<w.length;g++)w[g]=Math.floor(Math.random()*256);return w};const T=new Uint8Array(16),O=[];for(let w=0;w<256;w++)O.push(w.toString(16).padStart(2,"0"));return function(){R(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let g=0,c="";return c+=O[T[g++]],c+=O[T[g++]],c+=O[T[g++]],c+=O[T[g++]],c+="-",c+=O[T[g++]],c+=O[T[g++]],c+="-",c+=O[T[g++]],c+=O[T[g++]],c+="-",c+=O[T[g++]],c+=O[T[g++]],c+="-",c+=O[T[g++]],c+=O[T[g++]],c+=O[T[g++]],c+=O[T[g++]],c+=O[T[g++]],c+=O[T[g++]],c}}()}),define(Z[73],Q([0,1,33]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(O){const w=O.replace(/\-/g,":").toLowerCase();return!D.has(w)}function T(){const O=(0,N.networkInterfaces)();for(const w in O){const g=O[w];if(g){for(const{mac:c}of g)if(R(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(Z[74],Q([8,9]),function(x,e){return x.create("vs/base/common/date",e)}),define(Z[75],Q([0,1,74]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,R=D*60,T=R*24,O=T*7,w=T*30,g=T*365;function c(p,h,k,E){typeof p!="number"&&(p=p.getTime());const A=Math.round((new Date().getTime()-p)/1e3);if(A<-30)return(0,N.localize)(0,null,c(new Date().getTime()+A*1e3,!1));if(!E&&A<30)return(0,N.localize)(1,null);let d;return A<D?(d=A,h?d===1?k?(0,N.localize)(2,null,d):(0,N.localize)(3,null,d):k?(0,N.localize)(4,null,d):(0,N.localize)(5,null,d):d===1?k?(0,N.localize)(6,null,d):(0,N.localize)(7,null,d):k?(0,N.localize)(8,null,d):(0,N.localize)(9,null,d)):A<R?(d=Math.floor(A/D),h?d===1?k?(0,N.localize)(10,null,d):(0,N.localize)(11,null,d):k?(0,N.localize)(12,null,d):(0,N.localize)(13,null,d):d===1?k?(0,N.localize)(14,null,d):(0,N.localize)(15,null,d):k?(0,N.localize)(16,null,d):(0,N.localize)(17,null,d)):A<T?(d=Math.floor(A/R),h?d===1?k?(0,N.localize)(18,null,d):(0,N.localize)(19,null,d):k?(0,N.localize)(20,null,d):(0,N.localize)(21,null,d):d===1?k?(0,N.localize)(22,null,d):(0,N.localize)(23,null,d):k?(0,N.localize)(24,null,d):(0,N.localize)(25,null,d)):A<O?(d=Math.floor(A/T),h?d===1?(0,N.localize)(26,null,d):(0,N.localize)(27,null,d):d===1?(0,N.localize)(28,null,d):(0,N.localize)(29,null,d)):A<w?(d=Math.floor(A/O),h?d===1?k?(0,N.localize)(30,null,d):(0,N.localize)(31,null,d):k?(0,N.localize)(32,null,d):(0,N.localize)(33,null,d):d===1?k?(0,N.localize)(34,null,d):(0,N.localize)(35,null,d):k?(0,N.localize)(36,null,d):(0,N.localize)(37,null,d)):A<g?(d=Math.floor(A/w),h?d===1?k?(0,N.localize)(38,null,d):(0,N.localize)(39,null,d):k?(0,N.localize)(40,null,d):(0,N.localize)(41,null,d):d===1?k?(0,N.localize)(42,null,d):(0,N.localize)(43,null,d):k?(0,N.localize)(44,null,d):(0,N.localize)(45,null,d)):(d=Math.floor(A/g),h?d===1?k?(0,N.localize)(46,null,d):(0,N.localize)(47,null,d):k?(0,N.localize)(48,null,d):(0,N.localize)(49,null,d):d===1?k?(0,N.localize)(50,null,d):(0,N.localize)(51,null,d):k?(0,N.localize)(52,null,d):(0,N.localize)(53,null,d))}e.fromNow=c;function S(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=S}),define(Z[76],Q([8,9]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Z[34],Q([0,1,19,3,76]),function(x,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(p,h){return h&&(p.stack||p.stacktrace)?R.localize(0,null,w(p),O(p.stack)||O(p.stacktrace)):w(p)}function O(p){return Array.isArray(p)?p.join(`
`):p}function w(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?R.localize(1,null,p.message):p.message||R.localize(2,null)}function g(p=null,h=!1){if(!p)return R.localize(3,null);if(Array.isArray(p)){const k=N.coalesce(p),E=g(k[0],h);return k.length>1?R.localize(4,null,E,k.length):E}if(D.isString(p))return p;if(p.detail){const k=p.detail;if(k.error)return T(k.error,h);if(k.exception)return T(k.exception,h)}return p.stack?T(p,h):p.message?p.message:R.localize(5,null)}e.toErrorMessage=g;function c(p){const h=p;return h instanceof Error&&Array.isArray(h.actions)}e.isErrorWithActions=c;function S(p,h){let k;return typeof p=="string"?k=new Error(p):k=p,k.actions=h,k}e.createErrorWithActions=S}),define(Z[77],Q([8,9]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Z[78],Q([0,1,77]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function D(R){switch(R){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.getParseErrorMessage=D}),define(Z[51],Q([0,1,12]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var R;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(w,...g){const c=g.reduce((h,k)=>(h[k]=!0,h),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(h=>!c[h]).forEach(h=>{for(let k=0;k<S.length;k++)if(h.search(S[k])!==-1){delete w[h];break}})}e.sanitizeProcessEnvironment=T;function O(w){!w||(delete w.DEBUG,N.isMacintosh&&delete w.DYLD_LIBRARY_PATH,N.isLinux&&delete w.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(Z[52],Q([0,1,32]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(l){return R(l,0)}e.hash=D;function R(l,v){switch(typeof l){case"object":return l===null?T(349,v):Array.isArray(l)?g(l,v):c(l,v);case"string":return w(l,v);case"boolean":return O(l,v);case"number":return T(l,v);case"undefined":return T(937,v);default:return T(617,v)}}e.doHash=R;function T(l,v){return(v<<5)-v+l|0}e.numberHash=T;function O(l,v){return T(l?433:863,v)}function w(l,v){v=T(149417,v);for(let b=0,m=l.length;b<m;b++)v=T(l.charCodeAt(b),v);return v}e.stringHash=w;function g(l,v){return v=T(104579,v),l.reduce((b,m)=>R(m,b),v)}function c(l,v){return v=T(181387,v),Object.keys(l).sort().reduce((b,m)=>(b=w(m,b),R(l[m],b)),v)}class S{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=R(v,this.g),this.g}}e.Hasher=S;var p;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function h(l,v,b=32){const m=b-v,y=~((1<<m)-1);return(l<<v|(y&l)>>>m)>>>0}function k(l,v=0,b=l.byteLength,m=0){for(let y=0;y<b;y++)l[v+y]=m}function E(l,v,b="0"){for(;l.length<v;)l=b+l;return l}function A(l,v=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(b=>b.toString(16).padStart(2,"0")).join(""):E((l>>>0).toString(16),v/4)}e.toHexString=A;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const b=v.length;if(b===0)return;const m=this.p;let y=this.r,t=this.u,s,i;for(t!==0?(s=t,i=-1,t=0):(s=v.charCodeAt(0),i=0);;){let n=s;if(N.isHighSurrogate(s))if(i+1<b){const r=v.charCodeAt(i+1);N.isLowSurrogate(r)?(i++,n=N.computeCodePoint(s,r)):n=65533}else{t=s;break}else N.isLowSurrogate(s)&&(n=65533);if(y=this.w(m,y,n),i++,i<b)s=v.charCodeAt(i);else break}this.r=y,this.u=t}w(v,b,m){return m<128?v[b++]=m:m<2048?(v[b++]=192|(m&1984)>>>6,v[b++]=128|(m&63)>>>0):m<65536?(v[b++]=224|(m&61440)>>>12,v[b++]=128|(m&4032)>>>6,v[b++]=128|(m&63)>>>0):(v[b++]=240|(m&1835008)>>>18,v[b++]=128|(m&258048)>>>12,v[b++]=128|(m&4032)>>>6,v[b++]=128|(m&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),A(this.h)+A(this.l)+A(this.m)+A(this.n)+A(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=d.g,b=this.q;for(let a=0;a<64;a+=4)v.setUint32(a,b.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)v.setUint32(a,h(v.getUint32(a-12,!1)^v.getUint32(a-32,!1)^v.getUint32(a-56,!1)^v.getUint32(a-64,!1),1),!1);let m=this.h,y=this.l,t=this.m,s=this.n,i=this.o,n,r,o;for(let a=0;a<80;a++)a<20?(n=y&t|~y&s,r=1518500249):a<40?(n=y^t^s,r=1859775393):a<60?(n=y&t|y&s|t&s,r=2400959708):(n=y^t^s,r=3395469782),o=h(m,5)+n+i+r+v.getUint32(a*4,!1)&4294967295,i=s,s=t,t=h(y,30),y=m,m=o;this.h=this.h+m&4294967295,this.l=this.l+y&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=d,d.g=new DataView(new ArrayBuffer(320))}),define(Z[53],Q([0,1,32]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const T="error",O="warning",w="warn",g="info",c="ignore";function S(h){return h?N.equalsIgnoreCase(T,h)?R.Error:N.equalsIgnoreCase(O,h)||N.equalsIgnoreCase(w,h)?R.Warning:N.equalsIgnoreCase(g,h)?R.Info:R.Ignore:R.Ignore}R.fromValue=S;function p(h){switch(h){case R.Error:return T;case R.Warning:return O;case R.Info:return g;default:return c}}R.toString=p}(D||(D={})),e.default=D}),define(Z[79],Q([0,1,11]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(c){const S=c;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.isRemoteConsoleLog=D;function R(c){const S=[];let p;try{const h=JSON.parse(c.arguments),k=h[h.length-1];k&&k.__$stack&&(h.pop(),p=k.__$stack),S.push(...h)}catch{S.push("Unable to log remote console arguments",c.arguments)}return{args:S,stack:p}}e.parse=R;function T(c){if(typeof c!="string")return T(R(c).stack);const S=c;if(S){const p=O(S),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(h&&h.length===4)return{uri:N.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=T;function O(c){if(!c)return c;const S=c.indexOf(`
`);return S===-1?c:c.substring(0,S)}function w(c,S){const{args:p,stack:h}=R(c),k=typeof p[0]=="string"&&p.length===1;let E=O(h);E&&(E=`(${E.trim()})`);let A=[];if(typeof p[0]=="string"?E&&k?A=[`%c[${S}] %c${p[0]} %c${E}`,g("blue"),g(""),g("grey")]:A=[`%c[${S}] %c${p[0]}`,g("blue"),g(""),...p.slice(1)]:A=[`%c[${S}]%`,g("blue"),...p],E&&!k&&A.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,A)}e.log=w;function g(c){return`color: ${c}`}}),define(Z[44],Q([0,1,15,32,11]),function(x,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(c){return JSON.stringify(c,w)}e.stringify=T;function O(c){let S=JSON.parse(c);return S=g(S),S}e.parse=O;function w(c,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,D.regExpFlags)(S)}:S}function g(c,S=0){if(!c||S>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return R.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof N.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let p=0;p<c.length;++p)c[p]=g(c[p],S+1);else for(const p in c)Object.hasOwnProperty.call(c,p)&&(c[p]=g(c[p],S+1))}return c}e.revive=g}),define(Z[80],Q([0,1,33,7,54,31,73]),function(x,e,N,D,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(S){return this.a||(this.a=R.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(S)}value(){if(this.b===void 0){let S=0,p=0;const h=(0,N.networkInterfaces)();for(const k in h){const E=h[k];if(E)for(const{mac:A,internal:d}of E)d||(p+=1,this.c(A.toUpperCase())&&(S+=1))}this.b=p>0?S/p:0}return this.b}};let w;async function g(){return w||(w=(async()=>await c()||T.generateUuid())()),w}e.getMachineId=g;async function c(){try{const S=await new Promise((h,k)=>{x(["crypto"],h,k)}),p=(0,O.getMac)();return S.createHash("sha256").update(p,"utf8").digest("hex")}catch(S){D.onUnexpectedError(S);return}}}),define(Z[81],Q([0,1,33,14,20]),function(x,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,O=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var g;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(g||(g={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class p{constructor(y,t,s){this.exePath=y,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function h({useAlternateBitness:m=!1}={}){return m?c===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function k({useAlternateBitness:m=!1,findPreview:y=!1}={}){const t=h({useAlternateBitness:m});if(!t)return null;const s=D.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const a of await R.Promises.readdir(s)){let u=-1;if(y){const L=a.indexOf("-");if(L<0)continue;const F=a.substring(0,L);if(!T.test(F)||a.substring(L+1)!=="preview")continue;u=parseInt(F,10)}else{if(!T.test(a))continue;u=parseInt(a,10)}if(u<=i)continue;const f=D.join(s,a,"pwsh.exe");!await R.SymlinkSupport.existsFile(f)||(n=f,i=u)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",o=y?" Preview":"";return new p(n,`PowerShell${o}${r}`,!0)}async function E({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const y=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(y))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=m?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(y))if(t.test(i)){const n=D.join(y,i,"pwsh.exe");return new p(n,s)}return null}function A(){const m=D.join(N.homedir(),".dotnet","tools","pwsh.exe");return new p(m,".NET Core PowerShell Global Tool")}function d(){const m=D.join(process.env.windir,c===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(m,"Windows PowerShell",!0)}async function*l(){let m=await k();m&&(yield m),m=await k({useAlternateBitness:!0}),m&&(yield m),m=await E(),m&&(yield m),m=A(),m&&(yield m),m=await k({findPreview:!0}),m&&(yield m),m=await E({findPreview:!0}),m&&(yield m),m=await k({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=d(),m&&(yield m)}async function*v(){for await(const m of l())await m.exists()&&(yield m)}e.enumeratePowerShellInstallations=v;async function b(){for await(const m of v())return m;return null}e.getFirstAvailablePowerShellInstallation=b}),define(Z[55],Q([0,1,14,12,35,51,3,20]),function(x,e,N,D,R,T,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function g(p=R.env){return p.comspec||"cmd.exe"}e.getWindowsShell=g;function c(p){let h=[],k=!1;const E=function(A){if(k){h.push(A);return}(!p.send(A,l=>{if(l&&console.error(l),k=!1,h.length>0){const v=h.slice(0);h=[],v.forEach(b=>E(b))}})||D.isWindows)&&(k=!0)};return{send:E}}e.createQueuedSender=c;var S;(function(p){async function h(k,E,A){if(N.isAbsolute(k))return k;if(E===void 0&&(E=R.cwd()),N.dirname(k)!=="."||(A===void 0&&O.isString(R.env.PATH)&&(A=R.env.PATH.split(N.delimiter)),A===void 0||A.length===0))return N.join(E,k);async function l(v){if(await w.Promises.exists(v)){let b;try{b=await w.Promises.stat(v)}catch(m){m.message.startsWith("EACCES")&&(b=await w.Promises.lstat(v))}return b?!b.isDirectory():!1}return!1}for(const v of A){let b;if(N.isAbsolute(v)?b=N.join(v,k):b=N.join(E,v,k),await l(b))return b;let m=b+".com";if(await l(m)||(m=b+".exe",await l(m)))return m}return N.join(E,k)}p.findExecutable=h})(S=e.win32||(e.win32={}))}),define(Z[82],Q([0,1,33,12,81,55]),function(x,e,N,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function O(p,h){return p===1?D.isWindows?S():T.getWindowsShell(h):g(p,h)}e.getSystemShell=O;let w=null;function g(p,h){if(D.isLinux&&p===2||D.isMacintosh&&p===3)return"/bin/bash";if(!w){let k;if(D.isWindows)k="/bin/bash";else{if(k=h.SHELL,!k)try{k=(0,N.userInfo)().shell}catch{}k||(k="sh"),k==="/bin/false"&&(k="/bin/bash")}w=k}return w}let c=null;async function S(){return c||(c=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),c}});var fe=this&&this.__decorate||function(x,e,N,D){var R=arguments.length,T=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,N):D,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(x,e,N,D);else for(var w=x.length-1;w>=0;w--)(O=x[w])&&(T=(R<3?O(T):R>3?O(e,N,T):O(e,N))||T);return R>3&&T&&Object.defineProperty(e,N,T),T};define(Z[56],Q([0,1,19,5,15,22,49,7,4,2,44,32,3]),function(x,e,N,D,R,T,O,w,g,c,S,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var k;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(k||(k={}));function E(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var A;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(A||(A={}));function d(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(l||(l={}));function v(j){let M=0;for(let V=0;;V+=7){const W=j.read(1);if(M|=(W.buffer[0]&127)<<V,!(W.buffer[0]&128))return M}}const b=i(0);function m(j,M){if(M===0){j.write(b);return}let V=0;for(let q=M;q!==0;q=q>>>7)V++;const W=R.VSBuffer.alloc(V);for(let q=0;M!==0;q++)W.buffer[q]=M&127,M=M>>>7,M>0&&(W.buffer[q]|=128);j.write(W)}class y{constructor(M){this.b=M,this.a=0}read(M){const V=this.b.slice(this.a,this.a+M);return this.a+=V.byteLength,V}}e.BufferReader=y;class t{constructor(){this.a=[]}get buffer(){return R.VSBuffer.concat(this.a)}write(M){this.a.push(M)}}e.BufferWriter=t;var s;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(s||(s={}));function i(j){const M=R.VSBuffer.alloc(1);return M.writeUInt8(j,0),M}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object),Uint:i(s.Int)},r=typeof Buffer<"u";function o(j,M){if(typeof M>"u")j.write(n.Undefined);else if(typeof M=="string"){const V=R.VSBuffer.fromString(M);j.write(n.String),m(j,V.byteLength),j.write(V)}else if(r&&Buffer.isBuffer(M)){const V=R.VSBuffer.wrap(M);j.write(n.Buffer),m(j,V.byteLength),j.write(V)}else if(M instanceof R.VSBuffer)j.write(n.VSBuffer),m(j,M.byteLength),j.write(M);else if(Array.isArray(M)){j.write(n.Array),m(j,M.length);for(const V of M)o(j,V)}else if(typeof M=="number"&&(M|0)===M)j.write(n.Uint),m(j,M);else{const V=R.VSBuffer.fromString(JSON.stringify(M));j.write(n.Object),m(j,V.byteLength),j.write(V)}}e.serialize=o;function a(j){switch(j.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return j.read(v(j)).toString();case s.Buffer:return j.read(v(j)).buffer;case s.VSBuffer:return j.read(v(j));case s.Array:{const V=v(j),W=[];for(let q=0;q<V;q++)W.push(a(j));return W}case s.Object:return JSON.parse(j.read(v(j)).toString());case s.Int:return v(j)}}e.deserialize=a;class u{constructor(M,V,W=null,q=1e3){this.h=M,this.j=V,this.k=W,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(M,V){this.b.set(M,V),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const V=this.o([M.type]);this.k?.logOutgoing(V,0,1,d(M.type));return}case 201:case 202:case 204:case 203:{const V=this.o([M.type,M.id],M.data);this.k?.logOutgoing(V,M.id,1,d(M.type),M.data);return}}}o(M,V=void 0){const W=new t;return o(W,M),o(W,V),this.p(W.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const V=new y(M),W=a(V),q=a(V),X=W[0];switch(X){case 100:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(X)}: ${W[2]}.${W[3]}`,q),this.s({type:X,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(X)}: ${W[2]}.${W[3]}`,q),this.t({type:X,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(X)}`),this.u({type:X,id:W[1]});case 103:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(X)}`),this.u({type:X,id:W[1]})}}s(M){const V=this.b.get(M.channelName);if(!V){this.v(M);return}const W=new T.CancellationTokenSource;let q;try{q=V.call(this.j,M.name,M.arg,W.token)}catch(I){q=Promise.reject(I)}const X=M.id;q.then(I=>{this.m({id:X,data:I,type:201}),this.d.delete(M.id)},I=>{I instanceof Error?this.m({id:X,data:{message:I.message,name:I.name,stack:I.stack?I.stack.split?I.stack.split(`
`):I.stack:void 0},type:202}):this.m({id:X,data:I,type:203}),this.d.delete(M.id)});const P=(0,c.toDisposable)(()=>W.cancel());this.d.set(M.id,P)}t(M){const V=this.b.get(M.channelName);if(!V){this.v(M);return}const W=M.id,X=V.listen(this.j,M.name,M.arg)(P=>this.m({id:W,data:P,type:204}));this.d.set(M.id,X)}u(M){const V=this.d.get(M.id);V&&(V.dispose(),this.d.delete(M.id))}v(M){let V=this.g.get(M.channelName);V||(V=[],this.g.set(M.channelName,V));const W=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:M,timeoutTimer:W})}w(M){const V=this.g.get(M);if(V){for(const W of V)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.s(W.request);break;case 102:this.t(W.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var f;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(M,V=null){this.l=M,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=V}getChannel(M){const V=this;return{call(W,q,X){return V.a?Promise.reject(new w.CancellationError):V.m(M,W,q,X)},listen(W,q){return V.a?g.Event.None:V.o(M,W,q)}}}m(M,V,W,q=T.CancellationToken.None){const X=this.g++,I={id:X,type:100,channelName:M,name:V,arg:W};if(q.isCancellationRequested)return Promise.reject(new w.CancellationError);let C;return new Promise(($,G)=>{if(q.isCancellationRequested)return G(new w.CancellationError);const te=()=>{const le=ce=>{switch(ce.type){case 201:this.f.delete(X),$(ce.data);break;case 202:{this.f.delete(X);const we=new Error(ce.data.message);we.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,we.name=ce.data.name,G(we);break}case 203:this.f.delete(X),G(ce.data);break}};this.f.set(X,le),this.p(I)};let se=null;this.b===l.Idle?te():(se=(0,D.createCancelablePromise)(le=>this.u()),se.then(()=>{se=null,te()}));const he=()=>{se?(se.cancel(),se=null):this.p({id:X,type:101}),G(new w.CancellationError)},ve=q.onCancellationRequested(he);C=(0,c.combinedDisposable)((0,c.toDisposable)(he),ve),this.d.add(C)}).finally(()=>{this.d.delete(C)})}o(M,V,W){const q=this.g++,P={id:q,type:102,channelName:M,name:V,arg:W};let I=null;const C=new g.Emitter({onWillAddFirstListener:()=>{I=(0,D.createCancelablePromise)($=>this.u()),I.then(()=>{I=null,this.d.add(C),this.p(P)})},onDidRemoveLastListener:()=>{I?(I.cancel(),I=null):(this.d.delete(C),this.p({id:q,type:103}))}}),U=$=>C.fire($.data);return this.f.set(q,U),C.event}p(M){switch(M.type){case 100:case 102:{const V=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(V,M.id,0,`${E(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const V=this.q([M.type,M.id]);this.j?.logOutgoing(V,M.id,0,E(M.type));return}}}q(M,V=void 0){const W=new t;return o(W,M),o(W,V),this.r(W.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const V=new y(M),W=a(V),q=a(V),X=W[0];switch(X){case 200:return this.j?.logIncoming(M.byteLength,0,0,d(X)),this.t({type:W[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,W[1],0,d(X),q),this.t({type:W[0],id:W[1],data:q})}}t(M){if(M.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}fe([O.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class F{get connections(){const M=[];return this.f.forEach(V=>M.push(V)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,M(({protocol:V,onDidClientDisconnect:W})=>{g.Event.once(V.onMessage)(X=>{const P=new y(X),I=a(P),C=new u(V,I),U=new L(V);this.a.forEach((G,te)=>C.registerChannel(te,G));const $={channelServer:C,channelClient:U,ctx:I};this.f.add($),this.g.fire($),W(()=>{C.dispose(),U.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(M,V){const W=this;return{call(q,X,P){let I;if((0,h.isFunction)(V)){const U=(0,N.getRandomElement)(W.connections.filter(V));I=U?Promise.resolve(U):g.Event.toPromise(g.Event.filter(W.onDidAddConnection,V))}else I=V.routeCall(W,q,X);const C=I.then(U=>U.channelClient.getChannel(M));return J(C).call(q,X,P)},listen(q,X){if((0,h.isFunction)(V))return W.j(M,V,q,X);const P=V.routeEvent(W,q,X).then(I=>I.channelClient.getChannel(M));return J(P).listen(q,X)}}}j(M,V,W,q){const X=this;let P=new c.DisposableStore;const I=new g.Emitter({onWillAddFirstListener:()=>{P=new c.DisposableStore;const C=new g.EventMultiplexer,U=new Map,$=te=>{const he=te.channelClient.getChannel(M).listen(W,q),ve=C.add(he);U.set(te,ve)},G=te=>{const se=U.get(te);!se||(se.dispose(),U.delete(te))};X.connections.filter(V).forEach($),g.Event.filter(X.onDidAddConnection,V)($,void 0,P),X.onDidRemoveConnection(G,void 0,P),C.event(I.fire,I,P),P.add(C)},onDidRemoveLastListener:()=>{P.dispose()}});return I.event}registerChannel(M,V){this.a.set(M,V),this.f.forEach(W=>{W.channelServer.registerChannel(M,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=F;class Y{constructor(M,V,W=null){const q=new t;o(q,V),M.send(q.buffer),this.a=new L(M,W),this.d=new u(M,V,W)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,V){this.d.registerChannel(M,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Y;function J(j){return{call(M,V,W){return j.then(q=>q.call(M,V,W))},listen(M,V){const W=new g.Relay;return j.then(q=>W.input=q.listen(M,V)),W.event}}}e.getDelayedChannel=J;function ee(j){let M=!1;return{call(V,W,q){return M?j.call(V,W,q):(0,D.timeout)(0).then(()=>M=!0).then(()=>j.call(V,W,q))},listen(V,W){if(M)return j.listen(V,W);const q=new g.Relay;return(0,D.timeout)(0).then(()=>M=!0).then(()=>q.input=j.listen(V,W)),q.event}}}e.getNextTickChannel=ee;class ie{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const V of M.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await g.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.StaticRouter=ie;var ne;(function(j){function M(X,P){const I=X,C=P&&P.disableMarshalling,U=new Map;for(const $ in I)W($)&&U.set($,g.Event.buffer(I[$],!0));return new class{listen($,G,te){const se=U.get(G);if(se)return se;if(q(G)){const he=I[G];if(typeof he=="function")return he.call(I,te)}throw new Error(`Event not found: ${G}`)}call($,G,te){const se=I[G];if(typeof se=="function"){if(!C&&Array.isArray(te))for(let he=0;he<te.length;he++)te[he]=(0,S.revive)(te[he]);return se.apply(I,te)}throw new Error(`Method not found: ${G}`)}}}j.fromService=M;function V(X,P){const I=P&&P.disableMarshalling;return new Proxy({},{get(C,U){if(typeof U=="string")return P?.properties?.has(U)?P.properties.get(U):q(U)?function($){return X.listen(U,$)}:W(U)?X.listen(U):async function(...$){let G;P&&!(0,h.isUndefinedOrNull)(P.context)?G=[P.context,...$]:G=$;const te=await X.call(U,G);return I?te:(0,S.revive)(te)};throw new Error(`Property not found: ${String(U)}`)}})}j.toService=V;function W(X){return X[0]==="o"&&X[1]==="n"&&p.isUpperAsciiLetter(X.charCodeAt(2))}function q(X){return/^onDynamic/.test(X)&&p.isUpperAsciiLetter(X.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const M=j.toString();if(M!=="[object Object]")return M}return j}function re(j){return Array.isArray(j)?j.map(ue):ue(j)}function ge(j,M,V,W,q,X,P){P=re(P);const I=ae[q],C=I[W%I.length];let U=[`%c[${j}]%c[${String(M).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(X)?(U=U.concat(P),U.push(")")):U.push(P),console.log.apply(console,U)}class B{constructor(M,V){this.d=M,this.f=V,this.a=0,this.b=0}logOutgoing(M,V,W,q,X){this.b+=M,ge(this.d,this.b,M,V,W,q,X)}logIncoming(M,V,W,q,X){this.a+=M,ge(this.f,this.a,M,V,W,q,X)}}e.IPCLogger=B}),define(Z[83],Q([0,1,57,5,15,22,79,7,4,2,30,55,51,56]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends k.ChannelServer{constructor(l){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",v=>R.VSBuffer.wrap(Buffer.from(v,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=E;class A{constructor(l,v){this.i=l,this.j=v,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const b=v&&v.timeout?v.timeout:6e4;this.b=new D.Delayer(b),this.d=null,this.f=null}getChannel(l){const v=this;return{call(b,m,y){return v.k(l,b,m,y)},listen(b,m){return v.l(l,b,m)}}}k(l,v,b,m=T.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(w.canceled());this.b.cancel();const y=this.n(l),t=(0,D.createCancelablePromise)(n=>y.call(v,b,n)),s=m.onCancellationRequested(()=>t.cancel()),i=(0,c.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{s.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,v,b){if(!this.b)return g.Event.None;this.b.cancel();let m;const y=new g.Emitter({onWillAddFirstListener:()=>{m=this.n(l).listen(v,b)(y.fire,y),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return y.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],v=Object.create(null);v.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(v.env={...v.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(v.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,h.removeDangerousEnvVariables)(v.env),this.d=(0,N.fork)(this.i,l,v);const b=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,O.isRemoteConsoleLog)(r)){(0,O.log)(r,`IPC Library: ${this.j.serverName}`);return}b.fire(R.VSBuffer.wrap(Buffer.from(r,"base64")))});const y=this.j.useQueue?(0,p.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&y.send(r.buffer.toString("base64")),s=b.event,i={send:t,onMessage:s};this.f=new k.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,c.dispose)(a)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(l){let v=this.g.get(l);return v||(v=this.m.getChannel(l),this.g.set(l,v)),v}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=A}),define(Z[84],Q([0,1,5,4,2,3]),function(x,e,N,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O=e.StorageHint||(e.StorageHint={}));function w(p){const h=p;return h?.changed instanceof Map||h?.deleted instanceof Set}e.isStorageItemsChangeEvent=w;var g;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class c extends R.Disposable{constructor(h,k=Object.create(null)){super(),this.m=h,this.n=k,this.b=this.B(new D.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new N.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){h.changed?.forEach((k,E)=>this.s(E,k)),h.deleted?.forEach(k=>this.s(k,void 0))}s(h,k){if(this.c===g.Closed)return;let E=!1;(0,T.isUndefinedOrNull)(k)?E=this.f.delete(h):this.f.get(h)!==k&&(this.f.set(h,k),E=!0),E&&this.b.fire(h)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,k){const E=this.f.get(h);return(0,T.isUndefinedOrNull)(E)?k:E}getBoolean(h,k){const E=this.get(h);return(0,T.isUndefinedOrNull)(E)?k:E==="true"}getNumber(h,k){const E=this.get(h);return(0,T.isUndefinedOrNull)(E)?k:parseInt(E,10)}async set(h,k){if(this.c===g.Closed)return;if((0,T.isUndefinedOrNull)(k))return this.delete(h);const E=String(k);if(this.f.get(h)!==E)return this.f.set(h,E),this.j.set(h,E),this.h.delete(h),this.b.fire(h),this.w()}async delete(h){if(!(this.c===g.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire(h),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(!!this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(!!this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===O.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=c,c.a=100;class S{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((k,E)=>this.a.set(E,k)),h.delete?.forEach(k=>this.a.delete(k))}async close(){}}e.InMemoryStorageDatabase=S}),define(Z[85],Q([8,9]),function(x,e){return x.create("vs/base/node/zip",e)}),define(Z[86],Q([8,9]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[87],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[88],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[89],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Z[90],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[91],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[92],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[93],Q([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[94],Q([8,9]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[95],Q([8,9]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Z[96],Q([8,9]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Z[97],Q([8,9]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[98],Q([8,9]),function(x,e){return x.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Z[99],Q([8,9]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Z[100],Q([8,9]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Z[101],Q([8,9]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[102],Q([8,9]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[103],Q([8,9]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Z[104],Q([0,1,75,49,16,14,35,18,11]),function(x,e,N,D,R,T,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,T.dirname)(R.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,w.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,N.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(g.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,w.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,w.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=O.env.VSCODE_PORTABLE;return E?g.URI.file((0,T.join)(E,"argv.json")):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,T.resolve)(E):(0,T.normalize)((0,T.join)(R.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const E=this.args["extensions-download-dir"];return E?g.URI.file((0,T.resolve)(E)):g.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,T.resolve)(E);const A=O.env.VSCODE_EXTENSIONS;if(A)return A;const d=O.env.VSCODE_PORTABLE;return d?(0,T.join)(d,"extensions"):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(A=>/^[^:/?#]+?:\/\//.test(A)?g.URI.parse(A):g.URI.file((0,T.normalize)(A)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?g.URI.parse(E):g.URI.file((0,T.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(E=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(E))}get extensionLogLevel(){const E=[];for(const A of this.args.log||[]){const d=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(A);d&&d[1]&&d[2]&&E.push([d[1],d[2]])}return E.length?E:void 0}get serviceMachineIdResource(){return(0,w.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=O.env.VSCODE_PORTABLE;return E?g.URI.file((0,T.join)(E,"policy.json")):(0,w.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(E){this.args.continueOn=E}get args(){return this.a}constructor(E,A,d){this.a=E,this.b=A,this.c=d,this.editSessionId=this.args.editSessionId}}fe([D.memoize],c.prototype,"appRoot",null),fe([D.memoize],c.prototype,"userHome",null),fe([D.memoize],c.prototype,"userDataPath",null),fe([D.memoize],c.prototype,"appSettingsHome",null),fe([D.memoize],c.prototype,"tmpDir",null),fe([D.memoize],c.prototype,"cacheHome",null),fe([D.memoize],c.prototype,"stateResource",null),fe([D.memoize],c.prototype,"userRoamingDataHome",null),fe([D.memoize],c.prototype,"userDataSyncHome",null),fe([D.memoize],c.prototype,"userDataSyncLogResource",null),fe([D.memoize],c.prototype,"editSessionsLogResource",null),fe([D.memoize],c.prototype,"sync",null),fe([D.memoize],c.prototype,"machineSettingsResource",null),fe([D.memoize],c.prototype,"workspaceStorageHome",null),fe([D.memoize],c.prototype,"localHistoryHome",null),fe([D.memoize],c.prototype,"keyboardLayoutResource",null),fe([D.memoize],c.prototype,"argvResource",null),fe([D.memoize],c.prototype,"isExtensionDevelopment",null),fe([D.memoize],c.prototype,"untitledWorkspacesHome",null),fe([D.memoize],c.prototype,"installSourcePath",null),fe([D.memoize],c.prototype,"builtinExtensionsPath",null),fe([D.memoize],c.prototype,"extensionsPath",null),fe([D.memoize],c.prototype,"extensionDevelopmentLocationURI",null),fe([D.memoize],c.prototype,"extensionDevelopmentKind",null),fe([D.memoize],c.prototype,"extensionTestsLocationURI",null),fe([D.memoize],c.prototype,"debugExtensionHost",null),fe([D.memoize],c.prototype,"logLevel",null),fe([D.memoize],c.prototype,"extensionLogLevel",null),fe([D.memoize],c.prototype,"serviceMachineIdResource",null),fe([D.memoize],c.prototype,"telemetryLogResource",null),fe([D.memoize],c.prototype,"disableWorkspaceTrust",null),fe([D.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function S(k,E){return h(k["inspect-extensions"],k["inspect-brk-extensions"],5870,E,k.debugId,k.extensionEnvironment)}e.parseExtensionHostPort=S;function p(k,E){return h(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,E,k.extensionEnvironment)}e.parsePtyHostPort=p;function h(k,E,A,d,l,v){const m=Number(E||k)||(d?null:A),y=m?Boolean(!!E):!1;let t;if(v)try{t=JSON.parse(v)}catch{}return{port:m,break:y,debugId:l,env:t}}}),function(){"use strict";function x(e,N,D){function R(O,w){const g=T(O,w),c=[g];return e.isAbsolute(g)||c.unshift(D),e.resolve(...c)}function T(O,w){process.env.VSCODE_DEV&&(w="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,w);const S=O["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(p,"AppData","Roaming")}break;case"darwin":c=e.join(N.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,w)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[105],Q([157,33,35]),function(e,N,D){return x(e,N,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=x(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[106],Q([0,1,33,104,105]),function(x,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends D.AbstractNativeEnvironmentService{constructor(w,g){super(w,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,R.getUserDataPath)(w,g.nameShort)},g)}}e.NativeEnvironmentService=T}),define(Z[107],Q([0,1,3,90]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(O,w,g){try{T(O,w,g)}catch(c){console.error(c?.message??c)}return O}e.localizeManifest=R;function T(O,w,g){const c=(S,p,h)=>{const k=S[p];if((0,N.isString)(k)){const E=k,A=E.length;if(A>1&&E[0]==="%"&&E[A-1]==="%"){const d=E.substr(1,A-2);let l=w[d];l===void 0&&g&&(l=g[d]);const v=typeof l=="string"?l:l?.message,b=g?.[d],m=typeof b=="string"?b:b?.message;if(!v){m||console.warn(`[${O.name}]: ${(0,D.localize)(0,null,d)}`);return}if(h&&(p==="title"||p==="category")&&m&&m!==v){const y={value:v,original:m};S[p]=y}else S[p]=v}}else if((0,N.isObject)(k))for(const E in k)k.hasOwnProperty(E)&&(E==="commands"?c(k,E,!0):c(k,E,h));else if(Array.isArray(k))for(let E=0;E<k.length;E++)c(k,E,h)};for(const S in O)O.hasOwnProperty(S)&&c(O,S)}}),define(Z[108],Q([0,1,7]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this.a=new Map}register(T,O){this.a.set(T,O)}updateManifest(T){if(!(typeof T.main>"u"&&typeof T.browser>"u")&&(T.activationEvents===void 0&&Object.assign(T,{activationEvents:[]}),!(!Array.isArray(T.activationEvents)||!T.contributes)))for(const O in T.contributes){const w=this.a.get(O);if(!w)continue;const g=T.contributes[O],c=Array.isArray(g)?g:[g];try{w(c,T.activationEvents)}catch(S){(0,N.onUnexpectedError)(S)}}}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(Z[45],Q([0,1,18,53,94,41]),function(x,e,N,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function g(l){return l=l.trim(),l==="*"||O.test(l)}e.isValidVersionStr=g;function c(l){if(!g(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=l.match(O);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=c;function S(l){if(!l)return null;const v=l.majorBase,b=l.majorMustEqual,m=l.minorBase;let y=l.minorMustEqual;const t=l.patchBase;let s=l.patchMustEqual;l.hasCaret&&(v===0||(y=!1),s=!1);let i=0;if(l.preRelease){const n=w.exec(l.preRelease);if(n){const[,r,o,a]=n;i=Date.UTC(Number(r),Number(o)-1,Number(a))}}return{majorBase:v,majorMustEqual:b,minorBase:m,minorMustEqual:y,patchBase:t,patchMustEqual:s,isMinimum:l.hasGreaterEquals,notBefore:i}}e.normalizeVersion=S;function p(l,v,b){let m;typeof l=="string"?m=S(c(l)):m=l;let y;v instanceof Date?y=v.getTime():typeof v=="string"&&(y=new Date(v).getTime());let t;if(typeof b=="string"?t=S(c(b)):t=b,!m||!t)return!1;const s=m.majorBase,i=m.minorBase,n=m.patchBase;let r=t.majorBase,o=t.minorBase,a=t.patchBase;const u=t.notBefore;let f=t.majorMustEqual,L=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?s>r?!0:s<r?!1:i>o?!0:i<o||y&&y<u?!1:n>=a:(s===1&&r===0&&(!f||!L||!F)&&(r=1,o=0,a=0,f=!0,L=!1,F=!1),s<r?!1:s>r?!f:i<o?!1:i>o?!L:n<a?!1:n>a?!F:!(y&&y<u))}e.isValidVersion=p;function h(l,v,b,m,y){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([D.default.Error,R.localize(0,null)]),t;if(typeof m.name!="string")return t.push([D.default.Error,R.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([D.default.Error,R.localize(2,null,"version")]),t;if(!m.engines)return t.push([D.default.Error,R.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([D.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!d(m.extensionDependencies))return t.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!d(m.activationEvents))return t.push([D.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([D.default.Error,R.localize(7,null,"activationEvents","main")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([D.default.Error,R.localize(9,null,"main")]),t;{const n=(0,N.joinPath)(b,m.main);(0,N.isEqualOrParent)(n,b)||t.push([D.default.Warning,R.localize(10,null,n.path,b.path)])}if(typeof m.activationEvents>"u")return t.push([D.default.Error,R.localize(11,null,"activationEvents","main")]),t}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([D.default.Error,R.localize(12,null,"browser")]),t;{const n=(0,N.joinPath)(b,m.browser);(0,N.isEqualOrParent)(n,b)||t.push([D.default.Warning,R.localize(13,null,n.path,b.path)])}if(typeof m.activationEvents>"u")return t.push([D.default.Error,R.localize(14,null,"activationEvents","browser")]),t}if(!T.valid(m.version))return t.push([D.default.Error,R.localize(15,null)]),t;const s=[];if(!k(l,v,m,y,s))for(const n of s)t.push([D.default.Error,n]);return t}e.validateExtensionManifest=h;function k(l,v,b,m,y){return m||typeof b.main>"u"&&typeof b.browser>"u"?!0:A(l,v,b.engines.vscode,y)}e.isValidExtensionVersion=k;function E(l,v,b){return l==="*"||A(v,b,l)}e.isEngineValid=E;function A(l,v,b,m=[]){const y=S(c(b));if(!y)return m.push(R.localize(16,null,b)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return m.push(R.localize(17,null,b)),!1}else if(!y.majorMustEqual)return m.push(R.localize(18,null,b)),!1;return p(l,v,y)?!0:(m.push(R.localize(19,null,l,b)),!1)}function d(l){if(!Array.isArray(l))return!1;for(let v=0,b=l.length;v<b;v++)if(typeof l[v]!="string")return!1;return!0}}),define(Z[109],Q([0,1,15,31]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(T,O,w){let g=w&&w.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const S=(await O.readFile(T.serviceMachineIdResource)).value.toString();g=(0,D.isUUID)(S)?S:null}catch{g=null}if(!g){g=(0,D.generateUuid)();try{await O.writeFile(T.serviceMachineIdResource,N.VSBuffer.fromString(g))}catch{}}return w?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=R}),define(Z[46],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class N{constructor(R,T=[],O=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=N}),define(Z[110],Q([0,1,46]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const D=[];var R;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function T(w,g,c){g instanceof N.SyncDescriptor||(g=new N.SyncDescriptor(g,[],Boolean(c))),D.push([w,g])}e.registerSingleton=T;function O(){return D}e.getSingletonServiceDescriptors=O}),define(Z[111],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class N{constructor(T,O){this.key=T,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=N;class D{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const O of this.a.values())O.outgoing.size===0&&T.push(O);return T}insertEdge(T,O){const w=this.lookupOrInsertNode(T),g=this.lookupOrInsertNode(O);w.outgoing.set(g.key,g),g.incoming.set(w.key,w)}removeNode(T){const O=this.b(T);this.a.delete(O);for(const w of this.a.values())w.outgoing.delete(O),w.incoming.delete(O)}lookupOrInsertNode(T){const O=this.b(T);let w=this.a.get(O);return w||(w=new N(O,T),this.a.set(O,w)),w}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[O,w]of this.a)T.push(`${O}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,O]of this.a){const w=new Set([T]),g=this.c(O,w);if(g)return g}}c(T,O){for(const[w,g]of T.outgoing){if(O.has(w))return[...O,w].join(" -> ");O.add(w);const c=this.c(g,O);if(c)return c;O.delete(w)}}}e.Graph=D}),define(Z[23],Q([0,1,3,11,10]),function(x,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function T(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}e.isConfigurationOverrides=T;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=O;var w;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function c(l,v){const b=Object.create(null);for(const m in l)S(b,m,l[m],v);return b}e.toValuesTree=c;function S(l,v,b,m){const y=v.split("."),t=y.pop();let s=l;for(let i=0;i<y.length;i++){const n=y[i];let r=s[n];switch(typeof r){case"undefined":r=s[n]=Object.create(null);break;case"object":break;default:m(`Ignoring ${v} as ${y.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[t]=b}catch{m(`Ignoring ${v} as ${y.join(".")} is ${JSON.stringify(s)}`)}else m(`Ignoring ${v} as ${y.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=S;function p(l,v){const b=v.split(".");h(l,b)}e.removeFromValueTree=p;function h(l,v){const b=v.shift();if(v.length===0){delete l[b];return}if(Object.keys(l).indexOf(b)!==-1){const m=l[b];typeof m=="object"&&!Array.isArray(m)&&(h(m,v),Object.keys(m).length===0&&delete l[b])}}function k(l,v,b){function m(s,i){let n=s;for(const r of i){if(typeof n!="object"||n===null)return;n=n[r]}return n}const y=v.split("."),t=m(l,y);return typeof t>"u"?b:t}e.getConfigurationValue=k;function E(l,v,b){Object.keys(v).forEach(m=>{m!=="__proto__"&&(m in l?N.isObject(l[m])&&N.isObject(v[m])?E(l[m],v[m],b):b&&(l[m]=v[m]):l[m]=v[m])})}e.merge=E;function A(l,v,b){const m=l.inspect(v),y=l.inspect(b);return typeof m.userValue<"u"||typeof m.workspaceValue<"u"||typeof m.workspaceFolderValue<"u"?m.value:typeof y.userValue<"u"||typeof y.workspaceValue<"u"||typeof y.workspaceFolderValue<"u"?y.value:m.defaultValue}e.getMigratedSettingValue=A;function d(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Z[58],Q([0,1,10]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,N.createDecorator)("downloadService")}),define(Z[17],Q([0,1,10]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,N.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,N.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[24],Q([0,1,88,10]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function T(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function O(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function w(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function g(l,v,b){return w(v,b)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===b?!0:c(b).includes(l)}e.isTargetPlatformCompatible=g;function c(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function S(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=S;var p;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var k;(function(l){l.Install="install",l.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var E;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var A;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(A=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(v,b){super(v),this.code=b,this.name=b}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,N.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,N.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[59],Q([0,1,10]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,N.createDecorator)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((T,O)=>x(["node-vsce-sign"],async w=>T(w),O))),this.a}async verify(T,O){let w;try{w=await this.b()}catch{return!1}return w.verify(T,O)}}e.ExtensionSignatureVerificationService=D}),define(Z[60],Q([0,1,15,7,96,13]),function(x,e,N,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(S,p,h,k,E,A){let d;try{await w(S,p,h,k,E,A)}catch(l){d=l}finally{d&&E.errorTransformer&&(d=E.errorTransformer(d)),typeof d<"u"&&h.error(d),h.end()}}e.readFileIntoStream=O;async function w(S,p,h,k,E,A){g(A);const d=await S.open(p,{create:!1});try{g(A);let l=0,v=0,b=E&&typeof E.length=="number"?E.length:void 0,m=N.VSBuffer.alloc(Math.min(E.bufferSize,typeof b=="number"?b:E.bufferSize)),y=E&&typeof E.position=="number"?E.position:0,t=0;do v=await S.read(d,y,m.buffer,t,m.byteLength-t),y+=v,t+=v,l+=v,typeof b=="number"&&(b-=v),t===m.byteLength&&(await h.write(k(m)),m=N.VSBuffer.alloc(Math.min(E.bufferSize,typeof b=="number"?b:E.bufferSize)),t=0);while(v>0&&(typeof b!="number"||b>0)&&g(A)&&c(l,E));if(t>0){let s=t;typeof b=="number"&&(s=Math.min(t,b)),h.write(k(m.slice(0,s)))}}catch(l){throw(0,T.ensureFileSystemProviderError)(l)}finally{await S.close(d)}}function g(S){if(S.isCancellationRequested)throw(0,D.canceled)();return!0}function c(S,p){if(p?.limits){if(typeof p.limits.memory=="number"&&S>p.limits.memory)throw(0,T.createFileSystemProviderError)((0,R.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof p.limits.size=="number"&&S>p.limits.size)throw(0,T.createFileSystemProviderError)((0,R.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[112],Q([0,1,4,158,2,12,159]),function(x,e,N,D,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class w extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new N.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new N.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=N.Event.None,this.c=new Map,this.f=!1}async watch(c){const S=this.i(c),p=S.filter(k=>{const E=this.c.get(k.path);return E?!(0,D.patternsEquals)(E.request.excludes,k.excludes)||!(0,D.patternsEquals)(E.request.includes,k.includes):!0}),h=Array.from(this.c.values()).filter(({request:k})=>!S.find(E=>E.path===k.path&&(0,D.patternsEquals)(E.excludes,k.excludes)&&(0,D.patternsEquals)(E.includes,k.includes))).map(({request:k})=>k.path);p.length&&this.j(`Request to start watching: ${p.map(k=>`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"})`).join(",")}`),h.length&&this.j(`Request to stop watching: ${h.join(",")}`);for(const k of h)this.h(k);for(const k of p)this.g(k)}g(c){const S=new O.NodeJSFileWatcherLibrary(c,h=>this.a.fire(h),h=>this.b.fire(h),this.f),p={request:c,instance:S};this.c.set(c.path,p)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const S=this.c.get(c);S&&(this.c.delete(c),S.instance.dispose())}i(c){const S=new Map;for(const p of c){const h=T.isLinux?p.path:p.path.toLowerCase();S.set(h,p)}return Array.from(S.values())}async setVerboseLogging(c){this.f=c;for(const[,S]of this.c)S.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,S){return S?`[File Watcher (node.js)] ${c} (path: ${S.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=w}),define(Z[113],Q([0,1,61,112]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends N.AbstractNonRecursiveWatcherClient{constructor(O,w,g){super(O,w,g),this.m()}l(){return new D.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(Z[114],Q([0,1,16,56,83,61]),function(x,e,N,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends T.AbstractUniversalWatcherClient{constructor(g,c,S){super(g,c,S),this.m()}l(g){const c=g.add(new R.Client(N.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(c.onDidProcessExit(({code:S,signal:p})=>this.n(`terminated by itself with code ${S}, signal: ${p}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(Z[62],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class N{constructor(...R){this.a=new Map;for(const[T,O]of R)this.set(T,O)}set(R,T){const O=this.a.get(R);return this.a.set(R,T),O}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.ServiceCollection=N}),define(Z[115],Q([0,1,5,7,2,46,111,10,62,160]),function(x,e,N,D,R,T,O,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class p extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class h{constructor(d=new g.ServiceCollection,l=!1,v,b=S){this.f=d,this.g=l,this.h=v,this.i=b,this.o=new Set,this.f.set(w.IInstantiationService,this),this._globalGraph=b?v?._globalGraph??new O.Graph(m=>m):void 0}createChild(d){return new h(d,this.g,this,this.i)}invokeFunction(d,...l){const v=E.traceInvocation(this.i,d);let b=!1;try{return d({get:y=>{if(b)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(y,v);if(!t)throw new Error(`[invokeFunction] unknown service '${y}'`);return t}},...l)}finally{b=!0,v.stop()}}createInstance(d,...l){let v,b;return d instanceof T.SyncDescriptor?(v=E.traceCreation(this.i,d.ctor),b=this.j(d.ctor,d.staticArguments.concat(l),v)):(v=E.traceCreation(this.i,d),b=this.j(d,l,v)),v.stop(),b}j(d,l=[],v){const b=w._util.getServiceDependencies(d).sort((t,s)=>t.index-s.index),m=[];for(const t of b){const s=this.m(t.id,v);s||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(s)}const y=b.length>0?b[0].index:l.length;if(l.length!==y){console.trace(`[createInstance] First service dependency of ${d.name} at position ${y+1} conflicts with ${l.length} static arguments`);const t=y-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,y)}return Reflect.construct(d,l.concat(m))}k(d,l){if(this.f.get(d)instanceof T.SyncDescriptor)this.f.set(d,l);else if(this.h)this.h.k(d,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const l=this.f.get(d);return!l&&this.h?this.h.l(d):l}m(d,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const v=this.l(d);return v instanceof T.SyncDescriptor?this.q(d,v,l.branch(d,!0)):(l.branch(d,!1),v)}q(d,l,v){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,l,v)}finally{this.o.delete(d)}}r(d,l,v){const b=new O.Graph(t=>t.id.toString());let m=0;const y=[{id:d,desc:l,_trace:v}];for(;y.length;){const t=y.pop();if(b.lookupOrInsertNode(t),m++>1e3)throw new p(b);for(const s of w._util.getServiceDependencies(t.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),i instanceof T.SyncDescriptor){const n={id:s.id,desc:i,_trace:t._trace.branch(s.id,!0)};b.insertEdge(t,n),y.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new p(b);break}for(const{data:s}of t){if(this.l(s.id)instanceof T.SyncDescriptor){const n=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,n)}b.removeNode(s)}}return this.l(d)}s(d,l,v=[],b,m){if(this.f.get(d)instanceof T.SyncDescriptor)return this.t(d,l,v,b,m);if(this.h)return this.h.s(d,l,v,b,m);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(d,l,v=[],b,m){if(b){const y=new h(void 0,this.g,this,this.i);y.c=String(d);const t=new Map,s=new N.IdleValue(()=>{const i=y.j(l,v,m);for(const[n,r]of t){const o=i[n];if(typeof o=="function")for(const a of r)o.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new c.LinkedList,t.set(n,a)),(f,L,F)=>{const Y=a.push([f,L,F]);return(0,R.toDisposable)(Y)}}if(n in i)return i[n];const r=s.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),i[n]=o),o},set(i,n,r){return s.value[n]=r,!0},getPrototypeOf(i){return l.prototype}})}else return this.j(l,v,m)}u(d,l){if(l&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=h;var k;(function(A){A[A.None=0]="None",A[A.Creation=1]="Creation",A[A.Invocation=2]="Invocation",A[A.Branch=3]="Branch"})(k||(k={}));class E{static traceInvocation(d,l){return d?new E(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(d,l){return d?new E(1,l.name):E.c}constructor(d,l){this.type=d,this.name=l,this.g=Date.now(),this.h=[]}branch(d,l){const v=new E(3,d.toString());return this.h.push([d,l,v]),v}stop(){const d=Date.now()-this.g;E.f+=d;let l=!1;function v(m,y){const t=[],s=new Array(m+1).join("	");for(const[i,n,r]of y.h)if(n&&r){l=!0,t.push(`${s}CREATES -> ${i}`);const o=v(m+1,r);o&&t.push(o)}else t.push(`${s}uses -> ${i}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(d>2||l)&&E.all.add(b.join(`
`))}}e.Trace=E,E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0});var _=this&&this.__param||function(x,e){return function(N,D){e(N,D,x)}};define(Z[63],Q([0,1,22,2,12,98,24,10]),function(x,e,N,D,R,T,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function g(S){return S.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=g,e.ILanguagePackService=(0,w.createDecorator)("languagePackService");let c=class extends D.Disposable{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new N.CancellationTokenSource;setTimeout(()=>p.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const E=h.firstPage.filter(A=>A.properties.localizedLanguages?.length&&A.tags.some(d=>d.startsWith("lp-"))).map(A=>{const d=A.properties.localizedLanguages?.[0],l=g(A);return{...this.f(l,d,A),extensionId:A.identifier.id,galleryExtension:A}});return E.push({...this.f("en","English"),extensionId:"default"}),E}f(p,h,k){const E=h??p;let A;if(E!==p&&(A=`(${p})`),p.toLowerCase()===R.language.toLowerCase()&&(A??="",A+=(0,T.localize)(0,null)),k?.installCount){A??="";const d=k.installCount;let l;d>1e6?l=`${Math.floor(d/1e5)/10}M`:d>1e3?l=`${Math.floor(d/1e3)}K`:l=String(d),A+=` $(cloud-download) ${l}`}return{id:p,label:E,description:A}}};c=fe([_(0,O.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(Z[6],Q([0,1,34,4,2,36,12,3,11,10]),function(x,e,N,D,R,T,O,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setLogLevel=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,c.createDecorator)("logService"),e.ILoggerService=(0,c.createDecorator)("loggerService");function S(){return new Date().toISOString()}function p(u){return(0,w.isNumber)(u)}e.isLogLevel=p;var h;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function k(u,f,L){switch(f){case h.Trace:u.trace(L);break;case h.Debug:u.debug(L);break;case h.Info:u.info(L);break;case h.Warning:u.warn(L);break;case h.Error:u.error(L);break;case h.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=k;function E(u){let f="";for(let L=0;L<u.length;L++){let F=u[L];if(typeof F=="object")try{F=JSON.stringify(F)}catch{}f+=(L>0?" ":"")+F}return f}e.format=E;class A extends R.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new D.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==h.Off&&this.b<=f}}e.AbstractLogger=A;class d extends A{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...L){this.f(h.Trace)&&this.g(h.Trace,E([f,...L]))}debug(f,...L){this.f(h.Debug)&&this.g(h.Debug,E([f,...L]))}info(f,...L){this.f(h.Info)&&this.g(h.Info,E([f,...L]))}warn(f,...L){this.f(h.Warning)&&this.g(h.Warning,E([f,...L]))}error(f,...L){if(this.f(h.Error))if(f instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=f.stack,this.g(h.Error,E(F))}else this.g(h.Error,E([f,...L]))}flush(){}}e.AbstractMessageLogger=d;class l extends A{constructor(f=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(f),this.g=!O.isWindows}trace(f,...L){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,f,...L):console.log(`[main ${S()}]`,f,...L))}debug(f,...L){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,f,...L):console.log(`[main ${S()}]`,f,...L))}info(f,...L){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,f,...L):console.log(`[main ${S()}]`,f,...L))}warn(f,...L){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,f,...L):console.warn(`[main ${S()}]`,f,...L))}error(f,...L){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,f,...L):console.error(`[main ${S()}]`,f,...L))}dispose(){}flush(){}}e.ConsoleMainLogger=l;class v extends A{constructor(f=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(f)}trace(f,...L){this.f(h.Trace)&&console.log("%cTRACE","color: #888",f,...L)}debug(f,...L){this.f(h.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",f,...L)}info(f,...L){this.f(h.Info)&&console.log("%c INFO","color: #33f",f,...L)}warn(f,...L){this.f(h.Warning)&&console.log("%c WARN","color: #993",f,...L)}error(f,...L){this.f(h.Error)&&console.log("%c  ERR","color: #f33",f,...L)}dispose(){}flush(){}}e.ConsoleLogger=v;class b extends A{constructor(f,L=e.DEFAULT_LOG_LEVEL){super(),this.g=f,this.setLevel(L)}trace(f,...L){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(f),...L])}debug(f,...L){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(f),...L])}info(f,...L){this.f(h.Info)&&this.g.log(h.Info,[this.h(f),...L])}warn(f,...L){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(f),...L])}error(f,...L){this.f(h.Error)&&this.g.log(h.Error,[this.h(f),...L])}h(f){return typeof f=="string"?f:(0,N.toErrorMessage)(f,this.f(h.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class m extends A{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const L of this.g)L.setLevel(f);super.setLevel(f)}trace(f,...L){for(const F of this.g)F.trace(f,...L)}debug(f,...L){for(const F of this.g)F.debug(f,...L)}info(f,...L){for(const F of this.g)F.info(f,...L)}warn(f,...L){for(const F of this.g)F.warn(f,...L)}error(f,...L){for(const F of this.g)F.error(f,...L)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.MultiplexLogger=m;class y extends R.Disposable{constructor(f,L){if(super(),this.j=f,this.b=new T.ResourceMap,this.c=new T.ResourceMap,this.f=this.B(new D.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new D.Emitter),this.onDidChangeVisibility=this.h.event,L)for(const F of L)this.c.set(F.resource,F)}getLogger(f){return this.b.get(f)}createLogger(f,L,F){let Y=this.b.get(f);if(!Y){const J=L?.logLevel==="always"?h.Trace:L?.logLevel;Y=this.k(f,J??this.getLogLevel(f)??this.j,L),this.b.set(f,Y),F||this.registerLogger({resource:f,id:L?.id??f.toString(),logLevel:J,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId})}return Y}setLogLevel(f,L){if(g.URI.isUri(f)){const F=f,Y=L,J=this.c.get(F);J&&Y!==J.logLevel&&(J.logLevel=Y===this.j?void 0:Y,this.b.get(F)?.setLevel(Y),this.c.set(J.resource,J),this.g.fire([F,Y]))}else{this.j=f;for(const[F,Y]of this.b.entries())this.c.get(F)?.logLevel===void 0&&Y.setLevel(this.j);this.g.fire(this.j)}}setVisibility(f,L){const F=this.c.get(f);F&&L!==!F.hidden&&(F.hidden=!L,this.c.set(F.resource,F),this.h.fire([f,L]))}getLogLevel(f){let L;return f&&(L=this.c.get(f)?.logLevel),L??this.j}registerLogger(f){const L=this.c.get(f.resource);L?L.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.c.set(f.resource,f),this.f.fire({added:[f],removed:[]}))}deregisterLogger(f){const L=this.c.get(f);if(L){this.c.delete(f);const F=this.b.get(f);F&&(this.b.delete(f),F.dispose()),this.f.fire({added:[],removed:[L]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(f){return this.c.get(f)}dispose(){this.b.forEach(f=>f.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=y;class t{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(f){}getLevel(){return h.Info}trace(f,...L){}debug(f,...L){}info(f,...L){}warn(f,...L){}error(f,...L){}critical(f,...L){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;class i extends y{constructor(){super(h.Info)}k(f,L,F){return new t}}e.NullLoggerService=i;function n(u){if(u.verbose)return h.Trace;if(typeof u.logLevel=="string"){const f=o(u.logLevel.toLowerCase());if(f!==void 0)return f}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(u){switch(u){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.LogLevelToString=r;function o(u){switch(u){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.parseLogLevel=o;function a(u,f){p(f)?u.setLogLevel(f):u.setLogLevel(f[0],f[1])}e.setLogLevel=a}),define(Z[116],Q([0,1,19,5,7,4,2,14,61,6]),function(x,e,N,D,R,T,O,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends O.Disposable{constructor(h,k){super(),this.a=h,this.b=k,this.c=this.B(new T.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new T.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new D.ThrottledDelayer(0)),this.s=[],this.t=this.B(new D.ThrottledDelayer(0))}watch(h,k){return k.recursive||this.b?.watcher?.forceUniversal?this.l(h,k):this.u(h,k)}l(h,k){const E={path:this.C(h),excludes:k.excludes,includes:k.includes,recursive:k.recursive},A=(0,N.insert)(this.j,E);return this.m(),(0,O.toDisposable)(()=>{A(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(h=>(0,R.onUnexpectedError)(h))}n(){this.h||(this.h=this.B(this.p(k=>this.c.fire((0,g.toFileChanges)(k)),k=>this.z(k),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const h=this.b?.watcher?.recursive?.usePolling;if(h===!0)for(const k of this.j)(0,g.isRecursiveWatchRequest)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const k of this.j)(0,g.isRecursiveWatchRequest)(k)&&h.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(h,k){const E={path:this.C(h),excludes:k.excludes,includes:k.includes,recursive:!1},A=(0,N.insert)(this.s,E);return this.v(),(0,O.toDisposable)(()=>{A(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(h=>(0,R.onUnexpectedError)(h))}w(){return this.r||(this.r=this.B(this.y(h=>this.c.fire((0,g.toFileChanges)(h)),h=>this.z(h),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(h){h.type==="error"&&this.g.fire(h.message),this.a[h.type](h.message)}C(h){return(0,w.normalize)(h.fsPath)}}e.AbstractDiskFileSystemProvider=S}),define(Z[117],Q([0,1,19,5,15,22,4,52,64,2,54,16,118,18,43,95,13,60,6,7]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A,d,l,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new O.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new O.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new O.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new D.ResourceQueue)}registerProvider(t,s){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${t}`);const i=new c.DisposableStore;return this.h.set(t,s),this.c.fire({added:!0,scheme:t,provider:s}),i.add(s.onDidChangeFile(n=>this.R.fire(new d.FileChangesEvent(n,!this.O(s))))),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:s}),this.h.delete(t),(0,c.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const s=[];this.f.fire({scheme:t,join(i){s.push(i)}}),!this.h.has(t)&&await D.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,s){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return g.Iterable.map(this.h,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async j(t){if(!(0,k.isAbsolutePath)(t))throw new d.FileOperationError((0,A.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const s=this.h.get(t.scheme);if(!s){const i=new b.ErrorNoTelemetry;throw i.message=(0,A.localize)(1,null,t.toString()),i}return s}async k(t){const s=await this.j(t);if((0,d.hasOpenReadWriteCloseCapability)(s)||(0,d.hasReadWriteCapability)(s)||(0,d.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const s=await this.j(t);if((0,d.hasOpenReadWriteCloseCapability)(s)||(0,d.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.n(t,s)}catch(i){throw(0,d.toFileSystemProviderErrorCode)(i)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,A.localize)(2,null,this.nb(t)),1):(0,d.ensureFileSystemProviderError)(i)}}async n(t,s){const i=await this.j(t),n=this.O(i),r=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,u=await i.stat(t);let f;return this.p(i,t,u,void 0,!!a,(L,F)=>(f||(f=S.TernarySearchTree.forUris(()=>!n),f.set(t,!0),r&&f.fill(!0,r)),f.get(L.resource)||f.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&o?F===1:!1))}async p(t,s,i,n,r,o){const{providerExtUri:a}=this.N(t),u={resource:s,name:a.basename(s),isFile:(i.type&d.FileType.File)!==0,isDirectory:(i.type&d.FileType.Directory)!==0,isSymbolicLink:(i.type&d.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&d.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,d.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(u.isDirectory&&o(u,n)){try{const f=await t.readdir(s),L=await D.Promises.settled(f.map(async([F,Y])=>{try{const J=a.joinPath(s,F),ee=r?await t.stat(J):{type:Y};return await this.p(t,J,ee,f.length,r,o)}catch(J){return this.b.trace(J),null}}));u.children=(0,N.coalesce)(L)}catch(f){this.b.trace(f),u.children=[]}return u}return u}async resolveAll(t){return D.Promises.settled(t.map(async s=>{try{return{stat:await this.n(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.j(t),i=await s.stat(t);return this.p(s,t,i,void 0,!0,()=>!1)}async exists(t){const s=await this.j(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.r(t,s)}catch(i){return i}return!0}async r(t,s){if(!s?.overwrite&&await this.exists(t))throw new d.FileOperationError((0,A.localize)(3,null,this.nb(t)),3,s)}async createFile(t,s=R.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,s);return this.m.fire(new d.FileOperationEvent(t,0,n)),n}async writeFile(t,s,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let a;if((0,d.hasReadWriteCapability)(n)&&!(s instanceof R.VSBuffer))if((0,E.isReadableStream)(s)){const u=await(0,E.peekStream)(s,3);u.ended?a=R.VSBuffer.concat(u.buffer):a=u}else a=(0,E.peekReadable)(s,u=>R.VSBuffer.concat(u),3);else a=s;!(0,d.hasOpenReadWriteCloseCapability)(n)||(0,d.hasReadWriteCapability)(n)&&a instanceof R.VSBuffer?await this.cb(n,t,i,a):await this.Y(n,t,i,a instanceof R.VSBuffer?(0,R.bufferToReadable)(a):a),this.m.fire(new d.FileOperationEvent(t,4))}catch(o){throw new d.FileOperationError((0,A.localize)(4,null,this.nb(t),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,s,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,A.localize)(5,null,this.nb(s)));let r;try{r=await t.stat(s)}catch{return}if((r.type&d.FileType.Directory)!==0)throw new d.FileOperationError((0,A.localize)(6,null,this.nb(s)),0,i);if(this.mb(s,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==d.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,d.etag)({mtime:i.mtime,size:r.size}))throw new d.FileOperationError((0,A.localize)(7,null),3,i);return r}async readFile(t,s,i){const n=await this.k(t);return s?.atomic?this.t(n,t,s,i):this.u(n,t,s,i)}async t(t,s,i,n){return new Promise((r,o)=>{this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,s,i,n);r(a)}catch(a){o(a)}})})}async u(t,s,i,n){const r=await this.v(t,s,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(t,s,i){const n=await this.k(t);return this.v(n,t,s,i)}async v(t,s,i,n){const r=new T.CancellationTokenSource(n),o=this.F(s,i).then(u=>u,u=>{throw r.cancel(),u});let a;try{return typeof i?.etag=="string"&&i.etag!==d.ETAG_DISABLED&&await o,i?.atomic&&(0,d.hasFileAtomicReadCapability)(t)||!((0,d.hasOpenReadWriteCloseCapability)(t)||(0,d.hasFileReadStreamCapability)(t))||(0,d.hasReadWriteCapability)(t)&&i?.preferUnbuffered?a=this.D(t,s,i):(0,d.hasFileReadStreamCapability)(t)?a=this.z(t,s,r.token,i):a=this.C(t,s,r.token,i),{...await o,value:a}}catch(u){throw a&&await(0,E.consumeStream)(a),this.w(u,s,i)}}w(t,s,i){const n=(0,A.localize)(8,null,this.nb(s),(0,d.ensureFileSystemProviderError)(t).toString());return t instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof d.TooLargeFileOperationError?new d.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new d.FileOperationError(n,(0,d.toFileOperationResult)(t),i)}z(t,s,i,n=Object.create(null)){const r=t.readFileStream(s,n,i);return(0,E.transform)(r,{data:o=>o instanceof R.VSBuffer?o:R.VSBuffer.wrap(o),error:o=>this.w(o,s,n)},o=>R.VSBuffer.concat(o))}C(t,s,i,n=Object.create(null)){const r=(0,R.newWriteableBufferStream)();return(0,l.readFileIntoStream)(t,s,r,o=>o,{...n,bufferSize:this.a,errorTransformer:o=>this.w(o,s,n)},i),r}D(t,s,i){const n=(0,E.newWriteableStream)(r=>R.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,d.hasFileAtomicReadCapability)(t)?r=await t.readFile(s,{atomic:!0}):r=await t.readFile(s),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(s,r.byteLength,i),n.end(R.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,s){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new d.FileOperationError((0,A.localize)(9,null,this.nb(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==d.ETAG_DISABLED&&s.etag===i.etag)throw new d.NotModifiedSinceFileOperationError((0,A.localize)(10,null),i,s);return this.G(t,i.size,s),i}G(t,s,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&s>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&s>i.limits.size&&(n=7),typeof n=="number")throw new d.TooLargeFileOperationError((0,A.localize)(11,null,this.nb(t)),n,s,i)}}async canMove(t,s,i){return this.H(t,s,"move",i)}async canCopy(t,s,i){return this.H(t,s,"copy",i)}async H(t,s,i,n){if(t.toString()!==s.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(s),s);await this.M(r,t,o,s,i,n)}catch(r){return r}return!0}async move(t,s,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(s),s),o=await this.I(n,t,r,s,"move",!!i),a=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new d.FileOperationEvent(t,o==="move"?2:3,a)),a}async copy(t,s,i){const n=await this.k(t),r=this.lb(await this.l(s),s),o=await this.I(n,t,r,s,"copy",!!i),a=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new d.FileOperationEvent(t,o==="copy"?3:2,a)),a}async I(t,s,i,n,r,o){if(s.toString()===n.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:u}=await this.M(t,s,i,n,r,o);if(a&&!u&&o&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,d.hasFileFolderCopyCapability)(t))await t.copy(s,n,{overwrite:o});else{const f=await this.resolve(s);f.isDirectory?await this.L(t,f,i,n):await this.J(t,s,i,n)}return r}else return t===i?(await t.rename(s,n,{overwrite:o}),r):(await this.I(t,s,i,n,"copy",o),await this.del(s,{recursive:!0}),"copy")}async J(t,s,i,n){if((0,d.hasOpenReadWriteCloseCapability)(t)&&(0,d.hasOpenReadWriteCloseCapability)(i))return this.eb(t,s,i,n);if((0,d.hasOpenReadWriteCloseCapability)(t)&&(0,d.hasReadWriteCapability)(i))return this.kb(t,s,i,n);if((0,d.hasReadWriteCapability)(t)&&(0,d.hasOpenReadWriteCloseCapability)(i))return this.ib(t,s,i,n);if((0,d.hasReadWriteCapability)(t)&&(0,d.hasReadWriteCapability)(i))return this.gb(t,s,i,n)}async L(t,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await D.Promises.settled(s.children.map(async r=>{const o=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,o):this.J(t,r.resource,i,o)}))}async M(t,s,i,n,r,o){let a=!1;if(t===i){const{providerExtUri:f,isPathCaseSensitive:L}=this.N(t);if(L||(a=f.isEqual(s,n)),a&&r==="copy")throw new Error((0,A.localize)(12,null,this.nb(s),this.nb(n)));if(!a&&f.isEqualOrParent(n,s))throw new Error((0,A.localize)(13,null,this.nb(s),this.nb(n)))}const u=await this.exists(n);if(u&&!a){if(!o)throw new d.FileOperationError((0,A.localize)(14,null,this.nb(s),this.nb(n)),4);if(t===i){const{providerExtUri:f}=this.N(t);if(f.isEqualOrParent(s,n))throw new Error((0,A.localize)(15,null,this.nb(s),this.nb(n)))}}return{exists:u,isSameResourceWithDifferentPathCase:a}}N(t){const s=this.O(t);return{providerExtUri:s?k.extUri:k.extUriIgnorePathCase,isPathCaseSensitive:s}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.lb(await this.j(t),t);await this.P(s,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new d.FileOperationEvent(t,0,i)),i}async P(t,s){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(s,n.dirname(s));)try{if(((await t.stat(s)).type&d.FileType.Directory)===0)throw new Error((0,A.localize)(16,null,this.nb(s)));break}catch(r){if((0,d.toFileSystemProviderErrorCode)(r)!==d.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(s)),s=n.dirname(s)}for(let r=i.length-1;r>=0;r--){s=n.joinPath(s,i[r]);try{await t.mkdir(s)}catch(o){if((0,d.toFileSystemProviderErrorCode)(o)!==d.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,s){try{await this.Q(t,s)}catch(i){return i}return!0}async Q(t,s){const i=this.lb(await this.j(t),t);if(!!s?.useTrash&&!(i.capabilities&4096))throw new Error((0,A.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new d.FileOperationError((0,A.localize)(18,null,this.nb(t)),1);if(!!!s?.recursive){const a=await this.resolve(t);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,A.localize)(19,null,this.nb(t)))}return i}async del(t,s){const i=await this.Q(t,s),n=!!s?.useTrash,r=!!s?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new d.FileOperationEvent(t,1))}async cloneFile(t,s){const i=await this.j(t),n=this.lb(await this.l(s),s);if(i===n&&this.N(i).providerExtUri.isEqual(t,s))return;if(i===n&&(0,d.hasFileCloneCapability)(i))return i.cloneFile(t,s);await this.P(n,this.N(n).providerExtUri.dirname(s));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,d.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,s,{overwrite:!0})):r.queue(()=>this.J(i,t,n,s))}watch(t,s={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,c.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,s);n?(0,c.dispose)(o):r=()=>(0,c.dispose)(o)}catch(o){this.b.error(o)}})(),i}async W(t,s){const i=await this.j(t),n=(0,w.hash)([this.N(i).providerExtUri.getComparisonKey(t),s]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,s)},this.U.set(n,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,E.isReadableStream)(n)||(0,E.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async Z(t,s,i){let n=0,r;if((0,E.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=R.VSBuffer.concat(i.buffer);await this.bb(t,s,o,o.byteLength,n,0),n+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,a)=>{(0,E.listenStream)(r,{onData:async u=>{r.pause();try{await this.bb(t,s,u,u.byteLength,n,0)}catch(f){return a(f)}n+=u.byteLength,setTimeout(()=>r.resume())},onError:u=>a(u),onEnd:()=>o()})})}async ab(t,s,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,s,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,s,i,n,r,o){let a=0;for(;a<n;)a+=await t.write(s,r+a,i.buffer,o+a,n-a)}async cb(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.db(t,s,i,n))}async db(t,s,i,n){let r;n instanceof R.VSBuffer?r=n:(0,E.isReadableStream)(n)?r=await(0,R.streamToBuffer)(n):(0,E.isReadableBufferedStream)(n)?r=await(0,R.bufferedStreamToBuffer)(n):r=(0,R.readableToBuffer)(n),await t.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,s,i,n))}async fb(t,s,i,n){let r,o;try{r=await t.open(s,{create:!1}),o=await i.open(n,{create:!0,unlock:!1});const a=R.VSBuffer.alloc(this.a);let u=0,f=0,L=0;do L=await t.read(r,u,a.buffer,f,a.byteLength-f),await this.bb(i,o,a,L,u,f),u+=L,f+=L,f===a.byteLength&&(f=0);while(L>0)}catch(a){throw(0,d.ensureFileSystemProviderError)(a)}finally{await D.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async gb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,s,i,n))}async hb(t,s,i,n){return i.writeFile(n,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async ib(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,s,i,n))}async jb(t,s,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const o=await t.readFile(s);await this.bb(i,r,R.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await i.close(r)}}async kb(t,s,i,n){const r=await(0,R.streamToBuffer)(this.C(t,s,T.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,s){if(t.capabilities&2048)throw new d.FileOperationError((0,A.localize)(20,null,this.nb(s)),6);return t}mb(t,s){if((s.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,A.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===p.Schemas.file?t.fsPath:t.toString(!0)}};m=fe([_(0,v.ILogService)],m),e.FileService=m}),define(Z[119],Q([0,1,120,161,5,36,15,4,162,2,14,12,18,43,20,97,13,60,116,34,114,113]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A,d,l,v,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(N)}catch(s){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(s)}`)}})();class t extends v.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=w.Event.None,this.H=new T.ResourceMap(r=>h.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,p.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await E.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await E.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,h.joinPath)(i,o.name))).type:a=this.G(o),r.push([o.name,a])}catch(a){this.a.trace(a)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=d.FileType.Unknown:i.isFile()?r=d.FileType.File:i.isDirectory()?r=d.FileType.Directory:r=d.FileType.Unknown,n&&(r|=d.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new R.Barrier;return this.H.set(i,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const o=this.C(i);return await E.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const o=(0,k.newWriteableStream)(a=>O.VSBuffer.concat(a.map(u=>O.VSBuffer.wrap(u))).buffer);return(0,l.readFileIntoStream)(this,i,o,a=>a.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(i,n,r){let o;try{const a=this.C(i);if(!r.create||!r.overwrite){if(await E.Promises.exists(a)){if(!r.overwrite)throw(0,d.createFileSystemProviderError)((0,A.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,d.createFileSystemProviderError)((0,A.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let o;(0,d.isFileOpenForWriteOptions)(n)&&(o=await this.I(i));let a;try{if((0,d.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:f}=await E.SymlinkSupport.stat(r);f.mode&128||await E.Promises.chmod(r,f.mode|128)}catch(f){this.a.trace(f)}let u;if((0,d.isFileOpenForWriteOptions)(n)){if(p.isWindows)try{await E.Promises.truncate(r,0),u="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}u||(u="w")}else u="r";a=await E.Promises.open(r,u)}catch(u){throw o?.dispose(),(0,d.isFileOpenForWriteOptions)(n)?await this.Z(i,u):this.Y(u)}if(this.L.set(a,0),(0,d.isFileOpenForWriteOptions)(n)&&this.N.set(a,i),o){const u=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.M.set(a,o),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),u.dispose())}return a}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await E.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await E.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,o,a){const u=this.P(i,n);let f=null;try{f=(await E.Promises.read(i,r,o,a,u)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(i,u,f)}return f}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const o=this.L.get(i);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,o+r):this.L.delete(i)))}async write(i,n,r,o,a){return(0,R.retry)(()=>this.R(i,n,r,o,a),100,3)}async R(i,n,r,o,a){const u=this.P(i,n);let f=null;try{f=(await E.Promises.write(i,r,o,a,u)).bytesWritten}catch(L){throw await this.Z(this.N.get(i),L)}finally{this.Q(i,u,f)}return f}async mkdir(i){try{await E.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const o=this.C(i),a=this.C(n);if(o!==a)try{await this.S(i,n,"move",r.overwrite),await E.Promises.move(o,a)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,A.localize)(2,null,(0,S.basename)(o),(0,S.basename)((0,S.dirname)(a)),u.toString()))),this.Y(u)}}async copy(i,n,r){const o=this.C(i),a=this.C(n);if(o!==a)try{await this.S(i,n,"copy",r.overwrite),await E.Promises.copy(o,a,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,A.localize)(3,null,(0,S.basename)(o),(0,S.basename)((0,S.dirname)(a)),u.toString()))),this.Y(u)}}async S(i,n,r,o){const a=this.C(i),u=this.C(n);let f=!1;if(!!(this.capabilities&1024)||(f=(0,g.isEqual)(a,u,!0)),f&&r==="copy")throw(0,d.createFileSystemProviderError)((0,A.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!f&&await E.Promises.exists(u)){if(!o)throw(0,d.createFileSystemProviderError)((0,A.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const o=this.C(i),a=this.C(n),u=!!(this.capabilities&1024);if((0,g.isEqual)(o,a,!u))return;const f=new c.DisposableStore;try{const[L,F]=await Promise.all([this.I(i),this.I(n)]);f.add(L),f.add(F),r&&await E.Promises.mkdir((0,S.dirname)(a),{recursive:!0}),await E.Promises.copyFile(o,a)}catch(L){if(L.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(L)}finally{f.dispose()}}p(i,n,r){return new m.UniversalWatcherClient(o=>i(o),o=>n(o),r)}y(i,n,r){return new y.NodeJSWatcherClient(o=>i(o),o=>n(o),r)}Y(i){if(i instanceof d.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await E.SymlinkSupport.stat(this.C(i));o.mode&128||(r=(0,d.createFileSystemProviderError)(n,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(Z[121],Q([0,1,2,6]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class R extends N.Disposable{constructor(O,w=[]){super(),this.a=new D.MultiplexLogger([O,...w]),this.B(O.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...w){this.a.trace(O,...w)}debug(O,...w){this.a.debug(O,...w)}info(O,...w){this.a.info(O,...w)}warn(O,...w){this.a.warn(O,...w)}error(O,...w){this.a.error(O,...w)}flush(){this.a.flush()}}e.LogService=R}),define(Z[122],Q([0,1,13,6]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var R;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(R||(R={}));async function T(c,S,p,h,k){try{const E=await new Promise((d,l)=>{x(["spdlog"],d,l)});E.setFlushOn(R.Trace);const A=await E.createAsyncRotatingLogger(c,S,p,h);return k?A.clearFormatters():A.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),A}catch(E){console.error(E)}return null}function O(c,S,p){switch(S){case D.LogLevel.Trace:c.trace(p);break;case D.LogLevel.Debug:c.debug(p);break;case D.LogLevel.Info:c.info(p);break;case D.LogLevel.Warning:c.warn(p);break;case D.LogLevel.Error:c.error(p);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function w(c,S){switch(S){case D.LogLevel.Trace:c.setLevel(R.Trace);break;case D.LogLevel.Debug:c.setLevel(R.Debug);break;case D.LogLevel.Info:c.setLevel(R.Info);break;case D.LogLevel.Warning:c.setLevel(R.Warning);break;case D.LogLevel.Error:c.setLevel(R.Error);break;case D.LogLevel.Off:c.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class g extends D.AbstractMessageLogger{constructor(S,p,h,k,E){super(),this.k=[],this.setLevel(E),this.l=this.n(S,p,h,k),this.B(this.onDidChangeLogLevel(A=>{this.m&&w(this.m,A)}))}async n(S,p,h,k){const E=h?6:1,A=30/E*N.ByteSize.MB,d=await T(S,p,A,E,k);if(d){this.m=d,w(this.m,this.getLevel());for(const{level:l,message:v}of this.k)O(this.m,l,v);this.k=[]}}g(S,p){this.m?O(this.m,S,p):this.getLevel()<=S&&this.k.push({level:S,message:p})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(Z[38],Q([0,1,4,64,2,10]),function(x,e,N,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class O extends R.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new N.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const S=Object.keys(this.f).length;return this.f={...c,...this.f},S!==Object.keys(this.f).length&&await this.i(c),D.Iterable.reduce(this.g.entries(),(p,[h,k])=>({...p,[h]:k}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[S,p])=>({...c,[S]:{definition:p,value:this.g.get(S)}}),{})}}e.AbstractPolicyService=O;class w{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=w}),define(Z[123],Q([0,1,5,4,64,3,13,6,38]),function(x,e,N,D,R,T,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(p,h){const k=[];for(const E of new Set(R.Iterable.concat(p.keys(),h.keys())))p.get(E)!==h.get(E)&&k.push(E);return k}let S=class extends g.AbstractPolicyService{constructor(h,k,E){super(),this.j=h,this.k=k,this.l=E,this.c=this.B(new N.ThrottledDelayer(500));const A=D.Event.filter(k.onDidFilesChange,d=>d.affects(h));this.B(k.watch(h)),this.B(A(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const h=new Map;try{const k=await this.k.readFile(this.j),E=JSON.parse(k.value.toString());if(!(0,T.isObject)(E))throw new Error("Policy file isn't a JSON object");for(const A of Object.keys(E))this.f[A]&&h.set(A,E[A])}catch(k){k.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",k)}return h}async p(){const h=await this.n(),k=c(this.g,h);this.g=h,k.length>0&&this.h.fire(k)}};S=fe([_(1,O.IFileService),_(2,w.ILogService)],S),e.FilePolicyService=S}),define(Z[28],Q([0,1,10]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,N.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[37],Q([0,1,70,3]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.a=new Map}add(O,w){N.ok(D.isString(O)),N.ok(D.isObject(w)),N.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,w)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.Registry=new R}),define(Z[124],Q([0,1,4,37]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class T{constructor(){this.b=new N.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,c){this.a[R(g)]=c,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const O=new T;D.Registry.add(e.Extensions.JSONContribution,O)}),define(Z[42],Q([0,1,19,4,3,86,23,124,37]),function(x,e,N,D,R,T,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const p=g.Registry.as(w.Extensions.JSONContribution);class h{constructor(){this.h=new Set,this.i=new D.Emitter,this.onDidSchemaChange=this.i.event,this.j=new D.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const i=new Set;this.n(t,s,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const s=new Set;this.o(t,s),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const i=new Set;this.o(s,i),this.n(t,!1,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const i=[];for(const{overrides:n,source:r}of t)for(const o in n)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const a=this.a.get(o),u=a?.valuesSources??new Map;if(r)for(const Y of Object.keys(n[o]))u.set(Y,r);const f={...a?.value||{},...n[o]};this.a.set(o,{source:r,value:f,valuesSources:u});const L=(0,O.getLanguageTagSettingPlainKey)(o),F={type:"object",default:f,description:T.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:R.isString(r)?void 0:r,defaultValueSource:r};i.push(...A(o)),this.d[o]=F,this.b.properties[o]=F}else{this.a.set(o,{value:n[o],source:r});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(i)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:i,source:n}of t)for(const r in i){const o=this.a.get(r),a=R.isString(n)?n:n?.id,u=R.isString(o?.source)?o?.source:o?.source?.id;if(a===u)if(s.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const f=this.d[r];f&&(this.w(r,f),this.r(r,f))}}this.u()}deltaConfiguration(t){let s=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,i){t.forEach(n=>{this.p(n,s,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,s){const i=n=>{if(n.properties)for(const r in n.properties){s.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,s=!0,i,n,r=3,o){r=R.isUndefinedOrNull(t.scope)?r:t.scope;const a=t.properties;if(a)for(const f in a){const L=a[f];if(s&&b(f,L)){delete a[f];continue}if(L.source=i,L.defaultDefaultValue=a[f].default,this.w(f,L),e.OVERRIDE_PROPERTY_REGEX.test(f)?L.scope=void 0:(L.scope=R.isUndefinedOrNull(L.scope)?r:L.scope,L.restricted=R.isUndefinedOrNull(L.restricted)?!!n?.includes(f):L.restricted),a[f].hasOwnProperty("included")&&!a[f].included){this.f[f]=a[f],delete a[f];continue}else this.d[f]=a[f],a[f].policy?.name&&this.e.set(a[f].policy.name,f);!a[f].deprecationMessage&&a[f].markdownDeprecationMessage&&(a[f].deprecationMessage=a[f].markdownDeprecationMessage),o.add(f)}const u=t.allOf;if(u)for(const f of u)this.p(f,s,i,n,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=i=>{const n=i.properties;if(n)for(const o in n)this.r(o,n[o]);i.allOf?.forEach(s)};s(t)}r(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,i={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}}v(){const t={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,s){const i=this.a.get(t);let n=i?.value,r=i?.source;R.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),R.isUndefined(n)&&(n=l(s.type)),s.default=n,s.defaultValueSource=r}}const k="\\[([^\\]]+)\\]",E=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function A(y){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(y)){let s=E.exec(y);for(;s?.length;){const i=s[1].trim();i&&t.push(i),s=E.exec(y)}}return(0,N.distinct)(t)}e.overrideIdentifiersFromKey=A;function d(y){return y.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=d;function l(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const v=new h;g.Registry.add(e.Extensions.Configuration,v);function b(y,t){return y.trim()?e.OVERRIDE_PROPERTY_REGEX.test(y)?T.localize(7,null,y):v.getConfigurationProperties()[y]!==void 0?T.localize(8,null,y):t.policy?.name&&v.getPolicyConfigurations().get(t.policy?.name)!==void 0?T.localize(9,null,y,t.policy?.name,v.getPolicyConfigurations().get(t.policy?.name)):null:T.localize(6,null)}e.validateProperty=b;function m(){const y=[],t=v.getConfigurationProperties();for(const s of Object.keys(t))y.push([s,t[s].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=m}),define(Z[65],Q([0,1,19,4,50,2,36,30,3,11,23,42,37]),function(x,e,N,D,R,T,O,w,g,c,S,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function k(s){return Object.isFrozen(s)?s:w.deepFreeze(s)}class E{constructor(i={},n=[],r=[],o){this.b=i,this.c=n,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof E)return n;const r=new A("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),o=n?this.rawConfiguration.getOverrideValue(i,n):void 0,a=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:o,merged:a}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,S.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return N.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return N.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=w.deepClone(this.contents),r=w.deepClone(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const u of i)if(a.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(n,u.contents);for(const f of u.overrides){const[L]=r.filter(F=>N.equals(F.identifiers,f.identifiers));L?(this.h(L.contents,f.contents),L.keys.push(...f.keys),L.keys=N.distinct(L.keys)):r.push(w.deepClone(f))}for(const f of u.keys)o.indexOf(f)===-1&&o.push(f)}return new E(n,o,r,a.every(u=>u instanceof E)?void 0:a)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of N.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[o];const u=n[o];u&&(typeof a=="object"&&typeof u=="object"?(a=w.deepClone(a),this.h(a,u)):a=u),r[o]=a}return new E(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&g.isObject(i[r])&&g.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=w.deepClone(n[r])}}i(i){let n=null,r=null;const o=a=>{a&&(r?this.h(r,a):r=w.deepClone(a))};for(const a of this.overrides)N.equals(a.identifiers,[i])?n=a.contents:a.identifiers.includes(i)&&o(a.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,S.removeFromValueTree)(this.contents,i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>N.equals(r.identifiers,(0,p.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,S.addToValueTree)(this.contents,i,n,o=>console.error(o)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,p.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,S.toValuesTree)(this.contents[i],o=>console.error(o))})}}e.ConfigurationModel=E;class A{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!g.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:o,overrides:a,restricted:u,hasExcludedProperties:f}=this.h(i,n);this.b=new E(r,o,a,f?[i]:void 0),this.c=u||[]}g(i){let n={},r=null,o=[];const a=[],u=[];function f(F){Array.isArray(o)?o.push(F):r!==null&&(o[r]=F)}const L={onObjectBegin:()=>{const F={};f(F),a.push(o),o=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const F=[];f(F),a.push(o),o=F,r=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:f,onError:(F,Y,J)=>{u.push({error:F,offset:Y,length:J})}};if(i)try{R.visit(i,L),n=o[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return n}h(i,n){const r=h.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),o=this.i(i,r,!0,n);i=o.raw;const a=(0,S.toValuesTree)(i,L=>console.error(`Conflict in settings file ${this.f}: ${L}`)),u=Object.keys(i),f=this.j(i,L=>console.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:a,keys:u,overrides:f,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(i,n,r,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const u={},f=[];for(const L in i)if(p.OVERRIDE_PROPERTY_REGEX.test(L)&&r){const F=this.i(i[L],n,!1,o);u[L]=F.raw,a=a||F.hasExcludedProperties,f.push(...F.restricted)}else{const F=n[L],Y=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&f.push(L),(Y===void 0||o.scopes===void 0||o.scopes.includes(Y))&&!(o.skipRestricted&&F?.restricted)?u[L]=i[L]:a=!0}return{raw:u,restricted:f,hasExcludedProperties:a}}j(i,n){const r=[];for(const o of Object.keys(i))if(p.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const u in i[o])a[u]=i[o][u];r.push({identifiers:(0,p.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,S.toValuesTree)(a,n)})}return r}}e.ConfigurationModelParser=A;class d extends T.Disposable{constructor(i,n,r,o){super(),this.f=i,this.g=n,this.h=o,this.c=this.B(new D.Emitter),this.onDidChange=this.c.event,this.a=new A(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(D.Event.any(D.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),D.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new E}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class l{constructor(i,n,r,o,a,u,f,L,F,Y,J,ee,ie){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=o,this.d=a,this.f=u,this.g=f,this.h=L,this.i=F,this.j=Y,this.k=J,this.l=ee,this.m=ie}get value(){return k(this.c)}n(i,n,r){const o=i.inspect(n,r);return{get value(){return k(o.value)},get override(){return k(o.override)},get merged(){return k(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class v{constructor(i,n,r,o,a=new E,u=new E,f=new O.ResourceMap,L=new E,F=new O.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=o,this.h=a,this.i=u,this.j=f,this.l=L,this.m=F,this.a=null,this.b=new O.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new E,this.m.set(r.resource,o))):o=this.l,n===void 0?o.removeValue(i):o.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const o=this.q(i,n,r),a=this.u(n.resource,r),u=n.resource?this.m.get(n.resource)||this.l:this.l,f=new Set;for(const L of o.overrides)for(const F of L.identifiers)o.getOverrideValue(i,F)!==void 0&&f.add(F);return new l(i,n,o.getValue(i),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,a||void 0,u)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:o,updated:a,removed:u}=y(this.c,i);n=[...o,...a,...u]}for(const o of n)for(const a of(0,p.overrideIdentifiersFromKey)(o)){const u=this.c.getKeysForOverrideIdentifier(a),f=i.getKeysForOverrideIdentifier(a),L=[...f.filter(F=>u.indexOf(F)===-1),...u.filter(F=>f.indexOf(F)===-1),...u.filter(F=>!w.equals(this.c.override(a).getValue(F),i.override(a).getValue(F)))];r.push([a,L])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:o}=y(this.d,i),a=[...n,...r,...o];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=y(this.applicationConfiguration,i),u=[...n,...r,...o];return u.length&&this.updateApplicationConfiguration(i),{keys:u,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=y(this.localUserConfiguration,i),u=[...n,...r,...o];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=y(this.remoteUserConfiguration,i),u=[...n,...r,...o];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=y(this.workspaceConfiguration,i),u=[...n,...r,...o];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:a}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:o,updated:a,removed:u,overrides:f}=y(r,n),L=[...o,...a,...u];return(L.length||!r)&&this.updateFolderConfiguration(i,n),{keys:L,overrides:f}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:a,overrides:u}=y(n,void 0);return{keys:[...r,...o,...a],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let o=this.r(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(o=o.merge(this.d)),o}r({resource:i},n){let r=this.s();if(n&&i){const o=n.getFolder(i);o&&(r=this.t(o.uri)||r);const a=this.m.get(i);a&&(r=r.merge(a))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),o=this.j.get(i);o?(n=r.merge(o),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:o,keys:a}=this.j.get(n);return i.push([n,{contents:r,overrides:o,keys:a}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),o=this.x(i.application),a=this.x(i.user),u=this.x(i.workspace),f=i.folders.reduce((L,F)=>(L.set(c.URI.revive(F[0]),this.x(F[1])),L),new O.ResourceMap);return new v(n,r,o,a,new E,u,f,new E,new O.ResourceMap)}static x(i){return new E(i.contents,i.keys,i.overrides)}}e.Configuration=v;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const o of s)o.keys.forEach(a=>i.add(a)),o.overrides.forEach(([a,u])=>{const f=(0,O.getOrSet)(n,a,new Set);u.forEach(L=>f.add(L))});const r=[];return n.forEach((o,a)=>r.push([a,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=b;class m{constructor(i,n,r,o){this.change=i,this.f=n,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of i.keys)this.affectedKeys.add(a);for(const[,a]of i.overrides)for(const u of a)this.affectedKeys.add(u);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=v.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,o=this.d.indexOf(r);if(o<0)return!1;const a=o+r.length;if(a>=this.d.length)return!1;const u=this.d.charCodeAt(a);if(u!==this.b&&u!==this.c)return!1;if(n){const f=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,L=this.g.getValue(i,n,this.h);return!w.equals(f,L)}return!0}}e.ConfigurationChangeEvent=m;function y(s,i){const{added:n,removed:r,updated:o}=t(i?.rawConfiguration,s?.rawConfiguration),a=[],u=s?.getAllOverrideIdentifiers()||[],f=i?.getAllOverrideIdentifiers()||[];if(i){const L=f.filter(F=>!u.includes(F));for(const F of L)a.push([F,i.getKeysForOverrideIdentifier(F)])}if(s){const L=u.filter(F=>!f.includes(F));for(const F of L)a.push([F,s.getKeysForOverrideIdentifier(F)])}if(i&&s){for(const L of u)if(f.includes(L)){const F=t({contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)},{contents:i.getOverrideValue(void 0,L)||{},keys:i.getKeysForOverrideIdentifier(L)});a.push([L,[...F.added,...F.removed,...F.updated]])}}return{added:n,removed:r,updated:o,overrides:a}}function t(s,i){const n=s?i?s.keys.filter(a=>i.keys.indexOf(a)===-1):[...s.keys]:[],r=i?s?i.keys.filter(a=>s.keys.indexOf(a)===-1):[...i.keys]:[],o=[];if(s&&i){for(const a of i.keys)if(s.keys.indexOf(a)!==-1){const u=(0,S.getConfigurationValue)(i.contents,a),f=(0,S.getConfigurationValue)(s.contents,a);w.equals(u,f)||o.push(a)}}return{added:n,removed:r,updated:o}}}),define(Z[125],Q([0,1,19,4,2,30,3,65,42,6,38,37]),function(x,e,N,D,R,T,O,w,g,c,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class h extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new D.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(p.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:l})=>this.c(Array.from(d),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,l){this.h(d,p.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new w.ConfigurationModel;const d=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,l){const v=this.f();for(const b of d){const m=v[b],y=l[b];m!==void 0?this.b.addValue(b,m):y?this.b.addValue(b,y.default):this.b.removeValue(b)}}}e.DefaultConfiguration=h;class k{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=k;let E=class extends R.Disposable{get configurationModel(){return this.b}constructor(d,l,v){super(),this.c=d,this.f=l,this.g=v,this.a=this.B(new D.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.i(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.j(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const l={},v=[],b=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const m of d){const y=b[m];if(!y){v.push(m);continue}if(y.policy){if(y.type!=="string"&&y.type!=="number"){this.g.warn(`Policy ${y.policy.name} has unsupported type ${y.type}`);continue}v.push(m),l[y.policy.name]={type:y.type}}}return(0,O.isEmptyObject)(l)||await this.f.updatePolicyDefinitions(l),v}i(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const l=p.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),v=(0,N.coalesce)(d.map(b=>l.get(b)));this.j(v,!0)}j(d,l){this.g.trace("PolicyConfiguration#update",d);const v=p.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),b=[],m=this.b.isEmpty();for(const y of d){const t=v[y]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(m?s!==void 0:!(0,T.equals)(this.b.getValue(y),s))&&b.push([y,s])}else this.b.getValue(y)!==void 0&&b.push([y,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const y=this.b;this.b=new w.ConfigurationModel;for(const t of y.keys)this.b.setValue(t,y.getValue(t));for(const[t,s]of b)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);l&&this.a.fire(this.b)}}};E=fe([_(1,S.IPolicyService),_(2,c.ILogService)],E),e.PolicyConfiguration=E}),define(Z[126],Q([0,1,5,4,2,18,23,65,125,38]),function(x,e,N,D,R,T,O,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class S extends R.Disposable{constructor(h,k,E,A){super(),this.i=h,this.h=this.B(new D.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=E instanceof c.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,E,A)),this.f=this.B(new w.UserSettings(this.i,void 0,T.extUriBiasedIgnorePathCase,k)),this.a=new w.Configuration(this.b.configurationModel,this.c.configurationModel,new w.ConfigurationModel,new w.ConfigurationModel),this.g=this.B(new N.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:l})=>this.k(d,l))),this.B(this.c.onDidChangeConfiguration(d=>this.l(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,k,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new w.Configuration(h,k,new w.ConfigurationModel,E)}getConfigurationData(){return this.a.toData()}getValue(h,k){const E=typeof h=="string"?h:void 0,A=(0,O.isConfigurationOverrides)(h)?h:(0,O.isConfigurationOverrides)(k)?k:{};return this.a.getValue(E,A,void 0)}updateValue(h,k,E,A){return Promise.reject(new Error("not supported"))}inspect(h){return this.a.inspect(h,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.j(h)}j(h){const k=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(h);this.m(E,k,2)}k(h,k){const E=this.a.toData(),A=this.a.compareAndUpdateDefaultConfiguration(h,k);this.m(A,E,7)}l(h){const k=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(h);this.m(E,k,7)}m(h,k,E){const A=new w.ConfigurationChangeEvent(h,{data:k},this.a);A.source=E,A.sourceConfig=this.n(E),this.h.fire(A)}n(h){switch(h){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=S}),define(Z[66],Q([0,1,16]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(c){return c.scheme===N.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=D;function R(c){if(!c)return;const S=c.indexOf("+");return S<0?c:c.substr(0,S)}e.getRemoteName=R;function T(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=T;function O(c){const{host:S,port:p}=g(c);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:p}}e.parseAuthorityWithPort=O;function w(c,S){let{host:p,port:h}=g(c);return typeof h>"u"&&(h=S),{host:p,port:h}}e.parseAuthorityWithOptionalPort=w;function g(c){const S=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const p=c.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const h=c.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:c,port:void 0}}}),define(Z[29],Q([0,1,32,10,66]),function(x,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=T;function O(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(w=e.ExtensionType||(e.ExtensionType={}));var g;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class c{constructor(A){this.value=A,this.c=A.toLowerCase()}static equals(A,d){if(typeof A>"u"||A===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof A=="string"||typeof d=="string"){const l=typeof A=="string"?A:A.value,v=typeof d=="string"?d:d.value;return N.equalsIgnoreCase(l,v)}return A.c===d.c}static toKey(A){return typeof A=="string"?A.toLowerCase():A.c}}e.ExtensionIdentifier=c;function S(E){return p(E)}e.isApplicationScopedExtension=S;function p(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function h(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=h;function k(E,A){if(A){const d=`onResolveRemoteAuthority:${(0,R.getRemoteName)(A)}`;return E.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[127],Q([0,1,2,14,20,29]),function(x,e,N,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends N.Disposable{constructor(g,c){super(),this.b=g,this.a=(0,D.join)(this.b.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this.B(c.onDidInstallExtensions(S=>this.c(S))),this.B(c.onDidUninstallExtension(S=>this.f(S)))}c(g){g.some(c=>!!c.local)&&this.invalidate()}f(g){g.error||this.invalidate()}invalidate(){R.Promises.rm(this.a,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(Z[47],Q([0,1,15,99,42,10,37]),function(x,e,N,D,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function w(A){return A.res.statusCode&&A.res.statusCode>=200&&A.res.statusCode<300||A.res.statusCode===1223}e.isSuccess=w;function g(A){return A.res.statusCode===204}async function c(A){return g(A)?null:(await(0,N.streamToBuffer)(A.stream)).toString()}e.asText=c;async function S(A){if(!w(A))throw new Error("Server returned "+A.res.statusCode);return c(A)}e.asTextOrError=S;async function p(A){if(!w(A))throw new Error("Server returned "+A.res.statusCode);if(g(A))return null;const l=(await(0,N.streamToBuffer)(A.stream)).toString();try{return JSON.parse(l)}catch(v){throw v.message+=`:
`+l,v}}e.asJson=p;function h(A){E(A)}e.updateProxyConfigurationsScope=h;let k;function E(A){const d=O.Registry.as(R.Extensions.Configuration),l=k;k={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:A,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[k],remove:l?[l]:[]})}E(2)}),define(Z[128],Q([0,1,22,16,13,47]),function(x,e,N,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(g,c){this.a=g,this.b=c}async download(g,c,S=N.CancellationToken.None){if(g.scheme===D.Schemas.file||g.scheme===D.Schemas.vscodeRemote){await this.b.copy(g,c);return}const p={type:"GET",url:g.toString(!0)},h=await this.a.request(p,S);if(h.res.statusCode===200)await this.b.writeFile(c,h.stream);else{const k=await(0,T.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${k}`)}}};O=fe([_(0,T.IRequestService),_(1,R.IFileService)],O),e.DownloadService=O}),define(Z[129],Q([0,1,130,3]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(O,w){return O.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:O.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function T(O,w,g={}){const c=(0,N.parse)(O),S=g.proxyUrl||R(c,w);if(!S)return null;const p=(0,N.parse)(S);if(!/^https?:$/.test(p.protocol||""))return null;const h={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,D.isBoolean)(g.strictSSL)?g.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((k,E)=>{x(["http-proxy-agent"],k,E)}))(h):new(await new Promise((k,E)=>{x(["https-proxy-agent"],k,E)}))(h)}e.getProxyAgent=T}),define(Z[131],Q([0,1,57,14,100,22,34,7,12,31,82,163,5,71]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let E;async function A(l,v,b,m){return b["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.isLaunchedFromCli)(m)&&!b["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.isLaunchedFromCli)(m)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=h.Promises.withAsyncBody(async(y,t)=>{const s=new T.CancellationTokenSource;let i=1e4;const n=l.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,k.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),t(new Error((0,R.localize)(0,null)))},i);try{y(await d(v,s.token))}catch(o){!(0,w.isCancellationError)(o)&&!s.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,O.toErrorMessage)(o)))):y({})}finally{clearTimeout(r),s.dispose()}})),E)}e.getResolvedShellEnv=A;async function d(l,v){const b=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",b);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",m);const y=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(y+"({.*})"+y),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",s);const i=await(0,S.getSystemShell)(g.OS,s);return l.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(v.isCancellationRequested)return r(new w.CancellationError);const o=(0,D.basename)(i);let a,u;const f=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' ${f} -p '''${y}'' + JSON.stringify(process.env) + ''${y}'''`,u=["-Login","-Command"]):(a=`'${process.execPath}' ${f} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,o==="tcsh"||o==="csh"?u=["-ic"]:u=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),a);const L=(0,N.spawn)(i,[...u,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(L.kill(),r(new w.CancellationError))),L.on("error",J=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(J)),r(J)});const F=[];L.stdout.on("data",J=>F.push(J));const Y=[];L.stderr.on("data",J=>Y.push(J)),L.on("close",(J,ee)=>{const ie=Buffer.concat(F).toString("utf8");l.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(Y).toString("utf8");if(ne.trim()&&l.trace("getUnixShellEnvironment#stderr",ne),J||ee)return r(new Error((0,R.localize)(2,null,J,ee)));const ae=t.exec(ie),ue=ae?ae[1]:"{}";try{const re=JSON.parse(ue);b?re.ELECTRON_RUN_AS_NODE=b:delete re.ELECTRON_RUN_AS_NODE,m?re.ELECTRON_NO_ATTACH_CONSOLE=m:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",re),n(re)}catch(re){l.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(re)),r(re)}})})}}),define(Z[67],Q([0,1,10]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,N.createDecorator)("stateService")}),define(Z[132],Q([0,1,5,15,3,17,13,6]),function(x,e,N,D,R,T,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(p,h,k){this.f=p,this.g=h,this.h=k,this.a=Object.create(null),this.b="",this.c=new N.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.g.error(p)}}getItem(p,h){const k=this.a[p];return(0,R.isUndefinedOrNull)(k)?h:k}setItem(p,h){this.setItems([{key:p,data:h}])}setItems(p){let h=!1;for(const{key:k,data:E}of p)this.a[k]!==E&&((0,R.isUndefinedOrNull)(E)?(0,R.isUndefined)(this.a[k])||(this.a[k]=void 0,h=!0):(this.a[k]=E,h=!0));h&&this.j()}removeItem(p){(0,R.isUndefined)(this.a[p])||(this.a[p]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.h.writeFile(this.f,D.VSBuffer.fromString(p)),this.b=p}catch(h){this.g.error(h)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=g;let c=class{constructor(p,h,k){this.a=new g(p.stateResource,h,k)}async init(){await this.a.init()}getItem(p,h){return this.a.getItem(p,h)}};c=fe([_(0,T.IEnvironmentService),_(1,w.ILogService),_(2,O.IFileService)],c),e.StateService=c}),define(Z[68],Q([0,1,12,35,11,31]),function(x,e,N,D,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(c){if(N.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function w(c,S,p,h,k,E,A,d,l,v){const b=Object.create(null);b["common.machineId"]=A,b.sessionID=(0,T.generateUuid)()+Date.now(),b.commitHash=k,b.version=E,b["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,N.PlatformToString)(N.platform),b["common.nodePlatform"]=D.platform,b["common.nodeArch"]=h,b["common.product"]=v||"desktop",d&&(b["common.msftInternal"]=d);let m=0;const y=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),N.isLinuxSnap&&(b["common.snap"]="true");const t=O(p);t&&(b["common.platformDetail"]=t);try{const s=await c.readFile(R.URI.file(l));b["common.source"]=s.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=w;function g(c){const S=D.env.USERDNSDOMAIN;if(!S)return!1;const p=S.toLowerCase();return c.some(h=>p===h)}e.verifyMicrosoftInternalDomain=g}),define(Z[25],Q([0,1,10]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,N.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,N.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[39],Q([0,1,30,3,4,23,66,68,25]),function(x,e,N,D,R,T,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(a){this.value=a}}e.TelemetryTrustedValue=c;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,u){return Promise.resolve(void 0)}publicLog2(a,u){return this.publicLog(a,u)}publicLogError(a,u){return Promise.resolve(void 0)}publicLogError2(a,u){return this.publicLogError(a,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class p{async publicLog(a,u,f){}async publicLogError(a,u,f){}}e.NullEndpointTelemetryService=p,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(o,a){return R.Event.debounce(a.onDidChangeConfiguration,(f,L)=>{const F=f?new Set([...f.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:F}},1e3,!0)(f=>{f.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(f.source),configurationKeys:m(f.affectedKeys)})})}e.configurationTelemetry=h;function k(o,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!o.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=k;function E(o,a){return!(a.isBuilt||a.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=E;function A(o){const a=o.getValue(g.TELEMETRY_SETTING_ID),u=o.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=A;function d(o){const a={},u={},f={};b(o,f);for(let L in f){L=L.length>150?L.substr(L.length-149):L;const F=f[L];typeof F=="number"?u[L]=F:typeof F=="boolean"?u[L]=F?1:0:typeof F=="string"?(F.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${F.length}`),a[L]=F.substring(0,8191)):typeof F<"u"&&F!==null&&(a[L]=F)}return{properties:a,measurements:u}}e.validateTelemetryData=d;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function v(o){if(!o)return"none";const a=(0,O.getRemoteName)(o);return l.has(a)?a:"other"}e.cleanRemoteAuthority=v;function b(o,a,u=0,f){if(!!o)for(const L of Object.getOwnPropertyNames(o)){const F=o[L],Y=f?f+L:L;Array.isArray(F)?a[Y]=(0,N.safeStringify)(F):F instanceof Date?a[Y]=F.toISOString():(0,D.isObject)(F)?u<2?b(F,a,u+1,Y+"."):a[Y]=(0,N.safeStringify)(F):a[Y]=F}}function m(o){if(!o)return[];const a=[];return y(a,"",o),a}function y(o,a,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(f=>y(o,a?`${a}.${f}`:f,u[f])):o.push(a)}function t(o,a){const u=o.msftInternalDomains||[],f=a.getValue("telemetry.internalTesting");return(0,w.verifyMicrosoftInternalDomain)(u)||f}e.isInternalTelemetry=t;function s(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(o,a){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let u=o;const f=[];for(const J of a)for(;;){const ee=J.exec(o);if(!ee)break;f.push([ee.index,J.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,F=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let Y=0;for(u="";;){const J=F.exec(o);if(!J)break;const ee=f.some(([ie,ne])=>J.index<ne&&ie<F.lastIndex);!L.test(J[0])&&!ee&&(u+=o.substring(Y,J.index)+"<REDACTED: user-file-path>",Y=F.lastIndex)}return Y<o.length&&(u+=o.substr(Y)),u}function n(o){if(!o)return o;const a=o.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of u)if(f.regex.test(a))return`<REDACTED: ${f.label}>`;return o}function r(o,a){return(0,N.cloneAndChange)(o,u=>{if(u instanceof c)return u.value;if(typeof u=="string"){let f=u.replaceAll("%20"," ");f=i(f,a);for(const L of a)f=f.replace(L,"");return f=n(f),f}})}e.cleanData=r}),define(Z[26],Q([0,1,32,24,29,12,11,7,35,39]),function(x,e,N,D,R,T,O,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,N.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=S;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new h(n.identifier,r,o)}static parse(n){const r=p.exec(n);return r&&r[1]&&r[2]?new h({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof h?S(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=h;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(i){const n=k.exec(i);return n&&n[1]?[d(n[1]),n[2]]:[d(i),void 0]}e.getIdAndVersion=E;function A(i,n){return`${i}.${n}`}e.getExtensionId=A;function d(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function l(i,n){return d(A(i,n))}e.getGalleryExtensionId=l;function v(i,n){const r=[],o=a=>{for(const u of r)if(u.some(f=>S(n(f),n(a))))return u;return null};for(const a of i){const u=o(a);u?u.push(a):r.push([a])}return r}e.groupByExtension=v;function b(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function m(i){return{id:new c.TelemetryTrustedValue(i.identifier.id),name:new c.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function y(i,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&r.every(u=>!S(u.identifier,{id:a}))){const u=i.filter(f=>S(f.identifier,{id:a}));u.length===1&&(r.push(u[0]),o.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=y;async function t(i,n){if(!T.isLinux)return!1;let r;try{r=(await i.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,w.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function s(i,n){const r=await t(i,n),o=(0,D.getTargetPlatform)(r?"alpine":T.platform,g.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(Z[133],Q([0,1,22,7,16,18,41,11,89,24,26,29]),function(x,e,N,D,R,T,O,w,g,c,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const h=d=>(0,g.localize)(0,null,d),k=(0,g.localize)(1,null,"ms-dotnettools.csharp");function E(d,l){return l?`${d.publisher}.${d.name}@${d.version}`:`${d.publisher}.${d.name}`}let A=class{constructor(l,v){this.a=l,this.b=v}get d(){}async listExtensions(l,v,b,m=console){let y=await this.a.getInstalled(1,b);const t=p.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(v&&v!==""){if(t.indexOf(v.toLowerCase())<0){m.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}y=y.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(v.toLowerCase())>-1:!1)}else if(v===""){m.log("Possible Categories: "),t.forEach(i=>{m.log(i)});return}this.d&&m.log((0,g.localize)(2,null,this.d)),y=y.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let s;for(const i of y)s!==i.identifier.id&&(s=i.identifier.id,m.log(E(i.manifest,l)))}async installExtensions(l,v,b,m,y=console){const t=[],s=[];l.length&&y.log(this.d?(0,g.localize)(3,null,this.d):(0,g.localize)(4,null));const i=await this.a.getInstalled(1,b.profileLocation),n=(u,f)=>{const L=i.find(F=>(0,S.areSameExtensions)(F.identifier,{id:u}));if(L){if(!m&&(!f||f==="prerelease"&&L.preRelease))return y.log((0,g.localize)(5,null,u,L.manifest.version,u)),!1;if(f&&L.manifest.version===f)return y.log((0,g.localize)(6,null,`${u}@${f}`)),!1}return!0},r=(u,f,L)=>{a.push({id:u,version:f!=="prerelease"?f:void 0,installOptions:{...b,isBuiltin:L,installPreReleaseVersion:f==="prerelease"||b.installPreReleaseVersion}})},o=[],a=[];for(const u of l)if(u instanceof w.URI)o.push(u);else{const[f,L]=(0,S.getIdAndVersion)(u);n(f,L)&&r(f,L,!1)}for(const u of v){const[f,L]=(0,S.getIdAndVersion)(u);n(f,L)&&r(f,L,!0)}if(o.length&&await Promise.all(o.map(async u=>{try{const f=await this.f(u,{...b,isBuiltin:!1},m,y);f&&s.push(f)}catch(f){y.error(f.message||f.stack||f),t.push(u.toString())}})),a.length){const u=await this.g(a);await Promise.all(a.map(async f=>{const L=u.get(f.id.toLowerCase());if(L)try{const F=await this.h(f,L,i,m,y);F&&s.push(F)}catch(F){y.error(F.message||F.stack||F),t.push(f.id)}else y.error(`${h(f.version?`${f.id}@${f.version}`:f.id)}
${k}`),t.push(f.id)}))}if(t.length)throw new Error((0,g.localize)(7,null,t.join(", ")))}async f(l,v,b,m){const y=await this.a.getManifest(l);if(!y)throw new Error("Invalid vsix");if(await this.k(y,b,v.profileLocation,m))try{return await this.a.install(l,v),m.log((0,g.localize)(8,null,(0,T.basename)(l))),y}catch(s){if((0,D.isCancellationError)(s))return m.log((0,g.localize)(9,null,(0,T.basename)(l))),null;throw s}return null}async g(l){const v=new Map,b=l.some(y=>y.installOptions.installPreReleaseVersion),m=await this.b.getExtensions(l.map(y=>({...y,preRelease:b})),N.CancellationToken.None);for(const y of m)v.set(y.identifier.id.toLowerCase(),y);return v}async h({id:l,version:v,installOptions:b},m,y,t,s){const i=await this.b.getManifest(m,N.CancellationToken.None);if(i&&!this.j(i,s))return null;const n=y.find(r=>(0,S.areSameExtensions)(r.identifier,m.identifier));if(n){if(m.version===n.manifest.version)return s.log((0,g.localize)(10,null,v?`${l}@${v}`:l)),null;s.log((0,g.localize)(11,null,l,m.version))}try{b.isBuiltin?s.log(v?(0,g.localize)(12,null,l,v):(0,g.localize)(13,null,l)):s.log(v?(0,g.localize)(14,null,l,v):(0,g.localize)(15,null,l));const r=await this.a.installFromGallery(m,{...b,installGivenVersion:!!v});return s.log((0,g.localize)(16,null,l,r.manifest.version)),i}catch(r){if((0,D.isCancellationError)(r))return s.log((0,g.localize)(17,null,l)),null;throw r}}j(l,v){return!0}async k(l,v,b,m){const y={id:(0,S.getGalleryExtensionId)(l.publisher,l.name)},s=(await this.a.getInstalled(1,b)).find(i=>(0,S.areSameExtensions)(y,i.identifier)&&(0,O.gt)(i.manifest.version,l.version));return s&&!v?(m.log((0,g.localize)(18,null,s.identifier.id,s.manifest.version,l.version)),!1):this.j(l,m)}async uninstallExtensions(l,v,b,m=console){const y=async s=>{if(s instanceof w.URI){const i=await this.a.getManifest(s);return E(i)}return s},t=[];for(const s of l){const i=await y(s),r=(await this.a.getInstalled(void 0,b)).filter(o=>(0,S.areSameExtensions)(o.identifier,{id:i}));if(!r.length)throw new Error(`${this.l(i)}
${k}`);if(r.some(o=>o.type===0)){m.log((0,g.localize)(19,null,i));return}if(!v&&r.some(o=>o.isBuiltin)){m.log((0,g.localize)(20,null,i));return}m.log((0,g.localize)(21,null,i));for(const o of r)await this.a.uninstall(o,{profileLocation:b}),t.push(o);this.d?m.log((0,g.localize)(22,null,i,this.d)):m.log((0,g.localize)(23,null,i))}}async locateExtension(l,v=console){const b=await this.a.getInstalled();l.forEach(m=>{b.forEach(y=>{if(y.identifier.id===m&&y.location.scheme===R.Schemas.file){v.log(y.location.fsPath);return}})})}l(l){return this.d?(0,g.localize)(24,null,l,this.d):(0,g.localize)(25,null,l)}};A=fe([_(0,c.IExtensionManagementService),_(1,c.IExtensionGalleryService)],A),e.ExtensionManagementCLI=A}),define(Z[134],Q([0,1,5,7,2,16,12,18,41,3,31,20,23,17,24,26,59,13,6,28]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A,d,l,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let m=class Ve extends R.Disposable{constructor(t,s,i,n,r,o,a){super(),this.h=s,this.i=i,this.j=n,this.k=r,this.l=o,this.m=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(t,s){await this.g;const i=(0,w.joinPath)(this.extensionsDownloadDir,this.w(t));try{await this.t(t,i,r=>this.i.download(t,r,s))}catch(r){throw new E.ExtensionManagementError(r.message,E.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.n(t)){const r=await this.r(t);try{await this.l.verify(i.fsPath,r.fsPath)&&(n="Verified"),this.m.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`)}catch(o){const a=o.code;if(a==="UnknownError")n="UnknownError",this.m.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`);else throw await this.delete(r),await this.delete(i),new E.ExtensionManagementError(a,E.ExtensionManagementErrorCode.Signature)}}return{location:i,verificationStatus:n}}async n(t){if(!t.isSigned)return!1;const s=this.j.getValue("extensions.verifySignature");return(0,c.isBoolean)(s)?s:this.k.quality!=="stable"}async r(t){await this.g;const s=(0,w.joinPath)(this.extensionsDownloadDir,`${this.w(t)}${Ve.c}`);return await this.t(t,s,i=>this.i.downloadSignatureArchive(t,i)),s}async t(t,s,i){if(await this.h.exists(s))return;if(s.scheme!==T.Schemas.file){await i(s);return}const n=(0,w.joinPath)(this.extensionsDownloadDir,`.${(0,S.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.u(n,s,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(n)}catch{}if(r.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.m.info(`Rename failed because of ${(0,D.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(t){await this.g,await this.h.del(t)}async u(t,s,i){try{await p.Promises.rename(t.fsPath,s.fsPath)}catch(n){if(O.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.m.info(`Failed renaming ${t} to ${s} with 'EPERM' error. Trying again...`),this.u(t,s,i);throw n}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],i=[],n=[];for(const a of t.children)if(a.name.endsWith(Ve.c))n.push(a.resource);else{const u=A.ExtensionKey.parse(a.name);u&&i.push([u,a])}const r=(0,A.groupByExtension)(i,([a])=>a),o=[];for(const a of r)a.sort((u,f)=>g.rcompare(u[0].version,f[0].version)),s.push(...a.slice(1).map(u=>u[1].resource)),o.push(a[0][1]);o.sort((a,u)=>a.mtime-u.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.f)).map(a=>a.resource)),s.push(...n),await N.Promises.settled(s.map(a=>(this.m.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.m.error(t)}}w(t){return this.f?A.ExtensionKey.create(t).toString().toLowerCase():(0,S.generateUuid)()}};m.c=".sigzip",m=fe([_(0,k.INativeEnvironmentService),_(1,l.IFileService),_(2,E.IExtensionGalleryService),_(3,h.IConfigurationService),_(4,b.IProductService),_(5,d.IExtensionSignatureVerificationService),_(6,v.ILogService)],m),e.ExtensionsDownloader=m}),define(Z[135],Q([0,1,4,2,36,26,29]),function(x,e,N,D,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class w extends D.Disposable{constructor(c,S,p,h,k,E,A){super(),this.f=c,this.g=S,this.h=p,this.i=h,this.j=k,this.k=E,this.l=A,this.a=this.B(new N.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.DisposableMap),this.m().then(null,d=>A.error(d))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c,S){try{await Promise.all(S.map(p=>(this.c.deleteAndDispose(p.id),this.z(p.extensionsResource)))),c.length&&await Promise.all(c.map(p=>(this.c.set(p.id,(0,D.combinedDisposable)(this.k.watch(this.j.extUri.dirname(p.extensionsResource)),this.k.watch(p.extensionsResource))),this.y(p.extensionsResource))))}catch(p){throw this.l.error(p),p}}async r(c){for(const S of c.extensions)this.D(this.G(S.identifier,S.version),c.profileLocation)}async s(c){for(const S of c.extensions){const p=this.G(S.identifier,S.version);c.error?this.F(p,c.profileLocation):this.D(p,c.profileLocation)}}async t(c){for(const S of c.extensions)this.F(this.G(S.identifier,S.version),c.profileLocation)}async u(c){let S=!1;for(const p of c.extensions){const h=this.G(p.identifier,p.version);c.error?this.D(h,c.profileLocation):(this.F(h,c.profileLocation),S=S||!this.b.has(h))}S&&await this.C()}v(c){for(const S of this.h.profiles)c.contains(S.extensionsResource,0,1)&&this.w(S.extensionsResource)}async w(c){const S=[],p=[],h=await this.i.scanProfileExtensions(c),k=new Set,E=new Set;for(const[A,d]of this.b)d.has(c)&&E.add(A);for(const A of h){const d=this.G(A.identifier,A.version);k.add(d),E.has(d)||(S.push(A.identifier),this.D(d,c))}for(const A of E)if(!k.has(A)){const d=this.H(A);d&&(p.push(d.identifier),this.F(A,c))}(S.length||p.length)&&this.a.fire({added:S.length?{extensions:S,profileLocation:c}:void 0,removed:p.length?{extensions:p,profileLocation:c}:void 0})}async y(c){const S=await this.i.scanProfileExtensions(c);for(const p of S)this.D(this.G(p.identifier,p.version),c)}async z(c){for(const S of[...this.b.keys()])this.F(S,c);await this.C()}async C(){const S=(await this.f.getAllUserInstalled()).filter(p=>p.installedTimestamp&&!this.b.has(this.G(p.identifier,p.manifest.version)));S.length&&await this.f.markAsUninstalled(...S)}D(c,S){let p=this.b.get(c);p||this.b.set(c,p=new R.ResourceSet(h=>this.j.extUri.getComparisonKey(h))),p.add(S)}F(c,S){const p=this.b.get(c);p&&p.delete(S),p?.size||this.b.delete(c)}G(c,S){return`${O.ExtensionIdentifier.toKey(c.id)}@${S}`}H(c){const[S,p]=(0,T.getIdAndVersion)(c);return p?{identifier:{id:S},version:p}:void 0}}e.ExtensionsWatcher=w}),define(Z[136],Q([0,1,109,39]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(T,O,w,g,c,S,p){const h={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${O.nameShort})`};if((0,D.supportsTelemetry)(O,w)&&(0,D.getTelemetryLevel)(g)===3){const k=await(0,N.getServiceMachineId)(w,c,S),{machineId:E}=await p.getTelemetryInfo();h["X-Market-User-Id"]=k,h["VSCode-SessionId"]=E||k}return h}e.resolveMarketplaceHeaders=R}),define(Z[137],Q([0,1,164,19,5,2,16,14,20,17,24,26,6,63,12,11]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let d=class extends k.LanguagePackBaseService{constructor(m,y,t,s){super(t),this.h=m,this.i=s,this.g=this.B(new l(y,s)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(m){const t=(await this.g.getLanguagePacks())[E.Language.value()];if(!t){this.i.warn(`No language pack found for ${E.Language.value()}`);return}const s=t.translations[m];return s?A.URI.file(s):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),y=Object.keys(m).map(t=>{const s=m[t];return{...this.f(t,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return y.push({...this.f("en","English"),extensionId:"default"}),y.sort((t,s)=>t.label.localeCompare(s.label)),y}async j(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",m.identifier.id),await this.update())}async k(m){const y=await this.g.getLanguagePacks();Object.keys(y).some(t=>y[t]&&y[t].extensions.some(s=>(0,p.areSameExtensions)(s.extensionIdentifier,m.identifier)))&&(this.i.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(y);return!(0,D.equals)(Object.keys(m),Object.keys(t))}};d=fe([_(0,S.IExtensionManagementService),_(1,c.INativeEnvironmentService),_(2,S.IExtensionGalleryService),_(3,h.ILogService)],d),e.NativeLanguagePackService=d;let l=class extends T.Disposable{constructor(m,y){super(),this.i=y,this.c={},this.f=(0,w.join)(m.userDataPath,"languagepacks.json"),this.g=new R.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.m(y=>{Object.keys(y).forEach(t=>delete y[t]),this.j(y,...m)}).then(()=>this.c)}j(m,...y){for(const t of y)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(m,t);Object.keys(m).forEach(t=>this.l(m[t]))}k(m,y){const t=y.identifier,s=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const i of s)if(y.location.scheme===O.Schemas.file&&v(i)){let n=m[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},m[i.languageId]=n);const r=n.extensions.filter(o=>(0,p.areSameExtensions)(o.extensionIdentifier,t))[0];r?r.version=y.manifest.version:n.extensions.push({extensionIdentifier:t,version:y.manifest.version});for(const o of i.translations)n.translations[o.id]=(0,w.join)(y.location.fsPath,o.path)}}l(m){if(m){const y=(0,N.createHash)("md5");for(const t of m.extensions)y.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);m.hash=y.digest("hex")}}m(m=()=>null){return this.g.queue(()=>{let y=null;return g.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(y=m(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const s=JSON.stringify(this.c);return this.i.debug("Writing language packs",s),g.Promises.writeFile(this.f,s)}).then(()=>y,t=>this.i.error(t))})}};l=fe([_(0,c.INativeEnvironmentService),_(1,h.ILogService)],l);function v(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const m of b.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}}),define(Z[138],Q([0,1,7,30,39]),function(x,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function w(c,S,p){const h=await new Promise((l,v)=>{x(["@microsoft/1ds-core-js"],l,v)}),k=await new Promise((l,v)=>{x(["@microsoft/1ds-post-js"],l,v)}),E=new h.AppInsightsCore,A=new k.PostChannel,d={instrumentationKey:c,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[A]]};if(p){d.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:p};d.extensionConfig[A.identifier]=l}return E.initialize(d,[]),E.addTelemetryInitializer(l=>{S&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),E}class g{constructor(S,p,h,k,E){this.e=S,this.f=p,this.g=h,this.h=E,this.c=T,this.d=O,this.g||(this.g={}),typeof k=="function"?this.a=k():this.a=k,this.b=null}i(S){if(!!this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(p=>{S(p)},p=>{(0,N.onUnexpectedError)(p),console.error(p)})}}log(S,p){if(!this.a)return;p=(0,D.mixin)(p,this.g),p=(0,R.validateTelemetryData)(p);const h=this.f+"/"+S;try{this.i(k=>{k.pluginVersionString=p?.properties.version??"Unknown",k.track({name:h,baseData:{name:h,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Z[139],Q([0,1,2,30,12,32,101,23,42,140,28,37,25,39]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(l,v,b){this.k=v,this.l=b,this.d={},this.i=new N.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,T.escapeRegExpCharacters)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,T.escapeRegExpCharacters)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(h.TELEMETRY_SETTING_ID)||m.affectsConfiguration(h.TELEMETRY_OLD_SETTING_ID)||m.affectsConfiguration(h.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(l,v){this.d[l]=v}m(){let l=(0,k.getTelemetryLevel)(this.k);const v=this.l.enabledTelemetryLevels;if(v){this.h=this.sendErrorTelemetry?v.error:!1;const b=v.usage?3:v.error?2:0;l=Math.min(l,b)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,v=l.sessionID,b=l["common.machineId"],m=l["common.firstSessionDate"],y=l["common.msftInternal"];return{sessionId:v,machineId:b,firstSessionDate:m,msftInternal:y}}dispose(){this.i.dispose()}n(l,v,b){return this.g<v?Promise.resolve(void 0):this.c.then(m=>{b=(0,D.mixin)(b,this.d),b=(0,k.cleanData)(b,this.j),b=(0,D.mixin)(b,m),this.b.forEach(y=>y.log(l,b))},m=>{console.error(m)})}publicLog(l,v){return this.n(l,3,v)}publicLog2(l,v){return this.publicLog(l,v)}publicLogError(l,v){return this.h?this.n(l,2,v):Promise.resolve(void 0)}publicLogError2(l,v){return this.publicLogError(l,v)}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=fe([_(1,w.IConfigurationService),_(2,S.IProductService)],E),e.TelemetryService=E;function A(){const d=(0,O.localize)(0,null,c.default.nameLong),l=c.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=R.isWeb?"":(0,O.localize)(3,null),b=(0,O.localize)(4,null),m=(0,O.localize)(5,null),y=(0,O.localize)(6,null),t=(0,O.localize)(7,null),s=`
|       | ${b} | ${m} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,O.localize)(8,null);return`
${d} ${l} ${v}

&nbsp;

${t}
${s}

&nbsp;

${i}
`}p.Registry.as(g.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(9,null),properties:{[h.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:A(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(g.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[h.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,O.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,O.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${h.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[141],Q([0,1,165,138]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends D.AbstractOneDataSystemAppender{constructor(O,w,g,c){const S={sendPOST:(p,h)=>{const k={method:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data)}};try{const E=N.request(p.urlString,k,A=>{A.on("data",function(d){h(A.statusCode??200,A.headers,d.toString())}),A.on("error",function(d){h(0,{})})});E.write(p.data),E.end()}catch{h(0,{})}}};super(O,w,g,c,S)}}e.OneDataSystemAppender=R}),define(Z[142],Q([0,1,14,20]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function R(T,O){const w=Object.create(null),g=(S,p)=>{const h=JSON.parse(S);w[p]=h};if(O){const S=[],p=await D.Promises.readdir(O);for(const k of p)try{(await D.Promises.stat((0,N.join)(O,k))).isDirectory()&&S.push(k)}catch{}const h=[];for(const k of S)(await D.Promises.readdir((0,N.join)(O,k))).filter(A=>A==="telemetry.json").length===1&&h.push(k);for(const k of h){const E=(await D.Promises.readFile((0,N.join)(O,k,"telemetry.json"))).toString();g(E,k)}}let c=(await D.Promises.readFile((0,N.join)(T,"telemetry-core.json"))).toString();return g(c,"vscode-core"),c=(await D.Promises.readFile((0,N.join)(T,"telemetry-extensions.json"))).toString(),g(c,"vscode-extensions"),JSON.stringify(w,null,4)}e.buildTelemetryMessage=R}),define(Z[143],Q([0,1,12,80,25]),function(x,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function T(O){let w=O.getItem(R.machineIdKey);return(typeof w!="string"||N.isMacintosh&&w==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(w=await(0,D.getMachineId)()),w}e.resolveMachineId=T}),define(Z[27],Q([0,1,10]),function(x,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,N.createDecorator)("IUriIdentityService")}),define(Z[144],Q([0,1,27,110,13,18,72,4,2]),function(x,e,N,D,R,T,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(h){this.uri=h,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let S=class{constructor(h){this.g=h,this.c=new g.DisposableStore,this.f=2**16;const k=new Map,E=A=>{let d=k.get(A.scheme);return d===void 0&&(d=h.hasProvider(A)&&!this.g.hasCapability(A,1024),k.set(A.scheme,d)),d};this.c.add(w.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(A=>{k.delete(A.scheme)})),this.extUri=new T.ExtUri(E),this.d=new O.SkipList((A,d)=>this.extUri.compare(A,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,T.normalizePath)(h));const k=this.d.get(h);return k?k.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new c(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((E,A)=>E[1].touch<A[1].touch?1:E[1].touch>A[1].touch?-1:0);c._clock=0,this.d.clear();const k=this.f*.5;for(let E=0;E<k;E++)this.d.set(h[E][0],h[E][1].touch())}};S=fe([_(0,R.IFileService)],S),e.UriIdentityService=S,(0,D.registerSingleton)(N.IUriIdentityService,S,1)}),define(Z[145],Q([0,1,103,14,54,18,11,10,16]),function(x,e,N,D,R,T,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,w.createDecorator)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&O.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=c;function S(i){return typeof i?.id=="string"&&!c(i)&&!h(i)}e.isEmptyWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function p(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=p;function h(i){const n=i;return typeof n?.id=="string"&&O.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=h;function k(i){const n=i;if(n?.uri)return{id:n.id,uri:O.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=k;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function A(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=A;function d(i){const n=i;return!!(n&&typeof n=="object"&&O.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=d;class l{constructor(n,r,o,a,u){this.h=n,this.j=o,this.k=a,this.l=u,this.c=R.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class v{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,T.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function b(i){return new v({uri:i,index:0,name:(0,T.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,N.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(i,n){return T.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function y(i){let n;return O.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=y;function t(i,n){return!m(i,n)&&!y(i)}e.isSavedWorkspace=t;function s(i){return(typeof i=="string"?(0,D.extname)(i):(0,T.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Z[21],Q([0,1,52,4,2,18,11,102,17,13,10,6,145,36,27,5,31,32,3]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A,d,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&O.URI.isUri(n.location)&&O.URI.isUri(n.globalStorageHome)&&O.URI.isUri(n.settingsResource)&&O.URI.isUri(n.keybindingsResource)&&O.URI.isUri(n.tasksResource)&&O.URI.isUri(n.snippetsHome)&&O.URI.isUri(n.extensionsResource))}e.isUserDataProfile=b,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,S.createDecorator)("IUserDataProfilesService");function m(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:O.URI.revive(i.location).with({scheme:n}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:O.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=m;function y(i,n,r,o){return{id:i,name:n,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,T.joinPath)(r,"globalStorage"),settingsResource:(0,T.joinPath)(r,"settings.json"),keybindingsResource:(0,T.joinPath)(r,"keybindings.json"),tasksResource:(0,T.joinPath)(r,"tasks.json"),snippetsHome:(0,T.joinPath)(r,"snippets"),extensionsResource:(0,T.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=y;let t=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,o,a){super(),this.m=n,this.n=r,this.r=o,this.s=a,this.f=!1,this.g=this.B(new D.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new D.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new D.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new D.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new k.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,T.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const u of this.G()){if(!u.name||!(0,v.isString)(u.name)||!u.location){this.s.warn("Skipping the invalid stored profile",u.location||u.name);continue}n.push(y((0,T.basename)(u.location),u.name,u.location,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}const r=new k.ResourceMap,o=new Map,a=y((0,N.hash)(this.m.userRoamingDataHome.path).toString(16),(0,w.localize)(0,null),this.m.userRoamingDataHome);if(n.unshift({...a,extensionsResource:this.L()??a.extensionsResource,isDefault:!0}),n.length){const u=this.I();if(u.workspaces)for(const[f,L]of Object.entries(u.workspaces)){const F=O.URI.parse(f),Y=O.URI.parse(L),J=n.find(ee=>this.r.extUri.isEqual(ee.location,Y));J&&r.set(F,J)}if(u.emptyWindows)for(const[f,L]of Object.entries(u.emptyWindows)){const F=O.URI.parse(L),Y=n.find(J=>this.r.extUri.isEqual(J.location,F));Y&&o.set(f,Y)}}this.t={profiles:n,workspaces:r,emptyWindows:o}}return this.t}async createTransientProfile(n){const r="Temp",o=new RegExp(`${(0,l.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const f of this.profiles){const L=o.exec(f.name),F=L?parseInt(L[1]):0;a=F>a?F:a}const u=`${r} ${a+1}`;return this.createProfile((0,N.hash)((0,d.generateUuid)()).toString(16),u,{transient:!0},n)}async createNamedProfile(n,r,o){return this.createProfile((0,N.hash)((0,d.generateUuid)()).toString(16),n,r,o)}async createProfile(n,r,o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.v(n,r,o);return a&&await this.setProfileForWorkspace(a,u),u}async v(n,r,o){if(!(0,v.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(r);return a||(a=(async()=>{try{const u=this.profiles.find(F=>F.name===r||F.id===n);if(u)return u;const f=y(n,r,(0,T.joinPath)(this.profilesHome,n),o);await this.n.createFolder(f.location);const L=[];return this.h.fire({profile:f,join(F){L.push(F)}}),await A.Promises.settled(L),this.z([f],[],[]),f}finally{this.k.delete(r)}})(),this.k.set(r,a)),a}async updateProfile(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=y(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.z([],[],[o]),o}async removeProfile(n){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const o=[];this.i.fire({profile:r,join(a){o.push(a)}});try{await Promise.allSettled(o)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.F(),this.z([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.D(n,o)}unsetWorkspace(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.y(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.w(n);return O.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}w(n){return(0,h.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,h.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}z(n,r,o){const a=[...this.profiles,...n],u=[];this.l.profiles=[];for(let f of a)f.isDefault||r.some(L=>f.id===L.id)||(f=o.find(L=>f.id===L.id)??f,f.isTransient?this.l.profiles.push(f):u.push({location:f.location,name:f.name,shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}));this.H(u),this.t=void 0,this.C(n,r,o)}C(n,r,o){this.g.fire({added:n,removed:r,updated:o,all:this.profiles})}D(n,r,o){o=r?.isTransient?!0:o,o||this.D(n,void 0,!0);const a=this.w(n),u=o?this.l:this.u;O.URI.isUri(a)?(u.workspaces.delete(a),r&&u.workspaces.set(a,r)):(u.emptyWindows.delete(a),r&&u.emptyWindows.set(a,r)),o||this.F()}F(){const n={};for(const[o,a]of this.u.workspaces.entries())n[o.toString()]=a.location.toString();const r={};for(const[o,a]of this.u.emptyWindows.entries())r[o.toString()]=a.location.toString();this.J({workspaces:n,emptyWindows:r}),this.t=void 0}G(){return[]}H(n){throw new Error("not implemented")}I(){return{}}J(n){throw new Error("not implemented")}L(){}};t.b="userDataProfiles",t.c="profileAssociations",t=fe([_(0,g.IEnvironmentService),_(1,c.IFileService),_(2,E.IUriIdentityService),_(3,p.ILogService)],t),e.UserDataProfilesService=t;class s extends t{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(n){this.a=n}I(){return this.O}J(n){this.O=n}}e.InMemoryUserDataProfilesService=s}),define(Z[146],Q([0,1,19,5,22,7,4,2,12,11,87,24,26,29,6,28,25,21]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var v;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(v=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let b=class extends w.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,o,a,u){super(),this.t=n,this.u=r,this.v=o,this.w=a,this.y=u,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new O.Emitter),this.m=this.B(new O.Emitter),this.n=this.B(new O.Emitter),this.p=this.B(new O.Emitter),this.s=[],this.B((0,w.toDisposable)(()=>{this.j.forEach(({task:f})=>f.cancel()),this.k.forEach(f=>f.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(o=>(0,p.isTargetPlatformCompatible)(o,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new p.ExtensionManagementError(S.localize(0,null),p.ExtensionManagementErrorCode.Internal);const o=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw t(this.u,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(n),error:o}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(o),y(o)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,o){const a={...o,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,k.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},u=ee=>`${h.ExtensionKey.create(ee).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!c.URI.isUri(r)){const ee=this.j.get(u(r));if(ee){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await ee.task.waitUntilTaskIsFinished();return ie}}const f=[],L=[],F=[],Y=this.Q(n,r,a);c.URI.isUri(r)||this.j.set(u(r),{task:Y,waitingTasks:[]}),this.l.fire({identifier:Y.identifier,source:r,profileLocation:a.profileLocation}),this.v.info("Installing extension:",Y.identifier.id),f.push({task:Y,manifest:n});let J=!1;try{if(a.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ie=await this.F(Y.identifier,n,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),ne=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:ae,manifest:ue}of(0,N.distinct)(ie,({gallery:re})=>re.identifier.id)){J=J||!!ue.extensionDependencies?.some(B=>(0,h.areSameExtensions)({id:B},Y.identifier));const re=u(ae),ge=this.j.get(re);if(ge){if(this.C(Y,ge.task)){const B=ge.task.identifier;this.v.info("Waiting for already requested installing extension",B.id,Y.identifier.id),ge.waitingTasks.push(Y),L.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,j=>j.some(M=>(0,h.areSameExtensions)(M.identifier,B)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",B.id,Y.identifier.id),!j.find(V=>(0,h.areSameExtensions)(V.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!ne.some(({identifier:B})=>(0,h.areSameExtensions)(B,ae.identifier))){const B=this.Q(ue,ae,{...a,donotIncludePackAndDependencies:!0});this.j.set(re,{task:B,waitingTasks:[Y]}),this.l.fire({identifier:B.identifier,source:ae,profileLocation:a.profileLocation}),this.v.info("Installing extension:",B.identifier.id,Y.identifier.id),f.push({task:B,manifest:ue})}}}catch(ie){if(c.URI.isUri(Y.source))(0,N.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",Y.identifier.id,ie.message),(0,N.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",Y.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ie}const ee=f.reduce((ie,{task:ne,manifest:ae})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:ae}),ie),new Map);for(;ee.size;){let ie;const ne=[...ee.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(ue=>ee.has(ue.toLowerCase())));ne.length?ie=ee.size===1?ne:ne.filter(({task:ae})=>!(ae===Y&&!J)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:ae})=>ae.identifier.id)),ie=[...ee.values()]),await this.D(ie.map(async({task:ae})=>{const ue=new Date().getTime();try{const{local:re}=await ae.run();if(await this.D(this.s.map(ge=>ge.postInstall(re,ae.source,a,R.CancellationToken.None))),!c.URI.isUri(ae.source)){const ge=ae.operation===3,B=ge?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.u,ge?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-ue,durationSinceUpdate:B}),g.isWeb&&ae.operation!==3)try{await this.t.reportStatistic(re.manifest.publisher,re.manifest.name,re.manifest.version,"install")}catch{}}F.push({local:re,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:re.isApplicationScoped})}catch(re){throw c.URI.isUri(ae.source)||t(this.u,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-ue,error:re}),this.v.error("Error while installing the extension:",ae.identifier.id),re}finally{ee.delete(ae.identifier.id.toLowerCase())}}))}return L.length&&await this.D(L),F.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(F),F.filter(({identifier:ie})=>(0,h.areSameExtensions)(ie,Y.identifier))[0].local}catch(ee){if(f.forEach(({task:ie})=>ie.cancel()),F.length)try{const ie=await Promise.allSettled(F.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const ae=ie[ne],{identifier:ue}=F[ne];ae.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",ue.id):this.v.warn("Rollback: Error while uninstalling extension",ue.id,(0,T.getErrorMessage)(ae.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,T.getErrorMessage)(ie),F.map(({identifier:ne})=>ne.id))}throw this.m.fire(f.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:a.context,profileLocation:a.profileLocation}))),ee}finally{for(const{task:ee}of f)ee.source&&!c.URI.isUri(ee.source)&&this.j.delete(u(ee.source))}}C(n,r){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===n&&(a.includes(r)||a.some(u=>this.C(u,r)))||o===r&&a[0]&&!this.C(n,a[0]))return!1;return!0}async D(n){const r=[],o=[],a=await Promise.allSettled(n);for(const u of a)u.status==="fulfilled"?r.push(u.value):o.push(u.reason);if(o.length)throw m(o);return r}async F(n,r,o,a,u){if(!this.t.isEnabled())return[];const f=await this.getInstalled(void 0,u),L=[],F=[],Y=async(J,ee)=>{L.push(J);const ie=ee.extensionDependencies||[],ne=[...ie];if(ee.extensionPack){const ae=o?f.find(ue=>(0,h.areSameExtensions)(ue.identifier,J)):void 0;for(const ue of ee.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(re=>(0,h.areSameExtensions)({id:re},{id:ue}))||ne.every(re=>!(0,h.areSameExtensions)({id:re},{id:ue}))&&ne.push(ue)}if(ne.length){const ae=ne.filter(ue=>L.every(re=>!(0,h.areSameExtensions)(re,{id:ue})));if(ae.length){const ue=await this.t.getExtensions(ae.map(re=>({id:re,preRelease:a})),R.CancellationToken.None);for(const re of ue){if(L.find(j=>(0,h.areSameExtensions)(j,re.identifier)))continue;const ge=ie.some(j=>(0,h.areSameExtensions)({id:j},re.identifier));let B;try{B=await this.G(re,!1,a)}catch(j){if(j instanceof p.ExtensionManagementError&&j.code===p.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ge){this.v.info("Skipping the packed extension as it cannot be installed",re.identifier.id);continue}else throw j}F.push({gallery:B.extension,manifest:B.manifest}),await Y(B.extension.identifier,B.manifest)}}}};return await Y(n,r),F}async G(n,r,o){if((await this.getExtensionsControlManifest()).malicious.some(L=>(0,h.areSameExtensions)(n.identifier,L)))throw new p.ExtensionManagementError(S.localize(1,null,n.identifier.id),p.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const L=await this.getTargetPlatform();throw new p.ExtensionManagementError(S.localize(2,null,n.identifier.id,this.w.nameLong,(0,p.TargetPlatformToString)(L)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.H(n,r,o);if(u){if(o&&!r&&n.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new p.ExtensionManagementError(S.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],R.CancellationToken.None))[0]?new p.ExtensionManagementError(S.localize(4,null,n.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.ExtensionManagementError(S.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",u.identifier.id);const f=await this.t.getManifest(u,R.CancellationToken.None);if(f===null)throw new p.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(f.version!==u.version)throw new p.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:f}}async H(n,r,o){const a=await this.getTargetPlatform();let u=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==o&&(u=(await this.t.getExtensions([{...n.identifier,preRelease:o}],{targetPlatform:a,compatible:!0},R.CancellationToken.None))[0]||null),!u&&await this.t.isExtensionCompatible(n,o,a)&&(u=n),u||(r?u=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},R.CancellationToken.None))[0]||null:u=await this.t.getCompatibleExtension(n,o,a)),u}async I(n,r){const o={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},a=J=>`${J.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,u=this.k.get(a(n.identifier));if(u)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),u.waitUntilTaskIsFinished();const f=J=>{const ee=this.R(J,o);return this.k.set(a(ee.extension.identifier),ee),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${J.identifier.id}@${J.manifest.version}`),this.n.fire({identifier:J.identifier,profileLocation:o.profileLocation,applicationScoped:J.isApplicationScoped}),ee},L=(J,ee)=>{ee?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,o.profileLocation.toString(),ee.message):this.v.error("Failed to uninstall extension:",`${J.identifier.id}@${J.manifest.version}`,ee.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${J.identifier.id}@${J.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${J.identifier.id}@${J.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(J),error:ee}),this.p.fire({identifier:J.identifier,error:ee?.code,profileLocation:o.profileLocation,applicationScoped:J.isApplicationScoped})},F=[],Y=[];try{F.push(f(n));const J=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ee=this.M(n,J);for(const ie of ee)this.k.has(a(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):F.push(f(ie))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(F.map(ee=>ee.extension),J,n),await this.D(F.map(async ee=>{try{if(await ee.run(),await this.D(this.s.map(ie=>ie.postUninstall(ee.extension,o,R.CancellationToken.None))),ee.extension.identifier.uuid)try{await this.t.reportStatistic(ee.extension.manifest.publisher,ee.extension.manifest.name,ee.extension.manifest.version,"uninstall")}catch{}L(ee.extension)}catch(ie){const ne=ie instanceof p.ExtensionManagementError?ie:new p.ExtensionManagementError((0,T.getErrorMessage)(ie),p.ExtensionManagementErrorCode.Internal);throw L(ee.extension,ne),ne}finally{Y.push(ee)}}))}catch(J){const ee=J instanceof p.ExtensionManagementError?J:new p.ExtensionManagementError((0,T.getErrorMessage)(J),p.ExtensionManagementErrorCode.Internal);for(const ie of F){try{ie.cancel()}catch{}Y.includes(ie)||L(ie.extension,ee)}throw ee}finally{for(const J of F)this.k.delete(a(J.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",J.extension.identifier.id)}}J(n,r,o){for(const a of n){const u=this.N(a,r);if(u.length){const f=u.filter(L=>!n.some(F=>(0,h.areSameExtensions)(F.identifier,L.identifier)));if(f.length)throw new Error(this.L(a,f,o))}}}L(n,r,o){return o===n?r.length===1?S.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?S.localize(9,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(10,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(11,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,o=[]){if(o.indexOf(n)!==-1)return[];o.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const u=r.filter(L=>!L.isBuiltin&&a.some(F=>(0,h.areSameExtensions)({id:F},L.identifier))),f=[];for(const L of u)f.push(...this.M(L,r,o));return[...u,...f]}return[]}N(n,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,h.areSameExtensions)({id:a},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};b=fe([_(0,p.IExtensionGalleryService),_(1,d.ITelemetryService),_(2,E.ILogService),_(3,A.IProductService),_(4,l.IUserDataProfilesService)],b),e.AbstractExtensionManagementService=b;function m(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=m;function y(i){if(i instanceof p.ExtensionManagementError)return i;const n=new p.ExtensionManagementError(i.message,p.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:o,duration:a,error:u,durationSinceUpdate:f}){let L,F;u&&(u instanceof p.ExtensionManagementError?(L=u.code,u.code===p.ExtensionManagementErrorCode.Signature&&(F=u.message)):L=p.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:o,success:!u,duration:a,errorcode:L,errorcodeDetail:F,durationSinceUpdate:f})}e.reportTelemetry=t;class s{constructor(){this.d=new D.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.createCancelablePromise)(n=>new Promise((r,o)=>{const a=n.onCancellationRequested(()=>{a.dispose(),o(new T.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=s}),define(Z[40],Q([0,1,5,15,2,4,36,11,26,29,13,10,6,21,27,3,7,25]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var v;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(v=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class b extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=b,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let m=class extends R.Disposable{constructor(i,n,r,o,a,u){super(),this.h=i,this.i=n,this.j=r,this.k=o,this.l=a,this.m=u,this.a=this.B(new T.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new T.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new T.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new T.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new O.ResourceMap}scanProfileExtensions(i,n){return this.n(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],o=[];try{return await this.n(n,a=>{const u=[];for(const f of a)i.some(([L])=>(0,g.areSameExtensions)(L.identifier,f.identifier)&&L.manifest.version!==f.version)?r.push(f):u.push(f);for(const[f,L]of i)if(!u.some(F=>(0,g.areSameExtensions)(F.identifier,f.identifier)&&F.version===f.manifest.version)){const F={identifier:f.identifier,version:f.manifest.version,location:f.location,metadata:L};o.push(F),u.push(F)}return o.length&&this.a.fire({extensions:o,profileLocation:n}),r.length&&this.c.fire({extensions:r,profileLocation:n}),u}),o.length&&this.b.fire({extensions:o,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),o}catch(a){throw o.length&&this.b.fire({extensions:o,error:a,profileLocation:n}),r.length&&this.f.fire({extensions:r,error:a,profileLocation:n}),a}}async updateMetadata(i,n){const r=[];return await this.n(n,o=>{const a=[];for(const u of o){const f=i.find(([L])=>(0,g.areSameExtensions)(L.identifier,u.identifier)&&L.manifest.version===u.version);f&&(u.metadata={...u.metadata,...f[1]},r.push(u)),a.push(u)}return a}),r}async removeExtensionFromProfile(i,n){const r=[];this.c.fire({extensions:r,profileLocation:n});try{await this.n(n,o=>{const a=[];for(const u of o)(0,g.areSameExtensions)(u.identifier,i.identifier)?r.push(u):a.push(u);return r.length&&this.c.fire({extensions:r,profileLocation:n}),a}),r.length&&this.f.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this.f.fire({extensions:r,error:o,profileLocation:n}),o}}async n(i,n,r){return this.v(i).queue(async()=>{let o=[],a;try{const u=await this.i.readFile(i);a=JSON.parse(u.value.toString())}catch(u){if((0,S.toFileOperationResult)(u)!==1)throw u;if(this.k.extUri.isEqual(i,this.j.defaultProfile.extensionsResource)&&(a=await this.u()),!a&&r?.bailOutWhenFileNotFound)throw new b((0,d.getErrorMessage)(u),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.p(i);let u=!1;for(const f of a){y(f)||this.p(i);let L;if((0,A.isString)(f.location))L=this.s(f.location);else{L=w.URI.revive(f.location);const F=this.r(L);F&&(u=!0,f.location=F)}o.push({identifier:f.identifier,location:L,version:f.version,metadata:f.metadata})}u&&await this.i.writeFile(i,D.VSBuffer.fromString(JSON.stringify(a)))}if(n){o=n(o);const u=o.map(f=>({identifier:f.identifier,version:f.version,location:this.r(f.location)??f.location.toJSON(),metadata:f.metadata}));await this.i.writeFile(i,D.VSBuffer.fromString(JSON.stringify(u)))}return o})}p(i){const n=new b(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(i){return this.k.extUri.isEqualOrParent(i,this.h)?this.k.extUri.relativePath(this.h,i):void 0}s(i){return this.k.extUri.joinPath(this.h,i)}async u(){return this.t||(this.t=(async()=>{const i=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let n;try{n=(await this.i.readFile(i)).value.toString()}catch(o){if((0,S.toFileOperationResult)(o)===1)return;throw o}this.m.info("Migrating extensions from old default profile location",i.toString());let r;try{const o=JSON.parse(n);Array.isArray(o)&&o.every(a=>y(a))?r=o:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.m.error(o)}if(r)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",i.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(o){if((0,S.toFileOperationResult)(o)===3)this.m.info("Migration from old default profile location to new location is done by another window",i.toString(),this.j.defaultProfile.extensionsResource.toString());else throw o}try{await this.i.del(i)}catch(o){(0,S.toFileOperationResult)(o)!==1&&this.m.error(o)}return r})()),this.t}v(i){let n=this.g.get(i);return n||(n=new N.Queue,this.g.set(i,n)),n}};m=fe([_(1,S.IFileService),_(2,k.IUserDataProfilesService),_(3,E.IUriIdentityService),_(4,l.ITelemetryService),_(5,h.ILogService)],m),e.AbstractExtensionsProfileScannerService=m;function y(s){return(0,A.isObject)(s)&&(0,c.isIExtensionIdentifier)(s.identifier)&&(t(s.location)||(0,A.isString)(s.location))&&s.version&&(0,A.isString)(s.version)}function t(s){return s?(0,A.isString)(s.path)&&(0,A.isString)(s.scheme):!1}}),define(Z[48],Q([0,1,19,5,30,15,7,50,78,2,16,14,12,18,41,53,3,11,91,17,26,29,45,13,10,6,28,4,44,40,21,27,107,108]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A,d,l,v,b,m,y,t,s,i,n,r,o,a,u,f,L,F,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var J;(function(ge){function B(j,M){if(j===M)return!0;const V=Object.keys(j),W=new Set;for(const q of Object.keys(M))W.add(q);if(V.length!==W.size)return!1;for(const q of V){if(j[q]!==M[q])return!1;W.delete(q)}return W.size===0}ge.equals=B})(J=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ee=class extends c.Disposable{constructor(B,j,M,V,W,q,X,P,I,C,U,$){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=j,this.l=M,this.m=V,this.n=W,this.p=q,this.r=X,this.s=P,this.t=I,this.u=C,this.v=U,this.w=$,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,k.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ae,(0,k.joinPath)(this.m,y.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ae,(0,k.joinPath)(this.m,y.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ne,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,m.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(B,j,M){const[V,W]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(j)]),q=M?await this.scanExtensionsUnderDevelopment(B,[...V,...W]):[];return this.F(V,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const j=[];j.push(this.G(!!B.useCache,B.language)),j.push(this.H(B.language,!!B.checkControlFile));const[M,V]=await Promise.all(j);return this.D([...M,...V],0,B,!1)}async scanUserExtensions(B){const j=B.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const M=this.v.extUri.isEqual(B.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.J(j,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,M),W=B.useCache&&!V.devMode&&V.excludeObsolete?this.j:this.k;let q;try{q=await W.scanExtensions(V)}catch(X){if(X instanceof u.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),q=await W.scanExtensions(V);else throw X}return q=await this.D(q,1,B,!0),this.s.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(B,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const M=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(V=>V.scheme===S.Schemas.file).map(async V=>{const W=await this.J(V,!1,1,!0,B.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(X=>(X.type=j.find(P=>(0,m.areSameExtensions)(P.identifier,X.identifier))?.type??X.type,this.k.validate(X,W)))}))).flat();return this.D(M,"development",B,!0)}return[]}async scanExistingExtension(B,j,M){const V=await this.J(B,!1,j,!0,M.language,!0,void 0),W=await this.k.scanExtension(V);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(B,j,M){const V=await this.J(B,!1,j,!0,M.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions(V);return this.D(W,j,M,!0)}async scanMetadata(B){const j=(0,k.joinPath)(B,"package.json"),M=(await this.r.readFile(j)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(B,j){const M=(0,k.joinPath)(B,"package.json"),V=(await this.r.readFile(M)).value.toString(),W=JSON.parse(V);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,W.__metadata={...W.__metadata,...j},await this.r.writeFile((0,k.joinPath)(B,"package.json"),T.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof u.ExtensionsProfileScanningError&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw B}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.p.addExtensionsToProfile(B.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,T.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,s.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.s.error(B)}finally{this.z=void 0}})()),this.z}async D(B,j,M,V){return M.includeAllVersions||(B=this.F(j===0?B:void 0,j===1?B:void 0,j==="development"?B:void 0,await this.getTargetPlatform(),V)),M.includeInvalid||(B=B.filter(W=>W.isValid)),B.sort((W,q)=>{const X=p.basename(W.location.fsPath),P=p.basename(q.location.fsPath);return X<P?-1:X>P?1:0})}F(B,j,M,V,W){const q=(P,I,C)=>{if(P.isValid&&!I.isValid)return!1;if(P.isValid===I.isValid){if(W&&E.gt(P.manifest.version,I.manifest.version))return this.s.debug(`Skipping extension ${I.location.path} with lower version ${I.manifest.version} in favour of ${P.location.path} with version ${P.manifest.version}`),!1;if(E.eq(P.manifest.version,I.manifest.version)){if(P.type===0)return this.s.debug(`Skipping extension ${I.location.path} in favour of system extension ${P.location.path} with same version`),!1;if(P.targetPlatform===V)return this.s.debug(`Skipping extension ${I.location.path} from different target platform ${I.targetPlatform}`),!1}}return C?this.s.warn(`Overwriting user extension ${P.location.path} with ${I.location.path}.`):this.s.debug(`Overwriting user extension ${P.location.path} with ${I.location.path}.`),!0},X=new Map;return B?.forEach(P=>{const I=y.ExtensionIdentifier.toKey(P.identifier.id),C=X.get(I);(!C||q(C,P,!1))&&X.set(I,P)}),j?.forEach(P=>{const I=y.ExtensionIdentifier.toKey(P.identifier.id),C=X.get(I);if(!C&&B&&P.type===0){this.s.debug(`Skipping obsolete system extension ${P.location.path}.`);return}(!C||q(C,P,!1))&&X.set(I,P)}),M?.forEach(P=>{const I=y.ExtensionIdentifier.toKey(P.identifier.id),C=X.get(I);(!C||q(C,P,!0))&&X.set(I,P),X.set(I,P)}),[...X.values()]}async G(B,j){this.s.trace("Started scanning system extensions");const M=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),W=await(B&&!M.devMode?this.i:this.k).scanExtensions(M);return this.s.trace("Scanned system extensions:",W.length),W}async H(B,j){const M=this.t.isBuilt?[]:this.u.builtInExtensions;if(!M?.length)return[];this.s.trace("Started scanning dev system extensions");const V=j?await this.I():{},W=[],q=l.URI.file(p.normalize(p.join(S.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const P of M){const I=V[P.name]||"marketplace";switch(I){case"disabled":break;case"marketplace":W.push((0,k.joinPath)(q,P.name));break;default:W.push(l.URI.file(I));break}}const X=await Promise.all(W.map(async P=>this.k.scanExtension(await this.J(P,!1,0,!0,B,!0,void 0))));return this.s.trace("Scanned dev system extensions:",X.length),(0,N.coalesce)(X)}async I(){try{const B=await this.r.readFile(this.l);return JSON.parse(B.value.toString())}catch{return{}}}async J(B,j,M,V,W,q,X){const P=await this.f(W??h.language),I=await this.L(B),C=j&&!this.v.extUri.isEqual(B,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=C?await this.L(C):void 0;return new ie(B,I,C,U,j,X,M,V,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,P)}async L(B){try{const j=await this.r.stat(B);if(typeof j.mtime=="number")return j.mtime}catch{}}};ee=fe([_(4,f.IUserDataProfilesService),_(5,u.IExtensionsProfileScannerService),_(6,s.IFileService),_(7,n.ILogService),_(8,b.IEnvironmentService),_(9,r.IProductService),_(10,L.IUriIdentityService),_(11,i.IInstantiationService)],ee),e.AbstractExtensionsScannerService=ee;class ie{constructor(B,j,M,V,W,q,X,P,I,C,U,$,G,te,se){this.location=B,this.mtime=j,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=V,this.profile=W,this.profileScanOptions=q,this.type=X,this.excludeObsolete=P,this.validate=I,this.productVersion=C,this.productDate=U,this.productCommit=$,this.devMode=G,this.language=te,this.translations=se}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,j){return(0,k.isEqual)(B.location,j.location)&&B.mtime===j.mtime&&(0,k.isEqual)(B.applicationExtensionslocation,j.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&B.profile===j.profile&&R.equals(B.profileScanOptions,j.profileScanOptions)&&B.type===j.type&&B.excludeObsolete===j.excludeObsolete&&B.validate===j.validate&&B.productVersion===j.productVersion&&B.productDate===j.productDate&&B.productCommit===j.productCommit&&B.devMode===j.devMode&&B.language===j.language&&J.equals(B.translations,j.translations)}}e.ExtensionScannerInput=ie;let ne=class extends c.Disposable{constructor(B,j,M,V,W){super(),this.f=B,this.g=j,this.h=M,this.i=V,this.j=W}async scanExtensions(B){const j=B.profile?await this.l(B):await this.k(B);let M={};if(B.excludeObsolete&&B.type===1)try{const V=(await this.i.readFile(this.f)).value.toString();M=JSON.parse(V)}catch{}return(0,d.isEmptyObject)(M)?j:j.filter(V=>!M[m.ExtensionKey.create(V).toString()])}async k(B){const j=await this.i.resolve(B.location);if(!j.children?.length)return[];const M=await Promise.all(j.children.map(async V=>{if(!V.isDirectory||B.type===1&&(0,k.basename)(V.resource).indexOf(".")===0)return null;const W=new ie(V.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(W)}));return(0,N.coalesce)(M).sort((V,W)=>V.location.path<W.location.path?-1:1)}async l(B){let j=await this.m(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){j=j.filter(V=>!V.metadata?.isApplicationScoped);const M=await this.m(B.applicationExtensionslocation,V=>!!V.metadata?.isApplicationScoped,B);j.push(...M)}return j}async m(B,j,M){const V=await this.g.scanProfileExtensions(B,M.profileScanOptions);if(!V.length)return[];const W=await Promise.all(V.map(async q=>{if(j(q)){const X=new ie(q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(X,q.metadata)}return null}));return(0,N.coalesce)(W)}async scanOneOrMultipleExtensions(B){try{if(await this.i.exists((0,k.joinPath)(B.location,"package.json"))){const j=await this.scanExtension(B);return j?[j]:[]}else return await this.scanExtensions(B)}catch(j){return this.j.error(`Error scanning extensions at ${B.location.path}:`,(0,O.getErrorMessage)(j)),[]}}async scanExtension(B,j){try{let M=await this.scanExtensionManifest(B.location);if(M){M.publisher||(M.publisher=y.UNDEFINED_PUBLISHER),j=j??M.__metadata,delete M.__metadata;const V=(0,m.getGalleryExtensionId)(M.publisher,M.name),W=j?.id?{id:V,uuid:j.id}:{id:V},q=j?.isSystem?0:B.type,X=q===0||!!j?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(M),M=await this.n(B.location,M,ie.createNlsConfiguration(B));const P={type:q,identifier:W,manifest:M,location:B.location,isBuiltin:X,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return B.validate?this.validate(P,B):P}}catch(M){B.type!==0&&this.j.error(M)}return null}validate(B,j){let M=!0;const V=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,B.manifest,B.isBuiltin);for(const[W,q]of V)W===A.default.Error&&(M=!1,this.j.error(this.t(j.location,q)));return B.isValid=M,B.validations=V,B}async scanExtensionManifest(B){const j=(0,k.joinPath)(B,"package.json");let M;try{M=(await this.i.readFile(j)).value.toString()}catch(W){return(0,s.toFileOperationResult)(W)!==1&&this.j.error(this.t(B,(0,v.localize)(0,null,j.path,W.message))),null}let V;try{V=JSON.parse(M)}catch{const q=[];(0,w.parse)(M,q);for(const X of q)this.j.error(this.t(B,(0,v.localize)(1,null,j.path,X.offset,X.length,(0,g.getParseErrorMessage)(X.error))));return null}return(0,w.getNodeType)(V)!=="object"?(this.j.error(this.t(B,(0,v.localize)(2,null,j.path))),null):V}async n(B,j,M){const V=await this.p(B,j,M);if(V)try{const W=[],q=await this.r(V.default,W);if(W.length>0)return W.forEach(P=>{this.j.error(this.t(B,(0,v.localize)(3,null,V.default?.path,(0,g.getParseErrorMessage)(P.error))))}),j;if((0,w.getNodeType)(V)!=="object")return this.j.error(this.t(B,(0,v.localize)(4,null,V.default?.path))),j;const X=V.values||Object.create(null);return(0,F.localizeManifest)(j,X,q)}catch{}return j}async p(B,j,M){const V=(0,k.joinPath)(B,"package.nls.json"),W=(I,C)=>{C.forEach(U=>{this.j.error(this.t(B,(0,v.localize)(5,null,I?.path,(0,g.getParseErrorMessage)(U.error))))})},q=I=>{this.j.error(this.t(B,(0,v.localize)(6,null,I?.path)))},X=`${j.publisher}.${j.name}`,P=M.translations[X];if(P)try{const I=l.URI.file(P),C=(await this.i.readFile(I)).value.toString(),U=[],$=(0,w.parse)(C,U);return U.length>0?(W(I,U),{values:void 0,default:V}):(0,w.getNodeType)($)!=="object"?(q(I),{values:void 0,default:V}):{values:$.contents?$.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.i.exists(V))return;let C;try{C=await this.s(B,M)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const U=(await this.i.readFile(C.localized)).value.toString(),$=[],G=(0,w.parse)(U,$);return $.length>0?(W(C.localized,$),{values:void 0,default:C.original}):(0,w.getNodeType)(G)!=="object"?(q(C.localized),{values:void 0,default:C.original}):{values:G,default:C.original}}catch{return{values:void 0,default:C.original}}}}async r(B,j){if(B)try{const M=(await this.i.readFile(B)).value.toString();return(0,w.parse)(M,j)}catch{}}s(B,j){return new Promise((M,V)=>{const W=q=>{const X=(0,k.joinPath)(B,`package.nls.${q}.json`);this.i.exists(X).then(P=>{P&&M({localized:X,original:(0,k.joinPath)(B,"package.nls.json")});const I=q.lastIndexOf("-");I===-1?M({localized:(0,k.joinPath)(B,"package.nls.json"),original:null}):(q=q.substring(0,I),W(q))})};if(j.devMode||j.pseudo||!j.language)return M({localized:(0,k.joinPath)(B,"package.nls.json"),original:null});W(j.language)})}t(B,j){return`[${B.path}]: ${j}`}};ne=fe([_(1,u.IExtensionsProfileScannerService),_(2,L.IUriIdentityService),_(3,s.IFileService),_(4,n.ILogService)],ne);let ae=class extends ne{constructor(B,j,M,V,W,q){super(j,M,V,W,q),this.y=B,this.v=this.B(new D.ThrottledDelayer(3e3)),this.w=this.B(new o.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(B){const j=await this.z();if(this.u=B,j&&j.input&&ie.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",B.location.toString()),this.v.trigger(()=>this.D()),j.result.map(V=>(V.location=l.URI.revive(V.location),V));const M=await super.scanExtensions(B);return await this.C({input:B,result:M}),M}async z(){try{const B=await this.i.readFile(this.y),j=JSON.parse(B.value.toString());return{result:j.result,input:(0,a.revive)(j.input)}}catch(B){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,O.getErrorMessage)(B))}return null}async C(B){try{await this.i.writeFile(this.y,T.VSBuffer.fromString(JSON.stringify(B)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,O.getErrorMessage)(j))}}async D(){if(!this.u)return;const B=await this.z();if(!B)return;const j=B.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!R.equals(M,j))try{await this.i.del(this.y),this.w.fire()}catch(V){this.j.error(V)}}};ae=fe([_(2,u.IExtensionsProfileScannerService),_(3,L.IUriIdentityService),_(4,s.IFileService),_(5,n.ILogService)],ae);function ue(ge,B){const j=(0,m.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:j,identifier:new y.ExtensionIdentifier(j),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:B,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=ue;class re extends ee{constructor(B,j,M,V,W,q,X,P,I,C,U,$){super(B,j,(0,k.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,k.joinPath)(V,y.MANIFEST_CACHE_FOLDER),W,q,X,P,I,C,U,$),this.M=(async()=>{if(h.translationsConfigFile)try{const G=await this.r.readFile(l.URI.file(h.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(B){return this.M}}e.NativeExtensionsScannerService=re}),define(Z[147],Q([0,1,57,5,34,4,2,16,14,20,6,21]),function(x,e,N,D,R,T,O,w,g,c,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends O.Disposable{constructor(E,A){super(),this.b=E,this.f=A,this.a=new D.Limiter(5)}async postUninstall(E){const A=this.g(E,"uninstall");return A&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(A.script,"uninstall",A.args,!0,E).then(()=>this.f.info(E.identifier.id,E.manifest.version,"Finished running post uninstall script"),d=>this.f.error(E.identifier.id,E.manifest.version,`Failed to run post uninstall script: ${d}`)))),c.Promises.rm(this.j(E)).then(void 0,d=>this.f.error("Error while removing extension storage path",d))}g(E,A){const d=`vscode:${A}`;if(E.location.scheme===w.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[d]=="string"){const l=E.manifest.scripts[d].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${d} should be a node script`),null):{script:(0,g.join)(E.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(E,A,d,l,v){return new Promise((b,m)=>{const y=this.i(E,A,d,v);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?m(i):b(void 0)};y.on("error",i=>{s((0,R.toErrorMessage)(i)||"Unknown")}),y.on("exit",(i,n)=>{s(i?`post-${A} process exited with code ${i}`:void 0)}),l&&(t=setTimeout(()=>{t=null,y.kill(),m("timed out")},5e3))})}i(E,A,d,l){const v={silent:!0,execArgv:void 0},b=(0,N.fork)(E,[`--type=extension-post-${A}`,...d],v);b.stdout.setEncoding("utf8"),b.stderr.setEncoding("utf8");const m=T.Event.fromNodeEventEmitter(b.stdout,"data"),y=T.Event.fromNodeEventEmitter(b.stderr,"data");m(i=>this.f.info(l.identifier.id,l.manifest.version,`post-${A}`,i)),y(i=>this.f.error(l.identifier.id,l.manifest.version,`post-${A}`,i));const t=T.Event.any(T.Event.map(m,i=>({data:`%c${i}`,format:[""]})),T.Event.map(y,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(l.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),b}j(E){return(0,g.join)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};h=fe([_(0,p.IUserDataProfilesService),_(1,S.ILogService)],h),e.ExtensionsLifecycle=h}),define(Z[148],Q([0,1,6,21,27,25,40,13,17,11]),function(x,e,N,D,R,T,O,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let S=class extends O.AbstractExtensionsProfileScannerService{constructor(h,k,E,A,d,l){super(c.URI.file(h.extensionsPath),k,E,A,d,l)}};S=fe([_(0,g.INativeEnvironmentService),_(1,w.IFileService),_(2,D.IUserDataProfilesService),_(3,R.IUriIdentityService),_(4,T.ITelemetryService),_(5,N.ILogService)],S),e.ExtensionsProfileScannerService=S}),define(Z[149],Q([0,1,11,17,40,48,13,10,6,28,27,21]),function(x,e,N,D,R,T,O,w,g,c,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let h=class extends T.NativeExtensionsScannerService{constructor(E,A,d,l,v,b,m,y){super(N.URI.file(v.builtinExtensionsPath),N.URI.file(v.extensionsPath),v.userHome,N.URI.file(v.userDataPath),E,A,d,l,v,b,m,y)}};h=fe([_(0,p.IUserDataProfilesService),_(1,R.IExtensionsProfileScannerService),_(2,O.IFileService),_(3,g.ILogService),_(4,D.INativeEnvironmentService),_(5,c.IProductService),_(6,S.IUriIdentityService),_(7,w.IInstantiationService)],h),e.ExtensionsScannerService=h}),define(Z[150],Q([0,1,5,4,2,118,3,84,10,21]),function(x,e,N,D,R,T,O,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var S;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var h;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(h=e.StorageTarget||(e.StorageTarget={}));function k(v){const b=v.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.loadKeyTargets=k;class E extends R.Disposable{constructor(b={flushInterval:E.a}){super(),this.j=b,this.b=this.B(new D.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new D.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new N.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new R.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,N.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,R.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.J()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(b,m){if(m===e.TARGET_KEY){switch(b){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:m,target:this.F(b)[m]})}r(b){this.f.fire({reason:b})}get(b,m,y){return this.L(m)?.get(b,y)}getBoolean(b,m,y){return this.L(m)?.getBoolean(b,y)}getNumber(b,m,y){return this.L(m)?.getNumber(b,y)}store(b,m,y,t){if((0,O.isUndefinedOrNull)(m)){this.remove(b,y);return}this.t(()=>{this.u(b,y,t),this.L(y)?.set(b,m)})}remove(b,m){this.t(()=>{this.u(b,m,void 0),this.L(m)?.delete(b)})}t(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,m){const y=[],t=this.F(b);for(const s of Object.keys(t))t[s]===m&&y.push(s);return y}u(b,m,y){const t=this.F(m);typeof y=="number"?t[b]!==y&&(t[b]=y,this.L(m)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[b]=="number"&&(delete t[b],this.L(m)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(b){switch(b){case-1:return this.D;case 0:return this.z;default:return this.w}}G(b){const m=this.L(b);return m?k(m):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=S.NONE){this.f.fire({reason:b});const m=this.L(-1),y=this.L(0),t=this.L(1);switch(b){case S.NONE:await N.Promises.settled([m?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await N.Promises.settled([m?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.L(-1)?.items??new Map,m=this.L(0)?.items??new Map,y=this.L(1)?.items??new Map;return l(b,m,y,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(b,m){return this.r(S.NONE),(0,c.isUserDataProfile)(b)?this.N(b,m):this.O(b,m)}H(b,m){return!(b.id===m.id||A(m)&&A(b))}I(b,m,y,t){this.t(()=>{if(t)for(const[s,i]of b)m.set(s,i);else{const s=new Set;for(const[i,n]of b)s.add(i),m.get(i)!==n&&this.n(y,i);for(const[i]of m.items)s.has(i)||this.n(y,i)}})}}e.AbstractStorageService=E,E.a=60*1e3;function A(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=A;class d extends E{constructor(){super(),this.p=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(b=>this.n(1,b))),this.B(this.P.onDidChangeStorage(b=>this.n(0,b))),this.B(this.p.onDidChangeStorage(b=>this.n(-1,b)))}L(b){switch(b){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(b){return!1}}e.InMemoryStorageService=d;async function l(v,b,m,y,t,s){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},n=new Map,r=new Map;v.forEach((Y,J)=>{n.set(J,Y),r.set(J,i(Y))});const o=new Map,a=new Map;b.forEach((Y,J)=>{o.set(J,Y),a.set(J,i(Y))});const u=new Map,f=new Map;m.forEach((Y,J)=>{u.set(J,Y),f.set(J,i(Y))}),console.group(y!==t?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const L=[];if(n.forEach((Y,J)=>{L.push({key:J,value:Y})}),console.table(L),console.groupEnd(),console.log(r),y!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];o.forEach((J,ee)=>{Y.push({key:ee,value:J})}),console.table(Y),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${s})`);const F=[];u.forEach((Y,J)=>{F.push({key:J,value:Y})}),console.table(F),console.groupEnd(),console.log(f)}e.logStorage=l}),define(Z[151],Q([0,1,19,22,7,12,35,3,11,23,17,24,26,45,13,6,28,47,136,150,25]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A,d,l,v,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const y=T.isWeb?"web":(0,p.getTargetPlatform)(T.platform,O.arch);var t;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function s(...P){return String(P.reduce((I,C)=>I|C,0))}var i;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class u{constructor(I=a){this.d=I}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(I,C=this.d.pageSize){return new u({...this.d,pageNumber:I,pageSize:C})}withFilter(I,...C){const U=[...this.d.criteria,...C.length?C.map($=>({filterType:I,value:$})):[{filterType:I}]];return new u({...this.d,criteria:U})}withSortBy(I){return new u({...this.d,sortBy:I})}withSortOrder(I){return new u({...this.d,sortOrder:I})}withFlags(...I){return new u({...this.d,flags:I.reduce((C,U)=>C|U,0)})}withAssetTypes(...I){return new u({...this.d,assetTypes:I})}withSource(I){return new u({...this.d,source:I})}get raw(){const{criteria:I,pageNumber:C,pageSize:U,sortBy:$,sortOrder:G,flags:te,assetTypes:se}=this.d;return{filters:[{criteria:I,pageNumber:C,pageSize:U,sortBy:$,sortOrder:G}],assetTypes:se,flags:te}}get searchText(){const I=this.d.criteria.filter(C=>C.filterType===i.SearchText)[0];return I&&I.value?I.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(I=>String(I.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function f(P,I){const C=(P||[]).filter(U=>U.statisticName===I)[0];return C?C.value:0}function L(P){const I="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(U=>U.assetType.indexOf(I)===0).reduce((U,$)=>{const G=J(P,$.assetType);return G&&U.push([$.assetType.substring(I.length),G]),U},[])}function F(P){if(P.properties){const I=P.properties.filter($=>$.key===n.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=I.filter($=>C.test($.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return J(P,n.Repository)}function Y(P){return{uri:`${P.fallbackAssetUri}/${n.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${n.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function J(P,I){return P.files.filter(U=>U.assetType===I)[0]?{uri:`${P.assetUri}/${I}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${I}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function ee(P,I){const C=P.properties?P.properties.filter($=>$.key===I):[],U=C.length>0&&C[0].value;return U?U.split(",").map($=>(0,h.adoptToGalleryExtensionId)($)):[]}function ie(P){const I=P.properties?P.properties.filter(C=>C.key===r.Engine):[];return I.length>0&&I[0].value||""}function ne(P){const I=P.properties?P.properties.filter(C=>C.key===r.PreRelease):[];return I.length>0&&I[0].value==="true"}function ae(P){const I=P.properties?P.properties.filter(U=>U.key===r.LocalizedLanguages):[],C=I.length>0&&I[0].value||"";return C?C.split(","):[]}function ue(P){return P.properties?.find(I=>I.key===r.SponsorLink)?.value}function re(P){return P.indexOf("preview")!==-1}function ge(P){return P.targetPlatform?(0,p.toTargetPlatform)(P.targetPlatform):"undefined"}function B(P){const I=(0,N.distinct)(P.versions.map(ge)),C=!!P.tags?.includes(p.WEB_EXTENSION_TAG),U=I.indexOf("web");return C?U===-1&&I.push("web"):U!==-1&&I.splice(U,1),I}function j(P,I){const C=(0,p.getFallbackTargetPlarforms)(I);for(let U=0;U<P.length;U++){const $=P[U];if($.version===P[U-1]?.version){let G=U;const te=ge($);if(te===I)for(;G>0&&P[G-1].version===$.version;)G--;else if(C.includes(te))for(;G>0&&P[G-1].version===$.version&&ge(P[G-1])!==I;)G--;G!==U&&(P.splice(U,1),P.splice(G,0,$))}}return P}e.sortExtensionVersions=j;function M(P,I,C){P.telemetryData={index:I,querySource:C}}function V(P,I,C){const U=P.versions[0],$={manifest:J(I,n.Manifest),readme:J(I,n.Details),changelog:J(I,n.Changelog),license:J(I,n.License),repository:F(I),download:Y(I),icon:J(I,n.Icon),signature:J(I,n.Signature),coreTranslations:L(I)};return{identifier:{id:(0,h.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:I.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:ue(U),description:P.shortDescription||"",installCount:f(P.statistics,"install"),rating:f(P.statistics,"averagerating"),ratingCount:f(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:C,assets:$,properties:{dependencies:ee(I,r.Dependency),extensionPack:ee(I,r.ExtensionPack),engine:ie(I),localizedLanguages:ae(I),targetPlatform:ge(I),isPreReleaseVersion:ne(I)},hasPreReleaseVersion:ne(U),hasReleaseVersion:!0,preview:re(P.flags),isSigned:!!$.signature}}let W=class{constructor(I,C,U,$,G,te,se,he){this.k=C,this.l=U,this.n=$,this.o=G,this.q=te,this.u=se,this.w=he;const ve=se.extensionsGallery,le=ve?.servicePPEUrl&&he.getValue("_extensionsGallery.enablePPE");this.d=le?ve.servicePPEUrl:ve?.serviceUrl,this.g=le?void 0:ve?.searchUrl,this.h=ve?.controlUrl,this.j=(0,v.resolveMarketplaceHeaders)(se.version,se,this.n,this.w,this.q,I,this.o)}x(I=""){return`${this.d}${I}`}isEnabled(){return!!this.d}async getExtensions(I,C,U){const $=D.CancellationToken.isCancellationToken(C)?{}:C,G=D.CancellationToken.isCancellationToken(C)?C:U,te=[],se=[],he=[],ve=[];let le=!0;for(const pe of I){pe.uuid?se.push(pe.uuid):te.push(pe.id);const oe=!!(pe.version||pe.preRelease);he.push({id:pe.id,uuid:pe.uuid,includePreRelease:oe}),pe.version&&ve.push({id:pe.id,uuid:pe.uuid,version:pe.version}),le=le&&!!pe.hasPreRelease&&!oe}if(!se.length&&!te.length)return[];let ce=new u().withPage(1,I.length);se.length&&(ce=ce.withFilter(i.ExtensionId,...se)),te.length&&(ce=ce.withFilter(i.ExtensionName,...te)),($.queryAllVersions||le)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),$.source&&(ce=ce.withSource($.source));const{extensions:we}=await this.z(ce,{targetPlatform:$.targetPlatform??y,includePreRelease:he,versions:ve,compatible:!!$.compatible},G);return $.source&&we.forEach((pe,oe)=>M(pe,oe,$.source)),we}async getCompatibleExtension(I,C,U){if((0,p.isNotWebExtensionInWebTargetPlatform)(I.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(I,C,U))return I;const $=new u().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,I.identifier.uuid),{extensions:G}=await this.z($,{targetPlatform:U,compatible:!0,includePreRelease:C},D.CancellationToken.None);return G[0]||null}async isExtensionCompatible(I,C,U){if(!(0,p.isTargetPlatformCompatible)(I.properties.targetPlatform,I.allTargetPlatforms,U)||!C&&I.properties.isPreReleaseVersion)return!1;let $=I.properties.engine;if(!$){const G=await this.getManifest(I,D.CancellationToken.None);if(!G)throw new Error("Manifest was not found");$=G.engines.vscode}return(0,k.isEngineValid)($,this.u.version,this.u.date)}async y(I,C,U,$,G){if(!(0,p.isTargetPlatformCompatible)(ge(I),$,G)||C!=="any"&&ne(I)!==(C==="prerelease"))return!1;if(U)try{const te=await this.E(I);if(!(0,k.isEngineValid)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${I.version}.`,(0,R.getErrorMessage)(te)),!1}return!0}async query(I,C){let U=I.text||"";const $=I.pageSize??50;let G=new u().withPage(1,$);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ce,we)=>(G=G.withFilter(i.Category,we||ce),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ce,we)=>(G=G.withFilter(i.Tag,we||ce),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(i.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),G=G.withFilter(i.SearchText,U)),G=G.withSortBy(0)):I.ids?G=G.withFilter(i.ExtensionId,...I.ids):I.names?G=G.withFilter(i.ExtensionName,...I.names):G=G.withSortBy(4),typeof I.sortBy=="number"&&(G=G.withSortBy(I.sortBy)),typeof I.sortOrder=="number"&&(G=G.withSortOrder(I.sortOrder)),I.source&&(G=G.withSource(I.source));const te=async(le,ce)=>{const{extensions:we,total:pe}=await this.z(le,{targetPlatform:y,compatible:!1,includePreRelease:!!I.includePreRelease},ce);return we.forEach((oe,Se)=>M(oe,(le.pageNumber-1)*le.pageSize+Se,I.source)),{extensions:we,total:pe}},{extensions:se,total:he}=await te(G,C),ve=async(le,ce)=>{if(ce.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await te(G.withPage(le+1),ce);return we};return{firstPage:se,total:he,pageSize:G.pageSize,getPage:ve}}async z(I,C,U){const $=I.flags;!!(I.flags&t.IncludeLatestVersionOnly)&&!!(I.flags&t.IncludeVersions)&&(I=I.withFlags(I.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(I.flags&t.IncludeLatestVersionOnly)&&!(I.flags&t.IncludeVersions)&&(I=I.withFlags(I.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(I=I.withFlags(I.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),I=I.withFlags(I.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:G,total:te}=await this.B(I,U);if(!(I.flags&t.IncludeLatestVersionOnly)){const le=[];for(const ce of G){const we=await this.A(ce,C);we&&le.push(we)}return{extensions:le,total:te}}const he=[],ve=new Map;for(let le=0;le<G.length;le++){const ce=G[le],we={id:(0,h.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},pe=(0,w.isBoolean)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(Se=>(0,h.areSameExtensions)(Se,we))?.includePreRelease;if(C.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(B(ce),C.targetPlatform))continue;const oe=await this.A(ce,C);!oe||oe.properties.isPreReleaseVersion&&(!pe||!oe.hasReleaseVersion)||!oe.properties.isPreReleaseVersion&&oe.properties.targetPlatform!==C.targetPlatform&&oe.hasPreReleaseVersion?ve.set(ce.extensionId,le):he.push([le,oe])}if(ve.size){const le=new Date().getTime(),ce=new u().withFlags($&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ve.size).withFilter(i.ExtensionId,...ve.keys()),{extensions:we}=await this.z(ce,C,U);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ve.size});for(const pe of we){const oe=ve.get(pe.identifier.uuid);he.push([oe,pe])}}return{extensions:he.sort((le,ce)=>le[0]-ce[0]).map(([,le])=>le),total:te}}async A(I,C){const U={id:(0,h.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},$=C.versions?.find(he=>(0,h.areSameExtensions)(he,U))?.version,G=(0,w.isBoolean)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(he=>(0,h.areSameExtensions)(he,U))?.includePreRelease,te=B(I),se=j(I.versions,C.targetPlatform);if(C.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(te,C.targetPlatform))return null;for(let he=0;he<se.length;he++){const ve=se[he];if(!($&&ve.version!==$)){if(await this.y(ve,G?"any":"release",C.compatible,te,C.targetPlatform))return V(I,ve,te);if($&&ve.version===$)return null}}return $||C.compatible?null:V(I,I.versions[0],te)}async B(I,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");I=I.withFlags(I.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(t.Unpublished));const U=await this.j,$=JSON.stringify(I.raw),G={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String($.length)},te=new Date().getTime();let se,he,ve=0;try{if(se=await this.k.request({type:"POST",url:this.g&&I.criteria.some(ce=>ce.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:$,headers:G},C),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ve};const le=await(0,l.asJson)(se);if(le){const ce=le.results[0],we=ce.extensions,pe=ce.resultMetadata&&ce.resultMetadata.filter(oe=>oe.metadataType==="ResultCount")[0];return ve=pe&&pe.metadataItems.filter(oe=>oe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ve}}return{galleryExtensions:[],total:ve}}catch(le){throw he=le,le}finally{this.o.publicLog2("galleryService:query",{...I.telemetryData,requestBodySize:String($.length),duration:new Date().getTime()-te,success:!!se&&(0,l.isSuccess)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:he?(0,R.isCancellationError)(he)?"canceled":(0,R.getErrorMessage)(he).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(I,C,U,$){if(!this.isEnabled())return;const G=T.isWeb?this.x(`/itemName/${I}.${C}/version/${U}/statType/${$==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${I}/extensions/${C}/${U}/stats?statType=${$}`),te=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:G,headers:he},D.CancellationToken.None)}catch{}}async download(I,C,U){this.l.trace("ExtensionGalleryService#download",I.identifier.id);const $=(0,h.getGalleryExtensionTelemetryData)(I),G=new Date().getTime(),te=le=>this.o.publicLog("galleryService:downloadVSIX",{...$,duration:le}),se=U===2?"install":U===3?"update":"",he=se?{uri:`${I.assets.download.uri}${g.URI.parse(I.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${I.assets.download.fallbackUri}${g.URI.parse(I.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:I.assets.download,ve=await this.D(he);await this.q.writeFile(C,ve.stream),te(new Date().getTime()-G)}async downloadSignatureArchive(I,C){if(!I.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",I.identifier.id);const U=await this.D(I.assets.signature);await this.q.writeFile(C,U.stream)}async getReadme(I,C){if(I.assets.readme){const U=await this.D(I.assets.readme,{},C);return await(0,l.asTextOrError)(U)||""}return""}async getManifest(I,C){if(I.assets.manifest){const U=await this.D(I.assets.manifest,{},C),$=await(0,l.asTextOrError)(U);return $?JSON.parse($):null}return null}async C(I,C){const U=J(I,n.Manifest);if(!U)throw new Error("Manifest was not found");const $={"Accept-Encoding":"gzip"},G=await this.D(U,{headers:$});return await(0,l.asJson)(G)}async getCoreTranslation(I,C){const U=I.assets.coreTranslations.filter($=>$[0]===C.toUpperCase())[0];if(U){const $=await this.D(U[1]),G=await(0,l.asTextOrError)($);return G?JSON.parse(G):null}return null}async getChangelog(I,C){if(I.assets.changelog){const U=await this.D(I.assets.changelog,{},C);return await(0,l.asTextOrError)(U)||""}return""}async getAllCompatibleVersions(I,C,U){let $=new u().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);I.identifier.uuid?$=$.withFilter(i.ExtensionId,I.identifier.uuid):$=$.withFilter(i.ExtensionName,I.identifier.id);const{galleryExtensions:G}=await this.B($,D.CancellationToken.None);if(!G.length)return[];const te=B(G[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(te,U))return[];const se=[];await Promise.all(G[0].versions.map(async le=>{try{await this.y(le,C?"any":"release",!0,te,U)&&se.push(le)}catch{}}));const he=[],ve=new Set;for(const le of j(se,U))ve.has(le.version)||(ve.add(le.version),he.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:ne(le)}));return he}async D(I,C={},U=D.CancellationToken.None){const $=await this.j,G={type:"GET"},te={...$,...C.headers||{}};C={...C,...G,headers:te};const se=I.uri,he=I.fallbackUri,ve={...C,url:se};try{const le=await this.k.request(ve,U);if(le.res.statusCode===200)return le;const ce=await(0,l.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${ce}`)}catch(le){if((0,R.isCancellationError)(le))throw le;const ce=(0,R.getErrorMessage)(le);this.o.publicLog2("galleryService:cdnFallback",{url:se,message:ce});const we={...C,url:he};return this.k.request(we,U)}}async E(I){let C=ie(I);if(!C){const U=await this.C(I,D.CancellationToken.None);if(!U)throw new Error("Manifest was not found");C=U.engines.vscode}return C}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const I=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,l.asJson)(I),U=[],$={};if(C){for(const G of C.malicious)U.push({id:G});if(C.migrateToPreRelease)for(const[G,te]of Object.entries(C.migrateToPreRelease))(!te.engine||(0,k.isEngineValid)(te.engine,this.u.version,this.u.date))&&($[G.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[G,te]of Object.entries(C.deprecated))te&&($[G.toLowerCase()]=(0,w.isBoolean)(te)?{}:te)}return{malicious:U,deprecated:$}}};W=fe([_(1,l.IRequestService),_(2,A.ILogService),_(3,S.IEnvironmentService),_(4,m.ITelemetryService),_(5,E.IFileService),_(6,d.IProductService),_(7,c.IConfigurationService)],W);let q=class extends W{constructor(I,C,U,$,G,te,se,he){super(I,C,U,$,G,te,se,he)}};q=fe([_(0,b.IStorageService),_(1,l.IRequestService),_(2,A.ILogService),_(3,S.IEnvironmentService),_(4,m.ITelemetryService),_(5,E.IFileService),_(6,d.IProductService),_(7,c.IConfigurationService)],q),e.ExtensionGalleryService=q;let X=class extends W{constructor(I,C,U,$,G,te,se){super(void 0,I,C,U,$,G,te,se)}};X=fe([_(0,l.IRequestService),_(1,A.ILogService),_(2,S.IEnvironmentService),_(3,m.ITelemetryService),_(4,E.IFileService),_(5,d.IProductService),_(6,c.IConfigurationService)],X),e.ExtensionGalleryServiceWithNoStorageService=X}),define(Z[152],Q([0,1,44,11,17,13,6,67,27,21]),function(x,e,N,D,R,T,O,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let S=class extends c.UserDataProfilesService{constructor(k,E,A,d){super(E,A,k,d),this.a=E}L(){return this.r.extUri.joinPath(D.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S=fe([_(0,g.IUriIdentityService),_(1,R.INativeEnvironmentService),_(2,T.IFileService),_(3,O.ILogService)],S),e.ServerUserDataProfilesService=S;let p=class $e extends S{constructor(k,E,A,d,l){super(E,A,d,l),this.N=k}G(){return(0,N.revive)(this.N.getItem($e.b,[]))}I(){return(0,N.revive)(this.N.getItem($e.c,{}))}L(){return this.r.extUri.joinPath(D.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p=fe([_(0,w.IStateService),_(1,g.IUriIdentityService),_(2,R.INativeEnvironmentService),_(3,T.IFileService),_(4,O.ILogService)],p),e.UserDataProfilesService=p}),define(Z[153],Q([0,1,38,5,166,2,6]),function(x,e,N,D,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let w=class extends N.AbstractPolicyService{constructor(c,S){super(),this.j=c,this.k=S,this.a=new D.Throttler,this.b=this.B(new T.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((S,p)=>{try{this.b.value=(0,R.createWatcher)(this.k,c,h=>{this.m(h),S()})}catch(h){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",h),p(h)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const S in c){const p=c[S];p===void 0?this.g.delete(S):this.g.set(S,p)}this.h.fire(Object.keys(c))}};w=fe([_(0,O.ILogService)],w),e.NativePolicyService=w}),define(Z[69],Q([0,1,120,5,14,3,20,85,167,168]),function(x,e,N,D,R,T,O,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class S extends Error{constructor(t,s){let i=s.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=s}}e.ExtractError=S;function p(y){const t=y.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,i)=>s+i,t&61440)}function h(y){if(y instanceof S)return y;let t;return/end of central directory record signature not found/.test(y.message)&&(t="CorruptZip"),new S(t,y)}function k(y,t,s,i,n,r){const o=R.dirname(t),a=R.join(i,o);if(!a.startsWith(i))return Promise.reject(new Error(w.localize(0,null,t)));const u=R.join(i,t);let f;return r.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(O.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((L,F)=>{if(!r.isCancellationRequested)try{f=(0,N.createWriteStream)(u,{mode:s}),f.once("close",()=>L()),f.once("error",F),y.once("error",F),y.pipe(f)}catch(Y){F(Y)}}))}function E(y,t,s,i){let n=(0,D.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),y.close()}),new Promise((o,a)=>{const u=new D.Sequencer,f=L=>{L.isCancellationRequested||(r++,y.readEntry())};y.once("error",a),y.once("close",()=>n.then(()=>{i.isCancellationRequested||y.entryCount===r?o():a(new S("Incomplete",new Error(w.localize(1,null,r,y.entryCount))))},a)),y.readEntry(),y.on("entry",L=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(L.fileName)){f(i);return}const F=L.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(F)){const ee=R.join(t,F);n=(0,D.createCancelablePromise)(ie=>O.Promises.mkdir(ee,{recursive:!0}).then(()=>f(ie)).then(void 0,a));return}const Y=d(y,L),J=p(L);n=(0,D.createCancelablePromise)(ee=>u.queue(()=>Y.then(ie=>k(ie,F,J,t,s,ee).then(()=>f(ee)))).then(null,a))})})}function A(y,t=!1){return new Promise((s,i)=>{(0,g.open)(y,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(h(n)):s((0,T.assertIsDefined)(r))})})}function d(y,t){return new Promise((s,i)=>{y.openReadStream(t,(n,r)=>{n?i(h(n)):s((0,T.assertIsDefined)(r))})})}function l(y,t){return new Promise((s,i)=>{const n=new c.ZipFile;t.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,N.createWriteStream)(y);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>s(y))})}e.zip=l;function v(y,t,s={},i){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=A(y,!0);return s.overwrite&&(r=r.then(o=>O.Promises.rm(t).then(()=>o))),r.then(o=>E(o,t,{sourcePathRegex:n},i))}e.extract=v;function b(y,t){return A(y).then(s=>new Promise((i,n)=>{s.on("entry",r=>{r.fileName===t&&d(s,r).then(o=>i(o),o=>n(o))}),s.once("close",()=>n(new Error(w.localize(2,null,t))))}))}function m(y,t){return b(y,t).then(s=>new Promise((i,n)=>{const r=[];s.once("error",n),s.on("data",o=>r.push(o)),s.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=m}),define(Z[154],Q([0,1,69,93]),function(x,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(T){return(0,N.buffer)(T,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.getManifest=R}),define(Z[155],Q([0,1,5,22,34,7,4,2,36,16,14,12,18,41,3,11,31,20,69,92,58,17,146,24,26,40,48,134,147,154,127,135,29,45,13,10,6,28,25,27,21]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A,d,l,v,b,m,y,t,s,i,n,r,o,a,u,f,L,F,Y,J,ee,ie,ne,ae,ue,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(s.IExtensionManagementService);let ge=class extends t.AbstractExtensionManagementService{constructor(P,I,C,U,$,G,te,se,he,ve,le,ce){super(P,I,C,ve,ce),this.Z=$,this.ab=G,this.bb=te,this.cb=he,this.db=le,this.X=this.B(new O.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new g.ResourceSet;const we=this.B(se.createInstance(a.ExtensionsLifecycle));this.S=this.B(se.createInstance(B,oe=>we.postUninstall(oe))),this.U=this.B(new f.ExtensionsManifestCache(U,this)),this.W=this.B(se.createInstance(o.ExtensionsDownloader));const pe=this.B(new L.ExtensionsWatcher(this,this.Z,ce,G,le,he,C));this.B(pe.onDidChangeExtensionsByAnotherSource(oe=>this.kb(oe))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(P){this.v.trace("ExtensionManagementService#zip",P.identifier.id);const I=await this.jb(P),C=await(0,v.zip)((0,h.joinPath)(this.W.extensionsDownloadDir,(0,d.generateUuid)()).fsPath,I);return A.URI.file(C)}async unzip(P){return this.v.trace("ExtensionManagementService#unzip",P.toString()),(await this.install(P)).identifier}async getManifest(P){const{location:I,cleanup:C}=await this.fb(P),U=S.resolve(I.fsPath);try{return await(0,u.getManifest)(U)}finally{await C()}}getInstalled(P,I){return this.S.scanExtensions(P??null,I)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(P,I={}){this.v.trace("ExtensionManagementService#install",P.toString());const{location:C,cleanup:U}=await this.fb(P);try{const $=await(0,u.getManifest)(S.resolve(C.fsPath));if($.engines&&$.engines.vscode&&!(0,Y.isEngineValid)($.engines.vscode,this.w.version,this.w.date))throw new Error(b.localize(0,null,(0,i.getGalleryExtensionId)($.publisher,$.name),this.w.version));return await this.z($,C,I)}finally{await U()}}async installFromLocation(P,I){this.v.trace("ExtensionManagementService#installFromLocation",P.toString());const C=await this.S.scanUserExtensionAtLocation(P);if(!C)throw new Error(`Cannot find a valid extension from the location ${P.toString()}`);return await this.ob([C],I),this.v.info("Successfully installed extension",C.identifier.id,I.toString()),C}getMetadata(P,I=this.y.defaultProfile.extensionsResource){return this.S.scanMetadata(P,I)}async updateMetadata(P,I,C=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",P.identifier.id),I.isPreReleaseVersion&&(I.preRelease=!0),I.isMachineScoped=I.isMachineScoped||void 0,I.isBuiltin=I.isBuiltin||void 0,I.pinned=I.pinned||void 0,P=await this.S.updateMetadata(P,I,C),this.U.invalidate(),this.X.fire(P),P}async reinstallFromGallery(P){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",P.identifier.id),!this.t.isEnabled())throw new Error(b.localize(1,null));const I=await this.getTargetPlatform(),[C]=await this.t.getExtensions([{...P.identifier,preRelease:P.preRelease}],{targetPlatform:I,compatible:!0},D.CancellationToken.None);if(!C)throw new Error(b.localize(2,null));await this.S.setUninstalled(P);try{await this.S.removeUninstalledExtension(P)}catch(U){throw new Error(b.localize(3,null,(0,R.toErrorMessage)(U)))}return this.installFromGallery(C)}markAsUninstalled(...P){return this.S.setUninstalled(...P)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(P,I){const{location:C}=await this.W.download(P,I);return C}async fb(P){if(P.scheme===c.Schemas.file)return{location:P,async cleanup(){}};this.v.trace("Downloading extension from",P.toString());const I=(0,h.joinPath)(this.W.extensionsDownloadDir,(0,d.generateUuid)());return await this.bb.download(P,I),this.v.info("Downloaded extension to",I.toString()),{location:I,cleanup:async()=>{try{await this.cb.del(I)}catch(U){this.v.error(U)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(P,I,C){let U;if(A.URI.isUri(I))U=new V(P,I,C,this.t,this.S,this.v);else{const $=i.ExtensionKey.create(I).toString();U=this.Y.get($),U||(this.Y.set($,U=new M(P,I,C,this.W,this.S,this.v)),U.waitUntilTaskIsFinished().then(()=>this.Y.delete($)))}return new W(U,C.profileLocation,this.db,this.y,this.Z,this.ab)}R(P,I){return new q(P,I.profileLocation,this.ab)}async jb(P){const I=async U=>{let $=await l.Promises.readdir(U);$=$.map(se=>S.join(U,se));const G=await Promise.all($.map(se=>l.Promises.stat(se)));let te=Promise.resolve([]);return G.forEach((se,he)=>{const ve=$[he];se.isFile()&&(te=te.then(le=>[...le,ve])),se.isDirectory()&&(te=te.then(le=>I(ve).then(ce=>[...le,...ce])))}),te};return(await I(P.location.fsPath)).map(U=>({path:`extension/${S.relative(P.location.fsPath,U)}`,localPath:U}))}async kb({added:P,removed:I}){if(I)for(const C of I.extensions)this.v.info("Extensions removed from another source",C.id,I.profileLocation.toString()),this.p.fire({identifier:C,profileLocation:I.profileLocation});if(P){const U=(await this.S.scanExtensions(1,P.profileLocation)).filter($=>P.extensions.some(G=>(0,i.areSameExtensions)(G,$.identifier)));this.m.fire(U.map($=>(this.v.info("Extensions added from another source",$.identifier.id,P.profileLocation.toString()),{identifier:$.identifier,local:$,profileLocation:P.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(I=>this.lb.add(I)));const P=await this.cb.resolve(this.Z.userExtensionsLocation);for(const I of P.children??[])I.isDirectory&&this.lb.add(I.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(I=>this.nb(I)))}async nb(P){if(!P.affects(this.Z.userExtensionsLocation,1))return;const I=[];for(const C of P.rawAdded){if(this.lb.has(C)||!this.db.extUri.isEqual(this.db.extUri.dirname(C),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(C,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(C).startsWith(".")||!(await this.cb.stat(C)).isDirectory)continue;const U=await this.S.scanUserExtensionAtLocation(C);U&&U.installedTimestamp===void 0&&(this.lb.add(C),I.push(U))}I.length&&(await this.ob(I,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",I.map(C=>C.identifier.id)))}async ob(P,I){await this.ab.addExtensionsToProfile(P.map(C=>[C,void 0]),I),this.m.fire(P.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:I})))}};ge=fe([_(0,s.IExtensionGalleryService),_(1,ae.ITelemetryService),_(2,ie.ILogService),_(3,y.INativeEnvironmentService),_(4,r.IExtensionsScannerService),_(5,n.IExtensionsProfileScannerService),_(6,m.IDownloadService),_(7,ee.IInstantiationService),_(8,J.IFileService),_(9,ne.IProductService),_(10,ue.IUriIdentityService),_(11,re.IUserDataProfilesService)],ge),e.ExtensionManagementService=ge;let B=class extends w.Disposable{constructor(P,I,C,U,$){super(),this.j=P,this.k=I,this.l=C,this.m=U,this.n=$,this.h=this.B(new O.Emitter),this.onExtract=this.h.event,this.c=(0,h.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new N.Queue}async cleanUp(){await this.w()}async scanExtensions(P,I){const C={includeInvalid:!0,profileLocation:I};let U=[];return P===null||P===0?U.push(...await this.l.scanAllExtensions({includeInvalid:!0},C,!1)):P===1&&U.push(...await this.l.scanUserExtensions(C)),U=P!==null?U.filter($=>$.type===P):U,Promise.all(U.map($=>this.v($)))}async scanAllUserExtensions(P){const I=await this.l.scanUserExtensions({includeAllVersions:!P,includeInvalid:!0});return Promise.all(I.map(C=>this.v(C)))}async scanUserExtensionAtLocation(P){try{const I=await this.l.scanExistingExtension(P,1,{includeInvalid:!0});if(I)return await this.v(I)}catch(I){this.n.error(I)}return null}async extractUserExtension(P,I,C,U){const $=P.toString(),G=S.join(this.l.userExtensionsLocation.fsPath,`.${(0,d.generateUuid)()}`),te=S.join(this.l.userExtensionsLocation.fsPath,$);try{await l.Promises.rm(te)}catch{throw new s.ExtensionManagementError(b.localize(4,null,te,P.id),s.ExtensionManagementErrorCode.Delete)}await this.s(P,I,G,U),await this.l.updateMetadata(A.URI.file(G),C);try{this.h.fire(A.URI.file(te)),await this.t(P,G,te,Date.now()+2*60*1e3),this.n.info("Renamed to",te)}catch(se){try{await l.Promises.rm(G)}catch{}if(se.code==="ENOTEMPTY")this.n.info("Rename failed because extension was installed by another source. So ignoring renaming.",P.id);else throw this.n.info(`Rename failed because of ${(0,T.getErrorMessage)(se)}. Deleted from extracted location`,G),se}return this.u(A.URI.file(te),1)}async scanMetadata(P,I){return I?(await this.m.scanProfileExtensions(I)).find(U=>(0,i.areSameExtensions)(U.identifier,P.identifier))?.metadata:this.l.scanMetadata(P.location)}async updateMetadata(P,I,C){return C?await this.m.updateMetadata([[P,I]],C):await this.l.updateMetadata(P.location,I),this.u(P.location,P.type)}getUninstalledExtensions(){return this.p()}async setUninstalled(...P){const I=P.map(C=>i.ExtensionKey.create(C));await this.p(C=>I.forEach(U=>{C[U.toString()]=!0,this.n.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(P){await this.p(U=>delete U[P.toString()]);const C=(await this.scanAllUserExtensions(!0)).find(U=>i.ExtensionKey.create(U).equals(P))||null;return C?this.updateMetadata(C,{installedTimestamp:Date.now()}):null}async removeExtension(P,I){this.n.trace(`Deleting ${I} extension from disk`,P.identifier.id,P.location.fsPath),await l.Promises.rm(P.location.fsPath),this.n.info("Deleted from disk",P.identifier.id,P.location.fsPath)}async removeUninstalledExtension(P){await this.removeExtension(P,"uninstalled"),await this.p(I=>delete I[i.ExtensionKey.create(P).toString()])}async p(P){return this.g.queue(async()=>{let I;try{I=await l.Promises.readFile(this.c,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let C={};if(I)try{C=JSON.parse(I)}catch{}return P&&(P(C),Object.keys(C).length?await l.Promises.writeFile(this.c,JSON.stringify(C)):await l.Promises.rm(this.c)),C})}async s(P,I,C,U){this.n.trace(`Started extracting the extension from ${I} to ${C}`);try{await l.Promises.rm(C)}catch($){throw new s.ExtensionManagementError(this.y($).message,s.ExtensionManagementErrorCode.Delete)}try{await(0,v.extract)(I,C,{sourcePath:"extension",overwrite:!0},U),this.n.info(`Extracted extension to ${C}:`,P.id)}catch($){try{await l.Promises.rm(C)}catch{}let G=s.ExtensionManagementErrorCode.Extract;throw $ instanceof v.ExtractError&&($.type==="CorruptZip"?G=s.ExtensionManagementErrorCode.CorruptZip:$.type==="Incomplete"&&(G=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError($.message,G)}}async t(P,I,C,U){try{await l.Promises.rename(I,C)}catch($){if(p.isWindows&&$&&$.code==="EPERM"&&Date.now()<U)return this.n.info(`Failed renaming ${I} to ${C} with 'EPERM' error. Trying again...`,P.id),this.t(P,I,C,U);throw new s.ExtensionManagementError($.message||b.localize(5,null,I,C),$.code||s.ExtensionManagementErrorCode.Rename)}}async u(P,I){const C=await this.l.scanExistingExtension(P,I,{includeInvalid:!0});if(C)return this.v(C);throw new Error(b.localize(6,null,P.path))}async v(P){const I=await this.k.resolve(P.location);let C,U;return I.children&&(C=I.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,U=I.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource),{identifier:P.identifier,type:P.type,isBuiltin:P.isBuiltin||!!P.metadata?.isBuiltin,location:P.location,manifest:P.manifest,targetPlatform:P.targetPlatform,validations:P.validations,isValid:P.isValid,readmeUrl:C,changelogUrl:U,publisherDisplayName:P.metadata?.publisherDisplayName||null,publisherId:P.metadata?.publisherId||null,isApplicationScoped:!!P.metadata?.isApplicationScoped,isMachineScoped:!!P.metadata?.isMachineScoped,isPreReleaseVersion:!!P.metadata?.isPreReleaseVersion,preRelease:!!P.metadata?.preRelease,installedTimestamp:P.metadata?.installedTimestamp,updated:!!P.metadata?.updated,pinned:!!P.metadata?.pinned}}async w(){const P=await this.getUninstalledExtensions(),I=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),C=new Set;for(const G of I)P[i.ExtensionKey.create(G).toString()]||C.add(G.identifier.id.toLowerCase());const U=(0,i.groupByExtension)(I,G=>G.identifier);await N.Promises.settled(U.map(async G=>{const te=G.sort((se,he)=>k.rcompare(se.manifest.version,he.manifest.version))[0];C.has(te.identifier.id.toLowerCase())||await this.j(await this.v(te))}));const $=I.filter(G=>G.metadata&&P[i.ExtensionKey.create(G).toString()]);await N.Promises.settled($.map(G=>this.removeUninstalledExtension(G)))}y(P){const I=Array.isArray(P)?P:[P];return I.length===1?I[0]instanceof Error?I[0]:new Error(I[0]):I.reduce((C,U)=>new Error(`${C.message}${C.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};B=fe([_(1,J.IFileService),_(2,r.IExtensionsScannerService),_(3,n.IExtensionsProfileScannerService),_(4,ie.ILogService)],B),e.ExtensionsScanner=B;class j extends t.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,E.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(P,I,C,U,$){super(),this.identifier=P,this.source=I,this.l=C,this.m=U,this.n=$,this.j="Unverified",this.k=2}async o(P,I){try{const C=await this.p(P.key);if(C)return this.m.updateMetadata(C,P.metadata)}catch{throw p.isMacintosh?new s.ExtensionManagementError(b.localize(7,null),s.ExtensionManagementErrorCode.Internal):new s.ExtensionManagementError(b.localize(8,null),s.ExtensionManagementErrorCode.Internal)}return this.s(P,I)}async p(P){if(!await this.q(P))return null;this.n.trace("Removing the extension from uninstalled list:",P.id);const C=await this.m.setInstalled(P);return this.n.info("Removed the extension from uninstalled list:",P.id),C}async q(P){return!!(await this.m.getUninstalledExtensions())[P.toString()]}async s({zipPath:P,key:I,metadata:C},U){const $=await this.m.extractUserExtension(I,P,C,U);return this.n.info("Extracting completed.",I.id),$}}class M extends j{constructor(P,I,C,U,$,G){super(I.identifier,I,C,$,G),this.t=P,this.u=I,this.v=U}async h(P){const C=(await this.m.scanExtensions(null,this.l.profileLocation)).find(te=>(0,i.areSameExtensions)(te.identifier,this.u.identifier));C&&(this.k=3);const U={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,F.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||C?.isMachineScoped,isBuiltin:this.l.isBuiltin||C?.isBuiltin,isSystem:C?.type===0?!0:void 0,updated:!!C,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.u.properties.isPreReleaseVersion||((0,E.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:C?.preRelease)};if(C?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(C,U),metadata:U};const{location:$,verificationStatus:G}=await this.v.download(this.u,this.k);try{return this.j=G,this.x($.fsPath),{local:await this.o({zipPath:$.fsPath,key:i.ExtensionKey.create(this.u),metadata:U},P),metadata:U}}catch(te){try{await this.v.delete($)}catch(se){this.n.warn("Error while deleting the downloaded file",$.toString(),(0,T.getErrorMessage)(se))}throw te}}async x(P){try{await(0,u.getManifest)(P)}catch(I){throw new s.ExtensionManagementError((0,t.joinErrors)(I).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=M;class V extends j{constructor(P,I,C,U,$,G){super({id:(0,i.getGalleryExtensionId)(P.publisher,P.name)},I,C,$,G),this.t=P,this.u=I,this.v=U}async h(P){const I=new i.ExtensionKey(this.identifier,this.t.version),U=(await this.m.scanExtensions(1,this.l.profileLocation)).find(te=>(0,i.areSameExtensions)(this.identifier,te.identifier)),$=await this.x(this.identifier.id,this.t.version,P);if($.isApplicationScoped=(0,F.isApplicationScopedExtension)(this.t),$.isMachineScoped=this.l.isMachineScoped||U?.isMachineScoped,$.isBuiltin=this.l.isBuiltin||U?.isBuiltin,$.installedTimestamp=Date.now(),$.pinned=this.l.installGivenVersion?!0:void 0,U)if(this.k=3,I.equals(new i.ExtensionKey(U.identifier,U.manifest.version)))try{await this.m.removeExtension(U,"existing")}catch{throw new Error(b.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&k.gt(U.manifest.version,this.t.version)&&await this.m.setUninstalled(U);else{const te=await this.p(I);if(te)try{await this.m.removeExtension(te,"existing")}catch{throw new Error(b.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:S.resolve(this.u.fsPath),key:I,metadata:$},P),metadata:$}}async x(P,I,C){try{let[U]=await this.v.getExtensions([{id:P,version:I}],C);if(U||([U]=await this.v.getExtensions([{id:P}],C)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class W{get verificationStatus(){return this.d.verificationStatus}constructor(P,I,C,U,$,G){this.d=P,this.g=I,this.h=C,this.j=U,this.k=$,this.l=G,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const P=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[P.local,P.metadata]],this.g),P}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends t.AbstractExtensionTask{constructor(P,I,C){super(),this.extension=P,this.j=I,this.k=C}async h(P){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Z[156],Q([0,1,130,5,15,7,2,3,23,17,131,6,129,169]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let E=class extends O.Disposable{constructor(d,l,v){super(),this.h=d,this.i=l,this.j=v,this.k(),this.B(d.onDidChangeConfiguration(b=>{b.affectsConfiguration("http")&&this.k()}))}k(){const d=this.h.getValue("http");this.a=d?.proxy,this.b=!!d?.proxyStrictSSL,this.f=d?.proxyAuthorization}async request(d,l){this.j.trace("RequestService#request (node) - begin",d.url);const{a:v,b}=this;let m;try{m=await(0,S.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(s){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",s))}const y={...process.env,...m},t=d.agent?d.agent:await(0,h.getProxyAgent)(d.url||"",y,{proxyUrl:v,strictSSL:b});d.agent=t,d.strictSSL=b,this.f&&(d.headers={...d.headers||{},"Proxy-Authorization":this.f});try{const s=await this.m(d,l);return this.j.trace("RequestService#request (node) - success",d.url),s}catch(s){throw this.j.trace("RequestService#request (node) - error",d.url,s),s}}async l(d){return((0,N.parse)(d.url).protocol==="https:"?await new Promise((b,m)=>{x(["https"],b,m)}):await new Promise((b,m)=>{x(["http"],b,m)})).request}m(d,l){return D.Promises.withAsyncBody(async(v,b)=>{const m=(0,N.parse)(d.url),y=d.getRawRequest?d.getRawRequest(d):await this.l(d),t={hostname:m.hostname,port:m.port?parseInt(m.port):m.protocol==="https:"?443:80,protocol:m.protocol,path:m.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,w.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(t.auth=d.user+":"+d.password);const s=y(t,i=>{const n=(0,w.isNumber)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...d,url:i.headers.location,followRedirects:n-1},l).then(v,b);else{let r=i;!d.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,k.createGunzip)())),v({res:i,stream:(0,R.streamToBufferReadableStream)(r)})}});s.on("error",b),d.timeout&&s.setTimeout(d.timeout),d.isChromiumNetwork&&s.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&s.write(d.data),s.end(),l.onCancellationRequested(()=>{s.abort(),b(new T.CancellationError)})})}async resolveProxy(d){}};E=fe([_(0,g.IConfigurationService),_(1,c.INativeEnvironmentService),_(2,p.ILogService)],E),e.RequestService=E}),define(Z[170],Q([0,1,33,5,15,34,7,2,16,14,12,35,11,20,23,126,58,128,17,106,151,24,59,133,40,48,155,149,13,117,119,46,115,62,63,137,6,122,123,38,153,140,28,47,156,67,132,68,25,139,39,141,142,27,144,21,152,143,148,121]),function(x,e,N,D,R,T,O,w,g,c,S,p,h,k,E,A,d,l,v,b,m,y,t,s,i,n,r,o,a,u,f,L,F,Y,J,ee,ie,ne,ae,ue,re,ge,B,j,M,V,W,q,X,P,I,C,U,$,G,te,se,he,ve,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ce extends w.Disposable{constructor(oe){super(),this.b=oe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[oe,Se]=await this.f();return oe.invokeFunction(async Ie=>{const Me=Ie.get(ie.ILogService),Ue=Ie.get(a.IFileService),z=Ie.get(v.INativeEnvironmentService),H=Ie.get(te.IUserDataProfilesService);Me.info("CLI main",this.b),this.g(Me),await this.h(z,Ue,H,oe),await Promise.all(Se.map(K=>{(0,D.raceTimeout)(K.flush(),1e3)}))})}async f(){const oe=new Y.ServiceCollection,Se={_serviceBrand:void 0,...ge.default};oe.set(B.IProductService,Se);const Ie=new b.NativeEnvironmentService(this.b,Se);oe.set(v.INativeEnvironmentService,Ie),await Promise.all([Ie.appSettingsHome.fsPath,Ie.extensionsPath].map(ke=>ke?k.Promises.mkdir(ke,{recursive:!0}):void 0));const Me=(0,ie.getLogLevel)(Ie),Ue=new ne.SpdLogLogger("cli",(0,c.join)(Ie.logsPath,"cli.log"),!0,!1,Me),z=[];Me===ie.LogLevel.Trace&&z.push(new ie.ConsoleLogger(Me));const H=this.B(new le.LogService(Ue,z));oe.set(ie.ILogService,H);const K=this.B(new u.FileService(H));oe.set(a.IFileService,K);const de=this.B(new f.DiskFileSystemProvider(H));K.registerProvider(g.Schemas.file,de);const me=new W.StateService(Ie,H,K);oe.set(V.IStateService,me);const Oe=new G.UriIdentityService(K);oe.set($.IUriIdentityService,Oe);const be=new se.UserDataProfilesService(me,Oe,Ie,K,H);oe.set(te.IUserDataProfilesService,be);const Ne=S.isWindows&&Se.win32RegValueName?this.B(new re.NativePolicyService(H,Se.win32RegValueName)):Ie.policyFile?this.B(new ae.FilePolicyService(Ie.policyFile,K,H)):new ue.NullPolicyService;oe.set(ue.IPolicyService,Ne);const Re=this.B(new A.ConfigurationService(be.defaultProfile.settingsResource,K,Ne,H));oe.set(E.IConfigurationService,Re),await Promise.all([me.init(),Re.initialize()]),be.setEnablement(Se.quality!=="stable"||Re.getValue(te.PROFILES_ENABLEMENT_CONFIG)),oe.set($.IUriIdentityService,new G.UriIdentityService(K)),oe.set(j.IRequestService,new L.SyncDescriptor(M.RequestService,void 0,!0)),oe.set(d.IDownloadService,new L.SyncDescriptor(l.DownloadService,void 0,!0)),oe.set(i.IExtensionsProfileScannerService,new L.SyncDescriptor(ve.ExtensionsProfileScannerService,void 0,!0)),oe.set(n.IExtensionsScannerService,new L.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),oe.set(t.IExtensionSignatureVerificationService,new L.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),oe.set(r.INativeServerExtensionManagementService,new L.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),oe.set(y.IExtensionGalleryService,new L.SyncDescriptor(m.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),oe.set(J.ILanguagePackService,new L.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1));const Te=[],Fe=(0,I.isInternalTelemetry)(Se,Re);if((0,I.supportsTelemetry)(Se,Ie)){Se.aiConfig&&Se.aiConfig.ariaKey&&Te.push(new C.OneDataSystemAppender(Fe,"monacoworkbench",null,Se.aiConfig.ariaKey));const{installSourcePath:ke}=Ie,Le={appenders:Te,sendErrorTelemetry:!1,commonProperties:(async()=>{let Ae;try{Ae=await(0,he.resolveMachineId)(me)}catch(je){je.code!=="ENOENT"&&H.error(je)}return(0,q.resolveCommonProperties)(K,(0,N.release)(),(0,N.hostname)(),process.arch,Se.commit,Se.version,Ae,Fe,ke)})(),piiPaths:(0,I.getPiiPathsFromEnvironment)(Ie)};oe.set(X.ITelemetryService,new L.SyncDescriptor(P.TelemetryService,[Le],!1))}else oe.set(X.ITelemetryService,I.NullTelemetryService);return[new F.InstantiationService(oe),Te]}g(oe){(0,O.setUnexpectedErrorHandler)(Se=>{const Ie=(0,T.toErrorMessage)(Se,!0);!Ie||oe.error(`[uncaught exception in CLI]: ${Ie}`)}),process.on("uncaughtException",Se=>(0,O.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,O.onUnexpectedError)(Se))}async h(oe,Se,Ie,Me){const Ue=(oe.args.profile?Ie.profiles.find(z=>z.name===oe.args.profile)??Ie.defaultProfile:Ie.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(oe,Se,this.b["install-source"]);if(this.b["list-extensions"])return Me.createInstance(s.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Ue);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const z={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Ue};return Me.createInstance(s.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],z,!!this.b.force)}else{if(this.b["uninstall-extension"])return Me.createInstance(s.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Ue);if(this.b["locate-extension"])return Me.createInstance(s.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.buildTelemetryMessage)(oe.appRoot,oe.extensionsPath))}}i(oe){return oe.map(Se=>/\.vsix$/i.test(Se)?h.URI.file((0,c.isAbsolute)(Se)?Se:(0,c.join)((0,p.cwd)(),Se)):Se)}async j(oe,Se,Ie){await Se.writeFile(h.URI.file(oe.installSourcePath),R.VSBuffer.fromString(Ie.slice(0,30)))}}async function we(pe){const oe=new ce(pe);try{await oe.run()}finally{oe.dispose()}}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0e76dfa9095a62efe572ae1d215be7ce2a7f1f8e/core/vs/code/node/cliProcessMain.js.map
