/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(te){for(var e=[],a=0,R=te.length;a<R;a++)e[a]=ye[te[a]];return e};define(ye[61],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(C,A){const y=Object.create(null);for(const I of C){const L=A(I);let k=y[L];k||(k=y[L]=[]),k.push(I)}return y}e.groupBy=a;function R(C,A){const y=[],I=[];for(const L of C)A.has(L)||y.push(L);for(const L of A)C.has(L)||I.push(L);return{removed:y,added:I}}e.diffSets=R;function T(C,A){const y=[],I=[];for(const[L,k]of C)A.has(L)||y.push(k);for(const[L,k]of A)C.has(L)||I.push(k);return{removed:y,added:I}}e.diffMaps=T;class u{constructor(){this.a=new Map}add(A,y){let I=this.a.get(A);I||(I=new Set,this.a.set(A,I)),I.add(y)}delete(A,y){const I=this.a.get(A);!I||(I.delete(y),I.size===0&&this.a.delete(A))}forEach(A,y){const I=this.a.get(A);!I||I.forEach(y)}}e.SetMap=u}),define(ye[62],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(C){return(A,y,I)=>{let L=null,k=null;if(typeof I.value=="function"?(L="value",k=I.value):typeof I.get=="function"&&(L="get",k=I.get),!k)throw new Error("not supported");I[L]=C(k,y)}}function R(C,A,y){let I=null,L=null;if(typeof y.value=="function"?(I="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(I="get",L=y.get),!L)throw new Error("not supported");const k=`$memoize$${A}`;y[I]=function(...v){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[k]}}e.memoize=R;function T(C,A,y){return a((I,L)=>{const k=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...P){this[v]||(this[v]=y?y():void 0),clearTimeout(this[k]),A&&(this[v]=A(this[v],...P),P=[this[v]]),this[k]=setTimeout(()=>{I.apply(this,P),this[v]=y?y():void 0},C)}})}e.debounce=T;function u(C,A,y){return a((I,L)=>{const k=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,P=`$throttle$lastRun$${L}`,E=`$throttle$pending$${L}`;return function(...h){if(this[v]||(this[v]=y?y():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),A&&(this[v]=A(this[v],...h)),this[E])return;const d=this[P]+C;d<=Date.now()?(this[P]=Date.now(),I.apply(this,[this[v]]),this[v]=y?y():void 0):(this[E]=!0,this[k]=setTimeout(()=>{this[E]=!1,this[P]=Date.now(),I.apply(this,[this[v]]),this[v]=y?y():void 0},d-Date.now()))}})}e.throttle=u}),define(ye[11],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?b.isErrorNoTelemetry(t)?new b(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.ErrorHandler=a,e.errorHandler=new a;function R(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=R;function T(g){y(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=T;function u(g){y(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=u;function C(g){if(g instanceof Error){const{name:t,message:l}=g,r=g.stacktrace||g.stack;return{$isError:!0,name:t,message:l,stack:r,noTelemetry:b.isErrorNoTelemetry(g)}}return g}e.transformErrorForSerialization=C;const A="Canceled";function y(g){return g instanceof I?!0:g instanceof Error&&g.name===A&&g.message===A}e.isCancellationError=y;class I extends Error{constructor(){super(A),this.name=this.message}}e.CancellationError=I;function L(){const g=new Error(A);return g.name=g.message,g}e.canceled=L;function k(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=k;function v(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=v;function P(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=P;function E(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=E;function h(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=h;class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=d;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=f;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class b extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof b)return t;const l=new b;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class S extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}e.BugIndicatingError=S}),define(ye[15],De([1,0,11]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function R(se,oe=0){return se[se.length-(1+oe)]}e.tail=R;function T(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=T;function u(se,oe,fe=(Z,ce)=>Z===ce){if(se===oe)return!0;if(!se||!oe||se.length!==oe.length)return!1;for(let Z=0,ce=se.length;Z<ce;Z++)if(!fe(se[Z],oe[Z]))return!1;return!0}e.equals=u;function C(se,oe){const fe=se.length-1;oe<fe&&(se[oe]=se[fe]),se.pop()}e.removeFastWithoutKeepingOrder=C;function A(se,oe,fe){return y(se.length,Z=>fe(se[Z],oe))}e.binarySearch=A;function y(se,oe){let fe=0,Z=se-1;for(;fe<=Z;){const ce=(fe+Z)/2|0,ne=oe(ce);if(ne<0)fe=ce+1;else if(ne>0)Z=ce-1;else return ce}return-(fe+1)}e.binarySearch2=y;function I(se,oe){let fe=0,Z=se.length;if(Z===0)return 0;for(;fe<Z;){const ce=Math.floor((fe+Z)/2);oe(se[ce])?Z=ce:fe=ce+1}return fe}e.findFirstInSorted=I;function L(se,oe,fe){if(se=se|0,se>=oe.length)throw new TypeError("invalid index");const Z=oe[Math.floor(oe.length*Math.random())],ce=[],ne=[],N=[];for(const H of oe){const Q=fe(H,Z);Q<0?ce.push(H):Q>0?ne.push(H):N.push(H)}return se<ce.length?L(se,ce,fe):se<ce.length+N.length?N[0]:L(se-(ce.length+N.length),ne,fe)}e.quickSelect=L;function k(se,oe){const fe=[];let Z;for(const ce of se.slice(0).sort(oe))!Z||oe(Z[0],ce)!==0?(Z=[ce],fe.push(Z)):Z.push(ce);return fe}e.groupBy=k;function v(se,oe,fe){const Z=[];function ce(H,Q,Y){if(Q===0&&Y.length===0)return;const he=Z[Z.length-1];he&&he.start+he.deleteCount===H?(he.deleteCount+=Q,he.toInsert.push(...Y)):Z.push({start:H,deleteCount:Q,toInsert:Y})}let ne=0,N=0;for(;;){if(ne===se.length){ce(ne,0,oe.slice(N));break}if(N===oe.length){ce(ne,se.length-ne,[]);break}const H=se[ne],Q=oe[N],Y=fe(H,Q);Y===0?(ne+=1,N+=1):Y<0?(ce(ne,1,[]),ne+=1):Y>0&&(ce(ne,0,[Q]),N+=1)}return Z}e.sortedDiff=v;function P(se,oe,fe){const Z=v(se,oe,fe),ce=[],ne=[];for(const N of Z)ce.push(...se.slice(N.start,N.start+N.deleteCount)),ne.push(...N.toInsert);return{removed:ce,added:ne}}e.delta=P;function E(se,oe,fe){if(fe===0)return[];const Z=se.slice(0,fe).sort(oe);return d(se,oe,Z,fe,se.length),Z}e.top=E;function h(se,oe,fe,Z,ce){return fe===0?Promise.resolve([]):new Promise((ne,N)=>{(async()=>{const H=se.length,Q=se.slice(0,fe).sort(oe);for(let Y=fe,he=Math.min(fe+Z,H);Y<H;Y=he,he=Math.min(he+Z,H)){if(Y>fe&&await new Promise(ve=>setTimeout(ve)),ce&&ce.isCancellationRequested)throw new a.CancellationError;d(se,oe,Q,Y,he)}return Q})().then(ne,N)})}e.topAsync=h;function d(se,oe,fe,Z,ce){for(const ne=fe.length;Z<ce;Z++){const N=se[Z];if(oe(N,fe[ne-1])<0){fe.pop();const H=I(fe,Q=>oe(N,Q)<0);fe.splice(H,0,N)}}}function f(se){return se.filter(oe=>!!oe)}e.coalesce=f;function p(se){let oe=0;for(let fe=0;fe<se.length;fe++)se[fe]&&(se[oe]=se[fe],oe+=1);se.length=oe}e.coalesceInPlace=p;function b(se,oe,fe){se.splice(fe,0,se.splice(oe,1)[0])}e.move=b;function S(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=S;function g(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=g;function t(se,oe=fe=>fe){const fe=new Set;return se.filter(Z=>{const ce=oe(Z);return fe.has(ce)?!1:(fe.add(ce),!0)})}e.distinct=t;function l(se){const oe=new Set;return fe=>{const Z=se(fe);return oe.has(Z)?!1:(oe.add(Z),!0)}}e.uniqueFilter=l;function r(se,oe){const fe=o(se,oe);if(fe!==-1)return se[fe]}e.findLast=r;function o(se,oe){for(let fe=se.length-1;fe>=0;fe--){const Z=se[fe];if(oe(Z))return fe}return-1}e.lastIndex=o;function n(se,oe){return se.length>0?se[0]:oe}e.firstOrDefault=n;function m(se,oe){return se.length>0?se[se.length-1]:oe}e.lastOrDefault=m;function s(se,oe,fe=(Z,ce)=>Z===ce){let Z=0;for(let ce=0,ne=Math.min(se.length,oe.length);ce<ne&&fe(se[ce],oe[ce]);ce++)Z++;return Z}e.commonPrefixLength=s;function i(se){return[].concat(...se)}e.flatten=i;function c(se,oe){let fe=typeof oe=="number"?se:0;typeof oe=="number"?fe=se:(fe=0,oe=se);const Z=[];if(fe<=oe)for(let ce=fe;ce<oe;ce++)Z.push(ce);else for(let ce=fe;ce>oe;ce--)Z.push(ce);return Z}e.range=c;function w(se,oe,fe){return se.reduce((Z,ce)=>(Z[oe(ce)]=fe?fe(ce):ce,Z),Object.create(null))}e.index=w;function D(se,oe){return se.push(oe),()=>F(se,oe)}e.insert=D;function F(se,oe){const fe=se.indexOf(oe);if(fe>-1)return se.splice(fe,1),oe}e.remove=F;function x(se,oe,fe){const Z=se.slice(0,oe),ce=se.slice(oe);return Z.concat(fe,ce)}e.arrayInsert=x;function q(se,oe){let fe;if(typeof oe=="number"){let Z=oe;fe=()=>{const ce=Math.sin(Z++)*179426549;return ce-Math.floor(ce)}}else fe=Math.random;for(let Z=se.length-1;Z>0;Z-=1){const ce=Math.floor(fe()*(Z+1)),ne=se[Z];se[Z]=se[ce],se[ce]=ne}}e.shuffle=q;function M(se,oe){const fe=se.indexOf(oe);fe>-1&&(se.splice(fe,1),se.unshift(oe))}e.pushToStart=M;function B(se,oe){const fe=se.indexOf(oe);fe>-1&&(se.splice(fe,1),se.push(oe))}e.pushToEnd=B;function O(se,oe){for(const fe of oe)se.push(fe)}e.pushMany=O;function U(se,oe){return Array.isArray(se)?se.map(oe):oe(se)}e.mapArrayOrNot=U;function z(se){return Array.isArray(se)?se:[se]}e.asArray=z;function j(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=j;function le(se,oe){for(const fe of se){const Z=oe(fe);if(Z!==void 0)return Z}}e.mapFind=le;function V(se,oe,fe){const Z=J(se,oe),ce=se.length,ne=fe.length;se.length=ce+ne;for(let N=ce-1;N>=Z;N--)se[N+ne]=se[N];for(let N=0;N<ne;N++)se[N+Z]=fe[N]}e.insertInto=V;function _(se,oe,fe,Z){const ce=J(se,oe),ne=se.splice(ce,fe);return V(se,ce,Z),ne}e.splice=_;function J(se,oe){return oe<0?Math.max(oe+se.length,0):Math.min(oe,se.length)}var ie;(function(se){function oe(ce){return ce<0}se.isLessThan=oe;function fe(ce){return ce>0}se.isGreaterThan=fe;function Z(ce){return ce===0}se.isNeitherLessOrGreaterThan=Z,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function ee(se,oe){return(fe,Z)=>oe(se(fe),se(Z))}e.compareBy=ee;function K(...se){return(oe,fe)=>{for(const Z of se){const ce=Z(oe,fe);if(!ie.isNeitherLessOrGreaterThan(ce))return ce}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=K;const G=(se,oe)=>se-oe;e.numberComparator=G;function de(se,oe){if(se.length===0)return;let fe=se[0];for(let Z=1;Z<se.length;Z++){const ce=se[Z];oe(ce,fe)>0&&(fe=ce)}return fe}e.findMaxBy=de;function be(se,oe){if(se.length===0)return;let fe=se[0];for(let Z=1;Z<se.length;Z++){const ce=se[Z];oe(ce,fe)>=0&&(fe=ce)}return fe}e.findLastMaxBy=be;function Ee(se,oe){return de(se,(fe,Z)=>-oe(fe,Z))}e.findMinBy=Ee;class Pe{constructor(oe){this.f=oe,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(oe){let fe=this.c;for(;fe<this.f.length&&oe(this.f[fe]);)fe++;const Z=fe===this.c?null:this.f.slice(this.c,fe);return this.c=fe,Z}takeFromEndWhile(oe){let fe=this.d;for(;fe>=0&&oe(this.f[fe]);)fe--;const Z=fe===this.d?null:this.f.slice(fe+1,this.d+1);return this.d=fe,Z}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const oe=this.f[this.c];return this.c++,oe}removeLast(){const oe=this.f[this.d];return this.d--,oe}takeCount(oe){const fe=this.f.slice(this.c,this.c+oe);return this.c+=oe,fe}}e.ArrayQueue=Pe;class Fe{constructor(oe){this.iterate=oe}forEach(oe){this.iterate(fe=>(oe(fe),!0))}toArray(){const oe=[];return this.iterate(fe=>(oe.push(fe),!0)),oe}filter(oe){return new Fe(fe=>this.iterate(Z=>oe(Z)?fe(Z):!0))}map(oe){return new Fe(fe=>this.iterate(Z=>fe(oe(Z))))}some(oe){let fe=!1;return this.iterate(Z=>(fe=oe(Z),!fe)),fe}findFirst(oe){let fe;return this.iterate(Z=>oe(Z)?(fe=Z,!1):!0),fe}findLast(oe){let fe;return this.iterate(Z=>(oe(Z)&&(fe=Z),!0)),fe}findLastMaxBy(oe){let fe,Z=!0;return this.iterate(ce=>((Z||ie.isGreaterThan(oe(ce,fe)))&&(Z=!1,fe=ce),!0)),fe}}e.CallbackIterable=Fe,Fe.empty=new Fe(se=>{})}),define(ye[50],De([1,0,11]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(y,I){if(!y)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=R;function T(y,I="Unreachable"){throw new Error(I)}e.assertNever=T;function u(y){if(!y)throw new a.BugIndicatingError("Assertion Failed")}e.assert=u;function C(y){if(!y()){debugger;y(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function A(y,I){let L=0;for(;L<y.length-1;){const k=y[L],v=y[L+1];if(!I(k,v))return!1;L++}return!0}e.checkAdjacentItems=A}),define(ye[63],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(R){const T=this;let u=!1,C;return function(){return u||(u=!0,C=R.apply(T,arguments)),C}}e.once=a}),define(ye[101],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(T){this.a=T,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(ye[64],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(R){function T(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}R.is=T;const u=Object.freeze([]);function C(){return u}R.empty=C;function*A(S){yield S}R.single=A;function y(S){return T(S)?S:A(S)}R.wrap=y;function I(S){return S||u}R.from=I;function L(S){return!S||S[Symbol.iterator]().next().done===!0}R.isEmpty=L;function k(S){return S[Symbol.iterator]().next().value}R.first=k;function v(S,g){for(const t of S)if(g(t))return!0;return!1}R.some=v;function P(S,g){for(const t of S)if(g(t))return t}R.find=P;function*E(S,g){for(const t of S)g(t)&&(yield t)}R.filter=E;function*h(S,g){let t=0;for(const l of S)yield g(l,t++)}R.map=h;function*d(...S){for(const g of S)for(const t of g)yield t}R.concat=d;function f(S,g,t){let l=t;for(const r of S)l=g(l,r);return l}R.reduce=f;function*p(S,g,t=S.length){for(g<0&&(g+=S.length),t<0?t+=S.length:t>S.length&&(t=S.length);g<t;g++)yield S[g]}R.slice=p;function b(S,g=Number.POSITIVE_INFINITY){const t=[];if(g===0)return[t,S];const l=S[Symbol.iterator]();for(let r=0;r<g;r++){const o=l.next();if(o.done)return[t,R.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return l}}]}R.consume=b})(a=e.Iterable||(e.Iterable={}))}),define(ye[146],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var u;(function(t){t.DEFAULT={allowTrailingComma:!0}})(u=e.ParseOptions||(e.ParseOptions={}));function C(t,l=!1){let r=0;const o=t.length;let n="",m=0,s=16,i=0;function c(B){let O=0,U=0;for(;O<B;){const z=t.charCodeAt(r);if(z>=48&&z<=57)U=U*16+z-48;else if(z>=65&&z<=70)U=U*16+z-65+10;else if(z>=97&&z<=102)U=U*16+z-97+10;else break;r++,O++}return O<B&&(U=-1),U}function w(B){r=B,n="",m=0,s=16,i=0}function D(){const B=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&I(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&I(t.charCodeAt(r)))for(r++;r<t.length&&I(t.charCodeAt(r));)r++;else return i=3,t.substring(B,r);let O=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&I(t.charCodeAt(r))){for(r++;r<t.length&&I(t.charCodeAt(r));)r++;O=r}else i=3;return t.substring(B,O)}function F(){let B="",O=r;for(;;){if(r>=o){B+=t.substring(O,r),i=2;break}const U=t.charCodeAt(r);if(U===34){B+=t.substring(O,r),r++;break}if(U===92){if(B+=t.substring(O,r),r++,r>=o){i=2;break}switch(t.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const j=c(4);j>=0?B+=String.fromCharCode(j):i=4;break}default:i=5}O=r;continue}if(U>=0&&U<=31)if(y(U)){B+=t.substring(O,r),i=2;break}else i=6;r++}return B}function x(){if(n="",i=0,m=r,r>=o)return m=o,s=17;let B=t.charCodeAt(r);if(A(B)){do r++,n+=String.fromCharCode(B),B=t.charCodeAt(r);while(A(B));return s=15}if(y(B))return r++,n+=String.fromCharCode(B),B===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),s=14;switch(B){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,n=F(),s=10;case 47:{const O=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<o&&!y(t.charCodeAt(r));)r++;return n=t.substring(O,r),s=12}if(t.charCodeAt(r+1)===42){r+=2;const U=o-1;let z=!1;for(;r<U;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,z=!0;break}r++}return z||(r++,i=1),n=t.substring(O,r),s=13}return n+=String.fromCharCode(B),r++,s=16}case 45:if(n+=String.fromCharCode(B),r++,r===o||!I(t.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=D(),s=11;default:for(;r<o&&q(B);)r++,B=t.charCodeAt(r);if(m!==r){switch(n=t.substring(m,r),n){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return n+=String.fromCharCode(B),r++,s=16}}function q(B){if(A(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:w,getPosition:()=>r,scan:l?M:x,getToken:()=>s,getTokenValue:()=>n,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>i}}e.createScanner=C;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function k(t,l){const r=[],o=new Object;let n;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function i(c,w,D,F){m.value=c,m.offset=w,m.length=D,m.type=F,m.colonOffset=void 0,n=m}try{b(t,{onObjectBegin:(c,w)=>{if(l<=c)throw o;n=void 0,s=l>c,r.push("")},onObjectProperty:(c,w,D)=>{if(l<w||(i(c,w,D,"property"),r[r.length-1]=c,l<=w+D))throw o},onObjectEnd:(c,w)=>{if(l<=c)throw o;n=void 0,r.pop()},onArrayBegin:(c,w)=>{if(l<=c)throw o;n=void 0,r.push(0)},onArrayEnd:(c,w)=>{if(l<=c)throw o;n=void 0,r.pop()},onLiteralValue:(c,w,D)=>{if(l<w||(i(c,w,D,g(c)),l<=w+D))throw o},onSeparator:(c,w,D)=>{if(l<=w)throw o;if(c===":"&&n&&n.type==="property")n.colonOffset=w,s=!1,n=void 0;else if(c===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(s=!0,r[r.length-1]=""),n=void 0}}})}catch(c){if(c!==o)throw c}return{path:r,previousNode:n,isAtPropertyKey:s,matches:c=>{let w=0;for(let D=0;w<c.length&&D<r.length;D++)if(c[w]===r[D]||c[w]==="*")w++;else if(c[w]!=="**")return!1;return w===c.length}}}e.getLocation=k;function v(t,l=[],r=u.DEFAULT){let o=null,n=[];const m=[];function s(c){Array.isArray(n)?n.push(c):o!==null&&(n[o]=c)}return b(t,{onObjectBegin:()=>{const c={};s(c),m.push(n),n=c,o=null},onObjectProperty:c=>{o=c},onObjectEnd:()=>{n=m.pop()},onArrayBegin:()=>{const c=[];s(c),m.push(n),n=c,o=null},onArrayEnd:()=>{n=m.pop()},onLiteralValue:s,onError:(c,w,D)=>{l.push({error:c,offset:w,length:D})}},r),n[0]}e.parse=v;function P(t,l=[],r=u.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(c){o.type==="property"&&(o.length=c-o.offset,o=o.parent)}function m(c){return o.children.push(c),c}b(t,{onObjectBegin:c=>{o=m({type:"object",offset:c,length:-1,parent:o,children:[]})},onObjectProperty:(c,w,D)=>{o=m({type:"property",offset:w,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:c,offset:w,length:D,parent:o})},onObjectEnd:(c,w)=>{o.length=c+w-o.offset,o=o.parent,n(c+w)},onArrayBegin:(c,w)=>{o=m({type:"array",offset:c,length:-1,parent:o,children:[]})},onArrayEnd:(c,w)=>{o.length=c+w-o.offset,o=o.parent,n(c+w)},onLiteralValue:(c,w,D)=>{m({type:g(c),offset:w,length:D,parent:o,value:c}),n(w+D)},onSeparator:(c,w,D)=>{o.type==="property"&&(c===":"?o.colonOffset=w:c===","&&n(w))},onError:(c,w,D)=>{l.push({error:c,offset:w,length:D})}},r);const i=o.children[0];return i&&delete i.parent,i}e.parseTree=P;function E(t,l){if(!t)return;let r=t;for(const o of l)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===o){r=m.children[1],n=!0;break}if(!n)return}else{const n=o;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.findNodeAtLocation=E;function h(t){if(!t.parent||!t.parent.children)return[];const l=h(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;l.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&l.push(r)}return l}e.getNodePath=h;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const l=Object.create(null);for(const r of t.children){const o=r.children[1];o&&(l[r.children[0].value]=d(o))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=d;function f(t,l,r=!1){return l>=t.offset&&l<t.offset+t.length||r&&l===t.offset+t.length}e.contains=f;function p(t,l,r=!1){if(f(t,l,r)){const o=t.children;if(Array.isArray(o))for(let n=0;n<o.length&&o[n].offset<=l;n++){const m=p(o[n],l,r);if(m)return m}return t}}e.findNodeAtOffset=p;function b(t,l,r=u.DEFAULT){const o=C(t,!1);function n(ee){return ee?()=>ee(o.getTokenOffset(),o.getTokenLength()):()=>!0}function m(ee){return ee?K=>ee(K,o.getTokenOffset(),o.getTokenLength()):()=>!0}const s=n(l.onObjectBegin),i=m(l.onObjectProperty),c=n(l.onObjectEnd),w=n(l.onArrayBegin),D=n(l.onArrayEnd),F=m(l.onLiteralValue),x=m(l.onSeparator),q=n(l.onComment),M=m(l.onError),B=r&&r.disallowComments,O=r&&r.allowTrailingComma;function U(){for(;;){const ee=o.scan();switch(o.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:B||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ee){case 12:case 13:B?z(10):q();break;case 16:z(1);break;case 15:case 14:break;default:return ee}}}function z(ee,K=[],G=[]){if(M(ee),K.length+G.length>0){let de=o.getToken();for(;de!==17;){if(K.indexOf(de)!==-1){U();break}else if(G.indexOf(de)!==-1)break;de=U()}}}function j(ee){const K=o.getTokenValue();return ee?F(K):i(K),U(),!0}function le(){switch(o.getToken()){case 11:{let ee=0;try{ee=JSON.parse(o.getTokenValue()),typeof ee!="number"&&(z(2),ee=0)}catch{z(2)}F(ee);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return U(),!0}function V(){return o.getToken()!==10?(z(3,[],[2,5]),!1):(j(!1),o.getToken()===6?(x(":"),U(),ie()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function _(){s(),U();let ee=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ee||z(4,[],[]),x(","),U(),o.getToken()===2&&O)break}else ee&&z(6,[],[]);V()||z(4,[],[2,5]),ee=!0}return c(),o.getToken()!==2?z(7,[2],[]):U(),!0}function J(){w(),U();let ee=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ee||z(4,[],[]),x(","),U(),o.getToken()===4&&O)break}else ee&&z(6,[],[]);ie()||z(4,[],[4,5]),ee=!0}return D(),o.getToken()!==4?z(8,[4],[]):U(),!0}function ie(){switch(o.getToken()){case 3:return J();case 1:return _();case 10:return j(!0);default:return le()}}return U(),o.getToken()===17?r.allowEmptyContent?!0:(z(4,[],[]),!1):ie()?(o.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=b;function S(t,l){const r=C(t),o=[];let n,m=0,s;do switch(s=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:m!==s&&o.push(t.substring(m,s)),l!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,l)),m=r.getPosition();break}while(n!==17);return o.join("")}e.stripComments=S;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ye[65],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(T){this.d=T,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(T){this.c=T}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=a}),define(ye[6],De([1,0,63,64]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let u=null;function C(m){u=m}if(e.setDisposableTracker=C,T){const m="__is_disposable_tracked__";C(new class{trackDisposable(s){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[m]||console.log(i)},3e3)}setParent(s,i){if(s&&s!==p.None)try{s[m]=!0}catch{}}markAsDisposed(s){if(s&&s!==p.None)try{s[m]=!0}catch{}}markAsSingleton(s){}})}function A(m){return u?.trackDisposable(m),m}function y(m){u?.markAsDisposed(m)}function I(m,s){u?.setParent(m,s)}function L(m,s){if(!!u)for(const i of m)u.setParent(i,s)}function k(m){return u?.markAsSingleton(m),m}e.markAsSingleton=k;function v(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=v;function P(m){if(R.Iterable.is(m)){const s=[];for(const i of m)if(i)try{i.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.dispose=P;function E(m){for(const s of m)v(s)&&s.dispose();return[]}e.disposeIfDisposable=E;function h(...m){const s=d(()=>P(m));return L(m,s),s}e.combinedDisposable=h;function d(m){const s=A({dispose:(0,a.once)(()=>{y(s),m()})});return s}e.toDisposable=d;class f{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{P(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return I(s,this),this.f?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this.q=new f,A(this),I(this.q,this)}dispose(){y(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class b{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&I(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&I(s,null),s}}e.MutableDisposable=b;class S{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(s){let i=s;return this.unset=()=>i=void 0,this.isset=()=>i!==void 0,this.dispose=()=>{i&&(i(),i=void 0,y(this))},this}}e.SafeDisposable=g;class t{constructor(){this.a=new Map}acquire(s,...i){let c=this.a.get(s);c||(c={counter:0,object:this.b(s,...i)},this.a.set(s,c));const{object:w}=c,D=(0,a.once)(()=>{--c.counter===0&&(this.c(s,c.object),this.a.delete(s))});return c.counter++,{object:w,dispose:D}}}e.ReferenceCollection=t;class l{constructor(s){this.a=s}async acquire(s,...i){const c=this.a.acquire(s,...i);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(w){throw c.dispose(),w}}}e.AsyncReferenceCollection=l;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r;function o(m){const s=new f;try{m(s)}finally{s.dispose()}}e.disposeOnReturn=o;class n{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{P(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,i,c=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),c||this.a.get(s)?.dispose(),this.a.set(s,i)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=n}),define(ye[66],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(u){this.element=u,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class R{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let u=this.a;for(;u!==a.Undefined;){const C=u.next;u.prev=a.Undefined,u.next=a.Undefined,u=C}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(u){return this.d(u,!1)}push(u){return this.d(u,!0)}d(u,C){const A=new a(u);if(this.a===a.Undefined)this.a=A,this.b=A;else if(C){const I=this.b;this.b=A,A.prev=I,I.next=A}else{const I=this.a;this.a=A,A.next=I,I.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==a.Undefined){const u=this.a.element;return this.e(this.a),u}}pop(){if(this.b!==a.Undefined){const u=this.b.element;return this.e(this.b),u}}e(u){if(u.prev!==a.Undefined&&u.next!==a.Undefined){const C=u.prev;C.next=u.next,u.next.prev=C}else u.prev===a.Undefined&&u.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):u.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):u.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let u=this.a;for(;u!==a.Undefined;)yield u.element,u=u.next}}e.LinkedList=R}),define(ye[28],De([1,0]),function(te,e){"use strict";var a,R,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function u(E,h,d){let f=E.get(h);return f===void 0&&(f=d,E.set(h,f)),f}e.getOrSet=u;function C(E){const h=[];return E.forEach((d,f)=>{h.push(`${f} => ${d}`)}),`Map(${E.size}) {${h.join(", ")}}`}e.mapToString=C;function A(E){const h=[];return E.forEach(d=>{h.push(d)}),`Set(${E.size}) {${h.join(", ")}}`}e.setToString=A;class y{constructor(h,d){this.uri=h,this.value=d}}class I{constructor(h,d){this[a]="ResourceMap",h instanceof I?(this.b=new Map(h.b),this.c=d??I.a):(this.b=new Map,this.c=h??I.a)}set(h,d){return this.b.set(this.c(h),new y(h,d)),this}get(h){return this.b.get(this.c(h))?.value}has(h){return this.b.has(this.c(h))}get size(){return this.b.size}clear(){this.b.clear()}delete(h){return this.b.delete(this.c(h))}forEach(h,d){typeof d<"u"&&(h=h.bind(d));for(const[f,p]of this.b)h(p.value,p.uri,this)}*values(){for(const h of this.b.values())yield h.value}*keys(){for(const h of this.b.values())yield h.uri}*entries(){for(const h of this.b.values())yield[h.uri,h.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.b)yield[h.uri,h.value]}}e.ResourceMap=I,I.a=E=>E.toString();class L{constructor(h,d){this[R]="ResourceSet",!h||typeof h=="function"?this.a=new I(h):(this.a=new I(d),h.forEach(this.add,this))}get size(){return this.a.size}add(h){return this.a.set(h,h),this}clear(){this.a.clear()}delete(h){return this.a.delete(h)}forEach(h,d){this.a.forEach((f,p)=>h.call(d,p,p,this))}has(h){return this.a.has(h)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var k;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(k=e.Touch||(e.Touch={}));class v{constructor(){this[T]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(h){return this.a.has(h)}get(h,d=0){const f=this.a.get(h);if(!!f)return d!==0&&this.j(f,d),f.value}set(h,d,f=0){let p=this.a.get(h);if(p)p.value=d,f!==0&&this.j(p,f);else{switch(p={key:h,value:d,next:void 0,previous:void 0},f){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(h,p),this.d++}return this}delete(h){return!!this.remove(h)}remove(h){const d=this.a.get(h);if(!!d)return this.a.delete(h),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const h=this.b;return this.a.delete(h.key),this.i(h),this.d--,h.value}forEach(h,d){const f=this.e;let p=this.b;for(;p;){if(d?h.bind(d)(p.value,p.key,this):h(p.value,p.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const h=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.key,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}values(){const h=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.value,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}entries(){const h=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:[f.key,f.value],done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(h){if(h>=this.size)return;if(h===0){this.clear();return}let d=this.b,f=this.size;for(;d&&f>h;)this.a.delete(d.key),d=d.next,f--;this.b=d,this.d=f,d&&(d.previous=void 0),this.e++}g(h){if(!this.b&&!this.c)this.c=h;else if(this.b)h.next=this.b,this.b.previous=h;else throw new Error("Invalid list");this.b=h,this.e++}h(h){if(!this.b&&!this.c)this.b=h;else if(this.c)h.previous=this.c,this.c.next=h;else throw new Error("Invalid list");this.c=h,this.e++}i(h){if(h===this.b&&h===this.c)this.b=void 0,this.c=void 0;else if(h===this.b){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.b=h.next}else if(h===this.c){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.c=h.previous}else{const d=h.next,f=h.previous;if(!d||!f)throw new Error("Invalid list");d.previous=f,f.next=d}h.next=void 0,h.previous=void 0,this.e++}j(h,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(h===this.b)return;const f=h.next,p=h.previous;h===this.c?(p.next=void 0,this.c=p):(f.previous=p,p.next=f),h.previous=void 0,h.next=this.b,this.b.previous=h,this.b=h,this.e++}else if(d===2){if(h===this.c)return;const f=h.next,p=h.previous;h===this.b?(f.previous=void 0,this.b=f):(f.previous=p,p.next=f),h.next=void 0,h.previous=this.c,this.c.next=h,this.c=h,this.e++}}}toJSON(){const h=[];return this.forEach((d,f)=>{h.push([f,d])}),h}fromJSON(h){this.clear();for(const[d,f]of h)this.set(d,f)}}e.LinkedMap=v;class P extends v{constructor(h,d=1){super(),this.k=h,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(h){this.k=h,this.m()}get ratio(){return this.l}set ratio(h){this.l=Math.min(Math.max(0,h),1),this.m()}get(h,d=2){return super.get(h,d)}peek(h){return super.get(h,0)}set(h,d){return super.set(h,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=P}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],De([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(se,oe){for(var fe=0;fe<oe.length;fe++){var Z=oe[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(se,Z.key,Z)}}function a(se,oe,fe){return oe&&e(se.prototype,oe),fe&&e(se,fe),Object.defineProperty(se,"prototype",{writable:!1}),se}function R(se,oe){if(!!se){if(typeof se=="string")return T(se,oe);var fe=Object.prototype.toString.call(se).slice(8,-1);if(fe==="Object"&&se.constructor&&(fe=se.constructor.name),fe==="Map"||fe==="Set")return Array.from(se);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return T(se,oe)}}function T(se,oe){(oe==null||oe>se.length)&&(oe=se.length);for(var fe=0,Z=new Array(oe);fe<oe;fe++)Z[fe]=se[fe];return Z}function u(se,oe){var fe=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(fe)return(fe=fe.call(se)).next.bind(fe);if(Array.isArray(se)||(fe=R(se))||oe&&se&&typeof se.length=="number"){fe&&(se=fe);var Z=0;return function(){return Z>=se.length?{done:!0}:{done:!1,value:se[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=C();function A(se){te.defaults=se}var y=/[&<>"']/,I=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(oe){return v[oe]};function E(se,oe){if(oe){if(y.test(se))return se.replace(I,P)}else if(L.test(se))return se.replace(k,P);return se}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(se){return se.replace(h,function(oe,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var f=/(^|[^\[])\^/g;function p(se,oe){se=typeof se=="string"?se:se.source,oe=oe||"";var fe={replace:function(ce,ne){return ne=ne.source||ne,ne=ne.replace(f,"$1"),se=se.replace(ce,ne),fe},getRegex:function(){return new RegExp(se,oe)}};return fe}var b=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(se,oe,fe){if(se){var Z;try{Z=decodeURIComponent(d(fe)).replace(b,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}oe&&!S.test(fe)&&(fe=n(oe,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var t={},l=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(se,oe){t[" "+se]||(l.test(se)?t[" "+se]=se+"/":t[" "+se]=c(se,"/",!0)),se=t[" "+se];var fe=se.indexOf(":")===-1;return oe.substring(0,2)==="//"?fe?oe:se.replace(r,"$1")+oe:oe.charAt(0)==="/"?fe?oe:se.replace(o,"$1")+oe:se+oe}var m={exec:function(){}};function s(se){for(var oe=1,fe,Z;oe<arguments.length;oe++){fe=arguments[oe];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(se[Z]=fe[Z])}return se}function i(se,oe){var fe=se.replace(/\|/g,function(ne,N,H){for(var Q=!1,Y=N;--Y>=0&&H[Y]==="\\";)Q=!Q;return Q?"|":" |"}),Z=fe.split(/ \|/),ce=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>oe)Z.splice(oe);else for(;Z.length<oe;)Z.push("");for(;ce<Z.length;ce++)Z[ce]=Z[ce].trim().replace(/\\\|/g,"|");return Z}function c(se,oe,fe){var Z=se.length;if(Z===0)return"";for(var ce=0;ce<Z;){var ne=se.charAt(Z-ce-1);if(ne===oe&&!fe)ce++;else if(ne!==oe&&fe)ce++;else break}return se.slice(0,Z-ce)}function w(se,oe){if(se.indexOf(oe[1])===-1)return-1;for(var fe=se.length,Z=0,ce=0;ce<fe;ce++)if(se[ce]==="\\")ce++;else if(se[ce]===oe[0])Z++;else if(se[ce]===oe[1]&&(Z--,Z<0))return ce;return-1}function D(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(se,oe){if(oe<1)return"";for(var fe="";oe>1;)oe&1&&(fe+=se),oe>>=1,se+=se;return fe+se}function x(se,oe,fe,Z){var ce=oe.href,ne=oe.title?E(oe.title):null,N=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){Z.state.inLink=!0;var H={type:"link",raw:fe,href:ce,title:ne,text:N,tokens:Z.inlineTokens(N)};return Z.state.inLink=!1,H}return{type:"image",raw:fe,href:ce,title:ne,text:E(N)}}function q(se,oe){var fe=se.match(/^(\s+)(?:```)/);if(fe===null)return oe;var Z=fe[1];return oe.split(`
`).map(function(ce){var ne=ce.match(/^\s+/);if(ne===null)return ce;var N=ne[0];return N.length>=Z.length?ce.slice(Z.length):ce}).join(`
`)}var M=function(){function se(fe){this.options=fe||te.defaults}var oe=se.prototype;return oe.space=function(Z){var ce=this.rules.block.newline.exec(Z);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},oe.code=function(Z){var ce=this.rules.block.code.exec(Z);if(ce){var ne=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:c(ne,`
`)}}},oe.fences=function(Z){var ce=this.rules.block.fences.exec(Z);if(ce){var ne=ce[0],N=q(ne,ce[3]||"");return{type:"code",raw:ne,lang:ce[2]?ce[2].trim():ce[2],text:N}}},oe.heading=function(Z){var ce=this.rules.block.heading.exec(Z);if(ce){var ne=ce[2].trim();if(/#$/.test(ne)){var N=c(ne,"#");(this.options.pedantic||!N||/ $/.test(N))&&(ne=N.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ne,tokens:this.lexer.inline(ne)}}},oe.hr=function(Z){var ce=this.rules.block.hr.exec(Z);if(ce)return{type:"hr",raw:ce[0]}},oe.blockquote=function(Z){var ce=this.rules.block.blockquote.exec(Z);if(ce){var ne=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},oe.list=function(Z){var ce=this.rules.block.list.exec(Z);if(ce){var ne,N,H,Q,Y,he,ve,Ae,pe,Ce,ke,Ve,xe=ce[1].trim(),et=xe.length>1,Qe={type:"list",raw:"",ordered:et,start:et?+xe.slice(0,-1):"",loose:!1,items:[]};xe=et?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=et?xe:"[*+-]");for(var nt=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(Ve=!1,!(!(ce=nt.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=ce[0],Z=Z.substring(ne.length),Ae=ce[2].split(`
`,1)[0],pe=Z.split(`
`,1)[0],this.options.pedantic?(Q=2,ke=Ae.trimLeft()):(Q=ce[2].search(/[^ ]/),Q=Q>4?1:Q,ke=Ae.slice(Q),Q+=ce[1].length),he=!1,!Ae&&/^ *$/.test(pe)&&(ne+=pe+`
`,Z=Z.substring(pe.length+1),Ve=!0),!Ve)for(var st=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,Q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ue=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,Q-1)+"}#");Z&&(Ce=Z.split(`
`,1)[0],Ae=Ce,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ue.test(Ae)||rt.test(Ae)||st.test(Ae)||ht.test(Z)));){if(Ae.search(/[^ ]/)>=Q||!Ae.trim())ke+=`
`+Ae.slice(Q);else if(!he)ke+=`
`+Ae;else break;!he&&!Ae.trim()&&(he=!0),ne+=Ce+`
`,Z=Z.substring(Ce.length+1)}Qe.loose||(ve?Qe.loose=!0:/\n *\n *$/.test(ne)&&(ve=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(ke),N&&(H=N[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ne,task:!!N,checked:H,loose:!1,text:ke}),Qe.raw+=ne}Qe.items[Qe.items.length-1].raw=ne.trimRight(),Qe.items[Qe.items.length-1].text=ke.trimRight(),Qe.raw=Qe.raw.trimRight();var ae=Qe.items.length;for(Y=0;Y<ae;Y++){this.lexer.state.top=!1,Qe.items[Y].tokens=this.lexer.blockTokens(Qe.items[Y].text,[]);var $=Qe.items[Y].tokens.filter(function(Ie){return Ie.type==="space"}),ue=$.every(function(Ie){for(var Le=Ie.raw.split(""),$e=0,Ke=u(Le),Ze;!(Ze=Ke()).done;){var pt=Ze.value;if(pt===`
`&&($e+=1),$e>1)return!0}return!1});!Qe.loose&&$.length&&ue&&(Qe.loose=!0,Qe.items[Y].loose=!0)}return Qe}},oe.html=function(Z){var ce=this.rules.block.html.exec(Z);if(ce){var ne={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(ce[0]):E(ce[0]);ne.type="paragraph",ne.text=N,ne.tokens=this.lexer.inline(N)}return ne}},oe.def=function(Z){var ce=this.rules.block.def.exec(Z);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ne=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ce[0],href:ce[2],title:ce[3]}}},oe.table=function(Z){var ce=this.rules.block.table.exec(Z);if(ce){var ne={type:"table",header:i(ce[1]).map(function(ve){return{text:ve}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ce[0];var N=ne.align.length,H,Q,Y,he;for(H=0;H<N;H++)/^ *-+: *$/.test(ne.align[H])?ne.align[H]="right":/^ *:-+: *$/.test(ne.align[H])?ne.align[H]="center":/^ *:-+ *$/.test(ne.align[H])?ne.align[H]="left":ne.align[H]=null;for(N=ne.rows.length,H=0;H<N;H++)ne.rows[H]=i(ne.rows[H],ne.header.length).map(function(ve){return{text:ve}});for(N=ne.header.length,Q=0;Q<N;Q++)ne.header[Q].tokens=this.lexer.inline(ne.header[Q].text);for(N=ne.rows.length,Q=0;Q<N;Q++)for(he=ne.rows[Q],Y=0;Y<he.length;Y++)he[Y].tokens=this.lexer.inline(he[Y].text);return ne}}},oe.lheading=function(Z){var ce=this.rules.block.lheading.exec(Z);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},oe.paragraph=function(Z){var ce=this.rules.block.paragraph.exec(Z);if(ce){var ne=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:ne,tokens:this.lexer.inline(ne)}}},oe.text=function(Z){var ce=this.rules.block.text.exec(Z);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},oe.escape=function(Z){var ce=this.rules.inline.escape.exec(Z);if(ce)return{type:"escape",raw:ce[0],text:E(ce[1])}},oe.tag=function(Z){var ce=this.rules.inline.tag.exec(Z);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):E(ce[0]):ce[0]}},oe.link=function(Z){var ce=this.rules.inline.link.exec(Z);if(ce){var ne=ce[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var N=c(ne.slice(0,-1),"\\");if((ne.length-N.length)%2===0)return}else{var H=w(ce[2],"()");if(H>-1){var Q=ce[0].indexOf("!")===0?5:4,Y=Q+ce[1].length+H;ce[2]=ce[2].substring(0,H),ce[0]=ce[0].substring(0,Y).trim(),ce[3]=""}}var he=ce[2],ve="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Ae&&(he=Ae[1],ve=Ae[3])}else ve=ce[3]?ce[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(ne)?he=he.slice(1):he=he.slice(1,-1)),x(ce,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:ve&&ve.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},oe.reflink=function(Z,ce){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var N=(ne[2]||ne[1]).replace(/\s+/g," ");if(N=ce[N.toLowerCase()],!N||!N.href){var H=ne[0].charAt(0);return{type:"text",raw:H,text:H}}return x(ne,N,ne[0],this.lexer)}},oe.emStrong=function(Z,ce,ne){ne===void 0&&(ne="");var N=this.rules.inline.emStrong.lDelim.exec(Z);if(!!N&&!(N[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=N[1]||N[2]||"";if(!H||H&&(ne===""||this.rules.inline.punctuation.exec(ne))){var Q=N[0].length-1,Y,he,ve=Q,Ae=0,pe=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ce=ce.slice(-1*Z.length+Q);(N=pe.exec(ce))!=null;)if(Y=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!Y){if(he=Y.length,N[3]||N[4]){ve+=he;continue}else if((N[5]||N[6])&&Q%3&&!((Q+he)%3)){Ae+=he;continue}if(ve-=he,!(ve>0)){if(he=Math.min(he,he+ve+Ae),Math.min(Q,he)%2){var Ce=Z.slice(1,Q+N.index+he);return{type:"em",raw:Z.slice(0,Q+N.index+he+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ke=Z.slice(2,Q+N.index+he-1);return{type:"strong",raw:Z.slice(0,Q+N.index+he+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},oe.codespan=function(Z){var ce=this.rules.inline.code.exec(Z);if(ce){var ne=ce[2].replace(/\n/g," "),N=/[^ ]/.test(ne),H=/^ /.test(ne)&&/ $/.test(ne);return N&&H&&(ne=ne.substring(1,ne.length-1)),ne=E(ne,!0),{type:"codespan",raw:ce[0],text:ne}}},oe.br=function(Z){var ce=this.rules.inline.br.exec(Z);if(ce)return{type:"br",raw:ce[0]}},oe.del=function(Z){var ce=this.rules.inline.del.exec(Z);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},oe.autolink=function(Z,ce){var ne=this.rules.inline.autolink.exec(Z);if(ne){var N,H;return ne[2]==="@"?(N=E(this.options.mangle?ce(ne[1]):ne[1]),H="mailto:"+N):(N=E(ne[1]),H=N),{type:"link",raw:ne[0],text:N,href:H,tokens:[{type:"text",raw:N,text:N}]}}},oe.url=function(Z,ce){var ne;if(ne=this.rules.inline.url.exec(Z)){var N,H;if(ne[2]==="@")N=E(this.options.mangle?ce(ne[0]):ne[0]),H="mailto:"+N;else{var Q;do Q=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(Q!==ne[0]);N=E(ne[0]),ne[1]==="www."?H="http://"+N:H=N}return{type:"link",raw:ne[0],text:N,href:H,tokens:[{type:"text",raw:N,text:N}]}}},oe.inlineText=function(Z,ce){var ne=this.rules.inline.text.exec(Z);if(ne){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):E(ne[0]):ne[0]:N=E(this.options.smartypants?ce(ne[0]):ne[0]),{type:"text",raw:ne[0],text:N}}},se}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=p(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=p(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=p(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=p(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=p(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=p(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=s({},B),B.gfm=s({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=p(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=p(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=s({},B.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:p(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=p(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=p(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=p(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=p(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=p(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=p(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=p(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=p(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=p(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=p(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=p(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=s({},O),O.pedantic=s({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=s({},O.normal,{escape:p(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=p(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=s({},O.gfm,{br:p(O.br).replace("{2,}","*").getRegex(),text:p(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(se){var oe="",fe,Z,ce=se.length;for(fe=0;fe<ce;fe++)Z=se.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),oe+="&#"+Z+";";return oe}var j=function(){function se(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||te.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:B.normal,inline:O.normal};this.options.pedantic?(Z.block=B.pedantic,Z.inline=O.pedantic):this.options.gfm&&(Z.block=B.gfm,this.options.breaks?Z.inline=O.breaks:Z.inline=O.gfm),this.tokenizer.rules=Z}se.lex=function(Z,ce){var ne=new se(ce);return ne.lex(Z)},se.lexInline=function(Z,ce){var ne=new se(ce);return ne.inlineTokens(Z)};var oe=se.prototype;return oe.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},oe.blockTokens=function(Z,ce){var ne=this;ce===void 0&&(ce=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(ve,Ae,pe){return Ae+"    ".repeat(pe.length)});for(var N,H,Q,Y;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ve){return(N=ve.call({lexer:ne},Z,ce))?(Z=Z.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.space(Z)){Z=Z.substring(N.raw.length),N.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(N);continue}if(N=this.tokenizer.code(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N);continue}if(N=this.tokenizer.fences(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.heading(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.hr(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.blockquote(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.list(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.html(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.def(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+N.raw,H.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.lheading(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(Q=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var ve=1/0,Ae=Z.slice(1),pe=void 0;ne.options.extensions.startBlock.forEach(function(Ce){pe=Ce.call({lexer:this},Ae),typeof pe=="number"&&pe>=0&&(ve=Math.min(ve,pe))}),ve<1/0&&ve>=0&&(Q=Z.substring(0,ve+1))}(),this.state.top&&(N=this.tokenizer.paragraph(Q))){H=ce[ce.length-1],Y&&H.type==="paragraph"?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N),Y=Q.length!==Z.length,Z=Z.substring(N.raw.length);continue}if(N=this.tokenizer.text(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&H.type==="text"?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N);continue}if(Z){var he="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,ce},oe.inline=function(Z,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:Z,tokens:ce}),ce},oe.inlineTokens=function(Z,ce){var ne=this;ce===void 0&&(ce=[]);var N,H,Q,Y=Z,he,ve,Ae;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)pe.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,he.index)+"["+F("a",he[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,he.index)+"["+F("a",he[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,he.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(ve||(Ae=""),ve=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(N=ke.call({lexer:ne},Z,ce))?(Z=Z.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.escape(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.tag(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&N.type==="text"&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.link(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&N.type==="text"&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.emStrong(Z,Y,Ae)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.codespan(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.br(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.del(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.autolink(Z,z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(Z,z))){Z=Z.substring(N.raw.length),ce.push(N);continue}if(Q=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,Ve=Z.slice(1),xe=void 0;ne.options.extensions.startInline.forEach(function(et){xe=et.call({lexer:this},Ve),typeof xe=="number"&&xe>=0&&(ke=Math.min(ke,xe))}),ke<1/0&&ke>=0&&(Q=Z.substring(0,ke+1))}(),N=this.tokenizer.inlineText(Q,U)){Z=Z.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Ae=N.raw.slice(-1)),ve=!0,H=ce[ce.length-1],H&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(Z){var Ce="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ce},a(se,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),se}(),le=function(){function se(fe){this.options=fe||te.defaults}var oe=se.prototype;return oe.code=function(Z,ce,ne){var N=(ce||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(Z,N);H!=null&&H!==Z&&(ne=!0,Z=H)}return Z=Z.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+E(N,!0)+'">'+(ne?Z:E(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:E(Z,!0))+`</code></pre>
`},oe.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},oe.html=function(Z){return Z},oe.heading=function(Z,ce,ne,N){if(this.options.headerIds){var H=this.options.headerPrefix+N.slug(ne);return"<h"+ce+' id="'+H+'">'+Z+"</h"+ce+`>
`}return"<h"+ce+">"+Z+"</h"+ce+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Z,ce,ne){var N=ce?"ol":"ul",H=ce&&ne!==1?' start="'+ne+'"':"";return"<"+N+H+`>
`+Z+"</"+N+`>
`},oe.listitem=function(Z){return"<li>"+Z+`</li>
`},oe.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Z){return"<p>"+Z+`</p>
`},oe.table=function(Z,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ce+`</table>
`},oe.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},oe.tablecell=function(Z,ce){var ne=ce.header?"th":"td",N=ce.align?"<"+ne+' align="'+ce.align+'">':"<"+ne+">";return N+Z+("</"+ne+`>
`)},oe.strong=function(Z){return"<strong>"+Z+"</strong>"},oe.em=function(Z){return"<em>"+Z+"</em>"},oe.codespan=function(Z){return"<code>"+Z+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Z){return"<del>"+Z+"</del>"},oe.link=function(Z,ce,ne){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var N='<a href="'+E(Z)+'"';return ce&&(N+=' title="'+ce+'"'),N+=">"+ne+"</a>",N},oe.image=function(Z,ce,ne){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var N='<img src="'+Z+'" alt="'+ne+'"';return ce&&(N+=' title="'+ce+'"'),N+=this.options.xhtml?"/>":">",N},oe.text=function(Z){return Z},se}(),V=function(){function se(){}var oe=se.prototype;return oe.strong=function(Z){return Z},oe.em=function(Z){return Z},oe.codespan=function(Z){return Z},oe.del=function(Z){return Z},oe.html=function(Z){return Z},oe.text=function(Z){return Z},oe.link=function(Z,ce,ne){return""+ne},oe.image=function(Z,ce,ne){return""+ne},oe.br=function(){return""},se}(),_=function(){function se(){this.seen={}}var oe=se.prototype;return oe.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Z,ce){var ne=Z,N=0;if(this.seen.hasOwnProperty(ne)){N=this.seen[Z];do N++,ne=Z+"-"+N;while(this.seen.hasOwnProperty(ne))}return ce||(this.seen[Z]=N,this.seen[ne]=0),ne},oe.slug=function(Z,ce){ce===void 0&&(ce={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,ce.dryrun)},se}(),J=function(){function se(fe){this.options=fe||te.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new _}se.parse=function(Z,ce){var ne=new se(ce);return ne.parse(Z)},se.parseInline=function(Z,ce){var ne=new se(ce);return ne.parseInline(Z)};var oe=se.prototype;return oe.parse=function(Z,ce){ce===void 0&&(ce=!0);var ne="",N,H,Q,Y,he,ve,Ae,pe,Ce,ke,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ae=Z.length;for(N=0;N<ae;N++){if(ke=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(rt=this.options.extensions.renderers[ke.type].call({parser:this},ke),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ne+=rt||"";continue}switch(ke.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,d(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Ae="",Y=ke.header.length,H=0;H<Y;H++)Ae+=this.renderer.tablecell(this.parseInline(ke.header[H].tokens),{header:!0,align:ke.align[H]});for(pe+=this.renderer.tablerow(Ae),Ce="",Y=ke.rows.length,H=0;H<Y;H++){for(ve=ke.rows[H],Ae="",he=ve.length,Q=0;Q<he;Q++)Ae+=this.renderer.tablecell(this.parseInline(ve[Q].tokens),{header:!1,align:ke.align[Q]});Ce+=this.renderer.tablerow(Ae)}ne+=this.renderer.table(pe,Ce);continue}case"blockquote":{Ce=this.parse(ke.tokens),ne+=this.renderer.blockquote(Ce);continue}case"list":{for(Ve=ke.ordered,xe=ke.start,et=ke.loose,Y=ke.items.length,Ce="",H=0;H<Y;H++)nt=ke.items[H],st=nt.checked,ht=nt.task,Qe="",nt.task&&(Ue=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Ue+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Ue+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Ue}):Qe+=Ue),Qe+=this.parse(nt.tokens,et),Ce+=this.renderer.listitem(Qe,ht,st);ne+=this.renderer.list(Ce,Ve,xe);continue}case"html":{ne+=this.renderer.html(ke.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Ce=ke.tokens?this.parseInline(ke.tokens):ke.text;N+1<ae&&Z[N+1].type==="text";)ke=Z[++N],Ce+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ne+=ce?this.renderer.paragraph(Ce):Ce;continue}default:{var $='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}}return ne},oe.parseInline=function(Z,ce){ce=ce||this.renderer;var ne="",N,H,Q,Y=Z.length;for(N=0;N<Y;N++){if(H=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(Q=this.options.extensions.renderers[H.type].call({parser:this},H),Q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){ne+=Q||"";continue}switch(H.type){case"escape":{ne+=ce.text(H.text);break}case"html":{ne+=ce.html(H.text);break}case"link":{ne+=ce.link(H.href,H.title,this.parseInline(H.tokens,ce));break}case"image":{ne+=ce.image(H.href,H.title,H.text);break}case"strong":{ne+=ce.strong(this.parseInline(H.tokens,ce));break}case"em":{ne+=ce.em(this.parseInline(H.tokens,ce));break}case"codespan":{ne+=ce.codespan(H.text);break}case"br":{ne+=ce.br();break}case"del":{ne+=ce.del(this.parseInline(H.tokens,ce));break}case"text":{ne+=ce.text(H.text);break}default:{var he='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return ne},se}();function ie(se,oe,fe){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof oe=="function"&&(fe=oe,oe=null),oe=s({},ie.defaults,oe||{}),D(oe),fe){var Z=oe.highlight,ce;try{ce=j.lex(se,oe)}catch(Y){return fe(Y)}var ne=function(he){var ve;if(!he)try{oe.walkTokens&&ie.walkTokens(ce,oe.walkTokens),ve=J.parse(ce,oe)}catch(Ae){he=Ae}return oe.highlight=Z,he?fe(he):fe(null,ve)};if(!Z||Z.length<3||(delete oe.highlight,!ce.length))return ne();var N=0;ie.walkTokens(ce,function(Y){Y.type==="code"&&(N++,setTimeout(function(){Z(Y.text,Y.lang,function(he,ve){if(he)return ne(he);ve!=null&&ve!==Y.text&&(Y.text=ve,Y.escaped=!0),N--,N===0&&ne()})},0))}),N===0&&ne();return}function H(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+E(Y.message+"",!0)+"</pre>";throw Y}try{var Q=j.lex(se,oe);if(oe.walkTokens){if(oe.async)return Promise.all(ie.walkTokens(Q,oe.walkTokens)).then(function(){return J.parse(Q,oe)}).catch(H);ie.walkTokens(Q,oe.walkTokens)}return J.parse(Q,oe)}catch(Y){H(Y)}}ie.options=ie.setOptions=function(se){return s(ie.defaults,se),A(ie.defaults),ie},ie.getDefaults=C,ie.defaults=te.defaults,ie.use=function(){for(var se=arguments.length,oe=new Array(se),fe=0;fe<se;fe++)oe[fe]=arguments[fe];var Z=s.apply(void 0,[{}].concat(oe)),ce=ie.defaults.extensions||{renderers:{},childTokens:{}},ne;oe.forEach(function(N){if(N.extensions&&(ne=!0,N.extensions.forEach(function(Q){if(!Q.name)throw new Error("extension name required");if(Q.renderer){var Y=ce.renderers?ce.renderers[Q.name]:null;Y?ce.renderers[Q.name]=function(){for(var he=arguments.length,ve=new Array(he),Ae=0;Ae<he;Ae++)ve[Ae]=arguments[Ae];var pe=Q.renderer.apply(this,ve);return pe===!1&&(pe=Y.apply(this,ve)),pe}:ce.renderers[Q.name]=Q.renderer}if(Q.tokenizer){if(!Q.level||Q.level!=="block"&&Q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[Q.level]?ce[Q.level].unshift(Q.tokenizer):ce[Q.level]=[Q.tokenizer],Q.start&&(Q.level==="block"?ce.startBlock?ce.startBlock.push(Q.start):ce.startBlock=[Q.start]:Q.level==="inline"&&(ce.startInline?ce.startInline.push(Q.start):ce.startInline=[Q.start]))}Q.childTokens&&(ce.childTokens[Q.name]=Q.childTokens)})),N.renderer&&function(){var Q=ie.defaults.renderer||new le,Y=function(Ae){var pe=Q[Ae];Q[Ae]=function(){for(var Ce=arguments.length,ke=new Array(Ce),Ve=0;Ve<Ce;Ve++)ke[Ve]=arguments[Ve];var xe=N.renderer[Ae].apply(Q,ke);return xe===!1&&(xe=pe.apply(Q,ke)),xe}};for(var he in N.renderer)Y(he);Z.renderer=Q}(),N.tokenizer&&function(){var Q=ie.defaults.tokenizer||new M,Y=function(Ae){var pe=Q[Ae];Q[Ae]=function(){for(var Ce=arguments.length,ke=new Array(Ce),Ve=0;Ve<Ce;Ve++)ke[Ve]=arguments[Ve];var xe=N.tokenizer[Ae].apply(Q,ke);return xe===!1&&(xe=pe.apply(Q,ke)),xe}};for(var he in N.tokenizer)Y(he);Z.tokenizer=Q}(),N.walkTokens){var H=ie.defaults.walkTokens;Z.walkTokens=function(Q){var Y=[];return Y.push(N.walkTokens.call(this,Q)),H&&(Y=Y.concat(H.call(this,Q))),Y}}ne&&(Z.extensions=ce),ie.setOptions(Z)})},ie.walkTokens=function(se,oe){for(var fe=[],Z=function(){var H=ne.value;switch(fe=fe.concat(oe.call(ie,H)),H.type){case"table":{for(var Q=u(H.header),Y;!(Y=Q()).done;){var he=Y.value;fe=fe.concat(ie.walkTokens(he.tokens,oe))}for(var ve=u(H.rows),Ae;!(Ae=ve()).done;)for(var pe=Ae.value,Ce=u(pe),ke;!(ke=Ce()).done;){var Ve=ke.value;fe=fe.concat(ie.walkTokens(Ve.tokens,oe))}break}case"list":{fe=fe.concat(ie.walkTokens(H.items,oe));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[H.type]?ie.defaults.extensions.childTokens[H.type].forEach(function(xe){fe=fe.concat(ie.walkTokens(H[xe],oe))}):H.tokens&&(fe=fe.concat(ie.walkTokens(H.tokens,oe)))}},ce=u(se),ne;!(ne=ce()).done;)Z();return fe},ie.parseInline=function(se,oe){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");oe=s({},ie.defaults,oe||{}),D(oe);try{var fe=j.lexInline(se,oe);return oe.walkTokens&&ie.walkTokens(fe,oe.walkTokens),J.parseInline(fe,oe)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+E(Z.message+"",!0)+"</pre>";throw Z}},ie.Parser=J,ie.parser=J.parse,ie.Renderer=le,ie.TextRenderer=V,ie.Lexer=j,ie.lexer=j.lex,ie.Tokenizer=M,ie.Slugger=_,ie.parse=ie;var ee=ie.options,K=ie.setOptions,G=ie.use,de=ie.walkTokens,be=ie.parseInline,Ee=ie,Pe=J.parse,Fe=j.lex;te.Lexer=j,te.Parser=J,te.Renderer=le,te.Slugger=_,te.TextRenderer=V,te.Tokenizer=M,te.getDefaults=C,te.lexer=Fe,te.marked=ie,te.options=ee,te.parse=Ee,te.parseInline=be,te.parser=Pe,te.setOptions=K,te.use=G,te.walkTokens=de,Object.defineProperty(te,"__esModule",{value:!0})}),define(ye[85],De([1,0,28]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new a.LRUCache(1e4);function T(I){return y(I,"NFC",R)}e.normalizeNFC=T;const u=new a.LRUCache(1e4);function C(I){return y(I,"NFD",u)}e.normalizeNFD=C;const A=/[^\u0000-\u0080]/;function y(I,L,k){if(!I)return I;const v=k.get(I);if(v)return v;let P;return A.test(I)?P=I.normalize(L):P=I,k.set(I,P),P}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(L){return C(L).replace(I,"")}}()}),define(ye[102],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(A,y,I){return Math.min(Math.max(A,y),I)}e.clamp=a;function R(A,y){return(y+A%y)%y}e.rot=R;class T{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=T;class u{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=u;class C{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const I=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function te(T){const u=[];typeof T=="number"&&u.push("code/timeOrigin",T);function C(y){u.push(y,Date.now())}function A(){const y=[];for(let I=0;I<u.length;I+=2)y.push({name:u[I],startTime:u[I+1]});return y}return{mark:C,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const u=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const C of performance.getEntriesByType("mark"))u.push({name:C.name,startTime:Math.round(T+C.startTime)});return u}};if(typeof process=="object"){const T=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function a(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=a(R))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var R in a)(typeof exports=="object"?exports:te)[R]=a[R]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function a(R){if(e[R])return e[R].exports;var T=e[R]={i:R,l:!1,exports:{}};return te[R].call(T.exports,T,T.exports,a),T.l=!0,T.exports}return a.m=te,a.c=e,a.d=function(R,T,u){a.o(R,T)||Object.defineProperty(R,T,{enumerable:!0,get:u})},a.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},a.t=function(R,T){if(1&T&&(R=a(R)),8&T||4&T&&typeof R=="object"&&R&&R.__esModule)return R;var u=Object.create(null);if(a.r(u),Object.defineProperty(u,"default",{enumerable:!0,value:R}),2&T&&typeof R!="string")for(var C in R)a.d(u,C,function(A){return R[A]}.bind(null,C));return u},a.n=function(R){var T=R&&R.__esModule?function(){return R.default}:function(){return R};return a.d(T,"a",T),T},a.o=function(R,T){return Object.prototype.hasOwnProperty.call(R,T)},a.p="",a(a.s=0)}([function(te,e,a){(function(R){var T;e=te.exports=G,T=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var u=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],I=0,L=I++;y[L]="0|[1-9]\\d*";var k=I++;y[k]="[0-9]+";var v=I++;y[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=I++;y[P]="("+y[L]+")\\.("+y[L]+")\\.("+y[L]+")";var E=I++;y[E]="("+y[k]+")\\.("+y[k]+")\\.("+y[k]+")";var h=I++;y[h]="(?:"+y[L]+"|"+y[v]+")";var d=I++;y[d]="(?:"+y[k]+"|"+y[v]+")";var f=I++;y[f]="(?:-("+y[h]+"(?:\\."+y[h]+")*))";var p=I++;y[p]="(?:-?("+y[d]+"(?:\\."+y[d]+")*))";var b=I++;y[b]="[0-9A-Za-z-]+";var S=I++;y[S]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var g=I++,t="v?"+y[P]+y[f]+"?"+y[S]+"?";y[g]="^"+t+"$";var l="[v=\\s]*"+y[E]+y[p]+"?"+y[S]+"?",r=I++;y[r]="^"+l+"$";var o=I++;y[o]="((?:<|>)?=?)";var n=I++;y[n]=y[k]+"|x|X|\\*";var m=I++;y[m]=y[L]+"|x|X|\\*";var s=I++;y[s]="[v=\\s]*("+y[m]+")(?:\\.("+y[m]+")(?:\\.("+y[m]+")(?:"+y[f]+")?"+y[S]+"?)?)?";var i=I++;y[i]="[v=\\s]*("+y[n]+")(?:\\.("+y[n]+")(?:\\.("+y[n]+")(?:"+y[p]+")?"+y[S]+"?)?)?";var c=I++;y[c]="^"+y[o]+"\\s*"+y[s]+"$";var w=I++;y[w]="^"+y[o]+"\\s*"+y[i]+"$";var D=I++;y[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=I++;y[F]="(?:~>?)";var x=I++;y[x]="(\\s*)"+y[F]+"\\s+",A[x]=new RegExp(y[x],"g");var q=I++;y[q]="^"+y[F]+y[s]+"$";var M=I++;y[M]="^"+y[F]+y[i]+"$";var B=I++;y[B]="(?:\\^)";var O=I++;y[O]="(\\s*)"+y[B]+"\\s+",A[O]=new RegExp(y[O],"g");var U=I++;y[U]="^"+y[B]+y[s]+"$";var z=I++;y[z]="^"+y[B]+y[i]+"$";var j=I++;y[j]="^"+y[o]+"\\s*("+l+")$|^$";var le=I++;y[le]="^"+y[o]+"\\s*("+t+")$|^$";var V=I++;y[V]="(\\s*)"+y[o]+"\\s*("+l+"|"+y[s]+")",A[V]=new RegExp(y[V],"g");var _=I++;y[_]="^\\s*("+y[s]+")\\s+-\\s+("+y[s]+")\\s*$";var J=I++;y[J]="^\\s*("+y[i]+")\\s+-\\s+("+y[i]+")\\s*$";var ie=I++;y[ie]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)T(ee,y[ee]),A[ee]||(A[ee]=new RegExp(y[ee]));function K(pe,Ce){if(pe instanceof G)return pe;if(typeof pe!="string"||pe.length>u||!(Ce?A[r]:A[g]).test(pe))return null;try{return new G(pe,Ce)}catch{return null}}function G(pe,Ce){if(pe instanceof G){if(pe.loose===Ce)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>u)throw new TypeError("version is longer than "+u+" characters");if(!(this instanceof G))return new G(pe,Ce);T("SemVer",pe,Ce),this.loose=Ce;var ke=pe.trim().match(Ce?A[r]:A[g]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(Ve){if(/^[0-9]+$/.test(Ve)){var xe=+Ve;if(xe>=0&&xe<C)return xe}return Ve}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=K,e.valid=function(pe,Ce){var ke=K(pe,Ce);return ke?ke.version:null},e.clean=function(pe,Ce){var ke=K(pe.trim().replace(/^[=v]+/,""),Ce);return ke?ke.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(pe){return T("SemVer.compare",this.version,this.loose,pe),pe instanceof G||(pe=new G(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},G.prototype.compareMain=function(pe){return pe instanceof G||(pe=new G(pe,this.loose)),be(this.major,pe.major)||be(this.minor,pe.minor)||be(this.patch,pe.patch)},G.prototype.comparePre=function(pe){if(pe instanceof G||(pe=new G(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var Ce=0;do{var ke=this.prerelease[Ce],Ve=pe.prerelease[Ce];if(T("prerelease compare",Ce,ke,Ve),ke===void 0&&Ve===void 0)return 0;if(Ve===void 0)return 1;if(ke===void 0)return-1;if(ke!==Ve)return be(ke,Ve)}while(++Ce)},G.prototype.inc=function(pe,Ce){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,Ce,ke,Ve){typeof ke=="string"&&(Ve=ke,ke=void 0);try{return new G(pe,ke).inc(Ce,Ve).version}catch{return null}},e.diff=function(pe,Ce){if(se(pe,Ce))return null;var ke=K(pe),Ve=K(Ce);if(ke.prerelease.length||Ve.prerelease.length){for(var xe in ke)if((xe==="major"||xe==="minor"||xe==="patch")&&ke[xe]!==Ve[xe])return"pre"+xe;return"prerelease"}for(var xe in ke)if((xe==="major"||xe==="minor"||xe==="patch")&&ke[xe]!==Ve[xe])return xe},e.compareIdentifiers=be;var de=/^[0-9]+$/;function be(pe,Ce){var ke=de.test(pe),Ve=de.test(Ce);return ke&&Ve&&(pe=+pe,Ce=+Ce),ke&&!Ve?-1:Ve&&!ke?1:pe<Ce?-1:pe>Ce?1:0}function Ee(pe,Ce,ke){return new G(pe,ke).compare(new G(Ce,ke))}function Pe(pe,Ce,ke){return Ee(pe,Ce,ke)>0}function Fe(pe,Ce,ke){return Ee(pe,Ce,ke)<0}function se(pe,Ce,ke){return Ee(pe,Ce,ke)===0}function oe(pe,Ce,ke){return Ee(pe,Ce,ke)!==0}function fe(pe,Ce,ke){return Ee(pe,Ce,ke)>=0}function Z(pe,Ce,ke){return Ee(pe,Ce,ke)<=0}function ce(pe,Ce,ke,Ve){var xe;switch(Ce){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),xe=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),xe=pe!==ke;break;case"":case"=":case"==":xe=se(pe,ke,Ve);break;case"!=":xe=oe(pe,ke,Ve);break;case">":xe=Pe(pe,ke,Ve);break;case">=":xe=fe(pe,ke,Ve);break;case"<":xe=Fe(pe,ke,Ve);break;case"<=":xe=Z(pe,ke,Ve);break;default:throw new TypeError("Invalid operator: "+Ce)}return xe}function ne(pe,Ce){if(pe instanceof ne){if(pe.loose===Ce)return pe;pe=pe.value}if(!(this instanceof ne))return new ne(pe,Ce);T("comparator",pe,Ce),this.loose=Ce,this.parse(pe),this.semver===N?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(pe,Ce){return be(Ce,pe)},e.major=function(pe,Ce){return new G(pe,Ce).major},e.minor=function(pe,Ce){return new G(pe,Ce).minor},e.patch=function(pe,Ce){return new G(pe,Ce).patch},e.compare=Ee,e.compareLoose=function(pe,Ce){return Ee(pe,Ce,!0)},e.rcompare=function(pe,Ce,ke){return Ee(Ce,pe,ke)},e.sort=function(pe,Ce){return pe.sort(function(ke,Ve){return e.compare(ke,Ve,Ce)})},e.rsort=function(pe,Ce){return pe.sort(function(ke,Ve){return e.rcompare(ke,Ve,Ce)})},e.gt=Pe,e.lt=Fe,e.eq=se,e.neq=oe,e.gte=fe,e.lte=Z,e.cmp=ce,e.Comparator=ne;var N={};function H(pe,Ce){if(pe instanceof H)return pe.loose===Ce?pe:new H(pe.raw,Ce);if(pe instanceof ne)return new H(pe.value,Ce);if(!(this instanceof H))return new H(pe,Ce);if(this.loose=Ce,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function Q(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function Y(pe,Ce,ke,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ae){return((Ce=Q(ke)?"":Q(Ve)?">="+ke+".0.0":Q(xe)?">="+ke+"."+Ve+".0":">="+Ce)+" "+(nt=Q(st)?"":Q(ht)?"<"+(+st+1)+".0.0":Q(Ue)?"<"+st+"."+(+ht+1)+".0":rt?"<="+st+"."+ht+"."+Ue+"-"+rt:"<="+nt)).trim()}function he(pe,Ce){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(Ce))return!1;if(Ce.prerelease.length){for(ke=0;ke<pe.length;ke++)if(T(pe[ke].semver),pe[ke].semver!==N&&pe[ke].semver.prerelease.length>0){var Ve=pe[ke].semver;if(Ve.major===Ce.major&&Ve.minor===Ce.minor&&Ve.patch===Ce.patch)return!0}return!1}return!0}function ve(pe,Ce,ke){try{Ce=new H(Ce,ke)}catch{return!1}return Ce.test(pe)}function Ae(pe,Ce,ke,Ve){var xe,et,Qe,nt,st;switch(pe=new G(pe,Ve),Ce=new H(Ce,Ve),ke){case">":xe=Pe,et=Z,Qe=Fe,nt=">",st=">=";break;case"<":xe=Fe,et=fe,Qe=Pe,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(pe,Ce,Ve))return!1;for(var ht=0;ht<Ce.set.length;++ht){var Ue=Ce.set[ht],rt=null,ae=null;if(Ue.forEach(function($){$.semver===N&&($=new ne(">=0.0.0")),rt=rt||$,ae=ae||$,xe($.semver,rt.semver,Ve)?rt=$:Qe($.semver,ae.semver,Ve)&&(ae=$)}),rt.operator===nt||rt.operator===st||(!ae.operator||ae.operator===nt)&&et(pe,ae.semver)||ae.operator===st&&Qe(pe,ae.semver))return!1}return!0}ne.prototype.parse=function(pe){var Ce=this.loose?A[j]:A[le],ke=pe.match(Ce);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new G(ke[2],this.loose):this.semver=N},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(pe){return T("Comparator.test",pe,this.loose),this.semver===N||(typeof pe=="string"&&(pe=new G(pe,this.loose)),ce(pe,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(pe,Ce){if(!(pe instanceof ne))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new H(pe.value,Ce),ve(this.value,ke,Ce);if(pe.operator==="")return ke=new H(this.value,Ce),ve(pe.semver,ke,Ce);var Ve=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=ce(this.semver,"<",pe.semver,Ce)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=ce(this.semver,">",pe.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return Ve||xe||et&&Qe||nt||st},e.Range=H,H.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},H.prototype.toString=function(){return this.range},H.prototype.parseRange=function(pe){var Ce=this.loose;pe=pe.trim(),T("range",pe,Ce);var ke=Ce?A[J]:A[_];pe=pe.replace(ke,Y),T("hyphen replace",pe),pe=pe.replace(A[V],"$1$2$3"),T("comparator trim",pe,A[V]),pe=(pe=(pe=pe.replace(A[x],"$1~")).replace(A[O],"$1^")).split(/\s+/).join(" ");var Ve=Ce?A[j]:A[le],xe=pe.split(" ").map(function(et){return function(Qe,nt){return T("comp",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Ue){return function(rt,ae){T("caret",rt,ae);var $=ae?A[z]:A[U];return rt.replace($,function(ue,Ie,Le,$e,Ke){var Ze;return T("caret",rt,ue,Ie,Le,$e,Ke),Q(Ie)?Ze="":Q(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Q($e)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":Ke?(T("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+Le+"."+(+$e+1):">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+$e+Ke+" <"+(+Ie+1)+".0.0"):(T("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+Le+"."+(+$e+1):">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+$e+" <"+(+Ie+1)+".0.0"),T("caret return",Ze),Ze})}(Ue,ht)}).join(" ")}(Qe,nt),T("caret",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Ue){return function(rt,ae){var $=ae?A[M]:A[q];return rt.replace($,function(ue,Ie,Le,$e,Ke){var Ze;return T("tilde",rt,ue,Ie,Le,$e,Ke),Q(Ie)?Ze="":Q(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Q($e)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":Ke?(T("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ze=">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+(+Le+1)+".0",T("tilde return",Ze),Ze})}(Ue,ht)}).join(" ")}(Qe,nt),T("tildes",Qe),Qe=function(st,ht){return T("replaceXRanges",st,ht),st.split(/\s+/).map(function(Ue){return function(rt,ae){rt=rt.trim();var $=ae?A[w]:A[c];return rt.replace($,function(ue,Ie,Le,$e,Ke,Ze){T("xRange",rt,ue,Ie,Le,$e,Ke,Ze);var pt=Q(Le),gt=pt||Q($e),ct=gt||Q(Ke);return Ie==="="&&ct&&(Ie=""),pt?ue=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&ct?(gt&&($e=0),ct&&(Ke=0),Ie===">"?(Ie=">=",gt?(Le=+Le+1,$e=0,Ke=0):ct&&($e=+$e+1,Ke=0)):Ie==="<="&&(Ie="<",gt?Le=+Le+1:$e=+$e+1),ue=Ie+Le+"."+$e+"."+Ke):gt?ue=">="+Le+".0.0 <"+(+Le+1)+".0.0":ct&&(ue=">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0"),T("xRange return",ue),ue})}(Ue,ht)}).join(" ")}(Qe,nt),T("xrange",Qe),Qe=function(st,ht){return T("replaceStars",st,ht),st.trim().replace(A[ie],"")}(Qe,nt),T("stars",Qe),Qe}(et,Ce)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(et){return!!et.match(Ve)})),xe=xe.map(function(et){return new ne(et,Ce)})},H.prototype.intersects=function(pe,Ce){if(!(pe instanceof H))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(Ve){return pe.set.some(function(xe){return xe.every(function(et){return Ve.intersects(et,Ce)})})})})},e.toComparators=function(pe,Ce){return new H(pe,Ce).set.map(function(ke){return ke.map(function(Ve){return Ve.value}).join(" ").trim().split(" ")})},H.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new G(pe,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(he(this.set[Ce],pe))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(pe,Ce,ke){var Ve=null,xe=null;try{var et=new H(Ce,ke)}catch{return null}return pe.forEach(function(Qe){et.test(Qe)&&(Ve&&xe.compare(Qe)!==-1||(xe=new G(Ve=Qe,ke)))}),Ve},e.minSatisfying=function(pe,Ce,ke){var Ve=null,xe=null;try{var et=new H(Ce,ke)}catch{return null}return pe.forEach(function(Qe){et.test(Qe)&&(Ve&&xe.compare(Qe)!==1||(xe=new G(Ve=Qe,ke)))}),Ve},e.validRange=function(pe,Ce){try{return new H(pe,Ce).range||"*"}catch{return null}},e.ltr=function(pe,Ce,ke){return Ae(pe,Ce,"<",ke)},e.gtr=function(pe,Ce,ke){return Ae(pe,Ce,">",ke)},e.outside=Ae,e.prerelease=function(pe,Ce){var ke=K(pe,Ce);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,Ce,ke){return pe=new H(pe,ke),Ce=new H(Ce,ke),pe.intersects(Ce)},e.coerce=function(pe){if(pe instanceof G)return pe;if(typeof pe!="string")return null;var Ce=pe.match(A[D]);return Ce==null?null:K((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,a(1))},function(te,e){var a,R,T=te.exports={};function u(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function A(d){if(a===setTimeout)return setTimeout(d,0);if((a===u||!a)&&setTimeout)return a=setTimeout,setTimeout(d,0);try{return a(d,0)}catch{try{return a.call(null,d,0)}catch{return a.call(this,d,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:u}catch{a=u}try{R=typeof clearTimeout=="function"?clearTimeout:C}catch{R=C}})();var y,I=[],L=!1,k=-1;function v(){L&&y&&(L=!1,y.length?I=y.concat(I):k=-1,I.length&&P())}function P(){if(!L){var d=A(v);L=!0;for(var f=I.length;f;){for(y=I,I=[];++k<f;)y&&y[k].run();k=-1,f=I.length}y=null,L=!1,function(p){if(R===clearTimeout)return clearTimeout(p);if((R===C||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(p);try{R(p)}catch{try{return R.call(null,p)}catch{return R.call(this,p)}}}(d)}}function E(d,f){this.fun=d,this.array=f}function h(){}T.nextTick=function(d){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];I.push(new E(d,f)),I.length!==1||L||A(P)},E.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=h,T.addListener=h,T.once=h,T.off=h,T.removeListener=h,T.removeAllListeners=h,T.emit=h,T.prependListener=h,T.prependOnceListener=h,T.listeners=function(d){return[]},T.binding=function(d){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(d){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(ye[103],De([1,0,11,6]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(S){const g=S;return g?typeof g.read=="function":!1}e.isReadable=T;function u(S){const g=S;return g?[g.on,g.pause,g.resume,g.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=u;function C(S){const g=S;return g?u(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=C;function A(S,g){return new y(S,g)}e.newWriteableStream=A;class y{constructor(g,t){this.e=g,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(t=>t(g))}h(g){this.c.error.length===0?(0,a.onUnexpectedError)(g):this.c.error.slice(0).forEach(t=>t(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,t){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(g,t){if(this.a.destroyed)return;let l;switch(g){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(t);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function I(S,g){const t=[];let l;for(;(l=S.read())!==null;)t.push(l);return g(t)}e.consumeReadable=I;function L(S,g,t){const l=[];let r;for(;(r=S.read())!==null&&l.length<t;)l.push(r);return r===null&&l.length>0?g(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const o=r;return r=void 0,o}return S.read()}}}e.peekReadable=L;function k(S,g){return new Promise((t,l)=>{const r=[];v(S,{onData:o=>{g&&r.push(o)},onError:o=>{g?l(o):t(void 0)},onEnd:()=>{t(g?g(r):void 0)}})})}e.consumeStream=k;function v(S,g){let t=!1;return S.on("error",l=>{t||g.onError(l)}),S.on("end",()=>{t||g.onEnd()}),S.on("data",l=>{t||g.onData(l)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=v;function P(S,g){return new Promise((t,l)=>{const r=new R.DisposableStore,o=[],n=i=>{if(o.push(i),o.length>g)return r.dispose(),S.pause(),t({stream:S,buffer:o,ended:!1})},m=i=>l(i),s=()=>t({stream:S,buffer:o,ended:!0});r.add((0,R.toDisposable)(()=>S.removeListener("error",m))),S.on("error",m),r.add((0,R.toDisposable)(()=>S.removeListener("end",s))),S.on("end",s),r.add((0,R.toDisposable)(()=>S.removeListener("data",n))),S.on("data",n)})}e.peekStream=P;function E(S,g){const t=A(g);return t.end(S),t}e.toStream=E;function h(){const S=A(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=h;function d(S){let g=!1;return{read:()=>g?null:(g=!0,S)}}e.toReadable=d;function f(S,g,t){const l=A(t);return v(S,{onData:r=>l.write(g.data(r)),onError:r=>l.error(g.error?g.error(r):r),onEnd:()=>l.end()}),l}e.transform=f;function p(S,g,t){let l=!1;return{read:()=>{const r=g.read();return l?r:(l=!0,r!==null?t([S,r]):S)}}}e.prefixedReadable=p;function b(S,g,t){let l=!1;const r=A(t);return v(g,{onData:o=>l?r.write(o):(l=!0,r.write(t([S,o]))),onError:o=>r.error(o),onEnd:()=>{l||(l=!0,r.write(S)),r.end()}}),r}e.prefixedStream=b}),define(ye[22],De([1,0,103]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let T,u;class C{static alloc(i){return R?new C(Buffer.allocUnsafe(i)):new C(new Uint8Array(i))}static wrap(i){return R&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new C(i)}static fromString(i,c){return!(c?.dontUseNodeBuffer||!1)&&R?new C(Buffer.from(i)):(T||(T=new TextEncoder),new C(T.encode(i)))}static fromByteArray(i){const c=C.alloc(i.length);for(let w=0,D=i.length;w<D;w++)c.buffer[w]=i[w];return c}static concat(i,c){if(typeof c>"u"){c=0;for(let F=0,x=i.length;F<x;F++)c+=i[F].byteLength}const w=C.alloc(c);let D=0;for(let F=0,x=i.length;F<x;F++){const q=i[F];w.set(q,D),D+=q.byteLength}return w}constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}clone(){const i=C.alloc(this.byteLength);return i.set(this),i}toString(){return R?this.buffer.toString():(u||(u=new TextDecoder),u.decode(this.buffer))}slice(i,c){return new C(this.buffer.subarray(i,c))}set(i,c){if(i instanceof C)this.buffer.set(i.buffer,c);else if(i instanceof Uint8Array)this.buffer.set(i,c);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),c);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),c);else throw new Error("Unknown argument 'array'")}readUInt32BE(i){return I(this.buffer,i)}writeUInt32BE(i,c){L(this.buffer,i,c)}readUInt32LE(i){return k(this.buffer,i)}writeUInt32LE(i,c){v(this.buffer,i,c)}readUInt8(i){return P(this.buffer,i)}writeUInt8(i,c){E(this.buffer,i,c)}}e.VSBuffer=C;function A(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0}e.readUInt16LE=A;function y(s,i,c){s[c+0]=i&255,i=i>>>8,s[c+1]=i&255}e.writeUInt16LE=y;function I(s,i){return s[i]*2**24+s[i+1]*2**16+s[i+2]*2**8+s[i+3]}e.readUInt32BE=I;function L(s,i,c){s[c+3]=i,i=i>>>8,s[c+2]=i,i=i>>>8,s[c+1]=i,i=i>>>8,s[c]=i}e.writeUInt32BE=L;function k(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0|s[i+2]<<16>>>0|s[i+3]<<24>>>0}e.readUInt32LE=k;function v(s,i,c){s[c+0]=i&255,i=i>>>8,s[c+1]=i&255,i=i>>>8,s[c+2]=i&255,i=i>>>8,s[c+3]=i&255}e.writeUInt32LE=v;function P(s,i){return s[i]}e.readUInt8=P;function E(s,i,c){s[c]=i}e.writeUInt8=E;function h(s){return a.consumeReadable(s,i=>C.concat(i))}e.readableToBuffer=h;function d(s){return a.toReadable(s)}e.bufferToReadable=d;function f(s){return a.consumeStream(s,i=>C.concat(i))}e.streamToBuffer=f;async function p(s){return s.ended?C.concat(s.buffer):C.concat([...s.buffer,await f(s.stream)])}e.bufferedStreamToBuffer=p;function b(s){return a.toStream(s,i=>C.concat(i))}e.bufferToStream=b;function S(s){return a.transform(s,{data:i=>typeof i=="string"?C.fromString(i):C.wrap(i)},i=>C.concat(i))}e.streamToBufferReadableStream=S;function g(s){return a.newWriteableStream(i=>C.concat(i),s)}e.newWriteableBufferStream=g;function t(s,i){return a.prefixedReadable(s,i,c=>C.concat(c))}e.prefixedBufferReadable=t;function l(s,i){return a.prefixedStream(s,i,c=>C.concat(c))}e.prefixedBufferStream=l;function r(s){let i=0,c=0,w=0;const D=new Uint8Array(Math.floor(s.length/4*3)),F=q=>{switch(c){case 3:D[w++]=i|q,c=0;break;case 2:D[w++]=i|q>>>2,i=q<<6,c=3;break;case 1:D[w++]=i|q>>>4,i=q<<4,c=2;break;default:i=q<<2,c=1}};for(let q=0;q<s.length;q++){const M=s.charCodeAt(q);if(M>=65&&M<=90)F(M-65);else if(M>=97&&M<=122)F(M-97+26);else if(M>=48&&M<=57)F(M-48+52);else if(M===43||M===45)F(62);else if(M===47||M===95)F(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${s[q]}`)}}const x=w;for(;c>0;)F(0);return C.wrap(D).slice(0,x)}e.decodeBase64=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:s},i=!0,c=!1){const w=c?n:o;let D="";const F=s.byteLength%3;let x=0;for(;x<s.byteLength-F;x+=3){const q=s[x+0],M=s[x+1],B=s[x+2];D+=w[q>>>2],D+=w[(q<<4|M>>>4)&63],D+=w[(M<<2|B>>>6)&63],D+=w[B&63]}if(F===1){const q=s[x+0];D+=w[q>>>2],D+=w[q<<4&63],i&&(D+="==")}else if(F===2){const q=s[x+0],M=s[x+1];D+=w[q>>>2],D+=w[(q<<4|M>>>4)&63],D+=w[M<<2&63],i&&(D+="=")}return D}e.encodeBase64=m}),define(ye[9],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(l){return typeof l=="string"}e.isString=a;function R(l){return Array.isArray(l)&&l.every(r=>a(r))}e.isStringArray=R;function T(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=T;function u(l){const r=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof r}e.isTypedArray=u;function C(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=C;function A(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=A;function y(l){return l===!0||l===!1}e.isBoolean=y;function I(l){return typeof l>"u"}e.isUndefined=I;function L(l){return!k(l)}e.isDefined=L;function k(l){return I(l)||l===null}e.isUndefinedOrNull=k;function v(l,r){if(!l)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=v;function P(l){if(k(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=P;function E(...l){const r=[];for(let o=0;o<l.length;o++){const n=l[o];if(k(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);r.push(n)}return r}e.assertAllDefined=E;const h=Object.prototype.hasOwnProperty;function d(l){if(!T(l))return!1;for(const r in l)if(h.call(l,r))return!1;return!0}e.isEmptyObject=d;function f(l){return typeof l=="function"}e.isFunction=f;function p(...l){return l.length>0&&l.every(f)}e.areFunctions=p;function b(l,r){const o=Math.min(l.length,r.length);for(let n=0;n<o;n++)S(l[n],r[n])}e.validateConstraints=b;function S(l,r){if(a(r)){if(typeof l!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(f(r)){try{if(l instanceof r)return}catch{}if(!k(l)&&l.constructor===r||r.length===1&&r.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function g(l){return l===null?void 0:l}e.withNullAsUndefined=g;function t(l){return typeof l>"u"?null:l}e.withUndefinedAsNull=t}),define(ye[67],De([1,0,9]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=e.getCodiconAriaLabel=void 0;function R(y){return y?y.replace(/\$\((.*?)\)/g,(I,L)=>` ${L} `).trim():""}e.getCodiconAriaLabel=R;const T=Object.create(null);function u(y,I){if((0,a.isString)(I)){const L=T[I];if(L===void 0)throw new Error(`${y} references an unknown codicon: ${I}`);I=L}return T[y]=I,{id:y}}function C(){return T}e.getCodiconFontCharacters=C;function A(){return Object.values(e.Codicon)}e.getAllCodicons=A,e.Codicon={add:u("add",6e4),plus:u("plus",6e4),gistNew:u("gist-new",6e4),repoCreate:u("repo-create",6e4),lightbulb:u("lightbulb",60001),lightBulb:u("light-bulb",60001),repo:u("repo",60002),repoDelete:u("repo-delete",60002),gistFork:u("gist-fork",60003),repoForked:u("repo-forked",60003),gitPullRequest:u("git-pull-request",60004),gitPullRequestAbandoned:u("git-pull-request-abandoned",60004),recordKeys:u("record-keys",60005),keyboard:u("keyboard",60005),tag:u("tag",60006),tagAdd:u("tag-add",60006),tagRemove:u("tag-remove",60006),person:u("person",60007),personFollow:u("person-follow",60007),personOutline:u("person-outline",60007),personFilled:u("person-filled",60007),gitBranch:u("git-branch",60008),gitBranchCreate:u("git-branch-create",60008),gitBranchDelete:u("git-branch-delete",60008),sourceControl:u("source-control",60008),mirror:u("mirror",60009),mirrorPublic:u("mirror-public",60009),star:u("star",60010),starAdd:u("star-add",60010),starDelete:u("star-delete",60010),starEmpty:u("star-empty",60010),comment:u("comment",60011),commentAdd:u("comment-add",60011),alert:u("alert",60012),warning:u("warning",60012),search:u("search",60013),searchSave:u("search-save",60013),logOut:u("log-out",60014),signOut:u("sign-out",60014),logIn:u("log-in",60015),signIn:u("sign-in",60015),eye:u("eye",60016),eyeUnwatch:u("eye-unwatch",60016),eyeWatch:u("eye-watch",60016),circleFilled:u("circle-filled",60017),primitiveDot:u("primitive-dot",60017),closeDirty:u("close-dirty",60017),debugBreakpoint:u("debug-breakpoint",60017),debugBreakpointDisabled:u("debug-breakpoint-disabled",60017),debugHint:u("debug-hint",60017),primitiveSquare:u("primitive-square",60018),edit:u("edit",60019),pencil:u("pencil",60019),info:u("info",60020),issueOpened:u("issue-opened",60020),gistPrivate:u("gist-private",60021),gitForkPrivate:u("git-fork-private",60021),lock:u("lock",60021),mirrorPrivate:u("mirror-private",60021),close:u("close",60022),removeClose:u("remove-close",60022),x:u("x",60022),repoSync:u("repo-sync",60023),sync:u("sync",60023),clone:u("clone",60024),desktopDownload:u("desktop-download",60024),beaker:u("beaker",60025),microscope:u("microscope",60025),vm:u("vm",60026),deviceDesktop:u("device-desktop",60026),file:u("file",60027),fileText:u("file-text",60027),more:u("more",60028),ellipsis:u("ellipsis",60028),kebabHorizontal:u("kebab-horizontal",60028),mailReply:u("mail-reply",60029),reply:u("reply",60029),organization:u("organization",60030),organizationFilled:u("organization-filled",60030),organizationOutline:u("organization-outline",60030),newFile:u("new-file",60031),fileAdd:u("file-add",60031),newFolder:u("new-folder",60032),fileDirectoryCreate:u("file-directory-create",60032),trash:u("trash",60033),trashcan:u("trashcan",60033),history:u("history",60034),clock:u("clock",60034),folder:u("folder",60035),fileDirectory:u("file-directory",60035),symbolFolder:u("symbol-folder",60035),logoGithub:u("logo-github",60036),markGithub:u("mark-github",60036),github:u("github",60036),terminal:u("terminal",60037),console:u("console",60037),repl:u("repl",60037),zap:u("zap",60038),symbolEvent:u("symbol-event",60038),error:u("error",60039),stop:u("stop",60039),variable:u("variable",60040),symbolVariable:u("symbol-variable",60040),array:u("array",60042),symbolArray:u("symbol-array",60042),symbolModule:u("symbol-module",60043),symbolPackage:u("symbol-package",60043),symbolNamespace:u("symbol-namespace",60043),symbolObject:u("symbol-object",60043),symbolMethod:u("symbol-method",60044),symbolFunction:u("symbol-function",60044),symbolConstructor:u("symbol-constructor",60044),symbolBoolean:u("symbol-boolean",60047),symbolNull:u("symbol-null",60047),symbolNumeric:u("symbol-numeric",60048),symbolNumber:u("symbol-number",60048),symbolStructure:u("symbol-structure",60049),symbolStruct:u("symbol-struct",60049),symbolParameter:u("symbol-parameter",60050),symbolTypeParameter:u("symbol-type-parameter",60050),symbolKey:u("symbol-key",60051),symbolText:u("symbol-text",60051),symbolReference:u("symbol-reference",60052),goToFile:u("go-to-file",60052),symbolEnum:u("symbol-enum",60053),symbolValue:u("symbol-value",60053),symbolRuler:u("symbol-ruler",60054),symbolUnit:u("symbol-unit",60054),activateBreakpoints:u("activate-breakpoints",60055),archive:u("archive",60056),arrowBoth:u("arrow-both",60057),arrowDown:u("arrow-down",60058),arrowLeft:u("arrow-left",60059),arrowRight:u("arrow-right",60060),arrowSmallDown:u("arrow-small-down",60061),arrowSmallLeft:u("arrow-small-left",60062),arrowSmallRight:u("arrow-small-right",60063),arrowSmallUp:u("arrow-small-up",60064),arrowUp:u("arrow-up",60065),bell:u("bell",60066),bold:u("bold",60067),book:u("book",60068),bookmark:u("bookmark",60069),debugBreakpointConditionalUnverified:u("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:u("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:u("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:u("debug-breakpoint-data-unverified",60072),debugBreakpointData:u("debug-breakpoint-data",60073),debugBreakpointDataDisabled:u("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:u("debug-breakpoint-log-unverified",60074),debugBreakpointLog:u("debug-breakpoint-log",60075),debugBreakpointLogDisabled:u("debug-breakpoint-log-disabled",60075),briefcase:u("briefcase",60076),broadcast:u("broadcast",60077),browser:u("browser",60078),bug:u("bug",60079),calendar:u("calendar",60080),caseSensitive:u("case-sensitive",60081),check:u("check",60082),checklist:u("checklist",60083),chevronDown:u("chevron-down",60084),dropDownButton:u("drop-down-button",60084),chevronLeft:u("chevron-left",60085),chevronRight:u("chevron-right",60086),chevronUp:u("chevron-up",60087),chromeClose:u("chrome-close",60088),chromeMaximize:u("chrome-maximize",60089),chromeMinimize:u("chrome-minimize",60090),chromeRestore:u("chrome-restore",60091),circle:u("circle",60092),circleOutline:u("circle-outline",60092),debugBreakpointUnverified:u("debug-breakpoint-unverified",60092),circleSlash:u("circle-slash",60093),circuitBoard:u("circuit-board",60094),clearAll:u("clear-all",60095),clippy:u("clippy",60096),closeAll:u("close-all",60097),cloudDownload:u("cloud-download",60098),cloudUpload:u("cloud-upload",60099),code:u("code",60100),collapseAll:u("collapse-all",60101),colorMode:u("color-mode",60102),commentDiscussion:u("comment-discussion",60103),compareChanges:u("compare-changes",60157),creditCard:u("credit-card",60105),dash:u("dash",60108),dashboard:u("dashboard",60109),database:u("database",60110),debugContinue:u("debug-continue",60111),debugDisconnect:u("debug-disconnect",60112),debugPause:u("debug-pause",60113),debugRestart:u("debug-restart",60114),debugStart:u("debug-start",60115),debugStepInto:u("debug-step-into",60116),debugStepOut:u("debug-step-out",60117),debugStepOver:u("debug-step-over",60118),debugStop:u("debug-stop",60119),debug:u("debug",60120),deviceCameraVideo:u("device-camera-video",60121),deviceCamera:u("device-camera",60122),deviceMobile:u("device-mobile",60123),diffAdded:u("diff-added",60124),diffIgnored:u("diff-ignored",60125),diffModified:u("diff-modified",60126),diffRemoved:u("diff-removed",60127),diffRenamed:u("diff-renamed",60128),diff:u("diff",60129),discard:u("discard",60130),editorLayout:u("editor-layout",60131),emptyWindow:u("empty-window",60132),exclude:u("exclude",60133),extensions:u("extensions",60134),eyeClosed:u("eye-closed",60135),fileBinary:u("file-binary",60136),fileCode:u("file-code",60137),fileMedia:u("file-media",60138),filePdf:u("file-pdf",60139),fileSubmodule:u("file-submodule",60140),fileSymlinkDirectory:u("file-symlink-directory",60141),fileSymlinkFile:u("file-symlink-file",60142),fileZip:u("file-zip",60143),files:u("files",60144),filter:u("filter",60145),flame:u("flame",60146),foldDown:u("fold-down",60147),foldUp:u("fold-up",60148),fold:u("fold",60149),folderActive:u("folder-active",60150),folderOpened:u("folder-opened",60151),gear:u("gear",60152),gift:u("gift",60153),gistSecret:u("gist-secret",60154),gist:u("gist",60155),gitCommit:u("git-commit",60156),gitCompare:u("git-compare",60157),gitMerge:u("git-merge",60158),githubAction:u("github-action",60159),githubAlt:u("github-alt",60160),globe:u("globe",60161),grabber:u("grabber",60162),graph:u("graph",60163),gripper:u("gripper",60164),heart:u("heart",60165),home:u("home",60166),horizontalRule:u("horizontal-rule",60167),hubot:u("hubot",60168),inbox:u("inbox",60169),issueClosed:u("issue-closed",60324),issueReopened:u("issue-reopened",60171),issues:u("issues",60172),italic:u("italic",60173),jersey:u("jersey",60174),json:u("json",60175),kebabVertical:u("kebab-vertical",60176),key:u("key",60177),law:u("law",60178),lightbulbAutofix:u("lightbulb-autofix",60179),linkExternal:u("link-external",60180),link:u("link",60181),listOrdered:u("list-ordered",60182),listUnordered:u("list-unordered",60183),liveShare:u("live-share",60184),loading:u("loading",60185),location:u("location",60186),mailRead:u("mail-read",60187),mail:u("mail",60188),markdown:u("markdown",60189),megaphone:u("megaphone",60190),mention:u("mention",60191),milestone:u("milestone",60192),mortarBoard:u("mortar-board",60193),move:u("move",60194),multipleWindows:u("multiple-windows",60195),mute:u("mute",60196),noNewline:u("no-newline",60197),note:u("note",60198),octoface:u("octoface",60199),openPreview:u("open-preview",60200),package_:u("package",60201),paintcan:u("paintcan",60202),pin:u("pin",60203),play:u("play",60204),run:u("run",60204),plug:u("plug",60205),preserveCase:u("preserve-case",60206),preview:u("preview",60207),project:u("project",60208),pulse:u("pulse",60209),question:u("question",60210),quote:u("quote",60211),radioTower:u("radio-tower",60212),reactions:u("reactions",60213),references:u("references",60214),refresh:u("refresh",60215),regex:u("regex",60216),remoteExplorer:u("remote-explorer",60217),remote:u("remote",60218),remove:u("remove",60219),replaceAll:u("replace-all",60220),replace:u("replace",60221),repoClone:u("repo-clone",60222),repoForcePush:u("repo-force-push",60223),repoPull:u("repo-pull",60224),repoPush:u("repo-push",60225),report:u("report",60226),requestChanges:u("request-changes",60227),rocket:u("rocket",60228),rootFolderOpened:u("root-folder-opened",60229),rootFolder:u("root-folder",60230),rss:u("rss",60231),ruby:u("ruby",60232),saveAll:u("save-all",60233),saveAs:u("save-as",60234),save:u("save",60235),screenFull:u("screen-full",60236),screenNormal:u("screen-normal",60237),searchStop:u("search-stop",60238),server:u("server",60240),settingsGear:u("settings-gear",60241),settings:u("settings",60242),shield:u("shield",60243),smiley:u("smiley",60244),sortPrecedence:u("sort-precedence",60245),splitHorizontal:u("split-horizontal",60246),splitVertical:u("split-vertical",60247),squirrel:u("squirrel",60248),starFull:u("star-full",60249),starHalf:u("star-half",60250),symbolClass:u("symbol-class",60251),symbolColor:u("symbol-color",60252),symbolCustomColor:u("symbol-customcolor",60252),symbolConstant:u("symbol-constant",60253),symbolEnumMember:u("symbol-enum-member",60254),symbolField:u("symbol-field",60255),symbolFile:u("symbol-file",60256),symbolInterface:u("symbol-interface",60257),symbolKeyword:u("symbol-keyword",60258),symbolMisc:u("symbol-misc",60259),symbolOperator:u("symbol-operator",60260),symbolProperty:u("symbol-property",60261),wrench:u("wrench",60261),wrenchSubaction:u("wrench-subaction",60261),symbolSnippet:u("symbol-snippet",60262),tasklist:u("tasklist",60263),telescope:u("telescope",60264),textSize:u("text-size",60265),threeBars:u("three-bars",60266),thumbsdown:u("thumbsdown",60267),thumbsup:u("thumbsup",60268),tools:u("tools",60269),triangleDown:u("triangle-down",60270),triangleLeft:u("triangle-left",60271),triangleRight:u("triangle-right",60272),triangleUp:u("triangle-up",60273),twitter:u("twitter",60274),unfold:u("unfold",60275),unlock:u("unlock",60276),unmute:u("unmute",60277),unverified:u("unverified",60278),verified:u("verified",60279),versions:u("versions",60280),vmActive:u("vm-active",60281),vmOutline:u("vm-outline",60282),vmRunning:u("vm-running",60283),watch:u("watch",60284),whitespace:u("whitespace",60285),wholeWord:u("whole-word",60286),window:u("window",60287),wordWrap:u("word-wrap",60288),zoomIn:u("zoom-in",60289),zoomOut:u("zoom-out",60290),listFilter:u("list-filter",60291),listFlat:u("list-flat",60292),listSelection:u("list-selection",60293),selection:u("selection",60293),listTree:u("list-tree",60294),debugBreakpointFunctionUnverified:u("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:u("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:u("debug-breakpoint-function-disabled",60296),debugStackframeActive:u("debug-stackframe-active",60297),circleSmallFilled:u("circle-small-filled",60298),debugStackframeDot:u("debug-stackframe-dot",60298),debugStackframe:u("debug-stackframe",60299),debugStackframeFocused:u("debug-stackframe-focused",60299),debugBreakpointUnsupported:u("debug-breakpoint-unsupported",60300),symbolString:u("symbol-string",60301),debugReverseContinue:u("debug-reverse-continue",60302),debugStepBack:u("debug-step-back",60303),debugRestartFrame:u("debug-restart-frame",60304),callIncoming:u("call-incoming",60306),callOutgoing:u("call-outgoing",60307),menu:u("menu",60308),expandAll:u("expand-all",60309),feedback:u("feedback",60310),groupByRefType:u("group-by-ref-type",60311),ungroupByRefType:u("ungroup-by-ref-type",60312),account:u("account",60313),bellDot:u("bell-dot",60314),debugConsole:u("debug-console",60315),library:u("library",60316),output:u("output",60317),runAll:u("run-all",60318),syncIgnored:u("sync-ignored",60319),pinned:u("pinned",60320),githubInverted:u("github-inverted",60321),debugAlt:u("debug-alt",60305),serverProcess:u("server-process",60322),serverEnvironment:u("server-environment",60323),pass:u("pass",60324),stopCircle:u("stop-circle",60325),playCircle:u("play-circle",60326),record:u("record",60327),debugAltSmall:u("debug-alt-small",60328),vmConnect:u("vm-connect",60329),cloud:u("cloud",60330),merge:u("merge",60331),exportIcon:u("export",60332),graphLeft:u("graph-left",60333),magnet:u("magnet",60334),notebook:u("notebook",60335),redo:u("redo",60336),checkAll:u("check-all",60337),pinnedDirty:u("pinned-dirty",60338),passFilled:u("pass-filled",60339),circleLargeFilled:u("circle-large-filled",60340),circleLarge:u("circle-large",60341),circleLargeOutline:u("circle-large-outline",60341),combine:u("combine",60342),gather:u("gather",60342),table:u("table",60343),variableGroup:u("variable-group",60344),typeHierarchy:u("type-hierarchy",60345),typeHierarchySub:u("type-hierarchy-sub",60346),typeHierarchySuper:u("type-hierarchy-super",60347),gitPullRequestCreate:u("git-pull-request-create",60348),runAbove:u("run-above",60349),runBelow:u("run-below",60350),notebookTemplate:u("notebook-template",60351),debugRerun:u("debug-rerun",60352),workspaceTrusted:u("workspace-trusted",60353),workspaceUntrusted:u("workspace-untrusted",60354),workspaceUnspecified:u("workspace-unspecified",60355),terminalCmd:u("terminal-cmd",60356),terminalDebian:u("terminal-debian",60357),terminalLinux:u("terminal-linux",60358),terminalPowershell:u("terminal-powershell",60359),terminalTmux:u("terminal-tmux",60360),terminalUbuntu:u("terminal-ubuntu",60361),terminalBash:u("terminal-bash",60362),arrowSwap:u("arrow-swap",60363),copy:u("copy",60364),personAdd:u("person-add",60365),filterFilled:u("filter-filled",60366),wand:u("wand",60367),debugLineByLine:u("debug-line-by-line",60368),inspect:u("inspect",60369),layers:u("layers",60370),layersDot:u("layers-dot",60371),layersActive:u("layers-active",60372),compass:u("compass",60373),compassDot:u("compass-dot",60374),compassActive:u("compass-active",60375),azure:u("azure",60376),issueDraft:u("issue-draft",60377),gitPullRequestClosed:u("git-pull-request-closed",60378),gitPullRequestDraft:u("git-pull-request-draft",60379),debugAll:u("debug-all",60380),debugCoverage:u("debug-coverage",60381),runErrors:u("run-errors",60382),folderLibrary:u("folder-library",60383),debugContinueSmall:u("debug-continue-small",60384),beakerStop:u("beaker-stop",60385),graphLine:u("graph-line",60386),graphScatter:u("graph-scatter",60387),pieChart:u("pie-chart",60388),bracket:u("bracket",60388),bracketDot:u("bracket-dot",60389),bracketError:u("bracket-error",60390),lockSmall:u("lock-small",60391),azureDevops:u("azure-devops",60392),verifiedFilled:u("verified-filled",60393),newLine:u("newline",60394),layout:u("layout",60395),layoutActivitybarLeft:u("layout-activitybar-left",60396),layoutActivitybarRight:u("layout-activitybar-right",60397),layoutPanelLeft:u("layout-panel-left",60398),layoutPanelCenter:u("layout-panel-center",60399),layoutPanelJustify:u("layout-panel-justify",60400),layoutPanelRight:u("layout-panel-right",60401),layoutPanel:u("layout-panel",60402),layoutSidebarLeft:u("layout-sidebar-left",60403),layoutSidebarRight:u("layout-sidebar-right",60404),layoutStatusbar:u("layout-statusbar",60405),layoutMenubar:u("layout-menubar",60406),layoutCentered:u("layout-centered",60407),layoutSidebarRightOff:u("layout-sidebar-right-off",60416),layoutPanelOff:u("layout-panel-off",60417),layoutSidebarLeftOff:u("layout-sidebar-left-off",60418),target:u("target",60408),indent:u("indent",60409),recordSmall:u("record-small",60410),errorSmall:u("error-small",60411),arrowCircleDown:u("arrow-circle-down",60412),arrowCircleLeft:u("arrow-circle-left",60413),arrowCircleRight:u("arrow-circle-right",60414),arrowCircleUp:u("arrow-circle-up",60415),heartFilled:u("heart-filled",60420),map:u("map",60421),mapFilled:u("map-filled",60422),circleSmall:u("circle-small",60423),bellSlash:u("bell-slash",60424),bellSlashDot:u("bell-slash-dot",60425),commentUnresolved:u("comment-unresolved",60426),gitPullRequestGoToChanges:u("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:u("git-pull-request-new-changes",60428),searchFuzzy:u("search-fuzzy",60429),commentDraft:u("comment-draft",60430),dialogError:u("dialog-error","error"),dialogWarning:u("dialog-warning","warning"),dialogInfo:u("dialog-info","info"),dialogClose:u("dialog-close","close"),treeItemExpanded:u("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:u("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:u("tree-filter-on-type-off","list-selection"),treeFilterClear:u("tree-filter-clear","close"),treeItemLoading:u("tree-item-loading","loading"),menuSelection:u("menu-selection","check"),menuSubmenu:u("menu-submenu","chevron-right"),menuBarMore:u("menubar-more","more"),scrollbarButtonLeft:u("scrollbar-button-left","triangle-left"),scrollbarButtonRight:u("scrollbar-button-right","triangle-right"),scrollbarButtonUp:u("scrollbar-button-up","triangle-up"),scrollbarButtonDown:u("scrollbar-button-down","triangle-down"),toolBarMore:u("toolbar-more","more"),quickInputBack:u("quick-input-back","arrow-left")}}),define(ye[23],De([1,0,9]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const p=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([b,S])=>{p[b]=S&&typeof S=="object"?R(S):S}),p}e.deepClone=R;function T(f){if(!f||typeof f!="object")return f;const p=[f];for(;p.length>0;){const b=p.shift();Object.freeze(b);for(const S in b)if(u.call(b,S)){const g=b[S];typeof g=="object"&&!Object.isFrozen(g)&&!(0,a.isTypedArray)(g)&&p.push(g)}}return f}e.deepFreeze=T;const u=Object.prototype.hasOwnProperty;function C(f,p){return A(f,p,new Set)}e.cloneAndChange=C;function A(f,p,b){if((0,a.isUndefinedOrNull)(f))return f;const S=p(f);if(typeof S<"u")return S;if(Array.isArray(f)){const g=[];for(const t of f)g.push(A(t,p,b));return g}if((0,a.isObject)(f)){if(b.has(f))throw new Error("Cannot clone recursive data-structure");b.add(f);const g={};for(const t in f)u.call(f,t)&&(g[t]=A(f[t],p,b));return b.delete(f),g}return f}function y(f,p,b=!0){return(0,a.isObject)(f)?((0,a.isObject)(p)&&Object.keys(p).forEach(S=>{S in f?b&&((0,a.isObject)(f[S])&&(0,a.isObject)(p[S])?y(f[S],p[S],b):f[S]=p[S]):f[S]=p[S]}),f):p}e.mixin=y;function I(f,p){if(f===p)return!0;if(f==null||p===null||p===void 0||typeof f!=typeof p||typeof f!="object"||Array.isArray(f)!==Array.isArray(p))return!1;let b,S;if(Array.isArray(f)){if(f.length!==p.length)return!1;for(b=0;b<f.length;b++)if(!I(f[b],p[b]))return!1}else{const g=[];for(S in f)g.push(S);g.sort();const t=[];for(S in p)t.push(S);if(t.sort(),!I(g,t))return!1;for(b=0;b<g.length;b++)if(!I(f[g[b]],p[g[b]]))return!1}return!0}e.equals=I;function L(f){const p=new Set;return JSON.stringify(f,(b,S)=>{if((0,a.isObject)(S)||Array.isArray(S)){if(p.has(S))return"[Circular]";p.add(S)}return S})}e.safeStringify=L;function k(f,p){const b=Object.create(null);return!f||!p||Object.keys(p).forEach(g=>{const t=f[g],l=p[g];I(t,l)||(b[g]=l)}),b}e.distinct=k;function v(f,p){const b=p.toLowerCase(),S=Object.keys(f).find(g=>g.toLowerCase()===b);return S?f[S]:f[p]}e.getCaseInsensitive=v;function P(f,p){const b=Object.create(null);for(const[S,g]of Object.entries(f))p(S,g)&&(b[S]=g);return b}e.filter=P;function E(f){let p=[],b=Object.getPrototypeOf(f);for(;Object.prototype!==b;)p=p.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return p}e.getAllPropertyNames=E;function h(f){const p=[];for(const b of E(f))typeof f[b]=="function"&&p.push(b);return p}e.getAllMethodNames=h;function d(f,p){const b=g=>function(){const t=Array.prototype.slice.call(arguments,0);return p(g,t)},S={};for(const g of f)S[g]=b(g);return S}e.createProxyObject=d}),define(ye[51],De([1,0,67]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(C){function A(y){return y&&typeof y=="object"&&typeof y.id=="string"}C.isThemeColor=A})(R=e.ThemeColor||(e.ThemeColor={}));function T(C){return{id:C}}e.themeColorFromId=T;var u;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function y(p){const b=A.exec(p.id);if(!b)return y(a.Codicon.error);const[,S,g]=b,t=["codicon","codicon-"+S];return g&&t.push("codicon-modifier-"+g.substring(1)),t}C.asClassNameArray=y;function I(p){return y(p).join(" ")}C.asClassName=I;function L(p){return"."+y(p).join(".")}C.asCSSSelector=L;function k(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||R.isThemeColor(p.color))}C.isThemeIcon=k;const v=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function P(p){const b=v.exec(p);if(!b)return;const[,S]=b;return{id:S}}C.fromString=P;function E(p){return{id:p}}C.fromId=E;function h(p,b){let S=p.id;const g=S.lastIndexOf("~");return g!==-1&&(S=S.substring(0,g)),b&&(S=`${S}~${b}`),{id:S}}C.modify=h;function d(p){const b=p.id.lastIndexOf("~");if(b!==-1)return p.id.substring(b+1)}C.getModifier=d;function f(p,b){return p.id===b.id&&p.color?.id===b.color?.id}C.isEqual=f})(u=e.ThemeIcon||(e.ThemeIcon={}))}),define(ye[104],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function R(u){return u<0?0:u>255?255:u|0}e.toUint8=R;function T(u){return u<0?0:u>4294967295?4294967295:u|0}e.toUint32=T}),define(ye[30],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(T){return a.test(T)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const u=new Uint8Array(16),C=[];for(let A=0;A<256;A++)C.push(A.toString(16).padStart(2,"0"));return function(){T(u),u[6]=u[6]&15|64,u[8]=u[8]&63|128;let y=0,I="";return I+=C[u[y++]],I+=C[u[y++]],I+=C[u[y++]],I+=C[u[y++]],I+="-",I+=C[u[y++]],I+=C[u[y++]],I+="-",I+=C[u[y++]],I+=C[u[y++]],I+="-",I+=C[u[y++]],I+=C[u[y++]],I+="-",I+=C[u[y++]],I+=C[u[y++]],I+=C[u[y++]],I+=C[u[y++]],I+=C[u[y++]],I+=C[u[y++]],I}}()}),define(ye[148],De([1,0,15,30]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function T(A){return{id:(0,R.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=T;function u(A,y,I){return{id:(0,R.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:I}),value:void 0}}e.createFileDataTransferItem=u;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,I){const L=this.a.get(y);L?L.push(I):this.a.set(this.b(y),[I])}replace(y,I){this.a.set(this.b(y),[I])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,I]of this.a.entries())for(const L of I)yield[y,L]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[I,L]of this.entries())y(L,I)}b(y){return y.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:A=>(0,a.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),define(ye[105],De([1,0,104]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(A){const y=(0,a.toUint8)(A);this.c=y,this.a=R.d(y),this.b=new Map}static d(A){const y=new Uint8Array(256);return y.fill(A),y}set(A,y){const I=(0,a.toUint8)(y);A>=0&&A<256?this.a[A]=I:this.b.set(A,I)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=R;var T;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(T||(T={}));class u{constructor(){this.a=new R(0)}add(A){this.a.set(A,1)}has(A){return this.a.get(A)===1}clear(){return this.a.clear()}}e.CharacterSet=u}),define(ye[52],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(T,u){this.lineNumber=T,this.column=u}with(T=this.lineNumber,u=this.column){return T===this.lineNumber&&u===this.column?this:new a(T,u)}delta(T=0,u=0){return this.with(this.lineNumber+T,this.column+u)}equals(T){return a.equals(this,T)}static equals(T,u){return!T&&!u?!0:!!T&&!!u&&T.lineNumber===u.lineNumber&&T.column===u.column}isBefore(T){return a.isBefore(this,T)}static isBefore(T,u){return T.lineNumber<u.lineNumber?!0:u.lineNumber<T.lineNumber?!1:T.column<u.column}isBeforeOrEqual(T){return a.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,u){return T.lineNumber<u.lineNumber?!0:u.lineNumber<T.lineNumber?!1:T.column<=u.column}static compare(T,u){const C=T.lineNumber|0,A=u.lineNumber|0;if(C===A){const y=T.column|0,I=u.column|0;return y-I}return C-A}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new a(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=a}),define(ye[35],De([1,0,52]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(u,C,A,y){u>A||u===A&&C>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=u,this.endColumn=C):(this.startLineNumber=u,this.startColumn=C,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return R.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return R.containsPosition(this,u)}static containsPosition(u,C){return!(C.lineNumber<u.startLineNumber||C.lineNumber>u.endLineNumber||C.lineNumber===u.startLineNumber&&C.column<u.startColumn||C.lineNumber===u.endLineNumber&&C.column>u.endColumn)}static strictContainsPosition(u,C){return!(C.lineNumber<u.startLineNumber||C.lineNumber>u.endLineNumber||C.lineNumber===u.startLineNumber&&C.column<=u.startColumn||C.lineNumber===u.endLineNumber&&C.column>=u.endColumn)}containsRange(u){return R.containsRange(this,u)}static containsRange(u,C){return!(C.startLineNumber<u.startLineNumber||C.endLineNumber<u.startLineNumber||C.startLineNumber>u.endLineNumber||C.endLineNumber>u.endLineNumber||C.startLineNumber===u.startLineNumber&&C.startColumn<u.startColumn||C.endLineNumber===u.endLineNumber&&C.endColumn>u.endColumn)}strictContainsRange(u){return R.strictContainsRange(this,u)}static strictContainsRange(u,C){return!(C.startLineNumber<u.startLineNumber||C.endLineNumber<u.startLineNumber||C.startLineNumber>u.endLineNumber||C.endLineNumber>u.endLineNumber||C.startLineNumber===u.startLineNumber&&C.startColumn<=u.startColumn||C.endLineNumber===u.endLineNumber&&C.endColumn>=u.endColumn)}plusRange(u){return R.plusRange(this,u)}static plusRange(u,C){let A,y,I,L;return C.startLineNumber<u.startLineNumber?(A=C.startLineNumber,y=C.startColumn):C.startLineNumber===u.startLineNumber?(A=C.startLineNumber,y=Math.min(C.startColumn,u.startColumn)):(A=u.startLineNumber,y=u.startColumn),C.endLineNumber>u.endLineNumber?(I=C.endLineNumber,L=C.endColumn):C.endLineNumber===u.endLineNumber?(I=C.endLineNumber,L=Math.max(C.endColumn,u.endColumn)):(I=u.endLineNumber,L=u.endColumn),new R(A,y,I,L)}intersectRanges(u){return R.intersectRanges(this,u)}static intersectRanges(u,C){let A=u.startLineNumber,y=u.startColumn,I=u.endLineNumber,L=u.endColumn;const k=C.startLineNumber,v=C.startColumn,P=C.endLineNumber,E=C.endColumn;return A<k?(A=k,y=v):A===k&&(y=Math.max(y,v)),I>P?(I=P,L=E):I===P&&(L=Math.min(L,E)),A>I||A===I&&y>L?null:new R(A,y,I,L)}equalsRange(u){return R.equalsRange(this,u)}static equalsRange(u,C){return!u&&!C?!0:!!u&&!!C&&u.startLineNumber===C.startLineNumber&&u.startColumn===C.startColumn&&u.endLineNumber===C.endLineNumber&&u.endColumn===C.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(u){return new a.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(u){return new a.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,C){return new R(this.startLineNumber,this.startColumn,u,C)}setStartPosition(u,C){return new R(u,C,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(u){return new R(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(u){return new R(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new R(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,C=u){return new R(u.lineNumber,u.column,C.lineNumber,C.column)}static lift(u){return u?new R(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,C){return!(u.endLineNumber<C.startLineNumber||u.endLineNumber===C.startLineNumber&&u.endColumn<C.startColumn||C.endLineNumber<u.startLineNumber||C.endLineNumber===u.startLineNumber&&C.endColumn<u.startColumn)}static areIntersecting(u,C){return!(u.endLineNumber<C.startLineNumber||u.endLineNumber===C.startLineNumber&&u.endColumn<=C.startColumn||C.endLineNumber<u.startLineNumber||C.endLineNumber===u.startLineNumber&&C.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,C){if(u&&C){const I=u.startLineNumber|0,L=C.startLineNumber|0;if(I===L){const k=u.startColumn|0,v=C.startColumn|0;if(k===v){const P=u.endLineNumber|0,E=C.endLineNumber|0;if(P===E){const h=u.endColumn|0,d=C.endColumn|0;return h-d}return P-E}return k-v}return I-L}return(u?1:0)-(C?1:0)}static compareRangesUsingEnds(u,C){return u.endLineNumber===C.endLineNumber?u.endColumn===C.endColumn?u.startLineNumber===C.startLineNumber?u.startColumn-C.startColumn:u.startLineNumber-C.startLineNumber:u.endColumn-C.endColumn:u.endLineNumber-C.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}e.Range=R}),define(ye[149],De([1,0,52,35]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class u extends R.Range{constructor(A,y,I,L){super(A,y,I,L),this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=I,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return u.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,A,y):new u(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,y){return this.getDirection()===0?new u(A,y,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new u(A.lineNumber,A.column,y.lineNumber,y.column)}static fromRange(A,y){return y===0?new u(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new u(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new u(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let I=0,L=A.length;I<L;I++)if(!this.selectionsEqual(A[I],y[I]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,I,L,k){return k===0?new u(A,y,I,L):new u(I,L,A,y)}}e.Selection=u}),define(ye[150],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[151],De([1,0,105]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends a.CharacterClassifier{constructor(A){super(0);for(let y=0,I=A.length;y<I;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function u(C){const A={};return y=>(A.hasOwnProperty(y)||(A[y]=C(y)),A[y])}e.getMapForWordSeparators=u(C=>new T(C))}),define(ye[106],De([1,0,64,6,66]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(k=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(v+="\\"+P);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=u();function C(k){let v=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)v=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),v=new RegExp(k.source,P)}return v.lastIndex=0,v}e.ensureValidWordDefinition=C;const A=new T.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(k){const v=A.unshift(k);return(0,R.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=y;function I(k,v,P,E,h){if(h||(h=a.Iterable.first(A)),P.length>h.maxLen){let S=k-h.maxLen/2;return S<0?S=0:E+=S,P=P.substring(S,k+h.maxLen/2),I(k,v,P,E,h)}const d=Date.now(),f=k-1-E;let p=-1,b=null;for(let S=1;!(Date.now()-d>=h.timeBudget);S++){const g=f-h.windowSize*S;v.lastIndex=Math.max(0,g);const t=L(v,P,f,p);if(!t&&b||(b=t,g<=0))break;p=g}if(b){const S={word:b[0],startColumn:E+1+b.index,endColumn:E+1+b.index+b[0].length};return v.lastIndex=0,S}return null}e.getWordAtText=I;function L(k,v,P,E){let h;for(;h=k.exec(v);){const d=h.index||0;if(d<=P&&k.lastIndex>=P)return h;if(E>0&&d>E)return null}return null}}),define(ye[152],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class R{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,I=A.notIn.length;y<I;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const I=A.findTokenIndexAtOffset(y-2),L=A.getStandardTokenType(I);return this.isOK(L)}g(A,y){for(let I=A;I<=y;I++){const L=String.fromCharCode(I);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=R;class T{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)u(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),u(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),u(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),u(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&u(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=T;function u(C,A,y){C.has(A)?C.get(A).push(y):C.set(A,[y])}}),define(ye[153],De([1,0,105]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var R;(function(P){P[P.Invalid=0]="Invalid",P[P.Start=1]="Start",P[P.H=2]="H",P[P.HT=3]="HT",P[P.HTT=4]="HTT",P[P.HTTP=5]="HTTP",P[P.F=6]="F",P[P.FI=7]="FI",P[P.FIL=8]="FIL",P[P.BeforeColon=9]="BeforeColon",P[P.AfterColon=10]="AfterColon",P[P.AlmostThere=11]="AlmostThere",P[P.End=12]="End",P[P.Accept=13]="Accept",P[P.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class T{constructor(E,h,d){const f=new Uint8Array(E*h);for(let p=0,b=E*h;p<b;p++)f[p]=d;this.a=f,this.rows=E,this.cols=h}get(E,h){return this.a[E*this.cols+h]}set(E,h,d){this.a[E*this.cols+h]=d}}class u{constructor(E){let h=0,d=0;for(let p=0,b=E.length;p<b;p++){const[S,g,t]=E[p];g>h&&(h=g),S>d&&(d=S),t>d&&(d=t)}h++,d++;const f=new T(d,h,0);for(let p=0,b=E.length;p<b;p++){const[S,g,t]=E[p];f.set(S,g,t)}this.a=f,this.b=h}nextState(E,h){return h<0||h>=this.b?0:this.a.get(E,h)}}e.StateMachine=u;let C=null;function A(){return C===null&&(C=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var y;(function(P){P[P.None=0]="None",P[P.ForceTermination=1]="ForceTermination",P[P.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let I=null;function L(){if(I===null){I=new a.CharacterClassifier(0);const P=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<P.length;h++)I.set(P.charCodeAt(h),1);const E=".;:";for(let h=0;h<E.length;h++)I.set(E.charCodeAt(h),2)}return I}class k{static a(E,h,d,f,p){let b=p-1;do{const S=h.charCodeAt(b);if(E.get(S)!==2)break;b--}while(b>f);if(f>0){const S=h.charCodeAt(f-1),g=h.charCodeAt(b);(S===40&&g===41||S===91&&g===93||S===123&&g===125)&&b--}return{range:{startLineNumber:d,startColumn:f+1,endLineNumber:d,endColumn:b+2},url:h.substring(f,b+1)}}static computeLinks(E,h=A()){const d=L(),f=[];for(let p=1,b=E.getLineCount();p<=b;p++){const S=E.getLineContent(p),g=S.length;let t=0,l=0,r=0,o=1,n=!1,m=!1,s=!1,i=!1;for(;t<g;){let c=!1;const w=S.charCodeAt(t);if(o===13){let D;switch(w){case 40:n=!0,D=0;break;case 41:D=n?0:1;break;case 91:s=!0,m=!0,D=0;break;case 93:s=!1,D=m?0:1;break;case 123:i=!0,D=0;break;case 125:D=i?0:1;break;case 39:case 34:case 96:r===w?D=1:r===39||r===34||r===96?D=0:D=1;break;case 42:D=r===42?1:0;break;case 124:D=r===124?1:0;break;case 32:D=s?0:1;break;default:D=d.get(w)}D===1&&(f.push(k.a(d,S,p,l,t)),c=!0)}else if(o===12){let D;w===91?(m=!0,D=0):D=d.get(w),D===1?c=!0:o=13}else o=h.nextState(o,w),o===0&&(c=!0);c&&(o=1,n=!1,m=!1,i=!1,l=t+1,r=w),t++}o===13&&f.push(k.a(d,S,p,l,g))}return f}}e.LinkComputer=k;function v(P){return!P||typeof P.getLineCount!="function"||typeof P.getLineContent!="function"?[]:k.computeLinks(P)}e.computeLinks=v}),define(ye[107],De([1,0,23]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var R;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(R=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var u;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(u=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(S){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,S.tabSize|0),S.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,S.indentSize|0),this.a=!1),this.insertSpaces=Boolean(S.insertSpaces),this.defaultEOL=S.defaultEOL|0,this.trimAutoWhitespace=Boolean(S.trimAutoWhitespace),this.bracketPairColorizationOptions=S.bracketPairColorizationOptions}equals(S){return this.tabSize===S.tabSize&&this.a===S.a&&this.indentSize===S.indentSize&&this.insertSpaces===S.insertSpaces&&this.defaultEOL===S.defaultEOL&&this.trimAutoWhitespace===S.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,S.bracketPairColorizationOptions)}createChangeEvent(S){return{tabSize:this.tabSize!==S.tabSize,indentSize:this.indentSize!==S.indentSize,insertSpaces:this.insertSpaces!==S.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==S.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class L{constructor(S,g){this._findMatchBrand=void 0,this.range=S,this.matches=g}}e.FindMatch=L;var k;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(b){return b&&typeof b.read=="function"}e.isITextSnapshot=v;var P;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(P=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class h{constructor(S,g,t,l,r,o){this.identifier=S,this.range=g,this.text=t,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=r,this._isTracked=o}}e.ValidAnnotatedEditOperation=h;class d{constructor(S,g,t){this.regex=S,this.wordSeparators=g,this.simpleSearch=t}}e.SearchData=d;class f{constructor(S,g,t){this.reverseEdits=S,this.changes=g,this.trimAutoWhitespaceLineNumbers=t}}e.ApplyEditsResult=f;function p(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=p}),define(ye[154],De([1,0,15,104]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class T{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,I){y=(0,R.toUint32)(y);const L=this.a,k=this.b,v=I.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y),y+v),this.a.set(I,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}setValue(y,I){return y=(0,R.toUint32)(y),I=(0,R.toUint32)(I),this.a[y]===I?!1:(this.a[y]=I,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,I){y=(0,R.toUint32)(y),I=(0,R.toUint32)(I);const L=this.a,k=this.b;if(y>=L.length)return!1;const v=L.length-y;return I>=v&&(I=v),I===0?!1:(this.a=new Uint32Array(L.length-I),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y+I),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,R.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let I=this.c[0]+1;I===0&&(this.b[0]=this.a[0],I++),y>=this.a.length&&(y=this.a.length-1);for(let L=I;L<=y;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let I=0,L=this.a.length-1,k=0,v=0,P=0;for(;I<=L;)if(k=I+(L-I)/2|0,v=this.b[k],P=v-this.a[k],y<P)L=k-1;else if(y>=v)I=k+1;else break;return new C(k,y-P)}}e.PrefixSumComputer=T;class u{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const I=this.e[y],L=I>0?this.d[I-1]:0;return new C(I,y-L)}removeValues(y,I){this.a.splice(y,I),this.f(y)}insertValues(y,I){this.a=(0,a.arrayInsert)(this.a,y,I),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,I=this.a.length;y<I;y++){const L=this.a[y],k=y>0?this.d[y-1]:0;this.d[y]=k+L;for(let v=0;v<L;v++)this.e[k+v]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,I){this.a[y]!==I&&(this.a[y]=I,this.f(y))}}e.ConstantTimePrefixSumComputer=u;class C{constructor(y,I){this.index=y,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=I}}e.PrefixSumIndexOfResult=C}),define(ye[155],De([19,20]),function(te,e){return te.create("vs/base/common/actions",e)}),define(ye[156],De([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(ye[157],De([1,0,156]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,T=R*60,u=T*24,C=u*7,A=u*30,y=u*365;function I(k,v,P,E){typeof k!="number"&&(k=k.getTime());const h=Math.round((new Date().getTime()-k)/1e3);if(h<-30)return(0,a.localize)(0,null,I(new Date().getTime()+h*1e3,!1));if(!E&&h<30)return(0,a.localize)(1,null);let d;return h<R?(d=h,v?d===1?P?(0,a.localize)(2,null,d):(0,a.localize)(3,null,d):P?(0,a.localize)(4,null,d):(0,a.localize)(5,null,d):d===1?P?(0,a.localize)(6,null,d):(0,a.localize)(7,null,d):P?(0,a.localize)(8,null,d):(0,a.localize)(9,null,d)):h<T?(d=Math.floor(h/R),v?d===1?P?(0,a.localize)(10,null,d):(0,a.localize)(11,null,d):P?(0,a.localize)(12,null,d):(0,a.localize)(13,null,d):d===1?P?(0,a.localize)(14,null,d):(0,a.localize)(15,null,d):P?(0,a.localize)(16,null,d):(0,a.localize)(17,null,d)):h<u?(d=Math.floor(h/T),v?d===1?P?(0,a.localize)(18,null,d):(0,a.localize)(19,null,d):P?(0,a.localize)(20,null,d):(0,a.localize)(21,null,d):d===1?P?(0,a.localize)(22,null,d):(0,a.localize)(23,null,d):P?(0,a.localize)(24,null,d):(0,a.localize)(25,null,d)):h<C?(d=Math.floor(h/u),v?d===1?(0,a.localize)(26,null,d):(0,a.localize)(27,null,d):d===1?(0,a.localize)(28,null,d):(0,a.localize)(29,null,d)):h<A?(d=Math.floor(h/C),v?d===1?P?(0,a.localize)(30,null,d):(0,a.localize)(31,null,d):P?(0,a.localize)(32,null,d):(0,a.localize)(33,null,d):d===1?P?(0,a.localize)(34,null,d):(0,a.localize)(35,null,d):P?(0,a.localize)(36,null,d):(0,a.localize)(37,null,d)):h<y?(d=Math.floor(h/A),v?d===1?P?(0,a.localize)(38,null,d):(0,a.localize)(39,null,d):P?(0,a.localize)(40,null,d):(0,a.localize)(41,null,d):d===1?P?(0,a.localize)(42,null,d):(0,a.localize)(43,null,d):P?(0,a.localize)(44,null,d):(0,a.localize)(45,null,d)):(d=Math.floor(h/y),v?d===1?P?(0,a.localize)(46,null,d):(0,a.localize)(47,null,d):P?(0,a.localize)(48,null,d):(0,a.localize)(49,null,d):d===1?P?(0,a.localize)(50,null,d):(0,a.localize)(51,null,d):P?(0,a.localize)(52,null,d):(0,a.localize)(53,null,d))}e.fromNow=I;function L(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[158],De([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ye[45],De([1,0,15,9,158]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function u(k,v){return v&&(k.stack||k.stacktrace)?T.localize(0,null,A(k),C(k.stack)||C(k.stacktrace)):A(k)}function C(k){return Array.isArray(k)?k.join(`
`):k}function A(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?T.localize(1,null,k.message):k.message||T.localize(2,null)}function y(k=null,v=!1){if(!k)return T.localize(3,null);if(Array.isArray(k)){const P=a.coalesce(k),E=y(P[0],v);return P.length>1?T.localize(4,null,E,P.length):E}if(R.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return u(P.error,v);if(P.exception)return u(P.exception,v)}return k.stack?u(k,v):k.message?k.message:T.localize(5,null)}e.toErrorMessage=y;function I(k){const v=k;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=I;function L(k,v){let P;return typeof k=="string"?P=new Error(k):P=k,P.actions=v,P}e.createErrorWithActions=L}),define(ye[159],De([19,20]),function(te,e){return te.create("vs/base/common/platform",e)}),define(ye[12],De([1,0,159]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let R=!1,T=!1,u=!1,C=!1,A=!1,y=!1,I=!1,L=!1,k=!1,v=!1,P,E=e.LANGUAGE_DEFAULT,h,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const p=typeof f?.versions?.electron=="string",b=p&&f?.type==="renderer";if(typeof navigator=="object"&&!b)d=navigator.userAgent,R=d.indexOf("Windows")>=0,T=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=d.indexOf("Linux")>=0,v=d?.indexOf("Mobi")>=0,y=!0,P=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,E=P;else if(typeof f=="object"){R=f.platform==="win32",T=f.platform==="darwin",u=f.platform==="linux",C=u&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,I=p,k=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,P=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const i=JSON.parse(s),c=i.availableLanguages["*"];P=i.locale,E=c||e.LANGUAGE_DEFAULT,h=i._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var S;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function g(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let t=0;T?t=1:R?t=3:u&&(t=2),e.isWindows=R,e.isMacintosh=T,e.isLinux=u,e.isLinuxSnap=C,e.isNative=A,e.isElectron=I,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=v,e.isCI=k,e.platform=t,e.userAgent=d,e.language=E;var l;(function(s){function i(){return e.language}s.value=i;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function w(){return e.language==="en"}s.isDefault=w})(l=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let w=0,D=s.length;w<D;w++){const F=s[w];if(F.id===c.data.vscodeScheduleAsyncWork){s.splice(w,1),F.callback();return}}});let i=0;return c=>{const w=++i;s.push({id:w,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||L?2:R?1:3;let o=!0,n=!1;function m(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,o=new Uint16Array(s.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=m,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],De([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const T=a.globals.vscode.process;R={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(ye[10],De([1,0,36]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,T=97,u=90,C=122,A=46,y=47,I=92,L=58,k=63;class v extends Error{constructor(l,r,o){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const m=l.indexOf(".")!==-1?"property":"argument";let s=`The "${l}" ${m} ${n} of type ${r}`;s+=`. Received type ${typeof o}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function P(t,l){if(t===null||typeof t!="object")throw new v(l,"Object",t)}function E(t,l){if(typeof t!="string")throw new v(l,"string",t)}const h=a.platform==="win32";function d(t){return t===y||t===I}function f(t){return t===y}function p(t){return t>=R&&t<=u||t>=T&&t<=C}function b(t,l,r,o){let n="",m=0,s=-1,i=0,c=0;for(let w=0;w<=t.length;++w){if(w<t.length)c=t.charCodeAt(w);else{if(o(c))break;c=y}if(o(c)){if(!(s===w-1||i===1))if(i===2){if(n.length<2||m!==2||n.charCodeAt(n.length-1)!==A||n.charCodeAt(n.length-2)!==A){if(n.length>2){const D=n.lastIndexOf(r);D===-1?(n="",m=0):(n=n.slice(0,D),m=n.length-1-n.lastIndexOf(r)),s=w,i=0;continue}else if(n.length!==0){n="",m=0,s=w,i=0;continue}}l&&(n+=n.length>0?`${r}..`:"..",m=2)}else n.length>0?n+=`${r}${t.slice(s+1,w)}`:n=t.slice(s+1,w),m=w-s-1;s=w,i=0}else c===A&&i!==-1?++i:i=-1}return n}function S(t,l){P(l,"pathObject");const r=l.dir||l.root,o=l.base||`${l.name||""}${l.ext||""}`;return r?r===l.root?`${r}${o}`:`${r}${t}${o}`:o}e.win32={resolve(...t){let l="",r="",o=!1;for(let n=t.length-1;n>=-1;n--){let m;if(n>=0){if(m=t[n],E(m,"path"),m.length===0)continue}else l.length===0?m=a.cwd():(m=a.env[`=${l}`]||a.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==l.toLowerCase()&&m.charCodeAt(2)===I)&&(m=`${l}\\`));const s=m.length;let i=0,c="",w=!1;const D=m.charCodeAt(0);if(s===1)d(D)&&(i=1,w=!0);else if(d(D))if(w=!0,d(m.charCodeAt(1))){let F=2,x=F;for(;F<s&&!d(m.charCodeAt(F));)F++;if(F<s&&F!==x){const q=m.slice(x,F);for(x=F;F<s&&d(m.charCodeAt(F));)F++;if(F<s&&F!==x){for(x=F;F<s&&!d(m.charCodeAt(F));)F++;(F===s||F!==x)&&(c=`\\\\${q}\\${m.slice(x,F)}`,i=F)}}}else i=1;else p(D)&&m.charCodeAt(1)===L&&(c=m.slice(0,2),i=2,s>2&&d(m.charCodeAt(2))&&(w=!0,i=3));if(c.length>0)if(l.length>0){if(c.toLowerCase()!==l.toLowerCase())continue}else l=c;if(o){if(l.length>0)break}else if(r=`${m.slice(i)}\\${r}`,o=w,w&&l.length>0)break}return r=b(r,!o,"\\",d),o?`${l}\\${r}`:`${l}${r}`||"."},normalize(t){E(t,"path");const l=t.length;if(l===0)return".";let r=0,o,n=!1;const m=t.charCodeAt(0);if(l===1)return f(m)?"\\":t;if(d(m))if(n=!0,d(t.charCodeAt(1))){let i=2,c=i;for(;i<l&&!d(t.charCodeAt(i));)i++;if(i<l&&i!==c){const w=t.slice(c,i);for(c=i;i<l&&d(t.charCodeAt(i));)i++;if(i<l&&i!==c){for(c=i;i<l&&!d(t.charCodeAt(i));)i++;if(i===l)return`\\\\${w}\\${t.slice(c)}\\`;i!==c&&(o=`\\\\${w}\\${t.slice(c,i)}`,r=i)}}}else r=1;else p(m)&&t.charCodeAt(1)===L&&(o=t.slice(0,2),r=2,l>2&&d(t.charCodeAt(2))&&(n=!0,r=3));let s=r<l?b(t.slice(r),!n,"\\",d):"";return s.length===0&&!n&&(s="."),s.length>0&&d(t.charCodeAt(l-1))&&(s+="\\"),o===void 0?n?`\\${s}`:s:n?`${o}\\${s}`:`${o}${s}`},isAbsolute(t){E(t,"path");const l=t.length;if(l===0)return!1;const r=t.charCodeAt(0);return d(r)||l>2&&p(r)&&t.charCodeAt(1)===L&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,r;for(let m=0;m<t.length;++m){const s=t[m];E(s,"path"),s.length>0&&(l===void 0?l=r=s:l+=`\\${s}`)}if(l===void 0)return".";let o=!0,n=0;if(typeof r=="string"&&d(r.charCodeAt(0))){++n;const m=r.length;m>1&&d(r.charCodeAt(1))&&(++n,m>2&&(d(r.charCodeAt(2))?++n:o=!1))}if(o){for(;n<l.length&&d(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(t,l){if(E(t,"from"),E(l,"to"),t===l)return"";const r=e.win32.resolve(t),o=e.win32.resolve(l);if(r===o||(t=r.toLowerCase(),l=o.toLowerCase(),t===l))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===I;)n++;let m=t.length;for(;m-1>n&&t.charCodeAt(m-1)===I;)m--;const s=m-n;let i=0;for(;i<l.length&&l.charCodeAt(i)===I;)i++;let c=l.length;for(;c-1>i&&l.charCodeAt(c-1)===I;)c--;const w=c-i,D=s<w?s:w;let F=-1,x=0;for(;x<D;x++){const M=t.charCodeAt(n+x);if(M!==l.charCodeAt(i+x))break;M===I&&(F=x)}if(x!==D){if(F===-1)return o}else{if(w>D){if(l.charCodeAt(i+x)===I)return o.slice(i+x+1);if(x===2)return o.slice(i+x)}s>D&&(t.charCodeAt(n+x)===I?F=x:x===2&&(F=3)),F===-1&&(F=0)}let q="";for(x=n+F+1;x<=m;++x)(x===m||t.charCodeAt(x)===I)&&(q+=q.length===0?"..":"\\..");return i+=F,q.length>0?`${q}${o.slice(i,c)}`:(o.charCodeAt(i)===I&&++i,o.slice(i,c))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.win32.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===I){if(l.charCodeAt(1)===I){const r=l.charCodeAt(2);if(r!==k&&r!==A)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(p(l.charCodeAt(0))&&l.charCodeAt(1)===L&&l.charCodeAt(2)===I)return`\\\\?\\${l}`;return t},dirname(t){E(t,"path");const l=t.length;if(l===0)return".";let r=-1,o=0;const n=t.charCodeAt(0);if(l===1)return d(n)?t:".";if(d(n)){if(r=o=1,d(t.charCodeAt(1))){let i=2,c=i;for(;i<l&&!d(t.charCodeAt(i));)i++;if(i<l&&i!==c){for(c=i;i<l&&d(t.charCodeAt(i));)i++;if(i<l&&i!==c){for(c=i;i<l&&!d(t.charCodeAt(i));)i++;if(i===l)return t;i!==c&&(r=o=i+1)}}}}else p(n)&&t.charCodeAt(1)===L&&(r=l>2&&d(t.charCodeAt(2))?3:2,o=r);let m=-1,s=!0;for(let i=l-1;i>=o;--i)if(d(t.charCodeAt(i))){if(!s){m=i;break}}else s=!1;if(m===-1){if(r===-1)return".";m=r}return t.slice(0,m)},basename(t,l){l!==void 0&&E(l,"ext"),E(t,"path");let r=0,o=-1,n=!0,m;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(r=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let s=l.length-1,i=-1;for(m=t.length-1;m>=r;--m){const c=t.charCodeAt(m);if(d(c)){if(!n){r=m+1;break}}else i===-1&&(n=!1,i=m+1),s>=0&&(c===l.charCodeAt(s)?--s===-1&&(o=m):(s=-1,o=i))}return r===o?o=i:o===-1&&(o=t.length),t.slice(r,o)}for(m=t.length-1;m>=r;--m)if(d(t.charCodeAt(m))){if(!n){r=m+1;break}}else o===-1&&(n=!1,o=m+1);return o===-1?"":t.slice(r,o)},extname(t){E(t,"path");let l=0,r=-1,o=0,n=-1,m=!0,s=0;t.length>=2&&t.charCodeAt(1)===L&&p(t.charCodeAt(0))&&(l=o=2);for(let i=t.length-1;i>=l;--i){const c=t.charCodeAt(i);if(d(c)){if(!m){o=i+1;break}continue}n===-1&&(m=!1,n=i+1),c===A?r===-1?r=i:s!==1&&(s=1):r!==-1&&(s=-1)}return r===-1||n===-1||s===0||s===1&&r===n-1&&r===o+1?"":t.slice(r,n)},format:S.bind(null,"\\"),parse(t){E(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.length;let o=0,n=t.charCodeAt(0);if(r===1)return d(n)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(d(n)){if(o=1,d(t.charCodeAt(1))){let F=2,x=F;for(;F<r&&!d(t.charCodeAt(F));)F++;if(F<r&&F!==x){for(x=F;F<r&&d(t.charCodeAt(F));)F++;if(F<r&&F!==x){for(x=F;F<r&&!d(t.charCodeAt(F));)F++;F===r?o=F:F!==x&&(o=F+1)}}}}else if(p(n)&&t.charCodeAt(1)===L){if(r<=2)return l.root=l.dir=t,l;if(o=2,d(t.charCodeAt(2))){if(r===3)return l.root=l.dir=t,l;o=3}}o>0&&(l.root=t.slice(0,o));let m=-1,s=o,i=-1,c=!0,w=t.length-1,D=0;for(;w>=o;--w){if(n=t.charCodeAt(w),d(n)){if(!c){s=w+1;break}continue}i===-1&&(c=!1,i=w+1),n===A?m===-1?m=w:D!==1&&(D=1):m!==-1&&(D=-1)}return i!==-1&&(m===-1||D===0||D===1&&m===i-1&&m===s+1?l.base=l.name=t.slice(s,i):(l.name=t.slice(s,m),l.base=t.slice(s,i),l.ext=t.slice(m,i))),s>0&&s!==o?l.dir=t.slice(0,s-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(h){const t=/\\/g;return()=>{const l=a.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...t){let l="",r=!1;for(let o=t.length-1;o>=-1&&!r;o--){const n=o>=0?t[o]:g();E(n,"path"),n.length!==0&&(l=`${n}/${l}`,r=n.charCodeAt(0)===y)}return l=b(l,!r,"/",f),r?`/${l}`:l.length>0?l:"."},normalize(t){if(E(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===y,r=t.charCodeAt(t.length-1)===y;return t=b(t,!l,"/",f),t.length===0?l?"/":r?"./":".":(r&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return E(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let l;for(let r=0;r<t.length;++r){const o=t[r];E(o,"path"),o.length>0&&(l===void 0?l=o:l+=`/${o}`)}return l===void 0?".":e.posix.normalize(l)},relative(t,l){if(E(t,"from"),E(l,"to"),t===l||(t=e.posix.resolve(t),l=e.posix.resolve(l),t===l))return"";const r=1,o=t.length,n=o-r,m=1,s=l.length-m,i=n<s?n:s;let c=-1,w=0;for(;w<i;w++){const F=t.charCodeAt(r+w);if(F!==l.charCodeAt(m+w))break;F===y&&(c=w)}if(w===i)if(s>i){if(l.charCodeAt(m+w)===y)return l.slice(m+w+1);if(w===0)return l.slice(m+w)}else n>i&&(t.charCodeAt(r+w)===y?c=w:w===0&&(c=0));let D="";for(w=r+c+1;w<=o;++w)(w===o||t.charCodeAt(w)===y)&&(D+=D.length===0?"..":"/..");return`${D}${l.slice(m+c)}`},toNamespacedPath(t){return t},dirname(t){if(E(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===y;let r=-1,o=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===y){if(!o){r=n;break}}else o=!1;return r===-1?l?"/":".":l&&r===1?"//":t.slice(0,r)},basename(t,l){l!==void 0&&E(l,"ext"),E(t,"path");let r=0,o=-1,n=!0,m;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let s=l.length-1,i=-1;for(m=t.length-1;m>=0;--m){const c=t.charCodeAt(m);if(c===y){if(!n){r=m+1;break}}else i===-1&&(n=!1,i=m+1),s>=0&&(c===l.charCodeAt(s)?--s===-1&&(o=m):(s=-1,o=i))}return r===o?o=i:o===-1&&(o=t.length),t.slice(r,o)}for(m=t.length-1;m>=0;--m)if(t.charCodeAt(m)===y){if(!n){r=m+1;break}}else o===-1&&(n=!1,o=m+1);return o===-1?"":t.slice(r,o)},extname(t){E(t,"path");let l=-1,r=0,o=-1,n=!0,m=0;for(let s=t.length-1;s>=0;--s){const i=t.charCodeAt(s);if(i===y){if(!n){r=s+1;break}continue}o===-1&&(n=!1,o=s+1),i===A?l===-1?l=s:m!==1&&(m=1):l!==-1&&(m=-1)}return l===-1||o===-1||m===0||m===1&&l===o-1&&l===r+1?"":t.slice(l,o)},format:S.bind(null,"/"),parse(t){E(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.charCodeAt(0)===y;let o;r?(l.root="/",o=1):o=0;let n=-1,m=0,s=-1,i=!0,c=t.length-1,w=0;for(;c>=o;--c){const D=t.charCodeAt(c);if(D===y){if(!i){m=c+1;break}continue}s===-1&&(i=!1,s=c+1),D===A?n===-1?n=c:w!==1&&(w=1):n!==-1&&(w=-1)}if(s!==-1){const D=m===0&&r?1:m;n===-1||w===0||w===1&&n===s-1&&n===m+1?l.base=l.name=t.slice(D,s):(l.name=t.slice(D,n),l.base=t.slice(D,s),l.ext=t.slice(n,s))}return m>0?l.dir=t.slice(0,m-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h?e.win32.normalize:e.posix.normalize,e.isAbsolute=h?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h?e.win32.join:e.posix.join,e.resolve=h?e.win32.resolve:e.posix.resolve,e.relative=h?e.win32.relative:e.posix.relative,e.dirname=h?e.win32.dirname:e.posix.dirname,e.basename=h?e.win32.basename:e.posix.basename,e.extname=h?e.win32.extname:e.posix.extname,e.format=h?e.win32.format:e.posix.format,e.parse=h?e.win32.parse:e.posix.parse,e.toNamespacedPath=h?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h?e.win32.sep:e.posix.sep,e.delimiter=h?e.win32.delimiter:e.posix.delimiter}),define(ye[108],De([1,0,65,10]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new a.Lazy(()=>{const i=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:i,collatorIsNumeric:i.resolvedOptions().numeric}}),u=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(i,c,w=!1){const D=i||"",F=c||"",x=T.value.collator.compare(D,F);return T.value.collatorIsNumeric&&x===0&&D!==F?D<F?-1:1:x}e.compareFileNames=A;function y(i,c){const w=u.value.collator;return i=i||"",c=c||"",S(w,i,c)}e.compareFileNamesDefault=y;function I(i,c){const w=u.value.collator;return i=i||"",c=c||"",r(i,c)||S(w,i,c)}e.compareFileNamesUpper=I;function L(i,c){const w=u.value.collator;return i=i||"",c=c||"",l(i,c)||S(w,i,c)}e.compareFileNamesLower=L;function k(i,c){return i=i||"",c=c||"",i===c?0:i<c?-1:1}e.compareFileNamesUnicode=k;function v(i,c){const[w,D]=p(i),[F,x]=p(c);let q=T.value.collator.compare(D,x);if(q===0){if(T.value.collatorIsNumeric&&D!==x)return D<x?-1:1;if(q=T.value.collator.compare(w,F),T.value.collatorIsNumeric&&q===0&&w!==F)return w<F?-1:1}return q}e.compareFileExtensions=v;function P(i,c){i=i||"",c=c||"";const w=b(i),D=b(c),F=u.value.collator,x=C.value.collator;return S(x,w,D)||S(F,i,c)}e.compareFileExtensionsDefault=P;function E(i,c){i=i||"",c=c||"";const w=b(i),D=b(c),F=u.value.collator,x=C.value.collator;return S(x,w,D)||r(i,c)||S(F,i,c)}e.compareFileExtensionsUpper=E;function h(i,c){i=i||"",c=c||"";const w=b(i),D=b(c),F=u.value.collator,x=C.value.collator;return S(x,w,D)||l(i,c)||S(F,i,c)}e.compareFileExtensionsLower=h;function d(i,c){i=i||"",c=c||"";const w=b(i).toLowerCase(),D=b(c).toLowerCase();return w!==D?w<D?-1:1:i!==c?i<c?-1:1:0}e.compareFileExtensionsUnicode=d;const f=/^(.*?)(\.([^.]*))?$/;function p(i,c=!1){const w=i?f.exec(i):[];let D=[w&&w[1]||"",w&&w[3]||""];return c&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function b(i){const c=i?f.exec(i):[];return c&&c[1]&&c[1].charAt(0)!=="."&&c[3]||""}function S(i,c,w){const D=i.compare(c,w);return D!==0?D:c.length!==w.length?c.length<w.length?-1:1:0}function g(i){const c=i.charAt(0);return c.toLocaleUpperCase()!==c}function t(i){const c=i.charAt(0);return c.toLocaleLowerCase()!==c}function l(i,c){return g(i)&&t(c)?-1:t(i)&&g(c)?1:0}function r(i,c){return t(i)&&g(c)?-1:g(i)&&t(c)?1:0}function o(i,c,w=!1){return w||(i=i&&i.toLowerCase(),c=c&&c.toLowerCase()),i===c?0:i<c?-1:1}function n(i,c,w=!1){const D=i.split(R.sep),F=c.split(R.sep),x=D.length-1,q=F.length-1;let M,B;for(let O=0;;O++){if(M=x===O,B=q===O,M&&B)return A(D[O],F[O],w);if(M)return-1;if(B)return 1;const U=o(D[O],F[O],w);if(U!==0)return U}}e.comparePaths=n;function m(i,c,w){const D=i.toLowerCase(),F=c.toLowerCase(),x=s(i,c,w);if(x)return x;const q=D.endsWith(w),M=F.endsWith(w);if(q!==M)return q?-1:1;const B=A(D,F);return B!==0?B:D.localeCompare(F)}e.compareAnything=m;function s(i,c,w){const D=i.toLowerCase(),F=c.toLowerCase(),x=D.startsWith(w),q=F.startsWith(w);if(x!==q)return x?-1:1;if(x&&q){if(D.length<F.length)return-1;if(D.length>F.length)return 1}return 0}e.compareByPrefix=s}),define(ye[86],De([1,0,10]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function u(L){const k=(0,a.extname)(L),v=R[k.toLowerCase()];return v!==void 0?v:C(L)}e.getMediaOrTextMime=u;function C(L){const k=(0,a.extname)(L);return T[k.toLowerCase()]}e.getMediaMime=C;function A(L){for(const k in T)if(T[k]===L)return k}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function I(L,k){const v=y.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:k?void 0:L}e.normalizeMimeType=I}),define(ye[109],De([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var T;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function u(A,...y){const I=y.reduce((v,P)=>(v[P]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(v=>!I[v]).forEach(v=>{for(let P=0;P<L.length;P++)if(v.search(L[P])!==-1){delete A[v];break}})}e.sanitizeProcessEnvironment=u;function C(A){!A||(delete A.DEBUG,a.isMacintosh&&delete A.DYLD_LIBRARY_PATH,a.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(ye[43],De([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=a.globals.performance&&typeof a.globals.performance.now=="function";class T{static create(C=!0){return new T(C)}constructor(C){this.a=R&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ye[3],De([1,0,11,63,6,66,43]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,y=!1;var I;(function(m){m.None=()=>T.Disposable.None;function s(Ee){if(y){const{onDidAddListener:Pe}=Ee,Fe=E.create();let se=0;Ee.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Fe.print()),Pe?.()}}}function i(Ee,Pe){return O(Ee,()=>{},0,void 0,void 0,Pe)}m.defer=i;function c(Ee){return(Pe,Fe=null,se)=>{let oe=!1,fe;return fe=Ee(Z=>{if(!oe)return fe?fe.dispose():oe=!0,Pe.call(Fe,Z)},null,se),oe&&fe.dispose(),fe}}m.once=c;function w(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>se.call(oe,Pe(Z)),null,fe),Fe)}m.map=w;function D(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>{Pe(Z),se.call(oe,Z)},null,fe),Fe)}m.forEach=D;function F(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>Pe(Z)&&se.call(oe,Z),null,fe),Fe)}m.filter=F;function x(Ee){return Ee}m.signal=x;function q(...Ee){return(Pe,Fe=null,se)=>(0,T.combinedDisposable)(...Ee.map(oe=>oe(fe=>Pe.call(Fe,fe),null,se)))}m.any=q;function M(Ee,Pe,Fe,se){let oe=Fe;return w(Ee,fe=>(oe=Pe(oe,fe),oe),se)}m.reduce=M;function B(Ee,Pe){let Fe;const se={onWillAddFirstListener(){Fe=Ee(oe.fire,oe)},onDidRemoveLastListener(){Fe?.dispose()}};Pe||s(se);const oe=new d(se);return Pe?.add(oe),oe.event}function O(Ee,Pe,Fe=100,se=!1,oe,fe){let Z,ce,ne,N=0;const H={leakWarningThreshold:oe,onWillAddFirstListener(){Z=Ee(Y=>{N++,ce=Pe(ce,Y),se&&!ne&&(Q.fire(ce),ce=void 0),clearTimeout(ne),ne=setTimeout(()=>{const he=ce;ce=void 0,ne=void 0,(!se||N>1)&&Q.fire(he),N=0},Fe)})},onDidRemoveLastListener(){Z.dispose()}};fe||s(H);const Q=new d(H);return fe?.add(Q),Q.event}m.debounce=O;function U(Ee,Pe=0,Fe){return m.debounce(Ee,(se,oe)=>se?(se.push(oe),se):[oe],Pe,void 0,void 0,Fe)}m.accumulate=U;function z(Ee,Pe=(se,oe)=>se===oe,Fe){let se=!0,oe;return F(Ee,fe=>{const Z=se||!Pe(fe,oe);return se=!1,oe=fe,Z},Fe)}m.latch=z;function j(Ee,Pe,Fe){return[m.filter(Ee,Pe,Fe),m.filter(Ee,se=>!Pe(se),Fe)]}m.split=j;function le(Ee,Pe=!1,Fe=[]){let se=Fe.slice(),oe=Ee(ce=>{se?se.push(ce):Z.fire(ce)});const fe=()=>{se?.forEach(ce=>Z.fire(ce)),se=null},Z=new d({onWillAddFirstListener(){oe||(oe=Ee(ce=>Z.fire(ce)))},onDidAddFirstListener(){se&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){oe&&oe.dispose(),oe=null}});return Z.event}m.buffer=le;class V{constructor(Pe){this.event=Pe,this.c=new T.DisposableStore}map(Pe){return new V(w(this.event,Pe,this.c))}forEach(Pe){return new V(D(this.event,Pe,this.c))}filter(Pe){return new V(F(this.event,Pe,this.c))}reduce(Pe,Fe){return new V(M(this.event,Pe,Fe,this.c))}latch(){return new V(z(this.event,void 0,this.c))}debounce(Pe,Fe=100,se=!1,oe){return new V(O(this.event,Pe,Fe,se,oe,this.c))}on(Pe,Fe,se){return this.event(Pe,Fe,se)}once(Pe,Fe,se){return c(this.event)(Pe,Fe,se)}dispose(){this.c.dispose()}}function _(Ee){return new V(Ee)}m.chain=_;function J(Ee,Pe,Fe=se=>se){const se=(...ce)=>Z.fire(Fe(...ce)),oe=()=>Ee.on(Pe,se),fe=()=>Ee.removeListener(Pe,se),Z=new d({onWillAddFirstListener:oe,onDidRemoveLastListener:fe});return Z.event}m.fromNodeEventEmitter=J;function ie(Ee,Pe,Fe=se=>se){const se=(...ce)=>Z.fire(Fe(...ce)),oe=()=>Ee.addEventListener(Pe,se),fe=()=>Ee.removeEventListener(Pe,se),Z=new d({onWillAddFirstListener:oe,onDidRemoveLastListener:fe});return Z.event}m.fromDOMEventEmitter=ie;function ee(Ee){return new Promise(Pe=>c(Ee)(Pe))}m.toPromise=ee;function K(Ee,Pe){return Pe(void 0),Ee(Fe=>Pe(Fe))}m.runAndSubscribe=K;function G(Ee,Pe){let Fe=null;function se(fe){Fe?.dispose(),Fe=new T.DisposableStore,Pe(fe,Fe)}se(void 0);const oe=Ee(fe=>se(fe));return(0,T.toDisposable)(()=>{oe.dispose(),Fe?.dispose()})}m.runAndSubscribeWithStore=G;class de{constructor(Pe,Fe){this.obs=Pe,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Fe||s(se),this.emitter=new d(se),Fe&&Fe.add(this.emitter)}beginUpdate(Pe){this.c++}handleChange(Pe,Fe){this.d=!0}endUpdate(Pe){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function be(Ee,Pe){return new de(Ee,Pe).emitter.event}m.fromObservable=be})(I=e.Event||(e.Event={}));class L{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${L.c++}`,L.all.add(this)}start(s){this.d=new C.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=L,L.all=new Set,L.c=0;let k=-1;function v(m){const s=k;return k=m,{dispose(){k=s}}}e.setGlobalLeakWarningThreshold=v;class P{constructor(s,i=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=i,this.d=0}dispose(){this.c?.clear()}check(s,i){const c=this.threshold;if(c<=0||i<c)return;this.c||(this.c=new Map);const w=this.c.get(s.value)||0;if(this.c.set(s.value,w+1),this.d-=1,this.d<=0){this.d=c*.5;let D,F=0;for(const[x,q]of this.c)(!D||F<q)&&(D=x,F=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${F}):`),console.warn(D)}return()=>{const D=this.c.get(s.value)||0;this.c.set(s.value,D-1)}}}class E{static create(){return new E(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(s,i,c){this.callback=s,this.callbackThis=i,this.stack=c,this.subscription=new T.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class d{constructor(s){this.j=!1,this.d=s,this.f=k>0||this.d?.leakWarningThreshold?new P(this.d?.leakWarningThreshold??k):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const s=Array.from(this.q);queueMicrotask(()=>{for(const i of s)i.subscription.isset()&&(i.subscription.unset(),i.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,i,c)=>{if(this.q||(this.q=new u.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),T.Disposable.None;const w=this.q.isEmpty();w&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let D,F;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(F=E.create(),D=this.f.check(F,this.q.size+1)),A&&(F=F??E.create());const x=new h(s,i,F),q=this.q.push(x);w&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,i);const M=x.subscription.set(()=>{D?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return c instanceof T.DisposableStore?c.add(M):Array.isArray(c)&&c.push(M),M}),this.l}fire(s){if(this.q){this.m||(this.m=new p);for(const i of this.q)this.m.push(this,i,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=d;class f{constructor(){this.c=new u.LinkedList}get size(){return this.c.size}push(s,i,c){this.c.push(new b(s,i,c))}clear(s){const i=new u.LinkedList;for(const c of this.c)c.emitter!==s&&i.push(c);this.c=i}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(i){(0,a.onUnexpectedError)(i)}}}}e.EventDeliveryQueue=f;class p extends f{clear(s){this.c.clear()}}class b{constructor(s,i,c){this.emitter=s,this.listener=i,this.event=c}}class S extends d{async fireAsync(s,i,c){if(!!this.q){this.c||(this.c=new u.LinkedList);for(const w of this.q)this.c.push([w,s]);for(;this.c.size>0&&!i.isCancellationRequested;){const[w,D]=this.c.shift(),F=[],x={...D,token:i,waitUntil:q=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");c&&(q=c(q,w.callback)),F.push(q)}};try{w.invoke(x)}catch(q){(0,a.onUnexpectedError)(q);continue}Object.freeze(F),await Promise.allSettled(F).then(q=>{for(const M of q)M.status==="rejected"&&(0,a.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=S;class g extends d{constructor(s){super(s),this.h=0,this.s=new u.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=g;class t extends g{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=t;class l extends d{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(i=>super.fire(i)),this.c=[]}))}}e.MicrotaskEmitter=l;class r{constructor(){this.d=!1,this.f=[],this.c=new d({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const i={event:s,listener:null};this.f.push(i),this.d&&this.j(i);const c=()=>{this.d&&this.k(i);const w=this.f.indexOf(i);this.f.splice(w,1)};return(0,T.toDisposable)((0,R.once)(c))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(i=>this.c.fire(i))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.c=[]}wrapEvent(s){return(i,c,w)=>s(D=>{const F=this.c[this.c.length-1];F?F.push(()=>i.call(c,D)):i.call(c,D)},void 0,w)}bufferEvents(s){const i=[];this.c.push(i);const c=s();return this.c.pop(),i.forEach(w=>w()),c}}e.EventBufferer=o;class n{constructor(){this.c=!1,this.d=I.None,this.f=T.Disposable.None,this.g=new d({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=n}),define(ye[160],De([1,0,3,6,155]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class u extends R.Disposable{constructor(v,P="",E="",h=!0,d){super(),this.h=this.B(new a.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=P,this.u=E,this.w=h,this.C=d}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,P){this.C&&await this.C(v)}}e.Action=u;class C extends R.Disposable{constructor(){super(...arguments),this.f=this.B(new a.Emitter),this.onWillRun=this.f.event,this.h=this.B(new a.Emitter),this.onDidRun=this.h.event}async run(v,P){if(!v.enabled)return;this.f.fire({action:v});let E;try{await this.runAction(v,P)}catch(h){E=h}this.h.fire({action:v,error:E})}async runAction(v,P){await v.run(P)}}e.ActionRunner=C;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let P=[];for(const E of v)E.length&&(P.length?P=[...P,new A,...E]:P=E);return P}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(v,P,E,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=P,this.class=h,this.a=E}async run(){}}e.SubmenuAction=y;class I extends u{constructor(){super(I.ID,T.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=I,I.ID="vs.actions.empty";function L(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=L}),define(ye[21],De([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(A,y){const I=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(I)}}});var T;(function(A){function y(I){return I===A.None||I===A.Cancelled||I instanceof u?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(T=e.CancellationToken||(e.CancellationToken={}));class u{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new u),this.a}cancel(){this.a?this.a instanceof u&&this.a.cancel():this.a=T.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof u&&this.a.dispose():this.a=T.None}}e.CancellationTokenSource=C}),define(ye[161],De([1,0,21]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class R{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new a.CancellationTokenSource,y=this.b(A.token);return this.a={promise:y,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=R;class T{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const y=JSON.stringify(A);return this.b!==y&&(this.b=y,this.a=this.c(A)),this.a}}e.LRUCachedFunction=T;class u{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const y=this.b(A);return this.a.set(A,y),y}}e.CachedFunction=u}),define(ye[8],De([1,0,161,65]),function(te,e,a,R){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function u($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=u;const C=/{(\d+)}/g;function A($,...ue){return ue.length===0?$:$.replace(C,function(Ie,Le){const $e=parseInt(Le,10);return isNaN($e)||$e<0||$e>=ue.length?Ie:ue[$e]})}e.format=A;const y=/{([^}]+)}/g;function I($,ue){return $.replace(y,(Ie,Le)=>ue[Le]??Ie)}e.format2=I;function L($){return $.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=L;function k($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function v($,ue){let Ie=0;const Le=ue.charCodeAt(0);for(let $e=$.length-1;$e>=0;$e--)$.charCodeAt($e)===Le&&Ie++;return Ie}e.count=v;function P($,ue,Ie="\u2026"){return $.length<=ue?$:`${$.substr(0,ue)}${Ie}`}e.truncate=P;function E($,ue=" "){const Ie=h($,ue);return d(Ie,ue)}e.trim=E;function h($,ue){if(!$||!ue)return $;const Ie=ue.length;if(Ie===0||$.length===0)return $;let Le=0;for(;$.indexOf(ue,Le)===Le;)Le=Le+Ie;return $.substring(Le)}e.ltrim=h;function d($,ue){if(!$||!ue)return $;const Ie=ue.length,Le=$.length;if(Ie===0||Le===0)return $;let $e=Le,Ke=-1;for(;Ke=$.lastIndexOf(ue,$e-1),!(Ke===-1||Ke+Ie!==$e);){if(Ke===0)return"";$e=Ke}return $.substring(0,$e)}e.rtrim=d;function f($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function p($){return $.replace(/\*/g,"")}e.stripWildcards=p;function b($,ue,Ie={}){if(!$)throw new Error("Cannot create regex from empty string");ue||($=k($)),Ie.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=b;function S($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function g($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function t($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=t;function l($){return $.split(/\r\n|\r|\n/)}e.splitLines=l;function r($){for(let ue=0,Ie=$.length;ue<Ie;ue++){const Le=$.charCodeAt(ue);if(Le!==32&&Le!==9)return ue}return-1}e.firstNonWhitespaceIndex=r;function o($,ue=0,Ie=$.length){for(let Le=ue;Le<Ie;Le++){const $e=$.charCodeAt(Le);if($e!==32&&$e!==9)return $.substring(ue,Le)}return $.substring(ue,Ie)}e.getLeadingWhitespace=o;function n($,ue=$.length-1){for(let Ie=ue;Ie>=0;Ie--){const Le=$.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=n;function m($,ue,Ie){const Le=[];let $e=0;for(const Ke of $.matchAll(ue)){if(Le.push($.slice($e,Ke.index)),Ke.index===void 0)throw new Error("match.index should be defined");$e=Ke.index+Ke[0].length,Le.push(Ie(Ke[0],...Ke.slice(1),Ke.index,$,Ke.groups))}return Le.push($.slice($e)),Promise.all(Le).then(Ke=>Ke.join(""))}e.replaceAsync=m;function s($,ue){return $<ue?-1:$>ue?1:0}e.compare=s;function i($,ue,Ie=0,Le=$.length,$e=0,Ke=ue.length){for(;Ie<Le&&$e<Ke;Ie++,$e++){const gt=$.charCodeAt(Ie),ct=ue.charCodeAt($e);if(gt<ct)return-1;if(gt>ct)return 1}const Ze=Le-Ie,pt=Ke-$e;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstring=i;function c($,ue){return w($,ue,0,$.length,0,ue.length)}e.compareIgnoreCase=c;function w($,ue,Ie=0,Le=$.length,$e=0,Ke=ue.length){for(;Ie<Le&&$e<Ke;Ie++,$e++){let gt=$.charCodeAt(Ie),ct=ue.charCodeAt($e);if(gt===ct)continue;if(gt>=128||ct>=128)return i($.toLowerCase(),ue.toLowerCase(),Ie,Le,$e,Ke);F(gt)&&(gt-=32),F(ct)&&(ct-=32);const Et=gt-ct;if(Et!==0)return Et}const Ze=Le-Ie,pt=Ke-$e;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstringIgnoreCase=w;function D($){return $>=48&&$<=57}e.isAsciiDigit=D;function F($){return $>=97&&$<=122}e.isLowerAsciiLetter=F;function x($){return $>=65&&$<=90}e.isUpperAsciiLetter=x;function q($,ue){return $.length===ue.length&&w($,ue)===0}e.equalsIgnoreCase=q;function M($,ue){const Ie=ue.length;return ue.length>$.length?!1:w($,ue,0,Ie)===0}e.startsWithIgnoreCase=M;function B($,ue){const Ie=Math.min($.length,ue.length);let Le;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Le)!==ue.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=B;function O($,ue){const Ie=Math.min($.length,ue.length);let Le;const $e=$.length-1,Ke=ue.length-1;for(Le=0;Le<Ie;Le++)if($.charCodeAt($e-Le)!==ue.charCodeAt(Ke-Le))return Le;return Ie}e.commonSuffixLength=O;function U($){return 55296<=$&&$<=56319}e.isHighSurrogate=U;function z($){return 56320<=$&&$<=57343}e.isLowSurrogate=z;function j($,ue){return($-55296<<10)+(ue-56320)+65536}e.computeCodePoint=j;function le($,ue,Ie){const Le=$.charCodeAt(Ie);if(U(Le)&&Ie+1<ue){const $e=$.charCodeAt(Ie+1);if(z($e))return j(Le,$e)}return Le}e.getNextCodePoint=le;function V($,ue){const Ie=$.charCodeAt(ue-1);if(z(Ie)&&ue>1){const Le=$.charCodeAt(ue-2);if(U(Le))return j(Le,Ie)}return Ie}class _{get offset(){return this.e}constructor(ue,Ie=0){this.c=ue,this.d=ue.length,this.e=Ie}setOffset(ue){this.e=ue}prevCodePoint(){const ue=V(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=le(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=_;class J{get offset(){return this.c.offset}constructor(ue,Ie=0){this.c=new _(ue,Ie)}nextGraphemeLength(){const ue=et.getInstance(),Ie=this.c,Le=Ie.offset;let $e=ue.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const Ke=Ie.offset,Ze=ue.getGraphemeBreakType(Ie.nextCodePoint());if(Ve($e,Ze)){Ie.setOffset(Ke);break}$e=Ze}return Ie.offset-Le}prevGraphemeLength(){const ue=et.getInstance(),Ie=this.c,Le=Ie.offset;let $e=ue.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const Ke=Ie.offset,Ze=ue.getGraphemeBreakType(Ie.prevCodePoint());if(Ve(Ze,$e)){Ie.setOffset(Ke);break}$e=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function ie($,ue){return new J($,ue).nextGraphemeLength()}e.nextCharLength=ie;function ee($,ue){return new J($,ue).prevGraphemeLength()}e.prevCharLength=ee;function K($,ue){ue>0&&z($.charCodeAt(ue))&&ue--;const Ie=ue+ie($,ue);return[Ie-ee($,Ie),Ie]}e.getCharContainingOffset=K;function G($){const ue=new J($);let Ie=0;for(;!ue.eol();)Ie++,ue.nextGraphemeLength();return Ie}e.charCount=G;let de;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ee($){return de||(de=be()),de.test($)}e.containsRTL=Ee;const Pe=/^[\t\n\r\x20-\x7E]*$/;function Fe($){return Pe.test($)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=se;function oe($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=oe;function fe($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=fe;function Z($,ue){if($.length<ue)return $;const Ie=/\b/g;let Le=0;for(;Ie.test($)&&!($.length-Ie.lastIndex<ue);)Le=Ie.lastIndex,Ie.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=Z;const ce=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,N=/\x1b\[0?m/g;function H($){return $&&($=$.replace(ce,""),$=$.replace(ne,""),$=$.replace(N,"")),$}e.removeAnsiEscapeCodes=H,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Q;function Y($){return Q($)?$.substr(1):$}e.stripUTF8BOM=Y;function he($,ue){if(!$||!ue||$.length<ue.length)return!1;const Ie=ue.length,Le=$.toLowerCase();let $e=0,Ke=-1;for(;$e<Ie;){const Ze=Le.indexOf(ue[$e],Ke+1);if(Ze<0)return!1;Ke=Ze,$e++}return!0}e.fuzzyContains=he;function ve($,ue=!1){return $?(ue&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=ve;function Ae($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=Ae;function pe($,ue=1){if(ue===0)return"";let Ie=-1;do Ie=$.indexOf(`
`,Ie+1),ue--;while(ue>0&&Ie>=0);return Ie===-1?$:($[Ie-1]==="\r"&&Ie--,$.substr(0,Ie))}e.getNLines=pe;function Ce($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=Ce;function ke($){return et.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=ke;function Ve($,ue){return $===0?ue!==5&&ue!==7:$===2&&ue===3?!1:$===4||$===2||$===3||ue===4||ue===2||ue===3?!0:!($===8&&(ue===8||ue===9||ue===11||ue===12)||($===11||$===9)&&(ue===9||ue===10)||($===12||$===10)&&ue===10||ue===5||ue===13||ue===7||$===1||$===13&&ue===14||$===6&&ue===6)}var xe;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=Qe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const Ie=this.d,Le=Ie.length/3;let $e=1;for(;$e<=Le;)if(ue<Ie[3*$e])$e=2*$e;else if(ue>Ie[3*$e+1])$e=2*$e+1;else return Ie[3*$e+2];return 0}}et.c=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,ue){if($===0)return 0;const Ie=st($,ue);if(Ie!==void 0)return Ie;const Le=new _(ue,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st($,ue){const Ie=new _(ue,$);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!fe(Le))return;let $e=Ie.offset;return $e>0&&Ie.prevCodePoint()===8205&&($e=Ie.offset),$e}function ht($){return 127995<=$&&$<=127999}var Ue;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),e.noBreakWhitespace="\xA0";class rt{static getInstance(ue){return rt.d.get(Array.from(ue))}static getLocales(){return rt.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=rt,T=rt,rt.c=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),rt.d=new a.LRUCachedFunction($=>{function ue(ct){const Et=new Map;for(let tt=0;tt<ct.length;tt+=2)Et.set(ct[tt],ct[tt+1]);return Et}function Ie(ct,Et){const tt=new Map(ct);for(const[ft,At]of Et)tt.set(ft,At);return tt}function Le(ct,Et){if(!ct)return Et;const tt=new Map;for(const[ft,At]of ct)Et.has(ft)&&tt.set(ft,At);return tt}const $e=T.c.value;let Ke=$.filter(ct=>!ct.startsWith("_")&&ct in $e);Ke.length===0&&(Ke=["_default"]);let Ze;for(const ct of Ke){const Et=ue($e[ct]);Ze=Le(Ze,Et)}const pt=ue($e._common),gt=Ie(pt,Ze);return new rt(gt)}),rt.e=new R.Lazy(()=>Object.keys(rt.c.value).filter($=>!$.startsWith("_")));class ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ae.c())),this.d}static isInvisibleCharacter(ue){return ae.e().has(ue)}static get codePoints(){return ae.e()}}e.InvisibleCharacters=ae,ae.d=void 0}),define(ye[32],De([1,0,10,12,8,9]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(n){return n===47||n===92}e.isPathSeparator=C;function A(n){return n.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=A;function y(n){return n.indexOf("/")===-1&&(n=A(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=y;function I(n,m=a.posix.sep){if(!n)return"";const s=n.length,i=n.charCodeAt(0);if(C(i)){if(C(n.charCodeAt(1))&&!C(n.charCodeAt(2))){let w=3;const D=w;for(;w<s&&!C(n.charCodeAt(w));w++);if(D!==w&&!C(n.charCodeAt(w+1))){for(w+=1;w<s;w++)if(C(n.charCodeAt(w)))return n.slice(0,w+1).replace(/[\\/]/g,m)}}return m}else if(f(i)&&n.charCodeAt(1)===58)return C(n.charCodeAt(2))?n.slice(0,2)+m:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<s;c++)if(C(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=I;function L(n){if(!R.isWindows||!n||n.length<5)return!1;let m=n.charCodeAt(0);if(m!==92||(m=n.charCodeAt(1),m!==92))return!1;let s=2;const i=s;for(;s<n.length&&(m=n.charCodeAt(s),m!==92);s++);return!(i===s||(m=n.charCodeAt(s+1),isNaN(m)||m===92))}e.isUNC=L;const k=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,P=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(n,m=R.isWindows){const s=m?k:v;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||m&&P.test(n)||n==="."||n===".."||m&&n[n.length-1]==="."||m&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=E;function h(n,m,s){const i=n===m;return!s||i?i:!n||!m?!1:(0,T.equalsIgnoreCase)(n,m)}e.isEqual=h;function d(n,m,s,i=a.sep){if(n===m)return!0;if(!n||!m||m.length>n.length)return!1;if(s){if(!(0,T.startsWithIgnoreCase)(n,m))return!1;if(m.length===n.length)return!0;let w=m.length;return m.charAt(m.length-1)===i&&w--,n.charAt(w)===i}return m.charAt(m.length-1)!==i&&(m+=i),n.indexOf(m)===0}e.isEqualOrParent=d;function f(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=f;function p(n,m){return R.isWindows&&n.endsWith(":")&&(n+=a.sep),(0,a.isAbsolute)(n)||(n=(0,a.join)(m,n)),n=(0,a.normalize)(n),R.isWindows?(n=(0,T.rtrim)(n,a.sep),n.endsWith(":")&&(n+=a.sep)):(n=(0,T.rtrim)(n,a.sep),n||(n=a.sep)),n}e.sanitizeFilePath=p;function b(n){const m=(0,a.normalize)(n);return R.isWindows?n.length>3?!1:S(m)&&(n.length===2||m.charCodeAt(2)===92):m===a.posix.sep}e.isRootOrDriveLetter=b;function S(n,m=R.isWindows){return m?f(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function g(n){return S(n)?n[0]:void 0}e.getDriveLetter=g;function t(n,m,s){return m.length>n.length?-1:n===m?0:(s&&(n=n.toLowerCase(),m=m.toLowerCase()),n.indexOf(m))}e.indexOfPath=t;function l(n){const m=n.split(":");let s,i,c;for(const w of m){const D=Number(w);(0,u.isNumber)(D)?i===void 0?i=D:c===void 0&&(c=D):s=s?[s,w].join(":"):w}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:i!==void 0?i:void 0,column:c!==void 0?c:i!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(n,m,s=8){let i="";for(let w=0;w<s;w++)i+=r.charAt(Math.floor(Math.random()*r.length));let c;return m?c=`${m}-${i}`:c=i,n?(0,a.join)(n,c):c}e.randomPath=o}),define(ye[110],De([1,0,28,8]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...ne){return function(N,H){for(let Q=0,Y=ne.length;Q<Y;Q++){const he=ne[Q](N,H);if(he)return he}return null}}e.or=T,e.matchesStrictPrefix=u.bind(void 0,!1),e.matchesPrefix=u.bind(void 0,!0);function u(ne,N,H){if(!H||H.length<N.length)return null;let Q;return ne?Q=R.startsWithIgnoreCase(H,N):Q=H.indexOf(N)===0,Q?N.length>0?[{start:0,end:N.length}]:[]:null}function C(ne,N){const H=N.toLowerCase().indexOf(ne.toLowerCase());return H===-1?null:[{start:H,end:H+ne.length}]}e.matchesContiguousSubString=C;function A(ne,N){return y(ne.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=A;function y(ne,N,H,Q){if(H===ne.length)return[];if(Q===N.length)return null;if(ne[H]===N[Q]){let Y=null;return(Y=y(ne,N,H+1,Q+1))?f({start:Q,end:Q+1},Y):null}return y(ne,N,H,Q+1)}function I(ne){return 97<=ne&&ne<=122}function L(ne){return 65<=ne&&ne<=90}e.isUpper=L;function k(ne){return 48<=ne&&ne<=57}function v(ne){return ne===32||ne===9||ne===10||ne===13}const P=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>P.add(ne.charCodeAt(0)));function E(ne){return v(ne)||P.has(ne)}function h(ne,N){return ne===N||E(ne)&&E(N)}function d(ne){return I(ne)||L(ne)||k(ne)}function f(ne,N){return N.length===0?N=[ne]:ne.end===N[0].start?N[0].start=ne.start:N.unshift(ne),N}function p(ne,N){for(let H=N;H<ne.length;H++){const Q=ne.charCodeAt(H);if(L(Q)||k(Q)||H>0&&!d(ne.charCodeAt(H-1)))return H}return ne.length}function b(ne,N,H,Q){if(H===ne.length)return[];if(Q===N.length)return null;if(ne[H]!==N[Q].toLowerCase())return null;{let Y=null,he=Q+1;for(Y=b(ne,N,H+1,Q+1);!Y&&(he=p(N,he))<N.length;)Y=b(ne,N,H+1,he),he++;return Y===null?null:f({start:Q,end:Q+1},Y)}}function S(ne){let N=0,H=0,Q=0,Y=0,he=0;for(let ke=0;ke<ne.length;ke++)he=ne.charCodeAt(ke),L(he)&&N++,I(he)&&H++,d(he)&&Q++,k(he)&&Y++;const ve=N/ne.length,Ae=H/ne.length,pe=Q/ne.length,Ce=Y/ne.length;return{upperPercent:ve,lowerPercent:Ae,alphaPercent:pe,numericPercent:Ce}}function g(ne){const{upperPercent:N,lowerPercent:H}=ne;return H===0&&N>.6}function t(ne){const{upperPercent:N,lowerPercent:H,alphaPercent:Q,numericPercent:Y}=ne;return H>.2&&N<.8&&Q>.6&&Y<.2}function l(ne){let N=0,H=0,Q=0,Y=0;for(let he=0;he<ne.length;he++)Q=ne.charCodeAt(he),L(Q)&&N++,I(Q)&&H++,v(Q)&&Y++;return(N===0||H===0)&&Y===0?ne.length<=30:N<=5}function r(ne,N){if(!N||(N=N.trim(),N.length===0)||!l(ne)||N.length>60)return null;const H=S(N);if(!t(H)){if(!g(H))return null;N=N.toLowerCase()}let Q=null,Y=0;for(ne=ne.toLowerCase();Y<N.length&&(Q=b(ne,N,0,Y))===null;)Y=p(N,Y+1);return Q}e.matchesCamelCase=r;function o(ne,N,H=!1){if(!N||N.length===0)return null;let Q=null,Y=0;for(ne=ne.toLowerCase(),N=N.toLowerCase();Y<N.length&&(Q=n(ne,N,0,Y,H))===null;)Y=m(N,Y+1);return Q}e.matchesWords=o;function n(ne,N,H,Q,Y){if(H===ne.length)return[];if(Q===N.length)return null;if(h(ne.charCodeAt(H),N.charCodeAt(Q))){let he=null,ve=Q+1;if(he=n(ne,N,H+1,Q+1,Y),!Y)for(;!he&&(ve=m(N,ve))<N.length;)he=n(ne,N,H+1,ve,Y),ve++;return he?ne.charCodeAt(H)!==N.charCodeAt(Q)?he:f({start:Q,end:Q+1},he):null}else return null}function m(ne,N){for(let H=N;H<ne.length;H++)if(E(ne.charCodeAt(H))||H>0&&E(ne.charCodeAt(H-1)))return H;return ne.length}const s=T(e.matchesPrefix,r,C),i=T(e.matchesPrefix,r,A),c=new a.LRUCache(1e4);function w(ne,N,H=!1){if(typeof ne!="string"||typeof N!="string")return null;let Q=c.get(ne);Q||(Q=new RegExp(R.convertSimple2RegExpPattern(ne),"i"),c.set(ne,Q));const Y=Q.exec(N);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:H?i(ne,N):s(ne,N)}e.matchesFuzzy=w;function D(ne,N){const H=Pe(ne,ne.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?x(H):null}e.matchesFuzzy2=D;function F(ne,N,H,Q,Y,he){const ve=Math.min(13,ne.length);for(;H<ve;H++){const Ae=Pe(ne,N,H,Q,Y,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,he]}e.anyScore=F;function x(ne){if(typeof ne>"u")return[];const N=[],H=ne[1];for(let Q=ne.length-1;Q>1;Q--){const Y=ne[Q]+H,he=N[N.length-1];he&&he.end===Y?he.end=Y+1:N.push({start:Y,end:Y+1})}return N}e.createMatches=x;const q=128;function M(){const ne=[],N=[];for(let H=0;H<=q;H++)N[H]=0;for(let H=0;H<=q;H++)ne.push(N.slice(0));return ne}function B(ne){const N=[];for(let H=0;H<=ne;H++)N[H]=0;return N}const O=B(2*q),U=B(2*q),z=M(),j=M(),le=M(),V=!1;function _(ne,N,H,Q,Y){function he(Ae,pe,Ce=" "){for(;Ae.length<pe;)Ae=Ce+Ae;return Ae}let ve=` |   |${Q.split("").map(Ae=>he(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=H;Ae++)Ae===0?ve+=" |":ve+=`${N[Ae-1]}|`,ve+=ne[Ae].slice(0,Y+1).map(pe=>he(pe.toString(),3)).join("|")+`
`;return ve}function J(ne,N,H,Q){ne=ne.substr(N),H=H.substr(Q),console.log(_(j,ne,ne.length,H,H.length)),console.log(_(le,ne,ne.length,H,H.length)),console.log(_(z,ne,ne.length,H,H.length))}function ie(ne,N){if(N<0||N>=ne.length)return!1;const H=ne.codePointAt(N);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(H)}}function ee(ne,N){if(N<0||N>=ne.length)return!1;switch(ne.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function K(ne,N,H){return N[ne]!==H[ne]}function G(ne,N,H,Q,Y,he,ve=!1){for(;N<H&&Y<he;)ne[N]===Q[Y]&&(ve&&(O[N]=Y),N+=1),Y+=1;return N===H}e.isPatternInWord=G;var de;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(de||(de={}));var be;(function(ne){ne.Default=[-100,0];function N(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}ne.isDefault=N})(be=e.FuzzyScore||(e.FuzzyScore={}));class Ee{constructor(N,H){this.firstMatchCanBeWeak=N,this.boostFullMatch=H}}e.FuzzyScoreOptions=Ee,Ee.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Pe(ne,N,H,Q,Y,he,ve=Ee.default){const Ae=ne.length>q?q:ne.length,pe=Q.length>q?q:Q.length;if(H>=Ae||he>=pe||Ae-H>pe-he||!G(N,H,Ae,Y,he,pe,!0))return;Fe(Ae,pe,H,he,N,Y);let Ce=1,ke=1,Ve=H,xe=he;const et=[!1];for(Ce=1,Ve=H;Ve<Ae;Ce++,Ve++){const Ue=O[Ve],rt=U[Ve],ae=Ve+1<Ae?U[Ve+1]:pe;for(ke=Ue-he+1,xe=Ue;xe<ae;ke++,xe++){let $=Number.MIN_SAFE_INTEGER,ue=!1;xe<=rt&&($=se(ne,N,Ve,H,Q,Y,xe,pe,he,z[Ce-1][ke-1]===0,et));let Ie=0;$!==Number.MAX_SAFE_INTEGER&&(ue=!0,Ie=$+j[Ce-1][ke-1]);const Le=xe>Ue,$e=Le?j[Ce][ke-1]+(z[Ce][ke-1]>0?-5:0):0,Ke=xe>Ue+1&&z[Ce][ke-1]>0,Ze=Ke?j[Ce][ke-2]+(z[Ce][ke-2]>0?-5:0):0;if(Ke&&(!Le||Ze>=$e)&&(!ue||Ze>=Ie))j[Ce][ke]=Ze,le[Ce][ke]=3,z[Ce][ke]=0;else if(Le&&(!ue||$e>=Ie))j[Ce][ke]=$e,le[Ce][ke]=2,z[Ce][ke]=0;else if(ue)j[Ce][ke]=Ie,le[Ce][ke]=1,z[Ce][ke]=z[Ce-1][ke-1]+1;else throw new Error("not possible")}}if(V&&J(ne,H,Q,he),!et[0]&&!ve.firstMatchCanBeWeak)return;Ce--,ke--;const Qe=[j[Ce][ke],he];let nt=0,st=0;for(;Ce>=1;){let Ue=ke;do{const rt=le[Ce][Ue];if(rt===3)Ue=Ue-2;else if(rt===2)Ue=Ue-1;else break}while(Ue>=1);nt>1&&N[H+Ce-1]===Y[he+ke-1]&&!K(Ue+he-1,Q,Y)&&nt+1>z[Ce][Ue]&&(Ue=ke),Ue===ke?nt++:nt=1,st||(st=Ue),Ce--,ke=Ue-1,Qe.push(ke)}pe===Ae&&ve.boostFullMatch&&(Qe[0]+=2);const ht=st-Ae;return Qe[0]-=ht,Qe}e.fuzzyScore=Pe;function Fe(ne,N,H,Q,Y,he){let ve=ne-1,Ae=N-1;for(;ve>=H&&Ae>=Q;)Y[ve]===he[Ae]&&(U[ve]=Ae,ve--),Ae--}function se(ne,N,H,Q,Y,he,ve,Ae,pe,Ce,ke){if(N[H]!==he[ve])return Number.MIN_SAFE_INTEGER;let Ve=1,xe=!1;return ve===H-Q?Ve=ne[H]===Y[ve]?7:5:K(ve,Y,he)&&(ve===0||!K(ve-1,Y,he))?(Ve=ne[H]===Y[ve]?7:5,xe=!0):ie(he,ve)&&(ve===0||!ie(he,ve-1))?Ve=5:(ie(he,ve-1)||ee(he,ve-1))&&(Ve=5,xe=!0),Ve>1&&H===Q&&(ke[0]=!0),xe||(xe=K(ve,Y,he)||ie(he,ve-1)||ee(he,ve-1)),H===Q?ve>pe&&(Ve-=xe?3:5):Ce?Ve+=xe?2:0:Ve+=xe?0:1,ve+1===Ae&&(Ve-=xe?3:5),Ve}function oe(ne,N,H,Q,Y,he,ve){return Z(ne,N,H,Q,Y,he,!0,ve)}e.fuzzyScoreGracefulAggressive=oe;function fe(ne,N,H,Q,Y,he,ve){return Z(ne,N,H,Q,Y,he,!1,ve)}e.fuzzyScoreGraceful=fe;function Z(ne,N,H,Q,Y,he,ve,Ae){let pe=Pe(ne,N,H,Q,Y,he,Ae);if(pe&&!ve)return pe;if(ne.length>=3){const Ce=Math.min(7,ne.length-1);for(let ke=H+1;ke<Ce;ke++){const Ve=ce(ne,ke);if(Ve){const xe=Pe(Ve,Ve.toLowerCase(),H,Q,Y,he,Ae);xe&&(xe[0]-=3,(!pe||xe[0]>pe[0])&&(pe=xe))}}}return pe}function ce(ne,N){if(N+1>=ne.length)return;const H=ne[N],Q=ne[N+1];if(H!==Q)return ne.slice(0,N)+Q+H+ne.slice(N+2)}}),define(ye[87],De([1,0,8]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(f){return T(f,0)}e.hash=R;function T(f,p){switch(typeof f){case"object":return f===null?u(349,p):Array.isArray(f)?y(f,p):I(f,p);case"string":return A(f,p);case"boolean":return C(f,p);case"number":return u(f,p);case"undefined":return u(937,p);default:return u(617,p)}}e.doHash=T;function u(f,p){return(p<<5)-p+f|0}e.numberHash=u;function C(f,p){return u(f?433:863,p)}function A(f,p){p=u(149417,p);for(let b=0,S=f.length;b<S;b++)p=u(f.charCodeAt(b),p);return p}e.stringHash=A;function y(f,p){return p=u(104579,p),f.reduce((b,S)=>T(S,b),p)}function I(f,p){return p=u(181387,p),Object.keys(f).sort().reduce((b,S)=>(b=A(S,b),T(f[S],b)),p)}class L{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=T(p,this.g),this.g}}e.Hasher=L;var k;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function v(f,p,b=32){const S=b-p,g=~((1<<S)-1);return(f<<p|(g&f)>>>S)>>>0}function P(f,p=0,b=f.byteLength,S=0){for(let g=0;g<b;g++)f[p+g]=S}function E(f,p,b="0"){for(;f.length<p;)f=b+f;return f}function h(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(b=>b.toString(16).padStart(2,"0")).join(""):E((f>>>0).toString(16),p/4)}e.toHexString=h;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const b=p.length;if(b===0)return;const S=this.p;let g=this.r,t=this.u,l,r;for(t!==0?(l=t,r=-1,t=0):(l=p.charCodeAt(0),r=0);;){let o=l;if(a.isHighSurrogate(l))if(r+1<b){const n=p.charCodeAt(r+1);a.isLowSurrogate(n)?(r++,o=a.computeCodePoint(l,n)):o=65533}else{t=l;break}else a.isLowSurrogate(l)&&(o=65533);if(g=this.w(S,g,o),r++,r<b)l=p.charCodeAt(r);else break}this.r=g,this.u=t}w(p,b,S){return S<128?p[b++]=S:S<2048?(p[b++]=192|(S&1984)>>>6,p[b++]=128|(S&63)>>>0):S<65536?(p[b++]=224|(S&61440)>>>12,p[b++]=128|(S&4032)>>>6,p[b++]=128|(S&63)>>>0):(p[b++]=240|(S&1835008)>>>18,p[b++]=128|(S&258048)>>>12,p[b++]=128|(S&4032)>>>6,p[b++]=128|(S&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=d.g,b=this.q;for(let s=0;s<64;s+=4)p.setUint32(s,b.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)p.setUint32(s,v(p.getUint32(s-12,!1)^p.getUint32(s-32,!1)^p.getUint32(s-56,!1)^p.getUint32(s-64,!1),1),!1);let S=this.h,g=this.l,t=this.m,l=this.n,r=this.o,o,n,m;for(let s=0;s<80;s++)s<20?(o=g&t|~g&l,n=1518500249):s<40?(o=g^t^l,n=1859775393):s<60?(o=g&t|g&l|t&l,n=2400959708):(o=g^t^l,n=3395469782),m=v(S,5)+o+r+n+p.getUint32(s*4,!1)&4294967295,r=l,l=t,t=v(g,30),g=S,S=m;this.h=this.h+S&4294967295,this.l=this.l+g&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+r&4294967295}}e.StringSHA1=d,d.g=new DataView(new ArrayBuffer(320))}),define(ye[111],De([1,0,108,110,87,10,12,8]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,I=[y,[]];function L(z,j,le,V){if(!z||!j)return I;const _=z.length,J=j.length;if(_<J)return I;const ie=z.toLowerCase();return k(j,le,J,z,ie,_,V)}e.scoreFuzzy=L;function k(z,j,le,V,_,J,ie){const ee=[],K=[];for(let Ee=0;Ee<le;Ee++){const Pe=Ee*J,Fe=Pe-J,se=Ee>0,oe=z[Ee],fe=j[Ee];for(let Z=0;Z<J;Z++){const ce=Z>0,ne=Pe+Z,N=ne-1,H=Fe+Z-1,Q=ce?ee[N]:0,Y=se&&ce?ee[H]:0,he=se&&ce?K[H]:0;let ve;!Y&&se?ve=0:ve=v(oe,fe,V,_,Z,he),ve&&Y+ve>=Q&&(ie||se||_.startsWith(j,Z))?(K[ne]=he+1,ee[ne]=Y+ve):(K[ne]=y,ee[ne]=Q)}}const G=[];let de=le-1,be=J-1;for(;de>=0&&be>=0;){const Ee=de*J+be;K[Ee]===y||(G.push(be),de--),be--}return[ee[le*J-1],G.reverse()]}function v(z,j,le,V,_,J){let ie=0;if(!P(j,V[_]))return ie;if(ie+=1,J>0&&(ie+=J*5),z===le[_]&&(ie+=1),_===0)ie+=8;else{const ee=E(le.charCodeAt(_-1));ee?ie+=ee:(0,R.isUpper)(le.charCodeAt(_))&&J===0&&(ie+=2)}return ie}function P(z,j){return z===j?!0:z==="/"||z==="\\"?j==="/"||j==="\\":!1}function E(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function d(z,j,le=0,V=0){const _=j;return _.values&&_.values.length>1?f(z,_.values,le,V):p(z,j,le,V)}e.scoreFuzzy2=d;function f(z,j,le,V){let _=0;const J=[];for(const ie of j){const[ee,K]=p(z,ie,le,V);if(typeof ee!="number")return h;_+=ee,J.push(...K)}return[_,i(J)]}function p(z,j,le,V){const _=(0,R.fuzzyScore)(j.original,j.originalLowercase,le,z,z.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?[_[0],(0,R.createMatches)(_)]:h}const b=Object.freeze({score:0}),S=1<<18,g=1<<17,t=1<<16;function l(z,j,le,V){const _=V.values?V.values:[V];return(0,T.hash)({[V.normalized]:{values:_.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:z,description:j,allowNonContiguousMatches:le}})}function r(z,j,le,V,_){if(!z||!j.normalized)return b;const J=V.getItemLabel(z);if(!J)return b;const ie=V.getItemDescription(z),ee=l(J,ie,le,j),K=_[ee];if(K)return K;const G=o(J,ie,V.getItemPath(z),j,le);return _[ee]=G,G}e.scoreItemFuzzy=r;function o(z,j,le,V,_){const J=!le||!V.containsPathSeparator;return le&&(C.isLinux?V.pathNormalized===le:(0,A.equalsIgnoreCase)(V.pathNormalized,le))?{score:S,labelMatch:[{start:0,end:z.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:V.values&&V.values.length>1?n(z,j,le,V.values,J,_):m(z,j,le,V,J,_)}function n(z,j,le,V,_,J){let ie=0;const ee=[],K=[];for(const G of V){const{score:de,labelMatch:be,descriptionMatch:Ee}=m(z,j,le,G,_,J);if(de===y)return b;ie+=de,be&&ee.push(...be),Ee&&K.push(...Ee)}return{score:ie,labelMatch:i(ee),descriptionMatch:i(K)}}function m(z,j,le,V,_,J){if(_||!j){const[ie,ee]=L(z,V.normalized,V.normalizedLowercase,J&&!V.expectContiguousMatch);if(ie){const K=(0,R.matchesPrefix)(V.normalized,z);let G;return K?(G=g,G+=Math.round(V.normalized.length/z.length*100)):G=t,{score:G+ie,labelMatch:K||s(ee)}}}if(j){let ie=j;le&&(ie=`${j}${u.sep}`);const ee=ie.length,K=`${ie}${z}`,[G,de]=L(K,V.normalized,V.normalizedLowercase,J&&!V.expectContiguousMatch);if(G){const be=s(de),Ee=[],Pe=[];return be.forEach(Fe=>{Fe.start<ee&&Fe.end>ee?(Ee.push({start:0,end:Fe.end-ee}),Pe.push({start:Fe.start,end:ee})):Fe.start>=ee?Ee.push({start:Fe.start-ee,end:Fe.end-ee}):Pe.push(Fe)}),{score:G,labelMatch:Ee,descriptionMatch:Pe}}}return b}function s(z){const j=[];if(!z)return j;let le;for(const V of z)le&&le.end===V?le.end+=1:(le={start:V,end:V+1},j.push(le));return j}function i(z){const j=z.sort((_,J)=>_.start-J.start),le=[];let V;for(const _ of j)!V||!c(V,_)?(V=_,le.push(_)):(V.start=Math.min(V.start,_.start),V.end=Math.max(V.end,_.end));return le}function c(z,j){return!(z.end<j.start||j.end<z.start)}function w(z,j,le,V,_,J){const ie=r(z,le,V,_,J),ee=r(j,le,V,_,J),K=ie.score,G=ee.score;if((K===S||G===S)&&K!==G)return K===S?-1:1;if(K>t||G>t){if(K!==G)return K>G?-1:1;if(K<g&&G<g){const oe=F(ie.labelMatch,ee.labelMatch);if(oe!==0)return oe}const Fe=_.getItemLabel(z)||"",se=_.getItemLabel(j)||"";if(Fe.length!==se.length)return Fe.length-se.length}if(K!==G)return K>G?-1:1;const de=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,be=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(de&&!be)return-1;if(be&&!de)return 1;const Ee=D(z,ie,_),Pe=D(j,ee,_);return Ee&&Pe&&Ee!==Pe?Pe>Ee?-1:1:x(z,j,le,_)}e.compareItemsByFuzzyScore=w;function D(z,j,le){let V=-1,_=-1;if(j.descriptionMatch&&j.descriptionMatch.length?V=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(V=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(_=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const J=le.getItemDescription(z);J&&(_+=J.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(_=j.descriptionMatch[j.descriptionMatch.length-1].end);return _-V}function F(z,j){if(!z&&!j||(!z||!z.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!z||!z.length)return 1;const le=z[0].start,_=z[z.length-1].end-le,J=j[0].start,ee=j[j.length-1].end-J;return _===ee?0:ee<_?1:-1}function x(z,j,le,V){const _=V.getItemLabel(z)||"",J=V.getItemLabel(j)||"",ie=V.getItemDescription(z),ee=V.getItemDescription(j),K=_.length+(ie?ie.length:0),G=J.length+(ee?ee.length:0);if(K!==G)return K-G;const de=V.getItemPath(z),be=V.getItemPath(j);return de&&be&&de.length!==be.length?de.length-be.length:_!==J?(0,a.compareAnything)(_,J,le.normalized):ie&&ee&&ie!==ee?(0,a.compareAnything)(ie,ee,le.normalized):de&&be&&de!==be?(0,a.compareAnything)(de,be,le.normalized):0}function q(z){return z.startsWith('"')&&z.endsWith('"')}const M=" ";function B(z){typeof z!="string"&&(z="");const j=z.toLowerCase(),{pathNormalized:le,normalized:V,normalizedLowercase:_}=O(z),J=le.indexOf(u.sep)>=0,ie=q(z);let ee;const K=z.split(M);if(K.length>1)for(const G of K){const de=q(G),{pathNormalized:be,normalized:Ee,normalizedLowercase:Pe}=O(G);Ee&&(ee||(ee=[]),ee.push({original:G,originalLowercase:G.toLowerCase(),pathNormalized:be,normalized:Ee,normalizedLowercase:Pe,expectContiguousMatch:de}))}return{original:z,originalLowercase:j,pathNormalized:le,normalized:V,normalizedLowercase:_,values:ee,containsPathSeparator:J,expectContiguousMatch:ie}}e.prepareQuery=B;function O(z){let j;C.isWindows?j=z.replace(/\//g,u.sep):j=z.replace(/\\/g,u.sep);const le=(0,A.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:le,normalizedLowercase:le.toLowerCase()}}function U(z){return Array.isArray(z)?B(z.map(j=>j.original).join(M)):B(z.original)}e.pieceToQuery=U}),define(ye[162],De([1,0,110,8,51]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const u="$(",C=new RegExp(`\\$\\(${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${C.source}`,"g");function y(d){return d.replace(A,(f,p)=>p?f:`\\${f}`)}e.escapeIcons=y;const I=new RegExp(`\\\\${C.source}`,"g");function L(d){return d.replace(I,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=L;const k=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function v(d){return d.indexOf(u)===-1?d:d.replace(k,(f,p,b,S)=>b?f:p||S||"")}e.stripIcons=v;const P=new RegExp(`\\$\\(${T.ThemeIcon.iconNameCharacter}+\\)`,"g");function E(d){P.lastIndex=0;let f="";const p=[];let b=0;for(;;){const S=P.lastIndex,g=P.exec(d),t=d.substring(S,g?.index);if(t.length>0){f+=t;for(let l=0;l<t.length;l++)p.push(b)}if(!g)break;b+=g[0].length}return{text:f,iconOffsets:p}}e.parseLabelWithIcons=E;function h(d,f,p=!1){const{text:b,iconOffsets:S}=f;if(!S||S.length===0)return(0,a.matchesFuzzy)(d,b,p);const g=(0,R.ltrim)(b," "),t=b.length-g.length,l=(0,a.matchesFuzzy)(d,g,p);if(l)for(const r of l){const o=S[r.start+t]+t;r.start+=o,r.end+=o}return l}e.matchesFuzzyIconAware=h}),define(ye[37],De([1,0,8]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(R||(R={})),function(T){const u="error",C="warning",A="warn",y="info",I="ignore";function L(v){return v?a.equalsIgnoreCase(u,v)?T.Error:a.equalsIgnoreCase(C,v)||a.equalsIgnoreCase(A,v)?T.Warning:a.equalsIgnoreCase(y,v)?T.Info:T.Ignore:T.Ignore}T.fromValue=L;function k(v){switch(v){case T.Error:return u;case T.Warning:return C;case T.Info:return y;default:return I}}T.toString=k}(R||(R={})),e.default=R}),define(ye[68],De([1,0,15,8]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class T{constructor(){this.b="",this.c=0}reset(P){return this.b=P,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(P){const E=P.charCodeAt(0),h=this.b.charCodeAt(this.c);return E-h}value(){return this.b[this.c]}}e.StringIterator=T;class u{constructor(P=!0){this.e=P}reset(P){return this.b=P,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let P=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(P)this.c++;else break;else P=!1;return this}cmp(P){return this.e?(0,R.compareSubstring)(P,this.b,0,P.length,this.c,this.d):(0,R.compareSubstringIgnoreCase)(P,this.b,0,P.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=u;class C{constructor(P=!0,E=!0){this.f=P,this.g=E}reset(P){this.d=0,this.e=0,this.b=P,this.c=P.length;for(let E=P.length-1;E>=0;E--,this.c--){const h=this.b.charCodeAt(E);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let P=!0;for(;this.e<this.c;this.e++){const E=this.b.charCodeAt(this.e);if(E===47||this.f&&E===92)if(P)this.d++;else break;else P=!1}return this}cmp(P){return this.g?(0,R.compareSubstring)(P,this.b,0,P.length,this.d,this.e):(0,R.compareSubstringIgnoreCase)(P,this.b,0,P.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var A;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(P,E){this.f=P,this.g=E,this.d=[],this.e=0}reset(P){return this.c=P,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(P)),this.b.reset(P.path),this.b.value()&&this.d.push(3)),this.g(P)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(P){if(this.d[this.e]===1)return(0,R.compareIgnoreCase)(P,this.c.scheme);if(this.d[this.e]===2)return(0,R.compareIgnoreCase)(P,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(P);if(this.d[this.e]===4)return(0,R.compare)(P,this.c.query);if(this.d[this.e]===5)return(0,R.compare)(P,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const P=this.right;return this.right=P.left,P.left=this,this.updateHeight(),P.updateHeight(),P}rotateRight(){const P=this.left;return this.left=P.right,P.right=this,this.updateHeight(),P.updateHeight(),P}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class k{static forUris(P=()=>!1,E=()=>!1){return new k(new y(P,E))}static forPaths(P=!1){return new k(new C(void 0,!P))}static forStrings(){return new k(new T)}static forConfigKeys(){return new k(new u)}constructor(P){this.b=P}clear(){this.c=void 0}fill(P,E){if(E){const h=E.slice(0);(0,a.shuffle)(h);for(const d of h)this.set(d,P)}else{const h=P.slice(0);(0,a.shuffle)(h);for(const d of h)this.set(d[0],d[1])}}set(P,E){const h=this.b.reset(P);let d;this.c||(this.c=new I,this.c.segment=h.value());const f=[];for(d=this.c;;){const b=h.cmp(d.segment);if(b>0)d.left||(d.left=new I,d.left.segment=h.value()),f.push([-1,d]),d=d.left;else if(b<0)d.right||(d.right=new I,d.right.segment=h.value()),f.push([1,d]),d=d.right;else if(h.hasNext())h.next(),d.mid||(d.mid=new I,d.mid.segment=h.value()),f.push([0,d]),d=d.mid;else break}const p=d.value;d.value=E,d.key=P;for(let b=f.length-1;b>=0;b--){const S=f[b][1];S.updateHeight();const g=S.balanceFactor();if(g<-1||g>1){const t=f[b][0],l=f[b+1][0];if(t===1&&l===1)f[b][1]=S.rotateLeft();else if(t===-1&&l===-1)f[b][1]=S.rotateRight();else if(t===1&&l===-1)S.right=f[b+1][1]=f[b+1][1].rotateRight(),f[b][1]=S.rotateLeft();else if(t===-1&&l===1)S.left=f[b+1][1]=f[b+1][1].rotateLeft(),f[b][1]=S.rotateRight();else throw new Error;if(b>0)switch(f[b-1][0]){case-1:f[b-1][1].left=f[b][1];break;case 1:f[b-1][1].right=f[b][1];break;case 0:f[b-1][1].mid=f[b][1];break}else this.c=f[0][1]}}return p}get(P){return this.d(P)?.value}d(P){const E=this.b.reset(P);let h=this.c;for(;h;){const d=E.cmp(h.segment);if(d>0)h=h.left;else if(d<0)h=h.right;else if(E.hasNext())E.next(),h=h.mid;else break}return h}has(P){const E=this.d(P);return!(E?.value===void 0&&E?.mid===void 0)}delete(P){return this.e(P,!1)}deleteSuperstr(P){return this.e(P,!0)}e(P,E){const h=this.b.reset(P),d=[];let f=this.c;for(;f;){const p=h.cmp(f.segment);if(p>0)d.push([-1,f]),f=f.left;else if(p<0)d.push([1,f]),f=f.right;else if(h.hasNext())h.next(),d.push([0,f]),f=f.mid;else break}if(!!f){if(E?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const p=this.f(f.right);if(p.key){const{key:b,value:S,segment:g}=p;this.e(p.key,!1),f.key=b,f.value=S,f.segment=g}}else{const p=f.left??f.right;if(d.length>0){const[b,S]=d[d.length-1];switch(b){case-1:S.left=p;break;case 0:S.mid=p;break;case 1:S.right=p;break}}else this.c=p}for(let p=d.length-1;p>=0;p--){const b=d[p][1];b.updateHeight();const S=b.balanceFactor();if(S>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),d[p][1]=b.rotateLeft()):S<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),d[p][1]=b.rotateRight()),p>0)switch(d[p-1][0]){case-1:d[p-1][1].left=d[p][1];break;case 1:d[p-1][1].right=d[p][1];break;case 0:d[p-1][1].mid=d[p][1];break}else this.c=d[0][1]}}}f(P){for(;P.left;)P=P.left;return P}findSubstr(P){const E=this.b.reset(P);let h=this.c,d;for(;h;){const f=E.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(E.hasNext())E.next(),d=h.value||d,h=h.mid;else break}return h&&h.value||d}findSuperstr(P){return this.g(P,!1)}g(P,E){const h=this.b.reset(P);let d=this.c;for(;d;){const f=h.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(h.hasNext())h.next(),d=d.mid;else return d.mid?this.h(d.mid):E?d.value:void 0}}hasElementOrSubtree(P){return this.g(P,!0)!==void 0}forEach(P){for(const[E,h]of this)P(h,E)}*[Symbol.iterator](){yield*this.h(this.c)}h(P){const E=[];return this.j(P,E),E[Symbol.iterator]()}j(P,E){!P||(P.left&&this.j(P.left,E),P.value&&E.push([P.key,P.value]),P.mid&&this.j(P.mid,E),P.right&&this.j(P.right,E))}_isBalanced(){const P=E=>{if(!E)return!0;const h=E.balanceFactor();return h<-1||h>1?!1:P(E.left)&&P(E.right)};return P(this.c)}}e.TernarySearchTree=k}),define(ye[2],De([1,0,10,12]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,u=/^\//,C=/^\/\//;function A(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!T.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!u.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,o){return!r&&!o?"file":r}function I(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==k&&(o=k+o):o=k;break}return o}const L="",k="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class P{static isUri(o){return o instanceof P?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,n,m,s,i,c=!1){typeof o=="object"?(this.scheme=o.scheme||L,this.authority=o.authority||L,this.path=o.path||L,this.query=o.query||L,this.fragment=o.fragment||L):(this.scheme=y(o,c),this.authority=n||L,this.path=I(this.scheme,m||L),this.query=s||L,this.fragment=i||L,A(this,c))}get fsPath(){return b(this,!1)}with(o){if(!o)return this;let{scheme:n,authority:m,path:s,query:i,fragment:c}=o;return n===void 0?n=this.scheme:n===null&&(n=L),m===void 0?m=this.authority:m===null&&(m=L),s===void 0?s=this.path:s===null&&(s=L),i===void 0?i=this.query:i===null&&(i=L),c===void 0?c=this.fragment:c===null&&(c=L),n===this.scheme&&m===this.authority&&s===this.path&&i===this.query&&c===this.fragment?this:new h(n,m,s,i,c)}static parse(o,n=!1){const m=v.exec(o);return m?new h(m[2]||L,l(m[4]||L),l(m[5]||L),l(m[7]||L),l(m[9]||L),n):new h(L,L,L,L,L)}static file(o){let n=L;if(R.isWindows&&(o=o.replace(/\\/g,k)),o[0]===k&&o[1]===k){const m=o.indexOf(k,2);m===-1?(n=o.substring(2),o=k):(n=o.substring(2,m),o=o.substring(m)||k)}return new h("file",n,o,L,L)}static from(o){const n=new h(o.scheme,o.authority,o.path,o.query,o.fragment);return A(n,!0),n}static joinPath(o,...n){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return R.isWindows&&o.scheme==="file"?m=P.file(a.win32.join(b(o,!0),...n)).path:m=a.posix.join(o.path,...n),o.with({path:m})}toString(o=!1){return S(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof P)return o;{const n=new h(o);return n._formatted=o.external,n._fsPath=o._sep===E?o.fsPath:null,n}}else return o}}e.URI=P;const E=R.isWindows?1:void 0;class h extends P{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(o=!1){return o?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=E),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(r,o,n){let m,s=-1;for(let i=0;i<r.length;i++){const c=r.charCodeAt(i);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||o&&c===47||n&&c===91||n&&c===93||n&&c===58)s!==-1&&(m+=encodeURIComponent(r.substring(s,i)),s=-1),m!==void 0&&(m+=r.charAt(i));else{m===void 0&&(m=r.substr(0,i));const w=d[c];w!==void 0?(s!==-1&&(m+=encodeURIComponent(r.substring(s,i)),s=-1),m+=w):s===-1&&(s=i)}}return s!==-1&&(m+=encodeURIComponent(r.substring(s))),m!==void 0?m:r}function p(r){let o;for(let n=0;n<r.length;n++){const m=r.charCodeAt(n);m===35||m===63?(o===void 0&&(o=r.substr(0,n)),o+=d[m]):o!==void 0&&(o+=r[n])}return o!==void 0?o:r}function b(r,o){let n;return r.authority&&r.path.length>1&&r.scheme==="file"?n=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?o?n=r.path.substr(1):n=r.path[1].toLowerCase()+r.path.substr(2):n=r.path,R.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=b;function S(r,o){const n=o?p:f;let m="",{scheme:s,authority:i,path:c,query:w,fragment:D}=r;if(s&&(m+=s,m+=":"),(i||s==="file")&&(m+=k,m+=k),i){let F=i.indexOf("@");if(F!==-1){const x=i.substr(0,F);i=i.substr(F+1),F=x.lastIndexOf(":"),F===-1?m+=n(x,!1,!1):(m+=n(x.substr(0,F),!1,!1),m+=":",m+=n(x.substr(F+1),!1,!0)),m+="@"}i=i.toLowerCase(),F=i.lastIndexOf(":"),F===-1?m+=n(i,!1,!0):(m+=n(i.substr(0,F),!1,!0),m+=i.substr(F))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const F=c.charCodeAt(1);F>=65&&F<=90&&(c=`/${String.fromCharCode(F+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const F=c.charCodeAt(0);F>=65&&F<=90&&(c=`${String.fromCharCode(F+32)}:${c.substr(2)}`)}m+=n(c,!0,!1)}return w&&(m+="?",m+=n(w,!1,!1)),D&&(m+="#",m+=o?D:f(D,!1,!1)),m}function g(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+g(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(r){return r.match(t)?r.replace(t,o=>g(o)):r}}),define(ye[69],De([1,0,22,8,2]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function u(I){return JSON.stringify(I,A)}e.stringify=u;function C(I){let L=JSON.parse(I);return L=y(L),L}e.parse=C;function A(I,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,R.regExpFlags)(L)}:L}function y(I,L=0){if(!I||L>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return T.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 16:return new Date(I.source)}if(I instanceof a.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let k=0;k<I.length;++k)I[k]=y(I[k],L+1);else for(const k in I)Object.hasOwnProperty.call(I,k)&&(I[k]=y(I[k],L+1))}return I}e.revive=y}),define(ye[16],De([1,0,11,12,2]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var u;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(u=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${u.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${u.vscodeRemoteResource}`}set(L,k,v){this.a[L]=k,this.b[L]=v}setConnectionToken(L,k){this.c[L]=k}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(d){return a.onUnexpectedError(d),L}const k=L.authority;let v=this.a[k];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const P=this.b[k],E=this.c[k];let h=`path=${encodeURIComponent(L.path)}`;return typeof E=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),T.URI.from({scheme:R.isWeb?this.d:u.vscodeRemoteResource,authority:`${v}:${P}`,path:this.f,query:h})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(L){const k=this.b(L,te);return this.uriToBrowserUri(k)}uriToBrowserUri(L){return L.scheme===u.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===u.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${u.vscodeFileResource}://${A.a}`)?L.with({scheme:u.vscodeFileResource,authority:L.authority||A.a,query:null,fragment:null}):L}asFileUri(L){const k=this.b(L,te);return this.uriToFileUri(k)}uriToFileUri(L){return L.scheme===u.vscodeFileResource?L.with({scheme:u.file,authority:L.authority!==A.a?L.authority:null,query:null,fragment:null}):L}b(L,k){return T.URI.isUri(L)?L:T.URI.parse(k.toUrl(L))}}A.a="vscode-app",e.FileAccess=new A;var y;(function(I){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(L.get("3"));const k="vscode-coi";function v(E){let h;typeof E=="string"?h=new URL(E).searchParams:E instanceof URL?h=E.searchParams:T.URI.isUri(E)&&(h=new URL(E.toString(!0)).searchParams);const d=h?.get(k);if(!!d)return L.get(d)}I.getHeadersFromQuery=v;function P(E,h,d){if(!globalThis.crossOriginIsolated)return;const f=h&&d?"3":d?"2":"1";E instanceof URLSearchParams?E.set(k,f):E[k]=f}I.addSearchParam=P})(y=e.COI||(e.COI={}))}),define(ye[24],De([1,0,32,16,10,12,8,2]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(P){return(0,A.uriToFsPath)(P,!0)}e.originalFSPath=y;class I{constructor(E){this.a=E}compare(E,h,d=!1){return E===h?0:(0,C.compare)(this.getComparisonKey(E,d),this.getComparisonKey(h,d))}isEqual(E,h,d=!1){return E===h?!0:!E||!h?!1:this.getComparisonKey(E,d)===this.getComparisonKey(h,d)}getComparisonKey(E,h=!1){return E.with({path:this.a(E)?E.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(E){return this.a(E)}isEqualOrParent(E,h,d=!1){if(E.scheme===h.scheme){if(E.scheme===R.Schemas.file)return a.isEqualOrParent(y(E),y(h),this.a(E))&&E.query===h.query&&(d||E.fragment===h.fragment);if((0,e.isEqualAuthority)(E.authority,h.authority))return a.isEqualOrParent(E.path,h.path,this.a(E),"/")&&E.query===h.query&&(d||E.fragment===h.fragment)}return!1}joinPath(E,...h){return A.URI.joinPath(E,...h)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return T.posix.basename(E.path)}extname(E){return T.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let h;return E.scheme===R.Schemas.file?h=A.URI.file(T.dirname(y(E))).path:(h=T.posix.dirname(E.path),E.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),h="/")),E.with({path:h})}normalizePath(E){if(!E.path.length)return E;let h;return E.scheme===R.Schemas.file?h=A.URI.file(T.normalize(y(E))).path:h=T.posix.normalize(E.path),E.with({path:h})}relativePath(E,h){if(E.scheme!==h.scheme||!(0,e.isEqualAuthority)(E.authority,h.authority))return;if(E.scheme===R.Schemas.file){const p=T.relative(y(E),y(h));return u.isWindows?a.toSlashes(p):p}let d=E.path||"/";const f=h.path||"/";if(this.a(E)){let p=0;for(const b=Math.min(d.length,f.length);p<b&&!(d.charCodeAt(p)!==f.charCodeAt(p)&&d.charAt(p).toLowerCase()!==f.charAt(p).toLowerCase());p++);d=f.substr(0,p)+d.substr(p)}return T.posix.relative(d,f)}resolvePath(E,h){if(E.scheme===R.Schemas.file){const d=A.URI.file(T.resolve(y(E),h));return E.with({authority:d.authority,path:d.path})}return h=a.toPosixPath(h),E.with({path:T.posix.resolve(E.path,h)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,h){return E===h||E!==void 0&&h!==void 0&&(0,C.equalsIgnoreCase)(E,h)}hasTrailingPathSeparator(E,h=T.sep){if(E.scheme===R.Schemas.file){const d=y(E);return d.length>a.getRoot(d).length&&d[d.length-1]===h}else{const d=E.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,h=T.sep){return(0,e.hasTrailingPathSeparator)(E,h)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,h=T.sep){let d=!1;if(E.scheme===R.Schemas.file){const f=y(E);d=f!==void 0&&f.length===a.getRoot(f).length&&f[f.length-1]===h}else{h="/";const f=E.path;d=f.length===1&&f.charCodeAt(f.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(E,h)?E.with({path:E.path+"/"}):E}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(P=>P.scheme===R.Schemas.file?!u.isLinux:!0),e.extUriIgnorePathCase=new I(P=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(P,E){const h=[];for(let d=0;d<P.length;d++){const f=E(P[d]);P.some((p,b)=>b===d?!1:(0,e.isEqualOrParent)(f,E(p)))||h.push(P[d])}return h}e.distinctParents=L;var k;(function(P){P.META_DATA_LABEL="label",P.META_DATA_DESCRIPTION="description",P.META_DATA_SIZE="size",P.META_DATA_MIME="mime";function E(h){const d=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(b=>{const[S,g]=b.split(":");S&&g&&d.set(S,g)});const p=h.path.substring(0,h.path.indexOf(";"));return p&&d.set(P.META_DATA_MIME,p),d}P.parseMetaData=E})(k=e.DataUri||(e.DataUri={}));function v(P,E,h){if(E){let d=P.path;return d&&d[0]!==T.posix.sep&&(d=T.posix.sep+d),P.with({scheme:h,authority:E,path:d})}return P.with({scheme:h})}e.toLocalResource=v}),define(ye[17],De([1,0,21,11,3,6,24,12]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(K){return!!K&&typeof K.then=="function"}e.isThenable=y;function I(K){const G=new a.CancellationTokenSource,de=K(G.token),be=new Promise((Ee,Pe)=>{const Fe=G.token.onCancellationRequested(()=>{Fe.dispose(),G.dispose(),Pe(new R.CancellationError)});Promise.resolve(de).then(se=>{Fe.dispose(),G.dispose(),Ee(se)},se=>{Fe.dispose(),G.dispose(),Pe(se)})});return new class{cancel(){G.cancel()}then(Ee,Pe){return be.then(Ee,Pe)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return be.finally(Ee)}}}e.createCancelablePromise=I;function L(K,G,de){return new Promise((be,Ee)=>{const Pe=G.onCancellationRequested(()=>{Pe.dispose(),be(de)});K.then(be,Ee).finally(()=>Pe.dispose())})}e.raceCancellation=L;function k(K,G){return new Promise((de,be)=>{const Ee=G.onCancellationRequested(()=>{Ee.dispose(),be(new R.CancellationError)});K.then(de,be).finally(()=>Ee.dispose())})}e.raceCancellationError=k;async function v(K){let G=-1;const de=K.map((Ee,Pe)=>Ee.then(Fe=>(G=Pe,Fe))),be=await Promise.race(de);return K.forEach((Ee,Pe)=>{Pe!==G&&Ee.cancel()}),be}e.raceCancellablePromises=v;function P(K,G,de){let be;const Ee=setTimeout(()=>{be?.(void 0),de?.()},G);return Promise.race([K.finally(()=>clearTimeout(Ee)),new Promise(Pe=>be=Pe)])}e.raceTimeout=P;function E(K){return new Promise((G,de)=>{const be=K();y(be)?be.then(G,de):G(be)})}e.asPromise=E;class h{constructor(){this.a=null,this.b=null,this.d=null}queue(G){if(this.a){if(this.d=G,!this.b){const de=()=>{this.b=null;const be=this.queue(this.d);return this.d=null,be};this.b=new Promise(be=>{this.a.then(de,de).then(be)})}return new Promise((de,be)=>{this.b.then(de,be)})}return this.a=G(),new Promise((de,be)=>{this.a.then(Ee=>{this.a=null,de(Ee)},Ee=>{this.a=null,be(Ee)})})}}e.Throttler=h;class d{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.Sequencer=d;class f{constructor(){this.a=new Map}queue(G,de){const Ee=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(de).finally(()=>{this.a.get(G)===Ee&&this.a.delete(G)});return this.a.set(G,Ee),Ee}}e.SequencerByKey=f;const p=(K,G)=>{let de=!0;const be=setTimeout(()=>{de=!1,G()},K);return{isTriggered:()=>de,dispose:()=>{clearTimeout(be),de=!1}}},b=K=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,K())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,de=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((Ee,Pe)=>{this.d=Ee,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const Ee=this.g;return this.g=null,Ee()}}));const be=()=>{this.a=null,this.d?.(null)};return this.a=de===e.MicrotaskDelay?b(be):p(de,be),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=S;class g{constructor(G){this.a=new S(G),this.b=new h}trigger(G,de){return this.a.trigger(()=>this.b.queue(G),de)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=g;class t{constructor(){this.a=!1,this.b=new Promise((G,de)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=t;class l extends t{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=l;function r(K,G){return G?new Promise((de,be)=>{const Ee=setTimeout(()=>{Pe.dispose(),de()},K),Pe=G.onCancellationRequested(()=>{clearTimeout(Ee),Pe.dispose(),be(new R.CancellationError)})}):I(de=>r(K,de))}e.timeout=r;function o(K,G=0){const de=setTimeout(K,G);return(0,u.toDisposable)(()=>clearTimeout(de))}e.disposableTimeout=o;function n(K){const G=[];let de=0;const be=K.length;function Ee(){return de<be?K[de++]():null}function Pe(Fe){Fe!=null&&G.push(Fe);const se=Ee();return se?se.then(Pe):Promise.resolve(G)}return Promise.resolve(null).then(Pe)}e.sequence=n;function m(K,G=be=>!!be,de=null){let be=0;const Ee=K.length,Pe=()=>{if(be>=Ee)return Promise.resolve(de);const Fe=K[be++];return Promise.resolve(Fe()).then(oe=>G(oe)?Promise.resolve(oe):Pe())};return Pe()}e.first=m;function s(K,G=be=>!!be,de=null){if(K.length===0)return Promise.resolve(de);let be=K.length;const Ee=()=>{be=-1;for(const Pe of K)Pe.cancel?.()};return new Promise((Pe,Fe)=>{for(const se of K)se.then(oe=>{--be>=0&&G(oe)?(Ee(),Pe(oe)):be===0&&Pe(de)}).catch(oe=>{--be>=0&&(Ee(),Fe(oe))})})}e.firstParallel=s;class i{constructor(G){this.a=0,this.d=G,this.f=[],this.b=0,this.g=new T.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(G){return this.a++,new Promise((de,be)=>{this.f.push({factory:G,c:de,e:be}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const G=this.f.shift();this.b++;const de=G.factory();de.then(G.c,G.e),de.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=i;class c extends i{constructor(){super(1)}}e.Queue=c;class w{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const G=new le;return this.b.add(G),G.p}d(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueFor(G,de=C.extUri){const be=de.getComparisonKey(G);let Ee=this.a.get(be);return Ee||(Ee=new c,T.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(be),this.f()}),this.a.set(be,Ee)),Ee}f(){!this.d()||this.g()}g(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.g()}}e.ResourceQueue=w;class D{constructor(G,de){this.a=-1,typeof G=="function"&&typeof de=="number"&&this.setIfNotSet(G,de)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,de){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},de)}setIfNotSet(G,de){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},de))}}e.TimeoutTimer=D;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(G,de){this.cancel(),this.a=setInterval(()=>{G()},de)}}e.IntervalTimer=F;class x{constructor(G,de){this.b=-1,this.a=G,this.d=de,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=x;class q{constructor(G,de){de%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${de}ms is not a multiple of 1000ms.`),this.a=G,this.b=de,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=q;class M extends x{constructor(G,de){super(G,de),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=M;class B extends u.Disposable{constructor(G,de){super(),this.g=G,this.h=de,this.a=[],this.b=this.B(new u.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const de of G)this.a.push(de);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,A.setTimeout0)(()=>{if(G)return;const de=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.runWhenIdle=(K,G)=>{const de=requestIdleCallback(K,typeof G=="number"?{timeout:G}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(de))}}}}();class O{constructor(G){this.d=!1,this.a=()=>{try{this.f=G()}catch(de){this.g=de}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=O;async function U(K,G,de){let be;for(let Ee=0;Ee<de;Ee++)try{return await K()}catch(Pe){be=Pe,await r(G)}throw be}e.retry=U;class z{hasPending(G){return this.a?typeof G=="number"?this.a.taskId===G:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(G,de,be){return this.a={taskId:G,cancel:()=>be?.(),promise:de},de.then(()=>this.d(G),()=>this.d(G)),de}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this.b)this.b.run=G;else{let de,be;const Ee=new Promise((Pe,Fe)=>{de=Pe,be=Fe});this.b={run:G,promise:Ee,promiseResolve:de,promiseReject:be}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class j{constructor(G,de=()=>Date.now()){this.d=G,this.f=de,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.IntervalCounter=j;class le{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((G,de)=>{this.a=G,this.b=de})}complete(G){return new Promise(de=>{this.a(G),this.f=!0,de()})}error(G){return new Promise(de=>{this.b(G),this.d=!0,de()})}cancel(){new Promise(G=>{this.b(new R.CancellationError),this.d=!0,G()})}}e.DeferredPromise=le;var V;(function(K){async function G(be){let Ee;const Pe=await Promise.all(be.map(Fe=>Fe.then(se=>se,se=>{Ee||(Ee=se)})));if(typeof Ee<"u")throw Ee;return Pe}K.settled=G;function de(be){return new Promise(async(Ee,Pe)=>{try{await be(Ee,Pe)}catch(Fe){Pe(Fe)}})}K.withAsyncBody=de})(V=e.Promises||(e.Promises={}));var _;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(_||(_={}));class J{static fromArray(G){return new J(de=>{de.emitMany(G)})}static fromPromise(G){return new J(async de=>{de.emitMany(await G)})}static fromPromises(G){return new J(async de=>{await Promise.all(G.map(async be=>de.emitOne(await be)))})}static merge(G){return new J(async de=>{await Promise.all(G.map(async be=>{for await(const Ee of be)de.emitOne(Ee)}))})}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new T.Emitter,queueMicrotask(async()=>{const de={emitOne:be=>this.g(be),emitMany:be=>this.h(be),reject:be=>this.k(be)};try{await Promise.resolve(G(de)),this.j()}catch(be){this.k(be)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await T.Event.toPromise(this.f.event)}while(!0)}}}static map(G,de){return new J(async be=>{for await(const Ee of G)be.emitOne(de(Ee))})}map(G){return J.map(this,G)}static filter(G,de){return new J(async be=>{for await(const Ee of G)de(Ee)&&be.emitOne(Ee)})}filter(G){return J.filter(this,G)}static coalesce(G){return J.filter(G,de=>!!de)}coalesce(){return J.coalesce(this)}static async toPromise(G){const de=[];for await(const be of G)de.push(be);return de}toPromise(){return J.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class ie extends J{constructor(G,de){super(de),this.l=G}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ie;function ee(K){const G=new a.CancellationTokenSource,de=K(G.token);return new ie(G,async be=>{const Ee=G.token.onCancellationRequested(()=>{Ee.dispose(),G.dispose(),be.reject(new R.CancellationError)});try{for await(const Pe of de){if(G.token.isCancellationRequested)return;be.emitOne(Pe)}Ee.dispose(),G.dispose()}catch(Pe){Ee.dispose(),G.dispose(),be.reject(Pe)}})}e.createCancelableAsyncIterable=ee}),define(ye[38],De([1,0,15,17,32,28,10,12,8]),function(te,e,a,R,T,u,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",k="[^/\\\\]",v=/\//g;function P(le,V){switch(le){case 0:return"";case 1:return`${k}*?`;default:return`(?:${L}|${k}+${L}${V?`|${L}${k}+`:""})*?`}}function E(le,V){if(!le)return[];const _=[];let J=!1,ie=!1,ee="";for(const K of le){switch(K){case V:if(!J&&!ie){_.push(ee),ee="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}ee+=K}return ee&&_.push(ee),_}e.splitGlobAware=E;function h(le){if(!le)return"";let V="";const _=E(le,e.GLOB_SPLIT);if(_.every(J=>J===e.GLOBSTAR))V=".*";else{let J=!1;_.forEach((ie,ee)=>{if(ie===e.GLOBSTAR){if(J)return;V+=P(2,ee===_.length-1)}else{let K=!1,G="",de=!1,be="";for(const Ee of ie){if(Ee!=="}"&&K){G+=Ee;continue}if(de&&(Ee!=="]"||!be)){let Pe;Ee==="-"?Pe=Ee:(Ee==="^"||Ee==="!")&&!be?Pe="^":Ee===e.GLOB_SPLIT?Pe="":Pe=(0,y.escapeRegExpCharacters)(Ee),be+=Pe;continue}switch(Ee){case"{":K=!0;continue;case"[":de=!0;continue;case"}":{V+=`(?:${E(G,",").map(se=>h(se)).join("|")})`,K=!1,G="";break}case"]":{V+="["+be+"]",de=!1,be="";break}case"?":V+=k;continue;case"*":V+=P(1);continue;default:V+=(0,y.escapeRegExpCharacters)(Ee)}}ee<_.length-1&&(_[ee+1]!==e.GLOBSTAR||ee+2<_.length)&&(V+=L)}J=ie===e.GLOBSTAR})}return V}const d=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new u.LRUCache(1e4),l=function(){return!1},r=function(){return null};function o(le,V){if(!le)return r;let _;typeof le!="string"?_=le.pattern:_=le,_=_.trim();const J=`${_}_${!!V.trimForExclusions}`;let ie=t.get(J);if(ie)return n(ie,le);let ee;return d.test(_)?ie=s(_.substr(4),_):(ee=f.exec(m(_,V)))?ie=i(ee[1],_):(V.trimForExclusions?b:p).test(_)?ie=c(_,V):(ee=S.exec(m(_,V)))?ie=w(ee[1].substr(1),_,!0):(ee=g.exec(m(_,V)))?ie=w(ee[1],_,!1):ie=D(_),t.set(J,ie),n(ie,le)}function n(le,V){if(typeof V=="string")return le;const _=function(J,ie){return(0,T.isEqualOrParent)(J,V.base,!A.isLinux)?le((0,y.ltrim)(J.substr(V.base.length),C.sep),ie):null};return _.allBasenames=le.allBasenames,_.allPaths=le.allPaths,_.basenames=le.basenames,_.patterns=le.patterns,_}function m(le,V){return V.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function s(le,V){return function(_,J){return typeof _=="string"&&_.endsWith(le)?V:null}}function i(le,V){const _=`/${le}`,J=`\\${le}`,ie=function(K,G){return typeof K!="string"?null:G?G===le?V:null:K===le||K.endsWith(_)||K.endsWith(J)?V:null},ee=[le];return ie.basenames=ee,ie.patterns=[V],ie.allBasenames=ee,ie}function c(le,V){const _=z(le.slice(1,-1).split(",").map(G=>o(G,V)).filter(G=>G!==r),le),J=_.length;if(!J)return r;if(J===1)return _[0];const ie=function(G,de){for(let be=0,Ee=_.length;be<Ee;be++)if(_[be](G,de))return le;return null},ee=_.find(G=>!!G.allBasenames);ee&&(ie.allBasenames=ee.allBasenames);const K=_.reduce((G,de)=>de.allPaths?G.concat(de.allPaths):G,[]);return K.length&&(ie.allPaths=K),ie}function w(le,V,_){const J=C.sep===C.posix.sep,ie=J?le:le.replace(v,C.sep),ee=C.sep+ie,K=C.posix.sep+le;let G;return _?G=function(de,be){return typeof de=="string"&&(de===ie||de.endsWith(ee)||!J&&(de===le||de.endsWith(K)))?V:null}:G=function(de,be){return typeof de=="string"&&(de===ie||!J&&de===le)?V:null},G.allPaths=[(_?"*/":"./")+le],G}function D(le){try{const V=new RegExp(`^${h(le)}$`);return function(_){return V.lastIndex=0,typeof _=="string"&&V.test(_)?le:null}}catch{return r}}function F(le,V,_){return!le||typeof V!="string"?!1:x(le)(V,void 0,_)}e.match=F;function x(le,V={}){if(!le)return l;if(typeof le=="string"||q(le)){const _=o(le,V);if(_===r)return l;const J=function(ie,ee){return!!_(ie,ee)};return _.allBasenames&&(J.allBasenames=_.allBasenames),_.allPaths&&(J.allPaths=_.allPaths),J}return O(le,V)}e.parse=x;function q(le){const V=le;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=q;function M(le){return le.allBasenames||[]}e.getBasenameTerms=M;function B(le){return le.allPaths||[]}e.getPathTerms=B;function O(le,V){const _=z(Object.getOwnPropertyNames(le).map(G=>U(G,le[G],V)).filter(G=>G!==r)),J=_.length;if(!J)return r;if(!_.some(G=>!!G.requiresSiblings)){if(J===1)return _[0];const G=function(Ee,Pe){let Fe;for(let se=0,oe=_.length;se<oe;se++){const fe=_[se](Ee,Pe);if(typeof fe=="string")return fe;(0,R.isThenable)(fe)&&(Fe||(Fe=[]),Fe.push(fe))}return Fe?(async()=>{for(const se of Fe){const oe=await se;if(typeof oe=="string")return oe}return null})():null},de=_.find(Ee=>!!Ee.allBasenames);de&&(G.allBasenames=de.allBasenames);const be=_.reduce((Ee,Pe)=>Pe.allPaths?Ee.concat(Pe.allPaths):Ee,[]);return be.length&&(G.allPaths=be),G}const ie=function(G,de,be){let Ee,Pe;for(let Fe=0,se=_.length;Fe<se;Fe++){const oe=_[Fe];oe.requiresSiblings&&be&&(de||(de=(0,C.basename)(G)),Ee||(Ee=de.substr(0,de.length-(0,C.extname)(G).length)));const fe=oe(G,de,Ee,be);if(typeof fe=="string")return fe;(0,R.isThenable)(fe)&&(Pe||(Pe=[]),Pe.push(fe))}return Pe?(async()=>{for(const Fe of Pe){const se=await Fe;if(typeof se=="string")return se}return null})():null},ee=_.find(G=>!!G.allBasenames);ee&&(ie.allBasenames=ee.allBasenames);const K=_.reduce((G,de)=>de.allPaths?G.concat(de.allPaths):G,[]);return K.length&&(ie.allPaths=K),ie}function U(le,V,_){if(V===!1)return r;const J=o(le,_);if(J===r)return r;if(typeof V=="boolean")return J;if(V){const ie=V.when;if(typeof ie=="string"){const ee=(K,G,de,be)=>{if(!be||!J(K,G))return null;const Ee=ie.replace("$(basename)",()=>de),Pe=be(Ee);return(0,R.isThenable)(Pe)?Pe.then(Fe=>Fe?le:null):Pe?le:null};return ee.requiresSiblings=!0,ee}}return J}function z(le,V){const _=le.filter(G=>!!G.basenames);if(_.length<2)return le;const J=_.reduce((G,de)=>{const be=de.basenames;return be?G.concat(be):G},[]);let ie;if(V){ie=[];for(let G=0,de=J.length;G<de;G++)ie.push(V)}else ie=_.reduce((G,de)=>{const be=de.patterns;return be?G.concat(be):G},[]);const ee=function(G,de){if(typeof G!="string")return null;if(!de){let Ee;for(Ee=G.length;Ee>0;Ee--){const Pe=G.charCodeAt(Ee-1);if(Pe===47||Pe===92)break}de=G.substr(Ee)}const be=J.indexOf(de);return be!==-1?ie[be]:null};ee.basenames=J,ee.patterns=ie,ee.allBasenames=J;const K=le.filter(G=>!G.basenames);return K.push(ee),K}function j(le,V){return(0,a.equals)(le,V,(_,J)=>typeof _=="string"&&typeof J=="string"?_===J:typeof _!="string"&&typeof J!="string"?_.base===J.base&&_.pattern===J.pattern:!1)}e.patternsEquals=j}),define(ye[112],De([1,0,11,162,24,8,2]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",p=!1){if(this.value=f,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(f,p=0){return this.value+=v(this.supportThemeIcons?(0,R.escapeIcons)(f):f).replace(/([ \t]+)/g,(b,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,p){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(f,p,b){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(f),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(f,p){const b=new RegExp((0,u.escapeRegExpCharacters)(p),"g");return f.replace(b,(S,g)=>f.charAt(g-1)!=="\\"?`\\${S}`:S)}}e.MarkdownString=y;function I(d){return L(d)?!d.value:Array.isArray(d)?d.every(I):!0}e.isEmptyMarkdownString=I;function L(d){return d instanceof y?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function k(d,f){return d===f?!0:!d||!f?!1:d.value===f.value&&d.isTrusted===f.isTrusted&&d.supportThemeIcons===f.supportThemeIcons&&d.supportHtml===f.supportHtml&&(d.baseUri===f.baseUri||!!d.baseUri&&!!f.baseUri&&(0,T.isEqual)(C.URI.from(d.baseUri),C.URI.from(f.baseUri)))}e.markdownStringEqual=k;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function P(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=P;function E(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=E;function h(d){const f=[],p=d.split("|").map(S=>S.trim());d=p[0];const b=p[1];if(b){const S=/height=(\d+)/.exec(b),g=/width=(\d+)/.exec(b),t=S?S[1]:"",l=g?g[1]:"",r=isFinite(parseInt(l)),o=isFinite(parseInt(t));r&&f.push(`width="${l}"`),o&&f.push(`height="${t}"`)}return{href:d,dimensions:f}}e.parseHrefAndDimensions=h}),define(ye[113],De([1,0,15,32,10,12,24,8]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(r,o){const{os:n,tildify:m,relative:s}=o;if(s){const w=I(r,s,n);if(typeof w=="string")return w}let i=r.fsPath;if(n===1&&!u.isWindows?i=i.replace(/\//g,"\\"):n!==1&&u.isWindows&&(i=i.replace(/\\/g,"/")),n!==1&&m?.userHome){const w=m.userHome.fsPath;let D;r.scheme!==m.userHome.scheme&&r.path.startsWith(T.posix.sep)?D=m.userHome.with({path:r.path}).fsPath:D=r.fsPath,i=v(D,w,n)}return(n===1?T.win32:T.posix).normalize(L(i,n===1))}e.getPathLabel=y;function I(r,o,n){const m=n===1?T.win32:T.posix,s=n===3?C.extUri:C.extUriIgnorePathCase,i=o.getWorkspace(),c=(0,a.firstOrDefault)(i.folders);if(!c)return;r.scheme!==c.uri.scheme&&r.path.startsWith(T.posix.sep)&&(r=c.uri.with({path:r.path}));const w=o.getWorkspaceFolder(r);if(!w)return;let D;if(s.isEqual(w.uri,r)?D="":D=s.relativePath(w.uri,r)??"",D&&(D=m.normalize(D)),i.folders.length>1&&!o.noPrefix){const F=w.name?w.name:s.basenameOrAuthority(w.uri);D=D?`${F} \u2022 ${D}`:F}return D}function L(r,o=u.isWindows){return(0,R.hasDriveLetter)(r,o)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=L;let k=Object.create(null);function v(r,o,n=u.OS){if(n===1||!r||!o)return r;let m=k.original===o?k.normalized:void 0;m||(m=o,u.isWindows&&(m=(0,R.toSlashes)(m)),m=`${(0,A.rtrim)(m,T.posix.sep)}${T.posix.sep}`,k={original:o,normalized:m});let s=r;return u.isWindows&&(s=(0,R.toSlashes)(s)),(n===3?s.startsWith(m):(0,A.startsWithIgnoreCase)(s,m))?`~/${s.substr(m.length)}`:r}e.tildify=v;function P(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=P;const E="\u2026",h="\\\\",d="~";function f(r,o=T.sep){const n=new Array(r.length);let m=!1;for(let s=0;s<r.length;s++){const i=r[s];if(i===""){n[s]=`.${o}`;continue}if(!i){n[s]=i;continue}m=!0;let c="",w=i;w.indexOf(h)===0?(c=w.substr(0,w.indexOf(h)+h.length),w=w.substr(w.indexOf(h)+h.length)):w.indexOf(o)===0?(c=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length)):w.indexOf(d)===0&&(c=w.substr(0,w.indexOf(d)+d.length),w=w.substr(w.indexOf(d)+d.length));const D=w.split(o);for(let F=1;m&&F<=D.length;F++)for(let x=D.length-F;m&&x>=0;x--){m=!1;let q=D.slice(x,x+F).join(o);for(let M=0;!m&&M<r.length;M++)if(M!==s&&r[M]&&r[M].indexOf(q)>-1){const B=x+F===D.length,O=x>0&&r[M].indexOf(o)>-1?o+q:q,U=r[M].endsWith(O);m=!B||U}if(!m){let M="";(D[0].endsWith(":")||c!=="")&&(x===1&&(x=0,F++,q=D[0]+o+q),x>0&&(M=D[0]+o),M=c+M),x>0&&(M=M+E+o),M=M+q,x+F<D.length&&(M=M+o+E),n[s]=M}}m&&(n[s]=i)}return n}e.shorten=f;var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function b(r,o=Object.create(null)){const n=[];let m=!1,s="";for(const i of r)if(i==="$"||m&&i==="{")s&&n.push({value:s,type:p.TEXT}),s="",m=!0;else if(i==="}"&&m){const c=o[s];if(typeof c=="string")c.length&&n.push({value:c,type:p.VARIABLE});else if(c){const w=n[n.length-1];(!w||w.type!==p.SEPARATOR)&&n.push({value:c.label,type:p.SEPARATOR})}s="",m=!1}else s+=i;return s&&!m&&n.push({value:s,type:p.TEXT}),n.filter((i,c)=>{if(i.type===p.SEPARATOR){const w=n[c-1],D=n[c+1];return[w,D].every(F=>F&&(F.type===p.VARIABLE||F.type===p.TEXT)&&F.value.length>0)}return!0}).map(i=>i.value).join("")}e.template=b;function S(r,o){return u.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,u.isMacintosh?"&":"&&"):r.replace(/&&|&/g,n=>n==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function g(r,o){return u.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):u.isWindows?r.replace(/&&|&/g,n=>n==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function l(r){const o=r.indexOf("/")!==-1?T.posix:T.win32,n=o.basename(r),m=o.dirname(r);return n.length?{name:n,parentPath:m}:{name:m,parentPath:""}}e.splitName=l}),define(ye[114],De([1,0,22,2]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(k){return k.toJSON()}class u{constructor(v){this.a=v}transformIncoming(v){const P=this.a.transformIncoming(v);return P===v?v:T(R.URI.from(P))}transformOutgoing(v){const P=this.a.transformOutgoing(v);return P===v?v:T(R.URI.from(P))}transformOutgoingURI(v){const P=this.a.transformOutgoing(v);return P===v?v:R.URI.from(P)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=u,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function C(k,v,P){if(!k||P>200)return null;if(typeof k=="object"){if(k instanceof R.URI)return v.transformOutgoing(k);for(const E in k)if(Object.hasOwnProperty.call(k,E)){const h=C(k[E],v,P+1);h!==null&&(k[E]=h)}}return null}function A(k,v){const P=C(k,v,0);return P===null?k:P}e.transformOutgoingURIs=A;function y(k,v,P,E){if(!k||E>200)return null;if(typeof k=="object"){if(k.$mid===1)return P?R.URI.revive(v.transformIncoming(k)):v.transformIncoming(k);if(k instanceof a.VSBuffer)return null;for(const h in k)if(Object.hasOwnProperty.call(k,h)){const d=y(k[h],v,P,E+1);d!==null&&(k[h]=d)}}return null}function I(k,v){const P=y(k,v,!1,0);return P===null?k:P}e.transformIncomingURIs=I;function L(k,v){const P=y(k,v,!0,0);return P===null?k:P}e.transformAndReviveIncomingURIs=L}),define(ye[29],De([1,0,70,88,316,17,32,85,10,12,24,2]),function(te,e,a,R,T,u,C,A,y,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function P(O,U=v.UNLINK){if((0,C.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return U===v.UNLINK?h(O):E(O)}async function E(O){try{const U=(0,C.randomPath)((0,R.tmpdir)());try{await a.promises.rename(O,U)}catch(z){return z.code==="ENOENT"?void 0:h(O)}h(U).catch(z=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function h(O){return(0,T.promisify)(a.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function d(O){if((0,C.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function f(O,U){return S(await(U?p(O):(0,T.promisify)(a.readdir)(O)))}async function p(O){try{return await(0,T.promisify)(a.readdir)(O,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const U=[],z=await f(O);for(const j of z){let le=!1,V=!1,_=!1;try{const J=await e.Promises.lstat((0,y.join)(O,j));le=J.isFile(),V=J.isDirectory(),_=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}U.push({name:j,isFile:()=>le,isDirectory:()=>V,isSymbolicLink:()=>_})}return U}function b(O){return S(a.readdirSync(O))}e.readdirSync=b;function S(O){return O.map(U=>typeof U=="string"?I.isMacintosh?(0,A.normalizeNFC)(U):U:(U.name=I.isMacintosh?(0,A.normalizeNFC)(U.name):U.name,U))}async function g(O){const U=await f(O),z=[];for(const j of U)await l.existsDirectory((0,y.join)(O,j))&&z.push(j);return z}function t(O,U=1e3){return new Promise(z=>{let j=!1;const le=setInterval(()=>{j||(j=!0,a.access(O,V=>{j=!1,V&&(clearInterval(le),z(void 0))}))},U)})}e.whenDeleted=t;var l;(function(O){async function U(le){let V;try{if(V=await e.Promises.lstat(le),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(le),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(I.isWindows&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(le)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw J}throw _}}O.stat=U;async function z(le){try{const{stat:V,symbolicLink:_}=await O.stat(le);return V.isFile()&&_?.dangling!==!0}catch{}return!1}O.existsFile=z;async function j(le){try{const{stat:V,symbolicLink:_}=await O.stat(le);return V.isDirectory()&&_?.dangling!==!0}catch{}return!1}O.existsDirectory=j})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new u.ResourceQueue;function o(O,U,z){return r.queueFor(k.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const j=c(z);return new Promise((le,V)=>s(O,U,j,_=>_?V(_):le()))})}let n=!0;function m(O){n=O}e.configureFlushOnWrite=m;function s(O,U,z,j){if(!n)return a.writeFile(O,U,{mode:z.mode,flag:z.flag},j);a.open(O,z.flag,z.mode,(le,V)=>{if(le)return j(le);a.writeFile(V,U,_=>{if(_)return a.close(V,()=>j(_));a.fdatasync(V,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),m(!1)),a.close(V,ie=>j(ie))))})})}function i(O,U,z){const j=c(z);if(!n)return a.writeFileSync(O,U,{mode:j.mode,flag:j.flag});const le=a.openSync(O,j.flag,j.mode);try{a.writeFileSync(le,U);try{a.fdatasyncSync(le)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),m(!1)}}finally{a.closeSync(le)}}e.writeFileSync=i;function c(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function w(O,U){if(O!==U)try{await e.Promises.rename(O,U)}catch(z){if(O.toLowerCase()!==U.toLowerCase()&&z.code==="EXDEV"||O.endsWith("."))await D(O,U,{preserveSymlinks:!1}),await P(O,v.MOVE);else throw z}}async function D(O,U,z){return x(O,U,{root:{source:O,target:U},options:z,handledSourcePaths:new Set})}const F=511;async function x(O,U,z){if(z.handledSourcePaths.has(O))return;z.handledSourcePaths.add(O);const{stat:j,symbolicLink:le}=await l.stat(O);if(le){if(z.options.preserveSymlinks)try{return await B(O,U,z)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(le.dangling)return}return j.isDirectory()?q(O,U,j.mode&F,z):M(O,U,j.mode&F)}async function q(O,U,z,j){await e.Promises.mkdir(U,{recursive:!0,mode:z});const le=await f(O);for(const V of le)await x((0,y.join)(O,V),(0,y.join)(U,V),j)}async function M(O,U,z){await e.Promises.copyFile(O,U),await e.Promises.chmod(U,z)}async function B(O,U,z){let j=await e.Promises.readlink(O);(0,C.isEqualOrParent)(j,z.root.source,!I.isLinux)&&(j=(0,y.join)(z.root.target,j.substr(z.root.source.length+1))),await e.Promises.symlink(j,U)}e.Promises=new class{get access(){return(0,T.promisify)(a.access)}get stat(){return(0,T.promisify)(a.stat)}get lstat(){return(0,T.promisify)(a.lstat)}get utimes(){return(0,T.promisify)(a.utimes)}get read(){return(O,U,z,j,le)=>new Promise((V,_)=>{a.read(O,U,z,j,le,(J,ie,ee)=>J?_(J):V({bytesRead:ie,buffer:ee}))})}get readFile(){return(0,T.promisify)(a.readFile)}get write(){return(O,U,z,j,le)=>new Promise((V,_)=>{a.write(O,U,z,j,le,(J,ie,ee)=>J?_(J):V({bytesWritten:ie,buffer:ee}))})}get appendFile(){return(0,T.promisify)(a.appendFile)}get fdatasync(){return(0,T.promisify)(a.fdatasync)}get truncate(){return(0,T.promisify)(a.truncate)}get rename(){return(0,T.promisify)(a.rename)}get copyFile(){return(0,T.promisify)(a.copyFile)}get open(){return(0,T.promisify)(a.open)}get close(){return(0,T.promisify)(a.close)}get symlink(){return(0,T.promisify)(a.symlink)}get readlink(){return(0,T.promisify)(a.readlink)}get chmod(){return(0,T.promisify)(a.chmod)}get mkdir(){return(0,T.promisify)(a.mkdir)}get unlink(){return(0,T.promisify)(a.unlink)}get rmdir(){return(0,T.promisify)(a.rmdir)}get realpath(){return(0,T.promisify)(a.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return g}get writeFile(){return o}get rm(){return P}get move(){return w}get copy(){return D}}}),define(ye[115],De([1,0,70,10,12,8,29]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(v){if(T.isLinux)return v;const P=(0,R.dirname)(v);if(v===P)return v;const E=((0,R.basename)(v)||v).toLowerCase();try{const d=(0,C.readdirSync)(P).filter(f=>f.toLowerCase()===E);if(d.length===1){const f=A(P);if(f)return(0,R.join)(f,d[0])}else if(d.length>1){const f=d.indexOf(E);if(f>=0){const p=A(P);if(p)return(0,R.join)(p,d[f])}}}catch{}return null}e.realcaseSync=A;async function y(v){if(T.isLinux)return v;const P=(0,R.dirname)(v);if(v===P)return v;const E=((0,R.basename)(v)||v).toLowerCase();try{const d=(await C.Promises.readdir(P)).filter(f=>f.toLowerCase()===E);if(d.length===1){const f=await y(P);if(f)return(0,R.join)(f,d[0])}else if(d.length>1){const f=d.indexOf(E);if(f>=0){const p=await y(P);if(p)return(0,R.join)(p,d[f])}}}catch{}return null}e.realcase=y;async function I(v){try{return await C.Promises.realpath(v)}catch{const E=k(v);return await C.Promises.access(E,a.constants.R_OK),E}}e.realpath=I;function L(v){try{return a.realpathSync(v)}catch{const E=k(v);return a.accessSync(E,a.constants.R_OK),E}}e.realpathSync=L;function k(v){return(0,u.rtrim)((0,R.normalize)(v),R.sep)}}),define(ye[116],De([1,0,10,12,36,109,9,29]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return u.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return u.TerminateResponseCode}});function y(k=T.env){return k.comspec||"cmd.exe"}e.getWindowsShell=y;function I(k){let v=[],P=!1;const E=function(h){if(P){v.push(h);return}(!k.send(h,f=>{if(f&&console.error(f),P=!1,v.length>0){const p=v.slice(0);v=[],p.forEach(b=>E(b))}})||R.isWindows)&&(P=!0)};return{send:E}}e.createQueuedSender=I;var L;(function(k){async function v(P,E,h){if(a.isAbsolute(P))return P;if(E===void 0&&(E=T.cwd()),a.dirname(P)!=="."||(h===void 0&&C.isString(T.env.PATH)&&(h=T.env.PATH.split(a.delimiter)),h===void 0||h.length===0))return a.join(E,P);async function f(p){if(await A.Promises.exists(p)){let b;try{b=await A.Promises.stat(p)}catch(S){S.message.startsWith("EACCES")&&(b=await A.Promises.lstat(p))}return b?!b.isDirectory():!1}return!1}for(const p of h){let b;if(a.isAbsolute(p)?b=a.join(p,P):b=a.join(E,p,P),await f(b))return b;let S=b+".com";if(await f(S)||(S=b+".exe",await f(S)))return S}return a.join(E,P)}k.findExecutable=v})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(te,e,a,R){var T=arguments.length,u=T<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,a):R,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")u=Reflect.decorate(te,e,a,R);else for(var A=te.length-1;A>=0;A--)(C=te[A])&&(u=(T<3?C(u):T>3?C(e,a,u):C(e,a))||u);return T>3&&u&&Object.defineProperty(e,a,u),u};define(ye[117],De([1,0,15,17,22,21,62,11,3,6,69,8,9]),function(te,e,a,R,T,u,C,A,y,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var P;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(P||(P={}));function E(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(h||(h={}));function d(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function p(V){let _=0;for(let J=0;;J+=7){const ie=V.read(1);if(_|=(ie.buffer[0]&127)<<J,!(ie.buffer[0]&128))return _}}const b=r(0);function S(V,_){if(_===0){V.write(b);return}let J=0;for(let ee=_;ee!==0;ee=ee>>>7)J++;const ie=T.VSBuffer.alloc(J);for(let ee=0;_!==0;ee++)ie.buffer[ee]=_&127,_=_>>>7,_>0&&(ie.buffer[ee]|=128);V.write(ie)}class g{constructor(_){this.b=_,this.a=0}read(_){const J=this.b.slice(this.a,this.a+_);return this.a+=J.byteLength,J}}e.BufferReader=g;class t{constructor(){this.a=[]}get buffer(){return T.VSBuffer.concat(this.a)}write(_){this.a.push(_)}}e.BufferWriter=t;var l;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(l||(l={}));function r(V){const _=T.VSBuffer.alloc(1);return _.writeUInt8(V,0),_}const o={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object),Uint:r(l.Int)},n=typeof Buffer<"u";function m(V,_){if(typeof _>"u")V.write(o.Undefined);else if(typeof _=="string"){const J=T.VSBuffer.fromString(_);V.write(o.String),S(V,J.byteLength),V.write(J)}else if(n&&Buffer.isBuffer(_)){const J=T.VSBuffer.wrap(_);V.write(o.Buffer),S(V,J.byteLength),V.write(J)}else if(_ instanceof T.VSBuffer)V.write(o.VSBuffer),S(V,_.byteLength),V.write(_);else if(Array.isArray(_)){V.write(o.Array),S(V,_.length);for(const J of _)m(V,J)}else if(typeof _=="number"&&(_|0)===_)V.write(o.Uint),S(V,_);else{const J=T.VSBuffer.fromString(JSON.stringify(_));V.write(o.Object),S(V,J.byteLength),V.write(J)}}e.serialize=m;function s(V){switch(V.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return V.read(p(V)).toString();case l.Buffer:return V.read(p(V)).buffer;case l.VSBuffer:return V.read(p(V));case l.Array:{const J=p(V),ie=[];for(let ee=0;ee<J;ee++)ie.push(s(V));return ie}case l.Object:return JSON.parse(V.read(p(V)).toString());case l.Int:return p(V)}}e.deserialize=s;class i{constructor(_,J,ie=null,ee=1e3){this.h=_,this.j=J,this.k=ie,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(_,J){this.b.set(_,J),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const J=this.o([_.type]);this.k?.logOutgoing(J,0,1,d(_.type));return}case 201:case 202:case 204:case 203:{const J=this.o([_.type,_.id],_.data);this.k?.logOutgoing(J,_.id,1,d(_.type),_.data);return}}}o(_,J=void 0){const ie=new t;return m(ie,_),m(ie,J),this.p(ie.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const J=new g(_),ie=s(J),ee=s(J),K=ie[0];switch(K){case 100:return this.k?.logIncoming(_.byteLength,ie[1],1,`${E(K)}: ${ie[2]}.${ie[3]}`,ee),this.s({type:K,id:ie[1],channelName:ie[2],name:ie[3],arg:ee});case 102:return this.k?.logIncoming(_.byteLength,ie[1],1,`${E(K)}: ${ie[2]}.${ie[3]}`,ee),this.t({type:K,id:ie[1],channelName:ie[2],name:ie[3],arg:ee});case 101:return this.k?.logIncoming(_.byteLength,ie[1],1,`${E(K)}`),this.u({type:K,id:ie[1]});case 103:return this.k?.logIncoming(_.byteLength,ie[1],1,`${E(K)}`),this.u({type:K,id:ie[1]})}}s(_){const J=this.b.get(_.channelName);if(!J){this.v(_);return}const ie=new u.CancellationTokenSource;let ee;try{ee=J.call(this.j,_.name,_.arg,ie.token)}catch(de){ee=Promise.reject(de)}const K=_.id;ee.then(de=>{this.m({id:K,data:de,type:201}),this.d.delete(_.id)},de=>{de instanceof Error?this.m({id:K,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split?de.stack.split(`
`):de.stack:void 0},type:202}):this.m({id:K,data:de,type:203}),this.d.delete(_.id)});const G=(0,I.toDisposable)(()=>ie.cancel());this.d.set(_.id,G)}t(_){const J=this.b.get(_.channelName);if(!J){this.v(_);return}const ie=_.id,K=J.listen(this.j,_.name,_.arg)(G=>this.m({id:ie,data:G,type:204}));this.d.set(_.id,K)}u(_){const J=this.d.get(_.id);J&&(J.dispose(),this.d.delete(_.id))}v(_){let J=this.g.get(_.channelName);J||(J=[],this.g.set(_.channelName,J));const ie=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:_,timeoutTimer:ie})}w(_){const J=this.g.get(_);if(J){for(const ie of J)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,I.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=i;var c;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(_,J=null){this.l=_,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=J}getChannel(_){const J=this;return{call(ie,ee,K){return J.a?Promise.reject(new A.CancellationError):J.m(_,ie,ee,K)},listen(ie,ee){return J.a?y.Event.None:J.o(_,ie,ee)}}}m(_,J,ie,ee=u.CancellationToken.None){const K=this.g++,de={id:K,type:100,channelName:_,name:J,arg:ie};if(ee.isCancellationRequested)return Promise.reject(new A.CancellationError);let be;return new Promise((Pe,Fe)=>{if(ee.isCancellationRequested)return Fe(new A.CancellationError);const se=()=>{const ce=ne=>{switch(ne.type){case 201:this.f.delete(K),Pe(ne.data);break;case 202:{this.f.delete(K);const N=new Error(ne.data.message);N.stack=Array.isArray(ne.data.stack)?ne.data.stack.join(`
`):ne.data.stack,N.name=ne.data.name,Fe(N);break}case 203:this.f.delete(K),Fe(ne.data);break}};this.f.set(K,ce),this.p(de)};let oe=null;this.b===f.Idle?se():(oe=(0,R.createCancelablePromise)(ce=>this.u()),oe.then(()=>{oe=null,se()}));const fe=()=>{oe?(oe.cancel(),oe=null):this.p({id:K,type:101}),Fe(new A.CancellationError)},Z=ee.onCancellationRequested(fe);be=(0,I.combinedDisposable)((0,I.toDisposable)(fe),Z),this.d.add(be)}).finally(()=>{this.d.delete(be)})}o(_,J,ie){const ee=this.g++,G={id:ee,type:102,channelName:_,name:J,arg:ie};let de=null;const be=new y.Emitter({onWillAddFirstListener:()=>{de=(0,R.createCancelablePromise)(Pe=>this.u()),de.then(()=>{de=null,this.d.add(be),this.p(G)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.d.delete(be),this.p({id:ee,type:103}))}}),Ee=Pe=>be.fire(Pe.data);return this.f.set(ee,Ee),be.event}p(_){switch(_.type){case 100:case 102:{const J=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(J,_.id,0,`${E(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const J=this.q([_.type,_.id]);this.j?.logOutgoing(J,_.id,0,E(_.type));return}}}q(_,J=void 0){const ie=new t;return m(ie,_),m(ie,J),this.r(ie.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const J=new g(_),ie=s(J),ee=s(J),K=ie[0];switch(K){case 200:return this.j?.logIncoming(_.byteLength,0,0,d(K)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,ie[1],0,d(K),ee),this.t({type:ie[0],id:ie[1],data:ee})}}t(_){if(_.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,I.dispose)(this.d.values()),this.d.clear()}}qe([C.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class D{get connections(){const _=[];return this.f.forEach(J=>_.push(J)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,_(({protocol:J,onDidClientDisconnect:ie})=>{y.Event.once(J.onMessage)(K=>{const G=new g(K),de=s(G),be=new i(J,de),Ee=new w(J);this.a.forEach((Fe,se)=>be.registerChannel(se,Fe));const Pe={channelServer:be,channelClient:Ee,ctx:de};this.f.add(Pe),this.g.fire(Pe),ie(()=>{be.dispose(),Ee.dispose(),this.f.delete(Pe),this.h.fire(Pe)})})})}getChannel(_,J){const ie=this;return{call(ee,K,G){let de;if((0,v.isFunction)(J)){const Ee=(0,a.getRandomElement)(ie.connections.filter(J));de=Ee?Promise.resolve(Ee):y.Event.toPromise(y.Event.filter(ie.onDidAddConnection,J))}else de=J.routeCall(ie,ee,K);const be=de.then(Ee=>Ee.channelClient.getChannel(_));return x(be).call(ee,K,G)},listen(ee,K){if((0,v.isFunction)(J))return ie.j(_,J,ee,K);const G=J.routeEvent(ie,ee,K).then(de=>de.channelClient.getChannel(_));return x(G).listen(ee,K)}}}j(_,J,ie,ee){const K=this;let G=new I.DisposableStore;const de=new y.Emitter({onWillAddFirstListener:()=>{G=new I.DisposableStore;const be=new y.EventMultiplexer,Ee=new Map,Pe=se=>{const fe=se.channelClient.getChannel(_).listen(ie,ee),Z=be.add(fe);Ee.set(se,Z)},Fe=se=>{const oe=Ee.get(se);!oe||(oe.dispose(),Ee.delete(se))};K.connections.filter(J).forEach(Pe),y.Event.filter(K.onDidAddConnection,J)(Pe,void 0,G),K.onDidRemoveConnection(Fe,void 0,G),be.event(de.fire,de,G),G.add(be)},onDidRemoveLastListener:()=>{G.dispose()}});return de.event}registerChannel(_,J){this.a.set(_,J),this.f.forEach(ie=>{ie.channelServer.registerChannel(_,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=D;class F{constructor(_,J,ie=null){const ee=new t;m(ee,J),_.send(ee.buffer),this.a=new w(_,ie),this.d=new i(_,J,ie)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,J){this.d.registerChannel(_,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=F;function x(V){return{call(_,J,ie){return V.then(ee=>ee.call(_,J,ie))},listen(_,J){const ie=new y.Relay;return V.then(ee=>ie.input=ee.listen(_,J)),ie.event}}}e.getDelayedChannel=x;function q(V){let _=!1;return{call(J,ie,ee){return _?V.call(J,ie,ee):(0,R.timeout)(0).then(()=>_=!0).then(()=>V.call(J,ie,ee))},listen(J,ie){if(_)return V.listen(J,ie);const ee=new y.Relay;return(0,R.timeout)(0).then(()=>_=!0).then(()=>ee.input=V.listen(J,ie)),ee.event}}}e.getNextTickChannel=q;class M{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const J of _.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await y.Event.toPromise(_.onDidAddConnection),await this.b(_)}}e.StaticRouter=M;var B;(function(V){function _(K,G){const de=K,be=G&&G.disableMarshalling,Ee=new Map;for(const Pe in de)ie(Pe)&&Ee.set(Pe,y.Event.buffer(de[Pe],!0));return new class{listen(Pe,Fe,se){const oe=Ee.get(Fe);if(oe)return oe;if(ee(Fe)){const fe=de[Fe];if(typeof fe=="function")return fe.call(de,se)}throw new Error(`Event not found: ${Fe}`)}call(Pe,Fe,se){const oe=de[Fe];if(typeof oe=="function"){if(!be&&Array.isArray(se))for(let fe=0;fe<se.length;fe++)se[fe]=(0,L.revive)(se[fe]);return oe.apply(de,se)}throw new Error(`Method not found: ${Fe}`)}}}V.fromService=_;function J(K,G){const de=G&&G.disableMarshalling;return new Proxy({},{get(be,Ee){if(typeof Ee=="string")return G?.properties?.has(Ee)?G.properties.get(Ee):ee(Ee)?function(Pe){return K.listen(Ee,Pe)}:ie(Ee)?K.listen(Ee):async function(...Pe){let Fe;G&&!(0,v.isUndefinedOrNull)(G.context)?Fe=[G.context,...Pe]:Fe=Pe;const se=await K.call(Ee,Fe);return de?se:(0,L.revive)(se)};throw new Error(`Property not found: ${String(Ee)}`)}})}V.toService=J;function ie(K){return K[0]==="o"&&K[1]==="n"&&k.isUpperAsciiLetter(K.charCodeAt(2))}function ee(K){return/^onDynamic/.test(K)&&k.isUpperAsciiLetter(K.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const _=V.toString();if(_!=="[object Object]")return _}return V}function z(V){return Array.isArray(V)?V.map(U):U(V)}function j(V,_,J,ie,ee,K,G){G=z(G);const de=O[ee],be=de[ie%de.length];let Ee=[`%c[${V}]%c[${String(_).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${be}`];/\($/.test(K)?(Ee=Ee.concat(G),Ee.push(")")):Ee.push(G),console.log.apply(console,Ee)}class le{constructor(_,J){this.d=_,this.f=J,this.a=0,this.b=0}logOutgoing(_,J,ie,ee,K){this.b+=_,j(this.d,this.b,_,J,ie,ee,K)}logIncoming(_,J,ie,ee,K){this.a+=_,j(this.f,this.a,_,J,ie,ee,K)}}e.IPCLogger=le}),define(ye[118],De([1,0,17,22,3,6,117]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(w){w.Created="created",w.Read="read",w.Write="write",w.Open="open",w.Error="error",w.Close="close",w.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",w.NodeEndReceived="nodeEndReceived",w.NodeEndSent="nodeEndSent",w.NodeDrainBegin="nodeDrainBegin",w.NodeDrainEnd="nodeDrainEnd",w.zlibInflateError="zlibInflateError",w.zlibInflateData="zlibInflateData",w.zlibInflateInitialWrite="zlibInflateInitialWrite",w.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",w.zlibInflateWrite="zlibInflateWrite",w.zlibInflateFlushFired="zlibInflateFlushFired",w.zlibDeflateError="zlibDeflateError",w.zlibDeflateData="zlibDeflateData",w.zlibDeflateWrite="zlibDeflateWrite",w.zlibDeflateFlushFired="zlibDeflateFlushFired",w.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",w.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",w.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",w.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",w.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",w.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",w.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",w.ProtocolHeaderRead="protocolHeaderRead",w.ProtocolMessageRead="protocolMessageRead",w.ProtocolHeaderWrite="protocolHeaderWrite",w.ProtocolMessageWrite="protocolMessageWrite",w.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(w){w.enableDiagnostics=!1,w.records=[];const D=new WeakMap;let F=0;function x(M,B){if(!D.has(M)){const O=String(++F);D.set(M,O)}return D.get(M)}function q(M,B,O,U){if(!w.enableDiagnostics)return;const z=x(M,B);if(U instanceof R.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const j=R.VSBuffer.alloc(U.byteLength);j.set(U),w.records.push({timestamp:Date.now(),id:z,label:B,type:O,buff:j})}else w.records.push({timestamp:Date.now(),id:z,label:B,type:O,data:U})}w.traceSocketEvent=q})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(w){w[w.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",w[w.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function k(){return L||(L=R.VSBuffer.alloc(0)),L}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(D){this.a.push(D),this.b+=D.byteLength}read(D){return this.c(D,!0)}peek(D){return this.c(D,!1)}c(D,F){if(D===0)return k();if(D>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===D){const B=this.a[0];return F&&(this.a.shift(),this.b-=D),B}if(this.a[0].byteLength>D){const B=this.a[0].slice(0,D);return F&&(this.a[0]=this.a[0].slice(D),this.b-=D),B}const x=R.VSBuffer.alloc(D);let q=0,M=0;for(;D>0;){const B=this.a[M];if(B.byteLength>D){const O=B.slice(0,D);x.set(O,q),q+=D,F&&(this.a[M]=B.slice(D),this.b-=D),D-=D}else x.set(B,q),q+=B.byteLength,F?(this.a.shift(),this.b-=B.byteLength):M++,D-=B.byteLength}return x}}e.ChunkStream=v;var P;(function(w){w[w.None=0]="None",w[w.Regular=1]="Regular",w[w.Control=2]="Control",w[w.Ack=3]="Ack",w[w.Disconnect=5]="Disconnect",w[w.ReplayRequest=6]="ReplayRequest",w[w.Pause=7]="Pause",w[w.Resume=8]="Resume",w[w.KeepAlive=9]="KeepAlive",w[w.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",w[w.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(P||(P={}));function E(w){switch(w){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var h;(function(w){w[w.HeaderLength=13]="HeaderLength",w[w.AcknowledgeTime=2e3]="AcknowledgeTime",w[w.TimeoutTime=2e4]="TimeoutTime",w[w.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",w[w.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",w[w.KeepAliveSendTime=5e3]="KeepAliveSendTime",w[w.LatencySampleTime=6e4]="LatencySampleTime",w[w.LatencySampleCount=5]="LatencySampleCount",w[w.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",w[w.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(D,F,x,q){this.type=D,this.id=F,this.ack=x,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends u.Disposable{constructor(D){super(),this.f=this.B(new T.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=D,this.b=!1,this.c=new v,this.B(this.a.onData(F=>this.acceptChunk(F))),this.lastReadTime=Date.now()}acceptChunk(D){if(!(!D||D.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(D);this.c.byteLength>=this.g.readLen;){const F=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=F.readUInt32BE(9),this.g.messageType=F.readUInt8(0),this.g.id=F.readUInt32BE(1),this.g.ack=F.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const x=this.g.messageType,q=this.g.id,M=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",F),this.f.fire(new d(x,q,M,F)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(D){this.k=null,this.a=!1,this.b=!1,this.c=D,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(D){if(this.a)return;D.writtenTime=Date.now(),this.lastWriteTime=Date.now();const F=R.VSBuffer.alloc(13);F.writeUInt8(D.type,0),F.writeUInt32BE(D.id,1),F.writeUInt32BE(D.ack,5),F.writeUInt32BE(D.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(D.type),id:D.id,ack:D.ack,messageSize:D.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",D.data),this.j(F,D.data)}g(D,F){const x=this.f===0;return this.d.push(D,F),this.f+=D.byteLength+F.byteLength,x}h(){const D=R.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,D}j(D,F){this.g(D,F)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const D=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:D.byteLength}),this.c.write(D)}}class b extends u.Disposable{constructor(D){super(),this.f=new T.Emitter,this.onMessage=this.f.event,this.g=new T.Emitter,this.onDidDispose=this.g.event,this.a=D,this.b=this.B(new p(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(F=>{F.type===1&&this.f.fire(F.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(D){this.b.write(new d(1,0,0,D))}}e.Protocol=b;class S extends C.IPCClient{static fromSocket(D,F){return new S(new b(D),F)}get onDidDispose(){return this.b.onDidDispose}constructor(D,F,x=null){super(D,F,x),this.b=D}dispose(){super.dispose();const D=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),D.end()}}e.Client=S;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(D){this.b?this.d.length>0?this.d.push(D):this.a.fire(D):this.d.push(D)}flushBuffer(){this.d=[]}}e.BufferedEmitter=g;class t{constructor(D){this.data=D,this.next=null}}class l{constructor(){this.a=null,this.b=null}length(){let D=0,F=this.a;for(;F;)F=F.next,D++;return D}peek(){return this.a?this.a.data:null}toArray(){const D=[];let F=0,x=this.a;for(;x;)D[F++]=x.data,x=x.next;return D}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(D){const F=new t(D);if(!this.a){this.a=F,this.b=F;return}this.b.next=F,this.b=F}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const D=Date.now();for(let F=0;F<r.a;F++)this.c[F]=D-1e3*F;setInterval(()=>{for(let F=r.a;F>=1;F--)this.c[F]=this.c[F-1];this.c[0]=Date.now()},1e3)}d(){const D=Date.now(),F=(1+r.a)*1e3;let x=0;for(let q=0;q<r.a;q++)D-this.c[q]<=F&&x++;return 1-x/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var o;(function(w){w[w.Good=0]="Good",w[w.Poor=1]="Poor"})(o=e.ConnectionHealth||(e.ConnectionHealth={}));function n(w){switch(w){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=n;class m{constructor(D){this.connectionHealth=D}}e.ConnectionHealthChangedEvent=m;class s{constructor(D,F){this.roundTripTime=D,this.recentHighRoundTripCount=F}}e.HighRoundTripTimeEvent=s;class i{get unacknowledgedCount(){return this.c-this.d}constructor(D){this.x=new g,this.onControlMessage=this.x.event,this.y=new g,this.onMessage=this.y.event,this.z=new g,this.onDidDispose=this.z.event,this.A=new g,this.onSocketClose=this.A.event,this.B=new g,this.onSocketTimeout=this.B.event,this.C=new g,this.onHighRoundTripTime=this.C.event,this.D=new g,this.onDidChangeConnectionHealth=this.D.event,this.u=D.loadEstimator??r.getInstance(),this.v=D.measureRoundTripTime??!1,this.w=D.sendKeepAlive??!0,this.a=!1,this.b=new l,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new u.DisposableStore,this.o=D.socket,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new c),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.v&&this.r.start(),D.initialChunk&&this.q.acceptChunk(D.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const D=new d(5,0,0,k());this.p.write(D),this.p.flush()}sendPause(){const D=new d(7,0,0,k());this.p.write(D)}sendResume(){const D=new d(8,0,0,k());this.p.write(D)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(D,F){this.a=!0,this.t.dispose(),this.t=new u.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=D,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(x=>this.E(x))),this.t.add(this.o.onClose(x=>this.A.fire(x))),this.r=this.t.add(new c),this.t.add(this.r.onSendLatencyRequest(x=>this.J(x))),this.t.add(this.r.onHighRoundTripTime(x=>this.C.fire(x))),this.t.add(this.r.onDidChangeConnectionHealth(x=>this.D.fire(x))),this.q.acceptChunk(F)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const D=new d(3,0,this.h,k());this.p.write(D);const F=this.b.toArray();for(let x=0,q=F.length;x<q;x++)this.p.write(F[x]);this.G()}acceptDisconnect(){this.z.fire()}E(D){if(D.ack>this.d){this.d=D.ack;do{const F=this.b.peek();if(F&&F.id<=D.ack)this.b.pop();else break}while(!0)}switch(D.type){case 0:break;case 1:{if(D.id>this.g)if(D.id!==this.g+1){const F=Date.now();F-this.m>1e4&&(this.m=F,this.p.write(new d(6,0,0,k())))}else this.g=D.id,this.j=Date.now(),this.F(),this.y.fire(D.data);break}case 2:{this.x.fire(D.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const F=this.b.toArray();for(let x=0,q=F.length;x<q;x++)this.p.write(F[x]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(D.data);break}case 11:{this.r.handleResponse(D.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(D){const F=++this.c;this.h=this.g;const x=new d(1,F,this.h,D);this.b.push(x),this.a||(this.p.write(x),this.G())}sendControl(D){const F=new d(2,0,0,D);this.p.write(F)}F(){if(this.g<=this.h||this.k)return;const D=Date.now()-this.j;if(D>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-D+5)}G(){if(this.c<=this.d||this.f||this.a)return;const D=this.b.peek(),F=Date.now()-D.writtenTime,x=Date.now()-this.q.lastReadTime,q=Date.now()-this.n;if(F>=2e4&&x>=2e4&&q>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:F,timeSinceLastReceivedSomeData:x});return}const M=Math.max(2e4-F,2e4-x,2e4-q,500);this.f=setTimeout(()=>{this.f=null,this.G()},M)}H(){if(this.g<=this.h)return;this.h=this.g;const D=new d(3,0,this.h,k());this.p.write(D)}I(){this.h=this.g;const D=new d(9,0,this.h,k());this.p.write(D)}J(D){this.h=this.g;const F=new d(10,0,this.h,D);this.p.write(F)}K(D){this.h=this.g;const F=new d(11,0,this.h,D);this.p.write(F)}}e.PersistentProtocol=i;class c extends u.Disposable{constructor(){super(),this.a=this.B(new T.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new T.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new T.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new a.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},D=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const D=++this.h,F=R.VSBuffer.alloc(4);F.writeUInt32BE(D,0),this.a.fire(F)},6e4)}handleResponse(D){if(D.byteLength!==4)return;const F=D.readUInt32BE(0);if(this.g<=0||F!==this.h)return;const x=Date.now()-this.g,q=this.k++;this.j[q%this.j.length]=x;const M=this.l,B=this.j.filter(O=>O>=1e3).length;this.l=B>=3?1:0,x>1e3&&this.b.fire(new s(x,B)),M!==this.l&&this.c.fire(this.l)}}}),define(ye[119],De([1,0,22,11,3,6,10,12,30,117,118]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(s,i){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,i)}constructor(s,i=""){this.f=!0,this.debugLabel=i,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=c=>{if(this.traceSocketEvent("error",{code:c?.code,message:c?.message}),c){if(c.code==="EPIPE")return;(0,R.onUnexpectedError)(c)}},this.socket.on("error",this.a),this.b=c=>{this.traceSocketEvent("close",{hadError:c}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const i=c=>{this.traceSocketEvent("read",c),s(a.VSBuffer.wrap(c))};return this.socket.on("data",i),{dispose:()=>this.socket.off("data",i)}}onClose(s){const i=c=>{s({type:0,hadError:c,error:void 0})};return this.socket.on("close",i),{dispose:()=>this.socket.off("close",i)}}onEnd(s){const i=()=>{s()};return this.socket.on("end",i),{dispose:()=>this.socket.off("end",i)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,i=>{if(i){if(i.code==="EPIPE")return;(0,R.onUnexpectedError)(i)}})}catch(i){if(i.code==="EPIPE")return;(0,R.onUnexpectedError)(i)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,i)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const c=()=>{this.socket.off("close",c),this.socket.off("end",c),this.socket.off("error",c),this.socket.off("timeout",c),this.socket.off("drain",c),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",c),this.socket.on("end",c),this.socket.on("error",c),this.socket.on("timeout",c),this.socket.on("drain",c)})}}e.NodeSocket=v;var P;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var E;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(E||(E={}));class h extends u.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,i){this.socket.traceSocketEvent(s,i)}constructor(s,i,c,w){super(),this.f=this.B(new T.Emitter),this.g=this.B(new T.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:i,inflateBytesLength:c?.byteLength||0,recordInflateBytes:w}),this.a=this.B(new d(this,i,c,w,this.f,(D,F)=>this.k(D,F))),this.B(this.a.onError(D=>{console.error(D),(0,R.onUnexpectedError)(D),this.g.fire({type:0,hadError:!0,error:D})})),this.b=new L.ChunkStream,this.B(this.socket.onData(D=>this.l(D))),this.B(this.socket.onClose(D=>this.g.fire(D)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,i){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let c=2;s.byteLength<126?c+=0:s.byteLength<2**16?c+=2:c+=8;const w=a.VSBuffer.alloc(c);if(i?w.writeUInt8(194,0):w.writeUInt8(130,0),s.byteLength<126)w.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){w.writeUInt8(126,1);let D=1;w.writeUInt8(s.byteLength>>>8&255,++D),w.writeUInt8(s.byteLength>>>0&255,++D)}else{w.writeUInt8(127,1);let D=1;w.writeUInt8(0,++D),w.writeUInt8(0,++D),w.writeUInt8(0,++D),w.writeUInt8(0,++D),w.writeUInt8(s.byteLength>>>24&255,++D),w.writeUInt8(s.byteLength>>>16&255,++D),w.writeUInt8(s.byteLength>>>8&255,++D),w.writeUInt8(s.byteLength>>>0&255,++D)}this.socket.write(a.VSBuffer.concat([w,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const i=this.b.peek(this.j.readLen),c=i.readUInt8(0),w=(c&128)>>>7,D=(c&64)>>>6,F=i.readUInt8(1),x=(F&128)>>>7,q=F&127;this.j.state=2,this.j.readLen=2+(x?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=w,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(D)),this.j.firstFrameOfMessage=Boolean(w),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const i=this.b.read(this.j.readLen),c=i.readUInt8(1),w=(c&128)>>>7;let D=c&127,F=1;D===126?D=i.readUInt8(++F)*2**8+i.readUInt8(++F):D===127&&(D=i.readUInt8(++F)*0+i.readUInt8(++F)*0+i.readUInt8(++F)*0+i.readUInt8(++F)*0+i.readUInt8(++F)*2**24+i.readUInt8(++F)*2**16+i.readUInt8(++F)*2**8+i.readUInt8(++F));let x=0;w&&(x=i.readUInt8(++F)*2**24+i.readUInt8(++F)*2**16+i.readUInt8(++F)*2**8+i.readUInt8(++F)),this.j.state=3,this.j.readLen=D,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const i=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",i),b(i,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",i),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(i,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await T.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class d extends u.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(s,i,c,w,D,F){super(),this.k=s,this.l=D,this.m=F,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new T.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,i?(this.b=this.B(new f(this.k,w,c,{windowBits:15})),this.f=this.B(new p(this.k,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const i=await this.r(this.f,s);this.m(i,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,i){return new Promise((c,w)=>{s.write(i),s.flush(D=>c(D))})}acceptFrame(s,i,c){this.h.push({data:s,isCompressed:i,isLastFrameOfMessage:c}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const i=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(i)}else this.l.fire(s.data)}this.s=!1}}u(s,i,c){return new Promise((w,D)=>{s.write(i),c&&s.write(a.VSBuffer.fromByteArray([0,0,255,255])),s.flush(F=>w(F))})}}class f extends u.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(s,i,c,w){super(),this.h=s,this.j=i,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=k().zlib.createInflateRaw(w),this.b.on("error",D=>{this.h.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.h.traceSocketEvent("zlibInflateData",D),this.g.push(a.VSBuffer.wrap(D))}),c&&(this.h.traceSocketEvent("zlibInflateInitialWrite",c.buffer),this.b.write(c.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const i=a.VSBuffer.concat(this.g);this.g.length=0,s(i)})}}class p extends u.Disposable{constructor(s,i){super(),this.g=s,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.f=[],this.b=k().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",c=>{this.g.traceSocketEvent("zlibDeflateError",{message:c?.message,code:c?.code}),this.a.fire(c)}),this.b.on("data",c=>{this.g.traceSocketEvent("zlibDeflateData",c),this.f.push(a.VSBuffer.wrap(c))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let i=a.VSBuffer.concat(this.f);this.f.length=0,i=i.slice(0,i.byteLength-4),s(i)})}}function b(m,s){if(s===0)return;const i=m.byteLength>>>2;for(let q=0;q<i;q++){const M=m.readUInt32BE(q*4);m.writeUInt32BE(M^s,q*4)}const c=i*4,w=m.byteLength-c,D=s>>>24&255,F=s>>>16&255,x=s>>>8&255;w>=1&&m.writeUInt8(m.readUInt8(c)^D,c),w>=2&&m.writeUInt8(m.readUInt8(c+1)^F,c+1),w>=3&&m.writeUInt8(m.readUInt8(c+2)^x,c+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function g(){const m=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):s=(0,C.join)(k().os.tmpdir(),`vscode-ipc-${m}.sock`),l(s),s}e.createRandomIPCHandle=g;function t(m,s,i){const c=k().crypto.createHash("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${c}-${i}-${s}-sock`;let w;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?w=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${c.substr(0,8)}-${i}-${s}.sock`):w=(0,C.join)(m,`${i}-${s}.sock`),l(w),w}e.createStaticIPCHandle=t;function l(m){const s=S[A.platform];typeof s=="number"&&m.length>=s&&console.warn(`WARNING: IPC handle "${m}" is longer than ${s} chars, try a shorter --user-data-dir`)}class r extends I.IPCServer{static b(s){const i=T.Event.fromNodeEventEmitter(s,"connection");return T.Event.map(i,c=>({protocol:new L.Protocol(new v(c,"ipc-server-connection")),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(c,"close"))}))}constructor(s){super(r.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function o(m){return new Promise((s,i)=>{const c=k().net.createServer();c.on("error",i),c.listen(m,()=>{c.removeListener("error",i),s(new r(c))})})}e.serve=o;function n(m,s){return new Promise((i,c)=>{const w=k().net.createConnection(m,()=>{w.removeListener("error",c),i(L.Client.fromSocket(new v(w,`ipc-client${s}`),s))});w.once("error",c)})}e.connect=n}),define(ye[163],De([1,0,38,10]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(u,C,A,y,I,L){if(Array.isArray(u)){let k=0;for(const v of u){const P=T(v,C,A,y,I,L);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof u=="string")return y?u==="*"?5:u===A?10:0:0;if(u){const{language:k,pattern:v,scheme:P,hasAccessToAllModels:E,notebookType:h}=u;if(!y&&!E)return 0;h&&I&&(C=I);let d=0;if(P)if(P===C.scheme)d=10;else if(P==="*")d=5;else return 0;if(k)if(k===A)d=10;else if(k==="*")d=Math.max(d,5);else return 0;if(h)if(h===L)d=10;else if(h==="*"&&L!==void 0)d=Math.max(d,5);else return 0;if(v){let f;if(typeof v=="string"?f=v:f={...v,base:(0,R.normalize)(v.base)},f===C.fsPath||(0,a.match)(f,C.fsPath))d=10;else return 0}return d}else return 0}}e.score=T}),define(ye[164],De([1,0,8,52,154]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class u{constructor(A,y,I,L){this.c=A,this.d=y,this.f=I,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(A){A.eol&&A.eol!==this.f&&(this.f=A.eol,this.h=null);const y=A.changes;for(const I of y)this.n(I.range),this.o(new R.Position(I.range.startLineNumber,I.range.startColumn),I.text);this.g=A.versionId,this.j=null}k(){if(!this.h){const A=this.f.length,y=this.d.length,I=new Uint32Array(y);for(let L=0;L<y;L++)I[L]=this.d[L].length+A;this.h=new T.PrefixSumComputer(I)}}l(A,y){this.d[A]=y,this.h&&this.h.setValue(A,this.d[A].length+this.f.length)}n(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.startLineNumber-1].substring(A.endColumn-1));return}this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.endLineNumber-1].substring(A.endColumn-1)),this.d.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.h&&this.h.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}o(A,y){if(y.length===0)return;const I=(0,a.splitLines)(y);if(I.length===1){this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+I[0]+this.d[A.lineNumber-1].substring(A.column-1));return}I[I.length-1]+=this.d[A.lineNumber-1].substring(A.column-1),this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+I[0]);const L=new Uint32Array(I.length-1);for(let k=1;k<I.length;k++)this.d.splice(A.lineNumber+k-1,0,I[k]),L[k-1]=I[k].length+this.f.length;this.h&&this.h.insertValues(A.lineNumber,L)}}e.MirrorTextModel=u}),define(ye[165],De([1,0,8,151,52,35,107]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(p,b,S,g){this.searchString=p,this.isRegex=b,this.matchCase=S,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=I(this.searchString):p=this.searchString.indexOf(`
`)>=0;let b=null;try{b=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!b)return null;let S=!this.isRegex&&!p;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new C.SearchData(b,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}e.SearchParams=y;function I(f){if(!f||f.length===0)return!1;for(let p=0,b=f.length;p<b;p++){const S=f.charCodeAt(p);if(S===10)return!0;if(S===92){if(p++,p>=b)break;const g=f.charCodeAt(p);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=I;function L(f,p,b){if(!b)return new C.FindMatch(f,null);const S=[];for(let g=0,t=p.length;g<t;g++)S[g]=p[g];return new C.FindMatch(f,S)}e.createFindMatch=L;class k{constructor(p){const b=[];let S=0;for(let g=0,t=p.length;g<t;g++)p.charCodeAt(g)===10&&(b[S++]=g);this.a=b}findLineFeedCountBeforeOffset(p){const b=this.a;let S=0,g=b.length-1;if(g===-1||p<=b[0])return 0;for(;S<g;){const t=S+((g-S)/2>>0);b[t]>=p?g=t-1:b[t+1]>=p?(S=t,g=t):S=t+1}return S+1}}class v{static findMatches(p,b,S,g,t){const l=b.parseSearchRequest();return l?l.regex.multiline?this.b(p,S,new d(l.wordSeparators,l.regex),g,t):this.c(p,S,l,g,t):[]}static a(p,b,S,g,t,l){let r,o=0;g?(o=g.findLineFeedCountBeforeOffset(t),r=b+t+o):r=b+t;let n;if(g){const c=g.findLineFeedCountBeforeOffset(t+l.length)-o;n=r+l.length+c}else n=r+l.length;const m=p.getPositionAt(r),s=p.getPositionAt(n);return new u.Range(m.lineNumber,m.column,s.lineNumber,s.column)}static b(p,b,S,g,t){const l=p.getOffsetAt(b.getStartPosition()),r=p.getValueInRange(b,1),o=p.getEOL()===`\r
`?new k(r):null,n=[];let m=0,s;for(S.reset(0);s=S.next(r);)if(n[m++]=L(this.a(p,l,r,o,s.index,s[0]),s,g),m>=t)return n;return n}static c(p,b,S,g,t){const l=[];let r=0;if(b.startLineNumber===b.endLineNumber){const n=p.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return r=this.d(S,n,b.startLineNumber,b.startColumn-1,r,l,g,t),l}const o=p.getLineContent(b.startLineNumber).substring(b.startColumn-1);r=this.d(S,o,b.startLineNumber,b.startColumn-1,r,l,g,t);for(let n=b.startLineNumber+1;n<b.endLineNumber&&r<t;n++)r=this.d(S,p.getLineContent(n),n,0,r,l,g,t);if(r<t){const n=p.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);r=this.d(S,n,b.endLineNumber,0,r,l,g,t)}return l}static d(p,b,S,g,t,l,r,o){const n=p.wordSeparators;if(!r&&p.simpleSearch){const i=p.simpleSearch,c=i.length,w=b.length;let D=-c;for(;(D=b.indexOf(i,D+c))!==-1;)if((!n||h(n,b,w,D,c))&&(l[t++]=new C.FindMatch(new u.Range(S,D+1+g,S,D+1+c+g),null),t>=o))return t;return t}const m=new d(p.wordSeparators,p.regex);let s;m.reset(0);do if(s=m.next(b),s&&(l[t++]=L(new u.Range(S,s.index+1+g,S,s.index+1+s[0].length+g),s,r),t>=o))return t;while(s);return t}static findNextMatch(p,b,S,g){const t=b.parseSearchRequest();if(!t)return null;const l=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.e(p,S,l,g):this.f(p,S,l,g)}static e(p,b,S,g){const t=new T.Position(b.lineNumber,1),l=p.getOffsetAt(t),r=p.getLineCount(),o=p.getValueInRange(new u.Range(t.lineNumber,t.column,r,p.getLineMaxColumn(r)),1),n=p.getEOL()===`\r
`?new k(o):null;S.reset(b.column-1);const m=S.next(o);return m?L(this.a(p,l,o,n,m.index,m[0]),m,g):b.lineNumber!==1||b.column!==1?this.e(p,new T.Position(1,1),S,g):null}static f(p,b,S,g){const t=p.getLineCount(),l=b.lineNumber,r=p.getLineContent(l),o=this.g(S,r,l,b.column,g);if(o)return o;for(let n=1;n<=t;n++){const m=(l+n-1)%t,s=p.getLineContent(m+1),i=this.g(S,s,m+1,1,g);if(i)return i}return null}static g(p,b,S,g,t){p.reset(g-1);const l=p.next(b);return l?L(new u.Range(S,l.index+1,S,l.index+1+l[0].length),l,t):null}static findPreviousMatch(p,b,S,g){const t=b.parseSearchRequest();if(!t)return null;const l=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.h(p,S,l,g):this.j(p,S,l,g)}static h(p,b,S,g){const t=this.b(p,new u.Range(1,1,b.lineNumber,b.column),S,g,10*A);if(t.length>0)return t[t.length-1];const l=p.getLineCount();return b.lineNumber!==l||b.column!==p.getLineMaxColumn(l)?this.h(p,new T.Position(l,p.getLineMaxColumn(l)),S,g):null}static j(p,b,S,g){const t=p.getLineCount(),l=b.lineNumber,r=p.getLineContent(l).substring(0,b.column-1),o=this.k(S,r,l,g);if(o)return o;for(let n=1;n<=t;n++){const m=(t+l-n-1)%t,s=p.getLineContent(m+1),i=this.k(S,s,m+1,g);if(i)return i}return null}static k(p,b,S,g){let t=null,l;for(p.reset(0);l=p.next(b);)t=L(new u.Range(S,l.index+1,S,l.index+1+l[0].length),l,g);return t}}e.TextModelSearch=v;function P(f,p,b,S,g){if(S===0)return!0;const t=p.charCodeAt(S-1);if(f.get(t)!==0||t===13||t===10)return!0;if(g>0){const l=p.charCodeAt(S);if(f.get(l)!==0)return!0}return!1}function E(f,p,b,S,g){if(S+g===b)return!0;const t=p.charCodeAt(S+g);if(f.get(t)!==0||t===13||t===10)return!0;if(g>0){const l=p.charCodeAt(S+g-1);if(f.get(l)!==0)return!0}return!1}function h(f,p,b,S,g){return P(f,p,b,S,g)&&E(f,p,b,S,g)}e.isValidMatch=h;class d{constructor(p,b){this._wordSeparators=p,this.a=b,this.b=-1,this.c=0}reset(p){this.a.lastIndex=p,this.b=-1,this.c=0}next(p){const b=p.length;let S;do{if(this.b+this.c===b||(S=this.a.exec(p),!S))return null;const g=S.index,t=S[0].length;if(g===this.b&&t===this.c){if(t===0){a.getNextCodePoint(p,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=g,this.c=t,!this._wordSeparators||h(this._wordSeparators,p,b,g,t))return S}while(S);return null}}e.Searcher=d}),define(ye[120],De([1,0,22,12]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(T||(T={}));function u(k){for(let v=0,P=k.length;v<P;v+=4){const E=k[v+0],h=k[v+1],d=k[v+2],f=k[v+3];k[v+0]=f,k[v+1]=d,k[v+2]=h,k[v+3]=E}}function C(k){const v=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return R.isLittleEndian()||u(v),a.VSBuffer.wrap(v)}function A(k){const v=k.buffer;if(R.isLittleEndian()||u(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const P=new Uint8Array(v.byteLength);return P.set(v),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function y(k){const v=new Uint32Array(I(k));let P=0;if(v[P++]=k.id,k.type==="full")v[P++]=1,v[P++]=k.data.length,v.set(k.data,P),P+=k.data.length;else{v[P++]=2,v[P++]=k.deltas.length;for(const E of k.deltas)v[P++]=E.start,v[P++]=E.deleteCount,E.data?(v[P++]=E.data.length,v.set(E.data,P),P+=E.data.length):v[P++]=0}return C(v)}e.encodeSemanticTokensDto=y;function I(k){let v=0;if(v+=1+1,k.type==="full")v+=1+k.data.length;else{v+=1,v+=(1+1+1)*k.deltas.length;for(const P of k.deltas)P.data&&(v+=P.data.length)}return v}function L(k){const v=A(k);let P=0;const E=v[P++];if(v[P++]===1){const p=v[P++],b=v.subarray(P,P+p);return P+=p,{id:E,type:"full",data:b}}const d=v[P++],f=[];for(let p=0;p<d;p++){const b=v[P++],S=v[P++],g=v[P++];let t;g>0&&(t=v.subarray(P,P+g),P+=g),f[p]={start:b,deleteCount:S,data:t}}return{id:E,type:"delta",deltas:f}}e.decodeSemanticTokensDto=L}),define(ye[166],De([1,0,3,6]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class T{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,y){return this.a.set(A,y),this.fire([A]),(0,R.toDisposable)(()=>{this.a.get(A)===y&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,y){this.b.get(A)?.dispose();const I=new u(this,A,y);return this.b.set(A,I),(0,R.toDisposable)(()=>{const L=this.b.get(A);!L||L!==I||(this.b.delete(A),L.dispose())})}async getOrCreate(A){const y=this.get(A);if(y)return y;const I=this.b.get(A);return!I||I.isResolved?null:(await I.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const I=this.b.get(A);return!!(!I||I.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=T;class u extends R.Disposable{get isResolved(){return this.c}constructor(A,y,I){super(),this.f=A,this.g=y,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ye[71],De([1,0,67,2,35,166]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(c,w,D){this._tokenBrand=void 0,this.offset=c,this.type=w,this.language=D}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class A{constructor(c,w){this._tokenizationResultBrand=void 0,this.tokens=c,this.endState=w}}e.TokenizationResult=A;class y{constructor(c,w){this._encodedTokenizationResultBrand=void 0,this.tokens=c,this.endState=w}}e.EncodedTokenizationResult=y;var I;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(i){const c=new Map;c.set(0,a.Codicon.symbolMethod),c.set(1,a.Codicon.symbolFunction),c.set(2,a.Codicon.symbolConstructor),c.set(3,a.Codicon.symbolField),c.set(4,a.Codicon.symbolVariable),c.set(5,a.Codicon.symbolClass),c.set(6,a.Codicon.symbolStruct),c.set(7,a.Codicon.symbolInterface),c.set(8,a.Codicon.symbolModule),c.set(9,a.Codicon.symbolProperty),c.set(10,a.Codicon.symbolEvent),c.set(11,a.Codicon.symbolOperator),c.set(12,a.Codicon.symbolUnit),c.set(13,a.Codicon.symbolValue),c.set(15,a.Codicon.symbolEnum),c.set(14,a.Codicon.symbolConstant),c.set(15,a.Codicon.symbolEnum),c.set(16,a.Codicon.symbolEnumMember),c.set(17,a.Codicon.symbolKeyword),c.set(27,a.Codicon.symbolSnippet),c.set(18,a.Codicon.symbolText),c.set(19,a.Codicon.symbolColor),c.set(20,a.Codicon.symbolFile),c.set(21,a.Codicon.symbolReference),c.set(22,a.Codicon.symbolCustomColor),c.set(23,a.Codicon.symbolFolder),c.set(24,a.Codicon.symbolTypeParameter),c.set(25,a.Codicon.account),c.set(26,a.Codicon.issues);function w(x){let q=c.get(x);return q||(console.info("No codicon found for CompletionItemKind "+x),q=a.Codicon.symbolProperty),q}i.toIcon=w;const D=new Map;D.set("method",0),D.set("function",1),D.set("constructor",2),D.set("field",3),D.set("variable",4),D.set("class",5),D.set("struct",6),D.set("interface",7),D.set("module",8),D.set("property",9),D.set("event",10),D.set("operator",11),D.set("unit",12),D.set("value",13),D.set("constant",14),D.set("enum",15),D.set("enum-member",16),D.set("enumMember",16),D.set("keyword",17),D.set("snippet",27),D.set("text",18),D.set("color",19),D.set("file",20),D.set("reference",21),D.set("customcolor",22),D.set("folder",23),D.set("type-parameter",24),D.set("typeParameter",24),D.set("account",25),D.set("issue",26);function F(x,q){let M=D.get(x);return typeof M>"u"&&!q&&(M=9),M}i.fromString=F})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(i){i[i.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(i){i[i.None=0]="None",i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var P;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(P=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(i){return i&&R.URI.isUri(i.uri)&&T.Range.isIRange(i.range)&&(T.Range.isIRange(i.originSelectionRange)||T.Range.isIRange(i.targetSelectionRange))}e.isLocationLink=p;var b;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(b=e.SymbolKind||(e.SymbolKind={}));var S;(function(i){i[i.Deprecated=1]="Deprecated"})(S=e.SymbolTag||(e.SymbolTag={}));var g;(function(i){const c=new Map;c.set(0,a.Codicon.symbolFile),c.set(1,a.Codicon.symbolModule),c.set(2,a.Codicon.symbolNamespace),c.set(3,a.Codicon.symbolPackage),c.set(4,a.Codicon.symbolClass),c.set(5,a.Codicon.symbolMethod),c.set(6,a.Codicon.symbolProperty),c.set(7,a.Codicon.symbolField),c.set(8,a.Codicon.symbolConstructor),c.set(9,a.Codicon.symbolEnum),c.set(10,a.Codicon.symbolInterface),c.set(11,a.Codicon.symbolFunction),c.set(12,a.Codicon.symbolVariable),c.set(13,a.Codicon.symbolConstant),c.set(14,a.Codicon.symbolString),c.set(15,a.Codicon.symbolNumber),c.set(16,a.Codicon.symbolBoolean),c.set(17,a.Codicon.symbolArray),c.set(18,a.Codicon.symbolObject),c.set(19,a.Codicon.symbolKey),c.set(20,a.Codicon.symbolNull),c.set(21,a.Codicon.symbolEnumMember),c.set(22,a.Codicon.symbolStruct),c.set(23,a.Codicon.symbolEvent),c.set(24,a.Codicon.symbolOperator),c.set(25,a.Codicon.symbolTypeParameter);function w(D){let F=c.get(D);return F||(console.info("No codicon found for SymbolKind "+D),F=a.Codicon.symbolProperty),F}i.toIcon=w})(g=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(c){this.value=c}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var l;(function(i){function c(w){return!w||typeof w!="object"?!1:typeof w.id=="string"&&typeof w.title=="string"}i.is=c})(l=e.Command||(e.Command={}));var r;(function(i){i[i.Collapsed=0]="Collapsed",i[i.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(i){i[i.Unresolved=0]="Unresolved",i[i.Resolved=1]="Resolved"})(o=e.CommentThreadState||(e.CommentThreadState={}));var n;(function(i){i[i.Editing=0]="Editing",i[i.Preview=1]="Preview"})(n=e.CommentMode||(e.CommentMode={}));var m;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new u.TokenizationRegistry;var s;(function(i){i[i.None=0]="None",i[i.Option=1]="Option",i[i.Default=2]="Default",i[i.Preferred=3]="Preferred"})(s=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[167],De([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],De([1,0,167,12,106,15,23,150]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor($){this.c=$}hasChanged($){return this.c[$]}}e.ConfigurationChangedEvent=I;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class k{constructor($,ue,Ie,Le){this.id=$,this.name=ue,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ue){return P($,ue)}compute($,ue,Ie){return Ie}}class v{constructor($,ue){this.newValue=$,this.didChange=ue}}e.ApplyUpdateResult=v;function P(ae,$){if(typeof ae!="object"||typeof $!="object"||!ae||!$)return new v($,ae!==$);if(Array.isArray(ae)||Array.isArray($)){const Ie=Array.isArray(ae)&&Array.isArray($)&&u.equals(ae,$);return new v($,!Ie)}let ue=!1;for(const Ie in $)if($.hasOwnProperty(Ie)){const Le=P(ae[Ie],$[Ie]);Le.didChange&&(ae[Ie]=Le.newValue,ue=!0)}return new v(ae,ue)}class E{constructor($){this.schema=void 0,this.id=$,this.name="_never_",this.defaultValue=void 0}applyUpdate($,ue){return P($,ue)}validate($){return this.defaultValue}}class h{constructor($,ue,Ie,Le){this.id=$,this.name=ue,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ue){return P($,ue)}validate($){return typeof $>"u"?this.defaultValue:$}compute($,ue,Ie){return Ie}}function d(ae,$){return typeof ae>"u"?$:ae==="false"?!1:Boolean(ae)}e.boolean=d;class f extends h{constructor($,ue,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super($,ue,Ie,Le)}validate($){return d($,this.defaultValue)}}function p(ae,$,ue,Ie){if(typeof ae>"u")return $;let Le=parseInt(ae,10);return isNaN(Le)?$:(Le=Math.max(ue,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=p;class b extends h{static clampedInt($,ue,Ie,Le){return p($,ue,Ie,Le)}constructor($,ue,Ie,Le,$e,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Ie,Ke.minimum=Le,Ke.maximum=$e),super($,ue,Ie,Ke),this.minimum=Le,this.maximum=$e}validate($){return b.clampedInt($,this.defaultValue,this.minimum,this.maximum)}}class S extends h{static clamp($,ue,Ie){return $<ue?ue:$>Ie?Ie:$}static float($,ue){if(typeof $=="number")return $;if(typeof $>"u")return ue;const Ie=parseFloat($);return isNaN(Ie)?ue:Ie}constructor($,ue,Ie,Le,$e){typeof $e<"u"&&($e.type="number",$e.default=Ie),super($,ue,Ie,$e),this.validationFn=Le}validate($){return this.validationFn(S.float($,this.defaultValue))}}class g extends h{static string($,ue){return typeof $!="string"?ue:$}constructor($,ue,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super($,ue,Ie,Le)}validate($){return g.string($,this.defaultValue)}}function t(ae,$,ue){return typeof ae!="string"||ue.indexOf(ae)===-1?$:ae}e.stringSet=t;class l extends h{constructor($,ue,Ie,Le,$e=void 0){typeof $e<"u"&&($e.type="string",$e.enum=Le,$e.default=Ie),super($,ue,Ie,$e),this.c=Le}validate($){return t($,this.defaultValue,this.c)}}class r extends k{constructor($,ue,Ie,Le,$e,Ke,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=$e,Ze.default=Le),super($,ue,Ie,Ze),this.c=$e,this.d=Ke}validate($){return typeof $!="string"?this.defaultValue:this.c.indexOf($)===-1?this.defaultValue:this.d($)}}function o(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate($){switch($){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute($,ue,Ie){return Ie===0?$.accessibilitySupport:Ie}}class m extends k{constructor(){const $={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",$,{"editor.comments.insertSpace":{type:"boolean",default:$.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:$.ignoreEmptyLines,description:a.localize(5,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{insertSpace:d(ue.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ue.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(c=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(ae){switch(ae){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function D(ae){switch(ae){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class F extends E{constructor(){super(135)}compute($,ue,Ie){const Le=["monaco-editor"];return ue.get(36)&&Le.push(ue.get(36)),$.extraEditorClassName&&Le.push($.extraEditorClassName),ue.get(70)==="default"?Le.push("mouse-default"):ue.get(70)==="copy"&&Le.push("mouse-copy"),ue.get(105)&&Le.push("showUnused"),ue.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class x extends f{constructor(){super(34,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute($,ue,Ie){return Ie&&$.emptySelectionClipboard}}class q extends k{constructor(){const $={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",$,{"editor.find.cursorMoveOnType":{type:"boolean",default:$.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:$.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:$.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:$.globalFindClipboard,description:a.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:$.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:$.loop,description:a.localize(18,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{cursorMoveOnType:d(ue.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof $.seedSearchStringFromSelection=="boolean"?$.seedSearchStringFromSelection?"always":"never":t(ue.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof $.autoFindInSelection=="boolean"?$.autoFindInSelection?"always":"never":t(ue.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ue.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ue.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ue.loop,this.defaultValue.loop)}}}class M extends k{constructor(){super(48,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?M.OFF:$==="true"?M.ON:$:Boolean($)?M.ON:M.OFF}}e.EditorFontLigatures=M,M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on';class B extends k{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?B.OFF:$==="true"?B.TRANSLATE:$:Boolean($)?B.TRANSLATE:B.OFF}compute($,ue,Ie){return $.fontInfo.fontVariationSettings}}e.EditorFontVariations=B,B.OFF="normal",B.TRANSLATE="translate";class O extends E{constructor(){super(47)}compute($,ue,Ie){return $.fontInfo}}class U extends h{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate($){const ue=S.float($,this.defaultValue);return ue===0?e.EDITOR_FONT_DEFAULTS.fontSize:S.clamp(ue,6,100)}compute($,ue,Ie){return $.fontInfo.fontSize}}class z extends k{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate($){return $==="normal"||$==="bold"?$:String(b.clampedInt($,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class j extends k{constructor(){const $={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ue={type:"string",enum:["peek","gotoAndPeek","goto"],default:$.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",$,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...ue},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...ue},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...ue},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...ue},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...ue},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:$.alternativeDefinitionCommand,enum:Ie,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:$.alternativeTypeDefinitionCommand,enum:Ie,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:$.alternativeDeclarationCommand,enum:Ie,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:$.alternativeImplementationCommand,enum:Ie,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:$.alternativeReferenceCommand,enum:Ie,description:a.localize(41,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{multiple:t(ue.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ue.multipleDefinitions??t(ue.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ue.multipleTypeDefinitions??t(ue.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ue.multipleDeclarations??t(ue.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ue.multipleImplementations??t(ue.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ue.multipleReferences??t(ue.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(ue.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(ue.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(ue.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(ue.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(ue.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends k{constructor(){const $={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",$,{"editor.hover.enabled":{type:"boolean",default:$.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:$.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:$.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:$.above,description:a.localize(45,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),delay:b.clampedInt(ue.delay,this.defaultValue.delay,0,1e4),sticky:d(ue.sticky,this.defaultValue.sticky),above:d(ue.above,this.defaultValue.above)}}}var V;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class _ extends E{constructor(){super(138)}compute($,ue,Ie){return _.computeLayout(ue,{memory:$.memory,outerWidth:$.outerWidth,outerHeight:$.outerHeight,isDominatedByLongLines:$.isDominatedByLongLines,lineHeight:$.fontInfo.lineHeight,viewLineCount:$.viewLineCount,lineNumbersDigitCount:$.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:$.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:$.fontInfo.maxDigitWidth,pixelRatio:$.pixelRatio})}static computeContainedMinimapLineCount($){const ue=$.height/$.lineHeight,Ie=Math.floor($.paddingTop/$.lineHeight);let Le=Math.floor($.paddingBottom/$.lineHeight);$.scrollBeyondLastLine&&(Le=Math.max(Le,ue-1));const $e=(Ie+$.viewLineCount+Le)/($.pixelRatio*$.height),Ke=Math.floor($.viewLineCount/$e);return{typicalViewportLineCount:ue,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:$e,minimapLineCount:Ke}}static c($,ue){const Ie=$.outerWidth,Le=$.outerHeight,$e=$.pixelRatio;if(!$.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Ke=ue.stableMinimapLayoutInput,Ze=Ke&&$.outerHeight===Ke.outerHeight&&$.lineHeight===Ke.lineHeight&&$.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&$.pixelRatio===Ke.pixelRatio&&$.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&$.paddingTop===Ke.paddingTop&&$.paddingBottom===Ke.paddingBottom&&$.minimap.enabled===Ke.minimap.enabled&&$.minimap.side===Ke.minimap.side&&$.minimap.size===Ke.minimap.size&&$.minimap.showSlider===Ke.minimap.showSlider&&$.minimap.renderCharacters===Ke.minimap.renderCharacters&&$.minimap.maxColumn===Ke.minimap.maxColumn&&$.minimap.scale===Ke.minimap.scale&&$.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&$.isViewportWrapping===Ke.isViewportWrapping,pt=$.lineHeight,gt=$.typicalHalfwidthCharacterWidth,ct=$.scrollBeyondLastLine,Et=$.minimap.renderCharacters;let tt=$e>=2?Math.round($.minimap.scale*2):$.minimap.scale;const ft=$.minimap.maxColumn,At=$.minimap.size,Kt=$.minimap.side,Rt=$.verticalScrollbarWidth,mt=$.viewLineCount,Tt=$.remainingWidth,$t=$.isViewportWrapping,Nt=Et?2:3;let Xe=Math.floor($e*Le);const Mt=Xe/$e;let Ut=!1,Wt=!1,bt=Nt*tt,Re=tt/$e,Oe=1;if(At==="fill"||At==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:lt,extraLinesBeyondLastLine:Pt,desiredRatio:St,minimapLineCount:yt}=_.computeContainedMinimapLineCount({viewLineCount:mt,scrollBeyondLastLine:ct,paddingTop:$.paddingTop,paddingBottom:$.paddingBottom,height:Le,lineHeight:pt,pixelRatio:$e});if(mt/yt>1)Ut=!0,Wt=!0,tt=1,bt=1,Re=tt/$e;else{let Dt=!1,Ct=tt+1;if(At==="fit"){const qt=Math.ceil((lt+mt+Pt)*bt);$t&&Ze&&Tt<=ue.stableFitRemainingWidth?(Dt=!0,Ct=ue.stableFitMaxMinimapScale):Dt=qt>Xe}if(At==="fill"||Dt){Ut=!0;const qt=tt;bt=Math.min(pt*$e,Math.max(1,Math.floor(1/St))),$t&&Ze&&Tt<=ue.stableFitRemainingWidth&&(Ct=ue.stableFitMaxMinimapScale),tt=Math.min(Ct,Math.max(1,Math.floor(bt/Nt))),tt>qt&&(Oe=Math.min(2,tt/qt)),Re=tt/$e/Oe,Xe=Math.ceil(Math.max(it,lt+mt+Pt)*bt),$t?(ue.stableMinimapLayoutInput=$,ue.stableFitRemainingWidth=Tt,ue.stableFitMaxMinimapScale=tt):(ue.stableMinimapLayoutInput=null,ue.stableFitRemainingWidth=0)}}}const Se=Math.floor(ft*Re),re=Math.min(Se,Math.max(0,Math.floor((Tt-Rt-2)*Re/(gt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor($e*re);const He=Ne/$e;Ne=Math.floor(Ne*Oe);const _e=Et?1:2,je=Kt==="left"?0:Ie-re-Rt;return{renderMinimap:_e,minimapLeft:je,minimapWidth:re,minimapHeightIsEditorHeight:Ut,minimapIsSampling:Wt,minimapScale:tt,minimapLineHeight:bt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:He,minimapCanvasOuterHeight:Mt}}static computeLayout($,ue){const Ie=ue.outerWidth|0,Le=ue.outerHeight|0,$e=ue.lineHeight|0,Ke=ue.lineNumbersDigitCount|0,Ze=ue.typicalHalfwidthCharacterWidth,pt=ue.maxDigitWidth,gt=ue.pixelRatio,ct=ue.viewLineCount,Et=$.get(130),tt=Et==="inherit"?$.get(129):Et,ft=tt==="inherit"?$.get(125):tt,At=$.get(128),Kt=ue.isDominatedByLongLines,Rt=$.get(54),mt=$.get(64).renderType!==0,Tt=$.get(65),$t=$.get(99),Nt=$.get(80),Xe=$.get(69),Mt=$.get(97),Ut=Mt.verticalScrollbarSize,Wt=Mt.verticalHasArrows,bt=Mt.arrowSize,Re=Mt.horizontalScrollbarSize,Oe=$.get(40),Se=$.get(104)!=="never";let re=$.get(62);Oe&&Se&&(re+=16);let Ne=0;if(mt){const wt=Math.max(Ke,Tt);Ne=Math.round(wt*pt)}let He=0;Rt&&(He=$e);let _e=0,je=_e+He,it=je+Ne,lt=it+re;const Pt=Ie-He-Ne-re;let St=!1,yt=!1,kt=-1;tt==="inherit"&&Kt?(St=!0,yt=!0):ft==="on"||ft==="bounded"?yt=!0:ft==="wordWrapColumn"&&(kt=At);const Dt=_.c({outerWidth:Ie,outerHeight:Le,lineHeight:$e,typicalHalfwidthCharacterWidth:Ze,pixelRatio:gt,scrollBeyondLastLine:$t,paddingTop:Nt.top,paddingBottom:Nt.bottom,minimap:Xe,verticalScrollbarWidth:Ut,viewLineCount:ct,remainingWidth:Pt,isViewportWrapping:yt},ue.memory||new L);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(_e+=Dt.minimapWidth,je+=Dt.minimapWidth,it+=Dt.minimapWidth,lt+=Dt.minimapWidth);const Ct=Pt-Dt.minimapWidth,qt=Math.max(1,Math.floor((Ct-Ut-2)/Ze)),Jt=Wt?bt:0;return yt&&(kt=Math.max(1,qt),ft==="bounded"&&(kt=Math.min(kt,At))),{width:Ie,height:Le,glyphMarginLeft:_e,glyphMarginWidth:He,lineNumbersLeft:je,lineNumbersWidth:Ne,decorationsLeft:it,decorationsWidth:re,contentLeft:lt,contentWidth:Ct,minimap:Dt,viewportColumn:qt,isWordWrapMinified:St,isViewportWrapping:yt,wrappingColumn:kt,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:Re,overviewRuler:{top:Jt,width:Ut,height:Le-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=_;class J extends k{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate($){return t($,"simple",["simple","advanced"])}compute($,ue,Ie){return ue.get(2)===2?"advanced":Ie}}class ie extends k{constructor(){const $={enabled:!0};super(61,"lightbulb",$,{"editor.lightbulb.enabled":{type:"boolean",default:$.enabled,description:a.localize(49,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}class ee extends k{constructor(){const $={enabled:!1,maxLineCount:5};super(109,"stickyScroll",$,{"editor.stickyScroll.enabled":{type:"boolean",default:$.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:$.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(ue.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class K extends k{constructor(){const $={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",$,{"editor.inlayHints.enabled":{type:"string",default:$.enabled,description:a.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(53,null),a.localize(54,null,R.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(55,null,R.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:$.fontSize,markdownDescription:a.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:$.fontFamily,markdownDescription:a.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:$.padding,description:a.localize(59,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return typeof ue.enabled=="boolean"&&(ue.enabled=ue.enabled?"on":"off"),{enabled:t(ue.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(ue.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ue.fontFamily,this.defaultValue.fontFamily),padding:d(ue.padding,this.defaultValue.padding)}}}class G extends k{constructor(){super(62,"lineDecorationsWidth",10)}validate($){return typeof $=="string"&&/^\d+(\.\d+)?ch$/.test($)?-parseFloat($.substring(0,$.length-2)):b.clampedInt($,this.defaultValue,0,1e3)}compute($,ue,Ie){return Ie<0?b.clampedInt(-Ie*$.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class de extends S{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,$=>S.clamp($,0,150),{markdownDescription:a.localize(60,null)})}compute($,ue,Ie){return $.fontInfo.lineHeight}}class be extends k{constructor(){const $={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",$,{"editor.minimap.enabled":{type:"boolean",default:$.enabled,description:a.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:$.autohide,description:a.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)],default:$.size,description:a.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:$.side,description:a.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:$.showSlider,description:a.localize(68,null)},"editor.minimap.scale":{type:"number",default:$.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:$.renderCharacters,description:a.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:$.maxColumn,description:a.localize(71,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),autohide:d(ue.autohide,this.defaultValue.autohide),size:t(ue.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(ue.side,this.defaultValue.side,["right","left"]),showSlider:t(ue.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ue.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(ue.scale,1,1,3),maxColumn:b.clampedInt(ue.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(ae){return ae==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Pe extends k{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{top:b.clampedInt(ue.top,0,0,1e3),bottom:b.clampedInt(ue.bottom,0,0,1e3)}}}class Fe extends k{constructor(){const $={enabled:!0,cycle:!0};super(81,"parameterHints",$,{"editor.parameterHints.enabled":{type:"boolean",default:$.enabled,description:a.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:$.cycle,description:a.localize(75,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),cycle:d(ue.cycle,this.defaultValue.cycle)}}}class se extends E{constructor(){super(136)}compute($,ue,Ie){return $.pixelRatio}}class oe extends k{constructor(){const $={other:"on",comments:"off",strings:"off"},ue=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null)]}];super(84,"quickSuggestions",$,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ue,default:$.strings,description:a.localize(79,null)},comments:{anyOf:ue,default:$.comments,description:a.localize(80,null)},other:{anyOf:ue,default:$.other,description:a.localize(81,null)}},default:$,markdownDescription:a.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=$}validate($){if(typeof $=="boolean"){const gt=$?"on":"off";return{comments:gt,strings:gt,other:gt}}if(!$||typeof $!="object")return this.defaultValue;const{other:ue,comments:Ie,strings:Le}=$,$e=["on","inline","off"];let Ke,Ze,pt;return typeof ue=="boolean"?Ke=ue?"on":"off":Ke=t(ue,this.defaultValue.other,$e),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=t(Ie,this.defaultValue.comments,$e),typeof Le=="boolean"?pt=Le?"on":"off":pt=t(Le,this.defaultValue.strings,$e),{other:Ke,comments:Ze,strings:pt}}}var fe;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Z extends k{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(83,null),a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"on",description:a.localize(87,null)})}validate($){let ue=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof $<"u"&&(typeof $=="function"?(ue=4,Ie=$):$==="interval"?ue=3:$==="relative"?ue=2:$==="on"?ue=1:ue=0),{renderType:ue,renderFn:Ie}}}function ce(ae){const $=ae.get(92);return $==="editable"?ae.get(86):$!=="on"}e.filterValidationDecorations=ce;class ne extends k{constructor(){const $=[],ue={type:"number",description:a.localize(88,null)};super(96,"rulers",$,{type:"array",items:{anyOf:[ue,{type:["object"],properties:{column:ue,color:{type:"string",description:a.localize(89,null),format:"color-hex"}}}]},default:$,description:a.localize(90,null)})}validate($){if(Array.isArray($)){const ue=[];for(const Ie of $)if(typeof Ie=="number")ue.push({column:b.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;ue.push({column:b.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ue.sort((Ie,Le)=>Ie.column-Le.column),ue}return this.defaultValue}}function N(ae,$){if(typeof ae!="string")return $;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends k{constructor(){const $={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",$,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(91,null),a.localize(92,null),a.localize(93,null)],default:"auto",description:a.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(95,null),a.localize(96,null),a.localize(97,null)],default:"auto",description:a.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:$.verticalScrollbarSize,description:a.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:$.horizontalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:$.scrollByPage,description:a.localize(101,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$,Ie=b.clampedInt(ue.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=b.clampedInt(ue.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(ue.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ue.vertical,this.defaultValue.vertical),horizontal:N(ue.horizontal,this.defaultValue.horizontal),useShadows:d(ue.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ue.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ue.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ue.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ue.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:b.clampedInt(ue.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:b.clampedInt(ue.verticalSliderSize,Le,0,1e3),scrollByPage:d(ue.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends k{constructor(){const $={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",$,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.nonBasicASCII,description:a.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:$.invisibleCharacters,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:$.ambiguousCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeComments,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeStrings,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:$.allowedCharacters,description:a.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:$.allowedLocales,description:a.localize(108,null)}})}applyUpdate($,ue){let Ie=!1;ue.allowedCharacters&&$&&(C.equals($.allowedCharacters,ue.allowedCharacters)||($={...$,allowedCharacters:ue.allowedCharacters},Ie=!0)),ue.allowedLocales&&$&&(C.equals($.allowedLocales,ue.allowedLocales)||($={...$,allowedLocales:ue.allowedLocales},Ie=!0));const Le=super.applyUpdate($,ue);return Ie?new v(Le.newValue,!0):Le}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{nonBasicASCII:Ae(ue.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(ue.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(ue.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(ue.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(ue.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c($.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c($.allowedLocales,this.defaultValue.allowedLocales)}}c($,ue){if(typeof $!="object"||!$)return ue;const Ie={};for(const[Le,$e]of Object.entries($))$e===!0&&(Ie[Le]=!0);return Ie}}class Y extends k{constructor(){const $={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",$,{"editor.inlineSuggest.enabled":{type:"boolean",default:$.enabled,description:a.localize(109,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),mode:t(ue.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class he extends k{constructor(){const $={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",$,{"editor.bracketPairColorization.enabled":{type:"boolean",default:$.enabled,markdownDescription:a.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:$.independentColorPoolPerBracketType,description:a.localize(111,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(ue.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ve extends k{constructor(){const $={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",$,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(112,null),a.localize(113,null),a.localize(114,null)],default:$.bracketPairs,description:a.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(116,null),a.localize(117,null),a.localize(118,null)],default:$.bracketPairsHorizontal,description:a.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:$.highlightActiveBracketPair,description:a.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:$.indentation,description:a.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(122,null),a.localize(123,null),a.localize(124,null)],default:$.highlightActiveIndentation,description:a.localize(125,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{bracketPairs:Ae(ue.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(ue.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(ue.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(ue.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(ue.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(ae,$,ue){const Ie=ue.indexOf(ae);return Ie===-1?$:ue[Ie]}class pe extends k{constructor(){const $={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",$,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(126,null),a.localize(127,null)],default:$.insertMode,description:a.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:$.filterGraceful,description:a.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:$.localityBonus,description:a.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:$.shareSuggestSelections,markdownDescription:a.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(132,null),a.localize(133,null),a.localize(134,null),a.localize(135,null)],default:$.selectionMode,markdownDescription:a.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:$.snippetsPreventQuickSuggestions,description:a.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:$.showIcons,description:a.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:$.showStatusBar,description:a.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:$.preview,description:a.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:$.showInlineDetails,description:a.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{insertMode:t(ue.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ue.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ue.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ue.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ue.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(ue.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(ue.showIcons,this.defaultValue.showIcons),showStatusBar:d(ue.showStatusBar,this.defaultValue.showStatusBar),preview:d(ue.preview,this.defaultValue.preview),previewMode:t(ue.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(ue.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ue.showMethods,this.defaultValue.showMethods),showFunctions:d(ue.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ue.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(ue.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(ue.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(ue.showFields,this.defaultValue.showFields),showVariables:d(ue.showVariables,this.defaultValue.showVariables),showClasses:d(ue.showClasses,this.defaultValue.showClasses),showStructs:d(ue.showStructs,this.defaultValue.showStructs),showInterfaces:d(ue.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ue.showModules,this.defaultValue.showModules),showProperties:d(ue.showProperties,this.defaultValue.showProperties),showEvents:d(ue.showEvents,this.defaultValue.showEvents),showOperators:d(ue.showOperators,this.defaultValue.showOperators),showUnits:d(ue.showUnits,this.defaultValue.showUnits),showValues:d(ue.showValues,this.defaultValue.showValues),showConstants:d(ue.showConstants,this.defaultValue.showConstants),showEnums:d(ue.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ue.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ue.showKeywords,this.defaultValue.showKeywords),showWords:d(ue.showWords,this.defaultValue.showWords),showColors:d(ue.showColors,this.defaultValue.showColors),showFiles:d(ue.showFiles,this.defaultValue.showFiles),showReferences:d(ue.showReferences,this.defaultValue.showReferences),showFolders:d(ue.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ue.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ue.showSnippets,this.defaultValue.showSnippets),showUsers:d(ue.showUsers,this.defaultValue.showUsers),showIssues:d(ue.showIssues,this.defaultValue.showIssues)}}}class Ce extends k{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(174,null),default:!0,type:"boolean"}})}validate($){return!$||typeof $!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d($.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends E{constructor(){super(137)}compute($,ue,Ie){return ue.get(86)?!0:$.tabFocusMode}}var Ve;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Ve=e.WrappingIndent||(e.WrappingIndent={}));class xe extends k{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(175,null),a.localize(176,null),a.localize(177,null),a.localize(178,null)],description:a.localize(179,null),default:"same"}})}validate($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute($,ue,Ie){return ue.get(2)===2?0:Ie}}class et extends E{constructor(){super(139)}compute($,ue,Ie){const Le=ue.get(138);return{isDominatedByLongLines:$.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class Qe extends k{constructor(){const $={enabled:!0};super(33,"dropIntoEditor",$,{"editor.dropIntoEditor.enabled":{type:"boolean",default:$.enabled,markdownDescription:a.localize(180,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?st:R.isLinux?ht:nt,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var rt;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.autoClosingBrackets=5]="autoClosingBrackets",ae[ae.autoClosingDelete=6]="autoClosingDelete",ae[ae.autoClosingOvertype=7]="autoClosingOvertype",ae[ae.autoClosingQuotes=8]="autoClosingQuotes",ae[ae.autoIndent=9]="autoIndent",ae[ae.automaticLayout=10]="automaticLayout",ae[ae.autoSurround=11]="autoSurround",ae[ae.bracketPairColorization=12]="bracketPairColorization",ae[ae.guides=13]="guides",ae[ae.codeLens=14]="codeLens",ae[ae.codeLensFontFamily=15]="codeLensFontFamily",ae[ae.codeLensFontSize=16]="codeLensFontSize",ae[ae.colorDecorators=17]="colorDecorators",ae[ae.colorDecoratorsLimit=18]="colorDecoratorsLimit",ae[ae.columnSelection=19]="columnSelection",ae[ae.comments=20]="comments",ae[ae.contextmenu=21]="contextmenu",ae[ae.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=23]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=25]="cursorStyle",ae[ae.cursorSurroundingLines=26]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=28]="cursorWidth",ae[ae.disableLayerHinting=29]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",ae[ae.domReadOnly=31]="domReadOnly",ae[ae.dragAndDrop=32]="dragAndDrop",ae[ae.dropIntoEditor=33]="dropIntoEditor",ae[ae.emptySelectionClipboard=34]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=36]="extraEditorClassName",ae[ae.fastScrollSensitivity=37]="fastScrollSensitivity",ae[ae.find=38]="find",ae[ae.fixedOverflowWidgets=39]="fixedOverflowWidgets",ae[ae.folding=40]="folding",ae[ae.foldingStrategy=41]="foldingStrategy",ae[ae.foldingHighlight=42]="foldingHighlight",ae[ae.foldingImportsByDefault=43]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=44]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=46]="fontFamily",ae[ae.fontInfo=47]="fontInfo",ae[ae.fontLigatures=48]="fontLigatures",ae[ae.fontSize=49]="fontSize",ae[ae.fontWeight=50]="fontWeight",ae[ae.fontVariations=51]="fontVariations",ae[ae.formatOnPaste=52]="formatOnPaste",ae[ae.formatOnType=53]="formatOnType",ae[ae.glyphMargin=54]="glyphMargin",ae[ae.gotoLocation=55]="gotoLocation",ae[ae.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",ae[ae.hover=57]="hover",ae[ae.inDiffEditor=58]="inDiffEditor",ae[ae.inlineSuggest=59]="inlineSuggest",ae[ae.letterSpacing=60]="letterSpacing",ae[ae.lightbulb=61]="lightbulb",ae[ae.lineDecorationsWidth=62]="lineDecorationsWidth",ae[ae.lineHeight=63]="lineHeight",ae[ae.lineNumbers=64]="lineNumbers",ae[ae.lineNumbersMinChars=65]="lineNumbersMinChars",ae[ae.linkedEditing=66]="linkedEditing",ae[ae.links=67]="links",ae[ae.matchBrackets=68]="matchBrackets",ae[ae.minimap=69]="minimap",ae[ae.mouseStyle=70]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=72]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=74]="multiCursorModifier",ae[ae.multiCursorPaste=75]="multiCursorPaste",ae[ae.multiCursorLimit=76]="multiCursorLimit",ae[ae.occurrencesHighlight=77]="occurrencesHighlight",ae[ae.overviewRulerBorder=78]="overviewRulerBorder",ae[ae.overviewRulerLanes=79]="overviewRulerLanes",ae[ae.padding=80]="padding",ae[ae.parameterHints=81]="parameterHints",ae[ae.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=84]="quickSuggestions",ae[ae.quickSuggestionsDelay=85]="quickSuggestionsDelay",ae[ae.readOnly=86]="readOnly",ae[ae.renameOnType=87]="renameOnType",ae[ae.renderControlCharacters=88]="renderControlCharacters",ae[ae.renderFinalNewline=89]="renderFinalNewline",ae[ae.renderLineHighlight=90]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=92]="renderValidationDecorations",ae[ae.renderWhitespace=93]="renderWhitespace",ae[ae.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",ae[ae.roundedSelection=95]="roundedSelection",ae[ae.rulers=96]="rulers",ae[ae.scrollbar=97]="scrollbar",ae[ae.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=99]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=100]="scrollPredominantAxis",ae[ae.selectionClipboard=101]="selectionClipboard",ae[ae.selectionHighlight=102]="selectionHighlight",ae[ae.selectOnLineNumbers=103]="selectOnLineNumbers",ae[ae.showFoldingControls=104]="showFoldingControls",ae[ae.showUnused=105]="showUnused",ae[ae.snippetSuggestions=106]="snippetSuggestions",ae[ae.smartSelect=107]="smartSelect",ae[ae.smoothScrolling=108]="smoothScrolling",ae[ae.stickyScroll=109]="stickyScroll",ae[ae.stickyTabStops=110]="stickyTabStops",ae[ae.stopRenderingLineAfter=111]="stopRenderingLineAfter",ae[ae.suggest=112]="suggest",ae[ae.suggestFontSize=113]="suggestFontSize",ae[ae.suggestLineHeight=114]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",ae[ae.suggestSelection=116]="suggestSelection",ae[ae.tabCompletion=117]="tabCompletion",ae[ae.tabIndex=118]="tabIndex",ae[ae.unicodeHighlighting=119]="unicodeHighlighting",ae[ae.unusualLineTerminators=120]="unusualLineTerminators",ae[ae.useShadowDOM=121]="useShadowDOM",ae[ae.useTabStops=122]="useTabStops",ae[ae.wordBreak=123]="wordBreak",ae[ae.wordSeparators=124]="wordSeparators",ae[ae.wordWrap=125]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=128]="wordWrapColumn",ae[ae.wordWrapOverride1=129]="wordWrapOverride1",ae[ae.wordWrapOverride2=130]="wordWrapOverride2",ae[ae.wrappingIndent=131]="wrappingIndent",ae[ae.wrappingStrategy=132]="wrappingStrategy",ae[ae.showDeprecated=133]="showDeprecated",ae[ae.inlayHints=134]="inlayHints",ae[ae.editorClassName=135]="editorClassName",ae[ae.pixelRatio=136]="pixelRatio",ae[ae.tabFocusMode=137]="tabFocusMode",ae[ae.layoutInfo=138]="layoutInfo",ae[ae.wrappingInfo=139]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(181,null)})),acceptSuggestionOnEnter:Ue(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(182,null),""],markdownDescription:a.localize(183,null)})),accessibilitySupport:Ue(new n),accessibilityPageSize:Ue(new b(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(184,null),tags:["accessibility"]})),ariaLabel:Ue(new g(4,"ariaLabel",a.localize(185,null))),autoClosingBrackets:Ue(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(186,null),a.localize(187,null),""],description:a.localize(188,null)})),autoClosingDelete:Ue(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(189,null),""],description:a.localize(190,null)})),autoClosingOvertype:Ue(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(191,null),""],description:a.localize(192,null)})),autoClosingQuotes:Ue(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(193,null),a.localize(194,null),""],description:a.localize(195,null)})),autoIndent:Ue(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[a.localize(196,null),a.localize(197,null),a.localize(198,null),a.localize(199,null),a.localize(200,null)],description:a.localize(201,null)})),automaticLayout:Ue(new f(10,"automaticLayout",!1)),autoSurround:Ue(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),""],description:a.localize(205,null)})),bracketPairColorization:Ue(new he),bracketPairGuides:Ue(new ve),stickyTabStops:Ue(new f(110,"stickyTabStops",!1,{description:a.localize(206,null)})),codeLens:Ue(new f(14,"codeLens",!0,{description:a.localize(207,null)})),codeLensFontFamily:Ue(new g(15,"codeLensFontFamily","",{description:a.localize(208,null)})),codeLensFontSize:Ue(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(209,null)})),colorDecorators:Ue(new f(17,"colorDecorators",!0,{description:a.localize(210,null)})),colorDecoratorsLimit:Ue(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(211,null)})),columnSelection:Ue(new f(19,"columnSelection",!1,{description:a.localize(212,null)})),comments:Ue(new m),contextmenu:Ue(new f(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new f(22,"copyWithSyntaxHighlighting",!0,{description:a.localize(213,null)})),cursorBlinking:Ue(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:a.localize(214,null)})),cursorSmoothCaretAnimation:Ue(new l(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(215,null),a.localize(216,null),a.localize(217,null)],description:a.localize(218,null)})),cursorStyle:Ue(new r(25,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:a.localize(219,null)})),cursorSurroundingLines:Ue(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(220,null)})),cursorSurroundingLinesStyle:Ue(new l(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(221,null),a.localize(222,null)],description:a.localize(223,null)})),cursorWidth:Ue(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(224,null)})),disableLayerHinting:Ue(new f(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new f(30,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new f(31,"domReadOnly",!1)),dragAndDrop:Ue(new f(32,"dragAndDrop",!0,{description:a.localize(225,null)})),emptySelectionClipboard:Ue(new x),dropIntoEditor:Ue(new Qe),stickyScroll:Ue(new ee),experimentalWhitespaceRendering:Ue(new l(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(226,null),a.localize(227,null),a.localize(228,null)],description:a.localize(229,null)})),extraEditorClassName:Ue(new g(36,"extraEditorClassName","")),fastScrollSensitivity:Ue(new S(37,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:a.localize(230,null)})),find:Ue(new q),fixedOverflowWidgets:Ue(new f(39,"fixedOverflowWidgets",!1)),folding:Ue(new f(40,"folding",!0,{description:a.localize(231,null)})),foldingStrategy:Ue(new l(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(232,null),a.localize(233,null)],description:a.localize(234,null)})),foldingHighlight:Ue(new f(42,"foldingHighlight",!0,{description:a.localize(235,null)})),foldingImportsByDefault:Ue(new f(43,"foldingImportsByDefault",!1,{description:a.localize(236,null)})),foldingMaximumRegions:Ue(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(237,null)})),unfoldOnClickAfterEndOfLine:Ue(new f(45,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(238,null)})),fontFamily:Ue(new g(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(239,null)})),fontInfo:Ue(new O),fontLigatures2:Ue(new M),fontSize:Ue(new U),fontWeight:Ue(new z),fontVariations:Ue(new B),formatOnPaste:Ue(new f(52,"formatOnPaste",!1,{description:a.localize(240,null)})),formatOnType:Ue(new f(53,"formatOnType",!1,{description:a.localize(241,null)})),glyphMargin:Ue(new f(54,"glyphMargin",!0,{description:a.localize(242,null)})),gotoLocation:Ue(new j),hideCursorInOverviewRuler:Ue(new f(56,"hideCursorInOverviewRuler",!1,{description:a.localize(243,null)})),hover:Ue(new le),inDiffEditor:Ue(new f(58,"inDiffEditor",!1)),letterSpacing:Ue(new S(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>S.clamp(ae,-5,20),{description:a.localize(244,null)})),lightbulb:Ue(new ie),lineDecorationsWidth:Ue(new G),lineHeight:Ue(new de),lineNumbers:Ue(new Z),lineNumbersMinChars:Ue(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new f(66,"linkedEditing",!1,{description:a.localize(245,null)})),links:Ue(new f(67,"links",!0,{description:a.localize(246,null)})),matchBrackets:Ue(new l(68,"matchBrackets","always",["always","near","never"],{description:a.localize(247,null)})),minimap:Ue(new be),mouseStyle:Ue(new l(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new S(71,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:a.localize(248,null)})),mouseWheelZoom:Ue(new f(72,"mouseWheelZoom",!1,{markdownDescription:a.localize(249,null)})),multiCursorMergeOverlapping:Ue(new f(73,"multiCursorMergeOverlapping",!0,{description:a.localize(250,null)})),multiCursorModifier:Ue(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[a.localize(251,null),a.localize(252,null)],markdownDescription:a.localize(253,null)})),multiCursorPaste:Ue(new l(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(254,null),a.localize(255,null)],markdownDescription:a.localize(256,null)})),multiCursorLimit:Ue(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(257,null)})),occurrencesHighlight:Ue(new f(77,"occurrencesHighlight",!0,{description:a.localize(258,null)})),overviewRulerBorder:Ue(new f(78,"overviewRulerBorder",!0,{description:a.localize(259,null)})),overviewRulerLanes:Ue(new b(79,"overviewRulerLanes",3,0,3)),padding:Ue(new Pe),parameterHints:Ue(new Fe),peekWidgetDefaultFocus:Ue(new l(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(260,null),a.localize(261,null)],description:a.localize(262,null)})),definitionLinkOpensInPeek:Ue(new f(83,"definitionLinkOpensInPeek",!1,{description:a.localize(263,null)})),quickSuggestions:Ue(new oe),quickSuggestionsDelay:Ue(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(264,null)})),readOnly:Ue(new f(86,"readOnly",!1)),renameOnType:Ue(new f(87,"renameOnType",!1,{description:a.localize(265,null),markdownDeprecationMessage:a.localize(266,null)})),renderControlCharacters:Ue(new f(88,"renderControlCharacters",!0,{description:a.localize(267,null),restricted:!0})),renderFinalNewline:Ue(new l(89,"renderFinalNewline",R.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(268,null)})),renderLineHighlight:Ue(new l(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(269,null)],description:a.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Ue(new f(91,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(271,null)})),renderValidationDecorations:Ue(new l(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new l(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(272,null),a.localize(273,null),a.localize(274,null),""],description:a.localize(275,null)})),revealHorizontalRightPadding:Ue(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new f(95,"roundedSelection",!0,{description:a.localize(276,null)})),rulers:Ue(new ne),scrollbar:Ue(new H),scrollBeyondLastColumn:Ue(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(277,null)})),scrollBeyondLastLine:Ue(new f(99,"scrollBeyondLastLine",!0,{description:a.localize(278,null)})),scrollPredominantAxis:Ue(new f(100,"scrollPredominantAxis",!0,{description:a.localize(279,null)})),selectionClipboard:Ue(new f(101,"selectionClipboard",!0,{description:a.localize(280,null),included:R.isLinux})),selectionHighlight:Ue(new f(102,"selectionHighlight",!0,{description:a.localize(281,null)})),selectOnLineNumbers:Ue(new f(103,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new l(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(282,null),a.localize(283,null),a.localize(284,null)],description:a.localize(285,null)})),showUnused:Ue(new f(105,"showUnused",!0,{description:a.localize(286,null)})),showDeprecated:Ue(new f(133,"showDeprecated",!0,{description:a.localize(287,null)})),inlayHints:Ue(new K),snippetSuggestions:Ue(new l(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(288,null),a.localize(289,null),a.localize(290,null),a.localize(291,null)],description:a.localize(292,null)})),smartSelect:Ue(new Ce),smoothScrolling:Ue(new f(108,"smoothScrolling",!1,{description:a.localize(293,null)})),stopRenderingLineAfter:Ue(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new pe),inlineSuggest:Ue(new Y),suggestFontSize:Ue(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new f(115,"suggestOnTriggerCharacters",!0,{description:a.localize(296,null)})),suggestSelection:Ue(new l(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null),a.localize(299,null)],description:a.localize(300,null)})),tabCompletion:Ue(new l(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],description:a.localize(304,null)})),tabIndex:Ue(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new Q),unusualLineTerminators:Ue(new l(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(305,null),a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),useShadowDOM:Ue(new f(121,"useShadowDOM",!0)),useTabStops:Ue(new f(122,"useTabStops",!0,{description:a.localize(309,null)})),wordBreak:Ue(new l(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(310,null),a.localize(311,null)],description:a.localize(312,null)})),wordSeparators:Ue(new g(124,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:a.localize(313,null)})),wordWrap:Ue(new l(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(314,null),a.localize(315,null),a.localize(316,null),a.localize(317,null)],description:a.localize(318,null)})),wordWrapBreakAfterCharacters:Ue(new g(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new g(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(319,null)})),wordWrapOverride1:Ue(new l(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new l(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new F),pixelRatio:Ue(new se),tabFocusMode:Ue(new ke),layoutInfo:Ue(new _),wrappingInfo:Ue(new et),wrappingIndent:Ue(new xe),wrappingStrategy:Ue(new J)}}),define(ye[168],De([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[169],De([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[170],De([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[171],De([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[172],De([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ye[173],De([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ye[174],De([19,20]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[175],De([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ye[176],De([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[177],De([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[178],De([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[179],De([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[180],De([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[181],De([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[182],De([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[183],De([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[184],De([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[185],De([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ye[186],De([19,20]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(ye[187],De([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[188],De([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[189],De([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[190],De([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[191],De([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[192],De([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[193],De([19,20]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[194],De([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[195],De([1,0,11]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class R{constructor(){this.a=new Map}register(u,C){this.a.set(u,C)}updateManifest(u){if(!(typeof u.main>"u"&&typeof u.browser>"u")&&(u.activationEvents===void 0&&Object.assign(u,{activationEvents:[]}),!(!Array.isArray(u.activationEvents)||!u.contributes)))for(const C in u.contributes){const A=this.a.get(C);if(!A)continue;const y=u.contributes[C],I=Array.isArray(y)?y:[y];try{A(I,u.activationEvents)}catch(L){(0,a.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=R,e.ImplicitActivationEvents=new R}),define(ye[196],De([1,0,24,37,170,317]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(f){return f=f.trim(),f==="*"||C.test(f)}e.isValidVersionStr=y;function I(f){if(!y(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(C);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=I;function L(f){if(!f)return null;const p=f.majorBase,b=f.majorMustEqual,S=f.minorBase;let g=f.minorMustEqual;const t=f.patchBase;let l=f.patchMustEqual;f.hasCaret&&(p===0||(g=!1),l=!1);let r=0;if(f.preRelease){const o=A.exec(f.preRelease);if(o){const[,n,m,s]=o;r=Date.UTC(Number(n),Number(m)-1,Number(s))}}return{majorBase:p,majorMustEqual:b,minorBase:S,minorMustEqual:g,patchBase:t,patchMustEqual:l,isMinimum:f.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function k(f,p,b){let S;typeof f=="string"?S=L(I(f)):S=f;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let t;if(typeof b=="string"?t=L(I(b)):t=b,!S||!t)return!1;const l=S.majorBase,r=S.minorBase,o=S.patchBase;let n=t.majorBase,m=t.minorBase,s=t.patchBase;const i=t.notBefore;let c=t.majorMustEqual,w=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?l>n?!0:l<n?!1:r>m?!0:r<m||g&&g<i?!1:o>=s:(l===1&&n===0&&(!c||!w||!D)&&(n=1,m=0,s=0,c=!0,w=!1,D=!1),l<n?!1:l>n?!c:r<m?!1:r>m?!w:o<s?!1:o>s?!D:!(g&&g<i))}e.isValidVersion=k;function v(f,p,b,S,g){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([R.default.Error,T.localize(0,null)]),t;if(typeof S.name!="string")return t.push([R.default.Error,T.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([R.default.Error,T.localize(2,null,"version")]),t;if(!S.engines)return t.push([R.default.Error,T.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([R.default.Error,T.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!d(S.extensionDependencies))return t.push([R.default.Error,T.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!d(S.activationEvents))return t.push([R.default.Error,T.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([R.default.Error,T.localize(7,null,"activationEvents","main")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([R.default.Warning,T.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([R.default.Error,T.localize(9,null,"main")]),t;{const o=(0,a.joinPath)(b,S.main);(0,a.isEqualOrParent)(o,b)||t.push([R.default.Warning,T.localize(10,null,o.path,b.path)])}if(typeof S.activationEvents>"u")return t.push([R.default.Error,T.localize(11,null,"activationEvents","main")]),t}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([R.default.Error,T.localize(12,null,"browser")]),t;{const o=(0,a.joinPath)(b,S.browser);(0,a.isEqualOrParent)(o,b)||t.push([R.default.Warning,T.localize(13,null,o.path,b.path)])}if(typeof S.activationEvents>"u")return t.push([R.default.Error,T.localize(14,null,"activationEvents","browser")]),t}if(!u.valid(S.version))return t.push([R.default.Error,T.localize(15,null)]),t;const l=[];if(!P(f,p,S,g,l))for(const o of l)t.push([R.default.Error,o]);return t}e.validateExtensionManifest=v;function P(f,p,b,S,g){return S||typeof b.main>"u"&&typeof b.browser>"u"?!0:h(f,p,b.engines.vscode,g)}e.isValidExtensionVersion=P;function E(f,p,b){return f==="*"||h(p,b,f)}e.isEngineValid=E;function h(f,p,b,S=[]){const g=L(I(b));if(!g)return S.push(T.localize(16,null,b)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return S.push(T.localize(17,null,b)),!1}else if(!g.majorMustEqual)return S.push(T.localize(18,null,b)),!1;return k(f,p,g)?!0:(S.push(T.localize(19,null,f,b)),!1)}function d(f){if(!Array.isArray(f))return!1;for(let p=0,b=f.length;p<b;p++)if(typeof f[p]!="string")return!1;return!0}}),define(ye[122],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(T,u=[],C=!1){this.ctor=T,this.staticArguments=u,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=a}),define(ye[89],De([1,0,122]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var T;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(T=e.InstantiationType||(e.InstantiationType={}));function u(A,y,I){y instanceof a.SyncDescriptor||(y=new a.SyncDescriptor(y,[],Boolean(I))),R.push([A,y])}e.registerSingleton=u;function C(){return R}e.getSingletonServiceDescriptors=C}),define(ye[197],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(u,C){this.key=u,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class R{constructor(u){this.b=u,this.a=new Map}roots(){const u=[];for(const C of this.a.values())C.outgoing.size===0&&u.push(C);return u}insertEdge(u,C){const A=this.lookupOrInsertNode(u),y=this.lookupOrInsertNode(C);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(u){const C=this.b(u);this.a.delete(C);for(const A of this.a.values())A.outgoing.delete(C),A.incoming.delete(C)}lookupOrInsertNode(u){const C=this.b(u);let A=this.a.get(C);return A||(A=new a(C,u),this.a.set(C,A)),A}lookup(u){return this.a.get(this.b(u))}isEmpty(){return this.a.size===0}toString(){const u=[];for(const[C,A]of this.a)u.push(`${C}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return u.join(`
`)}findCycleSlow(){for(const[u,C]of this.a){const A=new Set([u]),y=this.c(C,A);if(y)return y}}c(u,C){for(const[A,y]of u.outgoing){if(C.has(A))return[...C,A].join(" -> ");C.add(A);const I=this.c(y,C);if(I)return I;C.delete(A)}}}e.Graph=R}),define(ye[4],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=A})(a=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function R(C,A,y){A[a.DI_TARGET]===A?A[a.DI_DEPENDENCIES].push({id:C,index:y}):(A[a.DI_DEPENDENCIES]=[{id:C,index:y}],A[a.DI_TARGET]=A)}function T(C){if(a.serviceIds.has(C))return a.serviceIds.get(C);const A=function(y,I,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(A,y,L)};return A.toString=()=>C,a.serviceIds.set(C,A),A}e.createDecorator=T;function u(C){return C}e.refineServiceDecorator=u}),define(ye[53],De([1,0,9,2,4]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function u(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof R.URI)}e.isConfigurationOverrides=u;function C(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=C;var A;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function I(f,p){const b=Object.create(null);for(const S in f)L(b,S,f[S],p);return b}e.toValuesTree=I;function L(f,p,b,S){const g=p.split("."),t=g.pop();let l=f;for(let r=0;r<g.length;r++){const o=g[r];let n=l[o];switch(typeof n){case"undefined":n=l[o]=Object.create(null);break;case"object":break;default:S(`Ignoring ${p} as ${g.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[t]=b}catch{S(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(l)}`)}else S(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=L;function k(f,p){const b=p.split(".");v(f,b)}e.removeFromValueTree=k;function v(f,p){const b=p.shift();if(p.length===0){delete f[b];return}if(Object.keys(f).indexOf(b)!==-1){const S=f[b];typeof S=="object"&&!Array.isArray(S)&&(v(S,p),Object.keys(S).length===0&&delete f[b])}}function P(f,p,b){function S(l,r){let o=l;for(const n of r){if(typeof o!="object"||o===null)return;o=o[n]}return o}const g=p.split("."),t=S(f,g);return typeof t>"u"?b:t}e.getConfigurationValue=P;function E(f,p,b){Object.keys(p).forEach(S=>{S!=="__proto__"&&(S in f?a.isObject(f[S])&&a.isObject(p[S])?E(f[S],p[S],b):b&&(f[S]=p[S]):f[S]=p[S])})}e.merge=E;function h(f,p,b){const S=f.inspect(p),g=f.inspect(b);return typeof S.userValue<"u"||typeof S.workspaceValue<"u"||typeof S.workspaceFolderValue<"u"?S.value:typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:S.defaultValue}e.getMigratedSettingValue=h;function d(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(ye[54],De([1,0,12,8,4]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",a.isMacintosh),u.set("isLinux",a.isLinux),u.set("isWindows",a.isWindows),u.set("isWeb",a.isWeb),u.set("isMacNative",a.isMacintosh&&!a.isWeb),u.set("isEdge",a.isEdge),u.set("isFirefox",a.isFirefox),u.set("isChrome",a.isChrome),u.set("isSafari",a.isSafari);const C=Object.prototype.hasOwnProperty;var A;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return k.INSTANCE}static true(){return v.INSTANCE}static has(M){return P.create(M)}static equals(M,B){return E.create(M,B)}static notEquals(M,B){return f.create(M,B)}static regex(M,B){return r.create(M,B)}static in(M,B){return h.create(M,B)}static notIn(M,B){return d.create(M,B)}static not(M){return p.create(M)}static and(...M){return m.create(M,null,!0)}static or(...M){return s.create(M,null,!0)}static greater(M,B){return S.create(M,B)}static greaterEquals(M,B){return g.create(M,B)}static smaller(M,B){return t.create(M,B)}static smallerEquals(M,B){return l.create(M,B)}static deserialize(M,B=!1){if(!!M)return this.c(M,B)}static c(M,B){const O=M.split("||");return s.create(O.map(U=>this.d(U,B)),null,!0)}static d(M,B){const O=M.split("&&");return m.create(O.map(U=>this.f(U,B)),null,!0)}static f(M,B){if(M=M.trim(),M.indexOf("!=")>=0){const O=M.split("!=");return f.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf("==")>=0){const O=M.split("==");return E.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf("=~")>=0){const O=M.split("=~");return r.create(O[0].trim(),this.h(O[1],B))}if(M.indexOf(" not in ")>=0){const O=M.split(" not in ");return d.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf(" in ")>=0){const O=M.split(" in ");return h.create(O[0].trim(),this.g(O[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(M)){const O=M.split(">=");return g.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(M)){const O=M.split(">");return S.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(M)){const O=M.split("<=");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(M)){const O=M.split("<");return t.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(M)?p.create(M.substr(1).trim()):P.create(M)}static g(M,B){if(M=M.trim(),M==="true")return!0;if(M==="false")return!1;const O=/^'([^']*)'$/.exec(M);return O?O[1].trim():M}static h(M,B){if((0,R.isFalsyOrWhitespace)(M)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=M.indexOf("/"),U=M.lastIndexOf("/");if(O===U||O<0){if(B)throw new Error(`bad regexp-value '${M}', missing /-enclosure`);return console.warn(`bad regexp-value '${M}', missing /-enclosure`),null}const z=M.slice(O+1,U),j=M[U+1]==="i"?"i":"";try{return new RegExp(z,j)}catch(le){if(B)throw new Error(`bad regexp-value '${M}', parse error: ${le}`);return console.warn(`bad regexp-value '${M}', parse error: ${le}`),null}}}e.ContextKeyExpr=y;function I(q,M){const B=q?q.substituteConstants():void 0,O=M?M.substituteConstants():void 0;return!B&&!O?!0:!B||!O?!1:B.equals(O)}e.expressionsAreEqualWithConstantSubstitution=I;function L(q,M){return q.cmp(M)}class k{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class v{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class P{static create(M,B=null){const O=u.get(M);return typeof O=="boolean"?O?v.INSTANCE:k.INSTANCE:new P(M,B)}constructor(M,B){this.key=M,this.c=B,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:c(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=u.get(this.key);return typeof M=="boolean"?M?v.INSTANCE:k.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=P;class E{static create(M,B,O=null){if(typeof B=="boolean")return B?P.create(M,O):p.create(M,O);const U=u.get(M);return typeof U=="boolean"?B===(U?"true":"false")?v.INSTANCE:k.INSTANCE:new E(M,B,O)}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=u.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?v.INSTANCE:k.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=E;class h{static create(M,B){return new h(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:w(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.f),O=M.getValue(this.d);return Array.isArray(B)?B.includes(O):typeof O=="string"&&typeof B=="object"&&B!==null?C.call(B,O):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=h;class d{static create(M,B){return new d(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=11,this.c=h.create(M,B)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=d;class f{static create(M,B,O=null){if(typeof B=="boolean")return B?p.create(M,O):P.create(M,O);const U=u.get(M);return typeof U=="boolean"?B===(U?"true":"false")?k.INSTANCE:v.INSTANCE:new f(M,B,O)}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=u.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?k.INSTANCE:v.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=f;class p{static create(M,B=null){const O=u.get(M);return typeof O=="boolean"?O?k.INSTANCE:v.INSTANCE:new p(M,B)}constructor(M,B){this.c=M,this.d=B,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:c(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=u.get(this.c);return typeof M=="boolean"?M?k.INSTANCE:v.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=P.create(this.c,this)),this.d}}e.ContextKeyNotExpr=p;function b(q,M){if(typeof q=="string"){const B=parseFloat(q);isNaN(B)||(q=B)}return typeof q=="string"||typeof q=="number"?M(q):k.INSTANCE}class S{static create(M,B,O=null){return b(B,U=>new S(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=S;class g{static create(M,B,O=null){return b(B,U=>new g(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=g;class t{static create(M,B,O=null){return b(B,U=>new t(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=t;class l{static create(M,B,O=null){return b(B,U=>new l(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=l;class r{static create(M,B){return new r(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const B=this.f?this.f.source:"",O=M.f?M.f.source:"";return B<O?-1:B>O?1:0}equals(M){if(M.type===this.type){const B=this.f?this.f.source:"",O=M.f?M.f.source:"";return this.d===M.d&&B===O}return!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=o.create(this)),this.c}}e.ContextKeyRegexExpr=r;class o{static create(M){return new o(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(M){return new o(this.c.map(M))}negate(){return this.c}}e.ContextKeyNotRegexExpr=o;function n(q){let M=null;for(let B=0,O=q.length;B<O;B++){const U=q[B].substituteConstants();if(q[B]!==U&&M===null){M=[];for(let z=0;z<B;z++)M[z]=q[z]}M!==null&&(M[B]=U)}return M===null?q:M}class m{static create(M,B,O){return m.d(M,B,O)}constructor(M,B){this.expr=M,this.c=B,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],M.expr[B]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=n(this.expr);return M===this.expr?this:m.create(M,this.c,!1)}evaluate(M){for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].evaluate(M))return!1;return!0}static d(M,B,O){const U=[];let z=!1;for(const j of M)if(!!j){if(j.type===1){z=!0;continue}if(j.type===0)return k.INSTANCE;if(j.type===6){U.push(...j.expr);continue}U.push(j)}if(U.length===0&&z)return v.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];for(;U.length>1;){const j=U[U.length-1];if(j.type!==9)break;U.pop();const le=U.pop(),V=U.length===0,_=s.create(j.expr.map(J=>m.create([J,le],null,O)),null,V);_&&(U.push(_),U.sort(L))}if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let le=j+1;le<U.length;le++)if(U[j].negate().equals(U[le]))return k.INSTANCE;if(U.length===1)return U[0]}return new m(U,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new m(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());this.c=s.create(M,this,!0)}return this.c}}class s{static create(M,B,O){return s.d(M,B,O)}constructor(M,B){this.expr=M,this.c=B,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],M.expr[B]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=n(this.expr);return M===this.expr?this:s.create(M,this.c,!1)}evaluate(M){for(let B=0,O=this.expr.length;B<O;B++)if(this.expr[B].evaluate(M))return!0;return!1}static d(M,B,O){let U=[],z=!1;if(M){for(let j=0,le=M.length;j<le;j++){const V=M[j];if(!!V){if(V.type===0){z=!0;continue}if(V.type===1)return v.INSTANCE;if(V.type===9){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&z)return k.INSTANCE;U.sort(L)}if(U.length!==0){if(U.length===1)return U[0];for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let le=j+1;le<U.length;le++)if(U[j].negate().equals(U[le]))return v.INSTANCE;if(U.length===1)return U[0]}return new s(U,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new s(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());for(;M.length>1;){const B=M.shift(),O=M.shift(),U=[];for(const z of x(B))for(const j of x(O))U.push(m.create([z,j],null,!1));M.unshift(s.create(U,null,!1))}this.c=s.create(M,this,!0)}return this.c}}class i extends P{static all(){return i.d.values()}constructor(M,B,O){super(M,null),this.f=B,typeof O=="object"?i.d.push({...O,key:M}):O!==!0&&i.d.push({key:M,description:O,type:B!=null?typeof B:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return E.create(this.key,M)}notEqualsTo(M){return f.create(this.key,M)}}e.RawContextKey=i,i.d=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService");function c(q,M){return q<M?-1:q>M?1:0}function w(q,M,B,O){return q<B?-1:q>B?1:M<O?-1:M>O?1:0}function D(q,M){if(q.type===0||M.type===1)return!0;if(q.type===9)return M.type===9?F(q.expr,M.expr):!1;if(M.type===9){for(const B of M.expr)if(D(q,B))return!0;return!1}if(q.type===6){if(M.type===6)return F(M.expr,q.expr);for(const B of q.expr)if(D(B,M))return!0;return!1}return q.equals(M)}e.implies=D;function F(q,M){let B=0,O=0;for(;B<q.length&&O<M.length;){const U=q[B].cmp(M[O]);if(U<0)return!1;U===0&&B++,O++}return B===q.length}function x(q){return q.type===9?q.expr:[q]}}),define(ye[198],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[123],De([1,0,169,4]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function u(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=u;function C(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function A(f,p){return p==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(f,p,b){return A(p,b)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===b?!0:I(b).includes(f)}e.isTargetPlatformCompatible=y;function I(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L;var k;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var v;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var P;(function(f){f.Install="install",f.Uninstall="uninstall"})(P=e.StatisticType||(e.StatisticType={}));var E;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var h;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(p,b){super(p),this.code=b,this.name=b}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ye[199],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(ye[200],De([1,0,46,16,10,12,109,29,116,171,199]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=I.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:P.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class P extends v{openTerminal(S,g){return this.spawnTerminal(a,S,y.getWindowsShell(),g)}spawnTerminal(S,g,t,l){const r=g.windowsExec||P.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const o=T.basename(r).toLowerCase();if(o==="cmder"||o==="cmder.exe")return S.spawn(r,l?[l]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),(o==="wt"||o==="wt.exe")&&n.push("-d ."),new Promise((m,s)=>{const i=d(process),c=S.spawn(t,n,{cwd:l,env:i});c.on("error",s),c.on("exit",()=>m())})}runInTerminal(S,g,t,l,r){const o="windowsExec"in r&&r.windowsExec?r.windowsExec:P.getDefaultTerminalWindows();return new Promise((n,m)=>{const s=`"${g} - ${k}"`,i=`""${t.join('" "')}" & pause"`,c=["/c","start",s,"/wait",o,"/c",i],w=Object.assign({},d(process),l);Object.keys(w).filter(x=>w[x]===null).forEach(x=>delete w[x]);const D={cwd:g,env:w,windowsVerbatimArguments:!0};a.spawn(P.b,c,D).on("error",x=>{m(f(x))}),n(void 0)})}static getDefaultTerminalWindows(){if(!P.d){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");P.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return P.d}}e.WindowsExternalTerminalService=P,P.b="cmd.exe";class E extends v{openTerminal(S,g){return this.spawnTerminal(a,S,g)}runInTerminal(S,g,t,l,r){const o=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((n,m)=>{if(o===L.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const s=o===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",c=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`).fsPath,"-t",S||k,"-w",g];for(const F of t)c.push("-a"),c.push(F);if(l){const F=Object.assign({},d(process),l);for(const x in F){const q=F[x];q===null?(c.push("-u"),c.push(x)):(c.push("-e"),c.push(`${x}=${q}`))}}let w="";const D=a.spawn(E.b,c);D.on("error",F=>{m(f(F))}),D.stderr.on("data",F=>{w+=F.toString()}),D.on("exit",F=>{if(F===0)n(void 0);else if(w){const x=w.split(`
`,1);m(new Error(x[0]))}else m(new Error(I.localize(1,null,s,F)))})}else m(new Error(I.localize(2,null,o)))})}spawnTerminal(S,g,t){const l=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{const n=["-a",l];t&&n.push(t);const m=d(process),s=S.spawn("/usr/bin/open",n,{cwd:t,env:m});s.on("error",o),s.on("exit",()=>r())})}}e.MacExternalTerminalService=E,E.b="/usr/bin/osascript";class h extends v{openTerminal(S,g){return this.spawnTerminal(a,S,g)}runInTerminal(S,g,t,l,r){const o=r.linuxExec?Promise.resolve(r.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((n,m)=>{const s=[];o.then(i=>{i.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const c=`${p(t)}; echo; read -p "${h.b}" -n1;`;s.push(`''${c}''`);const w=Object.assign({},d(process),l);Object.keys(w).filter(q=>w[q]===null).forEach(q=>delete w[q]);const D={cwd:g,env:w};let F="";const x=a.spawn(i,s,D);x.on("error",q=>{m(f(q))}),x.stderr.on("data",q=>{F+=q.toString()}),x.on("exit",q=>{if(q===0)n(void 0);else if(F){const M=F.split(`
`,1);m(new Error(M[0]))}else m(new Error(I.localize(4,null,i,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!h.d)if(!u.isLinux)h.d=Promise.resolve("xterm");else{const S=await A.Promises.exists("/etc/debian_version");h.d=new Promise(g=>{S?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return h.d}spawnTerminal(S,g,t){const l=g.linuxExec?Promise.resolve(g.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{l.then(n=>{const m=d(process),s=S.spawn(n,[],{cwd:t,env:m});s.on("error",o),s.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=h,h.b=I.localize(3,null);function d(b){const S={...b.env};return(0,C.sanitizeProcessEnvironment)(S),S}function f(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(I.localize(5,null,b.path)):b}function p(b){let S="";for(const g of b)g.indexOf(" ")>=0?S+='"'+g+'"':S+=g,S+=" ";return S}}),define(ye[44],De([1,0,68,10,8,9,2,172,4,12]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function L(V){return V.create===!0}e.isFileOpenForWriteOptions=L;var k;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(k=e.FileType||(e.FileType={}));var v;(function(V){V[V.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var P;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=E;function h(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=h;function d(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=d;function f(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function p(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=p;function b(V){return E(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var S;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(_,J){super(_),this.code=J}}e.FileSystemProviderError=g;function t(V,_){const J=new g(V.toString(),_);return r(J,_),J}e.createFileSystemProviderError=t;function l(V){return V||t((0,A.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=l;function r(V,_){return V.name=_?`${_} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=r;function o(V){if(!V)return S.Unknown;if(V instanceof g)return V.code;const _=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!_)return S.Unknown;switch(_[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=o;function n(V){if(V instanceof D)return V.fileOperationResult;switch(o(V)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var m;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(m=e.FileOperation||(e.FileOperation={}));class s{constructor(_,J,ie){this.resource=_,this.operation=J,this.target=ie}isOperation(_){return this.operation===_}}e.FileOperationEvent=s;var i;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class c{constructor(_,J){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const ee of _){const K=ie.get(ee.type);switch(K?K.push([ee.resource,ee]):ie.set(ee.type,[[ee.resource,ee]]),ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}}for(const[ee,K]of ie)switch(ee){case 1:this.a=a.TernarySearchTree.forUris(()=>J),this.a.fill(K);break;case 0:this.b=a.TernarySearchTree.forUris(()=>J),this.b.fill(K);break;case 2:this.c=a.TernarySearchTree.forUris(()=>J),this.c.fill(K);break}}contains(_,...J){return this.d(_,{includeChildren:!1},...J)}affects(_,...J){return this.d(_,{includeChildren:!0},...J)}d(_,J,...ie){if(!_)return!1;const ee=ie.length>0;return!!((!ee||ie.includes(1))&&(this.a?.get(_)||J.includeChildren&&this.a?.findSuperstr(_))||(!ee||ie.includes(0))&&(this.b?.get(_)||J.includeChildren&&this.b?.findSuperstr(_))||(!ee||ie.includes(2))&&(this.c?.findSubstr(_)||J.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=c;function w(V,_,J){return!V||!_||V===_||_.length>V.length?!1:(_.charAt(_.length-1)!==R.sep&&(_+=R.sep),J?(0,T.startsWithIgnoreCase)(V,_):V.indexOf(_)===0)}e.isParent=w;class D extends Error{constructor(_,J,ie){super(_),this.fileOperationResult=J,this.options=ie}}e.FileOperationError=D;class F extends D{constructor(_,J,ie,ee){super(_,J,ee),this.fileOperationResult=J,this.size=ie}}e.TooLargeFileOperationError=F;class x extends D{constructor(_,J,ie){super(_,2,ie),this.stat=J}}e.NotModifiedSinceFileOperationError=x;var q;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=B;async function O(V,_){if(!_.hasProvider(C.URI.from({scheme:V.scheme})))return new Promise(J=>{const ie=_.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===V.scheme&&ee.added&&(ie.dispose(),J())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(_){return(0,u.isNumber)(_)||(_=0),_<U.KB?(0,A.localize)(1,null,_.toFixed(0)):_<U.MB?(0,A.localize)(2,null,(_/U.KB).toFixed(2)):_<U.GB?(0,A.localize)(3,null,(_/U.MB).toFixed(2)):_<U.TB?(0,A.localize)(4,null,(_/U.GB).toFixed(2)):(0,A.localize)(5,null,(_/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var z;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function j(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformFileLimits=j;function le(V){return I.isWeb?V?10*U.MB:50*U.MB:V?100*U.MB:1024*U.MB}e.getLargeFileConfirmationLimit=le}),define(ye[90],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...T){this.a=new Map;for(const[u,C]of T)this.set(u,C)}set(T,u){const C=this.a.get(T);return this.a.set(T,u),C}has(T){return this.a.has(T)}get(T){return this.a.get(T)}}e.ServiceCollection=a}),define(ye[201],De([1,0,17,11,6,122,197,4,90,66]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class k extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class v{constructor(d=new y.ServiceCollection,f=!1,p,b=L){this.f=d,this.g=f,this.h=p,this.i=b,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=b?p?._globalGraph??new C.Graph(S=>S):void 0}createChild(d){return new v(d,this.g,this,this.i)}invokeFunction(d,...f){const p=E.traceInvocation(this.i,d);let b=!1;try{return d({get:g=>{if(b)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(g,p);if(!t)throw new Error(`[invokeFunction] unknown service '${g}'`);return t}},...f)}finally{b=!0,p.stop()}}createInstance(d,...f){let p,b;return d instanceof u.SyncDescriptor?(p=E.traceCreation(this.i,d.ctor),b=this.j(d.ctor,d.staticArguments.concat(f),p)):(p=E.traceCreation(this.i,d),b=this.j(d,f,p)),p.stop(),b}j(d,f=[],p){const b=A._util.getServiceDependencies(d).sort((t,l)=>t.index-l.index),S=[];for(const t of b){const l=this.m(t.id,p);l||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(l)}const g=b.length>0?b[0].index:f.length;if(f.length!==g){console.trace(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${f.length} static arguments`);const t=g-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,g)}return Reflect.construct(d,f.concat(S))}k(d,f){if(this.f.get(d)instanceof u.SyncDescriptor)this.f.set(d,f);else if(this.h)this.h.k(d,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const f=this.f.get(d);return!f&&this.h?this.h.l(d):f}m(d,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const p=this.l(d);return p instanceof u.SyncDescriptor?this.q(d,p,f.branch(d,!0)):(f.branch(d,!1),p)}q(d,f,p){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,f,p)}finally{this.o.delete(d)}}r(d,f,p){const b=new C.Graph(t=>t.id.toString());let S=0;const g=[{id:d,desc:f,_trace:p}];for(;g.length;){const t=g.pop();if(b.lookupOrInsertNode(t),S++>1e3)throw new k(b);for(const l of A._util.getServiceDependencies(t.desc.ctor)){const r=this.l(l.id);if(r||this.u(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),r instanceof u.SyncDescriptor){const o={id:l.id,desc:r,_trace:t._trace.branch(l.id,!0)};b.insertEdge(t,o),g.push(o)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new k(b);break}for(const{data:l}of t){if(this.l(l.id)instanceof u.SyncDescriptor){const o=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,o)}b.removeNode(l)}}return this.l(d)}s(d,f,p=[],b,S){if(this.f.get(d)instanceof u.SyncDescriptor)return this.t(d,f,p,b,S);if(this.h)return this.h.s(d,f,p,b,S);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(d,f,p=[],b,S){if(b){const g=new v(void 0,this.g,this,this.i);g.c=String(d);const t=new Map,l=new a.IdleValue(()=>{const r=g.j(f,p,S);for(const[o,n]of t){const m=r[o];if(typeof m=="function")for(const s of n)m.apply(r,s)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,o){if(!l.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let s=t.get(o);return s||(s=new I.LinkedList,t.set(o,s)),(c,w,D)=>{const F=s.push([c,w,D]);return(0,T.toDisposable)(F)}}if(o in r)return r[o];const n=l.value;let m=n[o];return typeof m!="function"||(m=m.bind(n),r[o]=m),m},set(r,o,n){return l.value[o]=n,!0},getPrototypeOf(r){return f.prototype}})}else return this.j(f,p,S)}u(d,f){if(f&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=v;var P;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(P||(P={}));class E{static traceInvocation(d,f){return d?new E(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(d,f){return d?new E(1,f.name):E.c}constructor(d,f){this.type=d,this.name=f,this.g=Date.now(),this.h=[]}branch(d,f){const p=new E(3,d.toString());return this.h.push([d,f,p]),p}stop(){const d=Date.now()-this.g;E.f+=d;let f=!1;function p(S,g){const t=[],l=new Array(S+1).join("	");for(const[r,o,n]of g.h)if(o&&n){f=!0,t.push(`${l}CREATES -> ${r}`);const m=p(S+1,n);m&&t.push(m)}else t.push(`${l}uses -> ${r}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(d>2||f)&&E.all.add(b.join(`
`))}}e.Trace=E,E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0}),define(ye[13],De([1,0,45,3,6,28,12,9,2,4]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.setLogLevel=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function L(){return new Date().toISOString()}function k(i){return(0,A.isNumber)(i)}e.isLogLevel=k;var v;(function(i){i[i.Off=0]="Off",i[i.Trace=1]="Trace",i[i.Debug=2]="Debug",i[i.Info=3]="Info",i[i.Warning=4]="Warning",i[i.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function P(i,c,w){switch(c){case v.Trace:i.trace(w);break;case v.Debug:i.debug(w);break;case v.Info:i.info(w);break;case v.Warning:i.warn(w);break;case v.Error:i.error(w);break;case v.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=P;function E(i){let c="";for(let w=0;w<i.length;w++){let D=i[w];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}c+=(w>0?" ":"")+D}return c}e.format=E;class h extends T.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(c){this.b!==c&&(this.b=c,this.c.fire(this.b))}getLevel(){return this.b}f(c){return this.b!==v.Off&&this.b<=c}}e.AbstractLogger=h;class d extends h{constructor(c){super(),this.h=c}f(c){return this.h||super.f(c)}trace(c,...w){this.f(v.Trace)&&this.g(v.Trace,E([c,...w]))}debug(c,...w){this.f(v.Debug)&&this.g(v.Debug,E([c,...w]))}info(c,...w){this.f(v.Info)&&this.g(v.Info,E([c,...w]))}warn(c,...w){this.f(v.Warning)&&this.g(v.Warning,E([c,...w]))}error(c,...w){if(this.f(v.Error))if(c instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=c.stack,this.g(v.Error,E(D))}else this.g(v.Error,E([c,...w]))}flush(){}}e.AbstractMessageLogger=d;class f extends h{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.g=!C.isWindows}trace(c,...w){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,c,...w):console.log(`[main ${L()}]`,c,...w))}debug(c,...w){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,c,...w):console.log(`[main ${L()}]`,c,...w))}info(c,...w){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,c,...w):console.log(`[main ${L()}]`,c,...w))}warn(c,...w){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${L()}]\x1B[0m`,c,...w):console.warn(`[main ${L()}]`,c,...w))}error(c,...w){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${L()}]\x1B[0m`,c,...w):console.error(`[main ${L()}]`,c,...w))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class p extends h{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c)}trace(c,...w){this.f(v.Trace)&&console.log("%cTRACE","color: #888",c,...w)}debug(c,...w){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",c,...w)}info(c,...w){this.f(v.Info)&&console.log("%c INFO","color: #33f",c,...w)}warn(c,...w){this.f(v.Warning)&&console.log("%c WARN","color: #993",c,...w)}error(c,...w){this.f(v.Error)&&console.log("%c  ERR","color: #f33",c,...w)}dispose(){}flush(){}}e.ConsoleLogger=p;class b extends h{constructor(c,w=e.DEFAULT_LOG_LEVEL){super(),this.g=c,this.setLevel(w)}trace(c,...w){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(c),...w])}debug(c,...w){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(c),...w])}info(c,...w){this.f(v.Info)&&this.g.log(v.Info,[this.h(c),...w])}warn(c,...w){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(c),...w])}error(c,...w){this.f(v.Error)&&this.g.log(v.Error,[this.h(c),...w])}h(c){return typeof c=="string"?c:(0,a.toErrorMessage)(c,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class S extends h{constructor(c){super(),this.g=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const w of this.g)w.setLevel(c);super.setLevel(c)}trace(c,...w){for(const D of this.g)D.trace(c,...w)}debug(c,...w){for(const D of this.g)D.debug(c,...w)}info(c,...w){for(const D of this.g)D.info(c,...w)}warn(c,...w){for(const D of this.g)D.warn(c,...w)}error(c,...w){for(const D of this.g)D.error(c,...w)}flush(){for(const c of this.g)c.flush()}dispose(){for(const c of this.g)c.dispose()}}e.MultiplexLogger=S;class g extends T.Disposable{constructor(c,w){if(super(),this.j=c,this.b=new u.ResourceMap,this.c=new u.ResourceMap,this.f=this.B(new R.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new R.Emitter),this.onDidChangeVisibility=this.h.event,w)for(const D of w)this.c.set(D.resource,D)}getLogger(c){return this.b.get(c)}createLogger(c,w,D){let F=this.b.get(c);if(!F){const x=w?.logLevel==="always"?v.Trace:w?.logLevel;F=this.k(c,x??this.getLogLevel(c)??this.j,w),this.b.set(c,F),D||this.registerLogger({resource:c,id:w?.id??c.toString(),logLevel:x,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId})}return F}setLogLevel(c,w){if(y.URI.isUri(c)){const D=c,F=w,x=this.c.get(D);x&&F!==x.logLevel&&(x.logLevel=F===this.j?void 0:F,this.b.get(D)?.setLevel(F),this.c.set(x.resource,x),this.g.fire([D,F]))}else{this.j=c;for(const[D,F]of this.b.entries())this.c.get(D)?.logLevel===void 0&&F.setLevel(this.j);this.g.fire(this.j)}}setVisibility(c,w){const D=this.c.get(c);D&&w!==!D.hidden&&(D.hidden=!w,this.c.set(D.resource,D),this.h.fire([c,w]))}getLogLevel(c){let w;return c&&(w=this.c.get(c)?.logLevel),w??this.j}registerLogger(c){const w=this.c.get(c.resource);w?w.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this.c.set(c.resource,c),this.f.fire({added:[c],removed:[]}))}deregisterLogger(c){const w=this.c.get(c);if(w){this.c.delete(c);const D=this.b.get(c);D&&(this.b.delete(c),D.dispose()),this.f.fire({added:[],removed:[w]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(c){return this.c.get(c)}dispose(){this.b.forEach(c=>c.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=g;class t{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(c){}getLevel(){return v.Info}trace(c,...w){}debug(c,...w){}info(c,...w){}warn(c,...w){}error(c,...w){}critical(c,...w){}dispose(){}flush(){}}e.NullLogger=t;class l extends t{}e.NullLogService=l;class r extends g{constructor(){super(v.Info)}k(c,w,D){return new t}}e.NullLoggerService=r;function o(i){if(i.verbose)return v.Trace;if(typeof i.logLevel=="string"){const c=m(i.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function n(i){switch(i){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=n;function m(i){switch(i){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=m;function s(i,c){k(c)?i.setLogLevel(c):i.setLogLevel(c[0],c[1])}e.setLogLevel=s}),define(ye[202],De([1,0,6,13]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class T extends a.Disposable{constructor(C,A=[]){super(),this.a=new R.MultiplexLogger([C,...A]),this.B(C.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...A){this.a.trace(C,...A)}debug(C,...A){this.a.debug(C,...A)}info(C,...A){this.a.info(C,...A)}warn(C,...A){this.a.warn(C,...A)}error(C,...A){this.a.error(C,...A)}flush(){this.a.flush()}}e.LogService=T}),define(ye[203],De([1,0,44,13]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var T;(function(I){I[I.Trace=0]="Trace",I[I.Debug=1]="Debug",I[I.Info=2]="Info",I[I.Warning=3]="Warning",I[I.Error=4]="Error",I[I.Critical=5]="Critical",I[I.Off=6]="Off"})(T||(T={}));async function u(I,L,k,v,P){try{const E=await new Promise((d,f)=>{te(["spdlog"],d,f)});E.setFlushOn(T.Trace);const h=await E.createAsyncRotatingLogger(I,L,k,v);return P?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(E){console.error(E)}return null}function C(I,L,k){switch(L){case R.LogLevel.Trace:I.trace(k);break;case R.LogLevel.Debug:I.debug(k);break;case R.LogLevel.Info:I.info(k);break;case R.LogLevel.Warning:I.warn(k);break;case R.LogLevel.Error:I.error(k);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function A(I,L){switch(L){case R.LogLevel.Trace:I.setLevel(T.Trace);break;case R.LogLevel.Debug:I.setLevel(T.Debug);break;case R.LogLevel.Info:I.setLevel(T.Info);break;case R.LogLevel.Warning:I.setLevel(T.Warning);break;case R.LogLevel.Error:I.setLevel(T.Error);break;case R.LogLevel.Off:I.setLevel(T.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class y extends R.AbstractMessageLogger{constructor(L,k,v,P,E){super(),this.k=[],this.setLevel(E),this.l=this.n(L,k,v,P),this.B(this.onDidChangeLogLevel(h=>{this.m&&A(this.m,h)}))}async n(L,k,v,P){const E=v?6:1,h=30/E*a.ByteSize.MB,d=await u(L,k,h,E,P);if(d){this.m=d,A(this.m,this.getLevel());for(const{level:f,message:p}of this.k)C(this.m,f,p);this.k=[]}}g(L,k){this.m?C(this.m,L,k):this.getLevel()<=L&&this.k.push({level:L,message:k})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(ye[124],De([1,0,37,173,4]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var u;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(u=e.MarkerTag||(e.MarkerTag={}));var C;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function I(E,h){return h-E}y.compare=I;const L=Object.create(null);L[y.Error]=(0,R.localize)(0,null),L[y.Warning]=(0,R.localize)(1,null),L[y.Info]=(0,R.localize)(2,null);function k(E){return L[E]||""}y.toString=k;function v(E){switch(E){case a.default.Error:return y.Error;case a.default.Warning:return y.Warning;case a.default.Info:return y.Info;case a.default.Ignore:return y.Hint}}y.fromSeverity=v;function P(E){switch(E){case y.Error:return a.default.Error;case y.Warning:return a.default.Warning;case y.Info:return a.default.Info;case y.Hint:return a.default.Ignore}}y.toSeverity=P}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const I="";function L(v){return k(v,!0)}y.makeKey=L;function k(v,P){const E=[I];return v.source?E.push(v.source.replace("\xA6","\\\xA6")):E.push(I),v.code?typeof v.code=="string"?E.push(v.code.replace("\xA6","\\\xA6")):E.push(v.code.value.replace("\xA6","\\\xA6")):E.push(I),v.severity!==void 0&&v.severity!==null?E.push(C.toString(v.severity)):E.push(I),v.message&&P?E.push(v.message.replace("\xA6","\\\xA6")):E.push(I),v.startLineNumber!==void 0&&v.startLineNumber!==null?E.push(v.startLineNumber.toString()):E.push(I),v.startColumn!==void 0&&v.startColumn!==null?E.push(v.startColumn.toString()):E.push(I),v.endLineNumber!==void 0&&v.endLineNumber!==null?E.push(v.endLineNumber.toString()):E.push(I),v.endColumn!==void 0&&v.endColumn!==null?E.push(v.endColumn.toString()):E.push(I),E.push(I),E.join("\xA6")}y.makeKeyOptionalMessage=k})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,T.createDecorator)("markerService")}),define(ye[204],De([1,0,3,37,4]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,T.createDecorator)("notificationService");var u;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(u=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(ye[125],De([1,0,8,2,4]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService");function u(I,L){return R.URI.isUri(I)?(0,a.equalsIgnoreCase)(I.scheme,L):(0,a.startsWithIgnoreCase)(I,L+":")}e.matchesScheme=u;function C(I,...L){return L.some(k=>u(I,k))}e.matchesSomeScheme=C;function A(I,L){return I.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=A;function y(I){let L;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(I.fragment);return k&&(L={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},I=I.with({fragment:""})),{selection:L,uri:I}}e.extractSelection=y}),define(ye[205],De([1,0,12,36]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const u=a.globals.vscode.context.configuration();if(u)T=u.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const u=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:u.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ye[206],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(te,e){return function(a,R){e(a,R,te)}};define(ye[126],De([1,0,17,21,6,4]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,u.createDecorator)("progressService");var C;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(k){this.b=k}report(k){this.a=k,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends T.Disposable{constructor(k,v){super(),this.a=new a.DeferredPromise,v.withProgress(k,P=>(this.b=P,this.c&&P.report(this.c),this.a.p)),this.B((0,T.toDisposable)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};y=qe([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class I extends T.Disposable{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new T.DisposableStore)}start(k){this.stop();const v=++this.a,P=new R.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,T.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,T.toDisposable)(()=>P.cancel())),this.b.add((0,T.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:P.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,u.createDecorator)("editorProgressService")}),define(ye[39],De([1,0,50,9]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.a=new Map}add(C,A){a.ok(R.isString(C)),a.ok(R.isObject(A)),a.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,A)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new T}),define(ye[91],De([1,0,3,39]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class u{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,I){this.a[T(y)]=I,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const C=new u;R.Registry.add(e.Extensions.JSONContribution,C)}),define(ye[127],De([1,0,15,3,9,168,53,91,39]),function(te,e,a,R,T,u,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=y.Registry.as(A.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:u.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const r=new Set;this.n(t,l,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const l=new Set;this.o(t,l),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const r=new Set;this.o(l,r),this.n(t,!1,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const r=[];for(const{overrides:o,source:n}of t)for(const m in o)if(l.add(m),e.OVERRIDE_PROPERTY_REGEX.test(m)){const s=this.a.get(m),i=s?.valuesSources??new Map;if(n)for(const F of Object.keys(o[m]))i.set(F,n);const c={...s?.value||{},...o[m]};this.a.set(m,{source:n,value:c,valuesSources:i});const w=(0,C.getLanguageTagSettingPlainKey)(m),D={type:"object",default:c,description:u.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:T.isString(n)?void 0:n,defaultValueSource:n};r.push(...h(m)),this.d[m]=D,this.b.properties[m]=D}else{this.a.set(m,{value:o[m],source:n});const s=this.d[m];s&&(this.w(m,s),this.r(m,s))}this.m(r)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:r,source:o}of t)for(const n in r){const m=this.a.get(n),s=T.isString(o)?o:o?.id,i=T.isString(m?.source)?m?.source:m?.source?.id;if(s===i)if(l.add(n),this.a.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.d[n],delete this.b.properties[n];else{const c=this.d[n];c&&(this.w(n,c),this.r(n,c))}}this.u()}deltaConfiguration(t){let l=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,r){t.forEach(o=>{this.p(o,l,o.extensionInfo,o.restrictedProperties,void 0,r),this.c.push(o),this.q(o)})}o(t,l){const r=o=>{if(o.properties)for(const n in o.properties){l.add(n);const m=this.d[n];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[n],this.s(n,o.properties[n])}o.allOf?.forEach(n=>r(n))};for(const o of t){r(o);const n=this.c.indexOf(o);n!==-1&&this.c.splice(n,1)}}p(t,l=!0,r,o,n=3,m){n=T.isUndefinedOrNull(t.scope)?n:t.scope;const s=t.properties;if(s)for(const c in s){const w=s[c];if(l&&b(c,w)){delete s[c];continue}if(w.source=r,w.defaultDefaultValue=s[c].default,this.w(c,w),e.OVERRIDE_PROPERTY_REGEX.test(c)?w.scope=void 0:(w.scope=T.isUndefinedOrNull(w.scope)?n:w.scope,w.restricted=T.isUndefinedOrNull(w.restricted)?!!o?.includes(c):w.restricted),s[c].hasOwnProperty("included")&&!s[c].included){this.f[c]=s[c],delete s[c];continue}else this.d[c]=s[c],s[c].policy?.name&&this.e.set(s[c].policy.name,c);!s[c].deprecationMessage&&s[c].markdownDeprecationMessage&&(s[c].deprecationMessage=s[c].markdownDeprecationMessage),m.add(c)}const i=t.allOf;if(i)for(const c of i)this.p(c,l,r,o,n,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=r=>{const o=r.properties;if(o)for(const m in o)this.r(m,o[m]);r.allOf?.forEach(l)};l(t)}r(t,l){switch(e.allSettings.properties[t]=l,l.scope){case 1:e.applicationSettings.properties[t]=l;break;case 2:e.machineSettings.properties[t]=l;break;case 6:e.machineOverridableSettings.properties[t]=l;break;case 3:e.windowSettings.properties[t]=l;break;case 4:e.resourceSettings.properties[t]=l;break;case 5:e.resourceSettings.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.allSettings.properties[t],l.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,r={type:"object",description:u.localize(2,null),errorMessage:u.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(l,r),e.allSettings.properties[l]=r,e.applicationSettings.properties[l]=r,e.machineSettings.properties[l]=r,e.machineOverridableSettings.properties[l]=r,e.windowSettings.properties[l]=r,e.resourceSettings.properties[l]=r}}v(){const t={type:"object",description:u.localize(4,null),errorMessage:u.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,l){const r=this.a.get(t);let o=r?.value,n=r?.source;T.isUndefined(o)&&(o=l.defaultDefaultValue,n=void 0),T.isUndefined(o)&&(o=f(l.type)),l.default=o,l.defaultValueSource=n}}const P="\\[([^\\]]+)\\]",E=new RegExp(P,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${P})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(g){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let l=E.exec(g);for(;l?.length;){const r=l[1].trim();r&&t.push(r),l=E.exec(g)}}return(0,a.distinct)(t)}e.overrideIdentifiersFromKey=h;function d(g){return g.reduce((t,l)=>`${t}[${l}]`,"")}e.keyFromOverrideIdentifiers=d;function f(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new v;y.Registry.add(e.Extensions.Configuration,p);function b(g,t){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?u.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?u.localize(8,null,g):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?u.localize(9,null,g,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:u.localize(6,null)}e.validateProperty=b;function S(){const g=[],t=p.getConfigurationProperties();for(const l of Object.keys(t))g.push([l,t[l].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=S}),define(ye[207],De([1,0,15,3,146,6,28,23,9,2,53,127,39]),function(te,e,a,R,T,u,C,A,y,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function P(l){return Object.isFrozen(l)?l:A.deepFreeze(l)}class E{constructor(r={},o=[],n=[],m){this.b=r,this.c=o,this.d=n,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(o=>{if(o instanceof E)return o;const n=new h("");return n.parseRaw(o),n.configurationModel});this.f=r.reduce((o,n)=>n===o?n:o.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}inspect(r,o){const n=this.rawConfiguration.getValue(r),m=o?this.rawConfiguration.getOverrideValue(r,o):void 0,s=o?this.rawConfiguration.override(o).getValue(r):n;return{value:n,override:m,merged:s}}getOverrideValue(r,o){const n=this.i(o);return n?r?(0,L.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const o=[];for(const n of this.overrides)n.identifiers.includes(r)&&o.push(...n.keys);return a.distinct(o)}getAllOverrideIdentifiers(){const r=[];for(const o of this.overrides)r.push(...o.identifiers);return a.distinct(r)}override(r){let o=this.a.get(r);return o||(o=this.g(r),this.a.set(r,o)),o}merge(...r){const o=A.deepClone(this.contents),n=A.deepClone(this.overrides),m=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const i of r)if(s.push(...i.raw?.length?i.raw:[i]),!i.isEmpty()){this.h(o,i.contents);for(const c of i.overrides){const[w]=n.filter(D=>a.equals(D.identifiers,c.identifiers));w?(this.h(w.contents,c.contents),w.keys.push(...c.keys),w.keys=a.distinct(w.keys)):n.push(A.deepClone(c))}for(const c of i.keys)m.indexOf(c)===-1&&m.push(c)}return new E(o,m,n,s.every(i=>i instanceof E)?void 0:s)}g(r){const o=this.i(r);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const n={};for(const m of a.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[m];const i=o[m];i&&(typeof s=="object"&&typeof i=="object"?(s=A.deepClone(s),this.h(s,i)):s=i),n[m]=s}return new E(n,this.keys,this.overrides)}h(r,o){for(const n of Object.keys(o)){if(n in r&&y.isObject(r[n])&&y.isObject(o[n])){this.h(r[n],o[n]);continue}r[n]=A.deepClone(o[n])}}i(r){let o=null,n=null;const m=s=>{s&&(n?this.h(n,s):n=A.deepClone(s))};for(const s of this.overrides)a.equals(s.identifiers,[r])?o=s.contents:s.identifiers.includes(r)&&m(s.contents);return m(o),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,o){this.j(r,o,!0)}setValue(r,o){this.j(r,o,!1)}removeValue(r){const o=this.keys.indexOf(r);o!==-1&&(this.keys.splice(o,1),(0,L.removeFromValueTree)(this.contents,r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>a.equals(n.identifiers,(0,k.overrideIdentifiersFromKey)(r))),1))}j(r,o,n){(0,L.addToValueTree)(this.contents,r,o,m=>console.error(m)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,L.toValuesTree)(this.contents[r],m=>console.error(m))})}}e.ConfigurationModel=E;class h{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,o){if(!y.isUndefinedOrNull(r)){const n=this.g(r);this.parseRaw(n,o)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,o){this.a=r;const{contents:n,keys:m,overrides:s,restricted:i,hasExcludedProperties:c}=this.h(r,o);this.b=new E(n,m,s,c?[r]:void 0),this.c=i||[]}g(r){let o={},n=null,m=[];const s=[],i=[];function c(D){Array.isArray(m)?m.push(D):n!==null&&(m[n]=D)}const w={onObjectBegin:()=>{const D={};c(D),s.push(m),m=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{m=s.pop()},onArrayBegin:()=>{const D=[];c(D),s.push(m),m=D,n=null},onArrayEnd:()=>{m=s.pop()},onLiteralValue:c,onError:(D,F,x)=>{i.push({error:D,offset:F,length:x})}};if(r)try{T.visit(r,w),o=m[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return o}h(r,o){const n=v.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),m=this.i(r,n,!0,o);r=m.raw;const s=(0,L.toValuesTree)(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),i=Object.keys(r),c=this.j(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:s,keys:i,overrides:c,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(r,o,n,m){let s=!1;if(!m?.scopes&&!m?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:s};const i={},c=[];for(const w in r)if(k.OVERRIDE_PROPERTY_REGEX.test(w)&&n){const D=this.i(r[w],o,!1,m);i[w]=D.raw,s=s||D.hasExcludedProperties,c.push(...D.restricted)}else{const D=o[w],F=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&c.push(w),(F===void 0||m.scopes===void 0||m.scopes.includes(F))&&!(m.skipRestricted&&D?.restricted)?i[w]=r[w]:s=!0}return{raw:i,restricted:c,hasExcludedProperties:s}}j(r,o){const n=[];for(const m of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(m)){const s={};for(const i in r[m])s[i]=r[m][i];n.push({identifiers:(0,k.overrideIdentifiersFromKey)(m),keys:Object.keys(s),contents:(0,L.toValuesTree)(s,o)})}return n}}e.ConfigurationModelParser=h;class d extends u.Disposable{constructor(r,o,n,m){super(),this.f=r,this.g=o,this.h=m,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new h(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(n.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&n.isEqual(s.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new E}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class f{constructor(r,o,n,m,s,i,c,w,D,F,x,q,M){this.a=r,this.b=o,this.c=n,this.overrideIdentifiers=m,this.d=s,this.f=i,this.g=c,this.h=w,this.i=D,this.j=F,this.k=x,this.l=q,this.m=M}get value(){return P(this.c)}n(r,o,n){const m=r.inspect(o,n);return{get value(){return P(m.value)},get override(){return P(m.override)},get merged(){return P(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(r,o,n,m,s=new E,i=new E,c=new C.ResourceMap,w=new E,D=new C.ResourceMap){this.c=r,this.d=o,this.f=n,this.g=m,this.h=s,this.i=i,this.j=c,this.l=w,this.m=D,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(r,o,n){return this.q(r,o,n).getValue(r)}updateValue(r,o,n={}){let m;n.resource?(m=this.m.get(n.resource),m||(m=new E,this.m.set(n.resource,m))):m=this.l,o===void 0?m.removeValue(r):m.setValue(r,o),n.resource||(this.a=null)}inspect(r,o,n){const m=this.q(r,o,n),s=this.u(o.resource,n),i=o.resource?this.m.get(o.resource)||this.l:this.l,c=new Set;for(const w of m.overrides)for(const D of w.identifiers)m.getOverrideValue(r,D)!==void 0&&c.add(D);return new f(r,o,m.getValue(r),c.size?[...c]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,s||void 0,i)}keys(r){const o=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,o){this.j.set(r,o),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,o){const n=[];if(!o){const{added:m,updated:s,removed:i}=g(this.c,r);o=[...m,...s,...i]}for(const m of o)for(const s of(0,k.overrideIdentifiersFromKey)(m)){const i=this.c.getKeysForOverrideIdentifier(s),c=r.getKeysForOverrideIdentifier(s),w=[...c.filter(D=>i.indexOf(D)===-1),...i.filter(D=>c.indexOf(D)===-1),...i.filter(D=>!A.equals(this.c.override(s).getValue(D),r.override(s).getValue(D)))];n.push([s,w])}return this.updateDefaultConfiguration(r),{keys:o,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:o,updated:n,removed:m}=g(this.d,r),s=[...o,...n,...m];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:o,updated:n,removed:m,overrides:s}=g(this.applicationConfiguration,r),i=[...o,...n,...m];return i.length&&this.updateApplicationConfiguration(r),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:o,updated:n,removed:m,overrides:s}=g(this.localUserConfiguration,r),i=[...o,...n,...m];return i.length&&this.updateLocalUserConfiguration(r),{keys:i,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:o,updated:n,removed:m,overrides:s}=g(this.remoteUserConfiguration,r),i=[...o,...n,...m];return i.length&&this.updateRemoteUserConfiguration(r),{keys:i,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:o,updated:n,removed:m,overrides:s}=g(this.workspaceConfiguration,r),i=[...o,...n,...m];return i.length&&this.updateWorkspaceConfiguration(r),{keys:i,overrides:s}}compareAndUpdateFolderConfiguration(r,o){const n=this.p.get(r),{added:m,updated:s,removed:i,overrides:c}=g(n,o),w=[...m,...s,...i];return(w.length||!n)&&this.updateFolderConfiguration(r,o),{keys:w,overrides:c}}compareAndDeleteFolderConfiguration(r){const o=this.p.get(r);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:m,removed:s,overrides:i}=g(o,void 0);return{keys:[...n,...m,...s],overrides:i}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,o,n){let m=this.r(o,n);return o.overrideIdentifier&&(m=m.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(m=m.merge(this.d)),m}r({resource:r},o){let n=this.s();if(o&&r){const m=o.getFolder(r);m&&(n=this.t(m.uri)||n);const s=this.m.get(r);s&&(n=n.merge(s))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let o=this.b.get(r);if(!o){const n=this.s(),m=this.j.get(r);m?(o=n.merge(m),this.b.set(r,o)):o=n}return o}u(r,o){if(o&&r){const n=o.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,o)=>{const{contents:n,overrides:m,keys:s}=this.j.get(o);return r.push([o,{contents:n,overrides:m,keys:s}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(o=>r.add(o)),this.userConfiguration.keys.forEach(o=>r.add(o)),this.i.keys.forEach(o=>r.add(o)),this.j.forEach(o=>o.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const o=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>o.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>o.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>o.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(m=>o.add(m))),[...o.values()]}static parse(r){const o=this.x(r.defaults),n=this.x(r.policy),m=this.x(r.application),s=this.x(r.user),i=this.x(r.workspace),c=r.folders.reduce((w,D)=>(w.set(I.URI.revive(D[0]),this.x(D[1])),w),new C.ResourceMap);return new p(o,n,m,s,new E,i,c,new E,new C.ResourceMap)}static x(r){return new E(r.contents,r.keys,r.overrides)}}e.Configuration=p;function b(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,o=new Map;for(const m of l)m.keys.forEach(s=>r.add(s)),m.overrides.forEach(([s,i])=>{const c=(0,C.getOrSet)(o,s,new Set);i.forEach(w=>c.add(w))});const n=[];return o.forEach((m,s)=>n.push([s,[...m.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=b;class S{constructor(r,o,n,m){this.change=r,this.f=o,this.g=n,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of r.keys)this.affectedKeys.add(s);for(const[,s]of r.overrides)for(const i of s)this.affectedKeys.add(i);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(r,o){const n=this.a+r,m=this.d.indexOf(n);if(m<0)return!1;const s=m+n.length;if(s>=this.d.length)return!1;const i=this.d.charCodeAt(s);if(i!==this.b&&i!==this.c)return!1;if(o){const c=this.previousConfiguration?this.previousConfiguration.getValue(r,o,this.f?.workspace):void 0,w=this.g.getValue(r,o,this.h);return!A.equals(c,w)}return!0}}e.ConfigurationChangeEvent=S;function g(l,r){const{added:o,removed:n,updated:m}=t(r?.rawConfiguration,l?.rawConfiguration),s=[],i=l?.getAllOverrideIdentifiers()||[],c=r?.getAllOverrideIdentifiers()||[];if(r){const w=c.filter(D=>!i.includes(D));for(const D of w)s.push([D,r.getKeysForOverrideIdentifier(D)])}if(l){const w=i.filter(D=>!c.includes(D));for(const D of w)s.push([D,l.getKeysForOverrideIdentifier(D)])}if(r&&l){for(const w of i)if(c.includes(w)){const D=t({contents:l.getOverrideValue(void 0,w)||{},keys:l.getKeysForOverrideIdentifier(w)},{contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)});s.push([w,[...D.added,...D.removed,...D.updated]])}}return{added:o,removed:n,updated:m,overrides:s}}function t(l,r){const o=l?r?l.keys.filter(s=>r.keys.indexOf(s)===-1):[...l.keys]:[],n=r?l?r.keys.filter(s=>l.keys.indexOf(s)===-1):[...r.keys]:[],m=[];if(l&&r){for(const s of r.keys)if(l.keys.indexOf(s)!==-1){const i=(0,L.getConfigurationValue)(r.contents,s),c=(0,L.getConfigurationValue)(l.contents,s);A.equals(i,c)||m.push(s)}}return{added:o,removed:n,updated:m}}}),define(ye[128],De([1,0,11,4]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var T;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class u extends a.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof u&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof u&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof u&&y._code===T.NoResolverFound}static isHandled(y){return y instanceof u&&y.isHandled}constructor(y,I=T.Unknown,L){super(y),this._message=y,this._code=I,this._detail=L,this.isHandled=I===T.NotAvailable&&L===!0,Object.setPrototypeOf(this,u.prototype)}}e.RemoteAuthorityResolverError=u;function C(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}e.getRemoteAuthorityPrefix=C}),define(ye[72],De([1,0,16]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(I){return I.scheme===a.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=R;function T(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}e.getRemoteName=T;function u(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=u;function C(I){const{host:L,port:k}=y(I);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:k}}e.parseAuthorityWithPort=C;function A(I,L){let{host:k,port:v}=y(I);return typeof v>"u"&&(v=L),{host:k,port:v}}e.parseAuthorityWithOptionalPort=A;function y(I){const L=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const k=I.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const v=I.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:I,port:void 0}}}),define(ye[26],De([1,0,8,4,72]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function u(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=u;function C(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(h){this.value=h,this.c=h.toLowerCase()}static equals(h,d){if(typeof h>"u"||h===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof h=="string"||typeof d=="string"){const f=typeof h=="string"?h:h.value,p=typeof d=="string"?d:d.value;return a.equalsIgnoreCase(f,p)}return h.c===d.c}static toKey(h){return typeof h=="string"?h.toLowerCase():h.c}}e.ExtensionIdentifier=I;function L(E){return k(E)}e.isApplicationScopedExtension=L;function k(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function v(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function P(E,h){if(h){const d=`onResolveRemoteAuthority:${(0,T.getRemoteName)(h)}`;return E.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[208],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((T,u)=>te(["vsda"],T,u))}async createNewMessage(T){try{const u=await this.c(),C=new u.validator;if(C){const A=String(a.a++);return this.b.set(A,C),{id:A,data:C.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,u){if(!T.id)return!0;const C=this.b.get(T.id);if(!C)return!1;this.b.delete(T.id);try{return C.validate(u)==="ok"}catch{return!1}}async sign(T){try{const u=await this.c(),C=new u.signer;if(C)return C.sign(T)}catch{}return T}}e.SignService=a,a.a=1}),define(ye[209],De([1,0,12,36,2,30]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(I){if(a.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function A(I,L,k,v,P,E,h,d,f,p){const b=Object.create(null);b["common.machineId"]=h,b.sessionID=(0,u.generateUuid)()+Date.now(),b.commitHash=P,b.version=E,b["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,a.PlatformToString)(a.platform),b["common.nodePlatform"]=R.platform,b["common.nodeArch"]=v,b["common.product"]=p||"desktop",d&&(b["common.msftInternal"]=d);let S=0;const g=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),a.isLinuxSnap&&(b["common.snap"]="true");const t=C(k);t&&(b["common.platformDetail"]=t);try{const l=await I.readFile(T.URI.file(f));b["common.source"]=l.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=A;function y(I){const L=R.env.USERDNSDOMAIN;if(!L)return!1;const k=L.toLowerCase();return I.some(v=>k===v)}e.verifyMicrosoftInternalDomain=y}),define(ye[210],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(u){u[u.NONE=0]="NONE",u[u.CRASH=1]="CRASH",u[u.ERROR=2]="ERROR",u[u.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var T;(function(u){u.OFF="off",u.CRASH="crash",u.ERROR="error",u.ON="all"})(T=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[73],De([1,0,23,9,3,53,72,209,210]),function(te,e,a,R,T,u,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class I{constructor(s){this.value=s}}e.TelemetryTrustedValue=I;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,i){return Promise.resolve(void 0)}publicLog2(s,i){return this.publicLog(s,i)}publicLogError(s,i){return Promise.resolve(void 0)}publicLogError2(s,i){return this.publicLogError(s,i)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class k{async publicLog(s,i,c){}async publicLogError(s,i,c){}}e.NullEndpointTelemetryService=k,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(m,s){return T.Event.debounce(s.onDidChangeConfiguration,(c,w)=>{const D=c?new Set([...c.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:D}},1e3,!0)(c=>{c.source!==7&&m.publicLog2("updateConfiguration",{configurationSource:(0,u.ConfigurationTargetToString)(c.source),configurationKeys:S(c.affectedKeys)})})}e.configurationTelemetry=v;function P(m,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!m.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=P;function E(m,s){return!(s.isBuilt||s.disableTelemetry||m.enableTelemetry&&m.aiConfig?.ariaKey)}e.isLoggingOnly=E;function h(m){const s=m.getValue(y.TELEMETRY_SETTING_ID),i=m.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(m.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||i===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=h;function d(m){const s={},i={},c={};b(m,c);for(let w in c){w=w.length>150?w.substr(w.length-149):w;const D=c[w];typeof D=="number"?i[w]=D:typeof D=="boolean"?i[w]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${D.length}`),s[w]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(s[w]=D)}return{properties:s,measurements:i}}e.validateTelemetryData=d;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function p(m){if(!m)return"none";const s=(0,C.getRemoteName)(m);return f.has(s)?s:"other"}e.cleanRemoteAuthority=p;function b(m,s,i=0,c){if(!!m)for(const w of Object.getOwnPropertyNames(m)){const D=m[w],F=c?c+w:w;Array.isArray(D)?s[F]=(0,a.safeStringify)(D):D instanceof Date?s[F]=D.toISOString():(0,R.isObject)(D)?i<2?b(D,s,i+1,F+"."):s[F]=(0,a.safeStringify)(D):s[F]=D}}function S(m){if(!m)return[];const s=[];return g(s,"",m),s}function g(m,s,i){i&&typeof i=="object"&&!Array.isArray(i)?Object.keys(i).forEach(c=>g(m,s?`${s}.${c}`:c,i[c])):m.push(s)}function t(m,s){const i=m.msftInternalDomains||[],c=s.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(i)||c}e.isInternalTelemetry=t;function l(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=l;function r(m,s){if(!m||!m.includes("/")&&!m.includes("\\"))return m;let i=m;const c=[];for(const x of s)for(;;){const q=x.exec(m);if(!q)break;c.push([q.index,x.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let F=0;for(i="";;){const x=D.exec(m);if(!x)break;const q=c.some(([M,B])=>x.index<B&&M<D.lastIndex);!w.test(x[0])&&!q&&(i+=m.substring(F,x.index)+"<REDACTED: user-file-path>",F=D.lastIndex)}return F<m.length&&(i+=m.substr(F)),i}function o(m){if(!m)return m;const s=m.toLowerCase(),i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of i)if(c.regex.test(s))return`<REDACTED: ${c.label}>`;return m}function n(m,s){return(0,a.cloneAndChange)(m,i=>{if(i instanceof I)return i.value;if(typeof i=="string"){let c=i.replaceAll("%20"," ");c=r(c,s);for(const w of s)c=c.replace(w,"");return c=o(c),c}})}e.cleanData=n}),define(ye[211],De([1,0,8,123,26,12,2,11,36,73]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(r,o){return r.uuid&&o.uuid?r.uuid===o.uuid:r.id===o.id?!0:(0,a.compareIgnoreCase)(r.id,o.id)===0}e.areSameExtensions=L;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(o){const n=o.manifest?o.manifest.version:o.version,m=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new v(o.identifier,n,m)}static parse(o){const n=k.exec(o);return n&&n[1]&&n[2]?new v({id:n[1]},n[2],n[4]||void 0):null}constructor(o,n,m="undefined"){this.version=n,this.targetPlatform=m,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof v?L(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=v;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(r){const o=P.exec(r);return o&&o[1]?[d(o[1]),o[2]]:[d(r),void 0]}e.getIdAndVersion=E;function h(r,o){return`${r}.${o}`}e.getExtensionId=h;function d(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function f(r,o){return d(h(r,o))}e.getGalleryExtensionId=f;function p(r,o){const n=[],m=s=>{for(const i of n)if(i.some(c=>L(o(c),o(s))))return i;return null};for(const s of r){const i=m(s);i?i.push(s):n.push([s])}return n}e.groupByExtension=p;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function S(r){return{id:new I.TelemetryTrustedValue(r.identifier.id),name:new I.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function g(r,o){const n=[],m=o.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const s=m.shift();if(s&&n.every(i=>!L(i.identifier,{id:s}))){const i=r.filter(c=>L(c.identifier,{id:s}));i.length===1&&(n.push(i[0]),m.push(...i[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=g;async function t(r,o){if(!u.isLinux)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){o.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(s))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function l(r,o){const n=await t(r,o),m=(0,R.getTargetPlatform)(n?"alpine":u.platform,y.arch);return o.debug("ComputeTargetPlatform:",m),m}e.computeTargetPlatform=l}),define(ye[212],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=a;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R;function T(C){return Array.from(C.entries()).map(A=>[A[0],a(A[1].map)])}e.serializeEnvironmentVariableCollections=T;function u(C){return new Map(C.map(A=>[A[0],{map:R(A[1])}]))}e.deserializeEnvironmentVariableCollections=u}),define(ye[213],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(T){this.b=T,this.a=new Map}dispose(){for(const T of this.a.values())T.dispose()}startBuffering(T,u,C=5){const A=u(y=>{const I=typeof y=="string"?y:y.data;let L=this.a.get(T);if(L){L.data.push(I);return}const k=setTimeout(()=>this.flushBuffer(T),C);L={data:[I],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(T),A.dispose()}},this.a.set(T,L)});return A}stopBuffering(T){this.a.get(T)?.dispose()}flushBuffer(T){const u=this.a.get(T);u&&(this.a.delete(T),this.b(T,u.data.join("")))}}e.TerminalDataBufferer=a}),define(ye[214],De([1,0,17,67,51,3,9,2,174,91,39]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(S){function g(t,l){let r=t.defaults;for(;T.ThemeIcon.isThemeIcon(r);){const o=E.getIcon(r.id);if(!o)return;r=o.defaults}return r}S.getDefinition=g})(k=e.IconContribution||(e.IconContribution={}));var v;(function(S){function g(l){return{weight:l.weight,style:l.style,src:l.src.map(r=>({format:r.format,location:r.location.toString()}))}}S.toJSONObject=g;function t(l){const r=o=>(0,C.isString)(o)?o:void 0;if(l&&Array.isArray(l.src)&&l.src.every(o=>(0,C.isString)(o.format)&&(0,C.isString)(o.location)))return{weight:r(l.weight),style:r(l.style),src:l.src.map(o=>({format:o.format,location:A.URI.parse(o.location)}))}}S.fromJSONObject=t})(v=e.IconFontDefinition||(e.IconFontDefinition={}));class P{constructor(){this.a=new u.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,t,l,r){const o=this.b[g];if(o){if(l&&!o.description){o.description=l,this.d.properties[g].markdownDescription=`${l} $(${g})`;const s=this.e.enum.indexOf(g);s!==-1&&(this.e.enumDescriptions[s]=l),this.a.fire()}return o}const n={id:g,description:l,defaults:t,deprecationMessage:r};this.b[g]=n;const m={$ref:"#/definitions/icons"};return r&&(m.deprecationMessage=r),l&&(m.markdownDescription=`${l}: $(${g})`),this.d.properties[g]=m,this.e.enum.push(g),this.e.enumDescriptions.push(l||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const t=this.e.enum.indexOf(g);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,t){const l=this.f[g];return l||(this.f[g]=t,this.a.fire(),t)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(o,n)=>o.id.localeCompare(n.id),t=o=>{for(;T.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(o=>this.b[o]);for(const o of r.filter(n=>!!n.description).sort(g))l.push(`|<i class="${t(o)}"></i>|${o.id}|${T.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const o of r.filter(n=>!T.ThemeIcon.isThemeIcon(n.defaults)).sort(g))l.push(`|<i class="${t(o)}"></i>|${o.id}|`);return l.join(`
`)}}const E=new P;L.Registry.add(e.Extensions.IconContribution,E);function h(S,g,t,l){return E.registerIcon(S,g,t,l)}e.registerIcon=h;function d(){return E}e.getIconRegistry=d;function f(){const S=(0,R.getCodiconFontCharacters)();for(const g in S){const t="\\"+S[g].toString(16);E.registerIcon(g,{fontCharacter:t})}}f(),e.iconsSchemaId="vscode://schemas/icons";const p=L.Registry.as(I.Extensions.JSONContribution);p.registerSchema(e.iconsSchemaId,E.getIconSchema());const b=new a.RunOnceScheduler(()=>p.notifySchemaChanged(e.iconsSchemaId),200);E.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=h("widget-close",R.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=h("goto-previous-location",R.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=h("goto-next-location",R.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=T.ThemeIcon.modify(R.Codicon.sync,"spin"),e.spinningLoading=T.ThemeIcon.modify(R.Codicon.loading,"spin")}),define(ye[129],De([1,0,3,53,4,13]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var C;(function(h){h.Http="http",h.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=k;function v(h,d,f,p){if(f===1)return!1;if(f===2&&k(d)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(b?.length===4&&parseInt(b[1])>=18)return!1}return h<1024}e.isPortPrivileged=v;class P{constructor(d,f,p){this.remoteAddress=d,this.localAddress=f,this.b=p,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=P;let E=class{constructor(d,f){this.i=d,this.j=f,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const d=this.j.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.e=d,d?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.f=d.elevation,this.g=d.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const d=[],f=Array.from(this.d.values());for(const p of f){const b=Array.from(p.values());for(const S of b){const g=await S.value;g&&d.push(g)}}return d}async dispose(){for(const d of this.d.values()){for(const{value:f}of d.values())await f.then(p=>p?.dispose());d.clear()}this.d.clear()}setEnvironmentTunnel(d,f,p,b,S){this.o(d,f,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:f,localAddress:p,privacy:b,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,f){(k(d)||L(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const p=this.q(d,f);if(p)return++p.refcount,p.value}openTunnel(d,f,p,b,S,g=!1,t,l){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${p} on local port ${S}.`),!d)return;if(f||(f="localhost"),b||(b=this.k),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(d,f,p,b,S,g,t,l);return r?r.then(o=>{if(!o){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(f,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.m(o);return(o.tunnelRemoteHost!==f||o.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(n),n}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const f=this.d.get(d.tunnelRemoteHost);if(f){const p=f.get(d.tunnelRemotePort);p&&(p.refcount--,await this.n(d.tunnelRemoteHost,d.tunnelRemotePort,p))}}}}async n(d,f,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${f}.`);const b=p.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(d)&&this.d.get(d).delete(f),b}}async closeTunnel(d,f){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${f} `);const p=this.d.get(d);if(p&&p.has(f)){const b=p.get(f);b.refcount=0,await this.n(d,f,b)}}o(d,f,p){this.d.has(d)||this.d.set(d,new Map),this.d.get(d).set(f,{refcount:1,value:p})}async p(d,f){const p=this.d.get(d);p&&(await p.get(f)||p.delete(f),p.size===0&&this.d.delete(d))}q(d,f){const p=[d];L(d)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):k(d)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const b=p.map(S=>this.d.get(S));for(const S of b){const g=S?.get(f);if(g)return g}}canTunnel(d){return!!I(d)}s(d,f,p,b,S,g,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${p} on local port ${b}.`);const l=p;this.h.add(l);const r=b===void 0?p:b,o={elevationRequired:S?this.isPortPrivileged(r):!1},n={remoteAddress:{host:f,port:p},localAddressPort:b,privacy:g,public:g?g!==A.Private:void 0,protocol:t},m=d.forwardPort(n,o);return m?(this.o(f,p,m),m.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(l)})):this.h.delete(l),m}};E=qe([We(0,u.ILogService),We(1,R.IConfigurationService)],E),e.AbstractTunnelService=E}),define(ye[215],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var R;(function(T){T[T.Complete=100]="Complete",T[T.Partial=50]="Partial",T[T.None=0]="None"})(R=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[216],De([1,0,16]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function R(y){return y.scheme!==a.Schemas.file&&y.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=R;function T(y){if(y.folders.length)return y.folders.every(I=>R(I.uri))?y.folders[0].uri:void 0;if(y.configuration&&R(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=T;function u(y){return T(y)?.scheme}e.getVirtualWorkspaceScheme=u;function C(y){return T(y)?.authority}e.getVirtualWorkspaceAuthority=C;function A(y){return T(y)!==void 0}e.isVirtualWorkspace=A}),define(ye[47],De([1,0,175,10,68,24,2,4,16]),function(te,e,a,R,T,u,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function I(r){const o=r;return typeof o?.id=="string"&&C.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=I;function L(r){return typeof r?.id=="string"&&!I(r)&&!v(r)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(r,o){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,R.basename)(r)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const n=r;return n.configuration?{id:n.id,configPath:n.configuration}:n.folders.length===1?{id:n.id,uri:n.folders[0].uri}:{id:n.id}}e.toWorkspaceIdentifier=k;function v(r){const o=r;return typeof o?.id=="string"&&C.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=v;function P(r){const o=r;if(o?.uri)return{id:o.id,uri:C.URI.revive(o.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:C.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=P;var E;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function h(r){const o=r;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=h;function d(r){const o=r;return!!(o&&typeof o=="object"&&C.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=d;class f{constructor(o,n,m,s,i){this.h=o,this.j=m,this.k=s,this.l=i,this.c=T.TernarySearchTree.forUris(this.l,()=>!0),this.folders=n}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=T.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class p{constructor(o,n){this.raw=n,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,u.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function b(r){return new p({uri:r,index:0,name:(0,u.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(r,o){return u.extUriBiasedIgnorePathCase.isEqualOrParent(r,o.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function g(r){let o;return C.URI.isUri(r)?o=r:o=r.configuration,o?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=g;function t(r,o){return!S(r,o)&&!g(r)}e.isSavedWorkspace=t;function l(r){return(typeof r=="string"?(0,R.extname)(r):(0,u.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=l}),define(ye[74],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(T){this.d=T,this.b=new Map,this.c=1}add(T){const u=this.c++;return this.b.set(u,T),this.e(),u}get(T,u){return this.b.has(T)?this.b.get(T)[u]:void 0}delete(T){this.b.delete(T),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=a,a.a=!1}),define(ye[48],De([1,0,16,24,4]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class u{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new R.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=u,e.IExtHostFileSystemInfo=(0,T.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(ye[217],De([1,0,13,202,25]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let u=class extends R.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:y.logName}))}};u=qe([We(0,a.ILoggerService),We(1,T.IExtHostInitDataService)],u),e.ExtHostLogService=u}),define(ye[218],De([1,0,17]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(C,A,y){this.h=new Map,this.a=C,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(I=>(this.f=I,this)),this.g=this.c.onDidChangeStorage(I=>{I.shared===this.b&&I.key===this.a&&(this.f=I.value)}),this.i=new a.RunOnceScheduler(()=>{const I=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of I.values())L.complete()}catch(L){for(const k of I.values())k.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,A){let y=this.f[C];return typeof y>"u"&&(y=A),y}update(C,A){this.f[C]=A;const y=this.h.get(C);if(y!==void 0)return y.p;const I=new a.DeferredPromise;return this.h.set(C,I),this.i.isScheduled()||this.i.schedule(),I.p}dispose(){this.g.dispose()}}e.ExtensionMemento=R;class T extends R{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,A){super(C.identifier.value,!0,A),this.j=C}}e.ExtensionGlobalMemento=T}),define(ye[219],De([1,0,3,2]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class T{constructor(C){this.c=C,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,A,y,I){const k=this.c.getNotebookDocument(R.URI.revive(C)).acceptModelChanged(A.value,y,I);this.b.fire(k)}$acceptDirtyStateChanged(C,A){this.c.getNotebookDocument(R.URI.revive(C)).acceptDirty(A)}$acceptModelSaved(C){const A=this.c.getNotebookDocument(R.URI.revive(C));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=T}),define(ye[18],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class R{constructor(u){this.getProxy=u.getProxy.bind(u),this.set=u.set.bind(u),this.dispose=u.dispose.bind(u),this.assertRegistered=u.assertRegistered.bind(u),this.drain=u.drain.bind(u)}}e.ExtHostRpcService=R});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)};define(ye[220],De([1,0,26,3]),function(te,e,a,R){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class u{constructor(A,y){T.set(this,void 0),this.b=new R.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(A.identifier),Je(this,T,y,"f"),Be(this,T,"f").onDidChangePassword(I=>{I.extensionId===this.a&&this.b.fire({key:I.key})})}get(A){return Be(this,T,"f").get(this.a,A)}store(A,y){return Be(this,T,"f").store(this.a,A,y)}delete(A){return Be(this,T,"f").delete(this.a,A)}}e.ExtensionSecrets=u,T=new WeakMap}),define(ye[55],De([1,0,4,129,3,18]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(y){function I(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?R.TunnelPrivacyId.Public:R.TunnelPrivacyId.Private),protocol:k.protocol}}y.fromApiTunnel=I;function L(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==R.TunnelPrivacyId.ConstantPrivate&&k.privacy!==R.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}y.fromServiceTunnel=L})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let A=class{constructor(I){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,L){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,L){return{dispose:()=>{}}}async $providePortAttributes(I,L,k,v,P){return[]}async $forwardPort(I,L){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([We(0,u.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(ye[56],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class R{constructor(u){u?(this.transformIncoming=u.transformIncoming.bind(u),this.transformOutgoing=u.transformOutgoing.bind(u),this.transformOutgoingURI=u.transformOutgoingURI.bind(u),this.transformOutgoingScheme=u.transformOutgoingScheme.bind(u)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=R}),define(ye[221],De([1,0,22]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let I=this.buffers.indexOf(y);return I<0&&(I=this.buffers.length,this.buffers.push(y)),I}}function T(A,y){if(y.serializeBuffersForPostMessage){const I=new R,L=(P,E)=>{if(E instanceof ArrayBuffer){const h=I.add(E);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(E)){const h=u(E);if(h){const d=I.add(E.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:h,byteLength:E.byteLength,byteOffset:E.byteOffset}}}}return E},k=JSON.stringify(A,L),v=I.buffers.map(P=>{const E=new Uint8Array(P);return a.VSBuffer.wrap(E)});return{message:k,buffers:v}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=T;function u(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(A,y){const I=y.map(v=>{const P=new ArrayBuffer(v.byteLength);return new Uint8Array(P).set(v.buffer),P}),L=y.length?(v,P)=>{if(P&&typeof P=="object"&&P.$$vscode_array_buffer_reference$$){const E=P,{index:h}=E,d=I[h];if(E.view)switch(E.view.type){case 1:return new Int8Array(d,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return P}:void 0;return{message:JSON.parse(A,L),arrayBuffers:I}}e.deserializeWebviewMessage=C}),define(ye[222],De([1,0,114]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function R(u){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:u,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function T(u){return new a.URITransformer(R(u))}e.createURITransformer=T}),define(ye[130],De([1,0,185,9,2,6,4,39,44,16,45,160,37]),function(te,e,a,R,T,u,C,A,y,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var P;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(P=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var E;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(E=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function h(K){const G=K;return!!G&&typeof G.getSelection=="function"&&!!G.onDidChangeSelection}e.isEditorPaneWithSelection=h;function d(K,G,de){for(const be of de.visibleEditorPanes)if(be.group.id===G&&K.matches(be.input))return be.getViewState()}e.findViewStateForEditor=d;function f(K){if(i(K))return!1;const G=K;return T.URI.isUri(G?.resource)}e.isResourceEditorInput=f;function p(K){if(i(K))return!1;const G=K;return G?.original!==void 0&&G.modified!==void 0}e.isResourceDiffEditorInput=p;function b(K){if(i(K)||p(K))return!1;const G=K;return G?.primary!==void 0&&G.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function S(K){if(i(K))return!1;const G=K;return G?G.resource===void 0||G.resource.scheme===I.Schemas.untitled||G.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;const g=/Untitled-\d+/;function t(K){return K.scheme===I.Schemas.untitled&&K.path.length>1&&!g.test(K.path)}e.isUntitledWithAssociatedResource=t;function l(K){if(i(K))return!1;const G=K;return T.URI.isUri(G?.base?.resource)&&T.URI.isUri(G?.input1?.resource)&&T.URI.isUri(G?.input2?.resource)&&T.URI.isUri(G?.result?.resource)}e.isResourceMergeEditorInput=l;var r;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var o;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o=e.SaveReason||(e.SaveReason={}));class n{constructor(){this.a=new Map}registerSource(G,de){let be=this.a.get(G);return be||(be={source:G,label:de},this.a.set(G,be)),be.source}getSourceLabel(G){return this.a.get(G)?.label??G}}e.SaveSourceRegistry=new n;var m;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends u.Disposable{}e.AbstractEditorInput=s;function i(K){return K instanceof s}e.isEditorInput=i;function c(K){const G=K;return T.URI.isUri(G?.preferredResource)}function w(K){const G=K;return i(G?.primary)&&i(G?.secondary)}e.isSideBySideEditorInput=w;function D(K){const G=K;return i(G?.modified)&&i(G?.original)}e.isDiffEditorInput=D;function F(K,G,de,be,Ee){return ee(be,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const Pe={...de,limits:{size:Number.MAX_VALUE}};K.openEditor(G,Pe)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>Ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=F;function x(K){return i(K?.editor)}e.isEditorInputWithOptions=x;function q(K){const G=K;return x(K)&&G?.group!==void 0}e.isEditorInputWithOptionsAndGroup=q;function M(K){const G=K;return typeof G?.groupId=="number"&&i(G.editor)}e.isEditorIdentifier=M;var B;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var O;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(O=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri(G,de){if(!G)return;if(l(G))return e.EditorResourceAccessor.getOriginalUri(G.result,de);if(de?.supportSideBySide){const{primary:Ee,secondary:Pe}=this.a(G);if(Ee&&Pe){if(de?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:de.filterByScheme}),secondary:this.getOriginalUri(Pe,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===U.ANY)return this.getOriginalUri(Ee,{filterByScheme:de.filterByScheme})??this.getOriginalUri(Pe,{filterByScheme:de.filterByScheme});G=de.supportSideBySide===U.PRIMARY?Ee:Pe}}if(p(G)||b(G)||l(G))return;const be=c(G)?G.preferredResource:G.resource;return!be||!de||!de.filterByScheme?be:this.b(be,de.filterByScheme)}a(G){return w(G)||b(G)?{primary:G.primary,secondary:G.secondary}:D(G)||p(G)?{primary:G.modified,secondary:G.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(G,de){if(!G)return;if(l(G))return e.EditorResourceAccessor.getCanonicalUri(G.result,de);if(de?.supportSideBySide){const{primary:Ee,secondary:Pe}=this.a(G);if(Ee&&Pe){if(de?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:de.filterByScheme}),secondary:this.getCanonicalUri(Pe,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===U.ANY)return this.getCanonicalUri(Ee,{filterByScheme:de.filterByScheme})??this.getCanonicalUri(Pe,{filterByScheme:de.filterByScheme});G=de.supportSideBySide===U.PRIMARY?Ee:Pe}}if(p(G)||b(G)||l(G))return;const be=G.resource;return!be||!de||!de.filterByScheme?be:this.b(be,de.filterByScheme)}b(G,de){if(Array.isArray(de)){if(de.some(be=>G.scheme===be))return G}else if(de===G.scheme)return G}}e.EditorResourceAccessor=new z;var j;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class le{constructor(){this.c=new Map,this.d=new Map}start(G){const de=this.a=G.get(C.IInstantiationService);for(const[be,Ee]of this.c)this.e(be,Ee,de);this.c.clear()}e(G,de,be){const Ee=be.createInstance(de);this.d.set(G,Ee)}registerFileEditorFactory(G){if(this.b)throw new Error("Can only register one file editor factory.");this.b=G}getFileEditorFactory(){return(0,R.assertIsDefined)(this.b)}registerEditorSerializer(G,de){if(this.c.has(G)||this.d.has(G))throw new Error(`A editor serializer with type ID '${G}' was already registered.`);return this.a?this.e(G,de,this.a):this.c.set(G,de),(0,u.toDisposable)(()=>{this.c.delete(G),this.d.delete(G)})}getEditorSerializer(G){return this.d.get(typeof G=="string"?G:G.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new le);async function V(K,G,de){return!K||!K.length?[]:await Promise.all(K.map(async be=>{const Ee=T.URI.revive(be.fileUri);if(!Ee){de.info("Cannot resolve the path because it is not valid.",be);return}if(!await G.canHandleResource(Ee)){de.info("Cannot resolve the path because it cannot be handled",be);return}let Fe=be.exists,se=be.type;if(typeof Fe!="boolean"||typeof se!="number")try{se=(await G.stat(Ee)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Fe=!0}catch(fe){de.error(fe),Fe=!1}if(!Fe&&be.openOnlyIfExists){de.info("Cannot resolve the path because it does not exist",be);return}if(se===y.FileType.Directory){de.info("Cannot resolve the path because it is a directory",be);return}const oe={...be.options,pinned:!0};return Fe?{resource:Ee,options:oe}:{resource:Ee,options:oe,forceUntitled:!0}}))}e.pathsToEditors=V;var _;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(_=e.EditorsOrder||(e.EditorsOrder={}));function J(K){const G=K;if(!G)return!1;const de=G;if(de.modified)return J(de.modified);const be=G;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}e.isTextEditorViewState=J;function ie(K){return(0,L.isErrorWithActions)(K)}e.isEditorOpenError=ie;function ee(K,G,de){const be=(0,L.createErrorWithActions)(K,G);return be.forceMessage=de?.forceMessage,be.forceSeverity=de?.forceSeverity,be.allowDialog=de?.allowDialog,be}e.createEditorOpenError=ee}),define(ye[223],De([1,0,3,186,4,6,28,39,15,61,23,67,214]),function(te,e,a,R,T,u,C,A,y,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,v.registerIcon)("default-view-icon",k.Codicon.window,(0,R.localize)(0,null));var P;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(P=e.Extensions||(e.Extensions={}));var E;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(E=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function h(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=h;class d extends u.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new a.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(o,n,m){const s=this.get(o.id);if(s)return s;const i=o;return i.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:i.openCommandActionDescriptor??{id:i.id},(0,C.getOrSet)(this.g,n,[]).push(i),m?.isDefault&&this.h.push(i),this.c.fire({viewContainer:i,viewContainerLocation:n}),i}deregisterViewContainer(o){for(const n of this.g.keys()){const m=this.g.get(n),s=m?.indexOf(o);if(s!==-1){m?.splice(s,1),m.length===0&&this.g.delete(n),this.f.fire({viewContainer:o,viewContainerLocation:n});return}}}get(o){return this.all.filter(n=>n.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(n=>this.getViewContainers(n).filter(m=>m?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(n=>this.getViewContainerLocation(n)===o)}}A.Registry.add(P.ViewContainersRegistry,new d);var f;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(f=e.ViewContentGroups||(e.ViewContentGroups={}));function p(r,o){const n=r.group??f.More,m=o.group??f.More;return n!==m?n.localeCompare(m):(r.order??5)-(o.order??5)}class b extends u.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new a.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new a.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new a.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new I.SetMap}registerViews(o,n){this.registerViews2([{views:o,viewContainer:n}])}registerViews2(o){o.forEach(({views:n,viewContainer:m})=>this.l(n,m)),this.c.fire(o)}deregisterViews(o,n){const m=this.m(o,n);m.length&&this.f.fire({views:m,viewContainer:n})}moveViews(o,n){for(const m of this.j.keys())if(m!==n){const s=this.m(o,m);s.length&&(this.l(s,n),this.g.fire({views:s,from:m,to:n}))}}getViews(o){return this.j.get(o)||[]}getView(o){for(const n of this.i){const m=(this.j.get(n)||[]).filter(s=>s.id===o)[0];if(m)return m}return null}getViewContainer(o){for(const n of this.i)if((this.j.get(n)||[]).filter(s=>s.id===o)[0])return n;return null}registerViewWelcomeContent(o,n){return this.k.add(o,n),this.h.fire(o),(0,u.toDisposable)(()=>{this.k.delete(o,n),this.h.fire(o)})}registerViewWelcomeContent2(o,n){const m=new Map;for(const[s,i]of n)this.k.add(o,i),m.set(s,(0,u.toDisposable)(()=>{this.k.delete(o,i),this.h.fire(o)}));return this.h.fire(o),m}getViewWelcomeContent(o){const n=[];return this.k.forEach(o,m=>n.push(m)),n.sort(p)}l(o,n){let m=this.j.get(n);m||(m=[],this.j.set(n,m),this.i.push(n));for(const s of o){if(this.getView(s.id)!==null)throw new Error((0,R.localize)(1,null,s.id));m.push(s)}}m(o,n){const m=this.j.get(n);if(!m)return[];const s=[],i=[];for(const c of m)o.includes(c)?s.push(c):i.push(c);return s.length&&(i.length?this.j.set(n,i):(this.j.delete(n),this.i.splice(this.i.indexOf(n),1))),s}}A.Registry.add(P.ViewsRegistry,new b),e.IViewsService=(0,T.createDecorator)("viewsService"),e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var S;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(S=e.ViewVisibilityState||(e.ViewVisibilityState={}));var g;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(g=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(o,n){this.c=!1,this.d=!1,(0,L.mixin)(this,o),this.d=!!n,this.resolve=async m=>{if(n&&!this.c){const s=await n(m);s&&(this.tooltip=this.tooltip??s.tooltip,this.command=this.command??s.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class l extends Error{constructor(o){super((0,R.localize)(2,null,o))}}e.NoTreeViewError=l}),define(ye[131],De([1,0,3,17,187]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class u{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,I,L){const k={command:A};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.s("request",k),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const P=this.f.get(k.seq);if(P){this.f.delete(k.seq);const E={type:"response",seq:0,request_seq:k.seq,success:!1,command:A,message:(0,T.localize)(0,null,L,A)};P(E)}},L)}return I&&this.f.set(k.seq,I),k.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,R.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,I=this.f.get(y.request_seq);I&&(this.f.delete(y.request_seq),I(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,I)=>A.set(I,y)),await(0,R.timeout)(500),A.forEach((y,I)=>{y({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.f.delete(I)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=u}),define(ye[224],De([1,0,188,54,4]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new R.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new R.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new R.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new R.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new R.RawContextKey("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new R.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new R.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new R.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new R.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new R.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new R.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new R.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new R.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new R.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new R.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new R.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new R.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new R.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new R.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new R.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new R.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new R.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new R.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new R.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new R.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new R.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new R.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new R.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new R.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new R.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new R.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new R.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new R.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new R.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new R.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new R.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new R.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new R.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new R.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new R.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new R.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new R.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new R.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new R.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new R.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new R.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new R.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new R.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new R.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new R.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new R.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const u=v=>a.localize(51,null,v);e.debuggerDisabledMessage=u,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var C;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(C=e.State||(e.State={}));function A(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,T.createDecorator)("debugService");var k;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[225],De([1,0,8,2,10,23,16]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(r,o,n){return r.replace(A,function(m,s){return o&&s.length>0&&s[0]!=="_"?m:n&&n.hasOwnProperty(s)?n[s]:m})}e.formatPII=y;function I(r){const o={};for(const n of Object.keys(r))n.startsWith("!")||(o[n]=r[n]);return o}e.filterExceptionsFromTelemetry=I;function L(r){return r.configuration.request==="attach"&&!k(r)&&(!r.parentSession||L(r.parentSession))}e.isSessionAttach=L;function k(r){let o=r.configuration.type;if(!!o)return o==="vslsShare"&&(o=r.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(o,"extensionhost")||(0,a.equalsIgnoreCase)(o,"pwa-extensionhost")?r:r.parentSession?k(r.parentSession):void 0}e.getExtensionHostDebugSession=k;function v(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=v;function P(r,o,n){let m,s=0;const i=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let c=null;for(;c=i.exec(r);){const w=c.index+1,D=w+c[0].length;if(w<=o&&D>=n){m=c[0],s=w;break}}if(m){const w=/\w+/g;let D=null;for(;(D=w.exec(m))&&!(D.index+1+s+D[0].length>=n););D&&(m=m.substring(0,w.lastIndex))}return m?{start:s,end:s+m.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=P;const E=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(r){return!!(r&&r.match(E))}e.isUri=h;function d(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(h(r.path))return R.URI.parse(r.path);if((0,T.isAbsolute)(r.path))return R.URI.file(r.path)}return r.path}function f(r){if(typeof r.path=="object"){const o=R.URI.revive(r.path);if(o)return o.scheme===C.Schemas.file?o.fsPath:o.toString()}return r.path}function p(r,o){const n=o?d:f,m=(0,u.deepClone)(r);return S(m,(s,i)=>{s&&i&&(i.path=n(i))}),m}e.convertToDAPaths=p;function b(r,o){const n=o?d:f,m=(0,u.deepClone)(r);return S(m,(s,i)=>{!s&&i&&(i.path=n(i))}),m}e.convertToVSCPaths=b;function S(r,o){switch(r.type){case"event":{const n=r;switch(n.event){case"output":o(!1,n.body.source);break;case"loadedSource":o(!1,n.body.source);break;case"breakpoint":o(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=r;switch(n.command){case"setBreakpoints":o(!0,n.arguments.source);break;case"breakpointLocations":o(!0,n.arguments.source);break;case"source":o(!0,n.arguments.source);break;case"gotoTargets":o(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(m=>o(!1,m));break;default:break}break}case"response":{const n=r;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(m=>o(!1,m.source));break;case"loadedSources":n.body.sources.forEach(m=>o(!1,m));break;case"scopes":n.body.scopes.forEach(m=>o(!1,m.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(m=>o(!1,m.source));break;case"setBreakpoints":n.body.breakpoints.forEach(m=>o(!1,m.source));break;case"disassemble":n.body?.instructions.forEach(s=>o(!1,s.location));break;default:break}break}}}function g(r){return r.filter(o=>!o.presentation?.hidden).sort((o,n)=>o.presentation?n.presentation?o.presentation.group?n.presentation.group?o.presentation.group!==n.presentation.group?o.presentation.group.localeCompare(n.presentation.group):t(o.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(o.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=g;function t(r,o){return typeof r!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:r-o}async function l(r,o){const n=r.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorLanguageId});if(n!=="none"&&(await o.saveAll(),n==="allEditorsInActiveGroup")){const m=o.activeEditorPane;m&&m.input.resource?.scheme===C.Schemas.untitled&&await o.save({editor:m.input,groupId:m.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=l}),define(ye[226],De([1,0,46,227,23,10,12,8,29,189,131]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(f,p){this.p=p,this.r=Buffer.allocUnsafe(0),this.t=-1,f.on("data",b=>this.w(b))}sendMessage(f){if(this.p){const p=JSON.stringify(f);this.p.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${k.a}${p}`,"utf8")}}w(f){for(this.r=Buffer.concat([this.r,f]);;){if(this.t>=0){if(this.r.length>=this.t){const p=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(b){this.m.fire(new Error((b.message||b)+`
`+p))}continue}}else{const p=this.r.indexOf(k.a);if(p!==-1){const S=this.r.toString("utf8",0,p).split(k.b);for(const g of S){const t=g.split(k.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(p+k.a.length);continue}}break}}}e.StreamDebugAdapter=k,k.a=`\r
\r
`,k.b=/\r?\n/,k.l=/: */;class v extends k{startSession(){return new Promise((f,p)=>{let b=!1;this.x=this.y(()=>{this.v(this.x,this.x),f(),b=!0}),this.x.on("close",()=>{b?this.m.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.x.on("error",S=>{b?this.m.fire(S):p(S)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class P extends v{constructor(f){super(),this.z=f}y(f){return R.createConnection(this.z.port,this.z.host||"127.0.0.1",f)}}e.SocketDebugAdapter=P;class E extends v{constructor(f){super(),this.z=f}y(f){return R.createConnection(this.z.path,f)}}e.NamedPipeDebugAdapter=E;class h extends k{constructor(f,p){super(),this.y=f,this.z=p}async startSession(){const f=this.y.command,p=this.y.args,b=this.y.options||{};try{if(f)if(u.isAbsolute(f)){if(!await y.Promises.exists(f))throw new Error(I.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.z));let S=process.env;if(b.env&&Object.keys(b.env).length>0&&(S=T.mixin(T.deepClone(process.env),b.env)),f==="node")if(Array.isArray(p)&&p.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:S,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(t.cwd=b.cwd);const l=a.fork(p[0],p.slice(1),t);if(!l.pid)throw new Error(I.localize(2,null,p[0]));this.x=l}else throw new Error(I.localize(3,null));else{const g={env:S};b.cwd&&(g.cwd=b.cwd),this.x=a.spawn(f,p,g)}this.x.on("error",g=>{this.m.fire(g)}),this.x.on("exit",(g,t)=>{this.n.fire(g)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",g=>{this.m.fire(g)}),this.x.stdin.on("error",g=>{this.m.fire(g)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(S){this.m.fire(S)}}async stopSession(){return this.x?(await this.u(),C.isWindows?new Promise((f,p)=>{const b=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(S,g,t){if(S)return p(S)});b.on("exit",f),b.on("error",p)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(f,p){if(!f)return;const b=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?b.runtime=u.join(p,f.runtime):b.runtime=f.runtime),f.runtimeArgs&&(b.runtimeArgs=f.runtimeArgs),f.program&&(u.isAbsolute(f.program)?b.program=f.program:b.program=u.join(p,f.program)),f.args&&(b.args=f.args);const S=f;return S.win&&(b.win=h.A(S.win,p)),S.winx86&&(b.winx86=h.A(S.winx86,p)),S.windows&&(b.windows=h.A(S.windows,p)),S.osx&&(b.osx=h.A(S.osx,p)),S.linux&&(b.linux=h.A(S.linux,p)),b}static platformAdapterExecutable(f,p){let b=Object.create(null);p=p.toLowerCase();for(const o of f)if(o.contributes){const n=o.contributes.debuggers;n&&n.length>0&&n.filter(m=>typeof m.type=="string"&&A.equalsIgnoreCase(m.type,p)).forEach(m=>{const s=h.A(m,o.extensionLocation.fsPath);b=T.mixin(b,s,o.isBuiltin)})}let S;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?S=b.winx86||b.win||b.windows:C.isWindows?S=b.win||b.windows:C.isMacintosh?S=b.osx:C.isLinux&&(S=b.linux),S=S||b;const g=S.program||b.program,t=S.args||b.args,l=S.runtime||b.runtime,r=S.runtimeArgs||b.runtimeArgs;if(l)return{type:"executable",command:l,args:(r||[]).concat(typeof g=="string"?[g]:[]).concat(t||[])};if(g)return{type:"executable",command:g,args:t||[]}}}e.ExecutableDebugAdapter=h}),define(ye[228],De([1,0,46,32,12]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function u(I,L){return new Promise((k,v)=>{let P="";const E=a.spawn(I,L);E.pid&&E.stdout.on("data",h=>{P+=h.toString()}),E.on("error",h=>{v(h)}),E.on("close",h=>{k(P)})})}async function C(I){if(I)if(T.isWindows){const L=await new Promise((k,v)=>{te(["windows-process-tree"],k,v)});return new Promise(k=>{L.getProcessTree(I,v=>{k(!!v&&v.children.length>0)})})}else return u("/usr/bin/pgrep",["-lP",String(I)]).then(L=>{const k=L.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var A;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(A||(A={}));function y(I,L,k,v,P){I=I.trim().toLowerCase();let E;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?E=1:I.indexOf("cmd.exe")>=0?E=0:I.indexOf("bash")>=0?E=2:T.isWindows?E=0:E=2;let h,d=" ";switch(E){case 1:if(h=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),v){const f=(0,R.getDriveLetter)(v);f&&(d+=`${f}:; `),d+=`cd ${h(v)}; `}if(P)for(const f in P){const p=P[f];p===null?d+=`Remove-Item env:${f}; `:d+=`\${env:${f}}='${p}'; `}if(L.length>0){const f=L.shift(),p=k?f:h(f);d+=p[0]==="'"?`& ${p} `:`${p} `;for(const b of L)d+=b==="<"||b===">"||k?b:h(b),d+=" "}break;case 0:if(h=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(p=>f.includes(p))||f.length===0?`"${f}"`:f),v){const f=(0,R.getDriveLetter)(v);f&&(d+=`${f}: && `),d+=`cd ${h(v)} && `}if(P){d+='cmd /C "';for(const f in P){let p=P[f];p===null?d+=`set "${f}=" && `:(p=p.replace(/[&^|<>]/g,b=>`^${b}`),d+=`set "${f}=${p}" && `)}}for(const f of L)d+=f==="<"||f===">"||k?f:h(f),d+=" ";P&&(d+='"');break;case 2:{h=p=>(p=p.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),p.length===0?'""':p);const f=p=>/[^\w@%\/+=,.:^-]/.test(p)?`'${p.replace(/'/g,"'\\''")}'`:p;if(v&&(d+=`cd ${h(v)} ; `),P){d+="/usr/bin/env";for(const p in P){const b=P[p];b===null?d+=` -u ${f(p)}`:d+=` ${f(`${p}=${b}`)}`}d+=" "}for(const p of L)d+=p==="<"||p===">"||k?p:h(p),d+=" ";break}}return d}e.prepareCommand=y}),define(ye[92],De([1,0,22,38,64,86,16,10,12,54]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",u.Mimes.latex,u.Mimes.markdown,"image/png","image/jpeg",u.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[u.Mimes.latex,u.Mimes.markdown,"application/json",u.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var P;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(P=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var p;(function(U){U.scheme=C.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${z.join("")}]+`),le=7;function V(G,de){const be=de.toString(le),Pe=`${be.length<z.length?z[be.length-1]:"z"}${be}s${(0,a.encodeBase64)(a.VSBuffer.fromString(G.scheme),!0,!0)}`;return G.with({scheme:U.scheme,fragment:Pe})}U.generate=V;function _(G){if(G.scheme!==U.scheme)return;const de=G.fragment.indexOf("s");if(de<0)return;const be=parseInt(G.fragment.substring(0,de).replace(j,""),le),Ee=(0,a.decodeBase64)(G.fragment.substring(de+1)).toString();if(!isNaN(be))return{handle:be,notebook:G.with({scheme:Ee,fragment:null})}}U.parse=_;function J(G,de){return G.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${de??""},${G.scheme!==C.Schemas.file?G.scheme:""}`})}U.generateCellOutputUri=J;function ie(G){if(G.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const de=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(G.fragment);if(!de)return;const be=de[1]&&de[1]!==""?de[1]:void 0,Ee=de[2];return{outputId:be,notebook:G.with({scheme:Ee||C.Schemas.file,fragment:null})}}U.parseCellOutputUri=ie;function ee(G,de,be){return U.generate(G,de).with({scheme:be})}U.generateCellPropertyUri=ee;function K(G,de){if(G.scheme===de)return U.parse(G.with({scheme:U.scheme}))}U.parseCellPropertyUri=K})(p=e.CellUri||(e.CellUri={}));const b=U=>y.isWindows?U.replace(/\//g,"\\"):U;class S{constructor(z=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(z)].map(le=>({pattern:le,matches:R.parse(b(le))}))}sort(z){const j=new Map(T.Iterable.map(z,V=>[V,b(V)]));let le=[];for(const{matches:V}of this.d)for(const[_,J]of j)if(V(J)){le.push(_),j.delete(_);break}return j.size&&(le=le.concat([...j.keys()].sort((V,_)=>this.e.indexOf(V)-this.e.indexOf(_)))),le}prioritize(z,j){const le=this.f(z);if(le===-1){this.d.unshift({pattern:z,matches:R.parse(b(z))});return}const V=new Set(j.map(J=>this.f(J,le)));V.delete(-1);const _=Array.from(V).sort();this.d.splice(le+1,0,..._.map(J=>this.d[J]));for(let J=_.length-1;J>=0;J--)this.d.splice(_[J],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,j=this.d.length){const le=b(z);for(let V=0;V<j;V++)if(this.d[V].matches(le))return V;return-1}}e.MimeTypeDisplayOrder=S;function g(U,z,j,le=(V,_)=>V===_){const V=[];function _(ee,K,G){if(K===0&&G.length===0)return;const de=V[V.length-1];de&&de.start+de.deleteCount===ee?(de.deleteCount+=K,de.toInsert.push(...G)):V.push({start:ee,deleteCount:K,toInsert:G})}let J=0,ie=0;for(;;){if(J===U.length){_(J,0,z.slice(ie));break}if(ie===z.length){_(J,U.length-J,[]);break}const ee=U[J],K=z[ie];if(le(ee,K)){J+=1,ie+=1;continue}j(K)?(_(J,1,[]),J+=1):(_(J,0,[K]),ie+=1)}return V}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(U){U.default="default",U.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(U){const z=U;return!!((typeof z.include=="string"||R.isRelativePattern(z.include))&&(typeof z.exclude=="string"||R.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=l;function r(U,z,j){if(Array.isArray(U.viewType)&&U.viewType.indexOf(z)>=0||U.viewType===z)return!0;if(U.filenamePattern){const le=l(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,V=l(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(R.match(le,(0,A.basename)(j.fsPath).toLowerCase()))return!(V&&R.match(V,(0,A.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var o;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(o=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class n{static create(z){return`${n.d}${z}`}static parse(z){if(z.startsWith(n.d))return z.substring(n.d.length)}}e.NotebookWorkingCopyTypeIdentifier=n,n.d="notebook/";function m(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=m;const s=new TextDecoder;function i(U){const z=[];let j=!1;for(const le of U)(z.length===0||j)&&(z.push(le),j=!0);return F(z),O(a.VSBuffer.concat(z.map(le=>a.VSBuffer.wrap(le))))}e.compressOutputItemStreams=i;const c=`${String.fromCharCode(27)}[A`,w=c.split("").map(U=>U.charCodeAt(0)),D=10;function F(U){U.forEach((z,j)=>{if(j===0||z.length<c.length)return;const le=U[j-1],V=z.subarray(0,c.length);if(V[0]===w[0]&&V[1]===w[1]&&V[2]===w[2]){const _=le.lastIndexOf(D);if(_===-1)return;U[j-1]=le.subarray(0,_),U[j]=z.subarray(c.length)}})}function x(U){let z=U;do U=z,z=U.replace(/[^\n]\x08/gm,"");while(z.length<U.length);return U}function q(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const z=U.match(/^(.*)\r+/m)[1];let j=U.match(/\r+(.*)$/m)[1];j=j+z.slice(j.length,z.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return U}const M="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(U){return!U.buffer.includes(M)&&!U.buffer.includes(B)?U:a.VSBuffer.fromString(q(x(s.decode(U.buffer))))}}),define(ye[229],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var R;(function(T){T[T.Output=1]="Output",T[T.OutputItems=2]="OutputItems",T[T.ExecutionState=3]="ExecutionState"})(R=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(ye[57],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(u){u.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(u){u[u.IsSame=0]="IsSame",u[u.Disconnected=1]="Disconnected",u[u.IsChild=2]="IsChild",u[u.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class T{static fromExtHostTestItem(C,A,y=C.parent){if(C._isRoot)return new T([A]);const I=[C.id];for(let L=y;L&&L.id!==A;L=L.parent)I.push(L.id);return I.push(A),new T(I.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const A=C.indexOf("\0");return A===-1?C:C.slice(0,A)}static fromString(C){return new T(C.split("\0"))}static join(C,A){return new T([...C.path,A])}static joinToString(C,A){return C.toString()+"\0"+A}static parentId(C){const A=C.lastIndexOf("\0");return A===-1?void 0:C.slice(0,A)}static localId(C){const A=C.lastIndexOf("\0");return A===-1?C:C.slice(A+1)}static compare(C,A){return C===A?0:A.startsWith(C+"\0")?2:C.startsWith(A+"\0")?3:1}constructor(C,A=C.length){if(this.path=C,this.d=A,C.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new T(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new T(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new T(this.path,C)}compare(C){if(typeof C=="string")return T.compare(this.toString(),C);for(let A=0;A<C.d&&A<this.d;A++)if(C.path[A]!==this.path[A])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=T}),define(ye[75],De([1,0,2,35,57]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var u;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(u=e.TestResultState||(e.TestResultState={}));var C;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable",s[s.SupportsContinuousRun=64]="SupportsContinuousRun"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=s=>"runIn"in s;e.isStartControllerTests=A;var y;(function(s){s.serialize=i=>({range:i.range.toJSON(),uri:i.uri.toJSON()}),s.deserialize=i=>({range:R.Range.lift(i.range),uri:a.URI.revive(i.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var I;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(I=e.TestMessageType||(e.TestMessageType={}));var L;(function(s){s.serialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&y.serialize(i.location)}),s.deserialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&y.deserialize(i.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const k=(s,i)=>`${i?"s":"e"}${s}`;e.getMarkId=k;var v;(function(s){s.serialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&y.serialize(i.location)}),s.deserialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&y.deserialize(i.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var P;(function(s){s.serialize=i=>i.type===0?L.serialize(i):v.serialize(i),s.deserialize=i=>i.type===0?L.deserialize(i):v.deserialize(i)})(P=e.ITestMessage||(e.ITestMessage={}));var E;(function(s){s.serializeWithoutMessages=i=>({state:i.state,duration:i.duration,messages:[]}),s.serialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(P.serialize)}),s.deserialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(P.deserialize)})})(E=e.ITestTaskState||(e.ITestTaskState={}));const h="\0",d=(s,i)=>s+h+i;e.namespaceTestTag=d;const f=s=>{const i=s.indexOf(h);return{ctrlId:s.slice(0,i),tagId:s.slice(i+1)}};e.denamespaceTestTag=f;var p;(function(s){s.serialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?.toJSON(),range:i.range?.toJSON()||null,description:i.description,error:i.error,sortText:i.sortText}),s.deserialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?a.URI.revive(i.uri):void 0,range:i.range?R.Range.lift(i.range):null,description:i.description,error:i.error,sortText:i.sortText})})(p=e.ITestItem||(e.ITestItem={}));var b;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(s){s.serialize=i=>({expand:i.expand,item:p.serialize(i.item)}),s.deserialize=i=>({controllerId:T.TestId.root(i.item.extId),expand:i.expand,item:p.deserialize(i.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(s){s.serialize=i=>{let c;return i.item&&(c={},i.item.label!==void 0&&(c.label=i.item.label),i.item.tags!==void 0&&(c.tags=i.item.tags),i.item.busy!==void 0&&(c.busy=i.item.busy),i.item.uri!==void 0&&(c.uri=i.item.uri?.toJSON()),i.item.range!==void 0&&(c.range=i.item.range?.toJSON()),i.item.description!==void 0&&(c.description=i.item.description),i.item.error!==void 0&&(c.error=i.item.error),i.item.sortText!==void 0&&(c.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:c}},s.deserialize=i=>{let c;return i.item&&(c={},i.item.label!==void 0&&(c.label=i.item.label),i.item.tags!==void 0&&(c.tags=i.item.tags),i.item.busy!==void 0&&(c.busy=i.item.busy),i.item.range!==void 0&&(c.range=i.item.range?R.Range.lift(i.item.range):null),i.item.description!==void 0&&(c.description=i.item.description),i.item.error!==void 0&&(c.error=i.item.error),i.item.sortText!==void 0&&(c.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:c}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(s,i)=>{i.expand!==void 0&&(s.expand=i.expand),i.item!==void 0&&(s.item=s.item?Object.assign(s.item,i.item):i.item)};e.applyTestItemUpdate=t;var l;(function(s){s.serializeWithoutMessages=i=>({...S.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(E.serializeWithoutMessages),retired:i.retired}),s.serialize=i=>({...S.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(E.serialize),retired:i.retired}),s.deserialize=i=>({...S.deserialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(E.deserialize),retired:!0})})(l=e.TestResultItem||(e.TestResultItem={}));var r;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var o;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var n;(function(s){s.deserialize=i=>i.op===0?{op:i.op,item:S.deserialize(i.item)}:i.op===1?{op:i.op,item:g.deserialize(i.item)}:i.op===2?{op:i.op,uri:a.URI.revive(i.uri),docv:i.docv}:i,s.serialize=i=>i.op===0?{op:i.op,item:S.serialize(i.item)}:i.op===1?{op:i.op,item:g.serialize(i.item)}:i})(n=e.TestsDiffOp||(e.TestsDiffOp={}));class m{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(i){const c=this.o();for(const w of i)switch(w.op){case 0:this.j(S.deserialize(w.item),c);break;case 1:this.k(g.deserialize(w.item),c);break;case 3:this.l(w.itemId,c);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}c.complete?.()}j(i,c){const w=T.TestId.parentId(i.item.extId)?.toString();let D;if(!w)D=this.p(i),this.f.add(D),this.d.set(i.item.extId,D);else if(this.d.has(w)){const F=this.d.get(w);F.children.add(i.item.extId),D=this.p(i,F),this.d.set(i.item.extId,D)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(i)}`);return}return c.add?.(D),i.expand===2&&this.g++,D}k(i,c){const w=this.d.get(i.extId);if(!!w)return i.expand!==void 0&&(w.expand===2&&this.g--,i.expand===2&&this.g++),(0,e.applyTestItemUpdate)(w,i),c.update?.(w),w}l(i,c){const w=this.d.get(i);if(!w)return;const D=T.TestId.parentId(w.item.extId)?.toString();D?this.d.get(D).children.delete(w.item.extId):this.f.delete(w);const F=[[i]];for(;F.length;)for(const x of F.pop()){const q=this.d.get(x);q&&(F.push(q.children),this.d.delete(x),c.remove?.(q,q!==w),q.expand===2&&this.g--)}}m(i){}updatePendingRoots(i){this.h+=i}o(){return{}}}e.AbstractIncrementalTestCollection=m}),define(ye[93],De([1,0,17,3,6,50,75,57]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(p,b)=>p===b,k=Object.entries({range:(p,b)=>p===b?!0:!p||!b?!1:p.equalsRange(b),busy:I,label:I,description:I,error:I,sortText:I,tags:(p,b)=>!(p.length!==b.length||p.some(S=>!b.includes(S)))}),v=(p,b)=>{let S;for(const[g,t]of k)t(p[g],b[g])||(S?S[g]=b[g]:S={[g]:b[g]});return S};class P extends T.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new R.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const S of this.tree.values())this.G(S)}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const S of this.k)if(S.op===2&&S.uri===b.uri){S.docv=b.docv;return}break}case 1:{const S=this.k[this.k.length-1];if(S){if(S.op===1&&S.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(S.item,b.item);return}if(S.op===0&&S.item.item.extId===b.item.extId){(0,C.applyTestItemUpdate)(S.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,S){const g=this.tree.get(b);if(!!g){if((g.expandLevels===void 0||S>g.expandLevels)&&(g.expandLevels=S),g.expand===1){const t=this.I(g);return t.isOpen()?this.H(g,S-1):t.wait().then(()=>this.H(g,S-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.H(g,S-1)):this.H(g,S-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,S){switch(S.op){case 3:this.L(A.TestId.joinToString(b.fullId,S.id));break;case 0:this.u(S.item,b);break;case 5:for(const g of S.ops)this.p(b,g);break;case 1:this.w(S.new,S.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:S.update}});break;case 6:this.s(b.actual.uri);break;default:(0,u.assertNever)(S)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,S){const g=A.TestId.fromExtHostTestItem(b,this.root.id,S?.actual),t=this.m.getApiFor(b);t.parent&&t.parent!==S?.actual&&this.m.getChildren(t.parent).delete(b.id);let l=this.tree.get(g.toString());if(!l){l={fullId:g,actual:b,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(l.fullId.toString(),l),this.C(b,S),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:l.expand,item:this.m.toITestItem(b)}}),this.F(b,l,S);return}if(l.actual===b){this.D(b,l,S);return}if(l.actual.uri?.toString()!==b.uri?.toString())return this.L(g.toString()),this.u(b,S);const r=this.m.getChildren(l.actual),o=l.actual,n=v(this.m.toITestItem(o),this.m.toITestItem(b));this.m.getApiFor(o).listener=void 0,l.actual=b,l.expand=0,n&&(n.hasOwnProperty("tags")&&(this.w(b.tags,o.tags,g.toString()),delete n.tags),this.p(l,{op:4,update:n})),this.F(b,l,S);for(const[m,s]of r)this.m.getChildren(b).get(s.id)||this.L(A.TestId.joinToString(g,s.id));this.s(l.actual.uri)}w(b,S,g){const t=new Set(S.map(l=>l.id));for(const l of b)t.delete(l.id)||this.y(l);this.pushDiff({op:1,item:{extId:g,item:{tags:b.map(l=>(0,C.namespaceTestTag)(this.m.controllerId,l.id))}}}),t.forEach(this.z,this)}y(b){const S=this.j.get(b.id);S?S.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const S=this.j.get(b);S&&!--S.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,b)}))}C(b,S){this.m.getApiFor(b).parent=S&&S.actual!==this.root?S.actual:void 0}D(b,S,g){this.C(b,g);const t=this.m.getApiFor(b);t.parent=g?.actual,t.listener=l=>this.p(S,l),this.G(S)}F(b,S,g){this.D(b,S,g);for(const[t,l]of this.m.getChildren(b))this.u(l,S)}G(b){let S;this.h?b.resolveBarrier?S=b.resolveBarrier.isOpen()?3:2:S=b.actual.canResolveChildren?1:0:S=0,S!==b.expand&&(b.expand=S,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:S}}),S===1&&b.expandLevels!==void 0&&this.I(b))}H(b,S){if(S<0)return;const g=[];for(const[t,l]of this.m.getChildren(b.actual)){const r=this.expand(A.TestId.joinToString(b.fullId,l.id),S);(0,a.isThenable)(r)&&g.push(r)}if(g.length)return Promise.all(g).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const l=new a.Barrier;return l.open(),l}b.expand=2,this.J(b);const S=b.resolveBarrier=new a.Barrier,g=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,l)};let t;try{t=this.h(b.actual===this.root?void 0:b.actual)}catch(l){g(l)}return(0,a.isThenable)(t)?t.catch(g).then(()=>{S.open(),this.G(b)}):(S.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const S=this.tree.get(b);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const g=[S];for(;g.length;){const t=g.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const l of t.actual.tags)this.z(l.id);this.tree.delete(t.fullId.toString());for(const[l,r]of this.m.getChildren(t.actual))g.push(this.tree.get(A.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=P;class E extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=E;class h extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class d extends Error{constructor(b,S,g){super(`TestItem with ID "${b}" is from controller "${S}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=d;const f=(p,b,S)=>{let g=new Map;return{get size(){return g.size},forEach(t,l){for(const r of g.values())t.call(l,r,this)},[Symbol.iterator](){return g.entries()},replace(t){const l=new Map,r=new Set(g.keys()),o={op:5,ops:[]};for(const n of t){if(!(n instanceof S))throw new h(n.id);const m=b(n).controllerId;if(m!==p.controllerId)throw new d(n.id,m,p.controllerId);if(l.has(n.id))throw new E(n.id);l.set(n.id,n),r.delete(n.id),o.ops.push({op:0,item:n})}for(const n of r.keys())o.ops.push({op:3,id:n});p.listener?.(o),g=l},add(t){if(!(t instanceof S))throw new h(t.id);g.set(t.id,t),p.listener?.({op:0,item:t})},delete(t){g.delete(t)&&p.listener?.({op:3,id:t})},get(t){return g.get(t)},toJSON(){return Array.from(g.values())}}};e.createTestItemChildren=f}),define(ye[132],De([1,0,93]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const R=new WeakMap,T=(C,A)=>{const y={controllerId:A};return R.set(C,y),y};e.createPrivateApiFor=T;const u=C=>{const A=R.get(C);if(!A)throw new a.InvalidTestItemError(C?.id||"<unknown>");return A};e.getPrivateApiFor=u}),define(ye[94],De([1,0,16,2]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function T(A,y){return A.scheme===a.Schemas.http||A.scheme===a.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===a.Schemas.file&&(A=R.URI.from({scheme:a.Schemas.vscodeRemote,authority:y.authority,path:A.path})),R.URI.from({scheme:a.Schemas.https,authority:`${A.scheme}+${u(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=T;function u(A){return A.replace(/./g,y=>{const I=y.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?y:"-"+I.toString(16).padStart(4,"0")})}function C(A){return A.replace(/-([0-9a-f]{4})/g,(y,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=C}),define(ye[230],De([1,0,3,6,94]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class u{constructor(A,y,I){this.d=A,this.e=y,this.f=I,this.a=0,this.b=new R.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const k of this.c.values())L.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,I,L,k){let v;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===A){v=b;break}if(!v)throw new Error("not a visible editor");const P=this,E=this.a++,h=new a.Emitter,d=new a.Emitter,f=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,T.asWebviewUri)(b,P.f)}get cspSource(){return T.webviewGenericCspSource}set options(b){this.b=b,P.d.$setOptions(E,b)}get options(){return this.b}set html(b){this.a=b,P.d.$setHtml(E,b)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(b){return P.d.$postMessage(E,b)}},p=new class{constructor(){this.editor=A,this.line=y,this.height=I,this.webview=f,this.onDidDispose=d.event}dispose(){P.c.has(E)&&(P.c.delete(E),P.d.$disposeEditorInset(E),d.fire(),d.dispose(),h.dispose())}};return this.d.$createEditorInset(E,v.id,v.value.document.uri,y+1,I,L||{},k.identifier,k.extensionLocation),this.c.set(E,{editor:A,inset:p,onDidReceiveMessage:h}),p}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=u}),define(ye[231],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var R;(function(u){u.Unknown="unknown",u.Env="env",u.Config="config",u.Command="command",u.Input="input",u.ExtensionInstallFolder="extensionInstallFolder",u.WorkspaceFolder="workspaceFolder",u.Cwd="cwd",u.WorkspaceFolderBasename="workspaceFolderBasename",u.UserHome="userHome",u.LineNumber="lineNumber",u.SelectedText="selectedText",u.File="file",u.FileWorkspaceFolder="fileWorkspaceFolder",u.RelativeFile="relativeFile",u.RelativeFileDirname="relativeFileDirname",u.FileDirname="fileDirname",u.FileExtname="fileExtname",u.FileBasename="fileBasename",u.FileBasenameNoExtension="fileBasenameNoExtension",u.FileDirnameBasename="fileDirnameBasename",u.ExecPath="execPath",u.ExecInstallFolder="execInstallFolder",u.PathSeparator="pathSeparator"})(R=e.VariableKind||(e.VariableKind={}));class T extends Error{constructor(C,A){super(A),this.variable=C}}e.VariableError=T}),define(ye[232],De([1,0,10,36,9,23,12,113,192,231,8]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,E,h,d){this.g=new Map,this.a=P,this.b=E,this.d=h,d&&(this.c=d.then(f=>this.h(f)))}h(P){if(C.isWindows){const E=Object.create(null);return Object.keys(P).forEach(h=>{E[h.toLowerCase()]=P[h]}),E}return P}resolveWithEnvironment(P,E,h){return this.j({env:this.h(P),userHome:void 0},E?E.uri:void 0,h)}async resolveAsync(P,E){const h={env:await this.c,userHome:await this.d};return this.j(h,P?P.uri:void 0,E)}async i(P,E,h,d){const f=u.deepClone(E);C.isWindows&&f.windows?Object.keys(f.windows).forEach(b=>f[b]=f.windows[b]):C.isMacintosh&&f.osx?Object.keys(f.osx).forEach(b=>f[b]=f.osx[b]):C.isLinux&&f.linux&&Object.keys(f.linux).forEach(b=>f[b]=f.linux[b]),delete f.windows,delete f.osx,delete f.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,P?P.uri:void 0,f,h,d)}async resolveAnyAsync(P,E,h){return this.i(P,E,h)}async resolveAnyMap(P,E,h){const d=new Map;return{newConfig:await this.i(P,E,h,d),resolvedVariables:d}}resolveWithInteractionReplace(P,E,h,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,E,h,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,E){if(this.g.has(P))throw new Error("Variable "+P+" is contributed twice.");this.g.set(P,E)}async j(P,E,h,d,f){if(T.isString(h))return this.l(P,E,h,d,f);if(Array.isArray(h))return Promise.all(h.map(p=>this.j(P,E,p,d,f)));if(T.isObject(h)){const p=Object.create(null),b=await Promise.all(Object.keys(h).map(async S=>[await this.l(P,E,S,d,f),await this.j(P,E,h[S],d,f)]));for(const[S,g]of b)p[S]=g;return p}return h}l(P,E,h,d,f){return(0,L.replaceAsync)(h,k.VARIABLE_REGEXP,async(p,b)=>{if(b.includes(k.VARIABLE_LHS))return p;let S=await this.n(P,p,b,E,d);return f?.set(b,S),S!==p&&T.isString(S)&&S.match(k.VARIABLE_REGEXP)&&(S=await this.l(P,E,S,d,f)),S})}m(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async n(P,E,h,d,f){let p;const b=h.split(":");b.length>1&&(h=b[0],p=b[1]);const S=l=>{const r=this.a.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new I.VariableError(l,(0,y.localize)(0,null,E))},g=l=>{const r=S(l);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,A.normalizeDriveLetter)(o)}throw new I.VariableError(l,(0,y.localize)(1,null,E,a.basename(r)))},t=l=>{if(p){const r=this.a.getFolderUri(p);if(r)return r;throw new I.VariableError(l,(0,y.localize)(2,null,E,p))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new I.VariableError(l,(0,y.localize)(3,null,E)):new I.VariableError(l,(0,y.localize)(4,null,E))};switch(h){case"env":if(p){if(P.env){const l=P.env[C.isWindows?p.toLowerCase():p];if(T.isString(l))return l}return""}throw new I.VariableError(I.VariableKind.Env,(0,y.localize)(5,null,E));case"config":if(p){const l=this.a.getConfigurationValue(d,p);if(T.isUndefinedOrNull(l))throw new I.VariableError(I.VariableKind.Config,(0,y.localize)(6,null,E,p));if(T.isObject(l))throw new I.VariableError(I.VariableKind.Config,(0,y.localize)(7,null,E,p));return l}throw new I.VariableError(I.VariableKind.Config,(0,y.localize)(8,null,E));case"command":return this.o(I.VariableKind.Command,E,p,f,"command");case"input":return this.o(I.VariableKind.Input,E,p,f,"input");case"extensionInstallFolder":if(p){const l=await this.a.getExtension(p);if(!l)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,E,p));return this.m(l.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,E));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(t(I.VariableKind.WorkspaceFolder)));case"cwd":return d||p?(0,A.normalizeDriveLetter)(this.m(t(I.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(a.basename(this.m(t(I.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,y.localize)(11,null,E))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new I.VariableError(I.VariableKind.LineNumber,(0,y.localize)(12,null,E))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new I.VariableError(I.VariableKind.SelectedText,(0,y.localize)(13,null,E))}case"file":return S(I.VariableKind.File);case"fileWorkspaceFolder":return g(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||p?a.relative(this.m(t(I.VariableKind.RelativeFile)),S(I.VariableKind.RelativeFile)):S(I.VariableKind.RelativeFile);case"relativeFileDirname":{const l=a.dirname(S(I.VariableKind.RelativeFileDirname));if(d||p){const r=a.relative(this.m(t(I.VariableKind.RelativeFileDirname)),l);return r.length===0?".":r}return l}case"fileDirname":return a.dirname(S(I.VariableKind.FileDirname));case"fileExtname":return a.extname(S(I.VariableKind.FileExtname));case"fileBasename":return a.basename(S(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=a.basename(S(I.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-a.extname(l).length)}case"fileDirnameBasename":return a.basename(a.dirname(S(I.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||E}case"execInstallFolder":{const l=this.a.getAppRoot();return l||E}case"pathSeparator":return a.sep;default:try{const l=p?`${h}:${p}`:h;return this.o(I.VariableKind.Unknown,E,l,f,void 0)}catch{return E}}}}o(P,E,h,d,f){if(h&&d){const p=f===void 0?d[h]:d[f+":"+h];if(typeof p=="string")return p;throw new I.VariableError(P,(0,y.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[133],De([1,0,4,130]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var T;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var u;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(u=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var A;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function I(E){const h=E;return(0,R.isEditorInput)(h?.editor)&&(0,R.isEditorInput)(h?.replacement)}e.isEditorReplacement=I;var L;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function v(E){const h=E;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=v;function P(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(ye[233],De([1,0,4,133]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function T(u){const C=u;return typeof u=="number"||(0,R.isEditorGroup)(C)}e.isPreferredGroup=T}),define(ye[234],De([1,0,4,198]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(R.IEnvironmentService)}),define(ye[134],De([1,0,26,3,10]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class u{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=u;class C{static isHostExtension(k,v,P){if(v.getExtensionDescription(k))return!1;const E=P.getExtensionDescription(k);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(k){this.c=new R.Emitter,this.onDidChange=this.c.event,this.d=k,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const k of this.d){if(this.e.has(a.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this.e.set(a.ExtensionIdentifier.toKey(k.identifier),k),this.f.push(k),Array.isArray(k.activationEvents))for(let v of k.activationEvents)v==="onUri"&&(v=`onUri:${a.ExtensionIdentifier.toKey(k.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(k)}}set(k){this.d=k,this.h(),this.c.fire(void 0)}deltaExtensions(k,v){this.d=I(this.d,v),this.d=this.d.concat(k);const P=C.j(this.d);return this.d=I(this.d,P.map(E=>E.identifier)),this.h(),this.c.fire(void 0),new u(P)}static j(k){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,p){this.addNode(f),this.addNode(p),this.c.has(f)?this.c.get(f).push(p):this.c.set(f,[p])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,p){const b=v.getArcs(f);for(let S=0;S<b.length;S++)if(!p.has(b[S]))return!1;return!0}getNodes(){return this.e}},P=new Map;for(const f of k){const p=a.ExtensionIdentifier.toKey(f.identifier);if(P.set(p,f),f.extensionDependencies)for(const b of f.extensionDependencies){const S=a.ExtensionIdentifier.toKey(b);v.addArc(p,S)}}const E=new Set;v.getNodes().filter(f=>v.getArcs(f).length===0).forEach(f=>E.add(f));const h=v.getNodes().filter(f=>!E.has(f));let d;do{d=!1;for(let f=0;f<h.length;f++){const p=h[f];v.hasOnlyGoodArcs(p,E)&&(h.splice(f,1),f--,E.add(p),d=!0)}}while(d);return h.map(f=>P.get(f))}containsActivationEvent(k){return this.g.has(k)}containsExtension(k){return this.e.has(a.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const v=this.g.get(k);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(k){const v=this.e.get(a.ExtensionIdentifier.toKey(k));return v||void 0}getExtensionDescriptionByUUID(k){for(const v of this.f)if(v.uuid===k)return v}getExtensionDescriptionByIdOrUUID(k,v){return this.getExtensionDescription(k)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=C;var A;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(A||(A={}));function y(L,k){const v=L.isBuiltin?0:L.isUnderDevelopment?2:1,P=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(v!==P)return v-P;const E=T.posix.basename(L.extensionLocation.path),h=T.posix.basename(k.extensionLocation.path);return E<h?-1:E>h?1:0}function I(L,k){const v=new Set;return k.forEach(P=>v.add(a.ExtensionIdentifier.toKey(P))),L.filter(P=>!v.has(a.ExtensionIdentifier.toKey(P.identifier)))}}),define(ye[235],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class R{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[R.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=R,R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class T{constructor(){this.type=2}serialize(k){k[T.ENV_KEY]="1"}}e.SocketExtHostConnection=T,T.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class u{constructor(){this.type=3}serialize(k){k[u.ENV_KEY]="1"}}e.MessagePortExtHostConnection=u,u.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function C(L){delete L[R.ENV_KEY],delete L[T.ENV_KEY],delete L[u.ENV_KEY]}function A(L,k){C(k),L.serialize(k)}e.writeExtHostConnection=A;function y(L){if(L[R.ENV_KEY])return I(L,new R(L[R.ENV_KEY]));if(L[T.ENV_KEY])return I(L,new T);if(L[u.ENV_KEY])return I(L,new u);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function I(L,k){return C(L),k}}),define(ye[95],De([1,0,22]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(R=e.UIKind||(e.UIKind={}));var T;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var u;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(u=e.MessageType||(e.MessageType={}));function C(I){const L=a.VSBuffer.alloc(1);switch(I){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=C;function A(I,L){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=A;var y;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[96],De([1,0,4,3,13,25,95,72,73,23,2]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=class{constructor(h,d){this.i=h,this.a=new R.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new R.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=d.createLogger(L.URI.revive(this.i.environment.extensionTelemetryLogResource),{hidden:!0}),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(h,d,f){const p=this.getTelemetryDetails(),b=new v(d,f,h,this.g,this.f,this.getBuiltInCommonProperties(h),{isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled});return this.h.set(h.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(h,d,f){this.d=h,this.f=d,this.c=f??{usage:!0,error:!0}}getBuiltInCommonProperties(h){const d={};switch(d["common.extname"]=`${h.publisher}.${h.name}`,d["common.extversion"]=h.version,d["common.vscodemachineid"]=this.i.telemetryInfo.machineId,d["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,d["common.vscodeversion"]=this.i.version,d["common.isnewappinstall"]=P(this.i.telemetryInfo.firstSessionDate),d["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:d["common.uikind"]="web";break;case C.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),d}$onDidChangeTelemetryLevel(h){this.e=this.getTelemetryConfiguration(),this.d=h;const d=this.getTelemetryDetails();this.h.forEach(f=>{f.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(h,d){const f=this.h.get(h.value);return!f||f.ignoreUnhandledExtHostErrors?!1:(f.logError(d),!0)}};k=qe([We(0,u.IExtHostInitDataService),We(1,T.ILoggerService)],k),e.ExtHostTelemetry=k;class v{constructor(h,d,f,p,b,S,g){this.g=f,this.h=p,this.i=b,this.j=S,this.b=new R.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.e=d?.ignoreBuiltInCommonProperties??!1,this.f=d?.additionalCommonProperties,this.a=h,this.c={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(h,d){this.d&&(this.c={isUsageEnabled:h,isErrorsEnabled:d},this.b.fire(this.d))}mixInCommonPropsAndCleanData(h){let d=h.properties??h;return d=(0,y.cleanData)(d,[]),this.f&&(d=(0,I.mixin)(d,this.f)),this.e||(d=(0,I.mixin)(d,this.j)),h.properties?h.properties=d:h=d,h}k(h,d){this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.a.sendEventData(h,d),this.h.trace(h,d)}logUsage(h,d){!this.c.isUsageEnabled||this.k(h,d)}logError(h,d){!this.c.isErrorsEnabled||(typeof h=="string"?this.k(h,d):this.a.sendErrorData(h,d))}get apiTelemetryLogger(){if(!this.d){const h=this,d={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.c.isUsageEnabled},get isErrorsEnabled(){return h.c.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.b.event.bind(h)};this.d=Object.freeze(d)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=v;function P(E){const h=Date.now()-new Date(E).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=P,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(ye[27],De([1,0,3,2,4,26,211]),function(te,e,a,R,T,u,C){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new u.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class y{constructor(m){this.affinity=m,this.kind=1}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class I{constructor(m){this.affinity=m,this.kind=2}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=I;class L{constructor(){this.kind=3,this.affinity=0}equals(m){return this.kind===m.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class k{constructor(m){this.dependency=m}}e.MissingExtensionDependency=k;var v;(function(n){n[n.LocalProcess=1]="LocalProcess",n[n.LocalWebWorker=2]="LocalWebWorker",n[n.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function P(n){if(n===null)return"None";switch(n){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=P;class E{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(m,s){const i=[],c=[],w=[],D=[],F=f(this.c),x=f(m),q=(U,z)=>U.extensionLocation.toString()===z.extensionLocation.toString()||U.isBuiltin===z.isBuiltin||U.isUserBuiltin===z.isUserBuiltin||U.isUnderDevelopment===z.isUnderDevelopment;for(const U of this.c){const z=x.get(u.ExtensionIdentifier.toKey(U.identifier));if(!z){i.push(U.identifier),F.delete(u.ExtensionIdentifier.toKey(U.identifier));continue}if(!q(U,z)){i.push(U.identifier),F.delete(u.ExtensionIdentifier.toKey(U.identifier));continue}}for(const U of m){const z=F.get(u.ExtensionIdentifier.toKey(U.identifier));if(!z){c.push(U);continue}if(!q(z,U)){i.push(z.identifier),F.delete(u.ExtensionIdentifier.toKey(z.identifier));continue}}const M=d(this.d),B=d(s);for(const U of this.d)B.has(u.ExtensionIdentifier.toKey(U))||w.push(U);for(const U of s)M.has(u.ExtensionIdentifier.toKey(U))||D.push(U);const O={toRemove:i,toAdd:c,myToRemove:w,myToAdd:D};return this.delta(O),O}delta(m){const{toRemove:s,toAdd:i,myToRemove:c,myToAdd:w}=m,D=d(s),F=d(c);for(let x=0;x<this.c.length;x++)D.has(u.ExtensionIdentifier.toKey(this.c[x].identifier))&&(this.c.splice(x,1),x--);for(let x=0;x<this.d.length;x++)F.has(u.ExtensionIdentifier.toKey(this.d[x]))&&(this.d.splice(x,1),x--);for(const x of i)this.c.push(x);for(const x of w)this.d.push(x)}containsExtension(m){for(const s of this.d)if(u.ExtensionIdentifier.equals(s,m))return!0;return!1}}e.ExtensionHostExtensions=E;class h{constructor(m){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=u.ExtensionIdentifier.toKey,m)for(const s of m)this.add(s)}get size(){return this.c.size}add(m){return this.c.set(this.d(m),m),this}clear(){this.c.clear()}delete(m){return this.c.delete(this.d(m))}has(m){return this.c.has(this.d(m))}forEach(m,s){this.c.forEach(i=>m.call(s,i,i,this))}*entries(){for(const[m,s]of this.c)yield[s,s]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=h;function d(n){const m=new Set;for(const s of n)m.add(u.ExtensionIdentifier.toKey(s));return m}e.extensionIdentifiersArrayToSet=d;function f(n){const m=new Map;for(const s of n)m.set(u.ExtensionIdentifier.toKey(s.identifier),s);return m}function p(n,m){return n.enabledApiProposals?n.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=p;function b(n,m){if(!p(n,m))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.checkProposedApiEnabled=b;class S{constructor(m,s,i,c){this.codeLoadingTime=m,this.activateCallTime=s,this.activateResolvedTime=i,this.activationReason=c}}e.ActivationTimes=S;class g{constructor(m,s){this.description=m,this.value=s}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var t;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function l(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.toExtension=l;function r(n,m){return{identifier:new u.ExtensionIdentifier((0,C.getExtensionId)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!m,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,browserNlsBundleUris:n.browserNlsBundleUris}}e.toExtensionDescription=r;class o{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m,s){return Promise.resolve(0)}getInspectPorts(m,s){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=o}),define(ye[236],De([1,0,11,134,26,27,13,17]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(f,p,b,S){this.startup=f,this.codeLoadingTime=p,this.activateCallTime=b,this.activateResolvedTime=S}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class I{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,p){return f===-1||p===-1?-1:p-f}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=I;class L{constructor(f,p,b,S,g,t){this.activationFailed=f,this.activationFailedError=p,this.activationTimes=b,this.module=S,this.exports=g,this.subscriptions=t}}e.ActivatedExtension=L;class k extends L{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class v extends L{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class P extends L{constructor(f){super(!0,f,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(f,p,b,S){this.g=S,this.a=f,this.b=p,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[f,p]of this.d)p.dispose()}isActivated(f){const p=this.d.get(T.ExtensionIdentifier.toKey(f));return Boolean(p&&p.value)}getActivatedExtension(f){const p=this.d.get(T.ExtensionIdentifier.toKey(f));if(!p||!p.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return p.value}async activateByEvent(f,p){if(this.f[f])return;const b=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(b.map(S=>({id:S.identifier,reason:{startup:p,extensionId:S.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,p){const b=this.a.getExtensionDescription(f);if(!b)throw new Error(`Extension '${f}' is not known`);return this.h([{id:b.identifier,reason:p}])}async h(f){const p=f.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(p.map(b=>b.wait()))}j(f){if(this.d.has(T.ExtensionIdentifier.toKey(f.id)))return this.d.get(T.ExtensionIdentifier.toKey(f.id));if(this.l(f.id))return this.k(f,null,[],null);const p=this.a.getExtensionDescription(f.id);if(!p){const g=new Error(`Cannot activate unknown extension '${f.id.value}'`),t=this.k(f,null,[],new P(g));return this.c.onExtensionActivationError(f.id,g,new u.MissingExtensionDependency(f.id.value)),t}const b=[],S=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const g of S){if(this.m(g))continue;const t=this.d.get(T.ExtensionIdentifier.toKey(g));if(t){b.push(t);continue}if(this.l(g)){b.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:f.reason}));continue}const l=this.a.getExtensionDescription(g);if(l){if(!l.main&&!l.browser)continue;b.push(this.j({id:l.identifier,reason:f.reason}));continue}const r=p.displayName||p.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${g}'`),n=this.k(f,p.displayName,[],new P(o));return this.c.onExtensionActivationError(p.identifier,o,new u.MissingExtensionDependency(g)),n}return this.k(f,p.displayName,b,null)}k(f,p,b,S){const g=new h(f.id,p,f.reason,b,S,this.c,this.g);return this.d.set(T.ExtensionIdentifier.toKey(f.id),g),g}l(f){return R.ExtensionDescriptionRegistry.isHostExtension(f,this.a,this.b)}m(f){const p=this.b.getExtensionDescription(f);return p?!p.main&&!p.browser:!1}};E=qe([We(3,C.ILogService)],E),e.ExtensionsActivator=E;let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,p,b,S,g,t,l){this.c=f,this.d=p,this.f=b,this.g=S,this.h=g,this.j=t,this.k=l,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const p=this.g[f];if(p.value&&!p.value.activationFailed){this.g.splice(f,1),f--;continue}if(p.value&&p.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);b.detail=p.value.activationFailedError,this.h=new P(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const p=new Error;if(f&&f.name&&(p.name=f.name),f&&f.message?p.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(p.stack=f.stack),this.h=new P(p),this.b&&a.isCancellationError(f))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};h=qe([We(6,C.ILogService)],h)});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)};define(ye[7],De([1,0,15,11,112,28,86,8,9,2,30,44,128,92,27]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E){"use strict";var h,d,f,p,b,S,g,t,l,r,o,n,m,s,i,c,w,D,F,x,q,M,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(X){return Object.assign(X,{apply:function(){const me=arguments.length===1?[]:arguments[1];return Reflect.construct(X,me,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(X,[]);{const[me,...Te]=arguments;return Reflect.construct(X,Te,me.constructor)}}})}var U;(function(X){X[X.Top=0]="Top",X[X.Bottom=1]="Bottom"})(U=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(X){X[X.Command=0]="Command",X[X.Opener=1]="Opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=S=class{static from(...W){let me=W;return new S(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}constructor(W){h.set(this,void 0),Je(this,h,W,"f")}dispose(){typeof Be(this,h,"f")=="function"&&(Be(this,h,"f").call(this),Je(this,h,void 0,"f"))}};h=new WeakMap,j=S=qe([O],j),e.Disposable=j;let le=g=class{static Min(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ge=W[Te];Ge.isBefore(me)&&(me=Ge)}return me}static Max(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ge=W[Te];Ge.isAfter(me)&&(me=Ge)}return me}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:me,character:Te}=W;return typeof me=="number"&&typeof Te=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,me){if(W<0)throw(0,R.illegalArgument)("line must be non-negative");if(me<0)throw(0,R.illegalArgument)("character must be non-negative");this.c=W,this.e=me}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,me=0){if(W===null||me===null)throw(0,R.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,me=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&me===0?this:new g(this.line+Te,this.character+me)}with(W,me=this.character){if(W===null||me===null)throw(0,R.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,me=typeof W.character=="number"?W.character:this.character),Te===this.line&&me===this.character?this:new g(Te,me)}toJSON(){return{line:this.line,character:this.character}}};le=g=qe([O],le),e.Position=le;let V=t=class{static isRange(W){return W instanceof t?!0:W?le.isPosition(W.start)&&le.isPosition(W.end):!1}static of(W){if(W instanceof t)return W;if(this.isRange(W))return new t(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,me,Te,Ge){let Ye,at;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ge=="number"?(Ye=new le(W,me),at=new le(Te,Ge)):le.isPosition(W)&&le.isPosition(me)&&(Ye=le.of(W),at=le.of(me)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this.c=Ye,this.e=at):(this.c=at,this.e=Ye)}contains(W){return t.isRange(W)?this.contains(W.start)&&this.contains(W.end):le.isPosition(W)?!(le.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const me=le.Max(W.start,this.c),Te=le.Min(W.end,this.e);if(!me.isAfter(Te))return new t(me,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const me=le.Min(W.start,this.c),Te=le.Max(W.end,this.end);return new t(me,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,me=this.end){if(W===null||me===null)throw(0,R.illegalArgument)();let Te;return W?le.isPosition(W)?Te=W:(Te=W.start||this.start,me=W.end||this.end):Te=this.start,Te.isEqual(this.c)&&me.isEqual(this.end)?this:new t(Te,me)}toJSON(){return[this.start,this.end]}};V=t=qe([O],V),e.Range=V;let _=l=class extends V{static isSelection(W){return W instanceof l?!0:W?V.isRange(W)&&le.isPosition(W.anchor)&&le.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,me,Te,Ge){let Ye,at;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ge=="number"?(Ye=new le(W,me),at=new le(Te,Ge)):le.isPosition(W)&&le.isPosition(me)&&(Ye=le.of(W),at=le.of(me)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this.f=Ye,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};_=l=qe([O],_),e.Selection=_;class J{constructor(W,me,Te){if(typeof W!="string"||W.length===0)throw(0,R.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,R.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,R.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(me),this.connectionToken=Te}}e.ResolvedAuthority=J;class ie extends Error{static NotAvailable(W,me){return new ie(W,v.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(W){return new ie(W,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,me=v.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=me,this._detail=Te,Object.setPrototypeOf(this,ie.prototype)}}e.RemoteAuthorityResolverError=ie;var ee;(function(X){X[X.LF=1]="LF",X[X.CRLF=2]="CRLF"})(ee=e.EndOfLine||(e.EndOfLine={}));var K;(function(X){X[X.Replace=1]="Replace",X[X.Append=2]="Append",X[X.Prepend=3]="Prepend"})(K=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=r=class{static isTextEdit(W){return W instanceof r?!0:W?V.isRange(W)&&typeof W.newText=="string":!1}static replace(W,me){return new r(W,me)}static insert(W,me){return r.replace(new V(W,W),me)}static delete(W){return r.replace(W,"")}static setEndOfLine(W){const me=new r(new V(new le(0,0),new le(0,0)),"");return me.newEol=W,me}get range(){return this.c}set range(W){if(W&&!V.isRange(W))throw(0,R.illegalArgument)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,R.illegalArgument)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,R.illegalArgument)("newEol");this.f=W}constructor(W,me){this.c=W,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};G=r=qe([O],G),e.TextEdit=G;let de=o=class{static isNotebookCellEdit(W){return W instanceof o?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,me){return new o(W,me)}static insertCells(W,me){return new o(new xt(W,W),me)}static deleteCells(W){return new o(W,[])}static updateCellMetadata(W,me){const Te=new o(new xt(W,W),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(W){const me=new o(new xt(0,0),[]);return me.newNotebookMetadata=W,me}constructor(W,me){this.range=W,this.newCells=me}};de=o=qe([O],de),e.NotebookEdit=de;class be{static isSnippetTextEdit(W){return W instanceof be?!0:W?V.isRange(W.range)&&Fe.isSnippetString(W.snippet):!1}static replace(W,me){return new be(W,me)}static insert(W,me){return be.replace(new V(W,W),me)}constructor(W,me){this.range=W,this.snippet=me}}e.SnippetTextEdit=be;var Ee;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.Cell=3]="Cell",X[X.CellReplace=5]="CellReplace",X[X.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,me,Te,Ge){this.c.push({_type:1,from:W,to:me,options:Te,metadata:Ge})}createFile(W,me,Te){this.c.push({_type:1,from:void 0,to:W,options:me,metadata:Te})}deleteFile(W,me,Te){this.c.push({_type:1,from:W,to:void 0,options:me,metadata:Te})}e(W,me,Te){this.c.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:me},notebookMetadata:me})}f(W,me,Te,Ge){const Ye=me.start,at=me.end;(Ye!==at||Te.length>0)&&this.c.push({_type:5,uri:W,index:Ye,count:at-Ye,cells:Te,metadata:Ge})}g(W,me,Te,Ge){this.c.push({_type:3,metadata:Ge,uri:W,edit:{editType:8,index:me,metadata:Te}})}replace(W,me,Te,Ge){this.c.push({_type:2,uri:W,edit:new G(me,Te),metadata:Ge})}insert(W,me,Te,Ge){this.replace(W,new V(me,me),Te,Ge)}delete(W,me,Te){this.replace(W,me,"",Te)}has(W){return this.c.some(me=>me._type===2&&me.uri.toString()===W.toString())}set(W,me){if(me)for(const Te of me){if(!Te)continue;let Ge,Ye;Array.isArray(Te)?(Ge=Te[0],Ye=Te[1]):Ge=Te,de.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(W,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.e(W,Ge.newNotebookMetadata,Ye):this.f(W,Ge.range,Ge.newCells,Ye):be.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:W,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this.c.push({_type:2,uri:W,edit:Ge,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ge=this.c[Te];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===W.toString()&&(this.c[Te]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(W){const me=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===W.toString()&&me.push(Te.edit);return me}entries(){const W=new u.ResourceMap;for(const me of this.c)if(me._type===2){let Te=W.get(me.uri);Te||(Te=[me.uri,[]],W.set(me.uri,Te)),Te[1].push(me.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Pe=qe([O],Pe),e.WorkspaceEdit=Pe;let Fe=n=class{static isSnippetString(W){return W instanceof n?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=n.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,me=this.e++){if(typeof W=="function"){const Te=new n;Te.e=this.e,W(Te),this.e=Te.e,W=Te.value}else W=n.c(W);return this.value+="${",this.value+=me,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,me=this.e++){const Te=W.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,me){if(typeof me=="function"){const Te=new n;Te.e=this.e,me(Te),this.e=Te.e,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,me&&(this.value+=":",this.value+=me),this.value+="}",this}};Fe=n=qe([O],Fe),e.SnippetString=Fe;var se;(function(X){X[X.Unnecessary=1]="Unnecessary",X[X.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var oe;(function(X){X[X.Hint=3]="Hint",X[X.Information=2]="Information",X[X.Warning=1]="Warning",X[X.Error=0]="Error"})(oe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=m=class{static isLocation(W){return W instanceof m?!0:W?V.isRange(W.range)&&I.URI.isUri(W.uri):!1}constructor(W,me){if(this.uri=W,me)if(V.isRange(me))this.range=V.of(me);else if(le.isPosition(me))this.range=new V(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};fe=m=qe([O],fe),e.Location=fe;let Z=class{static is(W){return W?typeof W.message=="string"&&W.location&&V.isRange(W.location.range)&&I.URI.isUri(W.location.uri):!1}constructor(W,me){this.location=W,this.message=me}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.location.range.isEqual(me.location.range)&&W.location.uri.toString()===me.location.uri.toString()}};Z=qe([O],Z),e.DiagnosticRelatedInformation=Z;let ce=class{constructor(W,me,Te=oe.Error){if(!V.isRange(W))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=W,this.message=me,this.severity=Te}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.severity===me.severity&&W.code===me.code&&W.severity===me.severity&&W.source===me.source&&W.range.isEqual(me.range)&&(0,a.equals)(W.tags,me.tags)&&(0,a.equals)(W.relatedInformation,me.relatedInformation,Z.isEqual)}};ce=qe([O],ce),e.Diagnostic=ce;let ne=class{constructor(W,me){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=me}};ne=qe([O],ne),e.Hover=ne;var N;(function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"})(N=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(W,me=N.Text){this.range=W,this.kind=me}toJSON(){return{range:this.range,kind:N[this.kind]}}};H=qe([O],H),e.DocumentHighlight=H;var Q;(function(X){X[X.File=0]="File",X[X.Module=1]="Module",X[X.Namespace=2]="Namespace",X[X.Package=3]="Package",X[X.Class=4]="Class",X[X.Method=5]="Method",X[X.Property=6]="Property",X[X.Field=7]="Field",X[X.Constructor=8]="Constructor",X[X.Enum=9]="Enum",X[X.Interface=10]="Interface",X[X.Function=11]="Function",X[X.Variable=12]="Variable",X[X.Constant=13]="Constant",X[X.String=14]="String",X[X.Number=15]="Number",X[X.Boolean=16]="Boolean",X[X.Array=17]="Array",X[X.Object=18]="Object",X[X.Key=19]="Key",X[X.Null=20]="Null",X[X.EnumMember=21]="EnumMember",X[X.Struct=22]="Struct",X[X.Event=23]="Event",X[X.Operator=24]="Operator",X[X.TypeParameter=25]="TypeParameter"})(Q=e.SymbolKind||(e.SymbolKind={}));var Y;(function(X){X[X.Deprecated=1]="Deprecated"})(Y=e.SymbolTag||(e.SymbolTag={}));let he=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,me,Te,Ge,Ye){this.name=W,this.kind=me,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ge instanceof fe?this.location=Ge:Te instanceof V&&(this.location=new fe(Ge,Te)),s.validate(this)}toJSON(){return{name:this.name,kind:Q[this.kind],location:this.location,containerName:this.containerName}}};he=s=qe([O],he),e.SymbolInformation=he;let ve=i=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(i.validate)}constructor(W,me,Te,Ge,Ye){this.name=W,this.detail=me,this.kind=Te,this.range=Ge,this.selectionRange=Ye,this.children=[],i.validate(this)}};ve=i=qe([O],ve),e.DocumentSymbol=ve;var Ae;(function(X){X[X.Invoke=1]="Invoke",X[X.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(W,me){this.title=W,this.kind=me}};pe=qe([O],pe),e.CodeAction=pe;let Ce=c=class{constructor(W){this.value=W}append(W){return new c(this.value?this.value+c.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+c.c)}};Ce.c=".",Ce=c=qe([O],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let ke=class{constructor(W,me){if(this.range=W,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([O],ke),e.SelectionRange=ke;class Ve{constructor(W,me,Te,Ge,Ye,at){this.kind=W,this.name=me,this.detail=Te,this.uri=Ge,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=Ve;class xe{constructor(W,me){this.fromRanges=me,this.from=W}}e.CallHierarchyIncomingCall=xe;class et{constructor(W,me){this.fromRanges=me,this.to=W}}e.CallHierarchyOutgoingCall=et;var Qe;(function(X){X[X.Information=0]="Information",X[X.Warning=1]="Warning",X[X.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(W,me){this.range=W,this.command=me}get isResolved(){return!!this.command}};nt=qe([O],nt),e.CodeLens=nt;let st=w=class{static isMarkdownString(W){return W instanceof w?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,me=!1){d.set(this,void 0),Je(this,d,new T.MarkdownString(W,{supportThemeIcons:me}),"f")}get value(){return Be(this,d,"f").value}set value(W){Be(this,d,"f").value=W}get isTrusted(){return Be(this,d,"f").isTrusted}set isTrusted(W){Be(this,d,"f").isTrusted=W}get supportThemeIcons(){return Be(this,d,"f").supportThemeIcons}set supportThemeIcons(W){Be(this,d,"f").supportThemeIcons=W}get supportHtml(){return Be(this,d,"f").supportHtml}set supportHtml(W){Be(this,d,"f").supportHtml=W}get baseUri(){return Be(this,d,"f").baseUri}set baseUri(W){Be(this,d,"f").baseUri=W}appendText(W){return Be(this,d,"f").appendText(W),this}appendMarkdown(W){return Be(this,d,"f").appendMarkdown(W),this}appendCodeblock(W,me){return Be(this,d,"f").appendCodeblock(me??"",W),this}};d=new WeakMap,st=w=qe([O],st),e.MarkdownString=st;let ht=class{constructor(W,me){this.label=W,this.documentation=me}};ht=qe([O],ht),e.ParameterInformation=ht;let Ue=class{constructor(W,me){this.label=W,this.documentation=me,this.parameters=[]}};Ue=qe([O],Ue),e.SignatureInformation=Ue;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=qe([O],rt),e.SignatureHelp=rt;var ae;(function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"})(ae=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $;(function(X){X[X.Type=1]="Type",X[X.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={}));let ue=class{constructor(W){this.value=W}};ue=qe([O],ue),e.InlayHintLabelPart=ue;let Ie=class{constructor(W,me,Te){this.position=W,this.label=me,this.kind=Te}};Ie=qe([O],Ie),e.InlayHint=Ie;var Le;(function(X){X[X.Invoke=0]="Invoke",X[X.TriggerCharacter=1]="TriggerCharacter",X[X.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(X){X[X.Text=0]="Text",X[X.Method=1]="Method",X[X.Function=2]="Function",X[X.Constructor=3]="Constructor",X[X.Field=4]="Field",X[X.Variable=5]="Variable",X[X.Class=6]="Class",X[X.Interface=7]="Interface",X[X.Module=8]="Module",X[X.Property=9]="Property",X[X.Unit=10]="Unit",X[X.Value=11]="Value",X[X.Enum=12]="Enum",X[X.Keyword=13]="Keyword",X[X.Snippet=14]="Snippet",X[X.Color=15]="Color",X[X.File=16]="File",X[X.Reference=17]="Reference",X[X.Folder=18]="Folder",X[X.EnumMember=19]="EnumMember",X[X.Constant=20]="Constant",X[X.Struct=21]="Struct",X[X.Event=22]="Event",X[X.Operator=23]="Operator",X[X.TypeParameter=24]="TypeParameter",X[X.User=25]="User",X[X.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ke;(function(X){X[X.Deprecated=1]="Deprecated"})(Ke=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(W,me){this.label=W,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([O],Ze),e.CompletionItem=Ze;let pt=class{constructor(W=[],me=!1){this.items=W,this.isIncomplete=me}};pt=qe([O],pt),e.CompletionList=pt;let gt=class{constructor(W,me,Te){this.insertText=W,this.range=me,this.command=Te}};gt=qe([O],gt),e.InlineSuggestion=gt;let ct=class{constructor(W){this.commands=void 0,this.items=W}};ct=qe([O],ct),e.InlineSuggestionList=ct;var Et;(function(X){X[X.Active=-1]="Active",X[X.Beside=-2]="Beside",X[X.One=1]="One",X[X.Two=2]="Two",X[X.Three=3]="Three",X[X.Four=4]="Four",X[X.Five=5]="Five",X[X.Six=6]="Six",X[X.Seven=7]="Seven",X[X.Eight=8]="Eight",X[X.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var tt;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var At;(function(X){X[X.Manual=1]="Manual",X[X.AfterDelay=2]="AfterDelay",X[X.FocusOut=3]="FocusOut"})(At=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Kt;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(Kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Rt;(function(X){X[X.Keyboard=1]="Keyboard",X[X.Mouse=2]="Mouse",X[X.Command=3]="Command"})(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var mt;(function(X){X[X.Undo=1]="Undo",X[X.Redo=2]="Redo"})(mt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(X){X[X.OpenOpen=0]="OpenOpen",X[X.ClosedClosed=1]="ClosedClosed",X[X.OpenClosed=2]="OpenClosed",X[X.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(X){function W(me){switch(me){case"keyboard":return X.Keyboard;case"mouse":return X.Mouse;case"api":return X.Command}}X.fromValue=W}(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(W,me){if(me&&!I.URI.isUri(me))throw(0,R.illegalArgument)("target");if(!V.isRange(W)||W.isEmpty)throw(0,R.illegalArgument)("range");this.range=W,this.target=me}};$t=qe([O],$t),e.DocumentLink=$t;let Nt=class{constructor(W,me,Te,Ge){this.red=W,this.green=me,this.blue=Te,this.alpha=Ge}};Nt=qe([O],Nt),e.Color=Nt;let Xe=class{constructor(W,me){if(me&&!(me instanceof Nt))throw(0,R.illegalArgument)("color");if(!V.isRange(W)||W.isEmpty)throw(0,R.illegalArgument)("range");this.range=W,this.color=me}};Xe=qe([O],Xe),e.ColorInformation=Xe;let Mt=class{constructor(W){if(!W||typeof W!="string")throw(0,R.illegalArgument)("label");this.label=W}};Mt=qe([O],Mt),e.ColorPresentation=Mt;var Ut;(function(X){X[X.RGB=0]="RGB",X[X.HEX=1]="HEX",X[X.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var Wt;(function(X){X[X.Error=0]="Error",X[X.Warning=1]="Warning",X[X.Information=2]="Information"})(Wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var bt;(function(X){X[X.Unknown=0]="Unknown",X[X.Shutdown=1]="Shutdown",X[X.Process=2]="Process",X[X.User=3]="User",X[X.Extension=4]="Extension"})(bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(W,me,Te){if(this.startIndex=W,this.length=me,this.tooltip=Te,typeof W!="number"||W<0)throw(0,R.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,R.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Oe{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Oe;class Se{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Se;var re;(function(X){X[X.Panel=1]="Panel",X[X.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Ne{constructor(W){if(this.options=W,typeof W!="object")throw(0,R.illegalArgument)("options")}}e.TerminalProfile=Ne;var He;(function(X){X[X.Always=1]="Always",X[X.Silent=2]="Silent",X[X.Never=3]="Never"})(He=e.TaskRevealKind||(e.TaskRevealKind={}));var _e;(function(X){X[X.Shared=1]="Shared",X[X.Dedicated=2]="Dedicated",X[X.New=3]="New"})(_e=e.TaskPanelKind||(e.TaskPanelKind={}));let je=D=class{static from(W){switch(W){case"clean":return D.Clean;case"build":return D.Build;case"rebuild":return D.Rebuild;case"test":return D.Test;default:return}}constructor(W,me){if(this.label=me,typeof W!="string"||typeof me!="string")throw(0,R.illegalArgument)("name");this.c=W}get id(){return this.c}};je.Clean=new D("clean","Clean"),je.Build=new D("build","Build"),je.Rebuild=new D("rebuild","Rebuild"),je.Test=new D("test","Test"),je=D=qe([O],je),e.TaskGroup=je;function it(X){let W="";for(let me=0;me<X.length;me++)W+=X[me].replace(/,/g,",,")+",";return W}let lt=class{constructor(W,me,Te){if(typeof W!="string")throw(0,R.illegalArgument)("process");this.e=[],this.c=W,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Te):this.f=me)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,R.illegalArgument)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const me of this.e)W.push(me);return it(W)}};lt=qe([O],lt),e.ProcessExecution=lt;let Pt=class{constructor(W,me,Te){if(this.f=[],Array.isArray(me)){if(!W)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,R.illegalArgument)("command");this.e=W,this.f=me,this.g=Te}else{if(typeof W!="string")throw(0,R.illegalArgument)("commandLine");this.c=W,this.g=me}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,R.illegalArgument)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,R.illegalArgument)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)W.push(typeof me=="string"?me:me.value);return it(W)}};Pt=qe([O],Pt),e.ShellExecution=Pt;var St;(function(X){X[X.Escape=1]="Escape",X[X.Strong=2]="Strong",X[X.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class kt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this.c=W}get callback(){return this.c}}e.CustomExecution=kt;let Dt=F=class{constructor(W,me,Te,Ge,Ye,at){this.j=!1,this.k=this.definition=W;let dt;typeof me=="string"?(this.m=this.name=me,this.t=this.source=Te,this.execution=Ge,dt=Ye,this.j=!0):me===yt.Global||me===yt.Workspace?(this.target=me,this.m=this.name=Te,this.t=this.source=Ge,this.execution=Ye,dt=at):(this.target=me,this.m=this.name=Te,this.t=this.source=Ge,this.execution=Ye,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:F.e,id:this.n.computeId()}:this.n instanceof Pt?this.k={type:F.f,id:this.n.computeId()}:this.n instanceof kt?this.k={type:F.c,id:this.n.computeId()}:this.k={type:F.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,R.illegalArgument)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const me=this.k.type;(F.g===me||F.e===me||F.f===me||F.c===me)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};Dt.c="customExecution",Dt.e="process",Dt.f="shell",Dt.g="$empty",Dt=F=qe([O],Dt),e.Task=Dt;var Ct;(function(X){X[X.SourceControl=1]="SourceControl",X[X.Window=10]="Window",X[X.Notification=15]="Notification"})(Ct=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(X){function W(me){const Te=me;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}X.isViewBadge=W})(qt=e.ViewBadge||(e.ViewBadge={}));let Jt=x=class{static isTreeItem(W,me){if(W instanceof x)return!0;const Te=W;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!I.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const Ge=Te.iconPath;if(!Ge||!(0,y.isString)(Ge.light)&&!I.URI.isUri(Ge.light)&&!(0,y.isString)(Ge.dark)&&!I.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!I.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<wt.None&&Te.collapsibleState>wt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,E.checkProposedApiEnabled)(me,"treeItemCheckbox");const Ge=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==si.Checked&&Ge!==si.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,me=wt.None){this.collapsibleState=me,I.URI.isUri(W)?this.resourceUri=W:this.label=W}};Jt=x=qe([O],Jt),e.TreeItem=Jt;var wt;(function(X){X[X.None=0]="None",X[X.Collapsed=1]="Collapsed",X[X.Expanded=2]="Expanded"})(wt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(X){X[X.Unchecked=0]="Unchecked",X[X.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,me){this.value=W,this.id=me??(0,L.generateUuid)()}};oi=qe([O],oi),e.DataTransferItem=oi;let Zt=class{constructor(W){f.set(this,new Map);for(const[me,Te]of W??[]){const Ge=Be(this,f,"f").get(me);Ge?Ge.push(Te):Be(this,f,"f").set(me,[Te])}}get(W){return Be(this,f,"f").get(W)?.[0]}set(W,me){Be(this,f,"f").set(W,[me])}forEach(W,me){for(const[Te,Ge]of Be(this,f,"f"))for(const Ye of Ge)W.call(me,Ye,Te,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[W,me]of Be(this,f,"f"))for(const Te of me)yield[W,Te]}};Zt=qe([O],Zt),e.DataTransfer=Zt;let bi=class{constructor(W){this.insertText=W}};bi=qe([O],bi),e.DocumentDropEdit=bi;let Lt=class{constructor(W){this.insertText=W}};Lt=qe([O],Lt),e.DocumentPasteEdit=Lt;let Ht=class{constructor(W,me){this.id=W,this.color=me}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};Ht=qe([O],Ht),e.ThemeIcon=Ht,Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let vi=class{constructor(W){this.id=W}};vi=qe([O],vi),e.ThemeColor=vi;var ai;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace",X[X.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(W){this.c=W,this.e=I.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,me){if(typeof W!="string"&&(!W||!I.URI.isUri(W)&&!I.URI.isUri(W.uri)))throw(0,R.illegalArgument)("base");if(typeof me!="string")throw(0,R.illegalArgument)("pattern");typeof W=="string"?this.baseUri=I.URI.file(W):I.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([O],ei),e.RelativePattern=ei;const ut=new WeakMap;function Bi(X,W){ut.set(X,W)}e.setBreakpointId=Bi;let Bt=class{constructor(W,me,Te,Ge){this.enabled=typeof W=="boolean"?W:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=ut.get(this)??(0,L.generateUuid)()),this.c}};Bt=qe([O],Bt),e.Breakpoint=Bt;let Qt=class extends Bt{constructor(W,me,Te,Ge,Ye){if(super(me,Te,Ge,Ye),W===null)throw(0,R.illegalArgument)("location");this.location=W}};Qt=qe([O],Qt),e.SourceBreakpoint=Qt;let ci=class extends Bt{constructor(W,me,Te,Ge,Ye){super(me,Te,Ge,Ye),this.functionName=W}};ci=qe([O],ci),e.FunctionBreakpoint=ci;let wi=class extends Bt{constructor(W,me,Te,Ge,Ye,at,dt){if(super(Ge,Ye,at,dt),!me)throw(0,R.illegalArgument)("dataId");this.label=W,this.dataId=me,this.canPersist=Te}};wi=qe([O],wi),e.DataBreakpoint=wi;let Ei=class{constructor(W,me,Te){this.command=W,this.args=me||[],this.options=Te}};Ei=qe([O],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(W,me){this.port=W,this.host=me}};li=qe([O],li),e.DebugAdapterServer=li;let Si=class{constructor(W){this.path=W}};Si=qe([O],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(W){this.implementation=W}};ui=qe([O],ui),e.DebugAdapterInlineImplementation=ui;let ti=class{constructor(W,me){this.range=W,this.expression=me}};ti=qe([O],ti),e.EvaluatableExpression=ti;var $i;(function(X){X[X.Invoke=0]="Invoke",X[X.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(W,me){this.range=W,this.text=me}};ii=qe([O],ii),e.InlineValueText=ii;let ni=class{constructor(W,me,Te=!0){this.range=W,this.variableName=me,this.caseSensitiveLookup=Te}};ni=qe([O],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(W,me){this.range=W,this.expression=me}};yi=qe([O],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(W,me){this.frameId=W,this.stoppedLocation=me}};Di=qe([O],Di),e.InlineValueContext=Di;var ri;(function(X){X[X.Changed=1]="Changed",X[X.Created=2]="Created",X[X.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ci=q=class extends Error{static FileExists(W){return new q(W,k.FileSystemProviderErrorCode.FileExists,q.FileExists)}static FileNotFound(W){return new q(W,k.FileSystemProviderErrorCode.FileNotFound,q.FileNotFound)}static FileNotADirectory(W){return new q(W,k.FileSystemProviderErrorCode.FileNotADirectory,q.FileNotADirectory)}static FileIsADirectory(W){return new q(W,k.FileSystemProviderErrorCode.FileIsADirectory,q.FileIsADirectory)}static NoPermissions(W){return new q(W,k.FileSystemProviderErrorCode.NoPermissions,q.NoPermissions)}static Unavailable(W){return new q(W,k.FileSystemProviderErrorCode.Unavailable,q.Unavailable)}constructor(W,me=k.FileSystemProviderErrorCode.Unknown,Te){super(I.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,q.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Ci=q=qe([O],Ci),e.FileSystemError=Ci;let Ii=class{constructor(W,me,Te){this.start=W,this.end=me,this.kind=Te}};Ii=qe([O],Ii),e.FoldingRange=Ii;var zi;(function(X){X[X.Comment=1]="Comment",X[X.Imports=2]="Imports",X[X.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(X){X[X.Collapsed=0]="Collapsed",X[X.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(X){X[X.Editing=0]="Editing",X[X.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(X){X[X.Unresolved=0]="Unresolved",X[X.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(W,me=[]){this.tokenTypes=W,this.tokenModifiers=me}}e.SemanticTokensLegend=Ri;function Li(X){return typeof X>"u"||(0,y.isStringArray)(X)}class ze{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let me=0,Te=W.tokenTypes.length;me<Te;me++)this.j.set(W.tokenTypes[me],me);for(let me=0,Te=W.tokenModifiers.length;me<Te;me++)this.k.set(W.tokenModifiers[me],me)}}push(W,me,Te,Ge,Ye){if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(W,me,Te,Ge,Ye);if(V.isRange(W)&&typeof me=="string"&&Li(Te))return this.m(W,me,Te);throw(0,R.illegalArgument)()}m(W,me,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(me))throw new Error("`tokenType` is not in the provided legend");const Ge=W.start.line,Ye=W.start.character,at=W.end.character-W.start.character,dt=this.j.get(me);let Ft=0;if(Te)for(const Vt of Te){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Vt);Ft|=1<<Gt>>>0}this.n(Ge,Ye,at,dt,Ft)}n(W,me,Te,Ge,Ye){if(this.f&&(W<this.c||W===this.c&&me<this.e)){this.f=!1;const Ft=this.g.length/5|0;let Vt=0,Gt=0;for(let Xt=0;Xt<Ft;Xt++){let _t=this.g[5*Xt],Pi=this.g[5*Xt+1];_t===0?(_t=Vt,Pi+=Gt):_t+=Vt,this.g[5*Xt]=_t,this.g[5*Xt+1]=Pi,Vt=_t,Gt=Pi}}let at=W,dt=me;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ge,this.g[this.h++]=Ye,this.c=W,this.e=me}static o(W){const me=[],Te=W.length/5|0;for(let dt=0;dt<Te;dt++)me[dt]=dt;me.sort((dt,Ft)=>{const Vt=W[5*dt],Gt=W[5*Ft];if(Vt===Gt){const Xt=W[5*dt+1],_t=W[5*Ft+1];return Xt-_t}return Vt-Gt});const Ge=new Uint32Array(W.length);let Ye=0,at=0;for(let dt=0;dt<Te;dt++){const Ft=5*me[dt],Vt=W[Ft+0],Gt=W[Ft+1],Xt=W[Ft+2],_t=W[Ft+3],Pi=W[Ft+4],sn=Vt-Ye,Rn=sn===0?Gt-at:Gt,Ai=5*dt;Ge[Ai+0]=sn,Ge[Ai+1]=Rn,Ge[Ai+2]=Xt,Ge[Ai+3]=_t,Ge[Ai+4]=Pi,Ye=Vt,at=Gt}return Ge}build(W){return this.f?new jt(new Uint32Array(this.g),W):new jt(ze.o(this.g),W)}}e.SemanticTokensBuilder=ze;class jt{constructor(W,me){this.resultId=me,this.data=W}}e.SemanticTokens=jt;class Oi{constructor(W,me,Te){this.start=W,this.deleteCount=me,this.data=Te}}e.SemanticTokensEdit=Oi;class vt{constructor(W,me){this.resultId=me,this.edits=W}}e.SemanticTokensEdits=vt;var ji;(function(X){X[X.Separate=0]="Separate",X[X.MergeWithParent=1]="MergeWithParent"})(ji=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Ht("arrow-left")},di=qe([O],di),e.QuickInputButtons=di;var Ni;(function(X){X[X.Separator=-1]="Separator",X[X.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(X){X[X.Info=1]="Info",X[X.Warning=2]="Warning",X[X.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(X){X[X.UI=1]="UI",X[X.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(W){if(typeof W.badge=="string"){let me=(0,A.nextCharLength)(W.badge,0);if(me<W.badge.length&&(me+=(0,A.nextCharLength)(W.badge,me)),W.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ht.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,me,Te){this.badge=W,this.tooltip=me,this.color=Te}}e.FileDecoration=qi;let Ti=class{constructor(W){this.kind=W}};Ti=qe([O],Ti),e.ColorTheme=Ti;var xi;(function(X){X[X.Light=1]="Light",X[X.Dark=2]="Dark",X[X.HighContrast=3]="HighContrast",X[X.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,me){if(W<0)throw(0,R.illegalArgument)("start must be positive");if(me<0)throw(0,R.illegalArgument)("end must be positive");W<=me?(this.c=W,this.e=me):(this.c=me,this.e=W)}with(W){let me=this.c,Te=this.e;return W.start!==void 0&&(me=W.start),W.end!==void 0&&(Te=W.end),me===this.c&&Te===this.e?this:new xt(me,Te)}}e.NotebookRange=xt;class fi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(me=>fi.isNotebookCellData(me))}static isNotebookCellData(W){return!0}constructor(W,me,Te,Ge,Ye,at,dt){this.kind=W,this.value=me,this.languageId=Te,this.mime=Ge,this.outputs=Ye??[],this.metadata=at,this.executionSummary=dt,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(W){this.cells=W}}e.NotebookData=Gi;class zt{static isNotebookCellOutputItem(W){return W instanceof zt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const me={name:W.name,message:W.message,stack:W.stack};return zt.json(me,"application/vnd.code.notebook.error")}static stdout(W){return zt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return zt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,me="application/octet-stream"){return new zt(W,me)}static text(W,me=C.Mimes.text){const Te=Be(zt,p,"f",b).encode(String(W));return new zt(Te,me)}static json(W,me="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return zt.text(Te,me)}constructor(W,me){this.data=W,this.mime=me;const Te=(0,C.normalizeMimeType)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=zt,p=zt,b={value:new TextEncoder};class mi{static isNotebookCellOutput(W){return W instanceof mi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,me=!1){const Te=new Set,Ge=new Set;for(let Ye=0;Ye<W.length;Ye++){const at=W[Ye],dt=(0,C.normalizeMimeType)(at.mime);if(!Te.has(dt)||(0,P.isTextStreamMime)(dt)){Te.add(dt);continue}Ge.add(Ye),me&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?W:W.filter((Ye,at)=>!Ge.has(at))}constructor(W,me,Te){this.items=mi.ensureUniqueMimeTypes(W,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=me??Te)}}e.NotebookCellOutput=mi;var Ki;(function(X){X[X.Markup=1]="Markup",X[X.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(X){X[X.Idle=1]="Idle",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ge;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(ge=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var we;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(we=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Me{constructor(W,me){this.text=W,this.alignment=me}}e.NotebookCellStatusBarItem=Me;var ot;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var It;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred",X[X.Hidden=-1]="Hidden"})(It=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Ot{constructor(W,me=[]){this.uri=W,this.provides=(0,a.asArray)(me)}}e.NotebookRendererScript=Ot;class ln{constructor(W){this.label=W}}e.NotebookKernelSourceAction=ln;let Qi=class{constructor(W,me){this.label=W,this.timestamp=me}};Qi=qe([O],Qi),e.TimelineItem=Qi;var un;(function(X){X[X.Production=1]="Production",X[X.Development=2]="Development",X[X.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(X){X[X.Node=1]="Node",X[X.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(X){X[X.Other=0]="Other",X[X.Comment=1]="Comment",X[X.String=2]="String",X[X.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(W,me){this.ranges=W,this.wordPattern=me}}e.LinkedEditingRanges=fn;class mn{constructor(W,me){this.c=W,this.e=me}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(X){X[X.Queued=1]="Queued",X[X.Running=2]="Running",X[X.Passed=3]="Passed",X[X.Failed=4]="Failed",X[X.Skipped=5]="Skipped",X[X.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(X){X[X.Run=1]="Run",X[X.Debug=2]="Debug",X[X.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(W=void 0,me=void 0,Te=void 0){this.include=W,this.exclude=me,this.profile=Te}};Fi=qe([O],Fi),e.TestRunRequest=Fi;let _i=class extends Fi{constructor(W=void 0,me=void 0,Te=void 0,Ge=!1){super(W,me,Te),this.continuous=Ge}};_i=qe([O],_i),e.TestRunRequest2=_i;let Yi=M=class{static diff(W,me,Te){const Ge=new M(W);return Ge.expectedOutput=me,Ge.actualOutput=Te,Ge}constructor(W){this.message=W}};Yi=M=qe([O],Yi),e.TestMessage=Yi;let Ji=class{constructor(W){this.id=W}};Ji=qe([O],Ji),e.TestTag=Ji;let gi=class{constructor(W,me){this.covered=W,this.total=me}};gi=qe([O],gi),e.CoveredCount=gi;let Zi=B=class{static fromDetails(W,me){const Te=new gi(0,0),Ge=new gi(0,0),Ye=new gi(0,0);for(const dt of me)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Ft of dt.branches)Ge.total+=1,Ge.covered+=Ft.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const at=new B(W,Te,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=me,at}constructor(W,me,Te,Ge){this.uri=W,this.statementCoverage=me,this.branchCoverage=Te,this.functionCoverage=Ge}};Zi=B=qe([O],Zi),e.FileCoverage=Zi;let en=class{constructor(W,me,Te=[]){this.executionCount=W,this.location=me,this.branches=Te}};en=qe([O],en),e.StatementCoverage=en;let tn=class{constructor(W,me){this.executionCount=W,this.location=me}};tn=qe([O],tn),e.BranchCoverage=tn;let nn=class{constructor(W,me){this.executionCount=W,this.location=me}};nn=qe([O],nn),e.FunctionCoverage=nn;var bn;(function(X){X[X.None=0]="None",X[X.Option=1]="Option",X[X.Default=2]="Default",X[X.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(X){X[X.Untrusted=0]="Untrusted",X[X.Trusted=1]="Trusted",X[X.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wn;(function(X){X[X.Notify=1]="Notify",X[X.OpenBrowser=2]="OpenBrowser",X[X.OpenPreview=3]="OpenPreview",X[X.Silent=4]="Silent",X[X.Ignore=5]="Ignore",X[X.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(W,me,Te,Ge,Ye,at){this.kind=W,this.name=me,this.detail=Te,this.uri=Ge,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=En;class Sn{constructor(W){this.uri=W}}e.TextTabInput=Sn;class yn{constructor(W,me){this.original=W,this.modified=me}}e.TextDiffTabInput=yn;class Dn{constructor(W,me,Te,Ge){this.base=W,this.input1=me,this.input2=Te,this.result=Ge}}e.TextMergeTabInput=Dn;class Cn{constructor(W,me){this.uri=W,this.viewType=me}}e.CustomEditorTabInput=Cn;class In{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=In;class kn{constructor(W,me){this.uri=W,this.notebookType=me}}e.NotebookEditorTabInput=kn;class Tn{constructor(W,me,Te){this.original=W,this.modified=me,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(W,me){this.uri=W,this.inputBoxUri=me}}e.InteractiveWindowInput=An}),define(ye[135],De([1,0,50,16,8,164,106,7,15]),function(te,e,a,R,T,u,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const I=new Map;function L(E,h){h?I.set(E,h):I.delete(E)}e.setWordDefinitionFor=L;function k(E){return I.get(E)}class v extends u.MirrorTextModel{constructor(h,d,f,p,b,S,g,t){super(d,f,p,b),this.m=h,this.p=S,this.q=g,this.notebook=t,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,y.equals)(this.d,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.c},get fileName(){return h.c.fsPath},get isUntitled(){return h.c.scheme===R.Schemas.untitled},get languageId(){return h.p},get version(){return h.g},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(d){return d?h.s(d):h.getText()},get eol(){return h.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return h.d.length},lineAt(d){return h.t(d)},offsetAt(d){return h.u(d)},positionAt(d){return h.v(d)},validateRange(d){return h.w(d)},validatePosition(d){return h.x(d)},getWordRangeAtPosition(d,f){return h.y(d,f)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,a.ok)(!this.b),this.p=h}_acceptIsDirty(h){(0,a.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(h){const d=this.w(h);if(d.isEmpty)return"";if(d.isSingleLine)return this.d[d.start.line].substring(d.start.character,d.end.character);const f=this.f,p=d.start.line,b=d.end.line,S=[];S.push(this.d[p].substring(d.start.character));for(let g=p+1;g<b;g++)S.push(this.d[g]);return S.push(this.d[b].substring(0,d.end.character)),S.join(f)}t(h){let d;if(h instanceof A.Position?d=h.line:typeof h=="number"&&(d=h),typeof d!="number"||d<0||d>=this.d.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new P(d,this.d[d],d===this.d.length-1)}u(h){return h=this.x(h),this.k(),this.h.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.k();const d=this.h.getIndexOf(h),f=this.d[d.index].length;return new A.Position(d.index,Math.min(d.remainder,f))}w(h){if(!(h instanceof A.Range))throw new Error("Invalid argument");const d=this.x(h.start),f=this.x(h.end);return d===h.start&&f===h.end?h:new A.Range(d.line,d.character,f.line,f.character)}x(h){if(!(h instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return h.with(0,0);let{line:d,character:f}=h,p=!1;if(d<0)d=0,f=0,p=!0;else if(d>=this.d.length)d=this.d.length-1,f=this.d[d].length,p=!0;else{const b=this.d[d].length;f<0?(f=0,p=!0):f>b&&(f=b,p=!0)}return p?new A.Position(d,f):h}y(h,d){const f=this.x(h);if(!d)d=k(this.p);else if((0,T.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const p=(0,C.getWordAtText)(f.character+1,(0,C.ensureValidWordDefinition)(d),this.d[f.line],0);if(p)return new A.Range(f.line,p.startColumn-1,f.line,p.endColumn-1)}}e.ExtHostDocumentData=v;class P{constructor(h,d,f){this.a=h,this.b=d,this.c=f}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=P}),define(ye[237],De([1,0,7,18,3]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let u=class{constructor(A){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new T.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=a.ColorThemeKind.Light;break;case"hcDark":y=a.ColorThemeKind.HighContrast;break;case"hcLight":y=a.ColorThemeKind.HighContrastLight;break;default:y=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};u=qe([We(0,R.IExtHostRpcService)],u),e.ExtHostTheming=u}),define(ye[14],De([1,0,15,22,148,63,112,28,147,69,86,23,9,2,35,71,124,132,130,92,57,75,233,7]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S,g,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Re){function Oe(re){const{selectionStartLineNumber:Ne,selectionStartColumn:He,positionLineNumber:_e,positionColumn:je}=re,it=new l.Position(Ne-1,He-1),lt=new l.Position(_e-1,je-1);return new l.Selection(it,lt)}Re.to=Oe;function Se(re){const{anchor:Ne,active:He}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Re.from=Se})(r=e.Selection||(e.Selection={}));var o;(function(Re){function Oe(re){if(!re)return;const{start:Ne,end:He}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Re.from=Oe;function Se(re){if(!re)return;const{startLineNumber:Ne,startColumn:He,endLineNumber:_e,endColumn:je}=re;return new l.Range(Ne-1,He-1,_e-1,je-1)}Re.to=Se})(o=e.Range||(e.Range={}));var n;(function(Re){function Oe(Se){switch(Se){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Re.to=Oe})(n=e.TokenType||(e.TokenType={}));var m;(function(Re){function Oe(re){return new l.Position(re.lineNumber-1,re.column-1)}Re.to=Oe;function Se(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=Se})(m=e.Position||(e.Position={}));var s;(function(Re){function Oe(Ne,He){return(0,a.coalesce)((0,a.asArray)(Ne).map(_e=>Se(_e,He)))}Re.from=Oe;function Se(Ne,He){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,He),pattern:$.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function re(Ne,He){return He&&typeof Ne=="string"?He.transformOutgoingScheme(Ne):Ne}})(s=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(Re){function Oe(re){switch(re){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Re.from=Oe;function Se(re){switch(re){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(Re){function Oe(re){let Ne;return re.code&&((0,v.isString)(re.code)||(0,v.isNumber)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...o.from(re.range),message:re.message,source:re.source,code:Ne,severity:D.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(w.from),tags:Array.isArray(re.tags)?(0,a.coalesce)(re.tags.map(i.from)):void 0}}Re.from=Oe;function Se(re){const Ne=new l.Diagnostic(o.to(re),re.message,D.to(re.severity));return Ne.source=re.source,Ne.code=(0,v.isString)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(w.to),Ne.tags=re.tags&&(0,a.coalesce)(re.tags.map(i.to)),Ne}Re.to=Se})(c=e.Diagnostic||(e.Diagnostic={}));var w;(function(Re){function Oe(re){return{...o.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Oe;function Se(re){return new l.DiagnosticRelatedInformation(new l.Location(re.resource,o.to(re)),re.message)}Re.to=Se})(w=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var D;(function(Re){function Oe(re){switch(re){case l.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Re.from=Oe;function Se(re){switch(re){case d.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Re.to=Se})(D=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var F;(function(Re){function Oe(re){return typeof re=="number"&&re>=l.ViewColumn.One?re-1:re===l.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Re.from=Oe;function Se(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(F=e.ViewColumn||(e.ViewColumn={}));function x(Re){return typeof Re.range<"u"}function q(Re){return Re.length===0?!0:!!x(Re[0])}e.isDecorationOptionsArr=q;var M;(function(Re){function Oe(je){return je.map(Re.from)}Re.fromMany=Oe;function Se(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function re(je){let it;if(Se(je)){const{language:yt,value:kt}=je;it={value:"```"+yt+`
`+kt+"\n```\n"}}else l.MarkdownString.isMarkdownString(je)?it={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?it={value:je}:it={value:""};const lt=Object.create(null);it.uris=lt;const Pt=yt=>{try{let kt=P.URI.parse(yt,!0);kt=kt.with({query:Ne(kt.query,lt)}),lt[yt]=kt}catch{}return""},St=new y.marked.Renderer;return St.link=Pt,St.image=yt=>typeof yt=="string"?Pt(C.parseHrefAndDimensions(yt).href):"",(0,y.marked)(it.value,{renderer:St}),it}Re.from=re;function Ne(je,it){if(!je)return je;let lt;try{lt=(0,I.parse)(je)}catch{}if(!lt)return je;let Pt=!1;return lt=(0,k.cloneAndChange)(lt,St=>{if(P.URI.isUri(St)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[yt]=St,Pt=!0,yt}else return}),Pt?JSON.stringify(lt):je}function He(je){const it=new l.MarkdownString(je.value,je.supportThemeIcons);return it.isTrusted=je.isTrusted,it.supportHtml=je.supportHtml,it.baseUri=je.baseUri?P.URI.from(je.baseUri):void 0,it}Re.to=He;function _e(je){if(!!je)return typeof je=="string"?je:Re.from(je)}Re.fromStrict=_e})(M=e.MarkdownString||(e.MarkdownString={}));function B(Re){return q(Re)?Re.map(Oe=>({range:o.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?M.fromMany(Oe.hoverMessage):Oe.hoverMessage?M.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Re.map(Oe=>({range:o.from(Oe)}))}e.fromRangeOrRangeWithMessage=B;function O(Re){return typeof Re>"u"?Re:typeof Re=="string"?P.URI.file(Re):Re}e.pathOrURIToURI=O;var U;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?O(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Oe})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Oe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Re){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Oe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var le;(function(Re){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?j.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?z.from(Se.light):void 0,dark:Se.dark?z.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Oe})(le=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Re){function Oe(re){return{text:re.newText,eol:re.newEol&&st.from(re.newEol),range:o.from(re.range)}}Re.from=Oe;function Se(re){const Ne=new l.TextEdit(o.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:st.to(re.eol),Ne}Re.to=Se})(V=e.TextEdit||(e.TextEdit={}));var _;(function(Re){function Oe(re,Ne){const He={edits:[]};if(re instanceof l.WorkspaceEdit){const _e=new A.ResourceSet;for(const je of re._allEntries())je._type===1&&P.URI.isUri(je.to)&&je.from===void 0&&_e.add(je.to);for(const je of re._allEntries())je._type===1?He.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contentsBase64:je.options?.contents&&(0,R.encodeBase64)(R.VSBuffer.wrap(je.options.contents))},metadata:je.metadata}):je._type===2?He.edits.push({resource:je.uri,textEdit:V.from(je.edit),versionId:_e.has(je.uri)?void 0:Ne?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?He.edits.push({resource:je.uri,textEdit:{range:o.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:_e.has(je.uri)?void 0:Ne?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?He.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(je.uri)}):je._type===5&&He.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(pt.from)}})}return He}Re.from=Oe;function Se(re){const Ne=new l.WorkspaceEdit;for(const He of re.edits)He.textEdit?Ne.replace(P.URI.revive(He.resource),o.to(He.textEdit.range),He.textEdit.text):Ne.renameFile(P.URI.revive(He.oldResource),P.URI.revive(He.newResource),He.options);return Ne}Re.to=Se})(_=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Re){const Oe=Object.create(null);Oe[l.SymbolKind.File]=0,Oe[l.SymbolKind.Module]=1,Oe[l.SymbolKind.Namespace]=2,Oe[l.SymbolKind.Package]=3,Oe[l.SymbolKind.Class]=4,Oe[l.SymbolKind.Method]=5,Oe[l.SymbolKind.Property]=6,Oe[l.SymbolKind.Field]=7,Oe[l.SymbolKind.Constructor]=8,Oe[l.SymbolKind.Enum]=9,Oe[l.SymbolKind.Interface]=10,Oe[l.SymbolKind.Function]=11,Oe[l.SymbolKind.Variable]=12,Oe[l.SymbolKind.Constant]=13,Oe[l.SymbolKind.String]=14,Oe[l.SymbolKind.Number]=15,Oe[l.SymbolKind.Boolean]=16,Oe[l.SymbolKind.Array]=17,Oe[l.SymbolKind.Object]=18,Oe[l.SymbolKind.Key]=19,Oe[l.SymbolKind.Null]=20,Oe[l.SymbolKind.EnumMember]=21,Oe[l.SymbolKind.Struct]=22,Oe[l.SymbolKind.Event]=23,Oe[l.SymbolKind.Operator]=24,Oe[l.SymbolKind.TypeParameter]=25;function Se(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Re.from=Se;function re(Ne){for(const He in Oe)if(Oe[He]===Ne)return Number(He);return l.SymbolKind.Property}Re.to=re})(J=e.SymbolKind||(e.SymbolKind={}));var ie;(function(Re){function Oe(re){switch(re){case l.SymbolTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return l.SymbolTag.Deprecated}}Re.to=Se})(ie=e.SymbolTag||(e.SymbolTag={}));var ee;(function(Re){function Oe(re){return{name:re.name,kind:J.from(re.kind),tags:re.tags&&re.tags.map(ie.from),containerName:re.containerName,location:Ee.from(re.location)}}Re.from=Oe;function Se(re){const Ne=new l.SymbolInformation(re.name,J.to(re.kind),re.containerName,Ee.to(re.location));return Ne.tags=re.tags&&re.tags.map(ie.to),Ne}Re.to=Se})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(Re){function Oe(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:o.from(re.range),selectionRange:o.from(re.selectionRange),kind:J.from(re.kind),tags:re.tags?.map(ie.from)??[]};return re.children&&(Ne.children=re.children.map(Oe)),Ne}Re.from=Oe;function Se(re){const Ne=new l.DocumentSymbol(re.name,re.detail,J.to(re.kind),o.to(re.range),o.to(re.selectionRange));return(0,a.isNonEmptyArray)(re.tags)&&(Ne.tags=re.tags.map(ie.to)),re.children&&(Ne.children=re.children.map(Se)),Ne}Re.to=Se})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(Re){function Oe(re){const Ne=new l.CallHierarchyItem(J.to(re.kind),re.name,re.detail||"",P.URI.revive(re.uri),o.to(re.range),o.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,He){if(Ne=Ne??re._sessionId,He=He??re._itemId,Ne===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:He,name:re.name,detail:re.detail,kind:J.from(re.kind),uri:re.uri,range:o.from(re.range),selectionRange:o.from(re.selectionRange),tags:re.tags?.map(ie.from)}}Re.from=Se})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(Re){function Oe(Se){return new l.CallHierarchyIncomingCall(G.to(Se.from),Se.fromRanges.map(re=>o.to(re)))}Re.to=Oe})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(Re){function Oe(Se){return new l.CallHierarchyOutgoingCall(G.to(Se.to),Se.fromRanges.map(re=>o.to(re)))}Re.to=Oe})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ee;(function(Re){function Oe(re){return{range:re.range&&o.from(re.range),uri:re.uri}}Re.from=Oe;function Se(re){return new l.Location(P.URI.revive(re.uri),o.to(re.range))}Re.to=Se})(Ee=e.location||(e.location={}));var Pe;(function(Re){function Oe(re){const Ne=re,He=re;return{originSelectionRange:Ne.originSelectionRange?o.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:He.uri,range:o.from(Ne.targetRange?Ne.targetRange:He.range),targetSelectionRange:Ne.targetSelectionRange?o.from(Ne.targetSelectionRange):void 0}}Re.from=Oe;function Se(re){return{targetUri:P.URI.revive(re.uri),targetRange:o.to(re.range),targetSelectionRange:re.targetSelectionRange?o.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?o.to(re.originSelectionRange):void 0}}Re.to=Se})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Re){function Oe(re){return{range:o.from(re.range),contents:M.fromMany(re.contents)}}Re.from=Oe;function Se(re){return new l.Hover(re.contents.map(M.to),o.to(re.range))}Re.to=Se})(Fe=e.Hover||(e.Hover={}));var se;(function(Re){function Oe(re){return{range:o.from(re.range),expression:re.expression}}Re.from=Oe;function Se(re){return new l.EvaluatableExpression(o.to(re.range),re.expression)}Re.to=Se})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var oe;(function(Re){function Oe(re){if(re instanceof l.InlineValueText)return{type:"text",range:o.from(re.range),text:re.text};if(re instanceof l.InlineValueVariableLookup)return{type:"variable",range:o.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Oe;function Se(re){switch(re.type){case"text":return{range:o.to(re.range),text:re.text};case"variable":return{range:o.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:o.to(re.range),expression:re.expression}}}Re.to=Se})(oe=e.InlineValue||(e.InlineValue={}));var fe;(function(Re){function Oe(re){return{frameId:re.frameId,stoppedLocation:o.from(re.stoppedLocation)}}Re.from=Oe;function Se(re){return new l.InlineValueContext(re.frameId,o.to(re.stoppedLocation))}Re.to=Se})(fe=e.InlineValueContext||(e.InlineValueContext={}));var Z;(function(Re){function Oe(re){return{range:o.from(re.range),kind:re.kind}}Re.from=Oe;function Se(re){return new l.DocumentHighlight(o.to(re.range),re.kind)}Re.to=Se})(Z=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Re){function Oe(Se){switch(Se){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Re.to=Oe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ne;(function(Re){function Oe(Se){return{triggerKind:ce.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Oe})(ne=e.CompletionContext||(e.CompletionContext={}));var N;(function(Re){function Oe(re){switch(re){case l.CompletionItemTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return l.CompletionItemTag.Deprecated}}Re.to=Se})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Re){const Oe=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function Se(He){return Oe.get(He)??9}Re.from=Se;const re=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ne(He){return re.get(He)??l.CompletionItemKind.Property}Re.to=Ne})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(Re){function Oe(Se,re){const Ne=new l.CompletionItem(Se.label);return Ne.insertText=Se.insertText,Ne.kind=H.to(Se.kind),Ne.tags=Se.tags?.map(N.to),Ne.detail=Se.detail,Ne.documentation=C.isMarkdownString(Se.documentation)?M.to(Se.documentation):Se.documentation,Ne.sortText=Se.sortText,Ne.filterText=Se.filterText,Ne.preselect=Se.preselect,Ne.commitCharacters=Se.commitCharacters,E.Range.isIRange(Se.range)?Ne.range=o.to(Se.range):typeof Se.range=="object"&&(Ne.range={inserting:o.to(Se.range.insert),replacing:o.to(Se.range.replace)}),Ne.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Ne.insertText=new l.SnippetString(Se.insertText):(Ne.insertText=Se.insertText,Ne.textEdit=Ne.range instanceof l.Range?new l.TextEdit(Ne.range,Ne.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Se.additionalTextEdits.map(He=>V.to(He))),Ne.command=re&&Se.command?re.fromInternal(Se.command):void 0,Ne}Re.to=Oe})(Q=e.CompletionItem||(e.CompletionItem={}));var Y;(function(Re){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:M.fromStrict(re.documentation)}}Re.from=Oe;function Se(re){return{label:re.label,documentation:C.isMarkdownString(re.documentation)?M.to(re.documentation):re.documentation}}Re.to=Se})(Y=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Re){function Oe(re){return{label:re.label,documentation:M.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Y.from):[],activeParameter:re.activeParameter}}Re.from=Oe;function Se(re){return{label:re.label,documentation:C.isMarkdownString(re.documentation)?M.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Y.to):[],activeParameter:re.activeParameter}}Re.to=Se})(he=e.SignatureInformation||(e.SignatureInformation={}));var ve;(function(Re){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.from):[]}}Re.from=Oe;function Se(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.to):[]}}Re.to=Se})(ve=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Oe(Se,re){const Ne=new l.InlayHint(m.to(re.position),typeof re.label=="string"?re.label:re.label.map(pe.to.bind(void 0,Se)),re.kind&&Ce.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(V.to),Ne.tooltip=C.isMarkdownString(re.tooltip)?M.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Re.to=Oe})(Ae=e.InlayHint||(e.InlayHint={}));var pe;(function(Re){function Oe(Se,re){const Ne=new l.InlayHintLabelPart(re.label);return Ne.tooltip=C.isMarkdownString(re.tooltip)?M.to(re.tooltip):re.tooltip,h.Command.is(re.command)&&(Ne.command=Se.fromInternal(re.command)),re.location&&(Ne.location=Ee.to(re.location)),Ne}Re.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Re){function Oe(re){return re}Re.from=Oe;function Se(re){return re}Re.to=Se})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Re){function Oe(re){return{range:o.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Oe;function Se(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?P.URI.parse(re.url,!0):P.URI.revive(re.url)}catch{}return new l.DocumentLink(o.to(re.range),Ne)}Re.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var Ve;(function(Re){function Oe(re){const Ne=new l.ColorPresentation(re.label);return re.textEdit&&(Ne.textEdit=V.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map(He=>V.to(He))),Ne}Re.to=Oe;function Se(re){return{label:re.label,textEdit:re.textEdit?V.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>V.from(Ne)):void 0}}Re.from=Se})(Ve=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(Re){function Oe(re){return new l.Color(re[0],re[1],re[2],re[3])}Re.to=Oe;function Se(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=Se})(xe=e.Color||(e.Color={}));var et;(function(Re){function Oe(re){return{range:o.from(re.range)}}Re.from=Oe;function Se(re){return new l.SelectionRange(o.to(re.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Oe(Se){switch(Se){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Re.to=Oe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Oe(re){switch(re){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Oe;function Se(re){switch(re){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Oe(re){if(re===l.EndOfLine.CRLF)return 1;if(re===l.EndOfLine.LF)return 0}Re.from=Oe;function Se(re){if(re===1)return l.EndOfLine.CRLF;if(re===0)return l.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(Re){function Oe(Se){const re={start:Se.start+1,end:Se.end+1};return Se.kind&&(re.kind=rt.from(Se.kind)),re}Re.from=Oe})(Ue=e.FoldingRange||(e.FoldingRange={}));var rt;(function(Re){function Oe(Se){if(Se)switch(Se){case l.FoldingRangeKind.Comment:return h.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return h.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return h.FoldingRangeKind.Region}}Re.from=Oe})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(Re){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?o.from(Se.selection):void 0,override:typeof Se.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Oe})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $;(function(Re){function Oe(He){return He instanceof l.RelativePattern?He.toJSON():typeof He=="string"?He:Se(He)||re(He)?new l.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Re.from=Oe;function Se(He){const _e=He;return _e?P.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function re(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ne(He){return typeof He=="string"?He:new l.RelativePattern(P.URI.revive(He.baseUri),He.pattern)}Re.to=Ne})($=e.GlobPattern||(e.GlobPattern={}));var ue;(function(Re){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const re=Se;return{language:re.language,scheme:re.scheme,pattern:$.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Oe})(ue=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Oe(re){return{start:re.start,end:re.end}}Re.from=Oe;function Se(re){return new l.NotebookRange(re.start,re.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Oe;function Se(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var $e;(function(Re){function Oe(Se){if(Se===b.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(Se===b.NotebookCellExecutionState.Pending)return;if(Se===b.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Oe})($e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ke;(function(Re){function Oe(re){switch(re){case l.NotebookCellKind.Markup:return b.CellKind.Markup;case l.NotebookCellKind.Code:default:return b.CellKind.Code}}Re.from=Oe;function Se(re){switch(re){case b.CellKind.Markup:return l.NotebookCellKind.Markup;case b.CellKind.Code:default:return l.NotebookCellKind.Code}}Re.to=Se})(Ke=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Oe(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const He of re.cells)l.NotebookCellData.validate(He),Ne.cells.push(pt.from(He));return Ne}Re.from=Oe;function Se(re){const Ne=new l.NotebookData(re.cells.map(pt.to));return(0,v.isEmptyObject)(re.metadata)||(Ne.metadata=re.metadata),Ne}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var pt;(function(Re){function Oe(re){return{cellKind:Ke.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Le.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(ct.from):[]}}Re.from=Oe;function Se(re){return new l.NotebookCellData(Ke.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(ct.to):void 0,re.metadata,re.internalMetadata?Le.to(re.internalMetadata):void 0)}Re.to=Se})(pt=e.NotebookCellData||(e.NotebookCellData={}));var gt;(function(Re){function Oe(re){return{mime:re.mime,valueBytes:R.VSBuffer.wrap(re.data)}}Re.from=Oe;function Se(re){return new l.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Re.to=Se})(gt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ct;(function(Re){function Oe(re){return{outputId:re.id,items:re.items.map(gt.from),metadata:re.metadata}}Re.from=Oe;function Se(re){const Ne=re.items.map(gt.to);return new l.NotebookCellOutput(Ne,re.outputId,re.metadata)}Re.to=Se})(ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Re){function Oe(Ne){return re(Ne)?{include:(0,v.withNullAsUndefined)($.from(Ne.include)),exclude:(0,v.withNullAsUndefined)($.from(Ne.exclude))}:(0,v.withNullAsUndefined)($.from(Ne))}Re.from=Oe;function Se(Ne){return re(Ne)?{include:$.to(Ne.include),exclude:$.to(Ne.exclude)}:$.to(Ne)}Re.to=Se;function re(Ne){const He=Ne;return He?!(0,v.isUndefinedOrNull)(He.include)&&!(0,v.isUndefinedOrNull)(He.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var tt;(function(Re){function Oe(Se,re,Ne){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(He,Ne),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Oe})(tt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Re){function Oe(Se,re,Ne){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:re.toInternal(He,Ne),label:Se.label,description:Se.description,detail:Se.detail}}Re.from=Oe})(ft=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var At;(function(Re){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Oe})(At=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Kt;(function(Re){function Oe(re){return{uri:re.uri,provides:re.provides}}Re.from=Oe;function Se(re){return new l.NotebookRendererScript(P.URI.revive(re.uri),re.provides)}Re.to=Se})(Kt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Rt;(function(Re){function Oe(re){return{message:M.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:o.from(re.location.range),uri:re.location.uri}}}Re.from=Oe;function Se(re){const Ne=new l.TestMessage(typeof re.message=="string"?re.message:M.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.location=re.location?Ee.to(re.location):void 0,Ne}Re.to=Se})(Rt=e.TestMessage||(e.TestMessage={}));var mt;(function(Re){Re.namespace=g.namespaceTestTag,Re.denamespace=g.denamespaceTestTag})(mt=e.TestTag||(e.TestTag={}));var Tt;(function(Re){function Oe(re){const Ne=(0,f.getPrivateApiFor)(re).controllerId;return{extId:S.TestId.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:P.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(He=>mt.namespace(Ne,He.id)),range:E.Range.lift(o.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&M.fromStrict(re.error)||null}}Re.from=Oe;function Se(re){return{parent:void 0,error:void 0,id:S.TestId.fromString(re.extId).localId,label:re.label,uri:P.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:He}=mt.denamespace(Ne);return new l.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=Se})(Tt=e.TestItem||(e.TestItem={})),function(Re){function Oe(re){return{id:re.id}}Re.from=Oe;function Se(re){return new l.TestTag(re.id)}Re.to=Se}(mt=e.TestTag||(e.TestTag={}));var $t;(function(Re){const Oe=(re,Ne)=>{const He=[];for(const[je,it]of Ne)S.TestId.compare(it.item.extId,je)===2&&(Ne.delete(je),He.push(it));const _e={...Tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(it=>it.type===0).map(Rt.to)})),children:He.map(je=>Oe(je,Ne))};for(const je of _e.children)je.parent=_e;return _e};function Se(re){const Ne=[],He=new Map;for(const _e of re.items){He.set(_e.item.extId,_e);const je=S.TestId.root(_e.item.extId);re.request.targets.some(it=>it.controllerId===je&&it.testIds.includes(_e.item.extId))&&Ne.push(_e)}return{completedAt:re.completedAt,results:Ne.map(_e=>Oe(_e,He))}}Re.to=Se})($t=e.TestResults||(e.TestResults={}));var Nt;(function(Re){function Oe(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?m.from(He):o.from(He)}function re(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Re.fromDetailed=re;function Ne(He){return{uri:He.uri,statement:Oe(He.statementCoverage),branch:He.branchCoverage&&Oe(He.branchCoverage),function:He.functionCoverage&&Oe(He.functionCoverage),details:He.detailedCoverage?.map(re)}}Re.fromFile=Ne})(Nt=e.TestCoverage||(e.TestCoverage={}));var Xe;(function(Re){function Oe(Se){switch(Se){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Re.to=Oe})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(Re){function Oe(re){const Ne=new l.TypeHierarchyItem(J.to(re.kind),re.name,re.detail||"",P.URI.revive(re.uri),o.to(re.range),o.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,He){if(Ne=Ne??re._sessionId,He=He??re._itemId,Ne===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:He,kind:J.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:o.from(re.range),selectionRange:o.from(re.selectionRange),tags:re.tags?.map(ie.from)}}Re.from=Se})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(Re){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Oe})(Ut=e.ViewBadge||(e.ViewBadge={}));var Wt;(function(Re){function Oe(He,_e,je){const it=_e.fileData;return it?new class extends l.DataTransferItem{asFile(){return{name:it.name,uri:P.URI.revive(it.uri),data:(0,u.once)(()=>je())}}}("",_e.id):He===L.Mimes.uriList&&_e.uriListData?new l.DataTransferItem(Ne(_e.uriListData)):new l.DataTransferItem(_e.asString)}Re.to=Oe;async function Se(He,_e){const je=await _e.asString();if(He===L.Mimes.uriList)return{id:_e.id,asString:"",fileData:void 0,uriListData:re(je)};const it=_e.asFile();return{id:_e.id,asString:je,fileData:it?{name:it.name,uri:it.uri}:void 0}}Re.from=Se;function re(He){return T.UriList.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return P.URI.parse(_e)}catch{}return _e})}function Ne(He){return T.UriList.create(He.map(_e=>typeof _e=="string"?_e:P.URI.revive(_e)))}})(Wt=e.DataTransferItem||(e.DataTransferItem={}));var bt;(function(Re){function Oe(re,Ne){const He=re.items.map(([_e,je])=>[_e,Wt.to(_e,je,()=>Ne(je.id))]);return new l.DataTransfer(He)}Re.toDataTransfer=Oe;async function Se(re){const Ne={items:[]},He=[];return re.forEach((_e,je)=>{He.push((async()=>{Ne.items.push([je,await Wt.from(je,_e)])})())}),await Promise.all(He),Ne}Re.toDataTransferDTO=Se})(bt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[238],De([1,0,2,11,7,14,66]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(I,L,k,v={timeout:1500,errors:3}){this.c=I,this.d=L,this.f=k,this.g=v,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(L,k,v)=>{const E={dispose:this.a.push([L,k,I])};return Array.isArray(v)&&v.push(E),E}}async $participateInSave(I,L){const k=a.URI.revive(I);let v=!1;const P=setTimeout(()=>v=!0,this.g.timeout),E=[];try{for(const h of[...this.a]){if(v)break;const d=this.d.getDocument(k),f=await this.h(h,{document:d,reason:u.TextDocumentSaveReason.to(L)});E.push(f)}}finally{clearTimeout(P)}return E}h([I,L,k],v){const P=this.b.get(I);return typeof P=="number"&&P>this.g.errors?Promise.resolve(!1):this.i(k,I,L,v).then(()=>!0,E=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const h=this.b.get(I);this.b.set(I,h?h+1:1),typeof h=="number"&&h>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,L,k,v){const P=[],E=Date.now(),{document:h,reason:d}=v,{version:f}=h,p=Object.freeze({document:h,reason:d,waitUntil(b){if(Object.isFrozen(P))throw(0,R.illegalState)("waitUntil can not be called async");P.push(Promise.resolve(b))}});try{L.apply(k,[p])}catch(b){return Promise.reject(b)}return Object.freeze(P),new Promise((b,S)=>{const g=setTimeout(()=>S(new Error("timeout")),this.g.timeout);return Promise.all(P).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(g),b(t)}).catch(t=>{clearTimeout(g),S(t)})}).then(b=>{const S={edits:[]};for(const g of b)if(Array.isArray(g)&&g.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:l,range:r}of g)S.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:r&&u.Range.from(r),text:t,eol:l&&u.EndOfLine.from(l)}});if(S.edits.length!==0)return f===h.version?this.f.$tryApplyWorkspaceEdit(S):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ye[239],De([1,0,16,2,14,7,92]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(k,v,P,E){this.start=k,this.deletedCount=v,this.deletedItems=P,this.items=E}asApiEvent(){return{range:new u.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(k,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,v,P){this.notebook=k,this.h=v,this.j=P,this.handle=P.handle,this.uri=R.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(T.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(T.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:T.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return k.g},set mime(E){k.g=E},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(P)}return this.f}setOutputs(k){this.a=k.map(T.NotebookCellOutput.to)}setOutputItems(k,v,P){const E=P.map(T.NotebookCellOutputItem.to),h=this.a.find(d=>d.id===k);if(h&&(v||(h.items.length=0),h.items.push(...E),h.items.length>1&&h.items.every(d=>C.isTextStreamMime(d.mime)))){const d=new Map,f=[];h.items.forEach(p=>{let b;d.has(p.mime)?b=d.get(p.mime):(b=[],d.set(p.mime,b),f.push(p.mime)),b.push(p.data)}),h.items.length=0,f.forEach(p=>{const b=C.compressOutputItemStreams(d.get(p));h.items.push({mime:p,data:b.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(T.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=y;class I{constructor(k,v,P,E,h){this.k=k,this.l=v,this.m=P,this.uri=E,this.handle=I.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const k=this,v={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===a.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(P){return P=k.n(P),k.b[P].apiCell},getCells(P){return(P?k.p(P):k.b).map(h=>h.apiCell)},save(){return k.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,v,P){this.g=k.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:P});const E={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},h=[];for(const f of k.rawEvents)f.kind===C.NotebookCellsChangeType.ModelChange?this.r(f.changes,!1,E.contentChanges):f.kind===C.NotebookCellsChangeType.Move?this.s(f.index,f.length,f.newIdx,E.contentChanges):f.kind===C.NotebookCellsChangeType.Output?(this.t(f.index,f.outputs),h.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===C.NotebookCellsChangeType.OutputItem?(this.u(f.index,f.outputId,f.append,f.outputItems),h.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(f.index,f.language),h.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document})):f.kind===C.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document}):f.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(f.index,f.mime):f.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(f.index,f.metadata),h.push({cell:this.b[f.index].apiCell,metadata:this.b[f.index].apiCell.metadata})):f.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(f.index,f.internalMetadata),h.push({cell:this.b[f.index].apiCell,executionSummary:this.b[f.index].apiCell.executionSummary}));const d=new Map;for(let f=0;f<h.length;f++){const p=h[f],b=d.get(p.cell);if(b===void 0){const S=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});d.set(p.cell,S-1)}else E.cellChanges[b]={...E.cellChanges[b],...p}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let v=k.start|0,P=k.end|0;return v<0&&(v=0),P>this.b.length&&(P=this.b.length),k.with({start:v,end:P})}p(k){k=this.o(k);const v=[];for(let P=k.start;P<k.end;P++)v.push(this.b[P]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,v,P){if(this.j)return;const E=[],h=[],d=[];if(k.reverse().forEach(f=>{const b=f[2].map(t=>{const l=new y(this,this.l,t);return v||h.push(y.asModelAddData(this.apiNotebook,t)),l}),S=new A(f[0],f[1],[],b),g=this.b.splice(f[0],f[1],...b);for(const t of g)d.push(t.uri),S.deletedItems.push(t.apiCell);E.push(S)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:d}),P)for(const f of E)P.push(f.asApiEvent())}s(k,v,P,E){const h=this.b.splice(k,v);this.b.splice(P,0,...h);const d=[new A(k,v,h.map(f=>f.apiCell),[]),new A(P,0,[],h)];for(const f of d)E.push(f.asApiEvent())}t(k,v){this.b[k].setOutputs(v)}u(k,v,P,E){this.b[k].setOutputItems(v,P,E)}v(k,v){const P=this.b[k];P.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(P.uri,v)}w(k,v){const P=this.b[k];P.apiCell.mime=v}x(k,v){this.b[k].setMetadata(v)}y(k,v){this.b[k].setInternalMetadata(v)}getCellFromApiCell(k){return this.b.find(v=>v.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(v=>v.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.ExtHostNotebookDocument=I,I.a=0}),define(ye[136],De([1,0,11,14,7]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class u{constructor(A,y,I,L,k,v){this.id=A,this.f=y,this.notebookData=I,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=L,this.c=v}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(T.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,I){A.f.$tryRevealRange(A.id,R.NotebookRange.from(y),I??T.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},u.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(R.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=u,u.apiEditorsToExtHost=new WeakMap}),define(ye[240],De([1,0,3,13,14]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let u=class{constructor(A,y){this.c=A,this.d=y,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const I=this.d.getEditorById(A);y.visibleRanges&&I._acceptVisibleRanges(y.visibleRanges.ranges.map(T.NotebookRange.to)),y.selections&&I._acceptSelections(y.selections.selections.map(T.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this.d.getEditorById(y)._acceptViewColumn(T.ViewColumn.to(A[y]))}};u=qe([We(0,R.ILogService)],u),e.ExtHostNotebookEditors=u}),define(ye[241],De([1,0,14,126,178,21,62,11]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,P,E){const h=this.b++,{title:d,location:f,cancellable:p}=P,b={label:(0,T.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(h,{location:a.ProgressLocation.from(f),title:d,source:b,cancellable:p},v.isUnderDevelopment?void 0:v.identifier.value).catch(A.onUnexpectedExternalError),this.d(h,E,!!p)}d(v,P,E){let h;E&&(h=new u.CancellationTokenSource,this.c.set(v,h));const d=p=>{this.a.$progressEnd(p),this.c.delete(p),h?.dispose()};let f;try{f=P(new L(this.a,v),E&&h?h.token:u.CancellationToken.None)}catch(p){throw d(v),p}return f.then(p=>d(v),p=>d(v)),f}$acceptProgressCanceled(v){const P=this.c.get(v);P&&(P.cancel(),this.c.delete(v))}}e.ExtHostProgress=y;function I(k,v){return k.message=v.message,typeof v.increment=="number"&&(typeof k.increment=="number"?k.increment+=v.increment:k.increment=v.increment),k}class L extends R.Progress{constructor(v,P){super(E=>this.throttledReport(E)),this.c=v,this.d=P}throttledReport(v){this.c.$progressReport(this.d,v)}}qe([(0,C.throttle)(100,(k,v)=>I(k,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],De([1,0,35,132,57,93,75,14,2]),function(te,e,a,R,T,u,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(b,S,g,t)=>{let l=S;return{enumerable:!0,configurable:!1,get(){return l},set(r){if(!g(l,r)){const o=l;l=r,b.listener?.(t(r,o))}}}},L=(b,S)=>b===S,k={range:(b,S)=>b===S?!0:!b||!S?!1:b.isEqual(S),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(b,S)=>!(b.length!==S.length||b.some(g=>!S.find(t=>g.id===t.id)))},v=b=>S=>({op:4,update:b(S)}),P=(b,S)=>({range:(()=>{let g;const t=v(l=>({range:a.Range.lift(A.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return g},set(l){b.listener?.({op:6}),k.range(g,l)||(g=l,b.listener?.(t(l)))}}})(),label:I(b,S,k.label,v(g=>({label:g}))),description:I(b,void 0,k.description,v(g=>({description:g}))),sortText:I(b,void 0,k.sortText,v(g=>({sortText:g}))),canResolveChildren:I(b,!1,k.canResolveChildren,g=>({op:2,state:g})),busy:I(b,!1,k.busy,v(g=>({busy:g}))),error:I(b,void 0,k.error,v(g=>({error:A.MarkdownString.fromStrict(g)||null}))),tags:I(b,[],k.tags,(g,t)=>({op:1,new:g.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),E=b=>{const S=T.TestId.fromString(b.extId),g=new d(S.controllerId,S.localId,b.label,y.URI.revive(b.uri)||void 0);return g.range=A.Range.to(b.range||void 0),g.description=b.description||void 0,g.sortText=b.sortText||void 0,g.tags=b.tags.map(t=>A.TestTag.to({id:(0,C.denamespaceTestTag)(t).tagId})),g},h=b=>{let S;for(const g of b.tests){const t=E(g.item);(0,R.getPrivateApiFor)(t).parent=S,S=t}return S};e.toItemFromContext=h;class d{constructor(S,g,t,l){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const r=(0,R.createPrivateApiFor)(this,S);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof f?void 0:r.parent}},children:{value:(0,u.createTestItemChildren)(r,R.getPrivateApiFor,d),enumerable:!0,writable:!1},...P(r,t)})}}e.TestItemImpl=d;class f extends d{constructor(S,g){super(S,S,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class p extends u.TestItemCollection{constructor(S,g,t){super({controllerId:S,getDocumentVersion:l=>l&&t.getDocument(l)?.version,getApiFor:R.getPrivateApiFor,getChildren:l=>l.children,root:new f(S,g),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(ye[138],De([1,0,50,11,101,14,7]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(v,P,E){const h=A.c.nextId();v.$registerTextEditorDecorationType(P.identifier,h,u.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:h,dispose(){v.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=A,A.c=new T.IdGenerator("TextEditorDecorationType");class y{constructor(v,P){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,P){this.k();let E=null;if(v instanceof C.Position)E=new C.Range(v,v);else if(v instanceof C.Range)E=v;else throw new Error("Unrecognized location");this.l(E,P,!1)}insert(v,P){this.k(),this.l(new C.Range(v,v),P,!0)}delete(v){this.k();let P=null;if(v instanceof C.Range)P=v;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(v,P,E){const h=this.c.validateRange(v);this.g.push({range:h,text:P,forceMoveMarkers:E})}setEndOfLine(v){if(this.k(),v!==C.EndOfLine.LF&&v!==C.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this.h=v}}class I{constructor(v,P,E,h){this.c=v,this.d=P,this._accept(E),this.e=h;const d=this;this.value={get tabSize(){return d.f},set tabSize(f){d.m(f)},get indentSize(){return d.g},set indentSize(f){d.o(f)},get insertSpaces(){return d.h},set insertSpaces(f){d.q(f)},get cursorStyle(){return d.j},set cursorStyle(f){d.s(f)},get lineNumbers(){return d.k},set lineNumbers(f){d.t(f)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=u.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const P=Math.floor(v);return P>0?P:null}if(typeof v=="string"){const P=parseInt(v,10);return isNaN(P)?null:P>0?P:null}return null}m(v){const P=this.l(v);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const P=Math.floor(v);return P>0?P:null}if(typeof v=="string"){const P=parseInt(v,10);return isNaN(P)?null:P>0?P:null}return null}o(v){const P=this.n(v);if(P!==null){if(typeof P=="number"){if(this.g===P)return;this.g=P}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const P=this.p(v);if(typeof P=="boolean"){if(this.h===P)return;this.h=P}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:u.TextEditorLineNumbersStyle.from(v)})))}assign(v){const P={};let E=!1;if(typeof v.tabSize<"u"){const h=this.l(v.tabSize);h==="auto"?(E=!0,P.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,E=!0,P.tabSize=h)}if(typeof v.indentSize<"u"){const h=this.n(v.indentSize);h==="tabSize"?(E=!0,P.indentSize=h):typeof h=="number"&&this.g!==h&&(this.g=h,E=!0,P.indentSize=h)}if(typeof v.insertSpaces<"u"){const h=this.p(v.insertSpaces);h==="auto"?(E=!0,P.insertSpaces=h):this.h!==h&&(this.h=h,E=!0,P.insertSpaces=h)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,E=!0,P.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,E=!0,P.lineNumbers=u.TextEditorLineNumbersStyle.from(v.lineNumbers)),E&&this.u("setOptions",this.c.$trySetOptions(this.d,P))}u(v,P){P.catch(E=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(E)})}}e.ExtHostTextEditorOptions=I;class L{constructor(v,P,E,h,d,f,p,b){this.id=v,this.j=P,this.k=E,this.g=!1,this.h=new Set,this.c=d,this.d=new I(this.j,this.id,f,E),this.e=p,this.f=b;const S=this;this.value=Object.freeze({get document(){return h.value},set document(g){throw(0,R.readonly)("document")},get selection(){return S.c&&S.c[0]},set selection(g){if(!(g instanceof C.Selection))throw(0,R.illegalArgument)("selection");S.c=[g],S.l()},get selections(){return S.c},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof C.Selection)))throw(0,R.illegalArgument)("selections");S.c=g,S.l()},get visibleRanges(){return S.e},set visibleRanges(g){throw(0,R.readonly)("visibleRanges")},get options(){return S.d.value},set options(g){S.g||S.d.assign(g)},get viewColumn(){return S.f},set viewColumn(g){throw(0,R.readonly)("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new y(h.value,t);return g(l),S.m(l)},insertSnippet(g,t,l={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=S.c.map(o=>u.Range.from(o));else if(t instanceof C.Position){const{lineNumber:o,column:n}=u.Position.from(t);r=[{startLineNumber:o,startColumn:n,endLineNumber:o,endColumn:n}]}else if(t instanceof C.Range)r=[u.Range.from(t)];else{r=[];for(const o of t)if(o instanceof C.Range)r.push(u.Range.from(o));else{const{lineNumber:n,column:m}=u.Position.from(o);r.push({startLineNumber:n,startColumn:m,endLineNumber:n,endColumn:m})}}return P.$tryInsertSnippet(v,h.value.version,g.value,r,l)},setDecorations(g,t){const l=t.length===0;l&&!S.h.has(g.key)||(l?S.h.delete(g.key):S.h.add(g.key),S.n(()=>{if(u.isDecorationOptionsArr(t))return P.$trySetDecorations(v,g.key,u.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let o=0,n=t.length;o<n;o++){const m=t[o];r[4*o]=m.start.line+1,r[4*o+1]=m.start.character+1,r[4*o+2]=m.end.line+1,r[4*o+3]=m.end.character+1}return P.$trySetDecorationsFast(v,g.key,r)}}))},revealRange(g,t){S.n(()=>P.$tryRevealRange(v,u.Range.from(g),t||C.TextEditorRevealType.Default))},show(g){P.$tryShowEditor(v,u.ViewColumn.from(g))},hide(){P.$tryHideEditor(v)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,a.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,a.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,a.ok)(!this.g),this.f=v}_acceptSelections(v){(0,a.ok)(!this.g),this.c=v}async l(){const v=this.c.map(u.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const P=v.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const E=P.edits.map(d=>d.range);E.sort((d,f)=>d.end.line===f.end.line?d.end.character===f.end.character?d.start.line===f.start.line?d.start.character-f.start.character:d.start.line-f.start.line:d.end.character-f.end.character:d.end.line-f.end.line);for(let d=0,f=E.length-1;d<f;d++){const p=E[d].end;if(E[d+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=P.edits.map(d=>({range:u.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,h,{setEndOfLine:typeof P.setEndOfLine=="number"?u.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.ExtHostTextEditor=L}),define(ye[242],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[243],De([1,0,193,11,37,123,91,39,26,242,206,195]),function(te,e,a,R,T,u,C,A,y,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=A.Registry.as(C.Extensions.JSONContribution);class P{constructor(g,t,l){this.a=g,this.b=t,this.c=l}d(g,t){this.a({type:g,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(T.default.Error,g)}warn(g){this.d(T.default.Warning,g)}info(g){this.d(T.default.Info,g)}}e.ExtensionMessageCollector=P;class E{static a(g){const t=new Set;for(let l=0,r=g.length;l<r;l++)t.add(y.ExtensionIdentifier.toKey(g[l].description.identifier));return t}static compute(g,t){if(!g||!g.length)return new E(t,[]);if(!t||!t.length)return new E([],g);const l=this.a(g),r=this.a(t),o=t.filter(m=>!l.has(y.ExtensionIdentifier.toKey(m.description.identifier))),n=g.filter(m=>!r.has(y.ExtensionIdentifier.toKey(m.description.identifier)));return new E(o,n)}constructor(g,t){this.added=g,this.removed=t}}e.ExtensionPointUserDelta=E;class h{constructor(g,t){this.name=g,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=E.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,R.onUnexpectedError)(g)}}}e.ExtensionPoint=h;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},f="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:u.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:u.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const t=new h(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,t),g.activationEventsGenerator&&k.ImplicitActivationEvents.register(g.extensionPoint,g.activationEventsGenerator),e.schema.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,v.registerSchema(f,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const b={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(b.ExtensionsRegistry,new p),e.ExtensionsRegistry=A.Registry.as(b.ExtensionsRegistry),v.registerSchema(f,e.schema),v.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(ye[244],De([1,0,190,9,23,243,54,3]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var I;(function(v){function P(E,h,d){if(!E)return;const f=R.isString(E.type)?E.type:void 0;if(!f||f.length===0){d.error(a.localize(3,null));return}const p=[];if(Array.isArray(E.required))for(const b of E.required)R.isString(b)&&p.push(b);return{extensionId:h.value,taskType:f,required:p,properties:E.properties?T.deepClone(E.properties):{},when:E.when?C.ContextKeyExpr.deserialize(E.when):void 0}}v.from=P})(I||(I={}));const L=u.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:y}});class k{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,E)=>{L.setHandler((h,d)=>{this.c=void 0;try{for(const f of d.removed){const p=f.value;for(const b of p)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const f of d.added){const p=f.value;for(const b of p){const S=I.from(b,f.description.identifier,f.collector);S&&(this.a[S.taskType]=S)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const E of this.all()){const h={type:"object",additionalProperties:!1};E.required.length>0&&(h.required=E.required.slice(0)),E.properties!==void 0?h.properties=T.deepClone(E.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[E.taskType]},P.push(h)}this.c={oneOf:P}}return this.c}}e.TaskDefinitionRegistry=new k}),define(ye[245],De([1,0,191,9,24,23,54,244]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var y;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function U(z){if(!z)return O.Strong;switch(z.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=U}(y=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var L;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(O){function U(z){switch(z.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=U}(L=e.RevealKind||(e.RevealKind={}));var k;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function U(z){switch(z.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=U}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(O){function U(z){switch(z.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=U}(v=e.PanelKind||(e.PanelKind={}));var P;(function(O){O.defaults={echo:!0,reveal:L.Always,revealProblems:k.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(P=e.PresentationOptions||(e.PresentationOptions={}));var E;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(E=e.RuntimeType||(e.RuntimeType={})),function(O){function U(j){switch(j.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=U;function z(j){switch(j){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=z}(E=e.RuntimeType||(e.RuntimeType={}));var h;(function(O){function U(z){return R.isString(z)?z:z.value}O.value=U})(h=e.CommandString||(e.CommandString={}));var d;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function U(j){return j===O.Clean._id||j===O.Build._id||j===O.Rebuild._id||j===O.Test._id}O.is=U;function z(j){if(j!==void 0)return R.isString(j)?U(j)?{_id:j,isDefault:!1}:void 0:j}O.from=z})(d=e.TaskGroup||(e.TaskGroup={}));var f;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var p;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function U(z){switch(z){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=U})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var S;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(S=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:S.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class t{constructor(U,z,j,le,V,_){this._label="",this._id=U,z&&(this._label=z),j&&(this.type=j),this.runOptions=le,this.configurationProperties=V,this._source=_}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,z=!1){if(U===void 0)return!1;if(R.isString(U))return U===this._label||U===this.configurationProperties.identifier||z&&U===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class l extends t{constructor(U,z,j,le,V,_,J,ie){super(U,j,void 0,J,ie,z),this.command={},this._source=z,this.hasDefinedMatchers=_,V&&(this.command=V)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case E.Shell:z="shell";break;case E.Process:z="process";break;case E.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(U){return U instanceof l}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:z};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new l(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=l;class r extends t{constructor(U,z,j,le,V,_,J){super(U,j,le,_,J,z),this._source=z,this.configures=V}static is(U){return U instanceof r}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:z};return JSON.stringify(j)}}e.ConfiguringTask=r;class o extends t{constructor(U,z,j,le,V,_,J,ie,ee){super(U,j,le,ie,ee,z),this.defines=V,this.hasDefinedMatchers=J,this.command=_,this.icon=ee.icon,this.hide=ee.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof o}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new o(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=o;class n extends t{constructor(U,z,j,le,V,_){super(U,j,le,V,_,z),this._source=z}clone(){return new n(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof n}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new n(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=n;var m;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(m=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(m=e.ExecutionEngine||(e.ExecutionEngine={}));var s;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(s=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class i{constructor(U){this.c=new Map;for(let z=0;z<U.length;z++)this.c.set(U[z].uri.toString(),z)}compare(U,z){const j=U.getWorkspaceFolder(),le=z.getWorkspaceFolder();if(j&&le){let V=this.c.get(j.uri.toString());V=V===void 0?0:V+1;let _=this.c.get(le.uri.toString());return _=_===void 0?0:_+1,V===_?U._label.localeCompare(z._label):V-_}else return!j&&le?-1:j&&!le?1:0}}e.TaskSorter=i;var c;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(c=e.TaskEventKind||(e.TaskEventKind={}));var w;(function(O){O.SingleRun="singleRun",O.Background="background"})(w=e.TaskRunType||(e.TaskRunType={}));var D;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(D=e.TaskRunSource||(e.TaskRunSource={}));var F;(function(O){function U(z,j,le,V){if(j){const _={kind:z,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:j};return z==="start"?_.resolvedVariables=V:z==="processStarted"?_.processId=V:z==="processEnded"&&(_.exitCode=V),Object.freeze(_)}else return Object.freeze({kind:"changed"})}O.create=U})(F=e.TaskEvent||(e.TaskEvent={}));var x;(function(O){function U(j){const le=Object.keys(j).sort();let V="";for(const _ of le){let J=j[_];J instanceof Object?J=U(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),V+=_+","+J+","}return V}function z(j){const V={_key:U(j),type:j.taskType};return Object.assign(V,j),V}O.create=z})(x=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var q;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(q=e.TaskSettingId||(e.TaskSettingId={}));var M;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(M=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(O){function U(z,j){const le=A.TaskDefinitionRegistry.get(z.type);if(le===void 0){const ie=u.deepClone(z);return delete ie._key,x.create(ie)}const V=Object.create(null);V.type=le.taskType;const _=new Set;le.required.forEach(ie=>_.add(ie));const J=le.properties;for(const ie of Object.keys(J)){const ee=z[ie];if(ee!=null)V[ie]=ee;else if(_.has(ie)){const K=J[ie];if(K.default!==void 0)V[ie]=u.deepClone(K.default);else switch(K.type){case"boolean":V[ie]=!1;break;case"number":case"integer":V[ie]=0;break;case"string":V[ie]="";break;default:j.error(a.localize(2,null,JSON.stringify(z,void 0,0),ie));return}}}return x.create(V)}O.createTaskIdentifier=U})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[246],De([1,0,11]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,A)=>{this.b=C,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,a.onUnexpectedError)(C))}then(C,A){return this.j().then(C,A)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=R;class T extends R{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=T}),define(ye[58],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const R=[];function T(A){const y=new a(A);return R[y.nid]=y,y}e.createProxyIdentifier=T;function u(A){return R[A].sid}e.getStringIdentifierForProxy=u;class C{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=C}),define(ye[5],De([1,0,58]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput"})(T=e.TabInputKind||(e.TabInputKind={}));var u;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(u=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(d){return d._id=k.a++,d}}e.IdObject=k,k.a=0;var v;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var P;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(P=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,a.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,a.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[76],De([1,0,4,13,5,18]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(y,I){this.c=I,this.a=new Set,this.b=y.getProxy(T.MainContext.MainThreadTelemetry)}report(y,I,L){const k=this.d(y,I);this.a.has(k)||(this.a.add(k),I.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:y}))}d(y,I){return`${y}-${I.identifier.value}`}};C=qe([We(0,u.IExtHostRpcService),We(1,R.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,I){}})}),define(ye[247],De([1,0,3,5,7,26]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(y){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,I,L,k={}){const v=u.ExtensionIdentifier.toKey(y.identifier),P=this.f.get(v)||[],E=[...L].sort().join(" ");let h=P.find(d=>d.providerId===I&&d.scopes===E);if(h)return h.result;{const d=this.g(y,v,I,L,k);h={providerId:I,scopes:E,result:d},P.push(h),this.f.set(v,P);try{await d}finally{const f=P.findIndex(p=>p.providerId===I&&p.scopes===E);f>-1&&(P.splice(f),this.f.set(v,P))}return d}}async g(y,I,L,k,v={}){await this.a.$ensureProvider(L);const P=y.displayName||y.name;return this.a.$getSession(L,k,I,P,v)}async removeSession(y,I){const L=this.b.get(y);return L?L.provider.removeSession(I):this.a.$removeSession(y,I)}registerAuthenticationProvider(y,I,L,k){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:I,provider:L,options:k??{supportsMultipleAccounts:!1}}),this.c.find(P=>P.id===y)||this.c.push({id:y,label:I});const v=L.onDidChangeSessions(P=>{this.a.$sendDidChangeSessions(y,{added:P.added??[],changed:P.changed??[],removed:P.removed??[]})});return this.a.$registerAuthenticationProvider(y,I,k?.supportsMultipleAccounts??!1),new T.Disposable(()=>{v.dispose(),this.b.delete(y);const P=this.c.findIndex(E=>E.id===y);P>-1&&this.c.splice(P),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,I){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,I){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,I){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,I){return this.d.fire({provider:{id:y,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(ye[248],De([1,0,5,18,14]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let u=class{constructor(A,y){this.a=A.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>y.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,I){const L=T.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,I?.isRefactoring??!1)}};u=qe([We(0,R.IExtHostRpcService)],u),e.ExtHostBulkEdits=u}),define(ye[249],De([1,0,5]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(u){const C=u.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(A){return C.$writeText(A)}})}}e.ExtHostClipboard=R});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)};define(ye[40],De([1,0,9,7,14,23,5,15,13,69,35,52,2,6,4,18,137,22,58,45,43,73]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S,g){"use strict";var t,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(c,w){t.set(this,void 0),this.b=new Map,this.c=new Map,l.set(this,void 0),Je(this,t,c.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=w,Je(this,l,c.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new o(this,D=>{const F=this.c.get(D);return F?.result===m.Void?F:void 0},w),this.f=[{processArgument(D){return(0,I.revive)(D)}},{processArgument(D){return(0,u.cloneAndChange)(D,function(F){if(L.Range.isIRange(F))return T.Range.to(F);if(k.Position.isIPosition(F))return T.Position.to(F);if(L.Range.isIRange(F.range)&&v.URI.isUri(F.uri))return T.location.to(F);if(F instanceof f.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(c){this.f.push(c)}registerApiCommand(c){const w=this.registerCommand(!1,c.id,async(...D)=>{const F=c.args.map((q,M)=>{if(!q.validate(D[M]))throw new Error(`Invalid argument '${q.name}' when running '${c.id}', received: ${D[M]}`);return q.convert(D[M])}),x=await this.executeCommand(c.internalId,...F);return c.result.convert(x,D,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this.c.set(c.id,c),new R.Disposable(()=>{w.dispose(),this.c.delete(c.id)})}registerCommand(c,w,D,F,x,q){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:D,thisArg:F,description:x,extension:q}),c&&Be(this,t,"f").$registerCommand(w),new R.Disposable(()=>{this.b.delete(w)&&c&&Be(this,t,"f").$unregisterCommand(w)})}executeCommand(c,...w){return this.d.trace("ExtHostCommands#executeCommand",c),this.g(c,w,!0)}async g(c,w,D){if(this.b.has(c))return Be(this,t,"f").$fireCommandActivationEvent(c),this.h(c,w,!1);{let F=!1;const x=(0,u.cloneAndChange)(w,function(q){if(q instanceof R.Position)return T.Position.from(q);if(q instanceof R.Range)return T.Range.from(q);if(q instanceof R.Location)return T.location.from(q);if(R.NotebookRange.isNotebookRange(q))return T.NotebookRange.from(q);if(q instanceof ArrayBuffer)return F=!0,f.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return F=!0,f.VSBuffer.wrap(q);if(q instanceof f.VSBuffer)return F=!0,q;if(!Array.isArray(q))return q});try{const q=await Be(this,t,"f").$executeCommand(c,F?new p.SerializableObjectWithBuffers(x):x,D);return(0,I.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(c,w,!1);throw q}}}async h(c,w,D){const F=this.b.get(c);if(!F)throw new Error("Unknown command");const{callback:x,thisArg:q,description:M}=F;if(M)for(let O=0;O<M.args.length;O++)try{(0,a.validateConstraint)(w[O],M.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${M.args[O].name}' - ${M.args[O].description}`)}const B=S.StopWatch.create();try{return await x.apply(q,w)}catch(O){if(c===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...w);U&&(c=U.command)}throw this.d.error(O,c,F.extension?.identifier),D?new class extends Error{constructor(){super((0,b.toErrorMessage)(O)),this.id=c,this.source=F.extension?.displayName??F.extension?.name}}:O}finally{this.j(F,c,B.elapsed())}}j(c,w,D){!c.extension||Be(this,l,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:new g.TelemetryTrustedValue(w),duration:D})}$executeContributedCommand(c,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",c);const D=this.b.get(c);return D?(w=w.map(F=>this.f.reduce((x,q)=>q.processArgument(x,D.extension?.identifier),F)),this.h(c,w,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this.d.trace("ExtHostCommands#getCommands",c),Be(this,t,"f").$getCommands().then(w=>(c&&(w=w.filter(D=>D[0]!=="_")),w))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[w,D]of this.b){const{description:F}=D;F&&(c[w]=F)}return Promise.resolve(c)}};t=new WeakMap,l=new WeakMap,r=qe([We(0,h.IExtHostRpcService),We(1,y.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class o{constructor(c,w,D){this.d=c,this.f=w,this.g=D,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(c,w){if(!c)return;const D={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return D;const F=this.f(c.command);if(F)D.id=F.internalId,D.arguments=F.args.map((x,q)=>x.convert(c.arguments&&c.arguments[q]));else if((0,A.isNonEmptyArray)(c.arguments)){const x=`${c.command}/${++this.c}`;this.b.set(x,c),w.add((0,P.toDisposable)(()=>{this.b.delete(x),this.g.trace("CommandsConverter#DISPOSE",x)})),D.$ident=x,D.id=this.delegatingCommandId,D.arguments=[x],this.g.trace("CommandsConverter#CREATE",c.command,x)}return D}fromInternal(c){return typeof c.$ident=="string"?this.b.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this.b.get(c[0])}h(...c){const w=this.getActualCommand(...c);return this.g.trace("CommandsConverter#EXECUTE",c[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${c[0]}`)}}e.CommandsConverter=o;class n{constructor(c,w,D,F){this.name=c,this.description=w,this.validate=D,this.convert=F}optional(){return new n(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,w){return new n(c??this.name,w??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",i=>v.URI.isUri(i),i=>i),n.Position=new n("position","A position in a text document",i=>R.Position.isPosition(i),T.Position.from),n.Range=new n("range","A range in a text document",i=>R.Range.isRange(i),T.Range.from),n.Selection=new n("selection","A selection in a text document",i=>R.Selection.isSelection(i),T.Selection.from),n.Number=new n("number","",i=>typeof i=="number",i=>i),n.String=new n("string","",i=>typeof i=="string",i=>i),n.CallHierarchyItem=new n("item","A call hierarchy item",i=>i instanceof R.CallHierarchyItem,T.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",i=>i instanceof R.TypeHierarchyItem,T.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",i=>i instanceof d.TestItemImpl,T.TestItem.from);class m{constructor(c,w){this.description=c,this.convert=w}}e.ApiCommandResult=m,m.Void=new m("no result",i=>i);class s{constructor(c,w,D,F,x){this.id=c,this.internalId=w,this.description=D,this.args=F,this.result=x}}e.ApiCommand=s}),define(ye[250],De([1,0,2,14,7,71,40,15,120,125,16]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",P(R.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,d)=>{if((0,A.isFalsyOrEmpty)(h))return;class f extends T.SymbolInformation{static to(b){const S=new f(b.name,R.SymbolKind.to(b.kind),b.containerName||"",new T.Location(d[0],R.Range.to(b.range)));return S.detail=b.detail,S.range=S.location.range,S.selectionRange=R.Range.to(b.selectionRange),S.children=b.children?b.children.map(f.to):[],S}}return h.map(f.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(R.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(R.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new C.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(R.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",P(R.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",P(R.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(d=>T.Position.isPosition(d)),h=>h.map(R.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(d=>{let f;for(const p of d.reverse())f=new T.SelectionRange(R.Range.to(p),f);return f}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(R.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(R.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(R.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(R.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:R.Range.to(h.range),placeholder:h.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return R.WorkspaceEdit.to(h)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(R.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new T.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,y.decodeSemanticTokensDto)(h);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new T.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,y.decodeSemanticTokensDto)(h);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,d,f)=>{if(!h)return new T.CompletionList([]);const p=h.suggestions.map(b=>R.CompletionItem.to(b,f));return new T.CompletionList(p,h.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return R.SignatureHelp.to(h)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,d,f)=>P(p=>new T.CodeLens(R.Range.to(p.range),p.command&&f.fromInternal(p.command)))(h))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>T.Range.isRange(h),h=>T.Selection.isSelection(h)?R.Selection.from(h):R.Range.from(h)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,d,f)=>P(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(p.command)}else{const b=new T.CodeAction(p.title,p.kind?new T.CodeActionKind(p.kind):void 0);return p.edit&&(b.edit=R.WorkspaceEdit.to(p.edit)),p.command&&(b.command=f.fromInternal(p.command)),b.isPreferred=p.isPreferred,b}})(h))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(d=>new T.ColorInformation(R.Range.to(d.range),R.Color.to(d.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",h=>h instanceof T.Color,R.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:R.Range.from(h.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(R.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,d,f)=>h.map(R.InlayHint.to.bind(void 0,f)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",P(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(d=>R.NotebookExclusiveDocumentPattern.to(d))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(R.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>a.URI.isUri(h)||typeof h=="string"&&(0,I.matchesSomeScheme)(h,L.Schemas.http,L.Schemas.https),h=>h),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[R.ViewColumn.from(h),void 0]:[R.ViewColumn.from(h.viewColumn),R.TextEditorOpenOptions.from(h)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[R.ViewColumn.from(h),void 0]:[R.ViewColumn.from(h.viewColumn),R.TextEditorOpenOptions.from(h)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[R.ViewColumn.from(h.viewColumn),R.TextEditorOpenOptions.from(h)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(R.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(R.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(R.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,h=>h)],C.ApiCommandResult.Void)];class v{static register(d){k.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=v;function P(h){return d=>{if(Array.isArray(d))return d.map(h)}}function E(h){if(!Array.isArray(h))return;const d=[];for(const f of h)u.isLocationLink(f)?d.push(R.DefinitionLink.to(f)):d.push(R.location.to(f));return d}}),define(ye[251],De([1,0,17,62,3,6,2,71,26,14,7,5]),function(te,e,a,R,T,u,C,A,y,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(P,E,h){const d=P.getProxy(k.MainContext.MainThreadComments);class f{constructor(){this.b=new Map,this.c=new Map,E.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const m=this.b.get(n.handle);return m?m.value:n}else if(n&&n.$mid===7){const m=this.b.get(n.commentControlHandle);if(!m)return n;const s=m.getCommentThread(n.commentThreadHandle);return s?s.value:n}else if(n&&(n.$mid===9||n.$mid===8)){const m=this.b.get(n.thread.commentControlHandle);if(!m)return n;const s=m.getCommentThread(n.thread.commentThreadHandle);return s?n.$mid===8?s.value:{thread:s.value,text:n.text}:n}else if(n&&n.$mid===10){const m=this.b.get(n.thread.commentControlHandle);if(!m)return n;const s=m.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;const i=n.commentUniqueId,c=s.getCommentByUniqueId(i);return c||n}else if(n&&n.$mid===11){const m=this.b.get(n.thread.commentControlHandle);if(!m)return n;const s=m.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;const i=n.text,c=n.commentUniqueId,w=s.getCommentByUniqueId(c);return w?(typeof w.body=="string"?w.body=i:w.body=new L.MarkdownString(i),w):n}return n}})}createCommentController(n,m,s){const i=f.a++,c=new b(n,i,m,s);this.b.set(c.handle,c);const w=this.c.get(y.ExtensionIdentifier.toKey(n.identifier))||[];return w.push(c),this.c.set(y.ExtensionIdentifier.toKey(n.identifier),w),c.value}$createCommentThreadTemplate(n,m,s){const i=this.b.get(n);!i||i.$createCommentThreadTemplate(m,s)}async $updateCommentThreadTemplate(n,m,s){const i=this.b.get(n);!i||i.$updateCommentThreadTemplate(m,s)}$deleteCommentThread(n,m){this.b.get(n)?.$deleteCommentThread(m)}$provideCommentingRanges(n,m,s){const i=this.b.get(n);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const c=h.getDocument(C.URI.revive(m));return(0,a.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(c,s)).then(w=>w?w.map(D=>I.Range.from(D)):void 0)}$toggleReaction(n,m,s,i,c){const w=this.b.get(n);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const D=w.getCommentThread(m);if(D){const F=D.getCommentByUniqueId(i.uniqueIdInThread);if(w!==void 0&&F&&w.reactionHandler)return w.reactionHandler(F,t(c))}return Promise.resolve(void 0)})}dispose(){}}f.a=0;class p{set threadId(n){this.n=n}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(n){n.isEqual(this.p)||(this.p=n,this.b.range=n,this.c.fire())}get range(){return this.p}set canReply(n){this.d!==n&&(this.d=n,this.b.canReply=n,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(n){this.e=n,this.b.label=n,this.c.fire()}get contextValue(){return this.f}set contextValue(n){this.f=n,this.b.contextValue=n,this.c.fire()}get comments(){return this.q}set comments(n){this.q=n,this.b.comments=n,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(n){this.g=n,this.b.collapsibleState=n,this.c.fire()}get state(){return this.h}set state(n){this.h=n,this.b.state=n,this.c.fire()}get isDisposed(){return this.j}constructor(n,m,s,i,c,w,D,F){this.m=m,this.n=s,this.o=i,this.p=c,this.q=w,this.extensionDescription=D,this.r=F,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new T.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new u.MutableDisposable,this.l.value=new u.DisposableStore,this.n===void 0&&(this.n=`${n}.${this.handle}`),d.$createCommentThread(m,this.handle,this.n,this.o,I.Range.from(this.p),D.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{d.$deleteCommentThread(m,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(q){x.range=q},get comments(){return x.comments},set comments(q){x.comments=q},get collapsibleState(){return x.collapsibleState},set collapsibleState(q){x.collapsibleState=q},get canReply(){return x.canReply},set canReply(q){x.canReply=q},get contextValue(){return x.contextValue},set contextValue(q){x.contextValue=q},get label(){return x.label},set label(q){x.label=q},get state(){return x.state},set state(q){x.state=q},dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new u.DisposableStore);const n=s=>Object.prototype.hasOwnProperty.call(this.b,s),m={};n("range")&&(m.range=I.Range.from(this.p)),n("label")&&(m.label=this.label),n("contextValue")&&(m.contextValue=this.contextValue??null),n("comments")&&(m.comments=this.q.map(s=>S(this,s,this.k))),n("collapsibleState")&&(m.collapseState=l(this.g)),n("canReply")&&(m.canReply=this.canReply),n("state")&&(m.state=r(this.h)),n("isTemplate")&&(m.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,m)}getCommentByUniqueId(n){for(const m of this.k){const s=m[0],i=m[1];if(n===i)return s}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(n=>n.dispose())}}p.a=0,qe([(0,R.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(n){this.b=n,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(n){this.c=n,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this.d}set options(n){this.d=n,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(n,m,s,i){this.f=n,this.g=m,this.h=s,this.i=i,this.a=new Map,d.$registerCommentController(this.handle,s,i);const c=this;this.value=Object.freeze({id:c.id,label:c.label,get options(){return c.options},set options(w){c.options=w},get commentingRangeProvider(){return c.commentingRangeProvider},set commentingRangeProvider(w){c.commentingRangeProvider=w},get reactionHandler(){return c.reactionHandler},set reactionHandler(w){c.reactionHandler=w},createCommentThread(w,D,F){return c.createCommentThread(w,D,F).value},dispose:()=>{c.dispose()}}),this.e=[],this.e.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(n,m,s,i){if(typeof n=="string"){const c=new p(this.id,this.handle,n,m,s,i,this.f,!1);return this.a.set(c.handle,c),c}else{const c=new p(this.id,this.handle,void 0,n,m,s,this.f,!1);return this.a.set(c.handle,c),c}}$createCommentThreadTemplate(n,m){const s=new p(this.id,this.handle,void 0,C.URI.revive(n),I.Range.to(m),[],this.f,!0);return s.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(s.handle,s),s}$updateCommentThreadTemplate(n,m){const s=this.a.get(n);s&&(s.range=I.Range.to(m))}$deleteCommentThread(n){this.a.get(n)?.dispose(),this.a.delete(n)}getCommentThread(n){return this.a.get(n)}dispose(){this.a.forEach(n=>{n.dispose()}),this.e.forEach(n=>n.dispose())}}function S(o,n,m){let s=m.get(n);s||(s=++o.commentHandle,m.set(n,s));const i=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:s,body:typeof n.body=="string"?n.body:I.MarkdownString.from(n.body),userName:n.author.name,userIconPath:i,label:n.label,commentReactions:n.reactions?n.reactions.map(c=>g(c)):void 0,timestamp:n.timestamp?.toJSON()}}function g(o){return{label:o.label,iconPath:o.iconPath?I.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function t(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?C.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function l(o){if(o!==void 0)switch(o){case L.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function r(o){if(o!==void 0)switch(o){case L.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new f}e.createExtHostComments=v}),define(ye[252],De([1,0,23,5,25,18]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(L,k){this.a=L.getProxy(R.MainContext.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,k){const v=this,P=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,k,P,arguments)}})}e(L,k,v,P){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:y(P,this.b)}),this.c&&this.f(L,v,P)}};C=qe([We(0,u.IExtHostRpcService),We(1,T.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const A=1e5;function y(I,L){const k=[];if(I.length)for(let v=0;v<I.length;v++){let P=I[v];if(typeof P>"u")P="undefined";else if(P instanceof Error){const E=P;E.stack?P=E.stack:P=E.toString()}k.push(P)}if(L){const v=new Error().stack;v&&k.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,a.safeStringify)(k);return v.length>A?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],De([1,0,2,5,7,4,18,13,15,8,10,27]),function(te,e,a,R,T,u,C,A,y,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Mi{constructor(E,h){this.h=h,this.f=new Map,this.g=E.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,h){const d=Mi.c++;this.f.set(d,{provider:E,extensionDescription:h}),this.g.$registerDecorationProvider(d,h.identifier.value);const f=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(d,null);return}const b=(0,y.asArray)(p);if(b.length<=Mi.d){this.g.$onDidChange(d,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",h.identifier.value,b.length);const S=b.map(l=>({uri:l,rank:(0,I.count)(l.path,"/")})),g=(0,y.groupBy)(S,(l,r)=>l.rank-r.rank||(0,I.compare)(l.uri.path,r.uri.path)),t=[];e:for(const l of g){let r;for(const o of l){const n=(0,L.dirname)(o.uri.path);if(r!==n&&(r=n,t.push(o.uri)>=Mi.d))break e}}this.g.$onDidChange(d,t)});return new T.Disposable(()=>{f?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(E,h,d){if(!this.f.has(E))return Object.create(null);const f=Object.create(null),{provider:p,extensionDescription:b}=this.f.get(E);return await Promise.all(h.map(async S=>{try{const{uri:g,id:t}=S,l=await Promise.resolve(p.provideFileDecoration(a.URI.revive(g),d));if(!l)return;try{T.FileDecoration.validate(l),l.badge&&typeof l.badge!="string"&&(0,k.checkProposedApiEnabled)(b,"codiconDecoration"),f[t]=[l.propagate,l.tooltip,l.badge,l.color]}catch(r){this.h.warn(`INVALID decoration from extension '${b}': ${r}`)}}catch(g){this.h.error(g)}})),f}};v.c=0,v.d=250,v=qe([We(0,C.IExtHostRpcService),We(1,A.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,u.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)};define(ye[253],De([1,0,176,124,2,5,7,14,3,13,28,48]),function(te,e,a,R,T,u,C,A,y,I,L,k){"use strict";var v,P,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(p,b,S,g,t,l,r){this.d=p,this.e=b,this.f=S,this.g=g,v.set(this,void 0),P.set(this,void 0),E.set(this,void 0),this.c=!1,Je(this,E,new L.ResourceMap(o=>t.getComparisonKey(o)),"f"),Je(this,v,l,"f"),Je(this,P,r,"f")}dispose(){this.c||(Be(this,P,"f").fire([...Be(this,E,"f").keys()]),Be(this,v,"f")?.$clear(this.e),Be(this,E,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,b){if(!p){this.clear();return}this.h();let S=[];if(T.URI.isUri(p)){if(!b){this.delete(p);return}Be(this,E,"f").set(p,b.slice()),S=[p]}else if(Array.isArray(p)){S=[];let t;p=[...p].sort(h.j);for(const l of p){const[r,o]=l;if((!t||r.toString()!==t.toString())&&(t&&Be(this,E,"f").get(t).length===0&&Be(this,E,"f").delete(t),t=r,S.push(r),Be(this,E,"f").set(r,[])),o)Be(this,E,"f").get(r)?.push(...o);else{const n=Be(this,E,"f").get(r);n&&(n.length=0)}}}if(Be(this,P,"f").fire(S),!Be(this,v,"f"))return;const g=[];for(const t of S){let l=[];const r=Be(this,E,"f").get(t);if(r)if(r.length>this.f){l=[];const o=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const m of r)if(m.severity===o[n]&&l.push({...A.Diagnostic.from(m),modelVersionId:this.g(t)})===this.f)break e;l.push({severity:R.MarkerSeverity.Info,message:(0,a.localize)(0,null,r.length-this.f),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=r.map(o=>({...A.Diagnostic.from(o),modelVersionId:this.g(t)}));g.push([t,l])}Be(this,v,"f").$changeMany(this.e,g)}delete(p){this.h(),Be(this,P,"f").fire([p]),Be(this,E,"f").delete(p),Be(this,v,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Be(this,P,"f").fire([...Be(this,E,"f").keys()]),Be(this,E,"f").clear(),Be(this,v,"f")?.$clear(this.e)}forEach(p,b){this.h();for(const[S,g]of this)p.call(b,S,g,this)}*[(v=new WeakMap,P=new WeakMap,E=new WeakMap,Symbol.iterator)](){this.h();for(const p of Be(this,E,"f").keys())yield[p,this.get(p)]}get(p){this.h();const b=Be(this,E,"f").get(p);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(p){return this.h(),Array.isArray(Be(this,E,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,b){return p[0].toString()<b[0].toString()?-1:p[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=h;let d=class pi{static _mapper(p){const b=new L.ResourceMap;for(const S of p)b.set(S,S);return{uris:Object.freeze(Array.from(b.values()))}}constructor(p,b,S,g){this.h=b,this.j=S,this.k=g,this.f=new Map,this.g=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,pi._mapper),this.e=p.getProxy(u.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,b){const{f:S,e:g,g:t,h:l,j:r,k:o}=this,n=new class{$changeMany(i,c){g.$changeMany(i,c),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,i,c.length===0?"CLEARING":c)}$clear(i){g.$clear(i),l.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,i)}dispose(){g.dispose()}};let m;if(!b)b="_generated_diagnostic_collection_name_#"+pi.c++,m=b;else if(!S.has(b))m=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do m=b+pi.c++;while(S.has(m))}return new class extends h{constructor(){super(b,m,pi.d,i=>o.getDocument(i)?.version,r.extUri,n,t),S.set(m,this)}dispose(){super.dispose(),S.delete(m)}}}getDiagnostics(p){if(p)return this.l(p);{const b=new Map,S=[];for(const g of this.f.values())g.forEach((t,l)=>{let r=b.get(t.toString());typeof r>"u"&&(r=S.length,b.set(t.toString(),r),S.push([t,[]])),S[r][1]=S[r][1].concat(...l)});return S}}l(p){let b=[];for(const S of this.f.values())S.has(p)&&(b=b.concat(S.get(p)));return b}$acceptMarkersChange(p){if(!this.m){const b="_generated_mirror",S=new h(b,b,pi.d,g=>{},this.j.extUri,void 0,this.g);this.f.set(b,S),this.m=S}for(const[b,S]of p)this.m.set(T.URI.revive(b),S.map(A.Diagnostic.to))}};d.c=0,d.d=1e3,d=qe([We(1,I.ILogService),We(2,k.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[254],De([1,0,2,5]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(C){this.a=C.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(A=>A?A.map(y=>a.URI.revive(y)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(A=>A?a.URI.revive(A):void 0)}}e.ExtHostDialogs=T}),define(ye[255],De([1,0,11,2,7,5,16,21,8]),function(te,e,a,R,T,u,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(k,v,P){this.d=v,this.e=P,this.b=new Map,this.c=k.getProxy(u.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,v){if(Object.keys(C.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const P=I.a++;this.b.set(P,v),this.c.$registerTextContentProvider(P,k);let E;return typeof v.onDidChange=="function"&&(E=v.onDidChange(h=>{if(h.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this.d.getDocument(h)&&this.$provideTextDocumentContent(P,h).then(d=>{if(!d&&typeof d!="string")return;const f=this.d.getDocument(h);if(!f)return;const p=(0,y.splitLines)(d);if(!f.equalLines(p))return this.c.$onVirtualDocumentChange(h,d)},a.onUnexpectedError)})),new T.Disposable(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(k,v){const P=this.b.get(k);return P?Promise.resolve(P.provideTextDocumentContent(R.URI.revive(v),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=I,I.a=0}),define(ye[256],De([1,0,3,6,2,5,135,14,9,23,7]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(P,E){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.DisposableStore,this.h=new Map,this.f=P.getProxy(u.MainContext.MainThreadDocuments),this.g=E,this.g.onDidRemoveDocuments(h=>{for(const d of h)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const d of h)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const E=this.g.getDocument(P);if(E)return E}getDocument(P){const E=this.getDocumentData(P);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return E.document}ensureDocumentData(P){const E=this.g.getDocument(P);if(E)return Promise.resolve(E);let h=this.h.get(P.toString());return h||(h=this.f.$tryOpenDocument(P).then(d=>{this.h.delete(P.toString());const f=T.URI.revive(d);return(0,y.assertIsDefined)(this.g.getDocument(f))},d=>(this.h.delete(P.toString()),Promise.reject(d))),this.h.set(P.toString(),h)),h}createDocumentData(P){return this.f.$tryCreateDocument(P).then(E=>T.URI.revive(E))}$acceptModelLanguageChanged(P,E){const h=T.URI.revive(P),d=this.g.getDocument(h);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(E),this.a.fire(d.document)}$acceptModelSaved(P){const E=T.URI.revive(P),h=this.g.getDocument(E);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(P,E){const h=T.URI.revive(P),d=this.g.getDocument(h);if(!d)throw new Error("unknown document");d._acceptIsDirty(E),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,E,h){const d=T.URI.revive(P),f=this.g.getDocument(d);if(!f)throw new Error("unknown document");f._acceptIsDirty(h),f.onEvents(E);let p;E.isUndoing?p=L.TextDocumentChangeReason.Undo:E.isRedoing&&(p=L.TextDocumentChangeReason.Redo),this.c.fire((0,I.deepFreeze)({document:f.document,contentChanges:E.changes.map(b=>({range:A.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:p}))}setWordDefinitionFor(P,E){(0,C.setWordDefinitionFor)(P,E)}}e.ExtHostDocuments=k}),define(ye[59],De([1,0,50,3,6,2,4,5,135,18,138,14,13,28,16,64,65]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(S){this.value=S,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(S,g){this.h=S,this.i=g,this.a=null,this.b=new Map,this.c=new P.ResourceMap,this.d=new R.Emitter,this.e=new R.Emitter,this.f=new R.Emitter,this.g=new R.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(S){this.acceptDocumentsAndEditorsDelta(S)}acceptDocumentsAndEditorsDelta(S){const g=[],t=[],l=[];if(S.removedDocuments)for(const r of S.removedDocuments){const o=u.URI.revive(r),n=this.c.get(o);n?.unref()&&(this.c.delete(o),g.push(n.value))}if(S.addedDocuments)for(const r of S.addedDocuments){const o=u.URI.revive(r.uri);let n=this.c.get(o);if(n&&o.scheme!==E.Schemas.vscodeNotebookCell&&o.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);n||(n=new f(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),o,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(o,n),t.push(n.value)),n.ref()}if(S.removedEditors)for(const r of S.removedEditors){const o=this.b.get(r);this.b.delete(r),o&&l.push(o)}if(S.addedEditors)for(const r of S.addedEditors){const o=u.URI.revive(r.documentUri);a.ok(this.c.has(o),`document '${o}' does not exist`),a.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const n=this.c.get(o).value,m=new L.ExtHostTextEditor(r.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new d.Lazy(()=>n.document),r.selections.map(k.Selection.to),r.options,r.visibleRanges.map(s=>k.Range.to(s)),typeof r.editorPosition=="number"?k.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,m)}S.newActiveEditor!==void 0&&(a.ok(S.newActiveEditor===null||this.b.has(S.newActiveEditor),`active editor '${S.newActiveEditor}' does not exist`),this.a=S.newActiveEditor),(0,T.dispose)(g),(0,T.dispose)(l),S.removedDocuments&&this.e.fire(g),S.addedDocuments&&this.d.fire(t),(S.removedEditors||S.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),S.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(S){return this.c.get(S)?.value}allDocuments(){return h.Iterable.map(this.c.values(),S=>S.value)}getEditor(S){return this.b.get(S)}activeEditor(S){if(!this.a)return;const g=this.b.get(this.a);return S?g:g?.value}allEditors(){return[...this.b.values()]}};p=qe([We(0,I.IExtHostRpcService),We(1,v.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[60],De([1,0,14,5,2,3,4,7,18,9,61]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class k{constructor(d,f,p){this.e=p,this.d=f,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,f={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(f)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(T.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(T.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(d,f){this.c=[],this.d="",this.b=d,this.e=f;for(const p of d.tabs)p.isActive&&(this.d=p.id),this.c.push(new k(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,f={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return a.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(p=>p.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(p=>p.apiObject))}};this.a=Object.freeze(f)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const p=new k(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,p),d.tabDto.isActive&&(this.d=p.tabId),p}else if(d.kind===1){const p=this.c.splice(d.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(d.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,p),p}const f=this.c.find(p=>p.tabId===d.tabDto.id);if(!f)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),f.acceptDtoUpdate(d.tabDto),f}activeTabId(){return this.d}}let P=class{constructor(d){this.b=new u.Emitter,this.c=new u.Emitter,this.e=[],this.a=d.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,f={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(p=>p.apiObject))},get activeTabGroup(){const p=d.d;return(0,I.assertIsDefined)(d.e.find(S=>S.groupId===p)?.apiObject)},close:async(p,b)=>{const S=Array.isArray(p)?p:[p];return S.length?E(S[0])?this.j(S,b):this.i(S,b):!0}};this.f=Object.freeze(f)}return this.f}$acceptEditorTabModel(d){const f=new Set(this.e.map(r=>r.groupId)),p=new Set(d.map(r=>r.groupId)),b=(0,L.diffSets)(f,p),S=this.e.filter(r=>b.removed.includes(r.groupId)).map(r=>r.apiObject),g=[],t=[];this.e=d.map(r=>{const o=new v(r,()=>this.d);return b.added.includes(o.groupId)?g.push(o.apiObject):t.push(o.apiObject),o});const l=(0,I.assertIsDefined)(d.find(r=>r.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:g,closed:S,changed:t}))}$acceptTabGroupUpdate(d){const f=this.e.find(p=>p.groupId===d.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const f=this.e.find(b=>b.groupId===d.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const p=f.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(d){for(const f of this.e)for(const p of f.tabs)if(p.apiObject===d)return p}h(d){return this.e.find(f=>f.apiObject===d)}async i(d,f){const p=[];for(const b of d){const S=this.g(b);if(!S)throw new Error("Tab close: Invalid tab not found!");p.push(S.tabId)}return this.a.$closeTab(p,f)}async j(d,f){const p=[];for(const b of d){const S=this.h(b);if(!S)throw new Error("Group close: Invalid group not found!");p.push(S.groupId)}return this.a.$closeGroup(p,f)}};P=qe([We(0,y.IExtHostRpcService)],P),e.ExtHostEditorTabs=P;function E(h){return h.tabs!==void 0}}),define(ye[257],De([1,0,2,5,6,7,14,153,8,22,27]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this.a=[]}add(E){this.b=void 0,this.a.push(E)}delete(E){const h=this.a.indexOf(E);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const E=this.a.sort(),h=[];let d,f,p=14,b=14;for(const S of E){let g=d?(0,y.commonPrefixLength)(d,S):0;for(g===0?f=1:f=b;g<S.length;g++)g+1===S.length?(p=b,b=9):b+=1,h.push([f,S.toUpperCase().charCodeAt(g),b]),h.push([f,S.toLowerCase().charCodeAt(g),b]),f=b;d=S,b=p}h.push([9,58,10]),h.push([10,47,12]),this.b=new A.StateMachine(h)}}provideDocumentLinks(E){this.c();const h=[],d=A.LinkComputer.computeLinks({getLineContent(f){return E.lineAt(f-1).text},getLineCount(){return E.lineCount}},this.b);for(const f of d){const p=C.DocumentLink.to(f);p.target&&h.push(p)}return h}}class v{constructor(E,h){this.i=h,this.b=new k,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=E.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(E,h,d,f={}){if(this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(E,"*",this.b));const p=this.h++;this.b.add(h),this.d.add(h),this.c.set(p,d);let b=2;f.isCaseSensitive&&(b+=1024),f.isReadonly&&(b+=2048),typeof d.copy=="function"&&(b+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,L.checkProposedApiEnabled)(E,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(p,h,b).catch(g=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${h}`),console.error(g)});const S=d.onDidChangeFile(g=>{const t=[];for(const l of g){const{uri:r,type:o}=l;if(r.scheme!==h)continue;let n;switch(o){case u.FileChangeType.Changed:n=0;break;case u.FileChangeType.Created:n=1;break;case u.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:n})}this.a.$onFileSystemChange(p,t)});return(0,T.toDisposable)(()=>{S.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(E){const{type:h,ctime:d,mtime:f,size:p,permissions:b}=E;return{type:h,ctime:d,mtime:f,size:p,permissions:b}}$stat(E,h){return Promise.resolve(this.k(E).stat(a.URI.revive(h))).then(d=>v.j(d))}$readdir(E,h){return Promise.resolve(this.k(E).readDirectory(a.URI.revive(h)))}$readFile(E,h){return Promise.resolve(this.k(E).readFile(a.URI.revive(h))).then(d=>I.VSBuffer.wrap(d))}$writeFile(E,h,d,f){return Promise.resolve(this.k(E).writeFile(a.URI.revive(h),d.buffer,f))}$delete(E,h,d){return Promise.resolve(this.k(E).delete(a.URI.revive(h),d))}$rename(E,h,d,f){return Promise.resolve(this.k(E).rename(a.URI.revive(h),a.URI.revive(d),f))}$copy(E,h,d,f){const p=this.k(E);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(a.URI.revive(h),a.URI.revive(d),f))}$mkdir(E,h){return Promise.resolve(this.k(E).createDirectory(a.URI.revive(h)))}$watch(E,h,d,f){const p=this.k(E).watch(a.URI.revive(d),f);this.f.set(h,p)}$unwatch(E,h){const d=this.f.get(h);d&&(d.dispose(),this.f.delete(h))}$open(E,h,d){const f=this.k(E);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(a.URI.revive(h),d))}$close(E,h){const d=this.k(E);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(h))}$read(E,h,d,f){const p=this.k(E);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const b=I.VSBuffer.alloc(f);return Promise.resolve(p.read(h,d,b.buffer,0,f)).then(S=>b.slice(0,S))}$write(E,h,d,f){const p=this.k(E);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(h,d,f.buffer,0,f.byteLength))}k(E){const h=this.c.get(E);if(!h){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return h}}e.ExtHostFileSystem=v}),define(ye[77],De([1,0,5,44,7,22,4,18,48,6]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Yt{constructor(v,P){this.b=new Map,this.a=v.getProxy(a.MainContext.MainThreadFileSystem);const E=this;this.value=Object.freeze({async stat(h){try{const d=E.b.get(h.scheme);if(!d)return await E.a.$stat(h);await E.a.$ensureActivation(h.scheme);const f=await d.stat(h);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(d){Yt.c(d)}},async readDirectory(h){try{const d=E.b.get(h.scheme);return d?(await E.a.$ensureActivation(h.scheme),(await d.readDirectory(h)).slice()):await E.a.$readdir(h)}catch(d){return Yt.c(d)}},async createDirectory(h){try{return await E.a.$mkdir(h)}catch(d){return Yt.c(d)}},async readFile(h){try{const d=E.b.get(h.scheme);return d?(await E.a.$ensureActivation(h.scheme),(await d.readFile(h)).slice()):(await E.a.$readFile(h)).buffer}catch(d){return Yt.c(d)}},async writeFile(h,d){try{return await E.a.$writeFile(h,u.VSBuffer.wrap(d))}catch(f){return Yt.c(f)}},async delete(h,d){try{const f=E.b.get(h.scheme);return f?(await E.a.$ensureActivation(h.scheme),await f.delete(h,{recursive:!1,...d})):await E.a.$delete(h,{recursive:!1,useTrash:!1,...d})}catch(f){return Yt.c(f)}},async rename(h,d,f){try{return await E.a.$rename(h,d,{overwrite:!1,...f})}catch(p){return Yt.c(p)}},async copy(h,d,f){try{return await E.a.$copy(h,d,{overwrite:!1,...f})}catch(p){return Yt.c(p)}},isWritableFileSystem(h){const d=P.getCapabilities(h);if(typeof d=="number")return!(d&2048)}})}static c(v){if(v instanceof T.FileSystemError)throw v;if(!(v instanceof Error))throw new T.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw T.FileSystemError.Unavailable(v.message);switch(v.name){case R.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(v.message);case R.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(v.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(v.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(v.message);case R.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(v.message);case R.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(v.message);default:throw new T.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,P){return this.b.set(v,P),(0,I.toDisposable)(()=>this.b.delete(v))}};L=qe([We(0,A.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[258],De([1,0,3,38,2,5,14,7]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(k,v,P,E,h,d,f,p){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const b=this.h(k,P,h);this.g=0,d&&(this.g+=1),f&&(this.g+=2),p&&(this.g+=4);const S=(0,R.parse)(h),g=typeof h=="string",t=E(l=>{if(!d)for(const r of l.created){const o=T.URI.revive(r);S(o.fsPath)&&(!g||v.getWorkspaceFolder(o))&&this.a.fire(o)}if(!f)for(const r of l.changed){const o=T.URI.revive(r);S(o.fsPath)&&(!g||v.getWorkspaceFolder(o))&&this.b.fire(o)}if(!p)for(const r of l.deleted){const o=T.URI.revive(r);S(o.fsPath)&&(!g||v.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=A.Disposable.from(b,this.a,this.b,this.c,t)}h(k,v,P){const E=A.Disposable.from();if(typeof P=="string")return E;const h=k.getProxy(u.MainContext.MainThreadFileSystem);let d=!1;(P.pattern.includes(R.GLOBSTAR)||P.pattern.includes(R.GLOB_SPLIT))&&(d=!0);const f=Math.random();return h.$watch(v.identifier.value,f,P.baseUri,{recursive:d,excludes:[]}),A.Disposable.from({dispose:()=>h.$unwatch(f)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class I{constructor(k,v,P){this.j=k,this.k=v,this.l=P,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,v,P,E,h,d){return new y(this.j,k,v,this.a.event,C.GlobPattern.from(P),E,h,d)}$onFileEvent(k){this.a.fire(k)}$onDidRunFileOperation(k,v){switch(k){case 2:this.b.fire(Object.freeze({files:v.map(P=>({oldUri:T.URI.revive(P.source),newUri:T.URI.revive(P.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(P=>T.URI.revive(P.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(P=>T.URI.revive(P.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,v){return(P,E,h)=>{const d=function(p){P.call(E,p)};return d.extension=k,v.event(d,void 0,h)}}async $onWillRunFileOperation(k,v,P,E){switch(k){case 2:return await this.n(this.g,{files:v.map(h=>({oldUri:T.URI.revive(h.source),newUri:T.URI.revive(h.target)}))},P,E);case 1:return await this.n(this.i,{files:v.map(h=>T.URI.revive(h.target))},P,E);case 0:case 3:return await this.n(this.h,{files:v.map(h=>T.URI.revive(h.target))},P,E)}}async n(k,v,P,E){const h=new Set,d=[];if(await k.fireAsync(v,E,async(p,b)=>{const S=Date.now(),g=await Promise.resolve(p);g instanceof A.WorkspaceEdit&&(d.push([b.extension,g]),h.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-S>P&&this.k.warn("SLOW file-participant",b.extension.identifier)}),E.isCancellationRequested||d.length===0)return;const f={edits:[]};for(const[,p]of d){const{edits:b}=C.WorkspaceEdit.from(p,{getTextDocumentVersion:S=>this.l.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(b)}return{edit:f,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=I}),define(ye[259],De([1,0,2,40]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class T{constructor(C,A,y,I,L){this.a=A,this.b=y,this.c=I;const k=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new R.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new R.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new R.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new R.ApiCommandResult("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const P=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri),notebookEditor:P.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(C,A,y,I){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=T}),define(ye[260],De([1,0,6,5]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(C){this.b=0,this.a=C.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,C),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=T}),define(ye[261],De([1,0,2,23,14,7,71,5,8,35,15,9,149,21,6,120,101,74,43,11,17,27]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(N,H){this.d=N,this.e=H}async provideDocumentSymbols(N,H){const Q=this.d.getDocument(N),Y=await this.e.provideDocumentSymbols(Q,H);if(!(0,L.isFalsyOrEmpty)(Y))return Y[0]instanceof u.DocumentSymbol?Y.map(T.DocumentSymbol.from):t.f(Y)}static f(N){N=N.slice(0).sort((Y,he)=>{let ve=Y.location.range.start.compareTo(he.location.range.start);return ve===0&&(ve=he.location.range.end.compareTo(Y.location.range.end)),ve});const H=[],Q=[];for(const Y of N){const he={name:Y.name||"!!MISSING: name!!",kind:T.SymbolKind.from(Y.kind),tags:Y.tags?.map(T.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:T.Range.from(Y.location.range),selectionRange:T.Range.from(Y.location.range),children:[]};for(;;){if(Q.length===0){Q.push(he),H.push(he);break}const ve=Q[Q.length-1];if(I.Range.containsRange(ve.range,he.range)&&!I.Range.equalsRange(ve.range,he.range)){ve.children?.push(he),Q.push(he);break}Q.pop()}}return H}}class l{constructor(N,H,Q){this.g=N,this.h=H,this.j=Q,this.e=new f.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,H){const Q=this.g.getDocument(N),Y=await this.j.provideCodeLenses(Q,H);if(!Y||H.isCancellationRequested)return;const he=this.e.add(Y),ve=new E.DisposableStore;this.f.set(he,ve);const Ae={cacheId:he,lenses:[]};for(let pe=0;pe<Y.length;pe++)Ae.lenses.push({cacheId:[he,pe],range:T.Range.from(Y[pe].range),command:this.h.toInternal(Y[pe].command,ve)});return Ae}async resolveCodeLens(N,H){const Q=N.cacheId&&this.e.get(...N.cacheId);if(!Q)return;let Y;if(typeof this.j.resolveCodeLens!="function"||Q.isResolved?Y=Q:Y=await this.j.resolveCodeLens(Q,H),Y||(Y=Q),H.isCancellationRequested)return;const he=N.cacheId&&this.f.get(N.cacheId[0]);if(!!he)return N.command=this.h.toInternal(Y.command??l.d,he),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}l.d={command:"missing",title:"!!MISSING: command!!"};function r(ne){return Array.isArray(ne)?ne.map(T.DefinitionLink.from):ne?[T.DefinitionLink.from(ne)]:[]}class o{constructor(N,H){this.d=N,this.e=H}async provideDefinition(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),ve=await this.e.provideDefinition(Y,he,Q);return r(ve)}}class n{constructor(N,H){this.d=N,this.e=H}async provideDeclaration(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),ve=await this.e.provideDeclaration(Y,he,Q);return r(ve)}}class m{constructor(N,H){this.d=N,this.e=H}async provideImplementation(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),ve=await this.e.provideImplementation(Y,he,Q);return r(ve)}}class s{constructor(N,H){this.d=N,this.e=H}async provideTypeDefinition(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),ve=await this.e.provideTypeDefinition(Y,he,Q);return r(ve)}}class i{constructor(N,H){this.d=N,this.e=H}async provideHover(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),ve=await this.e.provideHover(Y,he,Q);if(!(!ve||(0,L.isFalsyOrEmpty)(ve.contents)))return ve.range||(ve.range=Y.getWordRangeAtPosition(he)),ve.range||(ve.range=new u.Range(he,he)),T.Hover.from(ve)}}class c{constructor(N,H){this.d=N,this.e=H}async provideEvaluatableExpression(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),ve=await this.e.provideEvaluatableExpression(Y,he,Q);if(ve)return T.EvaluatableExpression.from(ve)}}class w{constructor(N,H){this.d=N,this.e=H}async provideInlineValues(N,H,Q,Y){const he=this.d.getDocument(N),ve=await this.e.provideInlineValues(he,T.Range.to(H),T.InlineValueContext.to(Q),Y);if(Array.isArray(ve))return ve.map(Ae=>T.InlineValue.from(Ae))}}class D{constructor(N,H){this.d=N,this.e=H}async provideDocumentHighlights(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),ve=await this.e.provideDocumentHighlights(Y,he,Q);if(Array.isArray(ve))return ve.map(T.DocumentHighlight.from)}}class F{constructor(N,H){this.d=N,this.e=H}async provideLinkedEditingRanges(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),ve=await this.e.provideLinkedEditingRanges(Y,he,Q);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,L.coalesce)(ve.ranges.map(T.Range.from)),wordPattern:ve.wordPattern}}}class x{constructor(N,H){this.d=N,this.e=H}async provideReferences(N,H,Q,Y){const he=this.d.getDocument(N),ve=T.Position.to(H),Ae=await this.e.provideReferences(he,ve,Q,Y);if(Array.isArray(Ae))return Ae.map(T.location.from)}}class q{constructor(N,H,Q,Y,he,ve,Ae){this.g=N,this.h=H,this.j=Q,this.k=Y,this.l=he,this.m=ve,this.n=Ae,this.e=new f.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,H,Q,Y){const he=this.g.getDocument(N),ve=v.Selection.isISelection(H)?T.Selection.to(H):T.Range.to(H),Ae=[];for(const et of this.j.getDiagnostics(N))if(ve.intersection(et.range)&&Ae.push(et)>q.d)break;const pe={diagnostics:Ae,only:Q.only?new u.CodeActionKind(Q.only):void 0,triggerKind:T.CodeActionTriggerKind.to(Q.trigger)},Ce=await this.k.provideCodeActions(he,ve,pe,Y);if(!(0,L.isNonEmptyArray)(Ce)||Y.isCancellationRequested)return;const ke=this.e.add(Ce),Ve=new E.DisposableStore;this.f.set(ke,Ve);const xe=[];for(let et=0;et<Ce.length;et++){const Qe=Ce[et];!Qe||(q.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,Ve)})):(pe.only&&(Qe.kind?pe.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[ke,et],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,Ve),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(T.Diagnostic.from),edit:Qe.edit&&T.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:ke,actions:xe}}async resolveCodeAction(N,H){const[Q,Y]=N,he=this.e.get(Q,Y);if(!he||q.o(he)||!this.k.resolveCodeAction)return;const ve=await this.k.resolveCodeAction(he,H)??he;return ve?.edit?T.WorkspaceEdit.from(ve.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}q.d=1e3;class M{constructor(N,H,Q,Y){this.d=N,this.e=H,this.f=Q,this.g=Y}async prepareDocumentPaste(N,H,Q,Y){if(!this.f.prepareDocumentPaste)return;const he=this.e.getDocument(N),ve=H.map(pe=>T.Range.to(pe)),Ae=T.DataTransfer.toDataTransfer(Q,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(he,ve,Ae,Y),T.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(N,H,Q,Y,he){const ve=this.e.getDocument(H),Ae=Q.map(ke=>T.Range.to(ke)),pe=T.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolvePasteFileData(this.g,N,ke)).buffer),Ce=await this.f.provideDocumentPasteEdits(ve,Ae,pe,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?T.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class B{constructor(N,H){this.d=N,this.e=H}async provideDocumentFormattingEdits(N,H,Q){const Y=this.d.getDocument(N),he=await this.e.provideDocumentFormattingEdits(Y,H,Q);if(Array.isArray(he))return he.map(T.TextEdit.from)}}class O{constructor(N,H){this.d=N,this.e=H}async provideDocumentRangeFormattingEdits(N,H,Q,Y){const he=this.d.getDocument(N),ve=T.Range.to(H),Ae=await this.e.provideDocumentRangeFormattingEdits(he,ve,Q,Y);if(Array.isArray(Ae))return Ae.map(T.TextEdit.from)}}class U{constructor(N,H){this.d=N,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,H,Q,Y,he){const ve=this.d.getDocument(N),Ae=T.Position.to(H),pe=await this.e.provideOnTypeFormattingEdits(ve,Ae,Q,Y,he);if(Array.isArray(pe))return pe.map(T.TextEdit.from)}}class z{constructor(N,H){this.e=N,this.f=H,this.d=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,H){const Q=await this.e.provideWorkspaceSymbols(N,H);if(!(0,L.isNonEmptyArray)(Q))return{symbols:[]};const Y=this.d.add(Q),he={cacheId:Y,symbols:[]};for(let ve=0;ve<Q.length;ve++){const Ae=Q[ve];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}he.symbols.push({...T.WorkspaceSymbol.from(Ae),cacheId:[Y,ve]})}return he}async resolveWorkspaceSymbol(N,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const Q=this.d.get(...N.cacheId);if(Q){const Y=await this.e.resolveWorkspaceSymbol(Q,H);return Y&&(0,R.mixin)(N,T.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class j{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,H,Q){this.d=N,this.e=H,this.f=Q}async provideRenameEdits(N,H,Q,Y){const he=this.d.getDocument(N),ve=T.Position.to(H);try{const Ae=await this.e.provideRenameEdits(he,ve,Q,Y);return Ae?T.WorkspaceEdit.from(Ae):void 0}catch(Ae){const pe=j.g(Ae);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(N,H,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(N),he=T.Position.to(H);try{const ve=await this.e.prepareRename(Y,he,Q);let Ae,pe;if(u.Range.isRange(ve)?(Ae=ve,pe=Y.getText(ve)):(0,k.isObject)(ve)&&(Ae=ve.range,pe=ve.placeholder),!Ae||!pe)return;if(Ae.start.line>he.line||Ae.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Ae),text:pe}}catch(ve){const Ae=j.g(ve);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(ve)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class le{constructor(N,H){this.resultId=N,this.tokens=H}}class V{constructor(N,H){this.f=N,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,H,Q){const Y=this.f.getDocument(N),he=H!==0?this.d.get(H):null;let ve=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,he.resultId,Q):await this.g.provideDocumentSemanticTokens(Y,Q);return he&&this.d.delete(H),ve?(ve=V.h(ve),this.o(V.n(he,ve),ve)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return V.j(N)?V.k(N)?N:new u.SemanticTokens(new Uint32Array(N.data),N.resultId):V.l(N)?V.m(N)?N:new u.SemanticTokensEdits(N.edits.map(H=>new u.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const H of N.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(N,H){if(!V.j(H)||!N||!N.tokens)return H;const Q=N.tokens,Y=Q.length,he=H.data,ve=he.length;let Ae=0;const pe=Math.min(Y,ve);for(;Ae<pe&&Q[Ae]===he[Ae];)Ae++;if(Ae===Y&&Ae===ve)return new u.SemanticTokensEdits([],H.resultId);let Ce=0;const ke=pe-Ae;for(;Ce<ke&&Q[Y-Ce-1]===he[ve-Ce-1];)Ce++;return new u.SemanticTokensEdits([{start:Ae,deleteCount:Y-Ae-Ce,data:he.subarray(Ae,ve-Ce)}],H.resultId)}o(N,H){if(V.j(N)){const Q=this.e++;return this.d.set(Q,new le(N.resultId,N.data)),(0,h.encodeSemanticTokensDto)({id:Q,type:"full",data:N.data})}if(V.l(N)){const Q=this.e++;return V.j(H)?this.d.set(Q,new le(H.resultId,H.data)):this.d.set(Q,new le(N.resultId)),(0,h.encodeSemanticTokensDto)({id:Q,type:"delta",deltas:(N.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class _{constructor(N,H){this.d=N,this.e=H}async provideDocumentRangeSemanticTokens(N,H,Q){const Y=this.d.getDocument(N),he=await this.e.provideDocumentRangeSemanticTokens(Y,T.Range.to(H),Q);return he?this.f(he):null}f(N){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class J{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,H,Q,Y,he){this.f=N,this.g=H,this.h=Q,this.j=Y,this.k=he,this.d=new f.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,H,Q,Y){const he=this.f.getDocument(N),ve=T.Position.to(H),Ae=he.getWordRangeAtPosition(ve)||new u.Range(ve,ve),pe=Ae.with({end:ve}),Ce=new p.StopWatch(!0),ke=await this.h.provideCompletionItems(he,ve,Y,T.CompletionContext.to(Q));if(!ke||Y.isCancellationRequested)return;const Ve=Array.isArray(ke)?new u.CompletionList(ke):ke,xe=J.supportsResolving(this.h)?this.d.add(Ve.items):this.d.add([]),et=new E.DisposableStore;this.e.set(xe,et);const Qe=[],nt={x:xe,b:Qe,a:{replace:T.Range.from(Ae),insert:T.Range.from(pe)},c:Ve.isIncomplete||void 0,d:Ce.elapsed()};for(let st=0;st<Ve.items.length;st++){const ht=Ve.items[st],Ue=this.l(ht,[xe,st],pe,Ae);Qe.push(Ue)}return nt}async resolveCompletionItem(N,H){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...N);if(!Q)return;const Y=await this.h.resolveCompletionItem(Q,H);if(!!Y)return this.l(Y,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,H,Q,Y){const he=this.e.get(H[0]);if(!he)throw Error("DisposableStore is missing...");const ve=this.g.toInternal(N.command,he),Ae={x:H,a:N.label,b:N.kind!==void 0?T.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(T.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:T.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(T.TextEdit.from),n:ve?.$ident,o:ve?.id,p:ve?.$ident?void 0:ve?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=N.textEdit.newText):typeof N.insertText=="string"?Ae.h=N.insertText:N.insertText instanceof u.SnippetString&&(Ae.h=N.insertText.value,Ae.i|=4);let pe;return N.textEdit?pe=N.textEdit.range:N.range&&(pe=N.range),u.Range.isRange(pe)?Ae.j=T.Range.from(pe):pe&&(!Q?.isEqual(pe.inserting)||!Y?.isEqual(pe.replacing))&&(Ae.j={insert:T.Range.from(pe.inserting),replace:T.Range.from(pe.replacing)}),Ae}}class ie{async provideInlineCompletions(N,H,Q,Y){}disposeCompletions(N){}handleDidShowCompletionItem(N,H){}}class ee extends ie{constructor(N,H,Q,Y){super(),this.f=N,this.g=H,this.h=Q,this.j=Y,this.d=new K,this.e=(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:u.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:u.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(N,H,Q,Y){const he=this.g.getDocument(N),ve=T.Position.to(H),Ae=await this.h.provideInlineCompletionItems(he,ve,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:T.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},Y);if(!Ae||Y.isCancellationRequested)return;const pe=Array.isArray(Ae)?Ae:Ae.items,Ce=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((xe,et)=>{let Qe;xe.command&&(ke||(ke=new E.DisposableStore),Qe=this.j.toInternal(xe.command,ke));const nt=xe.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:xe.filterText,range:xe.range?T.Range.from(xe.range):void 0,command:Qe,idx:et,completeBracketPairs:this.e?xe.completeBracketPairs:!1}}),commands:Ce.map(xe=>(ke||(ke=new E.DisposableStore),this.j.toInternal(xe,ke)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,H){const Q=this.d.get(N)?.items[H];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q)}}class K{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const H=this.e++;return this.d.set(H,N),H}disposeReferenceId(N){const H=this.d.get(N);return this.d.delete(N),H}get(N){return this.d.get(N)}}class G{constructor(N,H){this.e=N,this.f=H,this.d=new f.Cache("SignatureHelp")}async provideSignatureHelp(N,H,Q,Y){const he=this.e.getDocument(N),ve=T.Position.to(H),Ae=this.g(Q),pe=await this.f.provideSignatureHelp(he,ve,Y,Ae);if(pe){const Ce=this.d.add([pe]);return{...T.SignatureHelp.from(pe),id:Ce}}}g(N){let H;if(N.activeSignatureHelp){const Q=T.SignatureHelp.to(N.activeSignatureHelp),Y=this.d.get(N.activeSignatureHelp.id,0);Y?(H=Y,H.activeSignature=Q.activeSignature,H.activeParameter=Q.activeParameter):H=Q}return{...N,activeSignatureHelp:H}}releaseSignatureHelp(N){this.d.delete(N)}}class de{constructor(N,H,Q,Y,he){this.f=N,this.g=H,this.h=Q,this.j=Y,this.k=he,this.d=new f.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,H,Q){const Y=this.f.getDocument(N),he=T.Range.to(H),ve=await this.h.provideInlayHints(Y,he,Q);if(!Array.isArray(ve)||ve.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(Q.isCancellationRequested)return;const Ae=this.d.add(ve);this.e.set(Ae,new E.DisposableStore);const pe={hints:[],cacheId:Ae};for(let Ce=0;Ce<ve.length;Ce++)this.l(ve[Ce],he)&&pe.hints.push(this.m(ve[Ce],[Ae,Ce]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),pe}async resolveInlayHint(N,H){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...N);if(!Q)return;const Y=await this.h.resolveInlayHint(Q,H);if(!!Y&&!!this.l(Y))return this.m(Y,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,H){return N.label.length===0||Array.isArray(N.label)&&N.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(H&&!H.contains(N.position))}m(N,H){const Q=this.e.get(H[0]);if(!Q)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:H,tooltip:T.MarkdownString.fromStrict(N.tooltip),position:T.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(T.TextEdit.from),kind:N.kind&&T.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?Y.label=N.label:Y.label=N.label.map(he=>{const ve={label:he.value};return ve.tooltip=T.MarkdownString.fromStrict(he.tooltip),u.Location.isLocation(he.location)&&(ve.location=T.location.from(he.location)),he.command&&(ve.command=this.g.toInternal(he.command,Q)),ve}),Y}}class be{constructor(N,H){this.e=N,this.f=H,this.d=new f.Cache("DocumentLink")}async provideLinks(N,H){const Q=this.e.getDocument(N),Y=await this.f.provideDocumentLinks(Q,H);if(!(!Array.isArray(Y)||Y.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(be.g).map(T.DocumentLink.from)};{const he=this.d.add(Y),ve={links:[],cacheId:he};for(let Ae=0;Ae<Y.length;Ae++){if(!be.g(Y[Ae]))continue;const pe=T.DocumentLink.from(Y[Ae]);pe.cacheId=[he,Ae],ve.links.push(pe)}return ve}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,H){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...N);if(!Q)return;const Y=await this.f.resolveDocumentLink(Q,H);if(!(!Y||!be.g(Y)))return T.DocumentLink.from(Y)}releaseLinks(N){this.d.delete(N)}}class Ee{constructor(N,H){this.d=N,this.e=H}async provideColors(N,H){const Q=this.d.getDocument(N),Y=await this.e.provideDocumentColors(Q,H);return Array.isArray(Y)?Y.map(ve=>({color:T.Color.from(ve.color),range:T.Range.from(ve.range)})):[]}async provideColorPresentations(N,H,Q){const Y=this.d.getDocument(N),he=T.Range.to(H.range),ve=T.Color.to(H.color),Ae=await this.e.provideColorPresentations(ve,{document:Y,range:he},Q);if(!!Array.isArray(Ae))return Ae.map(T.ColorPresentation.from)}}class Pe{constructor(N,H){this.d=N,this.e=H}async provideFoldingRanges(N,H,Q){const Y=this.d.getDocument(N),he=await this.e.provideFoldingRanges(Y,H,Q);if(!!Array.isArray(he))return he.map(T.FoldingRange.from)}}class Fe{constructor(N,H,Q){this.d=N,this.e=H,this.f=Q}async provideSelectionRanges(N,H,Q){const Y=this.d.getDocument(N),he=H.map(T.Position.to),ve=await this.e.provideSelectionRanges(Y,he,Q);if(!(0,L.isNonEmptyArray)(ve))return[];if(ve.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let pe=0;pe<he.length;pe++){const Ce=[];Ae.push(Ce);let ke=he[pe],Ve=ve[pe];for(;;){if(!Ve.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(T.SelectionRange.from(Ve)),!Ve.parent)break;ke=Ve.range,Ve=Ve.parent}}return Ae}}class se{constructor(N,H){this.f=N,this.g=H,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(N,H,Q){const Y=this.f.getDocument(N),he=T.Position.to(H),ve=await this.g.prepareCallHierarchy(Y,he,Q);if(!ve)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(ve)?ve.map(pe=>this.h(Ae,pe)):[this.h(Ae,ve)]}async provideCallsTo(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Y,Q);if(!!he)return he.map(ve=>({from:this.h(N,ve.from),fromRanges:ve.fromRanges.map(Ae=>T.Range.from(Ae))}))}async provideCallsFrom(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Y,Q);if(!!he)return he.map(ve=>({to:this.h(N,ve.to),fromRanges:ve.fromRanges.map(Ae=>T.Range.from(Ae))}))}releaseSession(N){this.e.delete(N)}h(N,H){const Q=this.e.get(N),Y=T.CallHierarchyItem.from(H,N,Q.size.toString(36));return Q.set(Y._itemId,H),Y}j(N,H){return this.e.get(N)?.get(H)}}class oe{constructor(N,H){this.f=N,this.g=H,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(N,H,Q){const Y=this.f.getDocument(N),he=T.Position.to(H),ve=await this.g.prepareTypeHierarchy(Y,he,Q);if(!ve)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(ve)?ve.map(pe=>this.h(Ae,pe)):[this.h(Ae,ve)]}async provideSupertypes(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Y,Q);if(!!he)return he.map(ve=>this.h(N,ve))}async provideSubtypes(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Y,Q);if(!!he)return he.map(ve=>this.h(N,ve))}releaseSession(N){this.e.delete(N)}h(N,H){const Q=this.e.get(N),Y=T.TypeHierarchyItem.from(H,N,Q.size.toString(36));return Q.set(Y._itemId,H),Y}j(N,H){return this.e.get(N)?.get(H)}}class fe{constructor(N,H,Q,Y){this.d=N,this.e=H,this.f=Q,this.g=Y}async provideDocumentOnDropEdits(N,H,Q,Y,he){const ve=this.e.getDocument(H),Ae=T.Position.to(Q),pe=T.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,ke)).buffer),Ce=await this.f.provideDocumentDropEdits(ve,Ae,pe,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?T.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class Z{constructor(N,H){this.adapter=N,this.extension=H}}class ce{constructor(N,H,Q,Y,he,ve,Ae,pe){this.g=H,this.h=Q,this.j=Y,this.k=he,this.l=ve,this.m=Ae,this.n=pe,this.f=new Map,this.e=N.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(N){return T.DocumentSelector.from(N,this.g)}p(N){return new u.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return ce.d++}async s(N,H,Q,Y,he,ve=!1){const Ae=this.f.get(N);if(!Ae||!(Ae.adapter instanceof H))return Y;const pe=Date.now();ve||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Ce=Q(Ae.adapter,Ae.extension);return Promise.resolve(Ce).catch(ke=>{(0,b.isCancellationError)(ke)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Ae.extension.identifier,ke))}).finally(()=>{ve||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),P.CancellationToken.isCancellationToken(he)?(0,S.raceCancellationError)(Ce,he):Ce}t(N,H){const Q=this.q();return this.f.set(Q,new Z(N,H)),Q}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,H,Q,Y){const he=this.t(new t(this.h,Q),N),ve=Y&&Y.label||ce.u(N);return this.e.$registerDocumentSymbolProvider(he,this.o(H),ve),this.p(he)}$provideDocumentSymbols(N,H,Q){return this.s(N,t,Y=>Y.provideDocumentSymbols(a.URI.revive(H),Q),void 0,Q)}registerCodeLensProvider(N,H,Q){const Y=this.q(),he=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new Z(new l(this.h,this.j.converter,Q),N)),this.e.$registerCodeLensSupport(Y,this.o(H),he);let ve=this.p(Y);if(he!==void 0){const Ae=Q.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(he));ve=u.Disposable.from(ve,Ae)}return ve}$provideCodeLenses(N,H,Q){return this.s(N,l,Y=>Y.provideCodeLenses(a.URI.revive(H),Q),void 0,Q)}$resolveCodeLens(N,H,Q){return this.s(N,l,Y=>Y.resolveCodeLens(H,Q),void 0,void 0)}$releaseCodeLenses(N,H){this.s(N,l,Q=>Promise.resolve(Q.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(N,H,Q){const Y=this.t(new o(this.h,Q),N);return this.e.$registerDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideDefinition(N,H,Q,Y){return this.s(N,o,he=>he.provideDefinition(a.URI.revive(H),Q,Y),[],Y)}registerDeclarationProvider(N,H,Q){const Y=this.t(new n(this.h,Q),N);return this.e.$registerDeclarationSupport(Y,this.o(H)),this.p(Y)}$provideDeclaration(N,H,Q,Y){return this.s(N,n,he=>he.provideDeclaration(a.URI.revive(H),Q,Y),[],Y)}registerImplementationProvider(N,H,Q){const Y=this.t(new m(this.h,Q),N);return this.e.$registerImplementationSupport(Y,this.o(H)),this.p(Y)}$provideImplementation(N,H,Q,Y){return this.s(N,m,he=>he.provideImplementation(a.URI.revive(H),Q,Y),[],Y)}registerTypeDefinitionProvider(N,H,Q){const Y=this.t(new s(this.h,Q),N);return this.e.$registerTypeDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideTypeDefinition(N,H,Q,Y){return this.s(N,s,he=>he.provideTypeDefinition(a.URI.revive(H),Q,Y),[],Y)}registerHoverProvider(N,H,Q,Y){const he=this.t(new i(this.h,Q),N);return this.e.$registerHoverProvider(he,this.o(H)),this.p(he)}$provideHover(N,H,Q,Y){return this.s(N,i,he=>he.provideHover(a.URI.revive(H),Q,Y),void 0,Y)}registerEvaluatableExpressionProvider(N,H,Q,Y){const he=this.t(new c(this.h,Q),N);return this.e.$registerEvaluatableExpressionProvider(he,this.o(H)),this.p(he)}$provideEvaluatableExpression(N,H,Q,Y){return this.s(N,c,he=>he.provideEvaluatableExpression(a.URI.revive(H),Q,Y),void 0,Y)}registerInlineValuesProvider(N,H,Q,Y){const he=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,ve=this.t(new w(this.h,Q),N);this.e.$registerInlineValuesProvider(ve,this.o(H),he);let Ae=this.p(ve);if(he!==void 0){const pe=Q.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(he));Ae=u.Disposable.from(Ae,pe)}return Ae}$provideInlineValues(N,H,Q,Y,he){return this.s(N,w,ve=>ve.provideInlineValues(a.URI.revive(H),Q,Y,he),void 0,he)}registerDocumentHighlightProvider(N,H,Q){const Y=this.t(new D(this.h,Q),N);return this.e.$registerDocumentHighlightProvider(Y,this.o(H)),this.p(Y)}$provideDocumentHighlights(N,H,Q,Y){return this.s(N,D,he=>he.provideDocumentHighlights(a.URI.revive(H),Q,Y),void 0,Y)}registerLinkedEditingRangeProvider(N,H,Q){const Y=this.t(new F(this.h,Q),N);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(H)),this.p(Y)}$provideLinkedEditingRanges(N,H,Q,Y){return this.s(N,F,async he=>{const ve=await he.provideLinkedEditingRanges(a.URI.revive(H),Q,Y);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?ce.w(ve.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(N,H,Q){const Y=this.t(new x(this.h,Q),N);return this.e.$registerReferenceSupport(Y,this.o(H)),this.p(Y)}$provideReferences(N,H,Q,Y,he){return this.s(N,x,ve=>ve.provideReferences(a.URI.revive(H),Q,Y,he),void 0,he)}registerCodeActionProvider(N,H,Q,Y){const he=new E.DisposableStore,ve=this.t(new q(this.h,this.j.converter,this.k,Q,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(ve,this.o(H),{providedKinds:Y?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:Y?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,he)}))},ce.u(N),Boolean(Q.resolveCodeAction)),he.add(this.p(ve)),he}$provideCodeActions(N,H,Q,Y,he){return this.s(N,q,ve=>ve.provideCodeActions(a.URI.revive(H),Q,Y,he),void 0,he)}$resolveCodeAction(N,H,Q){return this.s(N,q,Y=>Y.resolveCodeAction(H,Q),void 0,void 0)}$releaseCodeActions(N,H){this.s(N,q,Q=>Promise.resolve(Q.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(N,H,Q){const Y=this.t(new B(this.h,Q),N);return this.e.$registerDocumentFormattingSupport(Y,this.o(H),N.identifier,N.displayName||N.name),this.p(Y)}$provideDocumentFormattingEdits(N,H,Q,Y){return this.s(N,B,he=>he.provideDocumentFormattingEdits(a.URI.revive(H),Q,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(N,H,Q){const Y=this.t(new O(this.h,Q),N);return this.e.$registerRangeFormattingSupport(Y,this.o(H),N.identifier,N.displayName||N.name),this.p(Y)}$provideDocumentRangeFormattingEdits(N,H,Q,Y,he){return this.s(N,O,ve=>ve.provideDocumentRangeFormattingEdits(a.URI.revive(H),Q,Y,he),void 0,he)}registerOnTypeFormattingEditProvider(N,H,Q,Y){const he=this.t(new U(this.h,Q),N);return this.e.$registerOnTypeFormattingSupport(he,this.o(H),Y,N.identifier),this.p(he)}$provideOnTypeFormattingEdits(N,H,Q,Y,he,ve){return this.s(N,U,Ae=>Ae.provideOnTypeFormattingEdits(a.URI.revive(H),Q,Y,he,ve),void 0,ve)}registerWorkspaceSymbolProvider(N,H){const Q=this.t(new z(H,this.l),N);return this.e.$registerNavigateTypeSupport(Q,typeof H.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(N,H,Q){return this.s(N,z,Y=>Y.provideWorkspaceSymbols(H,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(N,H,Q){return this.s(N,z,Y=>Y.resolveWorkspaceSymbol(H,Q),void 0,void 0)}$releaseWorkspaceSymbols(N,H){this.s(N,z,Q=>Q.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(N,H,Q){const Y=this.t(new j(this.h,Q,this.l),N);return this.e.$registerRenameSupport(Y,this.o(H),j.supportsResolving(Q)),this.p(Y)}$provideRenameEdits(N,H,Q,Y,he){return this.s(N,j,ve=>ve.provideRenameEdits(a.URI.revive(H),Q,Y,he),void 0,he)}$resolveRenameLocation(N,H,Q,Y){return this.s(N,j,he=>he.resolveRenameLocation(a.URI.revive(H),Q,Y),void 0,Y)}registerDocumentSemanticTokensProvider(N,H,Q,Y){const he=this.t(new V(this.h,Q),N),ve=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(H),Y,ve);let Ae=this.p(he);if(ve){const pe=Q.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(ve));Ae=u.Disposable.from(Ae,pe)}return Ae}$provideDocumentSemanticTokens(N,H,Q,Y){return this.s(N,V,he=>he.provideDocumentSemanticTokens(a.URI.revive(H),Q,Y),null,Y)}$releaseDocumentSemanticTokens(N,H){this.s(N,V,Q=>Q.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,H,Q,Y){const he=this.t(new _(this.h,Q),N);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(H),Y),this.p(he)}$provideDocumentRangeSemanticTokens(N,H,Q,Y){return this.s(N,_,he=>he.provideDocumentRangeSemanticTokens(a.URI.revive(H),Q,Y),null,Y)}registerCompletionItemProvider(N,H,Q,Y){const he=this.t(new J(this.h,this.j.converter,Q,this.m,N),N);return this.e.$registerCompletionsProvider(he,this.o(H),Y,J.supportsResolving(Q),`${N.identifier.value}(${Y.join("")})`),this.p(he)}$provideCompletionItems(N,H,Q,Y,he){return this.s(N,J,ve=>ve.provideCompletionItems(a.URI.revive(H),Q,Y,he),void 0,he)}$resolveCompletionItem(N,H,Q){return this.s(N,J,Y=>Y.resolveCompletionItem(H,Q),void 0,Q)}$releaseCompletionItems(N,H){this.s(N,J,Q=>Q.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(N,H,Q){const Y=new ee(N,this.h,Q,this.j.converter),he=this.t(Y,N);return this.e.$registerInlineCompletionsSupport(he,this.o(H),Y.supportsHandleDidShowCompletionItem),this.p(he)}$provideInlineCompletions(N,H,Q,Y,he){return this.s(N,ie,ve=>ve.provideInlineCompletions(a.URI.revive(H),Q,Y,he),void 0,he)}$handleInlineCompletionDidShow(N,H,Q){this.s(N,ie,async Y=>{Y.handleDidShowCompletionItem(H,Q)},void 0,void 0)}$freeInlineCompletionsList(N,H){this.s(N,ie,async Q=>{Q.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(N,H,Q,Y){const he=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,ve=this.t(new G(this.h,Q),N);return this.e.$registerSignatureHelpProvider(ve,this.o(H),he),this.p(ve)}$provideSignatureHelp(N,H,Q,Y,he){return this.s(N,G,ve=>ve.provideSignatureHelp(a.URI.revive(H),Q,Y,he),void 0,he)}$releaseSignatureHelp(N,H){this.s(N,G,Q=>Q.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(N,H,Q){const Y=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new de(this.h,this.j.converter,Q,this.l,N),N);this.e.$registerInlayHintsProvider(he,this.o(H),typeof Q.resolveInlayHint=="function",Y,ce.u(N));let ve=this.p(he);if(Y!==void 0){const Ae=Q.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(Y));ve=u.Disposable.from(ve,Ae)}return ve}$provideInlayHints(N,H,Q,Y){return this.s(N,de,he=>he.provideInlayHints(a.URI.revive(H),Q,Y),void 0,Y)}$resolveInlayHint(N,H,Q){return this.s(N,de,Y=>Y.resolveInlayHint(H,Q),void 0,Q)}$releaseInlayHints(N,H){this.s(N,de,Q=>Q.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(N,H,Q){const Y=this.t(new be(this.h,Q),N);return this.e.$registerDocumentLinkProvider(Y,this.o(H),typeof Q.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(N,H,Q){return this.s(N,be,Y=>Y.provideLinks(a.URI.revive(H),Q),void 0,Q,H.scheme==="output")}$resolveDocumentLink(N,H,Q){return this.s(N,be,Y=>Y.resolveLink(H,Q),void 0,void 0,!0)}$releaseDocumentLinks(N,H){this.s(N,be,Q=>Q.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(N,H,Q){const Y=this.t(new Ee(this.h,Q),N);return this.e.$registerDocumentColorProvider(Y,this.o(H)),this.p(Y)}$provideDocumentColors(N,H,Q){return this.s(N,Ee,Y=>Y.provideColors(a.URI.revive(H),Q),[],Q)}$provideColorPresentations(N,H,Q,Y){return this.s(N,Ee,he=>he.provideColorPresentations(a.URI.revive(H),Q,Y),void 0,Y)}registerFoldingRangeProvider(N,H,Q){const Y=this.q(),he=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new Z(new Pe(this.h,Q),N)),this.e.$registerFoldingRangeProvider(Y,this.o(H),N.identifier,he);let ve=this.p(Y);if(he!==void 0){const Ae=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));ve=u.Disposable.from(ve,Ae)}return ve}$provideFoldingRanges(N,H,Q,Y){return this.s(N,Pe,he=>he.provideFoldingRanges(a.URI.revive(H),Q,Y),void 0,Y)}registerSelectionRangeProvider(N,H,Q){const Y=this.t(new Fe(this.h,Q,this.l),N);return this.e.$registerSelectionRangeProvider(Y,this.o(H)),this.p(Y)}$provideSelectionRanges(N,H,Q,Y){return this.s(N,Fe,he=>he.provideSelectionRanges(a.URI.revive(H),Q,Y),[],Y)}registerCallHierarchyProvider(N,H,Q){const Y=this.t(new se(this.h,Q),N);return this.e.$registerCallHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareCallHierarchy(N,H,Q,Y){return this.s(N,se,he=>Promise.resolve(he.prepareSession(a.URI.revive(H),Q,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(N,H,Q,Y){return this.s(N,se,he=>he.provideCallsTo(H,Q,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(N,H,Q,Y){return this.s(N,se,he=>he.provideCallsFrom(H,Q,Y),void 0,Y)}$releaseCallHierarchy(N,H){this.s(N,se,Q=>Promise.resolve(Q.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(N,H,Q){const Y=this.t(new oe(this.h,Q),N);return this.e.$registerTypeHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareTypeHierarchy(N,H,Q,Y){return this.s(N,oe,he=>Promise.resolve(he.prepareSession(a.URI.revive(H),Q,Y)),void 0,Y)}$provideTypeHierarchySupertypes(N,H,Q,Y){return this.s(N,oe,he=>he.provideSupertypes(H,Q,Y),void 0,Y)}$provideTypeHierarchySubtypes(N,H,Q,Y){return this.s(N,oe,he=>he.provideSubtypes(H,Q,Y),void 0,Y)}$releaseTypeHierarchy(N,H){this.s(N,oe,Q=>Promise.resolve(Q.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(N,H,Q){const Y=this.q();return this.f.set(Y,new Z(new fe(this.e,this.h,Q,Y),N)),this.e.$registerDocumentOnDropEditProvider(Y,this.o(H)),this.p(Y)}$provideDocumentOnDropEdits(N,H,Q,Y,he,ve){return this.s(N,fe,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(H,a.URI.revive(Q),Y,he,ve)),void 0,void 0)}registerDocumentPasteEditProvider(N,H,Q,Y){const he=this.q();return this.f.set(he,new Z(new M(this.e,this.h,Q,he),N)),this.e.$registerPasteEditProvider(he,this.o(H),!!Q.prepareDocumentPaste,Y.pasteMimeTypes),this.p(he)}$prepareDocumentPaste(N,H,Q,Y,he){return this.s(N,M,ve=>ve.prepareDocumentPaste(a.URI.revive(H),Q,Y,he),void 0,he)}$providePasteEdits(N,H,Q,Y,he,ve){return this.s(N,M,Ae=>Ae.providePasteEdits(H,a.URI.revive(Q),Y,he,ve),void 0,ve)}static w(N){return{pattern:N.source,flags:(0,y.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:ce.w(N.decreaseIndentPattern),increaseIndentPattern:ce.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ce.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ce.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:ce.w(N.beforeText),afterText:N.afterText?ce.w(N.afterText):void 0,previousLineText:N.previousLineText?ce.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(ce.z)}setLanguageConfiguration(N,H,Q){const{wordPattern:Y}=Q;if(Y&&(0,y.regExpLeadsToEndlessLoop)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(H,Y):this.h.setWordDefinitionFor(H,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const he=this.q(),ve={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?ce.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?ce.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?ce.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport};return this.e.$setLanguageConfiguration(he,H,ve),this.p(he)}$setWordDefinitions(N){for(const H of N)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(ye[262],De([1,0,5,14,7,37,17,6]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,k,v,P){this.c=k,this.d=v,this.e=P,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,k){await this.a.$changeLanguage(L,k);const v=this.c.getDocumentData(L);if(!v)throw new Error(`document '${L.toString()}' NOT found`);return v.document}async tokenAtPosition(L,k){const v=L.version,P=R.Position.from(k),E=await this.a.$tokensAtPosition(L.uri,P),h={type:T.StandardTokenType.Other,range:L.getWordRangeAtPosition(k)??new T.Range(k.line,k.character,k.line,k.character)};if(!E)return h;const d={range:R.Range.to(E.range),type:R.TokenType.to(E.type)};return!d.range.contains(k)||v!==L.version?h:d}createLanguageStatusItem(L,k,v){const P=this.f++,E=this.a,h=this.g,d=`${L.identifier.value}/${k}`;if(h.has(d))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);h.add(d);const f={selector:v,id:k,name:L.displayName??L.name,severity:T.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const b=new A.DisposableStore,S=()=>{p?.dispose(),p=(0,C.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(P,{id:d,name:f.name??L.displayName??L.name,source:L.displayName??L.name,selector:R.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===T.LanguageStatusSeverity.Error?u.default.Error:f.severity===T.LanguageStatusSeverity.Warning?u.default.Warning:u.default.Info,command:f.command&&this.d.toInternal(f.command,b),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},g={dispose(){b.dispose(),p?.dispose(),E.$removeLanguageStatus(P),h.delete(d)},get id(){return f.id},get name(){return f.name},set name(t){f.name=t,S()},get selector(){return f.selector},set selector(t){f.selector=t,S()},get text(){return f.text},set text(t){f.text=t,S()},get detail(){return f.detail},set detail(t){f.detail=t,S()},get severity(){return f.severity},set severity(t){f.severity=t,S()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(t){f.accessibilityInformation=t,S()},get command(){return f.command},set command(t){f.command=t,S()},get busy(){return f.busy},set busy(t){f.busy=t,S()}};return S(),g}}e.ExtHostLanguages=y}),define(ye[97],De([1,0,12,8,2,4,13,5,25,18]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(v,P,E){this.f=E,this.d=new Map,this.a=P.getProxy(A.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(v,P){const{message:E,args:h,comment:d}=P;if(this.c)return(0,R.format2)(E,h??{});let f=E;d&&d.length>0&&(f+=`/${Array.isArray(d)?d.join(""):d}`);const p=this.d.get(v)?.contents[f];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,R.format2)(p??E,h??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let P;const E=await this.g(v);if(!E){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(E),d=JSON.parse(h);P=v.isBuiltin?d.contents?.bundle:d}catch(h){this.f.error(`Failed to load translations for ${v.identifier.value} from ${E}: ${h.message}`);return}P&&this.d.set(v.identifier.value,{contents:P,uri:E})}async g(v){if(v.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(v.identifier.value);return T.URI.revive(P)}return v.l10n?T.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([We(0,y.IExtHostInitDataService),We(1,I.IExtHostRpcService),We(2,C.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,u.createDecorator)("IExtHostLocalizationService")}),define(ye[140],De([1,0,13,5,25,18,2,69]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends a.AbstractLoggerService{constructor(k,v){super(v.logLevel,v.loggers.map(P=>(0,A.revive)(P))),this.l=k.getProxy(R.MainContext.MainThreadLogger)}$setLogLevel(k,v){v?this.setLogLevel(C.URI.revive(v),k):this.setLogLevel(k)}k(k,v,P){return new I(this.l,k,v,P)}};y=qe([We(0,u.IExtHostRpcService),We(1,T.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class I extends a.AbstractMessageLogger{constructor(k,v,P,E){super(E?.logLevel==="always"),this.m=k,this.n=v,this.k=!1,this.l=[],this.setLevel(P),this.m.$createLogger(v,E).then(()=>{this.r(this.l),this.k=!0})}g(k,v){const P=[[k,v]];this.k?this.r(P):this.l.push(...P)}r(k){this.m.$log(this.n,k)}}}),define(ye[263],De([1,0,5,13,27]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function u(A){return A&&A.title}let C=class{constructor(y,I){this.b=I,this.a=y.getProxy(a.MainContext.MainThreadMessageService)}showMessage(y,I,L,k,v){const P={source:{identifier:y.identifier,label:y.displayName||y.name}};let E;typeof k=="string"||u(k)?E=[k,...v]:(P.modal=k?.modal,P.useCustom=k?.useCustom,P.detail=k?.detail,E=v),P.useCustom&&(0,T.checkProposedApiEnabled)(y,"resolvers");const h=[];for(let d=0;d<E.length;d++){const f=E[d];if(typeof f=="string")h.push({title:f,handle:d,isCloseAffordance:!1});else if(typeof f=="object"){const{title:p,isCloseAffordance:b}=f;h.push({title:p,isCloseAffordance:!!b,handle:d})}else this.b.warn("Invalid message item:",f)}return this.a.$showMessage(I,L,P,h).then(d=>{if(typeof d=="number")return E[d]})}};C=qe([We(1,R.ILogService)],C),e.ExtHostMessageService=C}),define(ye[264],De([1,0,22,3,6,28,8,9,2,74,5,40,14,7,58,239,136]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,S,g,t){this.q=g,this.r=t,this.f=new Map,this.g=new u.ResourceMap,this.h=new Map,this.j=new R.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(L.MainContext.MainThreadNotebook),this.c=b.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===13){const r=l.notebookEditor?.notebookUri,o=l.cell.handle,m=this.g.get(r)?.getCell(o);if(m)return m.apiCell}if(l&&l.$mid===14){const r=l.uri,o=this.g.get(r);if(o)return o.apiNotebook}return l}}),f.x(S)}getEditorById(b){const S=this.h.get(b);if(!S)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(b){for(const[S,g]of this.h)if(g.apiEditor===b)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,S){const g=this.g.get(b);if(!g&&!S)throw new Error(`NO notebook document for '${b}'`);return g}static s(b,S){if(!S)return;const g=S.filenamePattern.map(t=>v.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(S.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:S.displayName,filenamePattern:g,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,S,g){const t=f.a++,l=typeof g.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(t,g),this.b.$registerNotebookCellStatusBarItemProvider(t,l,S);let r;return l!==void 0&&(r=g.onDidChangeCellStatusBarItems(o=>this.b.$emitCellStatusBarEvent(l))),new P.Disposable(()=>{this.f.delete(t),this.b.$unregisterNotebookCellStatusBarItemProvider(t,l),r?.dispose()})}async createNotebookDocument(b){const S=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&v.NotebookData.from(b.content)});return y.URI.revive(S)}async openNotebookDocument(b){const S=this.g.get(b);if(S)return S.apiNotebook;const g=await this.c.$tryOpenNotebook(b),t=this.g.get(y.URI.revive(g));return(0,A.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(b,S){y.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let g;typeof S=="object"?g={position:v.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(v.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:g={preserveFocus:!1};const t=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,g),l=t&&this.h.get(t)?.apiEditor;if(l)return l;throw t?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,S,g,t){const l=this.f.get(b),r=y.URI.revive(S),o=this.g.get(r);if(!o||!l)return;const n=o.getCellFromIndex(g);if(!n)return;const m=await l.provideCellStatusBarItems(n.apiCell,t);if(!m)return;const s=new T.DisposableStore,i=this.p.add([s]),w=(Array.isArray(m)?m:[m]).map(D=>v.NotebookStatusBarItem.from(D,this.i,s));return{cacheId:i,items:w}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,S,g,t,l){if((0,C.isFalsyOrWhitespace)(S))throw new Error("viewType cannot be empty or just whitespace");const r=this.t++;return this.u.set(r,g),this.b.$registerNotebookSerializer(r,{id:b.identifier,location:b.extensionLocation},S,v.NotebookDocumentContentOptions.from(t),f.s(b,l)),(0,T.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(r)})}async $dataToNotebook(b,S,g){const t=this.u.get(b);if(!t)throw new Error("NO serializer found");const l=await t.deserializeNotebook(S.buffer,g);return new E.SerializableObjectWithBuffers(v.NotebookData.from(l))}async $notebookToData(b,S,g){const t=this.u.get(b);if(!t)throw new Error("NO serializer found");const l=await t.serializeNotebook(v.NotebookData.to(S.value),g);return a.VSBuffer.wrap(l)}w(b,S,g){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const t=new d.ExtHostNotebookEditor(S,this.d,b,g.visibleRanges.map(v.NotebookRange.to),g.selections.map(v.NotebookRange.to),typeof g.viewColumn=="number"?v.ViewColumn.to(g.viewColumn):void 0);this.h.set(S,t)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const g of b.value.removedDocuments){const t=y.URI.revive(g),l=this.g.get(t);l&&(l.dispose(),this.g.delete(t),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(r=>r.document.uri)}),this.n.fire(l.apiNotebook));for(const r of this.h.values())r.notebookData.uri.toString()===t.toString()&&this.h.delete(r.id)}if(b.value.addedDocuments){const g=[];for(const t of b.value.addedDocuments){const l=y.URI.revive(t.uri);if(this.g.has(l))throw new Error(`adding EXISTING notebook ${l} `);const r=new h.ExtHostNotebookDocument(this.c,this.q,this.r,l,t);g.push(...t.cells.map(o=>h.ExtHostCell.asModelAddData(r.apiNotebook,o))),this.g.get(l)?.dispose(),this.g.set(l,r),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(r.apiNotebook)}}if(b.value.addedEditors)for(const g of b.value.addedEditors){if(this.h.has(g.id))return;const t=y.URI.revive(g.documentUri),l=this.g.get(t);l&&this.w(l,g.id,g)}const S=[];if(b.value.removedEditors)for(const g of b.value.removedEditors){const t=this.h.get(g);t&&(this.h.delete(g),this.k?.id===t.id&&(this.k=void 0),S.push(t))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(t=>this.h.get(t)).filter(t=>!!t);const g=new Set;this.l.forEach(t=>g.add(t.id));for(const t of this.h.values()){const l=g.has(t.id);t._acceptVisibility(l)}this.l=[...this.h.values()].map(t=>t).filter(t=>t.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const S=k.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new k.ApiCommandArgument("data","Bytes to convert to data",l=>l instanceof Uint8Array,l=>a.VSBuffer.wrap(l))],new k.ApiCommandResult("Notebook Data",l=>v.NotebookData.to(l.value))),t=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",l=>!0,l=>new E.SerializableObjectWithBuffers(v.NotebookData.from(l)))],new k.ApiCommandResult("Bytes",l=>l.buffer));b.registerApiCommand(g),b.registerApiCommand(t)}}e.ExtHostNotebookController=f,f.a=0}),define(ye[265],De([1,0,15,17,21,3,6,28,2,26,13,74,5,40,14,7,94,229,27,58]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let S=class{constructor(n,m,s,i,c){this.k=m,this.l=s,this.m=i,this.n=c,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new k.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new u.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=n.getProxy(v.MainContext.MainThreadNotebookKernels);const w=new P.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new P.ApiCommandArgument("options","Select kernel options",D=>!0,D=>{if(D&&"notebookEditor"in D&&"id"in D){const F=this.l.getIdByEditor(D.notebookEditor);return{id:D.id,extension:D.extension,notebookEditorId:F}}else if(D&&"notebookEditor"in D){const F=this.l.getIdByEditor(D.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${D.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return D})],P.ApiCommandResult.Void);this.m.registerApiCommand(w)}createNotebookController(n,m,s,i,c,w){for(const ie of this.h.values())if(ie.controller.id===m&&I.ExtensionIdentifier.equals(n.identifier,ie.extensionId))throw new Error(`notebook controller with id '${m}' ALREADY exist`);const D=this.i++,F=this;this.n.trace(`NotebookController[${D}], CREATED by ${n.identifier.value}, ${m}`);const x=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${n.identifier}'`);let q=!1;const M=new C.DisposableStore,B=new u.Emitter,O=new u.Emitter,U={id:r(n.identifier,m),notebookType:s,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:i||n.identifier.value,preloads:w?w.map(E.NotebookRendererScript.from):[]};let z=c??x,j;this.a.$addKernel(D,U).catch(ie=>{console.log(ie),q=!0});let le=0;const V=()=>{if(q)return;const ie=++le;Promise.resolve().then(()=>{ie===le&&this.a.$updateKernel(D,U)})},_=new A.ResourceMap,J={get id(){return m},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(ie){U.label=ie??n.displayName??n.name,V()},get detail(){return U.detail??""},set detail(ie){U.detail=ie,V()},get description(){return U.description??""},set description(ie){U.description=ie,V()},get kind(){return(0,p.checkProposedApiEnabled)(n,"notebookControllerKind"),U.kind??""},set kind(ie){(0,p.checkProposedApiEnabled)(n,"notebookControllerKind"),U.kind=ie,V()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ie){U.supportedLanguages=ie,V()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){U.supportsExecutionOrder=ie,V()},get rendererScripts(){return U.preloads?U.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ie){z=ie??x},get interruptHandler(){return j},set interruptHandler(ie){j=ie,U.supportsInterrupt=Boolean(ie),V()},createNotebookCellExecution(ie){if(q)throw new Error("notebook controller is DISPOSED");if(!_.has(ie.notebook.uri))throw F.n.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return F._createNotebookCellExecution(ie,r(n.identifier,this.id))},dispose:()=>{q||(this.n.trace(`NotebookController[${D}], DISPOSED`),q=!0,this.h.delete(D),M.dispose(),B.dispose(),O.dispose(),this.a.$removeKernel(D))},updateNotebookAffinity(ie,ee){ee===h.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(n,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(D,ie.uri,ee)},onDidReceiveMessage:O.event,postMessage(ie,ee){return(0,p.checkProposedApiEnabled)(n,"notebookMessaging"),F.a.$postMessage(D,ee&&F.l.getIdByEditor(ee),ie)},asWebviewUri(ie){return(0,p.checkProposedApiEnabled)(n,"notebookMessaging"),(0,d.asWebviewUri)(ie,F.k.remote)}};return this.h.set(D,{extensionId:n.identifier,controller:J,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:_}),J}getIdByController(n){for(const[m,s]of this.h)if(s.controller===n)return r(s.extensionId,n.id);return null}createNotebookControllerDetectionTask(n,m){const s=this.d++,i=this;this.n.trace(`NotebookControllerDetectionTask[${s}], CREATED by ${n.identifier.value}`),this.a.$addKernelDetectionTask(s,m);const c={dispose:()=>{this.c.delete(s),i.a.$removeKernelDetectionTask(s)}};return this.c.set(s,c),c}registerKernelSourceActionProvider(n,m,s){const i=this.f++,c=this;return this.e.set(i,s),this.n.trace(`NotebookKernelSourceActionProvider[${i}], CREATED by ${n.identifier.value}`),this.a.$addKernelSourceActionProvider(i,m),{dispose:()=>{this.e.delete(i),c.a.$removeKernelSourceActionProvider(i)}}}async $provideKernelSourceActions(n,m){const s=this.e.get(n);if(s){const i=new C.DisposableStore;return this.g.add([i]),(await s.provideNotebookKernelSourceActions(m)??[]).map(w=>E.NotebookKernelSourceAction.from(w,this.m.converter,i))}return[]}$acceptNotebookAssociation(n,m,s){const i=this.h.get(n);if(i){const c=this.l.getNotebookDocument(y.URI.revive(m));s?i.associatedNotebooks.set(c.uri,!0):i.associatedNotebooks.delete(c.uri),this.n.trace(`NotebookController[${n}] ASSOCIATE notebook`,c.uri.toString(),s),i.onDidChangeSelection.fire({selected:s,notebook:c.apiNotebook})}}async $executeCells(n,m,s){const i=this.h.get(n);if(!i)return;const c=this.l.getNotebookDocument(y.URI.revive(m)),w=[];for(const D of s){const F=c.getCell(D);F&&w.push(F.apiCell)}try{this.n.trace(`NotebookController[${n}] EXECUTE cells`,c.uri.toString(),w.length),await i.controller.executeHandler.call(i.controller,w,c.apiNotebook,i.controller)}catch(D){this.n.error(`NotebookController[${n}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(n,m,s){const i=this.h.get(n);if(!i)return;const c=this.l.getNotebookDocument(y.URI.revive(m));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,c.apiNotebook);else for(const w of s){const D=c.getCell(w);D&&this.b.get(D.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,m,s){const i=this.h.get(n);if(!i)return;const c=this.l.getEditorById(m);i.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:s}))}$cellExecutionChanged(n,m,s){const c=this.l.getNotebookDocument(y.URI.revive(n)).getCell(m);if(c){const w=s?E.NotebookCellExecutionState.to(s):h.NotebookCellExecutionState.Idle;w!==void 0&&this.j.fire({cell:c.apiCell,state:w})}}_createNotebookCellExecution(n,m){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this.l.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!i)throw new Error("invalid cell");if(this.b.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const c=new t(m,i,this.a);this.b.set(i.uri,c);const w=c.onDidChangeState(()=>{c.state===g.Resolved&&(c.dispose(),w.dispose(),this.b.delete(i.uri))});return c.asApiObject()}};S=qe([We(4,L.ILogService)],S),e.ExtHostNotebookKernels=S;var g;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(g||(g={}));class t extends C.Disposable{get state(){return this.f}constructor(n,m,s){super(),this.j=m,this.k=s,this.b=t.a++,this.c=new u.Emitter,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new T.CancellationTokenSource),this.h=new l(10,i=>this.m(i)),this.i=m.internalMetadata.executionOrder,this.k.$createExecution(this.b,n,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(n){await this.h.addItem(n)}async m(n){const m=Array.isArray(n)?n:[n];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(m))}n(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(n){let m=this.j;if(n&&(m=this.j.notebook.getCellFromApiCell(n)),!m)throw new Error("INVALID cell");return m.handle}s(n){return n.map(m=>{const s=h.NotebookCellOutput.ensureUniqueMimeTypes(m.items,!0);return s===m.items?E.NotebookCellOutput.from(m):E.NotebookCellOutput.from({items:s,id:m.id,metadata:m.metadata})})}async t(n,m,s){const i=this.r(m),c=this.s((0,a.asArray)(n));return this.l({editType:f.CellExecutionUpdateType.Output,cellHandle:i,append:s,outputs:c})}async w(n,m,s){return n=h.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(n),!0),this.l({editType:f.CellExecutionUpdateType.OutputItems,items:n.map(E.NotebookCellOutputItem.from),outputId:m.id,append:s})}asApiObject(){const n=this;return Object.freeze({get token(){return n.g.token},get cell(){return n.j.apiCell},get executionOrder(){return n.i},set executionOrder(s){n.i=s,n.m([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:n.i}])},start(s){if(n.f===g.Resolved||n.f===g.Started)throw new Error("Cannot call start again");n.f=g.Started,n.c.fire(),n.m({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:s})},end(s,i){if(n.f===g.Resolved)throw new Error("Cannot call resolve twice");n.f=g.Resolved,n.c.fire(),n.h.flush(),n.k.$completeExecution(n.b,new b.SerializableObjectWithBuffers({runEndTime:i,lastRunSuccess:s}))},clearOutput(s){return n.n(),n.t([],s,!1)},appendOutput(s,i){return n.n(),n.t(s,i,!0)},replaceOutput(s,i){return n.n(),n.t(s,i,!1)},appendOutputItems(s,i){return n.n(),n.w(s,i,!0)},replaceOutputItems(s,i){return n.n(),n.w(s,i,!1)}})}}t.a=0;class l{constructor(n,m){this.d=n,this.e=m,this.a=[],this.b=Date.now()}addItem(n){return this.a.push(n),this.c||(this.c=new R.DeferredPromise,this.b=Date.now(),(0,R.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const n=this.c;this.c=void 0;const m=this.a;return this.a=[],this.e(m).finally(()=>n.complete())}}function r(o,n){return`${o.value}/${n}`}e.createKernelId=r}),define(ye[266],De([1,0,3,5,136]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class u{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,I){const L=this.c.getEditorById(A);this.a.get(y)?.fire({editor:L.apiEditor,message:I})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(L=>L.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(L,k,v)=>this.d(y).event(L,k,v),postMessage:(L,k)=>{T.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,k]=[k,L]);const v=k&&T.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.b.$postMessage(v?.id,y,L)}}}d(A){let y=this.a.get(A);return y||(y=new a.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=u}),define(ye[267],De([1,0,6,9,2,27,5]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(I){this.b=new Map,this.a=I.getProxy(C.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(I,L,k){if((0,u.checkProposedApiEnabled)(I,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,k),this.a.$registerProfileContentHandler(L,k.name,k.description,I.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(I,L,k,v){const P=this.b.get(I);if(!P)throw new Error(`Unknown handler with id: ${I}`);return P.saveProfile(L,k,v)}async $readProfile(I,L,k){const v=this.b.get(I);if(!v)throw new Error(`Unknown handler with id: ${I}`);return v.readProfile((0,R.isString)(L)?L:T.URI.revive(L),k)}}e.ExtHostProfileContentHandlers=A}),define(ye[268],De([1,0,2,5,17]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class u{constructor(A){this.c=new Map,this.b=A.getProxy(R.MainContext.MainThreadQuickDiff)}$provideOriginalResource(A,y,I){const L=a.URI.revive(y),k=this.c.get(A);return k?(0,T.asPromise)(()=>k.provideOriginalResource(L,I)).then(v=>v||null):Promise.resolve(null)}async registerQuickDiffProvider(A,y,I){const L=u.a++;return this.c.set(L,A),await this.b.$registerQuickDiffProvider(L,y,I),{dispose:()=>this.c.delete(L)}}}e.ExtHostQuickDiff=u,u.a=0}),define(ye[269],De([1,0,21,3,6,5,2,7,11,15,37,51]),function(te,e,a,R,T,u,C,A,y,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(P,E,h){const d=P.getProxy(u.MainContext.MainThreadQuickOpen);class f{constructor(n,m){this.e=new Map,this.f=0,this.a=n,this.b=m}showQuickPick(n,m,s=a.CancellationToken.None){this.c=void 0;const i=Promise.resolve(n),c=++this.f,w=d.$show(c,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},s),D={},F=w.then(()=>D);return Promise.race([F,i]).then(x=>{if(x!==D)return i.then(q=>{const M=[];for(let B=0;B<q.length;B++){const O=q[B];typeof O=="string"?M.push({label:O,handle:B}):O.kind===A.QuickPickItemKind.Separator?M.push({type:"separator",label:O.label}):M.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:B})}return m&&typeof m.onDidSelectItem=="function"&&(this.c=B=>{m.onDidSelectItem(q[B])}),d.$setItems(c,M),w.then(B=>{if(typeof B=="number")return q[B];if(Array.isArray(B))return B.map(O=>q[O])})})}).then(void 0,x=>{if(!(0,y.isCancellationError)(x))return d.$setError(c,x),Promise.reject(x)})}$onItemSelected(n){this.c?.(n)}showInput(n,m=a.CancellationToken.None){return this.d=n?.validateInput,d.$input(n,typeof this.d=="function",m).then(void 0,s=>{if(!(0,y.isCancellationError)(s))return Promise.reject(s)})}async $validateInput(n){if(!this.d)return;const m=await this.d(n);if(!m||typeof m=="string")return m;let s;switch(m.severity){case A.InputBoxValidationSeverity.Info:s=L.default.Info;break;case A.InputBoxValidationSeverity.Warning:s=L.default.Warning;break;case A.InputBoxValidationSeverity.Error:s=L.default.Error;break;default:s=m.message?L.default.Error:L.default.Ignore;break}return{content:m.message,severity:s}}async showWorkspaceFolderPick(n,m=a.CancellationToken.None){const s=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!s)return;const i=await this.a.getWorkspaceFolders2();if(!!i)return i.find(c=>c.uri.toString()===s.uri.toString())}createQuickPick(n){const m=new l(n,()=>this.e.delete(m._id));return this.e.set(m._id,m),m}createInputBox(n){const m=new r(n,()=>this.e.delete(m._id));return this.e.set(m._id,m),m}$onDidChangeValue(n,m){this.e.get(n)?._fireDidChangeValue(m)}$onDidAccept(n){this.e.get(n)?._fireDidAccept()}$onDidChangeActive(n,m){const s=this.e.get(n);s instanceof l&&s._fireDidChangeActive(m)}$onDidChangeSelection(n,m){const s=this.e.get(n);s instanceof l&&s._fireDidChangeSelection(m)}$onDidTriggerButton(n,m){this.e.get(n)?._fireDidTriggerButton(m)}$onDidTriggerItemButton(n,m,s){const i=this.e.get(n);i instanceof l&&i._fireDidTriggerItemButton(m,s)}$onDidHide(n){this.e.get(n)?._fireDidHide()}}class p{constructor(n,m){this.x=n,this.y=m,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.Emitter,this.q=new R.Emitter,this.r=new R.Emitter,this.s=new R.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(n){this.b=n,this.z({title:n})}get step(){return this.c}set step(n){this.c=n,this.z({step:n})}get totalSteps(){return this.d}set totalSteps(n){this.d=n,this.z({totalSteps:n})}get enabled(){return this.g}set enabled(n){this.g=n,this.z({enabled:n})}get busy(){return this.j}set busy(n){this.j=n,this.z({busy:n})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(n){this.k=n,this.z({ignoreFocusOut:n})}get value(){return this.l}set value(n){this.l=n,this.z({value:n})}get placeholder(){return this.m}set placeholder(n){this.m=n,this.z({placeholder:n})}get buttons(){return this.n}set buttons(n){this.n=n.slice(),this.o.clear(),n.forEach((m,s)=>{const i=m===A.QuickInputButtons.Back?-1:s;this.o.set(i,m)}),this.z({buttons:n.map((m,s)=>({...t(m),tooltip:m.tooltip,handle:m===A.QuickInputButtons.Back?-1:s}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(n){this.l=n,this.q.fire(n)}_fireDidTriggerButton(n){const m=this.o.get(n);m&&this.r.fire(m)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,T.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(n){if(!this.v){for(const m of Object.keys(n)){const s=n[m];this.u[m]=s===void 0?null:s}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}p.a=1;function b(o){if(o instanceof A.ThemeIcon)return{id:o.id};const n=g(o),m=S(o);return{dark:typeof n=="string"?C.URI.file(n):n,light:typeof m=="string"?C.URI.file(m):m}}function S(o){return typeof o=="object"&&"light"in o?o.light:o}function g(o){return typeof o=="object"&&"dark"in o?o.dark:o}function t(o){const n=b(o.iconPath);let m,s;return"id"in n?s=k.ThemeIcon.asClassName(n):m=n,{iconPath:m,iconClass:s}}class l extends p{constructor(n,m){super(n.identifier,m),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.Emitter,this.L=[],this.M=new R.Emitter,this.N=new R.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(n){this.B=n.slice(),this.C.clear(),this.D.clear(),n.forEach((s,i)=>{this.C.set(i,s),this.D.set(s,i)});const m=[];for(let s=0;s<n.length;s++){const i=n[s];i.kind===A.QuickPickItemKind.Separator?m.push({type:"separator",label:i.label}):m.push({handle:s,label:i.label,description:i.description,detail:i.detail,picked:i.picked,alwaysShow:i.alwaysShow,buttons:i.buttons?.map((c,w)=>({...t(c),tooltip:c.tooltip,handle:w}))})}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(n){this.E=n,this.z({canSelectMany:n})}get matchOnDescription(){return this.F}set matchOnDescription(n){this.F=n,this.z({matchOnDescription:n})}get matchOnDetail(){return this.G}set matchOnDetail(n){this.G=n,this.z({matchOnDetail:n})}get sortByLabel(){return this.H}set sortByLabel(n){this.H=n,this.z({sortByLabel:n})}get keepScrollPosition(){return this.I}set keepScrollPosition(n){this.I=n,this.z({keepScrollPosition:n})}get activeItems(){return this.J}set activeItems(n){this.J=n.filter(m=>this.D.has(m)),this.z({activeItems:this.J.map(m=>this.D.get(m))})}get selectedItems(){return this.L}set selectedItems(n){this.L=n.filter(m=>this.D.has(m)),this.z({selectedItems:this.L.map(m=>this.D.get(m))})}_fireDidChangeActive(n){const m=(0,I.coalesce)(n.map(s=>this.C.get(s)));this.J=m,this.K.fire(m)}_fireDidChangeSelection(n){const m=(0,I.coalesce)(n.map(s=>this.C.get(s)));this.L=m,this.M.fire(m)}_fireDidTriggerItemButton(n,m){const s=this.C.get(n);if(!s||!s.buttons||!s.buttons.length)return;const i=s.buttons[m];i&&this.N.fire({button:i,item:s})}}class r extends p{constructor(n,m){super(n.identifier,m),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(n){this.B=n,this.z({password:n})}get prompt(){return this.C}set prompt(n){this.C=n,this.z({prompt:n})}get valueSelection(){return this.D}set valueSelection(n){this.D=n,this.z({valueSelection:n})}get validationMessage(){return this.E}set validationMessage(n){this.E=n,n?typeof n=="string"?this.z({validationMessage:n,severity:L.default.Error}):this.z({validationMessage:n.message,severity:n.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new f(E,h)}e.createExtHostQuickOpen=v});var Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a};define(ye[270],De([1,0,2,3,62,6,17,5,15,108,13,26,51,14,27]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E){"use strict";var h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(i){if(i)return typeof i.iconPath=="string"?a.URI.file(i.iconPath):a.URI.isUri(i.iconPath)||v.ThemeIcon.isThemeIcon(i.iconPath)?i.iconPath:void 0}function p(i,c){if(!i.iconPath&&!c.iconPath)return 0;if(i.iconPath){if(!c.iconPath)return 1}else return-1;const w=typeof i.iconPath=="string"?i.iconPath:a.URI.isUri(i.iconPath)?i.iconPath.fsPath:i.iconPath.id,D=typeof c.iconPath=="string"?c.iconPath:a.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,I.comparePaths)(w,D)}function b(i,c){let w=0;if(i.strikeThrough!==c.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==c.faded)return i.faded?1:-1;if(i.tooltip!==c.tooltip)return(i.tooltip||"").localeCompare(c.tooltip||"");if(w=p(i,c),w!==0)return w;if(i.light&&c.light)w=p(i.light,c.light);else{if(i.light)return 1;if(c.light)return-1}if(w!==0)return w;if(i.dark&&c.dark)w=p(i.dark,c.dark);else{if(i.dark)return 1;if(c.dark)return-1}return w}function S(i,c){if(i.command!==c.command)return i.command<c.command?-1:1;if(i.title!==c.title)return i.title<c.title?-1:1;if(i.tooltip!==c.tooltip){if(i.tooltip!==void 0&&c.tooltip!==void 0)return i.tooltip<c.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(i.arguments===c.arguments)return 0;if(i.arguments)if(c.arguments){if(i.arguments.length!==c.arguments.length)return i.arguments.length-c.arguments.length}else return 1;else return-1;for(let w=0;w<i.arguments.length;w++){const D=i.arguments[w],F=c.arguments[w];if(D!==F)return D<F?-1:1}return 0}function g(i,c){let w=(0,I.comparePaths)(i.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(w!==0)return w;if(i.command&&c.command)w=S(i.command,c.command);else{if(i.command)return 1;if(c.command)return-1}if(w!==0)return w;if(i.decorations&&c.decorations)w=b(i.decorations,c.decorations);else{if(i.decorations)return 1;if(c.decorations)return-1}return w}function t(i,c){for(let w=0;w<i.length;w++)if(i[w]!==c[w])return!1;return!0}function l(i,c){return i.command===c.command&&i.title===c.title&&i.tooltip===c.tooltip&&(i.arguments&&c.arguments?t(i.arguments,c.arguments):i.arguments===c.arguments)}function r(i,c){return(0,y.equals)(i,c,l)}class o{get value(){return this.d}set value(c){c=c??"",Be(this,h,"f").$setInputBoxValue(this.l,c),this.m(c)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(c){Be(this,h,"f").$setInputBoxPlaceholder(this.l,c),this.f=c}get validateInput(){return(0,E.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(c){if((0,E.checkProposedApiEnabled)(this.k,"scmValidation"),c&&typeof c!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=c,Be(this,h,"f").$setValidationProviderIsEnabled(this.l,!!c)}get enabled(){return this.h}set enabled(c){c=!!c,this.h!==c&&(this.h=c,Be(this,h,"f").$setInputBoxEnablement(this.l,c))}get visible(){return this.j}set visible(c){c=!!c,this.j!==c&&(this.j=c,Be(this,h,"f").$setInputBoxVisibility(this.l,c))}constructor(c,w,D){this.k=c,this.l=D,h.set(this,void 0),this.d="",this.e=new R.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,h,w,"f")}showValidationMessage(c,w){(0,E.checkProposedApiEnabled)(this.k,"scmValidation"),Be(this,h,"f").$showValidationMessage(this.l,c,w)}$onInputBoxValueChange(c){this.m(c)}m(c){this.d=c,this.e.fire(c)}}e.ExtHostSCMInputBox=o,h=new WeakMap;class n{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(c){this.v=c,this.q.$updateGroupLabel(this.t,this.handle,c)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(c){this.p=c,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(c){this.f=[...c],this.k.fire()}constructor(c,w,D,F,x){this.q=c,this.s=w,this.t=D,this.u=F,this.v=x,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=n.d++}getResourceState(c){return this.g.get(c)}$executeResourceCommand(c,w){const D=this.h.get(c);return D?(0,C.asPromise)(()=>this.s.executeCommand(D.command,...D.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this.f].sort(g),D=(0,y.sortedDiff)(this.o,c,g).map(q=>{const M=q.toInsert.map(B=>{const O=this.e++;this.g.set(O,B);const U=B.resourceUri;let z;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const de=new u.DisposableStore;z=this.s.converter.toInternal(B.command,de),this.j.set(O,de)}else this.h.set(O,B.command);const j=f(B.decorations),le=B.decorations&&f(B.decorations.light)||j,V=B.decorations&&f(B.decorations.dark)||j,_=[le,V],J=B.decorations&&B.decorations.tooltip||"",ie=B.decorations&&!!B.decorations.strikeThrough,ee=B.decorations&&!!B.decorations.faded,K=B.contextValue||"";return{rawResource:[O,U,_,J,ie,ee,K,z],handle:O}});return{start:q.start,deleteCount:q.deleteCount,toInsert:M}}),F=D.map(({start:q,deleteCount:M,toInsert:B})=>[q,M,B.map(O=>O.rawResource)]),x=D.reverse();for(const{start:q,deleteCount:M,toInsert:B}of x){const O=B.map(z=>z.handle),U=this.n.splice(q,M,...O);for(const z of U)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=c,F}dispose(){this.l=!0,this.m.fire()}}n.d=0;class m{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(c){this.g!==c&&(this.g=c,Be(this,d,"f").$updateSourceControl(this.t,{count:c}))}get quickDiffProvider(){return this.h}set quickDiffProvider(c){this.h=c,Be(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this.j}set commitTemplate(c){c!==this.j&&(this.j=c,Be(this,d,"f").$updateSourceControl(this.t,{commitTemplate:c}))}get acceptInputCommand(){return this.l}set acceptInputCommand(c){this.k.value=new u.DisposableStore,this.l=c;const w=this.v.converter.toInternal(c,this.k.value);Be(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:w})}get actionButton(){return(0,E.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(c){(0,E.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new u.DisposableStore,this.n=c;const w=c!==void 0?{command:this.v.converter.toInternal(c.command,this.m.value),secondaryCommands:c.secondaryCommands?.map(D=>D.map(F=>this.v.converter.toInternal(F,this.m.value))),description:c.description,enabled:c.enabled}:void 0;Be(this,d,"f").$updateSourceControl(this.t,{actionButton:w??null})}get statusBarCommands(){return this.p}set statusBarCommands(c){if(this.p&&c&&r(this.p,c))return;this.o.value=new u.DisposableStore,this.p=c;const w=(c||[]).map(D=>this.v.converter.toInternal(D,this.o.value));Be(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:w})}get selected(){return this.q}constructor(c,w,D,F,x,q){this.u=c,this.v=D,this.w=F,this.x=x,this.y=q,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new u.MutableDisposable,this.l=void 0,this.m=new u.MutableDisposable,this.o=new u.MutableDisposable,this.p=void 0,this.q=!1,this.s=new R.Emitter,this.onDidChangeSelection=this.s.event,this.t=m.d++,this.z=new Map,this.A=new Set,Je(this,d,w,"f"),this.f=new o(c,Be(this,d,"f"),this.t),Be(this,d,"f").$registerSourceControl(this.t,F,x,q)}createResourceGroup(c,w){const D=new n(Be(this,d,"f"),this.v,this.t,c,w),F=R.Event.once(D.onDidDispose)(()=>this.z.delete(D));return this.z.set(D,F),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const c=[],w=[];for(const[D,F]of this.z){F.dispose();const x=D.onDidUpdateResourceStates(()=>{this.A.add(D),this.eventuallyUpdateResourceStates()});R.Event.once(D.onDidDispose)(()=>{this.A.delete(D),x.dispose(),this.e.delete(D.handle),Be(this,d,"f").$unregisterGroup(this.t,D.handle)}),c.push([D.handle,D.id,D.label,D.features]);const q=D._takeResourceStateSnapshot();q.length>0&&w.push([D.handle,q]),this.e.set(D.handle,D)}Be(this,d,"f").$registerGroups(this.t,c,w),this.z.clear()}eventuallyUpdateResourceStates(){const c=[];this.A.forEach(w=>{const D=w._takeResourceStateSnapshot();D.length!==0&&c.push([w.handle,D])}),c.length>0&&Be(this,d,"f").$spliceResourceStates(this.t,c),this.A.clear()}getResourceGroup(c){return this.e.get(c)}setSelectionState(c){this.q=c,this.s.fire(c)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(c=>c.dispose()),Be(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,m.d=0,qe([(0,T.debounce)(100)],m.prototype,"eventuallyAddResourceGroups",null),qe([(0,T.debounce)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let s=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(c,w,D){this.l=w,this.m=D,this.g=new Map,this.h=new Map,this.j=new R.Emitter,this.e=c.getProxy(A.MainContext.MainThreadSCM),this.f=c.getProxy(A.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===3){const x=this.g.get(F.sourceControlHandle);if(!x)return F;const q=x.getResourceGroup(F.groupHandle);return q?q.getResourceState(F.handle):F}else if(F&&F.$mid===4){const x=this.g.get(F.sourceControlHandle);return x?x.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===5){const x=this.g.get(F.handle);return x||F}return F}})}createSourceControl(c,w,D,F){this.m.trace("ExtHostSCM#createSourceControl",c.identifier.value,w,D,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const x=on.d++,q=new m(c,this.e,this.l,w,D,F);this.g.set(x,q);const M=this.h.get(k.ExtensionIdentifier.toKey(c.identifier))||[];return M.push(q),this.h.set(k.ExtensionIdentifier.toKey(c.identifier),M),q}getLastInputBox(c){this.m.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const w=this.h.get(k.ExtensionIdentifier.toKey(c.identifier)),D=w&&w[w.length-1];return D&&D.inputBox}$provideOriginalResource(c,w,D){const F=a.URI.revive(w);this.m.trace("ExtHostSCM#$provideOriginalResource",c,F.toString());const x=this.g.get(c);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(F,D)).then(q=>q||null)}$onInputBoxValueChange(c,w){this.m.trace("ExtHostSCM#$onInputBoxValueChange",c);const D=this.g.get(c);return D&&D.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(c,w,D,F){this.m.trace("ExtHostSCM#$executeResourceCommand",c,w,D);const x=this.g.get(c);if(!x)return Promise.resolve(void 0);const q=x.getResourceGroup(w);return q?q.$executeResourceCommand(D,F):Promise.resolve(void 0)}$validateInput(c,w,D){this.m.trace("ExtHostSCM#$validateInput",c);const F=this.g.get(c);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>F.inputBox.validateInput(w,D)).then(x=>{if(!x)return Promise.resolve(void 0);const q=P.MarkdownString.fromStrict(x.message);return q?Promise.resolve([q,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this.g.get(c)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=c,Promise.resolve(void 0)}};s.d=0,s=qe([We(2,L.ILogService)],s),e.ExtHostSCM=s}),define(ye[98],De([1,0,5,3,4]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class u{constructor(A){this.b=new R.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,I){return this.a.$setPassword(A,y,I)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=u,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)};define(ye[271],De([1,0,7,5,179,6,14,9]),function(te,e,a,R,T,u,C,A){"use strict";var y,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(E,h,d,f,p=a.StatusBarAlignment.Left,b){y.set(this,void 0),I.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new u.DisposableStore,Je(this,y,E,"f"),Je(this,I,h,"f"),this.c=L.a++,this.e=d,this.f=f,this.g=p,this.h=this.u(b)}u(E){if(!!(0,A.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(E){this.k=E,this.v()}set name(E){this.m=E,this.v()}set tooltip(E){this.l=E,this.v()}set color(E){this.n=E,this.v()}set backgroundColor(E){E&&!L.b.has(E.id)&&(E=void 0),this.o=E,this.v()}set command(E){this.r?.fromApi!==E&&(this.p&&this.q.add(this.p),this.p=new u.DisposableStore,typeof E=="string"?this.r={fromApi:E,internal:Be(this,I,"f").toInternal({title:"",command:E},this.p)}:E?this.r={fromApi:E,internal:Be(this,I,"f").toInternal(E,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(E){this.t=E,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let E;this.e?this.f?E=`${this.e.identifier.value}.${this.f}`:E=this.e.identifier.value:E=this.f;let h;this.m?h=this.m:h=(0,T.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=L.b.get(this.o.id));const f=C.MarkdownString.fromStrict(this.l);Be(this,y,"f").$setEntry(this.c,E,h,this.k,f,this.r?.internal,d,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,I=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(E){this.b=[],this.a=E.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,T.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(E){const h={message:E};return this.b.unshift(h),this.c(),new a.Disposable(()=>{const d=this.b.indexOf(h);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(E,h){this.a=E.getProxy(R.MainContext.MainThreadStatusBar),this.b=h,this.c=new k(this)}createStatusBarEntry(E,h,d,f){return new L(this.a,this.b,E,h,d,f)}setStatusBarMessage(E,h){const d=this.c.setMessage(E);let f;return typeof h=="number"?f=setTimeout(()=>d.dispose(),h):typeof h<"u"&&h.then(()=>d.dispose(),()=>d.dispose()),new a.Disposable(()=>{d.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=v}),define(ye[99],De([1,0,5,3,4]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class u{constructor(A,y){this.c=y,this.b=new R.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,I){const L=await this.a.$initializeExtensionStorage(A,y);let k;return L&&(k=this.d(A,y,L)),k||I}setValue(A,y,I){return this.a.$setValue(A,y,I)}$acceptValue(A,y,I){const L=this.d(A,y,I);L&&this.b.fire({shared:A,key:y,value:L})}d(A,y,I){try{return JSON.parse(I)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${L}`)}}}e.ExtHostStorage=u,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ye[78],De([1,0,4,25,13,77,2]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let A=class{constructor(I,L,k){this.d=L,this.f=k,this.a=I.workspace??void 0,this.b=I.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(I){return C.URI.joinPath(this.b.workspaceStorageHome,I)}async h(){if(!this.a)return Promise.resolve(void 0);const I=this.a.id,L=await this.g(I);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(C.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(I){if(this.c)return C.URI.joinPath(this.c,I.identifier.value)}globalValue(I){return C.URI.joinPath(this.b.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([We(0,R.IExtHostInitDataService),We(1,T.ILogService),We(2,u.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ye[41],De([1,0,3,5,4,2,18,6,7,180,11,212,21,30,213,51,9,17,14]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class b{constructor(s,i,c,w){this.k=s,this._id=i,this.l=c,this.m=w,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(F=>this.f=F);const D=this;this.value={get name(){return D.m||""},get processId(){return D.b},get creationOptions(){return D.l},get exitStatus(){return D.h},get state(){return D.j},sendText(F,x=!0){D.o(),D.k.$sendText(D._id,F,x)},show(F){D.o(),D.k.$show(D._id,F)},hide(){D.o(),D.k.$hide(D._id)},dispose(){D.a||(D.a=!0,D.k.$dispose(D._id))},get dimensions(){if(!(D.d===void 0||D.g===void 0))return{columns:D.d,rows:D.g}}}}async create(s,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:s.name,shellPath:(0,d.withNullAsUndefined)(s.shellPath),shellArgs:(0,d.withNullAsUndefined)(s.shellArgs),cwd:(0,d.withNullAsUndefined)(s.cwd),env:(0,d.withNullAsUndefined)(s.env),icon:(0,d.withNullAsUndefined)(o(s.iconPath)),color:h.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,d.withNullAsUndefined)(s.message),strictEnv:(0,d.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(i?.useShellEnvironment),location:i?.location||this.n(s.location,i?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(s.isTransient)})}async createExtensionTerminal(s,i,c,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:c,color:h.ThemeColor.isThemeColor(w)?w.id:void 0,location:this.n(s,i),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(s,i){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&i?{parentTerminal:i}:"viewColumn"in s?{viewColumn:p.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus}:void 0:s}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(s){this.m=s}setExitStatus(s,i){this.h=Object.freeze({code:s,reason:i})}setDimensions(s,i){return s===this.d&&i===this.g||s===0||i===0?!1:(this.d=s,this.g=i,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(s){this.f?(this.f(s),this.f=void 0):this.b.then(i=>{i!==s&&(this.b=Promise.resolve(s))})}}e.ExtHostTerminal=b;class S{get onProcessReady(){return this.b.event}constructor(s){this.g=s,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,i){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${i}`)}async start(){}shutdown(){this.g.close()}input(s){this.g.handleInput?.(s)}resize(s,i){this.g.setDimensions?.({columns:s,rows:i})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this.g.onDidWrite(i=>this.a.fire(i)),this.g.onDidClose?.((i=void 0)=>{this.f.fire(i===void 0?void 0:i)}),this.g.onDidOverrideDimensions?.(i=>{i&&this.d.fire({type:"overrideDimensions",value:{cols:i.columns,rows:i.rows}})}),this.g.onDidChangeName?.(i=>{this.d.fire({type:"title",value:i})}),this.g.open(s||void 0),s&&this.g.setDimensions?.(s),this.b.fire({pid:-1,cwd:""})}}let g=1,t=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(s=>s.value)}get onDidWriteTerminalData(){return this.I.event}constructor(s,i){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new a.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new a.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=i.getProxy(R.MainContext.MainThreadTerminalService),this.s=new E.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(s),this.B({dispose:()=>{for(const[c,w]of this.g)w.shutdown(!0)}})}getDefaultShell(s){return(s?this.n:this.m)?.path||""}getDefaultShellArgs(s){return(s?this.n:this.m)?.args||[]}createExtensionTerminal(s,i){const c=new b(this.a,(0,P.generateUuid)(),s,s.name),w=new S(s.pty);return c.createExtensionTerminal(s.location,this.L(s,i).resolvedExtHostIdentifier,o(s.iconPath),n(s.color)).then(D=>{const F=this.M(D,w);this.h[D]=F}),this.f.push(c),c.value}L(s,i){if(i=i||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const c=s.location.parentTerminal;if(c){const w=this.f.find(D=>D.value===c);w&&(i.resolvedExtHostIdentifier=w._id)}}else s.location&&typeof s.location!="object"?i.location=s.location:i.location&&typeof i.location=="object"&&"splitActiveTerminal"in i.location&&(i.location={splitActiveTerminal:!0});return i}attachPtyToTerminal(s,i){if(!this.O(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const w=new S(i),D=this.M(s,w);this.h[s]=D}async $acceptActiveTerminalChanged(s){const i=this.b;if(s===null){this.b=void 0,i!==this.b&&this.F.fire(this.b);return}const c=this.O(s);c&&(this.b=c,i!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(s,i){const c=this.O(s);c&&this.I.fire({terminal:c.value,data:i})}async $acceptTerminalDimensions(s,i,c){const w=this.O(s);w&&w.setDimensions(i,c)&&this.G.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(s,i,c){this.g.get(s)?.resize(i,c)}async $acceptTerminalTitleChange(s,i){const c=this.O(s);c&&(c.name=i)}async $acceptTerminalClosed(s,i,c){const w=this.Q(this.f,s);if(w!==null){const D=this.f.splice(w,1)[0];D.setExitStatus(i,c),this.C.fire(D.value)}}$acceptTerminalOpened(s,i,c,w){if(i){const x=this.Q(this.f,i);if(x!==null){this.f[x]._id=s,this.D.fire(this.terminals[x]),this.f[x].isOpen=!0;return}}const D={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:u.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},F=new b(this.a,s,D,c);this.f.push(F),this.D.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(s,i){this.O(s)?._setProcessId(i)}async $startExtensionTerminal(s,i){const c=this.O(s);if(!c)return{message:(0,I.localize)(0,null,s)};c.isOpen||await new Promise(D=>{const F=this.onDidOpenTerminal(async x=>{x===c.value&&(F.dispose(),D())})});const w=this.g.get(s);w?w.startSendingEvents(i):this.j[s]={initialDimensions:i}}M(s,i){const c=new A.DisposableStore;c.add(i.onProcessReady(D=>this.a.$sendProcessReady(s,D.pid,D.cwd))),c.add(i.onDidChangeProperty(D=>this.a.$sendProcessProperty(s,D))),this.s.startBuffering(s,i.onProcessData),c.add(i.onProcessExit(D=>this.N(s,D))),this.g.set(s,i);const w=this.j[s];return w&&i instanceof S&&(i.startSendingEvents(w.initialDimensions),delete this.j[s]),c}$acceptProcessAckDataEvent(s,i){this.g.get(s)?.acknowledgeDataEvent(i)}$acceptProcessInput(s,i){this.g.get(s)?.input(i)}$acceptTerminalInteraction(s){const i=this.O(s);i?.setInteractedWith()&&this.H.fire(i.value)}$acceptProcessResize(s,i,c){try{this.g.get(s)?.resize(i,c)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(s,i){this.g.get(s)?.shutdown(i)}$acceptProcessRequestInitialCwd(s){this.g.get(s)?.getInitialCwd().then(i=>this.a.$sendProcessProperty(s,{type:"initialCwd",value:i}))}$acceptProcessRequestCwd(s){this.g.get(s)?.getCwd().then(i=>this.a.$sendProcessProperty(s,{type:"cwd",value:i}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this.u.add(s),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(s),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(s,i,c){if(this.v.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this.v.set(i,c),this.a.$registerProfileProvider(i,s.identifier.value),new y.Disposable(()=>{this.v.delete(i),this.a.$unregisterProfileProvider(i)})}registerTerminalQuickFixProvider(s,i,c){if(this.w.has(s))throw new Error(`Terminal quick fix provider "${s}" is already registered`);return this.w.set(s,c),this.a.$registerQuickFixProvider(s,i),new y.Disposable(()=>{this.w.delete(s),this.a.$unregisterQuickFixProvider(s)})}async $provideTerminalQuickFixes(s,i){const c=new v.CancellationTokenSource().token;if(c.isCancellationRequested)return;const w=this.w.get(s);if(!w)return;const D=await w.provideTerminalQuickFixes(i,c);if(D!==null)return D}async $createContributedProfileTerminal(s,i){const c=new v.CancellationTokenSource().token;let w=await this.v.get(s)?.provideTerminalProfile(c);if(!c.isCancellationRequested){if(w&&!("options"in w)&&(w={options:w}),!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,i);return}this.createTerminalFromOptions(w.options,i)}}async $provideLinks(s,i){const c=this.O(s);if(!c)return[];this.y.delete(s),this.z.get(s)?.dispose(!0);const D=new v.CancellationTokenSource;this.z.set(s,D);const F=[],x={terminal:c.value,line:i},q=[];for(const O of this.u)q.push(f.Promises.withAsyncBody(async U=>{D.token.onCancellationRequested(()=>U({provider:O,links:[]}));const z=await O.provideTerminalLinks(x,D.token)||[];D.token.isCancellationRequested||U({provider:O,links:z})}));const M=await Promise.all(q);if(D.token.isCancellationRequested)return[];const B=new Map;for(const O of M)O&&O.links.length>0&&F.push(...O.links.map(U=>{const z={id:g++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set(z.id,{provider:O.provider,link:U}),z}));return this.y.set(s,B),F}$activateLink(s,i){const c=this.y.get(s)?.get(i);!c||c.provider.handleTerminalLink(c.link)}N(s,i){this.s.stopBuffering(s),this.g.delete(s),delete this.j[s];const c=this.h[s];c&&(c.dispose(),delete this.h[s]),this.a.$sendProcessExit(s,i)}O(s){return this.P(this.f,s)}P(s,i){const c=this.Q(s,i);return c!==null?s[c]:null}Q(s,i){let c=null;return s.some((w,D)=>w._id===i?(c=D,!0):!1),c}getEnvironmentVariableCollection(s){let i=this.l.get(s.identifier.value);return i||(i=new l,this.S(s.identifier.value,i)),i}R(s,i){const c=(0,k.serializeEnvironmentVariableCollection)(i.map);this.a.$setEnvironmentVariableCollection(s,i.persistent,c.length===0?void 0:c)}$initEnvironmentVariableCollections(s){s.forEach(i=>{const c=i[0],w=new l(i[1]);this.S(c,w)})}$acceptDefaultProfile(s,i){const c=this.m;this.m=s,this.n=i,c?.path!==s.path&&this.J.fire(s.path)}S(s,i){this.l.set(s,i),i.onDidChangeCollection(()=>{this.R(s,i)})}};t=qe([We(1,C.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class l{get persistent(){return this.a}set persistent(s){this.a=s,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(s){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(s)}get size(){return this.map.size}replace(s,i){this.d(s,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(s,i){this.d(s,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(s,i){this.d(s,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}d(s,i){const c=this.map.get(s);(!c||c.value!==i.value||c.type!==i.type)&&(this.map.set(s,i),this.b.fire())}get(s){return this.map.get(s)}forEach(s,i){this.map.forEach((c,w)=>s.call(i,w,c,this))}[Symbol.iterator](){return this.map.entries()}delete(s){this.map.delete(s),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends t{constructor(s){super(!1,s)}createTerminal(s,i,c){throw new L.NotSupportedError}createTerminalFromOptions(s,i){throw new L.NotSupportedError}};r=qe([We(0,C.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function o(m){if(!(!m||typeof m=="string"))return"id"in m?{id:m.id,color:m.color}:m}function n(m){return h.ThemeColor.isThemeColor(m)?m:void 0}});var Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a};define(ye[272],De([1,0,15,17,22,21,3,63,87,6,23,9,30,5,18,137,14,7,57,93,75,27]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S,g){"use strict";var t,l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(O,U,z){this.j=z,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=O.getProxy(P.MainContext.MainThreadTesting),this.h=new x(this.f),this.g=new s(this.f),U.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const le=j,V=le.tests[le.tests.length-1].item.extId;return this.d.get(p.TestId.root(V))?.collection.tree.get(V)?.actual??(0,h.toItemFromContext)(j)}})}createTestController(O,U,z,j){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const le=new I.DisposableStore,V=le.add(new h.ExtHostTestItemCollection(U,z,this.j));V.root.label=z;const _=new Map,J=this.f,ie={items:V.root.children,get label(){return z},set label(K){z=K,V.root.label=K,J.$updateController(U,{label:z})},get refreshHandler(){return j},set refreshHandler(K){j=K,J.$updateController(U,{canRefresh:!!K})},get id(){return U},createRunProfile:(K,G,de,be,Ee,Pe)=>{let Fe=(0,y.hash)(K);for(;_.has(Fe);)Fe++;return Pe!==void 0&&(0,g.checkProposedApiEnabled)(O,"testContinuousRun"),new q(this.f,_,U,Fe,K,G,de,be,Ee,Pe)},createTestItem(K,G,de){return new h.TestItemImpl(U,K,G,de)},createTestRun:(K,G,de=!0)=>this.g.createTestRun(U,V,K,G,de),set resolveHandler(K){V.resolveHandler=K},get resolveHandler(){return V.resolveHandler},dispose:()=>{le.dispose()}};J.$registerTestController(U,z,!!j),le.add((0,I.toDisposable)(()=>J.$unregisterTestController(U)));const ee={controller:ie,collection:V,profiles:_};return this.d.set(U,ee),le.add((0,I.toDisposable)(()=>this.d.delete(U))),le.add(V.onDidGenerateDiff(K=>J.$publishDiff(U,K.map(S.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.h.checkout()}async runTests(O,U=u.CancellationToken.None){const z=i(O);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(z.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(le=>p.TestId.fromExtHostTestItem(le,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:M[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:O.exclude?.map(le=>le.id)},U)}$syncTests(){for(const{collection:O}of this.d.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,U,z){return(0,a.mapFind)(this.g.trackers,le=>le.id===O?le.getCoverage(U):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(O,U,z,j){return(0,a.mapFind)(this.g.trackers,V=>V.id===O?V.getCoverage(U):void 0)?.resolveFileCoverage(z,j)??Promise.resolve([])}$configureRunProfile(O,U){this.d.get(O)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(O,U){await this.d.get(O)?.controller.refreshHandler?.(U)}$publishTestResults(O){this.results=Object.freeze(O.map(U=>(0,L.deepFreeze)(d.TestResults.to(U))).concat(this.results).sort((U,z)=>z.completedAt-U.completedAt).slice(0,32)),this.c.fire()}async $expandTest(O,U){const z=this.d.get(p.TestId.fromString(O).controllerId)?.collection;z&&(await z.expand(O,U<0?1/0:U),z.flushDiff())}$acceptDiff(O){this.h.applyDiff(O.map(S.TestsDiffOp.deserialize))}async $runControllerTests(O,U){return Promise.all(O.map(z=>this.k(z,!1,U)))}async $startContinuousRun(O,U){const z=new u.CancellationTokenSource(U),j=await Promise.all(O.map(le=>this.k(le,!0,z.token)));return!U.isCancellationRequested&&!j.some(le=>le.error)&&await new Promise(le=>U.onCancellationRequested(le)),z.dispose(!0),j}async k(O,U,z){const j=this.d.get(O.controllerId);if(!j)return{};const{collection:le,profiles:V}=j,_=V.get(O.profileId);if(!_)return{};const J=O.testIds.map(G=>le.tree.get(G)).filter(k.isDefined),ie=O.excludeExtIds.map(G=>j.collection.tree.get(G)).filter(k.isDefined).filter(G=>J.some(de=>de.fullId.compare(G.fullId)===2));if(!J.length)return{};const ee=new f.TestRunRequest2(J.some(G=>G.actual instanceof h.TestItemRootImpl)?void 0:J.map(G=>G.actual),ie.map(G=>G.actual),_,U),K=(0,S.isStartControllerTests)(O)&&this.g.prepareForMainThreadTestRun(ee,c.fromInternal(O,j.collection),z);try{return await _.runHandler(ee,z),{}}catch(G){return{error:String(G)}}finally{K&&(K.hasRunningTasks&&!z.isCancellationRequested&&await C.Event.toPromise(K.onEnd),K.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.g.cancelAllRuns():this.g.cancelRunById(O)}};r=qe([We(0,E.IExtHostRpcService)],r),e.ExtHostTesting=r;const o=1e4;var n;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(n||(n={}));class m extends I.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(O,U,z){super(),this.k=O,this.l=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new u.CancellationTokenSource(z));const j=this.B(new R.RunOnceScheduler(()=>this.m(),o));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(O){return this.f.get(O)?.coverage}createRun(O){const U=this.k.id,z=this.k.controllerId,j=(0,v.generateUuid)(),le=new w(this.l,U,j),V=ee=>(K,...G)=>{if(J){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(K)||(this.s(K),ee(K,...G))},_=(ee,K)=>{const G=K instanceof Array?K.map(d.TestMessage.from):[d.TestMessage.from(K)];if(ee.uri&&ee.range){const de={range:d.Range.from(ee.range),uri:ee.uri};for(const be of G)be.location=be.location||de}this.l.$appendTestMessagesInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),G)};let J=!1;const ie={isPersisted:this.k.isPersisted,token:this.h.token,name:O,get coverageProvider(){return le.coverageProvider},set coverageProvider(ee){le.coverageProvider=ee},enqueued:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),1)}),skipped:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),5)}),started:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),2)}),errored:V((ee,K,G)=>{_(ee,K),this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),6,G)}),failed:V((ee,K,G)=>{_(ee,K),this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),4,G)}),passed:V((ee,K)=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,this.k.controllerId).toString(),3,K)}),appendOutput:(ee,K,G)=>{J||(G&&(this.k.isIncluded(G)?this.s(G):G=void 0),this.l.$appendOutputToRun(U,j,T.VSBuffer.fromString(ee),K&&d.location.from(K),G&&p.TestId.fromExtHostTestItem(G,z).toString()))},end:()=>{J||(J=!0,this.l.$finishedTestRunTask(U,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ie,coverage:le}),this.l.$startedTestRunTask(U,{id:j,name:O,running:!0}),ie}m(){for(const{run:O}of this.f.values())O.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(O){if(!(O instanceof h.TestItemImpl))throw new b.InvalidTestItemError(O.id);if(this.g.has(p.TestId.fromExtHostTestItem(O,this.k.controllerId).toString()))return;const U=[],z=this.k.colllection.root;for(;;){const j=d.TestItem.from(O);if(U.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),O===z))break;O=O.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,U)}}class s{get trackers(){return this.c.values()}constructor(O){this.d=O,this.c=new Map}prepareForMainThreadTestRun(O,U,z){return this.f(O,U,z)}cancelRunById(O){for(const U of this.c.values())if(U.id===O){U.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,U,z,j,le){const V=this.c.get(z);if(V)return V.createRun(j);const _=c.fromPublic(O,U,z,le),J=i(z);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!z.continuous,profile:J&&{group:M[J.kind],id:J.profileId},exclude:z.exclude?.map(ee=>p.TestId.fromExtHostTestItem(ee,U.root.id).toString())??[],id:_.id,include:z.include?.map(ee=>p.TestId.fromExtHostTestItem(ee,U.root.id).toString())??[U.root.id],persist:le});const ie=this.f(z,_);return ie.onEnd(()=>{this.d.$finishedExtensionTestRun(_.id),ie.dispose()}),ie.createRun(j)}f(O,U,z){const j=new m(U,this.d,z);return this.c.set(O,j),j.onEnd(()=>this.c.delete(O)),j}}e.TestRunCoordinator=s;const i=B=>{if(!!B.profile){if(!(B.profile instanceof q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class c{static fromPublic(O,U,z,j){return new c(O,(0,v.generateUuid)(),z.include?.map(le=>p.TestId.fromExtHostTestItem(le,O).toString())??[O],z.exclude?.map(le=>p.TestId.fromExtHostTestItem(le,O).toString())??[],j,U)}static fromInternal(O,U){return new c(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,U)}constructor(O,U,z,j,le,V){this.controllerId=O,this.id=U,this.isPersisted=le,this.colllection=V,this.c=z.map(_=>_+"\0"),this.d=j.map(_=>_+"\0")}isIncluded(O){const U=p.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const z of this.d)if(U===z||U.startsWith(z))return!1;for(const z of this.c)if(U===z||U.startsWith(z))return!0;return!1}}e.TestRunDto=c;class w{set coverageProvider(O){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this.c=O,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(O,U,z){this.f=O,this.g=U,this.h=z}async provideFileCoverage(O){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(O))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(U){throw this.d=void 0,U}}async resolveFileCoverage(O,U){const z=await this.d;let j=z?.[O];return!this.c||!z||!j?[]:(j.detailedCoverage||(j=z[O]=await this.c.resolveFileCoverage?.(j,U)??j),j.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class D{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,d.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const U=p.TestId.parentId(O.item.extId);if(U&&this.g.has(U.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:U,f:z}=this;return{get added(){return[...O].map(j=>j.revived)},get updated(){return[...U].map(j=>j.revived)},get removed(){return[...z].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class F extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,U){return{...O,revived:d.TestItem.toPlain(O.item),depth:U?U.depth+1:0,children:new Set}}o(){return new D(this.q)}}class x{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(U=>U.revived)},dispose:(0,A.once)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new F;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class q{get label(){return this.d}set label(O){O!==this.d&&(this.d=O,Be(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,Be(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,Be(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Be(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?d.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,Be(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,U,z,j,le,V,_,J=!1,ie=void 0,ee=!1){this.controllerId=z,this.profileId=j,this.d=le,this.kind=V,this.runHandler=_,this.f=J,this._tag=ie,this.g=ee,t.set(this,void 0),l.set(this,void 0),Je(this,t,O,"f"),Je(this,l,U,"f"),U.set(j,this);const K=M[V];if(typeof K!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Be(this,t,"f").$publishTestRunProfile({profileId:j,controllerId:z,tag:ie?d.TestTag.namespace(this.controllerId,ie.id):null,label:le,group:K,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:ee})}dispose(){Be(this,l,"f")?.delete(this.profileId)&&(Je(this,l,void 0,"f"),Be(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=q,t=new WeakMap,l=new WeakMap;const M={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(ye[273],De([1,0,15,3,5,138,14,7]),function(te,e,a,R,T,u,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(L,k){this.i=k,this.a=new R.Emitter,this.b=new R.Emitter,this.c=new R.Emitter,this.d=new R.Emitter,this.f=new R.Emitter,this.g=new R.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(T.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const k=this.i.allEditors();return L?k:k.map(v=>v.value)}async showTextDocument(L,k,v){let P;typeof k=="number"?P={position:C.ViewColumn.from(k),preserveFocus:v}:typeof k=="object"?P={position:C.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?C.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:P={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(L.uri,P),h=E&&this.i.getEditor(E);if(h)return h.value;throw E?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,k){return new u.TextEditorDecorationType(this.h,L,k).value}$acceptEditorPropertiesChanged(L,k){const v=this.i.getEditor(L);if(!v)throw new Error("unknown text editor");if(k.options&&v._acceptOptions(k.options),k.selections){const P=k.selections.selections.map(C.Selection.to);v._acceptSelections(P)}if(k.visibleRanges){const P=a.coalesce(k.visibleRanges.map(C.Range.to));v._acceptVisibleRanges(P)}if(k.options&&this.b.fire({textEditor:v.value,options:{...k.options,lineNumbers:C.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const P=A.TextEditorSelectionChangeKind.fromValue(k.selections.source),E=k.selections.selections.map(C.Selection.to);this.a.fire({textEditor:v.value,selections:E,kind:P})}if(k.visibleRanges){const P=a.coalesce(k.visibleRanges.map(C.Range.to));this.c.fire({textEditor:v.value,visibleRanges:P})}}$acceptEditorPositionData(L){for(const k in L){const v=this.i.getEditor(k);if(!v)throw new Error("Unknown text editor");const P=C.ViewColumn.to(L[k]);v.value.viewColumn!==P&&(v._acceptViewColumn(P),this.d.fire({textEditor:v.value,viewColumn:P}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=y}),define(ye[274],De([1,0,2,4,5,6,7,14,26,9]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class L{constructor(P,E){this.b=new Map,this.c=new Map,this.a=P.getProxy(T.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:(h,d)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&y.ExtensionIdentifier.equals(d,this.b.get(h.source)?.extension)){const f=h.uri===void 0?void 0:a.URI.revive(h.uri);return this.c.get(h.source)?.get(k(f))?.get(h.handle)}else return;return h}})}async $getTimeline(P,E,h,d){return this.b.get(P)?.provider.provideTimeline(a.URI.revive(E),h,d)}registerTimelineProvider(P,E,h,d){const f=new u.DisposableStore,p=this.d(E.id,d,f).bind(this);let b;E.onDidChange&&(b=E.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:E.id}),this));const S=this.c;return this.f({...E,scheme:P,onDidChange:void 0,async provideTimeline(g,t,l){t?.resetCache&&(f.clear(),S.get(E.id)?.clear());const r=await E.provideTimeline(g,t,l);if(r==null)return;const o=p(g,t);return{...r,source:E.id,items:r.items.map(o)}},dispose(){for(const g of S.values())g.get(E.id)?.clear();b?.dispose(),f.dispose()}},h)}d(P,E,h){return(d,f)=>{let p;if(f?.cacheResults){let b=this.c.get(P);b===void 0&&(b=new Map,this.c.set(P,b));const S=k(d);p=b.get(S),p===void 0&&(p=new Map,b.set(S,p))}return b=>{const{iconPath:S,...g}=b,t=`${P}|${b.id??b.timestamp}`;p?.set(t,b);let l,r,o;b.iconPath&&(S instanceof C.ThemeIcon?o={id:S.id,color:S.color}:a.URI.isUri(S)?(l=S,r=S):{light:l,dark:r}=S);let n;return C.MarkdownString.isMarkdownString(g.tooltip)?n=A.MarkdownString.from(g.tooltip):(0,I.isString)(g.tooltip)?n=g.tooltip:C.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=A.MarkdownString.from(g.detail)):(0,I.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=g.detail),{...g,id:g.id??void 0,handle:t,source:P,command:b.command?E.toInternal(b.command,h):void 0,icon:l,iconDark:r,themeIcon:o,tooltip:n,accessibilityInformation:b.accessibilityInformation}}}}f(P,E){if(this.b.get(P.id))throw new Error(`Timeline Provider ${P.id} already exists.`);return this.a.$registerTimelineProvider({id:P.id,label:P.label,scheme:P.scheme}),this.b.set(P.id,{provider:P,extension:E}),(0,u.toDisposable)(()=>{for(const d of this.c.values())d.get(P.id)?.clear();this.b.delete(P.id),this.a.$unregisterTimelineProvider(P.id),P.dispose()})}}e.ExtHostTimeline=L;function k(v){return v?.toString()}}),define(ye[275],De([1,0,6,16,2,5]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(y){this.c=new Map,this.b=y.getProxy(u.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,I,L,k){if(this.c.has(I))throw new Error(`Opener with id '${I}' already registered`);const v=k.schemes.find(P=>!C.a.has(P));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(I,L),this.b.$registerUriOpener(I,k.schemes,y,k.label),(0,a.toDisposable)(()=>{this.c.delete(I),this.b.$unregisterUriOpener(I)})}async $canOpenUri(y,I,L){const k=this.c.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const v=T.URI.revive(I);return k.canOpenExternalUri(v,L)}async $openUri(y,I,L){const k=this.c.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(T.URI.revive(I.resolvedUri),{sourceUri:T.URI.revive(I.sourceUri)},L)}}e.ExtHostUriOpeners=C,C.a=new Set([R.Schemas.http,R.Schemas.https])}),define(ye[276],De([1,0,5,2,6,11,26]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(I){this.c=new Set,this.d=new Map,this.b=I.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(I,L){if(this.c.has(C.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const k=A.a++;return this.c.add(C.ExtensionIdentifier.toKey(I)),this.d.set(k,L),this.b.$registerUriHandler(k,I),(0,T.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(I)),this.d.delete(k),this.b.$unregisterUriHandler(k)})}$handleExternalUri(I,L){const k=this.d.get(I);if(!k)return Promise.resolve(void 0);try{k.handleUri(R.URI.revive(L))}catch(v){(0,u.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(I){return R.URI.revive(await this.b.$createAppUri(I))}}e.ExtHostUrls=A,A.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)};define(ye[79],De([1,0,3,16,23,2,196,221,94,5]),function(te,e,a,R,T,u,C,A,y,I){"use strict";var L,k,v,P,E,h,d,f,p,b,S,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(D,F,x,q,M,B,O){L.set(this,void 0),k.set(this,void 0),v.set(this,void 0),P.set(this,void 0),E.set(this,void 0),h.set(this,void 0),d.set(this,""),f.set(this,void 0),p.set(this,!1),b.set(this,!1),S.set(this,void 0),g.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new a.Emitter),this._onDidDispose=Be(this,t,"f").event,Je(this,L,D,"f"),Je(this,k,F,"f"),Je(this,f,x,"f"),Je(this,P,q,"f"),Je(this,E,M,"f"),Je(this,h,B,"f"),Je(this,S,r(B),"f"),Je(this,g,o(B),"f"),Je(this,v,O,"f")}dispose(){Je(this,p,!0,"f"),Be(this,t,"f").fire(),Be(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(D){return Je(this,b,!0,"f"),(0,y.asWebviewUri)(D,Be(this,P,"f"))}get cspSource(){const D=Be(this,h,"f").extensionLocation;if(D.scheme===R.Schemas.https||D.scheme===R.Schemas.http){let F=D.toString();return F.endsWith("/")||(F+="/"),F+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Be(this,d,"f")}set html(D){this.a(),Be(this,d,"f")!==D&&(Je(this,d,D,"f"),Be(this,g,"f")&&!Be(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(D)&&(Je(this,b,!0,"f"),Be(this,v,"f").report("Webview vscode-resource: uris",Be(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,k,"f").$setHtml(Be(this,L,"f"),this.b(D)))}get options(){return this.a(),Be(this,f,"f")}set options(D){this.a(),T.equals(Be(this,f,"f"),D)||Be(this,k,"f").$setOptions(Be(this,L,"f"),s(Be(this,h,"f"),Be(this,E,"f"),D)),Je(this,f,D,"f")}async postMessage(D){if(Be(this,p,"f"))return!1;const F=(0,A.serializeWebviewMessage)(D,{serializeBuffersForPostMessage:Be(this,S,"f")});return Be(this,k,"f").$postMessage(Be(this,L,"f"),F.message,...F.buffers)}a(){if(Be(this,p,"f"))throw new Error("Webview is disposed")}b(D){if(!Be(this,g,"f"))return D;const F=Be(this,h,"f").extensionLocation?.scheme===R.Schemas.vscodeRemote,x=Be(this,h,"f").extensionLocation.scheme===R.Schemas.vscodeRemote?Be(this,h,"f").extensionLocation.authority:void 0;return D.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,M,B,O,U,z)=>{const j=u.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),le=(0,y.asWebviewUri)(j,{isRemote:F,authority:x}).toString();return`${M}${le}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,M,B,O,U,z)=>{const j=u.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),le=(0,y.asWebviewUri)(j,{isRemote:F,authority:x}).toString();return`${M}${le}${z}`})}}e.ExtHostWebview=l,L=new WeakMap,k=new WeakMap,v=new WeakMap,P=new WeakMap,E=new WeakMap,h=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap,b=new WeakMap,S=new WeakMap,g=new WeakMap,t=new WeakMap;function r(w){try{const D=(0,C.normalizeVersion)((0,C.parseVersion)(w.engines.vscode));return!!D&&D.majorBase>=1&&D.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function o(w){try{const D=(0,C.normalizeVersion)((0,C.parseVersion)(w.engines.vscode));return D?D.majorBase<1||D.majorBase===1&&D.minorBase<60:!1}catch{return!1}}class n{constructor(D,F,x,q,M){this.c=F,this.d=x,this.e=q,this.f=M,this.b=new Map,this.a=D.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(D,F,x){const q=this.g(D);if(q){const{message:M}=(0,A.deserializeWebviewMessage)(F,x.value);q._onMessageEmitter.fire(M)}}$onMissingCsp(D,F){this.e.warn(`${F} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(D,F,x){const q=new l(D,this.a,i(F),this.c,this.d,x,this.f);return this.b.set(D,q),q._onDidDispose(()=>{this.b.delete(D)}),q}deleteWebview(D){this.b.delete(D)}g(D){return this.b.get(D)}}e.ExtHostWebviews=n;function m(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=m;function s(w,D,F){return{enableCommandUris:F.enableCommandUris,enableScripts:F.enableScripts,enableForms:F.enableForms,portMapping:F.portMapping,localResourceRoots:F.localResourceRoots||c(w,D)}}e.serializeWebviewOptions=s;function i(w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,enableForms:w.enableForms,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots?.map(D=>u.URI.from(D))}}function c(w,D){return[...(D?.getWorkspaceFolders()||[]).map(F=>F.uri),w.extensionLocation]}}),define(ye[277],De([1,0,21,87,6,16,24,2,14,79,74,5,7]),function(te,e,a,R,T,u,C,A,y,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class P{constructor(l,r){this.document=l,this.b=r,this.a=1,this.c=new L.Cache("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,r){await this.f(l).undo(),r||this.disposeBackup()}async redo(l,r){await this.f(l).redo(),r||this.disposeBackup()}disposeEdits(l){for(const r of l)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=g(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const r=this.c.get(l,0);if(!r)throw new Error("No edit found");return r}}class E{constructor(){this.a=new Map}get(l,r){return this.a.get(this.b(l,r))}add(l,r,o){const n=this.b(l,r.uri);if(this.a.has(n))throw new Error(`Document already exists for viewType:${l} resource:${r.uri}`);const m=new P(r,o);return this.a.set(n,m),m}delete(l,r){const o=this.b(l,r.uri);this.a.delete(o)}b(l,r){return`${l}@@@${r}`}}var h;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(h||(h={}));class d{constructor(){this.a=new Map}addTextProvider(l,r,o){return this.b(0,l,r,o)}addCustomProvider(l,r,o){return this.b(1,l,r,o)}get(l){return this.a.get(l)}b(l,r,o,n){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:l,extension:o,provider:n}),new v.Disposable(()=>this.a.delete(r))}}class f{constructor(l,r,o,n,m){this.d=r,this.f=o,this.g=n,this.h=m,this.b=new d,this.c=new E,this.a=l.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,r,o,n){const m=new T.DisposableStore;return b(o)?(m.add(this.b.addTextProvider(r,l,o)),this.a.$registerTextEditorProvider((0,I.toExtensionData)(l),r,n.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(l))):(m.add(this.b.addCustomProvider(r,l,o)),p(o)&&m.add(o.onDidChangeCustomDocument(s=>{const i=this.i(r,s.document.uri);if(S(s)){const c=i.addEdit(s);this.a.$onDidEdit(s.document.uri,r,c,s.label)}else this.a.$onContentChange(s.document.uri,r)})),this.a.$registerCustomEditorProvider((0,I.toExtensionData)(l),r,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(l))),v.Disposable.from(m,new v.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(l,r,o,n,m){const s=this.b.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provide type for '${r}'`);const i=A.URI.revive(l),c=await s.provider.openCustomDocument(i,{backupId:o,untitledDocumentData:n?.buffer},m);let w;return p(s.provider)&&this.f&&(w=this.f.workspaceValue(s.extension)??this.f.globalValue(s.extension)),this.c.add(r,c,w),{editable:p(s.provider)}}async $disposeCustomDocument(l,r){const o=this.b.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const n=A.URI.revive(l),{document:m}=this.i(r,n);this.c.delete(r,m),m.dispose()}async $resolveCustomEditor(l,r,o,n,m,s){console.log("xxxx");const i=this.b.get(o);if(!i)throw new Error(`No provider found for '${o}'`);const c=y.ViewColumn.to(m),w=this.g.createNewWebview(r,n.contentOptions,i.extension),D=this.h.createNewWebviewPanel(r,o,n.title,c,n.options,w,!0),F=A.URI.revive(l);switch(i.type){case 1:{const{document:x}=this.i(o,F);return i.provider.resolveCustomEditor(x,D,s)}case 0:{const x=this.d.getDocument(F);return i.provider.resolveCustomTextEditor(x,D,s)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,r,o){this.i(r,l).disposeEdits(o)}async $onMoveCustomEditor(l,r,o){const n=this.b.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const m=this.h.getWebviewPanel(l);if(!m)throw new Error("No webview found");const s=A.URI.revive(r),i=this.d.getDocument(s);await n.provider.moveCustomTextEditor(i,m,a.CancellationToken.None)}async $undo(l,r,o,n){return this.i(r,l).undo(o,n)}async $redo(l,r,o,n){return this.i(r,l).redo(o,n)}async $revert(l,r,o){const n=this.i(r,l);await this.j(r).revertCustomDocument(n.document,o),n.disposeBackup()}async $onSave(l,r,o){const n=this.i(r,l);await this.j(r).saveCustomDocument(n.document,o),n.disposeBackup()}async $onSaveAs(l,r,o,n){const m=this.i(r,l);return this.j(r).saveCustomDocumentAs(m.document,A.URI.revive(o),n)}async $backup(l,r,o){const n=this.i(r,l),s=await this.j(r).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},o);return n.updateBackup(s),s.id}i(l,r){const o=this.c.get(l,A.URI.revive(r));if(!o)throw new Error("No custom document found");return o}j(l){const o=this.b.get(l)?.provider;if(!o||!p(o))throw new Error("Custom document is not editable");return o}}e.ExtHostCustomEditors=f;function p(t){return!!t.onDidChangeCustomDocument}function b(t){return typeof t.resolveCustomTextEditor=="function"}function S(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function g(t){const l=t.scheme===u.Schemas.file||t.scheme===u.Schemas.untitled?t.fsPath:t.toString();return(0,R.hash)(l)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)};define(ye[278],De([1,0,3,6,2,30,14,79,5,7]),function(te,e,a,R,T,u,C,A,y,I){"use strict";var L,k,v,P,E,h,d,f,p,b,S,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends R.Disposable{constructor(m,s,i,c){super(),L.set(this,void 0),k.set(this,void 0),v.set(this,void 0),P.set(this,void 0),E.set(this,void 0),h.set(this,void 0),d.set(this,void 0),f.set(this,void 0),p.set(this,!0),b.set(this,void 0),S.set(this,!1),g.set(this,this.B(new a.Emitter)),this.onDidDispose=Be(this,g,"f").event,t.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,Je(this,L,m,"f"),Je(this,k,s,"f"),Je(this,P,i,"f"),Je(this,v,c.viewType,"f"),Je(this,E,c.panelOptions,"f"),Je(this,f,c.viewColumn,"f"),Je(this,h,c.title,"f"),Je(this,b,c.active,"f")}dispose(){Be(this,S,"f")||(Je(this,S,!0,"f"),Be(this,g,"f").fire(),Be(this,k,"f").$disposeWebview(Be(this,L,"f")),Be(this,P,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,P,"f")}get viewType(){return this.c(),Be(this,v,"f")}get title(){return this.c(),Be(this,h,"f")}set title(m){this.c(),Be(this,h,"f")!==m&&(Je(this,h,m,"f"),Be(this,k,"f").$setTitle(Be(this,L,"f"),m))}get iconPath(){return this.c(),Be(this,d,"f")}set iconPath(m){this.c(),Be(this,d,"f")!==m&&(Je(this,d,m,"f"),Be(this,k,"f").$setIconPath(Be(this,L,"f"),T.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Be(this,E,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,f,"f")=="number"&&Be(this,f,"f")<0))return Be(this,f,"f")}get active(){return this.c(),Be(this,b,"f")}get visible(){return this.c(),Be(this,p,"f")}_updateViewState(m){Be(this,S,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(Je(this,b,m.active,"f"),Je(this,p,m.visible,"f"),Je(this,f,m.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(m,s){this.c(),Be(this,k,"f").$reveal(Be(this,L,"f"),{viewColumn:typeof m>"u"?void 0:C.ViewColumn.from(m),preserveFocus:!!s})}c(){if(Be(this,S,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,k=new WeakMap,v=new WeakMap,P=new WeakMap,E=new WeakMap,h=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap,b=new WeakMap,S=new WeakMap,g=new WeakMap,t=new WeakMap;class r{static c(){return(0,u.generateUuid)()}constructor(m,s,i){this.g=s,this.h=i,this.e=new Map,this.f=new Map,this.d=m.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(m,s,i,c,w={}){const D=typeof c=="object"?c.viewColumn:c,F={viewColumn:C.ViewColumn.from(D),preserveFocus:typeof c=="object"&&!!c.preserveFocus},x=(0,A.shouldSerializeBuffersForPostMessage)(m),q=r.c();this.d.$createWebviewPanel((0,A.toExtensionData)(m),q,s,{title:i,panelOptions:o(w),webviewOptions:(0,A.serializeWebviewOptions)(m,this.h,w),serializeBuffersForPostMessage:x},F);const M=this.g.createNewWebview(q,w,m);return this.createNewWebviewPanel(q,s,i,D,w,M,!0)}$onDidChangeWebviewPanelViewStates(m){const s=Object.keys(m);s.sort((i,c)=>{const w=m[i],D=m[c];return w.active?1:D.active?-1:+w.visible-+D.visible});for(const i of s){const c=this.getWebviewPanel(i);if(!c)continue;const w=m[i];c._updateViewState({active:w.active,visible:w.visible,viewColumn:C.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.e.delete(m),this.g.deleteWebview(m)}registerWebviewPanelSerializer(m,s,i){if(this.f.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.f.set(s,{serializer:i,extension:m}),this.d.$registerSerializer(s,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(m)}),new I.Disposable(()=>{this.f.delete(s),this.d.$unregisterSerializer(s)})}async $deserializeWebviewPanel(m,s,i,c){const w=this.f.get(s);if(!w)throw new Error(`No serializer found for '${s}'`);const{serializer:D,extension:F}=w,x=this.g.createNewWebview(m,i.webviewOptions,F),q=this.createNewWebviewPanel(m,s,i.title,c,i.panelOptions,x,i.active);await D.deserializeWebviewPanel(q,i.state)}createNewWebviewPanel(m,s,i,c,w,D,F){const x=new l(m,this.d,D,{viewType:s,title:i,viewColumn:c,panelOptions:w,active:F});return this.e.set(m,x),x}getWebviewPanel(m){return this.e.get(m)}}e.ExtHostWebviewPanels=r;function o(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)};define(ye[279],De([1,0,3,6,79,14,5,7]),function(te,e,a,R,T,u,C,A){"use strict";var y,I,L,k,v,P,E,h,d,f,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends R.Disposable{constructor(t,l,r,o,n,m){super(),y.set(this,void 0),I.set(this,void 0),L.set(this,void 0),k.set(this,void 0),v.set(this,!1),P.set(this,void 0),E.set(this,void 0),h.set(this,void 0),d.set(this,void 0),f.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Be(this,f,"f").event,p.set(this,this.B(new a.Emitter)),this.onDidDispose=Be(this,p,"f").event,Je(this,L,r,"f"),Je(this,E,o,"f"),Je(this,y,t,"f"),Je(this,I,l,"f"),Je(this,k,n,"f"),Je(this,P,m,"f")}dispose(){Be(this,v,"f")||(Je(this,v,!0,"f"),Be(this,p,"f").fire(),Be(this,k,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,E,"f")}set title(t){this.a(),Be(this,E,"f")!==t&&(Je(this,E,t,"f"),Be(this,I,"f").$setWebviewViewTitle(Be(this,y,"f"),t))}get description(){return this.a(),Be(this,h,"f")}set description(t){this.a(),Be(this,h,"f")!==t&&(Je(this,h,t,"f"),Be(this,I,"f").$setWebviewViewDescription(Be(this,y,"f"),t))}get visible(){return Be(this,P,"f")}get webview(){return Be(this,k,"f")}get viewType(){return Be(this,L,"f")}_setVisible(t){t===Be(this,P,"f")||Be(this,v,"f")||(Je(this,P,t,"f"),Be(this,f,"f").fire())}get badge(){return this.a(),Be(this,d,"f")}set badge(t){this.a(),!(t?.value===Be(this,d,"f")?.value&&t?.tooltip===Be(this,d,"f")?.tooltip)&&(Je(this,d,u.ViewBadge.from(t),"f"),Be(this,I,"f").$setWebviewViewBadge(Be(this,y,"f"),t))}show(t){this.a(),Be(this,I,"f").$show(Be(this,y,"f"),!!t)}a(){if(Be(this,v,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,I=new WeakMap,L=new WeakMap,k=new WeakMap,v=new WeakMap,P=new WeakMap,E=new WeakMap,h=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap;class S{constructor(t,l){this.d=l,this.b=new Map,this.c=new Map,this.a=t.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,l,r,o){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,T.toExtensionData)(t),l,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(t,l,r,o,n){const m=this.b.get(l);if(!m)throw new Error(`No view provider found for '${l}'`);const{provider:s,extension:i}=m,c=this.d.createNewWebview(t,{},i),w=new b(t,this.a,l,r,c,!0);this.c.set(t,w),await s.resolveWebviewView(w,{state:o},n)}async $onDidChangeWebviewViewVisibility(t,l){this.e(t)._setVisible(l)}async $disposeWebviewView(t){const l=this.e(t);this.c.delete(t),l.dispose(),this.d.deleteWebview(t)}e(t){const l=this.c.get(t);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=S}),define(ye[141],De([1,0,3,5,2,16,8,4,18]),function(te,e,a,R,T,u,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class an{get state(){return this.d}constructor(k){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=k.getProxy(R.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(k){k!==this.d.focused&&(this.d={...this.d,focused:k},this.c.fire(this.d))}openUri(k,v){let P;if(typeof k=="string"){P=k;try{k=T.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,C.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===u.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,P,v)}async asExternalUri(k,v){if((0,C.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const P=await this.b.$asExternalUri(k,v);return T.URI.from(P)}};I.a={focused:!0},I=qe([We(0,y.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ye[280],De([1,0,119,281,70,40,2,13,47]),function(te,e,a,R,T,u,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(v,P,E){this.b=v,this.c=P,this.f=E,this.a=R.createServer((h,d)=>this.h(h,d)),this.g().catch(h=>(P.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,P){const E=(d,f)=>{P.writeHead(d,{"content-type":"application/json"}),P.end(JSON.stringify(f||null),p=>p&&this.c.error(p))},h=[];v.setEncoding("utf8"),v.on("data",d=>h.push(d)),v.on("end",async()=>{try{const d=JSON.parse(h.join(""));let f;switch(d.type){case"open":f=await this.i(d);break;case"openExternal":f=await this.j(d);break;case"status":f=await this.l(d);break;case"extensionManagement":f=await this.k(d);break;default:E(404,`Unknown message type: ${d.type}`);break}E(200,f)}catch(d){const f=d instanceof Error?d.message:JSON.stringify(d);E(500,f),this.c.error("Error while processing pipe request",d)}})}async i(v){const{fileURIs:P,folderURIs:E,forceNewWindow:h,diffMode:d,mergeMode:f,addMode:p,forceReuseWindow:b,gotoLineMode:S,waitMarkerFilePath:g,remoteAuthority:t}=v,l=[];if(Array.isArray(E))for(const m of E)try{l.push({folderUri:C.URI.parse(m)})}catch{}if(Array.isArray(P))for(const m of P)try{(0,y.hasWorkspaceFileExtension)(m)?l.push({workspaceUri:C.URI.parse(m)}):l.push({fileUri:C.URI.parse(m)})}catch{}const r=g?C.URI.file(g):void 0,n={forceNewWindow:h,diffMode:d,mergeMode:f,addMode:p,gotoLineMode:S,forceReuseWindow:b,preferNewWindow:!b&&!r&&!p,waitMarkerFileURI:r,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",l,n),""}async j(v){for(const P of v.uris){const E=C.URI.parse(P),h=E.scheme==="file"?E:P;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k(v){const P=h=>h?.map(d=>/\.vsix$/i.test(d)?C.URI.parse(d):d),E={list:v.list,install:P(v.install),uninstall:P(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",E)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&T.existsSync(this.f)&&T.unlinkSync(this.f)}}e.CLIServerBase=I;let L=class extends I{constructor(v,P){super(v,P,(0,a.createRandomIPCHandle)())}};L=qe([We(0,u.IExtHostCommands),We(1,A.ILogService)],L),e.CLIServer=L}),define(ye[282],De([1,0,252,25,18]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const u=1024*1024;let C=class extends a.AbstractExtHostConsoleForwarder{constructor(y,I){super(y,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,I,L){const k=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,k.write(`
START_NATIVE_LOG
`),I.apply(console,L),k.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,I){const L=process[y],k=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(P,E,h)=>{if(!this.g){v+=P.toString(E);const d=v.length>u?v.length:v.lastIndexOf(`
`);d!==-1&&(console[I](v.slice(0,d)),v=v.slice(d+1))}k.call(L,P,E,h)}})}};C=qe([We(0,T.IExtHostRpcService),We(1,R.IExtHostInitDataService)],C),e.ExtHostConsoleForwarder=C}),define(ye[283],De([1,0,10,88,30,40,6,5,2,18]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends C.Disposable{constructor(v,P){super();const E=v.getProxy(A.MainContext.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async h=>{const d=y.URI.file((0,a.join)((0,R.tmpdir)(),(0,T.generateUuid)()));return await E.$download(h,d),d})}};L=qe([We(0,I.IExtHostRpcService),We(1,u.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[284],De([1,0,140,16,203,30]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends a.ExtHostLoggerService{k(y,I,L){return y.scheme===R.Schemas.file?new T.SpdLogLogger(L?.name||(0,u.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,I):super.k(y,I,L)}registerLogger(y){super.registerLogger(y),this.l.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this.l.$deregisterLogger(y)}}e.ExtHostLoggerService=C}),define(ye[285],De([1,0,70,10,2,78,6,16,17,29]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends u.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(t){const l=await super.g(t);if(l.scheme!==A.Schemas.file)return l;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${l.fsPath}.`),l;const r=l.fsPath;let o=0;do{let n;o===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${o}`:`${r}-${o}`,await k(n);const m=R.join(n,"vscode.lock"),s=await h(this.d,m,!1);if(s)return this.i=s,process.on("exit",()=>{s.dispose()}),T.URI.file(n);o++}while(o<10);return l}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function k(g){try{await I.Promises.stat(g);return}catch{}try{await I.Promises.mkdir(g,{recursive:!0})}catch{}}const v=1e3,P=10*60*1e3;class E extends C.Disposable{constructor(t,l){super(),this.b=t,this.c=l,this.a=this.B(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const r=await d(t,l);(!r||r.pid!==process.pid)&&(t.info(`Lock '${l}': The lock was lost unexpectedly.`),this.a.cancel());try{await I.Promises.utimes(l,new Date,new Date)}catch(o){t.error(o),t.info(`Lock '${l}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const l={pid:process.pid,willReleaseAt:Date.now()+t};await I.Promises.writeFile(this.c,JSON.stringify(l),{flag:"w"})}catch(l){this.b.error(l)}}}async function h(g,t,l){try{const o={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(t,JSON.stringify(o),{flag:"wx"})}catch(o){g.error(o)}const r=await d(g,t);return!r||r.pid!==process.pid?l?(g.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),b(g,t)):(g.info(`Lock '${t}': Lock acquired.`),new E(g,t))}async function d(g,t){let l;try{l=await I.Promises.readFile(t)}catch(r){return g.error(r),null}try{return JSON.parse(String(l))}catch(r){return g.error(r),null}}async function f(g,t){let l;try{l=await I.Promises.stat(t)}catch(r){return g.error(r),0}return l.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch{return!1}}async function b(g,t){const l=await d(g,t);if(!l)return g.info(`Lock '${t}': Could not read pid of lock holder.`),S(g,t);if(l.willReleaseAt){let s=l.willReleaseAt-Date.now();if(s<5e3){for(s>0?g.info(`Lock '${t}': The lockfile is scheduled to be released in ${s} ms.`):g.info(`Lock '${t}': The lockfile is scheduled to have been released.`);s>0;){if(await(0,y.timeout)(Math.min(100,s)),await f(g,t)===0)return S(g,t);s=l.willReleaseAt-Date.now()}return S(g,t)}}if(!p(l.pid))return g.info(`Lock '${t}': The pid ${l.pid} appears to be gone.`),S(g,t);const r=await f(g,t),o=Date.now()-r;if(o<=P)return g.info(`Lock '${t}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;g.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const n=await f(g,t),m=Date.now()-n;return m<=P?(g.info(`Lock '${t}': The lock does not look stale, elapsed: ${m} ms, giving up.`),null):(g.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),S(g,t))}async function S(g,t){g.info(`Lock '${t}': Deleting a stale lock.`);try{await I.Promises.unlink(t)}catch{}return h(g,t,!0)}}),define(ye[286],De([1,0,30,18,41]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let u=class extends T.BaseExtHostTerminalService{constructor(A){super(!0,A)}createTerminal(A,y,I){return this.createTerminalFromOptions({name:A,shellPath:y,shellArgs:I})}createTerminalFromOptions(A,y){const I=new T.ExtHostTerminal(this.a,(0,a.generateUuid)(),A,A.name);return this.f.push(I),I.create(A,this.L(A,y)),I.value}};u=qe([We(0,R.IExtHostRpcService)],u),e.ExtHostTerminalService=u}),define(ye[287],De([1,0,5,18,184,6,25,2,46,24,29,7,12,55,3,129,102,13]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class p extends h.DisposableTunnel{}function b(s){const i=s.trim().split(`
`),c=[];return i.forEach(D=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(D);F&&F.length>=3&&c.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),c.reduce((D,F)=>(D[F.socket]=F,D),{})}e.getSockets=b;function S(...s){const i=[].concat(...s.map(t));return[...new Map(i.filter(c=>c.st==="0A").map(c=>{const w=c.local_address.split(":");return{socket:parseInt(c.inode,10),ip:g(w[0]),port:parseInt(w[1],16)}}).map(c=>[c.ip+":"+c.port,c])).values()]}e.loadListeningPorts=S;function g(s){let i="";if(s.length===8)for(let c=s.length-2;c>=0;c-=2)i+=parseInt(s.substr(c,2),16),c!==0&&(i+=".");else for(let c=s.length-4;c>=0;c-=4)i+=parseInt(s.substr(c,4),16).toString(16),c!==0&&(i+=":");return i}function t(s){const i=s.trim().split(`
`),c=i.shift().trim().split(/\s+/).filter(D=>D!=="rx_queue"&&D!=="tm->when");return i.map(D=>D.trim().split(/\s+/).reduce((F,x,q)=>(F[c[q]||q]=x,F),{}))}e.loadConnectionTable=t;function l(s){return!!s.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||s.indexOf("out/server-main.js")!==-1||s.indexOf("_productName=VSCode")!==-1}function r(s){const i=s.trim().split(`
`),c=[];return i.forEach(w=>{const D=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);D&&D.length>=4&&c.push({pid:parseInt(D[1],10),ppid:parseInt(D[2]),cmd:D[3]})}),c}e.getRootProcesses=r;async function o(s,i,c){const w=c.reduce((F,x)=>(F[x.pid]=x,F),{}),D=[];return s.forEach(({socket:F,ip:x,port:q})=>{const M=i[F]?i[F].pid:void 0,B=M?w[M]?.cmd:void 0;M&&B&&!l(B)&&D.push({host:x,port:q,detail:B,pid:M})}),D}e.findPorts=o;function n(s,i,c){const w=new Map,D=r(i);for(const F of s){const x=c.get(F.port);if(x){w.set(F.port,x);continue}const q=D.find(M=>M.cmd.includes(`${F.port}`));if(q){let M=q,B;do B=D.find(O=>O.ppid===M.pid),B&&(M=B);while(B);w.set(F.port,{host:F.ip,port:F.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else w.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=n;let m=class extends u.Disposable{constructor(i,c,w){super(),this.n=w,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new E.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=i.getProxy(a.MainContext.MainThreadTunnelService),v.isLinux&&c.remote.isRemote&&c.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(i,c){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const w=await this.a.$openTunnel(c,i.displayName);if(w){const D=new p(w.remoteAddress,w.localAddress,()=>this.a.$closeTunnel(w.remoteAddress));return this.B(D),D}}async getTunnels(){return this.a.$getTunnels()}p(i){return Math.max(i*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(i,c){const w=this.r();return this.l.set(w,{selector:i,provider:c}),this.a.$registerPortsAttributesProvider(i,w),new k.Disposable(()=>{this.l.delete(w),this.a.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(i,c,w,D,F){const x=[];for(const M of i){const B=this.l.get(M);if(!B)return[];x.push(...await Promise.all(c.map(async O=>B.provider.providePortAttributes(O,w,D,F))))}const q=x.filter(M=>!!M);return q.length>0?q.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(i){if(i&&this.h)return;this.h=i;const c=new d.MovingAverage;let w;for(;this.h;){const D=new Date().getTime(),F=(await this.findCandidatePorts()).filter(q=>(0,h.isLocalhost)(q.host)||(0,h.isAllInterfaces)(q.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(q=>q.port).join(", ")}`);const x=new Date().getTime()-D;c.update(x),(!w||JSON.stringify(w)!==JSON.stringify(F))&&(w=F,await this.a.$onFoundNewCandidates(w)),await new Promise(q=>setTimeout(()=>q(),this.p(c.value)))}}async setTunnelFactory(i){if(i){if(i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.c=i.showCandidatePort,this.a.$setCandidateFilter()),i.tunnelFactory){this.b=i.tunnelFactory;let c=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const w=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(w)}}else this.b=void 0;return(0,u.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(i,c){if(this.f.has(i.host)){const w=this.f.get(i.host);w.has(i.port)&&(c&&w.get(i.port).disposeListener.dispose(),await w.get(i.port).tunnel.dispose(),w.delete(i.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(i,c){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this.b(i,c);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const D=await w;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(i.remoteAddress.host)||this.f.set(i.remoteAddress.host,new Map);const F=this.B(D.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(D.remoteAddress))));return this.f.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:D,disposeListener:F}),P.TunnelDtoConverter.fromApiTunnel(D)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(D=>this.c(D.host,D.port,D.detail??""))),w=i.filter((D,F)=>c[F]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(D=>D.port).join(", ")} to ${w.map(D=>D.port).join(", ")}`),w}async findCandidatePorts(){let i="",c="";try{i=await L.Promises.readFile("/proc/net/tcp","utf8"),c=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=S(i,c),D=await new Promise(z=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,le,V)=>{z(le)})}),F=b(D),x=await L.Promises.readdir("/proc"),q=[];for(const z of x)try{const j=Number(z),le=I.joinPath(A.URI.file("/proc"),z);if((await L.Promises.stat(le.fsPath)).isDirectory()&&!isNaN(j)){const _=await L.Promises.readlink(I.joinPath(le,"cwd").fsPath),J=await L.Promises.readFile(I.joinPath(le,"cmdline").fsPath,"utf8");q.push({pid:j,cwd:_,cmd:J})}}catch{}const M=[],B=w.filter(z=>{const j=F[z.socket];return j||M.push(z),j}),O=o(B,F,q);let U;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const z=await new Promise(j=>{(0,y.exec)("ps -F -A -l | grep root",(le,V,_)=>{j(V)})});this.j=n(M,z,this.j),U=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(j=>j.port).join(", ")}`)}return O.then(z=>U?z.concat(U):z)}};m=qe([We(0,R.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,f.ILogService)],m),e.ExtHostTunnelService=m}),define(ye[288],De([1,0,17,22,21,11,3,6,114,246,58]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(w,D){try{return JSON.stringify(w,D)}catch{return"null"}}const P="$$ref$$",E={[P]:-1};class h{constructor(D,F){this.jsonString=D,this.referencedBuffers=F}}function d(w,D=null,F=!1){const x=[];return{jsonString:(F?v:JSON.stringify)(w,(M,B)=>{if(typeof B>"u")return E;if(typeof B=="object"){if(B instanceof R.VSBuffer){const O=x.push(B)-1;return{[P]:O}}if(D)return D(M,B)}return B}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=d;function f(w,D,F){return JSON.parse(w,(x,q)=>{if(q){const M=q[P];if(typeof M=="number")return D[M];if(F&&q.$mid===1)return F.transformIncoming(q)}return q})}e.parseJsonAndRestoreBufferRefs=f;function p(w,D){return JSON.stringify(w,D)}function b(w){return w?(D,F)=>F&&F.$mid===1?w.transformOutgoing(F):F:null}var S;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},l=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class o extends A.Disposable{constructor(D,F=null,x=null){super(),this[k]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=D,this.f=F,this.g=x,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let q=0,M=L.ProxyIdentifier.count;q<M;q++)this.k[q]=null,this.l[q]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(q=>this.G(q))}dispose(){this.j=!0,Object.keys(this.s).forEach(D=>{this.s[D].resolveErr(u.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(D){this.u===0&&(this.v=Date.now()+o.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(D){this.v=Date.now()+o.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(D){this.t!==D&&(this.t=D,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(D){return this.g?(0,y.transformIncomingURIs)(D,this.g):D}getProxy(D){const{nid:F,sid:x}=D;return this.l[F]||(this.l[F]=this.F(F,x)),this.l[F]}F(D,F){const x={get:(q,M)=>(typeof M=="string"&&!q[M]&&M.charCodeAt(0)===36&&(q[M]=(...B)=>this.O(D,M,B)),M===r?F:q[M])};return new Proxy(Object.create(null),x)}set(D,F){return this.k[D.nid]=F,F}assertRegistered(D){for(let F=0,x=D.length;F<x;F++){const q=D[F];if(!this.k[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}G(D){if(this.j)return;const F=D.byteLength,x=n.read(D,0),q=x.readUInt8(),M=x.readUInt32();switch(q){case 1:case 2:{let{rpcId:B,method:O,args:U}=s.deserializeRequestJSONArgs(x);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.H(F,M,B,O,U,q===2);break}case 3:case 4:{let{rpcId:B,method:O,args:U}=s.deserializeRequestMixedArgs(x);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.H(F,M,B,O,U,q===4);break}case 5:{this.f?.logIncoming(F,M,0,"ack"),this.z(M);break}case 6:{this.I(F,M);break}case 7:{this.J(F,M,void 0);break}case 9:{let B=s.deserializeReplyOKJSON(x);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.J(F,M,B);break}case 10:{const B=s.deserializeReplyOKJSONWithBuffers(x,this.g);this.J(F,M,B);break}case 8:{const B=s.deserializeReplyOKVSBuffer(x);this.J(F,M,B);break}case 11:{let B=s.deserializeReplyErrError(x);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.L(F,M,B);break}case 12:{this.L(F,M,void 0);break}default:console.error("received unexpected message"),console.error(D)}}H(D,F,x,q,M,B){this.f?.logIncoming(D,F,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(x)}.${q}(`,M);const O=String(F);let U,z;if(B){const le=new T.CancellationTokenSource;M.push(le.token),U=this.M(x,q,M),z=()=>le.cancel()}else U=this.M(x,q,M),z=t;this.p[O]=z;const j=s.serializeAcknowledged(F);this.f?.logOutgoing(j.byteLength,F,1,"ack"),this.c.send(j),U.then(le=>{delete this.p[O];const V=s.serializeReplyOK(F,le,this.h);this.f?.logOutgoing(V.byteLength,F,1,"reply:",le),this.c.send(V)},le=>{delete this.p[O];const V=s.serializeReplyErr(F,le);this.f?.logOutgoing(V.byteLength,F,1,"replyErr:",le),this.c.send(V)})}I(D,F){this.f?.logIncoming(D,F,1,"receiveCancel");const x=String(F);this.p[x]?.()}J(D,F,x){this.f?.logIncoming(D,F,0,"receiveReply:",x);const q=String(F);if(!this.s.hasOwnProperty(q))return;const M=this.s[q];delete this.s[q],M.resolveOk(x)}L(D,F,x){this.f?.logIncoming(D,F,0,"receiveReplyErr:",x);const q=String(F);if(!this.s.hasOwnProperty(q))return;const M=this.s[q];delete this.s[q];let B;x&&(x.$isError?(B=new Error,B.name=x.name,B.message=x.message,B.stack=x.stack):B=x),M.resolveErr(B)}M(D,F,x){try{return Promise.resolve(this.N(D,F,x))}catch(q){return Promise.reject(q)}}N(D,F,x){const q=this.k[D];if(!q)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(D));const M=q[F];if(typeof M!="function")throw new Error("Unknown method "+F+" on actor "+(0,L.getStringIdentifierForProxy)(D));return M.apply(q,x)}O(D,F,x){if(this.j)return new I.CanceledLazyPromise;let q=null;if(x.length>0&&T.CancellationToken.isCancellationToken(x[x.length-1])&&(q=x.pop()),q&&q.isCancellationRequested)return Promise.reject(u.canceled());const M=s.serializeRequestArguments(x,this.h),B=++this.m,O=String(B),U=new I.LazyPromise;q&&q.onCancellationRequested(()=>{const j=s.serializeCancel(B);this.f?.logOutgoing(j.byteLength,B,0,"cancel"),this.c.send(s.serializeCancel(B))}),this.s[O]=U,this.y(B);const z=s.serializeRequest(B,D,F,M,!!q);return this.f?.logOutgoing(z.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(D)}.${F}(`,x),this.c.send(z),U}}e.RPCProtocol=o,k=l,o.a=3*1e3;class n{static alloc(D,F,x){const q=new n(R.VSBuffer.alloc(x+1+4),0);return q.writeUInt8(D),q.writeUInt32(F),q}static read(D,F){return new n(D,F)}get buffer(){return this.a}constructor(D,F){this.a=D,this.b=F}static sizeUInt8(){return 1}writeUInt8(D){this.a.writeUInt8(D,this.b),this.b+=1}readUInt8(){const D=this.a.readUInt8(this.b);return this.b+=1,D}writeUInt32(D){this.a.writeUInt32BE(D,this.b),this.b+=4}readUInt32(){const D=this.a.readUInt32BE(this.b);return this.b+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this.a.writeUInt8(D.byteLength,this.b),this.b+=1,this.a.set(D,this.b),this.b+=D.byteLength}readShortString(){const D=this.a.readUInt8(this.b);this.b+=1;const x=this.a.slice(this.b,this.b+D).toString();return this.b+=D,x}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readLongString(){const D=this.a.readUInt32BE(this.b);this.b+=4;const x=this.a.slice(this.b,this.b+D).toString();return this.b+=D,x}writeBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readVSBuffer(){const D=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+D);return this.b+=D,F}static sizeMixedArray(D){let F=0;F+=1;for(let x=0,q=D.length;x<q;x++){const M=D[x];switch(F+=1,M.type){case 1:F+=this.sizeLongString(M.value);break;case 2:F+=this.sizeVSBuffer(M.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(M.value);for(let B=0;B<M.buffers.length;++B)F+=this.sizeVSBuffer(M.buffers[B]);break;case 4:break}}return F}writeMixedArray(D){this.a.writeUInt8(D.length,this.b),this.b+=1;for(let F=0,x=D.length;F<x;F++){const q=D[F];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let M=0;M<q.buffers.length;++M)this.writeBuffer(q.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this.a.readUInt8(this.b);this.b+=1;const F=new Array(D);for(let x=0;x<D;x++)switch(this.readUInt8()){case 1:F[x]=this.readLongString();break;case 2:F[x]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),B=this.readLongString(),O=[];for(let U=0;U<M;++U)O.push(this.readVSBuffer());F[x]=new L.SerializableObjectWithBuffers(f(B,O,null));break}case 4:F[x]=void 0;break}return F}}n.sizeUInt32=4;var m;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(m||(m={}));class s{static a(D){for(let F=0,x=D.length;F<x;F++)if(D[F]instanceof R.VSBuffer||D[F]instanceof L.SerializableObjectWithBuffers||typeof D[F]>"u")return!0;return!1}static serializeRequestArguments(D,F){if(this.a(D)){const x=[];for(let q=0,M=D.length;q<M;q++){const B=D[q];if(B instanceof R.VSBuffer)x[q]={type:2,value:B};else if(typeof B>"u")x[q]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:U}=d(B.value,F);x[q]={type:3,value:R.VSBuffer.fromString(O),buffers:U}}else x[q]={type:1,value:R.VSBuffer.fromString(p(B,F))}}return{type:1,args:x}}return{type:0,args:p(D,F)}}static serializeRequest(D,F,x,q,M){switch(q.type){case 0:return this.b(D,F,x,q.args,M);case 1:return this.c(D,F,x,q.args,M)}}static b(D,F,x,q,M){const B=R.VSBuffer.fromString(x),O=R.VSBuffer.fromString(q);let U=0;U+=n.sizeUInt8(),U+=n.sizeShortString(B),U+=n.sizeLongString(O);const z=n.alloc(M?2:1,D,U);return z.writeUInt8(F),z.writeShortString(B),z.writeLongString(O),z.buffer}static deserializeRequestJSONArgs(D){const F=D.readUInt8(),x=D.readShortString(),q=D.readLongString();return{rpcId:F,method:x,args:JSON.parse(q)}}static c(D,F,x,q,M){const B=R.VSBuffer.fromString(x);let O=0;O+=n.sizeUInt8(),O+=n.sizeShortString(B),O+=n.sizeMixedArray(q);const U=n.alloc(M?4:3,D,O);return U.writeUInt8(F),U.writeShortString(B),U.writeMixedArray(q),U.buffer}static deserializeRequestMixedArgs(D){const F=D.readUInt8(),x=D.readShortString(),q=D.readMixedArray(),M=new Array(q.length);for(let B=0,O=q.length;B<O;B++){const U=q[B];typeof U=="string"?M[B]=JSON.parse(U):M[B]=U}return{rpcId:F,method:x,args:M}}static serializeAcknowledged(D){return n.alloc(5,D,0).buffer}static serializeCancel(D){return n.alloc(6,D,0).buffer}static serializeReplyOK(D,F,x){if(typeof F>"u")return this.d(D);if(F instanceof R.VSBuffer)return this.e(D,F);if(F instanceof L.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:M}=d(F.value,x,!0);return this.g(D,q,M)}else return this.f(D,v(F,x))}static d(D){return n.alloc(7,D,0).buffer}static e(D,F){let x=0;x+=n.sizeVSBuffer(F);const q=n.alloc(8,D,x);return q.writeVSBuffer(F),q.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static f(D,F){const x=R.VSBuffer.fromString(F);let q=0;q+=n.sizeLongString(x);const M=n.alloc(9,D,q);return M.writeLongString(x),M.buffer}static g(D,F,x){const q=R.VSBuffer.fromString(F);let M=0;M+=n.sizeUInt32,M+=n.sizeLongString(q);for(const O of x)M+=n.sizeVSBuffer(O);const B=n.alloc(10,D,M);B.writeUInt32(x.length),B.writeLongString(q);for(const O of x)B.writeBuffer(O);return B.buffer}static deserializeReplyOKJSON(D){const F=D.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(D,F){const x=D.readUInt32(),q=D.readLongString(),M=[];for(let B=0;B<x;++B)M.push(D.readVSBuffer());return new L.SerializableObjectWithBuffers(f(q,M,F))}static serializeReplyErr(D,F){const x=F?v(u.transformErrorForSerialization(F),null):void 0;if(typeof x!="string")return this.h(D);const q=R.VSBuffer.fromString(x);let M=0;M+=n.sizeLongString(q);const B=n.alloc(11,D,M);return B.writeLongString(q),B.buffer}static deserializeReplyErrError(D){const F=D.readLongString();return JSON.parse(F)}static h(D){return n.alloc(12,D,0).buffer}}var i;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(i||(i={}));var c;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(c||(c={}))}),define(ye[289],De([1,0,3,39,54,4]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new T.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new T.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new T.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,u.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(I){this.a.has(I.id)||(this.a.set(I.id,I),this.b.fire(I.id))}getChannels(){const I=[];return this.a.forEach(L=>I.push(L)),I}getChannel(I){return this.a.get(I)}removeChannel(I){this.a.delete(I),this.c.fire(I)}}R.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new T.RawContextKey("activeOutputChannel","")}),define(ye[142],De([1,0,5,4,18,26,13,289,77,25,48,157,22,9,44,3,6]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class f extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(g,t,l,r,o){super(),this.id=g,this.name=t,this.m=l,this.n=r,this.extension=o,this.k=0,this.l=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(n=>this.setLevel(n)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,g)}replace(g){const t=this.k;this.info(g),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(g,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof g=="boolean"?g:t))}hide(){this.n.$close(this.id)}g(g,t){this.k+=v.VSBuffer.fromString(t).byteLength,(0,C.log)(this.m,g,t),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends f{appendLine(g){this.append(g)}}let b=class{constructor(g,t,l,r,o,n){this.i=t,this.j=l,this.k=r,this.l=o,this.m=n,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[t,l]of this.g)l.visible=t===this.h}createOutputChannel(g,t,l){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,o=(0,P.isString)(t)?t:void 0;if((0,P.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let n;const m=this.i.environment.extensionLogLevel?.find(([i])=>u.ExtensionIdentifier.equals(l.identifier,i))?.[1];m&&(n=(0,C.parseLogLevel)(m));const s=r?this.o(g,n,l):this.n(g,o,l);return s.then(i=>{this.g.set(i.id,i),i.visible=i.id===this.h}),r?this.r(g,n??this.m.getLevel(),s):this.q(g,s)}async n(g,t,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,o=this.k.extUri.joinPath(r,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),n=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(g,o,t,l.identifier.value);return new f(m,g,n,this.a,l)}async o(g,t,l){const r=await this.p(l),o=this.k.extUri.joinPath(r,`${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),n=o.toString(),m=this.l.createLogger(o,{id:n,name:g,logLevel:t,extensionId:l.identifier.value});return new p(n,g,m,this.a,l)}p(g){let t=this.d.get(g.identifier.value);if(!t){const l=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(l)}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileExists)throw r}return l})())}return t}q(g,t){let l=!1;const r=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return g},append(o){r(),t.then(n=>n.append(o))},appendLine(o){r(),t.then(n=>n.appendLine(o))},clear(){r(),t.then(o=>o.clear())},replace(o){r(),t.then(n=>n.replace(o))},show(o,n){r(),t.then(m=>m.show(o,n))},hide(){r(),t.then(o=>o.hide())},dispose(){l=!0,t.then(o=>o.dispose())}}}r(g,t,l){const r=new d.DisposableStore,o=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},n=r.add(new h.Emitter);function m(s){t=s,n.fire(s)}return l.then(s=>{r.add(s),s.logLevel!==t&&m(s.logLevel),r.add(s.onDidChangeLogLevel(i=>m(i)))}),{...this.q(g,l),get logLevel(){return t},onDidChangeLogLevel:n.event,trace(s,...i){o(),l.then(c=>c.trace(s,...i))},debug(s,...i){o(),l.then(c=>c.debug(s,...i))},info(s,...i){o(),l.then(c=>c.info(s,...i))},warn(s,...i){o(),l.then(c=>c.warn(s,...i))},error(s,...i){o(),l.then(c=>c.error(s,...i))},dispose(){r.dispose()}}}};b=qe([We(0,T.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,y.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,C.ILoggerService),We(5,C.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(ye[290],De([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(ye[291],De([1,0,32,16,10,12,24,2,4,216,47,234,290]),function(te,e,a,R,T,u,C,A,y,I,L,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let P=class cn{constructor(h,d,f,p){this.d=h,this.e=d,this.f=f,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||u.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??h})()}hasValidBasename(h,d,f){return typeof d=="string"||typeof d>"u"?this.a.then(p=>this.h(h,p,d)):this.h(h,d,f)}h(h,d,f){return h.scheme===R.Schemas.file||h.scheme===R.Schemas.vscodeRemote?(0,a.isValidBasename)(f??(0,C.basename)(h),d===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(h,d){if(h.remoteAuthority)return R.Schemas.vscodeRemote;const f=(0,I.getVirtualWorkspaceScheme)(d.getWorkspace());if(f)return f;const p=d.getWorkspace().folders[0];if(p)return p.uri.scheme;const b=d.getWorkspace().configuration;return b?b.scheme:R.Schemas.file}userHome(h){return h?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(h=>h===1?T.win32:T.posix)}async fileURI(h){let d="";if(await this.a===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const p=h.indexOf("/",2);p===-1?(d=h.substring(2),h="/"):(d=h.substring(2,p),h=h.substring(p)||"/")}return A.URI.from({scheme:R.Schemas.file,authority:d,path:h,query:"",fragment:""})}};P=qe([We(1,v.IRemoteAgentService),We(2,k.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(ye[80],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(C,A){this.line=C,this.character=A}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,A){return new a(0,0)}with(C){return new a(0,0)}}e.Position=a;class R{constructor(C,A,y,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(C,A),this.end=new a(y,I)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new R(0,0,0,0)}with(C){return new R(0,0,0,0)}}e.Range=R;var T;(function(u){u[u.Information=1]="Information",u[u.Warning=2]="Warning"})(T=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],De([1,0,15,38,23,32,8,4,10,11,80,17]),function(te,e,a,R,T,u,C,A,y,I,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",P=" characters skipped \u27EB",E=(v.length+P.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var h;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function f(J){return!!J.preview}e.resultIsMatch=f;function p(J){return!!J.resource}e.isFileMatch=p;function b(J){return!!J.message}e.isProgressMessage=b;var S;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(S=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=g;class t{constructor(ie,ee,K){this.ranges=ee;const G=Array.isArray(ee)?ee:[ee];if(K&&K.matchLines===1&&l(G)){ie=(0,C.getNLines)(ie,K.matchLines);let de="",be=0,Ee=0;const Pe=Math.floor(K.charsPerLine/5),Fe=[];for(const se of G){const oe=Math.max(se.startColumn-Pe,0),fe=se.startColumn+K.charsPerLine;if(oe>Ee+Pe+E){const Z=v+(oe-Ee)+P;de+=Z+ie.slice(oe,fe),be+=oe-(Ee+Z.length)}else de+=ie.slice(Ee,fe);Fe.push(new o(0,se.startColumn-be,se.endColumn-be)),Ee=fe}this.preview={text:de,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const de=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:ie,matches:(0,a.mapArrayOrNot)(ee,be=>new r(be.startLineNumber-de,be.startColumn,be.endLineNumber-de,be.endColumn))}}}}e.TextSearchMatch=t;function l(J){const ie=J[0].startLineNumber;for(const ee of J)if(ee.startLineNumber!==ie||ee.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,ee,K,G){this.startLineNumber=ie,this.startColumn=ee,this.endLineNumber=K,this.endColumn=G}}e.SearchRange=r;class o extends r{constructor(ie,ee,K){super(ie,ee,ie,K)}}e.OneLineRange=o;var n;(function(J){J.List="list",J.Tree="tree"})(n=e.ViewMode||(e.ViewMode={}));var m;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(m=e.SearchSortOrder||(e.SearchSortOrder={}));function s(J,ie=!0){const ee=J&&J.files&&J.files.exclude,K=ie&&J&&J.search&&J.search.exclude;if(!ee&&!K)return;if(!ee||!K)return ee||K;let G=Object.create(null);return G=T.mixin(G,T.deepClone(ee)),G=T.mixin(G,T.deepClone(K),!0),G}e.getExcludes=s;function i(J,ie){return J.excludePattern&&R.match(J.excludePattern,ie)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&R.match(J.includePattern,ie)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ee=>{const K=ee.folder.fsPath;if(u.isEqualOrParent(ie,K)){const G=y.relative(K,ie);return!ee.includePattern||!!R.match(ee.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var c;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(c=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(ie,ee){super(ie),this.code=ee}}e.SearchError=w;function D(J){const ie=J.message;if((0,I.isCancellationError)(J))return new w(ie,c.canceled);try{const ee=JSON.parse(ie);return new w(ee.message,ee.code)}catch{return new w(ie,c.other)}}e.deserializeSearchError=D;function F(J){const ie={message:J.message,code:J.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=F;function x(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=x;function q(J){return J.type==="success"}e.isSerializedSearchSuccess=q;function M(J){return!!J.path}e.isSerializedFileMatch=M;function B(J,ie){const ee=J.searchPath?J.searchPath:J.relativePath;return(0,C.fuzzyContains)(ee,ie)}e.isFilePatternMatch=B;class O{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function U(J,ie){const ee={...J||{},...ie||{}};return Object.keys(ee).filter(K=>{const G=ee[K];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=U;class z{constructor(ie,ee){this.c=null,this.a={...ie.excludePattern||{},...ee.excludePattern||{}},this.b=R.parse(this.a);let K=ie.includePattern;ee.includePattern&&(K?K={...K,...ee.includePattern}:K=ee.includePattern),K&&(this.c=R.parse(K))}matchesExcludesSync(ie,ee,K){return!!(this.b&&this.b(ie,ee,K))}includedInQuerySync(ie,ee,K){return!(this.b&&this.b(ie,ee,K)||this.c&&!this.c(ie,ee,K))}includedInQuery(ie,ee,K){const G=this.b(ie,ee,K),de=()=>this.c?!!this.c(ie,ee,K):!0;return(0,k.isThenable)(G)?G.then(be=>be?!1:de()):de()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=z;function j(J){for(const ie in J)if(typeof J[ie]!="boolean")return!0;return!1}function le(J){if(!J)return;let ie;return ee=>(ie||(ie=(J()||Promise.resolve([])).then(K=>K?_(K):{})),ie.then(K=>!!K[ee]))}e.hasSiblingPromiseFn=le;function V(J){if(!J)return;let ie;return ee=>{if(!ie){const K=J();ie=K?_(K):{}}return!!ie[ee]}}e.hasSiblingFn=V;function _(J){const ie={};for(const ee of J)ie[ee]=!0;return ie}}),define(ye[33],De([1,0,15,17,21,3,6,68,16,102,24,8,9,2,182,4,13,204,47,48,25,18,14,7,56,31,5]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S,g,t,l,r,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function m(q,M,B){return new L.ExtUri(O=>w(O,B)).isEqual(q,M)}function s(q,M,B){return m(q.uri,M.uri,B)?0:(0,k.compare)(q.uri.toString(),M.uri.toString())}function i(q,M,B){return q.index!==M.index?q.index<M.index?-1:1:m(q.uri,M.uri,B)?(0,k.compare)(q.name,M.name):(0,k.compare)(q.uri.toString(),M.uri.toString())}function c(q,M,B,O){const U=q.slice(0).sort((j,le)=>B(j,le,O)),z=M.slice(0).sort((j,le)=>B(j,le,O));return(0,a.delta)(U,z,(j,le)=>B(j,le,O))}function w(q,M){const B=M.getCapabilities(q.scheme);return!(B&&B&1024)}class D extends p.Workspace{static toExtHostWorkspace(M,B,O,U){if(!M)return{workspace:null,added:[],removed:[]};const{id:z,name:j,folders:le,configuration:V,transient:_,isUntitled:J}=M,ie=[],ee=B;B?le.forEach((be,Ee)=>{const Pe=P.URI.revive(be.uri),Fe=D.o(O||B,Pe,U);Fe?(Fe.name=be.name,Fe.index=be.index,ie.push(Fe)):ie.push({uri:Pe,name:be.name,index:Ee})}):ie.push(...le.map(({uri:be,name:Ee,index:Pe})=>({uri:P.URI.revive(be),name:Ee,index:Pe}))),ie.sort((be,Ee)=>be.index<Ee.index?-1:1);const K=new D(z,j,ie,!!_,V?P.URI.revive(V):null,!!J,be=>w(be,U)),{added:G,removed:de}=c(ee?ee.workspaceFolders:[],K.workspaceFolders,s,U);return{workspace:K,added:G,removed:de}}static o(M,B,O){for(let U=0;U<M.folders.length;U++){const z=M.workspaceFolders[U];if(m(z.uri,B,O))return z}}constructor(M,B,O,U,z,j,le){super(M,O.map(V=>new p.WorkspaceFolder(V)),U,z,le),this.t=B,this.u=j,this.q=[],this.s=A.TernarySearchTree.forUris(le),O.forEach(V=>{this.q.push(V),this.s.set(V.uri,V)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,B){return B&&this.s.get(M)&&(M=(0,L.dirname)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let F=class{constructor(M,B,O,U,z){this.c=new u.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new u.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new u.AsyncEmitter,this.h=U,this.s=O,this.t=z,this.j=new I.Counter,this.k=new R.Barrier,this.o=M.getProxy(n.MainContext.MainThreadWorkspace),this.q=M.getProxy(n.MainContext.MainThreadMessageService);const j=B.workspace;this.l=j?new D(j.id,j.name,[],!!j.transient,j.configuration?P.URI.revive(j.configuration):null,!!j.isUntitled,le=>w(le,O)):void 0}$initializeWorkspace(M,B){this.v=B,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?P.URI.from({scheme:y.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,B,O,...U){const z=[];if(Array.isArray(U)&&U.forEach(J=>{P.URI.isUri(J.uri)&&!z.some(ie=>m(ie.uri,J.uri,this.s))&&z.push({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri)})}),this.n||[B,O].some(J=>typeof J!="number"||J<0)||O===0&&z.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(B+O>j.length)return!1;const le=j.slice(0);le.splice(B,O,...z.map(J=>({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<le.length;J++){const ie=le[J];if(le.some((ee,K)=>K!==J&&m(ie.uri,ee.uri,this.s)))return!1}le.forEach((J,ie)=>J.index=ie);const{added:V,removed:_}=c(j,le,i,this.s);if(V.length===0&&_.length===0)return!1;if(this.o){const J=M.displayName||M.name;this.o.$updateWorkspaceFolders(J,B,O,z).then(void 0,ie=>{this.n=void 0;const ee={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(f.Severity.Error,(0,E.localize)(0,null,J,ie.toString()),ee,[])})}return this.y(le),!0}getWorkspaceFolder(M,B){if(!!this.x)return this.x.getWorkspaceFolder(M,B)}async getWorkspaceFolder2(M,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,B)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,B){let O,U="";if(typeof M=="string"?(O=P.URI.file(M),U=M):typeof M<"u"&&(O=M,U=M.fsPath),!O)return U;const z=this.getWorkspaceFolder(O,!0);if(!z)return U;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let j=(0,L.relativePath)(z.uri,O);return B&&z.name&&(j=`${z.name}/${j}`),j}y(M){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:B,added:O,removed:U}=D.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:U}))}findFiles(M,B,O,U,z=T.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let j;if(B===null?j=!1:B&&(typeof B=="string"?j=B:j=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:V}=x(t.GlobPattern.from(M));return this.o.$startFileSearch((0,v.withUndefinedAsNull)(le),(0,v.withUndefinedAsNull)(V),(0,v.withUndefinedAsNull)(j),(0,v.withUndefinedAsNull)(O),z).then(_=>Array.isArray(_)?_.map(J=>P.URI.revive(J)):[])}async findTextInFiles(M,B,O,U,z=T.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),le=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:V,folder:_}=x(t.GlobPattern.from(B.include)),J=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ie={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:le,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:V,excludePattern:J},ee=!1;if(this.u[j]=K=>{if(ee)return;const G=P.URI.revive(K.resource);K.results.forEach(de=>{(0,o.resultIsMatch)(de)?O({uri:G,preview:{text:de.preview.text,matches:(0,a.mapArrayOrNot)(de.preview.matches,be=>new l.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,a.mapArrayOrNot)(de.ranges,be=>new l.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):O({uri:G,text:de.text,lineNumber:de.lineNumber})})},z.isCancellationRequested)return{};try{const K=await this.o.$startTextSearch(M,(0,v.withUndefinedAsNull)(_),ie,j,z);return delete this.u[j],K||{}}catch(K){throw delete this.u[j],K}}$handleTextSearchResult(M,B){this.u[B]?.(M)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,B){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,B);const O=this.t.transformOutgoingScheme(M),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,O),(0,C.toDisposable)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(M,B){this.h.info("Getting edit session identifier for workspaceFolder",M);const O=await this.resolveWorkspaceFolder(P.URI.revive(M));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const U=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!U),!U)return;const z=await U.provideEditSessionIdentity(O,B);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(M,B,O,U){this.h.info("Getting edit session identifier for workspaceFolder",M);const z=await this.resolveWorkspaceFolder(P.URI.revive(M));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const j=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!j),!j)return;const le=await j.provideEditSessionIdentityMatch?.(B,O,U);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(M){return(B,O,U)=>{const z=function(le){B.call(O,le)};return z.extension=M,this.A.event(z,void 0,U)}}async $onWillCreateEditSessionIdentity(M,B,O){const U=await this.resolveWorkspaceFolder(P.URI.revive(M));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},B,async(z,j)=>{const le=Date.now();await Promise.resolve(z),Date.now()-le>O&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),B.isCancellationRequested}};F=qe([We(0,g.IExtHostRpcService),We(1,S.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,d.ILogService),We(4,r.IURITransformerService)],F),e.ExtHostWorkspace=F,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function x(q){let M,B;return q&&(typeof q=="string"?M=q:(M=q.pattern,B=P.URI.revive(q.baseUri))),{includePattern:M,folder:B}}}),define(ye[34],De([1,0,23,3,33,5,7,207,127,9,17,4,18,13,2]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(l,r){if(r){const o=r.split(".");let n=l;for(let m=0;n&&m<o.length;m++)n=n[o[m]];return n}}function d(l){return l instanceof E.URI}function f(l){return l&&l.uri instanceof E.URI&&l.languageId&&typeof l.languageId=="string"}function p(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function b(l){return l&&l.uri instanceof E.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function S(l){if(d(l))return{resource:l};if(f(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(p(l))return{overrideIdentifier:l.languageId};if(b(l))return{resource:l.uri};if(l===null)return{resource:null}}let g=class{constructor(r,o,n){this.a=r.getProxy(u.MainContext.MainThreadConfiguration),this.c=o,this.b=n,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,o){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(r,o))}};g=qe([We(0,v.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,P.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(r,o,n,m){this.a=new R.Emitter,this.b=r,this.f=m,this.c=o,this.e=A.Configuration.parse(n),this.d=this.k(n.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,o){const n={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(o,n))}getConfiguration(r,o,n){const m=S(o)||{},s=this.g(r?h(this.e.getValue(void 0,m,this.c.workspace),r):this.e.getValue(void 0,m,this.c.workspace));r&&this.h(r,m,n?.identifier);function i(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const c={has(w){return typeof h(s,w)<"u"},get:(w,D)=>{this.h(r?`${r}.${w}`:w,m,n?.identifier);let F=h(s,w);if(typeof F>"u")F=D;else{let x;const q=(M,B)=>{let O;const U=()=>{x=x||(0,a.deepClone)(s),O=O||h(x,B)};return(0,I.isObject)(M)?new Proxy(M,{get:(z,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return U(),()=>O;if(x)return O=O||h(x,B),O[j];const le=z[j];return typeof j=="string"?q(le,`${B}.${j}`):le},set:(z,j,le)=>(U(),O&&(O[j]=le),!0),deleteProperty:(z,j)=>(U(),O&&delete O[j],!0),defineProperty:(z,j,le)=>(U(),O&&Object.defineProperty(O,j,le),!0)}):M};F=q(F,w)}return F},update:(w,D,F,x)=>{w=r?`${r}.${w}`:w;const q=i(F);return D!==void 0?this.b.$updateConfigurationOption(q,w,D,m,x):this.b.$removeConfigurationOption(q,w,m,x)},inspect:w=>{w=r?`${r}.${w}`:w;const D=this.e.inspect(w,m,this.c.workspace);if(D)return{key:w,defaultValue:(0,a.deepClone)(D.policy?.value??D.default?.value),globalValue:(0,a.deepClone)(D.user?.value??D.application?.value),workspaceValue:(0,a.deepClone)(D.workspace?.value),workspaceFolderValue:(0,a.deepClone)(D.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(D.default?.override),globalLanguageValue:(0,a.deepClone)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,a.deepClone)(D.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(D.workspaceFolder?.override),languageIds:(0,a.deepClone)(D.overrideIdentifiers)}}};return typeof s=="object"&&(0,a.mixin)(c,s,!1),Object.freeze(c)}g(r){const o=n=>(0,I.isObject)(n)?new Proxy(n,{get:(m,s)=>o(m[s]),set:(m,s,i)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(m,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(m,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return o(r)}h(r,o,n){const m=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),s=n?`[${n.value}] `:"";if(m===4){typeof o?.resource>"u"&&this.f.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){o?.resource&&this.f.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,o){const n=new A.ConfigurationChangeEvent(r,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,s)=>n.affectsConfiguration(m,S(s))})}k(r){return r.reduce((o,n)=>(o.set(n[0],n[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)};define(ye[81],De([1,0,2,17,3,5,7,33,59,34,21,41,18,25,4,16,12,13,76,245,11]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(t||(t={}));var l;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(l||(l={}));var r;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(r||(r={}));var o;(function(M){function B(z){if(z){const j=z;return j&&!!j.process}else return!1}M.is=B;function O(z){if(z==null)return;const j={process:z.process,args:z.args};return z.options&&(j.options=r.from(z.options)),j}M.from=O;function U(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}M.to=U})(o||(o={}));var n;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(n||(n={}));var m;(function(M){function B(z){if(z){const j=z;return j&&(!!j.commandLine||!!j.command)}else return!1}M.is=B;function O(z){if(z==null)return;const j={};return z.commandLine!==void 0?j.commandLine=z.commandLine:(j.command=z.command,j.args=z.args),z.options&&(j.options=n.from(z.options)),j}M.from=O;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}M.to=U})(m||(m={}));var s;(function(M){function B(z){if(z){const j=z;return j&&j.customExecution==="customExecution"}else return!1}M.is=B;function O(z){return{customExecution:"customExecution"}}M.from=O;function U(z,j){return j.get(z)}M.to=U})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var i;(function(M){function B(O,U){let z;return O.scope!==void 0&&typeof O.scope!="number"?z=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===C.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=b.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:z}}M.from=B})(i=e.TaskHandleDTO||(e.TaskHandleDTO={}));var c;(function(M){function B(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}M.from=B})(c||(c={}));var w;(function(M){function B(z,j){if(z==null)return[];const le=[];for(const V of z){const _=O(V,j);_&&le.push(_)}return le}M.fromMany=B;function O(z,j){if(z==null)return;let le;z.execution instanceof C.ProcessExecution?le=o.from(z.execution):z.execution instanceof C.ShellExecution?le=m.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(le=s.from(z.execution));const V=t.from(z.definition);let _;return z.scope?typeof z.scope=="number"?_=z.scope:_=z.scope.uri:_=C.TaskScope.Workspace,!V||!_?void 0:{_id:z._id,definition:V,name:z.name,source:{extensionId:j.identifier.value,label:z.source,scope:_},execution:le,isBackground:z.isBackground,group:c.from(z.group),presentationOptions:l.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}M.from=O;async function U(z,j,le){if(z==null)return;let V;o.is(z.execution)?V=o.to(z.execution):m.is(z.execution)?V=m.to(z.execution):s.is(z.execution)&&(V=s.to(z._id,le));const _=t.to(z.definition);let J;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?J=z.source.scope:J=await j.resolveWorkspaceFolder(a.URI.revive(z.source.scope)):J=C.TaskScope.Workspace),!_||!J)return;const ie=new C.Task(_,J,z.name,z.source.label,V,z.problemMatchers);return z.isBackground!==void 0&&(ie.isBackground=z.isBackground),z.group!==void 0&&(ie.group=C.TaskGroup.from(z.group._id),ie.group&&z.group.isDefault&&(ie.group=new C.TaskGroup(ie.group.id,ie.group.label),z.group.isDefault===!0&&(ie.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ie.presentationOptions=l.to(z.presentationOptions)),z._id&&(ie._id=z._id),z.detail&&(ie.detail=z.detail),ie}M.to=U})(w=e.TaskDTO||(e.TaskDTO={}));var D;(function(M){function B(U){return U}M.from=B;function O(U){if(!!U)return Object.assign(Object.create(null),U)}M.to=O})(D||(D={}));class F{constructor(B,O,U){this._id=O,this.a=U,g.set(this,void 0),Je(this,g,B,"f")}get task(){return this.a}terminate(){Be(this,g,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}g=new WeakMap;let x=class{constructor(B,O,U,z,j,le,V,_){this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.t=new T.Emitter,this.a=B.getProxy(u.MainContext.MainThreadTask),this.b=U,this.c=z,this.d=j,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=V,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,O,U){if(!U)return new C.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:O,provider:U,extension:B}),this.a.$registerTaskProvider(z,O),new C.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(B,O){this.a.$registerTaskSystem(B,O)}fetchTasks(B){return this.a.$fetchTasks(D.from(B)).then(async O=>{const U=[];for(const z of O){const j=await w.to(z,this.b,this.m);j&&U.push(j)}return U})}get taskExecutions(){const B=[];return this.k.forEach(O=>B.push(O)),B}terminateTask(B){if(!(B instanceof F))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,O,U){const z=this.m.get(B.id);z&&(this.o.set(B.id,z),this.e.attachPtyToTerminal(O,await z.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const O=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const O=await this.y(B.id);this.s.fire({execution:O,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const O=await this.y(B.id);this.t.fire({execution:O,exitCode:B.exitCode})}$provideTasks(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const z=[],j=(0,R.asPromise)(()=>U.provider.provideTasks(L.CancellationToken.None)).then(le=>this.u(O,z,U,le));return new Promise(le=>{j.then(V=>{Promise.all(z).then(()=>{le(V)})})})}async $resolveTask(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(O.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await w.to(O,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const j=await U.provider.resolveTask(z,L.CancellationToken.None);if(!j)return;this.z(j,U);const le=w.from(j,U.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(le.execution)&&await this.x(le,j,!0),await this.v(le)}w(){return this.h++}async x(B,O,U){const z=await this.a.$createTaskId(B);!U&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,O.execution)),this.m.set(z,O.execution)}async y(B,O){if(typeof B=="string"){const j=this.l.get(B);if(!j)throw new S.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const U=this.l.get(B.id);if(U)return U;const z=new Promise((j,le)=>{function V(_,J,ie){ie?j(new F(_,J.id,ie)):le("Unexpected: Task does not exist.")}O?V(this,B,O):w.to(B.task,this.b,this.m).then(_=>V(this,B,_))});return this.l.set(B.id,z),z.then(j=>(this.k.set(B.id,j),j),j=>Promise.reject(j))}z(B,O){B._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let z=U.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=U.next()}};x=qe([We(0,v.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,I.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,f.ILogService),We(7,p.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let q=class extends x{constructor(B,O,U,z,j,le,V,_){super(B,O,U,z,j,le,V,_),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(B,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const U=w.from(O,B);if(U===void 0)throw new Error("Task is not valid");if(s.is(U.execution))await this.x(U,O,!1);else throw new S.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution(U),O);return this.a.$executeTask(U).catch(j=>{throw new Error(j)}),z}u(B,O,U,z){const j=[];if(z)for(const le of z){this.z(le,U),(!le.definition||!B[le.definition.type])&&this.f.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const V=w.from(le,U.extension);V&&s.is(V.execution)?(j.push(V),O.push(this.x(V,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:U.extension}}async v(B){if(s.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,O,U){}};q=qe([We(0,v.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,I.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,f.ILogService),We(7,p.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(ye[292],De([1,0,10,21,45,38,24,43,31]),function(te,e,a,R,T,u,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(v,P,E){this.k=v,this.l=P,this.o=E,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&u.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&u.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const P=this.k.folderQueries||[];return new Promise((E,h)=>{const d=f=>{this.f++,v(f)};if(this.g)return E({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(f=>{const p=f.toString(),b=a.basename(p);this.j&&this.j(p,b)||this.v(d,{base:f,basename:b})}),Promise.all(P.map(f=>this.p(f,d))).then(f=>{E({limitHit:this.e,stats:f[0]||void 0})},f=>{h(new Error((0,T.toErrorMessage)(f)))})})}async p(v,P){const E=new R.CancellationTokenSource,h=this.q(v),d=this.r(),f=new y.QueryGlobTester(this.k,v),p=!f.hasSiblingExcludeClauses();let b;try{this.h.add(E),b=A.StopWatch.create();const S=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,E.token),g=b.elapsed(),t=A.StopWatch.create();return this.g&&!this.e||(S&&S.forEach(l=>{const r=a.posix.relative(v.folder.path,l.path);if(p){const o=a.basename(l.path);this.v(P,{base:v.folder,relativePath:r,basename:o});return}this.s(d,v.folder,r,P)}),this.g&&!this.e)?null:(this.u(d,f,P),{providerTime:g,postProcessTime:t.elapsed()})}finally{E.dispose(),this.h.delete(E)}}q(v){const P=(0,y.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),E=(0,y.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:E,includes:P,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},P,E,h){if(E===this.a){const f=a.basename(this.a);this.v(h,{base:P,relativePath:this.a,basename:f})}function d(f){const p=a.basename(f),b=a.dirname(f);let S=v[b];S||(S=v[b]=[],d(b)),S.push({base:P,relativePath:f,basename:p})}d(E)}u({rootEntries:v,pathToEntries:P},E,h){const d=this,f=this.a;function p(b){const S=(0,y.hasSiblingFn)(()=>b.map(g=>g.basename));for(let g=0,t=b.length;g<t;g++){const l=b[g],{relativePath:r,basename:o}=l;if(E.matchesExcludesSync(r,o,f!==o?S:void 0))continue;const n=P[r];if(n)p(n);else{if(r===f)continue;d.v(h,l)}if(d.e)break}}p(v)}v(v,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(P))}}class L{constructor(){this.b=new Map}fileSearch(v,P,E,h){const d=this.c(v.cacheKey),f=new I(v,P,d&&d.token);let p=0;const b=S=>{p+=S.length,E(S.map(g=>this.d(g)))};return this.e(f,L.a,b,h).then(S=>({limitHit:S.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:S.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new R.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:C.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,P,E,h){h.onCancellationRequested(()=>{v.cancel()});const d=p=>{p&&(f.push(p),P>0&&f.length>=P&&(E(f),f=[]))};let f=[];return v.search(d).then(p=>(f.length&&E(f),p),p=>(f.length&&E(f),Promise.reject(p)))}}e.FileSearchManager=L,L.a=512}),define(ye[293],De([1,0,15,61,38,113,28,16,10,24,8,9,2,165,194,53,13,47,133,291,31]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(c,w,D,F,x){this.a=c,this.b=w,this.c=D,this.d=F,this.e=x}text(c,w,D={}){c=this.f(c,D);const F=this.a.getValue(),x=w&&w.some(M=>!this.a.getValue({resource:M}).search.useRipgrep);return{...this.h(w?.map(f.toWorkspaceFolder),D),type:2,contentPattern:c,previewOptions:D.previewOptions,maxFileSize:D.maxFileSize,usePCRE2:F.search.usePCRE2||x||!1,beforeContext:D.beforeContext,afterContext:D.afterContext,userDisabledExcludesAndIgnoreFiles:D.disregardExcludeSettings&&D.disregardIgnoreFiles}}f(c,w){const D=this.a.getValue();c.isRegExp&&(c.pattern=c.pattern.replace(/\r?\n/g,"\\n"));const F={...c,wordSeparators:D.editor.wordSeparators};return this.j(c,w)&&(F.isCaseSensitive=!0),this.k(c)&&(F.isMultiline=!0),F}file(c,w={}){return{...this.h(c,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(c,w){return c?(c=Array.isArray(c)?c.map(n):n(c),w?this.parseSearchPaths(c):{pattern:l(...Array.isArray(c)?c:[c])}):{}}h(c=[],w={}){const D=this.g(w.includePattern,w.expandPatterns),F=this.g(w.excludePattern,w.expandPatterns),x=c.length>1,q=(D.searchPaths&&D.searchPaths.length?D.searchPaths.map(O=>this.q(O,w,F)):c.map(O=>this.r(O,w,F,x))).filter(O=>!!O),M={_reason:w._reason,folderQueries:q,usingSearchPaths:!!(D.searchPaths&&D.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:F.pattern,includePattern:D.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const O=a.coalesce(a.flatten(this.c.groups.map(j=>j.editors.map(le=>le.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const U=O.filter(j=>(0,S.pathIncludedInQuery)(M,j.fsPath)),z=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...M,...z}}const B=w.extraFileResources&&w.extraFileResources.filter(O=>(0,S.pathIncludedInQuery)(M,O.fsPath));return M.extraFileResources=B&&B.length?B:void 0,M}i(c){const w=[],D=new C.ResourceMap,F={};let x=!1;return c.forEach(q=>{if(q.scheme===A.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(q)){const B=this.b.getWorkspaceFolder(q)?.uri??q.with({path:y.dirname(q.fsPath)});let O=D.get(B);O||(x=!0,O={folder:B,includePattern:{}},w.push(O),D.set(B,O));const U=y.relative(B.fsPath,q.fsPath);(0,k.assertIsDefined)(O.includePattern)[U.replace(/\\/g,"/")]=!0}else q.fsPath&&(x=!0,F[q.fsPath]=!0)}),{folderQueries:w,includePattern:F,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}j(c,w){if(w.isSmartCase){if(c.isRegExp){if(L.containsUppercaseCharacter(c.pattern,!0))return!0}else if(L.containsUppercaseCharacter(c.pattern))return!0}return!!c.isCaseSensitive}k(c){return c.isMultiline||c.isRegExp&&(0,P.isMultilineRegexSource)(c.pattern)||c.pattern.indexOf(`
`)>=0?!0:!!c.isMultiline}parseSearchPaths(c){const w=z=>y.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),F=(Array.isArray(c)?c:r(c)).map(z=>{const j=this.e.resolvedUserHome;return j?(0,u.untildify)(z,j.scheme===A.Schemas.file?j.fsPath:j.path):z}),x=R.groupBy(F,z=>w(z)?"searchPaths":"exprSegments"),q=(x.exprSegments||[]).map(z=>L.rtrim(z,"/")).map(z=>L.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),o(z))),M={},B=this.m(x.searchPaths||[]);B&&B.length&&(M.searchPaths=B);const O=a.flatten(q),U=l(...O);return U&&(M.pattern=U),M}l(c,w){return w.disregardExcludeSettings?void 0:(0,S.getExcludes)(c,!w.disregardSearchExcludeSettings)}m(c){if(!c||!c.length)return[];const w=c.flatMap(F=>{let{pathPortion:x,globPortion:q}=t(F);return q&&(q=m(q)),this.n(x).flatMap(B=>this.o(B,q))}),D=new Map;return w.forEach(F=>{const x=F.searchPath.toString(),q=D.get(x);q?F.pattern&&(q.pattern=q.pattern||{},q.pattern[F.pattern]=!0):D.set(x,{searchPath:F.searchPath,pattern:F.pattern?l(F.pattern):void 0})}),Array.from(D.values())}n(c){if(y.isAbsolute(c)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==A.Schemas.file?[{searchPath:w[0].uri.with({path:c})}]:[{searchPath:v.URI.file(y.normalize(c))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(c=n(c),c.startsWith("../")||c===".."){const F=y.posix.resolve(w.path,c);return[{searchPath:w.with({path:F})}]}const D=m(c);return[{searchPath:w,pattern:D}]}else{if(c==="./"||c===".\\")return[];{const w=c.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(x=>{const q=w.match(new RegExp(`^${L.escapeRegExpCharacters(x.name)}(?:/(.*)|$)`));return q?{match:q,folder:x}:null}).filter(k.isDefined);if(F.length)return F.map(x=>{const q=x.match[1];return{searchPath:x.folder.uri,pattern:q&&m(q)}});{const x=c.match(/\.[\/\\](.+)[\/\\]?/),q=x?x[1]:c,M=E.localize(0,null,q);throw new Error(M)}}}}o(c,w){const D=c.pattern&&w?`${c.pattern}/${w}`:c.pattern||w,F=[{searchPath:c.searchPath,pattern:D}];return D&&!D.endsWith("**")&&F.push({searchPath:c.searchPath,pattern:D+"/**"}),F}q(c,w,D){const F=this.r((0,f.toWorkspaceFolder)(c.searchPath),w,D,!1);return F?{...F,includePattern:c.pattern}:null}r(c,w,D,F){let x;const q=v.URI.isUri(c)?c:c.uri;if(D.searchPaths){const z=D.searchPaths.filter(j=>(0,I.isEqual)(j.searchPath,q))[0];if(z&&!z.pattern)return null;z&&(x=z.pattern)}const M=this.a.getValue({resource:q}),O={...this.l(M,w)||{},...x||{}},U=v.URI.isUri(c)?(0,I.basename)(c):c.name;return{folder:q,folderName:F?U:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!M.search.followSymlinks}}};g=qe([We(0,h.IConfigurationService),We(1,f.IWorkspaceContextService),We(2,p.IEditorGroupsService),We(3,d.ILogService),We(4,b.IPathService)],g),e.QueryBuilder=g;function t(i){const c=i.match(/[\*\{\}\(\)\[\]\?]/);if(c){const w=c.index,D=i.substr(0,w).match(/[/|\\][^/\\]*$/);if(D){let F=i.substr(0,D.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:i.substr((D.index||0)+1)}}}return{pathPortion:i}}function l(...i){return i.length?i.reduce((c,w)=>(c[w]=!0,c),Object.create(null)):void 0}function r(i){return T.splitGlobAware(i,",").map(c=>c.trim()).filter(c=>!!c.length)}function o(i){return[`**/${i}/**`,`**/${i}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function n(i){return i.replace(/\\/g,"/")}function m(i){return n(i).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(i,c){i=a.distinct(i,F=>F.toString());const w=[],D=c.getWorkspace();return i&&i.forEach(F=>{let x;if(c.getWorkbenchState()===2)x=(0,I.relativePath)(D.folders[0].uri,F),x&&x!=="."&&(x="./"+x);else{const q=c.getWorkspaceFolder(F);if(q){const M=q.name;if(D.folders.filter(O=>O.name===M).length===1){const O=(0,I.relativePath)(q.uri,F);O===""?x=`./${q.name}`:x=`./${q.name}/${O}`}else x=F.fsPath}}x&&w.push(x)}),w}e.resolveResourcesForSearchIncludes=s}),define(ye[294],De([1,0,24,2,21,11,4,293,31,47]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function k(h,d){const f=d.activationEvents;if(!f)return Promise.resolve(void 0);const p=[],b=[];for(const o of f)if(/^workspaceContains:/.test(o)){const n=o.substr(18);n.indexOf("*")>=0||n.indexOf("?")>=0||h.forceUsingSearch?b.push(n):p.push(n)}if(p.length===0&&b.length===0)return Promise.resolve(void 0);let S;const g=new Promise((o,n)=>{S=o}),t=o=>S({activationEvent:o}),l=Promise.all(p.map(o=>v(h,o,t))).then(()=>{}),r=P(h,d.identifier,b,t);return Promise.all([l,r]).then(()=>{S(void 0)}),g}e.checkActivateWorkspaceContainsExtension=k;async function v(h,d,f){for(const p of h.folders)if(await h.exists(a.joinPath(R.URI.revive(p),d))){f(`workspaceContains:${d}`);return}}async function P(h,d,f,p){if(f.length===0)return Promise.resolve(void 0);const b=new T.CancellationTokenSource,S=h.checkExists(h.folders,f,b.token),g=setTimeout(async()=>{b.cancel(),h.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},L);let t=!1;try{t=await S}catch(l){u.isCancellationError(l)||u.onUnexpectedError(l)}b.dispose(),clearTimeout(g),t&&p(`workspaceContains:${f.join(",")}`)}function E(h,d,f,p){const b=h.get(C.IInstantiationService),S=h.get(y.ISearchService),t=b.createInstance(A.QueryBuilder).file(d.map(l=>(0,I.toWorkspaceFolder)(R.URI.revive(l))),{_reason:"checkExists",includePattern:f,exists:!0});return S.fileSearch(t,p).then(l=>!!l.limitHit,l=>u.isCancellationError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=E});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,R,T){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?T.call(te,a):T?T.value=a:e.set(te,a),a},Be=this&&this.__classPrivateFieldGet||function(te,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(te):R?R.value:e.get(te)};define(ye[42],De([1,0,177,10,82,24,17,6,68,2,13,5,34,236,99,33,27,134,11,26,22,218,7,128,4,25,78,18,90,55,41,3,294,98,220,16,97,43]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S,g,t,l,r,o,n,m,s,i,c,w,D,F,x,q,M,B){"use strict";var O,U,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let j=class Ui extends A.Disposable{constructor(ee,K,G,de,be,Ee,Pe,Fe,se,oe,fe){super(),this.a=this.B(new w.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=K,this.g=G,this.f=Pe,this.j=de,this.k=be,this.l=Ee,this.m=se,this.p=oe,this.s=fe,this.t=this.g.getProxy(k.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(k.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(k.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new f.ExtensionDescriptionRegistry(this.f.allExtensions);const Z=(0,d.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new f.ExtensionDescriptionRegistry(_(this.F,Z)),this.G=new E.ExtHostStorage(this.g,this.l),this.H=new F.ExtHostSecretState(this.g),this.I=Fe,this.h=ee.createChild(new s.ServiceCollection([E.IExtHostStorage,this.G],[F.IExtHostSecretState,this.H])),this.J=this.B(new P.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,ne,N)=>{this.v.$onExtensionActivationError(ce,p.transformErrorForSerialization(ne),N)},actualActivateExtension:async(ce,ne)=>{if(f.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,ne),new P.HostExtension;const N=this.D.getExtensionDescription(ce);return this.Y(N,ne)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),T.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(ee){p.onUnexpectedError(ee)}}async Q(){this.I.onWillDeactivateAll();let ee=[];try{ee=this.D.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this.X(be))}catch{}await Promise.all(ee)}terminate(ee,K=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${ee}`),this.l.flush(),this.p.dispose(),this.J.dispose(),p.setUnexpectedErrorHandler(de=>{this.l.error(de)}),this.g.dispose();const G=this.Q();Promise.race([(0,C.timeout)(5e3),G]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${K}`):this.l.info(`Extension host exiting with code ${K}`),this.l.flush(),this.l.dispose(),this.c.exit(K)})}isActivated(ee){return this.z.isOpen()?this.J.isActivated(ee):!1}async getExtension(ee){const K=await this.v.$getExtension(ee);let G;if(K?.browserNlsBundleUris){G={};for(const de of Object.keys(K.browserNlsBundleUris))G[de]=I.URI.revive(K.browserNlsBundleUris[de])}return K&&{...K,identifier:new b.ExtensionIdentifier(K.identifier.value),extensionLocation:I.URI.revive(K.extensionLocation),browserNlsBundleUris:G}}R(ee,K){return this.J.activateByEvent(ee,K)}S(ee,K){return this.J.activateById(ee,K)}activateByIdWithErrors(ee,K){return this.S(ee,K).then(()=>{const G=this.J.getActivatedExtension(ee);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(ee=>this.D)}getExtensionExports(ee){return this.z.isOpen()?this.J.getActivatedExtension(ee).exports:null}async U(ee){if(ee.scheme!==q.Schemas.file)return ee;const K=await this.c.realpath(ee.fsPath);return I.URI.file(K)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(ee=>new J(ee))),this.L}async W(ee){const K=y.TernarySearchTree.forUris(G=>u.extUriBiasedIgnorePathCase.ignorePathCasing(G));return await Promise.all(ee.map(async G=>{if(this.ob(G)){const de=await this.U(G.extensionLocation);K.set(de,G)}})),K}X(ee){let K=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(ee))return K;const G=this.J.getActivatedExtension(ee);if(!G)return K;try{typeof G.module.deactivate=="function"&&(K=Promise.resolve(G.module.deactivate()).then(void 0,de=>(this.l.error(de),Promise.resolve(void 0))))}catch(de){this.l.error(`An error occurred when deactivating the extension '${ee.value}':`),this.l.error(de)}try{(0,A.dispose)(G.subscriptions)}catch(de){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this.l.error(de)}return K}async Y(ee,K){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ee.identifier):await this.v.$onWillActivateExtension(ee.identifier),this.ab(ee,K).then(G=>{const de=G.activationTimes;return this.v.$onDidActivateExtension(ee.identifier,de.codeLoadingTime,de.activateCallTime,de.activateResolvedTime,K),this.Z(ee,K,"success",de),G},G=>{throw this.Z(ee,K,"failure"),G})}Z(ee,K,G,de){const be=le(ee,K);this.u.$publicLog2("extensionActivationTimes",{...be,...de||{},outcome:G})}ab(ee,K){const G=le(ee,K);this.u.$publicLog2("activatePlugin",G);const de=this.ob(ee);if(!de)return Promise.resolve(new P.EmptyExtension(P.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${K.startup}, activationEvent: '${K.activationEvent}'${ee.identifier.value!==K.extensionId.value?`, root cause: ${K.extensionId.value}`:""}`),this.l.flush();const be=new P.ExtensionActivationTimesBuilder(K.startup);return Promise.all([this.pb(ee,(0,u.joinPath)(ee.extensionLocation,de),be),this.bb(ee)]).then(Ee=>(T.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),Ui.cb(this.l,ee.identifier,Ee[0],Ee[1],be))).then(Ee=>(T.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),Ee))}bb(ee){const K=new g.ExtensionGlobalMemento(ee,this.G),G=new g.ExtensionMemento(ee.identifier.value,!1,this.G),de=new x.ExtensionSecrets(ee,this.H),be=ee.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Ee=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([K.whenReady,G.whenReady,this.I.whenReady]).then(()=>{const Pe=this;let Fe,se;const oe=(0,d.isProposedApiEnabled)(ee,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:K,workspaceState:G,secrets:de,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(fe){return R.join(ee.extensionLocation.fsPath,fe)},get storagePath(){return Pe.I.workspaceValue(ee)?.fsPath},get globalStoragePath(){return Pe.I.globalValue(ee).fsPath},get logPath(){return R.join(Pe.f.logsLocation.fsPath,ee.identifier.value)},get logUri(){return I.URI.joinPath(Pe.f.logsLocation,ee.identifier.value)},get storageUri(){return Pe.I.workspaceValue(ee)},get globalStorageUri(){return Pe.I.globalValue(ee)},get extensionMode(){return be},get extension(){return Fe===void 0&&(Fe=new V(Pe,ee.identifier,ee,Ee,!1)),Fe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(ee,"extensionRuntime"),Pe.extensionRuntime},get environmentVariableCollection(){return Pe.p.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!se){if(!oe)return;const fe=w.Event.buffer(w.Event.fromDOMEventEmitter(oe,"message",Z=>Z.data));oe.start(),se={onDidReceiveMessage:fe,postMessage:oe.postMessage.bind(oe)}}return se}})})}static cb(ee,K,G,de,be){return G=G||{activate:void 0,deactivate:void 0},this.db(ee,K,G,de,be).then(Ee=>new P.ActivatedExtension(!1,null,be.build(),G,Ee,de.subscriptions))}static db(ee,K,G,de,be){if(typeof G.activate=="function")try{be.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${K.value}`);const Ee=typeof global=="object"?global:self,Pe=G.activate.apply(Ee,[de]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Pe).then(Fe=>(be.activateResolveStop(),Fe))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(G)}eb(ee,K){this.S(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:K}).then(void 0,G=>{this.l.error(G)})}fb(){this.v.$setPerformanceMarks(T.getMarks());for(const ee of this.D.getAllExtensionDescriptions())if(ee.activationEvents)for(const K of ee.activationEvents)K==="onStartupFinished"&&this.eb(ee,K)}gb(){const ee=this.R("*",!0).then(void 0,be=>{this.l.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.hb(be.added)));const K=this.j.workspace?this.j.workspace.folders:[],G=this.hb(K),de=Promise.all([ee,G]).then(()=>{});return Promise.race([de,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),de}hb(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(K=>this.ib(ee,K))).then(()=>{})}async ib(ee,K){if(this.isActivated(K.identifier))return;const G=!this.f.remote.isRemote&&!!this.f.remote.authority,de={logService:this.l,folders:ee.map(Ee=>Ee.uri),forceUsingSearch:G,exists:Ee=>this.c.exists(Ee.fsPath),checkExists:(Ee,Pe,Fe)=>this.t.$checkExists(Ee,Pe,Fe)},be=await(0,D.checkActivateWorkspaceContainsExtension)(de,K);if(!!be)return this.S(K.identifier,{startup:!0,extensionId:K.identifier,activationEvent:be.activationEvent}).then(void 0,Ee=>this.l.error(Ee))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(ee){throw console.error(ee),ee}}async jb(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:K}=this.f.environment;if(!ee||!K)throw new Error(a.localize(0,null));const G=await this.pb(null,K,new P.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(a.localize(1,null,K.toString()));return new Promise((de,be)=>{const Ee=(se,oe)=>{se?be(se):de(typeof oe=="number"&&oe>0?1:0)},Pe=(0,u.originalFSPath)(K),Fe=G.run(Pe,Ee);Fe&&Fe.then&&Fe.then(()=>{de(0)}).catch(se=>{be(se instanceof Error&&se.stack?se.stack:String(se))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,K){return this.M[ee]=K,(0,A.toDisposable)(()=>{delete this.M[ee]})}async lb(ee){const K=ee.indexOf("+");if(K===-1)throw new Error("Not an authority that can be resolved!");const G=ee.substr(0,K);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${G}`,!1),{authorityPrefix:G,resolver:this.M[G]}}async $resolveAuthority(ee,K){const G=B.StopWatch.create(!1),de=()=>`[resolveAuthority(${(0,l.getRemoteAuthorityPrefix)(ee)},${K})][${G.elapsed()}ms] `,be=oe=>this.l.info(`${de()}${oe}`),Ee=(oe,fe=void 0)=>this.l.error(`${de()}${oe}`,fe);be("activating resolver...");const{authorityPrefix:Pe,resolver:Fe}=await this.lb(ee);if(!Fe)return Ee("no resolver"),{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Pe}.`,detail:void 0}};const se=new C.IntervalTimer;try{be("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Fe)),se.cancelAndSet(()=>be("waiting..."),1e3),be("invoking resolve()..."),T.mark(`code/extHost/willResolveAuthority/${Pe}`);const oe=await Fe.resolve(ee,{resolveAttempt:K});T.mark(`code/extHost/didResolveAuthorityOK/${Pe}`),se.dispose(),be(`returned ${oe.host}:${oe.port}`);const fe={authority:ee,host:oe.host,port:oe.port,connectionToken:oe.connectionToken},Z={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:fe,options:Z,tunnelInformation:{environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures}}}}catch(oe){if(T.mark(`code/extHost/didResolveAuthorityError/${Pe}`),se.dispose(),Ee("returned an error",oe),oe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(ee,K){this.l.info(`$getCanonicalURI invoked for authority (${(0,l.getRemoteAuthorityPrefix)(ee)})`);const{resolver:G}=await this.lb(ee);if(!G)return null;const de=I.URI.revive(K);if(typeof G.getCanonicalURI>"u")return de;const be=await(0,C.asPromise)(()=>G.getCanonicalURI(de));return be||de}static mb(ee,K,G){const de=new f.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());de.deltaExtensions(G.toAdd,G.toRemove);const be=(0,d.extensionIdentifiersArrayToSet)(K.getAllExtensionDescriptions().map(Pe=>Pe.identifier));for(const Pe of G.myToRemove)be.delete(b.ExtensionIdentifier.toKey(Pe));for(const Pe of G.myToAdd)be.add(b.ExtensionIdentifier.toKey(Pe));const Ee=_(de,be);return{globalRegistry:de,myExtensions:Ee}}$startExtensionHost(ee){ee.toAdd.forEach(de=>de.extensionLocation=I.URI.revive(de.extensionLocation));const{globalRegistry:K,myExtensions:G}=Ui.mb(this.F,this.D,ee);return this.F.set(K.getAllExtensionDescriptions()),this.D.set(G),this.kb()}$activateByEvent(ee,K){return K===1?this.R(ee,!1):this.z.wait().then(G=>this.R(ee,!1))}async $activate(ee,K){return await this.z.wait(),this.D.getExtensionDescription(ee)?(await this.S(ee,K),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(Ee=>Ee.extensionLocation=I.URI.revive(Ee.extensionLocation));const{globalRegistry:K,myExtensions:G}=Ui.mb(this.F,this.D,ee),de=await this.W(G);return(await this.getExtensionPathIndex()).setSearchTree(de),this.F.set(K.getAllExtensionDescriptions()),this.D.set(G),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const K=S.VSBuffer.alloc(ee),G=Math.random()%256;for(let de=0;de<ee;de++)K.writeUInt8(G,de);return K}async $updateRemoteConnectionData(ee){this.P=ee,this.a.fire()}};j=qe([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,m.IExtHostRpcService),We(3,h.IExtHostWorkspace),We(4,v.IExtHostConfiguration),We(5,L.ILogService),We(6,o.IExtHostInitDataService),We(7,n.IExtensionStoragePaths),We(8,i.IExtHostTunnelService),We(9,c.IExtHostTerminalService),We(10,M.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function le(ie,ee){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class V{constructor(ee,K,G,de,be){O.set(this,void 0),U.set(this,void 0),z.set(this,void 0),Je(this,O,ee,"f"),Je(this,U,K,"f"),Je(this,z,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=R.normalize((0,u.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=de,this.isFromDifferentExtensionHost=be}get isActive(){return Be(this,O,"f").isActivated(Be(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,O,"f").getExtensionExports(Be(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,O,"f").activateByIdWithErrors(Be(this,z,"f"),{startup:!1,extensionId:Be(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=V,O=new WeakMap,U=new WeakMap,z=new WeakMap;function _(ie,ee){return ie.getAllExtensionDescriptions().filter(K=>ee.has(b.ExtensionIdentifier.toKey(K.identifier)))}class J{constructor(ee){this.a=ee}setSearchTree(ee){this.a=ee}findSubstr(ee){return this.a.findSubstr(ee)}forEach(ee){return this.a.forEach(ee)}}e.ExtensionPaths=J}),define(ye[295],De([1,0,82,2,5,34,27,26,18,25,4,42,36,13,8]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(g,t,l,r,o,n,m){this.c=g,this.d=t,this.e=l,this.f=r,this.g=o,this.h=n,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const g=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new f(this.c,t,this.d,g,this.i)),this.register(this.e.createInstance(p,t)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,t,this.h.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const t of g.nodeModuleName)this.a.set(t,g);else this.a.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this.b.push(t=>g.alternativeModuleName(t))}};h=qe([We(2,L.IInstantiationService),We(3,u.IExtHostConfiguration),We(4,k.IExtHostExtensionService),We(5,I.IExtHostInitDataService),We(6,P.ILogService)],h),e.RequireInterceptor=h;let d=class rn{constructor(g){if(g.environment.appRoot&&rn.a.size){const t=(0,E.escapeRegExpCharacters)(this.c(g.environment.appRoot.fsPath)),l="[a-z0-9_.-]",r=`@${l}+\\/${l}+|${l}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${o}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(g){if(!this.b)return;const t=this.b.exec(this.c(g));if(!t)return;const[,l,r,o]=t,n=rn.a.get(r);if(n!==void 0)return console.warn(`${r} as been renamed to ${n}, please update your imports`),l+n+o}c(g){return g.replace(/\\/g,"/")}};d.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=qe([We(0,I.IExtHostInitDataService)],d);class f{constructor(g,t,l,r,o){this.c=g,this.d=t,this.e=l,this.f=r,this.g=o,this.nodeModuleName="vscode",this.a=new Map}load(g,t){const l=this.d.findSubstr(t);if(l){let r=this.a.get(A.ExtensionIdentifier.toKey(l.identifier));return r||(r=this.c(l,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(l.identifier),r)),r}if(!this.b){let r="";this.d.forEach((o,n)=>r+=`	${n} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(g,t,l){this.d=g,this.nodeModuleName="keytar",this.a=t.getProxy(T.MainContext.MainThreadTelemetry);const{environment:r}=l,o=t.getProxy(T.MainContext.MainThreadKeytar);if(r.appRoot){let n=r.appRoot.fsPath;v.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.b=new Set,this.b.add(`${n}/node_modules.asar/keytar`),this.b.add(`${n}/node_modules/keytar`)}this.c={getPassword:(n,m)=>o.$getPassword(n,m),setPassword:(n,m,s)=>o.$setPassword(n,m,s),deletePassword:(n,m)=>o.$deletePassword(n,m),findPassword:n=>o.$findPassword(n),findCredentials(n){return o.$findCredentials(n)}}}load(g,t){const l=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:l?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(g){const t=g.length;if(t<=7||!this.b)return;const l=t-7;if((g.charAt(l)==="/"||g.charAt(l)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.b.has(g)))return"keytar"}};p=qe([We(1,y.IExtHostRpcService),We(2,I.IExtHostInitDataService)],p);let b=class{constructor(g,t,l){this.e=g,this.f=t,this.nodeModuleName=["open","opn"],this.d=l.getProxy(T.MainContext.MainThreadTelemetry);const r=l.getProxy(T.MainContext.MainThreadWindow);this.c=(o,n)=>{const m=R.URI.parse(o);return n?this.g(o,n):m.scheme==="http"||m.scheme==="https"?r.$openUri(m,o,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?r.$openUri(m,o,{}):this.g(o,n)}}load(g,t,l){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=l(g),this.c}g(g,t){return this.i(),this.b(g,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([We(2,y.IExtHostRpcService)],b)}),define(ye[49],De([1,0,65,6,10,36,4,59,60,42,7,33,232,34]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class E extends v.AbstractVariableResolverService{constructor(f,p,b,S,g,t,l){function r(){if(b){const o=b.activeEditor();if(o)return o.document.uri;const n=S.tabGroups.all.find(m=>m.isActive)?.activeTab;if(n!==void 0){if(n.input instanceof L.TextDiffTabInput||n.input instanceof L.NotebookDiffEditorTabInput)return n.input.modified;if(n.input instanceof L.TextTabInput||n.input instanceof L.NotebookEditorTabInput||n.input instanceof L.CustomEditorTabInput)return n.input.uri}}}super({getFolderUri:o=>{const n=t.folders.filter(m=>m.name===o);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,n)=>g.getConfiguration(void 0,o).get(n),getAppRoot:()=>u.cwd(),getExecPath:()=>u.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=r();if(o)return T.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const o=r();if(o){const n=p.getWorkspaceFolder(o);if(n)return T.normalize(n.uri.fsPath)}}},getSelectedText:()=>{if(b){const o=b.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(b){const o=b.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>f.getExtension(o)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(u.env))}}let h=class extends R.Disposable{constructor(f,p,b,S,g){super(),this.b=f,this.c=p,this.g=b,this.h=S,this.i=g,this.a=new a.Lazy(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new E(this.b,this.c,this.g,this.i,t,r,this.j())})}getResolver(){return this.a.value}j(){}};h=qe([We(0,I.IExtHostExtensionService),We(1,k.IExtHostWorkspace),We(2,A.IExtHostDocumentsAndEditors),We(3,P.IExtHostConfiguration),We(4,y.IExtHostEditorTabs)],h),e.ExtHostVariableResolverProviderService=h}),define(ye[83],De([1,0,17,3,9,2,4,5,60,42,18,7,33,131,225,34,49]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,o,n,m,s,i){this.D=o,this.E=n,this.F=m,this.G=s,this.H=i,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new R.Emitter,this.n=new R.Emitter,this.o=new R.Emitter,this.u=new R.Emitter,this.k=r.getProxy(A.MainContext.MainThreadDebugService),this.z=new R.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(c=>{c.onDidChange(w=>{this.I(c)}),this.I(c)})}asDebugSourceUri(r,o){const n=r;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let m=`debug:${encodeURIComponent(n.path||"")}`,s="?";return o&&(m+=`${s}session=${encodeURIComponent(o.id)}`,s="&"),m+=`${s}ref=${n.sourceReference}`,u.URI.parse(m)}else{if(n.path)return u.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const o=[];for(const n of r.getAllExtensionDescriptions())if(n.contributes){const m=n.contributes.debuggers;if(m&&m.length>0)for(const s of m)(0,E.isDebuggerMainContribution)(s)&&o.push(s.type)}this.k.$registerDebugTypes(o)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(o=>r.push(o)),r}addBreakpoints(r){this.T();const o=r.filter(s=>{const i=s.id;return this.w.has(i)?!1:(this.w.set(i,s),!0)});this.U(o,[],[]);const n=[],m=new Map;for(const s of o)if(s instanceof k.SourceBreakpoint){let i=m.get(s.location.uri.toString());i||(i={type:"sourceMulti",uri:s.location.uri,lines:[]},m.set(s.location.uri.toString(),i),n.push(i)),i.lines.push({id:s.id,enabled:s.enabled,condition:s.condition,hitCondition:s.hitCondition,logMessage:s.logMessage,line:s.location.range.start.line,character:s.location.range.start.character})}else s instanceof k.FunctionBreakpoint&&n.push({type:"function",id:s.id,enabled:s.enabled,hitCondition:s.hitCondition,logMessage:s.logMessage,condition:s.condition,functionName:s.functionName});return this.k.$registerBreakpoints(n)}removeBreakpoints(r){this.T();const o=r.filter(i=>this.w.delete(i.id));this.U([],o,[]);const n=o.filter(i=>i instanceof k.SourceBreakpoint).map(i=>i.id),m=o.filter(i=>i instanceof k.FunctionBreakpoint).map(i=>i.id),s=o.filter(i=>i instanceof k.DataBreakpoint).map(i=>i.id);return this.k.$unregisterBreakpoints(n,m,s)}startDebugging(r,o,n){return this.k.$startDebugging(r?r.uri:void 0,o,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,suppressSaveBeforeStart:n.suppressSaveBeforeStart,suppressDebugStatusbar:n.suppressDebugStatusbar??n.debugUI?.simple,suppressDebugToolbar:n.suppressDebugToolbar??n.debugUI?.simple,suppressDebugView:n.suppressDebugView??n.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,o,n){if(!o)return new k.Disposable(()=>{});const m=this.d++;return this.f.push({type:r,handle:m,provider:o}),this.k.$registerDebugConfigurationProvider(r,n,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,m),new k.Disposable(()=>{this.f=this.f.filter(s=>s.provider!==o),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(r,o,n){if(!n)return new k.Disposable(()=>{});if(!this.P(r,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.M(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:o,handle:m,factory:n}),this.k.$registerDebugAdapterDescriptorFactory(o,m),new k.Disposable(()=>{this.h=this.h.filter(s=>s.factory!==n),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(r,o){if(!o)return new k.Disposable(()=>{});const n=this.i++;return this.j.push({type:r,handle:n,factory:o}),new k.Disposable(()=>{this.j=this.j.filter(m=>m.factory!==o)})}async $runInTerminal(r,o){return Promise.resolve(void 0)}async $substituteVariables(r,o){let n;const m=await this.W(r);return m&&(n={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(n,o)}J(r,o){if(r.type==="implementation")return new g(r.implementation)}K(){}async $startDASession(r,o){const n=this,m=await this.V(o);return this.R(this.M(m.type),m).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const i=this.L(s),c=this.J(i,m);if(!c)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const w=c;return this.A.set(r,w),this.Q(m).then(D=>(D&&this.B.set(r,D),w.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const x=F,q={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const M=await this.C.sign(x.arguments.value);q.body={signature:M},w.sendResponse(q)}else throw new Error("no signer")}catch(M){q.success=!1,q.message=M.message,w.sendResponse(q)}}else D&&D.onDidSendMessage&&D.onDidSendMessage(F),F=(0,E.convertToVSCPaths)(F,!0),n.k.$acceptDAMessage(r,F)}),w.onError(F=>{D&&D.onError&&D.onError(F),this.k.$acceptDAError(r,F.name,F.message,F.stack)}),w.onExit(F=>{D&&D.onExit&&D.onExit((0,T.withNullAsUndefined)(F),void 0),this.k.$acceptDAExit(r,(0,T.withNullAsUndefined)(F),void 0)}),D&&D.onWillStartSession&&D.onWillStartSession(),w.startSession()))})}$sendDAMessage(r,o){o=(0,E.convertToDAPaths)(o,!1);const n=this.B.get(r);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(o),this.A.get(r)?.sendMessage(o)}$stopDASession(r){const o=this.B.get(r);this.B.delete(r),o&&o.onWillStopSession&&o.onWillStopSession();const n=this.A.get(r);return this.A.delete(r),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const o=[],n=[],m=[];if(r.added)for(const s of r.added){const i=s.id;if(i&&!this.w.has(i)){let c;if(s.type==="function")c=new k.FunctionBreakpoint(s.functionName,s.enabled,s.condition,s.hitCondition,s.logMessage);else if(s.type==="data")c=new k.DataBreakpoint(s.label,s.dataId,s.canPersist,s.enabled,s.hitCondition,s.condition,s.logMessage);else{const w=u.URI.revive(s.uri);c=new k.SourceBreakpoint(new k.Location(w,new k.Position(s.line,s.character)),s.enabled,s.condition,s.hitCondition,s.logMessage)}(0,k.setBreakpointId)(c,i),this.w.set(i,c),o.push(c)}}if(r.removed)for(const s of r.removed){const i=this.w.get(s);i&&(this.w.delete(s),n.push(i))}if(r.changed){for(const s of r.changed)if(s.id){const i=this.w.get(s.id);if(i){if(i instanceof k.FunctionBreakpoint&&s.type==="function"){const c=i;c.enabled=s.enabled,c.condition=s.condition,c.hitCondition=s.hitCondition,c.logMessage=s.logMessage,c.functionName=s.functionName}else if(i instanceof k.SourceBreakpoint&&s.type==="source"){const c=i;c.enabled=s.enabled,c.condition=s.condition,c.hitCondition=s.hitCondition,c.logMessage=s.logMessage,c.location=new k.Location(u.URI.revive(s.uri),new k.Position(s.line,s.character))}m.push(i)}}}this.U(o,n,m)}$provideDebugConfigurations(r,o,n){return(0,a.asPromise)(async()=>{const m=this.O(r);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const s=await this.W(o);return m.provideDebugConfigurations(s,n)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(r,o,n,m){return(0,a.asPromise)(async()=>{const s=this.O(r);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const i=await this.W(o);return s.resolveDebugConfiguration(i,n,m)})}$resolveDebugConfigurationWithSubstitutedVariables(r,o,n,m){return(0,a.asPromise)(async()=>{const s=this.O(r);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const i=await this.W(o);return s.resolveDebugConfigurationWithSubstitutedVariables(i,n,m)})}async $provideDebugAdapter(r,o){const n=this.N(r);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(o);return this.R(n,m).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.L(s)})}async $acceptDebugSessionStarted(r){const o=await this.V(r);this.m.fire(o)}async $acceptDebugSessionTerminated(r){const o=await this.V(r);o&&(this.n.fire(o),this.l.delete(o.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,o){(await this.V(r))?._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(r,o){const m={session:await this.V(r),event:o.event,body:o.body};this.u.fire(m)}L(r){if(r instanceof k.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof k.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const o=this.h.filter(n=>n.type===r);if(o.length>0)return o[0].factory}N(r){const o=this.h.filter(n=>n.handle===r);if(o.length>0)return o[0].factory}O(r){const o=this.f.filter(n=>n.handle===r);if(o.length>0)return o[0].provider}P(r,o){if(r.contributes){const n=r.contributes.debuggers;if(n&&n.length>0){for(const m of n)if(m.label&&m.type&&m.type===o)return!0}}return!1}Q(r){const n=r.configuration.type,m=this.j.filter(s=>s.type===n||s.type==="*").map(s=>(0,a.asPromise)(()=>s.factory.createDebugAdapterTracker(r)).then(i=>i,i=>null));return Promise.race([Promise.all(m).then(s=>{const i=s.filter(c=>!!c);if(i.length>0)return new S(i)}),new Promise(s=>setTimeout(()=>s(void 0),1e3))]).catch(s=>{})}async R(r,o){const n=o.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new k.DebugAdapterServer(n));if(r){const s=await this.E.getExtensionRegistry();return(0,a.asPromise)(()=>r.createDebugAdapterDescriptor(o,this.S(o,s))).then(i=>{if(i)return i})}const m=await this.E.getExtensionRegistry();return Promise.resolve(this.S(o,m))}S(r,o){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,o,n){(r.length>0||o.length>0||n.length>0)&&this.z.fire(Object.freeze({added:r,removed:o,changed:n}))}async V(r){if(r)if(typeof r=="string"){const o=this.l.get(r);if(o)return o}else{let o=this.l.get(r.id);if(!o){const n=await this.W(r.folderUri),m=r.parent?this.l.get(r.parent):void 0;o=new p(this.k,r.id,r.type,r.name,n,r.configuration,m),this.l.set(o.id,o),this.k.$sessionCached(o.id)}return o}throw new Error("cannot find session")}W(r){if(r){const o=u.URI.revive(r);return this.D.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};f=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,h.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class p{constructor(r,o,n,m,s,i,c){this.d=r,this.f=o,this.g=n,this.h=m,this.i=s,this.j=i,this.k=c}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,o){return this.d.$customDebugAdapterRequest(this.f,r,o)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=p;class b{constructor(r){this.value=Object.freeze({append(o){r.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.ExtHostDebugConsole=b;class S{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(o=>o.onError?o.onError(r):void 0)}onExit(r,o){this.d.forEach(n=>n.onExit?n.onExit(r,o):void 0)}}class g extends P.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends f{constructor(r,o,n,m,s,i){super(r,o,n,m,s,i)}};t=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,h.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(ye[296],De([1,0,11,82,2,5,288,13,89,90,25,201,18,56,42,96]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(b){const S=b.get(A.ILogService),t=b.get(v.IExtHostRpcService).getProxy(u.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(l=>{S.error(l);const r=a.transformErrorForSerialization(l);t.$onUnexpectedError(r)})}static async installFullHandler(b){const S=b.get(A.ILogService),g=b.get(v.IExtHostRpcService),t=b.get(E.IExtHostExtensionService),l=b.get(h.IExtHostTelemetry),r=g.getProxy(u.MainContext.MainThreadExtensionService),o=g.getProxy(u.MainContext.MainThreadErrors),n=await t.getExtensionPathIndex(),m=new WeakMap;Error.prepareStackTrace=(s,i)=>{let c="",w,D;for(const F of i)c+=`
	at ${F.toString()}`,D=F.getFileName(),!w&&D&&(w=n.findSubstr(T.URI.file(D)));return m.set(s,w?.identifier),`${s.name||"Error"}: ${s.message||""}${c}`},a.setUnexpectedErrorHandler(s=>{S.error(s);const i=a.transformErrorForSerialization(s),c=m.get(s);if(!c){o.$onUnexpectedError(i);return}r.$onExtensionRuntimeError(c,i);const w=l.onExtensionError(c,s);S.trace("forwarded error to extension?",w,c)})}}Error.stackTraceLimit=100;class f{constructor(b,S,g,t,l){this.a=g,this.b=new C.RPCProtocol(b,null,t),S=f.e(S,this.b);const r=new I.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...S,messagePorts:l}),r.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),r.set(P.IURITransformerService,new P.URITransformerService(t)),r.set(E.IHostUtils,g);const o=new k.InstantiationService(r,!0);o.invokeFunction(d.installEarlyHandler),this.d=o.invokeFunction(n=>n.get(A.ILogService)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",S),this.c=o.invokeFunction(n=>n.get(E.IExtHostExtensionService)),this.c.initialize(),o.invokeFunction(d.installFullHandler)}async asBrowserUri(b){const S=this.b.getProxy(u.MainContext.MainThreadExtensionService);return T.URI.revive(await S.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,S){b.allExtensions.forEach(t=>{t.extensionLocation=T.URI.revive(S.transformIncomingURIs(t.extensionLocation));const l={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(r=>l[r]=T.URI.revive(S.transformIncomingURIs(t.browserNlsBundleUris[r]))),t.browserNlsBundleUris=l)}),b.environment.appRoot=T.URI.revive(S.transformIncomingURIs(b.environment.appRoot));const g=b.environment.extensionDevelopmentLocationURI;return g&&(b.environment.extensionDevelopmentLocationURI=g.map(t=>T.URI.revive(S.transformIncomingURIs(t)))),b.environment.extensionTestsLocationURI=T.URI.revive(S.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=T.URI.revive(S.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=T.URI.revive(S.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=T.URI.revive(S.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=T.URI.revive(S.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=T.URI.revive(S.transformIncomingURIs(b.logsLocation)),b.logFile=T.URI.revive(S.transformIncomingURIs(b.logFile)),b.workspace=S.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=f}),define(ye[297],De([1,0,17,12,183,200,208,83,60,42,18,41,7,49,33,226,228,34]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let p=class extends A.ExtHostDebugServiceBase{constructor(l,r,o,n,m,s,i){super(l,r,o,n,s,i),this.Z=m,this.X=new g}J(l,r){switch(l.type){case"server":return new h.SocketDebugAdapter(l);case"pipeServer":return new h.NamedPipeDebugAdapter(l);case"executable":return new h.ExecutableDebugAdapter(l,r.type)}return super.J(l,r)}S(l,r){const o=h.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),l.type);if(o)return new v.DebugAdapterExecutable(o.command,o.args,o.options)}K(){return new C.SignService}async $runInTerminal(l,r){if(l.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const o=await this.F.getConfigProvider(),n=this.Z.getDefaultShell(!0),m=this.Z.getDefaultShellArgs(!0),s=l.title||T.localize(0,null),i=JSON.stringify({shell:n,shellArgs:m});let c=await this.X.checkout(i,s),w,D=!1;if(c)w=l.cwd;else{const M={shellPath:n,shellArgs:m,cwd:l.cwd,name:s,iconPath:new v.ThemeIcon("debug")};D=!0,c=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(c,i)}c.show(!0);const F=await c.processId;D?await new Promise(M=>setTimeout(M,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?c.sendText("cls"):n.indexOf("bash")>=0?c.sendText("clear"):R.isWindows?c.sendText("cls"):c.sendText("clear"));const x=(0,d.prepareCommand)(n,l.args,!!l.argsCanBeInterpretedByShell,w,l.env);c.sendText(x);const q=this.onDidTerminateDebugSession(M=>{M.id===r&&(this.X.free(c),q.dispose())});return F}else if(l.kind==="external")return S(l,await this.F.getConfigProvider());return super.$runInTerminal(l,r)}};p=qe([We(0,L.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,I.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,k.IExtHostTerminalService),We(5,y.IExtHostEditorTabs),We(6,P.IExtHostVariableResolverProvider)],p),e.ExtHostDebugService=p;let b;function S(t,l){if(!b)if(R.isWindows)b=new u.WindowsExternalTerminalService;else if(R.isMacintosh)b=new u.MacExternalTerminalService;else if(R.isLinux)b=new u.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=l.getConfiguration("terminal");return b.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class g{constructor(){this.b=new Map}async checkout(l,r){const n=[...this.b.entries()].map(([m,s])=>(0,a.createCancelablePromise)(async i=>{if(m.name!==r||s.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await m.processId))return null;const c=Date.now();return s.lastUsedAt+g.a>c||i.isCancellationRequested||s.config!==l?null:(s.lastUsedAt=c,m)}));return await(0,a.firstParallel)(n,m=>!!m)}insert(l,r){this.b.set(l,{lastUsedAt:Date.now(),config:r})}free(l){const r=this.b.get(l);r&&(r.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}g.a=1e3}),define(ye[298],De([1,0,10,2,116,33,59,34,47,41,18,25,81,16,13,76,24,88,49]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends v.ExtHostTaskBase{constructor(g,t,l,r,o,n,m,s,i){super(g,t,l,r,o,n,m,s),this.B=l,this.C=i,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,t){const l=t;if(!t.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const r=v.TaskHandleDTO.from(l,this.B),o=await this.a.$getTaskExecution(r);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.y(o,t);return this.a.$executeTask(r).catch(()=>{}),n}else{const r=v.TaskDTO.from(t,g);if(r===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(r.execution)&&await this.x(r,t,!1);const o=await this.y(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),o}}u(g,t,l,r){const o=[];if(r)for(const n of r){this.z(n,l),(!n.definition||!g[n.definition.type])&&this.f.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const m=v.TaskDTO.from(n,l.extension);m&&(o.push(m),v.CustomExecutionDTO.is(m.execution)&&t.push(this.x(m,n,!0)))}return{tasks:o,extension:l.extension}}async v(g){return g}async F(g){let t=g&&g.length>0?g[0]:void 0;if(!t){const l=R.URI.file((0,f.homedir)());t=new y.WorkspaceFolder({uri:l,name:d.basename(l),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,t){const l=R.URI.revive(g),r={process:void 0,variables:Object.create(null)},o=await this.b.resolveWorkspaceFolder(l),n=await this.b.getWorkspaceFolders2()??[],m=await this.C.getResolver(),s=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(n);for(const i of t.variables)r.variables[i]=await m.resolveAsync(s,i);if(t.process!==void 0){let i;if(t.process.path!==void 0){i=t.process.path.split(a.delimiter);for(let c=0;c<i.length;c++)i[c]=await m.resolveAsync(s,i[c])}r.process=await T.win32.findExecutable(await m.resolveAsync(s,t.process.name),t.process.cwd!==void 0?await m.resolveAsync(s,t.process.cwd):void 0,i)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(g,t,l){return T.win32.findExecutable(g,t,l)}};b=qe([We(0,L.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,u.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,E.ILogService),We(7,h.IExtHostApiDeprecationService),We(8,p.IExtHostVariableResolverProvider)],b),e.ExtHostTask=b}),define(ye[299],De([1,0,88,49]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class T extends R.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=T}),define(ye[143],De([1,0,15,17,21,45,16,10,24,2,31]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(p,b,S,g){this.d=p,this.e=b,this.f=S,this.g=g,this.a=null,this.b=!1,this.c=0}search(p,b){const S=this.d.folderQueries||[],g=new T.CancellationTokenSource;return b.onCancellationRequested(()=>g.cancel()),new Promise((t,l)=>{this.a=new P(p);let r=!1;const o=(n,m)=>{if(!r&&!this.b){const s=this.h(n);h(n)&&typeof this.d.maxResults=="number"&&this.c+s>this.d.maxResults&&(this.b=!0,r=!0,g.cancel(),n=this.j(n,this.d.maxResults-this.c));const i=this.h(n);this.c+=i,(i>0||!h(n))&&this.a.add(n,m)}};Promise.all(S.map((n,m)=>this.k(n,s=>o(s,m),g.token))).then(n=>{g.dispose(),this.a.flush();const m=n.some(s=>!!s&&!!s.limitHit);t({limitHit:this.b||m,messages:(0,a.flatten)(n.map(s=>s?.message?Array.isArray(s.message)?s.message:[s.message]:[])),stats:{type:this.g}})},n=>{g.dispose();const m=(0,u.toErrorMessage)(n);l(new Error(m))})})}h(p){return h(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,b){const S=Array.isArray(p.ranges)?p.ranges:[p.ranges],g=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:S.slice(0,b),preview:{matches:g.slice(0,b),text:p.preview.text},uri:p.uri}}async k(p,b,S){const g=new L.QueryGlobTester(this.d,p),t=[],l={report:n=>{if(!this.l(n))return;const m=p.folder.scheme===C.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(n.uri))):void 0,s=y.relativePath(p.folder,n.uri);if(s){const i=g.includedInQuery(s,A.basename(s),m);(0,R.isThenable)(i)?t.push(i.then(c=>{c&&b(n)})):i&&b(n)}}},r=this.n(p),o=await this.e.provideTextSearchResults(v(this.d.contentPattern),r,l,S);return t.length&&await Promise.all(t),o}l(p){if(h(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const b=(0,L.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),S=(0,L.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),g={folder:I.URI.from(p.folder),excludes:S,includes:b,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.TextSearchManager=k;function v(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class P{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new d(512,b=>this.g(b))}add(p,b){this.d&&(this.b!==b||!y.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:p.uri,results:[]}),this.d.results.push(E(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=P;function E(f){return h(f)?{preview:{matches:(0,a.mapArrayOrNot)(f.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:f.preview.text},ranges:(0,a.mapArrayOrNot)(f.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function h(f){return!!f.preview}e.extensionResultIsMatch=h;class d{constructor(p,b){this.g=p,this.h=b,this.c=0,this.d=[],this.e=0}addItem(p,b){!p||this.j(p,b)}addItems(p,b){!p||this.k(p,b)}j(p,b){this.d.push(p),this.e+=b,this.l()}k(p,b){this.d=this.d.concat(p),this.e+=b,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=d,d.a=4e3,d.b=50}),define(ye[84],De([1,0,6,5,4,292,18,56,13,2,143]),function(te,e,a,R,T,u,C,A,y,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let k=class{constructor(h,d,f){this.k=h,this.l=d,this.n=f,this.c=this.k.getProxy(R.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new u.FileSearchManager}o(h){return this.l.transformOutgoingScheme(h)}registerTextSearchProvider(h,d){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const f=this.d++;return this.e.set(f,d),this.c.$registerTextSearchProvider(f,this.o(h)),(0,a.toDisposable)(()=>{this.g.delete(h),this.e.delete(f),this.c.$unregisterProvider(f)})}registerFileSearchProvider(h,d){if(this.i.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.i.add(h);const f=this.d++;return this.h.set(f,d),this.c.$registerFileSearchProvider(f,this.o(h)),(0,a.toDisposable)(()=>{this.i.delete(h),this.h.delete(f),this.c.$unregisterProvider(f)})}$provideFileSearchResults(h,d,f,p){const b=v(f),S=this.h.get(h);if(S)return this.j.fileSearch(b,S,g=>{this.c.$handleFileMatch(h,d,g.map(t=>t.resource))},p);throw new Error("unknown provider: "+h)}$clearCache(h){return this.j.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,d,f,p){const b=this.e.get(h);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const S=v(f);return this.q(S,b).search(t=>this.c.$handleTextMatch(h,d,t),p)}$enableExtensionHostSearch(){}q(h,d){return new L.TextSearchManager(h,d,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};k=qe([We(0,C.IExtHostRpcService),We(1,A.IURITransformerService),We(2,y.ILogService)],k),e.ExtHostSearch=k;function v(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(P),extraFileResources:E.extraFileResources&&E.extraFileResources.map(h=>I.URI.revive(h))}}e.reviveQuery=v;function P(E){return{...E,folder:I.URI.revive(E.folder)}}}),define(ye[300],De([1,0,89,142,33,139,34,40,59,41,81,83,84,99,55,76,141,77,48,98,96,60,140,13,217,49,97]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S,g,t,l,r,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(n.IExtHostLocalizationService,n.ExtHostLocalizationService,1),(0,a.registerSingleton)(l.ILoggerService,t.ExtHostLoggerService,1),(0,a.registerSingleton)(l.ILogService,r.ExtHostLogService,1),(0,a.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,a.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,a.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,a.registerSingleton)(u.IExtHostDecorations,u.ExtHostDecorations,0),(0,a.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService,1),(0,a.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,a.registerSingleton)(P.IExtHostStorage,P.ExtHostStorage,0),(0,a.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,a.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,0),(0,a.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,a.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace,0),(0,a.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,a.registerSingleton)(S.IExtHostTelemetry,S.ExtHostTelemetry,0),(0,a.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,0),(0,a.registerSingleton)(o.IExtHostVariableResolverProvider,o.ExtHostVariableResolverProviderService,0)}),define(ye[100],De([1,0,15,13,31,80]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=C;function A(k,v,P,E){const h=(0,a.mapArrayOrNot)(P,y),d=new T.TextSearchMatch(v,h,E),f=d.preview.matches;return{ranges:(0,a.mapArrayOrNot)(h,I),uri:k,preview:{text:d.preview.text,matches:(0,a.mapArrayOrNot)(f,I)}}}e.createTextSearchResult=A;function y(k){return new T.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function I(k){return new u.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let L=class{constructor(v,P){this.a=v,this.b=P}appendLine(v){this.b.debug(`${this.a}#search`,v)}};L=qe([We(1,R.ILogService)],L),e.OutputChannel=L}),define(ye[301],De([1,0,46,10,85,32,12,8,100,302]),function(te,e,a,R,T,u,C,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(b,S,g,t){const l=v(b,S,g,t),r=S.folder.fsPath;return{cmd:a.spawn(L,l.args,{cwd:r}),rgDiskPath:L,siblingClauses:l.siblingClauses,rgArgs:l,cwd:r}}e.spawnRipgrepCmd=k;function v(b,S,g,t){const l=["--files","--hidden","--case-sensitive"];E([S],g,!1).forEach(o=>{const n=(0,y.anchorGlob)(o);if(l.push("-g",n),C.isMacintosh){const m=(0,T.normalizeNFD)(n);m!==n&&l.push("-g",m)}});const r=P([S],t,void 0,!1);return r.globArgs.forEach(o=>{const n=`!${(0,y.anchorGlob)(o)}`;if(l.push("-g",n),C.isMacintosh){const m=(0,T.normalizeNFD)(n);m!==n&&l.push("-g",m)}}),S.disregardIgnoreFiles!==!1?l.push("--no-ignore"):S.disregardParentIgnoreFiles!==!1&&l.push("--no-ignore-parent"),S.ignoreSymlinks||l.push("--follow"),b.exists&&l.push("--quiet"),l.push("--no-config"),S.disregardGlobalIgnoreFiles&&l.push("--no-ignore-global"),{args:l,siblingClauses:r.siblingClauses}}function P(b,S,g,t=!0){const l=[];let r={};return b.forEach(o=>{const n=Object.assign({},o.excludePattern||{},S||{}),m=h(n,t?o.folder.fsPath:void 0,g);l.push(...m.globArgs),m.siblingClauses&&(r=Object.assign(r,m.siblingClauses))}),{globArgs:l,siblingClauses:r}}function E(b,S,g=!0){const t=[];return b.forEach(l=>{const r=Object.assign({},S||{},l.includePattern||{}),o=h(r,g?l.folder.fsPath:void 0);t.push(...o.globArgs)}),t}function h(b,S,g){const t=[],l={};return Object.keys(b).forEach(r=>{if(g&&g.has(r)||!r)return;const o=b[r];r=f(S?d(S,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof o=="boolean"&&o?(r.startsWith("\\\\")&&(r+="**"),t.push(p(r))):o&&o.when&&(l[r]=o)}),{globArgs:t,siblingClauses:l}}function d(b,S){return R.isAbsolute(S)?S:R.join(b,S)}e.getAbsoluteGlob=d;function f(b){return b=A.rtrim(b,"\\"),A.rtrim(b,"/")}function p(b){return u.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=p}),define(ye[303],De([1,0,46,70,10,304,15,45,38,85,32,12,43,8,9,29,31,301,111]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(r=>r())});class S{constructor(o){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=o,this.b=o.filePattern||"",this.d=o.includePattern&&y.parse(o.includePattern),this.f=o.maxResults||null,this.g=!!o.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,p.prepareQuery)(this.b).normalizedLowercase),this.u=o.excludePattern&&y.parse(o.excludePattern),this.t=new Map,o.folderQueries.forEach(n=>{const m=Object.assign({},n.excludePattern||{},this.a.excludePattern||{}),s=n.folder.fsPath;o.folderQueries.map(i=>i.folder.fsPath).filter(i=>i!==s).forEach(i=>{(0,L.isEqualOrParent)(i,s)&&(m[T.relative(s,i)]=!0)}),this.t.set(s,new t(m,s))})}cancel(){this.l=!0,b.forEach(o=>o())}walk(o,n,m,s,i){if(this.m=v.StopWatch.create(!1),this.l)return i(null,this.j);n.forEach(c=>{const w=T.basename(c.fsPath);this.u&&this.u(c.fsPath,w)||this.J(m,{relativePath:c.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(o,(c,w)=>{this.x(this.y,this,c,m,s,D=>{if(D){const F=(0,A.toErrorMessage)(D);console.error(F),this.q.push(F),w(D,void 0)}else w(null,void 0)})},(c,w)=>{this.m.stop();const D=c?C.coalesce(c)[0]:null;i(D,this.j)})}w(o,n,m){const s=new Array(o.length),i=new Array(o.length);let c=!1,w=0;if(o.length===0)return m(null,[]);o.forEach((D,F)=>{n(D,(x,q)=>{if(x?(c=!0,s[F]=null,i[F]=x):(s[F]=q,i[F]=null),++w===o.length)return m(c?i:null,s)})})}x(o,n,...m){try{o.apply(n,m)}catch(s){m[m.length-1](s)}}y(o,n,m,s){const i=o.folder.fsPath,c=k.isMacintosh,w=()=>M&&M.kill();b.add(w);let D=z=>{b.delete(w),D=()=>{},s(z)},F="";const x=this.D(),q=(0,f.spawnRipgrepCmd)(this.a,o,this.a.includePattern,this.t.get(o.folder.fsPath).expression),M=q.cmd,B=!Object.keys(q.siblingClauses).length,O=q.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let U=`${q.rgDiskPath} ${O}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),m({message:U}),this.s=0,this.z(M,"utf8",m,(z,j,le)=>{if(z){D(z);return}if(this.j){D();return}const _=(F+(c?I.normalizeNFC(j||""):j)).split(`
`);if(le){const J=_.length;_[J-1]=_[J-1].trim(),_[J-1]||_.pop()}else F=_.pop()||"";if(_.length&&_[0].indexOf(`
`)!==-1){D(new Error("Splitting up files failed"));return}if(this.s+=_.length,B){for(const J of _)if(this.J(n,{base:i,relativePath:J,searchPath:this.N(o,J)}),this.j){w();break}(le||this.j)&&D();return}this.G(o,x,i,_,n),le&&(this.H(x,i,n),D())})}spawnFindCmd(o){const n=this.t.get(o.folder.fsPath),m=n.getBasenameTerms(),s=n.getPathTerms(),i=["-L","."];if(m.length||s.length){i.push("-not","(","(");for(const c of m)i.push("-name",c),i.push("-o");for(const c of s)i.push("-path",c),i.push("-o");i.pop(),i.push(")","-prune",")")}return i.push("-type","f"),a.spawn("find",i,{cwd:o.folder.fsPath})}readStdout(o,n,m){let s="";this.z(o,n,()=>{},(i,c,w)=>{if(i){m(i);return}s+=c,w&&m(null,s)})}z(o,n,m,s){let i=(D,F,x)=>{(D||x)&&(i=()=>{},this.r?.stop()),s(D,F,x)},c=!1;o.stdout?(this.A(o.stdout,n,i),o.stdout.once("data",()=>c=!0)):m({message:"stdout is null"});let w;o.stderr?w=this.B(o.stderr):m({message:"stderr is null"}),o.on("error",D=>{i(D)}),o.on("close",D=>{let F;!c&&(F=this.C(w,n))&&l(F)?i(new Error(`command failed with error code ${D}: ${this.C(w,n)}`)):(this.g&&D===0&&(this.j=!0),i(null,"",!0))})}A(o,n,m){const s=new u.StringDecoder(n);return o.on("data",i=>{m(null,s.write(i))}),s}B(o){const n=[];return o.on("data",m=>{n.push(m)}),n}C(o,n){const m=new u.StringDecoder(n);return o.map(s=>m.write(s)).join("")}D(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}G(o,{pathToEntries:n},m,s,i){s.indexOf(this.b)!==-1&&this.J(i,{base:m,relativePath:this.b,searchPath:this.N(o,this.b)});const c=w=>{const D=T.basename(w),F=T.dirname(w);let x=n[F];x||(x=n[F]=[],c(F)),x.push({base:m,relativePath:w,basename:D,searchPath:this.N(o,w)})};s.forEach(c)}H({rootEntries:o,pathToEntries:n},m,s){const i=this,c=this.t.get(m),w=this.b;function D(F){i.o++;const x=(0,d.hasSiblingFn)(()=>F.map(q=>q.basename));for(let q=0,M=F.length;q<M;q++){const B=F[q],{relativePath:O,basename:U}=B;if(c.test(O,U,w!==U?x:void 0))continue;const z=n[O];if(z)D(z);else{if(i.p++,O===w)continue;i.J(s,B)}if(i.j)break}}D(o)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(o,n,m,s,i){const c=o.folder,w=(0,d.hasSiblingFn)(()=>m);this.w(m,(D,F)=>{if(this.l||this.j)return F(null);const x=n?[n,D].join(T.sep):D;if(this.t.get(o.folder.fsPath).test(x,D,this.a.filePattern!==D?w:void 0))return F(null);const q=[c.fsPath,x].join(T.sep);R.lstat(q,(M,B)=>{if(M||this.l||this.j)return F(null);this.L(q,B,(O,U)=>O||this.l||this.j?F(null):U.isDirectory()?(this.o++,this.M(q,B,(z,j)=>z||this.l||this.j||(j=j||"",this.v[j])?F(null):(this.v[j]=!0,h.Promises.readdir(q).then(le=>{if(this.l||this.j)return F(null);this.I(o,x,le,s,V=>F(V||null))},le=>{F(null)})))):(this.p++,x===this.b||this.h&&E.isNumber(U.size)&&U.size>this.h||this.J(s,{base:c.fsPath,relativePath:x,searchPath:this.N(o,x)}),F(null,void 0)))})},D=>{const F=D&&C.coalesce(D);return i(F&&F.length>0?F[0]:void 0)})}J(o,n){this.K(n)&&(!this.d||this.d(n.relativePath,T.basename(n.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||o(n))}K(o){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.isFilePatternMatch)(o,this.c)}return!0}L(o,n,m){return n.isSymbolicLink()?R.stat(o,m):m(null,n)}M(o,n,m){return n.isSymbolicLink()?R.realpath(o,(s,i)=>s?m(s):m(null,i)):m(null,o)}N(o,n){return o.folderName?T.join(o.folderName,n):n}}e.FileWalker=S;class g{constructor(o){this.a=o.folderQueries,this.b=o.extraFileResources||[],this.c=new S(o)}search(o,n,m){this.c.walk(this.a,this.b,o,n,(s,i)=>{m(s,{limitHit:i,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=g;class t{constructor(o,n){this.expression=o,this.c=n,this.d(o)}d(o){let n,m;Object.keys(o).filter(s=>o[s]).forEach(s=>{T.isAbsolute(s)?(n=n||y.getEmptyExpression(),n[s]=o[s]):(m=m||y.getEmptyExpression(),m[s]=o[s])}),this.a=n&&y.parse(n,{trimForExclusions:!0}),this.b=m&&y.parse(m,{trimForExclusions:!0})}test(o,n,m){return this.b&&this.b(o,n,m)||this.a&&this.a(T.join(this.c,o),n,m)}getBasenameTerms(){const o=[];return this.a&&o.push(...y.getBasenameTerms(this.a)),this.b&&o.push(...y.getBasenameTerms(this.b)),o}getPathTerms(){const o=[];return this.a&&o.push(...y.getPathTerms(this.a)),this.b&&o.push(...y.getPathTerms(this.b)),o}}function l(r){const o=r.trim().split(`
`),n=o[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return P.uppercaseFirstLetter(o[o.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}}),define(ye[305],De([1,0,103,22]),function(te,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(o=>o===r)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const u=512,C=512,A=512*8,y=512*128;var I;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(o,n){super(o),this.decodeStreamErrorKind=n}}e.DecodeStreamError=L;class k{static async create(o){let n;if(o!==e.UTF8)n=(await new Promise((s,i)=>{te(["@vscode/iconv-lite-umd"],s,i)})).getDecoder(h(o));else{const m=new TextDecoder;n={write(s){return m.decode(s,{stream:!0})},end(){return m.decode()}}}return new k(n)}constructor(o){this.a=o}write(o){return this.a.write(o)}end(){return this.a.end()}}function v(r,o){const n=o.minBytesRequiredForDetection??o.guessEncoding?A:C;return new Promise((m,s)=>{const i=(0,a.newWriteableStream)(q=>q.join("")),c=[];let w=0,D,F;const x=async()=>{try{const q=await l({buffer:R.VSBuffer.concat(c),bytesRead:w},o.guessEncoding);if(q.seemsBinary&&o.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);q.encoding=await o.overwriteEncoding(q.encoding),D=await k.create(q.encoding);const M=D.write(R.VSBuffer.concat(c).buffer);i.write(M),c.length=0,w=0,m({stream:i,detected:q})}catch(q){F?.dispose(),i.destroy(),s(q)}};F=(0,a.listenStream)(r,{onData:async q=>{D?i.write(D.write(q.buffer)):(c.push(q),w+=q.byteLength,w>=n&&(r.pause(),await x(),setTimeout(()=>r.resume())))},onError:q=>i.error(q),onEnd:async()=>{D||await x(),i.end(D?.end())}})})}e.toDecodeStream=v;async function P(r,o,n){const s=(await new Promise((w,D)=>{te(["@vscode/iconv-lite-umd"],w,D)})).getEncoder(h(o),n);let i=!1,c=!1;return{read(){if(c)return null;const w=r.read();if(typeof w!="string"){if(c=!0,!i&&n?.addBOM)switch(o){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=s.end();return D&&D.length>0?(i=!0,R.VSBuffer.wrap(D)):null}return i=!0,R.VSBuffer.wrap(s.write(w))}}}e.toEncodeReadable=P;async function E(r){return(await new Promise((n,m)=>{te(["@vscode/iconv-lite-umd"],n,m)})).encodingExists(h(r))}e.encodingExists=E;function h(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=h;function d(r,o){if(!r||o<e.UTF16be_BOM.length)return null;const n=r.readUInt8(0),m=r.readUInt8(1);if(n===e.UTF16be_BOM[0]&&m===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&m===e.UTF16le_BOM[1])return e.UTF16le;if(o<e.UTF8_BOM.length)return null;const s=r.readUInt8(2);return n===e.UTF8_BOM[0]&&m===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const f=["ascii","utf-16","utf-32"];async function p(r){const o=await new Promise((c,w)=>{te(["jschardet"],c,w)}),n=r.slice(0,y),m=g(n.buffer),s=o.detect(m);if(!s||!s.encoding)return null;const i=s.encoding.toLowerCase();return 0<=f.indexOf(i)?null:S(s.encoding)}const b={ibm866:"cp866",big5:"cp950"};function S(r){const o=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[o]||o}function g(r){let o="";for(let n=0;n<r.length;n++)o+=String.fromCharCode(r[n]);return o}function t(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const o=r.match(/windows(\d+)/);return o?"windows-"+o[1]:r}}}e.toCanonicalName=t;function l({buffer:r,bytesRead:o},n){let m=d(r,o),s=!1;if(m!==e.UTF16be&&m!==e.UTF16le&&r){let i=!0,c=!0,w=!1;for(let D=0;D<o&&D<u;D++){const F=D%2===1,x=r.readUInt8(D)===0;if(x&&(w=!0),i&&(F&&!x||!F&&x)&&(i=!1),c&&(F&&x||!F&&!x)&&(c=!1),x&&!i&&!c)break}w&&(i?m=e.UTF16le:c?m=e.UTF16be:s=!0)}return n&&!s&&!m&&r?p(r.slice(0,o)).then(i=>({seemsBinary:!1,encoding:i})):{seemsBinary:s,encoding:m}}e.detectEncodingFromBuffer=l,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],De([1,0,305,29,143]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class u extends T.TextSearchManager{constructor(A,y,I=R,L="searchProcess"){super(A,y,{readdir:k=>I.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,a.toCanonicalName)(k)},L)}}e.NativeTextSearchManager=u}),define(ye[306],De([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const u=this.a.get(T);return this.a.delete(T),u}}addDragOperationTransfer(T,u){this.a.set(T,u)}getRenderedTreeElement(T){if(this.b.has(T))return this.b.get(T)}addRenderedTreeItemElement(T,u){this.b.set(T,u)}removeRenderedTreeItemElement(T){this.b.has(T)&&this.b.delete(T)}}e.TreeviewsService=a}),define(ye[307],De([1,0,181,7,24,2,3,6,223,17,7,9,15,14,21,306,27]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(S,g){if((0,k.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let t;return Array.isArray(S.highlights)&&(t=S.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),t=t.length?t:void 0),{label:S.label,highlights:t}}}class p{constructor(g,t,l){this.d=g,this.e=t,this.f=l,this.a=new Map,this.b=new h.TreeviewsService;function r(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>r(o)?this.i(o):Array.isArray(o)&&o.length>0?o.map(n=>r(n)?this.i(n):n):o})}registerTreeDataProvider(g,t,l){const r=this.createTreeView(g,{treeDataProvider:t},l);return{dispose:()=>r.dispose()}}createTreeView(g,t,l){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],n=!!t.dragAndDropController?.handleDrag,m=!!t.dragAndDropController?.handleDrop,s=this.h(g,t,l),i=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:o,hasHandleDrag:n,hasHandleDrop:m});return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(l,"treeItemCheckbox"),s.onDidChangeCheckboxState},get message(){return s.message},set message(c){s.message=c},get title(){return s.title},set title(c){s.title=c},get description(){return s.description},set description(c){s.description=c},get badge(){return s.badge},set badge(c){c!==void 0&&L.ViewBadge.isViewBadge(c)?s.badge={value:Math.floor(Math.abs(c.value)),tooltip:c.tooltip}:c===void 0&&(s.badge=void 0)},reveal:(c,w)=>s.reveal(c,w),dispose:async()=>{await i,this.a.delete(g),s.dispose()}}}$getChildren(g,t){const l=this.a.get(g);return l?l.getChildren(t):Promise.reject(new y.NoTreeViewError(g))}async $handleDrop(g,t,l,r,o,n,m,s){const i=this.a.get(g);if(!i)return Promise.reject(new y.NoTreeViewError(g));const c=P.DataTransfer.toDataTransfer(l,async w=>(await this.d.$resolveDropFileData(g,t,w)).buffer);return m===g&&s&&await this.g(c,i,s,o,n),i.onDrop(c,r,o)}async g(g,t,l,r,o){const n=this.b.removeDragOperationTransfer(o);if(n)(await n)?.forEach((m,s)=>{m&&g.set(s,m)});else if(o&&t.handleDrag){const m=t.handleDrag(l,g,r);this.b.addDragOperationTransfer(o,m),await m}return g}async $handleDrag(g,t,l,r){const o=this.a.get(g);if(!o)return Promise.reject(new y.NoTreeViewError(g));const n=await this.g(new R.DataTransfer,o,t,r,l);if(!!n)return P.DataTransfer.toDataTransferDTO(n)}async $hasResolve(g){const t=this.a.get(g);if(!t)throw new y.NoTreeViewError(g);return t.hasResolve}$resolve(g,t,l){const r=this.a.get(g);if(!r)throw new y.NoTreeViewError(g);return r.resolveTreeItem(t,l)}$setExpanded(g,t,l){const r=this.a.get(g);if(!r)throw new y.NoTreeViewError(g);r.setExpanded(t,l)}$setSelection(g,t){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setSelection(t)}$setFocus(g,t){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setFocus(t)}$setVisible(g,t){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setVisible(t)}$changeCheckboxState(g,t){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setCheckboxState(t)}h(g,t,l){const r=new b(g,t,this.d,this.e.converter,this.f,l);return this.a.set(g,r),r}i(g){const t=this.a.get(g.$treeViewId);return t&&"$treeItemHandle"in g?t.getExtensionElement(g.$treeItemHandle):t&&"$focusedTreeItem"in g&&g.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=p;class b extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,k.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,t,l,r,o,n){if(super(),this.C=g,this.D=l,this.F=r,this.G=o,this.H=n,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new E.CancellationTokenSource,n.contributes&&n.contributes.views)for(const i in n.contributes.views)for(const c of n.contributes.views[i])c.id===g&&(this.J=c.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(i=>this.w.fire({message:!1,element:i})));let m,s;this.B(C.Event.debounce(this.w.event,(i,c)=>(i||(i={message:!1,elements:[]}),c.element!==!1&&(m||(m=new Promise(w=>s=w),this.y=this.y.then(()=>m)),Array.isArray(c.element)?i.elements.push(...c.element):i.elements.push(c.element)),c.message&&(i.message=!0),i),200,!0)(({message:i,elements:c})=>{c.length&&(this.z=this.z.then(()=>{const w=s;return m=null,this.U(c).then(()=>w())})),i&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const t=g?this.getExtensionElement(g):void 0;if(g&&!t)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let l=this.Q(g);return l||(l=await this.R(t)),l?l.map(r=>r.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,t){t=t||{select:!0,focus:!1};const l=(0,k.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,k.isUndefinedOrNull)(t.focus)?!1:t.focus,o=(0,k.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(n=>this.P(g,n[n.length-1]).then(m=>this.D.$reveal(this.C,{item:m.item,parentChain:n.map(s=>s.item)},{select:l,focus:r,expand:o})),n=>this.G.error(n)):this.D.$reveal(this.C,void 0,{select:l,focus:r,expand:o})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=P.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,t){const l=this.getExtensionElement(g);l&&(t?this.r.fire(Object.freeze({element:l})):this.s.fire(Object.freeze({element:l})))}setSelection(g){(0,v.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const t=(await Promise.all(g.map(async l=>{const r=this.getExtensionElement(l.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:l.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);t.forEach(l=>{l.treeItem.checkboxState=l.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(l=>[l.extensionItem,l.newState])})}async handleDrag(g,t,l){const r=[];for(const o of g){const n=this.getExtensionElement(o);n&&r.push(n)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,l),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,t,l){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,I.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,g,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,t){if(!this.f.resolveTreeItem)return;const l=this.i.get(g);if(l){const r=this.j.get(l);if(r){const o=await this.f.resolveTreeItem(r.extensionItem,l,t)??r.extensionItem;return this.db(o),r.item.tooltip=this.ab(o.tooltip),r.item.command=this.bb(r.disposableStore,o.command),r.item}}}N(g){return this.O(g).then(t=>t?this.N(t).then(l=>this.P(t,l[l.length-1]).then(r=>(l.push(r),l))):Promise.resolve([]))}O(g){const t=this.j.get(g);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,I.asPromise)(()=>this.f.getParent(g))}P(g,t){const l=this.j.get(g);return l?Promise.resolve(l):(0,I.asPromise)(()=>this.f.getTreeItem(g)).then(r=>this.gb(g,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(r);if(o){const n=this.j.get(o);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(g){if(g){let t;if(typeof g=="string"){const l=this.getExtensionElement(g);t=l?this.j.get(l):void 0}else t=g;return t&&t.children||void 0}return this.h}async R(g){this.nb(g);const t=new E.CancellationTokenSource(this.S.token);try{const l=g?this.j.get(g):void 0,r=await this.f.getChildren(g);if(t.token.isCancellationRequested)return;const o=await Promise.all((0,v.coalesce)(r||[]).map(async n=>{const m=await this.f.getTreeItem(n);return m&&!t.token.isCancellationRequested?this.Z(n,m,l):null}));return t.token.isCancellationRequested?void 0:(0,v.coalesce)(o)}finally{t.dispose()}}U(g){if(g.some(l=>!l))return this.S.dispose(!0),this.S=new E.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const l=this.W(g);if(l.length)return this.X(l)}return Promise.resolve(void 0)}W(g){const t=new Set,l=g.map(o=>this.j.get(o));for(const o of l)if(o&&!t.has(o.item.handle)){let n=o;for(;n&&n.parent&&l.findIndex(m=>n&&n.parent&&m&&m.item.handle===n.parent.item.handle)===-1;){const m=this.i.get(n.parent.item.handle);n=m?this.j.get(m):void 0}n&&!n.parent&&t.add(o.item.handle)}const r=[];return t.forEach(o=>{const n=this.i.get(o);if(n){const m=this.j.get(n);m&&(!m.parent||!t.has(m.parent.item.handle))&&r.push(o)}}),r}X(g){const t={};return Promise.all(g.map(l=>this.Y(l).then(r=>{r&&(t[l]=r.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(g){const t=this.getExtensionElement(g);if(t){const l=this.j.get(t);if(l)return this.nb(t),(0,I.asPromise)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const o=this.eb(t,r,l.parent);return this.lb(t,o,l,l.parent),l.dispose(),o}return null})}return Promise.resolve(null)}Z(g,t,l){const r=this.eb(g,t,l);if(t.id&&this.i.has(r.item.handle))throw new Error((0,a.localize)(0,null,t.id));return this.kb(g,r),this.mb(r,l),r}ab(g){return L.MarkdownString.isMarkdownString(g)?P.MarkdownString.from(g):g}bb(g,t){return t?{...this.F.toInternal(t,g),originalId:t.command}:void 0}cb(g){if(!g.checkboxState)return;let t,l;return typeof g.checkboxState=="number"?t=g.checkboxState:(t=g.checkboxState.state,l=g.checkboxState.tooltip),{isChecked:t===L.TreeItemCheckboxState.Checked,tooltip:l}}db(g){if(!L.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,t,l){this.db(t);const r=new A.DisposableStore,o=this.gb(g,t,l),n=this.hb(t);return{item:{handle:o,parentHandle:l?l.item.handle:void 0,label:f(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(r,t.command),contextValue:t.contextValue,icon:n,iconDark:this.ib(t)||n,themeIcon:this.fb(t),collapsibleState:(0,k.isUndefinedOrNull)(t.collapsibleState)?L.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:l,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(g){return g.iconPath instanceof L.ThemeIcon?g.iconPath:void 0}gb(g,{id:t,label:l,resourceUri:r},o,n){if(t)return`${b.b}/${t}`;const m=f(l,this.H),s=o?o.item.handle:b.a;let i=m?m.label:r?(0,T.basename)(r):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const c=this.j.has(g)?this.j.get(g).item.handle:void 0,w=this.Q(o)||[];let D,F=0;do{if(D=`${s}/${F}:${i}`,n||!this.i.has(D)||c===D)break;F++}while(F<=w.length);return D}hb(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon))return typeof g.iconPath=="string"||u.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return u.URI.isUri(g)?g:u.URI.file(g)}kb(g,t){this.i.set(t.item.handle,g),this.j.set(g,t)}lb(g,t,l,r){this.i.delete(t.item.handle),this.j.delete(g),t.item.handle!==l.item.handle&&this.i.delete(l.item.handle),this.kb(g,t);const o=this.Q(r)||[],n=o.filter(m=>m.item.handle===l.item.handle)[0];n&&o.splice(o.indexOf(n),1,t)}mb(g,t){t?(t.children||(t.children=[]),t.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const t=this.j.get(g);if(t){if(t.children)for(const l of t.children){const r=this.i.get(l.item.handle);r&&this.ob(r)}t.children=void 0}}else this.pb()}ob(g){const t=this.j.get(g);if(t){if(t.children)for(const l of t.children){const r=this.i.get(l.item.handle);r&&this.ob(r)}this.j.delete(g),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[308],De([1,0,21,11,3,37,2,121,107,152,163,44,5,95,250,249,40,251,34,253,254,255,238,256,59,42,257,258,261,262,263,142,241,269,270,271,99,41,273,307,14,7,73,276,79,141,33,230,260,72,139,81,83,84,13,56,18,25,264,237,55,76,247,274,78,77,279,277,278,248,48,272,275,98,60,96,265,80,266,16,125,240,219,259,6,27,224,97,215,267,268]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S,g,t,l,r,o,n,m,s,i,c,w,D,F,x,q,M,B,O,U,z,j,le,V,_,J,ie,ee,K,G,de,be,Ee,Pe,Fe,se,oe,fe,Z,ce,ne,N,H,Q,Y,he,ve,Ae,pe,Ce,ke,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ae,$,ue,Ie,Le,$e,Ke,Ze,pt,gt,ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Et(tt){const ft=tt.get(fe.IExtHostInitDataService),At=tt.get(ke.IExtHostFileSystemInfo),Kt=tt.get(he.IExtHostConsumerFileSystem),Rt=tt.get(o.IExtHostExtensionService),mt=tt.get(ie.IExtHostWorkspace),Tt=tt.get(nt.IExtHostTelemetry),$t=tt.get(p.IExtHostConfiguration),Nt=tt.get(se.IURITransformerService),Xe=tt.get(oe.IExtHostRpcService),Mt=tt.get(M.IExtHostStorage),Ut=tt.get(Y.IExtensionStoragePaths),Wt=tt.get(Fe.ILoggerService),bt=tt.get(Fe.ILogService),Re=tt.get(ne.IExtHostTunnelService),Oe=tt.get(N.IExtHostApiDeprecationService),Se=tt.get(J.IExtHostWindow),re=tt.get(et.IExtHostSecretState),Ne=tt.get(Qe.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,At),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Wt),Xe.set(v.ExtHostContext.ExtHostWorkspace,mt),Xe.set(v.ExtHostContext.ExtHostConfiguration,$t),Xe.set(v.ExtHostContext.ExtHostExtensionService,Rt),Xe.set(v.ExtHostContext.ExtHostStorage,Mt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Re),Xe.set(v.ExtHostContext.ExtHostWindow,Se),Xe.set(v.ExtHostContext.ExtHostSecretState,re),Xe.set(v.ExtHostContext.ExtHostTelemetry,Tt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,Ne);const He=Xe.set(v.ExtHostContext.ExtHostDecorations,tt.get(de.IExtHostDecorations)),_e=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(r.IExtHostDocumentsAndEditors)),je=Xe.set(v.ExtHostContext.ExtHostCommands,tt.get(d.IExtHostCommands)),it=Xe.set(v.ExtHostContext.ExtHostTerminalService,tt.get(B.IExtHostTerminalService)),lt=Xe.set(v.ExtHostContext.ExtHostDebugService,tt.get(Ee.IExtHostDebugService)),Pt=Xe.set(v.ExtHostContext.ExtHostSearch,tt.get(Pe.IExtHostSearch)),St=Xe.set(v.ExtHostContext.ExtHostTask,tt.get(be.IExtHostTask)),yt=Xe.set(v.ExtHostContext.ExtHostOutputService,tt.get(w.IExtHostOutputService)),kt=Xe.set(v.ExtHostContext.ExtHostLocalization,tt.get(Ze.IExtHostLocalizationService)),Dt=Xe.set(v.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Xe)),Ct=Xe.set(v.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(Xe,_e)),qt=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(Xe,_e,bt)),Jt=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(bt,Ct,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),wt=Xe.set(v.ExtHostContext.ExtHostNotebook,new Z.ExtHostNotebookController(Xe,je,_e,Ct)),si=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new ue.ExtHostNotebookDocuments(wt)),oi=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new $.ExtHostNotebookEditors(bt,wt)),Zt=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,ft,wt,je,bt)),bi=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Ue.ExtHostNotebookRenderers(Xe,wt)),Lt=Xe.set(v.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Xe,_e)),Ht=Xe.set(v.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),je,bt)),vi=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new ee.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),Lt,ft.remote)),ai=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Xe,bt,At,_e)),ei=Xe.set(v.ExtHostContext.ExtHostLanguages,new i.ExtHostLanguages(Xe,Ct,je.converter,Nt)),ut=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(Xe,Nt,Ct,je,ai,bt,Oe,Tt)),Bi=Xe.set(v.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Xe,ut)),Bt=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(Xe,bt,_e)),Qt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(Xe,mt,je)),ci=Xe.set(v.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(Xe,je,bt)),wi=Xe.set(v.ExtHostContext.ExtHostQuickDiff,new ct.ExtHostQuickDiff(Xe)),Ei=Xe.set(v.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Xe,je,Ct)),li=Xe.set(v.ExtHostContext.ExtHostProgress,new D.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Si=Xe.set(v.ExtHostContext.ExtHosLabelService,new K.ExtHostLabelService(Xe)),ui=Xe.set(v.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Xe)),ti=Xe.set(v.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Xe)),$i=Xe.set(v.ExtHostContext.ExtHostTimeline,new Q.ExtHostTimeline(Xe,je)),ii=Xe.set(v.ExtHostContext.ExtHostWebviews,new _.ExtHostWebviews(Xe,ft.remote,mt,bt,Oe)),ni=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(Xe,ii,mt)),yi=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Ae.ExtHostCustomEditors(Xe,Ct,Ut,ii,ni)),Di=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new ve.ExtHostWebviewViews(Xe,ii)),ri=Xe.set(v.ExtHostContext.ExtHostTesting,new Ve.ExtHostTesting(Xe,je,_e)),Ci=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new xe.ExtHostUriOpeners(Xe)),Ii=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new gt.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Xe,wt,_e,je,bt));const zi=Object.values(v.ExtHostContext);Xe.assertRegistered(zi);const Wi=new Ce.ExtHostBulkEdits(Xe,_e),Hi=new h.ExtHostClipboard(Xe),ki=new c.ExtHostMessageService(Xe,bt),Ri=new S.ExtHostDialogs(Xe),Li=new q.ExtHostStatusBar(Xe,je.converter);return E.ExtHostApiCommands.register(je),function(ze,jt,Oi){const vt=function(){let ge=!ze.isUnderDevelopment;function we(){ge||(bt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Me(ot){if(Array.isArray(ot))ot.forEach(Me);else if(typeof ot=="string")we();else{const It=ot;typeof It.scheme>"u"&&we(),typeof It.exclusive=="boolean"&&(0,$e.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return ot}}(),ji={getSession(ge,we,Me){return ti.getSession(ze,ge,we,Me)},async hasSession(ge,we){return(0,$e.checkProposedApiEnabled)(ze,"authSession"),!!await ti.getSession(ze,ge,we,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ge,we,Me,ot){return ti.registerAuthenticationProvider(ge,we,Me,ot)}},di={registerCommand(ge,we,Me){return je.registerCommand(!0,ge,we,Me,void 0,ze)},registerTextEditorCommand(ge,we,Me){return je.registerCommand(!0,ge,(...ot)=>{const It=Lt.getActiveTextEditor();if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return It.edit(Ot=>{we.apply(Me,[It,Ot,...ot])}).then(Ot=>{Ot||bt.warn("Edits from command "+ge+" were not applied.")},Ot=>{bt.warn("An error occurred while running command "+ge,Ot)})},void 0,void 0,ze)},registerDiffInformationCommand:(ge,we,Me)=>((0,$e.checkProposedApiEnabled)(ze,"diffCommand"),je.registerCommand(!0,ge,async(...ot)=>{const It=_e.activeEditor(!0);if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(It.id);we.apply(Me,[Ot,...ot])},void 0,void 0,ze)),executeCommand(ge,...we){return je.executeCommand(ge,...we)},getCommands(ge=!1){return je.getCommands(ge)}},Ni={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return it.getDefaultShell(!1)},get onDidChangeShell(){return(0,$e.checkProposedApiEnabled)(ze,"envShellEvent"),it.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(ze,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(ze,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return(0,$e.checkProposedApiEnabled)(ze,"telemetryLogger"),Tt.instantiateLogger(ze,ge)},openExternal(ge,we){return Se.openUri(ge,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===ft.environment.appUriScheme)return Dt.createAppUri(ge);try{return await Se.asExternalUri(ge,{allowTunneling:!!ft.remote.authority})}catch(we){if((0,ae.matchesScheme)(ge,rt.Schemas.http)||(0,ae.matchesScheme)(ge,rt.Schemas.https))return ge;throw we}},get remoteName(){return(0,G.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,$e.checkProposedApiEnabled)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(Ni);const Vi={createTestController(ge,we,Me){return ri.createTestController(ze,ge,we,Me)},createTestObserver(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.createTestObserver()},runTests(ge){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.runTests(ge)},get onDidChangeTestResults(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.onResultsChanged},get testResults(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.results}},hi=ft.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,qi={getExtension(ge,we){(0,$e.isProposedApiEnabled)(ze,"extensionsAny")||(we=!1);const Me=jt.mine.getExtensionDescription(ge);if(Me)return new o.Extension(Rt,ze.identifier,Me,hi,!1);if(we){const ot=jt.all.getExtensionDescription(ge);if(ot)return new o.Extension(Rt,ze.identifier,ot,hi,!0)}},get all(){const ge=[];for(const we of jt.mine.getAllExtensionDescriptions())ge.push(new o.Extension(Rt,ze.identifier,we,hi,!1));return ge},get allAcrossExtensionHosts(){(0,$e.checkProposedApiEnabled)(ze,"extensionsAny");const ge=new $e.ExtensionIdentifierSet(jt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),we=[];for(const Me of jt.all.getAllExtensionDescriptions()){const ot=!ge.has(Me.identifier);we.push(new o.Extension(Rt,ze.identifier,Me,hi,ot))}return we},get onDidChange(){return(0,$e.isProposedApiEnabled)(ze,"extensionsAny")?T.Event.any(jt.mine.onDidChange,jt.all.onDidChange):jt.mine.onDidChange}},Ti={createDiagnosticCollection(ge){return ai.createDiagnosticCollection(ze.identifier,ge)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ge=>ai.getDiagnostics(ge),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ge,we){return ei.changeLanguage(ge.uri,we)},match(ge,we){const Me=Ct.getDocumentData(we.uri)?.notebook;return(0,L.score)(z.LanguageSelector.from(ge),we.uri,we.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(ge,we,Me){return ut.registerCodeActionProvider(ze,vt(ge),we,Me)},registerDocumentPasteEditProvider(ge,we,Me){return(0,$e.checkProposedApiEnabled)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,vt(ge),we,Me)},registerCodeLensProvider(ge,we){return ut.registerCodeLensProvider(ze,vt(ge),we)},registerDefinitionProvider(ge,we){return ut.registerDefinitionProvider(ze,vt(ge),we)},registerDeclarationProvider(ge,we){return ut.registerDeclarationProvider(ze,vt(ge),we)},registerImplementationProvider(ge,we){return ut.registerImplementationProvider(ze,vt(ge),we)},registerTypeDefinitionProvider(ge,we){return ut.registerTypeDefinitionProvider(ze,vt(ge),we)},registerHoverProvider(ge,we){return ut.registerHoverProvider(ze,vt(ge),we,ze.identifier)},registerEvaluatableExpressionProvider(ge,we){return ut.registerEvaluatableExpressionProvider(ze,vt(ge),we,ze.identifier)},registerInlineValuesProvider(ge,we){return ut.registerInlineValuesProvider(ze,vt(ge),we,ze.identifier)},registerDocumentHighlightProvider(ge,we){return ut.registerDocumentHighlightProvider(ze,vt(ge),we)},registerLinkedEditingRangeProvider(ge,we){return ut.registerLinkedEditingRangeProvider(ze,vt(ge),we)},registerReferenceProvider(ge,we){return ut.registerReferenceProvider(ze,vt(ge),we)},registerRenameProvider(ge,we){return ut.registerRenameProvider(ze,vt(ge),we)},registerDocumentSymbolProvider(ge,we,Me){return ut.registerDocumentSymbolProvider(ze,vt(ge),we,Me)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(ze,ge)},registerDocumentFormattingEditProvider(ge,we){return ut.registerDocumentFormattingEditProvider(ze,vt(ge),we)},registerDocumentRangeFormattingEditProvider(ge,we){return ut.registerDocumentRangeFormattingEditProvider(ze,vt(ge),we)},registerOnTypeFormattingEditProvider(ge,we,Me,...ot){return ut.registerOnTypeFormattingEditProvider(ze,vt(ge),we,[Me].concat(ot))},registerDocumentSemanticTokensProvider(ge,we,Me){return ut.registerDocumentSemanticTokensProvider(ze,vt(ge),we,Me)},registerDocumentRangeSemanticTokensProvider(ge,we,Me){return ut.registerDocumentRangeSemanticTokensProvider(ze,vt(ge),we,Me)},registerSignatureHelpProvider(ge,we,Me,...ot){return typeof Me=="object"?ut.registerSignatureHelpProvider(ze,vt(ge),we,Me):ut.registerSignatureHelpProvider(ze,vt(ge),we,typeof Me>"u"?[]:[Me,...ot])},registerCompletionItemProvider(ge,we,...Me){return ut.registerCompletionItemProvider(ze,vt(ge),we,Me)},registerInlineCompletionItemProvider(ge,we){return we.handleDidShowCompletionItem&&(0,$e.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,vt(ge),we)},registerDocumentLinkProvider(ge,we){return ut.registerDocumentLinkProvider(ze,vt(ge),we)},registerColorProvider(ge,we){return ut.registerColorProvider(ze,vt(ge),we)},registerFoldingRangeProvider(ge,we){return ut.registerFoldingRangeProvider(ze,vt(ge),we)},registerSelectionRangeProvider(ge,we){return ut.registerSelectionRangeProvider(ze,ge,we)},registerCallHierarchyProvider(ge,we){return ut.registerCallHierarchyProvider(ze,ge,we)},registerTypeHierarchyProvider(ge,we){return ut.registerTypeHierarchyProvider(ze,ge,we)},setLanguageConfiguration:(ge,we)=>ut.setLanguageConfiguration(ze,ge,we),getTokenInformationAtPosition(ge,we){return(0,$e.checkProposedApiEnabled)(ze,"tokenInformation"),ei.tokenAtPosition(ge,we)},registerInlayHintsProvider(ge,we){return ut.registerInlayHintsProvider(ze,ge,we)},createLanguageStatusItem(ge,we){return ei.createLanguageStatusItem(ze,ge,we)},registerDocumentDropEditProvider(ge,we){return ut.registerDocumentOnDropEditProvider(ze,ge,we)}},xi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return it.activeTerminal},get terminals(){return it.terminals},async showTextDocument(ge,we,Me){const ot=await(C.URI.isUri(ge)?Promise.resolve(xt.openTextDocument(ge)):Promise.resolve(ge));return Lt.showTextDocument(ot,we,Me)},createTextEditorDecorationType(ge){return Lt.createTextEditorDecorationType(ze,ge)},onDidChangeActiveTextEditor(ge,we,Me){return Lt.onDidChangeActiveTextEditor(ge,we,Me)},onDidChangeVisibleTextEditors(ge,we,Me){return Lt.onDidChangeVisibleTextEditors(ge,we,Me)},onDidChangeTextEditorSelection(ge,we,Me){return Lt.onDidChangeTextEditorSelection(ge,we,Me)},onDidChangeTextEditorOptions(ge,we,Me){return Lt.onDidChangeTextEditorOptions(ge,we,Me)},onDidChangeTextEditorVisibleRanges(ge,we,Me){return Lt.onDidChangeTextEditorVisibleRanges(ge,we,Me)},onDidChangeTextEditorViewColumn(ge,we,Me){return Lt.onDidChangeTextEditorViewColumn(ge,we,Me)},onDidCloseTerminal(ge,we,Me){return it.onDidCloseTerminal(ge,we,Me)},onDidOpenTerminal(ge,we,Me){return it.onDidOpenTerminal(ge,we,Me)},onDidChangeActiveTerminal(ge,we,Me){return it.onDidChangeActiveTerminal(ge,we,Me)},onDidChangeTerminalDimensions(ge,we,Me){return(0,$e.checkProposedApiEnabled)(ze,"terminalDimensions"),it.onDidChangeTerminalDimensions(ge,we,Me)},onDidChangeTerminalState(ge,we,Me){return it.onDidChangeTerminalState(ge,we,Me)},onDidWriteTerminalData(ge,we,Me){return(0,$e.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),it.onDidWriteTerminalData(ge,we,Me)},get state(){return Se.state},onDidChangeWindowState(ge,we,Me){return Se.onDidChangeWindowState(ge,we,Me)},showInformationMessage(ge,...we){return ki.showMessage(ze,u.default.Info,ge,we[0],we.slice(1))},showWarningMessage(ge,...we){return ki.showMessage(ze,u.default.Warning,ge,we[0],we.slice(1))},showErrorMessage(ge,...we){return ki.showMessage(ze,u.default.Error,ge,we[0],we.slice(1))},showQuickPick(ge,we,Me){return Qt.showQuickPick(ge,we,Me)},showWorkspaceFolderPick(ge){return Qt.showWorkspaceFolderPick(ge)},showInputBox(ge,we){return Qt.showInput(ge,we)},showOpenDialog(ge){return Ri.showOpenDialog(ge)},showSaveDialog(ge){return Ri.showSaveDialog(ge)},createStatusBarItem(ge,we,Me){let ot,It,Ot;return typeof ge=="string"?(ot=ge,It=we,Ot=Me):(It=ge,Ot=we),Li.createStatusBarEntry(ze,ot,It,Ot)},setStatusBarMessage(ge,we){return Li.setStatusBarMessage(ge,we)},withScmProgress(ge){return Oe.report("window.withScmProgress",ze,"Use 'withProgress' instead."),li.withProgress(ze,{location:j.ProgressLocation.SourceControl},(we,Me)=>ge({report(ot){}}))},withProgress(ge,we){return li.withProgress(ze,ge,we)},createOutputChannel(ge,we){return yt.createOutputChannel(ge,we,ze)},createWebviewPanel(ge,we,Me,ot){return ni.createWebviewPanel(ze,ge,we,Me,ot)},createWebviewTextEditorInset(ge,we,Me,ot){return(0,$e.checkProposedApiEnabled)(ze,"editorInsets"),vi.createWebviewEditorInset(ge,we,Me,ot,ze)},createTerminal(ge,we,Me){return typeof ge=="object"?"pty"in ge?it.createExtensionTerminal(ge):it.createTerminalFromOptions(ge):it.createTerminal(ge,we,Me)},registerTerminalLinkProvider(ge){return it.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,we){return it.registerProfileProvider(ze,ge,we)},registerTerminalQuickFixProvider(ge,we){return(0,$e.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),it.registerTerminalQuickFixProvider(ge,ze.identifier.value,we)},registerTreeDataProvider(ge,we){return Ht.registerTreeDataProvider(ge,we,ze)},createTreeView(ge,we){return Ht.createTreeView(ge,we,ze)},registerWebviewPanelSerializer:(ge,we)=>ni.registerWebviewPanelSerializer(ze,ge,we),registerCustomEditorProvider:(ge,we,Me={})=>yi.registerCustomEditorProvider(ze,ge,we,Me),registerFileDecorationProvider(ge){return He.registerFileDecorationProvider(ge,ze)},registerUriHandler(ge){return Dt.registerUriHandler(ze.identifier,ge)},createQuickPick(){return Qt.createQuickPick(ze)},createInputBox(){return Qt.createInputBox(ze)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ge,we,Me){return ui.onDidChangeActiveColorTheme(ge,we,Me)},registerWebviewViewProvider(ge,we,Me){return Di.registerWebviewViewProvider(ze,ge,we,Me?.webviewOptions)},get activeNotebookEditor(){return wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,we,Me){return wt.onDidChangeActiveNotebookEditor(ge,we,Me)},get visibleNotebookEditors(){return wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,we,Me){return oi.onDidChangeNotebookEditorSelection(ge,we,Me)},onDidChangeNotebookEditorVisibleRanges(ge,we,Me){return oi.onDidChangeNotebookEditorVisibleRanges(ge,we,Me)},showNotebookDocument(ge,we){return wt.showNotebookDocument(ge,we)},registerExternalUriOpener(ge,we,Me){return(0,$e.checkProposedApiEnabled)(ze,"externalUriOpener"),Ci.registerExternalUriOpener(ze.identifier,ge,we,Me)},registerProfileContentHandler(ge,we){return(0,$e.checkProposedApiEnabled)(ze,"profileContentHandlers"),Ii.registrProfileContentHandler(ze,ge,we)},async registerQuickDiffProvider(ge,we,Me){return(0,$e.checkProposedApiEnabled)(ze,"quickDiffProvider"),wi.registerQuickDiffProvider(ge,we,Me)},get tabGroups(){return Ne.tabGroups}},xt={get rootPath(){return Oe.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw R.readonly()},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw R.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw R.readonly()},updateWorkspaceFolders:(ge,we,...Me)=>mt.updateWorkspaceFolders(ze,ge,we||0,...Me),onDidChangeWorkspaceFolders:function(ge,we,Me){return mt.onDidChangeWorkspace(ge,we,Me)},asRelativePath:(ge,we)=>mt.getRelativePath(ge,we),findFiles:(ge,we,Me,ot)=>mt.findFiles(ge,we,Me,ze.identifier,ot),findTextInFiles:(ge,we,Me,ot)=>{(0,$e.checkProposedApiEnabled)(ze,"findTextInFiles");let It,Ot;return typeof we=="object"?(It=we,Ot=Me):(It={},Ot=we,ot=Me),mt.findTextInFiles(ge,It||{},Ot,ze.identifier,ot)},saveAll:ge=>mt.saveAll(ge),applyEdit(ge,we){return Wi.applyWorkspaceEdit(ge,ze,we)},createFileSystemWatcher:(ge,we,Me,ot)=>Bt.createFileSystemWatcher(mt,ze,ge,we,Me,ot),get textDocuments(){return Ct.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw R.readonly()},openTextDocument(ge){let we;const Me=ge;if(typeof ge=="string")we=Promise.resolve(C.URI.file(ge));else if(C.URI.isUri(ge))we=Promise.resolve(ge);else if(!Me||typeof Me=="object")we=Ct.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(ot=>Ct.ensureDocumentData(ot).then(It=>It.document))},onDidOpenTextDocument:(ge,we,Me)=>Ct.onDidAddDocument(ge,we,Me),onDidCloseTextDocument:(ge,we,Me)=>Ct.onDidRemoveDocument(ge,we,Me),onDidChangeTextDocument:(ge,we,Me)=>Ct.onDidChangeDocument(ge,we,Me),onDidSaveTextDocument:(ge,we,Me)=>Ct.onDidSaveDocument(ge,we,Me),onWillSaveTextDocument:(ge,we,Me)=>Jt.getOnWillSaveTextDocumentEvent(ze)(ge,we,Me),get notebookDocuments(){return wt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,we){let Me;if(C.URI.isUri(ge))Me=ge,await wt.openNotebookDocument(ge);else if(typeof ge=="string")Me=C.URI.revive(await wt.createNotebookDocument({viewType:ge,content:we}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ge,we,Me){return si.onDidSaveNotebookDocument(ge,we,Me)},onDidChangeNotebookDocument(ge,we,Me){return si.onDidChangeNotebookDocument(ge,we,Me)},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,we,Me,ot){return wt.registerNotebookSerializer(ze,ge,we,Me,(0,$e.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ge,we,Me)=>Oi.onDidChangeConfiguration(ge,we,Me),getConfiguration(ge,we){return we=arguments.length===1?void 0:we,Oi.getConfiguration(ge,we,ze)},registerTextDocumentContentProvider(ge,we){return qt.registerTextDocumentContentProvider(ge,we)},registerTaskProvider:(ge,we)=>(Oe.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(ze,ge,we)),registerFileSystemProvider(ge,we,Me){return(0,Le.combinedDisposable)(Bi.registerFileSystemProvider(ze,ge,we,Me),Kt.addFileSystemProvider(ge,we))},get fs(){return Kt.value},registerFileSearchProvider:(ge,we)=>((0,$e.checkProposedApiEnabled)(ze,"fileSearchProvider"),Pt.registerFileSearchProvider(ge,we)),registerTextSearchProvider:(ge,we)=>((0,$e.checkProposedApiEnabled)(ze,"textSearchProvider"),Pt.registerTextSearchProvider(ge,we)),registerRemoteAuthorityResolver:(ge,we)=>((0,$e.checkProposedApiEnabled)(ze,"resolvers"),Rt.registerRemoteAuthorityResolver(ge,we)),registerResourceLabelFormatter:ge=>((0,$e.checkProposedApiEnabled)(ze,"resolvers"),Si.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,we,Me)=>Bt.onDidCreateFile(ge,we,Me),onDidDeleteFiles:(ge,we,Me)=>Bt.onDidDeleteFile(ge,we,Me),onDidRenameFiles:(ge,we,Me)=>Bt.onDidRenameFile(ge,we,Me),onWillCreateFiles:(ge,we,Me)=>Bt.getOnWillCreateFileEvent(ze)(ge,we,Me),onWillDeleteFiles:(ge,we,Me)=>Bt.getOnWillDeleteFileEvent(ze)(ge,we,Me),onWillRenameFiles:(ge,we,Me)=>Bt.getOnWillRenameFileEvent(ze)(ge,we,Me),openTunnel:ge=>((0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.openTunnel(ze,ge).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.getTunnels()},onDidChangeTunnels:(ge,we,Me)=>((0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.onDidChangeTunnels(ge,we,Me)),registerPortAttributesProvider:(ge,we)=>((0,$e.checkProposedApiEnabled)(ze,"portsAttributes"),Re.registerPortsAttributesProvider(ge,we)),registerTimelineProvider:(ge,we)=>((0,$e.checkProposedApiEnabled)(ze,"timeline"),$i.registerTimelineProvider(ge,we,ze.identifier,je.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,$e.checkProposedApiEnabled)(ze,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,we,Me)=>mt.onDidGrantWorkspaceTrust(ge,we,Me),registerEditSessionIdentityProvider:(ge,we)=>((0,$e.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,we)),onWillCreateEditSessionIdentity:(ge,we,Me)=>((0,$e.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent(ze)(ge,we,Me))},fi={get inputBox(){return Oe.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(ze)},createSourceControl(ge,we,Me){return ci.createSourceControl(ze,ge,we,Me)}},Gi={createCommentController(ge,we){return Ei.createCommentController(ze,ge,we)}},zt={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(ge,we,Me){return lt.onDidStartDebugSession(ge,we,Me)},onDidTerminateDebugSession(ge,we,Me){return lt.onDidTerminateDebugSession(ge,we,Me)},onDidChangeActiveDebugSession(ge,we,Me){return lt.onDidChangeActiveDebugSession(ge,we,Me)},onDidReceiveDebugSessionCustomEvent(ge,we,Me){return lt.onDidReceiveDebugSessionCustomEvent(ge,we,Me)},onDidChangeBreakpoints(ge,we,Me){return lt.onDidChangeBreakpoints(ge,we,Me)},registerDebugConfigurationProvider(ge,we,Me){return lt.registerDebugConfigurationProvider(ge,we,Me||Ke.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,we){return lt.registerDebugAdapterDescriptorFactory(ze,ge,we)},registerDebugAdapterTrackerFactory(ge,we){return lt.registerDebugAdapterTrackerFactory(ge,we)},startDebugging(ge,we,Me){return!Me||typeof Me=="object"&&"configuration"in Me?lt.startDebugging(ge,we,{parentSession:Me}):lt.startDebugging(ge,we,Me||{})},stopDebugging(ge){return lt.stopDebugging(ge)},addBreakpoints(ge){return lt.addBreakpoints(ge)},removeBreakpoints(ge){return lt.removeBreakpoints(ge)},asDebugSourceUri(ge,we){return lt.asDebugSourceUri(ge,we)}},mi={registerTaskProvider:(ge,we)=>St.registerTaskProvider(ze,ge,we),fetchTasks:ge=>St.fetchTasks(ge),executeTask:ge=>St.executeTask(ze,ge),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ge,we,Me)=>St.onDidStartTask(ge,we,Me),onDidEndTask:(ge,we,Me)=>St.onDidEndTask(ge,we,Me),onDidStartTaskProcess:(ge,we,Me)=>St.onDidStartTaskProcess(ge,we,Me),onDidEndTaskProcess:(ge,we,Me)=>St.onDidEndTaskProcess(ge,we,Me)},Ki={createNotebookController(ge,we,Me,ot,It){return Zt.createNotebookController(ze,ge,we,Me,ot,(0,$e.isProposedApiEnabled)(ze,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(ge,we)=>wt.registerNotebookCellStatusBarItemProvider(ze,ge,we),createRendererMessaging(ge){return bi.createRendererMessaging(ze,ge)},createNotebookControllerDetectionTask(ge){return(0,$e.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(ze,ge)},registerKernelSourceActionProvider(ge,we){return(0,$e.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(ze,ge,we)},onDidChangeNotebookCellExecutionState(ge,we,Me){return(0,$e.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ge,we,Me)}},Xi={t(...ge){if(typeof ge[0]=="string"){const we=ge.shift(),Me=!ge||typeof ge[0]!="object"?ge:ge[0];return kt.getMessage(ze.identifier.value,{message:we,args:Me})}return kt.getMessage(ze.identifier.value,ge[0])},get bundle(){return kt.getBundle(ze.identifier.value)},get uri(){return kt.getBundleUri(ze.identifier.value)}};return{version:ft.version,authentication:ji,commands:di,comments:Gi,debug:zt,env:Ni,extensions:qi,l10n:Xi,languages:Ti,notebooks:Ki,scm:fi,tasks:mi,tests:Vi,window:xi,workspace:xt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ke.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:T.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:I.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:P.UIKind,Uri:C.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:Fe.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Et}),define(ye[309],De([1,0,281,318,319,2,320]),function(te,e,a,R,T,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(k,v,P,E,h,d){const f=d.environment.useHostProxy,p=typeof f=="boolean"?f:!d.remote.isRemote,b=(0,C.createProxyResolver)({resolveProxy:g=>k.resolveProxy(g),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(g,t,...l)=>{switch(g){case C.LogLevel.Trace:E.trace(t,...l);break;case C.LogLevel.Debug:E.debug(t,...l);break;case C.LogLevel.Info:E.info(t,...l);break;case C.LogLevel.Warning:E.warn(t,...l);break;case C.LogLevel.Error:E.error(t,...l);break;case C.LogLevel.Critical:E.error(t,...l);break;case C.LogLevel.Off:break;default:r(g,t,l);break}function r(o,n,...m){E.error("Unknown log level",o),E.error(n,...m)}},getLogLevel:()=>E.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:p,env:process.env}),S=y(v,b);return L(P,S)}e.connectProxyResolver=A;function y(k,v){const P={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(h=>{P.config=k.getConfiguration("http").get("proxySupport")||"off"});const E={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(h=>{E.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,C.createHttpPatch)(a,v,{config:"off"},E,!0)),on:Object.assign({},a,(0,C.createHttpPatch)(a,v,{config:"on"},E,!0)),override:Object.assign({},a,(0,C.createHttpPatch)(a,v,{config:"override"},E,!0)),onRequest:Object.assign({},a,(0,C.createHttpPatch)(a,v,P,E,!0)),default:Object.assign(a,(0,C.createHttpPatch)(a,v,P,E,!1))},https:{off:Object.assign({},R,(0,C.createHttpPatch)(R,v,{config:"off"},E,!0)),on:Object.assign({},R,(0,C.createHttpPatch)(R,v,{config:"on"},E,!0)),override:Object.assign({},R,(0,C.createHttpPatch)(R,v,{config:"override"},E,!0)),onRequest:Object.assign({},R,(0,C.createHttpPatch)(R,v,P,E,!0)),default:Object.assign(R,(0,C.createHttpPatch)(R,v,P,E,!1))},tls:Object.assign(T,(0,C.createTlsPatch)(T))}}const I=new Map;function L(k,v){return k.getExtensionPathIndex().then(P=>{const E=globalThis._VSCODE_NODE_MODULES.module,h=E._load;E._load=function(f,p,b){if(f==="tls")return v.tls;if(f!=="http"&&f!=="https")return h.apply(this,arguments);const S=v[f],g=P.findSubstr(u.URI.file(p.filename));let t=I.get(g);if(t||I.set(g,t={}),!t[f]){const l=S.default;t[f]={...l}}return t[f]}})}}),define(ye[310],De([1,0,82,308,295,309,42,283,2,16,7,280,115,282]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class E extends T.RequireInterceptor{j(){const f=this,p=globalThis._VSCODE_NODE_MODULES.module,b=p._load;p._load=function(l,r,o){return l=g(l),f.a.has(l)?f.a.get(l).load(l,y.URI.file((0,v.realpathSync)(r.filename)),n=>b.apply(this,[n,r,o])):b.apply(this,arguments)};const S=p._resolveLookupPaths;p._resolveLookupPaths=(t,l)=>S.call(this,g(t),l);const g=t=>{for(const l of f.b){const r=l(t);if(r){t=r;break}}return t}}}class h extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(P.ExtHostConsoleForwarder);const f=this.h.invokeFunction(R.createApiFactoryAndRegisterActors);if(this.h.createInstance(A.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const S=this.h.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=S.ipcHandlePath}await this.h.createInstance(E,f,{mine:this.D,all:this.F}).install(),a.mark("code/extHost/didInitAPI");const b=await this.k.getConfigProvider();await(0,u.connectProxyResolver)(this.j,b,this,this.l,this.u,this.f),a.mark("code/extHost/didInitProxyResolver")}ob(f){return f.main}async pb(f,p,b){if(p.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let S=null;b.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this.l.flush();const g=f?.identifier.value;f&&await this.s.initializeLocalizedMessages(f);try{g&&a.mark(`code/extHost/willLoadExtensionCode/${g}`),S=te.__$__nodeRequire(p.fsPath)}finally{g&&a.mark(`code/extHost/didLoadExtensionCode/${g}`),b.codeLoadingStop()}return S}async $setRemoteEnvironment(f){if(!!this.f.remote.isRemote)for(const p in f){const b=f[p];b===null?delete process.env[p]:process.env[p]=b}}}e.ExtHostExtensionService=h}),define(ye[145],De([1,0,46,321,304,15,61,38,10,8,2,31,80,322,302,100]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(c){this.a=c}provideTextSearchResults(c,w,D,F){return this.a.appendLine(`provideTextSearchResults ${c.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((x,q)=>{F.onCancellationRequested(()=>V());const M=l(c,w),B=w.folder.fsPath,O=M.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");this.a.appendLine(`${d} ${O}
 - cwd: ${B}`);let U=a.spawn(d,M,{cwd:B});U.on("error",K=>{console.error(K),this.a.appendLine("Error: "+(K&&K.message)),q((0,k.serializeSearchError)(new k.SearchError(K&&K.message,k.SearchErrorCode.rgProcessError)))});let z=!1;const j=new S(w.maxResults,B,w.previewOptions);j.on("result",K=>{z=!0,J="",D.report(K)});let le=!1;const V=()=>{le=!0,U?.kill(),j?.cancel()};let _=!1;j.on("hitLimit",()=>{_=!0,V()});let J="";U.stdout.on("data",K=>{j.handleData(K),z||(J+=K)});let ie=!1;U.stdout.once("data",()=>ie=!0);let ee="";U.stderr.on("data",K=>{const G=K.toString();this.a.appendLine(G),ee.length+G.length<1e6&&(ee+=G)}),U.on("close",()=>{if(this.a.appendLine(ie?"Got data from stdout":"No data from stdout"),this.a.appendLine(z?"Got result from parser":"No result from parser"),J&&this.a.appendLine(`Got data without result: ${J}`),this.a.appendLine(""),le)x({limitHit:_});else{j.flush(),U=null;let K;ee&&!ie&&(K=p(ee))?q((0,k.serializeSearchError)(new k.SearchError(K.message,K.code))):x({limitHit:_})}})})}}e.RipgrepTextSearchEngine=f;function p(i){const c=i.split(`
`),w=c[0].trim();if(c.some(F=>F.startsWith("regex parse error")))return new k.SearchError(b(c),k.SearchErrorCode.regexParseError);const D=w.match(/grep config error: unknown encoding: (.*)/);if(D)return new k.SearchError(`Unknown encoding: ${D[1]}`,k.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new k.SearchError(w.charAt(0).toUpperCase()+w.substr(1),k.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new k.SearchError(w.charAt(0).toUpperCase()+w.substr(1),k.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(w,k.SearchErrorCode.regexParseError)}function b(i){const c=["Regex parse error"],w=i.filter(D=>D.startsWith("PCRE2:"));if(w.length>=1){const D=w[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const F=D.split(":")[1];c.push(":"+F)}}return c.join("")}class S extends R.EventEmitter{constructor(c,w,D){super(),this.g=c,this.h=w,this.j=D,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new T.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(c,w){return super.on(c,w),this}handleData(c){if(this.b)return;const w=typeof c=="string"?c:this.d.write(c);this.k(w)}k(c){let w=c.indexOf(`
`);const D=this.a+c;if(w>=0)w+=this.a.length;else{this.a=D;return}let F=0;for(;w>=0;)this.m(D.substring(F,w).trim()),F=w+1,w=D.indexOf(`
`,F);this.a=D.substring(F)}m(c){if(this.b||!c)return;let w;try{w=JSON.parse(c)}catch{throw new Error(`malformed line from rg: ${c}`)}if(w.type==="match"){const D=g(w.data.path),F=L.URI.file(y.join(this.h,D)),x=this.n(w.data,F);this.p(x),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const D=g(w.data.path),F=L.URI.file(y.join(this.h,D));this.o(w.data,F).forEach(q=>this.p(q))}}n(c,w){const D=c.line_number-1,F=g(c.lines),x=Buffer.from(F);let q=0,M=0,B=D;c.submatches.length===0&&c.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const O=(0,u.coalesce)(c.submatches.map((U,z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const j=g(U.match),le=x.slice(q,U.start).toString(),V=t(le),_=V.numLines>0?V.lastLineLength:V.lastLineLength+M,J=t(j),ie=V.numLines+B,ee=J.numLines+ie,K=J.numLines>0?J.lastLineLength:J.lastLineLength+_;return q=U.end,M=K,B=ee,new v.Range(ie,_,ee,K)}));return(0,h.createTextSearchResult)(w,F,O,this.j)}o(c,w){const D=g(c.lines),F=c.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((x,q)=>({text:x,uri:w,lineNumber:F+q}))}p(c){this.emit("result",c)}}e.RipgrepParser=S;function g(i){return i.bytes?Buffer.from(i.bytes,"base64").toString():i.text}function t(i){const c=/\n/g;let w=0,D=-1,F;for(;F=c.exec(i);)w++,D=F.index;const x=D>=0?i.length-D-1:i.length;return{numLines:w,lastLineLength:x}}function l(i,c){const w=["--hidden"];w.push(i.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:F}=(0,C.groupBy)(c.includes,q=>q.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const q=new Set;F.forEach(M=>{q.add(M)}),w.push("-g","!*"),q.forEach(M=>{r(M).map(h.anchorGlob).forEach(B=>{w.push("-g",B)})})}D&&D.length&&D.forEach(q=>{w.push("-g",q)}),c.excludes.map(h.anchorGlob).forEach(q=>w.push("-g",`!${q}`)),c.maxFileSize&&w.push("--max-filesize",c.maxFileSize+""),c.useIgnoreFiles?c.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),c.followSymlinks&&w.push("--follow"),c.encoding&&c.encoding!=="utf8"&&w.push("--encoding",c.encoding),i.pattern==="--"&&(i.isRegExp=!0,i.pattern="\\-\\-"),i.isMultiline&&!i.isRegExp&&(i.pattern=(0,I.escapeRegExpCharacters)(i.pattern),i.isRegExp=!0),c.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),i.isRegExp&&(i.pattern=o(i.pattern),w.push("--engine","auto"));let x;if(i.isWordMatch){const M=(0,I.createRegExp)(i.pattern,!!i.isRegExp,{wholeWord:i.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",M)}else if(i.isRegExp){let q=m(i.pattern);q=s(q),w.push("--regexp",q)}else x=i.pattern,w.push("--fixed-strings");return w.push("--no-config"),c.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),i.isMultiline&&w.push("--multiline"),c.beforeContext&&w.push("--before-context",c.beforeContext+""),c.afterContext&&w.push("--after-context",c.afterContext+""),w.push("--"),x&&w.push(x),w.push("."),w}function r(i){const c=(0,A.splitGlobAware)(i,"/");return c.map((w,D)=>c.slice(0,D+1).join("/"))}function o(i){const c=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;i.match(c);)i=i.replace(c,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;i.match(w);)i=i.replace(w,"$1\\x{$2}");return i}e.unicodeEscapesToPCRE2=o;const n=i=>i.type==="Assertion"&&i.kind==="lookbehind";function m(i){let c;try{c=new P.RegExpParser().parsePattern(i)}catch{return i}let w="",D=0;const F=(M,B,O)=>{w+=i.slice(D,M)+O,D=B},x=[];return new P.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const B=x[0];if(!B)F(M.start,M.end,"\\r?\\n");else if(!x.some(n))if(B.type==="CharacterClass")if(B.negate){const O=i.slice(B.start+2,M.start)+i.slice(M.end,B.end-1);B.parent?.type==="Quantifier"?F(B.start,B.end,O?`[^${O}]`:"."):F(B.start,B.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=i.slice(B.start+1,M.start)+i.slice(M.end,B.end-1);F(B.start,B.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else B.type==="Quantifier"&&F(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){x.unshift(M)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(M){x.unshift(M)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(M){x.unshift(M)},onCharacterClassLeave(){x.shift()},onAssertionEnter(M){n(M)&&x.push(M)},onAssertionLeave(M){x[0]===M&&x.shift()}}).visit(c),w+=i.slice(D),w}e.fixRegexNewline=m;function s(i){return i.replace(/\n/g,"\\r?\\n")}e.fixNewline=s}),define(ye[311],De([1,0,21,145,126,16]),function(te,e,a,R,T,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(I){this.b=I,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(I,L,k,v){const P=new R.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===u.Schemas.vscodeUserData){const E={...L,folder:L.folder.with({scheme:u.Schemas.file})},h=new T.Progress(d=>k.report({...d,uri:d.uri.with({scheme:L.folder.scheme})}));return this.c(v,d=>P.provideTextSearchResults(I,E,h,d))}else return this.c(v,E=>P.provideTextSearchResults(I,L,k,E))}async c(I,L){const k=A(I);this.a.add(k);const v=await L(k.token);return this.a.delete(k),v}d(){this.a.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=C;function A(y){const I=new a.CancellationTokenSource;return y.onCancellationRequested(()=>I.cancel()),I}}),define(ye[312],De([1,0,29,145,144]),function(te,e,a,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class u{constructor(y){this.a=y}search(y,I,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(P){L({message:P})}},v=new T.NativeTextSearchManager(this.a,new R.RipgrepTextSearchEngine(k),a);return new Promise((P,E)=>v.search(h=>{I(h.map(C))},y).then(h=>P({limitHit:h.limitHit,type:"success",stats:h.stats}),E))}}e.TextSearchEngineAdapter=u;function C(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,I)=>{if(I.ranges){const L=I;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(ye[313],De([1,0,15,17,11,3,111,10,43,2,44,31,303,312]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{constructor(S="searchProcess"){this.d=S,this.b=Object.create(null)}fileSearch(S){let g;const t=f(S),l=new u.Emitter({onDidAddFirstListener:()=>{g=(0,R.createCancelablePromise)(r=>this.doFileSearchWithEngine(v.Engine,t,o=>l.fire(o),r)),g.then(r=>l.fire(r),r=>l.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return l.event}textSearch(S){let g;const t=f(S),l=new u.Emitter({onDidAddFirstListener:()=>{g=(0,R.createCancelablePromise)(r=>this.f(t,o=>l.fire(o),r)),g.then(r=>l.fire(r),r=>l.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return l.event}f(S,g,t){return S.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new P.TextSearchEngineAdapter(S).search(t,g,g)}doFileSearch(S,g,t){return this.doFileSearchWithEngine(v.Engine,S,g,t)}doFileSearchWithEngine(S,g,t,l,r=E.a){let o=0;const n=s=>{Array.isArray(s)?(o+=s.length,t(s.map(i=>this.g(i)))):s.relativePath?(o++,t(this.g(s))):t(s)};if(g.sortByScore){let s=this.k(g,n,l);if(!s){const i=g.maxResults?Object.assign({},g,{maxResults:null}):g,c=new S(i);s=this.h(c,g,t,n,l)}return new Promise((i,c)=>{s.then(([w,D])=>{const F=D.map(x=>this.g(x));this.n(F,t,r),i(w)},c)})}const m=new S(g);return this.q(m,n,r,l).then(s=>({limitHit:s.limitHit,type:"success",stats:{detailStats:s.stats,type:this.d,fromCache:!1,resultCount:o,sortingTime:void 0}}))}g(S){return{path:S.base?(0,A.join)(S.base,S.relativePath):S.relativePath}}h(S,g,t,l,r){const o=new u.Emitter;let n=(0,R.createCancelablePromise)(s=>{let i=[];const c=w=>{Array.isArray(w)?i=w:(l(w),o.fire(w))};return this.q(S,c,-1,s).then(w=>[w,i])}),m;if(g.cacheKey){m=this.j(g.cacheKey);const s={promise:n,event:o.event,resolved:!1};m.resultsToSearchCache[g.filePattern||""]=s,n.then(()=>{s.resolved=!0},i=>{delete m.resultsToSearchCache[g.filePattern||""]}),n=this.r(n)}return n.then(([s,i])=>{const c=m?m.scorerCache:Object.create(null),w=(typeof g.maxResults!="number"||g.maxResults>0)&&y.StopWatch.create(!1);return this.l(g,i,c,r).then(D=>{const F=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:s.stats,sortingTime:F,fromCache:!1,type:this.d,workspaceFolderCount:g.folderQueries.length,resultCount:D.length},messages:s.messages,limitHit:s.limitHit||typeof g.maxResults=="number"&&i.length>g.maxResults},D]})})}j(S){const g=this.b[S];return g||(this.b[S]=new h)}k(S,g,t){const l=S.cacheKey&&this.b[S.cacheKey];if(!l)return;const r=this.o(l,S.filePattern||"",g,t);if(r)return r.then(([o,n,m])=>{const s=y.StopWatch.create(!1);return this.l(S,n,l.scorerCache,t).then(i=>{const c=s.elapsed(),w={fromCache:!0,detailStats:m,type:this.d,resultCount:n.length,sortingTime:c};return[{type:"success",limitHit:o.limitHit||typeof S.maxResults=="number"&&n.length>S.maxResults,stats:w},i]})})}l(S,g,t,l){const r=(0,C.prepareQuery)(S.filePattern||""),o=(m,s)=>(0,C.compareItemsByFuzzyScore)(m,s,r,!0,d,t),n=typeof S.maxResults=="number"?S.maxResults:Number.MAX_VALUE;return a.topAsync(g,o,n,1e4,l)}n(S,g,t){if(t&&t>0)for(let l=0;l<S.length;l+=t)g(S.slice(l,l+t));else g(S)}o(S,g,t,l){const r=y.StopWatch.create(!1),o=g.indexOf(A.sep)>=0;let n;for(const c in S.resultsToSearchCache)if(g.startsWith(c)){if(o&&c.indexOf(A.sep)<0&&c!=="")continue;const w=S.resultsToSearchCache[c];n={promise:this.r(w.promise),event:w.event,resolved:w.resolved};break}if(!n)return null;const m=r.elapsed(),s=y.StopWatch.create(!1),i=n.event(t);return l&&l.onCancellationRequested(()=>{i.dispose()}),n.promise.then(([c,w])=>{if(l&&l.isCancellationRequested)throw(0,T.canceled)();const D=[],F=(0,C.prepareQuery)(g).normalizedLowercase;for(const x of w)!(0,k.isFilePatternMatch)(x,F)||D.push(x);return[c,D,{cacheWasResolved:n.resolved,cacheLookupTime:m,cacheFilterTime:s.elapsed(),cacheEntryCount:w.length}]})}q(S,g,t,l){return new Promise((r,o)=>{let n=[];l?.onCancellationRequested(()=>S.cancel()),S.search(m=>{m&&(t?(n.push(m),t>0&&n.length>=t&&(g(n),n=[])):g(m))},m=>{g(m)},(m,s)=>{n.length&&g(n),m?o(m):r(s)})})}clearCache(S){return delete this.b[S],Promise.resolve(void 0)}r(S){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,t){return S.then(g,t)}catch(g){return this.then(void 0,g)}finally(g){return S.finally(g)}}}}e.SearchService=E,E.a=512;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(b){return(0,A.basename)(b.relativePath)}getItemDescription(b){return(0,A.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function f(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(S=>I.URI.revive(S))}}function p(b){return{...b,folder:I.URI.revive(b.folder)}}}),define(ye[314],De([1,0,6,16,2,29,13,25,18,84,56,31,313,311,100,144]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends I.ExtHostSearch{constructor(p,b,S,g){super(p,S,g),this.s=u,this.t=-1,this.v=null,this.w=!1;const t=new E.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(R.Schemas.vscodeUserData,new P.RipgrepSearchProvider(t)),b.remote.isRemote&&b.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const p=new E.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(R.Schemas.file,new P.RipgrepSearchProvider(p)),this.y(R.Schemas.file,new v.SearchService("fileSearchProvider"))}y(p,b){const S=this.d++;return this.v=b,this.t=S,this.c.$registerFileSearchProvider(S,this.o(p)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(S)})}$provideFileSearchResults(p,b,S,g){const t=(0,I.reviveQuery)(S);return p===this.t?this.z(p,b,t,g):super.$provideFileSearchResults(p,b,S,g)}z(p,b,S,g){const t=l=>{if((0,k.isSerializedFileMatch)(l)&&(l=[l]),Array.isArray(l)){this.c.$handleFileMatch(p,b,l.map(r=>T.URI.file(r.path)));return}l.message&&this.n.debug("ExtHostSearch",l.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(S,t,g)}$clearCache(p){return this.v?.clearCache(p),super.$clearCache(p)}q(p,b){return new h.NativeTextSearchManager(p,b,void 0,"textSearchProvider")}};d=qe([We(0,y.IExtHostRpcService),We(1,A.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,C.ILogService)],d),e.NativeExtHostSearch=d}),define(ye[315],De([1,0,89,286,298,297,314,310,287,83,42,84,81,41,55,78,285,284,13,299,49]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(L.IExtHostExtensionService,A.ExtHostExtensionService,0),(0,a.registerSingleton)(p.ILoggerService,f.ExtHostLoggerService,1),(0,a.registerSingleton)(h.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,a.registerSingleton)(I.IExtHostDebugService,u.ExtHostDebugService,0),(0,a.registerSingleton)(k.IExtHostSearch,C.NativeExtHostSearch,0),(0,a.registerSingleton)(v.IExtHostTask,T.ExtHostTask,0),(0,a.registerSingleton)(P.IExtHostTerminalService,R.ExtHostTerminalService,0),(0,a.registerSingleton)(E.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,a.registerSingleton)(S.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(ye[323],De([1,0,227,324,82,11,118,119,205,95,296,22,29,115,17,121,222,235,300,315]),function(te,e,a,R,T,u,C,A,y,I,L,k,v,P,E,h,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let m=0;m<process.execArgv.length;m++)process.execArgv[m]==="--inspect-port=0"&&(process.execArgv.splice(m,1),m--)}();const p=R(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const n=globalThis._VSCODE_NODE_MODULES.module,m=n._load;n._load=function(s){if(s==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return m.apply(this,arguments)}})();const b=process.exit.bind(process);function S(n){process.exit=function(m){if(n)b(m);else{const s=new Error("An extension called process.exit() and this was prevented.");console.warn(s.stack)}},process.crash=function(){const m=new Error("An extension called process.crash() and this was prevented.");console.warn(m.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(n){b()};function t(){const n=(0,f.readExtHostConnection)(process.env);if(n.type===3)return new Promise((m,s)=>{const i=c=>{const w=c[0],D=new C.BufferedEmitter;w.on("message",F=>D.fire(k.VSBuffer.wrap(F.data))),w.on("close",()=>{g("renderer closed the MessagePort")}),w.start(),m({onMessage:D.event,send:F=>w.postMessage(F.buffer)})};process.parentPort.on("message",c=>i(c.ports))});if(n.type===2)return new Promise((m,s)=>{let i=null;const c=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),w=108e5,D=3e5,F=new E.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),w),x=new E.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),D);process.on("message",(M,B)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const O=k.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let U;if(M.skipWebSocketFrames)U=new A.NodeSocket(B,"extHost-socket");else{const z=k.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));U=new A.WebSocketNodeSocket(new A.NodeSocket(B,"extHost-socket"),M.permessageDeflate,z,!1)}i?(F.cancel(),x.cancel(),i.beginAcceptReconnection(U,O),i.endAcceptReconnection(),i.sendResume()):(clearTimeout(c),i=new C.PersistentProtocol({socket:U,initialChunk:O}),i.sendResume(),i.onDidDispose(()=>g("renderer disconnected")),m(i),i.onSocketClose(()=>{F.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(x.isScheduled())return;F.isScheduled()&&x.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const m=n.pipeName;return new Promise((s,i)=>{const c=a.createConnection(m,()=>{c.removeListener("error",i);const w=new C.PersistentProtocol({socket:new A.NodeSocket(c,"extHost-renderer")});w.sendResume(),s(w)});c.once("error",i),c.on("close",()=>{g("renderer closed the socket")})})}}async function l(){const n=await t();return new class{constructor(){this.a=new C.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,n.onMessage(m=>{(0,I.isMessageOfType)(m,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(m)})}send(m){this.b||n.send(m)}async drain(){if(n.drain)return n.drain()}}}function r(n){return new Promise(m=>{const s=n.onMessage(i=>{s.dispose();const c=JSON.parse(i.toString()),w=c.commit,D=y.default.commit;if(w&&D&&w!==D&&b(55),c.parentPid){let F=0;setInterval(function(){try{process.kill(c.parentPid,0),F=0}catch(q){q&&q.code==="EPERM"?(F++,F>=3&&g(`parent process ${c.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):g(`parent process ${c.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let x;try{x=globalThis._VSCODE_NODE_MODULES["native-watchdog"],x.start(c.parentPid)}catch(q){(0,u.onUnexpectedError)(q)}}n.send((0,I.createMessageOfType)(0)),m({protocol:n,initData:c})});n.send((0,I.createMessageOfType)(1))})}async function o(){const n=[];process.on("unhandledRejection",(F,x)=>{n.push(x),setTimeout(()=>{const q=n.indexOf(x);q>=0&&x.catch(M=>{n.splice(q,1),(0,u.isCancellationError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),F&&(0,u.onUnexpectedError)(F))})},1e3)}),process.on("rejectionHandled",F=>{const x=n.indexOf(F);x>=0&&n.splice(x,1)}),process.on("uncaughtException",function(F){(0,u.onUnexpectedError)(F)}),T.mark("code/extHost/willConnectToRenderer");const m=await l();T.mark("code/extHost/didConnectToRenderer");const s=await r(m);T.mark("code/extHost/didWaitForInitData");const{initData:i}=s;S(!!i.environment.extensionTestsLocationURI),i.environment.useHostProxy=p.useHostProxy!==void 0?p.useHostProxy!=="false":void 0,i.environment.skipWorkspaceStorageLock=(0,h.boolean)(p.skipWorkspaceStorageLock,!1);const c=new class{constructor(){this.pid=process.pid}exit(x){b(x)}exists(x){return v.Promises.exists(x)}realpath(x){return(0,P.realpath)(x)}};let w=null;i.remote.authority&&p.transformURIs&&(w=(0,d.createURITransformer)(i.remote.authority));const D=new L.ExtensionHostMain(s.protocol,i,c,w);g=F=>D.terminate(F)}o().catch(n=>console.log(n))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0e76dfa9095a62efe572ae1d215be7ce2a7f1f8e/core/vs/workbench/api/node/extensionHostProcess.js.map
